﻿//依据layout配置处理界面的生成，同时处理对象之间的关联刷新问题
define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "./_Builder"
],function(lang,array,_Builder){
    //由类型或data-dojo-type建立的html片段
    return new _Builder({
        htmls:{
            //顶部工具栏，可以水平和垂直，默认是水平的
            "topBar":'<div id="{id}" class="tool-bar {barClass}"><div class="top-bar-left">{left}</div><div class="top-bar-right">{right}</div></div>',
            //不带图标的按钮
            "menuItem":'<a id="{id}" class="menu-item {className}" href="{href}">{label}</a>',
            //带图标的按钮
            "iconMenuItem":'<a id="{id}" class="menu-item" href="{href}"><img src={logo} class="float-left"><span>{label}</span></a>',
            //左右分栏对象，右边宽度可变
            "splitterVR":'<div id="{id}" data-dojo-type="dojox/mobile/FixedSplitter" data-dojo-props="orientation:\'H\', variablePane:{variablePane}"><div data-dojo-type="dojox/mobile/Pane">{left}</div><div data-dojo-type="dojox/mobile/Pane">{right}</div></div>',
            //放置子view的容器
            "viewContainer":'<div id="{id}" class="cq-view-container"></div>',
            //编辑区域
            "editContainer":'<div id="{id}" class="cq-edit-container"></div>',
            //大字体文本，欢迎页的示例
            "bigText":'<div id="{id}" style="font-size:36px;">{content}</div>',
            //上下结构，可以指定高度可变的区域
            "fixedSplitter":'<div id="{id}" data-dojo-type="dojox/mobile/FixedSplitter" data-dojo-props="variablePane:{variablePane},orientation:\'V\'">{panes}</div>',
            //显示内容的pane
            "pane":'<div id="{id}" class="{className}" data-dojo-type="dojox/mobile/Pane">{content}</div>',
            "tagFields":'<div id="{id}" class="" data-dojo-type="dojox/mobile/View">{fields}</div>',
            
            
            //接下来的程序有问题，需要去掉，处理外部调用
            //店铺任务
            "shopTask":
				'<div class="widget-box-content">' +
				'<div class="task-info">' +
				'<h4 class="task-title">{taskTitle}</h4>' +
				'<p class="task-detail">{taskDetail}</p>' +
				'<p class="reward">{taskReward}</p>' +
				'<div class="task-opts" style="text-align:right;">' +
                '<a href="{taskTutorialUrl}" class="button">查看教程</a>' +
                '<a href="{targetUrl}" class="button">进行认证</a>' +
				'</div>' +
				'</div>' +
				'</div>',
			"infoList":"<div class='info-list'>{content}</div>",
			"listWithTitle":"<h4>{title}</h4>{list}",
			"trendDetail":"<h4>{title}</h4><div>{content}</div>",
            //详情区域的对象
            "detail":'<div id="{id}" data-dojo-type="cq/app/widget/web/Detail" data-dojo-props="dataProvider:\'{dataProvider}\',dataAction:\'{dataAction}\',dataField:\'{dataField}\',dataTemplate:\'{dataTemplate}\'"></div>',
            //编辑区域
            "edit":'<div id="{id}" data-dojo-type="cq/app/widget/web/Edit" data-dojo-props="dataProvider:\'{dataProvider}\',dataAction:\'{dataAction}\',dataField:\'{dataField}\'"></div>',
            "img":'<img src="{src}" class="{imgClass}" />',
            //可以在任何地方注入html片段的对象
            "content":"{content}",
            //固定宽度的工作区
            "cqFW":"<div class='cq-fw'>{content}</div>",
            


            //支持数据绑定的节点需要定义的内容
            //  data-cq-field:对应的字段名
            //  _LayoutMixin能够识别到对应类型的节点，具体做法参考文本框
            //      处理并实现以下两个方法——执行的上下文为节点本身
            //          setValue:设置节点的值，依据当前值刷新界面
            //          getValue:依据当前状态获取对应的值，只读对象可以不实现
            //      侦听变更事件，只读对象无需侦听变更
            //          发生变更之后更新_LayoutMixin中保存的数据
            //          并刷新其他相关元素的显示
            //支持数据绑定的组件widget需要提供的属性和方法
            //  field:对应的字段名
            //  setValue:设置值，需要修改自己的值，并刷新显示
            //  getValue:获取值，依据组件当前状态获取编辑对象的值，只读对象不提供这个方法
            //class说明
            //  cq-form:form表单区域
            //  cq-field-input:数据绑定的节点或对象
            //      直接用来显示数据的对象：文本框、checkbox、textarea、select、label(只读的对象显示)等
            //      必须提供data-cq-field属性——要显示或编辑的字段名
            //      若响应数据的变化，需要提供setValue方法
            //      若支持编辑内容，需要提供getValue方法
            //  cq-form-item:form中的一个字段显示对象，包含标签和显示组件
            //      以后可能会依据其他字段的值显示隐藏，这个时字段的根节点
            //  cq-form-label:form中的标签对象，独占一行
            //      只用来显示字段的标题
            //  cq-form-input:form中的输入框对象
            //      输入框(文本框、密码框、搜索框、电话号码、数字等)
            //  cq-form-button:form中的按钮
            //  cq-action:可以点击的对象
            //节点属性说明
            //  data-cq-field:本节点对应的字段
            //  cq-action:点击之后执行操作的操作名
            //TODO：以后扩展应该支持逗号分割的多个字段
            //编辑区域相关
            "form":'<form id="{id}" class="cq-form {formClass}" onsubmit="return false">{contents}</form>',
            //一项内容，内部包含标签和输入框内容
            "formItem":'<div id="{id}" class="cq-form-item {className}" data-cq-field="{field}">{contents}</div>',
            //输入框的标签
            "formLabel":'<label id="{id}" class="cq-form-label">{label}</label>',
            //输入框
            "formInput":'<input id="{id}" class="cq-form-input cq-field-input" placeholder="{placeholder}" data-dojo-props="canEdit:\'{canEdit}\',placeholder:\'{placeholder}\'" data-cq-field="{field}" type="{inputType}"/>',
            //按钮
            "formButton":'<button id="{id}" class="cq-action cq-form-button {buttonClass}" data-cq-field="{field}" cq-action="{action}">{label}</button>',
            // 超链接
            "formLink":'<a href="{href}" class="cq-form-link">{content}</a>',
            // 复选框
            "formCheckbox":'<span id="{id}" data-cq-field="{field}" class="cq-form-cb cq-field-input"  data-dojo-props="canEdit:\'{canEdit}\'"><input type="checkbox" class="cq-form-checkbox"><label class="cq-form-checkbox-label">{label}</label></span>',
            // 多行文本
            "formTextarea":'<textarea id="{id}" data-cq-field="{field}" data-dojo-props="canEdit:\'{canEdit}\'" class="cq-field-input cq-form-ta cq-form-input"></textarea>',
            // 日期
            "formDate":'<input id="{id}" data-dojo-type="dijit/Calendar">',
            // 列表选项
            "formOption":'<select id="{id}" class="cq-field-input cq-form-select cq-form-input" data-cq-field="{field}" selectOptions=\'{j:options}\'  data-dojo-props="field:\'{field}\',canEdit:\'{canEdit}\'" data-dojo-type="cq/app/widget/web/edit/Select"></select>'
        },
        //由data-dojo-type到对应的js模块
        models:{},
        //用来处理字段编辑的兼容性，这里的编辑方式和webBuilder中的一一对应
        decorateField:function(field,fields){
            var fieldType = ","+field.type+",",fieldItem = null;
            //所有支持的编辑方式都要在这里再写一遍，很奇怪
            if(fieldType===",action,"){
                //按钮
                return fields.push({
                    type: "formItem",
                    contents: [{
                        type: "formButton",
                        label: field.label,
                        field: field.field,
                        action: field.action,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                });
            }else if(-1<",text,tel,password,".indexOf(fieldType)){
                //文本
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        type: "formInput",
                        inputType: field.type,
                        field: field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        placeholder:field.placeHolder
                    }],
                    className:field.className
                };
            }else if(",date,"===fieldType){
                // 张松   2016/09/13  添加日期类型
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/DatePicker",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                };
            }else if(-1<",image,images,".indexOf(fieldType)){
                //图片
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        dojoType: "cq/app/widget/web/edit/ImagePicker",
                        field: field.field,
                        mode: field.type==="images"?"duplicate":"",
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        sizeType:field.sizeType,
                        size:field.size||{}
                    }],
                    className:field.className
                };
            }else if(",location,"===fieldType){
                //地理位置
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        dojoType: "cq/app/widget/web/edit/Location",
                        field: field.field,
                        distFields:field.distFields,
                        distFieldsStr:field.distFieldsStr,
                        detailAddrField:field.detailAddrField,
                        canEdit:field.canEdit
                    }],
                    className:field.className
                };
            }else if(",vcode,"===fieldType){
                //手机号、验证码
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        dojoType: "cq/app/widget/web/edit/UserNameAndVerifyCode",
                        //dojoType:"cq/app/widget/mobile/edit/VCode",
                        field: field.field,
                        errorMsg:field.errorMsg,
                        unExists:field.unExists,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        canToLogin:field.canToLogin
                    }],
                    className:field.className
                };
            }else if(",VerifyCode,"===fieldType){
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType: "cq/app/widget/web/edit/VerifyCode",
                        field:field.field
                    }],
                    className:field.className
                };
            }else if(",textarea,"===fieldType){
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        type: "formTextarea",
                        label: field.label,
                        field: field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                };
            }else if(",checkbox,"===fieldType){
                //复选框
                return fields.push({
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        type:"formCheckbox",
                        label:field.label,
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                });
            }else if(",options,"===fieldType){
                //枚举值
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        type:"formOption",
                        field:field.field,
                        options:field.options,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                };
            }else if(",ref,"===fieldType){
                //引用
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/Ref",
                        field:field.field,
                        searchAttr:field.searchField,
                        pageSize:field.pageSize||20,
                        labelAttr:field.labelFields,
                        dataProvider:field.dataProvider,
                        targetMethod:field.targetMethod,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                };
            }else if(",richText,"===fieldType){
                //富文本
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/RichEditor",
                        field:field.field,
                        height:"640",
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                };
            }else if(",dateTime,"===fieldType){
                // 张松   2016/09/13  添加日期类型
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/DateTimePicker",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:field.className
                };
            }else if(",district,"===fieldType){
                // 张松   2016/09/21  添加区划类型
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/DistrictEdit",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        fixedUpDis:field.fixedUpDis||{}
                    }],
                    className:field.className
                };
            }else if(",object,"===fieldType){
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/ObjEditor",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        fields:field.fields
                    }],
                    className:field.className
                };
            }else if(",objects,"===fieldType){
                fieldItem = {
                    type : "formItem",
                    field: field.field,
                    contents : [{
                        dojoType:"cq/app/widget/web/edit/ObjsEditor",
                        field:field.field,
                        label:field.label,
                        canEdit:field.canEdit==="false"||field.canEdit===false?false:true,
                        fields:field.fields,
                        defaultData:field.defaultData||{}
                    }],
                    className:field.className
                };
            }else if(",attachs,"===fieldType){
                fieldItem = {
                    type : "formItem",
                    field: field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/AttachmentList",
                        field: field.field,
                        label:field.label,
                        canEdit:field.canEdit==="false"||field.canEdit===false?false:true,
                        canAdd:field.canAdd==="false"||field.canAdd===false?false:true
                    }],
                    className:field.className
                };
            }
            //else if(",steps,"===fieldType){
            //    fieldItem = {
            //        dojoType:"cq/app/widget/web/Steps",
            //        field:field.field,
            //        stepsTags:field.steps.stepsTags,
            //        stepsFields:field.steps.stepsFields,
            //        stepsBtns:field.steps.stepsBtns
            //    };
            //}
            else if(",tagFields,"==fieldType){
                fieldItem = {
                    type:"tagFields",
                    fields:field.fields
                }
            }else if(",FileEditor,"===fieldType){
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/FileEditor",
                        field:field.field,
                        label:field.label,
                        canEdit:field.canEdit,
                        value:field.value||{}
                    }],
                    className:field.className
                }
            }
            
            if(fieldItem){
                //添加标签项
                if(field.label){
                    fieldItem.contents.splice(0,0,{
                        type: "formLabel",
                        label: field.label
                    });
                }
                // 文本框后添加提示框
                if(field.tips){
                    fieldItem.contents.push({
                        type:field.tips.type=="link"?"formLink":"",
                        content:field.tips.content,
                        href:field.tips.href
                    });
                }
                //添加到编辑列表中
                fields.push(fieldItem);
            }
        }
    });
});
