﻿//本轮变更需要达到的目标
//  view嵌套的问题
//  界面风格可配置性
//  开发和配置分离，系统的可配置性
//  部分操作标准化，列表、编辑界面等
//  样式标准化
//需要处理的问题
//  每个view配置文件的加载机制，提供几种标准的加载配置的方式
//  view和子view的联动机制，通过_RouteMixin来实现，子view的创建，子view的刷新
//  view和view下的组件的联动机制
//  同一view下组件之间的消息传递机制
define([
    "dojo/_base/lang",
    "dojo/ready",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/registry",
    "cq/util/config/config"
],function(lang,ready,Deferred,domClass,domStyle,registry,configUtil){
    window.moveToView = function(view,param,target){
		if("_blank"===target){
			return window.open("#" + view + (param || 0 === param ? "-" + param : ""),target);
		}
        location.href = "#"+view+(param||0===param||false===param?"-"+param:"");
    };
    //每个view的完整路径
    var viewRoads = {
        "":[]
    },
    mustLoginView = {},
    //初始化每个view的完整路径
    genViewRoads = function(view,id){
        if(view.mustLogin){
            mustLoginView[id] = true;
        }
        if(view.subViews){
            var road = null;
            for(var viewId in view.subViews){
                if(view.mustLogin){
                    view.subViews[viewId].mustLogin = true;
                    mustLoginView[viewId] = true;
                }
                road = viewRoads[viewId] = [].concat(viewRoads[id]);
                road.push(viewId);
                genViewRoads(view.subViews[viewId],viewId);
            }
        }
    },
    //应用启动函数
    startApp = function(){
        require([
            "dojo/_base/config"
        ],function(config){
            config.parseOnLoad = false;
        });
		window._clearBusyTimer = window._clearBusyTimer||function() {
			if (window._busyTimer) {
				clearTimeout(_busyTimer);
				window._busyTimer = null;
			}
		};
        window._initBusyTimer = window._initBusyTimer||function() {
            window._busyTimer = setTimeout(window.free, 5000);
        };
        window.busy = window.busy||function() {
			window._clearBusyTimer();
			domStyle.set("__loader", "display", "");
			window._initBusyTimer();
		};
        window.free = window.free||function() {
			setTimeout(function() {
				domStyle.set("__loader", "display", "none");
			}, 300);
		};
        
        //处理view之间的嵌套关系，生成每个view到达的路径
        genViewRoads(config.view,"");
        var topPane = registry.byId("topPane"),
        showView = function(){
            domStyle.set(config.view.view.domNode,"opacity",0);
            var hash = location.hash.substr(1).split("-");
            var view = hash.shift();
            var roads = viewRoads[view],param = hash.join("-");
            if(window.viewParam&&window.viewParam[view||"main"]){
                return;
            }
            //window.busy();
            //显示内容之后重算界面内元素大小
            if(mustLoginView[roads[roads.length-1]]){
                require(["cq/biz/user/user"],function(user){
                    if(configUtil.loginLevel==="hasUid"){
                        if(user.getCurrentUserId()){
                            config.view.view.showView(roads,param).then(function(){
                                config.view.view.resize();
                                domStyle.set(config.view.view.domNode,"opacity",1);
                            });
                        }else{
                            window.moveToView("login");
                        }
                    }else{
                        user.hasLogin().then(function(s){
                            if(s){
                                config.view.view.showView(roads,param).then(function(){
                                    config.view.view.resize();
                                    domStyle.set(config.view.view.domNode,"opacity",1);
                                });
                            }else{
                                window.moveToView("login");
                            }
                        });
                    }
                });
            }else{
                config.view.view.showView(roads,param).then(function(){
                    config.view.view.resize();
                    domStyle.set(config.view.view.domNode,"opacity",1);
                });
            }
        },clearCreatedViews = function(){
            var clearViewRef = function(viewInfo){
                if(viewInfo.view){
                    delete viewInfo.view;
                    if(viewInfo.subViews){
                        for(var k in viewInfo.subViews){
                            clearViewRef(viewInfo.subViews[k]);
                        }
                    }
                }
            };
            for(var k in config.view.subViews){
                if(config.view.subViews[k].view){
                    if(config.view.subViews[k]&&config.view.subViews[k].view){
                        config.view.subViews[k].view.destroyRecursive();
                        clearViewRef(config.view.subViews[k]);
                    }
                }
            }
            showView();
        };
        //加载根view对应的程序
        config.createView(config.view,"",topPane&&topPane.containerNode||document.body).then(function(view){
            //view的类型从布局对象那里读取，一种布局只能有一种view类型
            config.view.view = view;
            //监听地址栏的变化，从根view发起响应
            config.view.view.connect(window,"onhashchange",showView);
            //执行view的第一次切换响应
            showView();
            config.view.view.subscribe("whz/shop/changed",clearCreatedViews);
        });
    };
    var config = lang.mixin(lang.getObject("cq.app.config",true),{
        //界面配置
        view:{},
        //通用界面生成器
        layoutBuilder:null,
        //界面view对象
        ViewRender:null,
        nextPageOnLogin:"",

        //方法
        //加载layout的方式
        loadLayout:null,
        //依据配置生成新的view对象
        createView:function(viewInfo,viewId,parentNode){
            var def = new Deferred();
            config.loadLayout(viewInfo,viewId).then(function(layout){
                var view = new config.ViewRender({
                    subViews:viewInfo.subViews,
                    defaultView:viewInfo.defaultView
                });
                if(viewInfo["class"]){
                    domClass.add(view.domNode,viewInfo["class"]);
                }
                parentNode.appendChild(view.domNode);
                view.startup();
                config.layoutBuilder.build(layout,view).then(function(){
                    def.resolve(view);
                });
            });
            return def;
        }
    });
    ready(startApp);
    return config;
});
