﻿define([
    "dojo/Deferred"
],function(Deferred){
    // module:
    //      cq/app/layout/loader/memoryLayoutLoader
    return {
        // summary:
        //      对外提供获取view的layout的接口
        
        // layout:object
        //      viewId和layout的对照表，已经预先加载到了内存中
        layouts:{},
        
        // programLayouts:object
        //      需要执行程序才能获取到对应view信息的view清单
        programLayouts:{},
        
        loadLayout:function(viewInfo,viewId){
            // summary:
            //      依据view配置信息和viewId读取view的layout信息
            //      优先从内存中找，没有找到就从执行程序获取layout的信息中查找
            
            var def = new Deferred();
            if(this.layouts[viewId]){
                def.resolve(this.layouts[viewId]);
            }else if(this.programLayouts[viewId]){
                var layout = this.programLayouts[viewId];
                if(layout.dataProvider){
                    // 加载对应layout的提供者
                    require([layout.dataProvider],function(dataProvider){
                        // 执行提供者的获取对应layout的方法获取layout
                        layout = dataProvider[layout.method]();
                        if(layout&&layout.then){
                            layout.then(function(data){
                                def.resolve(data);
                            });
                        }else{
                            def.resolve(layout||[]);
                        }
                    });
                }else{
                    layout = this.layoutMethods[layout.method]();
                    if(layout&&layout.then){
                        layout.then(function(data){
                            def.resolve(data);
                        });
                    }else{
                        def.resolve(layout||[]);
                    }
                }
            }else{
                console.log("没有对应view的layout信息");
                console.log(viewId);
                console.log(viewInfo);
                def.resolve([]);
            }
            return def;
        }
    }
});;