define([
    "dojo/Deferred",
    "dojo/_base/lang",
    "cq/biz/user/user"
],function(Deferred, lang, user){
    var dataProvider = "cq/app/layout/mobile/programLayout";
    var layout = {
        programLayouts:{
            //这里定义哪些view使用哪些方法读取layout
            myPartnerList:{
                dataProvider:dataProvider,
                method:"myPartnerList"
            }
        },
        //下边定义具体获取layout的方法
        getUserLayout:function(){
            var layout = [{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"我的伙伴",
                left:[{
                    type:"iconMenuItem",
                    label:"返回",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{
                //顶部搜索框
                fixed:"top",
                id:"1",
                dojoType:"cq/app/widget/mobile/SearchBox"
            },{
                //顶部table区域
                type:"cq/app/widget/mobile/List",
                fixed:"top",
                id:"2",
                workMode: "single",
                itemType: "Label",
                listClass:"hflex",
                items:[{
                    _id:0,
                    labelClass:"flex1 font-size1 h-center tab-selector selected",
                    label:"全部"
                },{
                    _id:1,
                    labelClass:"flex1 font-size1 h-center tab-selector",
                    label:"供应商"
                },{
                    _id:2,
                    labelClass:"flex1 font-size1 h-center tab-selector",
                    label:"分销商"
                },{
                    _id:3,
                    labelClass:"flex1 font-size1 h-center tab-selector",
                    label:"待处理"
                }]
            },{
                //list类型
                dojoType: "cq/app/widget/mobile/List",
                //数据提供者
                dataProvider: "cq/bo/shop",
                //获取读取数据地址的方法名
                targetMethod: "getPartnerLoadUrl",
                //listem的label显示
                itemPropMethod: "getShopItemPropForPartener",
                //列表查询条件参数
                queryParamMethod: "getParamsForPartners",
                //列表项的类型，对应的对象分别放在web/item和mobile/item中
                itemType: "IconLabel",
                //工作模式：
                //  single单选(会触发onCqChanged)
                //  multi多选(点击之后选中，不触发事件)
                //  其他点击之后调用dataProvider的方法
                workMode: "action",
                //点击事件响应时，点击之后调用的dataProvider的方法名
                clickMethod: "onPartnerShop",
                //列表呈现方式
                //  列表呈现方式：cq-card显示为卡片模式，row-list单行列表模式
                //  图标大小：mini-card小图宽度44px，middle-card中图宽度72px，big-card大图宽度128px
                listClass: "cq-card middle-card",
                waitFor: {
                    "0": "cqViewParam",
                    "1":"search",
                    "2":"state"
                }
            },{
                fixed:"bottom",
                type:"footerBar",
                buttons:[{
                    dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                    className:"footer-tab-dark",
                    label:"查找更多伙伴",
                    dataProvider:"cq/bo/shop",
                    action:"findMore"
                }]
            }];
            return layout;            
        },
        myPartnerList:function(){
            var def = new Deferred();
            var role = user.getCurrentUserRole();
            var layout = this.getUserLayout();
            if(role == 2 || role == 3){
                layout.splice(2,1);
            }
            def.resolve(layout);               
            return def;
        }
    };
    return layout;
});