//需要解决的问题
//  部分内容为json，引号嵌套的问题
//  界面如何定义，由谁将描述翻译程界面对象
//  谁来复制数据绑定相关的事件侦听
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/query",
    "dojo/keys",
    "dijit/registry",
    "cq/util/css/clearButtonUtil",
    "../config"
],function(declare,lang,array,dom,domAttr,domStyle,domClass,query,keys,registry,clearButtonUtil,config){
    // module:
    //      cq/app/widget/_LayoutMixin

    //需要记录的节点
    /*
    1，field和编辑对象的关系，有getValue、setValue、setCanEdit，一对一
    2，field和节点的关系，字段编辑相关的根节点，用于显示隐藏，一对一
    3，字段和编辑对象的关系，用于关联刷新，一对多
    4，操作和节点之间的关系，一对一
    */
    return declare("",null,{
        // summary:
        //      页面布局的基类，并处理和绑定页面上的各个field的事件
        //      编辑的字段可以为：
        //      a,b,c
        //      a.a1.a2,b,c.c1
        //layout:object
        //      界面布局配置
        layout:null,
        //初始化界面元素
        buildRendering:function(){
            // summary:
            //      创建页面时，初始化各个页面布局的数据显示和事件绑定
            this.inherited(arguments);
            this.__data = this.__data||{};
            this.containerNode = this.containerNode||this.domNode;
            var layout = this.loadLayout();
            if(layout){
                
                // TODO
                //      this.loadLayou是可以被调用并重写的，并且支持异步，所有需要在此判断 
                if(layout.then){
                    layout.then(lang.hitch(this,this.initByLayout));
                }else{
                    this.initByLayout(layout);
                }
            }
        },
        loadLayout:function(){
            // summary:
            //      加载界面布局信息
            //tags:
            //      可以重写，但是返回的形式必须是标准的layout的形式，支持异步
            return this.layout;
        },
        initByLayout:function(layout){
            // summary:
            //      依据布局配置初始化界面
            this.layout = lang.clone(layout);
            this.destroyDescendants();
            config.layoutBuilder.build(this.layout,this).then(lang.hitch(this,this.onLayoutReady));
        },
        onLayoutReady:function(){
            // summary:
            //      界面初始化完毕后相应的处理函数
            this._indexElement();
            this.bindFieldEvent(this);
            //this.cqRefresh();
            //赵春辉   处理有时候页面内容显示不出来的问题   2016-11-01
            var parent = this.getParent();
            if(parent){
                parent.resize();
            }
        },
        cqRefresh:function(){
            this.setData(this.getData());
        },
        // fieldHandlers:array
        //      字段编辑相关的事件绑定对象
        fieldHandlers:null,
        // fieldToElements:object
        //      字段映射到编辑器
        fieldToElements:null,
        // editFieldToEditor:object
        //      编辑字段到编辑器
        editFieldToEditor:null,
        // editFieldToElement:object
        //      编辑字段到编辑器相关根节点
        editFieldToElement:null,
        
        _indexElement:function(){
            // summary:
            //      初始化各个元素的初始值，并获取到所有的需要绑定的节点
            // tags：
            //      private
            if(this.fieldHandlers){
                while(this.fieldHandlers.length){
                    this.fieldHandlers.pop().remove();
                }
            }
            this.fieldHandlers = [];
            this.fieldToElements = {};
            this.editFieldToEditor = {};
            this.editFieldToElement = {};
            //所有需要绑定的节点
            this.fieldElements = query(".cq-field-input",this.containerNode);
            this.actionElements = query(".cq-action",this.containerNode);
        },
        bindFieldEvent:function(){
            //summary:
            //      处理需要绑定的节点的绑定事件(文本输入变化和点击按钮事件)，
            //      并依据数据初始化界面显示
            this.fieldElements.forEach(this.bindFieldElementEvent,this);
            this.actionElements.forEach(this.bindActionElementEvent,this);
            this.setData(this.__data);
        },
        bindFieldElementEvent:function(node,index){
            //summary:
            //      为组件和表单元素绑定相应事件处理函数
            // params:
            //      node:需要绑定事件的节点
            //      index:节点所在数组中的索引值
            var widget = registry.byNode(node);
            if(widget){
                node = widget;
                this.fieldElements[index] = widget;
                this.connect(widget,"onFieldChanged",this.onWidgetFieldChanged);
            }else{
                var type = "";
                switch(node.tagName){
                    case "INPUT":
                        this.initInputEvent(node);
                        type = domAttr.get(node,"type");
                        if("password"===type){
                            //处理密码框获取焦点时选中的问题
                            node.onfocus = function(){
                                this.select();
                            };
                        }
                        if("button"!=type&&"checkbox"!=type){
                            this.connect(node,"onkeypress",function(e){
                                if(e.charOrCode===keys.ENTER){
                                    this.onTextEditorEnter(e.target,e.target.field,e.target.value);
                                }
                            });
                        }
                        clearButtonUtil.initClearButton(node);
                        break;
                    case "TEXTAREA":
                        this.initInputEvent(node);
                        break;
                    case "SPAN":
                        this.initInputEvent(node);
                        break;
                    default:
                        break;
                }
            }
            if(node.field){
                this.indexOneEditor(node,node.field);
            }
        },
        onTextEditorEnter:function(node,field,value){
            
        },
        indexOneEditor:function(editor,field){
            //summary:
            //      编辑区域根节点
            //params:
            //      editor:编辑区域根节点
            //      field:编辑区域
            
            //TODO
            //      编辑的字段可以为：
            //      a,b,c
            //      a.a1.a2,b,c.c1      
            //      处理不同情况并给fieldToElements添加元素
            var node = editor.domNode||editor;
            node = node.parentNode;
            while(node!=this.domNode){
                if(field!==domAttr.get(node,"data-cq-field")){
                    node = node.parentNode;
                }else{
                    break;
                }
            }
            if(node===this.domNode){
                node = editor.domNode||editor;
            }
            this.editFieldToElement[field] = node;
            //编辑字段到编辑器
            this.editFieldToEditor[field] = editor;
            //字段到编辑器
            var fields = field.split(","),fieldSegs = null;
            for(var index=0;index<fields.length;index++){
                fieldSegs = fields[index].split(".");
                while(fieldSegs.length){
                    this.fieldToElements[fieldSegs.join(".")] = this.fieldToElements[fieldSegs.join(".")]||[];
                    this.fieldToElements[fieldSegs.join(".")].push(editor);
                    fieldSegs.pop();
                }
            }
        },
        bindActionElementEvent:function(node){
            //summary:
            //      创建按钮节点的点击事件
            //params:
            //      node:指定节点
            var field = domAttr.get(node,"data-cq-field");
            if(field){
                this.indexOneEditor(node,field);
            }
            node.setLabel = this.buttonSetLabel;
        },
        buttonSetLabel:function(label){
            //summary:
            //      按钮设置指定节点显示内容
            this.innerHTML = label;
        },
        _onWidgetFieldChanged:function(widget,field,value){
            //summary:
            //      依据数据更改原先的数据并刷新相应的编辑区域的显示
            //tags:
            //      private
            this._updateByField(field,value);
            this._updateDisplay(field,widget);
        },
        onWidgetFieldChanged:function(widget,fields,values){
            //summary:
            //      编辑对象统一的变更事件接口,如果fields是一组数组，依次遍历每个属性并
            //      并更改数据并刷新显示,如果不是数组则直接更新数据并刷新显示
            //params:
            //      widget:当前对象
            //      fields:数据更改的编辑对象
            //      values:将要给编辑对象的数据
            if(lang.isArray(fields)){
                array.forEach(fields,function(field,index){
                    this._onWidgetFieldChanged(widget,field,values[index]);
                },this);
            }else{
                this._onWidgetFieldChanged(widget,fields,values);
            }
        },
        setInputElementDisabled:function(disabled){
            //summary:
            //      依据参数来设置文本框的只读属性
            domAttr.set(this,"readOnly",!disabled);  
            if(this.updateState){
                this.updateState();
            }
        },
        
        setCheckElementDisabled:function(disabled){
            //summary:
            //      设置复选框是否可选
            //params：
            //      disabled:boolean
            for(var i = 0;i<this.childNodes.length;i++){
                if(disabled){
                    domAttr.set(this.childNodes[i],"disabled",false);    
                }else{
                    domAttr.set(this.childNodes[i],"disabled",true);    
                }
            }
        },
        parseCanEdit:function(node){
            //summary:
            //      解析节点的dojoProps属性
            //params:
            //      node:节点
            
            //TODO
            if(node.dataset.dojoProps){
                if(!node.dojoProps){
                    node.dojoProps = eval("({" + node.dataset.dojoProps + "})");
                }
                return node.dojoProps.canEdit==false||node.dojoProps.canEdit=="false"?false:true;
            }
            return true;
        },
        initInputEvent:function(node){
            //summary:
            //      初始化<input>表单的点击事件和失焦事件
            //params:
            //      node:当前表单对象节点
            if(domClass.contains(node, "cq-form-cb")){
                //复选框
                node.field = domAttr.get(node, "data-cq-field");
                node.setValue = this.checkBoxSetValue;
                node.getValue = this.checkBoxGetValue;
                node.setCanEdit = this.setCheckElementDisabled;
                node.setCanEdit(this.parseCanEdit(node));
                this.connect(node, "onclick", this.onCheckBoxChanged);
            }else{
                node.field = domAttr.get(node,"data-cq-field");
                node.setValue = this.textBoxSetValue;
                node.getValue = this.textBoxGetValue;
                node.setCanEdit = this.setInputElementDisabled;
                node.setCanEdit(this.parseCanEdit(node));
                this.connect(node,"onblur",this.onTextBoxChanged);
            }
            //文本框
            //密码框
            //按钮
        },
        textBoxSetValue:function(value){
            //summary:
            //      依据参数修改显示问题(文本框、密码框...)
            this.value = value||"";
            if(this.updateState){
                this.updateState();
            }
        },
        textBoxGetValue:function(){
            //summary:
            //      读取内容(文本框、密码框...)
            return this.value||"";
        },
        onTextBoxChanged:function(e){
            //summary:
            //      内容变更事件(文本框、密码框...)
            var node = e.target;
            this.onWidgetFieldChanged(node,node.field,node.getValue());
        },
        // 复选框
        checkBoxSetValue:function(value){
            //summary:
            //      依据参数设置复选框的值，如果为真设为选中，否则不选中
            //params:
            //      value：boolean
            var node = query("input", this)[0];
            if(value){
                domAttr.set(node, "checked", true);
            }else{
                domAttr.set(node, "checked",false);
            }
        },
        checkBoxGetValue:function(){
            //summary:
            //      获取复选框的值
            var node = query("input", this)[0];
            return domAttr.get(node, "checked")?true:false;
        },
        onCheckBoxChanged:function(e){
            //summary:
            //      复选框点击事件的处理，点击后复选框值取反
            var node = e.target;
            if(node.tagName.toLowerCase() == "input" || node.tagName.toLowerCase() == "label"){
                node = node.parentNode;
            }
			value = node.getValue();
			if(e.target.tagName.toLowerCase() != "input"){
				// 复选框，点击之后，value值取反
				value = !value;
				node.setValue(value);
			}
            this.onWidgetFieldChanged(node,node.field,value);
        },
        getData:function(){
            //summary:
            //      获取界面上的所有数据
            this.__data = this.__data||{};
            if(this.fieldElements){
                this.fieldElements.forEach(function(node){
                    if(node.field&&-1===node.field.indexOf(".")&&node.getValue){
                        //TODO 可能有问题，一个对象多个字段
                        var field = node.field,value = node.getValue();
                        if(-1<node.field.indexOf(",")){
                            field = field.split(",");
                            //干劲：20161006，value.shift删除了value的内容，导致node的value被修改。修改为for循环
                            for(var i=0;i<field.length;i++) this.__data[field[i]] = value[i];
                            //while(field.length){
                            //    this.__data[field.shift()] = value.shift();
                            //}
                        }else{
                            this.__data[field] = value;
                        }
                    }
                },this);
            }
            return lang.clone(this.__data);
        },
        setData:function(data){
            //summary:
            //      依据数据初始化界面显示的内容
            //params:
            //      data:初始化界面的数据
            this.__data = data||{};
            if(this.fieldElements){
                //遍历所有对象
                this.fieldElements.forEach(function(node){
                    if(node.field&&node.setValue){
                        //刷新指定对象的显示
                        this.setElementValue(node);
                    }
                },this);
            }
        },
        updateByField:function(field,value){
            //summary:
            //      更新指定字段的值，对外提供的接口，自己不调用
            //params:
            //      fields:指定的编辑字段
            //      value:指定字段更改后的值
            this._updateByField(field,value);
            this._updateDisplay(field);
        },
        _updateByField:function(field,value){
            //summary:
            //      修改编辑区域的数据，只修改数据，不刷新显示
            //params:
            //      fields:当前的编辑文本对象
            //      values:将要给编辑对象的数据
            //tags:
            //      private
            this.__data = this.__data||{};
            this.__data[field] = value;
        },
        _updateDisplay:function(field,exceptWidget){
            //summary:
            //      刷新编辑区域的显示内容
            //params:
            //      fields:当前的编辑对象
            //      exceptWidget:当前编辑文本对象所在的组件，即当前对象
            //tags:
            //      private
            array.forEach(this.fieldToElements[field]||[],function(node){
                if(node.field&&node.setValue&&node!==exceptWidget){
                    this.setElementValue(node);
                }
            },this);
        },
        setElementValue:function(node){
            //summary:
            //      刷新指定节点的显示
            //params:
            //      node:指定节点
            var field = node.field,value = "";
            if(-1<field.indexOf(",")){
                value = [];
                field = field.split(",");
                
                //TODO
                //      处理编辑字段的不同形式
                while(field.length){
                    value.push(this.getFieldValue(field.shift()));
                }
            }else{
                value = this.getFieldValue(field);
            }
            node.setValue(value);
        },
        getFieldValue:function(field){
            //summary:
            //      获取指定节点的值
            //params:
            //      field:指定节点
            if(-1<field.indexOf(".")){
                field = field.split(".");
            }else{
                field = [field];
            }
            var value = this.__data;
            while(field.length&&value){
                value = value[field.shift()];
            }
            return value||0===value||false===value?value:"";
        },
        
        //idInfoMap:array
        //      原始id和真实id之间的对照关系
        idInfoMap:null,
        getElementByField:function(field){
            //summary:
            //      获取指点字段节点的元素
            //params:
            //      field:指定节点
            return this.editFieldToElement[field];
        },
        getEditorByField:function(field){
            //summary:
            //      获取指点编辑区域节点的元素
            //params:
            //      field:指定编辑节点
            return this.editFieldToEditor[field];
        },
        getElementById:function(id){
            //summary:
            //      通过id来获取组件上的节点
            //      此处的Id是layout里面定义的Id，不是widget里面的真实的Id
            id = this.idInfoMap[id];
            if(!id){
                return null;
            }else{
                var node = registry.byId(id);
                if(node){
                    return node.domNode;
                }else{
                    return dom.byId(id);
                }
            }
        },
        byId:function(id){
            id = this.idInfoMap[id];
            if(!id){
                return null;
            }else{
                return registry.byId(id);
            }
        },
        _showElement:function(node){
            //summary:
            //      处理节点的显示
            //tags:
            //      private
            
            //TODO
            if(node){
                var display = domStyle.get(node,"display");
                if("none"===display){
                    domStyle.set(node,"display",node.orginDisplay||"");
                }
            }
        },
        _hideElement:function(node){
            //summary:
            //      处理节点的隐藏       
            //tags:
            //      private
            
            //TODO
            if(node){
                var display = domStyle.get(node,"display");
                if("none"!==display){
                    if(!node.orginDisplay){
                        node.orginDisplay = display;
                    }
                    domStyle.set(node,"display","none");
                }
            }
        },
        showByIds:function(ids){
            //summary:
            //      通过id来处理节点的显示问题
            //params:
            //      ids:array
            array.forEach(ids,function(idTemp){
                this._showElement(this.getElementById(idTemp));
            },this);
        },
        hideByIds:function(ids){
            //summary:
            //      通过id来处理节点的隐藏问题
            //params:
            //      ids:array
            array.forEach(ids,function(idTemp){
                this._hideElement(this.getElementById(idTemp));
            },this);
        },
        
        //通过字段名和action处理，自己生成的通过这组方法
        showByFields:function(fields){
            //summary:
            //      通过字段名来显示页面上的节点的显示
            //params:
            //      fields:array
            array.forEach(fields,function(fieldsTemp){
                this._showElement(this.getElementByField(fieldsTemp));
            },this);
        },
        hideByFields:function(fields){
            //summary:
            //      通过字段名来显示页面上的节点的隐藏
            //params:
            //      fields:array
            array.forEach(fields,function(fieldsTemp){
                this._hideElement(this.getElementByField(fieldsTemp));
            },this);
        },
        enableByFields:function(fields){
            //summary:
            //      通过字段名来控制指定结点能编辑
            //params:
            //      fields:array
            array.forEach(fields,function(fieldsTemp){
                var node = this.getEditorByField(fieldsTemp);
                if(node){
                    if(node.setCanEdit) node.setCanEdit(true);
                    else{
                        domClass.remove(node,"disabled");
                    }
                }
            },this);
        },
        disableByFields:function(fields){
            //summary:
            //      通过字段名来控制指定结点不能编辑
            //params:
            //      fields:array
            array.forEach(fields,function(fieldsTemp){
                var node = this.getEditorByField(fieldsTemp);
                if(node){
                    if(node.setCanEdit) 
                        node.setCanEdit(false);
                    else{
                        domClass.add(node,"disabled");
                    }
                }
            },this);
        }
    });
});
