define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/EdgeToEdgeList",
    "../_ListMixin"
],function(declare,lang,EdgeToEdgeList,_ListMixin){
    var props = "label:'{label}',dataProvider:'{dataProvider}',targetMethod:'{targetMethod}',itemPropMethod:'{itemPropMethod}',queryParamMethod:'{queryParamMethod}',itemType:'{itemType}',workMode:'{workMode}',pageSize:'{pageSize}',clickMethod:'{clickMethod}'";
    return declare("",[EdgeToEdgeList,_ListMixin],{
        htmlTemp:'<ul id="{id}" class="cq-list {listClass}" data-dojo-type="cq/app/widget/mobile/List" allData=\'{j:allData}\' items=\'{j:items}\' data-dojo-props="'+props+'"></ul>',
        buildRendering:function(){
            this.inherited(arguments);
            if(this.dataProvider){
                var scrollable = this.getParent();
                while(scrollable&&(!scrollable.scrollTo)){
                    scrollable = scrollable.getParent();
                }
                this.scrollable = scrollable;
                if(this.scrollable){
                    //处理拖动加载更多
                    this.connect(scrollable,"onAfterScroll",function(e){
                        if(true!==this.busy&&e.afterBottom&&this._totalCount>this.start){
                            this.start = this.start + this.pageSize;
                            this.busy = true;
                            setTimeout(lang.hitch(this,function(){
                                this.loadMore();
                            }),1000);
                        }
                    });
                }
            }
        },
        loadMore:function(){
            var result = this.inherited(arguments);
            result.then(lang.hitch(this,function(){
                if((!this.start)&&this.scrollable){
                    this.scrollable.scrollTo({
                        x:0,
                        y:0
                    });
                }
                this.busy = false;
            }),lang.hitch(this,function(){
                this.busy = false;
            }));
        },
        onTotalReady:function(total){
            this._totalCount = total;
        },
        getItemTypeId:function(itemType){
            return "cq/app/widget/mobile/item/"+itemType;
        }
    });
});