﻿define([
    "dojo/_base/declare",
    "dojox/mobile/Switch"
],function(declare,Switch){
    // module:
    //      cq/app/widget/mobile/edit/CheckBox
    return declare("",[Switch],{
        // summary:
        //      所有复选框的编辑页面方式
        
        // htmlTemp:String
        //      复选框的html片段
        htmlTemp:'<div class="cq-form-checkbox cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/CheckBox" data-dojo-props="leftLabel:\'\',rightLabel:\'\',field:\'{field}\',canEdit:\'{canEdit}\'">',
        // field:String
        //      复选框的字段名
        field:"",
        // canEdit:boolean
        //      控制复选框是否可以编辑的字段
        canEdit:"",
        
        setCanEdit:function(canEdit){
            // summary:
            //      根据canEdit字段的值来设置复选框是否可以编辑
            canEdit = canEdit!==false&&canEdit!=="false";
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        //点击
        onClick:function(){
            // summary:
            //      点击复选框时触发，如果复选框不可编辑则返回，
            this.setCanEdit(this.canEdit);
            if(this.disabled) return false; 
        },
        //手机端滑动
        onTouchStart:function(){
            // summary:
            //      手机端滑动时触发，如果复选框不可编辑则返回，否则返回所有的复选框参数
            this.setCanEdit(this.canEdit);
            if(this.disabled) return false; 
            return this.inherited(arguments);
        },
        getValue:function(){
            // summary:
            //      获取所有被选中的复选框的值
            return this.get("value")==="on";
        },
        setValue:function(value){
            // summary:
            //      为复选框设定是否被选中
            this.set("value",value?"on":"off");
        },
        onStateChanged:function(){
            // summary:
            //      当复选框的状态改变时触发，提供外部使用
            this.onFieldChanged(this,this.field,this.getValue());
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      字段变化后触发，本身不做任何操作，提供外部使用
        }
    });
});