﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/ListItem",
    "cq/util/edit/datePick",
    "cq/util/edit/dateTimePick",
    "cq/util/sys/date"
],function(declare,lang,domStyle,ListItem,datePick,dateTimePick,date){
    // module:
    //      cq/app/widget/mobile/edit/Date
    
    return declare("",[ListItem],{
        // summary:
        //      时间编辑页面方式，列表选项，呈现为一个ListItem，内容显示在右侧
        
        // htmlTemp:String
        //      时间的html片段，内容显示在右侧
        htmlTemp:'<li class="cq-form-dateTime cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/DateTime" data-dojo-props=\'canEdit:"{canEdit}",field:"{field}",label:"{label}"\'></li>',
        
        // field:String
        //      时间列表的字段名
        field:"",
        
        // clickable:boolean
        //      控制时间列表是否可以点击的字段，默认为true
        clickable:true,
        
        // canEdit:boolean
        //      控制时间列表是否可以编辑,默认为true
        canEdit:true,
        
        buildRendering:function(){
            // summary:
            //      创建列表时，初始化列表元素
            this.setCanEdit(this.canEdit!==false&&this.canEdit!=="false");
            this.inherited(arguments);
        },
        
        getValue:function(){
            // summary:
            //      获取时间列表上的值
            return this.get("value");
        },
        
        setValue:function(value){
            // summary:
            //      如果时间列表可以编辑则根据传入的值更改列表的值，否则将该时间显示节点的透明度设置为0
            this.set("value",value);
            this.set("rightText",value?date.formatISODateMinutes(value):"");
        },
        
        setCanEdit:function(canEdit){
            // summary:
            //      根据参数来设置是否可以编辑时间列表，通过设置节点的透明度来实现控制
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        
        onClick:function(viewNode){
            // summary:
            //      如果不能编辑，则返回，否则将在该视图里面编辑时间并刷新页面显示，
            //      然后触发数据改变函数,提供外部使用
            if(false===this.canEdit){
                return;
            }
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            dateTimePick.startEdit(this.getValue()||"",this.view||viewNode).then(lang.hitch(this,function(value){
                this.setValue(value);
                this.onFieldChanged(this,this.field,value);
            }));
        },
        
        onFieldChanged:function(widget,field,value){
            // summary:
            //      数据改变后触发，提供外部实现功能
        }
    });
});