﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/ListItem",
    "cq/ui/util/districtOverlay"
],function(declare,lang,domStyle,ListItem,districtOverlay){
    // module:
    //      cq/app/widget/mobile/edit/District
    return declare("",[ListItem],{
        // summary:
        //      区化编辑页面方式，列表选项，呈现为一个ListItem，内容显示在右侧
        
        // htmlTemp:String
        //      区化的html片段，内容显示在右侧
        htmlTemp:'<li class="cq-form-district cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/District" data-dojo-props=\'canEdit:"{canEdit}",enableAll:"{enableAll}",selectType:"{selectType}",field:"{field}",labelTitle:"{label}"\'></li>',
        
        // field:String
        //      区化的字段名
        field:"",
        
        // labelTitle:String
        //      区划的字段标题
        labelTitle:"",
        // clickable:boolean
        //      能否点击字段，默认为true
        clickable:true,
        
        //enableAll:boolean
        //      
		enableAll:false,
        
        // canEdit:boolean
        //      控制能否编辑区划字段，默认为true
        canEdit:true,
        
        // selectType:String
        //      1:省市区+区划名,2:省市区,3:乡镇和村+区划名,4:乡镇和村，目前只支持1，3
        //      格式为"1","2","3"
		selectType:"1", 
        
        buildRendering:function(){
            // summary:
            //      创建列表时，初始化列表元素
            this.label = this.labelTitle;
            this.fields = this.field.split(",");
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
			this.selectType = this.selectType?this.selectType:"1";
            this.inherited(arguments);
        },
        
        setCanEdit:function(canEdit){
            // summary:
            //      设置是否能够编辑列表，通过设置透明度来达到控制效果
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        getValue:function(){
            // summary:
            //      获取列表上的值
            return this.get("value");
        },
        getDistLabel:function(distArr){
            // summary:
            //      创建列表时，初始化列表元素
            var label = "";
            for(var i=0;i<distArr.length;i++){
                if(distArr[i]&&distArr[i].distName){
                    label += distArr[i].distName;
                }
            }
            return label||"全国";
        },
        setValue:function(value){
            if(!this.canEdit){
                domStyle.set(this.rightIconNode,"opacity",0);
            }
            //value.remark=((value.provinceId&&value.provinceId.distName)||"")+((value.cityId&&value.cityId.distName)||"")+((value.countId&&value.countId.distName)||"");
            this.set("value",value);
            this.set("rightText",this.fields.length===4?value&&value[3]||"":this.getDistLabel(value));
        },
        onClick:function(parentView){
            if(false===this.canEdit){
                return;
            }
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            var value = this.getValue();
            districtOverlay.selectDistrict({
                province:value&&value[0],
                city:value&&value[1],
                county:value&&value[2]
            },this.enableAll).then(lang.hitch(this,function(value){
                var distArr = value?[value.province,value.city,value.county]:[null,null,null];
				if(this.fields.length===4){
                    var oldValue = this.getValue()||[];
                    if(this.getDataKey(distArr[0])!==this.getDataKey(oldValue[0])||this.getDataKey(distArr[1])!==this.getDataKey(oldValue[1])||this.getDataKey(distArr[2])!==this.getDataKey(oldValue[2])){
                        distArr.push(this.getDistLabel(distArr));
                    }else{
                        if(!oldValue[3]){
                            distArr.push(this.getDistLabel(distArr));    
                        }else{
                            distArr.push(oldValue[3]); 
                        }
                        
                    }
                }
                this.setValue(distArr);
                this.onFieldChanged(this,this.fields,distArr);
            }));
        },
        getDataKey:function(data){
            return "string"===typeof(data)?data:data&&data._id||data||"";
        },
        onFieldChanged:function(widget,field,value){
        }
    });
});