﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/event",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojox/mobile/ListItem",
    "cq/biz/blob/blob"
],function(declare,lang,event,domAttr,domClass,domConstruct,ListItem,blob){
    return declare("",[ListItem],{
        htmlTemp:'<li id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-fileEditor" data-dojo-type="cq/app/widget/mobile/edit/FileEditor" data-dojo-props=\'labelText:"{label}",canEdit:"{canEdit}",field:"{field}",value:{j:value}\'></li>',
        field:"",
        labelText:"",
        canEdit:true,
        value:null,
        buildRendering:function(){
            this.label = this.labelText;
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
            this.initFileEditor();
            //this.setCanEdit(this.canEdit);
        },
        setCanEdit:function(canEdit){
            this.canEdit = canEdit!==false&&canEdit!=="false";
            this.domNode.childNodes[0].innerHTML = this.canEdit?"选择文件":"下载";
            
        },
        getValue:function(){
            return this.value;
        },
        setValue:function(value){
			if(value){
				this.value = value;
				this.domNode.childNodes[0].innerHTML = this.canEdit?"选择文件":"下载";
				this.label=this.labelText+":"+(this.value.title||"");
                for(var i=0;i<this.domNode.childNodes.length;i++){
                    if(domClass.contains(this.domNode.childNodes[i],"mblListItemLabel")){
                        this.domNode.childNodes[i].innerHTML = this.label;
                    }
                }
				if(this.canEdit&&this.rightTextNode){
                    if(!this.downLoadBtnA){
                        this.downLoadBtnA = domConstruct.create("a",{
                            href:this.value.url,
                            downLoad:this.value.title,
                            style:"display:none;"
                        },document.body); 
                    }
					domAttr.set(this.downLoadBtnA,"href",this.value.url||"");
					domAttr.set(this.downLoadBtnA,"download",this.value.title||"");
				}
			}
			
        },
        onFiledChanged:function(widget,field,value){
            
        },
		//初始化组件
        initFileEditor:function(){
            this.rightText = this.canEdit?"选择文件":"下载";
			this.label=this.labelText+"："+(this.value.title||"");
            for(var i=0;i<this.domNode.childNodes.length;i++){
                if(domClass.contains(this.domNode.childNodes[i],"mblListItemLabel")){
                    this.domNode.childNodes[i].innerHTML = this.label;
                }
            }
        },
		loadFile:function(){
			var fileSelectInput = domConstruct.create("input",{
                "class":"none",
                //multiple:"multiple",
                type:"file"
            },document.body);
            fileSelectInput.click();
            fileSelectInput.onchange = lang.hitch(this,function(){
                blob.upload(fileSelectInput).then(lang.hitch(this,function(data){
                    if(data.items){
                        this.value ={
                            title:data.items[0].originName,
                            url:data.items[0].uri
                        };
                    }
                    this.setValue(this.value);
                    this.onFieldChanged(this,this.field,this.value);
                    if(fileSelectInput.parentNode){
                        fileSelectInput.parentNode.removeChild(fileSelectInput);
                    }
                }));
            });
		},
		// 组件准备完毕后执行setCanEdit();
		startup:function(){
			this.inherited(arguments);
            this.connect(this.rightTextNode,"onclick",lang.hitch(this,function(){
                if(this.canEdit){
                    this.loadFile();
                }else{
                    if(!this.downLoadBtnA){
                        this.downLoadBtnA = domConstruct.create("a",{
                            href:this.value.url,
                            downLoad:this.value.title,
                            style:"display:none;"
                        },document.body);
                        this.downLoadBtnA.click()  
                    }else{
                        this.downLoadBtnA.click();
                    }
                }
            }));
		}
    });
});