﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/touch",
    "dojox/mobile/IconContainer",
    "dojox/mobile/IconItem",
    "dojox/mobile/_EditableIconMixin",
    "cq/biz/blob/blob"
],function(declare,lang,array,domClass,domStyle,touch,IconContainer,IconItem,_EditableIconMixin,blob){
    //列表选项，呈现为一个ListItem，内容显示在右侧
    return declare("",[IconContainer],{
        htmlTemp:'<ul class="cq-form-imgs cq-field-input no-shake" data-dojo-type="cq/app/widget/mobile/edit/Images" data-dojo-props=\'sizeType:"{sizeType}",canEdit:"{canEdit}",field:"{field}",label:"{label}",size:{j:size}\'></ul>',
        field:"",
        label:"",
        size:{},
        //默认为压缩
        sizeType:"",
        canEdit:true,
        editable:true,
        
        //初始化内容
        buildRendering:function(){
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
            var size = {};
            if(this.size.width||this.size.height){
            }else{
                this.size = {width:640,height:480};
            }
            this.addItem = new IconItem({
                editable : false,
                onClick:function(){
                    return false;
                },
                innerHTML :"<div class='mblIconArea'><div class='mblIconAreaInner add-image' onclick=''>+<form action='/biz/blob/blob/upload'><input class='hidden-file-input' type='file'/></form></div></div>"
            });
        },
        setCanEdit:function(canEdit){
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        postCreate:function(){
            this.inherited(arguments);
            this.connect(this,"startEdit",function(){
                this.addChild(this.addItem);
            });
            this.addItem.domNode.addEventListener("click",lang.hitch(this,this.onAddImage));
            //this.own(touch.release(this.addItem.domNode,lang.hitch(this,this.onAddImage)));
            if(this.canEdit){
                this.startEdit();
            }
            var endEdit = this.endEdit;
            this.endEdit = function(){
                this._removeAddItem();
                return endEdit.apply(this,arguments);
            };
        },
        onAddImage:function(e){
            if(!this.canEdit){
                return;
            }
            blob.selectAndUpload(this.size,0.7,this.sizeType).then(lang.hitch(this,function(data){
                if(data.items && data.items.length == 1){
                    var newIcon = new IconItem({
                        icon : data.items[0].uri,
                        label : this.getChildren().length == 1?"主图":"细节图"
                    });
                    this.endEdit();
                    this.addChild(newIcon);
                    this.startEdit();
                    this.onFieldChanged(this,this.field,this.getValue());
                }
            }));
        },
        //设置内容
        getValue:function(){
            return array.map(array.filter(this.getChildren(),function(item){
                return item!==this.addItem;
            },this),function(item){
                return item.icon;
            });
        },
        //更新内容
        setValue:function(value){
            this.set("value",value);
            //刷新显示
            this.endEdit();
            var items = this.getChildren();
            while(items.length){
                items.pop().destroyRecursive();
            }
            for(var index=0;index<value.length;index++){
                var icon = new IconItem({
                    icon : value[index],
                    label : index == 1?"主图":"细节图"
                });
                this.addChild(icon);
            }
            if(this.canEdit){
                this.startEdit();
            }
        },
        
        onItemClick:function(){
            return false;
        },
        scaleItem:function(movingItem, scale){
            if(scale>1){
                this._removeAddItem();
            }
        },
        _removeAddItem:function(){
            var node = this.addItem&&this.addItem.domNode;
            if(node&&node.parentNode){
                node.parentNode.removeChild(node);
            }
        },
        onMoveItem:function(){
            this.inherited(arguments);
            this._refreshItem();
        },
        _refreshItem:function(){
            array.forEach(this.getChildren(),function(item,index){
                item.set("label",index===0?"主图":"细节图");
            });
            this.addChild(this.addItem);
            this.onFieldChanged(this,this.field,this.getValue());
        },
        removeChild:function(){
            this.inherited(arguments);
            this._refreshItem();
        },
        onFieldChanged:function(widget,field,value){
            
        }
    });
});