﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/ListItem",
    "cq/util/edit/optionsList"
],function(declare,lang,domStyle,ListItem,optionsList){
    // module:
    //      cq/app/widget/mobile/edit/LinkItem
    //      列表选项，呈现为一个ListItem，内容显示在右侧
    return declare("",[ListItem],{
        // summary:
        //      链接编辑页面方式，列表选项，呈现为一个ListItem，内容显示在右侧
        
        // htmlTemp:String
        //      区化的html片段，内容显示在右侧
        htmlTemp:'<li class="cq-form-date cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/LinkItem" data-dojo-props=\'canEdit:"{showLogo}",field:"{field}",label:"{label}",icon:"{icon}",rightText:"{rightText}",targetView:"{href}"\'></li>',
        
        // field:String
        //      显示属性的字段名
        field:"",
        
        // targetView:String
        //      跳转页面的链接
        targetView:"",
        
        // clickable:boolean
        clickable:true,
        
        //canEdit:boolean
        //      用来处理是否显示logo
        canEdit:true,
        
        
        buildRendering:function(){
            // summary:
            //      创建列表时，初始化列表元素
            
            //将原始的数据赋值给相应的变量，用以替换变量和赋值时使用
            this.fields = this.field.split(",");
            this.oriLabel = this.label;
            this.oriRightText = this.rightText;
            this.oriTargetView = this.targetView;
            this.oriIcon = this.icon;
            this.canEdit = this.canEdit !==false && this.canEdit!=="false";
            this.inherited(arguments);
        },
        setValue:function(value){
            //summary
            //      设置列表显示内容
            
            this.value = value;
            // 设置右边箭头
            domStyle.set(this.rightIconNode,"opacity",1);
            if(!this.targetView){
                domStyle.set(this.rightIconNode,"opacity",0);
            }
            // changeLabel,changeRightText,changeTargetView:Array
            //      获取穿过来的参数里面花括号里面的内容     
            var changeLabel = this.oriLabel;
            var changeRightText = this.oriRightText;
            var changeTargetView = this.oriTargetView;
            var changeIcon = this.oriIcon;
            // 将获取括号里面的值与传入的字段名比对并更新数据并赋值显示内容
            for(var i = 0;i<this.fields.length;i++){
                changeLabel = changeLabel.replace("{"+this.fields[i]+"}",value[i]||"");
                changeRightText = changeRightText.replace("{"+this.fields[i]+"}",value[i]||"");
                changeTargetView = changeTargetView.replace("{"+this.fields[i]+"}",value[i]||"");
                changeIcon = changeIcon.replace("{"+this.fields[i]+"}",value[i]||"");
            }
            this.set("label",changeLabel);
            this.set("rightText",changeRightText);
            this.set("icon",changeIcon);
            this.targetView = changeTargetView;
        },
        onClick:function(){
            // summary
            //      点击跳转页面
            if(this.targetView){
                location.href = this.targetView;
            }
        },
        onFieldChanged:function(widget,field,value){
            // summary
            //      当内容变化通知其他地方，供外部使用
        },
        
        getChangeField:function(data){
            // summary
            //      获取字符串花括号里面的值，并将获取到的值返回
            //  param
            //      data:String    
            var datas =[];
            if(data.indexOf("{")!==-1){
                var startIndex = data.indexOf("{");
                var endIndex = data.indexOf("}");
                datas.push(data.slice(startIndex+1,endIndex));
            }
            return datas;
        },

        getOtherString :function(data,param){
            // summary
            //      将第一个参数的中的花括号里面的内容用第二个参数替换掉，并返回替换后的值
            //  data:string
            //        被替换的字符串
            //  param:string
            //        替换的内容    
            if(this.getChangeField(data)){
                var datas=data.split("{");
                var newdatas = datas[1].split("}");
                var newString =datas[0]+param+newdatas[1]+"";
                return newString;
            }else{
                return data;
            }
        }
    });
});