﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojox/mobile/ListItem",
    "cq/util/edit/position"
],function(declare,lang,domConstruct,ListItem,position){
    if(!window.AMap){
        domConstruct.create("script",{
            //高德地图url
            src:"http://webapi.amap.com/maps?v=1.3&amp;key=0b9138e58ee2c5776ed90d144bfbfd97"
        },document.head,"last");
    }
    //列表选项，呈现为一个ListItem，内容显示在右侧
    return declare("",[ListItem],{
        htmlTemp:'<li id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-location" data-dojo-type="cq/app/widget/mobile/edit/Location" data-dojo-props="label:\'{label}\',canEdit:\'{canEdit}\',field:\'{field}\',distFields:\'{distFields}\',distFieldsStr:\'{distFieldsStr}\',detailAddrField:\'{detailAddrField}\'"></li>',
        //经纬度对应的字段，两个字段，用逗号隔开
        field:"",
        distFields:"",
        distFieldsStr:"",
        detailAddrField:"",
        clickable:true,
        canEdit:"",
        //addrField="",
        //fieldsStr:"",
        //canEdit:true,
        
        buildRendering:function(){
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
            this.distFieldArr = this.distFields.split(",");
            if(this.distFieldsStr){
                this.distFieldArr.push(this.distFieldsStr);
            }
        },
        setCanEdit: function(canEdit){
            this.canEdit = canEdit;
        },
        getValue:function(){
            return this.value||[];
        },
        setValue:function(value){
            this.value = value||[];
            if(value&&value[0]&&value[1]){
                this.set("rightText","已设置");
            }else{
                this.set("rightText","点击设置");
            }
        },
        onClick:function(viewNode){
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            position.startEdit(this.value&&this.value[0]&&this.value[1]&&{
                lon:this.value[0],
                lat:this.value[1]
            }||null,this.view||viewNode).then(lang.hitch(this,function(value){
                position.setEnable(true);
                if(!this.canEdit){
                    return;
                }
                var pos = [];
                if(value&&value.lon&&value.lat){
                    pos = [value.lon,value.lat];
                }
                this.setValue(pos);
                
                this.onFieldChanged(this,this.field.split(","),pos);
                if(this.distFields){
                    position.getCurrentDistName().then(lang.hitch(this,function(data){
                        require([
                            "cq/biz/shop/bs/district"
                        ],lang.hitch(this,function(district){
                            district.getPCCByName(data).then(lang.hitch(this,function(data){
                                if(data&&data.data&&data.data.item&&data.data.item.province){
                                    var value = [];
                                    if(data.data.item.city&&data.data.item.county){
                                        value = [
                                            data.data.item.province,data.data.item.city,data.data.item.county
                                        ];    
                                    }else{
                                        value = [
                                            data.data.item.province,null,null
                                        ];
                                    }
                                    if(this.distFieldArr.length===4){
                                        value.push((value[0]&&value[0].distName||"")+(value[1]&&value[1].distName||"")+(value[2]&&value[2].distName||""))
                                    }
                                    
                                    //通知区划改变
                                    this.onFieldChanged(this,this.distFieldArr,value);
                                }
                            }));
                        }));
                    }));
                }
                if(this.detailAddrField){
                    position.getDetailAddrFields(this.value[0],this.value[1]).then(lang.hitch(this,function(detailAddr){
                        if(detailAddr){
                            this.onFieldChanged(this,this.detailAddrField,[detailAddr]);
                        }
                    }));
                }
            }));
            position.setEnable(this.canEdit);
        },
        onFieldChanged:function(widget,field,value){
            
        }
    });
});