define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/_base/event",
    "dojo/touch",
    "dojo/Deferred",
    "dijit/registry",
    "dojox/mobile/ListItem",
    "dojox/mobile/View",
    "cq/app/widget/web/DataLayout",
    "cq/util/edit/overlay",
    "cq/bo/BoBase",
    "cq/app/widget/mobile/edit/District"
],function(declare,lang,domConstruct,domStyle,domClass,domAttr,event,touch,Deferred,registry,ListItem,View,DataLayout,overlay,BoBase,district){
    return declare("",[ListItem],{
        htmlTemp:'<li class="cq-form-objeditor cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/ObjEditor" data-dojo-props=\'fields:{j:fields},rightTextField:"{rightTextField}",labelField:"{labelField}",dataProvider:"{dataProvider}",canEdit:"{canEdit}",field:"{field}",label:"{label}",canAdd:"{canAdd}"\'></li>',
        field:"",
        fields:{},
        label:"",
        labelField:"",
        rightTextField:"",
        clickable:true,
        canEdit:true,
        canAdd:true,
        dataProvider:"",
        labelMethod:"",
        getObjLabel:function(field, data){
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    var def = new Deferred();
                    require([this.dataProvider], lang.hitch(this, function(dataProvider){
                        this.dataProvider = dataProvider;
                        var dt = this.dataProvider[this.labelMethod](field, data);
                        if(dt&&dt.then){
                            dt.then(function(result){
                                def.resolve(result);
                            });
                        }else{
                            def.resolve(dt);
                        }
                    }));
                    return def;
                }
            }else{
                return data&&data[field]||"";
            }
        },
        setCanEdit:function(canEdit){
            
            this.canEdit = canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
            if("inline"===this.workMode){
                //inline编辑模式，设置要编辑的所有字段的可编辑状态
                if(this._loadingEditor){
                    this._refreshCanEdit = true;
                    return;
                }
                if(canEdit){
                    this.inlineView.enableByFields([this.fields[0].field]);
                }else{
                    this.inlineView.disableByFields([this.fields[0].field]);
                }
            }
        },
        buildRendering:function(){
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.canAdd = this.canAdd!==false&&this.canAdd!=="false";
            this.fields = this.fields.layout;
            this.workMode = this.fields.length===1?"inline":"multip";
            if("inline"===this.workMode){
                this._loadingEditor = true;
                this._setCanEditing = true;
                setTimeout(lang.hitch(this,this.initInlineEditor),0);
            }
            this.inherited(arguments);
        },
        initInlineEditor:function(){
            // summary:
            //      初始化inline编辑器 

            //处理layout和 fields
            var layout ={};
            var fields =[];
            var item = lang.clone(this.fields[0]);
            fields.push(item.field);
            layout[item.field] = item;
            delete layout[item.field].field;
            
            //设置label为空
            this.label="";
            
            //创建inline编辑器，addChild
            this.inlineView = this.createInlineView(fields,layout);
            this.inlineView.placeAt(this.labelNode);
            
            // 调整样式并注销右箭头的点击事件
            var fieldElement = this.inlineView.getElementByField(this.fields[0].field);
            if(fieldElement){
                fieldElement = registry.byNode(fieldElement);
            }
            if(fieldElement){
                fieldElement.set("rightIcon","");
                domStyle.set(fieldElement.domNode,{
                    "float":"none",
                    "display":"block",
                    "background-color":"rgba(0,0,0,0) !important",
                    "margin":"0"
                });
                domStyle.set(fieldElement.getParent().domNode,{
                    margin:"0"
                });
            }
            this.connect(this.inlineView.domNode,"onclick",function(e){
                event.stop(e);
            });
            
            //侦听事件。inline编辑器的connect方法——变化之后刷新自己的内容，onFieldChanged
            this.connect(this.inlineView.getEditorByField(this.fields[0].field),"onFieldChanged",function(){
                this.initInlineData();
            });
            
            //初始化inline编辑器的内容
            this._loadingEditor = false;
            if(this._refreshOnload){
                this._refreshOnload = false;
                this._loadingEditor = false;
                this.setValue(this.getValue());
            }else{
                this.setValue(this.getValue());    
            }
            
            //初始化inline编辑器的可编辑状态
            this.setCanEdit(this.canEdit);
            //自动弹出overlay
            if(this._clickOnReady){
                this.onClick();
            }
            
            this._setCanEditing = false;
            if(this._refreshCanEdit){
                this._refreshCanEdit = false;
                this.setCanEdit(this.canEdit);
            }
        },
        
        initInlineData:function(){
            // summary:
            //      根据改变后的数据刷新自己的内容，并通知请他字段改变内容。
            
            this.onFieldChanged(this,this.field,this.inlineView.getData());
        },
        getValue:function(){
            // 获取组件的返回值
            return this.get("value");
        },
        //val:"",
        setValue:function(value){
            this.set("value",value);
            if("inline"===this.workMode){
                if(this._loadingEditor){
                    this._refreshOnload = true;
                    return;
                }
                //调用inlien编辑器的setData方法，刷新显示
                this.inlineView.setData(value);
            }else{
                if(this.dataProvider){
                    if(value){
                        this.getObjLabel(this.field, value).then(lang.hitch(this, function(label){
                            this.set("label", label);
                        }));
                    }else{
                        this.set("label", "");
                    }
                    this.set("rightText", "");
                }else{
                    this.set("rightText",value?this.getObjLabel(this.rightTextField,value):"");
                    if(this.labelField){
                        this.set("label", value?this.getObjLabel(this.labelField, value):"");
                    }
                }
            }
        },
        onClick:function(callback){
            if(!this.canAdd||false===this.canEdit){
                return;
            }
            if("inline"===this.workMode){
                if(this.inlineView){
                    if(this.inlineView.getEditorByField(this.fields[0].field).onClick){
                        this.inlineView.getEditorByField(this.fields[0].field).onClick();
                    }
                }else{
                    this._clickOnReady = true;
                }
                return;
            }
            //if(this.fields.length>1){
            // 点击之后创建DataLayout，底部添加确定和取消按钮，showInOverlay
            if(!this.pane){
                this.pane = new View();
                this.overlayView = this.createOverlayView();
                this.overlayView.placeAt(this.pane.domNode);
                this.btnPane = domConstruct.create("div",{},this.pane.domNode);
                this.subBtn = domConstruct.create("div",{
                    innerHTML:"确认",
                    className:"cq-btn-submmit",
                    style:"width:50%;height:49px;display:inline-block;background-color:rgba(145, 189, 214,0.8);color:black !important;background:none;font-size:12px;font-weight:normal;line-height:49px;text-align:center;"
                }, this.btnPane);
                this.cancleBtn = domConstruct.create("div",{
                    innerHTML:"取消",
                    className:"cq-btn-cancle",
                    style:"width:50%;height:49px;display:inline-block;background-color:rgba(33, 128, 172,0.8);color:black !important;background:none;font-size:12px;font-weight:normal;line-height:49px;text-align:center;"
                }, this.btnPane);
                // 绑定确定和取消按钮的点击事件
                touch.release(this.btnPane, lang.hitch(this, function(evt){
                    var target = evt.target;
                    if(domClass.contains(target, "cq-btn-submmit")){
                        // 确认按钮
                        var data = this.overlayView.getData();
                        this.setValue(data);
                    }
                    this.onFieldChanged(this, this.field, this.getValue());
                    var deleteList = this.getValue();
                    this.view.show();
                }));
            }
            this.overlayView.setData(this.get("value"));
            
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            this.pane.placeAt(this.view,"after");
            this.pane.startup();
            this.pane.show();
        },
        onFieldChanged:function(widget,field,value){
        },
        
        createInlineView : function(fields,layout){
            var model = new BoBase({
                fields:layout
            });
            return new DataLayout({
                layout:[{
                    type:"form",
                    fields:model.getFormItems(fields)
                }]
            });
        },
		createOverlayView:function(){
            var layout = {};
            var fields = [];
            lang.clone(this.fields).forEach(function(item){
                fields.push(item.field);
                layout[item.field] = item;
                delete layout[item.field].field;
            });
			var model = new BoBase({
				fields:layout
			});
			return new DataLayout({
				layout:[{
					type:"form",
					fields:model.getFormItems(fields)
				}]
			});
		},
        // 功能：更改对象fields
        // 传递参数有 fields（array）
        alterLayout:function(fields) {
            // 清空原有数据
			this.setValue(null);
			this.onFieldChanged(this, this.field, null);
			
			// 设置编辑属性清单
			this.fields = fields;
            
            //清理工作
            if(this.inlineView){
                //重做buildRendering中初始化工作
                //工作模式
                //若inline，初始化
                this.inlineView.destroyRecursive();
                this.buildRendering();
            }
			// 若已经创建编辑对象
			if(this.overlayView){
				var dataLayout = this.overlayView;
				// 依据新的属性清单创建创建编辑对象
				this.overlayView = this.createOverlayView();
				this.overlayView.placeAt(dataLayout.domNode,"before");
				// 销毁原有编辑对象
				dataLayout.destroyRecursive();
			}
        }
    });
});