define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/touch",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "dijit/registry",
    "./ObjEditor",
    "dojox/mobile/_EditableListMixin"
],function(declare,lang,domConstruct,domStyle,touch,EdgeToEdgeList,ListItem,registry,ObjEditor){
    return declare("",[EdgeToEdgeList],{
        htmlTemp:'<div class="cq-form-objseditor cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/ObjsEditor" data-dojo-props=\'rightTextField:"{rightTextField}",canAdd:{canAdd},canDelete:{canDelete},canDnd:{canDnd},label:"{label}",canEdit:{canEdit},field:"{field}",defaultData:{j:defaultData},labelField:"{labelField}",fields:{j:fields}\'></div>',
        field:"",
        fields:{},
        canEdit:true,
        // 是否可以添加
        canAdd:true,
        // 是否可以删除
        canDelete:true,
        // 是否可以调整顺序
        canDnd:true,
        label:"",
        labelField:"",
        rightTextField:"",
        
        defaultData:null,
        
        //对象数组所在容器
        _objectList:null,
        //editable:true,
        getValue:function(){
            return this._objectList.getChildren().map(function(item){
                return item.getValue();
            });
        },
        setValue:function(value){
            this.set("value", value);
            // 销毁子元素
            this._objectList.destroyDescendants();    
            
            // 创建新的子元素
            if(value){
                value.forEach(lang.hitch(this, function(item){
                    var newItem = new ObjEditor({
                        fields:this.fields,
                        canEdit:this.canEdit,
                        labelField:this.labelField,
                        rightTextField:this.rightTextField,
                        clickable:this.clickable,
                        onFieldChanged:lang.hitch(this, function(widget, field, value){
                            this.fieldChange();
                        })
                    });
                    this._objectList.addChild(newItem);
                    newItem.setValue(item);
                }));
            }
            if(this._objectList.startEdit && this.canEdit){
                this._objectList.startEdit();
            }
        },
        onFieldChanged:function(widget,field,value){
        },
        setCanEdit:function(canEdit){
            this.canEdit = canEdit!==false&&canEdit!=="false";
			this._objectList.set("canDnd",this.canEdit);
			this._objectList.set("canDelete",this.canEdit);
			this._objectList.set("editable",this.canEdit);
			if(canEdit && !this._objectList.isEditing && this._objectList.startEdit){
                this._objectList.startEdit();
            }else if(!canEdit && this._objectList.isEditing && this._objectList.endEdit){
                this._objectList.endEdit();
            }
			var child = this._objectList.getChildren();
			for(var i=0;i<child.length;i++){
                //if(child[i]&&child[i].fields[0].&&child[i].fields[0].type){
                    //district
                //}else{
                    child[i].setCanEdit(canEdit);
                //}
                //domStyle.set(this.addItem.domNode,"display",this.canEdit?"":"none");
            }
            this.addBtn.innerHTML=this.canEdit ?("添加"+this.label||""):(this.label||"");
        },
        setCanAdd:function(canAdd){
            this.canAdd = canAdd!=="false"&&canAdd!==false;
            domStyle.set(this.addItem.domNode,"display",this.canAdd?"":"none");
        },
        fieldChange:function(){
            // 重新获取数据，触发onFieldCHanged
            this.set("value", this.getValue());
            this.onFieldChanged(this, this.field, this.getValue());
            if(this.canEdit){
                this._objectList.startEdit();
            }
        },
        buildRendering:function(){
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.canAdd = this.canAdd!==false&&this.canAdd!=="false";
            this.canDelete = this.canDelete!==false&&this.canDelete!=="false";
            this.canDnd = this.canDnd!==false&&this.canDnd!=="false";
            this.inherited(arguments);
            // 创建添加ListItem的节点并绑定事件
            this.addItem = new ListItem({
                style:"text-align:center;",name:"objsEditor"
            });
            
            this.addBtn = domConstruct.create("div", {
                innerHTML:this.canEdit?("添加"+this.label||""):(this.label||"")
            }, this.addItem.domNode, "first");
            // 避免滑动屏幕时触发ontouch事件 这里使用onclick事件，而不是用onTouch事件
            this.addBtn.addEventListener("click",lang.hitch(this,function(evt){
                if(!this.canEdit || !this.canAdd) return;
                var newItem = new ObjEditor({
                    fields:this.fields,
                    canEdit:true,
                    labelField:this.labelField,
                    rightTextField:this.rightTextField,
                    clickable:this.clickable,
                    onFieldChanged:lang.hitch(this, function(widget, field, value){
                        this.fieldChange();
                    })
                });
                this._objectList.addChild(newItem);
                if(this.defaultData){
                    newItem.setValue(lang.clone(this.defaultData));
                }
                newItem.onClick();    
            }));
            this.addChild(this.addItem);
            this.setCanAdd(this.canAdd);
            
            //添加数组列表
            this._objectList = new EdgeToEdgeList({
                editable:true,
                clickable:true
            });
            this.addChild(this._objectList);
            this.mixinOver();
        },
        mixinOver:function(){
            this.connect(this._objectList, "onClick", lang.hitch(this, function(evt){
                var item = registry.getEnclosingWidget(evt.target);
                if(item){
                    if(item.deleteIconNode&&item.deleteIconNode.contains(evt.target)){
                        return;
                    }else{
                        item.onClick(evt);
                    }
                }
            }));
            this.connect(this._objectList, "onDeleteItem", lang.hitch(this, function(item){
                item.destroy();
                this.fieldChange();
            }));
            this.connect(this._objectList, "onMoveItem", lang.hitch(this, function(evt){
                if(evt&&evt.rightIcon==="mblDomButtonArrow"){
                    return;
                }else{
                    this.fieldChange();    
                }
            }));
			this.connect(this._objectList.domNode, "onselectstart", event.stop);
        },
        postCreate: function(){
            this.inherited(arguments);
			if(this.syncWithViews){ // see also TabBar#postCreate
				var f = function(view, moveTo, dir, transition, context, method){
					var child = array.filter(this.getChildren(), function(w){
						return w.moveTo === "#" + view.id || w.moveTo === view.id; })[0];
					if(child){ child.set("selected", true); }
				};
				this.subscribe("/dojox/mobile/afterTransitionIn", f);
				this.subscribe("/dojox/mobile/startView", f);
			}
		}
    });
});