﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/ListItem",
    "cq/util/edit/optionsList"
],function(declare,lang,domStyle,ListItem,optionsList){
    //列表选项，呈现为一个ListItem，内容显示在右侧
    return declare("",[ListItem],{
        htmlTemp:'<li class="cq-form-checkbox cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/Options" data-dojo-props=\'label:"{label}",canEdit:"{canEdit}",field:"{field}",options:{j:options},selected:"{selected}"\'></li>',
        field:"",
        options:{},
        clickable:true,
        canEdit:true,
        selected:"",
        buildRendering:function(){
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
        },
        setCanEdit:function(canEdit){
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        getValue:function(){
            return this.get("value");
        },
        setValue:function(value){
            if(!this.canEdit){
                //this.rightIconNode.innerHTML="";
                domStyle.set(this.rightIconNode,"opacity",0);
            }
            this.set("value",value?value:(this.selected||""));
            this.set("rightText",this.options[value?value:this.selected]||"");            
        },
        onClick:function(viewNode){
            if(false===this.canEdit){
                return;
            }
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            optionsList.startEdit(this.getValue()||"",this.view||viewNode,this.options).then(lang.hitch(this,function(value){
                this.setValue(value);
                this.onFieldChanged(this,this.field,value);
            }));
        },
        onFieldChanged:function(widget,field,value){
            
        }
    });
});