﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/_base/array",
    "dojox/mobile/ListItem",
    "cq/util/edit/jsonRef"
],function(declare,lang,domStyle,array,ListItem,jsonRef){
    return declare("cq.app.widget.mobile.edit.Ref",[ListItem],{
        htmlTemp:'<li id="{id}" data-cq-field="{field}"  class="cq-field-input cq-form-ref" data-dojo-type="cq/app/widget/mobile/edit/Ref" data-dojo-props="field:\'{field}\',pageSize:\'{pageSize}\',label:\'{label}\',targetMethod:\'{targetMethod}\',searchAttr:\'{searchAttr}\',labelAttr:\'{labelAttr}\',dataProvider:\'{dataProvider}\',canEdit:{canEdit},multiselect:\'{multiselect}\'"></li>',
        field:"",
        // 查询属性名
        searchAttr:"",
        // 显示的属性名，属性名中间以逗号隔开
        labelAttr:"",
        dataProvider:"",
        targetMethod:"",
        pageSize:"5",
        start:"0",
        multiselect:"",
        canEdit:true,
        clickable:true,
        searchParams:{},
        
        buildRendering:function(){
            this.inherited(arguments);
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            //加载dataProvider,获取接口url
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider], lang.hitch(this, function(dataProvider){
                        // 当数据提供者加载完成之后，调用targetMethod方法，获取url
                        this.dataProvider = dataProvider;
                        this.searchParams={
                            target: this.dataProvider[this.targetMethod](),
                            searchField:this.searchAttr,
                            labelField:this.labelAttr,
                            multiselect:this.multiselect,
                            query:{
								isUse:true,
                            }
                        };
                        if(this.labelAttr.split(",").length>1){
                            this.labelFields = this.labelAttr.split(",");
                            this.searchParams.getDataLabel = lang.hitch(this,this.getDataLabel);
                        }
                    }));
                }
            }
        },
        setCanEdit:function(canEdit){
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        getDataLabel:function(data){
            return '<div style="min-width:160px;display:inline-block;">'+array.map(this.labelFields,function(field){
                return data[field]||"";
            }).join('</div><div style="min-width:160px;display:inline-block;">')+"</div>";
        },
        //获取数据
        getValue:function(){
            return this.get("value");
        },
        //设置ListItem的数据
        setValue:function(value){
            if(!this.canEdit){
                //this.rightIconNode.innerHTML="";
                domStyle.set(this.rightIconNode,"opacity",0);
            }
            this.set("value",value);
            this.set("rightText",value[this.labelFields?this.labelFields[0]:this.labelAttr]||"");
        },
        //onClick事件
        onClick:function(viewNode){
            if(false===this.canEdit){
                return;
            }
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            //调用jsonRef的方法，读取到数据之后，setValue，onFieldChanged
            jsonRef.startEdit(this.getValue()||"",this.view||viewNode,this.searchParams).then(lang.hitch(this,function(value){
                this.setValue(value);
                this.onFieldChanged(this, this.field,value);
            }));
        },
        onFieldChanged:function(widget,field,value){
            
        }
    });
    
});