define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dijit/registry",
    "dijit/_WidgetBase",
    "cq/app/widget/mobile/List",
    "cq/util/edit/dropdown",
    "cq/app/widget/_WidgetBase"
], function(declare, lang, domClass, domConstruct, registry, _WidgetBase, List, dropdown, _CQWidgetBase){
    return declare("", [_WidgetBase,_CQWidgetBase], {
        htmlTemp:"<div id='{id}' class='cq-area cq-form-tabBox cq-field-input' data-dojo-type='cq/app/widget/mobile/edit/TabBox' data-dojo-props='tabItems:{j:tabItems},field:\"{field}\"'></div>",
        baseClass:"cq-list-tabBox",
        tabItems:[],
        field:"",
        tabHash:{},
        buildRendering:function(){
            this.inherited(arguments);
            this.tabItems = this.tabItems.items;
            this.tabItems.forEach(lang.hitch(this, function(item, index){
                domConstruct.create("div", {
                    className:"cq-list-tabItem",
                    innerHTML:item.label
                }, this.domNode);
                this.tabHash[item.label].items = item.items;
            }));
            this.connect(this.domNode, "onclick", lang.hitch(this, function(evt){
                var target = evt.target;
                if(!this.tabHash[target.innerHTML]){
                    var params = {};
                    if(this.tabHash[target.innerHTML].items[0]._id){
                        params.items = this.tabHash[target.innerHTML].items;
                    }else{
                        params = this.tabHash[target.innerHTML].items;
                    }
                    this.tabHash[target.innerHTML].list = new List(params);
                    this.connect(this.tabHash[target.innerHTML].list, "onCqChanged", lang.hitch(this, function(widget, value){
                        this.onCqChanged(value);
                        dropdown.hide();
                    }));
                }
                if(domClass.contains(target, "selected")){
                    dropdown.hide();
                    domClass.remove(target, "selected");
                }else{
                    dropdown.showContent(this.tabHash[target.innerHTML].list.domNode, this.domNode);
                    domClass.add(target, "selected");
                }
            }));
        }
    });
});