﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/ListItem",
    "cq/ui/util/villageOverlay"
],function(declare,lang,domStyle,ListItem,villageOverlay){
    return declare("",[ListItem],{
        htmlTemp:'<li class="cq-form-district cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/Village" data-dojo-props=\'canEdit:"{canEdit}",enableAll:"{enableAll}",selectType:"{selectType}",field:"{field}",labelTitle:"{label}"\'></li>',
        field:"",
        labelTitle:"",
        clickable:true,
        enableAll:false,
        canEdit:true,
        //selectType: "1",
        
        buildRendering:function(){
            this.label = this.labelTitle;
            this.fields = this.field.split(",");
            this.canEdit = this.canEdit !==false && this.canEdit!=="false";
            this.inherited(arguments);
        },
        setCanEdit:function(canEdit){
            this.canEdit = canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        getValue:function(){
            return this.get("value");
        },
        setValue:function(value){
            if(!this.canEdit){
                //this.rightIconNode.innerHTML="";
                domStyle.set(this.rightIconNode,"opacity",0);
            }
            var county = value[0]&&value[0]._id||value[0]||"";
            var oldValue = this.getValue()||[];
            var oldCounty = oldValue[0]&&oldValue[0]._id||oldValue[0]||"";
            //乡镇为空
            if((!value[1])
            ||("object"===typeof(value[1])&&(!value[1]._id))
            //区县没变
            ||county&&oldCounty===county
            //区县和乡镇都是字符串
            ||"string"===typeof(value[0])&&"string"===typeof(value[1])
            //乡镇上级为区县
            ||value[1].upDistId===county
            ){
            }else{
                //修改value
                value = [value[0],null,null];
                if(4===this.fields.length){
                    value.push(this.getDistLabel(value));
                }
                //字段变了
                this.onFieldChanged(this,this.fields,value);
            }
            //设置内容
            this.set("value",value);
            //刷新显示
            this.set("rightText",this.fields.length===4?value&&value[3]||"":this.getDistLabel(value));    
        },
        getDistLabel:function(distArr){
            var label = "";
            for(var i=1;i<distArr.length;i++){
                label += distArr[i]&&distArr[i].distName||"";
            }
            return label||"";
        },
        onClick:function(){
            if(false===this.canEdit){
                return;
            }
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            var value = this.getValue();
            if(!(value[0]!=='')){
                alert("请选择区县");
                return;
            }
            villageOverlay.selectVillage({
                county : value && value[0],
                town : value&&value[1],
                village : value&&value[2]
            },false).then(lang.hitch(this,function(value){
                var distArr = value?[value.county,value.town,value.village]:[null,null,null];
                if(this.fields.length===4){
                    var oldValue = this.getValue()||[];
                    if(this.getDataKey(distArr[1])!==this.getDataKey(oldValue[1])||this.getDataKey(distArr[2])!==this.getDataKey(oldValue[2])){
                        distArr.push(this.getDistLabel(distArr));
                    }else{
                        distArr.push(oldValue[3]);
                    }
                }
                this.setValue(distArr);
                this.onFieldChanged(this,this.fields,distArr);
            }));
        },
        getDataKey:function(data){
            return "string"===typeof(data)?data:data&&data._id||data||"";
        },
        onFieldChanged:function(widget,field,value){
            
        }
    });
});