﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dijit/_Widget",
    "../../_WidgetBase",
    "cq/app/widget/mobile/List",
    "cq/util/edit/dropdown"
],function(declare, lang, domClass, _Widget, _CqWidgetBase, List, dropdown){
    var props = 'label:"{label}",dropdownInfo:{j:dropdownInfo}';
    return declare("",[_Widget, _CqWidgetBase],{
        htmlTemp:'<div id="{id}" class="menu-item cq-list-tabItem" data-dojo-type="cq/app/widget/mobile/menu/DropDownButton" data-dojo-props=\''+props+"'></div>",
        label:"",
        // dropdownInfo = {dataProvider:"",targetMethod:"",itemPropMethod:"",queryParamMethod:"",labelField:""} 或者 dropdownInfo = {items:[{_id:"",label:""},{_id:"",label:""},....]}
        dropdownInfo:null,
        
        buildRendering:function(){
            this.inherited(arguments);
            this.dropdownInfo.itemType = "IconLabel";
            this.dropdownInfo.workMode = "single";
            this.domNode.innerHTML = this.label;
            if(!this.list){
                this.list = new List(this.dropdownInfo);
                this.list.domNode.style.backgroundColor = "white";
            }
            if(this.dropdownInfo.dataProvider){
                this.list.refresh();
            }
            this.connect(this.list, "onCqChanged", lang.hitch(this, function(widget, value){
                this.onCqChanged(this, value);
                this.changeLabel(value);
                dropdown.hide();
                domClass.remove(this.domNode, "selected");
            }));
            this.connect(this.domNode, "onclick", this.onClick);
            this.connect(dropdown.domNode, "onclick", lang.hitch(this, function(){
                domClass.remove(this.domNode, "selected");
            }));
        },
        changeLabel:function(value){
            if(!this.dropdownInfo.dataProvider){
                this.currLabel = value?(value.label=="全部"?this.label:value.label):this.label;
            }else{
                this.currLabel = value&&value[this.dropdownInfo.labelField]||this.label;
            }
            this.domNode.innerHTML = this.currLabel;
        },
        onClick:function(){
            //点击展开
            if(domClass.contains(this.domNode, "selected")){
                dropdown.hide();
                domClass.remove(this.domNode, "selected");
            }else{
                dropdown.showContent(this.list.domNode, this.domNode||this.containerNode);
                domClass.add(this.domNode, "selected");
            }
        }
    });
});