﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/_Widget",
    "../../_WidgetBase",
    "cq/ui/util/districtOverlay"
],function(declare,lang,domConstruct,_Widget,_CqWidgetBase,districtOverlay){
    return declare("",[_Widget,_CqWidgetBase],{
        htmlTemp:'<div id="{id}" class="flex1 {className}" data-dojo-type="cq/app/widget/mobile/menu/FlexDistrictButton" data-dojo-props="label:\'{label}\'">{label}</div>',
        label:"",
        buildRendering:function(){
            this.inherited(arguments);
            this.connect(this.domNode,"onclick",this.onClick);
        },
        _clickTimer:null,
        onClick:function(){
            clearTimeout(this._clickTimer);
            this._clickTimer = setTimeout(lang.hitch(this,function(){
                districtOverlay.selectDistrict(this.getValue(),true).then(lang.hitch(this,function(data){
                    this.setValue(data);
                }));
            }),300);
        },
        getValue:function(){
            return this.value||{};
        },
        setValue:function(data){
            this.value = data||{};
            var label = "";
            if(this.value){
                if(this.value.province&&this.value.province.distName){
                    label += this.value.province.distName;
                }
                if(this.value.city&&this.value.city.distName){
                    label += this.value.city.distName;
                }
                if(this.value.county&&this.value.county.distName){
                    label += this.value.county.distName;
                }
            }
            this.domNode.innerHTML = label||this.label;
            this.onCqChanged(this,this.getValue());
        },
        cqRefresh:function(){
            this.setValue();
        }
    });
});