﻿define([
    "dojo/_base/lang",
    "cq/util/sys/date"
],function(lang,date){
    return {
        typeFormatters:{
            "options":function(v){
                return this.options[v]||"";
            },
            "date":function(v){
                return v?date.formatISODate(v):"";
            },
            "dateTime":function(v){
                return v?date.formatISODateMinutes(v):"";
            },
            "ref":function(v,data){
                return (v && v[this.labelFields])||"";
            },
            "checkbox":function(v,data){
                return v?"是":"否";
            },
            "multiFields":function(v,data){
                this.fields = this.fields||this.field.split(".");
                v = data;
                for(var i=0;i<this.fields.length;i++){
                    v = v&&v[this.fields[i]];
                }
                return v||0===v||false===v?v:"";
            },
            "image":function(v,data){
                return v?'<image class="'+(this.iconClass||"dgrid-icon")+'" src="'+v+'"/>':"";
            },
            "none":function(v){
                return v||0===v||false===v?v:"";
            }
        },
        initLayoutFormatter:function(layout){
            var cols = lang.clone(layout);
			for(var i=0;i<cols.length;i++){
                if(!cols[i].formatter){
                    if(this.typeFormatters[cols[i].type]){
                        cols[i].formatter = this.typeFormatters[cols[i].type];
                    }else if(-1<cols[i].field.indexOf(".")){
                        cols[i].formatter = this.typeFormatters.multiFields;
                    }else{
                        cols[i].formatter = this.typeFormatters.none;
                    }
                }
			}
            return cols;
        }
    };
});