//购物车对象
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/dom-attr",
	'dojo/dom-construct',
    "dojo/Deferred",
    "dojo/store/JsonRest",
    "dijit/_WidgetBase",
	'dstore/Memory',
	'dstore/Trackable',
	"dstore/Rest",
	"dstore/Cache",
	'dgrid/OnDemandGrid',
	'dgrid/Selector',
	'dgrid/extensions/DijitRegistry',
	'dgrid/extensions/Pagination',
	'dgrid/extensions/ColumnResizer',
    "cq/app/widget/_WidgetBase",
    "cq/util/sys/xlsx",
    "cq/util/sys/date",
    "../utils/listLayout"
], function (declare, lang, on,domAttr,domConstruct, Deferred,JsonRest, _WidgetBase, Memory, Trackable,Rest,Cache, OnDemandGrid,Selector,DijitRegistry,Pagination,ColumnResizer, cqWidgetBase,xlsx,date,listLayout) {

    var props = "label:'{label}',dataProvider:'{dataProvider}',targetMethod:'{targetMethod}',clickMethod:'{clickMethod}',gridLayoutMethod:'{gridLayoutMethod}',queryParamMethod:'{queryParamMethod}'";
    return declare("",[_WidgetBase, cqWidgetBase], {
        //由第三方提供数据
        dataProvider:"",
        //数据提供者提供加载数据的方法
        targetMethod:"",
        //获取listItem属性的方法
        gridLayoutMethod:"",
        queryParamMethod:"",
		clickMethod:"",
        htmlTemp: '<div id="{id}"  data-dojo-type="cq/app/widget/web/DGrid" data-dojo-props="'+props+'"><div></div></div>',
        //当监听到其他对象变化时，刷新本对象
        cqRefresh:function(){
			//if(this.lastRefresh && Date.now()-this.lastRefresh<1000) return;
			//this.lastRefresh = Date.now();
            this.refresh();
        },
		refresh:function(){
            var query = {};
            if(this.dataProvider[this.queryParamMethod]){
                query = this.dataProvider[this.queryParamMethod](this.cqRefInfo);
            }
            this.queryParam = query;
            var url = this.dataProvider[this.targetMethod]();
            if(url.indexOf("?")<=0) url+="?__xx=xx";
            for(var p in query){
                if(query[p]!=undefined) url += "&"+p+"="+encodeURIComponent(query[p]);
            }
            this.store.target = url;
            this.grid.set("collection",this.store);
            this.grid.resize();
		},
        _onDataProviderReady:function(dataProvider){
            this.dataProvider = dataProvider;
			var url = this.dataProvider[this.targetMethod]();
			if(url.indexOf("?")<=0) url+="?__xx=xx";
			this.store = new declare([ Rest, Trackable, Cache ])({idProperty:"_id",target:url,useRangeHeaders: true,sortParam:"orderBy"});
			// Instantiate grid
			var cols = listLayout.initLayoutFormatter(this.dataProvider[this.gridLayoutMethod]());
			this.grid = new (declare([OnDemandGrid,ColumnResizer,Selector]))({
				//collection: store,
				rowsPerPage:30,
				keepScrollPosition:true,
				//allowSelectAll: true,
				columns: cols
			}, this.domNode.firstChild);
			this.grid.on('.dgrid-cell:click', lang.hitch(this,function (event) {
				if(event&&event.target && this.clickMethod){
					var row = this.grid.row(event.target);
					if(!row) return;
					this.dataProvider[this.clickMethod](row.data,this.getActionByNode(row.element,event.target),this);
				}
			}));
			this.grid.startup();
			domConstruct.create("div",{className:"button",innerHTML:"导出EXCEL",onclick:lang.hitch(this,function(){
				xlsx.exportData(this.grid.collection.target,{
				},cols,Date.now().toString());
			})},this.domNode,"first");
        },
        removeItemByData:function(data){
            if(data){
				var row = this.grid.row(data._id);
				if(!row) return;
				this.grid.removeRow(row);
            }
        },
        refreshItemByData:function(data){
            if(data){
				var row = this.grid.row(data._id);
				if(!row) return;
                lang.mixin(row.data,data);
				this.grid.insertRow(row.data,this.grid.contentNode,row.element,row.rowIndex);
            }
        },
        getActionByNode:function(range,node){
            var action = "";
            while(node&&node.parentNode&&node!==range){
                action = domAttr.get(node,"cq-action");
                if(action){
                    break;
                }
                node = node.parentNode;
            }
			return action;
        },
        postCreate : function () {
			this.inherited(arguments);
			
            if(this.dataProvider){
                //有数据提供者，初始化数据提供者
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,this._onDataProviderReady));
                }else{
                    this._onDataProviderReady(this.dataProvider);
                }
            }
			else
				this._onDataProviderReady();


        }
    });
});
