﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "../_WidgetBase",
    "../_LayoutMixin"
],function(declare,lang,domAttr,domStyle,domClass,Deferred,_WidgetBase,_CqWidgetBase,_LayoutMixin){
    var propStr = 'editorEnterMethod:"{editorEnterMethod}",fieldChangeMethod:"{fieldChangeMethod}",reloadMethod:"{reloadMethod}",idInfoMap:{j:idMap},actionStateMethod:"{actionStateMethod}",initMethod:"{initMethod}",dataProvider:"{dataProvider}",layoutMethod:"{layoutMethod}",layoutType:"{layoutType}"';
    return declare("",[_WidgetBase,_CqWidgetBase,_LayoutMixin],{
        htmlTemp:"<div id='{id}' class='cq-area {className}' data-dojo-type='cq/app/widget/web/DataLayout' data-dojo-props='"+propStr+"'></div>",
        dataProvider:"",
        layoutMethod:"",
        reloadMethod:"",
        fieldChangeMethod:"",
        editorEnterMethod:"",
        // 张松       布局方式，如表格布局      2016/11/8
        layoutType:"",
        
        preventScroll:true,
        buildRendering:function(){
            this.inherited(arguments);
        },
        loadLayout:function(){
            this.actionsHash = {};
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    var def = new Deferred();
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        var data = this.dataProvider[this.layoutMethod]();
                        if(data&&data.then){
                            data.then(function(result){
                                def.resolve(result);
                            });
                        }else{
                            def.resolve(data);
                        }
                    }));
                    return def;
                }else{
                    return this.dataProvider[this.layoutMethod]();
                }
            }else{
                console.error("no data provider");
                console.error(this);
                return this.inherited(arguments);
            }
        },
        bindActionElementEvent:function(node){
            var action = domAttr.get(node,"cq-action");
            if(action){
                this.actionsHash[action] = {};
                this.fieldHandlers.push(this.connect(node,"onclick",function(){
                    if(!domClass.contains(node,"disabled")) this.dataProvider[action](this.getData(),this);
                }));
                this.inherited(arguments);
            }
        },
        layoutLoaded:false,
        onLayoutReady:function(){
            this.layoutLoaded = true;
            this.inherited(arguments);
            if(this.autoRefresh){
                this.cqRefresh();
            }
        },
        cqRefresh:function(){
            this.autoRefresh = false;
            if(!this.layoutLoaded){
                this.autoRefresh = true;
                return;
            }
            if(this.initMethod&&this.dataProvider){
                if(this.dataProvider[this.initMethod]){
                    var data = this.dataProvider[this.initMethod](this.cqRefInfo);
                    if(data&&data.then){
                        data.then(lang.hitch(this,function(initData){
                            this.setData(initData);
                        }));
                    }else{
                        this.setData(data);
                    }
                }else{
                    this.autoRefresh = true;
                }
            }else{
                this.inherited(arguments);
            }
        },
        setData:function(data){
            this.inherited(arguments);
            if(this.dataProvider&&this.dataProvider[this.reloadMethod]){
                this.dataProvider[this.reloadMethod](this);
            }
        },
        onWidgetFieldChanged:function(widget,field,value){
            this.inherited(arguments);
            if(this.dataProvider&&this.dataProvider[this.fieldChangeMethod]){
                this.dataProvider[this.fieldChangeMethod](this,field&&field.join?field.join(","):field,value);
            }
        },
		//添加回车登陆
        onTextEditorEnter:function(widget,field,value){
            if(this.dataProvider&&this.dataProvider[this.editorEnterMethod]){
                this.dataProvider[this.editorEnterMethod](this,field,value);
            }
        }
    });
});