﻿//浏览数据区域
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojox/mobile/Pane",
    "cq/util/sys/date",
    "../_WidgetBase"
],function(declare,lang,array,domConstruct,Deferred,Pane,date,_WidgetBase){
    return declare("",[Pane,_WidgetBase],{
        //数据提供者，可以是对象id，也可以是对象本身
        dataProvider:"",
        //加载数据等方法再数据提供者的那个属性中
        dataAction:"",
        //数据提供者中哪个属性是当前浏览的字段列表
        dataField:"",
		//数据提供者中哪个方法是加载HTML模板
		dataTemplate:"",
        //点击之后跳转到哪个view
        editView:"",
        //是否允许编辑
        editable:true,
        
        //加载当前对象的数据提供者的异步对象
        _cqReqDef:null,
        //依据要浏览的字段的定义生成的html片段，这个方式待讨论
        _detailHtml:"",
        buildRendering:function(){
            this.inherited(arguments);
            //内容区域
            this.detailNode = domConstruct.create("div",{
                "class":"cq-detail-content"
            },this.containerNode||this.domNode);
            //编辑按钮
            if(this.editView){
                domConstruct.create("div",{
                    "class":"cq-detail-edit-btn",
                    "innerHTML":"修改",
                    onclick:lang.hitch(this,this.onEdit)
                },this.containerNode||this.domNode);
            }
            
            this._detailFields = {};
            this.detailData = {};
            //加载数据提供者，加载完成之后初始化界面
            var def = new Deferred();
            this._cqReqDef = def.then(lang.hitch(this,this.initTemp));
            //执行加载数据提供者操作
            if(this.dataProvider&&lang.isString(this.dataProvider)){
                require([this.dataProvider],lang.hitch(this,function(dataProvider){
                    this.dataProvider = dataProvider;
                    def.resolve();
                }));
            }else{
                def.resolve();
            }
            
            //几个经常在异步操作中使用的方法，直接绑定上下文，调用时就不用管执行的上下文了
            this._refreshCqDetail = lang.hitch(this,this._refreshCqDetail);
            this.onDetailDataLoaded = lang.hitch(this,this.onDetailDataLoaded);
            this.getFieldLabel = lang.hitch(this,this.getFieldLabel);
        },
        //外部事件导致刷新的方法，要等待加载数据提供者完成之后才能响应
        cqRefresh:function(){
            this._cqReqDef.then(this._refreshCqDetail);
        },
        //真正执行刷新的操作，加载数据，然后刷新界面显示
        _refreshCqDetail:function(){
			if(this.dataProvider[this.dataAction].load)
            this.dataProvider[this.dataAction].load(this.cqRefInfo).then(this.onDetailDataLoaded);
			else
            this.dataProvider[this.dataAction](this.cqRefInfo).then(this.onDetailDataLoaded);
        },
        //将将在到的数据设置为当前数据，刷新详情区域内容
        onDetailDataLoaded:function(data){
            this.detailData = data;
            this.detailNode.innerHTML = this._detailHtml.replace(/\{[_a-z0-9A-Z.]+\}/g,this.getFieldLabel);
        },
        //
        onEdit:function(){
            if(this.editView&&this.editable){
                topic.publish("/cq/app/show",this.editView,this.detailData&&this.detailData._id||"");
            }
        },
        getFieldLabel:function(str){
            var str = str.substr(1);
            str = str.substr(0,str.length-1);
            field = str.split(".");
            var item = this.detailData;
            while(item&&field.length){
                item = item[field.shift()];
            }
            if(item){
                switch(this._detailFields[str]&&this._detailFields[str].type){
                    case "date":
                        item = date.formatISODate(item);
                        break;
                    case "dateTime":
                        item = date.formatISODateMinutes(item);
                        break;
                    case "select":
                        item = this._detailFields[str].options[item];
                        break;
                    case "ref":
                        item = item&&item[this._detailFields[str].labelField];
                    default:break;
                }
            }
            return item||0===item||false===item?item:"";
        },
        initTemp:function(){
			if(this.dataTemplate){
				this._detailHtml = this.dataProvider[this.dataTemplate]();
			}
			else
				this._detailHtml = array.map(this.dataProvider[this.dataField],this.getFieldTemp,this).join("");
            this.onDetailDataLoaded(this.detailData);
        },
        getFieldTemp:function(field){
            this._detailFields[field.field] = field;
            var temp = "";
            if(field.type==="image"){
                return '<img src="{'+field.field+'}" class="cq-detail-icon"/>';
            }else{
                return '<span class="cq-detail-content">{'+field.field+"}</span>";
            }
        }
    });
});