﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/query",
    "dijit/_WidgetBase",
    "dijit/_Container",
    "../_ListMixin"
],function(declare,lang,domAttr,domClass,domConstruct,query,_WidgetBase,_Container,_ListMixin){
    return declare("",[_WidgetBase,_Container,_ListMixin],{
        getItemTypeId:function(itemType){
            return "cq/app/widget/web/item/"+itemType;
        },
        //初始化分页区域节点
        initPageNode:function(){
            this.pagerNode = domConstruct.create("div",{
            },this.containerNode,"after");
			if(!this.showPager) domClass.add(this.pagerNode,'none');
            //分页区域点击之后的响应函数
            this.connect(this.pagerNode,"onclick",function(e){
                var node = e.target;
                while(node!==this.pagerNode&&node.parentNode!=this.pagerNode){
                    node = node.parentNode;
                }
                if(node!=this.pagerNode){
                    var pageIndex = domAttr.get(node,"name")-0;
                    this.loadMore(pageIndex||0);
                }
            });
        },
        loadMore:function(index){
            this.currentPage = index||0;
            var result = this.inherited(arguments);
            if(result){
                this.clearList();
            }
        },
        //总页数返回之后，刷新分页区域的显示
        onTotalReady:function(totalCount){
            var html = "",currentPage = this.start/this.pageSize;
            //当前页和之前的页面链接
            if (0 === currentPage) {
                html += "";
            } else if (1 === currentPage) {
                html += "<span class='pager_item' name='0'>1</span>";
            } else {
                if (2 < currentPage) {
                    html += "<span class='pager_item' name='0'>首页</span>";
                    if (3 < currentPage) {
                        html += "<span class='pager_more'>...</span>";
                    }
                }
                html += "<span class='pager_item' name='" + (currentPage - 2);
                html += "'>" + (currentPage - 1) + "</span>";
                html += "<span class='pager_item' name='" + (currentPage - 1);
                html += "'>" + currentPage + "</span>";
            }
            
            //当前页之后的页面链接
            html += "<span class='pager_item selected'>";
            html += (currentPage + 1) + "</span>";
            var total = parseInt(totalCount / this.pageSize);
            total += (totalCount % this.pageSize ? 1 : 0) - 1;
            if (0 < total - currentPage) {
                html += "<span class='pager_item' name='" + (currentPage + 1);
                html += "'>" + (currentPage + 2) + "</span>";
            }
            if (1 < total - currentPage) {
                html += "<span class='pager_item' name='" + (currentPage + 2);
                html += "'>" + (currentPage + 3) + "</span>";
                if (2 < total - currentPage) {
                    if (3 < total - currentPage) {
                        html += "<span class='pager_more'>...</span>";
                    }
                    html += "<span class='pager_item' name='" + total + "'>尾页</span>";
                }
            }
            this.pagerNode.innerHTML = html;
        }
    });
});