//购物车对象
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/on",
    "dojo/Deferred",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dijit/_Container",
    "cq/biz/ts/cart",
    "cq/biz/user/user",
    "cq/biz/mat/mat",
    "cq/biz/shop/shop",
    "cq/util/config/config",
    "cq/app/widget/_WidgetBase"
], function (declare, lang, array, domAttr, domClass, domConstruct, query, on, Deferred, xhr, json, registry, _WidgetBase, _Container, cart, user, mat, shop, config, cqWidgetBase) {
    var fixedTo = function(value, cm) {
        // 有值才处理小数
        if (value || 0 === value) {
            cm = parseInt(cm, 10);
            if (cm && cm < 8) {
                //有效数字为 0 到 6 位时
                value = parseFloat(value, 10).toFixed(cm - 1);
            } else {
                //不控制时，解析为正常的小数
                value = parseFloat(value, 10);
            }
        } else {
            value = "";
        }
        return value;
    };
    var MatItem = declare("", [_WidgetBase], {
        matInfo : null,
        qty : null,
        'class' : "clear",
        postCreate : function () {
            this.createNode();
            this.indexElement();
            this.initEvent();
        },
        //创建dom节点
        createNode : function () {
            var matInfo = this.matInfo;
            if (matInfo.carQty > matInfo.qty) {
                //库存不足
                matInfo.carQty = matInfo.qty;
                var carts = cart.get();
                carts[matInfo._id] = matInfo.qty;
                cart.set(carts);
                matInfo.amnt = matInfo.carQty * matInfo.retailPrice;
            }
            // if (matInfo.minQty && matInfo.minQty > matInfo.carQty) {
            //     alert(matInfo.mName + matInfo.minQty + matInfo.sizeType + "件起售，请添加数量!");
            // }
            var htmlStr = ''
            + '<ul class="ordercarTr" style="text-align:center;">'
            +    '<li class="ordercarTd" style="width:444px;padding:5px;">'
            +            '<img src="'+(matInfo.logo?matInfo.logo:'images/nomat.png')+'" alt="'+matInfo.mName+'" style="float:left;width: 80px;height: 80px;">'
             +            '<h4 style="margin:15px;margin-left:85px;">'+matInfo.mName + (matInfo.minQty ?"(" + matInfo.minQty +  "件起售)" : "")+'</h4>'
            +    '</li>'
            +    '<li class="ordercarTd" style="width:80px; color: #FA5E19;">￥'
            +       fixedTo(matInfo.retailPrice,3) + '/' + matInfo.sizeType
            +       (matInfo.marketPrice?'<del style="display:block;font-size:12px;">￥'+ fixedTo(matInfo.marketPrice,3) + '/' + matInfo.sizeType +'</del>':'')
            +    '</li>'
            +    '<li class="ordercarTd mnumer" style="width:80px;line-height: 60px;">'
            +        '<a class="des" href="javascript:void(0);">-</a>'
            +        '<input type="tel" style="width:51px; text-align: center;" class="QTY" value="'+matInfo.carQty+'"/>'
            +        '<a class="add" href="javascript:void(0);">+</a>'
            +    '</li>'
            +    '<li class="ordercarTd AMNT" style="width:180px;color:#FA5E19;line-height: 60px;">￥'
                    + fixedTo(matInfo.amnt,3)
            +    '</li>'
            +    '<li class="ordercarTd clickable" style="width:79px;float:left;color:#2374C5;line-height: 60px;">'
            +        '<a class="del">删除</a>'
            +    '</li>'
            +'</ul>';
            this.domNode.appendChild(domConstruct.toDom(htmlStr));
        },
        //获取dom元素
        indexElement : function () {
            this.input = query("input", this.domNode)[0];
            this.amnt = query(".AMNT", this.domNode)[0];
        },
        //绑定事件
        initEvent : function () {
            this.connect(this.domNode, "onclick", this.domNodeClick);
            this.connect(this.input, "onchange", this.qtyChange);
            //购物车中的数量
            this.carQty = this.matInfo.carQty;
            //库存
            this.qty = this.matInfo.qty;
            //最小起订量
            this.minQty = this.matInfo.minQty || 1;
            //商品id
            this.mid = this.matInfo._id;
        },
        //对象点击事件
        domNodeClick : function (e) {
            var dom = e.target;
            if (dom && dom.tagName === "A") {
                if (domClass.contains(dom, "add")) {
                    //增加
                    if (this.carQty+1>this.qty) {
                        alert("库存不足!");
                        this.cartChange("set", this.qty);
                    } else {
                        this.cartChange("add", 1);
                    }
                } else if (domClass.contains(dom, "des")) {
                    //减少
                    if (this.carQty-this.minQty < 1) {
                        alert("不能减少了!")
                    } else {
                        this.cartChange("add", -1);
                    }
                } else if (domClass.contains(dom, "del")) {
                    //删除
                    this.cartChange("del");
                }
            }
        },
        //数量变更
        qtyChange : function () {
            var qty = Number(this.input.value) || 0;
            var sizeType = this.matInfo.sizeType;
            if(qty > 0){
                if (qty > this.qty) {
                    alert("库存不足" + qty + "/" + sizeType + "，最多购买" + this.qty + "/" + sizeType );
                    this.cartChange("set", this.qty);
                } else {
                    if (qty < this.minQty) {
                        alert("数量不能少于起订量" + this.minQty + "件！");
                        qty = this.minQty;
                    }
                    this.cartChange("set", qty);
                }
            } else {
                this.input.value = this.carQty;
            }
        },
        //数量变更
        cartChange : function (action, qty) {
            if (action === "add") {
                //加||减
                this.carQty += qty;
            } else if (action === "set") {
                //重设数量
                this.carQty = qty;
            } else {
                //删除
                this.carQty = 0;
                this.destroyRecursive();
            }
            this.input.value = this.carQty;
            this.amnt.innerHTML = "￥" + fixedTo(this.carQty * this.matInfo.retailPrice, 3);
            this.onCartChange(action, qty, this.mid);
        },
        //数量变更事件
        onCartChange : function (action, qty, mid) {
        }
    });
    var ShopItem = declare("", [_WidgetBase, _Container], {
        shopInfo : null,
        "class" : "shopItem",
        postCreate : function () {
            var shopInfo = this.shopInfo;
            var htmlStr = ''
            +'<div class="shoptitle"><a href="#appDetail-' + shopInfo._id + '">' + shopInfo.shopName + '</a></div>'
            +'<div class="topTitle">'
            +   '<div class="orderCarHead">'
            +       '<ul class="ordercarTr" style="padding:0;margin:0;background-color:rgb(242, 242, 242);line-height: 40px;"><li class="ordercarTh" style="width:424px;">商品</li><li class="ordercarTh" style="width:80px;">价格(元)</li><li class="ordercarTh" style="width:80px;">数量</li><li class="ordercarTh" style="width:180px;">小计(元)</li><li class="ordercarTh" style="width:79px;">操作</li></ul>'
            +   '</div>'
            +'</div>'
            +'</div>';
            this.domNode.appendChild(domConstruct.toDom(htmlStr));
            var ordercarBody = query(".ordercarBody", this.domNode)[0];
            array.forEach(shopInfo.mats, function (matInfo) {
                if (matInfo.qty > 0 && matInfo.isUse) {
                    var matItem = new MatItem({
                        matInfo : matInfo,
                        onCartChange : lang.hitch(this, this.cartChange)
                    });
                    this.addChild(matItem);
                } else {
                    cart.clear([matInfo._id]);
                }
            }, this);
        },
        cartChange : function (action, qty, mid) {
            //判断本对象的孩子对象数量,如果为0,则本对象也需要自毁
            if (!this.getChildren().length) {
                this.destroyRecursive();
            }
            this.onCartChange(action, qty, mid);
        },
        onCartChange : function (action, qty, mid) {

        }
    });
    return declare("",[_WidgetBase, _Container, cqWidgetBase], {
        htmlTemp: '<div id="{id}" class="orderCarmatList" data-dojo-type="cq/app/widget/web/OrderCar"></div>',
        orderInfo : null,
        "class" : "orderCarmatList",
        cqRefresh: function () {
            this.loadCartData();
        },
        postCreate : function () {
            this.domNode.innerHTML += '<h2 class="orderCarTitle" style="margin-top:20px;">我的购物车</h2><div class="shopItemList"></div>';
            this.domNode.innerHTML += '<div class="ordercarFoot clear"><div class="ordercarTd" style="width: 968px;;height:30px;"><a class="cleanOrderCarBtn  clickable">清空购物车</a><span style="float:right;">购物金额总计<strong class="ttlPrice">￥0.00</strong></span></div><a class="button" href="#matList">继续购物</a><a class="button" href="#orderInfo">确认结算</a></div>';
            this.orderShopItem = query('.shopItemList', this.domNode)[0];
            this.ttlPrice = query(".ttlPrice", this.domNode)[0];
            this.cleanOrderCarBtn = query(".cleanOrderCarBtn",this.domNode)[0];
            this.own(on(this.cleanOrderCarBtn, "click", lang.hitch(this, this.cleraOrderCar)));
            //this.loadCartData();
        },
        cleraOrderCar: function () {
            cart.clear();
            this.cqRefresh();
        },
        loadCartData: function () {
            this.destroyDescendants();
            mat.loadByIds(cart.getIds(),config.getPlatformShopId()).then(lang.hitch(this, function (data) {
                this.orderCarMats = {};//{mid:mat}
                var items = (data && data.data && data.data.items) || [],
                orderCar = cart.get();
                if (items.length > 0) {
                    var orderCarShops = {},//{shopId:[mat1,mat2,...]}
                    shopIds = [];//[shopId1,shopId2,...]
                    var unUseMats = [];
                    //初始化购物车数量及合计,并统计商家id
                    array.forEach(items, function (item) {
                        if (item.qty == 0 || !item.isUse ) {
                            unUseMats.push(item._id);
                        } else {
                            item.carQty = orderCar[item._id];
                            item.amnt = item.carQty * item.retailPrice;
                            if (!orderCarShops[item.fromShopId]){
                                orderCarShops[item.fromShopId] = [];
                            }
                            orderCarShops[item.fromShopId].push(item);
                            this.orderCarMats[item._id] = item;
                        }
                    }, this);
                    if (unUseMats.length) {
                        cart.clear(unUseMats);
                    }
                    //获取商家id数组
                    for (var shopid in orderCarShops) {
                        if (orderCarShops.hasOwnProperty(shopid)) {
                            shopIds.push(shopid);
                        }
                    }
                    shop.loadByIds(shopIds).then(lang.hitch(this, function (shopInfo) {
                        var shops = shopInfo && shopInfo.data || [];
                        array.forEach(shops, function (s) {
                            s.mats = orderCarShops[s._id];
                        });
                        this.createShopItem(shopInfo.data);
                    }));
                } else {
                    this.createShopItem([]);
                }
            }));
        },
        createShopItem: function (orderInfo) {
            this.onCartChange();
            if (orderInfo.length) {
                array.forEach(orderInfo, function (shopInfo) {
                    var shopItem = new ShopItem({
                        shopInfo : shopInfo,
                        onCartChange : lang.hitch(this, this.cartChange)
                    });
                    domConstruct.place(shopItem.domNode,this.orderShopItem);
                }, this);
            }
        },
        //修改cart,统一管理
        cartChange : function (action, qty, mid) {
            if (action == "add") {
                cart.add(mid, qty);
            } else if (action == "set") {
                var carts = cart.get();
                carts[mid] = qty;
                cart.set(carts);
            } else if (action == "del") {
                cart.clear([mid]);
            }
            this.onCartChange();
        },
        //购物车变更事件
        onCartChange : function () {
            var car = cart.get(),
            price = 0;
            for(var mid in car){
                if(this.orderCarMats[mid]){
                    price += this.orderCarMats[mid].retailPrice * car[mid];
                }
            }
            this.ttlPrice.innerHTML = "￥" + price.toFixed(2);
        }
    });
});
