﻿// 变更人员：母浚驰
// 变更时间：2016/9/19
// 变更内容：调整代码结构
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dijit/registry",
    "../_ViewBase",
    "dijit/_WidgetBase",
    "cq/biz/ts/order",
    "cq/biz/shop/shop",
    "cq/biz/ts/cart",
    "cq/biz/user/user",
    "cq/biz/user/userAddress",
    "cq/biz/mat/mat",
    "cq/util/sys/date",
    "cq/util/config/config",
    "cq/biz/mk/discount",
    "cq/biz/shop/bs/district"
], function(declare, lang, array, query, domClass, domStyle, domAttr, registry, Base, _WidgetBase, order, shopParam, cart, user, userAddress, mat, date, config, disCount, district) {
    //地址信息
    var UserAddr = declare("", _WidgetBase, {
        addrInfos : null,
        checkedAddress : "",
        postCreate : function () {
            this.createNode();
            this.indexElement();
            this.initEvent();
        },
        createNode : function(){
            var addrHtml = '<h1 class="orderInfoh1"><span>收货信息</span></h1>';
            addrHtml += '<ul class="orderinfo-address-list">';
            if(this.addrInfos){
                array.forEach(addrInfos,function(addrInfo){
                    addrHtml += '<li class = "orderInfo-address-list-li"><div class = "checked-div">   <div class = "address-checkbox" value = "'+addrInfo._id+'"></div></div><div class="address-info"><span>收货人：<em name = "contactName">'+addrInfo.contactName+'</em></span><span>电话：<em name= "tel">'+addrInfo.tel+'</em></span><span>区划：<em>'+addrInfo.addressName+'</em></span>  <span>详细地址：<em name = "detailAddress">'+addrInfo.detailAddress+'</em></span></div><div class="clear"></div></li>';
                },this);
            }else{
                addrHtml += '<li>没有收货地址信息</li>';
            }
            addrHtml += '</ul>';
            addrHtml += '<div class="address-list-div"><a class="address-button add-Addr">新增地址</a><a class="address-button edit-Addr">编辑地址</a></div><form class="add-address-form"><table><tbody><tr><td class = "td-left">收货人：</td><td><input class = "address-contactName" type = "text"></td></tr><tr><td class = "td-left">电话：</td><td><input class = "address-tel" type = "text"></td></tr><tr><td class = "td-left">区划：</td><td><select class="province-select"><option value="" class = "provinced-option">请选择省</option></select><select class="city-select"><option value="-1" class = "city-option">请选择市</option></select><select class="county-select"><option value="-1" class = "county-option">请选择县</option></select></td></tr><tr><td class = "td-left">详细地址：</td><td><input class = "address-detailAddress" type = "text"></td></tr><tr><td class = "td-left">设为默认地址：</td><td><input type="radio" name="isDefault" value="ture" style = "width: 20px;height: 15px;"/> 是<input type="radio" name="isDefault" value="false" style = "width: 20px;height: 15px;margin-left: 20px;"/> 否 </td></tr><tr><td></td><td><div><a class = "address-button make-Addr">确认</a><a class = "address-button cancel-Addr">取消</a></div></td></tr></tbody></table></form>'
        },
        indexElement : function(){
            // 用户地址列表
            this.addressList = query(".orderinfo-address-list", this.domNode)[0];
            // 获取地址编辑界面的节点
            this.editAddressNode = query(".add-address-form", this.domNode)[0];
            // 获取地址编辑的按钮Div
            this.addAddressDiv = query(".address-list-div", this.domNode)[0];
            // 获取省下拉节点
            this.provincedNode = query(".province-select", this.editAddressNode)[0];
            // 获取市
            this.cityNode = query(".city-select", this.editAddressNode)[0];
            this.countyNode = query(".county-select", this.editAddressNode)[0];
        },
        initEvent : function(){
            this.connect(this.addressList,"onclick",this.onAddressList);
            this.connect(this.addAddressDiv, "onclick", lang.hitch(this, this.onAddressDiv));
            this.connect(this.editAddressNode, "onclick", lang.hitch(this,this.onEditAddress));
            this.connect(this.provincedNode, "onchange", this.changeProvinced);
            this.connect(this.cityNode, "onchange", this.changeCity);
        },
        // 省选择框值改变
        changeProvinced : function (evt) {
            var upDistId = query("option", this.provincedNode)[evt.target.selectedIndex].value;
            // 刷新市中的数据
            this.refreshCity({upDistId : upDistId});
            // 清空县
            this.refreshCounty({});
        },
        // 市选择框值改变
        changeCity : function(evt) {
            var upDistId = query("option", this.cityNode)[evt.target.selectedIndex].value;
            // 刷新县中的数据
            this.refreshCounty({upDistId : upDistId});  
        },
        // 地址编辑表单的点击事件
        onEditAddress : function (evt) {
            var dom = evt.target;
            if (dom && domClass.contains(dom, "make-Addr")) {
                // 保存数据
                this.onSaveAddress();
            }
            if (dom && domClass.contains(dom, "cancel-Addr")) {
                domClass.add(this.editAddressNode,"hide");
            }    
        },
        // 保存新增的数据
        onSaveAddress : function () {
            var saveData = this.getEditListData();
            var msg = this.isMseege(saveData);
            if (msg) {
                alert(msg);
                return;
            }
            userAddress.save(saveData).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    alert("保存成功");
                    // 隐藏地址编辑的表单;
                    domClass.add(this.editAddressNode,"hide");
                    // 设置当前选中的默认地址
                    //this.checkedAddress = data.data.item._id;
                    // 刷新地址列表的显示
                    this.onRefreshAddressList();
                } else {
                    alert("保存失败");
                }
            }));
        },
        
        // 保存时验证必填字段是否填写
        isMseege : function (saveData) {
            if (!saveData.contactName) {
                return "请输入收货人姓名";
            }
            if (!saveData.tel) {
                return "请输入电话";
            }
            if (!saveData.provinceId || saveData.provinceId === "-1") {
                return "请选择省";
            }
            if (!saveData.cityId || saveData.cityId === "-1") {
                return "请选择市";
            }
            if (!saveData.countyId || saveData.countyId === "-1") {
                return "请选择县";
            }
            if (!saveData.detailAddress) {
                return "请详细地址";
            }
            return "";
        },
        // 新增或编辑的响应事件
        onAddressDiv : function (evt) {
            var dom = evt.target;
            if (dom && domClass.contains(dom, "add-Addr")) {
                domClass.remove(this.editAddressNode,"hide");
                this.refreshEditList();
            }
            if (dom && domClass.contains(dom, "edit-Addr")) {
                var checkedNodes = query(".address-checkbox[checked='checked']", this.addressList)
                if (checkedNodes.length === 1) {
                    // 修改当前选中的地址的值
                    this.checkedAddress = domAttr.get(checkedNodes[0], "value");
                    userAddress.loadById(domAttr.get(checkedNodes[0], "value")).then(lang.hitch(this, function (data) {
                        if (data && data.data && data.data.ok === 1) {
                            domClass.remove(this.editAddressNode,"hide");
                            var editData = data.data.item;
                            editData.provinceId = editData.provinceId._id || editData.provinceId;
                            editData.cityId = editData.cityId._id || editData.cityId;
                            editData.countyId = editData.countyId._id || editData.countyId;
                            this.refreshEditList(editData);
                        } else {
                            alert("没有找到对应的地址数据");
                        }
                    }));
                    
                } else {
                    alert("请选择要编辑的地址");
                }
            }
        },
        // 地址列表的点击事件
        onAddressList : function (evt) {
            var dom = evt.target;
            if (dom && domClass.contains(dom, "address-checkbox")) {
                // 修改选中的样式
                array.forEach(query(".address-checkbox", this.addressList), function(node) {
                    domAttr.set(node, "checked", "");
                });
                domAttr.set(dom, "checked", "checked");
                // 刷新订单列表的数据
                this.addressId = domAttr.get(dom, "value");
                this.onRefreshAddrList();
            }
        },
        // 刷新省下拉框中的数据
        refreshProvince : function (selectId) {
            // 加载省的数据
            var preferenceStr = "<option value='-1' class = 'provinced-option'>请选择省</option>";
            district.loadByLevel(2).then(lang.hitch(this, function(datas){
                if (datas && datas.data && datas.data.ok === 1) {
                    array.forEach(datas.data.items, function (item) {
                        if (item._id === selectId) {
                            preferenceStr = preferenceStr + "<option value ='"+item._id+"' class = 'provinced-option' selected>"+ item.distName+"</option>";
                        } else {
                            preferenceStr = preferenceStr + "<option value ='"+item._id+"' class = 'provinced-option'>"+ item.distName+"</option>";
                        }
                    })
                }
                this.provincedNode.innerHTML = preferenceStr;
            }));
        },
        // 刷新市下拉框中的数据
        refreshCity : function (params) {
            var cityStr = "<option class = 'city-option' value='-1'>请选择市</option>";
            if (params.upDistId) {
                district.loadByUpId(params.upDistId).then(lang.hitch(this, function(datas){
                    if (datas && datas.data && datas.data.ok === 1) {
                        array.forEach(datas.data.items, function (item) {
                            if (item._id === params.selectId) {
                                cityStr = cityStr + "<option value ='"+item._id+"' class = 'city-option' selected>"+ item.distName+"</option>";
                            } else {
                                cityStr = cityStr + "<option value ='"+item._id+"' class = 'city-option'>"+ item.distName+"</option>";
                            }
                        })
                    }
                    this.cityNode.innerHTML = cityStr;
                }));
            } else {
                this.cityNode.innerHTML = cityStr;
            }
            
        },
        // 刷新县下拉框中的数据
        refreshCounty : function (params) {
            var countyStr = "<option value='-1'>请选择县</option>";
            if (params.upDistId) {
                district.loadByUpId(params.upDistId).then(lang.hitch(this, function(datas){
                    if (datas && datas.data && datas.data.ok === 1) {
                        array.forEach(datas.data.items, function (item) {
                            if (item._id === params.selectId) {
                                countyStr = countyStr + "<option value ='"+item._id+"' selected>"+ item.distName+"</option>";
                            } else {
                                countyStr = countyStr + "<option value ='"+item._id+"'>"+ item.distName+"</option>";
                            }
                        })
                    }
                    this.countyNode.innerHTML = countyStr;
                }));
            } else {
                this.countyNode.innerHTML = countyStr;
            }
        },
        onRefreshAddressList : function(){},
        onRefreshAddrList : function(){},
        // 获取编辑页面的数据
        getEditListData : function () {
            var savaData = {};
            savaData.provinceId = query("option", this.provincedNode)[this.provincedNode.selectedIndex].value;
            savaData.cityId = query("option", this.cityNode)[this.cityNode.selectedIndex].value;
            savaData.countyId = query("option", this.countyNode)[this.countyNode.selectedIndex].value;
            
            array.forEach(query("input[name='isDefault']"),lang.hitch(this, function(node) {
                if (node.checked) {
                    savaData.isDefault = domAttr.get(node, "value");
                }
            }));
            
            savaData.detailAddress = query(".address-detailAddress", this.editAddressNode)[0].value;
            savaData.contactName = query(".address-contactName", this.editAddressNode)[0].value;
            savaData.tel = query(".address-tel", this.editAddressNode)[0].value;
            
            savaData._id = query(".make-Addr", this.editAddressNode)[0].value;
            return savaData;
        },
        // 设置编辑页面的数据
        refreshEditList : function (data) {
            if (!data){
                data = {};
            }
            // 如果等于false
            if (data.isDefault === false) {
                query("input[name='isDefault']")[1].checked = true;
            } else {
                query("input[name='isDefault']")[0].checked = true;
            }
            domAttr.set(query(".address-detailAddress", this.editAddressNode)[0], "value", data.detailAddress || "");
            domAttr.set(query(".address-tel", this.editAddressNode)[0], "value", data.tel || "");
            domAttr.set(query(".address-contactName", this.editAddressNode)[0], "value", data.contactName || "");
            domAttr.set(query(".make-Addr", this.editAddressNode)[0], "value", data._id || "");
            this.refreshProvince(data.provinceId);
            this.refreshCity({upDistId : data.provinceId, selectId : data.cityId});
            this.refreshCounty({upDistId : data.cityId,selectId : data.countyId});
        }
    });
    
    //优惠券信息
    var CouponsList = declare("", _WidgetBase, {
        postCreate : function () {
            this.createNode();
            this.indexElement();
            this.initEvent();
        },
        createNode : function(){
            
        },
        indexElement : function(){
            
        },
        initEvent : function(){
            this.connect(this.orderHead.domNode,"onclick",this.addCouponsClick);
            this.connect(this.orderHead.domNode,"onclick",this.getCouponsListClick);
            this.connect(this.couponHead.domNode,"onclick",this.makeCouponsClick);
            this.connect(this.couponHead.domNode,"onclick",this.getCouponsClick);
            
            this.connect(this.couponHead,"onDefRendered",function(data){
                array.forEach(data.data.items||[],lang.hitch(this,function(item){
                    item.startDate = item.startDate?date.formatISODate(item.startDate):"";
                    item.stopDate = item.stopDate?date.formatISODate(item.stopDate):"";
                }),this);
            });
        },
        
        //商品列表中的优惠券列表
        getCouponsListClick:function(e){
            var dom = e.target;
            if (dom && domClass.contains(dom, "couponList-checkbox")) {
                // 修改选中的样式
                array.forEach(query(".couponList-checkbox", dom.parentNode.parentNode.parentNode), function(node) {
                    domAttr.set(node, "checked", "");
                });
                domAttr.set(dom, "checked", "checked");
            }
        },
        getCouponsToOrder:function(){
            var checkedNodes = query(".couponList-checkbox[checked='checked']", this.orderHead.domNode);
                if (checkedNodes.length > 0) {
                    // 修改当前选中的优惠券的值
                    var couponsId = {};
                    array.forEach(checkedNodes,function(node){
                        var couponId = domAttr.get(node, "value");
                        var shopId = node.nextSibling.innerHTML;
                        couponsId[shopId] = couponId;
                    },this);
                    return couponsId;
                }else {
                    return null;
                }
        },
        //领取优惠券
        makeCouponsClick:function(e){
            var dom = e.target;
            if(domClass.contains(dom, "make-coupons")){
                var checkedNodes = query(".coupon-checkbox[checked='checked']", this.couponHead.domNode);
                if (checkedNodes.length === 1) {
                    // 修改当前选中的地址的值
                    this.checkedCoupons = domAttr.get(checkedNodes[0], "value");
                    disCount.getB2BCouponByUserSelf({_id:this.checkedCoupons,shopId:this.b2bShopId}).then(lang.hitch(this,function(data){
                        if(data&&data.data.ok == 1){
                            alert("您领取了优惠券");
                            // 刷新订单列表的数据
                            this.refreshOrderList();
                        }else{
                            var msg = data.data.message||"优惠券完了";
                            alert(msg);
                        }
                        domClass.add(this.couponHead.domNode,"hide");
                    }));
                }
            }
            
            if(domClass.contains(dom, "cancel-coupons")){
                domClass.add(this.couponHead.domNode,"hide");
            }
        },
        getCouponsClick:function(e){
            var dom = e.target;
            if (dom && domClass.contains(dom, "coupon-checkbox")) {
                // 修改选中的样式
                array.forEach(query(".coupon-checkbox", this.couponHead.domNode), function(node) {
                    domAttr.set(node, "checked", "");
                });
                domAttr.set(dom, "checked", "checked");
            }
        },
    });
    
    return declare("widgets.xmweb.OrderInfo", Base, {
        // 当前选中的地址id
        checkedAddress : "",
        indexElement: function () {
            this.inherited(arguments);
            this.orderHead = registry.byId("orderHead");
            this.buyerDetail = registry.byId("buyerDetail");
            this.couponHead = registry.byId("couponHead");//领取优惠券
            this.subOrderBtn=query(".checkOutButton a")[0];//提交订单按钮
            this.orderfooter = query(".orderfooter",this.domNode)[0];//支付相关
            this.payType = query(".payType",this.domNode)[0];
            this.payBtn = query(".payBtn",this.domNode)[0];
            this.coverOrderHead = query(".coverOrderHead",this.domNode)[0];
            // this.shopFromName = query(".shopFromName",this.domNode)[0];//供货商
            // this.matTd = query(".orderMatIcon",this.domNode)[0];//商品图片
        },
        initEvent: function () {
            this.inherited(arguments);
            this.connect(this.subOrderBtn,"onclick",this.submitOrder);
            this.connect(this.payType,"onclick",this.payTypeClick);
            this.connect(this.payBtn,"onclick",this.payOrder);
            
            this.connect(this.orderHead,"onDefRendered",function(data){
                array.forEach(data.data.items||[],lang.hitch(this,function(item){
                    if(item.coupons&&item.coupons.length>0){
                        array.forEach(item.coupons,lang.hitch(this,function(item){
                            item.startDate = item.startDate?date.formatISODate(item.startDate):"";
                            item.stopDate = item.stopDate?date.formatISODate(item.stopDate):"";
                        }),this);
                    }
                }),this);
            });
        },
        
        splitWindowDid : function () {
            if (window.did) {
                var strs = window.did.split("-");
                window.did = strs[0] || "";
                this.minQty = strs[1] || 1;
            } else {
                window.did = "";
                this.minQty = 1;
            }
            
        },
        // 刷新页面数据
        initData: function () {
            this.inherited(arguments);
            
            // 为了不影响后面的程序在这里处理最小起定量和window.did的问题
            this.splitWindowDid();
            
            domClass.add(this.orderfooter,"hide");
            domClass.remove(this.subOrderBtn,"hide");
            domClass.add(this.coverOrderHead,"hide");
            
            // 隐藏地址编辑的内容
            domClass.add(this.editAddressNode,"hide");
            
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    // 刷新商家地址列表
                    this.refreshAddressList();
                }else{
                    window.moveToView("login");
                    user.nextPage="orderInfo";
                }
            }));
        },
        
        //按商家搜索优惠券
        addCouponsClick:function(e){
            var dom = e.target;
            if(dom.parentNode.className == "getCoupons"){
                this.b2bShopId = domAttr.get(dom.parentNode, "disId");
                disCount.loadAvailableByUserSelfThen({shopId: this.b2bShopId}).then(lang.hitch(this,function(data){
                    if(data&&data.data&&data.data.items&&data.data.items.length>0){
                        this.couponHead.onDataReady(data);
                        domClass.remove(this.couponHead.domNode,"hide");
                    }else{
                        var msg = data.data.message||"该商家无优惠券";
                        alert(msg);
                    }
                }));
            }
        },
        
        // 刷新地址列表中的数据
        refreshAddressList : function () {
            // 获取数据
            userAddress.loadPlatformAddrs().then(lang.hitch(this, function (data) {
                var dflAddressId = "";
                if (data && data.data && data.data.ok === 1) {
                    array.forEach(data.data.items, function(item) {
                        if (item.isDefault) {
                            dflAddressId = item._id;
                        }
                    });
                    if(!this.userAddr){
                        this.userAddr = new UserAddr({
                            addrInfos : data.data.items,
                            checkedAddress : this.checkedAddress
                        });
                        this.connect(this.userAddr,"onRefreshAddrList",this.refreshOrderList);
                        this.connect(this.userAddr,"onRefreshAddressList",this.refreshAddressList);
                    }else{
                        this.userAddr.addrInfos = data.data.items;
                    }
                }
                // 当前选中的地址是否存在
                if (!this.checkedAddress) {
                    this.checkedAddress = dflAddressId;
                }
                // 设置选中
                this.setCheckedAddress();
                // 刷新订单列表
                this.addressId = this.checkedAddress;
            }));
        },
        // 设置地址的选中
        setCheckedAddress : function () {
            // 修改选中的样式
            array.forEach(query(".address-checkbox", this.addressList.domNode), lang.hitch(this, function(node) {
                if (this.checkedAddress === domAttr.get(node, "value")) {
                    domAttr.set(node, "checked", "checked");
                } else {
                    domAttr.set(node, "checked", "");
                }
                
            }));  
        },
        // 刷新订单信息
        refreshOrderList : function (addressId) {
            var mids = [],
            selectedCart = cart.getSelectedChart();
            this.mids=[];
            if(window.did){
                this.mids.push(window.did);
                mids.push({
                    mid : window.did,
                    qty : this.minQty
                })
            }else {
                this.mids = cart.getSelected();
                for (var mid in selectedCart) {
                    if (selectedCart.hasOwnProperty(mid)) {
                        mids.push({
                            mid : mid,
                            qty : selectedCart[mid]
                        });
                    }
                }
            }
            // 获取商品信息
            mat.loadByIds(this.mids,config.getPlatformShopId()).then(lang.hitch(this,function(data){
                var items=data.data.items;
                var shopMatHash = {},matHash = {},cartData = cart.get();
                if(window.did){
                    cartData = {};
                    cartData[window.did] = this.minQty;
                }
                for(var i=0;i<items.length;i++){
                    if(!shopMatHash[items[i].fromShopId]){
                        shopMatHash[items[i].fromShopId] = [];
                    }
                    shopMatHash[items[i].fromShopId].push({
                        price:items[i].retailPrice,
                        qty:cartData[items[i]._id],
                        mId:items[i]
                    });
                }
                array.forEach(data.data.items,lang.hitch(this,function(item,index){
                    item.qty = cartData[item._id];
                }),this);
                // 获取运费和商家信息
                order.getB2BCouponsAndTAmount({mids : mids, addressId : this.addressId}).then(lang.hitch(this,function(data){
                    if(data&&data.data&&data.data.ok==1){
                        var shopHash = data.data.item, shop = null;
                        var datas = {};
                        datas.data = {};
                        datas.data.items = [];
                        
                        for(var shopId in shopHash){
                            shop = shopHash[shopId];
                            datas.data.items.push({
                                details:shopMatHash[shopId],
                                amount:shop.totalPrice+shop.tAmount,
                                tAmount:shop.tAmount,
                                shopId:shopId,
                                shopName:shop.shopInfo&&shop.shopInfo.shopName||"",
                                coupons:shop.coupons
                            });
                        }
                        var countQty = 0;
                        
                        array.forEach(datas.data.items,function (item){
                            array.forEach(item.details,function (detail){
                                countQty += detail.qty;
                            },this);
                            item.qty = countQty;
                        },this);
                        this.orderHead.onDataReady(datas);
                    }else{
                        alert(data.data.msg);
                        history.back();
                    }
                }));
            }));  
        },
        
        
        //将分钟数转换为时间格式
        //    输入：80——分钟数
        //    输出：1小时20分钟
        minuteToTimeString:function(minutes){
            var minute = minutes%60;
            minutes = parseInt(minutes/60);
            var hour = minutes%24;
            var day = parseInt(minutes/24);
            var timeStr = "";
            if(day){
                timeStr += ""+day+"天";
            }
            if(hour){
                timeStr += ""+hour+"小时";
            }
            if(minute){
                timeStr += ""+minute+"分钟";
            }
            return timeStr;
        },
        // 获取收货人信息
        getContactInfo : function (data) {
            var node = query(".address-checkbox[checked='checked']")[0].parentNode.parentNode;
            data.dAddress = query("[name = 'detailAddress']", node)[0].innerHTML;
            data.dTel = query("[name = 'tel']", node)[0].innerHTML;
            data.dName = query("[name = 'contactName']", node)[0].innerHTML;
            return data
        },
        submitOrder: function () {
            window.busy();
            var m = {};
            if (!this.checkedAddress) {
                window.free();
                alert("请选择收货地址");
                return;
            }
            m.addressId = this.checkedAddress;
            m = this.getContactInfo(m);
            // 设置地址信息
            m.coupon = this.getCouponsToOrder();
            m.userId = user.userId;
            //处理立即购买的问题
            if(!window.did){
                m.mids = cart.getAsArray();
            } else {
                m.mids = [{mid : window.did, qty : this.minQty}];
            }

            //提交订单
            order.createDistributionOrder(m,config.getPlatformShopId()).then(lang.hitch(this, function (result) {
                domClass.remove(this.orderfooter,"hide");
                domClass.add(this.subOrderBtn,"hide");
                window.free();
                cart.clear(cart.getSelected());
                cart.setSelected([]);
                window.updateCarNum();
                var orderH = domStyle.get(query(".orderHead",this.domNode)[0],"height");
                domStyle.set(this.coverOrderHead,"height",orderH+"px");
                domClass.remove(this.coverOrderHead,"hide");
                // this.disconnect(this.matTdConnect);
                // this.disconnect(this.shopNameConnect);
                for (var shop in result.data.item) {
                    shopParam.loadById(shop).then(lang.hitch(this,function(data){
                        var msg = "";
                        if(data&&data.data&&data.data.shopName){
                            var shopId = data.data._id;
                            if (result.data.item.hasOwnProperty(shopId)) {
                                if(result.data.item[shopId]&&result.data.item[shopId].msg){
                                    if(result.data.item[shopId]&&result.data.item[shopId].msg){
                                        msg = data.data.shopName + result.data.item[shopId].msg.message|| "优惠券已锁定";
                                        delete(result.data.item[shopId]);
                                        alert(msg);
                                    }
                                }
                            }
                        }
                    }));
                }
                this.orderDetails = result;
            }));
        },
        
        payOrder:function(){
            if(query(".payBtnSelect",this.payType)[0]){
                var ids = [];
                var payType = domAttr.get(query(".payBtnSelect",this.payType)[0],"payType");
                for (var shop in this.orderDetails.data.item) {
                    if (this.orderDetails.data.item.hasOwnProperty(shop)) {
                        if(this.orderDetails.data.item[shop]&&this.orderDetails.data.item[shop].order){
                            ids.push(this.orderDetails.data.item[shop].order._id);
                        }
                    }
                }
                var timeout = this.orderDetails.data.item.timeout
                if(timeout>0){
                    alert("请在"+this.minuteToTimeString(timeout)+"内完成支付，否则订单会自动取消。");
                }
                window.busy();
                order.onB2BPayByIds({
                    ids : JSON.stringify(ids),
                    payType : payType
                }).then(lang.hitch(this,function(data){
                    window.free();
                    if(data&&data.data&&data.data.ok == 1){
                        if(this.orderDetails && this.orderDetails.data && this.orderDetails.data.ok === 1){
                            this.orderDetails = null;
                            if(ids.length>1){
                                window.moveToView("orderList");
                            }else {
                                window.moveToView("orderDetail",ids[0]);
                            }
                        }else {
                            alert(this.orderDetails && this.orderDetails.data && this.orderDetails.data.msg || "提交失败!");
                            this.orderDetails = null;
                        }
                    }else{
                        if(data.result){
                            alert(data.result);
                        }else if(data&&data.data&&data.data.msg){
                            alert(data&&data.data&&data.data.msg);
                        }else{
                            alert("支付失败");
                        }
                        if(this.orderDetails && this.orderDetails.data && this.orderDetails.data.ok === 1){
                            this.orderDetails = null;
                            if(ids.length>1){
                                window.moveToView("orderList");
                            }else {
                                window.moveToView("orderDetail",ids[0]);
                            }
                        }else {
                            alert(this.orderDetails && this.orderDetails.data && this.orderDetails.data.msg || "提交失败!");
                            this.orderDetails = null;
                        }
                    }
                    
                }));
                
            }else{
                alert("请先选择支付方式");
            }
        },
        payTypeClick:function(e){
            var dom = e.target;
            if(dom.tagName=="A"){
                //var cls = domClass.get(dom,"class");
                // 清楚以前选中的样式
                if(query(".payBtnSelect",this.payType)[0]){
                    domClass.remove(query(".payBtnSelect", this.payType)[0], "payBtnSelect");
                }
                // 添加当前节点的选中
                domClass.add(dom,"payBtnSelect");
            }
        }
    });
});
