define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "../_WidgetBase",
    "../_LayoutMixin",
    "./DataLayout"
],function(declare,lang,array,domAttr,domStyle,domClass,Deferred,_WidgetBase,_CqWidgetBase,_LayoutMixin,DataLayout){
    var propStr = 'editorEnterMethod:"{editorEnterMethod}",fieldChangeMethod:"{fieldChangeMethod}",reloadMethod:"{reloadMethod}",idInfoMap:{j:idMap},actionStateMethod:"{actionStateMethod}",initMethod:"{initMethod}",dataProvider:"{dataProvider}",layoutMethod:"{layoutMethod}",layoutType:"{layoutType}"';
    return declare("",[DataLayout],{
        htmlTemp:"<div id='{id}' class='cq-area cq-form-stepLayout {className}' data-dojo-type='cq/app/widget/web/StepLayout' data-dojo-props='"+propStr+"'></div>",
        loadLayout:function(){
            var layout = this.inherited(arguments);
            if(layout.then){
                return layout.then(lang.hitch(this,function(data){
                    return this._decorateStepLayout(data);
                }));
            }else{
                return this._decorateStepLayout(layout);
            }
        },
        _decorateStepLayout:function(rawData){
            var datas=[];
            var newData={
                dojoType:"cq/app/widget/web/Steps",
                field:"steps",
                steps:{
                    stepsTags:[],
                    stepsFields:[],
                    stepsBtns:[]
                }
            };
            array.forEach(rawData,function(item){
                array.forEach(item.tags,function(tag){
                    var tagObj = {type:"action",label:tag};
                    newData.steps.stepsTags.push(tagObj);
                    newData.steps.stepsFields.push({
                        fields:[],
                        type:"tagFields",
                        tag:tagObj.label
                    });
                });
                array.forEach(item.fields,function(field){
                    if(field.tag){
                        array.forEach(newData.steps.stepsFields,function(stepsField){
                            if(field.tag===stepsField.tag){
                                stepsField.fields.push(field);
                            }
                        });
                    }else{
                        newData.steps.stepsBtns.push(field);
                    }
                });
            });
            array.forEach(newData.steps.stepsFields,function(stepsField){
                delete stepsField.tag;
            });
            datas.push(newData);
            return datas;
        }
    });
});