﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/event",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "cq/biz/blob/blob"
],function(declare,lang,array,event,domAttr,domConstruct,domStyle,_WidgetBase,blob){
    return declare("",[_WidgetBase],{
        // summary: 
        //
        
        htmlTemp:'<div class="cq-form-objseditor cq-field-input" data-dojo-type="cq/app/widget/web/edit/AttachmentList" data-dojo-props=\'canAdd:"{canAdd}",label:"{label}",canEdit:{canEdit},field:"{field}"\'></div>',
        // field:String
        //      组件名称
        //      实际可能是该组件需要的某些字段、组件的组件名、与之联动的组件的组件名或字段名构成的一段字符串。
        field:"",
        
        
        label:"",
        
        canAdd:true,
        // canEdit:boolean
        //      编辑状态，true为可编辑。
        canEdit:true,
        
        buildRendering:function(){
            // summary:
            //      初始化组件
            // tags:
            //      private
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.canAdd = this.canAdd!==false&&this.canAdd!=="false";
            this.value = [];
            this.inherited(arguments);
            this.createAddBtn();
            this.fileList = domConstruct.create("div",{},this.domNode,"last"); 
       
        },
        setCanEdit:function(canEdit){
            // summary:
            //      设置组件是否可编辑。
            // params:
            //      canEdit:编辑状态
            // tags:
            //      public
            this.canEdit = canEdit!==false&&canEdit!=="false";
            
            if(this.canEdit){
                
                domStyle.set(this.addBtn,"display",this.canEdit?"":"none");
                if(this.fileList.childNodes.length){
                    for(var i=0; i<this.fileList.childNodes.length; i++){
                        domStyle.set(this.fileList.childNodes[i].childNodes[1],"display","inline");    
                    }
                }
            }else{
                domStyle.set(this.addBtn,"display",this.canEdit?"":"none");
                if(this.fileList.childNodes.length){
                    for(var i=0; i<this.fileList.childNodes.length; i++){
                        domStyle.set(this.fileList.childNodes[i].childNodes[1],"display","none");    
                    } 
                }
                
            }
        },
        getValue:function(){
            return this.value;
        },
        setValue:function(value){
            // summary:
            //      设置组件的值
            // params:
            //      value:组件的值
            // tags:
            //      private
            this.addFileNode(value);
            //this.value.concat(value);
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      本对象发生变化后通知其他对象刷新的接口
            // params:
            //      widget:发生变化对象所在的view
            //      field:发生变化的对象
            //      value:改变后的值
            // tags:
            //      interface
        },
        
        createAddBtn:function(){
            // summary:
            //      创建添加附件节点
            //      为节点提供添加附件的方法
            //this. = domConstruct.create("div",{},this.domNode,"first");
            this.addBtn = domConstruct.create("div",{
                innerHTML:"添加",
            },this.domNode,"first");
            if(this.canEdit){
                this.addBtn.addEventListener("click",lang.hitch(this,function(){
                    this.onAddFile();
                }));
            }
        },
        
        createList:function(){
            // sunmary:
            //      创建附件列表节点
        },
        
        onAddFile:function(){
            var fileSelectInput = domConstruct.create("input",{
                "class":"none",
                //multiple:"multiple",
                type:"file"
            },document.body);
            fileSelectInput.click();
            fileSelectInput.onchange = lang.hitch(this,function(){
                blob.upload(fileSelectInput).then(lang.hitch(this,function(data){
                    if(data.items && data.items.length > 0){
						var value=[];
						
						//for(var i=0;i<data.items.length;i++){
							//value.push(data.items[i]);
							//name.push(data.items[i])
							//this.value=this.value.concat(data.items[i]);
						//}
						this.value = (this.value||[]).concat(array.map(data.items||[],function(item){
							return {
								title:item.originName,
								url:item.uri
							};
						}));
						//this.setValue(value);
						this.setValue(this.value);
						this.onFieldChanged(this,this.field,this.value);
					}
                    if(fileSelectInput.parentNode){
                        fileSelectInput.parentNode.removeChild(fileSelectInput);
                    }
                }));
            });
            
        },
        addFileNode:function(value){
            domConstruct.empty(this.fileList);
            array.forEach(value,function(item){
                var name = item.title;
                this.fiel = domConstruct.create("li",{
                    innerHTML:"<a href='"+item.url+"' download='"+name.replace(/['"]/g,"")+"'>"+name+"</a>"
                    
                },this.fileList,"last");
                this.deleteBtn = domConstruct.create("div",{
                    innerHTML:"删除",
                    style:"float:right",
                },this.fiel,"last");
                this.deleteBtn.addEventListener("click",lang.hitch(this,function(){
					this.deleteFiel(item);
				}));
                //this.fileList.appendChild();
            },this);
        },
        deleteFiel:function(del){
			var index=array.indexOf(this.value,del);
			if(index>-1){
				this.value.splice(index,1);
			}
            this.setValue(this.value);
        }
        
    });
});