﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dijit/_WidgetBase",
    "cq/biz/blob/blob"
],function(declare,lang,domAttr,domConstruct,_WidgetBase,blob){
    return declare("",[_WidgetBase],{
        htmlTemp:'<div class="cq-form-fielEditor cq-field-input" data-cq-field="{field}" data-dojo-type="cq/app/widget/web/edit/FileEditor" data-dojo-props=\'label:"{label}",canEdit:{canEdit},field:"{field}",canEdit:"{canEdit}",value:{j:value}\'></div>',
        field:"",
        label:"",
        canEdit:true,
        value:null,
        buildRendering:function(){
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
            this.createBtn(this.canEdit);
            this.fileLabel=domConstruct.create("span",{
                innerHTML:this.value.title||""
            },this.domNode,"last");
        },
        setCanEdit:function(canEdit){
            this.createBtn(canEdit);
        },
        getValue:function(){
            return this.value;
        },
        setValue:function(value){
            this.fileLabel.innerHTML = value.title||getValue().title||"";
            if(!this.canEdit){
                domAttr.set(this.downLoadBtn,"href",value.url||this.getValue().url||"");
                domAttr.set(this.downLoadBtn,"download",value.title||this.getValue().title||"");    
            }
        },
        onFiledChanged:function(widget,field,value){
            
        },
        //创建左侧按钮,并绑定事件
        createBtn:function(canEdit){
            if(canEdit){
                // 可编辑时
                if(this.downLoadBtn){
                    domConstruct.destroy(this.downLoadBtn);
                }
                this.selectFileBtn = domConstruct.create("button",{
                    innerHTML:"选择文件"
                },this.domNode,"first");
                this.selectFileBtn.addEventListener("click",lang.hitch(this,function(){
                    this.selectFile();
                }));
            }else{
                // 不可编辑时
                if(this.selectFileBtn){
                    domConstruct.destroy(this.selectFileBtn);
                }
                this.downLoadBtn = domConstruct.create("a",{
                    innerHTML: "<button>下　载</buttom>",
                    href:this.value.url||"",
                    download:this.value.title||""
                },this.domNode,"first");
                this.downLoadBtn.children[0].addEventListener("click",lang.hitch(this,function(){
                    this.downLoadBtn.click();
                }));
            }
        },
        //选择文件
        selectFile:function(){
            var fileSelectInput = domConstruct.create("input",{
                "class":"none",
                //multiple:"multiple",
                type:"file"
            },document.body);
            fileSelectInput.click();
            fileSelectInput.onchange = lang.hitch(this,function(){
                blob.upload(fileSelectInput).then(lang.hitch(this,function(data){
                    if(data.items){
                        this.value ={
                            title:data.items[0].originName,
                            url:data.items[0].uri
                        };
                    }
                    this.setValue(this.value);
                    this.onFieldChanged(this,this.field,this.value);
                    if(fileSelectInput.parentNode){
                        fileSelectInput.parentNode.removeChild(fileSelectInput);
                    }
                }));
            });
        },
        
    });
});