﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dijit/_WidgetBase"
],function(declare,lang,xhr,domConstruct,Deferred,DeferredList,_WidgetBase){
    // module:
    //      cq/app/widget/web/edit/Location
    
    //引入高德地图
    if(!window.AMap){
        domConstruct.create("script",{
            //高德地图url
            src:"http://webapi.amap.com/maps?v=1.3&amp;key=0b9138e58ee2c5776ed90d144bfbfd97"
        },document.head,"last");
    }
    return declare("",[_WidgetBase],{
        // summary: 
        //      定义了web端的地图组件，继承自_WidgetBase.
        
        // htmlTemp:String
        //      组件的DOM结构字符串,并传递组件的属性。
        // tags:
        //      private
        htmlTemp:'<div id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-location" data-dojo-type="cq/app/widget/web/edit/Location" data-dojo-props="field:\'{field}\',distFields:\'{distFields}\',distFieldsStr:\'{distFieldsStr}\',detailAddrField:\'{detailAddrField}\',canEdit:\'{canEdit}\'"></div>',
        
        // field:String
        //      组件名称
        //      实际可能是该组件需要的某些字段、组件的组件名、与之联动的组件的组件名或字段名构成的一段字符串。
        field:"",
        
        // provinceField:String
        //      一个显示省名字符串的组件名
        //      用于省份名称字符串与地图的联动
        provinceField:"",
        
        // cityField:String
        //      一个显示市名称符串的组件名
        //      用于市名称字符串与地图的联动
        cityField:"",
        
        // countyField:String
        //      一个显示县/区名称符串的组件名
        //      用于县/区名称字符串与地图的联动
        countyField:"",
        
        //distFields:String
        //      一个区划组件的名称
        //      用于地图和区划之间的联动
        distFields:'',
        
        // distFieldsStr:String
        //      一个显示区划字符串的组件名
        //      用于地图与区划字符串显示之间的联动
        distFieldsStr:"",
        
        // detailAddrField:String
        //      一个显示详细地址字符串的组件名
        //      用于地图和详细地址显示之间的联动
        detailAddrField:"",
        
        // features:Array
        //      高德地图的特征
		features:["bg","point","road","building"],
        
        // geocoder:Object
        //      用于实例化高德地图
        geocoder :null,
        
        // canEdit:boolean
        //      编辑状态，true为可编辑。
        canEdit:true,
        
        buildRendering:function(){
            // summary:
            //      初始化组件
            // tags:
            //      private
            this.inherited(arguments);
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            //addedMarks:Array
            //      保存增加的地图标记
            this.addedMarks = [];
            this.containerNode = this.containerNode||this.domNode;
            //创建地图区域
            var mapId = this.get("id")+"map";
            //处理内容
            this.mapDiv = domConstruct.create("div",{
                style:"width:100%;height:100%;",
                "id":mapId
            },this.containerNode,"last");
            setTimeout(lang.hitch(this,function(){
                this._initMap(mapId);
            },this),300);
        },
        setCanEdit:function(canEdit){
            // summary:
            //      设置是否可编辑
            // params:
            //      canEdit:编辑状态         
            this.canEdit = canEdit;
        },
        _initMap:function(mapId){
            // summary:
            //      创建高德地图
            // param:
            //      mapId:地图节点的DOM结构ID
            // tags:
            //      private
            if(!this.map){
                if(!this.geocoder){
                    AMap.service('AMap.Geocoder',function(){//回调函数
                        //实例化Geocoder
                        var geocoder = this.geocoder = new AMap.Geocoder({});
                    });
                }
                this.addedMarks = [];
                var defs = [];
                var def1 = null;
                //创建地图
                var map = this.map = new AMap.Map(mapId,{
                    zoom:this.mapZoom||12, //地图显示的缩放级别,
                    resizeAble:((this.lon||this.lat)&&true)||false,
                    features:this.features
                });
                defs.push(def1 = new Deferred());
                this.map.plugin(["AMap.ToolBar"],function(){
                    map.addControl(new AMap.ToolBar({
                        direction:true,//方向导航
                        ruler:true,//视野级别控制尺
                        autoPosition:false//自动定位
                    }));
                    def1.resolve();
                });
				//如果有经纬度，立即设置中心
				if(this.value&&this.value.length) this.setCenter({lon:this.value[0], lat:this.value[1]});
                
                map.plugin('AMap.Geolocation', lang.hitch(this,function() {
                    var geolocation = new AMap.Geolocation({
                        enableHighAccuracy: true,
                        timeout: 10000,
                        buttonOffset: new AMap.Pixel(10, 20),
                        zoomToAccuracy: true,
                        buttonPosition:'RB'
                    });
                    map.addControl(geolocation);
                    geolocation.getCurrentPosition();
                    AMap.event.addListener(geolocation, 'complete', lang.hitch(this,function(e){
                        if(this.value&&this.value.length){
                            this.setCenter({lon:this.value[0], lat:this.value[1]});
                        }else{
                            this.onMapCenterChanged(e.position.lng, e.position.lat);
                            this.value = [e.position.lng, e.position.lat];
                            this.onFieldChanged(this,this.field.split(","),this.value);
                        }
                    }));
                    AMap.event.addListener(geolocation, 'error', function(){
                        console.error(arguments);
                        if(this.value&&this.value.length){
                            this.setCenter({lon:this.value[0], lat:this.value[1]});
                        }
                    });
                }));
                this._mapDef = new DeferredList(defs);
                this._mapDef.then(lang.hitch(this,function(){
                    this.setValue(this.getValue());
                }));
                //侦听事件
                var clickHandle = AMap.event.addListener(this.map, 'click', lang.hitch(this,function(e) {
                    var fieldsStr;
                    var addrField;
                    //点击之后判断是否可编辑，判断是否需要重新标记中心点
                    if(this.canEdit){
                        this.onMapCenterChanged(e.lnglat.lng, e.lnglat.lat);
                        this.currentPosition = e;
                        this.value = [e.lnglat.lng, e.lnglat.lat];
                        this.onFieldChanged(this,this.field.split(","),this.value);
                        if(this.provinceField||this.cityField||this.countyField||this.detailAddrField){
                            //处理省市县和详细信息
                            this.getDetailAddrFields(this.value[0],this.value[1]).then(lang.hitch(this,function(detailAddr){
                                if(detailAddr){
                                    this.onFieldChanged(this,this.detailAddrField,[detailAddr]);
                                }
                            }));    
                        }
                        //对象发生编辑之后的事件
                        if(this.distFields){
                            this.getDistrict().then(lang.hitch(this,function(data){
                                if(data){
                                    //区划字符串fieldsStr
                                    
                                    //通知区划改变
                                    this.onFieldChanged(this,this.distFields.split(","),data);
                                }
                            }));
                        }
                    }else{
                        return;
                    }
                }));
            }else{
                this.setValue(this.getValue());
                
            }
        },
        clearAllMarks:function(){
            // summary:
            //      清除所有标记
            while(this.addedMarks.length){
                this.clearMark(this.addedMarks[0]);
            }
        },
        
        clearMark:function(mark){
            // summary:
            //      清除指定标记      
            // params:
            //      mark:一个地图上的标记
            mark = this.addedMarks.pop();
            if(mark){
                while(mark._cqMarkEventHandlers&&mark._cqMarkEventHandlers.length){
                    AMap.event.removeListener(mark._cqMarkEventHandlers.pop());
                }
                mark.setMap(null);
            }
        },
        setCenter:function(center){
            // summary:
            //      设置并添加一个地图标记,然后删除原有标记
            // params:
            //      center:坐标
            var lon = center.lon;
            var lat = center.lat;
            if((lon||0===lon)&&(lat||0===lat)&&lon<=180&&lon>=-180&&lat>=-90&&lat<=90){
                this.map.setCenter(new AMap.LngLat(lon,lat));
                this.clearAllMarks();
                this.addMark({lon:lon, lat:lat});
            }
        },
        addMark:function(markInfo){
            //summary:
            //      添加标记
            // params:
            //      markInfo:坐标
            this._addMark(markInfo);
        },
        _addMark:function(markInfo){
            // summary:
            //      添加标记
            // params:
            //      markInfo:坐标
            // tags:
            //      private
            if(markInfo){
                markInfo.lon -= 0;
                markInfo.lat -= 0;
                if((markInfo.lon||0===markInfo.lon)&&(markInfo.lat||0===markInfo.lat)&&markInfo.lon<=180&&markInfo.lon>=-180&&markInfo.lat>=-90&&markInfo.lat<=90){
                    //创建一个标记
                    var mark = this._createMark(markInfo);
                    //记录创建的标记
                    this.addedMarks.push(mark);
                    //将标记放到地图上
                    mark.setMap(this.map);
                }
            }
        },
        
        _createMark:function(markInfo){
            // summary:
            //      依据参数创建一个标记    
            // params:
            //      markInfo:坐标
            var mark = null;
            if(markInfo){
                var param = {
                    position:new AMap.LngLat(markInfo.lon,markInfo.lat)
                };
                mark=new AMap.Marker(param);
            }
            return mark;
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      设置组件的值
            // params:
            //      value:组件的值
            // tags:
            //      private
        },
        onMapCenterChanged:function(lon, lat){
            // summary:
            //      改变中心点
            // params:
            //      lon:经度
            //      lat:纬度
            this.setCenter({lon:lon, lat:lat}, true);
            this.clearAllMarks();
            this.addMark({lon:lon, lat:lat});
        },
        setValue:function(value){
            // summary:
            //      设置组件的值
            // params:
            //      value:组件的值
            // tags:
            //      private
            this.value = value||[];
            if(this.map){
                this.onMapCenterChanged(this.value[0],this.value[1]);
            }
        },
        getValue:function(){
            // summary:
            //      获取组件的值
            // tags:
            //      private
            return this.value||[];
        },
        getDistrict:function(){
            // summary:
            //      获取区划
            // return:Deferred
            var def = new Deferred();
            if(this.map){
                this.map.getCity(function(data){
                    if(data.province&&data.district){
                        require([
                            "cq/biz/shop/bs/district"
                        ],function(district){
                            district.getPCCByName(data).then(function(data){
                                var districtData=[];
                                if(data&&data.data&&data.data.item&&data.data.item.province){
                                    def.resolve([
                                        data.data.item.province,data.data.item.city,data.data.item.county
                                    ]);
                                }else{
                                    def.resolve(null);
                                }
                            });
                        });
                    }else{
                        def.resolve(null);
                    }
                });
            }else{
                def.resolve(null);
            }
            return def;
        },
        
        getDetailAddrFields : function(lon,lat){
            // summary:
            //      获取详细地址数据的方法      
            // params:
            //      lon:经度
            //      lat:纬度
            // return:Deferred
            var def = new Deferred();
            geocoder.getAddress(new AMap.LngLat(lon,lat),function(status,result){
                if(status == "complete"){
                    def.resolve(result.regeocode.formattedAddress);    
                }else{
                    def.resolve();
                }
            });
            return def;
        }
    });
});