﻿define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "dijit/registry",
    "cq/app/widget/web/edit/ObjEditor"
],function(declare,lang,domConstruct,domStyle,_WidgetBase,registry,ObjEditor){
	// module:
    //      cq/app/widget/web/edit/ObjsEditor
	return declare("",[_WidgetBase],{
		// summary:
		// 		编辑组件集合一对多编辑组件
		
		htmlTemp:'<div class="cq-form-objseditor cq-field-input" data-dojo-type="cq/app/widget/web/edit/ObjsEditor" data-dojo-props=\'canAdd:"{canAdd}",label:"{label}",canEdit:{canEdit},field:"{field}",defaultData:{j:defaultData},labelField:"{labelField}",fields:{j:fields}\'></div>',
        //用于显示的名称字段
        label:"",
        //对象字段
        field:"",
        //要实现的组件的layout
        fields:{},
        // 是否可以添加
        canAdd:true,
        // 是否可以删除
        canDelete:true,
        // 是否可以调整顺序
        canDnd:true,
		// canEdit:boolean
		//      是否可编辑
		canEdit:true,
		
        // defaultData:obj
        //      设置默认选中项。
        defaultData:null,
		buildRendering:function(){
			// summary:
			// 		初始化组件
			this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
			
            this.canAdd = this.canAdd!==false&&this.canAdd!=="false";
			
            this.canDelete = this.canDelete!==false&&this.canDelete!=="false";
            
			this.inherited(arguments);
            
            this.addBtn =  domConstruct.place('<button  class="cq-action cq-form-button "  >添加'+this.label||""+'</button>',this.domNode,"first");
            
            this.addBtn.addEventListener("click",lang.hitch(this,function(){
                if(!this.canEdit || !this.canAdd) return;
                this.initObjEditor(this.defaultData);
            }));
            this._objWidgetBase = new _WidgetBase();
            this.domNode.appendChild(this._objWidgetBase.domNode);
		},
		setCanEdit:function(canEdit){
			// summary:
			// 		设置组件编辑状态
            this.canEdit = canEdit!==false&&canEdit!=="false";
            var nodeList = this._objWidgetBase.domNode.childNodes;
            var editArray=[];
            for(var i=0;i<nodeList.length;i++){
                registry.byId(nodeList[i].id).setCanEdit(canEdit);
            }
            //this.domNode.childNodes[1]
            if(this._objWidgetBase.domNode.childNodes.length){
                //domStyle.set(this.childDeleteNode,"display",this.canEdit?"inline":"none");
                var nodes = this._objWidgetBase.domNode.childNodes;
                for(var i=0; i<nodes.length; i++){
                    domStyle.set(nodes[i].childNodes[0],"display",this.canEdit?"inline":"none");
                } 
            }
            this.addBtn.innerHTML = this.canEdit?"添加"+this.label||"":this.label||"添加";
            
            
		},
        setCanAdd:function(canAdd){
            // summary:
            //      设置是添加对象状态
            this.canAdd = canAdd!=="false"&&canAdd!==false;
            domStyle.set(this.addBtn.domNode,"display",this.canAdd?"":"none");
        },
		getValue:function(){
			// summary:
			// 		获取组件的值
            var nodeList = this._objWidgetBase.domNode.childNodes;
            var editArray=[];
            for(var i=0;i<nodeList.length;i++){
                editArray.push(registry.byId(nodeList[i].id));
            }
			return editArray.map(function(item){
                return item.getValue();
            });
		},
		setValue:function(value){
			// summary:
			// 		设置组件的值
            var nodeList = this._objWidgetBase.domNode.childNodes;
            //var editArray=[];
            for(var i=0;i<nodeList.length;i){
                //editArray.push(registry.byId(nodeList[i].id));
                domConstruct.destroy(nodeList[i]);    
            }
            if(value){
                value.forEach(lang.hitch(this, function(item){
                    this.initObjEditor(item);    
                }));
            }
		},
		
        initObjEditor:function(value){
            var newObj = new ObjEditor({
				fields : this.fields,
				canEdit: this.canEdit,
				onFieldChanged: lang.hitch(this,function(widget,field,value){
					this.onFieldChanged(this, this.field, this.getValue());
				})
            });
            if(this.canEdit){
                newObj._listDeleteNode = domConstruct.create("span",{
                    innerHTML:"删除",
                    style:"float:right;",
                    onclick:lang.hitch(this,function(e){
                        var widget = registry.getEnclosingWidget(e.target);
                        if(widget){
                            widget.destroyRecursive();
                            this.onFieldChanged(this, this.field, this.getValue());
                        }
                    })
                },newObj.domNode,"first");
            }
            this.childDeleteNode = newObj._listDeleteNode;
            this._objWidgetBase.domNode.appendChild(newObj.domNode);
            if(value!==undefined){
                newObj.setValue(value);    
            }
        },
		onFieldChanged:function(widget,field,value){
			// summary:
			// 		value发生变化后通知关联组件
			// frame:
			// 		widget:页面（layoutData对象）
			// 		field:发生改变的字段
			// 		value:改变后的的值
		}
	});
});