define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/connect",
	"dojo/dom-construct",
	"dojo/dom-style",
	"dojo/on",
	"dojo/sniff",
	"dijit/registry",
	"dijit/Editor",
	"dijit/form/Button",
	"dijit/_editor/_Plugin",
	"dijit/_editor/plugins/LinkDialog",
    "cq/biz/blob/blob",
	"dijit/_editor/plugins/ViewSource"
],function(declare,lang,connect,domConstruct,domStyle,on,has,registry,Editor,Button,_Plugin,LinkDialog,blob){
	extraPlugins = ['createLink','insertImage','viewsource'];
	
	//图片编辑增加图片上传按钮
	lang.extend(LinkDialog.ImgLinkDialog,{
		_initButton:function(){
			//先执行原来的方法
			LinkDialog.prototype._initButton.apply(this,arguments);
			//图片对话框第一次显示时
			var handler = connect.connect(this.button,"openDropDown",lang.hitch(this,function(){
				//保证只执行一次
				handler.remove();
				domConstruct.place((new Button({
					label:"上传",style:"float:right;",onClick:lang.hitch(this,this._onUpLoadClick)
				})).domNode,registry.byId(this._uniqueId+"_cancelButton").domNode,"after");
			}));
			if(has("touch")){
				//赵春辉	若是设备，点击图片执行编辑	2015-11-17
				this.editor.onLoadDeferred.then(lang.hitch(this, function(){
					this.editor.own(on(this.editor.editNode, "click", lang.hitch(this, "_onDblClick")));
				}));
			}
		},
		//上传按钮点击之后，隐藏对话框，显示图片选择框
		_onUpLoadClick:function(){
			var value = this.dropDown.get("value");
			this.dropDown.onCancel();
            blob.selectAndUpload({width:0,height:0},0.7).then(lang.hitch(this,function(data){
                if (data.items && data.items.length == 1) {
                    this.button.openDropDown();
                    value = value||{};
                    value.urlInput = data.items[0].uri;
                    this.dropDown.set("value",value);
                }
            }));
		}
	});
	
	return declare("",Editor,{
        // htmlTemp:String
        //      组件的DOM结构字符串,并传递组件的属性。
        // tags:
        //      private
        htmlTemp:'<div id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-richeditor cq-form-input" data-dojo-type="cq/app/widget/web/edit/RichEditor" data-dojo-props="canEdit:{canEdit},field:\'{field}\',height:\'{height}\'"></div>',
        
        extraPlugins:extraPlugins,
        buildRendering:function(){
            this.inherited(arguments);
            this.setCanEdit(this.canEdit!==false&&this.canEdit!=="false");
        },
        startup:function(){
            //赵春辉	dijit/Editor多次startup会导致异常，但其没有做相应检查	2015-01-28
            if(!this.__editorStarted){
                this.__editorStarted = true;
                return this.inherited(arguments);
            }
        },
        setCanEdit:function(canEdit){
            this.canEdit = canEdit;
            this.set("disabled",canEdit?"":"disabled");
        }
    });
});