﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "cq/biz/auth/verifyCode"
],function(declare,lang,domConstruct,domStyle,Deferred,_WidgetBase,verifyCode){
    
    return declare("cq.app.widget.web.edit.VerifyCode",[_WidgetBase],{
        // summary: 
        //      定义了web端的注册组件，继承自_WidgetBase.
        
        // htmlTemp:String
        //      组件的DOM结构字符串,并传递组件的属性。
        // tags:
        //      private    
        htmlTemp:'<div id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-UserNameAndVerifyCode" data-dojo-type="cq/app/widget/web/edit/VerifyCode" data-dojo-props="field:\'{field}\'"></div>',
       
        // field:String
        //      组件名称
        //      实际可能是该组件需要的某些字段、组件的组件名、与之联动的组件的组件名或字段名构成的一段字符串。
        field:"",
        
        // canEdit:boolean
        //      编辑状态，true为可编辑。
        canEdit:true,
        
        val:0,        
         
        buildRendering:function(){
            // summary:
            //      初始化组件
            // tags:
            //      private
            this.inherited(arguments);
            this.containerNode = this.containerNode||this.domNode;
            this._initEditor();
        },
        _initEditor:function(){
            // summary：
            //      实现登录使用的组件
            this.label = domConstruct.create("label",{
                innerHTML:"验证码"
            },this.domNode);
            this.vCode = domConstruct.create("input",{},this.domNode);
            this.imgVerfy = domConstruct.create("img",{
                src:verifyCode.getUrl()
            },this.domNode);
            this.promptNode = domConstruct.create("lable",{
                innerHTML:"*",
                style:"color:red;display:none;font-size:30px;margin-left:10px;"
            },this.domNode);
            var refreshSrc = lang.hitch(this,function(e){
                this.imgVerfy.src = verifyCode.getUrl();
            });
            this.connect(this.imgVerfy, "onclick",refreshSrc);
            this.connect(this.imgVerfy,"onerror",lang.hitch(this,function(){
                setTimeout(refreshSrc,1000);
            }));
			this.connect(this.vCode,"oninput",lang.hitch(this,function(){
				this.val = this.vCode.value;
				this.onFieldChanged(this, this.field, this.val);
			}));
            this.connect(this.vCode,"onchange",lang.hitch(this,function(e){
                verifyCode.verify(this.vCode.value).then(lang.hitch(this,function(data){
                    if(data.data.ok!==1){
                        domStyle.set(this.promptNode,"display","inline-block");
                    }else{
                        domStyle.set(this.promptNode,"display","none");
                    }
                }));
            }));
        },
        onFieldChanged:function(widget, field, value){
            // summary:
            //      本对象发生变化后通知其他对象刷新的接口
            // params:
            //      widget:发生变化对象所在的view
            //      field:发生变化的对象
            //      value:改变后的值
            // tags:
            //      interface
        },
        setValue:function(value){
            // summary:
            //      设置组件的值
            // params:
            //      value:组件的值
            // tags:
            //      private
            this.val = value||"";
        },
        getValue:function(){
            // summary:
            //      获取组件的值
            // tags:
            //      private
            return this.val||"";
        }
    });
});