/*
一组按钮，有标题
按钮的选中样式

*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/registry",
    "dijit/_WidgetBase",
    "../../_WidgetBase",
    "./MenuItem"
],function(declare,lang,array,domConstruct, domStyle, registry, _WidgetBase,_CqWidgetBase,MenuItem){
    return declare("",[_WidgetBase,_CqWidgetBase],{
        baseClass:"menu-group",
        htmlTemp:'<div id="{id}" class="barClass {className}" data-dojo-type="cq/app/widget/web/menu/MenuGroup" data-dojo-props="isOpened:\'{isOpened}\',unopenIcon:\'{unopenIcon}\',openedIcon:\'{openedIcon}\',label:\'{label}\'"><div class="menu-menus">{menus}</div></div>',
        
        //属性
        //标签内容
        label:"",
        //展开时右侧图标地址 
        openedIcon:"",
        //合拢时右侧图标地址
        unopenIcon:"",
        //当前是否已展开
        isOpened:false,

        buildRendering:function(){
            this.inherited(arguments);
            this.containerNode = this.domNode;
            //私有节点属性
            this.groupNode=domConstruct.create("div",{
                class:"menu-item item-header"
            },this.domNode,"first");
            //标签节点
            this.groupLabelNode=domConstruct.create("span",{
                innerHTML:this.label
            },this.groupNode);
            //右侧图标节点
            this.groupRightIcon=domConstruct.create("img",{
                "src":this.isOpened?this.openedIcon:this.unopenIcon
            },this.groupNode);
            
            this.menusNode = this.domNode.lastElementChild;
        },
        startup:function(){
            if(!this._started){
                this.initMenuEvent();
            }
            this.inherited(arguments);
        },
        initMenuEvent:function(){
            this.groupNode.addEventListener("click",lang.hitch(this,function(){
                this.isOpened=!this.isOpened;
                this.groupRightIcon.src = this.isOpened?this.openedIcon:this.unopenIcon;
                this.openOrClose();
            }));
            array.forEach(this.getChildren(),function(menu){
                this.connect(menu,"onMenuClick",this.onMenuClick);
            },this);
            //依据当前状态刷新展开还是合拢
            this.openOrClose();
        },
        openOrClose:function(){
            domStyle.set(this.menusNode,"display",this.isOpened?"block":"none");
        },
        onMenuClick:function(menu){
            if(this.selectedMenu){
                this.selectedMenu.setSelected(false);
            }
            this.selectedMenu = menu;
            this.selectedMenu.setSelected(true);
        }
    });
});
