﻿/*
管理多组按钮
按钮和按钮分组直接写到html中通过parse实现
自己所有的孩子为管理的对象，所有孩子对象
    提供事件供侦听
    提供接口供调用
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dijit/_WidgetBase"
],function(declare,lang,array, domClass, _WidgetBase){
    return declare("",[_WidgetBase],{
        baseClass:"menu-groups",
        htmlTemp:'<div id="{id}" class="{className}" data-dojo-type="cq/app/widget/web/menu/MenuGroups">{groups}</div>',
        
        buildRendering:function(){
            this.inherited(arguments);
            this.containerNode = this.domNode;
        },
        startup:function(){
            if(!this._started){
                this.initGroupEvent();
            }
            this.inherited(arguments);
        },
        //监听每个孩子的事件
        initGroupEvent:function(){
            array.forEach(this.getChildren(),function(menu){
                this.connect(menu,"onMenuClick",this.onMenuClick);
            },this);
        },
        //下级的点击事件
        //    响应，若有前一个sub和menu
        //        若前一个menu不等于当前点击的menu，且当前点击的menu不等于sub，调用前一个sub的取消menu选中的方法
        //        否则不响应
        onMenuClick:function(menu){
            if(this.selectedMenu){
                this.selectedMenu.setSelected(false);
            }
            this.selectedMenu = menu;
            if(menu.getParent()!==this){
                menu.setSelected(true);
            }
        }
    });
});