//比较复杂的按钮对象
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dijit/registry",
    "dijit/_WidgetBase",
    "../../_WidgetBase"
],function(declare,lang,domAttr,domConstruct,domStyle, domClass, registry, _WidgetBase,_CqWidgetBase){
    return declare("",[_WidgetBase,_CqWidgetBase],{
        htmlTemp:'<a id="{id}" class="menu-item {className}"  data-dojo-type="cq/app/widget/web/menu/MenuItem" data-dojo-props="logo:\'{logo}\',href:\'{href}\',label:\'{label}\',rightIcon:\'{rightIcon}\',dataProvider:\'{dataProvider}\',dataAction:\'{dataAction}\',dataEvent:\'{dataEvent}\',clickAction:\'{clickAction}\'"></a>',
        //数据源相关
        dataProvider:"",
        //数据源读取数据的方法
        dataAction:"",
        //数据源提供的刷新本对象的事件
        dataEvent:"",
        //本对象点击之后的事件响应
        clickAction:"",

        //本对象显示相关
        //按钮图标
        logo:"",
        //按钮标签
        label:"",
        //点击之后跳转的目标地址
        href:"",
        
        
        //新增的属性
        //右侧按钮
        rightIcon:"",

        buildRendering:function(){
            // summary:
            //      初始化组件
            this.inherited(arguments);
            this._defaultData = {
                logo:this.logo,
                label:this.label,
                href:this.href,
                rightIcon:this.rightIcon
            };
            this.iconNode = domConstruct.create("img",{
                "class":"menu-icon"
            },this.domNode);
            this.labelNode = domConstruct.create("span",{},this.domNode);
            this.rightIconNode = domConstruct.create("img",{},this.domNode);
            this._refreshMenu();
        },
        postCreate:function(){
            //由数据源且由数据源读取数据的方法名，依据数据源刷新显示
            this.inherited(arguments);
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,this._initDataProvider));
                }else{
                    this._initDataProvider(this.dataProvider);
                }
            }else{
                //侦听点击事件，触发自己的onMenuClick事件共MenuGroup侦听
                this.domNode.addEventListener("click",lang.hitch(this,function(){
                    this.onMenuClick(this);
                }));
                /*
                this.connect(this.domNode,"onclick",function(){
                    this.onMenuClick()
                });
                */
                
                this.cqRefresh();
            }
        },
        _initDataProvider:function(dataProvider){
            this.dataProvider = dataProvider;
            if(this.dataEvent&&this.dataProvider&&this.dataProvider[this.dataEvent]){
                this.connect(this.dataProvider,this.dataEvent,this.cqRefresh);
            }
            if(this.dataProvider&&this.clickAction&&this.dataProvider[this.clickAction]){
                this.clickHandler = this.connect(this.domNode,"onclick",function(evt){
                    this.dataProvider[this.clickAction](evt);
                });
            }
            this.cqRefresh();
        },
        cqRefresh:function(){
            var data = null;
            if(this.dataProvider&&this.dataProvider[this.dataAction]){
                data = this.dataProvider[this.dataAction]();
                if(data&&data.then){
                    return data.then(lang.hitch(this,this._refreshMenu));
                }
            }
            data = data||{
                logo:this.logo,
                href:this.href,
                label:this.label
            };
            this._refreshMenu();
        },
        //这里的处理逻辑需要考虑，是否由初始值决定是否支持某个属性
        _refreshMenu:function(data){
            data = data||this._defaultData;
            this.logo = data.logo||"";
            if(this.logo){
                this.iconNode.src = this.logo;
                domStyle.set(this.iconNode,"display","");
            }else{
                domStyle.set(this.iconNode,"display","none");
            }
            this.href = data.href||"";
            if(this.clickHandler||this.href===""){
                domAttr.set(this.domNode,"href","javascript:void(0);");
            }else{
                domAttr.set(this.domNode,"href",this.href);
            }
            this.label = data.label||"";
            this.labelNode.innerHTML = this.label;
            
            //处理右侧图标
            if(this.rightIconNode){
                if(this.rightIcon){
                    this.rightIconNode.src = this.rightIcon;
                    domStyle.set(this.rightIconNode,"display","");
                }else{
                    domStyle.set(this.rightIconNode,"display","none");
                }
            }
        },
        //设置自己的选中样式,供外部对象调用
        setSelected:function(selected){
            //母浚驰 2016/11/15 修改选中样式
            if(selected){
                domClass.add(this.domNode,"selected");    
            }else{
                domClass.remove(this.domNode,"selected");
            }
        },
        onMenuClick:function(menu){
        }
    });
});
