define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/biz/object",
    "dojo/Deferred",
    "cq/widgets/item/itemProp"
],function(declare, array, json, lang, config, object,Deferred,itemProp){
    var O = declare("", object.Schema, {
        modalName:"article/article",
        //资讯详情
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        save:function(item){
            return this.execInCurrentShop("save",this.filterSaveData(item));
        },
		//20160805:干劲，delete是js关键字，会导致IE判断语法错误。
        deleteArticle:function(id){
            return this.execInCurrentShop("delete_by_id",{
                _id:id
            });
        },
        load:function(condition){
            condition.shopId = condition.shopId||this.getShopId();
            return this.exec("load",condition);
        },
        //通栏目取资讯
        loadByType:function(type,page){
            var hash={
				//20160805:干劲，删除逗号，IE判断语法错误。
                type:type?type:""
            };
            if(page){
                hash.pageSize=page.pageSize?page.pageSize:"";
                hash.pageIndex=page.pageIndex?page.pageIndex:"";
                hash.orderBy=page.orderBy?page.orderBy:"";
            }
            return this.execInCurrentShop("load_by_type",hash);
        },
        getArticleUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        getXMShopUrl:function(){
            return this.getBaseUrl()+"/load?shopId=5703ca7d0ccae34b2b40ab8c";
        },
        getNZBShopUrl:function(){
            return this.getBaseUrl()+"/load?shopId=571705de3023721a5aab8159";
        },
        loadNZBShopById:function(id){
            return this.exec("load_by_id",{
                _id:id,
                shopId:"571705de3023721a5aab8159"
            });
        },
        loadXMShopById:function(id){
            return this.exec("load_by_id",{
                _id:id,
                shopId:"5703ca7d0ccae34b2b40ab8c"
            });
        },
        getPlatformUrl:function(){
            //从config中读取platformID
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        },
        loadPlatformById:function(id){
            //从config中读取platformID
            return this.exec("load_by_id",{
                _id:id,
                shopId:config.getPlatformShopId()
            });
        },
        //帮助信息
        loadPlatformByTitle:function(title){
            //从config中读取platformID
            return this.exec("find_by_title",{
                title:title,
                shopId:config.getPlatformShopId(),
                isUse:true
            });
        },
        // 通过栏目标题取资讯
        loadBySectionName:function(title){
            //从config中读取platformID
            return this.getBaseUrl()+"/load_by_section_name?shopId="+this.getShopId()+"&title="+title;
        },
        getLoadByGroupNameUrl2: function(){
            return this.getBaseUrl()+"/load_by_group_name?shopId="+config.getPlatformShopId();
        },
        getLoadByGroupNameUrl: function(title){
            return this.getBaseUrl()+"/load_by_group_name?shopId="+config.getPlatformShopId()+"&title="+title;
        },
        loadByGroupNameFromShop:function(condition){
            condition.shopId = condition.shopId||this.getShopId();
            return this.exec("load_by_group_name",condition);
        },
        //乡村游，企业，事
        loadAsBoxes:function(params){
            var def = new Deferred();
            params.shopId = params.shopId||this.getShopId();
            this.exec("load_by_group_name",params).then(lang.hitch(this,function(data){
                itemProp.initReVillagerMatBox(data);
                def.resolve(data.data.items);
            }));
            return def;
        },
        //乡村简介
        loadMsgAsBoxes:function(condition){
            var def = new Deferred();
            condition.shopId = condition.shopId||this.getShopId();
            this.exec("load",condition).then(lang.hitch(this,function(data){
                itemProp.initReVillagerMsgBox(data);
                def.resolve(data.data.items);
            }));
            return def;
        },
        loadByGroupName: function(title, pageSize, isTop){
            // 支持传入pageSize
            var params = {
                title:title,
                shopId:config.getPlatformShopId()
            };
            if(pageSize){
                params.pageSize = pageSize;
            }
            if(isTop != undefined){
                params.isTop = isTop;
            }
            return this.exec("load_by_group_name",params);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.article.article", o);
    o.Schema = O;
    return o;
});