define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/config/config",
    "cq/biz/object",
    "../../user/user"
],function(declare, array, json, lang, Deferred, config, object, user){
    var O = declare("", object.Schema, {
        modalName:"article/bs/school_class",
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
        save:function(item){
            return this.execInCurrentShop("save",item);
        },
        loadByPlatform: function(params){
            if(!params){
                params = {};
            }
            params.shopId = config.getPlatformShopId();
            return this.exec("load", params);
        },
        load:function(condition){
            return this.execInCurrentShop("load",condition);
        },
        loadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        attend:function(condition){
            return this.execInCurrentShop("attend_by_room_id",condition);
        },
        loadStudents:function(condition){
            return this.execInCurrentShop("load_students_by_id",condition);
        },
		loadStudentsURL:function(){
            return this.getBaseUrl()+"/load_students_by_id?shopId="+this.getShopId();
        },
        sign:function(condition){
            return this.execInCurrentShop("sign_by_room_id",condition);
        },
        getAttendState:function(id){
            var def = new Deferred();
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.execInCurrentShop("get_user_state",{
                        userId:user.getCurrentUserId(),
                        _id:id
                    }).then(function(data){
                        data.data.item.isLogin = true;
                        def.resolve(data);
                    });
                }else{
                    def.resolve({
                        data:{
                            item:{
                                isLogin:false
                            }
                        }
                    });
                }
            }));
            return def;
        }
    });
    var o = new O();
    lang.setObject("cq.biz.article.bs.school_class", o);
    o.Schema = O;
    return o;
});