define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare,lang,object){
    var Prize = declare("",object.Schema,{
        modalName:"article/mk/prize",
        save:function(prize){
            return this.execInCurrentShop("save",prize);
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{
                _id:id
            });
        },
        verifyById:function(id){
            return this.execInCurrentShop("verify_by_id",{
                _id:id
            });
        },
        stopById:function(id){
            return this.execInCurrentShop("stop_by_id",{
                _id:id
            });
        },
        //获取抽奖活动信息，包含奖项awards，中奖人信息，wineInfos
        getPrizeInfo:function(id){
            return this.defTest({
                data:{
                    ok:1,
                    item:{
                        //主表信息
                        startTime:"2016-05-24 12:00:00",
                        endTime:"2016-06-27 00:00:00",
                        content:"fffffffffffffffffffffffffffffffff",
                        awards:[
                        {
                            //奖项设置
                            disId:"10000",
                            awardName:"谢谢惠顾"
                        },
                        {
                            //奖项设置
                            disId:"10000",
                            awardName:"一等奖"
                        },
                        {
                            //奖项设置
                            disId:"10000",
                            awardName:"二等奖"
                        }
                        ],
                        wineInfos:[
                        {
                            //时间wineTime
                            //奖项
                            //奖品名称awardName
                            //中奖用户
                            wineTime:"2016-05-21 15:22:11",
                            awardName:"电脑",
                            user:{
                                pName:"张三"
                            }
                        },
                        {
                            //时间wineTime
                            //奖项
                            //奖品名称awardName
                            //中奖用户
                            wineTime:"2016-05-21 15:22:11",
                            awardName:"电脑",
                            user:{
                                pName:"李四"
                            }
                        },
                        {
                            //时间wineTime
                            //奖项
                            //奖品名称awardName
                            //中奖用户
                            wineTime:"2016-05-21 15:22:11",
                            awardName:"电脑",
                            user:{
                                pName:"李四"
                            }
                        }
                        ]
                    }
                }
            });
        },
        //获取中奖明细
        loadWinners:function(prizeId){
            return this.defTest({
                data:{
                    ok:1,
                    items:[{
                        //中奖时间
                        createAt:"2016-05-24 12:00:00",
                        awards:{
                            //中奖奖项
                            disId:"10000",
                            awardName:"电饭锅"
                        },
                        userId:{
                            _id:"571705df3023721a5aab815a",
                            address: "重庆",
                            phone:"13355030505",
                            pName: "大头",
                            wxNick : "出来了",
                            nickName : "没了"
                        }
                    },
                    {
                        //主表信息
                        createAt:"2016-05-25 12:00:00",
                        awards:{
                            //中奖奖项
                            disId:"10000",
                            awardName:"iPhone7"
                        },
                        userId:{
                            _id:"571705df3023721a5aab815a",
                            address: "重庆",
                            phone:"13355030525",
                            pName: "小头",
                            wxNick : "进去了",
                            nickName : "来了"
                        }
                    }]
                }
            });
        },
        //获取当前用户的活动信息，剩余抽奖测试。中奖清单等，用户信息
        getCurrentUserPrizeInfo:function(id){
            return this.defTest({
                data:{
                    ok:1,
                    item:{
                        availableNum:2,
                        //中奖清单
                        wineInfos:[{
                            wineTime:"2016-05-21 15:22:11",
                            awardName:"电脑",
                            user:{
                                pName:"张三"
                            }
                        }]
                    }
                }
            });
        },
        //抽奖接口
        onPrize:function(id){
            return this.defTest({
                data:{
                    ok:1,
                    item:{
                        status:1
                        //同获取当前用户抽奖信息
                        /*prizeResult:{
                            //status:0——抽奖失败，
                            //errMessage——错误信息，status为0时有效
                            //时间wineTime
                            //奖项
                            //奖品名称awardName
                        }*/
                    }
                }
            });
        },
        //购买抽奖次数
        buyPrizeChance:function(id){
            return this.defTest({
                data:{
                    ok:1,//1购买成功，否则失败
                    //失败的提示信息和其他接口相同，查一下
                    item:{
                    }
                }
            })
        },
        //赠送抽奖次数
        giftToUser:function(prizeId,userId){
            return this.defTest({
                data:{
                    ok:1,//1赠送成功，否则失败
                    //失败的提示信息和其他接口相同，查一下
                    item:{
                    }
                }
            })
        }
    });
    var prize = new Prize();
    prize.Schema = Prize;
    lang.setObject("cq.biz.article.mk.prize",prize);
    return prize;
});