define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/biz/object"
], function(declare, lang, config, object) {
    var O = declare("", object.Schema, {
        modalName: "article/ss/comment",
        //资讯详情
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", { _id: id });
        },
        load: function(params) {
            if (!params.commentType) {
                params.commentType = 'mat';
            }
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            return this.exec('load', params);
        },
        save: function(item) {
            return this.execInCurrentShop("save", item);
        },
        // params必须传farmer，其余的参数可选
        loadByFarmerId: function(params) {
            return this.execInCurrentShop("load_by_farmer_id", params);
        },
        getLoadByFarmerUrl: function() {
            return this.getBaseUrl() + "/load_by_farmer_id?shopId=" + this.getShopId();
        },
        //支持的的参数：commentId(如商品id)，commentType(评论对戏那个的类型，商品为mat)
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        // 提供依据传递的shopId来查找信息
        getLoadUrlById: function(shopId) {
            return this.getBaseUrl() + "/load?shopId=" + shopId;
        }
    });
    var o = new O();
    lang.setObject("cq.biz.article.ss.comment", o);
    o.Schema = O;
    return o;
});
