// 张松    上传图片，只压缩，不裁剪的工具类
// selectAndUpload选择图片并且上传，可以传入压缩后图片的尺寸，以及压缩质量
// size如果不传，默认压缩后图片宽度640
// size如果宽度为0，则宽高不压缩
// 否则，压缩后图片宽高为传入的size值
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/request/xhr",
    "dojo/Deferred",
    "cq/biz/object"
],function(declare,lang,domConstruct,xhr,Deferred,object){
    var fileSelectInput = domConstruct.create("input",{
        "class":"none",
        type:"file"
    },document.body);
    var BlobItem = declare("",object.Schema,{
        modalName:"blob/blob",
        // 参数可选：size为图片压缩规格，quality为图片压缩质量0-1
        selectAndUpload:function(size, quality,sizeType){
            var def = new Deferred();
            fileSelectInput.click();
            fileSelectInput.onchange = lang.hitch(this,function(){
                var file = fileSelectInput.files&&fileSelectInput.files[0]||fileSelectInput.file||fileSelectInput.value;
                if(file){
                    if(fileSelectInput.parentNode){
                        fileSelectInput.parentNode.removeChild(fileSelectInput);
                    }
                    fileSelectInput = domConstruct.create("input",{
                        "class":"none",
                        type:"file"
                    },document.body);
                    if(size){
                        if("cut"===sizeType&&size.width&&size.height){
                            //做剪切操作
                            require(["cq/util/image/selector"],lang.hitch(this,function(selector){
                                selector.selectImg(null,size,URL.createObjectURL(file),"contain").then(lang.hitch(this,function(url){
                                    this.upload(url).then(function(data){
                                        def.resolve(data);
                                    });
                                }));
                            }));
                        }else{
                            //做压缩操作
                            var blob = URL.createObjectURL(file);
                            this._compress(blob, file, quality||0.4, size).then(lang.hitch(this, function(base64){
                                this.upload(base64).then(function(data){
                                    def.resolve(data);
                                });
                            }));
                        }
                    }else if(file.size>1024*2048){
                        //大于2M，强制压缩为宽度640
                        this._compress(URL.createObjectURL(file),file).then(lang.hitch(this,function(url){
                            this.upload(url).then(function(data){
                                def.resolve(data);
                            });
                        }));
                    }else{
                        //直接上传
                        this._upload(file).then(function(data){
                            def.resolve(data);
                        });
                    }
                }
            });
            return def;
        },
        // 张松  压缩图片的方法，blob为图片文件url，file为文件对象，quality为图片压缩比例，默认0.4  2016/06/24
        _compress:function(blob, file, quality, size){
            var def = new Deferred();
            var img = new Image();
            img.src = blob;
            if(size&&size.width===0){
                img.style = "width:auto;height:auto;";
            }else if(size){
                img.style = "width:" + size.width + "px;height:" + size.height + "px;";
            }else {
                img.style = "width:640px;";
            }
            // img.style = size?("width:" + size.width + "px;height:" + size.height + "px;"):"width:auto;height:auto;";
            img.onload = function(){
                var canvas = document.createElement("canvas");
                var ctx = canvas.getContext("2d");
                var w = img.width;
                var h = img.height;
                canvas.width = w;
                canvas.height = h;
                ctx.drawImage(img, 0, 0, w, h);
                var base64 = canvas.toDataURL(file.type, quality);
                def.resolve(base64);
            };
            return def;
        },
        upload:function(fileInput){
            var data = new FormData();
            if(fileInput&&(fileInput.files&&fileInput.files.length||fileInput.file||fileInput.value)){
                return this._upload(fileInput.files[0]);
            }else{
                var binary = atob((fileInput.substr(fileInput.indexOf(",")+1)).replace(/\s/g, ''));
                var len = binary.length;
                var buffer = new ArrayBuffer(len);
                var view = new Uint8Array(buffer);
                for(var i = 0; i < len;i++){
                    view[i] = binary.charCodeAt(i);
                }
                var file = new Blob([view],{type:"image/jpg"});
                return this._upload(file);
            }
        },
        _upload:function(file){
            var data = new FormData();
            data.append("cq_file",file);
            return xhr.post(this.getBaseUrl()+"/upload",{
                data:data,
                handleAs:"json"
            });
        }
        
        
        //选择图片、选择大小、上传文件的接口，准确的图片的规格
        
        //选择图片、压缩图片、上传文件的接口，固定宽高、最大宽度高度固定、最大高度宽度固定、最大大小
        
        //选择文件、上传文件的接口，任何文件，不做任何处理直接上传 
    });
    var blob = new BlobItem();
    lang.setObject("cq.biz.blob.blob",blob);
    return blob;
});