define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "cq/biz/object",
    "cq/util/config/config",
    "./socket"
],function(declare, lang, connect, object, config, socket){
    var O = declare("", object.Schema, {
        modalName:"im/channel_msg",
        save:function(item){
            return this.execInCurrentShop("save",this.filterSaveData(item));
        },
        getLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        saveToPlatform:function(item){
            item = this.filterSaveData(item);
            item.shopId = config.getPlatformShopId();
            return this.exec("save",item);
        },
        getPlatformLoadUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
        },
        join:function(roomId){
            try{
                socket.join(roomId);
            }catch(e){
                console.log("Socket链接异常");
            }
        },
        leave:function(roomId){
            try{
                socket.leave(roomId);
            }catch(e){
                console.log("Socket链接异常");
            }
        },
        onLiveMsg:function(msg){
        },
        onDiscussMsg:function(msg){
        }
    });
    var o = new O();
    connect.connect(socket, "onMsg", function(msg){
        if(msg.src == "channelMsg"){
            if(msg.msg.isHost){
                o.onLiveMsg(msg.msg);
                o.onDiscussMsg(msg.msg);
            }else{
                o.onDiscussMsg(msg.msg);
            }
        }
    });
    lang.setObject("cq.biz.im.channelMsg", o);
    o.Schema = O;
    return o;
});