define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "cq/biz/object",
    "cq/biz/user/user",
    "./socket"
],function(declare, lang, connect, object, user, socket){
    //用户会话消息列表相关接口：加载、发送、接受新消息
    var O = declare("", object.Schema, {
        modalName:"im/msg",
        //当前房间，当前登录用户的userId
        currentRoom:"",
        //发送新消息
        sendToUser:function(param){
            return this.execInCurrentShop("send_to_user",param);
        },
        //加载当前人的所有消息，暂时没有用
        getMsgHistoryUrl:function(){
            return this.getBaseUrl()+"/load_by_user?shopId="+this.getShopId();
        },
        //保存消息并广播, 必须传入shopId、receiverId、senderId
        save:function(params){
          return this[params.shopId?"exec":"execInCurrentShop"]("save", params);
        },
        //获取指定两人会话的消息历史的地址
        //加载指定的会话消息, 必须传入shopId、userId、userId2，其余可选
        getSvcMsgUrl:function(){
            return this.getBaseUrl()+"/load_specified_chat_msg";
        },
        join:function(){
            if(this.currentRoom){
                socket.leave(this.currentRoom);
            }
            this.currentRoom = user.getCurrentUserId();
            socket.join(this.currentRoom);
        },
        //对象创建之后的初始化
        init:function(){
            //加载指定的会话消息    张金鹏，2016/07/20
            this.join();
			//用connect对象的subscribe方法去判断是否登陆，登录则加载指定的会话消息    张金鹏，2016/07/20
            connect.subscribe("/cq/biz/user/user/hasLogin",lang.hitch(this,function(success){
                if(success){
                    this.join();
                }
            }));
            //侦听新消息    张金鹏，2016/07/20
            connect.connect(socket,"onMsg",this,function(msg){
                if(msg.src==="SVCMsg"){
                    msg = msg.msg;
                    this.onShowMsg(msg);
                    this.onPenddingMsg(msg);
                    this.onPenddingNum(msg);
                }
            });
        },
        //新消息，会话详情的处理
        onShowMsg:function(msg){
            
        },
        //新消息，会话列表的处理
        onPenddingMsg:function(msg){
            
        },
        //新消息，未读会话数量的处理
        onPenddingNum:function(msg){
            
        }
    });
    //创建消息对象
    var o = new O();
    //消息对象的初始化
    o.init();
    lang.setObject("cq.biz.im.msg", o);
    o.Schema = O;
    return o;
});