﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "./socket",
    "cq/biz/object",
    "cq/biz/user/user",
    "cq/biz/im/msg",
    "cq/util/config/config",
    "cq/biz/shop/shop"
],function(declare, lang, connect, socket, object, user, msg, config, shop){
    var O = declare("", object.Schema, {
        modalName:"im/msg_p",
        initPenddingMsg:function(senderId,receiverId,shopId){
            var params = {
                senderId:senderId,
                receiverId:receiverId,
                shopId:shopId||this.getShopId(),
                msgCount:0,
                lastMsg:""
            };
            return this.exec("income_msg",params);
        },
        loadByReceiver:function(){
            return this.execInCurrentShop("load",{});
        },
        getPendingUrl:function(){
            return this.getBaseUrl()+"/load_to_user?shopId="+this.getShopId();
        },
		onPenddingMsgChanged:function(num){
		},
		//获取和指定商家客服对话的信息
        getSvcInfo:function(shopId){
            //解决的问题：
            //  确保当前用户在目标商家有信息——客服能够看到在和谁对话
            //  获取目标商家的客服人员，确保进入对话页面时第二个参数正确
            return this.exec("get_svc_info",{
                shopId:shopId,
                fromShopId:this.getShopId(),
                userId:user.getCurrentUserId()
            });
        },
        penddingSenders:{},
		//若对应人在有未读消息的人的清单中，从清单中删除，重算数量   张金鹏，2016/07/21
		onReadPenddingMsg:function(senderId){
            if(this.penddingSenders[senderId]){
                delete this.penddingSenders[senderId];
                this.updatePenddingMsg();
            }
		},
		//更新未读消息数量    张金鹏，2016/07/21
		updatePenddingMsg:function(){
            var num = 0;
            for(var sender in this.penddingSenders){
                if(sender){
                    num = num+1;
                }
            }
            this.onPenddingMsgChanged(num);
        },
        init:function(){
            //侦听msg中的事件，更新有未读消息的人的清单，若人有变化，重算数量    张金鹏，2016/07/21
            connect.connect(msg,"onPenddingMsg",this,function(msg){
                var senderId = msg.senderId;
                senderId = senderId&&senderId._id;
                if(senderId&&true!==msg.isRead){
                    this.penddingSenders[senderId] = 1;
                }
                this.updatePenddingMsg();
            });
        },
        clearMsgCount : function(senderId, receiverId){
            return this.execInCurrentShop("clear_msg_count", {
                senderId : senderId,
                receiverId : receiverId
            });
        }
    });
    var o = new O();
    o.init();
    lang.setObject("cq.biz.im.msg_p", o);
    o.Schema = O;
    return o;
});