﻿//负责和服务器端的及时通讯的模块，是一个单例

//提供的方法：
//加入指定房间——通常是一个直播室或者两个人的一个会话
//join(roomId)
//退出一个房间——通常是切换到了另外一个直播室或和另一个人的会话
//leave(roomId)
//收到服务器端推送来的消息，提送收到的消息，谁对哪些信息感兴趣本对象不关心
//onMsg(msg)
define([
    "dojo/_base/lang",
    "cq/widgets/socket/SocketIO"
],function(lang, SocketIO){
    var reconnectTimer = null,nextTry = function(){
        clearTimeout(reconnectTimer);
        reconnectTimer = setTimeout(function(){
            o.socket.connect();
            nextTry();
        },3000);
    };
    var o = {
        socket:null,
        roomIds:{},
        init:function(){
            try{
                this.socket = new SocketIO();
                this.socket.on("msg", lang.hitch(this,function(msg){
                    this.onMsg(msg);
                }));
                this.socket.on("disconnect", lang.hitch(this, function(){
                    nextTry();
                }));
                this.socket.on("connect", lang.hitch(this, function(){
                    for(var roomId in this.roomIds){
                        this.join(roomId);
                    }
                    clearTimeout(reconnectTimer);
                }));
                this.socket.on("reconnect", lang.hitch(this, function(){
                    for(var roomId in this.roomIds){
                        this.join(roomId);
                    }
                    clearTimeout(reconnectTimer);
                }));
            }catch(e){
                console.log("Socket链接错误，" + e);
            }
        },
        join:function(roomId){
            if(roomId){
                this.roomIds[roomId] = 1;
                if(this.socket&&this.socket.connected){
                    this.socket.emit("join", roomId);
                }
            }
        },
        leave:function(roomId){
            delete this.roomIds[roomId];
            if(this.socket&&this.socket.connected){
                this.socket.emit("leave", roomId);
            }
        },
        onMsg:function(msg){
        }
    };
    lang.setObject("cq.biz.im.socket", o);
    o.init();
    return o;
});