define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
],function(declare,lang,object,config){
    var ShopActionLog = declare("",object.Schema,{
        modalName:"log/shop_action_log",
        save:function(logData){
            logData.shopId = config.getPlatformShopId();
            logData.fromShopId = this.getShopId();
            return this.exec("save",logData);
        },
        load:function(param){
            return this.exec("load",param).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.items){
                    return data.data.items;
                } else {
                    return [{remark: "暂无动态"}];
                }
            }));
        }
    });
    var shopActionLog = new ShopActionLog();
    lang.setObject("cq.biz.log.shopActionLog",shopActionLog);
    return shopActionLog;
});