define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, array, json,Deferred, lang, object){
    var O = declare("", object.Schema, {
        modalName:"mat/group",
        loadById:function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        save:function(data){
            return this.execInCurrentShop("save", data);
        },
        getGroupUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        loadAsBoxes:function(){
            var def =new Deferred();
            this.execInCurrentShop("load").then(lang.hitch(this,function(data){
                for(var i=0;i<data.data.items.length;i++){
                    data.data.items[i].icon=data.data.items[i].logo;
                    data.data.items[i].title=data.data.items[i].gName;
                    data.data.items[i].url="#matList-"+data.data.items[i]._id;
                }
                def.resolve(data.data.items);
            }));
            return def;
        },
        load:function(param){
            if(!param.shopId){
                param.shopId = this.getShopId();
            }
           //param obj
           return this.exec("load",param);
        },
        // 用于获得数据避免在网页端发出两个shopId
        getUrlByGroup:function(condition){
            return this.getBaseUrl()+"/load";
        },
    });
    var o = new O();
        lang.setObject("cq.biz.mat.group", o);
        o.Schema = O;
        return o;
})