//变更人:冉伟
//变更时间:2016/6/28
//变更原因:将Div元素改为Span元素，使名称和价格在同一行
//变更人:冉伟
//变更时间:2016/6/30
//变更原因:消费者端商品区域显示图片\名称\规格\价格,其中,商品名称独占两行,超过部分直接…,规格\价格显示一行,规格显示在前
// 变更人：干劲
// 变更日期：20160911
// 变更原因：B2B商品的上下架要通知下游商家
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "cq/biz/object",
    "dojo/Deferred",
    "cq/widgets/item/itemProp",
    "cq/util/config/config"
], function (declare, array, json, lang, object, Deferred, itemProp, config) {
    var O = declare("", object.Schema, {
        modalName: "mat/mat",
        //商品详情
        loadById: function (id, shopId) {
            var params = {
                _id: id
            };
            if (shopId) {
                params.shopId = shopId;
                return this.exec("load_by_id", params);
            } else {
                return this.execInCurrentShop("load_by_id", params);
            }
        },
        //购物车
        loadByIds: function (ids, shopId) {
            var i = ids.length;
            while (i--) {
                if (!ids[i]) {
                    ids.splice(i, 1);
                }
            }
            if (ids.length) {
                if (shopId) {
                    return this.exec("load_by_ids", {
                        ids: ids,
                        shopId: shopId
                    });
                } else {
                    return this.execInCurrentShop("load_by_ids", {
                        ids: ids
                    });
                }
            } else {
                return this.defTest({
                    data: {
                        ok: 1,
                        items: []
                    }
                });
            }
        },
        // params必须传farmer，其余的参数可选
        loadByFarmerId: function (params) {
            return this.execInCurrentShop("load_by_farmer_id", params);
        },
        //加载农户列表
        getLoadByFarmerUrl: function () {
            return this.getBaseUrl() + "/load_by_farmer_id?shopId=" + this.getShopId();
        },
        //商品详情
        loadPublicById: function (id, shopId) {
            return this.exec("load_by_id", shopId ? {
                _id: id,
                shopId: shopId
            } : {
                _id: id
            });
        },
        //通过品类取商品
        loadByType: function (type, page) {
            var hash = {
                type: type ? type : ""
            };
            if (page) {
                hash.pageSize = page.pageSize ? page.pageSize : "";
                hash.pageIndex = page.pageIndex ? page.pageIndex : "";
                hash.orderBy = page.orderBy ? page.orderBy : "";
            }
            return this.exec("load_by_type", hash);
        },
        loadOnSale: function (pageSize, pageIndex) {
            //TODO 这个接口的用途？？？？测试？
            return this.defTest([{
                logo: "images/icons/mat.png",
                mName: "酉州乌羊",
                totalSale: 1250,
                qty: 60
            }, {
                logo: "images/icons/mat.png",
                mName: "酉州乌羊",
                totalSale: 1250,
                qty: 60
            }]);
        },
        add: function (item) {
            return this.exec("add", item);
        },
        //保存商品信息
        save: function (data) {
            // data = this.filterSaveData(data);
            // return this.execInCurrentShop("save",{data:JSON.stringify(data)});
            return this.execInCurrentShop("save", data);
        },
        getOnSaleUrl: function (shopId) {
            return this.getBaseUrl() + "/load_mat?shopId=" + (shopId || this.getShopId());
        },
        //平台商品
        getPlatformOnSaleUrl: function () {
            return this.getBaseUrl() + "/load_mat?shopId=" + config.getPlatformShopId();
        },
        getCurrentShopOnSaleUrl: function () {
            return this.getBaseUrl() + "/load_mat?fromShopId=" + this.getShopId() + "&shopId=" + this.getShopId();
        },
        getUrlByShop: function (condition) {
            return this.getBaseUrl() + "/load_mat";
        },
        getByShopUrl: function (shopId) {
            return this.getBaseUrl() + "/load_mat?shopId=" + (shopId);
        },
        getRecMat: function () {
            return this.getBaseUrl() + "/load_rec_mat?shopId=" + this.getShopId();
        },
        loadRecMat: function (params) {
            if (!params) {
                params = {};
            }
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            return this.exec("load_rec_mat", params);
        },
        getOnSaleByShop: function (condition) {
            return this.exec("load_mat", condition);
        },
        loadAsBoxes: function (params) {
            var def = new Deferred();
            this.execInCurrentShop("load_mat", params).then(lang.hitch(this, function (data) {
                itemProp.initMatBox(data);
                def.resolve(data.data.items);
            }));
            return def;
        },
        loadRevillagerAsBoxes: function (params) {
            var def = new Deferred();
            params.shopId = params.shopId || this.getShopId();
            this.execInCurrentShop("load_mat", params).then(lang.hitch(this, function (data) {
                itemProp.initReVillagerMatBox(data);
                def.resolve(data.data.items);
            }));
            return def;
        },
        setRecommend: function (params) {
            return this.execInCurrentShop("rec_mat", params);
        },
        //加载推荐商品
        loadRecommendMat: function (params) {
            var def = new Deferred();
            this.execInCurrentShop("load_rec_mat", params).then(lang.hitch(this, function (data) {
                itemProp.initMatBox(data);
                def.resolve(data.data.items);
            }));
            return def;
        },
        //查询商品的粉丝数, 传参:shopId、mId
        loadFansNum: function (params) {
            return this.exec("load_fans_num", params);
        },
        //加入采购清单
        b2bAdd: function (params) {
            return this.execInCurrentShop("b2b_add", params);
        },
        //停止采购
        b2bRemove: function (params) {
            return this.execInCurrentShop("b2b_remove", params);
        },
        //上架商品
        b2bOnShelf: function (params) {
            params.platformShopId = config.getPlatformShopId()
            return this.execInCurrentShop("b2b_on_shelf", params);
        },
        //下架商品
        b2bOffShelf: function (params) {
            return this.execInCurrentShop("b2b_off_shelf", params);
        },
        //检查编码重复性
        checkCodeRepeat: function (code) {
            return this.execInCurrentShop("check_mat_repetition", {
                code: code
            });
        },
        // 依据标准分类ID查询商品
        loadBySort: function (params) {
            if (!params) {
                params = {};
            }
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            return this.execInCurrentShop("load_by_sort", params);
        },
        //通过sort加载商品列表
        getLoadBySortUrl: function () {
            return this.getBaseUrl() + "/load_by_sort?shopId=" + this.getShopId();
        },
        // 通过ids上架或者下架商品
        // matUpOrDownByIds: function(params) {
        //     if (!params.shopId) {
        //         params.shopId = this.getShopId();
        //     }
        //     if (!params.isUse) {
        //         params.isUse = false;
        //     }
        //     params.ids = JSON.stringify(params.ids);
        //     return this.execInCurrentShop("mat_up_or_down_by_ids", params);
        // },
        // 上架商品并通知下游商家
        b2bMatUpByIds: function (params) {
            // if (!params.shopId) {
            // params.shopId = this.getShopId();
            // }
            // params.ids = JSON.stringify(params.ids);
            // return this.execInCurrentShop("b2b_mat_up_by_ids", params);
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            if (!params.platformShopId) {
                params.platformShopId = config.getPlatformShopId();
            }
            //params.ids = JSON.stringify(params.ids);
            return this.exec("b2b_mat_up_by_ids", params);
        },
        // 下架商品并通知下游商家
        b2bMatDownByIds: function (params) {
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            //params.ids = JSON.stringify(params.ids);
            return this.execInCurrentShop("b2b_mat_down_by_ids", params);
        },
        // 给多个选项设置品类
        setGroupByIds: function (params) {
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            //params.ids = JSON.stringify(params.ids);
            return this.execInCurrentShop("set_group_by_ids", params);
        },
        // 通过传递id 确认商家商品
        platVerify: function (params) {
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            return this.execInCurrentShop("plat_verify", params);
        },
        // 提交审核
        submitVerify: function (id) {
            var params = {};
            params.shopId = this.getShopId();
            params.fromShopId = config.getPlatformShopId();
            params._id = id;
            return this.exec("submit_verify", params);
        },
        // 商品上架
        matUseUpByIds: function (params) {
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            //params.ids = JSON.stringify(params.ids);
            return this.execInCurrentShop("mat_up_by_ids", params);
        },
        // 商品下架
        matUseDownByIds: function (params) {
            if (!params.shopId) {
                params.shopId = this.getShopId();
            }
            //params.ids = JSON.stringify(params.ids);
            return this.execInCurrentShop("mat_down_by_ids", params);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.mat.mat", o);
    o.Schema = O;
    return o;
});