define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
], function(declare, lang, object) {
    var Discount = declare("", object.Schema, {
        modalName: "mk/discount",
        //查询当前商家的优惠活动
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        //用户自领优惠券
        //参数: _id，shopId
        getCouponByUserSelf: function(params) {
            return this.exec("get_coupon_by_user_self", params);
        },
        //网站用户自领优惠券
        //参数: _id
        getB2BCouponByUserSelf: function(params) {
            return this.exec("get_coupon_by_user_self", params);
        },
        //获取可用优惠活动
        loadAvailableByUserSelf: function() {
            return this.getBaseUrl() + "/load_available_by_user_self?shopId=" + this.getShopId();
        },
        //获取可用优惠活动
        loadAvailableByUserSelfThen: function(params) {
            return this.exec("load_available_by_user_self", params);
        },
        //网站获取可用优惠活动
        loadB2BAvailableByUserSelf: function(params) {
            return this.exec("load_available_by_user_self", params);
        },
        // 保存创建的活动
        save: function(params) {
            return this.execInCurrentShop("save", params);
        },
        // 加载指定的id内容
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", { _id: id });
        },
		// 停用优惠活动
		disableById: function(id) {
            return this.execInCurrentShop("disable_by_id", { _id: id });
        }
    });
    var discount = new Discount();
    lang.setObject("cq.biz.mk.discount", discount);
    return discount;
});
//保存
