define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/Deferred",
    "cq/util/config/config",
    "dojo/topic"
],function(declare,array,json,lang,xhr,Deferred,config,topic){
    var O = declare("",null,{
        modalName:"object",
        __shopId:null,
        // 赵春辉，保存时经常出现引用导致向服务器发送请求时字段为[object.object]
        // 提供一个方法统一处理这个问题，保存接口通过本接口过滤，开发者就不用考虑这个问题了
        filterSaveData:function(data){
            for(var field in data){
                if(data[field]&&data[field]._id){
                    data[field] = data[field]._id;
                }
            }
            delete data._v;
            return data;
        },
        getBaseUrl:function(){
            return config.getDataOrigin()+"/biz/" + this.modalName;
        },
        getShopId:function(){
            if(!this.__shopId){
                O.prototype.__shopId = config.shopId;
            }
            return this.__shopId;
        },
        replaceNull:function(param){
            if(param){
                if(-1<Object.prototype.toString.call(param).indexOf("Array")){
                    for(var i=0;i<param.length;i++){
                        if(!param[i]){
                            if(0!==param[i]&&false!==param[i]){
                                param[i] = "__n";
                            }
                        }else if("object"===typeof(param[i])){
                            this.replaceNull(param[i]);
                        }
                    }
                }else if(typeof(param)==="object"){
                    for(var field in param){
                        if(!param[field]){
                            if(0!==param[field]&&false!==param[field]){
                                param[field] = "__n";
                            }
                        }else if("object"===typeof(param[field])){
                            this.replaceNull(param[field]);
                        }
                    }
                }
            }
        },
        exec:function(action, param){
            var def = new Deferred();
            param = lang.clone(param);
            this.replaceNull(param);
            paramSend = param;
            paramSend = {};
            paramSend.__ds = JSON.stringify(param);
            xhr("POST",{
                url:config.getDataOrigin()+"/biz/" + this.modalName + "/" + action,
                handleAs:"json",
                sync: false,
                preventCache: true,
                content: paramSend,
                load:function(data1){
                    var data={data:[]};
                    data.data=data1;
                    def.resolve(data);
                },
                error:function(err){
                    def.resolve(err);
                }
            });
            return def;
        },
        execInCurrentShop:function(action,param){
            param = param||{};
            param.shopId = this.getShopId();
            return this.exec(action,param);
        },
        //调用指定对象的方法
        execByModal:function(modalName,action,param){
            var def = new Deferred();
            xhr("POST",{
                url:config.getDataOrigin()+"/biz/" + modalName + "/" + action,
                handleAs:"json",
                sync: false,
                preventCache: true,
                content: param,
                load:function(data1){
                    var data={data:[]};
                    data.data=data1;
                    def.resolve(data);
                },
                error:function(err){
                    def.resolve(err);
                }
            });
            return def;
        },
        //在当前店铺调用指定对象的方法
        execByModalInCurrentShop:function(modalName,action,param){
            param = param||{};
            param.shopId = this.getShopId();
            return this.execByModal(modalName,action,param);
        },
        //用于测试def
        defTest:function(data){
            var def = new Deferred();
            setTimeout(function(){
                def.resolve(data);
            },100);
            return def;
        }
    });
    if(config.shopId){
        O.prototype.__shopId = config.shopId;
    }
    topic.subscribe("whz/shop/changed",function(shop){
        O.prototype.__shopId = shop._id;
    });
    var o = new O();
    lang.setObject("cq.biz.object",o);
    o.Schema = O;
    return o;
});