define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
],function(declare, lang, object){
    var O = declare("", object.Schema, {
        modalName:"shop/bs/district",
        //仅供测试使用，后期删除
        findOne:function(){
            return this.exec("load",{
                pageSize:1,
                pageIndex:1
            });
        },
        //加载全部数据
        load : function(){
            return this.exec("load");
        },
        //根据level加载
        loadByLevel : function(level){
            return this.exec("load_by_level", {
                level : level
            });
        },
        //根据distName加载
        loadByName : function(distName){
            return this.exec("load_by_name", {
                distName : distName
            });
        },
        //根据distName进行模糊查询
        loadByFuzzyName : function(distName){
            return this.exec("load_by_fuzzy_name", {
                distName : distName
            });
        },
        //根据_id加载
        loadById : function(id){
            return this.exec("load_by_id",{
                _id : id
            });
        },
        //根据_id加载
        loadByOldid : function(oldId){
            return this.exec("load_by_oldid",{
                oldId : oldId
            });
        },
        //根据上层的upDistId来加载
        loadByUpId : function(upDistId){
            return this.exec("load_by_up_id",{
                upDistId : upDistId
            });
        },
        //获取依据上级加载的url，若不传上级id，表示参数要使用时自己传
        getLoadByUpIdUrl : function(upDistId){
            return this.getBaseUrl() + "/load_by_up_id?"+(upDistId?"upDistId=" + upDistId:"");
        },
        getPCCByName:function(params){
            return this.exec("get_pcc_by_name",params);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.bs.district", o);
    o.Schema = O;
    return o;
});