// 创建人：赵春辉
// 内容：提供操作辅助资料的js接口
// 创建日期：2016-06-03
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
], function (declare, lang, object, config) {
    var Parameter = declare("", object.Schema, {
        modalName: "shop/bs/parameter",
        // 保存辅助资料的接口，每个商家只能保存到本伤害数据库
        save: function (data) {
            return this.execInCurrentShop("save", data);
        },
        // 查询辅助资料，通常用于修改，只能查询本商家数据库中的信息
        loadById: function (id) {
            return this.execInCurrentShop("load_by_id", {
                _id: id
            });
        },
        // 从当前商家数据库中查询辅助资料信息，用于平台维护辅助资料的查询界面
        getLoadUrl: function () {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        // 加载平台的辅助资料信息，用于所有商家(包括平台)编辑商品时选择辅助资料
        getPlatformLoadUrl: function () {
            return this.getBaseUrl() + "/load?shopId=" + config.getPlatformShopId();
        },
        //加载平台的辅助资料信息
        loadPlatform: function (params) {
			if(!params){
				var params={};
			}
			params.shopId = config.getPlatformShopId();
            return this.exec("load", params);
        }
    });
    var parameter = new Parameter();
    lang.setObject("cq.biz.shop.bs.parameter", parameter);
    return parameter;
});