define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/biz/user/user",
    "cq/util/config/config"
],function(declare, lang, object, user, config){
    var O = declare("", object.Schema, {
        modalName:"shop/cm/mat_store",
        //查询当前userId关注了哪些商品
        load : function (){
            return this.exec("load", {
                shopId : config.getPlatformShopId(),
                userId : user.getCurrentUserId()
            });
        },
        //关注商品，传参：mId
        matStore : function (params) {
            return this.exec("mat_store", {
                shopId : config.getPlatformShopId(),
                mId : params.mId,
                userId : user.getCurrentUserId()
            });
        },
        //取消关注，传参：mId
        matStoreCancel : function (params) {
            return this.exec("mat_store_cancel", {
                shopId : config.getPlatformShopId(),
                mId : params.mId,
                userId : user.getCurrentUserId()
            });
        },
        //检查商品是否已经被收藏, 传参:mId
        checkMatStore:function (params) {
            return this.exec("check_mat_store", {
                shopId : config.getPlatformShopId(),
                mId : params.mId,
                userId : user.getCurrentUserId()
            });
        },
        // 获取当前用户关注的商家列表
        getShopListUrl:function(){
            return this.getBaseUrl() + "/load?shopId=" + config.getPlatformShopId() + "&userId=" + user.getCurrentUserId();
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.cm.matStore", o);
    o.Schema = O;
    return o;
});
