define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/biz/user/user",
    "cq/util/config/config"
],function(declare, lang, object, user, config){
    var O = declare("", object.Schema, {
        modalName:"shop/cm/shop_store",
        //查询当前userId关注了哪些商家
        load : function (param){
            param = lang.mixin(param||{},{
                shopId : config.getPlatformShopId(),
                userId : user.getCurrentUserId()
            });
            
            return this.exec("load",param);
        },
        //判断是否已关注商家
        hasStored:function(shopId){
            return this.exec("load",{
                shopId:config.getPlatformShopId(),
                targetShopId:shopId,
                userId:user.getCurrentUserId()
            }).then(function(data){
                return (data&&data.data&&data.data.items&&data.data.items.length)>0
            });
        },
        //关注商家，传参：targetShopId
        shopStore : function (params) {
            return this.exec("shop_store", {
                shopId : config.getPlatformShopId(),
                targetShopId : params.targetShopId,
                userId : user.getCurrentUserId()
            });
        },
        //取消关注，传参：targetShopId
        shopStoreCancel : function (params) {
            return this.exec("shop_store_cancel", {
                shopId : config.getPlatformShopId(),
                targetShopId : params.targetShopId,
                userId : user.getCurrentUserId()
            });
        },
        // 获取当前用户关注的商家列表
        getShopListUrl:function(){
            return this.getBaseUrl() + "/load?shopId=" + config.getPlatformShopId() + "&userId=" + user.getCurrentUserId();
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.cm.shopStore", o);
    o.Schema = O;
    return o;
});