define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config",
    "dojo/Deferred"
], function (declare, lang, object, config, Deferred) {
    var O = declare("", object.Schema, {
        modalName: "shop/shop_user",
        //保存用户
        save: function (param) {
            param.platformShopId = config.getPlatformShopId();
            return this.execInCurrentShop("save", this.filterSaveData(param));
        },
        //删除当前商家的指定用户——管理员
        deleteByUser: function (userId) {
            return this.execInCurrentShop("delete_by_shop_and_user", {
                userId:userId,
                platformShopId:config.getPlatformShopId()
            });
        },
        //加载指定商家的所有管理人员
        loadUsers: function () {
            return this.getBaseUrl() + "/load_users_by_shop?shopId=" + this.getShopId()+"&platformShopId="+config.getPlatformShopId();
        },
		// 加载指定商家指定人员
		loadById : function(param){
			param.platformShopId = config.getPlatformShopId();
			return this.execInCurrentShop("load_by_shop_and_user", param);
		},
        // 根据userid找shopid
        loadShopByUser: function(param){
            param.platformShopId = config.getPlatformShopId();
            return this.exec("load_shops_by_user", param);
        },
        // 获取当前用户的shopId
        getShopIdByNone: function(){
            return this.getShopId();
        }
    });
    var o = new O();
    lang.setObject("cq.biz.shop.shop_user", o);
    o.Schema = O;
    return o;
});