define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/topic"
], function(lang, array, json, topic){
    return lang.mixin(lang.getObject("cq.biz.ts.cart", true),{
        add:function(mid, qty){
            var orderCar = this.get();
            orderCar[mid] = (orderCar[mid]||0) + parseInt(qty)||1;
            this.set(orderCar);
        },
        set:function(car){
            localStorage.setItem(window.code + "order", json.toJson(car));
            topic.publish("cq/biz/ts/cart/numChanged",this.getNum());
        },
        get:function(){
             return json.fromJson(localStorage.getItem(window.code + "order") || "{}");
        },
        getIds:function(){
             var cart = json.fromJson(localStorage.getItem(window.code + "order") || "{}");
             var data=[];
             for(var id in cart){
                 data.push(id);
             }
             return data;
        },
        getAsArray:function(){
             var cart = json.fromJson(localStorage.getItem(window.code + "order") || "{}");
             var data=[];
             for(var id in cart){
                 data.push({mid:id,qty:cart[id]});
             }
             return data;
        },
        clear:function(mids){
            var car = this.get();
            if(mids){
                array.forEach(mids, function(mid){
                    delete car[mid];
                });
            }else{
                car = {};
            }
            this.set(car);
        },
        setSelected:function(selectedIds){
            localStorage.setItem(window.code + "selected", json.toJson({mids:selectedIds}));
        },
        getSelected:function(){
            var cart = json.fromJson(localStorage.getItem(window.code + "selected"));
            mids = cart&&cart.mids||[];
            return mids;
        },
        getSelectedChart:function(){
            var sMids = this.getSelected();
            var cart = this.get();
            var chart = {};
            array.forEach(sMids, function(mid){
                chart[mid] = cart[mid];
            });
            return chart;
        },
        getNum:function(){
            var car = this.get();
            var num=0;
            for(var item in car){
                num+=car[item];
            }
            return num;
        },
        //需要对应商品的shopId的相关接口 
        //保存相应的的shopId
        //保存商品的id对应的数量qty和shopId
        addByShop:function(shopId,mid,qty){
            var orderCar = this.get();
            var orderCarshop =this.getShopIdAndMid();
            orderCar[mid] = (orderCar[mid]||0) + parseInt(qty)||1;
            orderCarshop[mid] = shopId;
            this.set(orderCar);
            this.setShopIdAndMid(orderCarshop);
        },
        setShopIdAndMid:function(shopMatMap){
            localStorage.setItem(window.code+"orderShop",json.toJson(shopMatMap));
        },
        getShopIdAndMid:function(){
            return json.fromJson(localStorage.getItem(window.code+"orderShop")||"{}");
        },
        clearShop:function(mids){
            var car = this.get();
            var carShop = this.getShopIdAndMid()
            if(mids){
                array.forEach(mids, function(mid){
                    delete car[mid];
                    delete carShop[mid];
                });
            }else{
                car = {};
                carShop = {};
            }
            this.set(car);
            this.setShopIdAndMid(carShop);
        }
    });
});