﻿// 变更人: 赵春辉
// 变更日期: 2016-11-13
// 变更原因: 项目保存、审批、申请的审核都应该在自己的数据库中完成
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/biz/object"
],function(declare, lang, config,object){
    var O = declare("", object.Schema, {
        modalName:"ts/pm/project",
        //保存项目
        saveProject:function(data){
            data.fromShopId = this.getShopId();
            data.state = 0;
            data.projectType = 1;
            //this.filterSaveData(data);
            //连同附件一起保存
            return this.execInCurrentShop("save_project",{
                //shopId:config.getPlatformShopId(),
                //data:JSON.stringify(data)
                data : data
            });
        },
        //保存申请
        saveApply:function(data){
            data.fromShopId = this.getShopId();
			//提交申请和申请驳回时的保存
            if(data.state!=13){
				data.state = 0;	
			//验收驳回时的保存
			}else if(data.state=13){
				data.state=11;
			}
            data.projectType = 2;
            //this.filterSaveData(data);
            //连同附件一起保存
            return this.exec("save_apply",{
                shopId:config.getPlatformShopId(),
                //data:JSON.stringify(data)
                data : data
            });
        },
		//修改state为15(申请验收通过)
		examinePass:function(id){
			return this.execInCurrentShop("examine_pass",{
                _id : id//,
                //shopId:config.getPlatformShopId()
            });
		},
		//修改state为14(申请验收拒绝)
		examineNopass:function(id){
			return this.execInCurrentShop("examine_nopass",{
                _id : id//,
                //shopId:config.getPlatformShopId()
            });			
		},
		//修改state为13(申请验收驳回)
		examineReject:function(id){
			return this.execInCurrentShop("examine_reject",{
                _id : id//,
                //shopId:config.getPlatformShopId()
            });			
		},
		//修改state为11(申请待验收)
		examineWaiting:function(id,options){
			var param = {
                _id : id//,
                //shopId:config.getPlatformShopId()
            };
			if(options && options.actInvestments) param.actInvestments = options.actInvestments;
			if(options && options.result) param.result = options.result;
			return this.execInCurrentShop("examine_waiting",param);			
		},
        //依据id加载项目
        loadById:function(id){
            return this.exec("load_by_id",{
                _id:id,
                shopId:config.getPlatformShopId()
            });
        },
        //项目审核通过
        verifyById:function(id){
            return this.execInCurrentShop("verify_by_id",{
                _id:id//,
                //shopId:config.getPlatformShopId()
            });
        },
        //项目审核撤销
        cancelById:function(id){
            return this.execInCurrentShop("cancel_by_id",{
                _id:id//,
                //shopId:config.getPlatformShopId()
            });
        },
        //项目审核作废
        stopById:function(id){
            return this.execInCurrentShop("stop_by_id",{
                _id:id//,
                //shopId:config.getPlatformShopId()
            });
        },
        // 项目
        getLoadProjectUrl:function(){
            return this.getBaseUrl()+"/load_project?shopId="+config.getPlatformShopId();
        },
        // 申请
        getLoadApplyUrl:function(){
            return this.getBaseUrl()+"/load_apply?shopId="+config.getPlatformShopId();
        },
		//加载申请
        loadMyApply:function(projectId){
            return this.exec("load_apply",{
                shopId:config.getPlatformShopId(),
                srcProjectId:projectId,
                fromShopId:this.getShopId()
            });
        },
        //申请审核通过
        verifyApplyById:function(id,options){
			var params = {
                _id:id//,
                //shopId:config.getPlatformShopId()
            };
			if(options && options.verifiedAmount) params.verifiedAmount = options.verifiedAmount;
			if(options && options.scale) params.scale = options.scale;
			if(options && options.targetUsage) params.targetUsage = options.targetUsage;
            return this.execInCurrentShop("verify_apply_by_id",params);
        },
        //申请审核驳回，需要驳回原因
        rejectApplyById:function(id,reason){
            return this.execInCurrentShop("reject_apply_by_id",{
                _id:id,
                reason:reason//,
                //shopId:config.getPlatformShopId()
            });
        },
        //申请审核拒绝
        refuseApplyById:function(id){
            return this.execInCurrentShop("refuse_apply_by_id",{
                _id:id//,
                //shopId:config.getPlatformShopId()
            });
        },
		
		
		
		
		
        
		//新版接口，有权限控制
        //项目列表都是从平台读取
        getLoadProjectUrlV2:function(){
            return this.getBaseUrl()+"/load_project?shopId="+config.serviceShopId;
        },
        //申请信息都是从当前商家读取
        getLoadApplyUrlV2:function(){
            return this.getBaseUrl()+"/load_apply?shopId="+this.getShopId();
        },
        loadByIdV2:function(_id){
            return this.exec("load_by_id",{
                _id:_id,
                shopId:config.serviceShopId
            });
        },
        saveProjectV2:function(data){
            return this.saveProject(data);
        },
		//依据id加载申请
		loadApplyById:function(id){
			return this.execInCurrentShop("load_apply_by_id",{
				_id:id
			});
		},
		//加载项目信息
		loadProjectByIdV2:function(prjId,targetShopId){
			return this.execInCurrentShop("load_by_id_v2",{
				_id:prjId,
				targetShopId:targetShopId
			});
		},
        loadApplyByIdV2:function(applyId){
            return this.execInCurrentShop("load_by_id_v2",{
                _id:applyId
            });
        },
		//依据项目id加载当前商家发起的申请数据
		loadMyApplyByProjectId:function(prjId){
			return this.execInCurrentShop("load_v2",{
				srcProjectId:prjId,
				fromShopId:this.getShopId()
			}).then(function(data){
				if(data&&data.data&&data.data.items){
					data.data.item = data.data.items[0];
				}
				return data;
			});
		},
        //保存项目申请，先保存到自己的数据库，然后提交到审核方数据库
		saveApplyOnly:function(data){
			return this.execInCurrentShop("save_apply_v2",{data:data});
		},
		submitApply:function(id){
			return this.execInCurrentShop("submit_apply_v2",{
				_id:id
			});
		},
		refuseApply:function(id){
			return this.execInCurrentShop("refuse_apply_v2",{
				_id:id
			});
		},
		rejectApply:function(id,rejectInfo){
			return this.execInCurrentShop("reject_apply_v2",{
				_id:id,
				rejectInfo:rejectInfo
			});
		},
		agreeApply:function(id){
			return this.execInCurrentShop("agree_apply_v2",{
				_id:id
			});
		}
    });
    var o = new O();
    lang.setObject("cq.biz.ts.pm.project", o);
    o.Schema = O;
    return o;
});