//  变更人:肖芳圆
//  变更时间:2016/07/11
//  变更原因: 加载供求信息货架数据的接口
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/config/config",
    "cq/biz/object"
],function(declare, array, json, lang, Deferred, config, object){
    var O = declare("", object.Schema, {
        modalName:"ts/sc/supply_demand",
        //资讯详情
        loadById:function(id){
            return this.execInCurrentShop("load_by_id",{_id:id});
        },
        loadByIdFormPlatform:function(id){
            var params = {};
            params.shopId = config.getPlatformShopId();
            params._id = id;
            return this.exec("load_by_id",params);
        },
        save:function(item){
            return this.execInCurrentShop("save",this.filterSaveData(item));
        },
        load:function(){
            return this.getBaseUrl()+"/load_by_type?shopId="+this.getShopId();
        },
        loadData:function(condition){
            condition.shopId = condition.shopId||this.getShopId();
            return this.exec("load_by_type",condition);
        },
        loadByPlatform: function(){
            return this.exec("load_by_type",{
                shopId: config.getPlatformShopId()
            });
        },
        getPlatformDataUrl:function(){
            return this.getBaseUrl()+"/load_by_type?shopId="+config.getPlatformShopId();
        },
        getTotal:function(){
            return this.exec("get_total",{shopId:config.getPlatformShopId()});
        },
        loadByType:function(params){
            params.shopId = config.getPlatformShopId();
            return this.exec("load_by_type",params);
        },
        loadAsBoxes:function (params) {
            var def =new Deferred();
            params.shopId = config.getPlatformShopId();
			params.isUse = true;
            this.exec("load_by_type",params).then(lang.hitch(this,function (data) {
                var items = data && data.data && data.data.items || [];
                var item;
                for(var i=0;i<data.data.items.length;i++){
                    item = items[i];
                    item.icon = "";
                    items[i].title=''
                    +'<div class="shelf-sd" style="padding:0px 10px 10px 10px;">'
                    +   '<img style="width:70px;border-radius: 50%;" class="shelf-sd-logo" src="'+ (item.fromShopId && item.fromShopId.logo || '/static/sites/mobile/images/logo.png') +'" />'
                    +   '<div>'
                    +       '<p class="shelf-mat-title">' + (item.fromShopId && item.fromShopId.shopName || '匿名') + '</p>'
                    +       '<p class="shelf-mat-title">' + (item.ioType ? "需求：" : "供应：") + '<span class="shelf-sd-product">' + item.product + '</span>' + "*" + item.qty + item.unit + '，价格从' + window.fixedTo(item.minPrice,3) + '~' + window.fixedTo(item.maxPrice,3)  + "/" + item.unit + '，有意者请联系！' + '</p>'
                    +   '</div>'
                    +'</div>';
                    items[i].url = "#supplyDemandDetail-" + item._id;
                }
                def.resolve(data.data.items);
            }));
            return def;
        }
    });
    var o = new O();
    lang.setObject("cq.biz.ts.sc.supply_demand", o);
    o.Schema = O;
    return o;
});
