define([
    "dojo/_base/declare",
    "dojo/_base/array", 
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/cookie", 
    "cq/biz/object", 
    "dojo/Deferred",
    "dojo/topic", 
    "cq/util/config/config"
], function(declare, array, json, lang, cookie, object, Deferred, topic, config) {
    var O = declare("", object.Schema, {
        modalName : "user/user",
        loadById : function(id) {
          return this.execInCurrentShop("load_by_id", {_id : id});
        },
        loadUseByIdAndShop:function(id,shopId){
            return this.exec("load_by_id",{
                _id:id,
                shopId:shopId
            });
        },
        save : function(item) {
          item = this.filterSaveData(item);
          //赵春辉     只有修改时才不能提交用户名   2016-07-13
          if(item._id){
              delete item.userName;
          }
          return this.execInCurrentShop("save", item);
        },
		//20160805:干劲，会员对象不应该提供删除方法。delete是js关键字，会导致IE判断语法错误。
        // deleteUser : function(id) {
          // return this.execInCurrentShop("delete_by_id", {_id : id});
        // },
        load : function(condition) {
          return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        getUserUrl : function() {
          return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        getShopUserUrl:function(){
            return config.getDataOrigin()+"/biz/shop/shop_user/load_shops_by_user?platformShopId=" + config.getPlatformShopId()+"&userId="+this.getCurrentUserId();
        },
        register : function(condition) {
          return this.execInCurrentShop("register_by_password", condition);
        },
        resetPassword : function(condition) {
            condition.shopId = condition.shopId||this.getShopId();
          return this.exec("reset_password", condition);
        },
        loginByPassword : function(userName, password,verifyCode) {
          return this
              .execInCurrentShop("login",
                                 verifyCode?{
									 userName : userName,
									 password : password,
									 verifyCode:verifyCode
								 }:{
									 userName : userName,
									 password : password
								 })
              .then(lang.hitch(this, function(result) {
                if (result.data.ok === 1) {
                  this._onLoginSuccess(result.data.item);
                } else {
                  delete this.userId;
                }
                return result;
              }));
        },
        getUserInfo : function() {
          return this.defTest(
              {data : {ok : this.info ? 1 : 0, item : this.info}});
        },
        getCurrentUserRole:function(){
            return this.info&&this.info.role;
        },
        // 获取当前登录的用户对象
        getUserData : function () {
            return this.info;
        },
        _onLoginSuccess : function(info) {
          this.userId = info._id;
          this.userName = info.userName;
          this.info = info;
          setTimeout(function() {
            topic.publish("/cq/biz/user/user/hasLogin", true);
          }, 100);
        },
        hasLogin : function() {
          if (!this.userId) {
            return this.execInCurrentShop("get_current_user", {})
                .then(lang.hitch(this, function(data) {
                  if (data && data.data && data.data.item &&
                      data.data.item._id) {
                    this._onLoginSuccess(data.data.item);
                  }
                  return !!this.userId;
                }));
          } else {
            var def = new Deferred();
            def.resolve(!!this.userId);
            return def;
          }
        },
        getCurrentUserId : function() { return this.userId; },
        //注销
        logout : function() {
          delete this.userId;
          delete this.info;
          setTimeout(function() {
            topic.publish("/cq/biz/user/user/hasLogin", false);
          }, 100);
          return this.execInCurrentShop("logout", {shopId: this.getShopId()});
          /*var def=new Deferred();
          def.resolve(true);
          return def;*/
        },
        //修改密码，自己依据原密码修改自己的密码
        changePassword : function(password, newPassword) {
          return this.execInCurrentShop("modify_password_by_id", {
            _id : this.userId,
            password : password,
            newPassword : newPassword
          });
        },
        //商家端用户，依据原密码修改自己的密码
        changeMchPassword : function(password, newPassword) {
          return this.exec("modify_password_by_id", {
            _id : this.userId,
            password : password,
            newPassword : newPassword,
            shopId : config.getPlatformShopId()
          });
        },
        //依据客户信息修改客户密码
        changeUserPassword:function(id,userName,password){
            return this.execInCurrentShop("initUser",{
                _id:id,
                userName:userName,
                password:password
            });
        },
        //获取默认地址
        getDefaultAddr : function(shopId) {
          var shopId=shopId?shopId:this.getShopId();
          return this.exec("load_by_id", {_id : this.userId,shopId:shopId})
              .then(lang.hitch(this, function(result) {
                var defaultAddr = {};
                result = lang.clone(result);
                defaultAddr.pName = result.data.item.pName;
                defaultAddr.phone = result.data.item.phone;
                defaultAddr.address = result.data.item.address;
                return defaultAddr;
              }));
        },
        //保存默认地址
        setDefaultAddr : function(item,shopId) {
          item._id = this.getCurrentUserId();
          item.shopId=shopId?shopId:this.getShopId();
          return this.exec("save", item);
        },
        //商家端用户登录
        loginShop : function(userName, password) {
          return this
              .execByModalInCurrentShop("shop/shop", "login", {
                platformShopId : config.getPlatformShopId(),
                userName : userName,
                password : password
              })
              .then(lang.hitch(this, function(data) {
                var result = data.data;
                if (1 === result.ok) {
                  this.userShop = result.item.userShops;
                  this._onLoginSuccess(result.item.user);
                }
                return result;
              }));
        },
        // 返回商家的信息
        getValidShops : function() {
          return array.map(this.userShop || [],
                           function(shopInfo) { return shopInfo; });
        },
        // 扩展获取当前商家列表的接口
        getValidShopLists : function() {
          return this.userShop;

        },
        setCurrentShopId : function(shopId) {
          return this.execByModal("shop/shop", "load_by_id", {shopId : shopId})
              .then(lang.hitch(this, function(data) {
                localStorage.setItem("shopId", data.data._id);
                window.__shop = data.data;
              }));
        },
        setCurrentShop : function(shop) {
          localStorage.setItem("shopId", shop._id);
          // localStorage.setItem("role",shop.role);
          window.__shop = shop;
          topic.publish("whz/shop/changed", shop);
          this.execByModal("shop/shop", "auto_login_to", {
            shopId: config.getPlatformShopId(), 
            targetShopId: shop._id});
        },
        // 商家列表项存储商家对象
        setCurrentShopLists : function(shop) {
            //赵春辉   切换店铺之后确定当前用户的角色，获取用户信息时就可以得到当前用户对应的角色信息
            if(this.info){
                this.info.role = shop.role;
            }
          localStorage.setItem("role", shop.role);
		  this.setCurrentShop(shop.shopId);
        },
        //消费者端我的收入
        loadUserInformation : function(params) {
          if (!params) {
            var params = {};
          }
          params._id = this.userId;
          params.shopId = this.getShopId();
          return this.execInCurrentShop("load_user_information", params);
        },
        loadByWxId : function(wxId) {
          return this.execInCurrentShop("load_by_wxid", {"wxId" : wxId});
        },
        loadByUserName : function(userName) {
          return this.execInCurrentShop("load_by_username",
                                        {"userName" : userName});
        },
        //人气榜
        loadFans : function(params) {
          return this.getBaseUrl() + "/load_by_fans_desc?shopId=" +
                 this.getShopId();
        },
        //爱心榜
        loadLoves : function(params) {
          return this.getBaseUrl() + "/load_by_dis_income_desc?shopId=" +
                 this.getShopId();
        },
        //提现
        exchangeDisAmount : function(params) {
          params.userId = this.getCurrentUserId();
          return this.execInCurrentShop("exchanged_dis_to_amt", params);
        },
        //检查用户名是否重复
        onCheckExist : function(userName) {
          return this.execInCurrentShop("check_user", {userName : userName});
        },
        checkPlatformUser : function(userName) {
          return this.exec(
              "check_user",
              {userName : userName, shopId : config.getPlatformShopId()});
        },
        // 充值
        incamount : function(params) {
          return this.execInCurrentShop("inc_amount_by_id", params);
        },
        // 加载客户分销列表
        getLoadDisCardUrl : function() {
          return this.getBaseUrl() + "/load_discard?shopId=" + this.getShopId();
        },
        getStaffUrl : function() {
          return this.getBaseUrl() + "/load_staff?shopId=" + this.getShopId();
        }
      });
      var o = new O();
      lang.setObject("cq.biz.user.user", o);
      o.Schema = O;
      return o;
});
