define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/biz/user/user",
    "cq/util/config/config"
],function(declare, lang, object, user, config){
    var O = declare("", object.Schema, {
        modalName:"user/user_address",
        save : function(params){
            params.shopId = this.getShopId();
            params.userId = user.getCurrentUserId();
            params = this.filterSaveData(params);
            return this.exec("save", params);
        },
        // 删除指定id的address，调用后台的delete_address方法，需传入id
        deleteById : function(id){
            return this.exec("delete_address",{
                //shopId : config.getPlatformShopId(),
                shopId : this.getShopId(),
                _id : id
            });
        },
        getLoadUrl : function(){
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId() + "&userId=" + user.getCurrentUserId();
        },
        loadUserAddrs : function () {
            return this.execInCurrentShop("load",{userId:user.getCurrentUserId()});
        },
        loadPlatformAddrs : function () {
            return this.exec("load",{
                userId:user.getCurrentUserId(), 
                //shopId : config.getPlatformShopId(),
                shopId : this.getShopId()
            }); 
        },
        setDefault : function(id){
            return this.exec("set_default",{
                //shopId : config.getPlatformShopId(),
                shopId : this.getShopId(),
                _id : id
            });
        },
        loadById : function(id){
            return this.exec("load_by_id",{
                //shopId : config.getPlatformShopId(),
                shopId : this.getShopId(),
                _id : id
            });
        },
        loadDefaultAddress: function(){
            return this.exec("load_default_address",{
                //shopId : config.getPlatformShopId(),
                shopId : this.getShopId(),
                userId : user.getCurrentUserId()
            });
        }
    });
    var o = new O();
    lang.setObject("cq.biz.user.userAddress", o);
    o.Schema = O;
    return o;
});
