﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "./BoBase",
    "dojo/topic", //不依赖的模块
    "cq/util/config/config",//不依赖的模块
    "cq/biz/article/article",
    "cq/biz/article/articleGroup"
],function(topic,Deferred,lang,user,BoBase,topic,config,article,articleGroup){
    var articleBo =  new BoBase({
        fields:{
            logo: {
                type: "image",
                label: "题图",
                editable: true
            },
            code:{
                type:"text",
                placeHolder:"编号",
                label:"编号",
				className:"small-width"
            },
			groupName:{
                type:"text",
                placeHolder:"类别名称",
                label:"类别名称",
				className:"large-width"
			},
            title:{
                type:"text",
                placeHolder:"标题",
                label:"标题",
				className:"large-width"
            },
            brief:{
                type:"textarea",
                placeHolder:"摘要",
                label:"摘要",
				className:"large-width"
            },
            content:{
                type:"richText",
                label:"资讯详情",
				className:"large-width"
            },
            isTop:{
                type:"checkbox",
                label:"是否置顶",
				className:"large-width"
            },
            "section":{
                type:"ref",
                field:"section",
                label:"资讯类别",
                searchField:"title",
                pageSize:5,
                labelFields:"title",
                dataProvider:"cq/biz/article/section",
                targetMethod:"getSectionUrl",
                canEdit:true
            },
			saveButton:{
				type:"button",
				action:"onSaveArticle",
				label:"保存"
			},
			saveGroupButton:{
				type:"button",
				action:"onSaveGroup",
				label:"保存"
			},
            articleActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='deleteArticle'>删除</div><div class='button' onclick='window.moveToView(\"news\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            },
            groupActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='deleteGroup'>删除</div><div class='button' onclick='window.moveToView(\"newsGroup\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		trendDetailFields:[{
				type:"text",
				field:"title"
			},
			{
				type:"text",
				field:"content"
			}
		],
		getDetailTemplate:function(){
			return "<h4>{title}</h4><div>{content}</div>";
		},
		loadShopArticle:function(){
			return article.getArticleUrl();
		},
		loadPlatformAnn:function(){
			return article.getLoadByGroupNameUrl("平台公告");
		},
		loadPlatformActivity:function(){
			return article.getLoadByGroupNameUrl("活动公告");
		},
		loadPlatformBuyer:function(){
			return article.getLoadByGroupNameUrl("买家公告");
		},
		loadPlatformSaler:function(){
			return article.getLoadByGroupNameUrl("卖家公告");
		},
		loadPlatformArticle:function(param){
			var def=new Deferred();
			article.loadPlatformById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
		loadShopArticleById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			article.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
        getArticleItemProp:function(data,itemType){
            return {
                icon:data.logo||"",
                label:data.title||"",
                data:data
            };
        },
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
		onShowArticle:function(item){
			window.moveToView("trendDetail",item._id);
		},
		//资讯信息表格化显示
        getArticleGridLayout: function() {
            if(!this.articleGridLayout){
                this.articleGridLayout = this.getFormItems(["title","brief","articleActions"],false);
            }
            return this.articleGridLayout;
        },
        getArticleEditLayout: function() {
            if(!this.merchantLayout){
                this.merchantLayout = [{
                    type: "form",
                    fields: this.getFormItems(["logo","code","title", "brief","isTop", "section","content","saveButton"])
                }];
            }
            return this.merchantLayout;
        },
		onListAction:function(data,action,list){
			if(action == "deleteArticle"){
				if(!confirm("确定删除吗？")) return;
				article.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSaveArticle:function(data,dataList){
			article.save(data).then(function(){history.back();});
		},
		
		//以下内容为资讯类别管理用
		loadGroup:function(){
			return articleGroup.getLoadUrl();
		},
		loadGroupById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			articleGroup.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
        getGroupEditLayout: function() {
            if(!this.groupEditLayout){
                this.groupEditLayout = [{
                    type: "form",
                    fields: this.getFormItems(["logo","code","groupName","saveGroupButton"])
                }];
            }
            return this.groupEditLayout;
        },
		getGroupQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.groupName = params.search;
            }
            return query;
        },
        getGroupGridLayout: function() {
            if(!this.groupGridLayout){
                this.groupGridLayout = this.getFormItems(["code","groupName","groupActions"],false);
            }
            return this.groupGridLayout;
        },
		onGroupListAction:function(data,action,list){
			if(action == "deleteGroup"){
				if(!confirm("确定删除吗？")) return;
				articleGroup.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSaveGroup:function(data,dataList){
			articleGroup.save(data).then(function(){history.back();});
		}
        
    });
    return articleBo;
});
