﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "dojo/topic", //不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "cq/util/config/config",//不依赖的模块
    "cq/biz/user/expert",
    "./BoBase"
],function(topic,Deferred,lang,topic,user,config,expert,BoBase){
    var expertBo =  new BoBase({
        fields:{
            logo: {
                type: "image",
                label: "题图",
                editable: true
            },
            code:{
                type:"text",
                placeHolder:"编号",
                label:"编号",
				className:"middle-width"
            },
            pName:{
                type:"text",
                placeHolder:"姓名",
                label:"姓名",
				className:"middle-width"
            },
            category:{
                type:"options",
                label:"类型",
				options : {
                            0 : "畜牧",
                            1 : "兽医",
                            2 : "市场"
                        },
				className:"small-width"
            },
            phone:{
                type:"text",
                placeHolder:"电话",
                label:"电话",
				className:"middle-width"
            },
            address:{
                type:"text",
                placeHolder:"地址",
                label:"地址",
				className:"large-width"
            },
            address:{
                type:"text",
                label:"地址",
				className:"large-width"
            },
            duty:{
                type:"text",
                label:"职务",
				className:"large-width"
            },
            company:{
                type:"text",
                label:"单位",
				className:"large-width"
            },
            field:{
                type:"text",
                label:"领域",
				className:"large-width"
            },
            resumes:{
                type:"textarea",
                label:"个人履历",
				className:"large-width"
            },
            skill:{
                type:"textarea",
                label:"经历特长",
				className:"large-width"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            expertActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='deleteExpert'>删除</div><div class='button' onclick='window.moveToView(\"expert\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		getDetailTemplate:function(){
			return "<h4>{title}</h4><div>{content}</div>";
		},
		load:function(){
			return expert.load();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			expert.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.pName = params.search;
            }
            return query;
        },
		//资讯信息表格化显示
        getGridLayout: function() {
            if(!this.expertGridLayout){
                //店铺认证
                this.expertGridLayout = this.getFormItems(["pName","category","duty","phone","address","expertActions"],false);
            }
            return this.expertGridLayout;
        },
        getEditLayout: function() {
            if(!this.merchantLayout){
                //专家编辑
                this.merchantLayout = [{
                    type: "form",
                    fields: this.getFormItems(["logo","code","pName","category","phone","address",'duty','company','field','resumes','skill',"saveButton"])
                }];
            }
            return this.merchantLayout;
        },
		onListAction:function(data,action,list){
			if(action == "deleteExpert"){
				if(!confirm("确定删除吗？")) return;
				expert.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			//
			window.busy();
			expert.save(data).then(function(){
				history.back();
				window.free();
			});
		}
        
    });
    return expertBo;
});
