define([
    "dojo/_base/lang",//不依赖的模块
    "./BoBase",
    "cq/biz/ts/cart",
	"cq/biz/ts/order",
    "cq/biz/mat/mat"//不依赖的模块
], function (lang, BoBase, cart, order, mat) {
    var boBase = new BoBase({
		//添加字段
		fields:{
            "details.0.dName": {
                type:"text",
                label:"收件人姓名"
            },
            "details.0.dAddress": {
                type:"text",
                label:"收件人地址"
            },
            "details.0.mId.mName":{
                type:"text",
                label:"商品名称"
            },
            price:{
                type:"text",
                label:"价格"
            },
            "details.0.qty":{
                type:"text",
                label:"商品数量"
            },
            //运费
            tAmount:{
                type:"text",
                label:"运费"
            },
            orderListActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' onclick='window.moveToView(\"orderDetailB\",\""+data._id+"\");'>查看</div>";
					return v;
				}
            },
            //金额
            amount:{
                type:"text",
                label:"总金额(含运费)"
            },
            "details.0.dTel":{
                type:"text",
                label:"收件人电话"
            },
            "details.0.price":{
                type:"text",
                label:"商品单价"
            }
          
			
		},
        _hasLogin: true,
        //通过ID数组加载商家
        loadShops: function () {

        },
        //加载购物车中商品
        loadCartMats: function () {

        },
        //获取
        getShopMatData: function (ids) {
            // [{
            //     shopId: id,
            //     shopName: "",
            //     logo: "",
            //     mats: [{
            //         matId: id,
            //         mName: "",
            //         cartQty: number,
            //         qty: number,
            //         logo: "",
            //         price: ''
            //     }]
            // }]
        },
        //购物车数据
        getOrderCarLayout: function () {
            return this.getShopMatData(cart.getIds());
        },
        //清空购物车
        clearCart: function () {

        },
        //继续购买
        toMatList: function () {

        },
        //结算
        submitOrderCar: function () {

        },
        //购物车合计组件数据
        getCartCountLayout: function () {

        },
		//订单列表显示
		getOrderListGridLayout:function(){
			if(!this.orderListGridLayout){
                this.orderListGridLayout = this.getFormItems(["details.0.dName","details.0.dAddress","details.0.dTel","details.0.mId.mName","details.0.price","details.0.qty","amount","tAmount","orderListActions"],false);
            }
            return this.orderListGridLayout;
		},
		//获取订单列表数据的url
		getOrderListUrl:function(){
			return order.getWithDetailsUrl();
		},
        getOrderListQueryParam:function(params){
            //默认查询全部
            var query = {orderBy:'-createAt'};
                if(params.search){
                    query.search = params.search;
                }
                //1为待付款
                if(params.state&&params.state._id==1){
                    query={isPayed:false,isCanceled:false,orderBy:'-createAt'};
                }else if(params.state&&params.state._id==2){
                    //2为待审核
                    query={ isPayed:true,isCanceled:false,isAccepted:false,orderBy:'-createAt'};
                }else if(params.state&&params.state._id==3){
                    //3为待发货
                    query={isPayed:true,isCanceled:false,isAccepted:true,isDelived:false,orderBy:'-createAt'};
                }else if(params.state&&params.state._id==4){
                    //4为已发货
                    query={isPayed:true,isCanceled:false,isDelived:true,isReceipted:false,orderBy:'-createAt'};
                }else if(params.state&&params.state._id==5){
                    //5为已完成
                    query={isPayed:true,isCanceled:false,isDelived:true,isReceipted:true,orderBy:'-createAt'};
                }else if(params.state&&params.state._id==6){
                    //6为退款中
                    query={isPayed:true,isCanceled:true,isReceipted:false,orderBy:"-createAt"};
                }else if(params.state&&params.state._id==0){
                    query={orderBy:"-createAt"};
                }
            return query;
        },
        getOrderDetailLayout:function(){
            if(!this.orderDetailLayout){
                this.orderDetailLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        
                    ])
                }];
            }
            return this.orderDetailLayout;
        }
    });
    return boBase;
});
