﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "dojo/topic", //不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "cq/util/config/config",//不依赖的模块
    "cq/biz/mk/price",
    "./BoBase"
],function(topic,Deferred,lang,topic,user,config,price,BoBase){
    var priceBo =  new BoBase({
        fields:{
            market:{
                type:"options",
                label:"区域",
				options : {
					1:'全国',
					2:'重庆',
					3:'酉阳',
					4:'福建',
					5:'广东'
				}
            },
            makeDate:{
                type:"date",
                label:"日期",
				className:"large-width"
            },
            price:{
                type:"text",
                label:"价格",
				className:"large-width"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            priceActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"priceTrendDetail\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		getDetailTemplate:function(){
			return "<h4>{title}</h4><div>{content}</div>";
		},
		load:function(){
			return price.getLoadUrl();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			price.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.pName = params.search;
            }
            return query;
        },
		//资讯信息表格化显示
        getGridLayout: function() {
            if(!this.priceGridLayout){
                //店铺认证
                this.priceGridLayout = this.getFormItems(["market","makeDate","price","priceActions"],false);
            }
            return this.priceGridLayout;
        },
        getEditLayout: function() {
            if(!this.editLayout){
                //店铺认证
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["market","makeDate","price","saveButton"])
                }];
            }
            return this.editLayout;
        },
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				price.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			//
			window.busy();
			price.save(data).then(function(){history.back();window.free();});
		}
        
    });
    return priceBo;
});
