﻿define([
    "dojo/Deferred",
    "dojo/_base/lang",//不依赖的模块
    //依赖以下两个模块有问题
    "dojo/dom-class",
	"dojo/dom-construct",	// create
    "cq/util/config/config",
    "cq/util/sys/date",
    "cq/biz/ts/pm/project",
    "cq/biz/im/timeLine",
    "cq/widgets/bigImg",//不依赖的模块  写法有问题
    "./BoBase"
],function(Deferred,lang,domClass,domConstruct,config,date,project,timeLine,bigImg,BoBase){
    var projectBo =  new BoBase({
        fields:{
            typeId:{
                type:"options",
                label:"类型",
				options : {
					1: "资源保护",
					2: "良种繁育",
					3: "饲草饲料",
					4: "基地建设",
					5: "体系创建"
				},
				className:"small-width",
                tag:"基本信息"
			},
            state:{
                type:"options",
                label:"状态",
				options : {
					0: "申请中",
					1: "已通过",
                    10:"提交申请",
                    20:"拒绝申请",
                    30:"驳回申请",
                    40:"通过申请",
                    50:"申请已复核",
                    60:"提交验收材料",
                    70:"驳回验收",
                    80:"通过验收",
                    90:"验收已复核"
					/*2: "已驳回",
					3: "已拒绝",
					11: "申请验收",
					13: "驳回验收",
					14: "拒绝验收",
					15: "通过验收"*/
				},
				className:"small-width",
                tag:"基本信息"
			},
            fromShopId:{
                type: "ref",
                label: "申报单位",
                dataProvider: "cq/biz/shop/shop",
                targetMethod: "getShopByPlatform",
                searchField: "shopName",
                labelFields: "shopName",
				className:"middle-width",
                tag:"基本信息"
            },
            "fromShopId.shopName":{
                type:"text",
                label:"申报单位",
				className:"small-width",
                tag:"基本信息"
            },
            "fromShopId.contactName":{
                type:"text",
                label:"联系人",
				className:"small-width",
                tag:"基本信息"
            },
            "fromShopId.contactPhone":{
                type:"text",
                label:"联系电话",
				className:"middle-width",
                tag:"基本信息"
            },
            title:{
                type:"text",
                label:"项目名称",
				className:"middle-width",
                tag:"基本信息"
            },
            startDate:{
                type:"date",
                label:"申报开始日期",
				className:"middle-width",
                tag:"申报信息"
            },
            endDate:{
                type:"date",
                label:"申报截止日期",
				className:"middle-width",
                tag:"申报信息"
            },
            createAt:{
                type:"date",
                label:"申报日期",
				className:"middle-width",
                tag:"基本信息"
            },
            company:{
                type:"text",
                label:"申报主体",
				className:"large-width",
                tag:"申报信息"
            },
            property:{
                type:"text",
                label:"建设性质",
				className:"large-width",
                tag:"基本信息"
            },
            scale:{
                type:"textarea",
                label:"内容及规模",
				className:"middle-width",
                tag:"基本信息"
            },
            targetUsage:{
                type:"textarea",
                label:"补助环节",
				className:"middle-width",
                tag:"基本信息"
            },
            term:{
                type:"text",
                label:"建设年限",
				className:"large-width",
                tag:"基本信息"
            },
            balanceQty:{
                type:"text",
                label:"存栏量",
				className:"small-width",
                tag:"申报信息"
            },
            investments:{
                type:"text",
                label:"项目总投入(万元)",
				className:"small-width",
                tag:"基本信息"
            },
            actInvestments:{
                type:"text",
                label:"实际投资(万元)",
				className:"small-width",
                tag:"申报信息"
            },
            investmentByShop:{
                type:"text",
                label:"申报额度(万元)",
				className:"small-width",
                tag:"申报信息"
            },
            verifiedAmount:{
                type:"text",
                label:"批复金额（万元）",
				className:"small-width",
                tag:"申报信息"
            },
            newContactPerson:{
                type:"text",
                label:"联系人",
				className:"small-width",
                tag:"基本信息"
            },
            newContactPhone:{
                type:"text",
                label:"联系电话",
				className:"small-width",
                tag:"基本信息"
            },
            content:{
                type:"richText",
                label:"项目申报指南",
				className:"large-width large-high2",
                tag:"基本信息"
            },
            startReviewDate:{
                type:"date",
                label:"公示开始日期",
				className:"middle-width",
                tag:"申报信息"
            },
            endReviewDate:{
                type:"date",
                label:"公示截止日期",
				className:"middle-width",
                tag:"申报信息"
            },
            countyVerify:{
                label : "是否允许区县审核",
                type : "checkbox"
            },
            result:{
                type:"textarea",
                label:"建设成效",
				className:"large-width",
                tag:"验收信息"
            },
            // 创建项目定义 ,顶部tab
            "prjApplyTags":{
                type:"tags",
                tags:["基本信息","申报信息","验收信息"]
            },
            "prjApplyContents":{
                type:"table",
                contents:[[{
                    label:"项目名称",
                    type:"text",
                    field:"prjName"
                }],[{
                    label:"项目申报开始日期",
                    type:"date",
                    field:"startDate"
                }, {
                    label:"项目申报截止日期",
                    type:"date",
                    field:"endDate"
                }],[{
                    label:"项目金额",
                    type:"text",
                    field:"prjAmount"
                }],[{
                    label:"联合监管单位",
                    type:"options",
                    options:{
                        0:"重庆市政府",
                        1:"重庆市法院"
                    }
                },{
                    label:"业主类型",
                    type:"options",
                    options:{
                        0:"1",
                        1:"2"
                    }
                }]]
            },
            "prjApplySaveBtn":{
                type:"action",
                label:"确定",
                action:"save"
            },
            "prjApplyCancleBtn":{
                type:"action",
                label:"取消",
                action:"cancle"
            },
            
			//申请信息定义
			"applyInfosDef" : {
				type : "objects",
				label:"申请信息",
				labelField : "userName",
				rightTextField : "password",
				canEdit : true,
				canDelete : true,
				canAdd : true,
				fields : {
					layout : [{
						field : "title",
						type : "text",
						label : "名称"
					}, {
						field : "tp",
						type : "options",
						label : "字段类型",
						options : {
							"10": "字符串",
							"20": "数字",
							"30": "枚举值"
						}
					}, {
						field : "enums",
						type : "text",
						placeHolder : "枚举值，用逗号分隔",
						label : "枚举值"
					}, {
						field : "isStatistics",
						type : "checkbox",
						label : "是否统计"
					}]
				},
                tag:"申报信息"
			},
			"applyInfos":{
				type:"object",
				label:"申请材料",
				fields : {
					layout : [{
						field : "userName",
						type : "tel",
						placeHolder : "请填写手机号",
						label : "账号"
					}]
				},
                tag:"申报信息"
			},
			"applyFilesDef":{
				type:"attachs",
				label:"申请附件",
				cnaEdit: true,
                tag:"申报信息"
			},
			//验收信息定义
			"checkInfosDef" : {
				type : "objects",
				label:"验收信息",
				labelField : "userName",
				rightTextField : "password",
				canEdit : true,
				canDelete : true,
				canAdd : true,
				fields : {
					layout : [{
						field : "title",
						type : "text",
						label : "名称"
					}, {
						field : "tp",
						type : "options",
						label : "字段类型",
						options : {
							"10": "字符串",
							"20": "数字",
							"30": "枚举值"
						}
					}, {
						field : "enums",
						type : "text",
						placeHolder : "枚举值，用逗号分隔",
						label : "枚举值"
					}, {
						field : "isStatistics",
						type : "checkbox",
						label : "是否统计"
					}]
				},
                tag:"验收信息"
			},
			"checkInfos":{
				type:"object",
				label:"验收材料",
				fields : {
					layout : [{
						field : "userName",
						type : "tel",
						placeHolder : "请填写手机号",
						label : "账号"
					}]
				},
                tag:"验收信息"
			},
			"checkFilesDef":{
				type:"attachs",
				label:"验收附件",
				cnaEdit: true,
                tag:"验收信息"
			},
			
			
			
			
			//项目定义的操作按钮
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
			verifyButton:{
				type:"button",
				action:"onVerify",
				label:"通过"
			},
			
			
			//项目申请的操作按钮
			saveApplyButton:{
				type:"button",
				action:"onSaveApply",
				label:"保存"
			},
			//提交申请或提交验收材料
			submitApplyButton:{
				type:"button",
				action:"onSubmit",
				label:"提交"
			},
			//拒绝
			refuseApplyButton:{
				type:"button",
				action:"onRefuse",
				label:"拒绝"
			},
			//驳回
			rejectApplyButton:{
				type:"button",
				action:"onReject",
				label:"驳回"
			},
			//同意
			agreeApplyButton:{
				type:"button",
				action:"onAgree",
				label:"通过"
			},
			
			//列表按钮
            listActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = 
						"<div class='button' cq-action='delete'>删除</div>"+
						(data.state==0?"<div class='button' cq-action='verify'>审核</div><div class='button' cq-action='reject'>作废</div>":"")+
						(data.state==1?"<div class='button' cq-action='unVerify'>撤销审核</div><div class='button' cq-action='viewApply'>查看申报</div><div class='button' cq-action='reject'>作废</div>":"")+
						"<div class='button' onclick='window.moveToView(\"prjDefEdt\",\""+data._id+"\");'>详情</div>";
					return v;
				},
				className:"large-width"
            },
			//审核项目申报的操作集
            checkListActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = 
						//"<div class='button' cq-action='delete'>删除</div>"+
						(data.state==0?"<div class='button' cq-action='verify'>通过</div><div class='button' cq-action='refuse'>拒绝</div><div class='button none' cq-action='reject'>驳回</div>":"")+
						(data.state==11?"<div class='button' cq-action='verify2'>通过验收</div><div class='button' cq-action='refuse2'>拒绝验收</div><div class='button' cq-action='reject2'>驳回验收</div>":"")+
						//(data.state==1?"<div class='button' cq-action='reject'>驳回</div>":"")+
						"<div class='button' onclick='window.moveToView(\"prjCheckDtl\",\""+data._id+"\");'>详情</div>";
					return v;
				},
				className:"large-width"
            },
            applyPrjListAction:{
                type:"text",
                label:"",
                formatter:function(action,data){
					var v = 
						"<div class='button' onclick='window.moveToView(\"prjCheckDtl\",\"prj_"+data._id+"\");'>详情</div>";
					return v;
                },
				className:"large-width"
            }
        },
		getDetailTemplate:function(){
			return "<h4>{title}</h4><div>{content}</div>";
		},
        
        
        
        //项目管理列表界面相关接口
        //列表数据地址
		load:function(){
			return project.getLoadProjectUrlV2();
		},
        //查询条件
		getQueryParam:function(params){
			var query = {isUse:true};
			if(params.cqViewParam&& params.cqViewParam.params) query.srcProjectId = params.cqViewParam.params;
            if(params.search){
                query.pName = params.search;
            }
			if(params.state){
                query.state = params.state._id;
			}
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
        //列表结构
        getGridLayout: function() {
            if(!this.projectGridLayout){
                this.projectGridLayout = this.getFormItems(["typeId","title","targetUsage","startDate","endDate","listActions"],false);
            }
            return this.projectGridLayout;
        },
        //列表操作
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				project.saveProject({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
			if(action == "verify"){
				data.state=1;
				project.verifyById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "unVerify"){
				data.state=0;
				project.cancelById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "reject"){
				data.state=4;
				project.stopById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "viewApply"){
				window.moveToView("prjCheckList",data._id);
			}
		},
        
        
        
        //项目管理编辑界面相关接口
        //界面结构
        getEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    dojoType:"cq/app/widget/web/Steps",
                    field:"steps",
                    formClass:"table-clas",
                    steps:{
                        stepsTags:[{
                            type:"action",
                            label:"基本信息"
                        },{
                            type:"action", 
                            label:"项目申报材料"
                        },{
                            type:"action", 
                            label:"项目验收材料"
                        }],
                        stepsFields:[{
                            fields:this.getFormItems(["typeId","title","targetUsage","startDate","endDate","company","property","term","countyVerify","investments","investmentByShop","newContactPerson","newContactPhone","content"]),
                            type:"tagFields"
                        },{
                            fields:this.getFormItems(["applyInfosDef",'applyFilesDef']),
                            type:"tagFields"
                        },{
                            fields:this.getFormItems(['checkInfosDef','checkFilesDef']),
                            type:"tagFields"
                        }],
                        stepsBtns:this.getFormItems(['saveButton'])
                    }
                }];
            }
            return this.editLayout;
        },
        //数据重新加载之后刷新界面显示
        onDataReloaded : function(widget){
			var data = widget.getData();
			if(data.state!=0){
				widget.hideByFields(["saveButton"]);
			}
			else{
				widget.showByFields(["saveButton"]);
			}
		},
        //加载项目详细信息
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params){
                return project.defTest({isUse:true,state:0});
            }
			return project.loadByIdV2(param.cqViewParam.params).then(lang.hitch(this,function(data){
				return data.data.item;
			}));
		},
        
        
        //项目审核方申请列表相关接口
		getLoadApplyUrl:function(){
			return project.getLoadApplyUrlV2();
		},
        //查询条件与项目列表共用
        getApplyCheckGridLayout: function() {
            if(!this.projectApplyGridLayout){
                this.projectApplyGridLayout = this.getFormItems(["fromShopId.shopName","fromShopId.contactName","fromShopId.contactPhone","balanceQty","title","state","createAt","verifiedAmount","scale","targetUsage","actInvestments","result","checkListActions"],false);
            }
            return this.projectApplyGridLayout;
        },
        //列表中点击之后的响应，这个方法时错的
		onCheckListAction:function(data,action,list){
			if(action == "verify"){
				window.moveToView("prjCheckDtl",data._id);
				return;
				if(!confirm("通过该申请吗？")) return;
				data.state=1;
				project.verifyApplyById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "refuse"){
				if(!confirm("拒绝该申请吗？")) return;
				data.state=4;
				project.refuseApplyById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "reject"){
				var reason = prompt("请输入驳回理由");
				if(!reason) return;
				data.state=2;
				project.rejectApplyById(data._id,reason).then(function(){list.refreshItemByData(data);});
			}
			if(action == "verify2"){
				if(!confirm("通过该申请吗？")) return;
				data.state=15;
				project.examinePass(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "refuse2"){
				if(!confirm("拒绝该申请吗？")) return;
				data.state=14;
				project.examineNopass(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "reject2"){
				if(!confirm("驳回该申请吗？")) return;
				data.state=13;
				project.examineReject(data._id).then(function(){list.refreshItemByData(data);});
			}
		},
        
        
        
        
        
        
        //项目申请方项目列表相关接口
        //列表数据地址，服务商处已审核的项目
        getLoadApplyPrjUrl:function(){
            return project.getLoadProjectUrlV2()+"&state=1";
        },
        //查询条件与项目列表共用
        //申请方查看的项目列表结构
        getApplyPrjGridLayout: function() {
            if(!this.applyPrjGridLayout){
                this.applyPrjGridLayout = this.getFormItems(["title","state","createAt","scale","targetUsage","applyPrjListAction"],false);
            }
            return this.applyPrjGridLayout;
        },
        //列表点击之后最多只有view切换，无需响应函数
        
        
        
        
        //项目申请方，项目申请列表
		getLoadMyApplyUrl:function(){
			return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId;
		},
        getMyApplyGridLayout:function(){
            return this.getApplyCheckGridLayout();
        },
        
        
		loadCheckById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params){
                return project.defTest({isUse:true,state:0});
            }
			return project.loadApplyById(param.cqViewParam.params).then(lang.hitch(this,function(data){
                return data.data.item;
			}));
		},
		getToApplyQueryParam:function(params){
			var query = {isUse:true,state:1};
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
		getToApplyItemProp:function(data){
			return {
                label:
					"<div>项目名称："+data.title+"</div>"+
					"<div>申报日期从："+date.formatISODate(data.startDate)+"到"+date.formatISODate(data.endDate)+"</div>"
					//"<div>联系方式："+data.newContactPerson+"/"+data.newContactPhone+"</div>"
                ,
                variableHeight:true,
                data:data
            };
		},
		onToApplyDetail:function(data){
			window.moveToView("prjDtl",data._id);
		},
        // 创建项目
        getPrjApplyLayout:function(){
            if(!this.prjApplyLayout){
                this.prjApplyLayout = [{
                    type:"steps",
                    fields:this.getFormItems(["prjApplyTags", "prjApplyContents", "prjApplySaveBtn", "prjApplyCancleBtn"])
                }];
            }
            return this.prjApplyLayout;
        },
		//同意审核时的批复内容
        getVerifyLayout: function() {
            if(!this.verifyLayout){
                this.verifyLayout = [{
                    type: "form",
                    fields: this.getFormItems(["fromShopId","title","createAt","verifiedAmount","scale","targetUsage","verifyButton"])
                }];
            }
            return this.verifyLayout;
        },
		onPrjCheckLoaded:function(widget){
			var data = widget.getData();
			widget.disableByFields(["fromShopId","title","createAt","state","verifiedAmount","scale","targetUsage","actInvestments","result"]);
			widget.hideByFields(["verifyButton"]);
			if(data.state==0){
				widget.enableByFields(["verifiedAmount","scale","targetUsage"]);
				widget.showByFields(["verifyButton"]);
			}
			var n = widget.domNode.firstChild.lastChild;
			if(!n || !domClass.contains(n,"execution")){
				n = domConstruct.create("div", {
					className: "execution"
				}, widget.domNode.firstChild);
			}
			var s = "";
			for(var i=0;data.execution&&i<data.execution.length;i++){
				if(i==0) s+="<label class='cq-form-label'>项目执行记录</label>"
				s+="<div>"+data.execution[i].title+"<div style='float:right'>"+date.formatISODate(data.execution[i].createAt)+"</div></div>";
				s+="<div style='margin-bottom:5px;'>";
				for(var j=0;j<data.execution[i].images.length;j++){
					s+="<img src='"+data.execution[i].images[j]+"' style='margin-right:5px;width:64px;height:64px;cursor:pointer;display:inline-block;' onclick='cq.widgets.bigImg.show(\""+data.execution[i].images[j]+"\")'/>"
				}
				s+="</div>";
			}
			n.innerHTML = s;
		},
        getApplyEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["fromShopId","title","createAt","state","verifiedAmount","scale","targetUsage","actInvestments","result","verifyButton"])
                }];
            }
            return this.editLayout;
        },
		onSave:function(data,dataList){
			//
			window.busy();
			project.saveProjectV2(data).then(function(){history.back();window.free();});
		},
        prjApplyList : function () {
            window.moveToView("prjApplyList");
        },
		
		
        
        
        
        
        
        
        
        
        
        
        
        
		//项目申请/提交/审核详情界面相关接口
		//获取项目申请界面详情
		getApplyLayout:function(){
            return [{
                dojoType:"cq/app/widget/web/Steps",
                field:"steps",
                formClass:"table-clas",
                steps:{
                    stepsTags:[{
                        type:"action",
                        label:"基本信息"
                    },{
                        type:"action", 
                        label:"申报信息"
                    },{
                        type:"action", 
                        label:"验收信息"
                    }],
                    stepsFields:[{
                        fields:this.getFormItems(["typeId","title","targetUsage","startDate","endDate","company","property","term","investments","investmentByShop","newContactPerson","newContactPhone","content"],false),
                        type:"tagFields"
                    },{
                        fields:this.getFormItems(["applyInfosDef","applyInfos",'applyFilesDef']),
                        type:"tagFields"
                    },{
                        fields:this.getFormItems(['checkInfosDef',"checkInfos",'checkFilesDef']),
                        type:"tagFields"
                    }],
                    stepsBtns:this.getFormItems(["submitApplyButton","saveApplyButton","refuseApplyButton","rejectApplyButton","agreeApplyButton"])
                }
            }];
		},
		//依据界面参数从数据库中加载数据
        _loadApplyData:function(param){
			if(param&&param.cqViewParam&&param.cqViewParam.params){
				var applyId = param.cqViewParam.params;
				if(0===applyId.indexOf("prj_")){
					var def = new Deferred(),projectId = applyId.replace("prj_","");
					project.loadMyApplyByProjectId(projectId).then(function(data){
						if(data&&data.data&&data.data.item){
							def.resolve(data.data.item);
						}else{
							project.loadProjectByIdV2(projectId,config.serviceShopId).then(function(data){
								if(data&&data.data&&data.data.item){
									//依据项目信息生成项目审核信息
									var item = data.data.item;
									def.resolve({
										projectType:2,
										state:10,
										isUse:true,
										srcProjectId:projectId,
										fromShopId:project.getShopId(),
										targetShopId:item.fromShopId&&item.fromShopId._id||item.fromShopId,
										applyFiles:[],
										checkFiles:[],
										title:item.title,
										startDate:item.startDate,
										endDate:item.endDate,
										content:item.content,
										typeId:item.typeId,
										company:item.company,
										property:item.property,
										scale:item.scale,
										targetUsage:item.targetUsage,
										term:item.term,
										investments:item.investments,
										newContactPerson:item.newContactPerson,
										newContactPhone:item.newContactPhone,
										countyVerify:item.countyVerify,
										applyInfos:item.applyInfosDef,
										applyFilesDef:item.applyFilesDef,
										justiceName:item.justiceName,
										checkInfos:item.checkInfosDef,
										checkFilesDef:item.checkFilesDef
									});
								}else{
									def.resolve({});
									alert("参数错误");
									//history.back();
								}
							});
						}
					});
					return def;
				}else{
					return project.loadApplyByIdV2(applyId).then(function(data){
						if(data&&data.data&&data.data.item){
							var item = data.data.item;
							return data.data.item;
						}else{
							alert("参数错误");
							//history.back();
							return {};
						}
					});
				}
			}else{
				alert("参数错误");
				//history.back();
                return {};
			}
		},
		//依据参数加载数据并加工成界面呈现需要的形式
		loadApplyData:function(param){
			return this._loadApplyData(param).then(function(applyData){
				applyData.applyInfosBak = lang.clone(applyData.applyInfos);
				applyData.checkInfosBak = lang.clone(applyData.checkInfos);
				return applyData;
			});
		},
		//申请数据刷新之后的处理，数据刷新之后需要改变界面编辑结构
		onPrjApplyLoaded:function(widget){
			var data = widget.getData();
			if(data&&data.srcProjectId){
				//依据状态做数据的显示隐藏
				widget.getEditorByField("applyInfos").alterLayout(this._getInfoLayout(data.applyInfosBak));
				widget.updateByField("applyInfos",this._getInfoData(data.applyInfosBak));
				widget.getEditorByField("checkInfos").alterLayout(this._getInfoLayout(data.checkInfosBak));
				widget.updateByField("checkInfos",this._getInfoData(data.checkInfosBak));
				
				//禁止所有编辑
				widget.disableByFields(["applyInfos","applyFiles","checkInfos","checkFiles"]);
				//隐藏所有按钮
				widget.hideByFields(["applyInfos","applyFiles","checkInfos","checkFiles","saveApplyButton","submitApplyButton","refuseApplyButton","rejectApplyButton","agreeApplyButton"]);
				var nowDate = date.formatISODate(date.nowISOString());
				if(
					//申请被拒绝
					data.state===20
					//申请已结案
					||data.state===90
					//申请没有通过，且过了申请时限
					||data.state<50&&nowDate>date.formatISODate(data.endDate)
					//处于公示期中
					||nowDate>=date.formatISODate(data.startReviewDate)&&nowDate<=date.formatISODate(data.endReviewDate)
				){
					return;
				}
				if(data.currentShopId&&data.verShopIds){
					var shopId = project.getShopId();
					if(data.currentShopId===data.fromShopId){
						if(data.currentShopId===shopId){
							//申请提交者
							if(data.state===30){
								//处于填写申请阶段，可以修改任何申请材料
								widget.enableByFields(["applyInfos","applyFiles"]);
								widget.showByFields(["applyInfos","applyFiles","saveApplyButton","submitApplyButton"]);
							}else if(data.state===50||data.state===70){
								//处于填写验收阶段，可以修改任何验收材料
								widget.enableByFields(["checkInfos","checkFiles"]);
								widget.showByFields(["checkInfos","checkFiles","saveApplyButton","submitApplyButton"]);
							}
						}
					}else{
						//项目审核方
                        //隐藏添加申请、验收信息
                        widget.hideByFields(["checkInfosDef","applyInfosDef"]);
                        //禁止编辑添加按钮
                        widget.disableByFields(["applyFilesDef","checkFilesDef"]);
						var verShopIds = (data.verShopIds||[]).join(",");
						if(
							//当前商家审核申请
							data.currentShopId===shopId
							//或当前商家的下级在审核
							||verShopIds.indexOf(data.currentShopId)<verShopIds.indexOf(shopId)
						){
							if(data.state===10||data.state===30||data.state===40&&data.currentShopId!=shopId){
								//处于申请阶段
								//审核申请时，审核方需要补充的资料
								widget.enableByFields(["applyFiles"]);
								widget.showByFields(["applyInfos","applyFiles","saveApplyButton","refuseApplyButton","rejectApplyButton","agreeApplyButton"]);
							}else if(data.state===60||data.state===70||data.data.state===80&&data.currentShopId!=shopId){
								//处于验收阶段
								//审核验收时，审核方需要补充的材料
								widget.enableByFields(["checkFiles"]);
								widget.showByFields(["checkInfos","checkFiles","saveApplyButton","rejectApplyButton","agreeApplyButton"]);
							}
						}
					}
				}else{
                    //隐藏添加申请、验收信息
                    widget.hideByFields(["checkInfosDef","applyInfosDef"]);
                    //可以添加附件
                    widget.enableByFields(["applyFilesDef","checkFilesDef"]);
					//处于填写申请阶段，可以修改任何申请材料
					widget.enableByFields(["applyInfos","applyFiles"]);
					widget.showByFields(["applyInfos","applyFiles","saveApplyButton","submitApplyButton"]);
				}
			}
			//其他状态下应该字段是只读的，但是可以看
		},
		_getInfoLayout:function(infoDef){
			infoDef = infoDef||[];
			return infoDef.map(function(item){
				var f = {
					field:item.title,
					type:item.tp==30?"options":"text",
					label:item.title
				};
				if(f.type=="options"){
					f.options = {};
					enums = item.enums.split(",");
					enums.forEach(function(i){
						f.options[i] = i;
					});
				}
				return f;
			});
		},
		_getInfoData:function(infoFields){
			var d = {};
			infoFields.forEach(function(item){
				d[item.title] = item.value;
			});
			return d;
		},
		_refreshInfoByData:function(info,data){
			info.forEach(function(item){
				item.value = data[item.title];
			});
			return info;
		},
		//按钮响应
		_onSaveApply:function(data,dataList){
			var dd = lang.clone(data);
			dd.checkInfos = this._refreshInfoByData(dd.checkInfosBak,dd.checkInfos);
			dd.applyInfos = this._refreshInfoByData(dd.applyInfosBak,dd.applyInfos);
			return project.saveApplyOnly(dd);
		},
		//保存申请/验收/申请审核补充材料/验收审核补充材料，只保存不影响状态
		onSaveApply:function(data,dataList){
			window.busy();
			this._onSaveApply(data,dataList).then(function(){
				history.back();
			});
		},
		//提交,依据状态提交申请或验收材料,将数据同步到相关商家数据库
		onSubmit:function(data,dataList){
			window.busy();
			this._onSaveApply(data,dataList).then(function(data){
				//调用后台的提交操作
				project.submitApply(data.data.item._id).then(function(){
					//返回前一个页面
					history.back();
				});
			});
		},
		//拒绝,拒绝指定申请,申请流程到此终止
		onRefuse:function(data,dataList){
			window.busy();
			this._onSaveApply(data,dataList).then(function(){
				//调用后台的拒绝操作
				project.refuseApply(data._id).then(function(){
					//返回前一个页面
					history.back();
				});
			});
		},
		//驳回,驳回到指定商家重新处理
		onReject:function(data,dataList){
			window.busy();
			this._onSaveApply(data,dataList).then(lang.hitch(this,function(){
				//选择驳回的目标商家和驳回理由
				this.getRejectInfo(data).then(function(rejectInfo){
					//检查驳回信息的合法性,若不合法,给出提示
					if(!rejectInfo){
						return;
					}
					//调用后台的驳回操作
					project.rejectApply(data._id,rejectInfo).then(function(){
						//返回前一个页面
						history.back();
					});
				});
			}));
		},
		getRejectInfo:function(data){
			var def = new Deferred(),rejectInfo = null;
			for(var i=1;i<data.verShopIds.length;i++){
				if(data.verShopIds[i]===project.getShopId()){
					rejectInfo = {
						targetShopId:data.verShopIds[i-1],
						rejectRemark:""
					};
					break;
				}
			}
			def.resolve(rejectInfo);
			return def;
		},
		//同意,若最后一个处理者,项目结案,否则流转到下一个处理者
		onAgree:function(data,dataList){
			window.busy();
			//参数合法性检查,若没有通过,给出提示,最后一个审核者的必填项
				//若当前商家是最后一个审核商家
				//当前若是申请，申请审批信息必须完整
				//否则审核审批和结案信息必须完整
			this._onSaveApply(data,dataList).then(function(){
				//调用后台同意接口
				project.agreeApply(data._id).then(function(){
					//返回前一个页面
					history.back();
				});
			});
		}
    });
    return projectBo;
});
