﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "cq/util/config/config",//不依赖的模块
    "cq/biz/im/questionMsg",
    "./BoBase"
],function(topic,Deferred,lang,user,config,questionMsg,BoBase){
    var questionMsgBo =  new BoBase({
        fields:{
            title:{
                type:"text",
                label:"问题",
				className:"large-width"
            },
            pDate:{
                type:"dateTime",
                label:"提出时间",
				className:"small-width"
            },
            name:{
                type:"text",
                label:"姓名",
				className:"small-width"
            },
            phone:{
                type:"text",
                label:"电话",
				className:"small-width"
            },
            replyPeople:{
                type:"text",
                label:"回复人",
				className:"small-width"
            },
            content:{
                type:"textarea",
                label:"回复内容",
				className:"large-width"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"questionMsgDetail\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		getDetailTemplate:function(){
			return "<h4>{title}</h4><div>{content}</div>";
		},
		load:function(){
			return questionMsg.getLoadUrl();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			questionMsg.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
		//资讯信息表格化显示
        getGridLayout: function() {
            if(!this.gridLayout){
                //店铺认证
                this.gridLayout = this.getFormItems(["title","pDate","name","phone","replyPeople","content","listActions"],false);
            }
            return this.gridLayout;
        },
        getEditLayout: function() {
            if(!this.editLayout){
                //店铺认证
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["title","pDate","name","phone","replyPeople","content","saveButton"])
                }];
            }
            return this.editLayout;
        },
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				questionMsg.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			//
			window.busy();
			questionMsg.save(data).then(function(){history.back();window.free();});
		}
        
    });
    return questionMsgBo;
});
