﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "./BoBase",
    "dojo/topic", //不依赖的模块
    "cq/util/config/config",//不依赖的模块
    "cq/biz/article/bs/schoolClass"
],function(topic,Deferred,lang,user,BoBase,topic,config,schoolClass){
    var schoolClassBo =  new BoBase({
        fields:{
            logo: {
                type: "image",
                label: "课程图标",
                editable: true
            },
            title:{
                type:"text",
                placeHolder:"主题",
                label:"主题",
				className:"large-width"
            },
            teacher:{
                type:"text",
                placeHolder:"主讲人",
                label:"主讲人",
				className:"small-width"
            },
            startSignDate:{
                type:"dateTime",
                label:"报名开始日期",
				className:"small-width"
            },
            endSignDate:{
                type:"dateTime",
                label:"报名结束日期",
				className:"small-width"
            },
            startDate:{
                type:"dateTime",
                label:"讲堂开始日期",
				className:"small-width"
            },
            endDate:{
                type:"dateTime",
                label:"讲堂结束日期",
				className:"small-width"
            },
            address:{
                type:"text",
                label:"授课地址",
				className:"large-width"
            },
            content:{
                type:"richText",
                label:"课程简介",
				className:"large-width"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"操作",
				className:"middle-width",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"schoolClass\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		load:function(){
			return schoolClass.loadUrl();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			schoolClass.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
        getEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["logo","title","teacher","startSignDate","endSignDate","startDate","endDate","address","content","saveButton"])
                }];
            }
            return this.editLayout;
        },
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
        getGridLayout: function() {
            if(!this.gridLayout){
                this.gridLayout = this.getFormItems(["title","teacher","address","startSignDate","endSignDate","startDate","endDate","listActions"],false);
            }
            return this.gridLayout;
        },
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				schoolClass.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			schoolClass.save(data).then(function(){history.back();});
		}
    });
    return schoolClassBo;
});
