define([
    "dojo/topic",
    "dojo/Deferred",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/DeferredList",
    //下边几个对象的功能程序应该分离
    "cq/biz/shop/shop",
    "cq/biz/shop/partner",
    "cq/biz/shop/shopMsg",
    "cq/biz/ts/pm/shopPayLog",
    "cq/biz/ts/transaction",
    "cq/biz/shop/shopUser",
    "cq/biz/user/user",
    "cq/util/config/config",
    "cq/util/edit/editor",
    "cq/util/sys/xlsx",
    "cq/util/sys/date",
    "./BoBase"
], function(topic, Deferred, array, lang, DeferredList, shop, partner, shopMsg, shopPayLog, transaction, shopUser, user, config, editor, xlsx, date, BoBase) {
    var shopBo = new BoBase({
        fields: {
            companyName: {
                type: "text",
                label: "公司名称",
                editable: true,
                placeHolder:"请填写名称"
            },
            legalPerson: {
                type: "text",
                label: "法人姓名",
                editable: true,
                placeHolder:"请与营业执照保持一致"
            },
            // 只选区县
            "county":{
                type:"district",
                label:"区县",
                fixedUpDis:{
                    upDis:[
                        {provinceId:"57a936a0e026905d4c92f647"},
                        {cityId:"57a936a0e026905d4c92f648"}
                    ]
                }
            },
            businessLicense: {
                type: "image",
                label: "营业执照",
                size:{
                    width:600,
                    height:800
                },
                clickImg : true,
                sizeType:"cut"
            },
            legalImg1: {
                type: "image",
                label: "法人身份证正面",
                sizeType:"cut",//"compress",
                size:{
                    width:800,
                    height:600
                },
                clickImg : true
            },
            legalImg2: {
                type: "image",
                label: "法人身份证反面",
                sizeType:"cut",//"compress",
                size:{
                    width:800,
                    height:600
                },
                clickImg : true,
            },
            legalImg: {
                type: "image",
                label: "法人身份证正面",
                sizeType:"cut",//"compress",
                size:{
                    width:800,
                    height:600
                }
            },
            legalPersonCode: {
                type: "text",
                label: "法人身份证号",
                placeHolder:"请与身份证保持一致"
            },
            logo: {
                type: "image",
                label: "店铺图标",
                sizeType:"cut",
                size:{
                    width:128,
                    height:128
                },
                editable: true
            },
            shopName: {
                type: "text",
                label: "商家名称",
				className:"large-width",
                placeHolder:"请输入商家名称"
            },
            address: {
                type: "text",
                label: "详细地址"
            },
            amount:{
                type : "text",
                label: "金额"
            },
            brief: {
                type: "textarea",
                label: "店铺简介"
            },
            svcPhone: {
                type: "tel",
                label: "客服电话"
            },
            svcWx: {
                type: "text",
                label: "客服微信"
            },
            svcQQ: {
                type: "text",
                label: "客服QQ"
            },
            contactName: {
                type: "text",
                label: "联系人",
				className:"small-width",
                placeHolder:"请输入联系人"
            },
            contactPhone: {
                type: "tel",
                label: "联系电话",
				className:"middle-width",
                placeHolder:"请输入联系电话"
            },
            contactWx: {
                type: "text",
                label: "店主微信"
            },
            contactQQ: {
                type: "text",
                label: "店主QQ"
            },
            alipayAccount: {
                type: "text",
                label: "支付宝账号"
            },
            bankName: {
                type: "text",
                label: "开户行"
            },
            bankOwner : {
                type: "text",
                label: "账户名称"   
            },
            bankAccountName: {
                type: "text",
                label: "账户名"
            },
            bankAccount : {
                type: "text",
                label: "银行账号"    
            },
            tsCode : {
                type: "text",
                label: "流水号"    
            },
            bankAccountCode: {
                type: "text",
                label: "账号"
            },
            payee: {
                type: "text",
                label: "收款人"
            },
            fiName: {
                type: "text",
                label: "财务联系人姓名"
            },
            fiPhone: {
                type: "text",
                label: "财务联系人电话"
            },
            fiQQ: {
                type: "text",
                label: "财务联系人QQ"
            },
            registerDate: {
                type: "date",
                label: "成立日期"
            },
            empTotal: {
                type: "text",
                label: "员工数量",
                placeHolder:"必须为大于0的正数"
            },
            tecTotal: {
                type: "text",
                label: "技术人数",
                placeHolder:"必须为小于等于员工人数的正数"
            },
            email: {
                type: "text",
                label: "电子邮件",
                placeHolder:"abc.cba@163.com"
            },
            website: {
                type: "text",
                label: "公司网址"
            },
            orgCode: {
                type: "text",
                label: "组织机构代码"
            },
            shopLevel:{
                type:"options",
                label:"客户级别",
                options:config.shopLevel||{
                    
                },
                canEdit:true
            },
            //合作伙伴相关按钮
            completePartnerButton:{
                type:"button",
                label:"保存",
                action:"completeSave",
                buttonClass:"fullButton"
            },
            deletePartnerButton:{
                type:"button",
                label:"删除分销商",
                action:"deletePartner",
                buttonClass:"fullButton"
            },
            deleteSupplyerButton:{
                type:"button",
                label:"删除供应商",
                action:"deleteSupplyer",
                buttonClass:"fullButton"
            },
            beingPartnerButton_1:{
                type:"button",
                label:"同意成为分销商",
                action:"agreeAdd",
				buttonClass:"margin10"
            },
            beingPartnerButton_2:{
                type:"button",
                label:"不同意成为分销商",
                action:"disAgree",
				buttonClass:"margin10"
            },
            //Xmapp特有开始************
            "shopType":{
                type:"options",
                label:"经营主体",
                options:config.shopType||{
                    "2001":"服务机构",
                    "2002":"养殖企业",
                    "2003":"合作社",
                    "2004":"养殖户",
                    "2005":"养殖场",
                    "9999":"未分类"
                },
                canEdit:true
            },
            //列表选项编辑
            "industryType":{
                type:"options",
                label:"产业类别",
                options:{
                    "批发业":{
                        "100511":"农、林、牧产品批发",
                        "100512":"食品、饮料及烟草制品批发",
                        "100513":"纺织、服装及家庭用品批发",
                        "100514":"文化、体育用品及器材批发",
                        "100515":"医药及医疗器材批发",
                        "100516":"矿产品、建材及化工产品批发",
                        "100517":"机械设备、五金产品及电子产品批发",
                        "100518":"贸易经纪与代理",
                        "100519":"其他批发业"
                    },
                    "零售业":{
                        "100521":"综合零售",
                        "100522":"食品、饮料及烟草制品专门零售",
                        "100523":"纺织、服装及日用品专门零售",
                        "100524":"文化、体育用品及器材专门零售",
                        "100525":"医药及医疗器材专门零售",
                        "100526":"汽车、摩托车、燃料及零配件专门零售",
                        "100527":"家用电器及电子产品专门零售 ",
                        "100528":"五金、家具及室内装饰材料专门零售",
                        "100529":"货摊、无店铺及其他零售业"
                    },
                    "装卸搬运和运输代理业":{
                        "100581":"装卸搬运",
                        "100582":"运输代理业"
                    },
                    "仓储业":{
                        "100591":"谷物、棉花等农产品仓储",
                        "100599":"其他仓储业"
                    },
                    "住宿业":{
                        "100611":"旅游饭店",
                        "100612":"一般旅馆",
                        "100619":"其他住宿业"
                    },
                    "餐饮业":{
                        "100621":"正餐服务",
                        "100622":"快餐服务",
                        "100623":"饮料及冷饮服务",
                        "100629":"其他餐饮业"
                    },
                    "租赁业":{
                        "100711":"机械设备租赁",
                        "100712":"文化及日用品出租"
                    },
                    "商务服务业":{
                        "100721":"企业管理服务",
                        "100722":"法律服务",
                        "100723":"咨询与调查",
                        "100724":"广告业",
                        "100725":"知识产权服务",
                        "100726":"人力资源服务",
                        "100727":"旅行社及相关服务",
                        "100728":"安全保护服务",
                        "100729":"其他商务服务业"
                    },
                    "居民服务业":{
                        "100791":"家庭服务",
                        "100792":"托儿所服务",
                        "100793":"洗染服务",
                        "100794":"理发及美容服务",
                        "100795":"洗浴服务",
                        "100796":"保健服务",
                        "100797":"婚姻服务",
                        "100798":"殡葬服务",
                        "100799":"其他居民服务业"
                    },
                    "机动车、电子产品和日用产品修理业":{
                        "100801":"汽车、摩托车修理与维护",
                        "100802":"计算机和办公设备维修",
                        "100803":"家用电器修理",
                        "100809":"其他日用产品修理业"
                    },
                    "其他服务业":{
                        "100811":"清洁服务",
                        "100819":"其他未列明服务业"
                    }
                },
                canEdit:true
            },
            //Xmapp特有结束************
            rejectedReason: {
                type: "richText",
                canEdit:false,
                label: "驳回原因"
            },
            "lon":{
                type:"text",
                label:"经度",
				className:"small-width"
            },
            "lat":{
                type:"text",
                label:"纬度",
				className:"small-width"
            },
            //地理位置编辑
            "lon,lat":{
                type:"location",
                label:"地理位置",
                //用于联动区划，传入省市区ID字段名，不联动则传入空字符串
                distFields:"provinceId,cityId,countId",
                //区域划分地址字段名(显示字段名)
                distFieldsStr:"town",
                //详细地址
                detailAddrField:"address",
                //是否可编辑
                canEdit:true
            },
            // 只选区县
            "provinceId,cityId,countId":{
                type:"district",
                label:"区县",
                fixedUpDis:{
                    upDis:[
                        "57a936a0e026905d4c92f647",
                        "57a936a0e026905d4c92f648"
                    ]
                }
            },
            
            //区划编辑,省、市、区县、地址文本
            "provinceId,cityId,countId,town":{
                type:"district",
                label:"省-市-区县"
            },
            //乡村-镇
            //乡镇-村
            "countId,townId,villageId,locationName":{
                type:"village",
                label:"乡镇-村"
            },
            // 对象列表
            "tranRegions":{
                type:"objects",
                label:"销售区域",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countId,remark",
                        type:"district",
						enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                }
            },
            town:{
                type:"text",
                label:"省市区县"
            },
            locationName:{
                type:"text",
                label:"乡镇/村"
            },
			isVerified:{
                type:"checkbox",
                label:"是否认证",
				className:"small-width"
			},
            //**************
            saveButton:{
                type:"button",
                label:"确定",
                action:"onSave"
            },
            saveVerfyBut:{
                type:"button",
                label:"提交认证",
                action:"goToVerifiy",
                buttonClass:"fullButton"
            },
            rSaveButton:{
                type:"button",
                label:"显示",
                action:"onRSave"
            },
            shopBaseSaveButton:{
                type:"button",
                label:"确定",
                action:"onShopBaseSave"
            },
            
            
            //申请服务认证相关按钮
            //提交认证
            shopServiceVerifyPostButton:{
                type:"button",
                label:"提交",
                action:"onShopServiceVerifyPost"
            },
            //保存认证信息，不提交
            shopServiceVerifySaveButton:{
                type:"button",
                label:"保存",
                action:"onShopServiceVerifySave"
            },
            //认证通过
            shopVerifyButton:{
                type:"button",
                label:"认证",
                action:"onShopVerify"
            },
            //认证驳回
            shopVerifyRejectButton:{
                type:"button",
                label:"驳回",
                action:"onShopVerifyReject"
            },
            //撤销认证标志
            shopVerifyCancelButton:{
                type:"button",
                label:"取消认证",
                action:"onShopVerifyCancel"
            },
            
            
            
			//将地址信息拼接的详细地址
			combinedAddress: {
				label: '地址',
				formatter: function(town,shopInfo){return (shopInfo.town||"")+(shopInfo.addressName?"-"+shopInfo.addressName:"")+(shopInfo.address?"-"+shopInfo.address:"")},
				className:"large-width"
			},
			//一个店铺的认证相关按钮
			shopVerifyActions:{
				type:"text",
				label:"",
				formatter:function(action,shopInfo){
					var v = "<div class='button' cq-action='deleteShop'>删除</div><div class='button' onclick='window.moveToView(\"merchantDetail\",\""+shopInfo._id+"\");'>详情</div>";
					if(shopInfo.isVerified) v +="<div class='button' cq-action='cancelVerifyShop'>取消认证</div>"
					else if(shopInfo.isVerifySubmit==1 ) 
						v +="<div class='button' cq-action='verifyShop'>认证</div>"+
							"<div class='button' cq-action='rejectVerifyShop'>驳回</div>";
					return v;
				}

			},
            businessVerificationActions:{
				type:"text",
				label:"",
				formatter:function(action,shopInfo){
					var v = "<div class='button' cq-action='deletePartner'>删除</div><div class='button' onclick='window.moveToView(\"businessVerification\",\""+shopInfo._id+"\");'>详情</div>";
					if(shopInfo.isVerified) v +="<div class='button' cq-action='cancelVerifyPartner'>取消认证</div>"
					else if(shopInfo.isVerifySubmit==1 ) 
						v +="<div class='button' cq-action='verifyPartner'>认证</div>"+
							"<div class='button' cq-action='rejectVerifyPartner'>驳回</div>";
					return v;
				}
            },
            availableAmount: {
                type: "text",
                label: "店铺可用余额"
            },
            pendingAmount: {
                type: "text",
                label: "待结算余额"
            },
            balanceTransact:{
                type:"button",
                label:"充值",
                action:"getTransact",
                buttonClass:"margin10"
            },
            balanceDeposit:{
                type:"button",
                label:"提现",
                action:"getDeposit",
                buttonClass:"margin10"
            },
            comfirmDeposit:{
                type:"button",
                label:"确认提现",
                action:"getComfirmDepositAction"
            },
            amountSum:{
                type: "text",
                label: "店铺待审核金额"
            },
            amount:{
                type: "text",
                label: "提现金额"
            },
            amount1:{
                type: "text",
                label: "缴纳金额"
            },
            showAmount:{
                type: "text",
                label: "生效时间",
                placeHolder:"缴纳后立即生效"
            },
            onLineAction:{
                type:"button",
                label:"在线缴纳",
                action:"onLineActionGo"
            },
            outLineAction:{
                type:"button",
                label:"线下转账",
                action:"outLineActionGo"
            },
            shopBankName:{
                type: "text",
                label: "收款方开户行"
            },
            shopAccountName:{
                type: "text",
                label: "收款方户名"
            },
            shopAccountCode:{
                type: "text",
                label: "收款方开户账号"
            },
            bankName:{
                type: "text",
                label: "付款方开户行"
            },
            bankOwner:{
                type: "text",
                label: "付款方账户名"
            },
            bankAccount:{
                type: "text",
                label: "付款方开户账号"
            },
            amount2:{
                type: "text",
                label: "充值金额"
            },
            tsCode:{
                type: "text",
                label: "交易流水号"
            },
            remark:{
                type: "textarea",
                label: "备注"
            },
            comfirmDeposit:{
                type:"button",
                label:"确认提现",
                action:"getComfirmDepositAction"
            },
            confirmGoMoney:{
                type:"button",
                label:"确认充值",
                action:"getConfirmGoMoney"
            },
            balancet:{
                type:"button",
                label:"交易明细",
                action:"getChangeWay"
            },
            /*"shopName,_id,logo":{
                type:"link",
                label:"我的店名是{shopName}",
                showLogo:true,
                rightText:"{shopName}的小店",
                href:"/w/home/{_id}",
                icon:"{logo}"
            },*/
            "shopName,_id":{
                type:"link",
                showLogo:true,
                label:"{shopName}",
                rightText:"去看看",
                href:"#supplyBus-{_id}"
            },
            readonlyLink:{
                type:"link",
                label:"只读点击",
                href:"",
                icon:""
            },
            listActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = 
                        (data.isVerified == false?"<div class='button' cq-action='verify'>审核</div>":"")+
						"<div class='button' onclick='window.moveToView(\"balanceDetail\",\""+data._id+"\");'>查看详情</div>";
					return v;
				},
				className:"large-width"
            },
            "fromShopId.address": {
                type: "text",
                label: "地址"
            },
            "fromShopId.shopName": {
                type: "text",
                label: "商家名称"
            },
            "userId.pName": {
                type: "text",
                label: "姓名"
            },
            "userId.userName": {
                type: "text",
                label: "手机号"
            },
            "inviter.phone" : {
                type : "text",
                label : "邀请人电话号码"
            },
            role:{
                type:"options",
                label:"角色",
                options:{
                    "0": '普通管理员',
                    "1": '高级管理员',
                    "2": '采购员',
                    "3": '销售员',
                    "4": '财务'
                },
                canEdit:true
            },
            articleActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='deleteArticle'>删除</div><div class='button' onclick='window.moveToView(\"news\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            },
            addShopAdminSaveButton:{
                type:"button",
                label:"确定",
                action:"onAddShopAdminSave"
            },
            "password": {
                type: "password",
                label: "密码",
                placeHolder:"请输入密码"
            },
            "repassword": {
                type: "password",
                label: "确认密码",
                placeHolder:"请输与密码保持一致"
            },
            shopAdminActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='deleteArticle'>删除</div><div class='button' onclick='window.moveToView(\"addShopAdmin\",\""+data.userId._id+"\");'>编辑</div>";
					return v;
				}
            },
            tranRegion:{
                type: "text",
                label: "销售区域"
            },
            deleteMerchantButton:{
                type:"button",
                label:"删除商家",
                action:"deleteMerchan",
				buttonClass:"margin10"
            },
            recommendeMerchantButton:{
                type:"button",
                label:"推荐商家",
                action:"recommendeMerchant",
				buttonClass:"margin10"
            },
            noRecommendeButton:{
                type:"button",
                label:"撤销推荐",
                action:"cancelRecommende",
				buttonClass:"margin10"
            },
            verificationButton:{
                type:"button",
                label:"标记认证",
                action:"doVerification",
				buttonClass:"margin10"
            },
            noVerificationButton:{
                type:"button",
                label:"取消认证",
                action:"cancelVerification",
				buttonClass:"margin10"
            },
            backVerificationButton:{
                type:"button",
                label:"驳回认证",
                action:"backVerification",
				buttonClass:"margin10"
            },
            tsType :{
                type:"options",
                label : "类型",
                options:{
                    "" : "暂无交易",
                    "1": "会员购买(在线支付金额)",
                    "2":"支付手续费",
                    "3":"交易手续费",
                    "4":"交易补贴",
                    "5":"提现",
                    "6":"充值"
                }
            },
            payType :{
                type:"text",
                label : "支付方式"
            },
            payLogId :{
                type:"text",
                label : "交易单号"
            },
            tsAmount :{
                type:"text",
                label : "交易金额"
            },
            createAt : {
                type : "date",
                label : "交易时间"                
            },
            downStatisticButton:{
                type:"button",
                label:"导出",
                action:"getExport",
                buttonClass:"fullButton"
            },
            statisticName :{
                type:"text",
                label : "姓名"
            },
            statisticUserName :{
                type:"text",
                label : "电话"
            },
            statisticShopCount :{
                type:"text",
                label : "邀请商家数"
            },
            statisticVerifiedCount :{
                type:"text",
                label : "已认证商家数"
            },
            businessVerifyButton :{
                type:"button",
                label:"标记认证",
                action:"businessVerifyAction"
            },
            businessRejectButton :{
                type:"button",
                label:"驳回认证",
                action:"businessRejectAction"
            },
            businessCancelButton :{
                type:"button",
                label:"取消认证",
                action:"businessCancelAction"
            },
            businessVerfyingButton :{
                type:"button",
                label:"审核中",
                action:"getNullAction"
            },
            businessVerfiedButton :{
                type:"button",
                label:"已审核",
                action:"getNullAction"
            },
            exportButton:{
                type:"button",
                label:"导出",
                action:"shopExport",
                buttonClass:"fullButton"
            }
            
        },
        getNullAction: function(){
            
        },
        //平台商家导出
        exportLayout : function(){
            if(!this.shopLayout){
                this.shopLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "exportButton"
                    ])
                }];
            }
            return this.shopLayout;
        },
        //平台商家数据导出功能 11-15 程磊
        shopExport : function(e,dataLayout){
            var layout = dataLayout.byId("resultList");
            var list = layout.getCqQueryInfo();
            var query = list.query;
            var url = shop.getShopByPlatform();
            // var queryString = "";
            // for(var item in query){
                // queryString += "&" + item + "=" + query[item];
            // }
            // url += queryString;
            var cols = this.getFormItems([
                    "shopName",
                    "town",
                    "address",
                    "contactName",
                    "contactPhone",
                    "companyName",
                    "legalPerson",
                    "legalPersonCode",
                    "tranRegion",
                    "inviter.phone"
                ]);         
            xlsx.exportData(url,query,cols,Date.now().toString());
        },
        //销售员统计
        getExport : function(){
            var url = shop.summaryByInviter();
            var cols = [];
            cols[0] = {
                className:"large-width",
                id:"0",
                field:"inviter.pName",
                label:"姓名"
            };
            cols[1] = {
                className:"large-width",
                id:"1",
                field:"inviter.userName",
                label:"手机号"
            };
            cols[2] = {
                className:"large-width",
                id:"2",
                field:"shopCount",
                label:"邀请商家数"
            };
            cols[3] = {
                className:"large-width",
                id:"3",
                field:"verifiedCount",
                label:"已认证商家数"
            };
            
            xlsx.exportData(url,{
                },cols,Date.now().toString());
        },
        getPartnerUrl:function(){
            return shop.getPartnerUrl();
        },
        //销售员统计
        getDownStatisticLayout : function(){
            if(!this.downStatisticLayout){
                this.downStatisticLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "downStatisticButton"
                    ])
                }];
            }
            return this.downStatisticLayout;
        },
        //销售员统计
        getSaleStatisticParam :function(params){
            var query = {};
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
        //销售员统计
        getSaleStatisticProp:function(data){
            var listData = data;
            if(null == listData.inviter||!listData.inviter){
                listData.inviter = {};
            }
			return {
                label:"<div class='hflex'><div style='width: 50%;'>姓名："+((listData.inviter.pName||listData.inviter.nickName)||"")+"</div>"+
                "<div>手机号："+(listData.inviter.userName||"")+"</div></div>"+
				"<div  class='hflex'><div style='width: 50%;'>邀请商家数："+(listData.shopCount||"")+"</div>"+
				"<div>已认证商家数："+(listData.verifiedCount||"")+"</div></div>",
                variableHeight:true,
                data:listData
            };
		},
        //销售员统计
        getSaleStatisticUrl : function(){
            return shop.summaryByInviter();
        },
        //农庄宝认证布局
        getDeftVerifyLayout : function (){
            this.appType = "default";
            if(!this.deftVerifyLayout){
                //店铺认证
                this.deftVerifyLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "logo",
                    "companyName",
                    "legalPerson",
                    "legalPersonCode",
                    "contactName",
                    "contactPhone",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2",
                    "rejectedReason",
                    "lon,lat",
                    "provinceId,cityId,countId,town",
                    "address",
                    //"tranRegions",
                    "saveVerfyBut"])
                }];
            }
            return this.deftVerifyLayout;
        },
        //删除商家
        deleteMerchan : function(data){
            var targetShopId = data._id
			var r=confirm("删除商家后，该店铺将不能再次使用，是否确认删除！");
			if (r==true) {
				window.busy();
				shop.removeShop(targetShopId).then(function (data) {
					window.free();
					if (data && data.data && data.data.ok === 1){
						history.back();
					} else {
						alert('服务器繁忙！');
					}
				});
			}            
        },
        //推荐商家
        recommendeMerchant : function(data){
            window.busy();
            shop.setRecommend({isRecommend : true,targetShopId : data._id}).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //取消推荐
        cancelRecommende : function(data){
            window.busy();
            shop.setRecommend({
                isRecommend : false,
                targetShopId : data._id
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //标记认证
        doVerification : function(data){
            window.busy();
            shop.verifyShopAut({
                targetShopId : data._id
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //取消认证
        cancelVerification : function(data){
            window.busy();
            shop.cancelShopAut({
                targetShopId : data._id
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //驳回认证
        backVerification : function(data,views){
            if (!views.view) {
				var view = views.getParent();
				while (view) {
					if (!view.show) {
						view = view.getParent();
					} else {
						break;
					}
				}
				views.view = view;
			}
            window.busy();
			editor.startEdit("", views.view).then(lang.hitch(this, function (value) {     
                shop.rejectShopAut({targetShopId : data._id,rejectedReason : value}).then(lang.hitch(this, function (data) {
                    window.free();
                    if (data && data.data && data.data.ok === 1){
                        history.back();
                    } else {
                        if(data.data.ok === 0&&data.data.msg === "no rejectedReason"){
                            alert("请输入驳回原因！");
                        }else{
                            alert("服务器繁忙,请稍后再试！");
                        }
                    }
                }));
            }));
        },
        //重盐App商家管理
        getMerchantDetailLayout : function(){
            if(!this.merchantDetailLayout){
                this.merchantDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "logo",
                    "shopType",
                    "shopName",
                    "lon,lat",
                    "provinceId,cityId,countId,town",
                    "address",
                    "contactName",
                    "contactPhone",
                    "companyName",
                    "legalPerson",
                    "legalPersonCode",
                    "tranRegion",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2",
                    "backVerificationButton",
                    "noVerificationButton",
                    "verificationButton",
                    "deleteMerchantButton",
                    "recommendeMerchantButton",
                    "noRecommendeButton"
                    ])
                }];
            }
            return this.merchantDetailLayout;
        },
        //重盐App商家管理
        onMerchantDetailReloaded : function(widget){
            var merchantData = widget.__data;
            var btns = [
            "backVerificationButton",
            "noVerificationButton",
            "verificationButton",
            "recommendeMerchantButton",
            "noRecommendeButton"]
            widget.hideByFields(btns);
            widget.disableByFields([
                    "logo",
                    "shopType",
                    "shopName",
                    "lon,lat",
                    "provinceId,cityId,countId,town",
                    "address",
                    "contactName",
                    "contactPhone",
                    "companyName",
                    "legalPerson",
                    "legalPersonCode",
                    "tranRegion",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2"]);
            //推荐/撤销 推荐
            if(merchantData.isRecommend){
                //显示推荐，隐藏不推荐
                //  替换显示
                widget.showByFields(["noRecommendeButton"]);
                widget.hideByFields(["recommendeMerchantButton"]);
            }else{
                widget.showByFields(["recommendeMerchantButton"]);
                widget.hideByFields(["noRecommendeButton"]);
            }
            //驳回认证
            if(merchantData.isVerifySubmit === -1 && !merchantData.isVerified){
                widget.hideByFields(["noVerificationButton"]);
                widget.hideByFields(["verificationButton"]);
                widget.hideByFields(["backVerificationButton"]);
            }
            //待审核
            if(merchantData.isVerifySubmit === 1 && !merchantData.isVerified){
                widget.hideByFields(["noVerificationButton"]);
                widget.showByFields(["verificationButton"]);
                widget.showByFields(["backVerificationButton"]);
            }
            //已认证
            if(merchantData.isVerifySubmit === 2 && merchantData.isVerified){
                widget.showByFields(["noVerificationButton"]);
                widget.hideByFields(["verificationButton"]);
                widget.hideByFields(["backVerificationButton"]);
            }
        },
        //重盐App商家管理
        initMerchantDetailData : function(data){
            var id = data.cqViewParam.params;
            return shop.loadById(id).then(lang.hitch(this,function(data){
                return data.data;
            }));
        },
        //重盐（网站）：编辑管理员/添加管理员
        initAddShopAdminData : function(data){
            this.updateAdmin = false;
            if(data.cqViewParam.params){
                this.updateAdmin = true;
                return shopUser.loadById({userId: data.cqViewParam.params }).then(lang.hitch(this,function(userData){
                    return userData.data.item;
                }));
            }
        },
        //重盐（网站）：添加管理员
        getAddShopAdminLayout : function(){
            if(!this.addShopAdminLayout){
                this.addShopAdminLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "userId.userName",
                    "userId.pName",
                    "password",
                    "repassword",
                    "role",
                    "addShopAdminSaveButton"])
                }];
            }
            return this.addShopAdminLayout;
        },
        adminFeild : function(num){
            if(num == "PPR"){
                return ["userId.pName","password","repassword"];
            }
            if(num == "PR"){
                return ["password","repassword"];
            }
            if(num == "UP"){
                 return ["userId.userName","userId.pName"];
            }
            //手机号，姓名，角色，按钮
            if(num == "UPRA"){
                return ["userId.userName","userId.pName","role","addShopAdminSaveButton"];
            }if(num == "URA"){
                return ["userId.userName","role","addShopAdminSaveButton"];
            }
        },
        //重盐（网站）：添加管理员
        onAddShopAdminReloaded : function(widget){
            widget.hideByFields(["userId.pName","password","repassword"]);
            //判断为编辑
            if(this.updateAdmin == true){
                //显示姓名，手机号，角色，按钮；姓名手机号不可编辑
                //  显示字段
                widget.showByFields(this.adminFeild("UPRA"));
                widget.hideByFields(this.adminFeild("PR"));
                //  不可编辑字段
                widget.disableByFields(this.adminFeild("UP"));
            }else{
                //  显示字段
                widget.showByFields(this.adminFeild("URA"));
                widget.hideByFields(this.adminFeild("PPR"));
                //  编辑字段
                widget.enableByFields(this.adminFeild("UP"));
            }
        },
        //重盐（网站）：添加管理员(弃用！)
        fieldChangeMethodTest : function(widget,field,value){
            if(this.updateAdmin == false){
                if(field == "userId.userName"){
                    user.checkPlatformUser(value).then(lang.hitch(this,function(data){
                        if(data.data.ok == 1){
                            this.adminState = 1;
                            widget.hideByFields(["userId.pName","password","repassword"]);
                        }else{
                            alert("没有当前用户,请输入密码创建");
                            this.adminState = 2;
                            widget.showByFields(["userId.pName","password","repassword"]);
                        }
                    }));
                }
            }
        },
        checkFiles : function(data){
            if(data['userId.pName']){
                data.pName = data['userId.pName'];
                delete data['userId.pName'];
            }
            if(data['userId.userName']){
                data.userName = data['userId.userName'];
                delete data['userId.userName'];
            }
        },
        saveAction : function(adminData){
            shopUser.save(adminData).then(lang.hitch(this, function(shopData) {
                if (shopData.data.ok === 1) {
                    history.back();
                    this.updateAdmin = false;
                } else {
                    alert("服务器繁忙，请稍后再试！");
                    return;
                }
            }));
        },
        //重盐（网站）：添加管理员
        onAddShopAdminSave : function(adminData,widget){
            if(this.updateAdmin == false){
                user.checkPlatformUser(adminData['userId.userName']).then(lang.hitch(this,function(data){
                    if(data.data.ok == 1){
                        this.checkFiles(adminData);
                        adminData.userId = data.data.item._id;
                        this.saveAction(adminData);
                    }else{
                        if (!adminData.password || !adminData.repassword) {
                            alert("没有当前用户,请输入密码创建");
                            widget.showByFields(["userId.pName","password","repassword"]);
                        }else{
                            if(!adminData['userId.pName']){
                                alert("请输入姓名！");
                                return;
                            }
                            if(!adminData.password){
                                alert("请输入密码！");
                                return;
                            }
                            if(!adminData.repassword){
                                alert("请确认密码！");
                                return;
                            }
                            if (adminData.password !== adminData.repassword) {
                                alert("两次密码不一致");
                                return;
                            }else{
                                this.checkFiles(adminData);
                                this.saveAction(adminData);
                                widget.hideByFields(["userId.pName","password","repassword"]);
                            }
                        } 
                    }
                }));
            }else{
                this.saveAction(adminData);
            }
        },
        //重盐（网站）：商家管理员
        getShopAdminParam: function(params){
            var query = {};
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
        //重盐（网站）：商家管理员
        getShopAdminListUrl : function(){
            return shopUser.loadUsers();
        },
        //重盐（网站）：商家管理员
        getShopAdminLayout: function() {
            if(!this.shopAdminLayout){
                this.shopAdminLayout = this.getFormItems([
                "userId.pName",
                "userId.userName",
                "role",
                "shopAdminActions"],false);
            }
            return this.shopAdminLayout;
        },
        //重盐（网站）：充值
        getBalanceTransactionLayout : function(){
            if(!this.balanceTransactionLayout){
                this.balanceTransactionLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "showAmount",
                    "amount1",
                    "availableAmount",
                    "shopBankName",
                    "shopAccountName",
                    "shopAccountCode",
                    "bankName",
                    "bankOwner",
                    "bankAccount",
                    "amount2",
                    "tsCode",
                    "remark",
                    "onLineAction",
                    "outLineAction",
                    "confirmGoMoney"])
                }];
            }
            return this.balanceTransactionLayout;
        },
        loadgetBalanceTransactionInfo : function(){
            var dfList = new DeferredList([
                shop.loadCurrentShop(),
                shop.loadCurrentFromPaltShop()
            ]);
            return dfList.then(lang.hitch(this,function(result){
                var data = result[0][1];
                var paltData = result[1][1];
                var initData = ({
                    availableAmount : data.data.availableAmount.toFixed(2),
                    shopBankName : paltData.data.bankName,
                    shopAccountName : paltData.data.bankAccountName,
                    shopAccountCode : paltData.data.bankAccountCode
                });
                initData.showAmount = "缴纳后立即生效";
                return initData;
            }));
        },
        onBalanceTransactionReloaded : function(widget){
            var btns = [
                "showAmount",
                "availableAmount",
                "shopBankName",
                "shopAccountName",
                "shopAccountCode"];
            widget.disableByFields(btns);
            this.upBalanceTransactionBtns = [
                "showAmount",
                "amount1",
                "availableAmount",
            ];
            this.balanceTransactionBtns = [
                //"confirmGoMoney",
                "shopBankName",
                "shopAccountName",
                "shopAccountCode",
                "bankName",
                "bankOwner",
                "bankAccount",
                "amount2",
                "tsCode",
                "remark"];
            widget.hideByFields(this.balanceTransactionBtns);
        },
        getConfirmGoMoney : function(data){
            if(this.tsType == 1){
                data.amount=data.amount1;
            }else if(this.tsType == 2){
                data.amount=data.amount2;
            }
            if(data.amount == 0||isNaN(data.amount)){
                alert("请检查缴纳金额格式是否正确，数额是否大于0！");
                return;
            }
            // 如果是线下转账
            if(this.tsType == 2){
                if(!data.bankName || !data.bankAccount || !data.bankOwner){
                    alert("付款方信息填写不完整");
                    return;
                }
                shopdata = this.deleteSavaData(shopdata);
                data.ioType = 0;
                //data.amount = data.amount1;
                window.busy();
                shopPayLog.save(data).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok === 1){
                        history.back();
                    }else{
                        alert("充值失败");
                    }
                }));
            }
        },
        onLineActionGo : function(data,widget){
            this.tsType = 1;
            widget.hideByFields(this.balanceTransactionBtns);
            widget.showByFields(this.upBalanceTransactionBtns);
        },
        outLineActionGo : function(data,widget){
            this.tsType = 2;
            widget.showByFields(this.balanceTransactionBtns);
            widget.hideByFields(this.upBalanceTransactionBtns);
        },
        //重盐（网站）：提现
        getComfirmDepositLayout : function(){
            if(!this.comfirmDepositLayout){
                this.comfirmDepositLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "availableAmount",
                    "amountSum",
                    "amount",
                    "comfirmDeposit"])
                }];
            }
            return this.comfirmDepositLayout;
        },
        loadComfirmDepositInfo : function(){
            var initData;
            var dfList = new DeferredList([
                // 获取店铺的可用余额
                shop.loadCurrentShop(),
                // 获取店铺已申请提现，但为审核的总金额
                shopPayLog.loadByShopId({isVerified:false,ioType:1})
            ]);
             return dfList.then(lang.hitch(this,function(result){
                var data = result[0][1];
                var shopdata = result[1][1];
                var amountSum = 0;
                if(shopdata.data.ok === 1){
                    shopdata = shopdata.data.items;
                    for(var i=0;i<shopdata.length;i++){
                        amountSum+=shopdata[i].amount;
                    }
                }
                initData = {
                    availableAmount:data.data.availableAmount.toFixed(2),
                    bankName : data.data.bankName,
                    bankOwner : data.data.bankAccountName,
                    bankAccount : data.data.bankAccountCode,
                    amountSum : amountSum.toFixed(2)
                }
                return initData;
            }));
        },
        onComfirmDepositReloaded : function(widget){
            var btns = [
            "availableAmount",
            "amountSum"];
            widget.disableByFields(btns);
        },
        getComfirmDepositAction : function(data){
            data.ioType = 1;
            if(data.amount == 0||isNaN(data.amount)){
                alert("请检查缴纳金额格式是否正确，数额是否大于0！");
                return;
            }
            window.busy();
            shopPayLog.save(data).then(lang.hitch(this,function(data){
                window.free();
                if(data.data.ok === 1){
                    alert("提现申请已经发送，请等待平台审核");
                    history.back();
                }else{
                    alert("提现申请失败");
                }
            }));
        },
        //重盐（网站）
        onShopBalanceReloaded : function(widget){
            var btns = [
            "availableAmount",
            "pendingAmount"];
            widget.disableByFields(btns);
        },
        //重盐（网站）:充值
        getTransact : function(){
            window.moveToView("shopBalanceTransaction");
        },
        //重盐（网站）:提现
        getDeposit : function(){
            window.moveToView("shopBalanceDeposit");
        },
        //重盐（网站）:商家余额
        loadShopBalanceInfo: function(){
            return shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 显示信息
                data.data.availableAmount = data.data.availableAmount.toFixed(2);
                data.data.pendingAmount = data.data.pendingAmount.toFixed(2);
                return data.data;
            }));
        },
        //重盐（网站）：商家余额
        getShopBalanceLayout: function(){
            if(!this.shopBalanceLayout){
                this.shopBalanceLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "availableAmount",
                    "pendingAmount",
                    "balanceTransact",
                    "balanceDeposit",
                    "readonlyLink"])
                }];
            }
            return this.shopBalanceLayout;
        },
        getShopBalanceOffLayout: function(){
            if(!this.shopBalanceOffLayout){
                this.shopBalanceOffLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "balancet"
                    ])
                }];
            }
            return this.shopBalanceOffLayout;
        },
        getShopLogoMenu: function() {
            return shop.loadById(shop.getShopId()).then(function(data) {
                if (data.data) {
                    return {
                        logo: data.data.logo,
                        label: data.data.shopName
                    };
                } else {
                    return null;
                }
            });
        },
        onShopChanged: function() {},
        shopClicked: function() {
            window.moveToView("home");
        },
        //重盐合作伙伴详情
        getPartnerDetailLayout : function(){
            var role = user.getCurrentUserRole();
            if(role == 2 || role == 3){
                return [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo",
                        "shopName,_id",
                        "shopName",
                        "lon,lat",
                        "provinceId,cityId,countId,town",
                        "address",
                        "contactName",
                        "contactPhone",
                        "companyName",
                        "legalPerson",
                        "shopLevel",
                        "businessLicense",
                        "tranRegions",
                        "deletePartnerButton",
                        "deleteSupplyerButton",
                        "completePartnerButton",
                    ])
                }];    
            }else{
                return [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo",
                        "shopName,_id",
                        "shopName",
                        "lon,lat",
                        "provinceId,cityId,countId,town",
                        "address",
                        "contactName",
                        "contactPhone",
                        "companyName",
                        "legalPerson",
                        "shopLevel",
                        "businessLicense",
                        "tranRegions",
                        "beingPartnerButton_1",
                        "beingPartnerButton_2",
                        "completePartnerButton",
                        "deletePartnerButton",
                        "deleteSupplyerButton",
                    ])
                }];                   
            }
        },
        //重盐，合作伙伴数据初始化
        initPartnerDetailData : function(data){
            var id = data.cqViewParam.params;
            return partner.loadById(id).then(lang.hitch(this, function (shopData) {
                var data = shopData.data;
                return data;
            }));
        },
        onPartnerReloaded : function(widget){
            var btns = [
                "deletePartnerButton",
                "beingPartnerButton_1",
                "beingPartnerButton_2",
                "deleteSupplyerButton"
            ];
            //隐藏所有按钮
            widget.hideByFields(btns);
            //其他字段不可编辑
            var fields = [
                "logo",
                //"shopType",
                "shopName",
                "lon,lat",
                "provinceId,cityId,countId,town",
                "address",
                "contactName",
                "contactPhone",
                "companyName",
                "legalPerson",
                //"legalPersonCode",
                "businessLicense",
                "tranRegions"
            ];
            widget.disableByFields(fields);
            //根据supplierState状态显示：1、申请中 2、同意 3、拒绝 
            var label = "";
            //若是已审核的分销商则应该是2，申请中则是1，默认为3
            if(widget.__data.customerState == 1){
                //显示同意和不同意像个按钮
                widget.showByFields(["beingPartnerButton_1","beingPartnerButton_2"]);
                widget.hideByFields(["deletePartnerButton","deleteSupplyerButton"]);
            }
            if(widget.__data.isCustomer){
                //显示删除按钮
                widget.showByFields(["deletePartnerButton"]);
                widget.hideByFields(["beingPartnerButton_1","beingPartnerButton_2","deleteSupplyerButton"]);
            }
            if((widget.__data.isSupplier == true)&&(widget.__data.isDelete !== true)){
                widget.showByFields(["deleteSupplyerButton"]);
                widget.hideByFields(["beingPartnerButton_1","beingPartnerButton_2"]);
            }
            if(!widget.__data.isCustomer){
                widget.hideByFields(["shopLevel"]);
                //若不为分销商，隐藏保存按钮
                widget.hideByFields(["completePartnerButton"]);
            }else{
                widget.showByFields(["shopLevel"]);
                widget.showByFields(["completePartnerButton"]);
            }
        },
        //删除供应商
        deleteSupplyer: function(){
            partner.removeSupplier(window.did).then(lang.hitch(this,function(data){
                if(data.data.ok == 1){
                    history.back();
                }else{
                    alert("服务器繁忙！")
                }
            }));
        },
        //删除分销商
        deletePartner: function(removeData){
            partner.removeCustomer(removeData._id).then(lang.hitch(this, function(data) {
                if(data.data&&data.data.ok==1){
                    history.back();
                }else{
                    alert("服务器繁忙！")
                }
            }));
        },
        //同意成为分销商
        agreeAdd: function(agreeData){
            shop.agreeAdd(agreeData._id).then(lang.hitch(this, function(data) {
                if(data.data&&data.data.ok==1){
                    history.back();
                }else{
                    alert("服务器繁忙！")
                }
            }));
        },
        //同意成为分销商
        disAgree: function(refuseData){
            shop.disAgree(refuseData._id).then(lang.hitch(this, function(data) {
                if(data.data&&data.data.ok==1){
                    history.back();
                }else{
                    alert("服务器繁忙！")
                }
            }));
        },
        //修改合作伙伴等级，保存
        completeSave: function(saveData){
            var completeData = {};
            completeData.targetShopId = saveData._id;
            completeData.shopLevel = saveData.shopLevel;
            shop.modifyPartner(completeData).then(lang.hitch(this, function(data) {
                if(data.data&&data.data.ok==1){
                    history.back();
                }else{
                    alert("服务器繁忙！")
                }
            }));
        },
        //重盐App店铺认证布局：没有产业类别，经营主体，乡镇-村
        getGosaltbVerifyXmLayout : function(){
            this.appType = "cy";
            if(!this.shopVerificationXmLayout){
                //店铺认证
                this.shopVerificationXmLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "logo",
                    "companyName",
                    "legalPerson",
                    "legalPersonCode",
                    "contactName",
                    "contactPhone",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2",
                    "rejectedReason",
                    "lon,lat",
                    "provinceId,cityId,countId,town",
                    "address",
                    "tranRegions",
                    "saveVerfyBut"])
                }];
                this.shopVerificationXmLayout[0].fields[13].defaultData = config.defaltTranRegion||{};
            }
            return this.shopVerificationXmLayout;
        },
       
        //重盐及其他app认证布局结束
        //认证信息判断
        canSaveData : function(data){
            var def =  new Deferred();
            //销售区域不能为空
            var msg = "";
            if(!data.logo){
                msg = "请选择店铺图标！"
            }
            if(!data.companyName){
                msg = "请填写公司名称！"
            }
            if(!data.legalPerson){
                msg = "请填写法人姓名！"
            }
            if(!data.contactName){
                msg = "请填写联系人！"
            }
            if(!data.contactPhone){
                msg = "请填写联系电话！"
            }
            if(!data.businessLicense){
                msg = "请上传营业执照！"
            }
            if(!data.legalImg1){
                msg = "请上传法人身份证正面照！"
            }
            if(!data.legalImg2){
                msg = "请上传法人身份证反面照！"
            }
            if(!data.legalPersonCode){
                msg = "法人身份证号不能为空！"
            }
            if(!data.town){
                msg = "省-市-区县不能为空！"
            }
            if(this.appType == "xm"){
                if(!data.locationName){
                    msg = "乡镇-村不能为空！"
                }
            }
            if(!data.address){
                msg = "详细地址不能为空！"
            }
            def.resolve(msg);
            return def;
        },
        //Xmapp认证开始
        //  提交认证
        goToVerifiy : function(shopData){
            //town:若是点击地理位置之后是一个数组：若是一个数组则将其元素重新赋值
            //      目前只会出现数组或字符串两种类型
            if(typeof(shopData.town) !== "string"){
                shopData.town = shopData.town[0]
            }
            var showLands = "";
            //在店铺认证的时候只有重盐有销售区域，其他APP应不做处理
            if(this.appType == "cy"){
                //保存时处理tranRegion的问题（销售区域）
                array.forEach(shopData.tranRegions, lang.hitch(this, function(arg) {
                    if(showLands!==""){
                        showLands += "，" + arg.remark
                    }else{
                        showLands = arg.remark
                    }
                    if(arg.provinceId==null||!arg.provinceId) delete arg.provinceId;
                    if(arg.cityId==null||!arg.cityId) delete arg.cityId;
                    if(arg.countId==null||!arg.countId) delete arg.countId;
                }));
                shopData.tranRegion = showLands;
            }
            //处理点击，满足条件才可以提交认证
            if((shopData.isVerifySubmit === 0 && !shopData.isVerified)||(shopData.isVerifySubmit === -1 && !shopData.isVerified)){ 
                this.canSaveData(shopData).then(lang.hitch(this,function(msg){
                    if(msg){
                        alert(msg);
                        return;
                    }
                    if(!shopData.villageId) delete shopData.villageId;
                    if(!shopData.townId) delete shopData.townId;
					//由于认证提交的服务器接口不支持tranRegions的保存，所以先执行保存
					shop.save(shopData).then(function(data){
						if(!data || !data.data || !data.data.ok){
							alert("提交失败");
							return;
						}
						delete shopData.tranRegions;
						shop.verifySubmit(shopData).then(function(data) {
							window.free();
							if (data && data.data && data.data.ok === 1) {
								alert("提交成功");
								history.back();
							} else {
								this.isEditing = true;
								alert("提交失败");
							}
						});
					});
                }));
            }
        },
        //畜牧app***
        onVerifyReloaded : function(widget){
            //根据数据显示隐藏节点
            widget.hideByFields(["rejectedReason"]);
            var data = widget.__data,label = "";
            if(this.appType == "xm"){
                var fields = [
                    "logo",
                    "companyName",
                    "legalPerson",
                    "contactName",
                    "contactPhone",
                    "legalPersonCode",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2",
                    "shopType",
                    "industryType",
                    "lon,lat",
                    "rejectedReason",
                    "provinceId,cityId,countId,town",
                    "countId,townId,villageId,locationName",
                    "address",
                    //"tranRegions",
                    "saveVerfyBut"
                    ];
            }
            if(this.appType == "default"){
                var fields = [
                    "logo",
                    "companyName",
                    "legalPerson",
                    "contactName",
                    "contactPhone",
                    "legalPersonCode",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2",
                    "lon,lat",
                    "rejectedReason",
                    "provinceId,cityId,countId,town",
                    "address",
                    "saveVerfyBut"
                    ];
            }
            if(this.appType == "cy"){
                var fields = [
                    "logo",
                    "companyName",
                    "legalPerson",
                    "contactName",
                    "contactPhone",
                    "legalPersonCode",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2",
                    "lon,lat",
                    "rejectedReason",
                    "provinceId,cityId,countId,town",
                    "address",
                    "tranRegions",
                    "saveVerfyBut"
                    ];
            }
            if((!data.isVerified && data.isVerifySubmit === 1)||(data.isVerifySubmit === 2 && data.isVerified))
                widget.disableByFields(fields);
            else
                widget.enableByFields(fields);
            widget.hideByFields(["rejectedReason"]);
            //驳回原因，不可编辑
            widget.disableByFields(["rejectedReason"]);
            //显示提交认证
            if(data.isVerifySubmit === 0 && !data.isVerified){
                label = "提交认证";
            }
            // 显示重新提交（已驳回）
            if (data.isVerifySubmit === -1 && !data.isVerified) {
                label = "重新提交";
                //显示驳回原因
                widget.showByFields(["rejectedReason"]);
            }
            // 显示审核中
            if (!data.isVerified && data.isVerifySubmit === 1) {
                label = "审核中";
            }
            // 显示已审核
            if (data.isVerifySubmit === 2 && data.isVerified) {
                label = "已审核";
            }
            var buttonNode = widget.getEditorByField("saveVerfyBut");
            if(buttonNode){
                buttonNode.setLabel(label);
            }
        },
        initShopVerificationData : function(){
            return shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                var shopData = data.data;
                if(!shopData.companyName){
                    shopData.companyName = shopData.shopName;
                }
                if(!shopData.rejectedReason){
                    shopData.rejectedReason = "";
                }
                // 认证时将联系电话默认为当前登陆者的电话
                this.userData=shopData.svcId;
                if(!shopData.contactPhone){
                    shopData.contactPhone = this.userData && this.userData.userName;
                }
                return shopData;
                //通过状态设置底部按钮的显示隐藏
            }));
        },
        //XmApp店铺认证
        getShopVerifyXmLayout : function(){
            this.appType = "xm";
            if(!this.shopVerificationXmLayout){
                //店铺认证
                this.shopVerificationXmLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "logo",
                    "companyName",
                    "legalPerson",
                    "legalPersonCode",
                    "contactName",
                    "contactPhone",
                    "businessLicense",
                    "legalImg1",
                    "legalImg2",
                    "shopType",
                    "industryType",
                    "lon,lat",
                    "provinceId,cityId,countId,town",
                    "countId,townId,villageId,locationName",
                    "address",
                    "rejectedReason",
                    "saveVerfyBut"])
                }];
            }
            return this.shopVerificationXmLayout;
        },
        //Xmapp结束***
        //店铺管理
        onShopBaseSave: function(saveData) {
            shop.save(saveData).then(function(data) {
                if (data.data.ok) {
                    alert("更新店铺信息成功！暂留此页面，后面再改！");
                } else {
                    alert("信息更新失败！");
                }
            });
        },
        getServiceVerifySaveMsg:function(saveData){
            var msg = "";
            if(!saveData.industryType){
                msg = "请填写产业类别!";
            }else if(!saveData.address){
                msg = "请填写详细地址!";
            }else if(!saveData.brief){
                msg = "请填写店铺简介!";
            }//else if(!saveData.shopName){
             //   msg = "名称还未填写!";
            //}
            //shopLevel商家等级
            //  3：企业，1,2：政府
            if(3 == saveData.shopLevel){
                if(!saveData.registerDate){
                    msg = "请填写成立日期!";
                }else if(!saveData.legalPerson){
                    msg = "请填写法人姓名!";
                }else if(!saveData.empTotal){
                    msg = "请填写员工数量!";
                }else if(!saveData.tecTotal){
                    msg = "请填写技术人员数量!";
                }else if(!saveData.email){
                    msg = "请填写电子邮件!";
                }else if(!saveData.website){
                    msg = "请填写公司网址!";
                }else if(!saveData.orgCode){
                    msg = "请填写组织机构代码!";
                }else if(!saveData.businessLicense){
                    msg = "请上传营业执照!";
                }else if(!saveData.industryType){
                    msg = "请填写产业类别!";
                }
                if(saveData.empTotal&&!(/^[0-9]*[1-9][0-9]*$/.test(saveData.empTotal))){
                    msg = "员工数量必须为正整数!";
                }
                if(saveData.tecTotal&&!(/^[0-9]*[1-9][0-9]*$/.test(saveData.tecTotal))){
                    msg = "技术人员必须为正整数!";
                }
                if(saveData.empTotal<saveData.tecTotal){
                    msg = "技术人员不能多与员工总数!";
                }
            }
            return msg;
        },
        onShopServiceVerifySave: function(saveData) {
            //必填字段验证
            var msg = this.getServiceVerifySaveMsg(saveData);
            if(msg){
                alert(msg);
                return;
            }
            shop.save(saveData).then(function(data) {
                if (data.data.ok) {
                    alert("保存成功");
                } else {
                    alert("信息更新失败！");
                }
            });
        },
        onShopServiceVerifyPost: function(saveData) {
            shop.save(saveData).then(function(data) {
                if (data.data.ok) {
                    shop.cloneAndSubmit({shopId:saveData._id,targetShopId:config.serviceShopId}).then(lang.hitch(this,function(data){
                        if(1 == data.data.ok){
                            alert("提交成功，请等待审核！");
                            history.back();
                        }else{
                            alert("提交失败！");
                        }
                    }));
                } else {
                    alert("信息更新失败！");
                }
            });
        },
        //店铺管理
        getShopBaseLayout: function() {
            if(!this.shopBaseLayout){
                //店铺管理
                this.shopBaseLayout = [{
                    type: "form",
                    contents: this.getFormItems(["logo", "shopName", "address", "lon,lat", "brief",
                        "svcPhone", "svcWx", "svcQQ", "contactName", "contactPhone", "contactWx", "contactQQ",
                        "alipayAccount", "bankName", "bankAccountName", "bankAccountCode", "payee",
                        "fiName", "fiPhone", "fiQQ"
                    ], ["onShopBaseSave"])
                }];
            }
            return this.shopBaseLayout;
        },
        //店铺管理-数据加载
        loadShopBaseInfo: function() {
            return shop.loadById(shop.getShopId()).then(function(data) {
                return data.data;
            });
        },
        //店铺认证
        onSave: function(saveData) {
            var submitData = {};
            submitData.businessLicense = saveData.businessLicense;
            submitData._id = saveData._id;
            submitData.companyName = saveData.companyName;
            submitData.isVerified = saveData.isVerified;
            submitData.legalImg1 = saveData.legalImg1;
            submitData.legalImg2 = saveData.legalImg2;
            submitData.legalPerson = saveData.legalPerson;
            submitData.rejectedReason = saveData.rejectedReason;
            shop.verifySubmit(submitData).then(function(data) {
                if (data && data.data && data.data.ok === 1) {
                    alert("提交成功,请等待审核！");
                } else {
                    alert("提交失败");
                }
            });
        },
        //店铺认证
        getShopVerificationLayout: function() {
            if(!this.shopVerificationLayout){
                //店铺认证
                this.shopVerificationLayout = [{
                    type: "form",
                    fields: this.getFormItems(["companyName", "lon,lat", "legalPerson", "businessLicense", "legalImg1", "legalImg2","saveButton", "rSaveButton"])
                }];
            }
            return this.shopVerificationLayout;
        },
        //平台查看店铺详情
        getMerchantLayout: function() {
            if(!this.merchantLayout){
                //店铺认证
                this.merchantLayout = [{
                    type: "form",
                    fields: this.getFormItems(["logo","companyName", "lon,lat", "town", "locationName", "address","contactName", "contactPhone", "legalPerson", "businessLicense", "legalImg1", "legalImg2", "shopVerifyButton","shopVerifyRejectButton","shopVerifyCancelButton"],false)
                }];
            }
            return this.merchantLayout;
        },
        //农村处--驳回认证
        businessRejectAction:function(verfyData,views){
            var prams = {};
            prams.shopId = shop.getShopId();
            prams.targetShopId = verfyData._id;
            if (!views.view) {
				var view = views.getParent();
				while (view) {
					if (!view.show) {
						view = view.getParent();
					} else {
						break;
					}
				}
				views.view = view;
			}
            window.busy();
			editor.startEdit("", views.view).then(lang.hitch(this, function (value) { 
                prams.rejectedReason = value
                if(!prams.rejectedReason){
                    alert("请输入驳回原因！");
                    return;
                }
                partner.businessReject(prams).then(lang.hitch(this, function (data) {
                    window.free();
                    if (data && data.data && data.data.ok === 1){
                        history.back();
                    } else {
                        alert("服务器繁忙,请稍后再试！");
                    }
                }));
            }));
        },
        //标记认证
        businessVerifyAction:function(verfyData){
            var prams = {};
            prams.shopId = shop.getShopId();
            prams.targetShopId = verfyData._id;
            partner.businessVerify(prams).then(lang.hitch(this,function(data){
                var a = data;
                alert("认证成功");
                history.back();
            }));
        },
        //取消认证
        businessCancelAction:function(verfyData){
            var prams = {};
            prams.shopId = shop.getShopId();
            prams.targetShopId = verfyData._id;
            partner.businessCancel(prams).then(lang.hitch(this,function(data){
                var a = data;
                var a = data;
                alert("操作成功");
                history.back();
            }));
        },
        loadShopByBusinessData:function(param){
            //从服务商那里加载目标服务商家信息
            if(param.cqViewParam.params){
                var shopId = shop.getShopId();
                //读取指定服务商的信息
                var _id = param.cqViewParam.params;
            }else{
                //提交界面：从服务商那里读取自己的信息
                var shopId = config.serviceShopId;
                //读取指定服务商的信息
                var _id = shop.getShopId();
            }
            return partner.loadByIdAndShopId(shopId,_id).then(lang.hitch(this,function(data){
                var datas =data.data;
                datas["provinceId,cityId,countId"] = [datas.provinceId||'',datas.cityId||'',datas.countId||''];
                return datas;
            }));
            
        },
        //向服务商提交认证信息
        getBusinessVerificationLayout: function() {
            if(!this.businessVerificationLayout){
                //店铺认证
                this.businessVerificationLayout = [{
                    type: "form",
                    fields: this.getFormItems(["companyName",
                    "registerDate",
                    "legalPerson",
                    "contactName",
                    "contactPhone",
                    "empTotal",
                    "tecTotal",
                    "email",
                    "website",
                    "orgCode",
                    "businessLicense",
                    "industryType",
                    "rejectedReason",
                    "provinceId,cityId,countId",
                    "address",
                    "brief",
                    //"shopServiceVerifySaveButton",
                    "shopServiceVerifyPostButton",
                    "businessVerifyButton",
                    "businessRejectButton",
                    "businessCancelButton",
                    "businessVerfyingButton",
                    "businessVerfiedButton"],true)
                }];
            }
            return this.businessVerificationLayout;
        },
		//店铺信息表格化显示
        getMerchantGridLayout: function() {
            if(!this.merchantGridLayout){
                //店铺认证
                this.merchantGridLayout = this.getFormItems(["shopName", "combinedAddress","contactName", "contactPhone","isVerified","lon","lat","shopVerifyActions"],false);
            }
            return this.merchantGridLayout;
        },
		//合作伙伴认证表格化显示
        getPartnerVerificationGridLayout: function() {
            if(!this.partnerVerificationGridLayout){
                //店铺认证
                this.partnerVerificationGridLayout = this.getFormItems(["shopName", "combinedAddress","contactName", "contactPhone","isVerified","businessVerificationActions"],false);
            }
            return this.partnerVerificationGridLayout;
        },
        getServiceVerGridLayout:function(){
            return this.getFormItems(["shopName", "combinedAddress","contactName", "contactPhone","isVerified","shopLevel","businessVerificationActions"],false);
        },
		//从平台加载指定店铺信息
		loadShopByPlatform:function(params){
            if(params && params.cqViewParam && params.cqViewParam.params)
            return shop.loadShopByPlatform(params.cqViewParam.params).then(function(data) {
                return data.data;
            });
            else return this.loadShopInfo();
		},
        loadShopInfo: function() {
            return shop.loadCurrentShop().then(function(data) {
                return data.data;
            });
        },
		getLoadMsgUrl:function(){
			return shopMsg.getLoadUrl();
		},
		getSupplierMsgParam:function(){
			return {msgType:1};
		},
		getCustomerMsgParam:function(){
			return {msgType:2};
		},
		getShopMsgProp:function(data){
			return {
                icon:data.fromShopId.logo||"",
                label:(data.fromShopId.shopName+"："+data.msgContent)||"",
                data:data
            };
		},
		onShowShopMsg:function(data){
			if(data.toView){
				window.moveToView(data.toView,data.toParam);
			}
		},
        //合作伙伴相关
        getPartnerLoadUrl:function(){
            return partner.getLoadUrl();
        },
        //listem
        getShopItemPropForPartener:function(data){
			return {
                icon:data.logo||"images/logo.png",
                label:"<div>店铺名称："+data.shopName+"</div>"+
                "<div>地址："+(data.address||"")+"</div>"+
				"<div>联系人："+(data.contactName||"")+"</div>"+
				"<div>联系电话："+(data.contactPhone||"")+"</div>"                
                +"<div>"+(data.isSupplier?("<span class='forth-btn-t float-right'>供</span>"):"")+"</div>"
                //+"<div>"+(data.isCustomer?("<span class='forth-btn-t float-right removeCustomer'>删除</span>"):"")+"</div>"
                +"<div>"+(data.isCustomer?("<span class='forth-btn-t float-right'>销</span>"):"")+"</div>"
                +"<div>"+(data.customerState==1?("<span class='forth-btn-t float-right'>申</span>"):"")+"</div>"
                ,
                variableHeight:true,
                data:data
            };
		},
        //参数
        getParamsForPartners:function(params){
			//默认查询有效商家
            var query = {isDelete:false}; 
			if(params.search){
				query.search = params.search;
			}
            var role = user.getCurrentUserRole();
			// 采购员只能查看已审核的供应商
            if(role == 2){
				query.isSupplier = true;
				query.isVerified = true;
            } else 
			// 销售员只能查已审核的分销商
			if(role == 3){
				query.isCustomer = true;
				query.isVerified = true;          
            }else{
				// 过滤条件筛选
                //供应商
                if(params.state&&params.state._id == 1){
                    query.isDelete = false;
                    query.isSupplier = true;
					query.isVerified = true;
                }
                //分销商
                if(params.state&&params.state._id == 2){
                    query.isDelete = false;
                    query.isCustomer = true;
					query.isVerified = true;
                }
                //待处理：（申请中）
                if(params.state&&params.state._id == 3){
                    query.isDelete = false;
                    query.customerState = 1;
                }                
            }
			return query;			
        },
        //查找更多伙伴
        findMore:function(){
            window.moveToView("supplyList");
        },
        onPartnerShop:function(data){
            window.moveToView("myPartnerDetail",data._id);  
		},
        //商家管理
        getMerchantUrl:function(){
            return shop.getShopByPlatform();
        },
        getMerchantLabel:function(data){
            return {
                icon:data.logo||"images/logo.png",
                label:"<div>商家名称："+data.shopName+"</div>"+
                "<div>商家地址："+(data.saleAmount||"")+"</div>"+
                "<div>电话："+(data.contactPhone||"")+"</div>"
                +"<div>"+((data.isVerifySubmit==2&&data.isVerified==true)?("<span class='forth-btn-t float-right'>已认证</span>"):"")+"</div>"
                +"<div>"+((data.isVerifySubmit==1&&data.isVerified==false)?("<span class='forth-btn-t float-right'>待认证</span>"):"")+"</div>"
                +"<div>"+((data.isRecommend==true)?("<span class='forth-btn-t float-right'>荐</span>"):"")+"</div>"
                ,
                variableHeight:true,
                data:data
            };
        },
        addMerchant:function(){
            window.moveToView("businessRegist");
        },
        getParamsForMerchant:function(params){
            //默认为全部
            var query = {isDelete:false};
            if(params.search){
                query.shopName = params.search;
            }
			if(params.cqViewParam && params.cqViewParam.params){
				var p = params.cqViewParam.params.split("_");
				if(p[0] == "shopType") query[p[0]] = p[1];
				if(p[0] == "verifyState") {
					if(p[1]==0){
					}
					if(p[1]==1){
						query.isVerifySubmit=1;
						query.isVerified=false
					}
					if(p[1]==2){
						//query.isVerifySubmit=2;
						query.isVerified=true
					}
					if(p[1]==3){
						query.isVerifySubmit=0;
						query.isVerified=false;
					}
					if(p[1]==4){
						query.isVerifySubmit=-1;
						query.isVerified=false;
					}
				}
			}
            //搜索条件
            //全部；未分类
            if(params.state&&params.state._id==""){
				delete query.shopType;
            }
            else if(params.state){
                query.shopType=params.state._id;
            }
            //全部；待认证，已认证，未提交，已驳回
            if(params.state_2&&params.state_2._id==0){
				delete query.isVerifySubmit;
				delete query.isVerified;
            }
            if(params.state_2&&params.state_2._id==1){
                query.isVerifySubmit=1;
                query.isVerified=false
            }
            if(params.state_2&&params.state_2._id==2){
                query.isVerifySubmit=2;
                query.isVerified=true
            }
            if(params.state_2&&params.state_2._id==3){
                query.isVerifySubmit=0;
                query.isVerified=false;
            }
            if(params.state_2&&params.state_2._id==4){
                query.isVerifySubmit=-1;
                query.isVerified=false;
            }
            //推荐店铺，未推荐，已推荐
            if(params.state_3&&params.state_3._id==0){
            }
            if(params.state_3&&params.state_3._id==1){
                query.isRecommend=false;
            }
            if(params.state_3&&params.state_3._id==2){
                query.isRecommend=true;
            }
            //待处理：（申请中）
            if(params.state&&params.state._id == 3){
                query.isDelete = false;
                query.customerState = 1;
            }
            return query;
        },
        getParamsForPartnerVerification:function(params){
            this.querySelectAction = "all";
            var query = {};
            query.isDelete = false;
            //默认为全部
            if(params.search){
                query.shopName = params.search;
            }
            //搜索条件
            //全部；未分类
            if(params.shopLevel&&params.shopLevel._id==""){
				delete query.shopLevel;
            }
            else if(params.shopLevel){
                query.shopLevel=params.shopLevel._id;
            }
            //全部；待认证，已认证，未提交，已驳回
            if(params.state_2&&params.state_2._id==0){
                //处理页面显示（农村处服务商）
                this.querySelectAction = "all";
				delete query.isVerifySubmit;
				delete query.isVerified;
            }
            if(params.state_2&&params.state_2._id==1){
                this.querySelectAction = "verfying";
                query.isVerifySubmit=1;
                query.isVerified=false;
            }
            if(params.state_2&&params.state_2._id==2){
                this.querySelectAction = "verfied";
                query.isVerified=true;
                query.isVerifySubmit=2;
            }
            if(params.state_2&&params.state_2._id==3){
                this.querySelectAction = "notVerfy";
                query.isVerifySubmit=0;
                query.isVerified=false;
            }
            if(params.state_2&&params.state_2._id==4){
                this.querySelectAction = "rejectVerfy";
                query.isVerifySubmit=-1;
                query.isVerified=false;
            }
            return query;
        },
		getPlatformShopListUrl:function(){
			return shop.getShopByPlatform();
		},
        onMerchantShop:function(data){
            window.moveToView("merchantDetail",data._id);
        },
		getShopItemProp:function(data){
			return {
                icon:data.logo||"images/logo.png",
                label:"<div>"+data.shopName+"</div>"+
                "<div class='hflex'><div style='width:60%'>销量："+(data.saleAmount||"0")+"</div><div style='width:40%;'>商品数："+(data.shopMatNum||"0")+"</div></div>"+
                "<div>销售区域："+(data.tranRegion||"全国")+"</div>"+
                "<div>所在地："+(data.town||"")+"</div>"
                ,
                variableHeight:true,
                data:data
            };
		},
		getPlatformShopListParam:function(params){
			var query = {isVerified:true};
            if(params.search){
                query.shopName = params.search;
            }
            if(params.district){
                if(params.district.province){
                    query.provinceId = params.district.province._id;
                }
                if(params.district.city){
                    query.cityId = params.district.city._id;
                }
                if(params.district.county){
                    query.countId = params.district.county._id;
                }
            }
            return query;
		},
		onShowShop:function(data){
			window.moveToView("supplyBus",data._id);
		},
		getShopDetail:function(param){
			var def=new Deferred();
			shop.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				partner.loadById(param.cqViewParam.params).then(lang.hitch(this,function(partnerData){
					data.data.showApprove = partnerData.data && partnerData.data.customerState==1?"":"none";
					data.data.showAddSupplier = !partnerData.data || (!partnerData.data.isSupplier && partnerData.data.supplierState!=1)?"":"none";
					data.data.showRemoveSupplier = partnerData.data && partnerData.data.isSupplier?"":"none";
					data.data.showAddState = partnerData.data && partnerData.data.supplierState==1?"":"none";
					def.resolve(data.data);
					
				}));
			}));
			return def;
		},
		shopDetailFields:[{field:"shopName",type:"text"},{field:"logo",type:"text"},{field:"contactPhone",type:"text"},{field:"contactName",type:"text"},{field:"address",type:"text"}],
		getDetailTemplate:function(){
			return "<div><div style='display:inline-block'><img src='{logo}'/>"+
			"</div><div style='display:inline-block;vertical-align:top;'><h4>{shopName}</h4>"+
			"<p>联系人：{contactName}</p>"+
			"<p>电 话：{contactPhone}</p>"+
			"<p>地址：{address}</p></div>"+
			"<div style='text-align:right;'><div class='button {showAddSupplier}' onclick='cq.bo.shop.shop.addSupplier(\"{_id}\",event.target,true)'>添加供应商</div>"+
			"<div class='button {showRemoveSupplier}' onclick='cq.bo.shop.shop.removeSupplier(\"{_id}\",event.target,true)'>停止采购</div>"+
			"<div class='button {showAddState}'>申请采购中</div>"+
			"<div class='button {showApprove}' onclick='cq.bo.shop.shop.agreeCustmer(\"{_id}\",event.target,true)'>同意采购</div>"+
			"<div class='button {showApprove}' onclick='cq.bo.shop.shop.refuseCustmer(\"{_id}\",event.target,true)'>不同意采购</div></div></div>";
		},
		onDetailState:function(data, states){
			console.log(states);
		},
		addSupplier:function(shopId,targetNode,refreshTarget){
			partner.addSupplier(shopId).then(lang.hitch(this,function(data){
				if(data.data.ok == 1){
					alert("添加成功");
					if(refreshTarget&&targetNode){
						var n = dijit.registry.getEnclosingWidget(targetNode);
						if(n && n.cqRefresh) n.cqRefresh();
					}
				}else{
					alert(data.data.msg);
				}
			}));
		},
		removeSupplier:function(shopId,targetNode,refreshTarget){
			partner.removeSupplier(shopId).then(lang.hitch(this,function(data){
				if(data.data.ok == 1){
					alert("停止采购成功");
					if(refreshTarget&&targetNode){
						var n = dijit.registry.getEnclosingWidget(targetNode);
						if(n && n.cqRefresh) n.cqRefresh();
					}
				}else{
					alert(data.data.msg);
				}
			}));
		},
        agreeCustmer : function(shopId,targetNode,refreshTarget){
            shop.agreeAdd(shopId).then(lang.hitch(this,function(data){
				if(refreshTarget&&targetNode){
					var n = dijit.registry.getEnclosingWidget(targetNode);
					if(n && n.cqRefresh) n.cqRefresh();
				}
            }));
        },
        refuseCustmer : function(shopId,targetNode,refreshTarget){
            shop.disAgree(shopId).then(lang.hitch(this,function(data){
				if(refreshTarget&&targetNode){
					var n = dijit.registry.getEnclosingWidget(targetNode);
					if(n && n.cqRefresh) n.cqRefresh();
				}
            }));
        },
        //店铺认证页面显示状态
        verifyActionReload: function(dataLayout) {
			dataLayout.hideByFields(["shopVerifyButton","shopVerifyCancelButton","shopVerifyRejectButton"]);
			var data = dataLayout.getData();
            if (!data.isVerified && data.isVerifySubmit === 1) {
				dataLayout.showByFields(["shopVerifyButton","shopVerifyRejectButton"]);
            }
            if (data.isVerified && data.isVerifySubmit === 2) {
				dataLayout.showByFields(["shopVerifyCancelButton"]);
            }
        },
        //店铺向服务商提交认证认证页面显示状态
        serviceVerifyReload: function(dataLayout) {
            // 认证，取消认证按钮
            var verfyButton = ["businessVerifyButton","businessCancelButton"];
            // 保存，提交按钮
            var saveButtons = ["shopServiceVerifyPostButton"];
            //政府，需要隐藏的字段
            var goverButton = ["registerDate","legalPerson","empTotal","email","website","orgCode","businessLicense","industryType"];
            //全部字段
            var allFields = ["companyName","registerDate", "legalPerson","contactName", "contactPhone","empTotal","tecTotal","email","website","orgCode", "businessLicense", "industryType", "provinceId,cityId,countId", "address", "brief"];
            //全部按钮
            var allButtons = [
            "businessVerfiedButton",
            "businessVerfyingButton",
            "shopServiceVerifyPostButton",
            //"shopServiceVerifySaveButton",
            "businessRejectButton",
            "businessVerifyButton",
            "businessCancelButton"
            ]
            //从服务商那里加载本店铺的资料
            //如果没有，则是未提交状态
            //如果有，判断是否已认证
            //如果认证了，则不能再提交认证
            //如果没有，则可以提交认证
			dataLayout.hideByFields(allButtons);
            dataLayout.hideByFields(["rejectedReason"]);
			var data = dataLayout.getData();
            partner.loadByIdAndShopId(config.serviceShopId,data._id).then(function(partnerData){
                //if(!partnerData || !partnerData.data || !partnerData.data.isVerified ){
                //    dataLayout.showByFields(["shopServiceVerifyPostButton","shopServiceVerifySaveButton"]);
                //}
                //若级别是区县或者乡镇，隐藏部分本内容
                //  政府：只显示名称、级别、区县、地址、简介
                var domNodeName = dataLayout.getEditorByField("companyName").parentNode.childNodes[0];
                var domNodeBrief = dataLayout.getEditorByField("brief").parentNode.childNodes[0];
                if(partnerData&&partnerData.data){
                    var level = partnerData.data.shopLevel;
                    if(1 == level||2 == level){
                        domNodeName.innerHTML = "政府名称";
                        domNodeBrief.innerHTML = "政府简介";
                        dataLayout.hideByFields(["registerDate","legalPerson","empTotal","tecTotal","email","website","orgCode","businessLicense","industryType"]);
                    }else{
                        domNodeName.innerHTML = "公司名称";
                        domNodeBrief.innerHTML = "公司简介";
                        dataLayout.showByFields(["registerDate","legalPerson","empTotal","tecTotal","email","website","orgCode","businessLicense","industryType"]);
                    }
                }
                //如果非农村处，则为提交认证；农村处为审核认证
                // 若从得到的数据中取出的数据等于服务主体id则认为是审核页面（农村处）
                if(config.serviceShopId == shop.getShopId()){
                    //农村处
                    //点击提交之后审核之前的状态
                    //  审核方面：提交之后显示审核，驳回按钮
                    if (!data.isVerified && data.isVerifySubmit === 1) {
                        dataLayout.showByFields(["businessVerifyButton","businessRejectButton"]);
                    }else{
                        dataLayout.hideByFields(["businessVerifyButton","businessRejectButton"]);
                    }
                    //  认证之后的状态：显示取消认证按钮
                    if (data.isVerified && data.isVerifySubmit === 2) {
                        dataLayout.showByFields(["businessCancelButton"]);
                    }else{
                        dataLayout.hideByFields(["businessCancelButton"]);
                    }
                    dataLayout.disableByFields(allFields);
                }else{
                    //非 农村处
                    //隐藏（驳回），认证，取消认证按钮
                    //dataLayout.hideByFields(verfyButton);
                    if(!data.isVerified && data.isVerifySubmit === 1){
                        //审核中的显示状态:显示审核中
                        dataLayout.hideByFields(saveButtons);
                        dataLayout.hideByFields(["rejectedReason"]);
                        dataLayout.showByFields(["businessVerfyingButton"]);
                        dataLayout.hideByFields(["businessVerfiedButton"]);
                        dataLayout.disableByFields(allFields);
                    }else if(data.isVerified && data.isVerifySubmit === 2){
                        //已认证状态：显示已认证按钮
                        dataLayout.hideByFields(saveButtons);
                        dataLayout.hideByFields(["rejectedReason"]);
                        dataLayout.hideByFields(["businessVerfyingButton"]);
                        dataLayout.showByFields(["businessVerfiedButton"]);
                        dataLayout.disableByFields(allFields);
                    }else if(!data.isVerified && data.isVerifySubmit === -1){
                        //驳回：显示保存，提交按钮
                        dataLayout.showByFields(["rejectedReason"]);
                        dataLayout.showByFields(saveButtons);
                        dataLayout.hideByFields(["businessVerfyingButton"]);
                        dataLayout.hideByFields(["businessVerfiedButton"]);
                        //字段可编辑
                        dataLayout.enableByFields(allFields);
                    }else{
                        //驳回：显示保存，提交按钮
                        dataLayout.showByFields(saveButtons);
                        dataLayout.hideByFields(["rejectedReason"]);
                        dataLayout.hideByFields(["businessVerfyingButton"]);
                        dataLayout.hideByFields(["businessVerfiedButton"]);
                        //字段可编辑
                        dataLayout.enableByFields(allFields);
                    }
                }
            });
        },
		onShopVerify:function(data,dataLayout){
			shop.verifyShopAut({targetShopId:data._id}).then(function(){dataLayout.cqRefresh();});
		},
		onShopVerifyReject:function(data,dataLayout){
			var reason = prompt("请填写驳回理由：");
			if(!reason) return;
			shop.rejectShopAut({targetShopId:data._id,rejectedReason:reason}).then(function(){dataLayout.cqRefresh();});
		},
		onShopVerifyCancel:function(data,dataLayout){
			shop.cancelShopAut({targetShopId:data._id}).then(function(){dataLayout.cqRefresh();});
		},
		onListAction:function(data,action,list){
            if(action=="deleteArticle"){
                if(!confirm("确定删除“"+data.userId.pName+"”吗？")) return;
                shopUser.deleteByUser(data.userId._id).then(lang.hitch(this, function(backData) {
                    if (backData.data.ok === 1) {
                        //shop.removeShop(data._id).then(function(){
                            list.removeItemByData(data);
                        //});
                        alert("删除成功");
                    } else {
                        alert("删除失败");
                    }
                }));
            }
			if(action=="deleteShop"){
                if(!confirm("确定删除“"+data.shopName+"”吗？")) return;
				shop.removeShop(data._id).then(function(){
                    list.removeItemByData(data);
                });
			}
            if(action=="verifyPartner"){
                var prams = {};
                prams.shopId = shop.getShopId();
                prams.targetShopId = data._id;
                partner.businessVerify(prams).then(lang.hitch(this,function(backData){
                    list.refreshItemByData(backData&&backData.data&&backData.data.item||backData);
                    alert("操作成功！");
                }));
			}
            if(action=="rejectVerifyPartner"){
                var prams = {};
                prams.shopId = shop.getShopId();
                prams.targetShopId = data._id;
				prams.rejectedReason = prompt("请填写驳回理由：");
				if(!prams.rejectedReason){
                    alert("请填写驳回理由！");
                    return;
                };
				partner.businessReject(prams).then(function(backData){
                    list.refreshItemByData(backData&&backData.data&&backData.data.item||backData);
                });
                /*
                var prams = {};
                prams.shopId = shop.getShopId();
                prams.targetShopId = data._id;
                partner.businessReject(prams).then(lang.hitch(this,function(backData){
                    if(("rejectVerfy"!==this.querySelectAction)&&("all"!==this.querySelectAction)){
                        //list.removeItemByData(data);
                        list.refreshItemByData(data);
                    }
                    list.refreshItemByData(data);
                    alert("操作成功！");
                }));*/
			}
            if(action=="cancelVerifyPartner"){
                var prams = {};
                prams.shopId = shop.getShopId();
                prams.targetShopId = data._id;
                partner.businessCancel(prams).then(lang.hitch(this,function(backData){
                    list.refreshItemByData(backData&&backData.data&&backData.data.item||backData);
                    alert("操作成功！");
                }));
			}
            if(action=="deletePartner"){
                if(!confirm("确定删除“"+data.shopName+"”吗？")) return;
				var pram = {};
                pram.targetShopId = data._id;
                pram.shopId = shop.getShopId();
                partner.removeServiceShop(pram).then(function(){
                    list.removeItemByData(data);
                });
			}
			if(action=="verifyShop"){
				data.isVerified = true;
				shop.verifyShopAut({targetShopId:data._id}).then(function(){list.refreshItemByData(data);});
			}
			if(action=="cancelVerifyShop"){
				data.isVerified = false;
				data.isVerifySubmit = 0;
				shop.cancelShopAut({targetShopId:data._id}).then(function(){list.refreshItemByData(data);});
			}
			if(action=="rejectVerifyShop"){
				data.isVerified = false;
				data.isVerifySubmit = 2;
				var reason = prompt("请填写驳回理由：");
				if(!reason) return;
				shop.rejectShopAut({targetShopId:data._id,rejectedReason:reason}).then(function(){list.refreshItemByData(data);});
			}
		},
		getShopSummaryUrl:function(){
			return shop.getShopSummaryUrl();
		},
		getShopTypeName:function(){
			
		},
		getShopSummaryProp:function(data){
			return {
				icon:"images/userIcon.png",
                label:
					"<h5><a href='#merchantList2-shopType_"+data.shopType+"'>"+(data.count||"0")+"</a></h5>"+
					"<h6>"+(this.fields.shopType.options[data.shopType+""]||"未知类别")+"</h6>",
                data:data
            };
			
		},
		getShopSummaryParam:function(){
			return {};
		},
		getNull:function(){
			return null;
		},
		onShowMerchantList:function(){
			window.moveToView("merchantList");
		},
		getSummaryByVerifyUrl:function(){
			return shop.getSummaryByVerifyUrl();
		},
		getSummaryByVerifyProp:function(data){
			return {
                label:
					"<ul>"+
					"<li>"+
					"<h5><a href='#merchantList2-verifyState_1'>"+(data.applyCount||"0")+"</a></h5>"+
					"<h6>申请中</h6>"+
					"</li>"+
					"<li>"+
					"<h5><a href='#merchantList2-verifyState_2'>"+(data.verifiedCount||"0")+"</a></h5>"+
					"<h6>已认证</h6>"+
					"</li>"+
					"<li>"+
					"<h5><a href='#merchantList2-verifyState_3'>"+(data.notSubmitCount||"0")+"</a></h5>"+
					"<h6>未提交</h6>"+
					"</li>"+
					"<li>"+
					"<h5><a href='#merchantList2-verifyState_4'>"+(data.rejectedCount||"0")+"</a></h5>"+
					"<h6>已驳回</h6>"+
					"</li>"+
					"</ul>",
                data:data
            };
			
		},
        getPlatformUrl : function(){
            return  shopPayLog.loadByPlatformId(); 
        },
        getTrantransactionUrl : function(){          
            return  transaction.loadTransactionLog();
        },
        getGridLayout: function() {
            if(!this.balanceGridLayout){
                this.balanceGridLayout = this.getFormItems(["fromShopId.shopName","fromShopId.address","amount","listActions"],false);
            }
            return this.balanceGridLayout;
        },
        detailLayout : function(){
            if(!this.detailGridLayout){
                this.detailGridLayout = this.getFormItems(["tsType","payType","payLogId","tsAmount","createAt"]);
            }  
            return this.detailGridLayout;
        },
        
        getQueryParam : function(params){
            var query = {ioType : 1,isVerified : false};
            if(params.search){
                query.search = params.search;
            }
            if(params.state&&params.state._id==0){
                query.ioType = 1;
                if(params.state_2&&params.state_2._id==0){
                    query.isVerified = false;
                }else if(params.state_2&&params.state_2._id==1){
                    query.isVerified = true;
                }
            }else if(params.state&&params.state._id==1){
                query.ioType = 0;
                if(params.state_2&&params.state_2._id==0){
                    query.isVerified = false;
                }else if(params.state_2&&params.state_2._id==1){
                    query.isVerified = true;
                }    
            }
            return query;
        },
        getLogQueryParam : function(params){
            var query = {tsState : 2};
            if(params.search){
                query.tsType = params.search;
            }
            if(params.ts_state && params.ts_state._id == 0){
                query.tsState = 2;
            }else if(params.ts_state && params.ts_state._id == 1){
                query.tsState = 1;
            }else if(params.ts_state && params.ts_state._id == 2){
                query.tsState = 3;
            }else if(params.ts_state && params.ts_state._id == 3){
                query.tsState = 4;
            }
            return query;
        },
        balanceAction : function(data,action,list){
            if(action == "verify"){
				shopPayLog.verify({_id : data._id}).then(function(){
                    list.removeItemByData(data); 
                });
			}
        },
        getBalanceDetailLayout : function(){
            if(!this.balanceDetailLayout){
                this.balanceDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems(["shopName","address","bankAccount","bankName","bankOwner","amount","tsCode","fiName","fiPhone","fiQQ"])
                }];
                this.balanceDetailLayout.push()
            }
            return this.balanceDetailLayout;
        },
        loadShopById:function(data){
            var id = data.cqViewParam.params;
			return shopPayLog.loadById(id).then(lang.hitch(this,function(data){
				for(var i in data.data.item.fromShopId) {
                    data.data.item[i] = data.data.item.fromShopId[i];
                }
                return data.data.item;
			}));
		}
    });

    topic.subscribe("whz/shop/changed", function() {
        shopBo.onShopChanged();
    });
    lang.setObject("cq.bo.shop.shop", shopBo);
    return shopBo;
});
