﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "dojo/topic", //不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "cq/util/config/config",//不依赖的模块
    "cq/biz/ts/sc/supply_demand",
    "./BoBase"
],function(topic,Deferred,lang,topic,user,config,supplyDemand,BoBase){
    var supplyDemandBo =  new BoBase({
        fields:{
            fromShopId:{
                type: "ref",
                label: "发布单位",
                dataProvider: "cq/biz/shop/shop",
                targetMethod: "getShopByPlatform",
                searchField: "shopName",
                labelFields: "shopName",
				className:"middle-width"
            },
            ioType:{
                options:{
                    "0":"供应",
                    "1":"需求",
                    "2":"调换"
                },
                type:"options",
                label:"类型",
				className:"small-width"
            },
            minPrice:{
                type:"text",
                label:"最低价",
				className:"small-width"
            },
            maxPrice:{
                type:"text",
                label:"最高价",
				className:"small-width"
            },
            product:{
                type:"text",
                label:"品种",
				className:"small-width"
            },
            qty:{
                type:"text",
                label:"数量",
				className:"small-width"
            },
            sdDate:{
                type:"date",
                label:"上市日期",
				className:"small-width"
            },
            remark:{
                type:"text",
                label:"备注",
				className:"small-width"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"supplyDemandPost\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		getDetailTemplate:function(){
			return "<h4>{title}</h4><div>{content}</div>";
		},
		load:function(){
			return supplyDemand.load();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			supplyDemand.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.pName = params.search;
            }
            return query;
        },
		//资讯信息表格化显示
        getGridLayout: function() {
            if(!this.gridLayout){
                //店铺认证
                this.gridLayout = this.getFormItems(["fromShopId","ioType","product","qty","minPrice","maxPrice","listActions"],false);
            }
            return this.gridLayout;
        },
        getEditLayout: function() {
            if(!this.editLayout){
                //店铺认证
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["fromShopId","ioType","sdDate","product","qty","minPrice","maxPrice","remark","saveButton"])
                }];
            }
            return this.editLayout;
        },
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				supplyDemand.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			//
			window.busy();
			supplyDemand.save(data).then(function(){history.back();window.free();});
		}
        
    });
    return supplyDemandBo;
});
