﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "dojo/topic", //不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "cq/util/sys/date",
    "cq/util/config/config",//不依赖的模块
    "cq/biz/im/timeLine",
    "cq/widgets/bigImg",//不依赖的模块
    "./BoBase"
],function(topic,Deferred,lang,topic,user,date,config,timeLine,bigImg,BoBase){
    var timeLineBo =  new BoBase({
        fields:{
            title:{
                type:"text",
                label:"主题",
				placeHolder:"这一刻想记录...",
				className:"large-width"
            },
            createAt:{
                type:"dateTime",
                label:"日期",
				className:"small-width"
            },
            images:{
                type:"images",
                label:"图片",
				size:{width:640,height:640},
				sizeType:"cut"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"timeLineDetail\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		getExecutionItemProp:function(item){
			var imgs = "";
			for(var i=0;item.images&& i<item.images.length;i++){
				imgs+="<img src='"+item.images[i]+"' style='margin:5px;width:64px;height:64px;display:inline-block;' onclick='cq.widgets.bigImg.show(\""+item.images[i]+"\")'/>"
			}
			return {label:
				"<div>"+item.title+"</div>"+
				"<div>"+imgs+"</div>",
				rightText:date.formatISODate(item.createAt),
				variableHeight:true
			};
		},
		load:function(){
			return timeLine.getLoadUrl();
		},
		loadPlatform:function(){
			return timeLine.getPlatformLoadUrl();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var p = param && param.cqViewParam && param.cqViewParam.params;
			if(p){
				var q = p.split("_");
				if(q[0] == "prj"){
					return {isUse:true,projectId:q[1]};
				}
			}
			return timeLine.loadById(param.cqViewParam.params).then(function(data){
				return data.data.item;
			});
		},
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.search = params.search;
            }
			if(params.cqViewParam&& params.cqViewParam.params) {
				var p = params.cqViewParam.params.split("_");
				if(p[0] == "prj") query.projectId = p[1];
			}
            return query;
        },
		//资讯信息表格化显示
        getGridLayout: function() {
            if(!this.gridLayout){
                //店铺认证
                this.gridLayout = this.getFormItems(["title","pDate","name","phone","replyPeople","content","listActions"],false);
            }
            return this.gridLayout;
        },
        getEditLayout: function() {
            if(!this.editLayout){
                //店铺认证
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["title","images","saveButton"])
                }];
            }
            return this.editLayout;
        },
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				timeLine.savePlatform({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			//
			window.busy();
			timeLine.savePlatform(data).then(function(){history.back();window.free();});
		},
		addTimeLine:function(widget){
			window.moveToView("timeLineDtl",widget.cqRefInfo && widget.cqRefInfo.cqViewParam && widget.cqRefInfo.cqViewParam.params);
		},
		nothing:function(){
			
		}
        
    });
    return timeLineBo;
});
