﻿define([
    "dojo/topic",
    "dojo/_base/lang",
    "dojo/Deferred",
    "cq/biz/user/user",
    "./BoBase",
    "cq/util/config/config",
    "cq/app/config",
    "cq/biz/shop/shop",//动态require
    "cq/util/sys/common",
],function(topic,lang,Deferred,user,BoBase,config,appConfig,shop,common){
    var userBo =  new BoBase({
        fields:{
            userName:{
                type:"tel",
                placeHolder:"请填写手机号",
                label:"手机号"
            },
            password:{
                type:"password",
                placeHolder:"必须输入密码",
                label:"密码"
            },
            rememberPassword:{
                type:"checkbox",
                label:"记住密码"
            },
            loginButton:{
                type:"button",
                label:"登录",
                action:"onLogin",
                buttonClass:"fullButton"
            },
            retrieveButton:{
                type:"button",
                label:"找回密码",
                action:"onFindPassword",
                buttonClass:"rightTextButton"
            },
            toRegistButton:{
                type:"button",
                label:"注册",
                action:"toRegist"
            },
			
			
            /*icon:{
                label:"头像",
                type:"image",
                size:{
                    width:128,
                    height:128
                }
            },*/
            oldPassword:{
                type:"password",
                placeHolder:"请输入原密码",
                label:"原密码"
            },
            newPassword:{
                type:"password",
                placeHolder:"请输入新密码",
                label:"新密码"
            },
            confirmPassword:{
                type:"password",
                placeHolder:"请再次输入密码",
                label:"确认密码"
            },
            changePasswordButton:{
                type:"button",
                label:"确定",
                action:"onChange"
            },
            //消费者改密码
            changePasswordCButton:{
                type:"button",
                label:"确定",
                action:"onChangeC"
            },
            logo:{
                type:"image",
                label:"头像",
				sizeType:"cut",
                size:{
                    width:128,
                    height:128
                }
            },
            pName:{
                type:"text",
                placeHolder:"",
                label:"姓名"
            },
			nickName:{
                type:"text",
                placeHolder:"",
                label:"昵称"
			},
			amount:{
                type:"number",
                placeHolder:"",
                label:"余额"
			},
            phone:{
                type:"tel",
                placeHolder:"",
                label:"手机号"
            },
            birthDay:{
                type:"date",
                label:"生日"
            },
            sex:{
                type:"options",
                label:"性别",
                options:{
                    0:"男",
                    1:"女"
                },
                canEdit:true
            },
            address:{
                type:"text",
                label:"地址"
            },
            submitButton:{
                type:"button",
                label:"完成",
                action:"onSave"
            },
            toChangepasswordButton:{
                type:"button",
                label:"修改密码",
                action:"toChangePassword"
            },
            toLogoutButton:{
                type:"button",
                label:"注销",
                action:"logout"
            },
            "userName,vcode":{
                type:"vcode",
                errorMsg:"请输入正确的11位电话号码",
                unExists:"账号已经存在,请直接登录"
            },
            onRetrieveButton:{
                type:"button",
                label:"确定",
                action:"onRetrieve",
				buttonClass:"registerButton"
            },
            shopName:{
                type:"text",
                placeHolder:"取一个好听的店铺名吧",
                label:"店铺名"
            },
            shopLevel:{
                type:"options",
                label:"主体类别",
                options:{1:"区县",2:"乡镇",3:"企业"},
                canEdit:true
            },
            inviter:{
                type:"tel",
				placeHolder:"请填写邀请人的手机号",
                label:"邀请人"
            },
            onRegisterBButton:{
                type:"button",
                label:"注册",
                action:"onRegisterB",
				buttonClass:"registerButton"
            },
            onBusinessRegistButton:{
                type:"button",
                label:"确定",
                action:"onBusinessRegist",
				buttonClass:"registerButton"
            },
            onRegisterButton:{
                type:"button",
                label:"确定",
                action:"onRegister"
            },
            //平台服务协议按钮
            helpVerificationButton:{
                type:"button",
                label:"平台服务协议",
                action:"moveToHelpVerification"
            },
			//编辑按钮
			userActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' onclick='window.moveToView(\"user\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            },
            "verifyCode" : {
                type:"VerifyCode",
            }
        },
        _hasLogin:false,
        onLoginChanged:function(hasLogin){
            this._hasLogin = hasLogin;
        },

        getUserMenu:function(){
            var userInfo = user.getUserData();
            return this._hasLogin&&userInfo?[{
                label:userInfo.pName,
                href:"#personalInfo"
            },{
                label:"退出",
                dataProvider:"cq/bo/user",
                clickAction:"logout"
            }]:[{
                label:"登录",
                href:"#login"
            },{
                label:"注册",
                href:"#register",
            }];
        },
        logout:function(){
            localStorage.removeItem(this.loginShopId+"password");
            localStorage.removeItem(this.loginShopId+"rememberPassword");
            topic.publish("whz/shop/changed", {_id:this.loginShopId});
            user.logout().then(function(){
                window.moveToView("login");
            });
        },
        //获取登录的平台id
        loginShopId:null,
        onFindPassword:function(){
            window.moveToView("retrieve");
        },
        onChange:function(data,widgets){
            // 新密码和老密码不能一样
            if (data.oldPassword === data.newPassword) {
                alert("原密码和新密码不能一样");
                return;
            }
            if (!data.newPassword || data.newPassword !== data.confirmPassword) {
                alert("新密码必须输入，且两次输入的密码需一致");
                return;
            }
            user.changeMchPassword(data.oldPassword, data.newPassword).then(lang.hitch(this, function (result) {
                if (result.data.ok === 1) {
                    widgets.setData("");
                    //清除原先的密码
                    localStorage.removeItem(this.loginShopId+"password");
                    history.back();
                } else {
                    widgets.updateByField("oldPassword");
                    alert("修改失败，请检查原密码是否正确");
                }
            }));
        },
        getNull:function(){
            return null;
        },
        onSave:function(data){
			if(data.pName==""||data.phone==""){
				alert("请输入姓名和手机号");
			}else{
				user.save(data).then(function(){
					user.info.logo = data.logo || user.info.logo;
					user.info.pName = data.pName || user.info.pName;
					user.info.phone = data.phone || user.info.phone;
					history.back(-1);
				});
            } 
        },
        loadUserInfo:function(){
            return user.hasLogin().then(lang.hitch(this,function(userId){
                if(userId){
					return user.loadById(user.getUserData()._id).then(lang.hitch(this, function(userData){
						return userData.data.item;
					}));
                }else{
                    return {};
                }
            }));
        },
		
        loadUser:function(cqInfo){
            return user.loadById(cqInfo.cqViewParam.params).then(function(data){
                return data.data.item;
            });
        },
		//获取客户管理的列表的Url
        getUserUrl : function() {
          return user.getUserUrl();
        },	

		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                //query.pName = params.search;
				query.search = params.search;
            }
            return query;
        },
		
        getUserGridLayout: function() {
			if(!this.userGridLayout){
				this.userGridLayout = this.getFormItems(["pName","nickName","amount","phone","address","userActions"],false);
			}
            return this.userGridLayout;
        },
			
		//登陆
        getLoginLayout:function(){
            if(!this.loginLayout){
                this.loginLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "userName","password","rememberPassword","loginButton","retrieveButton"
                    ])
                }];
            }
            return this.loginLayout;
        },
        
        getVerLoginLayout:function(){
            return [{
                type:"content",
                content:'"<form id="cq-auto-3" class="cq-form " onsubmit="return false"><div>我的html哦</div><div id="cq-auto-4" class="cq-form-item" data-cq-field="userName"><label id="cq-auto-5" class="cq-form-label">手机号</label><input id="cq-auto-6" class="cq-form-input cq-field-input" placeholder="请填写手机号" data-dojo-props="canEdit:\'true\',placeholder:\'请填写手机号\'" data-cq-field="userName" type="tel"/></div><div id="cq-auto-7" class="cq-form-item" data-cq-field="password"><label id="cq-auto-8" class="cq-form-label">密码</label><input id="cq-auto-9" class="cq-form-input cq-field-input" placeholder="必须输入密码" data-dojo-props="canEdit:\'true\',placeholder:\'必须输入密码\'" data-cq-field="password" type="password"/><a href="#retrieve" class="cq-form-link">忘记密码?</a></div><div id="cq-auto-a" class="cq-form-item" data-cq-field=""><button id="cq-auto-b" class="cq-action cq-form-button " data-cq-field="loginButton" cq-action="onLogin">登录</button></div></form>"'
            }];
            if(!this.prjLoginLayout){
                this.prjLoginLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "userName","password",/*"verifyCode",*/"loginButton"
                    ])
                }];
                this.prjLoginLayout[0].fields[1].tips = {
                    type:"link",
                    content:"忘记密码?",
                    href:"#retrieve"
                };
            }
            return this.prjLoginLayout;
        },

		onLogin:function(data,widgets){
            this.loginShopId = user.getShopId();
            if(!data.userName){
                alert("请输入用户名");
                return;
            }
            if(!data.password){
                alert("请输入密码");
                return ; 
            }
			if(data.verifyCode===""){
				alert("请输入验证码");
				return ;
			}
            localStorage.setItem(this.loginShopId+"userName",data.userName);
            this.loginPassword(data.userName,data.password,data.verifyCode).then(lang.hitch(this,function(datas){
                if(datas.data.ok==1){
                    if(data.rememberPassword){
                        localStorage.setItem(this.loginShopId+"password",data.password);
                        localStorage.setItem(this.loginShopId+"rememberPassword",true);
                    }else if(widgets){
                        widgets.updateByField("password");
                    }
                    window.moveToView(appConfig.nextPageOnLogin||"shopList-auto");
                }else{
                    alert(datas.data.msg||"无效的用户名或密码");
                }
            }));
        },
		//添加回车登陆
        onLoginEnter:function(widget,field,value){
            if(("password"===field||"verifyCode"===field)&&value){
                this.onLogin(widget.getData(),widget);
            }
        },
        loginPassword:function(userName,password,verifyCode){
            return user.loginByPassword(userName,password,verifyCode);
        },
        //添加登录页面的初始化值事件
        loadInitInfo:function(data,widgets){
            var obj ={};
			var shopId = user.getShopId();
            if(localStorage.getItem(shopId+"userName")){
                obj.userName = localStorage.getItem(shopId+"userName");
            }
            if(localStorage.getItem(shopId+"password")){
                obj.password = localStorage.getItem(shopId+"password");
                obj.rememberPassword =true;
            }
            if(localStorage.getItem(shopId+"rememberPassword")){
                this.onLogin(obj);
            }
            return obj;
        },
        getLoginActionState:function(data,states){
            states.toRegist = {hide:!!data.userName};
            states.toRegist.label = data.userName;
        },
        toRegist:function(){
            window.moveToView("register");
        },
        //找回密码提交按钮
        onRetrieve:function(data,widgets){
             //console.log(data);
            if (!data.userName) {
                alert("请输入手机号码");
                return;
            } else if (data.vCode === "") {
                alert("验证码不能为空");
                return;
            } else if (data.password === "" || data.confirmPassword === "") {
                alert("密码不能为空");
                return;
            } else if (data.password != data.confirmPassword) {
                alert("两次密码不一致");
                return;
            } else {
                //登录请求
                user.resetPassword({
                    "userName": data.userName,
                    "password": data.password,
                    "vCode": data.vcode,
                    "shopId": user.getShopId()
                }).then(lang.hitch(this, function(result) {
                    if (result.data.ok === 1) {
                        widgets.setData("");
                        window.moveToView("login");
                    } 
                    else{
                        alert(result.data.msg);
                    }
                }));
            }
        },
        //店铺列表相关接口
        getUserShopUrl:function(){
            return user.getShopUserUrl();
        },
        getUserShopItemProp:function(data,itemType){
            return {
                icon:data.shopId.logo||"",
                label:data.shopId.shopName||"",
                data:data
            };
        },
        onSelectedUserShop:function(data,action,targetView){
            user.setCurrentShopLists(data);
            window.moveToView(action||"home");
        },
        getUserShopQuery:function(){
            return {};
        },
        //个人信息显示
        getpersonalInformationLayout:function(){
            if(!this.personalInformationLayout){
                this.personalInformationLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "logo","pName","phone","birthDay","sex","address","submitButton"
                    ])
                }];
            }
            return this.personalInformationLayout;
        },
        //跳转至修改密码界面
        toChangePassword:function(){
            window.moveToView("changePassword");
        },
        //修改密码界面显示
        getChangePasswordLayout:function(){
            if(!this.changePasswordLayout){
                this.changePasswordLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "oldPassword","newPassword","confirmPassword","changePasswordButton"
                    ])
                }];
            }
            return this.changePasswordLayout;
        },
        //找回密码
        getRetrieveLayout:function(){
            if(!this.retrieveLayout){
                this.retrieveLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "userName,vcode","password","confirmPassword","onRetrieveButton"
                    ])
                }];
                this.retrieveLayout[0].fields[0].canToLogin = false;
            }
            return this.retrieveLayout;
        },
        //注册
        getRegisterBLayout:function(){
            if(!this.registerBLayout){
                this.registerBLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "userName,vcode","shopName","password","confirmPassword","inviter","onRegisterBButton"//样式不对，暂时隐藏服务协议,"helpVerificationButton"
                    ])
                }];
            }
            return this.registerBLayout;
        },
        //添加商家
        getBusinessRegistLayout:function(){
            if(!this.businessRegistLayout){
                this.businessRegistLayout = [{
                    type:"form",
                    formClass:"user-add",
                    fields:this.getFormItems([
                        "shopLevel","userName","shopName","password","confirmPassword","onBusinessRegistButton"
                    ])
                }];
            }
            return this.businessRegistLayout;
        },
        getCheckPlatformUser:function(userName){
            return user.checkPlatformUser(userName);
        },
        //注册界面用户输入用户名后失去焦点时检测用户账号，如果存在则跳到登录界面
        getRegisterBChangeMethod:function(widget,field,value){
            if(field=="userName"){
                if(value.length==11){
                    this.getCheckPlatformUser(value).then(lang.hitch(this, function(userData) {
                        if (userData.data.ok === 1) {
                            alert("账号已经存在,请登录");
                            setTimeout(function() {
                                window.moveToView("login");
                            }, 300);
                        } 
                    }));
                }
            }
        },
        getBusinessRegistMethod:function(widget,field,value){
            if(field=="userName"){
                if(value.length==11){
                    this.getCheckPlatformUser(value).then(lang.hitch(this, function(userData) {
                        if (userData.data.ok === 1) {
                            alert("手机号已经存在,请重新输入手机号");
                            var data = widget.getData();
                            data.userName = "";
                            widget.setData(data);
                        } 
                    }));
                }
            }
        },
        onRegisterB:function(data){
            //console.log(data);
            if(!data.userName){
                alert("手机号不能为空");
                return;
            }else if (!common.isCellPhone(data.userName)){
                alert("手机号码格式不对");
                return;
            }else if(!data.vcode){
                alert("验证码不能为空");
                return;
            }else if(data.password === "" || data.confirmPassword === ""){
                alert("密码不能为空");
                return;
            }else if(data.password != data.confirmPassword){
                alert("两次密码不一致");
                return;
            }
            data.platformShopId = config.getPlatformShopId();
            data.vCode = data.vcode;
            if(data.inviter){
                window.busy();
                //若存在则通过其值查找id
                user.checkPlatformUser(data.inviter).then(lang.hitch(this, function(inviterdata) {							
                    if(inviterdata.data.ok === 1&&inviterdata&&inviterdata.data&&inviterdata.data.item&&inviterdata.data.item._id){
                        data.inviter = inviterdata.data.item._id
                    }else{
                        delete data.inviter;
                    }
                    shop.onSubmitShop(data).then(lang.hitch(this, function(datas) {
                        window.free();
                        if (datas.shop) {
                            user.setCurrentShop(datas.shop);
                            topic.publish("whz/shop/changed", window.__shop);
                            window.moveToView("home");
                        } else {
                            alert("提交失败!");
                        }								
                    }));
                }));
            } else {
                window.busy();
                delete data.inviter;
                shop.onSubmitShop(data).then(lang.hitch(this, function(datas) {
                    window.free();
                    if (datas.shop) {
                        user.setCurrentShop(datas.shop);
                        topic.publish("whz/shop/changed", window.__shop);
                        window.moveToView("home");
                    } else {
                        alert("提交失败!");
                    }
                }));
            }                    
        },
        onBusinessRegist:function(data){
            //console.log(data);
            if(!data.userName){
                alert("手机号不能为空");
                return;
            }else if (!common.isCellPhone(data.userName)){
                alert("手机号码格式不对");
                return;
            }else if(data.password === "" || data.confirmPassword === ""){
                alert("密码不能为空");
                return;
            }else if(shop.getShopId() === config.getPlatformShopId()){
                alert("不能在平台执行此操作");
                return;
            }else if(data.password != data.confirmPassword){
                alert("两次密码不一致");
                return;
            }
            data.platformShopId = config.getPlatformShopId();
                window.busy();
                shop.createShopNoCode(data).then(lang.hitch(this, function(datas) {
                    window.free();
                    if (datas.data.ok) {
                        shop.clone({shopId:datas.data.item.shop._id,targetShopId:shop.getShopId()}).then(function(shopData){
                            shop.modifyPartner({targetShopId:datas.data.item.shop._id,shopLevel:data.shopLevel});
                        });
                        history.back();
                    } else {
                        alert("提交失败!");
                    }
                }));
        },
        //消费者端注册
        getRegisterLayout:function(){
            if(!this.registerLayout){
                this.registerLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "userName,vcode","password","confirmPassword","onRegisterButton"
                    ])
                }];
            }
            return this.registerLayout;
        },
        //消费者端注册事件
        onRegister:function(data,widgets){
             user.register({
                "userName": data.userName,
                "password": data.password,
                "vCode": data.vcode
            }).then(lang.hitch(this, function(result) {
                if (result.data.ok === 1) {
                    widgets.setData("");
                    localStorage.setItem("userName",data.userName);
                    user.loginByPassword(data.userName, data.password).then(lang.hitch(this, function(r){
                        if(r.data.ok==1){
                            window.moveToView(user.nextPage||"user");
                        }else{
                            alert("登录失败");
                        }
                    }));
                } else if (result.data.status === 101) {
                    alert("验证码错误");
                } else if (result.data.status === 102) {
                    alert("验证码已过期");
                } else if (result.data.status === 310) {
                    alert("用户名已存在");
                }
            }))
        },
        getChangePasswordCLayout:function(){
            if(!this.changePasswordLayout){
                this.changePasswordLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        "oldPassword","newPassword","confirmPassword","changePasswordCButton"
                    ])
                }];
            }
            return this.changePasswordLayout;
        },
        onChangeC:function(data,widgets){
            // 新密码和老密码不能一样
            if (data.oldPassword === data.newPassword) {
                alert("原密码和新密码不能一样");
                return;
            }
            if (!data.newPassword || data.newPassword !== data.confirmPassword) {
                alert("新密码必须输入，且两次输入的密码需一致");
                return;
            }
            user.changePassword(data.oldPassword, data.newPassword).then(lang.hitch(this, function (result) {
                if (result.data.ok === 1) {
                    widgets.setData("");
                    //清除原先的密码
                    localStorage.removeItem(this.loginShopId+"password");
                    history.back();
                } else {
                    widgets.updateByField("oldPassword");
                    alert("修改失败，请检查原密码是否正确");
                }
            }));
        },
        //平台服务协议跳转
        moveToHelpVerification:function(){
            window.busy();
            require(["cq/biz/article/article"],function(article){
                article.loadPlatformByTitle("平台服务协议").then(function(data) {
                    window.free();
                    if (data.data.ok === 1) {
                        window.moveToView("helpVerification", "平台服务协议");
                    } else {
                        alert('暂无平台服务协议');
                    }
                });
            });
        },
        
        
        
        //依据模版字符串获取用户登录提示信息
        getAppUserTitle:function(cqRefInfo,options){
            var format = options&&options.format||"[客户名称]您好",userInfo = user.getUserData()||{};
            return user.defTest(format.replace("[客户名称]",userInfo.pName||""));
        }
    });
    topic.subscribe("/cq/biz/user/user/hasLogin",function(hasLogin){
        userBo.onLoginChanged(hasLogin);
    });
    user.hasLogin();

    return userBo;
});
