﻿define([
    "dojo/topic",
    "./BoBase"
],function(topic,BoBase){
    var widgetTextModel = new BoBase({
        fields:{
            //文本框
            userName:{
                type:"tel",
                placeHolder:"请填写手机号",
                label:"账号"
            },
            //密码框
            password:{
                type:"password",
                placeHolder:"必须输入密码",
                label:"密码"
            },
            //checkbox/开关编辑——bool值
            rememberPwd:{
                type:"checkbox",
                label:"记住密码"
            },
            //checkbox/开关编辑——bool值
            isStaff:{
                type:"checkbox",
                label:"保持登录",
                canEdit:false
            },
            //多行文本编辑
            address:{
                type:"textarea",
                label:"用户简介",
                canEdit:false
            },
            //年月日编辑
            date:{
                type:"date",
                label:"日期",
                canEdit:true
            },
            //列表选项编辑
            "sex":{
                type:"options",
                label:"性别",
                options:{
                    0:"男",
                    1:"女"
                },
                canEdit:true
            },
            //单图编辑
            "icon":{
                type:"image",
                //控制图片大小的方式，
                //cut:剪切
                //compress:压缩
                sizeType:"cut",
                size:{
                    width:128,
                    height:128
                },
                label:"店铺图标"
            },
            //图片列表编辑
            "icons":{
                type:"images",
                //控制图片大小的方式，
                //cut:剪切
                //compress:压缩
                sizeType:"cut",
                size:{
                    width:800,
                    height:600
                },
                canEdit:true
            },
            //手机号/验证码编辑
            "username,vCode":{
                type:"vcode",
                errorMsg:"请输入正确的11位电话号码",
                unExists:"账号已经存在,请直接登陆"
            },
            //引用编辑
            "newsId":{
                type:"ref",
                field:"newsId",
                label:"资讯",
                searchField:"title",
                pageSize:5,
                labelFields:"title,code",
                dataProvider:"cq/biz/article/article",
                targetMethod:"getArticleUrl",
                canEdit:true
            },
            //格式文本编辑
            content:{
                type:"richText",
                label:"格式文本",
                canEdit:true
            },
            //年月日编辑
            birthDay:{
                type:"date",
                label:"生日"
            },
            //多行文本编辑
            brief:{
                type:"textarea",
                label:"简介"
            },
            brief2:{
                type:"textarea",
                label:"简介"
            },
            //区划编辑,省、市、县、地址文本  测试用，晚上删
            "provinceId,cityId,countyId":{
                type:"dis",
                label:"测试用"
            },
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countyId":{
                type:"district",
                label:"无名区划"
            },
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countyId,distAddr":{
                type:"district",
                label:"区划"
            },
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countyId,townId,villageId":{
                type:"district",
                label:"无名选村",
				townFields:""
            },
            "provinceId,cityId,countyId,townId,villageId,distAddr":{
                type:"district",
                label:"选村",
				townFields:""
            },
            // 对象编辑
            "obj":{
                type:"object",
                label:"对象测试",
                // labelField:"userName",
                rightTextField:"userName",
                canEdit:true,
                fields:{
                    layout:[{
                        field:"userName",
                        type:"tel",
                        placeHolder:"请填写手机号",
                        label:"账号"
                    },{
                        field:"password",
                        type:"password",
                        placeHolder:"必须输入密码",
                        label:"密码"
                    },{
                        field:"rememberPwd",
                        type:"checkbox",
                        label:"记住密码"
                    },{
                        field:"isStaff",
                        type:"checkbox",
                        label:"保持登录",
                        canEdit:false
                    }]
                }
            },
            // 对象列表
            "objs":{
                type:"objects",
                labelField:"userName",
                rightTextField:"password",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                fields:{
                    layout:[{
                        field:"userName",
                        type:"tel",
                        placeHolder:"请填写手机号",
                        label:"账号"
                    },{
                        field:"password",
                        type:"password",
                        placeHolder:"必须输入密码",
                        label:"密码"
                    },{
                        field:"rememberPwd",
                        type:"checkbox",
                        label:"记住密码"
                    },{
                        field:"isStaff",
                        type:"checkbox",
                        label:"保持登录",
                        canEdit:false
                    }]
                }
            },
            saveButton1:{
                type:"button",
                label:"提交1",
                action:"save1"
            },
            saveButton2:{
                type:"button",
                label:"提交2",
                action:"save2"
            },
            saveButton3:{
                type:"button",
                label:"提交3",
                action:"save3",
                buttonClass:""
            },
            
            
            //按钮
            saveButton:{
                type:"button",
                label:"提交",
                action:"save"
            },
            readonlyLink:{
                type:"link",
                label:"只读点击",
                href:"",
                icon:""
            },
            "link":{
                type:"link",
                label:"点击",
                rightText:"点一下看看",
                href:"#login",
                icon:"https://ss0.baidu.com/73F1bjeh1BF3odCf/it/u=686530479,3007790249&fm=85&s=5E1445851CCA3AC4618D5D960300C0AA"
            }
        }
    });
    var widgetBo =  {
        widgetTest:[{}],
        widgetAction:{},
        widgetTestLayout:[{
            type:"form",
            fields:widgetTextModel.getFormItems([
                "userName","password","brief","rememberPwd","saveButton","isStaff","address","lon,lat","lon2,lat2","sex","date","icon","icons","username,vCode","newsId","content","provinceId,cityId,countyId,distAddr"
            ])
        }],
        getWidgetTestLayout:function(){
            return this.widgetTestLayout;
        },
        getMobileTestLayout:function(){
            if(!this.mobileTestLayout){
                this.mobileTestLayout = [{
                    type:"form",
                    fields:widgetTextModel.getFormItems([
                        "userName","password","rememberPwd","saveButton1","saveButton2","saveButton3","saveButton",{
                            field:"sex"//,
                            //canEdit:false
                        },"birthDay","brief","brief2","content","username,vCode","icon","icons","newsId",
                        "provinceId,cityId,countyId",
						"provinceId,cityId,countyId,distAddr",
						"provinceId,cityId,countyId,townId,villageId",
						"provinceId,cityId,countyId,townId,villageId,distAddr"
						//"lon,lat","lon2,lat2","obj","objs","readonlyLink","link"
                    ])
                }];
            }
            return this.mobileTestLayout;
        },
        save:function(data){
            alert(JSON.stringify(data));
        },
        save1:function(data){
            alert("save1");
        },
        save2:function(data){
            alert("save2");
        },
        save3:function(data){
            alert("save3");
        }
    };
    return widgetBo;
});
