define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dijit/_Widget",
    "dojo/_base/json",
    "dojo/dom-construct",
    "dojo/dom-style"
], function(declare, lang, array, Widget,json,domConstruct,domStyle){
    return declare("cq.ui.Barrage", Widget,{
        id:"",
        cqBizObj:"",
        cqBizAction:"",
        cqBizParam:"",
        cqBizMsgField:"",
        duration:30000,
        obj:null,
        fontSize:20,
        fillTextArr:["数据正在加载中......"],
        resize:function(){
            if(domStyle.get(this.domNode, "height") != this.canvasNode.height ||
            domStyle.get(this.domNode, "width") != this.canvasNode.width){
                this.inherited(arguments);
                this.resizeCanvas();
            }
        },
        onDefRendered:function(data){
        },
        startup:function(){
            this.inherited(arguments);
            if(!this.obj){
                require([this.cqBizObj],lang.hitch(this, function(obj){
                    if(!this.obj){
                        this.obj = obj;
                        this.timer = setInterval(lang.hitch(this, this.loadBizData),this.duration);
                        this.loadBizData();
                    }
                }));
            }
            this.resizeCanvas();
        },
        loadBizData:function(){
            this.obj[this.cqBizAction](json.fromJson(this.cqBizParam)).then(lang.hitch(this, function(data){
                this.onDefRendered(data);
                if(data && data.length){
                    this.fillTextArr = array.map(data, function(item){
                        return item[this.cqBizMsgField];
                    }, this);
                    this.startDraw();
                }
            }));
        },
        destroyRecursive:function(){
            this.inherited(arguments);
            clearInterval(this.timer);
            this.timer = null;
        },
        buildRendering:function(){
            this.inherited(arguments);
            this.canvasNode = domConstruct.create("canvas",{
                style:"width:100%;height:100%"
            }, this.domNode);
            this.canvasContext = this.canvasNode.getContext("2d");
        },
        resizeCanvas:function(){
            var width = domStyle.get(this.domNode, "width");
            var height = domStyle.get(this.domNode, "height");
            this.canvasNode.width = width;
            this.canvasNode.height = height;
            this._columns = width/this.fontSize;
            this._rows = height/this.fontSize;
            this._drop = [];
            for(var x = 0; x < this._rows; x++){
                this._drop[x] = 0;
            }
            this.startDraw();
        },
        startDraw:function(){
            if(this._drop){
                if(this._drawTimer){
                    clearTimeout(this._drawTimer);
                    this._drawTimer = null;
                }
                this.canvasContext.fillStyle = "rgba(0,0,0,0.07)";
                this.canvasContext.fillRect(0,0,this.canvasNode.width,this.canvasNode.height);
                this.canvasContext.fillStyle="#0F0";
                this.canvasContext.font=this.fontSize+"px arial";
                for(var i=0;i<this._drop.length;i++){
                    var logx = i>=this.fillTextArr.length?i%this.fillTextArr.length:i;
                    var logy = this._drop[i]>=this.fillTextArr[logx].length?this._drop[i]%this.fillTextArr[logx].length:this._drop[i];
                    var text1=this.fillTextArr[logx][logy];
                    this.canvasContext.fillText(text1,this._drop[i]*this.fontSize,i*this.fontSize);
                    this._drop[i]++;
                    if(this._drop[i]*this.fontSize>this.canvasNode.width&&Math.random()>0.9){//90%的几率掉落
                        this._drop[i]=0;
                    }
                }
                this._drawTimer = setTimeout(lang.hitch(this, this.startDraw),100);
            }
        }
    });
});