// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
// 变更人员：冉伟
// 变更内容：加载更多
// 变更时间：2016/6/23
// 变更人员：冉伟
// 变更内容：解决向上拖动之后，在有数据情况下显示暂无数据的错误状态
// 变更时间：2016/6/27
// 变更人员: 王龙
// 变更时间: 2016/7/11
// 变更内容: 在自动回复的内容中添加编辑和删除按钮
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "dojo/dom-style",
    "cq/ui/view/_ViewMixin",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "cq/biz/article/autoReply",
    "dijit/focus"
], function (declare, lang, array, View, domStyle, _ViewMixin, registry, EdgeToEdgeStoreList, on, when, JsonRest, domClass, autoReply, focusUtil) {
    return declare("cq.ui.b.a.AutoReply", [View, _ViewMixin], {
        // 设置初始显示第0行
        start : 0,
        pageSize : 20,
        // 加载数据,并显示到页面上
        onAfterShow : function () {
            // 重新加载数据并显示页面
            this.setQuery(this.storeList.get("query"), {
                start : this.start,
                count :  this.pageSize
            });
        },
        // 创建列表
        onCreatList : function () {
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div class='webkit-list'>"
                            + "<div class='user-list-left user-list-margin'>类型:" + this.parseRType(data[i].rType) + "</div>"
                            + "<div class='user-list-right user-list-margin'>关键词:" + (data[i].keyword || "") + "</div>"
                            + "</div>"
                            + "<div class='webkit-list'>"
                            + "<div class='user-list-margin'>回复内容:" + (data[i].replyText || "") + "</div>"
                            + "</div>"
                            + "<div class='forth-btn'><span class='float-right delete'>删除</span>"
                            + "<span class='float-right edituser'>编辑</span></div>",
                        data[i].noArrow = 
                        true;
                        data[i].moveTo = "#";
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                itemMap : {
                    _label : "label",
                    logo : "icon"
                }
            });
            // 读取接口
            this.store = new JsonRest({target : autoReply.loadByShopId()});
            // 将数据源赋值给storeList
            this.params = {isUse:true};
            var queryResult = this.storeList.setStore(this.store,this.params,{
                start:this.start,
                count:this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            // 侦听列表点击事件
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            // 侦听列表下拉事件
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
        },
        // 初始化页面元素,绑定事件
        onFirstShow : function () {
            // 创建头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "自动回复"
            };
            this.addHeader(option);
            // 创建底部信息
            option = {
                columns : [{
                        label : '添加自动回复',
                        icon : 'images/icon/crmicon.png',
                        iconClass : 'footer-tab-img',
                        onClick : function () {
                            window.moveToView("autoReplyDetail");
                        }
                    }
                ],
                valueClass : 'font-size3',
                labelClass : 'font-size1',
                className : 'fix-footer',
                isFooter : true
            },
            this.addColumns(option);
            this.onCreatList();
        },
        //重写点击事件
        onClickList : function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem"){
                return;
            }
            //var _tsId = li._id;
            //window.moveToView("autoReplyDetail", _tsId);
            var dom = evt.target;
            //删除
            if(dom&&domClass.contains(dom,"delete")){
                var _id = li.params._id;
                autoReply.deleteById(_id);
                // 删除数据的同时同时删掉这一行
                domStyle.set(dom.parentNode.parentNode.parentNode,"display","none");
            }
            //编辑
            if(dom&&domClass.contains(dom,"edituser")){
                var _id = li.params._id;
                window.moveToView("autoReplyDetail",_id);
            }
        },
        // 重新赋值列表并刷新显示
        setQuery : function (query) {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();
        },
        // 下拉列表加载更多
        onLoadMore : function (evt) {
			//判断下拉方向和能否加载
            if (!this.busy&&evt.afterBottom) {
				//设置本次加载内容的起始位置
                this.start = this.start + this.pageSize;
				//判断能否加载更多内容
				if(this.canLoadMore(this.start)){
					this.busy = true;
                    setTimeout(lang.hitch(this, function () {
						//执行加载内容操作
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
						//执行加载更多函数
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
				}
            }
        },
        // 回复的类型
        parseRType : function (rTyId) {
            var type = "";
            var types = {
                '00000' : '新会员关注自动回复',
                '99999' : '找不到自动回复时的回复',
                '其他' : '其他'
            };
            type = types[rTyId] || "未知";
            return type;
        }
    });
});