// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
// 变更人:徐阿雪
// 变更时间:2016/6/24
// 变更原因:页面处理时候的busy和Free,防止重复提交
// 变更人员:王龙
// 变更时间:2016/7/6
// 变更原因:解决回复类型为文本时，点击回复图片后，该字段始终在选中状态的BUG
// 变更人员:王龙
// 变更时间:2016/7/11
// 变更内容:隐藏是否启用按钮
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/autoReply",
    "dojo/query",
    "dijit/registry"
], function (declare, lang, domStyle, View, _ViewMixin, autoReply, query, registry) {
    return declare("cq.ui.b.a.AutoReplyDetail", [View, _ViewMixin], {
        // 是否编辑状态
        isEditing: false,
        // 加载数据,并显示到页面上
        onAfterShow: function () {
            // 如果是变更，加载自动回复信息
            if (!this.isEditing) {
                this.isEditing = true;
                if (!window.did) {
                    this.setData({
                        isUse: true
                    });
                    this.refreshData();
                } else {
                    // 读取接口
                    autoReply.loadById(window.did).then(lang.hitch(this, function (data) {
                        // 显示自动回复信息 加载信息
                        this.setData(data.data.item);
                        this.refreshData();
                    }));
                }
            }
            this.onDataChanged();
        },
        // 初始化页面元素,绑定事件
        onFirstShow: function () {
            // 创建头部信息
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function () {
                        this.isEditing = false;
                        history.back();
                    })
                },
                title: "自动回复设置",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            // 创建列表
            option = {
                isEdge: true,
                lists: [{
                    label: '触发条件',
                    rightText: '',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'options',
                        field: 'rType',
                        options: {
                            '00000': '新会员关注自动回复',
                            '99999': '找不到自动回复时的回复',
                            '其他': '其他'
                        }
                    }
                }, {
                    label: '回复类型',
                    rightText: '',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'options',
                        field: 'replyType',
                        options: {
                            'text': '文本',
                            'image': '图片',
                            'aritcle': '图文'
                        }
                    }
                }, {
                    label: '关键词',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'keyword',
                        placeHolder: '必填'
                    }
                }, {
                    label: "回复图片",
                    noArrow: false,
                    edit: {
                        type: "image",
                        field: "imgUrl"
                    },
                    class: "li-icon",
                    moveTo: "#"
                }, {
                    label: '回复内容',
                    moveTo: "#",
                    edit: {
                        type: 'textarea',
                        field: 'replyText'
                    }
                }, {
                    label: '链接网址',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'url'
                    }
                }]
            };
            this.addLists(option);
            this.onAfterShow();
        },
        //编辑状态变更
        onDataChanged: function () {
            var reType = this.getData().replyType;
            // var picContent=this.getData().imgUrl;
            var li = query(".li-icon", this.domNode)[0];
            var textcontent = query(".mblListItem",this.domNode)[4];
            if (reType === "text") {
                //取得当前图片的对象，清空图片
                var data = this.getData();
                data.imgUrl="";
                this.setData(data);
                this.refreshData();
                domStyle.set(li,"display","none");
                domStyle.set(textcontent,"display","block");
            } else if (reType === 'image') {
                var data = this.getData();
                data.replyText="";
                this.setData(data);
                this.refreshData();
                domStyle.set(li,"display","block");
                domStyle.set(textcontent,"display","none");
            } else if (reType === 'aritcle'){
                domStyle.set(li,"display","block");
                domStyle.set(textcontent,"display","block");
            }
        },
        // 保存信息
        onSaveStore: function () {
            // 当前节点失去焦点
            //focusUtil.curNode && focusUtil.curNode.blur();
            // setTimeout 保存数据
            // 徐阿雪  页面处理时候的busy和Free,防止重复提交， 2016/6/24
            window.busy();
            var m = this.getData();
            var msg = this.verify(m);
            if (msg) {
                window.free();
                alert(msg);
                return;
            }
            autoReply.save(m).then(function (data) {
                window.free();
                if (data.data.ok === 1) {
                    history.back();
                } else {
                    //是否需要添加window.busy();
                    alert("保存失败");
                    this.isEditing = true;
                }
            });
        },
        // 检查必填项是否已填
        verify: function (data) {
            var msg = "";
            if (!data.rType) {
                msg = "触发条件必须选择";
            } else if (!data.replyType) {
                msg = "类型必须选择";
            } else if (!data.keyword) {
                msg = "关键词必须填写";
            } else if (!data.replyText) {
                var reType = this.getData().replyType;
                var li = query(".li-icon", this.domNode)[0];
                var textcontent = query(".mblListItem",this.domNode)[4];
                if(reType === "text"||reType === 'aritcle'){
                    msg = "回复内容必须填写";
                } else if(reType==="image"){
                    return;
                }   
            }
            return msg;
        }
    });
});