// 变更人：潘云
// 变更时间：2016-05-17
// 变更事项：代码规范、注释、迁移
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/query",
    "dojox/mobile/View",
    "dojox/mobile/ContentPane",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/article"
],function(declare,lang,domStyle,query,View,ContentPane,_ViewMixin,article){
    // module:
    // cq/ui/b/a/NewDetail
    return declare("cq.ui.b.a.NewDetail",[View,_ViewMixin],{
        // 第一次进入页面，加载页面元素
        onFirstShow:function(){
            // 添加页面头部
            var option = {
                left:{
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        window.moveToView("newsList");
                    }
                },
                title: "资讯详情",
            };
            this.addHeader(option);
            // 添加页面底部编辑按钮
            option = {
                columns: [{
                    label: '编辑资讯',
                    icon: 'images/icon/addnews.png',
                    iconClass: 'width-16',
                    onClick: function() {
                        window.moveToView("news", window.did);
                    }
                }],
                valueClass: 'font-size3',
                labelClass: 'font-size1',
                className: 'fix-footer footerGrayTopBorder',
                isFooter: true
            }
            this.addColumns(option);
            this.onAfterShow();
        },
        // 每次进入页面都会对页面数据进行刷新
        onAfterShow: function() {
            // 执行基类的操作
            this.inherited(arguments);
            article.loadById(window.did).then(lang.hitch(this, function(data) {
                if(data.data.ok == 1){
                    if(this.dtlPane){
                        this.dtlPane.destroy();
                    }
                    data = data.data.item;
                    data.createAt = new Date(data.createAt);
                    var contentHtm = "<div class='title'>" + data.title + "</div>";
                    contentHtm += "<div class='time'>" + data.createAt.toLocaleDateString() + "</div>";
                    contentHtm += "<img class='img' src='" + data.logo + "' />";
                    contentHtm += "<div class='content'>" + data.content + "</div>";
                    this.dtlPane = new ContentPane({
                        content: contentHtm,
                        class: "dtlnew_view"
                    });
                    this.dtlPane.placeAt(this.centerPanel.containerNode, "last");
                }
            }));
        }
    });
});