// 变更人：潘云
// 变更时间：2016-05-17
// 变更事项：代码规范、注释、迁移
// 变更人：周超
// 变更时间：2016-06-8
// 变更事项：bug修复，1、栏目可以为空 2、m.section的条件判断，外层再添一层判断，避免未写入栏目时的报错
//变更人：程磊
//变更时间：20160624
//变更事项：界面busy/free
//变更人：周科吉
//变更时间：2016-07-08
//变更事项：修改栏目为微信栏目，并在标题后面加一列资讯类别的选项
//变更人：张松
//变更时间：2016-07-26
//变更事项：添加是否置顶标志
//变更人：周科吉
//变更时间： 2016-08-03
//变更事项：bug修复，保存完成后跳转

// 变更人: 刘轩
// 变更时间: 2016/9/5
// 变更事项: 保存后的返回直接用history.back()
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/article",
    "cq/biz/article/section",
    "cq/biz/article/articleGroup"
],function(declare,lang,View,_ViewMixin,article,section,articleGroup){
    // module:
    //      cq/ui/b/a/News
    return declare("cq.ui.b.a.News",[View,_ViewMixin],{
        // 页面是否处在编辑中，默认值为false
        isEditing : false,
        imgWidth: 900,
        imgHeight: 500,
        // 加载数据
        onAfterShow : function() {
            if(!this.isEditing){
                this.isEditing = true;
                if(!window.did){
                    this.setData({
                        isUse:true
                    });
                    this.refreshData();
                }else{
                    article.loadById(window.did).then(lang.hitch(this, function(data) {
                        if(data.data&&data.data.ok){
                            this.setData(data.data.item);
                            this.refreshData();
                        }
                    }));
                }
            }
        },
        // 第一次进入页面，初始化页面组件
        onFirstShow:function(){
            // 加载页面头部
            var option = {
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:lang.hitch(this,function(){
                        this.isEditing = false;
                        //window.moveToView("newsList");
                        history.back();
                    })
                },
                title:"新增资讯",
                right:{
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            // 加载页面中资讯详情的显示部分
            option = {
                isEdge:true,
                lists:[
                {
                    label : "主题图片",
                    noArrow : false,
                    imgSize:{
                        width: this.imgWidth,
                        height: this.imgHeight
                    },
                    edit :{
                        type:"image",
                        field:"logo"
                    },
                    class : "li-icon",
                    moveTo : "#"
                },
                {
                    label:'资讯编码',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'code',
                        placeHolder:"必填"
                    }
                },
                {
                    label:'标题',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'title',
                        placeHolder:"必填"
                    }
                },
                {
                    label:'资讯类别',
                    moveTo:"#",
                    rightText:'',
                    edit:{
                        type:'ref',
                        field:'groupId',
                        moveTo:"#",
                        params:{
                            target:articleGroup.getLoadUrl(),
                            query:{},
                            searchField:"groupName",
                            labelField:"groupName",
                            addPageId:"newsGroup"
                        }
                    }
                },
                {
                    label:'微信栏目',
                    moveTo : "#",
                    //__view_id : this.id,
                    edit:{
                        type:'ref',
                        field:'section',
                        moveTo:"#",
                        params:{
                            target:section.getSectionUrl(),
                            query:{
                                sectionType:2
                            },
                            searchField:"title",labelField:"title"
                        }
                    }
                },
                {
                    label:'摘要',
                    moveTo:"#",
                    edit:{
                        type:'textarea',
                        field:'brief'
                    }
                },
                {
                    label : '内容',
                    rightText : '资讯详情',
                    moveTo : "#",
                    edit:{
                        type:'richEdit',
                        field:'content'
                    }
                },
                {
                    label:'使用',
                    noArrow:true,
                    edit:{
                        type:'checkbox',
                        field:'isUse',
                        value:"on"
                    }
                },
                {
                    label:'置顶',
                    noArrow:true,
                    edit:{
                        type:'checkbox',
                        field:'isTop',
                        value:"false"
                    }
                }],
                data:this.getData()
                };
            this.addLists(option);
            this.onAfterShow();
        },
        // 将用户修改、新增的数据保存到数据库
        onSaveStore:function(){
            if(this.isEditing){
                //设置界面busy
                window.busy();
                this.isEditing = false;
                var m = this.getData();
                if(!m.shopId){
                    m.shopId=article.getShopId();
                }
                var checkMsg=this.checkFiled(m);
                if(checkMsg){
                    //设置界面free
                    window.free();
                    alert(checkMsg);
                    this.isEditing = true;
                    return;
                }
                article.save(m).then(lang.hitch(this,function(data){
                    //设置界面free
                    window.free();
                    // 保存成功则跳转到资讯列表页面
                    if(data.data.ok === 1){
                        history.back();
                        //window.moveToView("newsList",data.data.item.groupId);
                    }else{
                        alert("保存失败");
                        this.isEditing = true;
                    }
                }));
            }
        },
        // 验证必填项是否有值
        checkFiled:function(data){
            var msg="";
            if(!data.code){
                msg="编码不能为空!";
                return msg;
            }else if(!data.title){
                msg="标题不能为空!";
                return msg;
            }else if(!data.content){
                msg="内容不能为空!";
                return msg;
            }
        }
    });
});