define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/articleGroup"
],function(declare,lang,View,_ViewMixin,articleGroup){
    return declare("cq.ui.b.a.NewsGroup",[View,_ViewMixin],{
        // 页面是否处在编辑中，默认值为false
        isEditing : false,
        // 加载数据
        onAfterShow : function() {
            if(!this.isEditing){
                this.isEditing = true;
                if(!window.did){
                    this.setData({
                        isUse:true
                    });
                    this.refreshData();
                }else{
                    articleGroup.loadById(window.did).then(lang.hitch(this, function(data) {
                        if(data.data&&data.data.ok){
                            this.setData(data.data.item);
                            this.refreshData();
                        }
                    }));
                }
            }
        },
        // 第一次进入页面，初始化页面组件
        onFirstShow:function(){
            // 加载页面头部
            var option = {
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:lang.hitch(this,function(){
                        this.isEditing = false;
                        //window.moveToView("newsList");
                        history.back();
                    })
                },
                title:"资讯类别",
                right:{
                    iconButton:' ',
                    onClick:this.onSaveStore,label:"完成" }
            };
            this.addHeader(option);
            // 加载页面中资讯详情的显示部分
            option = {
                isEdge:true,
                lists:[
                {
                    label : "主题图片",
                    noArrow : false,
                    //imgSize:{width:900,height:500},
                    edit :{
                        type:"image",
                        field:"logo"
                    },
                    class : "li-icon",
                    moveTo : "#"
                },
                {
                    label:'类别编码',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'code',
                        placeHolder:"必填"
                    }
                },
                {
                    label:'类别名称',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'groupName',
                        placeHolder:"必填"
                    }
                },
                {
                    label:'使用',
                    noArrow:true,
                    edit:{
                        type:'checkbox',
                        field:'isUse',
                        value:"on"
                    }
                }],
                data:this.getData()
            };
            this.addLists(option);
            this.onAfterShow();
        },
        // 将用户修改、新增的数据保存到数据库
        onSaveStore:function(){
            if(this.isEditing){
                //设置界面busy
                window.busy();
                this.isEditing = false;
                var m = this.getData();
                var checkMsg=this.checkFiled(m);
                if(checkMsg){
                    //设置界面free
                    window.free();
                    alert(checkMsg);
                    this.isEditing = true;
                    return;
                }
                articleGroup.save(m).then(lang.hitch(this,function(data){
                    //设置界面free
                    window.free();
                    // 保存成功则跳转到资讯列表页面
                    if(data.data.ok === 1){
                        history.back();
                    }else{
                        alert("保存失败");
                        this.isEditing = true;
                    }
                }));
            }
        },
        // 验证必填项是否有值
        checkFiled:function(data){
            var msg="";
            if(!data.code){
                msg="编码不能为空!";
                return msg;
            }else if(!data.groupName){
                msg="标题不能为空!";
                return msg;
            }
        }
    });
});