// 创建人：周超
// 创建时间：2016-06-6
// 创建事项：讲堂录入
// 修改人：周超
// 修改时间：2016-6-23
// 修改事项：上传附件
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/query",
    "dojox/mobile/ListItem",
    "cq/biz/blob/blob",
    "dojox/mobile/View",
    "cq/biz/article/bs/schoolClass",
    "cq/ui/b/p/_PrjMixin",
    "cq/ui/view/_ViewMixin"
    ], function (declare, lang, array, domClass, query, ListItem, blob, View, schoolClass, _PrjMixin, _ViewMixin) {
    // module:
    //      whz/view/SecondaryData
    return declare("cq.ui.b.a.SchoolClassDetail", [View, _ViewMixin,_PrjMixin], {
        //isEditing:boolean;
        //      编辑状态
        isEditing : false,
        onAfterShow : function(){
            if(!this.isEditing){
                this.isEditing = true;
                // 清空附件列表
                this.refreshAttachList([]);
                // 如果是修改，加载信息
                if (window.did) {
                    schoolClass.loadById(window.did).then(lang.hitch(this, function (data) {
                        // 显示信息
                        this.setData(data.data.item);
                        this.refreshData();
                        if(data.data.item.attachs){
                            this.refreshAttachList(data.data.item.attachs);
                        }
                    }));
                }else{
                    this.setData({
                        isUse : 1
                    });
                    this.refreshData();
                }
            }
        },
        //onFirstShow：
        //      初始化界面元素
        //      参数：无
        //      返回值：无
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        this.isEditing = false;
                        history.back();
                    }
                },
                title : "课程编辑",
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            //logo
            //option = {
            //    isEdge : true,
            //    lists : [
            //    ]
            //};
            //this.addLists(option);
            option = {
                isEdge : true,
                lists :
                    [{
                        label : "课程图标",
                        noArrow : false,
                        rightIcon2 : "{{logo}}",
                        edit : {
                            type : "image",
                            field : "logo"
                        },
                        class : "li-icon",
                        moveTo : "#"
                    },{
                        label : '主题',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'title',
                            placeHolder : "必填"
                        }
                    },{
                        label : '主讲人',
                        edit : {
                            type : 'text',
                            field : 'teacher',
                            placeHolder : "必填"
                        }
                    },{
                        label : '报名开始日期',
                        moveTo:"#",
                        edit : {
                            type : 'dateMin',
                            field : 'startSignDate'
                        }
                    },{
                        label : '报名结束日期',
                        moveTo:"#",
                        edit : {
                            type : 'dateMin',
                            field : 'endSignDate'
                        }
                    },{
                        label : '讲堂开始日期',
                        moveTo:"#",
                        edit : {
                            type : 'dateMin',
                            field : 'startDate'
                        }
                    },{
                        label : '讲堂结束日期',
                        moveTo:"#",
                        edit : {
                            type : 'dateMin',
                            field : 'endDate'
                        }
                    },{
                        label:'课程简介',
                        moveTo:"#",
                        edit:{
                            type:'richEdit',
                            field:'content'
                        }
                    },
                    {
                        label : '授课地址',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'address',
                            placeHolder : ""
                        }
                    },
                    {
                        label : '是否使用',
                        noArrow : true,
                        edit : {
                            type : 'checkbox',
                            field : 'isUse'
                        }
                    }
                ]};
            this.addLists(option);
            // 附件信息
            this.createEdtAttachList();
            //添加附件
            var attachment = {
                columns : [{
                    label : "添加附件",
                    icon : 'images/icon/crmicon.png',
                    iconClass : 'footer-tab-img',
                    onClick : function () {
                        this.addAttachment({},true,true);
                    }
                }],
                className : 'fix-footer',
                isFooter : true
            }
            this.addColumns(attachment);
            this.onAfterShow();
        },
        // 依据附件数据刷新附件列表
        refreshAttachList:function(attachs){
            this.attachmentList.destroyDescendants();
            for(var index=0;index<attachs.length;index++){
                this.addAttachment(attachs[index],true,true);
            }
        },
        //添加附件
        addAttachment:function(attach,deleteable,canEditName){
            //设置附件属性
            attach = attach||{
                //标题
                title:"",
                //附件大小
                size:"",
                //附件扩展名
                extension:"",
                //附件链接
                attachUrl:""
            };
            var attachItem = new ListItem({
                label:"<div>"+"<div>"+(
                        false!==canEditName?"上传附件":"附件上传"
                    )+"：<a href='javascript:void(0);' class='attachUrl file'>选择文件<input type='file' class='sample'></a><span class='sampleValue'></span></div>"
                    +"<div style='position: relative; margin-left: 109px' class='InfoName'>"+(attach.title||"")+"</div>"
                    +"<div style='margin-left:16%' class='none InfoNameT'>1</div>"
                    +"<span class='sampleValue'></span></div>",
                rightText:deleteable?"<span class='attachment-cancel'>删除</span>":"",
                variableHeight:true,
                params:attach
            });
            this.attachmentList.addChild(attachItem);
            this.initAttachItemEvent(attachItem);
        },
        initAttachItemEvent:function(attachItem){
            if(0<attachItem.get("rightText").indexOf("attachment-cancel")){
                // 删除按钮
                attachItem.connect(query(".attachment-cancel",attachItem.domNode)[0],"onclick",function(e){
                    this.destroyRecursive();
                });
            }
            // 样表文件
            attachItem.connect(query(".sample",attachItem.domNode)[0],"onchange",function(e){
                window.busy();
                blob.upload(e.target).then(lang.hitch(this,function(data){
                    var fileInfo=e.target.files;
                    //上传文件地址
                    this.params.attachUrl = data.items[0].uri;
                    //文件大小
                    this.params.size = data.items[0].size;
                    //文件名
                    //无法获取到fieldName内容
                    this.params.title = fileInfo[0].name;
                    //this.params.title =
                    //文件类型
                    this.params.extension = data.items[0].mimeType;
                    var showInfo=query(".InfoName",this.domNode)[0];
                    domClass.add(showInfo,"none");
                    var showOther=query(".InfoNameT",this.domNode)[0];
                    domClass.remove(showOther,"none");
                    showOther.innerHTML=fileInfo[0].name;
                }));
                window.free();
            });
        },
        //onSaveStore：
        //      参数：无
        //      返回值：无
        //      保存数据
        onSaveStore:function(){
            if(this.isEditing){
                window.busy();
                this.isEditing = false;
                var m = this.getData();
                m.attachs = this.getAttachsFromList();
                var checkMsg=this.checkFiled(m);
                if(checkMsg){
                    window.free();
                    alert(checkMsg);
                    this.isEditing = true;
                    return;
                }
                m.attachs = JSON.stringify(this.getAttachsFromList());
                schoolClass.save(m).then(lang.hitch(this,function(data){
                    // 保存成功则跳转到资讯列表页面
                    if(data.data.ok === 1){
                        window.free();
                        alert("保存成功");
                        history.back();
                        //window.moveToView("schoolClassList");
                    }else{
                        window.free();
                        alert("保存失败");
                        this.isEditing = true;
                    }
                }));
            }
        },
        //checkFiled:
        //      参数:data :object
        //      返回值：msg :String
        //      检查数据填写
        checkFiled : function (data) {
            var msg = "";
            if (!data.title) {
                msg = "主题还没有填写";
                return msg;
            }else if(!data.teacher){
                msg = "主讲人还没有填写";
                return msg;
            }else if(!data.startSignDate){
                msg = "请选择报名开始日期";
                return msg;
            }else if(!data.endSignDate){
                msg = "请选择报名结束日期";
                return msg;
            }else if(!data.startDate){
                msg = "请选择讲堂开始日期";
                return msg;
            }else if(!data.endDate){
                msg = "请选择讲堂结束日期";
                return msg;
            }else if(data.attachs&&array.some(data.attachs,function(attach){
                    if(!attach.title){
                        msg = "请选择附件！";
                        return msg;
                    }
                })){
                msg = "请选择附件！";
                return msg;
            }
        }
    });
});