// 变更人：周超
// 变更时间：2016-05-17
// 变更事项：创建代码：讲堂列表
//变更人：周超
//变更：固定table顶部
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/query",
    "dojo/store/JsonRest",
    "dojo/when",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/biz/article/bs/schoolClass",
    "cq/util/sys/date",
    "cq/ui/view/_ViewMixin"
],function(declare, lang, on, query, JsonRest, when, registry, View, EdgeToEdgeStoreList, schoolClass, date, _ViewMixin){
    // module:
    //      cq.ui.b.a.SchoolClassList
    return declare("cq.ui.b.a.SchoolClassList",[View,_ViewMixin],{
        // 取数据时的开始下标，默认为0
        start : 0,
        // 每次加载的数据条数，默认为10
        pageSize : 10,
        // 每次进入页面，重新加载数据
        onAfterShow:function(){
            if(this.storeList.store){
                this.setQuery(this.storeList.get("query"));
            }else{
                var queryResult=this.storeList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                // 将数据源赋值给storeList
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
            this.refreshData();
        },
        // 第一次进入页面，加载页面显示的组件
        onFirstShow:function(){
            // 页面的头部
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                        //window.moveToView("schoolClassDetail");
                    }
                },
                title:"讲堂列表"
            };
            this.addHeader(option);
            // 搜索框
            option = {
                isHeader:true,
                placeHolder:"请输入要查询条件，按回车查询",
                type:"search",
                class:"cqSearchBox",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.title = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
						condition.title = "";
                    }
                })
            };
            this.addTextBox(option);
            // 页面尾部按钮
            option = {
                columns:[{
                    label:'添加课堂',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:function(){
                        window.moveToView("schoolClassDetail");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            }
            this.addColumns(option);
            // 咨询的显示列表
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        data[i]._label="<div style='line-height: 45px;'>"
                        +"<div class='mat-list-qty mat-list-margin'>主题:"+((data[i].title)||"")+"</div>"
                        +"<div class='user-list-margin webkit-list'>讲堂时间：<div class='user-list-margin'>"+((data[i].startDate?date.formatISODateMinutes(data[i].startDate):""))+"</div>"
                        +"&nbsp;至&nbsp<div class='user-list-margin'>"+((data[i].endDate?date.formatISODateMinutes(data[i].endDate):""))+"</div></div>"
                        +"</div><div>"
                        data[i].moveTo="#";
                        data[i]._logo = data[i].logo ? data[i].logo : 'images/nomat.png';
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                    },
                itemMap:{_label:"label",_logo:"icon", moveTo:"moveTo"}
            });
            // 创建数据源
            this.params={
                isUse : true
            };
            this.store = new JsonRest({target:schoolClass.loadUrl()});
            // 将数据源赋值给storeList
            //this.storeList.setStore(this.store,this.params);
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
            this.onAfterShow();
        },
        // 列表项的点击响应事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("schoolClassDetail",_id);
        },
        // 重新赋值列表并刷新显示
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
            //this.centerPanel.resize();
        },
        // 拖动加载更多
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载更多讲堂");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
            
        }
    });
});