// 变更人:徐阿雪
// 变更时间:2016/6/21
// 变更原因:将微信菜单改成微信栏目，将多余的UI删掉
// 变更人:徐阿雪
// 变更时间:2016/6/24
// 变更原因:页面处理时候的busy和Free,防止重复提交
// 变更人:肖芳圆
// 变更时间:2016/7/6
// 变更原因:保存成功后,没有修改页面的编辑状态,导致第二次进入页面没有刷新
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dojo/dom-class",
    "cq/biz/article/section",
    "cq/biz/mat/group",
    "cq/biz/article/autoReply"
],function(declare, lang, array, View, _ViewMixin, query, domClass, section, group, autoReply) {
    //微信栏目编辑对象
    return declare("cq.ui.b.a.SectionDetail", [View, _ViewMixin], {
        //页面的是否在编辑中
        isEditing: false,
        //首次进入界面时的初始化工作
        onFirstShow: function() {
            //顶部标题、返回和完成按钮
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function() {
                        this.isEditing = false;
                        history.back();
                    })
                },
                title: "微信栏目",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            //侦听栏目类型变更事件——侦听自己的onDataChange方法，字段名为栏目类型
            //品类
            //自动回复
            //会员服务
            //...
            option={isEdge:true,lists:[{
                label: '标题',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'title',
                    placeHolder: '必填'
                }
            },{
                //列表选项——栏目类型
                label: '类型',
                noArrow: true,
                className:"mblListItem rootSection",
                edit: {
                    type: 'options',
                    field: 'sectionType',
                    moveTo: "#",
                    options: {
                        1: "一级栏目",
                        2: "资讯栏目",
                        3: "商品栏目",
                        4: "打开网页",
                        5: "自动回复",
                        6: "会员服务",
                        //7:"微信扫码"
                    }
                }
            },{
                //列表选项——栏目类型
                label: '类型',
                noArrow: true,
                className:"mblListItem secondSection",
                edit: {
                    type: 'options',
                    field: 'sectionType',
                    moveTo: "#",
                    options: {
                        2: "资讯栏目",
                        3: "商品栏目",
                        4: "打开网页",
                        5: "自动回复",
                        6: "会员服务",
                        //7:"微信扫码"
                    }
                }
            },{
                label: '编码',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'sCode',
                    placeHolder: '必填'
                },
                className: 'none' //隐藏本字段
            },{
                label: '序号',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'sOrder',
                    placeHolder: '必填'
                },
                className: 'none' //隐藏本字段
            },{
                label: "品类",
                moveTo: "#",
                edit: {
                    type: 'ref',
                    field: 'groupId',
                    params: {
                        target: group.getGroupUrl(),
                        searchField: 'gName',
                        labelField: "gName"
                    }
                },
                className: 'mblListItem sectiondtl_item groupId'
            },{
                label: '自动回复',
                moveTo: '#',
                edit: {
                    type: 'ref',
                    field: 'arId',
                    params: {
                        target: autoReply.loadByShopId(),
                        searchField: "keyword",
                        labelField: "keyword"
                    }
                },
                className: 'mblListItem sectiondtl_item arId'
            },{
                label: '链接地址',
                noArrow: true,
                edit: {
                    type: 'textarea',
                    field: 'targetPath',
                    placeHolder: '必填'
                },
                className: 'mblListItem sectiondtl_item targetPath'
            },{
                label: '服务类型',
                noArrow: true,
                edit: {
                    type: 'options',
                    field: 'svcType',
                    moveTo: "#",
                    options: {
                        1: "我的账户",
                        2: "我的订单",
                        3: "我的收入",
                        4: "我的二维码",
                        5: "附近商家"
                    }
                },
                className: 'mblListItem sectiondtl_item svcType'
            }]};
            this.edgeList = this.addLists(option);
            //刷新数据显示
            this.onAfterShow();
        },
        //获取数据
        getData: function() {
            var data = lang.clone(this.inherited(arguments));
            if (data) {
                if (data.upSection && data.upSection._id) {
                    data.upSection = data.upSection._id;
                }
                if (data.groupId && data.groupId._id) {
                    data.groupId = data.groupId._id;
                }
                if (data.arId && data.arId._id) {
                    data.arId = data.arId._id;
                }
            }
            return data;
        },
        //刷新数据显示
        onAfterShow: function() {
            //若当前非编辑状态
            if (!this.isEditing) {
                //设置当前为编辑状态
                domClass.add(query(".rootSection",this.domNode)[0],"none");
                domClass.add(query(".secondSection",this.domNode)[0],"none");
                this.isEditing = true;
                //window.did可能的三种情况
                //  1.新增一级栏目:'add_add_maxOrder_5'
                //  2.新增二级栏目:'upId_577c5c9f153cd69f1d4a0663_maxOrder_9'
                //  3.编辑栏目:'id_577c5c9f153cd69f1d4a0663_maxOrder'
                var params = window.did.split('_');
                this.maxOrder = params[3] || '';
                if (params[0] !== "add") {
                    var id = params[1];
                    var sectionType = params[0];
                    //若window.did为up_+sectionId
                    if (sectionType === "upId") {
                        this.setData({
                            upSection: id,
                            sectionType: 2
                        });
                        this.refreshData();
                    } else {
                        //加载对应栏目并执行刷新操作
                        section.loadById(id).then(lang.hitch(this, function(data){
                            // 张松   品类查询结果为id值，应该为品类对象，因此当品类id存在时，查询品类并设置到data中     2016/07/06
                            data && data.data && data.data.item && group.loadById(data.data.item.groupId).then(lang.hitch(this, function(dt) {
                                if(dt&&dt.data&&dt.data.item){
                                    data.data.item.groupId = dt&&dt.data&&dt.data.item;
                                }
                                this.setData(data && data.data && data.data.item || {});
                                this.refreshData();
                            }))
                        }));
                    }
                } else {
                    this.setData({
                        sectionType: 1
                    });
                    this.refreshData();
                }
            }
        },
        refreshData:function(){
            if(this.getData().upSection){
                domClass.remove(query(".secondSection",this.domNode)[0],"none");
            }else{
                domClass.remove(query(".rootSection",this.domNode)[0],"none");
            }
            this.onSectionTypeChanged(this.getData().sectionType);
            this.inherited(arguments);
        },
        //数据变更是否合法的检查函数，当不合法时，返回false，可以阻止本次数据变更
        onDataChange: function(field, oldValue, newValue) {
            //若有上级栏目，栏目类型不能选择一级栏目
            if (field === "sectionType") {
                if (newValue == "1" && this.getData().upSection) {
                    alert("本栏目有上级栏目,不能设置为一级栏目");
                    return false;
                }
            }
        },
        //数据变更完成后,根据数据变更显示不同界面
        onDataChanged: function(field, oldValue, newValue) {
            if (field === "sectionType") {
                if (newValue !== oldValue) {
                    this.onSectionTypeChanged(newValue);
                }
            }
        },
        //栏目类型发生变化的事件响应函数
        onSectionTypeChanged: function(sectionType) {
            //获取所有需要控制的ListItem
            var Lists = query(".sectiondtl_item", this.domNode);
            for (var i = 0; i < Lists.length; i++) {
                domClass.add(Lists[i], "none");
            }
            this.sectionType = sectionType;
            if (sectionType == 3) {
                domClass.remove(query(".sectiondtl_item.groupId", this.domNode)[0], "none");
            } else if (sectionType == 4) {
                domClass.remove(query(".sectiondtl_item.targetPath", this.domNode)[0], "none");
            } else if (sectionType == 5) {
                domClass.remove(query(".sectiondtl_item.arId", this.domNode)[0], "none");
            } else if (sectionType == 6) {
                domClass.remove(query(".sectiondtl_item.svcType", this.domNode)[0], "none");
            }
        },
        //保存操作，参考商品的保存操作
        onSaveStore: function() {
            // 徐阿雪  页面处理时候的busy和Free,防止重复提交， 2016/6/24
            if (this.isEditing) {
                window.busy();
                var m = this.getData();
                var msg = this.checkFiled(m);
                if (msg) {
                    window.free();
                    alert(msg);
                    return;
                }
                //栏目的序号,用来做排序调整,修改的时候不做修改
                if (this.maxOrder) {
                    m.sOrder = this.maxOrder;
                }
                section.save(m).then(lang.hitch(this,function(data) {
                    window.free();
                    if (data.data.ok===1) {
                        this.isEditing = false;
                        history.back();
                    }else {
                        alert("保存失败!");
                    }
                }));
            }
        },
        //检查字段合法性
        checkFiled: function(data) {
            var msg = "";
            if (!data.title) {
                msg = "标题不能为空!";
            } else if (!data.sectionType) {
                msg = "栏目类型没有选择!";
            }else if (data.title.length>8) {
                msg = "标题栏目不能超过八个字!";
            }else{
                switch (parseInt(this.sectionType)) {
                case 3:
                    if (!data.groupId) {
                        msg = "商品类型还没有选择!";
                    }
                    break;
                case 4:
                    var webAddress = new RegExp("http");
                    if (!data.targetPath) {
                        msg = "网址不能为空!";
                    } else if (!webAddress.test(data.targetPath)) {
                        msg = "应该输入“http://www.cqthink.com”格式的网址!";
                    }
                    break;
                case 5:
                    if (!data.arId) {
                        msg = "自动回复内容还没有选择!";
                    }
                    break;
                case 6:
                    if (!data.svcType) {
                        msg = "服务类型还没有选择!";
                    }
                    break;
                default:
                }
                //没有上级,则为一级栏目
                if(""===msg&&!data.upSection&&(data.title.length>8)){
                    msg = "一级栏目的标题数量不能超过八个字!";
                }
            }
            return msg;
        },
        addPl:function(){
        }
    });
});
