define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojox/mobile/View",
	"dojo/store/Memory",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/ui/view/_ViewMixin",
	"cq/util/sys/date",
	"dojo/query",
	"dijit/registry",
	"cq/biz/ts/sc/supply_demand",
	"dojox/mobile/IconItem",
	"dijit/focus"
],function(declare,lang,array,View,Memory,EdgeToEdgeStoreList,_ViewMixin,date,query,registry,supplyDemand,IconItem,focusUtil){
	return declare("cq.ui.b.a.SupplyDemandDetail",[View,_ViewMixin],{
		isEditing : false,//是否编辑中(例如:商品详情填写后返回是)
		//初始化相关接口
		//索引界面元素
		indexElement:function(){

		},
		//初始化事件
		initEvent:function(){
		},
		onAfterShow : function() {
				if(!window.did){
					return;
				}else{
					supplyDemand.loadById(window.did).then(lang.hitch(this, function(data) {
						// 显示商品信息
						data.data.item.ioTypeName=data.data.item.ioType==1?"需求":"供应";
						data.data.item.sdDateText=data.data.item.sdDate&&date.formatISODate(data.data.item.sdDate);
                        data.data.item.maxPrice = window.fixedTo(data.data.item.maxPrice,3);
                        data.data.item.minPrice = window.fixedTo(data.data.item.minPrice,3);
                        data.data.item.qty = window.fixedTo(data.data.item.qty,3); 
						this.setData(data.data.item);
						this.refreshData();
					}));
				}
        },
        refreshData : function() {
          this.inherited(arguments);
        },
		onFirstShow:function(){
			//头部
			var option = {left:{iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick:lang.hitch(this,function(){
						history.back();
					})
				},
				title:"供求信息",
				right:{
					iconButton:' ',
					className:"edit-btn",
					onClick:this.onEdit,label:"编辑" }
				};
			this.addHeader(option);
			option = {isEdge:true,lists:[
				{label:'供求类别',noArrow:true,rightText:"{{ioTypeName}}"},
				{label:'供求日期',noArrow:true,rightText:'{{sdDateText}}'},
				{label:'产品',noArrow:true,rightText:'{{product}}'},
				{label:'数量',noArrow:true,rightText:'{{qty}}'},
				{label:'单位',noArrow:true,rightText:'{{unit}}'},
				{label:'价格从',noArrow:true,rightText:'{{minPrice}}'},
				{label:'价格到',noArrow:true,rightText:'{{maxPrice}}'},
				{label:'详情',noArrow:true,rightText:'{{remark}}'}],
				data:this.getData()
				};
			this.addLists(option);
			this.onAfterShow();
		},
		onEdit:function(){
			if(this.getData().fromShopId._id==__shop._id){
				window.moveToView("supplyDemandPost",window.did);
			}
		}
	});
});
