define([	
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"cq/util/sys/date",
	"dojo/query",
	"dijit/registry",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",			
	"dojo/store/JsonRest",
	"cq/biz/ts/sc/supply_demand",
	"cq/biz/user/user",
	"cq/biz/shop/shop",
	"dojo/dom-class"
],function(declare,lang,array,View,_ViewMixin,date,query,registry,EdgeToEdgeStoreList,on,when,JsonRest,supplyDemand,user, shop, domClass){
	return declare("cq.ui.b.a.SupplyDemandList",[View,_ViewMixin],{
		start:0,
        pageSize:20,
		url:"",
        indexElement : function() {
			this.sdListScroll = this.centerPanel;
        },
		onAfterShow:function(){
					if(this.url===supplyDemand.getPlatformDataUrl()){
						this.setQuery(this.getParse(window.did||"0"), {
							start: this.start,
							count: this.pageSize
						});
						
					}else{
						this.url = supplyDemand.getPlatformDataUrl();
						// 创建数据源
						this.store = new JsonRest({target:supplyDemand.getPlatformDataUrl()});	
                        this.params = {isUse:true,ioType:window.did||"0"};
						// 将数据源赋值给storeList	
						var queryResult = this.storeList.setStore(this.store, this.params,{
                            start:this.start,
                            count:this.pageSize
                        });
                        // 将数据源赋值给storeList
                        this.onLoadListData(queryResult,this.start,this.pageSize);
					}
					this.changeOnAll(window.did||"0");
		},
		
		onCreatList: function(){
			this.storeList=new EdgeToEdgeStoreList({
				append: true, 
				constraint: false, 
				query:{
				}, 
				class:"icon-list-item",
				variableHeight:true,
				//获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){
                    var icon = "";
					for(var i=0;i<data.length;i++){
                        // 有图片时 使用用户图片
                        if(data[i].fromShopId&&data[i].fromShopId.logo){
                            icon = data[i].fromShopId.logo;
                        }else {// 没有时使用默认图片
                            icon = "images/logo.png";
                        }
						data[i]._label="<img class='edit-car-matimg' src='"+icon+"' />"+
							"<div style='width: 62%; display:inline-block;margin-left:10px;'>发布单位："+
							(data[i].fromShopId&&data[i].fromShopId.shopName)+
							"<br/>联系人："+
							((data[i].fromShopId&&data[i].fromShopId.contactName) ||"")+"/"+((data[i].fromShopId&&data[i].fromShopId.contactPhone)||"")+
							"<br/>上市时间："+
							(data[i].sdDate?date.formatISODate(data[i].sdDate):"")+
							"<br/>品种："+(data[i].product||"")+
							"<br/>价格："+((window.fixedTo(data[i].minPrice||0,3))||"")+"-"+(window.fixedTo((data[i].maxPrice) || 0, 3)||"")+//"/"+(data[i].unit||"")+
							"</div>";
						data[i].rightText="x  "+(window.fixedTo(data[i].qty||0,3));
					}
					this.storeList.generateList(data);
					this.busy = false;
				}),				
				itemMap:{_label:"label", logo:"icon"}
			});
			
			this.storeList.placeAt(this.sdListScroll.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.sdListScroll,"afterscroll",lang.hitch(this,this.onLoadMore));
		},
        onFirstShow : function() {
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						history.back();
					}
				},
				title:""
			};
			this.addHeader(option);
			option = {
				columns:[{					
					label:'供应',
					className:'footer-tab-col-highlight sale',
					onClick:lang.hitch(this,function(e){
						domClass.remove(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
						domClass.remove(query(".sale",this.domNode)[2], "footer-tab-col-highlight");
						domClass.add(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
						var q = this.storeList.get("query");
						q.ioType="0";
						this.setQuery(q);
					})
				},
				{					
					label:'需求',
					className:'sale',
					onClick:lang.hitch(this,function(e){
						domClass.remove(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
						domClass.remove(query(".sale",this.domNode)[2], "footer-tab-col-highlight");
						domClass.add(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
						var q = this.storeList.get("query");
						q.ioType="1";
						this.setQuery(q);
					})
				},
				{					
					label:'调换',
					className:'sale',
					onClick:lang.hitch(this,function(e){
						domClass.remove(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
						domClass.remove(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
						domClass.add(query(".sale",this.domNode)[2], "footer-tab-col-highlight");
						var q = this.storeList.get("query");
						q.ioType="2";
						this.setQuery(q);
					})
				}],							
				labelClass:'font-size1 tab-selector'
			}
			this.addColumns(option);
			this.onCreatList();
			option = {
				columns:[{
					icon:'images/icon/mat.png',
					iconClass:'width-16',
					className:'footer-tab-col-highlight sales',
					label:'全部',
					onClick:lang.hitch(this,function(){
						var q = this.storeList.get("query");
						delete q.fromShopId;
						this.setQuery(q);
						domClass.add(query(".sales",this.domNode)[0],"footer-tab-col-highlight");
						domClass.remove(query(".sales",this.domNode)[1],"footer-tab-col-highlight");
					})
				},
				{
					icon:'images/icon/mat.png',
					iconClass:'width-16',
					className:'sales',
					label:'我发布的',
					onClick:lang.hitch(this,function(){
						var q = this.storeList.get("query");
						q.fromShopId = supplyDemand.getShopId();
						this.setQuery(q);
						domClass.remove(query(".sales",this.domNode)[0],"footer-tab-col-highlight");
						domClass.add(query(".sales",this.domNode)[1],"footer-tab-col-highlight");
					})
				},
				{
					icon:'images/icon/mat.png',
					iconClass:'width-16',
					label:'发布信息',
					onClick:function(){
						shop.loadCurrentShop().then(lang.hitch(this,function(data){
							if(data&&data.data&&data.data.isVerified){
								window.moveToView("supplyDemandPost");
							} else {
								alert("通过认证后才能发布供求信息！");
							}
						}))
						
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
			this.onAfterShow();
        },		
		getParse: function(type){
			var q = this.storeList.get("query");
			q.ioType = type;
			return q;
		},
		//供求类型改变
		changeOnAll : function(type){
			array.forEach(query(".sales",this.domNode),function(list,index){
				domClass.remove(list, "footer-tab-col-highlight");
			});
			array.forEach(query(".sale",this.domNode),function(list,index){
				domClass.remove(list, "footer-tab-col-highlight");
			});
			domClass.add(query(".sale",this.domNode)[parseInt(type)], "footer-tab-col-highlight");
		},
		onClickList:function(evt){
            if(this.storeList.get("query").fromShopId){
                // 得到点击的ListItem
                var li = registry.getEnclosingWidget(evt.target);
                if(li.declaredClass!="dojox.mobile.ListItem") return;
                var _tsId = li._id;
                window.moveToView("supplyDemandDetail",_tsId);
            }
		},
		setQuery:function(query){			
			this.start = 0;
			this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
		},
		onLoadMore:function(evt){												
			if(!this.busy&&evt.afterBottom){
				this.start = this.pageSize+this.start;
				if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);						
                    }), 1000);
                }
			}
		}
    });
});