define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojox/mobile/View",
	"dojo/store/Memory",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/ui/view/_ViewMixin",
	"dojo/query",
	"dijit/registry",
	"cq/biz/ts/sc/supply_demand",
	"dojox/mobile/IconItem",
	"dijit/focus"
],function(declare,lang,array,View,Memory,EdgeToEdgeStoreList,_ViewMixin,query,registry,supplyDemand,IconItem,focusUtil){
	return declare("cq.ui.b.a.SupplyDemandPost",[View,_ViewMixin],{
		isEditing : false,//是否编辑中(例如:商品详情填写后返回是)
		//初始化相关接口
		//索引界面元素
		onAfterShow : function() {
			if(!this.isEditing){
				this.isEditing = true;
				if(!window.did){
					this.setData({
						isUse:true,
						ioType:"0",
						fromShopId:window.__shop._id
					});
					this.refreshData();
				}else{
					supplyDemand.loadById(window.did).then(lang.hitch(this, function(data) {
						// 显示商品信息
                        data.data.item.maxPrice = window.fixedTo(data.data.item.maxPrice,3)
                        data.data.item.minPrice = window.fixedTo(data.data.item.minPrice,3)
                        data.data.item.qty = window.fixedTo(data.data.item.qty,3)
						this.setData(data.data.item);
						this.refreshData();
					}));
				}
			}
        },
        refreshData : function() {
          this.inherited(arguments);
        },
		onFirstShow:function(){
			//头部
			var option = {left:{iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick:lang.hitch(this,function(){
						this.isEditing = false;
						history.back();
					})
				},
				title:"供求信息",
				right:{
					iconButton:' ',
					onClick:this.onSaveStore,label:"完成" }
				};
			this.addHeader(option);
			option = {
			isEdge:true,
			lists:[
				{label:'供求类别',
				moveTo:"#",
				edit:{type:'options',field:'ioType',options:{0:'供应',1:'需求',2:"调换"},placeHolder : '类别不能为空'}},
				{label:'供求日期',moveTo:"#",edit:{type:'date',field:'sdDate'}},
				{label:'产品',noArrow:true,edit:{type:'text',field:'product'}},
				{label:'数量',noArrow:true,edit:{type:'text',field:'qty'}},
				//{label:'单位',noArrow:true,edit:{type:'text',field:'unit'}},
				{label:'价格从',noArrow:true,edit:{type:'text',field:'minPrice'}},
				{label:'价格到',noArrow:true,edit:{type:'text',field:'maxPrice'}},
				/*{
					//noArrow:true,
					label : '详情',
                    'class' : "content",
					rightText : '详情',
					moveTo : "#",
					__view_id : this.id
				},*/
				{label:'发布',noArrow:true,edit:{
					type:'checkbox',
					field:'isUse',
					value:"on"
				}}
				],
				data:this.getData()
				};
			this.addLists(option);
            this.connectElement();
			this.onAfterShow();
		},
        connectElement:function(){
            //this.connect(query(".content",this.domNode)[0],"onclick",this.remarkClick);
        },
        remarkClick:function(e){
            var dom = e.target;
            if(dom){
                var view = registry.byId(this.id);
                this.isEditing = true;
                view.startEditAsHtml(view.getData().remark).then(lang.hitch(view, view.onDetailChange));
            }
        },
		onDetailChange:function(remark){
			this.__data.remark = remark;
		},
		onSaveStore:function(){
            window.busy();
			var m = this.getData();
			if(!m.shopId){
				m.shopId=supplyDemand.getShopId();
			}
			var checkMsg=this.checkFiled(m);
			if(checkMsg){
                //程序出口--释放
                window.free();
				alert(checkMsg);
				this.isEditing=true;
				return;
			}
			this.isEditing = false;
			supplyDemand.save(m).then(function(data){
                if(data.data.ok==1){
                    alert("发布成功");
                    window.free();
                    window.moveToView("supplyDemandList");
                }else{
                    alert("发布失败");
                    window.free();
                    return;
                }
				//history.back();
			});
		},
		checkFiled:function(data){
            var tt=/^\d+$/g;
			var msg="";
			if(typeof(data.ioType)==="undefined"){
				msg="供求类别不能为空!";
			}else if(!data.sdDate){
				msg="供求日期不能为空!";
			}else if(!data.product){
				msg="产品不能为空!";
			}else if(!data.qty){
				msg="数量不能为空!";
			}else if(!data.minPrice){
				msg="价格从不能为空!";			
            }else if(data.minPrice&&!isNaN(data.minPrice)){
                if(data.minPrice&&data.minPrice<0){
                    msg="价格从只能输入大于0的数字!";
                }
            }else if(data.minPrice&&isNaN(data.minPrice)){
                msg="价格从只能输入数字!";
            }
            if(!msg){
                if(data.maxPrice&&!isNaN(data.maxPrice)){
                    if(data.maxPrice&&data.maxPrice<0){
                        msg="价格到只能输入大于0的数字!";
                    }
                }else if(data.maxPrice&&isNaN(data.maxPrice)){
                    msg="价格到只能输入数字!";
                }
            }
			return msg;
		}
	});
});
