//变更日期：2016-5-17  变更人：周超  变更原因：代码规范

// 变更人:刘轩
// 变更日期:2016-7-13
// 变更原因:资讯详情不显示img节点
// 变更人：杜飞军
// 变更日期：2016/10/19
// 变更原因：增加头部分享功能
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/query",
    "dojox/mobile/View",
    "dojox/mobile/ContentPane",
    "cq/ui/b/a/_share",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/article",
    "cq/biz/user/user"
], function(declare, lang, domStyle, domClass, query, View, ContentPane, _share, _ViewMixin, article, user) {
    return declare("cq.ui.b.a.TrendDetail", [View, _share, _ViewMixin], {
        //初始化相关接口
        //初始化界面元素
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "资讯详情",
                right: {
                    iconButton: '../../common/images/share.png',
                    onClick: lang.hitch(this, function() {
                        this.showShare();
                        var code = query('.shop2dcode', this.shareDiv)[0].parentNode.parentNode;
                        if (!domClass.contains(code, 'none')) {
                            // 隐藏店铺二维码
                            domClass.add(code, 'none');
                        }
                    })
                }
            };
            //添加顶部栏
            this.headerNode = this.addHeader(option);
            this.setHeadRightClass('shareSize-24');
            //赋值数据
            this.onAfterShow();
        },
        // 设置header右边的class
        setHeadRightClass: function(className) {
            var dom = query('.float-right', this.headerNode.domNode)[0];
            if (dom) {
                domClass.add(dom, className);
            }
            // 清除分享的背景颜色
            domStyle.set(dom, 'background-color', 'rgba(255,255,255,0)');
        },
        //赋值/刷新数据
        onAfterShow: function() {
            //调用父类接口
            this.inherited(arguments);
            //设置节点显示隐藏
            article.loadPlatformById(window.did).then(lang.hitch(this, function(data) {
                if (data.data.ok == 1) {
                    if (this.dtlPane) {
                        this.dtlPane.destroy();
                    }
                    data = data.data.item;
                    data.createAt = new Date(data.createAt);
                    var contentHtm = "<div class='title'>" + data.title + "</div>";
                    contentHtm += "<div class='time'>" + data.createAt.toLocaleDateString() + "</div>";
                    //contentHtm += data.logo?"<img class='img' src='"+data.logo+"' />":"";
                    contentHtm += "<div class='content'>" + data.content + "</div>";
                    this.dtlPane = new ContentPane({
                        content: contentHtm,
                        class: "dtlnew_view"
                    });
                    this.dtlPane.placeAt(this.centerPanel.containerNode, "last");
                }
            }));
        },
        // 重写分享点击按钮事件
        //分享按钮点击事件
        onShareClick: function(type) {
            if (type == 0) {
                if (!window.isWechatEnable) {
                    this.hideOverlay();
                    alert("不支持微信分享!");
                } else {
                    window.Wechat.share({
                            message: {
                                title: __shop.shopName, // 分享标题
                                description: __shop.brief || "", // 简介
                                thumb: __shop.logo || "", // 截图
                                //mediaTagName: "TEST-TAG-001",//
                                //messageExt: "这是第三方带的测试字段",//
                                //messageAction: "<action>dotalist</action>",
                                media: {
                                    type: Wechat.Type.WEBPAGE,
                                    webpageUrl: shop.getShopUrl()
                                }
                            },
                            scene: Wechat.Scene.SESSION // share to Timeline
                        },
                        function() {
                            alert("分享成功");
                        },
                        function(reason) {
                            alert("分享失败: " + reason);
                        });
                }
            } else if (type === 1) {
                if (!window.isWechatEnable) {
                    this.hideOverlay();
                    alert("不支持微信分享!");
                } else {
                    this.hideOverlay();
                    window.Wechat.share({
                            message: {
                                title: __shop.shopName, // 分享标题
                                description: __shop.brief || "", // 简介
                                thumb: __shop.logo || "", // 截图
                                //mediaTagName: "TEST-TAG-001",//
                                //messageExt: "这是第三方带的测试字段",//
                                //messageAction: "<action>dotalist</action>",
                                media: {
                                    type: Wechat.Type.WEBPAGE,
                                    webpageUrl: location.href
                                }
                            },
                            scene: Wechat.Scene.TIMELINE // share to Timeline
                        },
                        function() {
                            alert("分享成功");
                        },
                        function(reason) {
                            alert("分享失败: " + reason);
                        });
                }
            } else if (type == 2) {
                this.hideOverlay();
                if (window.sms) {
                    window.sms.send("", __shop.shopName + "地址:" + location.href);
                }
            } else if (type == 3) {
                this.hideOverlay();
                this.copyToClipboard(location.href, function() {
                    alert("复制成功!");
                }, function() {
                    prompt("", location.href);
                });
            } else if (type == 4) {
                this.hideOverlay();
                window.moveToView("shopQrCode");
            }
        }
    });
});
