//变更人:肖芳圆
//变更时间:2016/5/18
//变更原因:抽出微信分享的公共对象,供页面继承使用
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "cq/biz/shop/shop",
    "cq/util/image/qrCode"
],function (declare, lang, domConstruct, shop, qrCode) {
    return declare("cq.ui.b.a._share",null,{
        //显示微信分享的元素到overlay中
        showShare:function(){
            if(this.shareDiv){
                this.showInOverlay(this.shareDiv);
            }else {
                //是否显示微信分享的div
                var isNoneClass = window.isWechatEnable ? "":" none";
                //是否显示短信的div
                var isNoneSmsClass = window.sms ? "" : "none";
                var sharePart1=this.addColumns({
                    columns:[
                        {
                            icon:"images/icon/home_wxfriend.png",
                            iconClass:'width-32 friend',
                            label:'微信好友',
                            onClick:lang.hitch(this,function () {
                                this.onShareClick(0);
                            }),
                            className:isNoneClass
                        },
                        {
                            icon:'images/icon/home_frinedcircle.png',
                            iconClass:'width-32 firendCircle',
                            label:'微信朋友圈',
                            onClick:lang.hitch(this,function () {
                                this.onShareClick(1);
                            }),
                            className:isNoneClass
                        },
                        {
                            icon:'images/icon/home_copylink.png',
                            iconClass:'width-32 copyLink',
                            label:'复制链接',
                            onClick:lang.hitch(this,function () {
                                this.onShareClick(3);
                            })
                        },
                        {
                            icon:'images/icon/home_shop2dcode.png',
                            iconClass:'width-32 shop2dcode',
                            label:'店铺二维码',
                            onClick:lang.hitch(this,function () {
                                this.onShareClick(4);
                            })
                        }
                        //{
                        //    icon:'images/icon/home_sms.png',
                        //    iconClass:'width-32 sms',
                        //    label:'短信',
                        //    onClick:lang.hitch(this,function () {
                        //        this.onShareClick(2);
                        //    }),
                        //    className:isNoneSmsClass
                        //}
                    ],
                    className:"top-bottom-margin16",
                    labelClass:'font-size1',
                    valueClass:''
                });/*
                var sharePart2=this.addColumns({
                    columns:[
                        {
                            icon:'images/icon/home_copylink.png',
                            iconClass:'width-32 copyLink',
                            label:'复制链接',
                            onClick:lang.hitch(this,function () {
                                this.onShareClick(3);
                            })
                        },
                        {
                            icon:'images/icon/home_shop2dcode.png',
                            iconClass:'width-32 shop2dcode',
                            label:'店铺二维码',
                            onClick:lang.hitch(this,function () {
                                this.onShareClick(4);
                            })
                        }
                    ],
                    className:"top-bottom-margin16",
                    labelClass:'font-size1',
                    valueClass:''
                });*/
                var shareCancel=this.addColumns({
                    columns:[
                        {
                            label:'取消',
                            className:'font-size3',
                            onClick:lang.hitch(this,function () {
                                this.hideOverlay();
                            })
                        }
                    ],
                    className:"footer-tab-normal",
                    labelClass:'',
                    valueClass:''
                });
                this.shareDiv=domConstruct.create('div');
                this.shareDiv.className = "shareAll";
                this.shareDiv.appendChild(sharePart1);
                //this.shareDiv.appendChild(sharePart2);
                this.shareDiv.appendChild(shareCancel);
                this.showInOverlay(this.shareDiv);
                this.connectEvent();
            }
        },
        //绑定点击隐藏时间
        connectEvent:function(){
            this.connect(this.shareDiv.parentNode.domNode,"onclick",function(e){
                var dom = e.target;
                if(dom.className==="mblOverlay"){
                    window.moveToView("home");
                }
            });
        },
        //分享按钮点击事件
        onShareClick:function (type) {
            if(type==0){
                if(!window.isWechatEnable){
                    this.hideOverlay();
                    alert("不支持微信分享!");
                }else {
                    window.Wechat.share({
                        message: {
                            title: __shop.shopName,// 分享标题
                            description: __shop.brief||"",// 简介
                            thumb: __shop.logo||"",// 截图
                            //mediaTagName: "TEST-TAG-001",//
                            //messageExt: "这是第三方带的测试字段",//
                            //messageAction: "<action>dotalist</action>",
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: shop.getShopUrl()
                            }
                        },
                        scene: Wechat.Scene.SESSION   // share to Timeline
                    },
                    function () {
                        alert("分享成功");
                    }, function (reason) {
                        alert("分享失败: " + reason);
                    });
                }
            }else if(type===1){
                if(!window.isWechatEnable){
                    this.hideOverlay();
                    alert("不支持微信分享!");
                }else {
                    this.hideOverlay();
                    window.Wechat.share({
                        message: {
                            title: __shop.shopName,// 分享标题
                            description: __shop.brief||"",// 简介
                            thumb: __shop.logo||"",// 截图
                            //mediaTagName: "TEST-TAG-001",//
                            //messageExt: "这是第三方带的测试字段",//
                            //messageAction: "<action>dotalist</action>",
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: shop.getShopUrl()
                            }
                        },
                        scene: Wechat.Scene.TIMELINE   // share to Timeline
                    },
                    function () {
                        alert("分享成功");
                    }, function (reason) {
                        alert("分享失败: " + reason);
                    });
                }
            } else if(type==2) {
                this.hideOverlay();
                if(window.sms){
                    window.sms.send("",__shop.shopName+"地址:"+shop.getShopUrl());
                }
            }else if (type==3) {
                this.hideOverlay();
                this.copyToClipboard(shop.getShopUrl(),function(){
                    alert("复制成功!");
                },function () {
                    prompt("",shop.getShopUrl());
                });
            }else if (type==4) {
                this.hideOverlay();
                window.moveToView("shopQrCode");
            }
        }
    })
})