define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/touch",
    "dojo/query",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/im/channelMsg",
    "cq/biz/blob/blob",
    "cq/widgets/item/LiveListItem"
],function( declare, lang, JsonRest, domClass, touch, query, View, EdgeToEdgeStoreList, _ViewMixin, channelMsg, blob, LiveListItem){
    return declare("",[View,_ViewMixin],{
        liveStart: 0,
        liveEnd: -1,
        discussStart: 0,
        discussEnd: -1,
        pageSize: 10,
        onFirstShow : function(){
        //ҳԪأʼԪ
            //ͷ
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: 'left',
                    label: '',
                    onClick: function(){
                        history.back();
                    }
                },
                title:'ֱ'
            };
            this.addHeader(option);
            option = {
                isHeader: true,
                columns:[{
                    label:"ֱ",
                    onClick:function(e){
                        this.setChannelSelected(e.target);
                        this.refreshLiveView();
                    }
                },{
                    label:"",
                    onClick:function(e){
                        this.setChannelSelected(e.target);
                        this.refreshDiscussView();
                    }
                }
                ],
                labelClass:'font-size1 tab-selector'
            };
            this.tabSelector= this.addColumns(option);
            this.setChannelSelected(query('.tab-selector',this.tabSelector)[0]);
            //ͷѡ򣬲¼ʾӦĽ
            //ʼֱͼ
            this.liveView = new View();
            //ָݵλ
            this.liveView.placeAt(this.centerPanel.containerNode, "last");
            //ʼͼ
            this.discussView = new View();
            //ָݵλ
            this.discussView.placeAt(this.centerPanel.containerNode, "last");
            //ֱбʾ
            this.liveMessageList= new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                itemRenderer:LiveListItem,
                queryOptions: {
                    count: this.pageSize,
                    start: this.liveStart
                },
                itemMap: { _label: "label", moveTo: "moveTo" }
            });
            this.liveMessageList.placeAt(this.liveView, "last");
            //бʾ
            this.discussList= new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                itemRenderer:LiveListItem,
                queryOptions: {
                    count: this.pageSize,
                    start: this.liveStart
                },
                itemMap: { _label: "label", moveTo: "moveTo" }
            });
            this.discussList.placeAt(this.liveView, "last");
            //Ϊмͼ󶨹¼͵¼
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.centerPanel.on("click", lang.hitch(this, this.onListClick));
            //ӵײʹͼƬĿ
            option = {
                placeHolder: "ظ",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, this.onMessageEnter)
            };
            this.textBox = this.addTextBox(option);
            this.footerColumn = this.addColumns({
                forceWidth: false,
                isFooter: true,
                columns: [{
                    className: "flex1",
                    label: ""
                }, {
                    className: "miniIcon imageSelector",
                    label: ""
                }]
            });
            this.textBox.placeAt(query(".flex1", this.footerColumn)[0], "only");
            this._topSplitter.resize();
            this.own(touch.release(query(".miniIcon", this.footerColumn)[0], lang.hitch(this, function() {
                blob.selectAndUpload().then(lang.hitch(this, this.onUploadImage));
            })));
            // Դ
            this.params = {};
            this.onAfterShow();
        },
        //onafterShowˢҳ߸ʾ
        onAfterShow : function(){
            //  ȡǰûϢ
            //лǰƵ
            //лֱҽ
        },
        setChannelSelected: function(evt){
            //нڵѡʽ
            var items = query('.tab-selector',this.domNode);
            for(var i = 0,i<items.length,i++){
                domClass.remove(items[i],"selected")
            }
            domClass.add(evt,"selected");
        },
        refreshLiveView: function(query){
            this.liveView.show();
            this.liveStart = 0;
            this.liveEnd = -1;
            var def = null;
            // ÷ķ
            if (this.liveMessageList.store) {
                var queryInfo = this.liveMessageList.get("query");
                queryInfo.channelId = window.did;
                def = this.liveMessageList.setQuery(queryInfo, {
                    start: this.liveStart,
                    count: this.pageSize
                });
                this.onLoadListData(def, this.liveStart, this.pageSize, "live");
            } else {
                def = this.liveMessageList.setStore(new JsonRest({
                    target: channelMsg.getLoadUrl()
                }), {
                    isHost: true,
                    channelId: window.did
                }, {
                    start: this.liveStart,
                    count: this.pageSize
                });
                this.onLoadListData(def, this.liveStart, this.pageSize, "live");
            }
            domClass.remove(this.footerColumn, "none");
            def.then(lang.hitch(this, this.resize));
        },
        refreshDiscussViewView: function(){
            this.discussView.show();
            this.discussStart = 0;
            this.discussEnd = -1;
            this.discussList.destroyDescendants();
            var def = null;
            // ÷ķ
            if (this.discussList.store) {
                var queryInfo = this.discussList.get("query");
                queryInfo.channelId = window.did;
                def = this.discussList.setQuery(queryInfo, {
                    start: this.discussStart,
                    count: this.pageSize
                });
                // ql Ϊ
                this.onLoadListData(def, this.discussStart, this.pageSize, "ql");
            } else {
                def = this.discussList.setStore(new JsonRest({
                    target: channelMsg.getLoadUrl()
                }), {
                    channelId: window.did
                }, {
                    start: this.discussStart,
                    count: this.pageSize
                });
                // ql Ϊ
                this.onLoadListData(def, this.discussStart, this.pageSize, "ql");
            }
            domClass.add(this.footerColumn, "none");
            def.then(lang.hitch(this, this.resize));
        },
        onLoadMore: function(){
            
        },
        onUploadImage: function(imageInfo){
            if (imageInfo && imageInfo.items && imageInfo.items[0]) {
                channelMsg.save({
                    senderId: this.currentUserInfo._id,
                    channelId: window.did,
                    sendNick: this.currentUserInfo.pName || this.currentUserInfo.nickName || this.currentUserInfo.wxNick || "",
                    sendLogo: this.currentUserInfo.logo || null,
                    sendTime: new Date(),
                    msgType: 1,
                    msgImage: imageInfo.items[0].uri,
                    isHost: true
                }).then(lang.hitch(this, function() {
                    this.showLiveList();
                }));
            }
        },
        onListClick : function(evt){
            if(evt.target.localName == "img"){
                if(domClass.contains(evt.target.parentNode, "richText")){
                    var imgSrcUri = evt.target.src;
                    this.showImg(imgSrcUri); 
                } 
            }
        },
        onMessageEnter: function(evt) {
            if (evt.keyCode == 13) {
                this.search = evt.target.value;
                if (!this.search) {
                    return;
                }
                channelMsg.save({
                    senderId: this.currentUserInfo._id,
                    channelId: window.did,
                    sendNick: this.currentUserInfo.pName || this.currentUserInfo.nickName || this.currentUserInfo.wxNick || "",
                    sendLogo: this.currentUserInfo.logo || null,
                    sendTime: new Date(),
                    msgType: 0,
                    msgText: this.search,
                    isHost: true
                }).then(lang.hitch(this, function() {
                    this.refreshLiveView();
                    evt.target.value = "";
                }));
            }
        },
        
    });
});