// 变更人：宋宇
// 变更时间：2016-06-13
// 变更事项：初稿
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/im/channel"
],function(declare,lang,View,_ViewMixin,channel){
    // module:
    //        whz/view/Channel
    return declare("whz.view.Channel",[View,_ViewMixin],{
        // 页面是否处在编辑中，默认值为false
        isEditing : false,
        // 加载数据
        onAfterShow : function() {
            if(!this.isEditing){
                this.isEditing = true;
                if(!window.did){
                    this.setData({
                        isUse:true
                    });
                    this.refreshData();
                }else{
                    channel.loadById(window.did).then(lang.hitch(this, function(data) {
                        if(data.data&&data.data.ok){
                            this.setData(data.data.item);
                            this.refreshData();
                        }
                    }));
                }
            }
        },
    
    // 第一次进入页面，初始化页面组件
        onFirstShow:function(){
            // 加载页面头部
            var option = {
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:lang.hitch(this,function(){
                        this.isEditing = false;
                        history.back(); //返回浏览记录的上一个页面
                    })
                },
                title:"直播频道",
                right:{
                    iconButton:' ',
                    onClick:this.onSaveStore,label:"完成" 
                }
            };
            this.addHeader(option);
            option = {
                isEdge:true,
                lists:[
                {
                    label : "主题图片",
                    noArrow : false,
                    imgSize:{width:640,height:298},
                    edit :{
                        type:"image",
                        field:"logo"
                    },
                    class : "li-icon",
                    moveTo : "#"
                },
                {
                    label:'标题',
                    noArrow:true,
                    edit:{
                        type:'text',
                        field:'title',
                        placeHolder:"必填"
                    }
                },
                {
                    label:'使用',
                    noArrow:true,
                    edit:{
                        type:'checkbox',
                        field:'isUse',
                        value:"on"
                    }
                }],
                data:this.getData()
            };
            this.addLists(option);
            this.onAfterShow();
        },
    
        // 将用户修改、新增的数据保存到数据库
        onSaveStore:function(){
            window.busy();
            if(this.isEditing){
                this.isEditing = false;
                var m = this.getData();
                var checkMsg=this.validChannel(m);
                if(checkMsg){
                    alert(checkMsg);
                    this.isEditing = true;
                    return;
                }
                channel.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    // 保存成功则跳转到资讯列表页面
                    if(data.data.ok === 1){
                        history.back();
                    }else{
                        alert("保存失败");
                        this.isEditing = true;
                    }    
                }));
            }
        },
        
        validChannel:function(data){
            if(!data.title){
                return "请填写标题";
            }
        }
    });
});
