// 变更人：宋宇
// 变更时间：2016-06-13
// 变更事项：初稿
// 变更人:冉伟
// 变更时间:2016/6/22
// 变更原因:设置客户端底部图标的高度使其与农企宝底部高度保持一致
// 变更人: 杜飞军
// 变更时间: 2016-06-23
// 变更内容
//          搜索框锁定到头部  tab标签锁定到头部 加载中的提示 重复加载问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/JsonRest",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ListItem",
    "cq/ui/view/_ViewMixin",
    "cq/biz/im/channel"
], function(declare, lang, JsonRest, domConstruct, domClass, query, registry, View, EdgeToEdgeStoreList, ListItem, _ViewMixin, channel) {
    // module:
    //      whz/view/ChannelList
    return declare("whz.view.ChannelList", [View, _ViewMixin], {
        // 取数据时的开始下标，默认为0
        start: 0,
        // 每次加载的数据条数，默认为10
        pageSize: 10,

        // 每次进入页面，重新加载数据
        onAfterShow: function() {
            if (this.storeList.store) {
                this.setQuery(this.storeList.get("query"), {
                    start: this.start,
                    count: this.pageSize
                });
            } else {
                this.onLoadListData(this.storeList.setStore(this.store, {}, {
                    start: this.start,
                    count: this.pageSize
                }), this.start, this.pageSize);
            }
        },
        
        // 第一次进入页面，加载页面显示的组件
        onFirstShow: function() {
            // 页面的头部
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back(); //返回浏览记录的上一个页面
                    }
                },
                title: "直播频道"
            };
            this.addHeader(option);

            // 搜索框
            option = {
                placeHolder: "请输入要查询条件，按回车查询",
                type: "search",
                class: "cqSearchBox",
                // 搜索框固定到顶部
                isHeader: true,
                onInput: lang.hitch(this, function(evt) {
                    if (evt.keyCode == 13) {
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.title = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);

            // 页面的尾部添加按钮
            option = {
                columns: [{
                    label: '添加频道',
                    icon: 'images/icon/addnews.png',
                    /*iconClass:'width-16',*/
                    iconClass: 'footer-tab-img',
                    onClick: function() {
                        window.moveToView("channelB"); //跳到添加频道的页面
                    }
                }],
                valueClass: 'font-size3',
                labelClass: 'font-size1',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);

            // 频道的显示列表
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight: true,
                onComplete: lang.hitch(this, function(data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "" + "<div class='mat-list-mname mat-list-margin'>" + data[i].title + "</div>" + "<div class='margin-top24 forth-btn'>" + "<span class='intoChannel " + "'>进入直播</span>" + "<span class='modify'>修改</span></div>";
                        data[i].moveTo = "#";
                        data[i]._logo = data[i].logo ? data[i].logo : 'images/nomat.png';
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap: {
                    _label: "label",
                    _logo: "icon",
                    moveTo: "moveTo"
                }
            });
            // 创建数据源
            this.params = {};
            this.store = new JsonRest({
                target: channel.getLoadUrl()
            }); // 告诉在哪里获取数据源
            this.storeList.placeAt(this.centerPanel.containerNode, "last"); // 将列表放到哪里去
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },

        // 列表项的点击响应事件
        onClickList: function(evt) {
            // 得到点击的ListItem
            var dom = evt.target;
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")
                return;
            var _id = li.params._id;
            if (dom && domClass.contains(dom, "intoChannel")) {
                window.moveToView("channelDetailB", _id);
            } else if (dom && domClass.contains(dom, "modify")) {
                window.moveToView("channelB", _id);
            }
        },

        // 重新赋值列表并刷新显示
        setQuery: function(query) {
            this.start = 0;
            this.end = -1;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult, this.start, this.pageSize);
            this.centerPanel.resize();
        },

        // 拖动加载更多
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    console.log("加载更多频道");
                    setTimeout(lang.hitch(this, function() {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        }), this.start, this.pageSize);
                    }), 1000);
                }
            }
        },

        // 基类中已经提供 
        // onLoadListData: function(queryResult) {
        //     queryResult.then(lang.hitch(this, function() {
        //         this.centerPanel.resize();
        //     }));
        //     queryResult.total.then(lang.hitch(this, function(total) {
        //         this.totalCount = total;
        //         if (this.start + this.pageSize + 1 < total) {
        //             domClass.add(this.centerPanel.domNode, "bg-loading-img");
        //         } else {
        //             domClass.remove(this.centerPanel.domNode, "bg-loading-img");
        //         }
        //         if (total === 0) {
        //             domClass.add(this.centerPanel.domNode, "bg-nothing");
        //         }
        //     }));
        // }
    });
});
