define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "dijit/focus",
    "cq/biz/im/questionMsg"
],function(declare,lang,View,_ViewMixin,date,focusUtil,questionMsg){
    // module:
    //      cq/ui/b/u/User
    return declare("cq.ui.b.im.QuestionMsgDetail", [View, _ViewMixin], {
        // 检测是否编辑状态
        isEditing: false,
        // 初始化相关接口
        onAfterShow: function () {
            if (!this.isEditing) {
                this.isEditing = true;
                if (window.did) {
                    questionMsg.loadById(window.did).then(lang.hitch(this, function (data) {						
                        this.setData(data && data.data && data.data.item || {});
                        this.refreshData();
                    }));
                } else {
					this.setData({});
                    this.refreshData();
				}
            }
        },
        addOptionList:function(){
            return oldArray=[{
                label: '提出日期',
                moveTo: "#",
                edit: {
                    type: 'date',
                    field: 'pDate'
                }
            },{
                label: '姓名',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'name',
                    placeHolder: "必填"
                }
            },{
                label: '电话',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'phone',
                    placeHolder: "请输入电话"
                }
            },{
                label: '问题',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'title',
                    placeHolder: "请输入询问的问题"
                }
            },{
                label:"回复内容",
                moveTo:'#',
                edit:{
                    type:'textarea',
                    field:'content'
                }
            },{
                label: '回复人',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'replyPeople'
                }
            }];
        },
        onFirstShow: function () {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function () {                        
                        history.back();
                        this.isEditing = false;
                    }
                },
                title: "问题咨询",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: this.addOptionList()
            };
            this.addLists(option);
            this.onAfterShow();
        },
        // 保存数据
        onSaveStore: function () {
            //设置界面busy
            window.busy();
            // 当前节点失去焦点
            focusUtil.curNode && focusUtil.curNode.blur();
            var m = this.getData();
            var msg = this.checkData(m);
            if (msg) {
                //设置界面free
                window.free();
                alert(msg);
                return;
            }            
            questionMsg.save(m).then(lang.hitch(this, function (data) {
                //设置界面free
                window.free();
                if(data.data.ok == 1){
                    this.isEditing = false;                    
                    history.back();
                }else{
                    alert("保存失败");
                }
            }));
        },
        // 验证文本框内容
        checkData: function (data) {
            var msg = "";
            if(!data.name){
                return "姓名不能为空";
            }
            if(!data.title){
                return "问题不能为空";
            }            
        }
    });
})