// 变更人:肖芳圆
// 变更时间:2016-06-03
// 变更原因:增加畜牧商品辅助资料显示的接口,提供给XmMatDetail.js使用
// 变更人: 杜飞军
// 变更时间: 2016-06-07
// 变更原因: 没有预留按钮对象
// 变更人: 周超
// 变更时间: 2016-06-17
// 变更原因: 评价栏显示更改，显示规格
// 变更人: 母浚驰
// 变更时间: 2016-06-22
// 变更原因: 图片显示顺序
// 变更人: 张松
// 变更时间: 2016-07-21
// 变更原因: 添加商品参数标签及列表
// 变更人: 徐阿雪
// 变更时间: 2016/8/10
// 变更原因: 添加运费
// 变更人: 徐阿雪
// 变更时间: 2016/8/15
// 变更原因: 修复不能下架和商家
// 变更人: 杜飞军
// 变更时间: 2016-10-08
// 变更原因: 增加底部提交审核按钮 默认不显示
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/query",
    "dojo/dom-style",
    "dojo/dom-class",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/Rating",
    "cq/biz/mat/mat",
    "cq/biz/shop/shop",
    "cq/ui/view/_ViewMixin"
], function(declare, lang, array, Deferred, query, domStyle, domClass, registry, View, Rating, mat, shop, _ViewMixin) {
    return declare("cq.ui.b.m.view.MatDetail", [View, _ViewMixin], {
        hideBottom: false,
        isUseOnclick: true,
        onAfterShow: function() {
            var def = new Deferred();
            this.loadMatData().then(lang.hitch(this, function(data) {
                data.data.item.retailPrice = window.fixedTo(data.data.item.retailPrice, 3);
                if (!data.data.item.marketPrice) {
                    data.data.item.marketPrice = "0.00";
                } else {
                    data.data.item.marketPrice = window.fixedTo(data.data.item.marketPrice, 3);
                }
                data.data.item.totalSale = window.fixedTo(data.data.item.totalSale, 1);
                data.data.item.qty = window.fixedTo(data.data.item.qty, 1);
                //运费 重盐需要的字段
                data.data.item.freight = window.fixedTo(data.data.item.freight, 3) || 0.00;
                var target_1 = query(".getGoodsOn", this.domNode)[0];
                var target_2 = query(".getGoodsDown", this.domNode)[0];
                if (data.data.item.isUse == true) {
                    domClass.add(target_1, 'none');
                    domClass.remove(target_2, 'none');
                } else if (data.data.item.isUse == false) {
                    domClass.remove(target_1, 'none');
                    domClass.add(target_2, 'none');
                }
                this.putDataInHtml(data.data.item);
                var isMatPropsDivHidden;
                if (this.matPropsDiv) {
                    isMatPropsDivHidden = domClass.contains(this.matPropsDiv.containerNode, "none");
                    this.matPropsDiv.destroy();
                } else {
                    isMatPropsDivHidden = true;
                }
                // 添加商品参数列表
                var option = {
                    isEdge: true,
                    lists: []
                };
                array.forEach(data.data.item.props, function(prop) {
                    option.lists.push({ label: prop.name, rightText: prop.value });
                });
                this.matPropsDiv = this.addLists(option);
                if (isMatPropsDivHidden) {
                    domClass.add(this.matPropsDiv.containerNode, "none");
                }
                var targ = query(".editMatD", this.domNode)[0];
                /*if (shop.getShopId() !== data.data.item.fromShopId) {
                    domClass.add(targ, "none");
                } else {
                    domClass.remove(targ, "none");
                }*/
                def.resolve(data);
            }));
            return def;
        },
        onSaveStore: function(target) {
            var data = this.getData();
            if (data.qty == 0 || !data.qty) {
                alert("没有库存不能上架");
                return;
            }
            //修改不能商家下架问题  data.data.item
            if (target == true) {
                data.isUse = false;
            } else if (target == false) {
                data.isUse = true;
            }
            data_change = data;
            window.busy();
            mat.save(data_change).then(lang.hitch(this, function(data) {
                if (data && data.data && data.data.ok === 1) {
                    window.free();
                    this.changeGoods(target);
                } else {
                    window.free();
                    alert(data.message);
                }
            }));
        },
        //changeGoods:
        //      切换上下架图标
        //      参数cn：boolean
        //      返回值：无
        changeGoods: function(cn) {
            var target_1 = query(".getGoodsOn", this.domNode)[0];
            var target_2 = query(".getGoodsDown", this.domNode)[0];
            if (cn == false) {
                //设置显示/隐藏
                domClass.add(target_1, 'none');
                domClass.remove(target_2, 'none');
            } else {
                domClass.remove(target_1, 'none');
                domClass.add(target_2, 'none');
            }
        },
        //可重载的取数据方法
        loadMatData: function() {
            var def = new Deferred();
            mat.loadById(window.did).then(lang.hitch(this, function(data) {
                def.resolve(data);
            }));
            return def;
        },
        putDataInHtml: function(item) {
            if (item.scoreAvg) {
                item.scoreAvg = (item.scoreAvg).toFixed(1);
            }
            this.setData(item);
            var images = [];
            if (item.logo) {
                images.push({
                    icon: item.logo
                });
            }
            // 图片显示顺序
            for (var i = 0; i < item.images.length; i++) {
                images.push({
                    icon: item.images[i]
                });
            }
            this.slideShow.items = images;
            this.slideShow.refresh();
            if (item.isRecommend) {
                domStyle.set(query(".cancelrecommend", this.footerButton)[0], "display", "");
                domStyle.set(query(".recommend", this.footerButton)[0], "display", "none");
            } else {
                domStyle.set(query(".recommend", this.footerButton)[0], "display", "");
                domStyle.set(query(".cancelrecommend", this.footerButton)[0], "display", "none");
            }
            this.refreshData();
            if (!this.scoreWidget) {
                // 添加星级评论
                this.createRating();
            }
            this.addRatingNode();
            if (item.scoreAvg) {
                this.scoreWidget.set("value", Math.round(item.scoreAvg));
            } else {
                this.scoreWidget.set("value", 0);
            }
        },
        // 新增隐藏底部按钮接口
        hideFooterButton: function() {
            domStyle.set(this.footerButton, "display", "none");
        },
        //添加辅助资料部分
        addXmAssistList: function() {
            var option = {
                columns: [{
                    label: '商品详情',
                    onClick: lang.hitch(this.changeMatDetail)
                }, {
                    label: '商品参数',
                    onClick: lang.hitch(this.changeMatProps)
                }],
                labelClass: 'font-size1 tab-selector'
            };
            this.addColumns(option);
            this.tabSelected();
        },
        changeMatDetail: function(e) {
            this.tabSelected(e.target);
            domClass.remove(this.matDetailDiv.containerNode, "none");
            domClass.add(this.matPropsDiv.containerNode, "none");
        },
        changeMatProps: function(e) {
            this.tabSelected(e.target);
            domClass.remove(this.matPropsDiv.containerNode, "none");
            domClass.add(this.matDetailDiv.containerNode, "none");
        },
        tabSelected: function(dom) {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            if (dom) {
                domClass.add(dom, "selected");
            } else {
                domClass.add(items[0], "selected");
            }
        },
        onFirstShow: function() {
            this.setData({});
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "商品管理"
            };
            this.addHeader(option);
            var data = {
                boxes: [],
                options: {
                    width: domStyle.get(this.domNode, "width"),
                    height: Math.min(domStyle.get(this.domNode, "width"), 360)
                }
            };
            this.slideShow = this.addSlideShow(data);
            //基本信息
            option = {
                isEdge: true,
                lists: this.detailLists()
            };
            this.addLists(option);
            // 添加商品的评论模块
            option = {
                isEdge: true,
                class: "top-bottom-margin16",
                lists: [{
                    label: "<div style='display:flex;'>" +
                        "<div style='flex:1;'>宝贝评价({{commentNum}})</div>" +
                        "<div style='display:flex;'>" +
                        "<div style='flex:1;'>平均得分:{{scoreAvg}}</div>" +
                        "<div style='margin-left:5px;' class='ratingDiv'></div>" +
                        "</div>" +
                        "</div>",
                    variableHeight: true
                }]
            };
            this.matEvalList = this.addLists(option);

            //辅助资料接口
            this.addXmAssistList();
            //商品详情
            this.matDetailDiv = this.addLists({
                isEdge: true,
                lists: [{
                    label: "<div class='richText'>{{content}}</div>",
                    variableHeight: true
                }]
            });

            //底部按钮
            option = {
                columns: [{
                    label: '编辑商品',
                    className: 'flex2 footer-tab-dark editMatD',
                    onClick: function() {
                        window.moveToView("mat", window.did);
                    }
                }, {
                    label: '取消推荐',
                    className: 'flex2 footer-tab-highlight cancelrecommend',
                    onClick: function() {
                        mat.setRecommend({
                            isRecommend: false,
                            _id: window.did
                        }).then(lang.hitch(this, function() {
                            this.onAfterShow();
                        }));
                    }
                }, {
                    label: '推荐商品',
                    className: 'flex2 footer-tab-highlight recommend',
                    onClick: lang.hitch(this, function() {
                        mat.setRecommend({
                            isRecommend: true,
                            _id: window.did
                        }).then(lang.hitch(this, function() {
                            this.onAfterShow();
                        }));
                    })
                }, {
                    label: '商品上架',
                    className: 'flex2 footer-tab-dark getGoodsOn',
                    onClick: function() {
                        var target = false;
                        this.onSaveStore(target);
                    }
                }, {
                    label: '商品下架',
                    className: 'flex2 footer-tab-dark getGoodsDown',
                    onClick: function() {
                        var target = true;
                        //this.changeGoods(target);
                        this.onSaveStore(target);
                    }
                }, {
                    label: '提交审核',
                    className: 'flex2 footer-tab-dark none sendVerify',
                    onClick: function() {
                        this.sendVerify(window.did);
                    }
                }],
                forceWidth: false,
                isFooter: true
            };
            this.footerButton = this.addColumns(option);
            this.matEvalList.on("click", lang.hitch(this, this.onEvalList));
            // 提供隐藏底部按钮
            if (this.hideBottom) {
                this.hideFooterButton();
            }
            this.onAfterShow();
        },
        onEvalList: function(evt) {
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = window.did;
            window.moveToView("matEvalList", _id);
        },
        // 创建星级评论对象
        createRating: function() {
            this.scoreWidget = new Rating({
                image: "/static/common/images/star-orange.png",
                numStars: 5,
                value: 5
            });
        },
        // 添加星级评论对象
        addRatingNode: function() {
            var li = query("li", this.matEvalList.domNode)[0];
            var rightDiv = query(".mblListItemLabel", li)[0];
            var ratingDiv = query(".ratingDiv", rightDiv)[0];
            ratingDiv.appendChild(this.scoreWidget.domNode);
        },
        //基本信息需要在重盐重写
        //20160922 运费统一调整到基类，肖爱玲
        detailLists: function() {
            return [{
                label: "{{mName}}",
                variableHeight: true
            }, {
                label: "会员价:￥{{retailPrice}}",
                rightText: "市场价:￥{{marketPrice}}"
            }, {
                label: "规格:{{sizeType}}",
                rightText: "库存:{{qty}}"
            }, {
                label: "运费:￥{{freight}}"
            }, {
                label: "累计销售:{{totalSale}}"
            }];
        },
        // 提交审核的方法 提供重写
        sendVerify: function(id) {

        }
    });
});
