/*修改人员：胡飞
修改日期：20160621
修改内容：取消 品类图标和编码之间的ul间隔
 */
/*修改人员：冉伟
修改日期：20160624
修改内容：处理保存时的busy和free，防止重复提交
 */
define([
		"dojo/_base/declare",
		"dojo/_base/lang",
		"dojox/mobile/View",
		"dojo/store/Memory",
		"dojox/mobile/EdgeToEdgeStoreList",
		"cq/util/sys/date",
		"cq/ui/view/_ViewMixin",
		"dojo/request/xhr",
		"dojo/query",
		"dojo/on",
		"dijit/registry",
		"cq/biz/mat/group",
		"dijit/focus"
	], function (declare, lang, View, Memory, EdgeToEdgeStoreList, date, _ViewMixin, xhr, query, on, registry, matGroup, focusUtil) {
	return declare("cq.ui.b.m.MatGroup", [View, _ViewMixin], {
		isEditing : false,
		onAfterShow : function () {
			if (!this.isEditing) {
				this.isEditing = true;
				// 如果是修改，加载信息
				if (window.did) {
					matGroup.loadById(window.did).then(lang.hitch(this, function (data) {
							// 显示信息
							this.setData(data.data.item);
							this.refreshData();
						}));
				} else {
					this.setData({
						isUse : 1
					});
					this.refreshData();
				}
			}
		},
		onFirstShow : function () {
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function () {
						this.isEditing = false;
						//window.moveToView("matGroupList");
						history.back();
					}
				},
				title : "新增品类",
				right : {
					iconButton : ' ',
					onClick : this.onSaveStore,
					label : "完成"
				}
			};
			this.addHeader(option);
			//logo
			option = {
				isEdge : true,
				lists : [{
						label : "品类图标",
						noArrow : false,
						rightIcon2 : "{{logo}}",
						edit : {
							type : "image",
							field : "logo"
						},
						class : "li-icon",
						moveTo : "#"
					}, {
						label : '编码',
						noArrow : true,
						edit : {
							type : 'text',
							field : 'code',
							placeHolder : "必填"
						}
					}, {
						label : '品类名称',
						edit : {
							type : 'text',
							field : 'gName',
							placeHolder : "必填"
						}
					}, {
						label : '使用',
						noArrow : true,
						edit : {
							type : 'checkbox',
							field : 'isUse'
						}
					}
				]
			};
			this.addLists(option);
			this.onAfterShow();
		},
		onSaveStore : function () {
			//点击完成触发onSaveStore函数执行busy操作
			window.busy();
			var m = this.getData();
			var msg = this.checkFiled(m);
			if (msg) {
				//判断有异常，执行free操作
				window.free();
				alert(msg);
				return;
			}
			matGroup.save(m).then(lang.hitch(this, function () {
					//保存后执行free操作
					window.free();
					this.isEditing = false;
					//window.moveToView("matGroupList");
					history.back();
				}));
		},
		checkFiled : function (data) {
			var msg = "";
			if (!data.gName) {
				msg = "品类名称还没有填写";
				return msg;
			} else if (!data.code) {
				msg = "品类编码还没有填写";
				return msg;
			}
		}
	});
});
