//变更人:肖爱玲，变更时间:2016/5/21，变更原因:添加品类默认图片
//变更人：冉伟
//变更时间：2016/6/24
//变更内容：更改底部图标样式
//变更人:胡飞
//变更时间：2016/6/27
//变更内容：添加 加载中提示，加载更多的条件

// 变更人:刘轩
// 变更时间:2016-7-13
// 变更原因:未上传分类的默认LOGO的显示错误
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "dojo/_base/xhr",
    "dojo/query",
    "dijit/registry",
    "cq/biz/mat/group",
    "dojo/on",
    "dojo/when",
    "dojo/store/Memory",
    "dojo/store/JsonRest",
    "dojo/store/Observable"
], function (declare, lang, View, EdgeToEdgeStoreList, _ViewMixin, xhr, query, registry, matGroup, on, when, Memory, JsonRest, Observable) {
    return declare("cq.ui.b.m.MatGroupList", [View, _ViewMixin], {
        start : 0,
        pageSize:10,
        //初始化相关接口
        //索引界面元素
        indexElement : function () {
            this.newsListScroll = this.centerPanel;
        },
        onAfterShow : function () {
            this.setQuery(this.storeList.get("query"), {
                start : 0,
                count : this.pageSize
            });
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        //window.moveToView("matList");
                        history.back();
                    }
                },
                title : "品类管理"
            };
            this.addHeader(option);
            option = {
                isHeader:true,
                placeHolder : "请输入品类名称，按回车查询",
                type : "search",
                class : "cqSearchBox",
                onInput : lang.hitch(this, function (evt) {
                    if (evt.keyCode == 13) {
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.gName = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                columns : [{
                        label : '添加品类',
                        className: 'flex2 footer-tab-highlight',
                        onClick : function () {
                            window.moveToView("matGroup");
                        }
                    }
                ],
                valueClass : 'font-size3',
                labelClass : 'font-size1',
                className : 'fix-footer',
                isFooter : true
            };
            this.addColumns(option);
            this.storeList = new EdgeToEdgeStoreList({
                    append : true,
                    constraint : false,
                    query : {},
                    class : "icon-list-item",
                    variableHeight : true,
                    onComplete : lang.hitch(this, function (data) {
                        for (var i = 0; i < data.length; i++) {
                            data[i]._label = "<div class='mat-list-mname mat-list-margin'>" + data[i].gName + "</div>";
                            data[i]._logo = data[i].logo ? data[i].logo : '../../common/images/nopic.png';
                            data[i].moveTo = "#";
                        }
                        this.storeList.generateList(data);
                        this.end = this.start + data.length - 1;
                        this.busy = false;
                    }),
                    queryOptions: {
                        count : this.pageSize,
                        start : this.start
                    },
                    itemMap: {
                        _label : "label",
                        _logo : "icon",
                        moveTo : "moveTo"
                    }
                });
            // 创建数据源
            this.params = {};
            this.store = new JsonRest({
                    target : matGroup.getGroupUrl()
                });
            // 将数据源赋值给storeList
            this.storeList.setStore(this.store, this.params);
            this.storeList.placeAt(this.newsListScroll.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            on(this.newsListScroll, "afterscroll", lang.hitch(this, this.onLoadMore));
        },
        onClickList : function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")
                return;
            var _id = li.params._id;
            window.moveToView("matGroup", _id);
        },
        onLoadMore : function (evt) {
            //判断是否正在加载，判断是否向上拖动
            if (!this.busy&&evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载更多品类");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        setQuery : function (query) {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});