//  变更人:曹桂捷
//  变更时间:2016.08.03
//  变更原因:爱在龙乡标准分类编辑界面
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dijit/_WidgetBase",
    "dijit/registry",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/sort",
    "cq/biz/article/pm/richTextTemp",
    "cq/util/edit/jsonRef"
], function (declare, lang, array, Deferred, query, domConstruct, domClass, domAttr, _WidgetBase, registry, View, _ViewMixin, sortTDetail, richTextTemp, jsonRef) {
    var showInOverlay,hideOverlay;
    var AttrObj = declare("", [_WidgetBase], {
        //根节点
        domNode: null,
        baseClass:"sort-attr",
        data:null,
        postCreate: function () {
            this.data = this.data || {};
            this.deleteBtn = domConstruct.create("button",{
                onclick: lang.hitch(this,function () {
                    this.destroyRecursive();
                }),
                "class": "attr-delete-btn text-button-fill",
                innerHTML: "删除"
            },this.domNode);
            this.attrNameDiv = domConstruct.create("div",{
                innerHTML: this.data.title + "：",
                style:"display:inline-block;",
                onclick:lang.hitch(this, this.editAttrClick)
            },this.domNode);
            // this.attrValueDiv = domConstruct.create("ul",{
            //     style:"display:inline-block;"
            // },this.domNode);
            this.addAttrValueBtn = domConstruct.create("button",{
                onclick:lang.hitch(this, this.onAddAttrValueClick),
                innerHTML:"添加属性值",
                "class": "attr-addvalue-btn text-button-fill"
            },this.domNode);
            if (this.data.values && this.data.values.length) {
                array.forEach(this.data.values, function (value) {
                    this.addAttrValue(value);
                }, this);
            }
        },
        //添加属性值
        onAddAttrValueClick: function () {
            if(!this.attrValueEditorDiv){
                this.attrValueEditor = new AttrValueEditor();
                this.attrValueEditorDiv = domConstruct.create("div", {
                    style: "height:400px;text-align: left;"
                });
                this.attrValueEditor.placeAt(this.attrValueEditorDiv);
            }
            showInOverlay(this.attrValueEditorDiv);
            this.attrValueEditor.startEdit().then(lang.hitch(this,function (data) {
                hideOverlay();
                if (data) {
                    this.addAttrValue(data.attrValueName);
                }
            }));
        },
        addAttrValue: function (attrValueName) {
            var attrValueObj = new AttrValueObj({
                attrValueName: attrValueName
            });
            //this.attrValueDiv.appendChild(attrValueObj.domNode);
            domConstruct.place(attrValueObj.domNode, this.addAttrValueBtn, "before");
        },
        //编辑属性
        editAttrClick: function () {
            if(!this.attrEditorDiv){
                this.attrEditor = new AttrEditor();
                this.attrEditorDiv = domConstruct.create("div", {
                    style: "height:400px;text-align: left;"
                });
                this.attrEditor.placeAt(this.attrEditorDiv);
            }
            showInOverlay(this.attrEditorDiv);
            this.attrEditor.startEdit(this.data).then(lang.hitch(this,function (data) {
                hideOverlay();
                if (data) {
                    this.attrNameDiv.innerHTML = data.title + "：";
                    this.data = data;
                }
            }));
        },
        getData: function () {
            var data = this.data || {};
            data.values = [];
            array.forEach(registry.findWidgets(this.domNode),function (attrValueObj) {
                data.values.push(attrValueObj.getData());
            });
            return data;
        }
    });
    var AttrValueObj = declare("", _WidgetBase, {
        attrValueName:null,
        baseClass:"sort-attr-value",
        postCreate: function () {
            this.domNode.innerHTML = this.attrValueName;
            domConstruct.create("span",{
                innerHTML:"x",
                "class":"attr-value-delete",
                onclick: lang.hitch(this,function () {
                    this.destroyRecursive();
                })
            },this.domNode);
        },
        getData: function () {
            return this.attrValueName;
        }
    });
    //属性编辑对象,用来添加/编辑属性
    var AttrEditor = declare("", [View, _ViewMixin], {
        currentDef: null,
        //开始编辑
        startEdit: function (data) {
            this.startup();
            this.setData(data || {});
            this.refreshData();
            this.currentDef = new Deferred();
            return this.currentDef;
        },
        //初始化选择器
        indexElement: function () {
            var option = {
                isEdge: true,
                lists: [{
                    label: "属性标题",
                    edit: {
                        placeHolder: "必填",
                        type: "text",
                        field: "title"
                    }
                }, {
                    label: "是否自定义",
                    edit: {
                        type: "checkbox",
                        field: "isDefine"
                    }
                }]
            };
            this.addLists(option);
            option = {
                columns: [{
                    label: "确认",
                    onClick: lang.hitch(this, function() {
                        var m = this.getData();
                        if (!m.title) {
                            alert("属性名没有填写!");
                            return;
                        }
                        this.currentDef.resolve(m);
                    }),
                    className: "footer-tab-highlight"
                }, {
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                    }),
                    className: "footer-tab-dark"
                }],
                labelClass: 'font-size2',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
        }
    });
    var AttrValueEditor = declare("", [View, _ViewMixin], {
        currentDef: null,
        //开始编辑
        startEdit: function (data) {
            this.startup();
            this.setData(data || {});
            this.refreshData();
            this.currentDef = new Deferred();
            return this.currentDef;
        },
        //初始化选择器
        indexElement: function () {
            var option = {
                isEdge: true,
                lists: [{
                    label: "属性值",
                    edit: {
                        type: "text",
                        placeHolder: "必填",
                        field: "attrValueName"
                    }
                }]
            };
            this.addLists(option);
            option = {
                columns: [{
                    label: "确认",
                    onClick: lang.hitch(this, function() {
                        var m = this.getData();
                        if (!m.attrValueName) {
                            alert("属性值没有填写!");
                            return;
                        }
                        this.currentDef.resolve(m);
                    }),
                    className: "footer-tab-highlight"
                }, {
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                    }),
                    className: "footer-tab-dark"
                }],
                labelClass: 'font-size2',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
        }
    });
    var TmpSelecter = declare("", [View, _ViewMixin], {
        currentDef: null,
        startEdit: function (data) {
            this.currentDef = new Deferred();
            this.startup();
            this.onAfterShow(data);
            return this.currentDef;
        },
        indexElement: function () {
            //模板的显示框
            this.tmpDiv = domConstruct.create("ul", {
                "class": "sort-tmps",
                onclick: lang.hitch(this, this.onTmpDivClick)
            }, this.centerPanel.containerNode);
            var option;
            option = {
                columns: [{
                    label: "确认",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve(this.getData());
                    }),
                    className: "footer-tab-highlight"
                }, {
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                    }),
                    className: "footer-tab-dark"
                }],
                labelClass: 'font-size2',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
        },
        onAfterShow: function (selectedTmps) {
            var tmpLiStr = "";
            this.tmps = {};
            this.tmpDiv.innerHTML = "";
            richTextTemp.load().then(lang.hitch(this, function (data) {
                var tmps = data && data.data && data.data.items;
                array.forEach(tmps, function (tmp) {
                    tmpLiStr = '<li class="sort-tmp" _id="' + tmp._id + '">'
                    +   '<img src="' + tmp.logo + '" />'
                    +   '<div class="title">' + tmp.title + '<span></span></div>'
                    +'</li>';
                    this.tmpDiv.appendChild(domConstruct.toDom(tmpLiStr));
                    this.tmps[tmp._id] = tmp;
                }, this);
                //已经选中的设置选中样式
                array.forEach(selectedTmps, function (_id) {
                    var selectedDiv = query(".sort-tmp[_id='"+_id+"']",this.tmpDiv);
                    if (selectedDiv && selectedDiv.length) {
                        domClass.add(selectedDiv[0], "selected");
                    }
                }, this);
            }));
        },
        onTmpDivClick: function (e) {
            var dom = e.target;
            while (dom && dom.tagName != "LI") {
                dom = dom.parentNode;
            }
            if (dom && domClass.contains(dom,"sort-tmp")) {
                domClass.toggle(dom, "selected");
            }
        },
        getData:function () {
            var selecteds = query(".selected", this.tmpDiv),
            selectedTmps = [];
            array.forEach(selecteds, function (selected) {
                selectedTmps.push(this.tmps[domAttr.get(selected, "_id")]);
            }, this);
            return selectedTmps;
        }
    });
    return declare("cq.ui.b.m.SortTDetail", [View, _ViewMixin], {
        isEditing:false,
        onFirstShow: function () {
            //把这个方法赋值给全局showInOverlay
            showInOverlay = lang.hitch(this,this.showInOverlay);
            hideOverlay = lang.hitch(this,this.hideOverlay);
            var option = null;
            option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        this.isEditing = false;
                        history.back();
                    }
                },
                title : "标准分类",
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                lists:[{
                    label : "图标",
                    "class" : "li-icon",
                    moveTo : "#",
                    edit : {
                        type:"image",
                        field:"logo"
                    }
                }, {
                    label : '分类名称',
                    edit : {
                        type : 'text',
                        field : 'sortName',
                        placeHolder:"请输入名称"
                    }
                }, {
                    label : "使用",
                    edit : {
                        type : "checkbox",
                        field : "isUse"
                    }
                }]
            };
            this.addLists(option);
            //添加模板区域
            var tmpDiv = this.tmpDiv = domConstruct.create("div",{
                //,
                //"class" : "none"
            },this.centerPanel.containerNode);
            //添加模板按钮
            domConstruct.create("button",{
                innerHTML : "添加模板",
                onclick : lang.hitch(this,this.showTmpSelecter),
                "class" : "text-button-fill"
            },tmpDiv);
            //放选中的模板
            //点击之后处理删除
            this.temPart = domConstruct.create("div",{
                "class":"temPart",
                onclick:lang.hitch(this,this.onTemPartClick)
            },tmpDiv);
            //添加属性区域
            var attrDiv = this.attrDiv = domConstruct.create("div",{
                //"class" : "none"
            },this.centerPanel.containerNode);
            //添加区域按钮
            domConstruct.create("button",{
                innerHTML : "添加属性",
                "class" : "text-button-fill",
                onclick : lang.hitch(this,this.showAttrEditor)
            },attrDiv);
            //放新增的属性
            this.attrPart = domConstruct.create("div",{"class":"attrPart"},attrDiv);

            this.onAfterShow();
        },
        //加载数据刷新页面
        onAfterShow: function () {
            if (!this.isEditing) {
                this.isEditing = true;
                this.clearAttrs();
                this.clearTmps();
                if (window.did) {
                    sortTDetail.loadById(window.did).then(lang.hitch(this,function (data) {
                        if(data && data.data && data.data.ok === 1){
                            this.setData(data.data.item);
                        }else {
                            this.setData({
                                isUse : true
                            });
                        }
                        this.refreshData();
                    }));
                }else {
                    this.setData({
                        isUse : true
                    });
                    this.refreshData();
                }
            }
        },
        refreshData: function () {
            this.inherited(arguments);
            var m = this.getData();
            if (m) {
                if(m.props && m.props.length){
                    array.forEach(m.props, function (prop) {
                        this.addAttr(prop);
                    }, this);
                }
                if (m.temps && m.temps.length) {
                    richTextTemp.loadByIds(m.temps).then(lang.hitch(this,function (data) {
                        var items = data && data.data && data.data.items || [];
                        array.forEach(items, function (temp) {
                            this.addTmp(temp);
                        }, this);
                    }));
                }
            }
            this.tmpIds = m && m.temps || [];
        },
        //添加属性
        showAttrEditor: function () {
            if(!this.attrEditorDiv){
                this.attrEditor = new AttrEditor();
                this.attrEditorDiv = domConstruct.create("div", {
                    style: "height:400px;text-align: left;"
                });
                this.attrEditor.placeAt(this.attrEditorDiv);
            }
            this.showInOverlay(this.attrEditorDiv);
            this.attrEditor.startEdit().then(lang.hitch(this,function (data) {
                this.hideOverlay();
                if (data) {
                    this.addAttr(data);
                }
            }));
        },
        addAttr:function (attr) {
            var attrObj = new AttrObj({data:attr});
            this.attrPart.appendChild(attrObj.domNode);
        },
        getAttrs:function () {
            var attrs = [];
            array.forEach(registry.findWidgets(this.attrPart),function (attrObj) {
                attrs.push(attrObj.getData());
            });
            return attrs;
        },
        clearAttrs:function () {
            array.forEach(registry.findWidgets(this.attrPart),function (attrObj) {
                attrObj.destroyRecursive();
            });
        },
        //添加模板
        showTmpSelecter: function () {
            return jsonRef.startEdit("",this,{
                target:richTextTemp.getLoadUrl(),
                query:{
                    isUse:true
                },
                searchField:"title",labelField:"title"
            }).then(lang.hitch(this,function(data){
                if(data&&data._id){
                    if(-1<array.indexOf(this.tmpIds,data._id)){
                        return alert(data.title+"已添加");
                    }
                    this.tmpIds.push(data._id);
                    this.addTmp(data);
                }
            }));
        },
        //模版列表区域点击事件，删除的处理
        onTemPartClick:function(e){
            var node = e.target;
            if(domClass.contains(node,"del")){
                while("LI"!==node.tagName){
                    node = node.parentNode;
                }
                var _id = domAttr.get(node,"_id");
                node.parentNode.removeChild(node);
                for(var i=0;i<this.tmpIds.length;i++){
                    if(this.tmpIds[i]===_id){
                        this.tmpIds.splice(i,1);
                        break;
                    }
                }
            }
        },
        //添加模板
        addTmp:function (tmp) {
            var tmpLiStr = ""
            +'<li class="sort-tmp" _id="' + tmp._id + '">'
            +   '<img src="' + tmp.logo + '" />'
            +   '<div class="title">' + tmp.title
            +   '<span class="text-button-fill del" style="margin:0;padding:0;float:right;">删除</span>'
            +   '</div>'
            +'</li>';
            this.temPart.appendChild(domConstruct.toDom(tmpLiStr));
        },
        clearTmps: function () {
            this.temPart.innerHTML = "";
            this.tmpIds = [];
        },
        onDataChanged:function (field, oldValue, newValue) {
            if (field == "noSub" && this.tmpDiv) {
                if (newValue == true) {
                    domClass.remove(this.tmpDiv, "none");
                    domClass.remove(this.attrDiv, "none");
                } else {
                    domClass.add(this.tmpDiv, "none");
                    domClass.add(this.attrDiv, "none");
                }
            }
        },
        onSaveStore : function () {
            var m = this.getData();
            //如果是需要添加的分类，并存在上级分类，则设置上级分类的upSort
            if(window.did.indexOf("u_id") != -1){
                if(window.did.split("u_id")[1]){
                    m.upSort = window.did.split("u_id")[1];
                }
                //新分类编码默认设置为9999
                m.code = "9999";
                m.noSub = true;
            }
            m.props = this.getAttrs();
            m.temps = this.tmpIds;
            // 检查字段合法性
            var msg = this.checkField(m);
            if (msg) {
                alert(msg);
                return;
            }
            sortTDetail.save(m).then(lang.hitch(this,function () {
                this.isEditing = false;
                history.back();
            }));
        },
        checkField: function (m) {
            var msg = '';
            if (!m.logo) {
                msg = "图标没有上传!";
            } else if (!m.sortName) {
                msg = "名称没有填写!";
            }
            //如果没有下级,则需要检查temps
            if (m.noSub) {
                //if (m.temps.length < 1) {
                //    msg = "模板没有选择!";
                //}
            } else {
                m.props = null;
                m.temps = null;
            }
            return msg;
        }
    });
});