//  变更人:张伟
//  变更时间:2016.07.15
//  变更原因:爱在龙乡标准分类列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "cq/biz/mat/sort",
    "cq/ui/view/_ViewMixin"
], function (declare, lang, query, JsonRest, registry, EdgeToEdgeStoreList, View, sort, _ViewMixin) {
    return declare("cq.ui.b.m.StdSortList", [View, _ViewMixin], {
        start : 0,
        pageSize : 10,
        //初始化相关接口
        //索引界面元素
        indexElement : function () {
            this.newsListScroll = this.centerPanel;
        },
        onFirstShow : function () {
            var option = null;
            //添加Header
            option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    }
                },
                title : "标准分类列表"
            };
            this.addHeader(option);
            //添加TextBox
            option = {
                isHeader : true,
                placeHolder : "请输入分类名称，按回车查询",
                type : "search",
                class : "cqSearchBox",
                onInput : lang.hitch(this, function(evt){
                    if (evt.keyCode == 13) {
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.sortName = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            //添加底部Columns
            option = {
                columns : [{
                    label : '添加标准分类',
                    icon : 'images/icon/addnews.png',
                    iconClass : 'footer-tab-img',
                    onClick : function () {
                            window.moveToView("stdSort");
                        }
                }],
                valueClass : 'font-size3',
                labelClass : 'font-size1',
                className : 'fix-footer',
                isFooter : true
            };
            this.addColumns(option);
            //新建EdgeToEdgeStoreList
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                onComplete : lang.hitch(this,function(data){
                    for (var i = 0;i < data.length;i++){
                        data[i].label = "<div class='mat-list-mname mat-list-margin'>" + data[i].sortName + "</div>";
                        if (data[i].upSort&&data[i].upSort.sortName){
                            data[i].label += "<div class='margin-top10 mat-list-mname mat-list-margin'>上级分类："+data[i].upSort.sortName+"</div>";
                        }
                        data[i].label += "<div class='mat-list-mname mat-list-margin'>分类编码："+(data[i].code || '')+"</div>";
                        data[i]._logo = data[i].logo ? data[i].logo : '../../common/images/nopic.png';
                        data[i].moveTo = "#";
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                queryOptions : {
                    start : this.start,
                    count : this.pageSize
                },
                itemMap : {
                    _label : "label",
                    _logo : "icon",
                    _moveTo : "moveTo"
                },
            });
            //创建数据源
            this.params = {
                //添加查询的排序条件
                orderBy : "code"
            };
            this.store = new JsonRest({
                target : sort.getSortUrl()
            });
            // 将数据源赋值给storeList
            this.storeList.setStore(this.store, this.params);
            this.storeList.placeAt(this.newsListScroll.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            //on(this.newsListScroll, "afterscroll", lang.hitch(this,this.onLoadMore));
            this.newsListScroll.on( "afterscroll", lang.hitch(this, this.onLoadMore));
            // this.onAfterShow();
        },
        onAfterShow : function () {
            this.setQuery(this.storeList.get("query"));
        },
        //创建onClickList函数
        onClickList : function (evt) {
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")
                return;
            var _id = li.params._id;
            window.moveToView("stdSort", _id);
        },
        //创建onLoadMore函数
        onLoadMore : function (evt) {
            if (!this.busy&&evt.afterBottom){
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)){
                    console.log("加载更多分类");
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"),{
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult, this.start, this.pageSize);
                    }), 1000);
                }
            }
        },
        //加载数据
        setQuery : function (query){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            //添加排序条件2016-7-24肖芳圆
            query.orderBy = "code";
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult, this.start, this.pageSize);
        }
    });
});
