// 创建人：母浚驰
// 创建时间：2016-08-30
// 功能：拼团活动编辑
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "cq/biz/mk/pacBuy"
],function(declare, lang, View, _ViewMixin, mat, pacBuy){
    return declare("cq.ui.b.p.PacBuyDetail",[View,_ViewMixin],{
        // 页面是否处在编辑中，默认值为false
        isEditing : false,
        onFirstShow : function(){
            // 加载页面头部
            var option = {
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:lang.hitch(this,function(){
                        this.isEditing = false;
                        history.back();
                    })
                },
                title:"拼团活动编辑",
                right:{
                    iconButton:' ',
                    label:"完成",
                    onClick:this.onSaveStore
                }
            };
            this.addHeader(option);
            
            // 添加详情
            option = {
                isEdge:true,
                lists:[
                {
                    label : '活动标题',
                    edit : {
                        type : 'text',
                        field : 'title',
                        placeHolder: "必填"
                    }
                },
                {
                    label:"拼团商品",
                    noArrow:false,
                    moveTo:"#",
                    edit: {
                        type: "ref",
                        field: "mId",
                        params: {
                            target: mat.getCurrentShopOnSaleUrl(),
                            query: {
                                isUse : true,
                                qty : 1
                            },
                            searchField: "mName",
                            labelField: "mName"
                        },
                        placeHolder: "必选"
                    }
                },
                {
                    label : '拼团价格',
                    edit : {
                        type : 'text',
                        field : 'pacPic',
                        placeHolder: "必填"
                    }
                },
                {
                    label:'拼团人数',
                    rightText : '',
                    moveTo : "#",
                    edit:{
                        type:'options',
                        field:'pacNum',
                        options:{
                            '2':'2人团',
                            '3':'3人团',
                            '4':'4人团',
                            '5':'5人团',
                            '10':'10人团',
                            '20':'20人团',
                            '30':'30人团',
                            '50':'50人团',
                            '100':'100人团',
                        },
                        placeHolder: "必选"
                    }
                },
                {
                    label: "拼团开始时间",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "dateMin",
                        field: "startTime",
                        placeHolder: "必填"
                    }
                },
                {
                    label: "拼团结束时间",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "dateMin",
                        field: "endTime",
                        placeHolder: "必填"
                    }
                },
                {
                    label: "模拟成团",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "checkbox",
                        field: "ficInto"
                    }
                },
                {
                    label: "包邮",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "checkbox",
                        field: "freePost"
                    }
                },
                {
                    label: '推荐信息',
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "textarea",
                        field: "rcdInfo",
                        placeHolder: "必填"
                    }
                },
                {
                    label: "是否使用",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "checkbox",
                        field: "isUse"
                    }
                }],
            };
            this.addLists(option);
            this.onAfterShow();
        },
        
        onAfterShow : function(){
            if(!this.isEditing){
                this.isEditing = true;
                if(window.did){
                    pacBuy.loadById(window.did).then(lang.hitch(this,function(data){
                        if (data && data.data && data.data.item) {
                            this.setData(data.data.item);
                            this.refreshData();
                        }
                    }));
                }else{
                    //设置默认值
                    this.setData({ isUse: true });
                    this.refreshData();
                }
            }
        },
        
        onSaveStore : function(){
            if(this.isEditing){
                window.busy();
                var m=this.getData();
                //验证输入的正确性
                // var msg=this.onVerify(m);
                // if(msg){
                    // window.free();
                    // alert(msg);
                    // this.isEditing = true;
                    // return;
                // }
                pacBuy.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok){
                        this.isEditing = false;
                        history.back();
                    }else{
                        if(data&&data.data&&data.data.message){
                            alert(data.data.message);
                        }else{
                            alert("保存失败");
                        }
                        this.isEditing = true;
                    }
                }));
            }
        },
        
        onVerify : function(data){
            var msg="";
            var startTime = Date.parse(data.startTime);
            var endTime = Date.parse(data.endTime);
            if(!data.title){
                msg = "请填写活动标题";
            }else if(!data.mId){
                msg = "请选择拼团商品";
            }else{
                /* if(data.price&&!(/^\d+(?=\.{0,1}\d+$|$)/.test(data.price))||data.retailPrice<data.price){
                    msg = "团购价格必须是大于0而且小于原价的数字";
                } */
                if(!data.pacPic){
                    msg = "请填写拼团价格";
                }else if(!data.pacNum){
                    msg = "请选择拼团人数";
                }else if(!data.startTime){
                    msg = "请填写拼团开始时间";
                }else if(!data.endTime){
                    msg = "请填写拼团结束时间";
                }else if(startTime>=endTime){
                    msg = "开始时间不能大于结束时间";
                }else if(endTime-startTime<86400000){
                    msg = "拼团结束时间与开始时间的时间差不能小于24小时";
                }else if(!data.rcdInfo){
                    msg = "请填写推荐信息";
                }
            }
            return msg;
        }
    });
});