// 创建人：母浚驰
// 创建时间：2016-08-30
// 功能：拼团活动列表
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/query",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/pacBuy",
    "cq/util/sys/date"
],function(declare,lang,query,JsonRest,domClass,domStyle,EdgeToEdgeStoreList,View,registry,_ViewMixin,pacBuy,date){
    return declare("cq.ui.b.p.PacBuyList",[View,_ViewMixin],{
        //设置state:1所有团购，2进行中，3未开始，4已结束  后台筛选字段是state
        //筛选条件
        params : null,
        startDate : [],
        endDate : [],
        start:0,
        pageSize:10,
        onFirstShow:function(){
            //导航
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        this.startDate = [];
                        this.endDate = [];
                        this.params.state = 2;
                        history.back();
                    }
                },
                title : "拼团活动"
            };
            this.addHeader(option);
            //创建头部
            option = {
                isHeader:true,
                columns : [/* {
                    label : '所有',
                    onClick : function(e){
                        this.params.state = 1;
                        this.changeOnList(e);
                    }
                }, */{
                    label : '进行中',
                    onClick : function(e){
                        this.params.state=2;
                        this.changeOnList(e);
                    }
                },{
                    label : '未开始',
                    onClick : function(e){
                        this.params.state=3;
                        this.changeOnList(e);
                    }
                },{
                    label:'已结束',
                    onClick : function(e){
                        this.params.state=4;
                        this.changeOnList(e);
                    }
                },{
                    label:'已失效',
                    onClick : function(e){
                        this.params.state=5;
                        this.changeOnList(e);
                    }
                }],
                labelClass : 'font-size1 tab-selector'
            };
            this.addColumns(option);
            option = {
                columns :[{
                    label : "新建拼团",
                    onClick:function(){
						window.moveToView("pacBuyDetail");
					}
                }],
                labelClass : 'font-size1',
                className : 'padding-top-bottom16',
                isFooter : true
            };
            this.addColumns(option);
            this.onCreatList();
            this.onAfterShow();
        },
        //创建列表
        onCreatList : function(){
            //创建团购商品列表
            this.pacBuyList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"mblEdgeToEdgeList",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        var sDate = date.formatISODateMinutes(data[i].startTime);
                        var eDate = date.formatISODateMinutes(data[i].endTime);
                        if(data[i].mId){
                            data[i]._label="<div style='height:100px;float:left;'>"
                            +"<img style='height:100%;' src='"+data[i].mId.logo+"'></div>"
                            +"<div class='shelf-mat-title'>活动名称："+data[i].title+"</div>"
                            +"<div class='shelf-mat-title'>商品名称：<span style='width:40%'>"
                            +data[i].mId.mName+"</span></div>"
                            +"<div class='shelf-mat-title'>拼团人数："+data[i].pacNum+"</div>"
                            +"<div class='shelf-mat-title'>拼团价格："+data[i].pacPic+"</div>"
                            +"<div class='forth-btn' style='margin-top:-30px;'>"
                            +"<span class='editteam float-right' style='display:none;'>查看团队</span>"
                            +"<span class='editpac float-right'>编辑</span></div>"
                        }
                        this.startDate.push(sDate);
                        this.endDate.push(eDate);
                    }
                    this.pacBuyList.generateList(data);
                    this.editState();
                    this.busy=false;
                }),
                itemMap:{
                    _label:"label"
                }
            });
            this.pacBuyList.placeAt(this.centerPanel.containerNode,"last");
            //列表的点击事件
            this.pacBuyList.on("click",lang.hitch(this,this.onClickList));
            //添加滚动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        //根据type加载拼团商品信息  给出query的值 
        loadPac : function(){
            this.start = 0;
            this.pacBuyList.destroyDescendants();
            if(this.store){
                this.busy = true;
                var queryResult= this.pacBuyList.setQuery(this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.params = {
                    state : 2
                };
                //如果没有store就创建数据源
                this.store = new JsonRest({target:pacBuy.getLoadByStateUrl()});
                this.busy=true;
                var queryResult =this.pacBuyList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        //拖动加载更多
        onLoadMore:function(e){
            //当滚动加载更多的时候，通过e的事件来判断是setQuer哪一个列表
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.pacBuyList.setQuery(this.pacBuyList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        onAfterShow:function(){
            //默认加载所有团购商品列表
            //返回的时候应该还是在原来对应的列表
            var selectOption=0;
            if(this.params.state===2){
                selectOption=0;
            }else if(this.params.state===3){
                selectOption=1;
            }else if(this.params.state===4){
                selectOption=2;
            }else if(this.params.state===5){
                this.params.isUse = false;
                selectOption=3;
            }
            this.changeOnList({
                target:query(".tab-selector",this.domNode)[selectOption]
            });
        },
        editState: function(){
            for(var i=0;i<this.startDate.length;i++){
                if(new Date(this.startDate[i]) < new Date() && new Date(this.endDate[i]) > new Date()){
                    domStyle.set(query(".editpac",this.domNode)[i],"display","none");
                    domStyle.set(query(".editteam",this.domNode)[i],"display","inline-block");
                }else if(new Date(this.endDate[i]) < new Date()){
                    domStyle.set(query(".editteam",this.domNode)[i],"display","none");
                    domStyle.set(query(".editpac",this.domNode)[i],"display","none");
                }else{
                    domStyle.set(query(".editteam",this.domNode)[i],"display","none");
                    domStyle.set(query(".editpac",this.domNode)[i],"display","inline-block");
                }
            }
        },
        //选中样式
        changeOnList:function(e){
            //清空
            this.clearSelected();
            //事件发生触发添加selected样式
            domClass.add(e.target, "selected");
            this.loadPac();
        },
        //清空所有状态
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                //移除每个节点的selected类
                domClass.remove(items[i], "selected");
            }
            this.startDate = [];
            this.endDate = [];
        },
        //否则就做跳转
        onClickList:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")return;
            var dom = evt.target;
            var _id = li.params._id;
            if(dom&&domClass.contains(dom,"editpac")){
                window.moveToView("pacBuyDetail",_id);
            }
            if(dom&&domClass.contains(dom,"editteam")){
                window.moveToView("pacAllTeamList",_id);
            }
        }
    });
});