//创建人：周超   创建时间：2016-5-28  创建事项：项目申请--浏览/详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "cq/util/sys/date",
    "cq/biz/ts/pm/project"
],function(declare,lang,domClass,View,_ViewMixin,_PrjMixin,date,project){
    return declare("cq.ui.b.p.PrjApplyDtl",[View,_ViewMixin,_PrjMixin],{
        projectStateLabels:{
            0:"等待审核",
            1:"审核通过",
            2:"审核驳回",
            3:"审核拒绝",
            4:"审核作废",
			11:"等待验收",
			13:"验收驳回",
			14:"验收拒绝",
			15:"验收通过"
        },
		dtlOpers:{
            2:[false,false],
			1:[false,true,true],
			11:[false,false,true],
			13:[false,false,true],
			14:[false,false,true],
			15:[false,false,true],
			222:[false,false]
        },
        hasBlank:false,
        getDtlState:function(){
            var data = this.getData();
            if((data&&data.startDate&&data.endDate&&date.formatISODate(date.nowISOString())>data.endDate)&&(data.state === 2)){
                return 222;
            }else{
                return this.inherited(arguments);
            }
        },
		decorateLabelData:function(projectItem){
			projectItem = this.inherited(arguments);
			projectItem.projectStateLabel = this.projectStateLabels[projectItem.state];
			if(projectItem.state == 2){
				domClass.remove(this.rejectReason.domNode,"none");
			}
			else
				domClass.add(this.rejectReason.domNode,"none");
			return projectItem;
			
		},
        //onAfterShow：
        //        参数：无
        //        返回值：无
        //        给界面赋值数据
        onAfterShow:function() {
			if(!this.isEditing){
				this.refreshProjectData();
				this.isEditing = true;
			}
        },
        //onFirstShow：
        //        参数:无
        //        返回值:无
        //        初始化界面元素
        onFirstShow:function(){
            this.addListTitleHeader("项目申报");
            option = {
                isEdge:true,
                lists:[
                    {label:'业主单位',noArrow:true,rightText:"{{fromShopName}}"},
                    {label:'申报日期',noArrow:true,rightText:'{{createAt}}'},
                    {label:'申请项目',noArrow:true,rightText:'{{srcProjectName}}'},
					{label:'状态',noArrow:true,rightText:'{{projectStateLabel}}'},
					{label:'批复金额',noArrow:true,rightText:'{{verifiedAmount}}'},
					{label:'建设内容',noArrow:true,rightText:'{{scale}}',variableHeight:true},
					{label:'资金用途',noArrow:true,rightText:'{{targetUsage}}',variableHeight:true},
					{label:'投资总额',noArrow:true,edit:{
                        type:'text',
						placeHolder:"请填写实际投资总额",
                        field:'actInvestments'
                    }},
					{label:'建设成效',moveTo:"#",edit:{
                        type:'textarea',
                        field:'result'
                    },variableHeight:true}
                ],
                data:this.getData()
            };
            this.addLists(option);
            option = {
                isEdge:true,
                lists:[
					{label:'驳回原因',noArrow:true,rightText:'{{content}}'}
                ],
                data:this.getData()
            };
            this.rejectReason = this.addLists(option);
            //附件lists
            this.createDtlAttachList();
            option = {
                className: "showNone",
                columns : [{
                    label : '修改',
                    className : 'flex2 footer-tab-dark modify',
                    onClick : function () {
						return alert("不允许修改");
                        window.moveToView("prjApplyEdt",window.did);
                    }
                },{
					//验收按钮
                    label : '申请验收',
                    className : 'flex2 footer-tab-dark modify',
                    onClick : function () {
						var data = this.getData();
						if(!data.actInvestments) return alert("请填写投资总额");
						if(!data.result) return alert("请填写建设成效");
						project.examineWaiting(window.did,data).then(lang.hitch(this,function(){
							this.isEditing = false;
							this.onAfterShow();
						}));
                    }
                },{
					//执行情况
                    label : '执行',
                    className : 'flex2 footer-tab-dark modify',
                    onClick : function () {
						this.isEditing = false;
						window.moveToView("timeLine","prj_"+window.did);
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.createDtlOperColunm(option);
            this.onAfterShow();
        }
    });
});