// 变更人：母浚驰
// 变更时间：2016-05-27
// 变更事项：项目申请编辑
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "cq/util/sys/date",
    "cq/biz/ts/pm/project"
],function (declare, lang, array, domClass, query, View, _ViewMixin, _PrjMixin, date, project) {
    return declare("cq.ui.b.p.PrjApplyEdt", [View, _ViewMixin, _PrjMixin], {
        // 页面是否处在编辑中，默认值为false
        isEditing : false,
        //界面初始化时读取界面初始数据
        getOriginApplyData:function(){
            var did = window.did.indexOf("prj_")===0?window.did.substr(4):window.did;
            return project.loadById(did).then(function(data){
                if(data&&data.data&&data.data.ok){
                    var item = data.data.item;
                    if(window.did!==item._id){
                        //若新申请，从项目定义中复制部分信息
                        item = {
                            projectType:2,
                            title:item.title,
                            startDate:item.startDate,
                            endDate:item.endDate,
                            startReviewDate:item.startReviewDate,
                            endReviewDate:item.endReviewDate,
                            fromShopId:{
                                _id:project.getShopId()
                            },
                            srcProjectId:item,
                            attachs:[]
                        };
                        //复制附件列表
                        for(var index=0;index<item.srcProjectId.attachs.length;index++){
                            item.attachs.push({
                                title:item.srcProjectId.attachs[index].title,
                                sampleUrl:""
                            });
                        }
                    }
                    return item;
                }else{
                    //加载出错，返回空，表示错误
                    return null;
                }
            });
        },
        // 依据附件数据刷新附件列表
        refreshAttachList:function(attachs){
            this.attachmentList.destroyDescendants();
            for(var index=0;index<attachs.length;index++){
                this.addAttachment(attachs[index],false,false);
            }
        },
        // 加载数据
        onAfterShow : function() {
            if(!this.isEditing){
                this.isEditing = true;
                this.header.set("label","项目申请");
                this.getOriginApplyData().then(lang.hitch(this,function(data){
                    if(!data){
                        alert("请稍后重试");
                        history.back();
                    }else{
                        data.startReviewDateText = data.startReviewDate && date.formatISODate(data.startReviewDate);
                        data.endReviewDateText = data.endReviewDate && date.formatISODate(data.endReviewDate);
                        data.startDateText = data.startDate && date.formatISODate(data.startDate);
                        data.endDateText = data.endDate && date.formatISODate(data.endDate);
                        data.srcProjectName = data.srcProjectId&&data.srcProjectId.title||"";
                        this.setData(data);
						//处理驳回原因的显示隐藏
						domClass[data._id===window.did&&data.content?"remove":"add"](query(".reject",this.domNode)[0],"none");
                        this.refreshAttachList(data.attachs);
                        this.refreshData();
                    }
                }));
            }
        },
        // 第一次进入页面，初始化页面组件
        onFirstShow:function(){
            // 加载页面头部
            var option = {
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:lang.hitch(this,function(){
                        this.isEditing = false;
                        history.back();
                    })
                },
                title:"项目申请",
                right:{
                    iconButton:' ',
                    onClick:this.onSaveStore,label:"完成"
                }
            };
            this.addHeader(option);
            // 添加详情
            option = {
                isEdge:true,
                lists:[
                {
                    label : '项目驳回原因',
                    rightText : '项目驳回原因',
                    moveTo : "#",
                    'class' : "reject",
                    edit:{
                        type:'richEdit',
                        field:'content'
                    }
                },
                {
                    label : '申报开始日期',
                    noArrow:true,
                    rightText : '{{startDateText}}'
                },
                {
                    label : '申报截止日期',
                    noArrow:true,
                    rightText : '{{endDateText}}'
                },
                {
                    label : '申请项目',
                    noArrow:true,
                    rightText : '{{srcProjectName}}'
                },
                {
                    label : '公示开始日期',
                    noArrow:true,
                    rightText : '{{startReviewDateText}}'
                },
                {
                    label : '公示截止日期',
                    noArrow:true,
                    rightText : '{{endReviewDateText}}'
                }],
                data:this.getData()
            };
            this.addLists(option);
            // 附件信息
            this.createEdtAttachList();
			//增加附件的功能
            var attachment = {
                columns : [{
                    label : "添加附件",
                    icon : 'images/icon/crmicon.png',
                    iconClass : 'width-16',
                    onClick : function () {
                        this.addAttachment({},true,true);
                    }
                }],
                className : 'fix-footer',
                isFooter : true
            }
            this.addColumns(attachment);
            this.onAfterShow();

        },
        // 依据附件数据刷新附件列表
        refreshAttachList:function(attachs){
            this.attachmentList.destroyDescendants();
            for(var index=0;index<attachs.length;index++){
                this.addAttachment(attachs[index],true,true);
            }
        },
        // 将用户修改、新增的数据保存到数据库
        onSaveStore:function(){
            if(this.isEditing){
                this.isEditing = false;
                var projectItem = this.getData();
                projectItem.attachs = this.getAttachsFromList();
                if(array.some(projectItem.attachs,function(attach){
                    if(!attach.sampleUrl){
                        alert("请上传附件:"+attach.title);
                        return true;
                    }
                })){
                    this.isEditing = true;
                    return;
                }
                project.saveApply(projectItem).then(lang.hitch(this,function(data){
                    // 保存成功则跳转到模版列表页面
                    if(data.data.ok){
                        history.back();
                    }else{
                        alert("保存失败");
                        this.isEditing = true;
                    }
                }));
            }
        },
        // 验证必填项是否有值
        validProjectData:function(data){
            var msg="";
            if(!data.title){
                msg="标题不能为空!";            
            }else if(!data.startDate){
                msg="申请开始日期不能为空!";
            }else if(!data.endDate){
                msg="申请截止日期不能为空!";
            }
            if(msg){
                return msg;
            }
		}
    });
});