// 创建人：潘云
// 创建时间：2016-05-18
// 功能：商家申报列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "dojo/query",
    "dojo/store/JsonRest",
    "cq/biz/ts/pm/project",
    "dojo/dom-class",
    "cq/util/sys/date",
],function(declare,lang,array,View,_ViewMixin,_PrjMixin,query,JsonRest,project,domClass,date){
    // module:
    //        cq/ui/b/p/PrjDefList
    return declare("cq.ui.b.p.PrjDefList",[View,_ViewMixin,_PrjMixin],{
        listMoveView:"prjApplyDtl",
        projectStateLabels:{
            0:"等待审核",
            1:"审核通过",
            2:"审核驳回",
            3:"审核拒绝",
            4:"审核作废",
			11:"等待验收",
			13:"验收驳回",
			14:"验收拒绝",
			15:"验收通过"
        },
        onAfterShow:function(){
            if(this.storeList.store){
                this.setQuery();
            }else{
                this.storeList.setStore(this.store,this.getQuery(),{
                    start: 0,
                    count: this.pageSize
                });
            }
            this.refreshData();
        },
		initListItemLabel:function(projectItem){
            this.decorateLabelData(projectItem);
            projectItem.moveTo="#";
            projectItem.rightText=this.getProjectStateLabel(projectItem.state);
            projectItem._label = "<div class='mat-list-mname mat-list-margin'>"+(projectItem.title||"")+
                //"</div><div class='mat-list-mname mat-list-margin'>申报主体："+projectItem.fromShopId.shopName+
                "</div><div class='mat-list-mname mat-list-margin'>申报日期："+projectItem.createAt+
                "</div>";
		},
        onFirstShow:function(){
            this.addListTitleHeader("项目申报");
            option = {
                columns:[
                {
                    label:'我的申报',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(0,evt);
                    })
                },{
                    label:'项目公示',
                    onClick:lang.hitch(this,function(evt){
						this.changeState(15,evt);
                        //this.changeState(1,evt);
                    })
                }],
                labelClass:'font-size1 tab-selector'
            }
            //this.addColumns(option);
            this.initStoreList();
            this.store = new JsonRest({
                target:project.getLoadApplyUrl()
            });
            //domClass.add(query('.tab-selector',this.domNode)[0],"selected");
            this.onAfterShow();
        },
        // 改变标签的样式
        changeLabelClass:function(evnt){
            array.forEach(query(".tab-selector",this.domNode),function(item){
                domClass.remove(item,"selected");
            });
            domClass.add(evnt.target,"selected");
        },
        // 点击待审核按钮的响应事件
        changeState:function(type,evt){
            this.changeLabelClass(evt);
            this.selectedState = type;
            this.setQuery();
        },
        getQuery:function(){
            var query = {};
			//按最后修改时间修改
			query.orderBy = "-lastMod";
            // 默认选择我的申报列表
            if(this.selectedState === 0 || !this.selectedState){
                query.fromShopId = project.getShopId();
				//公示列表
            }else if(this.selectedState >= 0){
                query.state = this.selectedState;
				//公示期内进行公示
                query.isReviewing = true;
            }
            return query;

        },
        setQuery:function(){
			var data = this.getData();
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            this.storeList.setQuery(this.getQuery(),{
                start: this.start,
                count: this.pageSize
            });
            this.centerPanel.resize();
        }
    });
});