// 创建人：潘云
// 创建时间：2016-05-18
// 功能：平台申请列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "dojo/query",
    "dojo/store/JsonRest",
    "cq/biz/ts/pm/project",
    "dojo/dom-class"
],function(declare,lang,array,View,_ViewMixin,_PrjMixin,query,JsonRest,project,domClass){
    // module:
    //        cq/ui/b/p/PrjCheckList
    return declare("cq.ui.b.p.PrjCheckList",[View,_ViewMixin,_PrjMixin],{
        listMoveView:"prjCheckDtl",
        projectStateLabels:{
            0:"等待审核",
            1:"审核通过",
            2:"审核驳回",
            3:"审核拒绝",
            4:"审核作废",
			11:"等待验收",
			13:"验收驳回",
			14:"验收拒绝",
			15:"验收通过"
        },
        onAfterShow:function(){
            if(this.storeList.store){
                this.refreshProjectList();
            }else{
                this.storeList.setStore(this.store,this.getQueryCondition(),{
                    start: 0,
                    count: this.pageSize
                });
            }
        },
        onFirstShow:function(){
			var obj_0 = [0,1,2,3,4,11,13,14,15];
			var obj0 = [0,11];
			var obj1 = 1;
			var obj2 = [2,13];
			var obj3 = [3,14];
			var obj15 = 15;
            this.addListTitleHeader("申请列表");
            option = {
                columns:[{
					//添加全部标签页
                    label:'全部',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(obj_0,evt);
                    })
                },
                {
                    label:'待处理',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(obj0,evt);
                    })
                },{
                    label:'已审核',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(obj1,evt);
                    })
                },{
                    label:'已驳回',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(obj2,evt);
                    })
                },{
                    label:'已拒绝',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(obj3,evt);
                    })
                },{
					//添加已验收的标签页
                    label:'已验收',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(obj15,evt);
                    })
                }],
                labelClass:'font-size1 tab-selector'
            }
            this.addColumns(option);
            this.initStoreList();
            this.store = new JsonRest({
                target:project.getLoadApplyUrl()
            });
            domClass.add(query('.tab-selector',this.domNode)[1],"selected");
            this.onAfterShow();
        },
        // 改变标签的样式
        changeLabelClass:function(evnt){
            array.forEach(query(".tab-selector",this.domNode),function(item){
                domClass.remove(item,"selected");
            });
            domClass.add(evnt.target,"selected");
        },
        // 点击table栏的响应事件
        changeState:function(type,evt){
            this.changeLabelClass(evt);
            this.selectedState = type;
            this.refreshProjectList();
        },
        getQueryCondition:function(){
			//设置state的值
            var query = {};
			//按最后修改的时间排列
			query.orderBy = "-lastMod";
            if(!this.selectedState || this.selectedState === [0,11]){
                query.state = [0,11];
            } else if (this.selectedState != [0,11]){
                query.state = JSON.stringify(this.selectedState);
            }
            return query;
        },
        refreshProjectList:function(){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            this.storeList.setQuery(this.getQueryCondition(),{
                start: this.start,
                count: this.pageSize
            });
            this.centerPanel.resize();
        }
    });
});