// 变更人：母浚驰
// 变更时间：2016-05-27
// 变更事项：项目定义编辑
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "cq/util/sys/date",
    "cq/biz/ts/pm/project",
	"cq/util/config/config"
],function (declare, lang, array, query, View, _ViewMixin, _PrjMixin, date, project, config) {
    return declare("cq.ui.b.p.PrjDefEdt", [View, _ViewMixin, _PrjMixin], {
        // 页面是否处在编辑中，默认值为false
        isEditing : false,
        // 加载数据
        onAfterShow : function() {
            if(!this.isEditing){
                // 初始化数据
                this.isEditing = true;
                // 清空附件列表
                this.refreshAttachList([]);
                if(!window.did){
                    // 新增项目定义
                    this.header.set("label", "项目定义");
                    this.setData({});
                    this.refreshData();
                }else{
                    // 修改项目定义
                    project.loadById(window.did).then(lang.hitch(this, function(data) {
                        if(data.data&&data.data.ok){
                            // 显示项目信息
                            this.header.set("label", data.data.item.title);
                            this.setData(data.data.item);
                            this.refreshData();
                            // 刷新附件列表
                            this.refreshAttachList(data.data.item.attachs);
                        }
                    }));
                }
            }
        },
        // 第一次进入页面，初始化页面组件
        onFirstShow:function(){
            // 加载页面头部
            var option = {
                left:{
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:lang.hitch(this,function(){
                        this.isEditing = false;
                        history.back();
                    })
                },
                title:"项目定义",
                right:{
                    iconButton:' ',
                    onClick:this.onSaveStore,label:"完成"
                }
            };
            this.addHeader(option);
            // 添加详情
            option = {
                isEdge:true,
                lists:[
                {
                    label : '项目类型',
                    moveTo : "#",
                    edit : {
                        type : 'options',
                        field : 'typeId',
                        options : config.prjType
                    }
                },{
                    label:'项目名称',
                    noArrow:true,
                    edit:{
                        type : 'text',
                        field : 'title'
                    }
                },
                {
                    label : '申报开始日期',
                    moveTo : "#",
                    edit : {
                        type : 'date',
                        field : 'startDate'
                    }
                },
                {
                    label : '申报截止日期',
                    moveTo : "#",
                    edit : {
                        type : 'date',
                        field : 'endDate'
                    }
                },
                {
                    label : '建设单位',
                    moveTo : "#",
                    edit : {
                        type : 'text',
                        field : 'company'
                    }
                },
				{
                    label : '建设性质',
                    moveTo : "#",
                    edit : {
                        type : 'text',
                        field : 'property'
                    }
                },
				{
                    label : '建设内容及规模',
                    moveTo : "#",
                    edit : {
                        type : 'textarea',
                        field : 'scale'
                    }
                },
				{
                    label : '建设年限',
                    moveTo : "#",
                    edit : {
                        type : 'text',
                        field : 'term'
                    }
                },
				{
                    label : '计划总投入',
                    moveTo : "#",
                    edit : {
                        type : 'text',
                        field : 'investments'
                    }
                },
				{
                    label : '联系人',
                    moveTo : "#",
                    edit : {
                        type : 'text',
                        field : 'newContactPerson'
                    }
                },
				{
                    label : '联系电话',
                    moveTo : "#",
                    edit : {
                        type : 'text',
                        field : 'newContactPhone'
                    }
                },
				{
                    label : '项目申请指南',
                    rightText : '申请指南',
                    moveTo : "#",
                    edit:{
                        type:'richEdit',
                        field:'content'
                    }
                },
                {
                    label : '公示开始日期',
                    moveTo : "#",
                    edit : {
                        type : 'date',
                        field : 'startReviewDate'
                    }
                },
                {
                    label : '公示截止日期',
                    moveTo : "#",
                    edit : {
                        type : 'date',
                        field : 'endReviewDate'
                    }
                },
                {
                    label : '建设成效',
                    moveTo : "#",
                    edit : {
                        type : 'textarea',
                        field : 'result'
                    }					 
                }],
            };
            this.addLists(option);
            // 附件信息
            this.createEdtAttachList();
            var attachment = {
                columns : [{
                    label : "添加附件",
                    icon : 'images/icon/crmicon.png',
                    iconClass : 'width-16',
                    onClick : function () {
                        this.addAttachment({},true,true);
                    }
                }],
                className : 'fix-footer',
                isFooter : true
            }
            this.addColumns(attachment);
            this.onAfterShow();
        },
        // 依据附件数据刷新附件列表
        refreshAttachList:function(attachs){
            this.attachmentList.destroyDescendants();
            for(var index=0;index<attachs.length;index++){
                this.addAttachment(attachs[index],true,true);
            }
        },
        // 将用户修改、新增的数据保存到数据库
        onSaveStore:function(){
            if(this.isEditing){
                this.isEditing = false;
                var projectData = this.getData();
                projectData.attachs = this.getAttachsFromList();
                var msg=this.validProjectData(projectData);
                if(msg){
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                project.saveProject(projectData).then(lang.hitch(this,function(data){
                    // 保存成功则跳转到项目列表页面
                    if(data.data.ok){
                        history.back();
                    }else{
                        alert("保存失败");
                        this.isEditing = true;
                    }
                }));
            }
        },
        // 验证必填项是否有值
        validProjectData:function(data){
            var msg="";
            if(!data.title){
                msg="标题不能为空!";            
            }else if(!data.startDate){
                msg="申请开始日期不能为空!";
            }else if(!data.endDate){
                msg="申请截止日期不能为空!";
            }
            if(msg){
                return msg;
            }
            /*var startDate = date.formatISODate(data.startDate),
                endDate = date.formatISODate(data.endDate),
                startReviewDate = date.formatISODate(data.startReviewDate),
                endReviewDate = date.formatISODate(data.endReviewDate);
            if(startDate>endDate){
                msg = "申请开始日期不能晚于申请截止日期";
            }else if(startReviewDate<endDate){
                msg = "申请截止日期不能晚于公示开始日期";
            }else if(startReviewDate>endReviewDate){
                msg = "公示截止日期不能晚于公示开始日期";
            }else if(data.attachs&&array.some(data.attachs,function(attach){
                if(!attach.title){
                    msg = "申请材料的名称未填写";
                }else if(!attach.blankUrl){
                    msg = "空白申请文件未选择";
                }else if(!attach.sampleUrl){
                    msg = "申请材料范本未选择";
                }
                return !!msg;
            })){
                //检查附件
            }
            return msg;*/
        }
    });
});