// 创建人：潘云
// 创建时间：2016-05-18
// 功能：平台项目列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "dojo/query",
    "dojo/store/JsonRest",
    "cq/biz/ts/pm/project",
    "dojo/dom-class"
],function(declare,lang,array,View,_ViewMixin,_PrjMixin,query,JsonRest,project,domClass){
    // module:
    //        cq/ui/b/p/PrjDefList
    return declare("cq.ui.b.p.PrjDefList",[View,_ViewMixin,_PrjMixin],{
        listMoveView:"priDefDtl",
        projectStateLabels:{
            0:"等待审核",
            1:"审核通过",
            4:"审核作废",
        },
        onAfterShow:function(){
            if(this.storeList.store){
                this.setQuery()
            }else{
                this.storeList.setStore(this.store,this.getQuery(),{
                    start: 0,
                    count: this.pageSize
                });
            }
            this.refreshData();
        },
        onFirstShow:function(){
            this.addListTitleHeader("项目列表",{
                iconButton : ' ',
                label : "添加",
                onClick : function(){
                    window.moveToView("prjDefEdt");
                }
            });
            option = {
                columns:[{
                    label:'全部',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(-1,evt);
                    })
                },{
                    label:'待审核',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(0,evt);
                    })
                },{
                    label:'已审核',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(1,evt);
                    })
                },{
                    label:'已作废',
                    onClick:lang.hitch(this,function(evt){
                        this.changeState(4,evt);
                    })
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            this.initStoreList();
            this.store = new JsonRest({
                target:project.getLoadProjectUrl()
            });
            domClass.add(query('.tab-selector',this.domNode)[1],"selected");
            this.onAfterShow();
        },
        // 改变标签的样式
        changeLabelClass:function(evnt){
            array.forEach(query(".tab-selector",this.domNode),function(item){
                domClass.remove(item,"selected");
            });
            domClass.add(evnt.target,"selected");
        },
        // 点击table栏的响应事件
        changeState:function(type,evt){
            this.changeLabelClass(evt);
            this.selectedState = type;
            this.setQuery();
        },
        // 刷新list列表的条件
        getQuery:function(){
            var query = {};
			query.orderBy = "-createAt";
            if(!this.selectedState){
                query.state = 0;
            }else if(this.selectedState >= 0){
                query.state = this.selectedState;
            }
            return query;
        },
        // 刷新list列表
        setQuery:function(){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            this.storeList.setQuery(this.getQuery(),{
                start: this.start,
                count: this.pageSize
            });
            this.centerPanel.resize();
        }
    });
});