//创建人：周超   创建时间：2016-5-28  创建事项：项目申请--浏览/详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "cq/biz/ts/pm/project",
    "cq/util/sys/date"
],function(declare,lang,array,domClass,View,_ViewMixin,_PrjMixin,project,date){
    return declare("cq.ui.b.p.PrjDtl",[View,_ViewMixin,_PrjMixin],{
        getDtlState:function(){
            var data = this.getData();
            if(data&&data.startDate&&date.formatISODate(date.nowISOString())<data.startDate){
                return 4;
			}else if(data&&data.startDate&&date.formatISODate(date.nowISOString())>data.endDate){
                return 4;
            }else{
                return this.inherited(arguments);
            }
        },
		
        refreshOperColumn:function(){
            var state = this.getDtlState();
			var dtlOpers = [false,false];
			project.loadMyApply(window.did).then(lang.hitch(this,function(data){
				if(1==state && data&&data.data&&data.data.items&&data.data.items.length){
					//在申报期内，已经申报过
					dtlOpers = [false,true];
				}
				else if(1==state){
					//在申报期内，没有申报过
					dtlOpers = [true,false];
				}
				else if(1!=state && data&&data.data&&data.data.items&&data.data.items.length){
					//不在申报期内，已经申报过
					dtlOpers = [false,true];
				}
				array.forEach(this.dtlOperColumnNode.children,function(node,index){
					domClass[dtlOpers[index]?"remove":"add"](node,"none");
				});
				this.applyDid = data.data&& data.data.items && data.data.items.length && data.data.items[0]._id;
				domClass.remove(this.dtlOperColumnNode,"none");
				this.resize();
			}));
        },
		
        //onAfterShow：
        //        参数：无
        //        返回值：无
        //        初始化相关接口
        onAfterShow:function() {
            this.refreshProjectData();
        },
        //onFirstShow：
        //        参数:无
        //        返回值:无
        //        初始化界面元素
        onFirstShow:function(){
            this.addListTitleHeader("项目详情");
            option = {
                isEdge:true,
                lists:[
                    {label:'项目名称',noArrow:true,rightText:"{{title}}"},
                    {label:'补助环节',noArrow:true,rightText:"{{targetUsage}}"},
                    {label:'申报开始日期',noArrow:true,rightText:'{{startDate}}'},
                    {label:'申报结束日期',noArrow:true,rightText:'{{endDate}}'},
					{label:'申报主体',noArrow:true,rightText:'{{company}}'},
					{label:'建设性质',noArrow:true,rightText:'{{property}}'},
					{label:'建设年限',noArrow:true,rightText:'{{term}}'},
					{label:'申报额度',noArrow:true,rightText:'{{investmentByShop}}万元'},
					{label:'联系人',noArrow:true,rightText:'{{newContactPerson}}'},
					{label:'咨询电话',noArrow:true,rightText:'{{newContactPhone}}'},
                    {label:'项目申请指南',noArrow:true,rightText:'{{content}}',variableHeight:true}
                    //{label:'公示开始日期',noArrow:true,rightText:'{{startReviewDate}}'},
                    //{label:'公示结束日期',noArrow:true,rightText:'{{endReviewDate}}'}
                ],
                data:this.getData()
            };
            this.addLists(option);
            //附件lists
            this.createDtlAttachList();
            option = {
                className: "showNone",
                columns : [{
                    label : '我要申报',
                    className : 'flex2 footer-tab-dark applyFor',
                    onClick : function () {
						//点击后直接生成一条申报数据
						var prjData=this.getData();
						if(Date.now()>new Date(prjData.endDate) || Date.now()<new Date(prjData.startDate)){
							alert("操作失败：不在项目申报期内");
							return;
						}
						var projectItem = {
							projectType:2,
                            title:prjData.title,
                            startDate:prjData.startDate,
							startDateText:prjData.startDate,
                            endDate:prjData.endDate,
							endDateText:prjData.endDate,
                            fromShopId:{
                                _id:project.getShopId()
                            },
                            srcProjectId:prjData._id,
							srcProjectName:prjData.title
						}
						project.saveApply(projectItem).then(lang.hitch(this,function(data){
							// 保存成功则跳转到申报列表页面
							if(data.data.ok){
								alert("申报成功");
								history.back();
							}else{
								alert("申报失败");
							}
						}));
						
                        //调用接口设置审核
                        //window.moveToView("prjApplyEdt","prj_"+window.did);
                    }
                },{
                    label : '我的申报',
                    className : 'flex2 footer-tab-dark showFor',
                    onClick : function () {
                        //调用接口设置审核
                        window.moveToView("prjApplyDtl",this.applyDid);
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.createDtlOperColunm(option);
            this.onAfterShow();
        }
    });
});