// 创建人：潘云
// 创建时间：2016-05-18
// 功能：商家项目列表
define([
    "dojo/_base/declare",
    "dojox/mobile/View",
    "dojo/store/JsonRest",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/p/_PrjMixin",
    "cq/biz/ts/pm/project",
    "cq/util/sys/date"
],function(declare,View,JsonRest,_ViewMixin,_PrjMixin,project,date){
    // module:
    //        cq/ui/b/p/PrjList
    return declare("cq.ui.b.p.PrjList",[View,_ViewMixin,_PrjMixin],{
        // 消费者端项目列表界面，点击进入消费者浏览项目界面
        listMoveView:"prjDtl",
        projectStateLabels:{
            0:"等待审核",
            1:"审核通过",
            4:"审核作废"
        },
        onAfterShow:function(){
            if(this.storeList.store){
                this.setQuery();
            }else{
                this.storeList.setStore(this.store,this.getQuery(),{
                    start: 0,
                    count: this.pageSize
                });
            }
            this.refreshData();
        },
        onFirstShow:function(){
            this.addListTitleHeader("项目列表");
            this.initStoreList();
            this.store = new JsonRest({
                target:project.getLoadProjectUrl()
            });
            this.onAfterShow();
        },
        // 获取查询条件
        getQuery:function(){
            var query = {};
			//按开始申请时间倒序排列
			query.orderBy = "-startDate";
			var data = this.getData();
            if((data&&data.startDate&&data.endDate&&date.formatISODate(date.nowISOString())<data.endDate)){
            // 状态为已审核的
            query.state = 1;
            return query;				
			}
        },
        // 刷新list列表的显示
        setQuery:function(){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            this.storeList.setQuery(this.getQuery(),{
                start: this.start,
                count: this.pageSize
            });
            this.centerPanel.resize();
        }
    });
});