// 变更人：母浚驰
// 变更时间：2016-05-26
// 变更事项：编辑模版
//变更人：张金鹏
//变更时间；2016-06-24
//变更事项：解决编辑状态的问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/EdgeToEdgeCategory",
    "dojox/mobile/ListItem",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/pm/richTextTemp"
],function (declare,lang,array,domClass,domConstruct,Deferred,registry,View,EdgeToEdgeList,EdgeToEdgeCategory,ListItem,_ViewMixin,richTextTemp) {
    //定义弹窗
    var BoxEdit = declare("", [View, _ViewMixin], {
        editPropDef:null,
        //开始编辑界面
        setartEditProp:function(item){
            this.editPropDef = new Deferred();
            this.originItem = item;
            this.setData(lang.clone(item));
            this.refreshData();
            return this.editPropDef;
        },
        indexElement:function(){
            this.inherited(arguments);
            this.addLists({
                isEdge:true,
                lists:[{
                    label : "标题",
                    noArrow : true,
                    edit : {
                        type : "text",
                        field : "replaceTxt",
                        placeHolder : "替换的内容！"
                    }
                },{
                    label : "类型",
                    noArrow : false,
                    moveTo : "#",
                    edit : {
                        type : "options",
                        field : "replaceType",
                        options : {
                            "1" : "文本",
                            "2" : "图片"
                        }
                    }
                }]
            });
            this.addColumns({
                columns : [{
                    label : "确认",
                    onClick : this.onEditPropFinished, //未定义
                    className : "footer-tab-highlight"
                }, {
                    label : "取消",
                    onClick : this.onEditPropCanceled, //未定义,
                    className : "footer-tab-dark"
                }],
                labelClass : 'font-size2',
                className : 'fix-footer',
                isFooter : true
            });
        },
        onEditPropFinished:function(){
            this.editPropDef.resolve(this.getData());
        },
        onEditPropCanceled:function(){
            this.editPropDef.resolve(this.originItem);
        }
    });

    return declare("cq.ui.b.p.RichTextTempDetail", [View, _ViewMixin], {
        // 页面是否处在编辑中，默认值为false
        isEditing : false,
        // 加载数据
        onAfterShow : function () {
            if (!this.isEditing) {
                this.isEditing = true;
                if (!window.did) {
                    this.header.set("label", "新增模版");
                    this.initTempByData({
                        isUse : true,
                        content : "",
                        tempType : "mat"
                    });
                } else {
                    richTextTemp.loadById(window.did).then(lang.hitch(this, function (data) {
                        if (data.data && data.data.ok) {
                            // 显示模版信息
                            this.header.set("label", data.data.item.title);
                            this.initTempByData(data.data.item);
                        }
                    }));
                }
            }
        },
        //依据数据初始化界面显示
        initTempByData:function(data){
            //设置数据并刷新标准页面的显示
            this.setData(data);
            this.refreshData();
            //依据属性列表初始化属性列表的显示
            this.propsList.destroyDescendants();
            //初始化数据属性列表
            data.replaceTxt = data.replaceTxt||[];
            //遍历所有属性，添加到列表中
            array.forEach(data.replaceTxt,function(item){
                this.propsList.addChild(this.getPropItemByData(item));
            },this);
            this.centerPanel.scrollTo({x:0,y:0});
        },
        // 第一次进入页面，初始化页面组件
        onFirstShow : function () {
            // 加载页面头部
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : lang.hitch(this, function () {
                        this.isEditing = false;
                        //window.moveToView("richTextTempList");
                        history.back();
                    })
                },
                title : "新增模版",
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            // 添加详情
            option = {
                isEdge : true,
                class: "bottom-margin16",
                lists : [{
                    label : "主题图片",
                    noArrow : false,
                    imgSize : {
                        width : 640,
                        height : 320
                    },
                    edit : {
                        type : "image",
                        field : "logo"
                    },
                    'class' : "li-icon",
                    moveTo : "#"
                }, {
                    label : '标题',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'title'
                    }
                },/* {
                    label : '模版类型',
                    moveTo : "#",
                    edit : {
                        type : 'options',
                        field : 'tempType',
                        options : {
                            "mat" : "商品"
                        }
                    }
                }, */{
                    label : '内容',
                    rightText : '商品详情',
                    moveTo : "#",
                    edit : {
                        type : "textarea",//'richEdit',
                        field : 'content'
                    }
                },{
                    label : '是否使用',
                    noArrow : true,
                    edit : {
                        type : 'checkbox',
                        field : 'isUse',
                        value : "on"
                    }
                }],
                data : this.getData()
            };
            this.addLists(option);
            //添加更改按钮
            option = {
                columns : [{
                    //按钮名称 肖芳圆 2016-7-24
                    label : "添加自定义项",
                    onClick : lang.hitch(this, function () {
                        //添加一个列表项
                        var item = this.getPropItemByData({});
                        this.propsList.addChild(item);
                        //执行列表项的编辑操作
                        this.onPropItemClick({target:item.labelNode});
                    })
                }],
                labelClass : 'font-size1',
                className : 'padding-top-bottom16',
                isFooter : true
            };
            this.addColumns(option);
            //属性列表标题 肖芳圆 2016-7-24
            var propsListTitle = new EdgeToEdgeCategory({
                label : "自定义项"
            });
            propsListTitle.placeAt(this.centerPanel.containerNode, "last");
            //添加属性列表
            this.propsList = new EdgeToEdgeList();
            this.propsList.placeAt(this.centerPanel.containerNode,"last");
            //侦听属性列表的点击事件，做编辑操作
            this.propsList.on("click",lang.hitch(this,this.onPropItemClick));

            this.onAfterShow();
        },
        //依据数据项生成属性列表项
        getPropItemByData:function(item){
            return new ListItem(this.getItemProp(item));
        },
        getItemProp:function(item){
            return {
                icon:"mblDomButtonRedCircleMinus",
                params:item,
                label:item.replaceTxt||"",
                rightText:item.replaceType==1?"文本":"图片",
                moveTo:"#"
            };
        },
        //属性列表中的一项的点击事件
        onPropItemClick:function(e){
            var dom = e.target,propItem = registry.getEnclosingWidget(e.target);
            //删除条件判断改变 肖芳圆 2016-7-24
            while (dom && !domClass.contains(dom, "mblListItemIcon")) {
                dom = dom.parentNode;
            }
            if(dom){
                //删除
                propItem.destroyRecursive();
            }else{
                //编辑
                this.setartEditProp(propItem.params).then(lang.hitch(this,function(item){
                    propItem.set(this.getItemProp(item));
                    this.hideOverlay();
                }));
            }
        },
        setartEditProp:function(item){
            if(!this.propEditDiv){
                this.propEditDiv = domConstruct.create("div",{
                    style:"height:400px;text-align: left;"
                });
                this.propEditItem = new BoxEdit();
                this.propEditDiv.appendChild(this.propEditItem.domNode);
                setTimeout(lang.hitch(this.propEditItem,this.propEditItem.startup),0);
            }
            this.showInOverlay(this.propEditDiv);
            return this.propEditItem.setartEditProp(item);
        },

        // 将用户修改、新增的数据保存到数据库
        onSaveStore : function () {
            if (this.isEditing) {
                //标记数据保存状态
                window.busy();
                var m = this.getData();
                m.replaceTxt = array.map(this.propsList.getChildren(),function(item){
                    return item.params;
                });
                //保存时处理属性的保存
                this.isEditing = false;
                var msg = this.verify(m);
                if (msg) {
                    //标记数据保存状态
                    window.free();
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                richTextTemp.save(m).then(lang.hitch(this, function (data) {
                    //标记数据保存状态
                    window.free();
                    // 保存成功则跳转到模版列表页面
                    if (data.data.ok) {
                        history.back();
                    } else {
                        alert("保存失败");
                        this.isEditing = true;
                    }
                }));
            }
        },
        // 验证必填项是否有值
        verify : function (data) {
            //检查时，所有属性的名称和类型都不能为空
            var msg = "";
            if (!data.logo) {
                msg = "主题图片不能为空!";
            } else if (!data.title) {
                msg = "标题不能为空!";
            } else if (!data.tempType) {
                msg = "模版类型不能为空!";
            } else if (!data.content) {
                msg = "内容不能为空!";
            }else{
                array.some(data.replaceTxt,function(prop,index){
                    if(!prop.replaceTxt){
                        msg = "第"+(index+1)+"个替换内容没有设置替换标题";
                    }else if(!prop.replaceType){
                        msg = "第"+(index+1)+"个替换内容没有设置替换类型";
                    }else{
                        return false;
                    }
                    return true;
                });
            }
            return msg;
        }
    });
});
