// 变更人：母浚驰
// 变更时间：2016-05-26
// 变更事项：模版列表
//变更人：程磊
//变更时间；2016-06-23
//变更事项：列表界面清单
//变更人：张金鹏
//变更时间；2016-06-24
//变更事项：修改按钮样式、默认图标
 // 变更人:周科吉
 // 变更时间:2016/6/27
 // 变更原因:修复加载过程中临界值显示无数据的问题
// 变更人:徐阿雪
// 变更时间:2016/7/06
// 变更原因:名称修改为商品模板,支持按照模板标题查找

define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "dijit/registry",
    "cq/biz/article/pm/richTextTemp",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
],function(declare, lang, View, EdgeToEdgeStoreList, _ViewMixin, registry, temp, on, when, JsonRest){
    return declare("cq.ui.b.p.RichTextTempList",[View,_ViewMixin],{
        // 加载数据的下标，默认从0开始
        start : 0,
        pageSize:20,
        hideBottom : false,
        totalCount:0,
        // 设置页面内容的url
        url : "",
        // 每次进入页面重新加载数据
        onAfterShow:function(){
            if (this.url === temp.getLoadUrl()) {
                this.setQuery(this.storeList.get("query"),{
                    start: 0,
                    count: this.pageSize
                });
            } else {
                this.url = temp.getLoadUrl();
                // 创建数据源
                this.params={isUse:true};
                this.store = new JsonRest({target:temp.getLoadUrl()});
                // 将数据源赋值给storeList
                 var queryResult = this.storeList.setStore(this.store, this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                // 将数据源赋值给storeList
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        // 第一次进入页面加载页面显示组件
        onFirstShow:function(){
            // 页面头部
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        //window.moveToView("others");
                        history.back();
                    }
                },
                title:"商品模板"
            };
            this.addHeader(option);
            // 搜索框
            
            option = {
                isHeader:true,
                placeHolder:"请输入要查询条件，按回车查询",
                type:"search",
                'class':"cqSearchBox",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        //搜索内容是按照列表的title来模糊查询 徐阿雪 2016/7/6
                        condition.title = this.search;
                        this.setQuery(condition);
                        evt.target.value = "";
                        condition.title = "";
                    }
                })
            };
            this.addTextBox(option);
            // 页面底部按钮
            option = {
                columns:[{
                    label:'添加模板',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:function(){
                        window.moveToView("richTextTempDetail");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            }
            this.addColumns(option);
            // 资讯显示列表
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].title+"</div>";
                        data[i].moveTo="#";
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{_label:"label",logo:"icon", moveTo:"moveTo"}
            });
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        // 设置查询条件
        setQuery : function (query) {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start:this.start,
                count:this.pageSize
            });
            // 将数据源赋值给storeList
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();
        },
        // 模版列表项的点击响应事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("richTextTempDetail",_id);
        },
        // 列表拖动的响应事件，拖动加载更多
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                //使用canLoadMore方法替代原来的方法来判断
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                          var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        }
    });
});