/**
 * Writer 杜飞军
 * Create Time 2016/05/20
 **/
//isEditing的处理
//编辑界面的日期或事件不需要自己转换
//格式(缩进。空格)
//命名。大小写
//语句后的空格
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/discount",
    "cq/util/sys/date"
], function(declare, lang, View, _ViewMixin, disCount, date) {
    // module:
    //        cq/ui/b/s/AddCoupon
    return declare("cq.ui.b.addCoupon", [View, _ViewMixin], {
        // 编辑状态
        isEditing: false,
        onAfterShow: function() {
            // 选择事件后会导致重新请求 判断状态
            if (!this.isEditing) {
                this.isEditing = true;
                if (window.did) {
                    disCount.loadById(window.did).then(lang.hitch(this, function(data) {
                        if (data && data.data.item) {
                            // 活动有效期时间转换
                            //data.data.item.validDate  = date.formatISODate(data.data.item.validDate);
                            this.setData(data.data.item);
                            this.refreshData();
                        }
                    }));
                } else {
                    // 如果页面先通过did进来 再从添加活动入口进来 会有数据 先清空
                    this.setData({ using: true });
                    this.refreshData();
                }
            }
        },
        // 开始页面初始化
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "优惠活动",
                    onClick: lang.hitch(this, function() {
                        this.isEditing = false;
                        history.back();
                    })
                },
                title: "",
                right: {
                    iconButton: ' ',
                    onClick: lang.hitch(this, this.onComplete),
                    label: "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                lists: [{
                    label: "活动名称",
                    rightText: "",
                    edit: {
                        type: "text",
                        field: "title"
                    }
                }, {
                    label: "活动开始时间",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "dateMin",
                        field: "startDate"
                    }
                }, {
                    label: "活动结束时间",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "dateMin",
                        field: "stopDate"
                    }
                }, {
                    label: "发放数量",
                    rightText: "",
                    edit: {
                        type: "text",
                        field: "totalNum"
                    }
                }, {
                    label: "满抵金额",
                    rightText: "",
                    edit: {
                        type: "text",
                        field: "reachAmount"
                    }
                }, {
                    label: "抵用金额",
                    rightText: "",
                    edit: {
                        type: "text",
                        field: "amount"
                    }
                }, {
                    label: "会员领取限额",
                    rightText: "",
                    edit: {
                        type: "text",
                        field: "userQuota"
                    }
                }, {
                    label: "是否使用",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "checkbox",
                        field: "using"
                    }
                }, {
                    label: "是否设置活动奖品",
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "checkbox",
                        field: "isPrize"
                    }
                }, {
                    label: '活动说明',
                    rightText: "",
                    moveTo: "#",
                    edit: {
                        type: "textarea",
                        field: "remark"
                    }
                }]
            };
            this.addLists(option);
            this.onAfterShow();
        },
        // 验证数据
        onVerify: function() {
            this.isEditing = true;
            var data = this.getData(),
                msg = "",
                time = new Date();
            if (!data.title) {
                msg = "活动名称不能为空";
            } else if (!data.startDate) {
                msg = '开始时间必须填写';
            } else if (!data.stopDate) {
                msg = '结束时间必须填写';
            } else if (Date.parse(data.stopDate) < Date.parse(data.startDate || 0)) {
                msg = "活动结束时间不能小于开始时间";
            } else if ((Date.parse(data.startDate) - Date.parse(time)) < 0) {
                msg = "活动开始时间不能小于当前时间";
            } else if ((Date.parse(data.stopDate) - Date.parse(time)) < 0) {
                msg = "活动结束时间不能小于当前时间";
            } else if (parseInt(data.totalNum || 0) < 0 || !(parseInt(data.totalNum) == data.totalNum)) {
                msg = "发放数量不能小于0,并且只能为整数";
            } else if (parseInt(data.reachAmount || 0) < 0 || !(parseFloat(data.reachAmount) == data.reachAmount)) {
                msg = "满抵金额金额不能小于0,并且只能为数字";
            } else if (parseInt(data.amount || 0) <= 0 || !(parseFloat(data.amount) == data.amount)) {
                msg = "抵用金额金额不能小于等于0,并且只能为数字";
            } else if (parseFloat(data.amount || 0) >= parseFloat(data.reachAmount || 0)) {
                msg = "抵用金额必须小于满抵金额";
            } else if (parseInt(data.userQuota) >= parseInt(data.totalNum)) {
                msg = "会员领取限额必须小于发放数量";
            }
            if (data.isPrize) {
                if (parseInt(data.totalNum) || parseInt(data.userQuota)) {
                    msg = "设置为活动奖品时，发行总量、会员限领不可设置";
                }
            }
            if (msg) {
                alert(msg);
                return false;
            } else {
                if (data.distributeType === 1) {
                    data.num = 0;
                } else if (data.distributeType === 0) {
                    if (data.num <= 0) {
                        alert("指定客户,发放优惠券必须大于0");
                        return false;
                    }
                }
                return true;
            }
        },
        // 完成提数据
        onComplete: function() {
            //若处于编辑状态
            //    设置为非编辑状态
            //    若数据不合法：
            //        给出提示
            //        设置为编辑状态
            //        返回
            //    否则
            //        调用接口保存
            //            若保存成功：
            //                切换到列表
            //            否则：设置为编辑状态，给出提示
            if (this.isEditing) {
                var savePost = this.onVerify();
                if (savePost) {
                    var data = this.getData();
                    disCount.save(data).then(lang.hitch(this, function(dataMsg) {
                        if (dataMsg.data.ok === 1) {
                            this.isEditing = false;
                            //window.moveToView("coupon");
                            history.back();
                        } else {
                            alert(dataMsg.data.message);
                        }
                    }));
                }
            }
        },
    });
});
