/**
 * 创建人: 杜飞军
 * 创建时间: 2016-07-06
 * 创建内容: 显示所有管理员
 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/user",
    "cq/biz/shop/shopUser"
], function(declare, lang, on, domStyle, domAttr, query, View, _ViewMixin, user, shopUser) {
    return declare("cq.ui.b.s.AddShopAdmin", [View, _ViewMixin], {
        isEditing: true,
        //  输入密码状态
        isWritePass: true,
        onAfterShow: function() {
            if (this.isEditing) {
                this.isEditing = false;
                this.empty();
                if (window.did) {
                    shopUser.loadById({ userId: window.did }).then(lang.hitch(this, function(data) {
                        if (data.data.ok === 1) {
                            if (data.data.item && data.data.item.userId) {
                                this.setData({ userName: data.data.item.userId.userName, role: data.data.item.role ,pName : data.data.item.userId.pName});
                            } else {
                                alert("数据错误");
                            }
                            this.refreshData();
                        }
                    }));
                }else{
                    this.setData({ role: 0 });
                }
                var node = query("input", this.user.domNode)[0];
                domAttr.set(node, 'readonly',window.did?true:false);
                if(node.updateState){
                    node.updateState();
                }
                this.refreshData();
            }
            if (this.isWritePass) {
                this.isWritePass = false;
                domStyle.set(this.adminShow.domNode, "display", "none");
            }
        },

        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back();
                        this.isEditing = true;
                        this.isWritePass = true;
                    }
                },
                title: "店铺管理员",
                right: {
                    iconButton: ' ',
                    onClick: this.loginSubmit,
                    label: "确定"
                }
            };
            this.addHeader(option);

            option = {
                isEdge: true,
                lists: [{
                    label: '手机号',
                    noArrow: true,
                    edit: {
                        type: 'tel',
                        field: 'userName',
                        placeHolder: '请填写手机号',
                        pattern: "[0-9]*"
                    }
                }],
                class: "top-bottom-margin16"
            };
            this.user = this.addLists(option);
			
            option = {
                isEdge: true,
                lists: [{
                    label: '姓名',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'pName',
                        placeHolder: '必须输入姓名'
                    }
                },{
                    label: '密码',
                    noArrow: true,
                    edit: {
                        type: 'password',
                        field: 'password',
                        placeHolder: '必须输入密码'
                    }
                }, {
                    label: '确认密码',
                    noArrow: true,
                    edit: {
                        type: 'password',
                        field: 'repassword',
                        placeHolder: '必须输入密码'
                    }
                }],
                class: "top-bottom-margin16"
            };
            this.adminShow = this.addLists(option);

            option = {
                isEdge: true,
                lists: [{
                    label: '角色',
                    noArrow: false,
                    rightText: '',
                    moveTo: "#",
                    edit: {
                        type: 'options',
                        field: 'role',
                        options: {
                            '0': '普通管理员',
                            '1': '高级管理员',
                            '2': '采购员',
                            '3': '销售员',
                            '4': '财务'
                        }
                    }
                }],
                class: "top-bottom-margin16"
            };
            this.addLists(option);
            this.onAfterShow();
        },

        empty: function() {
            this.setData({});
            this.refreshData();
        },

        loginSubmit: function() {
            var adminData = this.getData();
            if (!this.isCellPhone(adminData.userName)) {
                alert("请输入11位电话号码");
                return;
            }
            if(adminData.userName){
                adminData.phone = adminData.userName;
            }
            user.checkPlatformUser(adminData.userName).then(lang.hitch(this, function(data) {
                if (data.data.ok === 1) {
                    // 存在则直接加入
                    adminData.userId = data.data.item._id;
                    shopUser.save(adminData).then(lang.hitch(this, function(shopData) {
                        var item = {
                            _id:adminData.userId,
                            pName:adminData.pName,
                            phone:adminData.phone
                        };
                        if(!item.pName||item.pName == "__n"){
                            delete item.pName;
                        }
                        user.save(item);
                        if (shopData.data.ok === 1) {
                            this.isEditing = true;
                            this.isWritePass = true;
                            history.back();
                        } else {
                            alert(shopData.data.msg);
                        }
                    }));
                } else {
                    if (!adminData.password || !adminData.repassword) {
                        alert("没有当前用户,请输入密码创建");
                        domStyle.set(this.adminShow.domNode, "display", "");
                    } else {
                        if (adminData.password !== adminData.repassword) {
                            alert("两次密码不一致");
                        } else {
                            shopUser.save(adminData).then(lang.hitch(this, function(shopData) {
                                if (shopData.data.ok === 1) {
                                    this.isEditing = true;
                                    this.isWritePass = true;
                                    history.back();
                                } else {
                                    alert(shopData.data.msg);
                                }
                            }));
                        }
                    }
                }
            }));
        }
    });
});
