// 创建人：周超
// 创建时间：2016-07-6
// 创建事项：商家注册
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/user/user"    
    ], function (declare, lang, query, View, _ViewMixin, shop, user) {
    // module:
    //      whz/view/SecondaryData
    return declare("cq.ui.b.s.BusinessRegist", [View, _ViewMixin], {
        //      编辑状态
        //onFirstShow：
        //      初始化界面元素
        //      参数：无
        //      返回值：无
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        this.emptyData();
                        history.back();
                    }
                },
                title : "商家注册",
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                lists :
                    [{
                        label : '手机号',
                        noArrow : true,
                        edit : {
                            type : 'tel',
                            field : 'userName',
                            placeHolder : "请填写0-9的数字",
                            pattern: "[0-9]*"
                        },
                        className: "mblListItem userName"
                    },{
                        label : '店铺名称',
                        edit : {
                            type : 'text',
                            field : 'shopName',
                            placeHolder : "请输入店铺名称"
                        }
                    },{
                        label : '密码',
                        edit : {
                            type : 'password',
                            field : 'password',
                            placeHolder : "必填"
                        }
                    },{
                        label : '确认密码',
                        edit : {
                            type : 'password',
                            field : 'passwordConfirm',
                            placeHolder : "与密码保持一致"
                        }
                    }
                ]};
            this.addLists(option);
			this.connect(query(".userName input", this.domNode)[0], "onblur", this.checkePhone);
        },
        //onSaveStore：
        //      参数：无
        //      返回值：无
        //      保存数据
        onSaveStore:function(){
            //var info = this.getData();
            window.busy();
            var checkMsg=this.checkFiled(this.getData());
            if(checkMsg){
                window.free();
                alert(checkMsg);
                return;
            }
			var setDataTo={};
			setDataTo.userName=this.getData().userName;
			setDataTo.shopName=this.getData().shopName;
			setDataTo.password=this.getData().password;            
			shop.createShopNoCode(setDataTo).then(lang.hitch(this, function(data) {
				if(data.data.item.createUser==true){
					window.free();
					alert("注册成功！");
					this.emptyData();
					history.back();
				} else {
					window.free();
					alert("注册失败！");
					this.emptyData();
				}
			}));						
        },
        //检查手机号格式是否正确
        isCellPhone:function(phone){
            return /(^1[3|4|5|7|8][0-9]{9}$)/.test(phone) && phone.length==11;
        },
        //检查手机号是否注册
        checkePhone: function() {
            var phoneName = query(".userName input", this.domNode)[0].value;
			user.checkPlatformUser(phoneName).then(lang.hitch(this, function(data) {
				if (data.data.ok === 1) {
					alert("账号已注册,请重新输入");
                    this.emptyData();
				}
                if (!this.isCellPhone(phoneName)) {
					alert("手机账号格式不对,请重新输入");
                    this.emptyData();
				}
			}));
        },
        // 清空数据
        emptyData: function() {
            this.setData({});
            this.refreshData();
        },
        //checkFiled:
        //      参数:data :object
        //      返回值：msg :String
        //      检查数据填写
        checkFiled : function (data) {
            var msg = "";
            if (!data.userName) {
                msg = "手机号码还没有填写";
                return msg;
            }else if(!data.shopName){
                msg = "店铺名称还没有填写";
                return msg;
            }else if(!data.password){
                msg = "请填写密码";
                return msg;
            }else if(!data.passwordConfirm){
                msg = "确认密码必须填写";
                return msg;
            }else if(data.passwordConfirm!==data.password){
                msg = "确认密码必须与原密码相同";
                return msg;
            }
        }
    });
});