// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
// 变更人员： 母浚驰
// 变更内容： 保存出错修改
// 变更时间： 2016/6/21
//  变更人:冉伟
//  变更时间:2016/6/22
//  变更原因:设置客户端底部图标的高度使其与农企宝底部高度保持一致
// 变更人员：肖芳圆
// 变更时间：2016/6/24
// 变更内容：
//  1.发送修改数据请求的时候给出busy,在请求完成的时候free
//  2.删除保存时,以前版本的历史代码
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-style",
    "dijit/focus",
    "dojox/mobile/View",
    "cq/biz/mk/cs/cShopConfig",
    "cq/ui/view/_ViewMixin"
],function(declare, lang, query, domStyle, focusUtil, View, cShop, _ViewMixin){
    "use strict";
    return declare("cq.ui.b.s.CShop",[View,_ViewMixin],{
        // 是否编辑状态
        isEditing : false,
        // 初始化页面元素,绑定事件
        onFirstShow:function(){
            // 创建头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : lang.hitch(this,function() {
                        this.isEditing = false;
                        history.back();
                    })
                },
                title:"客户分销",
                right :{
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            //分销相关信息
            option = {
                class : "top-bottom-margin16",
                isEdge: true,
                lists: [{
                    label: "背景图片",
                    noArrow: false,
                    class: "li-icon",
                    moveTo : "#",
                    imgSize:{width:640,height:960},
                    edit :{
                        type:"image",
                        field:"bgImg"
                    }
                }]
            };
            this.addLists(option);
            option = {
                class : "top-bottom-margin16",
                isEdge : true,
                lists : [
                {
                    label : '下线奖励',
                    noArrow : true,
                    edit : {type : 'text', field : 'newUserAmt', placeHolder: "未设置"}
                },
                {
                    label : '上线奖励',
                    noArrow : true,
                    edit : {type : 'text', field : 'oldUserAmt', placeHolder: "未设置"}
                },
                {
                    label : '兑换比率',
                    noArrow : true,
                    edit : {type : 'text', field : 'exRate', placeHolder: "未设置"}
                },
                {
                    label:'获取条件',
                    rightText : '',
                    moveTo : "#",
                    //__view_id : this.id,
                    edit:{
                        type:'options',
                        field:'reqType',
                        options:{
                            '0':'注册获取',
                            '1':'购买任意商品',
                            '2':'购买足够商品'
                        }
                    }
                },
                {
                    label : '累计消费',
                    noArrow : true,
                    class:"reqAmt",
                    // edit :{type : 'text', field : 'reqAmt', placeHolder: "获取条件为“购买足够商品”时填写此项,累计消费X元才能获取名片",disabled:true}
                    edit :{type : 'text', field : 'reqAmt', placeHolder: "获取条件为“购买足够商品”时填写此项,累计消费X元才能获取名片"}
                }]
            };
            this.infoList = this.addLists(option);
            // 提成比例相关信息
            option = {
                class : "top-bottom-margin16",
                isEdge : true,
                lists :
                [
                {
                    label : '一级提成比例',
                    noArrow : true,
                    edit : {type : 'text', field : 'rate1', placeHolder: "未设置"}
                },
                {
                    label : '二级提成比例',
                    noArrow : true,
                    edit : {type : 'text', field : 'rate2', placeHolder: "未设置"}
                },
                {
                    label : '三级提成比例',
                    noArrow : true,
                    edit : {type : 'text', field : 'rate3', placeHolder: "未设置"}
                },{
                    label : '是否启用',
                    noArrow : true,
                    edit : {type : 'checkbox', field : 'isUse'}
                }]
            };
            this.addLists(option);
            option = {
                columns : [{
                    icon : 'images/icon/mat.png',
                    /*iconClass:'width-16',*/
                    iconClass:'footer-tab-img',
                    label : '分销客户查询',
                    onClick : function () {
                        window.moveToView("cShopUserList");
                    }
                }],
                valueClass : 'font-size3',
                labelClass : 'font-size1',
                className : 'fix-footer',
                isFooter : true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        //用户选择审核类型时的回调接口函数
        onDataChanged : function(field, oldValue, newValue){
            if(field==="reqType"){
                this.handReqAmt(newValue);
            }
        },
        // 加载数据,并显示到页面上
        onAfterShow:function () {
            // 如果是变更，加载分销信息
            if (!this.isEditing) {
                this.isEditing = true;
                    cShop.loadByShopId().then(lang.hitch(this, function(data) {
                    if(data.data.item){
                        if(data.data.item.reqType){
                            this.handReqAmt(data.data.item.reqType);
                            this.setData(data.data.item);
                        }else {
                            this.setData(data.data.item);
                        }
                    }else {
                        this.setData({reqType:2});
                    }
                    this.refreshData();
                }));
            }
        },
        // 处理累计消费的可编辑问题
        handReqAmt:function(type){
            var lidom = query(".reqAmt",this.infoList.domNode)[0];
            var inputdom = query("input",lidom)[0];
            // 选择的是足够商品时
            if(type === 2||type ==="2"){
                //domAttr.remove(inputdom, "disabled");
                domStyle.set(inputdom, "display", "");
            }else{
                //domAttr.set(inputdom, "disabled","disabled");
                domStyle.set(inputdom, "display", "none");
            }
        },
        // 保存界面信息
        onSaveStore:function(){
            if(this.isEditing){
                //保存操作开始,给出busy状态
                window.busy();
                var m = this.getData();
                this.isEditing = false;
                // 检查必填项是否已填
                var msg=this.verify(m);
                if(msg){
                    window.free();
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                cShop.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok){
                        history.back();
                    }else{
                        alert("保存失败");
                        this.isEditing = true;
                    }
                }));
            }
        },
        // 检查必填项是否已填
        verify:function(data){
            var msg="";
            if(!data.newUserAmt){
                msg="下线奖励必须填写";
            }
            return msg;
        }
    });
});