// 变更人：周超
// 变更时间：2016-06-16
// 变更事项：创建js
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",    
    "dojo/dom-class",
    "dojo/on",
    "dojo/query",
    "dojo/store/JsonRest",
    "dojo/when",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/user",
    "cq/biz/shop/shop"
],function( declare, lang, domConstruct, domClass, on, query, JsonRest, when, registry, View, EdgeToEdgeStoreList, _ViewMixin, user, shop){
    // module:
    //      cq/ui/b/s/CShopUserList
    return declare("cq.ui.b.s.CShopUserList",[View,_ViewMixin],{
        // 加载数据的下标，默认从0开始
        start : 0,
        // 每次加载数据的条数
        pageSize : 20,
        //粉丝数排序变量
        changeFansSort:true,
        //累计收入排序
        changeTotalSort:true,
        // 每次进入页面重新加载数据
        onAfterShow:function(){
            if(this.storeList.store){
                this.setQuery(this.storeList.get("query"));
            }else{
                var queryResult = this.storeList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
            this.refreshData();
        },
        // 第一次进入页面加载页面显示组件
        onFirstShow:function(){
            // 页面头部
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        localStorage.removeItem("fromTrends");
                        //window.moveToView("home");
                        history.back();
                    }
                },
                title:"分销客户查询"
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                lists : [{
                    label : '选择客户',
                    rightText : '',
                    moveTo : "#",
                    edit : {
                        type : 'ref',
                        field : '_id',
                        moveTo : "#",
                        params : {
                            target :user.load(),
                            query : {},
                            searchField : "pName",
                            labelField : "pName"
                        }
                    }
                }]
            };
            //this.addLists(option);
            option = {
                placeHolder:"请输入要查询条件，按回车查询",
                "class":"cqSearchBox",
                isHeader:true,
                type:"search",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        //获取
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.search = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                columns : [{
                    label : '默认排序',
                    onClick : this.changeDefault
                },{
                    label : '按粉丝数排序',
                    onClick : this.changeFansNum
                },{
                    label : '按累计收入排序',
                    onClick : this.changeDisTotal
                }],
                isHeader:true,
                labelClass : 'font-size1 tab-selector'
            };
            this.addColumns(option);
            // 资讯显示列表
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        data[i]._label="<div class='mat-list-margin'>客户昵称："+(data[i].wxNick?data[i].wxNick:"暂无昵称")+"</div>";
                        data[i]._label+="<div class='mat-list-margin'><div style='float: left'>累计收入："+(data[i].disTotalIncome>0?window.fixedTo(data[i].disTotalIncome,3):"0.00")+"</div>";
                        data[i]._label+="<div style='margin-left: 52%'>一级粉丝数："+(data[i].fansNum1>=0?window.fixedTo(data[i].fansNum1 ,1):"")+"</div></div>";
                        data[i]._label+="<div class='mat-list-margin'>";
                        data[i]._label+="<div style='float: left'>二级粉丝数："+(data[i].fansNum2>=0?window.fixedTo(data[i].fansNum2 ,1):"")+"</div>";
                        data[i]._label+="<div style='margin-left: 52%'>三级粉丝数："+(data[i].fansNum3>=0?window.fixedTo(data[i].fansNum3 ,1):"")+"</div></div></div>";
                        data[i]._logo = data[i].disCard ? data[i].disCard : 'images/nomat.png';
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{_label:"label",_logo:"icon", moveTo:"moveTo"}
            });
            // 创建数据源
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.params = {};
            this.store = new JsonRest({target:user.getLoadDisCardUrl()});
            //srcUid:来源客户Id
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        //粉丝数排序变更函数
        getFansSort:function(){
            if(this.params.orderBy == "-fansNum1"){
                this.params.orderBy = "fansNum1";
            }else{
                this.params.orderBy = "-fansNum1";
            }
            this.storeList.destroyDescendants();
            this.setQuery(this.params);
        },
        //累计收入排序变更
        getTotalIncomeSort:function(){
            if(this.params.orderBy = "-disTotalIncome"){
                this.params.orderBy = "disTotalIncome";
            }else{
                this.params.orderBy = "-disTotalIncome";
            }
            this.storeList.destroyDescendants();
            this.setQuery(this.params);
        },
        // 重新赋值列表并刷新显示
        setQuery:function(query){
            this.start = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        //默认排序
        changeDefault:function (evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params = {};
            this.setQuery(this.params);
        },
        //粉丝数
        changeFansNum : function (evt) {
            window.busy();
            this.clearSelected();
            domClass.add(evt.target, "selected");
            //this.params.shopId = user.shopId;
            if(this.changeFansSort==true){
                this.changeFansSort = false;
                this.storeList.destroyDescendants();
                this.setQuery(this.params);
            }else{
                this.getFansSort();
            }
            window.free();
        },
        //累计收入
        changeDisTotal : function (evt) {
            window.busy();
            this.clearSelected();
            domClass.add(evt.target, "selected");
            //this.params.shopId = user.shopId;
            if(this.changeTotalSort==true){
                this.changeTotalSort = false;
                this.params.orderBy = "-disTotalIncome";
                this.setQuery(this.params);
            }else if(this.changeTotalSort == false){
                this.getTotalIncomeSort();
            }
            window.free();
        },
        //清空列表
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        // 列表拖动的响应事件，拖动加载更多
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        }
    });
});