/*
 * 修改人: 杜飞军
 * 修改时间: 2016-06-22
 * 修改内容:
 *       修改密码后完成跳转到上一个页面 不使用window.moveToView
 *       修改原密码和新密码不能一样
 */
define(
    [
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/topic",
        "dojox/mobile/View",
        "cq/ui/view/_ViewMixin",
        "dijit/registry",
        "dojo/_base/xhr",
        "dojo/query",
        "cq/biz/user/user"
    ],
    function(declare, lang, topic, View, _ViewMixin, registry, xhr, query, user) {
        return declare("cq.ui.b.s.ChangePassword", [View, _ViewMixin], {
            //初始化相关接口
            onFirstShow: function () {
                this.setData({});
                var option = {
                    left: {
                        iconButton: ' ',
                        arrow: "left",
                        label: "返回",
                        onClick: function () {
                            this.emptyData();
                            history.back(-1);
                        }
                    },
                    title: "修改密码",
                    right: {
                        iconButton: ' ',
                        onClick: this.changePasswordSubmit,
                        label: "确定"
                    }
                };
                this.addHeader(option);
                option = {
                    isEdge: true,
                    lists: [{
                        label: '原密码',
                        noArrow: true,
                        edit: {
                            type: 'password',
                            field: 'oldPassword',
                            placeHolder: '请填写原密码'
                        }
                    }, {
                        label: '新密码',
                        noArrow: true,
                        edit: {
                            type: 'password',
                            field: 'newPassword',
                            placeHolder: '请填写新密码'
                        }
                    }, {
                        label: '确认密码',
                        noArrow: true,
                        edit: {
                            type: 'password',
                            field: 'confirmPassword',
                            placeHolder: '再输入一次新密码'
                        }
                    }]
                };
                this.addLists(option);
            },
            // 清空数据
            emptyData: function () {
                this.setData({});
                this.refreshData();
            },
            changePasswordSubmit: function () {
                var data = this.getData();
                // 新密码和老密码不能一样
                if (data.oldPassword === data.newPassword) {
                    alert("原密码和新密码不能一样");
                    return;
                }
                if (!this.getData().newPassword || this.getData().newPassword !== this.getData().confirmPassword) {
                    alert("新密码必须输入，且两次输入的密码需一致");
                    return;
                }
                user.changeMchPassword(this.getData().oldPassword, this.getData().newPassword).then(lang.hitch(this, function (result) {
                    if (result.data.ok === 1) {
                        this.emptyData();
                        //window.moveToView("shop");
                        // 返回上一个页面
                        history.back();
                    } else {
                        alert("修改失败，请检查原密码是否正确");
                    }
                }));
            }
        });
    });