//变更人:肖芳圆
//变更时间:2016/5/17
//变更原因:代码规范,文件迁移
//变更人:张金鹏
//变更时间:2016/06/20
//变更原因:消息发送时间越近应该在越下面
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/ListItem",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/date/relative",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/im/msg",
    "dojo/dom-attr",
    "dojo/dom-class"
],function(declare,lang,View,_ViewMixin,query,registry,ListItem,EdgeToEdgeStoreList,
    relativeDate,on,when,JsonRest,msg,domAttr,domClass){
    //客服对话详情列表
    return declare("cq.ui.b.s.Chat",[View,_ViewMixin],{
        //查询开始的序号
        start:0,
        end:-1,
        pageSize:20,
        //重新加载数据
        onAfterShow:function(){
            this.setQuery(this.storeList.get("query"), {
                start: this.start,
                count: this.pageSize
            });
        },
        //初始化页面元素,以及绑定事件
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() { history.back(); }
                },
                title:"客服"
            };
            this.addHeader(option);
            option = {
                placeHolder:"请输入回复内容",
                class:"cqSearchBox",
                type:"search",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        if(!this.search) return;
                        var condition = this.storeList.get("query");
                        condition.mName = evt.target.value;
                        msg.sendToUser({
                            senderId:cq.biz.user.user.userId,
                            receiverId:window.did,
                            msgContent:this.search
                        }).then(lang.hitch(this,function(){
                            this.setQuery(condition);
                            evt.target.value = "";
                        }));
                    }
                })
            };
            this.textBox = this.addTextBox(option);
            this.textBox.placeAt(this._bottomPane.containerNode,"last");
            this._topSplitter.resize();
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<=data.length-1;i++){
                        if(data[i].senderId&&data[i].senderId._id == window.did){
                            data[i]._label="<div>"+data[i].msgContent+
                                "</div><div>"+relativeDate.format(new Date(data[i].createAt))+"</div>";
                            data[i].logo=data[i].senderId&&data[i].senderId.logo;
                        }else{
                            data[i]._label = "";
                            data[i].rightText="<div>"+data[i].msgContent+
                                "</div><div>"+relativeDate.format(new Date(data[i].createAt))+"</div>";
                            data[i].rightIcon2=data[i].senderId&&data[i].senderId.logo;
                        }
                        //new一个ListItem的对象
                        var item = new ListItem({
                        //传入相应的参数
                            label:data[i]._label,
                            icon:data[i].logo,
                            rightText:data[i].rightText,
                            rightIcon2:data[i].rightIcon2,
                            params:data[i]
                        });
                        //调用addChild方法
                        this.storeList.addChild(item,"first");
                    }
                    //this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                    },
                itemMap:{_label:"label", logo:"icon"}
            });
            // 创建数据源
            this.params={userId:window.did};
            this.store = new JsonRest({target:msg.getMsgHistoryUrl()});
            // 将数据源赋值给storeList
            this.storeList.setStore(this.store,this.params);
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            //this.storeList.on("click",lang.hitch(this,this.onClickList));
            on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
        },
        // onClickList:function(evt){
        //     // 得到点击的ListItem
        //     var li = registry.getEnclosingWidget(evt.target);
        //     if(li.declaredClass!="dojox.mobile.ListItem") return;
        //     var _id = li.params._id;
        //     window.moveToView("chat",_id);
        //
        // },
        //下拉加载更多
        onLoadMore:function(evt){
            if(this.busy||(0<this.end&&(this.start+this.pageSize-1>this.end))){
                return true;
            }
            if(evt.beforeTop){
                this.start = this.end+1;
                console.log("加载更多商品");
                this.busy = true;
                setTimeout(lang.hitch(this,function(){
                    when(this.storeList.setQuery(this.storeList.get("query"), {
                        start: this.start,
                        count: this.pageSize
                    }), lang.hitch(this,function(){
                        this.centerPanel.resize();
                    }));
                }), 1000);
            }
        },
        //加载数据
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            query.userId = window.did;
            this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            this.centerPanel.resize();
        }
    });
});