/**
 * Writer 杜飞军
 * Create Time 2016/05/20
 **/
//包含依赖的模块的顺序：dojo/_base,dojo其他模块，dijit，dojox，cq，whz，需要require但是本对象不直接使用的模块
//同级别的模块，按照字符顺序升序排列
//页面状态的处理机制
//大量使用生僻字
//词不达意
//class没有使用标准class
//方法的功能不完整
//依赖的模块看起来混乱
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/query",
    "dojo/on",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "cq/biz/mk/discount"
], function(declare, lang, JsonRest, domClass, query, on, registry, View, EdgeToEdgeStoreList, _ViewMixin, date, disCount) {
    // module:
    //        cq/ui/b/s/Coupon
    return declare("cq.ui.b.s.coupon", [View, _ViewMixin], {
        //为列表设置的数据开始默认值
        start: 0,
        pageSize: 10,
        onAfterShow: function() {
            if (!this.store) {
                this.storeList.setStore(this.store = new JsonRest({
                    target: disCount.getLoadUrl()
                }), {
                    count: 20
                });
                domClass.add(query('.tab-selector', this.selectBox)[0], "selected");
            } else {
                this._selectTabAndFetch(query(".tab-selector", this.selectBox)[0], 0);
            }
        },
        // 开始页面初始化
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        //window.moveToView("others");
                        history.back();
                    }
                },
                title: "优惠活动"
            };
            this.addHeader(option);
            option = {
                isHeader: true,
                columns: [{
                    label: '全部',
                    onClick: lang.hitch(this, this.fetchUnverified)
                }, {
                    label: '未开始',
                    onClick: lang.hitch(this, this.fetchVerified)
                }, {
                    label: '进行中',
                    onClick: lang.hitch(this, this.fetchGenerated)
                }, {
                    label: '已结束',
                    onClick: lang.hitch(this, this.fetchStoped)
                }],
                labelClass: 'font-size1 tab-selector'
            };
            this.selectBox = this.addColumns(option);
            // option = {
            //     columns: [{
            //         label: '活动名称',
            //     }, {
            //         label: '活动有效期',
            //     }, {
            //         label: '状态',
            //     }, {
            //         label: '优惠券信息'
            //     }],
            //     labelClass: 'font-size1 tab-selector'
            // };
            // this.addColumns(option);
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight: true,
                //获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    var time = new Date();
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div class='column-1 inline-block  col' style='width:70%;'>" + data[i].title + "</div>" +
                            "<div class='column-1 inline-block  col' style='width:30%;text-align:center'>" + this.getCheckLabel(data[i].using, data[i].startDate, data[i].stopDate) + "</div>" +
                            "<div class='column-1 col' > 活动期限: " + date.formatISODateMinutes(data[i].startDate) + '~' + date.formatISODateMinutes(data[i].stopDate) + "</div>" +
                            "<div class='column-1 inline-block  col' style='width:70%' > 满 " + window.fixedTo(data[i].reachAmount, 3) + '元抵' + window.fixedTo(data[i].amount, 3) + '元，总发放量' + data[i].totalNum + "张</div>";   
                    if ((Date.parse(date.formatISODateMinutes(data[i].startDate)) - Date.parse(time)) < 0) {
                        data[i]._label += "<div class='column-1 inline-block  col lookCoupon' style='width:30%;text-align:center;line-height:16px;'>" + '查看优惠券' + "</div>";
                    }

                    }

                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                    query(".lookCoupon", this.domNode).on('click', function(e) {
                        this.isEditing = false;
                        var dom = registry.getEnclosingWidget(e.target);
                        window.moveToView('lookCountSer', dom.params._id);
                    });
                }),
                itemMap: { _label: "label", logo: "icon" }
            });
            // 监控couList的点击
            this.storeList.on("click", lang.hitch(this, this.onCouponListClick));
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            //绑定事件--加载更多
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            // 添加底部功能
            option = {
                columns: [{
                    label: '添加活动',
                    onClick: function() {
                        window.moveToView("addCoupon");
                    }
                }],
                labelClass: 'font-size1 tab-selector',
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        fetchUnverified: function(e) {
            this._selectTabAndFetch(e.target);
        },
        fetchVerified: function(e) {
            this._selectTabAndFetch(e.target, 1);
        },
        fetchGenerated: function(e) {
            this._selectTabAndFetch(e.target, 2);
        },
        fetchStoped: function(e) {
            this._selectTabAndFetch(e.target, 3);
        },
        _selectTabAndFetch: function(node, state) {
            this.clearSelected();
            var condition = {};
            if (node) {
                domClass.add(node, "selected");
                if (state) {
                    condition.state = state;
                }
            }
            this.setQuery(condition);
        },
        clearSelected: function() {
            var items = query('.tab-selector', this.selectBox);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        // 设置查询条件
        setQuery: function(query) {
            this.storeList.destroyDescendants();
            this.start = 0;
            this.end = -1;
            this.storeList.setQuery(query, {
                start: this.start,
                count: 20
            });
            this.centerPanel.resize();
        },
        // 审核处理
        getCheckLabel: function(using, startDate, stopDate) {
            var state = "";
            var time = new Date();
            var start = Date.parse(time) - Date.parse(startDate);
            var stop = Date.parse(stopDate) - Date.parse(time);
            if (!using) {
                return '未启用';
            } else if (start < 0) {
                return '未开始';
            } else if (start > 0 && stop > 0) {
                return '进行中';
            } else if (stop < 0) {
                return '已结束';
            }
        },
        // 状态处理
        getStatusLabel: function(status) {
            var statusLabel = "";
            if (status === 0) {
                statusLabel = "没有审核不可用";
            } else if (status === 1 || status === 2) {
                statusLabel = "可用";
            } else if (status === 4) {
                statusLabel = "已停用";
            }
            return statusLabel;
        },
        // couList的事件
        onCouponListClick: function(e) {
            // 查看当前的内容 传递参数
            var li = registry.getEnclosingWidget(e.target);
            if (e.target && domClass.contains(e.target, "lookCoupon")) return;
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("selectCoupon", _id);
        },
        //加载更多，参数evt，返回值：无
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function() {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult, this.start, this.pageSize);
                    }), 1000);
                }
            }
        }
    });
});
