// 创建人：张金鹏
// 创建时间：2016-09-06
// 创建内容：商家端回复评价列表
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
	"dojo/dom-style",
	"dojo/query",
    "dojo/on",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojox/mobile/Rating",
    "cq/biz/article/ss/comment",
    "cq/biz/mat/mat",
	"cq/util/sys/date",
	"cq/ui/view/_ViewMixin",
], function(declare, lang, array, domClass, domStyle, query, on, JsonRest, registry, View, EdgeToEdgeStoreList, Rating, comment, mat, date, _ViewMixin){
	return declare("whz.view.EvaListb",[View,_ViewMixin],{
		start : 0,
		pageSize : 7,
		isReply : false,
		onAfterShow:function(){
			this.scores = [];
			if (this.storeList.store) {
				this.setQuery(this.storeList.get("query"));
			}else{
                this.store = new JsonRest({
                    target:comment.getLoadUrl()
                });
				var queryResult = this.storeList.setStore(this.store,this.getQuery(),{
					start: this.start,
					count: this.pageSize
				})
				this.onLoadListData(queryResult,this.start,this.pageSize);
			}
			//this.refreshData();
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
                        history.back();
                        
					}
				},
				title:"商品评价"
			};
			this.addHeader(option);
			//添加评论的分页
			option = {
                isHeader:true,
                columns : [{
                        label : '未回复',
                        onClick : this.noReply
                    },{
                        label : '已回复',
                        onClick : this.onReply
                    }
                ],
                labelClass : 'font-size1 tab-selector'
            };
            this.conditMenus = this.addColumns(option);
			// 添加评论列表
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				"class":"icon-list-item",
				variableHeight:true,
				//获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){
                    //在读取到商品数据还没读取完就开始走下一个for循环
					for(var i=0;i<data.length;i++){
                        // 保存评价等级信息
                        this.scores.push(data[i].score);
						data[i]._label = "";
						//订单编号
						data[i]._label +=(data[i].commentId._id)?("<div class='commentid'>[订单编号]"+data[i].commentId._id+"</div>"):"";
                        //商品名
                        data[i]._label +="<div class='userInfo'>[商品名]"+data[i].commentId.mName+"<div class='ratingdiv'></div></div>";
						//logo
						data[i]._label +=(data[i].commentId.logo)?("<img src='"+(data[i].commentId.logo)+"' style='height:60px'>"):"";
						//评价内容
						data[i]._label +=(data[i].content)?("<div class='userEva font-size1'>[评价内容]"+((data[i].content)||("&nbsp"))+"</div>"):"";
                        /* if(data[i].images){
							data[i]._label += "<div class='evalimages'>";
							array.forEach(data[i].images,function(image){
								data[i]._label += "<img src='"+image+"'>";
							});
							data[i]._label += "</div>";
						} */
                        //评价时间
                        data[i]._label += "<div class='evaDate'>[评价时间]"+(date.formatISODateMinutes(data[i].createAt))+"</div>";
                        //追加评价的内容
                        data[i]._label += (data[i].superadditionContent)?("<div class='font-size1' >[追加评价]"+(data[i].superadditionContent)+"</div>"):"";
                        //回复评价
                        data[i]._label += (data[i].recoveryContent)?("<div class='font-size1' style='float:right; clear:both; background-color:rgb(248,248,248)'>[商家回复]"+(data[i].recoveryContent)+"</div>"):"";
                        //按钮：商家回复，修改评论暂时放着
                        data[i]._label += (data[i].recoveryContent)?"":("<span class='edit-car-comment addContent' style='float:right'>商家回复</span>"); 
					}
					this.storeList.generateList(data);
					this.setRadio();
					this.busy = false;
				}),
				queryOptions: {
					count: this.pageSize,
					start: this.start
				},
				itemMap:{_label:"label"}
			});
			
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
			this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
            this.on("click",lang.hitch(this,this.onContentClick));
			this.onAfterShow();
		},
		//清除tab页的选中样式    张金鹏
		clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
		//未回复的点击事件    张金鹏
		noReply:function(evt){
			this.clearSelected();
			domClass.add(evt.target, "selected");
            this.isReply = false;
            this.setQuery();
		},
		//已回复的点击事件    张金鹏
		onReply:function(evt){
			this.clearSelected();
			domClass.add(evt.target, "selected");
			this.isReply =true;
            this.setQuery();
		},
        onContentClick:function(evt){
            //var targ = query(".addContent",this.domNode)[0];
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            var isClickDet = domClass.contains(evt.target, "addContent");
            if(isClickDet){
                if(li.declaredClass!="dojox.mobile.ListItem") return;
                window.moveToView('evab',li.params._id);
            }
        },
		// 加载商品的评论等级
		setRadio:function(){
			var lis = query("li",this.storeList.domNode);
			for(var i = this.start;i<lis.length;i++){
				var lidiv = query("div",lis[i])[0];
				var userInfoDiv = query(".userInfo",lidiv)[0];
				var radioDiv = query(".ratingdiv",userInfoDiv)[0];
				this.createRating(radioDiv,this.scores[i]);
			}
		},
		// 创建星级评论
		createRating:function(domNode,score){
			var scoreWidget = new Rating({
                image: "/static/common/images/star-orange.png",
                numStars: 5,
                value: score
            });
			domNode.appendChild(scoreWidget.domNode);
		},
		onLoadMore : function(evt){
			if(!this.busy && evt.afterBottom){
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
						var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
                
            }
		},
		getQuery : function(){
			var query = {};
			if(window.did){
				query.commentId = window.did;
			}
			query.isReply = this.isReply;
            query.withMat = 1;
			query.commentType = "mat";
			query.orderBy = "-lastMod";
			return query;
		},
		setQuery : function(){
			this.start = 0;
            this.end = -1;
            this.totalCount = 0;
			this.storeList.destroyDescendants();
			// 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(this.getQuery(), {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
		}
	});
});
