/**
 * 创建人：杜飞军
 * 创建时间：2016/08/10
 * 创建内容：
 *     输入需要的字段内容
 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/freightTemplate",
    "cq/ui/util/districtOverlay"
], function(declare, lang, array, Deferred, domConstruct, domAttr, domClass, query, registry, View, EdgeToEdgeList, ListItem, _ViewMixin, freightTemplate, districtOverlay) {
    /*
    {
        title: {
            type: String,
            required: true
        },
        minQty: {
            type: Number,
            set: utils.toFixed0Number,
            get: utils.toFixed0Number,
            default: 0,
            required: true
        },
        minFee: {
            type: Number,
            set: utils.toFixed2Number,
            get: utils.toFixed2Number,
            default: 0,
            required: true
        },
        incQty: {
            type: Number,
            set: utils.toFixed0Number,
            get: utils.toFixed0Number,
            default: 0,
            required: true
        },
        incFee: {
            type: Number,
            set: utils.toFixed2Number,
            get: utils.toFixed2Number,
            default: 0,
            required: true
        },
        exceptions: [{
            provinceId: 
            cityId: 
            countyId: 
            minQty: 
            minFee: 
            incQty: 
            incFee: 
        }]
    }
    */
    var AttrEditor = declare("", [View, _ViewMixin], {
        currentDef: null,
        //开始编辑
        startEdit: function(data) {
            this.startup();
            data = data || {};
            data.minQty = data.minQty || 1,
                data.minFee = data.minFee,
                data.incQty = data.incQty || 1,
                data.incFee = data.incFee;
            this.setData(data);
            this.refreshData();
            this.currentDef = new Deferred();
            return this.currentDef;
        },
        //初始化选择器
        indexElement: function() {
            var option = {
                isEdge: true,
                title: "模板信息",
                class: "top-bottom-margin16",
                lists: [{
                    label: '首件',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'minQty',
                        placeHolder: "填写首件数量"
                    }
                }, {
                    label: '首费',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'minFee',
                        placeHolder: "填写首件运送价格"
                    }
                }, {
                    label: '续件',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'incQty',
                        placeHolder: "填写续件数量"
                    }
                }, {
                    label: '续费',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'incFee',
                        placeHolder: "填写续件费用"
                    }
                }]
            };
            this.addLists(option);
            option = {
                columns: [{
                    label: "确认",
                    onClick: lang.hitch(this, this.verify),
                    className: "footer-tab-dark flex2 noverify"
                }, {
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                    }),
                    className: "footer-tab-highlight flex2 noverify"
                }],
                labelClass: 'font-size2 flex1',
                className: 'fix-footer',
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(option);
        },
        // 保存前数据检测
        verify: function() {
            var data = this.getData();
            var reg = /^\+?[1-9][0-9]*$/;
            if (data.minQty < 1 || !reg.test(data.minQty)) {
                alert('例外城市首件数量不能小于1,并且只能为整数');
                return false;
            } else if (data.minFee < 0 || !(parseFloat(data.minFee) == data.minFee)) {
                alert('例外城市首件费用不能小于0,并且只能为数字');
                return false;
            } else if (data.incQty < 1 || !reg.test(data.incQty)) {
                alert('例外城市续件数量不能小于1,并且只能为整数');
                return false;
            } else if (data.incFee < 0 || !(parseFloat(data.incFee) == data.incFee)) {
                alert('例外城市续件费用不能小于0,并且只能为数字');
                return false;
            } else {
                this.currentDef.resolve(data);
            }
        }
    });

    return declare('cq.ui.b.s.FreightDetail', [View, _ViewMixin], {
        // 例外城市数据
        exceptions: [],
        // 添加而外城市状态
        addExceptioned: false,
        isEditing: true,
        onAfterShow: function() {
            // 优先清除额外城市
            if (this.isEditing) {
                this.isEditing = false;
                if (this.expectionsList) {
                    this.expectionsList.destroyDescendants();
                }
                if (window.did) {
                    freightTemplate.loadById(window.did).then(lang.hitch(this, function(data) {
                        if (data.data.ok === 1) {
                            if (data.data.item.exceptions.length > 0) {
                                this.createException(data.data.item.exceptions);
                            }
                            this.setData(data.data.item);
                            this.refreshData();
                        }
                    }));
                } else {
                    this.setData({});
                    this.refreshData();
                }
            }
        },

        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        this.isEditing = true;
                        history.back();
                    }
                },
                right: { iconButton: ' ', onClick: this.onSaveStore, label: "完成" },
                title: "管理运费"
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                title: "模板信息",
                class: "top-bottom-margin16",
                lists: [{
                    label: '标题',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'title',
                        placeHolder: "填写模版标题"
                    }
                }, {
                    label: '首件',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'minQty',
                        placeHolder: "填写首件数量"
                    }
                }, {
                    label: '首费',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'minFee',
                        placeHolder: "填写首件运送价格"
                    }
                }, {
                    label: '续件',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'incQty',
                        placeHolder: "填写续件数量"
                    }
                }, {
                    label: '续费',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'incFee',
                        placeHolder: "填写续件费用"
                    }
                }]
            };
            this.mustFreight = this.addLists(option);

            this.expectionsList = new EdgeToEdgeList();
            this.expectionsList.placeAt(this.centerPanel.containerNode, "last");
            // 添加额外城市
            this.connect(this.expectionsList.containerNode, 'onclick', this.onExpectionClick);
            // 底部添加按钮
            option = {
                columns: [{
                    label: "添加例外城市运费",
                    className: 'flex2 footer-tab-highlight noverify',
                    onClick: function() {
                        this.addException();
                    }
                }],
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },

        // 进入界面存在exceptions创建
        createException: function(args) {
            array.forEach(args, lang.hitch(this, function(item) {
                this.addException(item);
            }));
        },

        addException: function(params) {
            params = params || {};
            var label = this.getExpectionLabelByData(params);
            var listItem = new ListItem({
                label: label,
                rightText: "<span class='attachment-cancel'>删除</span>",
                variableHeight: true,
                params: { data: params }
            });
            this.expectionsList.addChild(listItem);

            //若新增，自动弹出选择区划的界面
            if (!params.provinceId) {
                this.selectDistrict(listItem);
            }
        },
        // 为ListItem添加事件
        onExpectionClick: function(evt) {
            var target = evt.target;
            // 获得点击的组件
            var listItem = registry.getEnclosingWidget(target);
            if (listItem.declaredClass != "dojox.mobile.ListItem") return;
            while (target && target.parentNode != listItem.labelNode && target.parentNode != listItem.domNode) {
                target = target.parentNode;
            }
            if (target) {
                if (domClass.contains(target, "selectorDir")) {
                    //选择例外城市
                    this.selectDistrict(listItem, listItem.params);
                } else if (domClass.contains(target, "selectorEdit")) {
                    // 显示内容填写
                    this.showAttrEditor(listItem);
                } else if (domClass.contains(evt.target, "attachment-cancel")) {
                    // 移除这个对象
                    listItem.destroyRecursive();
                }
            }
        },

        // 依据数据 获得文本内容
        getExpectionLabelByData: function(data) {
            var label = "";
            if (data && data.provinceId) {
                label = "<div class='selectorDir' style='line-height:30px'>选择地区:&nbsp" +
                    "<span>" + this.getDistrictLabel(data) +
                    "</span> </div>";
            } else {
                label = "<div class='selectorDir' style='line-height:30px'>选择地区:&nbsp<span></span> </div>";
            }
            if (data && data.minQty) {
                label += "<div class='selectorEdit' style='line-height:30px'>设置费用:" +
                    "<span>" + '首件:' + data.minQty + '首费:' + window.fixedTo(data.minFee, 3) + '续件:' + data.incQty + '续费:' + window.fixedTo(data.incFee, 3) + "</span> </div>";
            } else {
                label += "<div class='selectorEdit' style='line-height:30px'>设置费用:<span></span> </div>";
            }
            return label;
        },
        getDistrictLabel: function(data) {
            return data.provinceId.distName + (
                data.cityId ? (
                    "," + data.cityId.distName + (
                        data.countyId ? "," + data.countyId.distName : ""
                    )
                ) : ""
            );
        },

        // 选择区域
        selectDistrict: function(listItem, params) {
            params = params && params.data && params.data.provinceId && { province: params.data.provinceId, city: params.data.cityId, county: params.data.countyId } || '';
            //选择完区划之后，自动弹出填写运费的对话框
            districtOverlay.selectDistrict(params,true).then(lang.hitch(this, function(data) {
                if (data.province) {
                    listItem.params.data.provinceId = data.province;
                    listItem.params.data.cityId = data.city;
                    listItem.params.data.countyId = data.county;
                    listItem.set("label", this.getExpectionLabelByData(listItem.params.data));
                    if (!(0 <= listItem.params.data.minQty)) {
                        this.showAttrEditor(listItem);
                    }
                }
            }));
        },
        // 显示编辑运费的视图
        showAttrEditor: function(listItem) {
            if (!this.attrEditorDiv) {
                this.attrEditor = new AttrEditor();
                this.attrEditorDiv = domConstruct.create("div", {
                    style: "height:400px;text-align: left;"
                });
                this.attrEditor.placeAt(this.attrEditorDiv);
            }
            this.showInOverlay(this.attrEditorDiv);
            listItem.params.data.minQty = listItem.params.data.minQty || 1;
            listItem.params.data.minFee = listItem.params.data.minFee;
            listItem.params.data.incQty = listItem.params.data.incQty || 1;
            listItem.params.data.incFee = listItem.params.data.incFee;
            this.attrEditor.startEdit(listItem.params.data).then(lang.hitch(this, function(data) {
                this.hideOverlay();
                if (data) {
                    lang.mixin(listItem.params.data, data);
                    listItem.set("label", this.getExpectionLabelByData(listItem.params.data));
                }
            }));
        },

        // 获得增加的数据
        getAttrs: function() {
            return array.map(this.expectionsList.getChildren(), function(listItem) {
                return listItem.params.data;
            });
        },

        // 保存处理
        onSaveStore: function() {
            if (this.verify()) {
                window.busy();
                var sData = this.getData();
                sData.exceptions = this.getAttrs();
                freightTemplate.save(sData).then(lang.hitch(this, function(data) {
                    if (data.data.ok === 1) {
                        window.free();
                        this.isEditing = true;
                        history.back();
                    } else {
                        window.free();
                        alert(data.data.message);
                    }
                }));
            }
        },

        // 保存前数据检测
        verify: function() {
            var data = this.getData();
            var exceptions = this.getAttrs();
            var reg = /^\+?[1-9][0-9]*$/;
            if (!data.title) {
                alert('标题不能为空');
            } else if (data.minQty < 1 || !reg.test(data.minQty)) {
                alert('首件数量不能小于1,并且只能为整数');
                return false;
            } else if (data.minFee < 0 || !(parseFloat(data.minFee) == data.minFee)) {
                alert('首件费用不能小于0,并且只能为数字');
                return false;
            } else if (data.incQty < 1 || !reg.test(data.incQty)) {
                alert('续件数量不能小于1,并且只能为整数');
                return false;
            } else if (data.incFee < 0 || !(parseFloat(data.incFee) == data.incFee)) {
                alert('续件费用不能小于0,并且只能为数字');
                return false;
            } else {
                if (exceptions.length > 0) {
                    if (this.verifyExcep(exceptions)) {
                        return true;
                    }
                } else {
                    return true;
                }
            }
        },

        // 检测额外的数据合法性
        verifyExcep: function(data) {
            var reg = /^\+?[1-9][0-9]*$/;
            for (var e = 0; e < data.length; e++) {
                if (!data[e].provinceId) {
                    alert('例外城市没有选择省城');
                    return false;
                } else if (data[e].minQty < 1 || !reg.test(data[e].minQty)) {
                    alert('例外城市首件数量不能小于1,并且只能为整数');
                    return false;
                } else if (data[e].minFee < 0 || !(parseFloat(data[e].minFee) == data[e].minFee)) {
                    alert('例外城市首件费用不能小于0,并且只能为数字');
                    return false;
                } else if (data[e].incQty < 1 || !reg.test(data[e].incQty)) {
                    alert('例外城市续件数量不能小于1,并且只能为整数');
                    return false;
                } else if (data[e].incFee < 0 || !(parseFloat(data[e].incFee) == data[e].incFee)) {
                    alert('例外城市续件费用不能小于0,并且只能为数字');
                    return false;
                }
            }
            if (this.hasVerifyCity(data)) {
                return true;
            }
            return false;
        },
        // 检测城市是否有相同的
        hasVerifyCity: function(data) {
            var handledDistrict = {};
            return !array.some(data, function(district) {
                district.cityId = district.cityId || null;
                district.countyId = district.countyId || null;
                var districtId = district.provinceId._id + "-" + (district.cityId && district.cityId._id) + "-" + (district.countyId && district.countyId._id);
                if (handledDistrict[districtId]) {
                    alert(handledDistrict[districtId] + " 只能设置一个运费规则");
                    return true;
                } else {
                    handledDistrict[districtId] = this.getDistrictLabel(district);
                }
            }, this);

            // var city = [];
            // array.forEach(data, function(item) {
            //     if (item.cityId) {
            //         city.push({ cityId: item.cityId._id || item.cityId, countyId: item.countyId && item.countyId._id || item.countyId });
            //     } else {
            //         lang.isObject(item.provinceId) ? city.push({ provinceId: item.provinceId._id + '全市' }) : city.push({ provinceId: item.provinceId + '全市' });
            //     }
            // });
            // var sortBy = function(filed, rev, primer) {
            //     rev = (rev) ? -1 : 1;
            //     return function(a, b) {
            //         a = a[filed];
            //         b = b[filed];
            //         if (typeof(primer) != 'undefined') {
            //             a = primer(a);
            //             b = primer(b);
            //         }
            //         if (a < b) {
            //             return rev * -1;
            //         }
            //         if (a > b) {
            //             return rev * 1;
            //         }
            //         return 1;
            //     };
            // };
            // city = city.sort(sortBy('cityId', false, String));
            // for (var e = 0; e < city.length; e++) {
            //     if ((city[e].countyId || '') == ((city[e + 1] && city[e + 1].countyId) || '')) {
            //         if ((city[e].cityId || '') == ((city[e + 1] && city[e + 1].cityId) || '')) {
            //             alert('相同地区只能设置一个');
            //             return false;
            //         }
            //     }
            // }
            // return true;
        }
    });
});
