/**
 * Writer 杜飞军
 * Create Time 2016/05/25
 **/
define([
    "dojo/_base/declare",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-construct",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/store/JsonRest",
    "cq/biz/mk/discountCoupon",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/on"
], function(declare, View, _ViewMixin, lang, query, domConstruct, EdgeToEdgeStoreList, JsonRest, discountCoupon, registry, array, domClass, on) {
    // module:
    //        cq/ui/b/s/LookCountSer
    return declare("cq.ui.b.LookCountSer", [View, _ViewMixin], {
        //为列表设置的数据开始默认值
        start: 0,
        pageSize: 10,
        onAfterShow: function() {
            if (!this.store) {
                this.store = new JsonRest({
                    target: discountCoupon.getLoadUrl(),
                });
                this.store.discountId = window.did;
                this.storeList.setStore(this.store, {
                    discountId: window.did,
                    count: 20
                });
                domClass.add(query('.tab-selector', this.selectBox)[0], "selected");
            } else {
                this._selectTabAndFetch(query(".tab-selector", this.selectBox)[0], 0);
            }
            this.getInfoEvent();
        },
        onFirstShow: function() {
            var options = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "优惠活动",
                    onClick: lang.hitch(this, function() {
                        history.back();
                    })
                },
                title: ""
            };
            var showHead = this.addHeader(options);
            // 创建切换
            options = {
                columns: [{
                    label: '全部',
                    className: 'sweepstakes',
                    onClick: lang.hitch(this, this.fetchNotUsed)
                }, {
                    label: '已发放',
                    className: 'sweepstakes',
                    onClick: lang.hitch(this, this.fetchHasUsed)
                }, {
                    label: '待支付',
                    className: 'sweepstakes',
                    onClick: lang.hitch(this, this.fetchNoPay)
                }, {
                    label: '已使用',
                    className: 'sweepstakes',
                    onClick: lang.hitch(this, this.fetchUsed)
                }],
                labelClass: 'font-size1 tab-selector',
                isHeader: true
            };
            this.selectBox = this.addColumns(options);
            // 创建显示内容
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight: true,
                //获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div class='column-2 inline-block  col' style='width:50%;text-align:center'>" + data[i]._id + "</div>" +
                            "<div class='column-2 inline-block  col' style='width:50%;text-align:center'>" + this.getSateView(data[i].state) + "</div>";
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                itemMap: { _label: "label", logo: "icon" }
            });
            // 监控couList的点击
            this.storeList.on("click", lang.hitch(this, this.onCouponListClick));
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            //绑定事件--加载更多
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        // 获得状态显示
        getSateView: function(it) {
            var view = "";
            if (!it) {
                view = "未使用";
            } else if (it === 1) {
                view = "已发放";
            } else if (it === 2) {
                view = "待支付";
            } else if (it === 3) {
                view = "已使用";
            }
            return view;
        },
        // 没有使用的优惠券
        fetchNotUsed: function(e) {
            this._selectTabAndFetch(e.target);
        },
        // 已经发放的优惠券
        fetchHasUsed: function(e) {
            this._selectTabAndFetch(e.target, 1);
        },
        // 待支付
        fetchNoPay: function(e) {
            this._selectTabAndFetch(e.target, 2);
        },
        // 已经使用
        fetchUsed: function(e) {
            this._selectTabAndFetch(e.target, 3);
        },
        // 停用
        // fetchStoped: function(e) {
        //     this._selectTabAndFetch(e.target, 4);
        // },
        // 选择显示
        _selectTabAndFetch: function(node, state) {
            this.clearSelected();
            var condition = {};
            condition.discountId = window.did;
            if (node) {
                domClass.add(node, "selected");
                if (state) {
                    condition.state = state;
                }
            }
            this.setQuery(condition);
        },
        clearSelected: function() {
            var items = query('.tab-selector', this.selectBox);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        setQuery: function(query) {
            this.storeList.destroyDescendants();
            this.start = 0;
            this.end = -1;
            this.storeList.setQuery(query, {
                start: this.start,
                count: 20,
                discountId: window.did
            });
            this.centerPanel.resize();
        },
        // 信息查看事件
        getInfoEvent: function() {
            query(".userInfo", this.storeList.domNode).forEach(lang.hitch(this, function(item) {
                on(item, "click", this.moveUserInfo);
            }));
            query(".shopInfo", this.storeList.domNode).forEach(lang.hitch(this, function(item) {
                on(item, "click", this.moveShopInfo);
            }));
        },
        // 移动到用户信息去
        moveUserInfo: function(e) {
            var item = registry.getEnclosingWidget(e.target);
            if (item.domNode._id) {
                //window.moveToView()
            }
        },
        // 移动到订单去
        moveShopInfo: function(e) {
            var item = registry.getEnclosingWidget(e.target);
            if (item.domNode._id) {
                //window.moveToView()
            }
        },
        // couList的事件
        onCouponListClick: function(e) {
            // 查看当前的内容 传递参数
            var li = registry.getEnclosingWidget(e.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("disCountSerDetail", _id);
        },
        //加载更多，参数evt，返回值：无
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function() {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult, this.start, this.pageSize);
                    }), 1000);
                }
            }
        }
    });
});
