// 变更人：潘云
// 变更时间：2016-06-24
// 功能：处理点击完成重复提交数据的问题、去掉店铺保证金审核相关操作、底部样式问题

// 变更人：潘云
// 变更时间：2016-7-7
// 功能：添加商家的负责人和商家等级功能
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "dojo/dom-style",
    "dojo/query",
    "dijit/registry",
    "cq/biz/shop/shop",
    "dojo/dom-class",
    "cq/util/config/config",
    "cq/biz/user/userAddress",
    "cq/biz/user/user",
    "cq/util/config/config"
], function (declare, lang, array, View, EdgeToEdgeStoreList, _ViewMixin, domStyle, query, registry, shop, domClass, config, userAddress, user, platformConfig) {
    return declare("cq.ui.b.s.MerchantDetail", [View, _ViewMixin], {
        isEditing : false,
        indexElement : function () {
            this.shopListScroll = this.centerPanel;
        },
        // 获取商家等级的Opthions
        getShopLevelOptions : function () {
            var options = {};
            if (this.shopGrade) {
                array.forEach(this.shopGrade, function (grade) {
                    options[grade.gradeCord] = grade.gradeName;
                });
            }
            return options;
        },
        getShopTypeOptions : function () {
            var options = {};
            if (this.shopType) {
                array.forEach(this.shopType, function (type) {
                    options[type.typeCard] = type.typeName;
                });
            }
            return options;
        },
        onAfterShow : function () {
            if (!this.isEditing) {
                //页面状态设置为修改中
                this.isEditing = true;
                // 如果是修改，加载信息
                if (!window.did) {
                    this.setData({});
                    this.refreshData();
                } else {
                    shop.loadShopByPlatform(window.did).then(lang.hitch(this, function (data) {
                        if (data && data.data) {
                            var shopMsg = data.data;
                            this.clearMerButton();
							domStyle.set(query(".delete.merchantbutton", this.footerButton)[0], "display", "");
                            if (shopMsg.isRecommend) {
                                domStyle.set(query(".cancelrecommend", this.footerButton)[0], "display", "none");
                            } else {
                                domStyle.set(query(".cancelrecommend", this.footerButton)[0], "display", "none");
                            }
                            if (!shopMsg.isRecommend) {
                                domStyle.set(query(".recommend", this.footerButton)[0], "display", "none");
                            } else {
                                domStyle.set(query(".recommend", this.footerButton)[0], "display", "none");
                            }
                            // 驳回认证
                            if (shopMsg.isVerifySubmit === -1 && !shopMsg.isVerified) {
                                domStyle.set(query(".onstate", this.footerButton)[0], "display", "none");
                                domStyle.set(query(".revoke", this.footerButton)[0], "display", "none");
                                domStyle.set(query(".cancelstate", this.footerButton)[0], "display", "none");
                            }
                            // 待审核
                            if (shopMsg.isVerifySubmit === 1 && !shopMsg.isVerified) {
                                domStyle.set(query(".onstate", this.footerButton)[0], "display", "");
                                domStyle.set(query(".revoke", this.footerButton)[0], "display", "");
                                domStyle.set(query(".cancelstate", this.footerButton)[0], "display", "none");
                            }
                            // 已认证
                            if (shopMsg.isVerifySubmit === 2 && shopMsg.isVerified) {
                                domStyle.set(query(".onstate", this.footerButton)[0], "display", "none");
                                domStyle.set(query(".revoke", this.footerButton)[0], "display", "none");
                                domStyle.set(query(".cancelstate", this.footerButton)[0], "display", "");
                            }
                            this.setData(data.data);
                            this.refreshData();
                            this.shopListScroll.resize();
                        }
                    }));
                }
            }
        },
        onFirstShow : function () {
            // 获取平台配置的商家等级对象
            this.shopGrade = platformConfig.shopGrade;
            // 获取平台配置的商家类型对象
            this.shopType = config.shopType;
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        this.isEditing = false;
                        history.back();
                    }
                },
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                },
                title : "商家管理"
            };
            this.addHeader(option);
            
            option = {
                isEdge : true,
                "class" : "bottom-margin16",
                lists : [{
                    label : "商家图标",
                    noArrow : true,
                    edit : {
                        type : "image",
                        field : "logo"
                    },
                    "class" : "li-icon",
                    moveTo : "#",
                    disabled:true
                    }, {
                    label : '经营主体',
                    rightText : '',
                    moveTo : "#",
                    edit : {
                        type : 'options',
                        field : 'shopType',
                        options : this.getShopTypeOptions()
                    }
                    }, {
                    label : '商家名称',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'shopName',
                        placeHolder : "未设置",
                        disabled : true
                    }
                    }, 
                    //郭周全 更改原因：加入商家编码字段
                    /*{
                    label : '备案编号',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : '_id',
                        disabled : true
                    }},*/
					{
						label : '地理位置',
						noArrow : false,
						moveTo : "#",
						edit : {
							type : 'position',
							lonField : 'lon',
							latField : 'lat'
						}
					},{
						label : '省市区',
						rightText:'{{town}}'
					},{
                    label : '详细地址',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'address',
                        placeHolder : "未设置",
                        disabled : true
                    }}, /*{
                    label : '商家简介',
                    edit : {
                        type : 'text',
                        field : 'brief',
                        placeHolder : "未设置",
                        disabled : true
                    }
                    }, {
                    label : '是否删除',
                    edit : {
                        type : 'checkbox',
                        field : 'isDelete'
                    }
                    }*/]
            };
            this.addLists(option);
            //客户信息
            option = {
                isEdge : true,
                title : "客户信息",
                "class" : "bottom-margin16",
                lists : [{
                        label : '客服电话',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'svcPhone',
                            placeHolder : "未设置",
                            disabled : true
                        }
                    }, {
                        label : '客服微信',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'svcWx',
                            placeHolder : "未设置",
                            disabled : true
                        }
                    }, {
                        label : '客服QQ',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'svcQQ',
                            placeHolder : "未设置",
                            disabled : true
                        }
                    }
                ]
            };
            //this.addLists(option);
            //商家信息
            option = {
                isEdge : true,
                "class" : "bottom-margin16",
                lists : [{
                        label : '联系人',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'contactName',
                            placeHolder : "未设置",
                            disabled : true
                        }
                    }, {
                        label : '联系电话',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'contactPhone',
                            placeHolder : "未设置",
                            disabled : true
                        }
                    }/*, {
                        label : '店主微信',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'contactQQ',
                            placeHolder : "未设置",
                            disabled : true
                        }
                    }, {
                        label : '店主QQ',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'contactWx',
                            placeHolder : "未设置",
                            disabled : true
                        }
                    }*/
                ]
            };
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                        label : '公司名称',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'companyName',
                            disabled : true
                        }
                    }, {
                        label : '法人姓名',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'legalPerson',
                            disabled : true
                        }
                    }, {
                        label : '法人身份证号',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'legalPersonCode',
                            disabled : true
                        }
                    }, {
                        label : '销售区域',
                        noArrow : true,
                        edit : {
                            type : 'text',
                            field : 'tranRegion',
                            disabled : true
                        }
                    }
                ]
            };
            this.addLists(option);
            
            // 修改商家的负责人，只有超级管理员可以修改
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : '店铺等级',
                    moveTo : '#',
                    noArrow : false,
                    edit:{
                        type : 'options',
                        field : 'shopLevel',
                        options : this.getShopLevelOptions()
                    }
                }, {
                    label : '店铺负责人',
                    noArrow : false,
                    moveTo : '#',
                    edit : {
                        type : 'ref',
                        field : 'platformResponsible',
                        params : {
                            target : user.getStaffUrl(),
                            query : {},
                            searchField : "search",
                            labelField : "pName",
                            //郭周全  添加显示平台（店铺）责任人的电话。
                            getDataLabel: function(item){
                                
                                var str = "<div style='float:left; width:50%;'>"
                                           + item.pName+
                                           "</div> <div style='float:left; width:50%;'>"
                                           +item.phone
                                           +"</div><div style='clear:both;'></div>"
                                
                                return str;
                            }
                        }
                    }
                }]
            };
            //this.addLists(option);
            
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                        label : "营业执照",
                        noArrow : true,
                        rightIcon2 : "{{businessLicense}}",
                        onClick : lang.hitch(this, function (event) {
                            this.showImg(registry.getEnclosingWidget(event.target).rightIcon2);
                        }),
                        class : "li-icon",
                        moveTo : "#"
                    }
                ]
            };
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                        label : "法人身份证正面",
                        noArrow : true,
                        onClick : lang.hitch(this, function (event) {
                            this.showImg(registry.getEnclosingWidget(event.target).rightIcon2);
                        }),
                        rightIcon2 : "{{legalImg1}}",
                        class : "li-icon",
                        moveTo : "#"
                    }, {
                        label : "法人身份证反面",
                        noArrow : true,
                        onClick : lang.hitch(this, function (event) {
                            this.showImg(registry.getEnclosingWidget(event.target).rightIcon2);
                        }),
                        rightIcon2 : "{{legalImg2}}",
                        class : "li-icon",
                        moveTo : "#"
                    }
                ]
            };
            this.addLists(option);
            option = {
                columns : [{
                        label : '删除商家',
                        className : 'delete footer-tab-dark flex1 merchantbutton',
                        onClick : function () {
							if(!confirm("确认要删除吗？")) return;
                            var _id = this.getData()._id
							this.isEditing = false;
							shop.removeShop(_id).then(function (data) {
								window.free();
								if (data && data.data && data.data.ok === 1){
									history.back();
								} else {
									alert('删除失败');
								}
							});
                        }
                    },{
                        label : '撤销推荐',
                        className : 'cancelrecommend footer-tab-dark flex1 merchantbutton',
                        onClick : function () {
                            this.onUpdateMer("cancelrecommend");
                        }
                    }, {
                        label : '推荐商家',
                        className : 'recommend footer-tab-dark flex1 merchantbutton',
                        onClick : function () {
                            this.onUpdateMer("recommend");
                        }
                    }, {
                        label : '标记认证',
                        className : 'onstate footer-tab-highlight flex1 merchantbutton',
                        onClick : function () {
                            this.onUpdateMer("onstate");
                        }
                    }, {
                        label : '驳回认证',
                        className : 'revoke footer-tab-dark flex1 merchantbutton',
                        onClick : function () {
                            this.startEditAsHtml("").then(lang.hitch(this,function (reason) {
                                if (reason) {
                                    this.rejectedReason = reason;
                                    this.onUpdateMer("revoke");
                                } else {
                                    alert("请输入驳回原因");
                                }
                            }));
                        }
                    }, {
                        label : '取消认证',
                        className : 'cancelstate footer-tab-highlight flex1 merchantbutton',
                        onClick : function () {
                            this.onUpdateMer("cancelstate");
                        }
                    }
                ],
                forceWidth : false,
                isFooter : true
            }
            this.footerButton = this.addColumns(option);
            this.onAfterShow();
        },
        clearMerButton : function () {
            var items = query('.merchantbutton', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domStyle.set(items[i], "display", "none");
            }
        },
        onUpdateMer : function (type) {
            window.busy();
            this.isEditing = false;
            switch (type) {
            case "cancelrecommend":
                shop.setRecommend({
                    isRecommend : false,
                    targetShopId : window.did
                }).then(lang.hitch(this, function () {
                    window.free();
                    this.isEditing = false;
                    this.onAfterShow();
                }));
                break;
            case "recommend":
                shop.setRecommend({
                    isRecommend : true,
                    targetShopId : window.did
                }).then(lang.hitch(this, function () {
                    window.free();
                    this.isEditing = false;
                    this.onAfterShow();
                }));
                break;
            case "bail":
                bail.verify({
                    _id : window.did
                }).then(lang.hitch(this, function () {
                    window.free();
                    this.isEditing = false;
                    this.onAfterShow();
                }));
                break;
            case "onstate":
                shop.verifyShopAut({
                    targetShopId : window.did
                }).then(lang.hitch(this, function (data) {
                    window.free();
                    this.isEditing = false;
                    this.onAfterShow();
                }));
                break;
            case "revoke":
                shop.rejectShopAut({
                    targetShopId : window.did,
                    rejectedReason : this.rejectedReason
                }).then(lang.hitch(this, function () {
                    window.free();
                    this.rejectedReason = "";
                    this.isEditing = false;
                    this.onAfterShow();
                }));
                break;
            case "cancelstate":
                shop.cancelShopAut({
                    targetShopId : window.did
                }).then(lang.hitch(this, function () {
                    window.free();
                    this.isEditing = false;
                    this.onAfterShow();
                }));
            default:
                window.free();
                this.onAfterShow();
                break;
            }
        },
        onSaveStore : function () {
            if (this.isEditing) {
                window.busy();
                this.isEditing = false;
                var shopDataOrg = this.getData();
                var msg = this.checkedFiled(shopDataOrg);
                if (msg) {
                    window.free();
                    alert(msg);
                    return;
                }
                //这里只保存可以修改的信息
                var shopData = {
                    _id : shopDataOrg._id,
                    shopType : shopDataOrg.shopType,
                    isDelete : shopDataOrg.isDelete,
                    shopLevel : shopDataOrg.shopLevel,
                    platformResponsible : shopDataOrg.platformResponsible._id,
                    //更改人：郭周全， 更改原因：加入商家编码字段
                    code : shopDataOrg.code
                };
                shop.platformSave(shopData).then(function (data) {
                    window.free();
                    if (data && data.data && data.data.ok === 1){
                        history.back();
                    } else {
                        alert('保存失败');
                    }
                });
            }
        },
        checkedFiled : function (data) {
            var msg = "";
            if (!data.shopLevel && data.shopLevel != '0') {
                msg = "商家等级不能为空";
                return msg;
            }            
            return msg;
        }
    });
});