// 变更人 ： 潘云
// 变更时间 ： 2016-6-22
// 变更内容 ：根据平台下配置的店铺类型做分页处理，优化原有的代码
// 变更人 :  宋宇
// 变更时间 :  2016-06-23
// 变更内容
//          搜索框锁定到头部  tab标签锁定到头部 加载中的提示 重复加载问题

// 变更人 ： 潘云
// 变更时间 ： 2016-7-6
// 变更内容 ：添加商家统计功能
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/query",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "cq/util/config/config"
], function (declare, lang, array, domClass, domStyle, query, on, when, JsonRest, registry, View, EdgeToEdgeStoreList, _ViewMixin, shop, user, platformConfig) {
    return declare("cq.ui.b.s.MerchantList", [View, _ViewMixin], {
        start : 0,
        pageSize : 12,
        onAfterShow : function () {
            // 获取当前登录的用户id
            this.platformResponsible = user.getCurrentUserId();
            // 获取会员等级总数
            if (this.shopGrade) {
                shop.getShopGradesCount(this.getUserId()).then(lang.hitch(this, function(gradeCountData) {
                    // 设置商家等级的个数
                    if (gradeCountData && gradeCountData.data && gradeCountData.data.items) {
                        this.setShopGradeCount(gradeCountData.data.items);
                    }
                }));
            }
            if (this.storeList.store) {
                this.setQuery(this.queryWhere);
            } else {
                this.onLoadListData(queryResult = this.storeList.setStore(this.store, this.params,{
                    start:this.start,
                    count:this.pageSize
                }), this.start, this.pageSize);
            }
            this.refreshData();
        },
        // 获取当前负责人id查询条件
        getUserId : function () {
            var query = {};
            if (!(localStorage.role && localStorage.role == 1)){
                query.platformResponsible = this.platformResponsible;
            }
            return query;
        },
        // 设置商家等级的个数
        setShopGradeCount : function (gradeCounts) {
            var items = query(".shopGrade",this.domNode);
            for (var i = 0; i < items.length; i++) {
                // 获取对应的等级tab节点
                var node = query(".tab-selector", items[i])[0];
                if (node) {
                    var gradeCord = array.filter(this.shopGrade, lang.hitch (this, function (sGrade) {
                        return this.getShopGradeName(node.innerHTML) == sGrade.gradeName;
                    }))[0].gradeCord;
                    var countDatas = array.filter (gradeCounts,lang.hitch(this,function (gradeCount) {
                        return gradeCord == gradeCount.shopLevel;
                    }));
                    var count = 0;
                    if (countDatas.length) {
                        count = (countDatas[0].count) ? countDatas[0].count : 0;
                    } 
                    node.innerHTML = this.getShopGradeName(node.innerHTML) + "(" + window.fixedTo(count, 1) + ")";
                }
            }
        },
        onFirstShow : function () {
            // 获取平台下的商家类型
            this.shopType = platformConfig.shopType;
            // 获取平台下的商家等级
            this.shopGrade = platformConfig.shopGrade;
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "商家管理"
            };
            this.addHeader(option);
            var mengerOptions = {
                1 : '店铺类型',
                2 : '店铺认证',
                3 : '推荐店铺'
            }
            if (this.shopGrade && this.shopGrade.length > 0) {
                mengerOptions[4] = '商家统计';
            }
            option = {
                isEdge : true,
                isHeader : true,
                lists : [{
                    label : '管理类型',
                    rightText : '',
                    moveTo : "#",
                    __view_id : this.id,
                    edit:{
                        type : 'options',
                        field : 'manageType',
                        /*options : {
                            1 : '店铺类型',
                            2 : '店铺认证',
                            3 : '推荐店铺',
                            4 : '商家统计'
                        }*/
                        options : mengerOptions
                    }
                }]
            };
            this.addLists(option);
            // 处理店铺类型
            this.createTabel();
            option = {
                placeHolder : "输入店铺名称，按回车查询",
                "class" : "cqSearchBox",
                type : "search",
                isHeader: true,
                onInput : lang.hitch(this, function (evt) {
                    if (evt.keyCode == 13) {
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.shopName = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            this.storeList = new EdgeToEdgeStoreList ({
                append : true,
                constraint : false,
                query : {},
                "class" : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this,function (data) {
                    for(var i = 0;i < data.length;i++){
						data[i]._logo=data[i].logo||"images/logo.png";
                        data[i]._label = "<div class='mat-list-mname mat-list-margin'>商家名称："+(data[i].shopName?data[i].shopName:" ")+
                            "</div><div class='mat-list-mname mat-list-margin'>商家地址："+(data[i].address?data[i].address:" ")+
                            "</div><div class='mat-list-qty mat-list-margin'><span>店主电话："+(data[i].contactPhone?data[i].contactPhone:" ")+
                            "</span></div>"
                        data[i].moveTo = "#"
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                    },
                itemMap : {_label:"label", _logo:"icon", moveTo:"moveTo"}
            });
            this.store = new JsonRest({target:shop.getShopByPlatform()});
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
            //首次进入默认修改店铺管理
            this.clearType();
            this.showShopTyptTab();
            this.setData({
                manageType:1
            });
            // 为店铺类型的tab页绑定事件
            //this.initShopTypeEvnt();
            // 页面尾部按钮
            option = {
                columns:[{
                    label:'添加商家',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:function(){
                        window.moveToView("businessRegist");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            }
            this.addColumns(option);
            this.onAfterShow();
        },
        // 创建tabl页
        createTabel : function () {
            var tabelColumns = [
            // 店铺认证
            {
                label:'待认证',
                className: 'flex1 shopSubmit',
                labelClass : 'shopSubmit',
                onClick:this.changeQuery
            }, {
                label:'已认证',
                className: 'flex1 shopSubmit',
                onClick:this.changeQuery
            }, {
                label:'未提交',
                className: 'flex1 shopSubmit',
                onClick:this.changeQuery
            }, {
                label:'已驳回',
                className: 'flex1 shopSubmit',
                onClick:this.changeQuery
            },
            // 推荐商家
            {
                label:'未推荐',
                className: 'flex1 commend',
                onClick:this.changeQuery
            }, {
                label:'已推荐',
                className: 'flex1 commend',
                onClick:this.changeQuery
            }];
            // 添加店铺类型的table页
            var talObj = {};
            if (this.shopType && this.shopType.length > 0) {
                talObj = {
                    label : "全部",
                    onClick : this.changeQuery,
                    className : "flex1 shopType"
                }
                tabelColumns.push(talObj);
                for(var i = 0;i < this.shopType.length;i++){
                    talObj = {
                        onClick : this.changeQuery,
                        className : "flex1 shopType"
                    };
                    talObj.label = this.shopType[i].typeName;
                    tabelColumns.push(talObj);
                }
            }
            // 添加商家统计类型的table页
            if (this.shopGrade && this.shopGrade.length > 0) {
                for(var i = 0;i < this.shopGrade.length;i++){
                    talObj = {
                        onClick : this.changeQuery,
                        className : "flex1 shopGrade"
                    };
                    talObj.label = this.shopGrade[i].gradeName + "(0)";
                    tabelColumns.push(talObj);
                }
            }
            
            var option = {
                columns : tabelColumns,
                forceWidth : false,
                isHeader : true,
                labelClass : 'font-size1 tab-selector'
            }
            this.queryList = this.addColumns(option);
        },
        // 隐藏所有的table页
        clearType : function(){
            var items = query('.tab-selector',this.domNode);
            for(var i = 0;i < items.length;i++){
                domStyle.set(items[i],"display","none");
            }
        },
        // 设置table页的选中样式
        setSelectedClass : function (evt) {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            domClass.add(evt.target, "selected");
        },
        onClickList : function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("merchantDetail",_id);
        },
        onLoadMore : function (evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }), this.start,this.pageSize);
                    }), 1000);  
                }
                
            }
        },
        setQuery : function (query) {
            this.start = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            //依据加载数据得结果处理界面显示
            this.onLoadListData(this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            }),this.start,this.pageSize);
        },
        // 显示出店铺认证的tab页
        showSubmitTab : function () {
            var items = query('.shopSubmit',this.domNode);
            for(var i=0;i<items.length;i++){
                domStyle.set(items[i],"display","");
            }
            domClass.add(query('.tab-selector',items[0])[0],"selected");
            this.queryWhere = {};
            this.queryWhere.isVerifySubmit = 1;
            this.queryWhere.isVerified = false;
        },
        // 显示出店铺类型的tab页
        showShopTyptTab : function () {
            if (this.shopType) {
                var items = query('.shopType',this.domNode);
                for(var i=0;i<items.length;i++){
                    domStyle.set(items[i],"display","");
                }
                domClass.add(query('.tab-selector',items[0])[0],"selected");
            }
            this.queryWhere = {};
        },
        // 显示出店铺推荐的tab页
        showCommendTab : function () {
            var items = query('.commend',this.domNode);
            for(var i = 0;i<items.length;i++){
                domStyle.set(items[i],"display","");
            }
            domClass.add(query('.tab-selector',items[0])[0],"selected");
            this.queryWhere = {};
            this.queryWhere.isRecommend = true;
        },
        // 显示出店铺统计的tab页
        showShopGradeTab : function () {
            var items = query('.shopGrade',this.domNode);
            for(var i = 0;i<items.length;i++){
                domStyle.set(items[i],"display","");
            }
            domClass.add(query('.tab-selector',items[0])[0],"selected");
            this.queryWhere = this.getUserId();
            this.queryWhere.shopLevel = this.shopGrade[0].gradeCord;
        },
        onDataChanged : function(field, oldValue, newValue){
            this.clearType();
            this.clearSelected();
            if(newValue == 1){
                // 如果存在店铺类型分类
                this.showShopTyptTab();
            }
            if(newValue == 2){
                // 显示出店铺认证的tab页
                this.showSubmitTab();
            }
            if(newValue == 3){
                // 显示出店铺推荐的tab页
                this.showCommendTab();
            }
            if(newValue == 4){
                // 显示出店铺统计的tab页
                this.showShopGradeTab();
            }
        },
        clearSelected : function () {
            var items = query('.tab-selector',this.domNode);
            for(var i = 0;i < items.length;i++){
                domClass.remove(items[i],"selected");
            }
        },
        clearType : function () {
            var items = query('.shopType',this.domNode);
            for(var i=0;i<items.length;i++){
                domStyle.set(items[i],"display","none");
            }
            items = query('.shopSubmit',this.domNode);
            for(var i=0;i<items.length;i++){
                domStyle.set(items[i],"display","none");
            }
            items = query('.commend',this.domNode);
            for(var i=0;i<items.length;i++){
                domStyle.set(items[i],"display","none");
            }
            items = query('.shopGrade',this.domNode);
            for(var i=0;i<items.length;i++){
                domStyle.set(items[i],"display","none");
            }
        },
        // 获取商家等级的名称
        getShopGradeName : function (gradeName) {
            return gradeName.split('(')[0];
        },
        changeQuery : function (evt) {
            this.clearSelected();
            domClass.add(evt.target,"selected");
            this.queryWhere = {};
            var dom = evt.target.parentNode;
            // 商家类型的点击事件
            if (domClass.contains(dom,"shopType")) {
                for(var i = 0;i < this.shopType.length;i++){
                    if (evt.target.innerHTML == this.shopType[i].typeName) {
                        this.queryWhere.shopType = this.shopType[i].typeCard;
                        break;
                    }
                }
            }
            if (domClass.contains(dom,"shopGrade")) {
                this.queryWhere = this.getUserId();
                for(var i = 0;i < this.shopGrade.length;i++){
                    if (this.getShopGradeName(evt.target.innerHTML) == this.shopGrade[i].gradeName) {
                        this.queryWhere.shopLevel = this.shopGrade[i].gradeCord;
                        break;
                    }
                }
            } 
            if (domClass.contains(dom,"shopSubmit")) {
                if (evt.target.innerHTML == "待认证") {
                    this.queryWhere.isVerifySubmit = 1;
                    this.queryWhere.isVerified = false;
                }
                if (evt.target.innerHTML=="已认证") {
                    this.queryWhere.isVerifySubmit = 2;
                    this.queryWhere.isVerified = true;
                }
                if (evt.target.innerHTML == "未提交") {
                    this.queryWhere.isVerifySubmit = 0;
                    this.queryWhere.isVerified = false;
                }
                if (evt.target.innerHTML == "已驳回") {
                    this.queryWhere.isVerifySubmit = -1;
                    this.queryWhere.isVerified = false;
                }
            }
            if (domClass.contains(dom,"commend")) {
                if (evt.target.innerHTML=="已推荐") {
                    this.queryWhere.isRecommend = true;
                }
                if (evt.target.innerHTML == "未推荐") {
                    this.queryWhere.isRecommend = false;
                }
            }
            this.setQuery(this.queryWhere);
        },
    });
});