define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/query",
    "dojo/Deferred",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "cq/biz/ts/order",
    "cq/util/sys/date",
    "cq/ui/view/_ViewMixin"
],function(declare,lang,domAttr,domStyle,domClass,query,Deferred,View,ListItem,order,date,_ViewMixin){
    return declare("widgets.mobile.OrderDetail",[View,_ViewMixin],{
        cancel:true,
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                        //window.moveToView("orderList");
                    }
                },
                title:"订单详情"
            };
            this.addHeader(option);
            //收货相关信息
            option={isEdge:true,lists:[]};
            this.orderList=this.addLists(option);
            this.orderStateItem = new ListItem({
                variableHeight:true
            });
            this.orderList.addChild(this.orderStateItem);
            //商品信息
            option={isEdge:true,lists:[]};
            this.matList=this.addLists(option);
            //费用信息
            option={isEdge:true,lists:[]};
            this.expenseList=this.addLists(option);
            this.expenseItem = new ListItem({
                variableHeight:true
            });
            this.expenseList.addChild(this.expenseItem);
            //底部
            option={
                columns:[{
                    label:"<div><span class='count'></span></div>",
                    className:"edit-car-count flex1"
                }, {
                    label:"<span class='amout'>支付</span>",
                    className:"edit-car-submit",
                    onClick: function(){
                        this.payOrder(1);
                    }
                }],
                className:'fix-footer edit-car-footer',
                forceWidth:false,
                isFooter:true
            }
            this.addColumns(option);
            this.connectEvent();
            this.onAfterShow();
        },
        payOrder:function(type){
        },
        connectEvent:function(){
            this.connect(this.orderStateItem.domNode,"onclick",function(e){
                console.log(e);
                if(domClass.contains(e.target,"")){
                    //执行取消订单的操作
                }
            });
            //var carCancel=query(".edit-car-cancel",this.domNode)[0];
            //this.connect(carCancel,"onclick",this.cancelOrder);
        },
        //按钮显示与不显示
        hiddenAmout:function(items){
            this.connectEvent();
            if(items.isPayed == false){
                if(items.isCanceled == false){
                    var amout = query(".amout",this.domNode);
                    domClass.toggle(amout[0],"inline-block");
                    var amouts = amout[0].parentNode.parentNode;
                    domClass.toggle(amouts,"inline-block");
                    domClass.remove(amouts,"hidden-file-input");
                }else {
                    domClass.toggle(query(".edit-car-cancel",this.domNode)[0],"hidden-file-input");
                    var footer = query(".edit-car-footer",this.domNode)[0];
                    domClass.toggle(footer,"display","hidden-file-input");
                }
            }else {
                domClass.add(query(".edit-car-cancel",this.domNode)[0],"hidden-file-input");
                var amout = query(".amout",this.domNode)[0];
                var amouts = amout.parentNode.parentNode;
                domClass.remove(amouts,"inline-block");
                domClass.add(amouts,"hidden-file-input");
            }
        },
        onAfterShow:function () {
            this.inherited(arguments);
            this.orderStateItem.set({label:"",rightText:""});
            this.matList.destroyDescendants();
            this.expenseItem.set({label:"",rightText:""});
            order.loadDetailById(window.did).then(lang.hitch(this,function (data) {
                var items=data&&data.data&&data.data.items||[];
                if(items.length){
                    //添加商品列表项
                    //this.hiddenAmout(items[0]);
                    //更新收货人信息
                    this.orderStateItem.set("label","");
                    //商品列表
                    for (var i = items.length - 1; i >= 0; i--) {
                        var listitem=new ListItem({
                            label:"<img class='edit-car-matimg' src='"+items[i].mId.logo+"' /><span class='edit-car-matname'>"+items[i].mId.mName+"</span><span class='edit-car-matprice'>￥"+items[i].price+"</span>"
                            +"<span class='edit-car-priceAll'>小计:￥"+items[i].price*items[i].qty+"</span>",
                            rightText:"x<span class='edit-car-qty'>"+items[i].qty+"</span>",
                            variableHeight:true
                            });
                        this.matList.addChild(listitem);
                    };
                }
            }));
            order.loadById(window.did).then(lang.hitch(this,function (data) {
                var item = data.data.item;
                this.orderStateItem.set("rightText",item.isCanceled?"已取消":item.isPayed?"yizhifu":"<span class=''>xxxx</>");
                //费用明细
                var dates = date.formatISODate(data.data.item.createAt);
                this.expenseItem.set({
                    "label":"<div class='edit-car-tAmount'>运费:</div>"
                    +"<div class='edit-car-amount'>交易金额（含运费）:</div>"
                    +"<div class='edit-car-createAt'>创建时间:</div>",
                    rightText:"<div class='edit-car-tAmount'>￥"+ data.data.item.tAmount +"</div>"
                    +"<div class='edit-car-amount'>￥"+ data.data.item.amount +"</div>"
                    +"<div class='edit-car-createAt'>"+ dates +"</div>"
                });
            }));
        },
        //取消订单
        cancelOrder:function(){
            if(this.cancel){
                order.onCancelAll(window.did).then(lang.hitch(this,function(data){
                        var carCancel=query(".edit-car-cancel",this.domNode)[0];
                        var carCancelStill=query(".edit-car-cancelStill",this.domNode)[0];
                        domClass.toggle(carCancel,"hidden-file-input");
                        domClass.remove(carCancelStill,"hidden-file-input");
                        var amout = query(".amout",this.domNode)[0];
                        var amouts = amout.parentNode.parentNode;
                        domClass.remove(amouts,"inline-block");
                        domClass.toggle(amouts,"hidden-file-input");
                }));
                this.cancel = false;
            }
        }
    });
});