//变更人:肖芳圆
//变更时间:2016/5/17
//变更原因:代码规范,文件迁移
//变更人:周科吉
//变更时间:2016/6/22
//变更原因:更改底部标签样式问题
//变更人：张金鹏
//变更时间：2016/07/20
//变更原因：在客服按钮上添加未读消息的提示的功能
//变更人：张金鹏
//变更时间：2016/07/26
//变更原因：新增商家和平台的沟通
//变更人:周科吉
//变更时间:2016/10/17
//变更原因:列表数据显示不了的问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dijit/registry",
    "dojox/mobile/ListItem",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/date/relative",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/im/msg_p",
    "cq/biz/im/msg",
    "dojo/dom-attr",
    "dojo/dom-class",
    "cq/biz/shop/shop",
    "cq/util/config/config",
    "cq/biz/user/user"
],function(declare,lang,domConstrcut,domStyle,query,View,_ViewMixin,registry,ListItem,EdgeToEdgeStoreList,
    relativeDate,on,when,JsonRest,msg_p,msg,domAttr,domClass,shop,config,user){
    //客服消息列表对象
    return declare("cq.ui.b.s.PendingMsg",[View,_ViewMixin],{
        //开始查询序号
        start: 0,
        pageSize:20,
        //加载数据
        onAfterShow:function(){
            if(!this.store){
                //创建数据源
                this.store = new JsonRest({target:msg_p.getPendingUrl()});
                //将数据源赋值给storeList
                var queryResult = this.storeList.setStore(this.store,{
                    userId:user.getCurrentUserId(),
                    orderBy:"-lastMsgTime"
                },{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.setQuery(this.storeList.get("query"));
            }
        },
        //初始化页面元素绑定事件
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() { history.back(); }
                },
                title:"客服",
                //添加平台负责人和商家沟通的入口
                right :{
                    iconButton : ' ',
                    label : "平台消息",
					isBadge:true,
					badgeClass:'orderCarNum',
                    onClick: lang.hitch(this, this.toTalk)
                }
            };
            this.addHeader(option);
            option = {
                placeHolder:"请输入要查询条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                isHeader:true,
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        //condition.search = evt.target.value;
                        // 修改为按照发送人姓名昵称等模糊搜索
                        condition.senderSearch = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        data[i]._label=this.getListLabel(data[i])||"";
                        data[i]._badge = data[i].msgCount||"";
                        data[i].logo=data[i].senderId&&data[i].senderId.logo ||"images/userIcon.png";
                        data[i].moveTo="#";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{_label:"label", logo:"icon",moveTo:"moveTo","_badge":"badge"}
            });
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            option = {
                columns:[{
                    icon:'images/icon/shop_footer_highlight.png',
                    iconClass:'footer-tab-img',
                    label:'店铺',
                    onClick:function(){
                        window.moveToView("home");                    }
                },
                {
                    icon:'images/icon/member_footer_highlight.png',
                    //icon1:'images/icon/member_footer_highlight.png',
                    iconClass:'footer-tab-img',
                    label:'客服',
					//添加未读消息的小图标    张金鹏，2016/07/19
					isBadge:true,
					badgeClass:'orderCarNum',
                    onClick:function(){
                        window.moveToView("pendingMsg");
                    }
                },
                {
                    icon:'images/icon/sale_footer.png',
                    iconClass:'footer-tab-img',
                    label:'动态',
                    onClick:function(){
                        window.moveToView("trends");
                    }
                },
                {
                    icon:'images/icon/more_footer.png',
                    iconClass:'footer-tab-img',
                    label:'更多',
                    onClick:function(){
                        window.moveToView("others");                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
            this.addColumns(option);
            //侦听msg_p的未读消息发生变化的事件，刷新未读消息数量显示    张金鹏，2016/07/21
            this.connect(msg_p, "onPenddingMsgChanged", function(num) {
                var badge = query(".orderCarNum", this.domNode)[0];
                if (badge) {
                    if (num > 0) {
                        badge.innerHTML = num;
                        domStyle.set(badge, "display", "");
                    } else {
                        domStyle.set(badge, "display", "none");
                    }
                }
            });
            msg_p.updatePenddingMsg();
            this.onAfterShow();
        },
        //改动:当data.lastMsg=null的时候match报错，导致后面this.storeList.generaList不执行，数据字符串化。
        getListLabel:function(data){
            return "<div style='margin-left:10px;'><div style='float:left'>"+(
                data.senderId && (data.senderId.pName || data.senderId.nickName)||""
            )+"</div><div style='float:right'>"+relativeDate.format(new Date(data.lastMsgTime))+"</div></div><div style='margin-top: 30px;margin-left:10px;'>"
            +((data.lastMsg+"").match(/^http/i)?"图片":data.lastMsg)+(data.msgCount>0?"<span class='badge' style='float:right;position:relative;'>"+data.msgCount+"</span>":"")+"</div>";
        },
        //获取当前商家的负责人
        //若获取到了负责人，就跳转到对话页面并传递参数
        //否则，提示错误
        toTalk: function(){
            //执行shop.js中的loadCurrentShop()函数，并返回一个异步返回值data    张金鹏，2016/07/27
            shop.loadShopByPlatform(shop.getShopId()).then(lang.hitch(this,function(data){
                //取出返回值中的platformResponsible字段(这个字段就是平台负责人的ID)    张金鹏，2016/07/27
                var platformResponsible = data&&data.data&&data.data.platformResponsible;
                if(platformResponsible){
                    msg_p.initPenddingMsg(user.getCurrentUserId(),platformResponsible._id,config.getPlatformShopId());
                    //假如获取到了平台负责人的ID，就跳转到svcDetail.js页面，并传递平台的shopId和平台的负责人ID    张金鹏，2016/07/27
                    window.moveToView("svcDetail",config.getPlatformShopId()+","+platformResponsible._id);
                }else{
                     shop.loadShopByPlatform(config.getPlatformShopId()).then(lang.hitch(this,function(data1){
						platformResponsible = data1&&data1.data&&data1.data.platformResponsible;
						if(platformResponsible){
							msg_p.initPenddingMsg(user.getCurrentUserId(),platformResponsible._id,config.getPlatformShopId());
							window.moveToView("svcDetail",config.getPlatformShopId()+","+platformResponsible._id);
						}else{
							alert("没有设置负责人，请设置后重试！！！");
						}
					}));
                }
            }));
        },

        //列表项被点击事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            var _id = li&&li.params.senderId && li.params.senderId._id;
            var _id1 = li&&li.params.receiverId && li.params.senderId._id;
            var badge = query(".badge", this.domNode)[0];
            if(_id){
                li.set("label",this.getListLabel(li.params));
                window.moveToView("svcDetail",msg.getShopId()/*config.getPlatformShopId()*/+","+_id);
                msg_p.onReadPenddingMsg(_id);
            }
            //点击列表消息清空消息条数
            msg_p.clearMsgCount(_id,_id1);
        },
        //加载更多数据
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.start + this.pageSize;
                if(this.canLoadMore(this.start)){
                    //console.log("加载更多消息");
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        //设置查询条件,并加载数据
        setQuery:function(query){
            this.start = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});