//变更日期：2016-5-17  变更人：周超  变更原因：代码规范
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/registry",
    "cq/biz/shop/shop",
    "cq/biz/user/user"
],function (declare, lang, View, _ViewMixin,query, registry, shop, user) {
    return declare("cq.ui.b.s.PlatShopDetail", [View, _ViewMixin], {
        //显示信息（初始化界面元素之后的信息显示）
        onAfterShow : function () {
            if(window.did){
                //异步函数，在进行加载商铺信息之后执行功能函数，参数window.did,
                shop.loadById(window.did).then(lang.hitch(this, function (data) {
                    // 显示信息
                    this.setData(data.data);
                    this.refreshData();
                }));
            }
        },
        //初始化界面元素
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        //window.moveToView("home");
                        history.back();
                    }
                },
                title : "店铺管理"
            };
            //添加头部栏，参数:option，返回值:节点。
            this.addHeader(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : "店铺图标",
                    noArrow : false,
                    rightIcon2 : "{{logo}}",
                    edit : {
                        type : "image",
                        field : "logo"
                    },
                    class : "li-icon",
                    moveTo : "#"
                }, {
                    label : '店铺名称',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'shopName',
                        placeHolder : "请输入店铺名称",
                        disabled : true
                    }
                }, {
                    label : '店铺地址',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'address',
                        placeHolder : "请输入店铺地址",
                        disabled : true
                    }
                }, {
                    label : '店铺简介',
                    rightText : '店铺详情',
                    moveTo : "#",
                    __view_id : this.id,
                    edit : {
                        type : 'textarea',
                        field : 'brief',
                        placeHolder : "请输入店铺简介",
                        disabled : true
                    }
                }]
            };
            //添加商铺lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            //客户信息
            option = {
                isEdge : true,
                title : "客户信息",
                class : "bottom-margin16",
                lists : [{
                    label : '客服电话',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'svcPhone',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '客服微信',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'svcWx',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '客服QQ',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'svcQQ',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '订单通知',
                    moveTo : "#",
                    edit : {
                        type : 'ref',
                        field : 'orderCheckerId',
                        placeHolder : "未设置",
                        params : {
                            target : user.getUserUrl(),
                            query : {},
                            searchField : "pName",
                            labelField : "pName"
                        },
                        disabled : true
                    }
                }, {
                    label : '客服通知',
                    moveTo : "#",
                    edit : {
                        type : 'ref',
                        field : 'svcId',
                        params : {
                            target : user.getUserUrl(),
                            query : {},
                            searchField : "pName",
                            labelField : "pName"
                        },
                        disabled : true
                    }
                }]
            };
            //添加客户信息lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            //店铺信息
            option = {
                isEdge : true,
                title : "店铺信息",
                class : "bottom-margin16",
                lists : [{
                    label : '店主姓名',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'contactName',
                        placeHolder : "未填写",
                        disabled : true
                    }
                }, {
                    label : '店主电话',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'contactPhone',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '店主微信',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'contactQQ',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '店主QQ',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'contactWx',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }]
            };
            //添加店铺信息lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            //电商信息
            option = {
                isEdge : true,
                title : "电商信息",
                class : "bottom-margin16",
                lists : [{
                    label : '销售区域',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'saleRegin',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '发货地点',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'shipAddress',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '自动关闭未付款订单',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'orderTimeout',
                        disabled : true
                    }
                }, {
                    label : '直销包邮金额',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'shipFreeAmount',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '运费',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'postage',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }]
            };
            //添加电商信息lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            //微信信息
            option = {
                isEdge : true,
                title : "微信信息",
                class : "bottom-margin16",
                lists : [{
                    label : '微信APPID',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxAppId',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '微信APPSEC',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxAppSec',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '微信配置Url',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxUrl',
                        placeHolder : '未设置',
                        disabled : "true"
                    }
                }, {
                    label : '微信Token',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxCqToken',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '订单状态模板',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'wxMsgTemplate',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '微信认证',
                    noArrow : true,
                    edit : {
                        type : 'checkbox',
                        field : 'wxVerification',
                        disabled : true
                    }
                }, {
                    label : '快速登陆',
                    noArrow : true,
                    edit : {
                        type : 'checkbox',
                        field : 'wxAutoLogin',
                        disabled : true
                    }
                }, {
                    label : '自动注册',
                    noArrow : true,
                    edit : {
                        type : 'checkbox',
                        field : 'wxAutoRegister',
                        disabled : true
                    }
                }]
            };
            //添加微信信息lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            //财务信息
            option = {
                isEdge : true,
                title : "财务信息",
                lists : [{
                    label : '支付宝账号',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'alipayAccount',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '开户行',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'bankName',
                        placeHolder : "未填写",
                        disabled : true
                    }
                }, {
                    label : '账户名',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'bankAccountName',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '账号',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'bankAccountCode',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '收款人',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'payee',
                        placeHolder : "未填写",
                        disabled : true
                    }
                }, {
                    label : '财务联系人姓名',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'fiName',
                        placeHolder : "未填写",
                        disabled : true
                    }
                }, {
                    label : '财务联系人电话',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'fiPhone',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }, {
                    label : '财务联系人QQ',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'fiQQ',
                        placeHolder : "未设置",
                        disabled : true
                    }
                }]
            };
            //添加财务信息lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : '公司名称',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'companyName',
                        disabled : true
                    }
                }, {
                    label : '法人姓名',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'legalPerson',
                        disabled : true
                    }
                }]
            };
            //添加公司法人lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : "营业执照",
                    noArrow : false,
                    rightIcon2 : "{{businessLicense}}",
                    onClick : lang.hitch(this, function (event) {
                        this.showImg(registry.getEnclosingWidget(event.target).rightIcon2);
                    }),
                    class : "li-icon",
                    moveTo : "#"
                }]
            };
            //添加营业执照lists栏，参数：option，返回值：节点
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : "法人身份证正面",
                    noArrow : false,
                    onClick : lang.hitch(this, function (event) {
                        this.showImg(registry.getEnclosingWidget(event.target).rightIcon2);
                    }),
                    rightIcon2 : "{{legalImg1}}",
                    class : "li-icon",
                    moveTo : "#"
                }, {
                    label : "法人身份证反面",
                    noArrow : false,
                    onClick : lang.hitch(this, function (event) {
                        this.showImg(registry.getEnclosingWidget(event.target).rightIcon2);
                    }),
                    rightIcon2 : "{{legalImg2}}",
                    class : "li-icon",
                    moveTo : "#"
                }]
            };
            //添加法人身份lists栏，参数：option，返回值：子节点(数组)
            this.addLists(option);
            var option = {
                columns : [{
                    label : '认证审核',
                    onClick : function () {
                        shop.verifyShop({
                            targetShopId : window.did
                        }).then(lang.hitch(this, function (data) {
                                if (data.data.ok == 1) {
                                    alert("审核成功");
                                } else {
                                    alert("审核失败：" + data.data.msg);
                                }
                            }));
                    }
                }],
                labelClass : 'font-size1',
                className : 'padding-top-bottom16',
                isFooter : true
            };
            //添加审核栏，参数：option，返回值：子节点(数组)
            this.addColumns(option);
            //给页面赋值数据/刷新页面数据
            this.onAfterShow();
        }
    });
});