//创建人：周超
//创建时间：2016/9/9
//创建内容：销售区域
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "cq/biz/shop/shop",
    "cq/ui/util/districtOverlay",
    "cq/ui/view/_ViewMixin"
],function( declare, lang, array, domClass, registry, View, EdgeToEdgeList, ListItem, shop, districtOverlay, _ViewMixin){
    return declare("cq.ui.b.s.PositionList",[View,_ViewMixin],{
        isEditing : true,
        onFirstShow: function(){
            this.positionsList = new EdgeToEdgeList();
            this.positionsList.placeAt(this.centerPanel.containerNode, "last");
            // 添加销售区域
            this.connect(this.positionsList.containerNode, 'onclick', this.onPositionsClick);
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        this.isEditing = true;
                        history.back();
                    }
                },
                right: { iconButton: ' ', onClick: this.onSave, label: "完成" },
                title: "销售区域"
            };
            this.addHeader(option);
            option = {
                columns: [{
                    label: "添加销售区域",
                    className: 'flex2 footer-tab-highlight position',
                    onClick: function() {
                        this.getInfo = 1;
                        this.addPositions();
                    }
                }],
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        onAfterShow: function(){
            if(this.isEditing){
                this.isEditing = false;
                if (this.positionsList) {
                    this.positionsList.destroyDescendants();
                }
                shop.loadById(shop.getShopId()).then(lang.hitch(this, function(data) {
                    //tranRegions
                    if (data&&data.data) {
                        this.tranRegion = data.data.tranRegion;
                        this.saveData = data.data;
                        if (data.data.tranRegions.length > 0) {
                            //0代表进入页面时读取数据，1代表添加，2代表修改
                            this.getInfo = 0;
                            //在此时tranRegions里面检查是含有remark的
                            this.createPositions(data.data.tranRegions);
                        }
                        this.setData(data.data.item);
                        this.refreshData();
                    }
                }));
            }
        },
        // 为ListItem添加事件
        onPositionsClick: function(evt) {
            var target = evt.target;
            var listItem = registry.getEnclosingWidget(evt.target);
            if (listItem.declaredClass != "dojox.mobile.ListItem") return;
            while (target && target.parentNode != listItem.labelNode && target.parentNode != listItem.domNode) {
                target = target.parentNode;
            }
            //li.params;
            if (domClass.contains(target, "selectorDir")) {
                this.getInfo = 2;
                //选择区域
                this.selectDistrict(listItem, listItem.params);
            } else if (domClass.contains(evt.target, "attachment-cancel")) {
                // 移除这个对象
                listItem.destroyRecursive();
            }
        },
        // 进入界面存在exceptions创建
        createPositions: function(args) {
            array.forEach(args, lang.hitch(this, function(item) {
                this.addPositions(item);
            }));
        },
        addPositions: function(params) {
            params = params || {};
            //根据//this.getInfo 的值来判定，0进入页面， 1添加， 2修改
            var label = this.getPositionsLabelByData(params);
            var listItem = new ListItem({
                label: label,
                rightText: "<span class='attachment-cancel'>删除</span>",
                variableHeight: true,
                params: { data: params }
            });
            this.positionsList.addChild(listItem);

            //若新增，自动弹出选择区划的界面
            if (!params.provinceId) {
                this.addDistrict(listItem);
            }
        },
        //添加销售区域
        addDistrict : function(listItem, params){
            districtOverlay.selectDistrict(params,true).then(lang.hitch(this, function(data) {
                if (data.province) {
                    //解决在选择完之后provinceId变为object的问题
                    if(data.province&&data.province._id){
                        listItem.params.data.provinceId = data.province._id;
                    }
                    if(data.city&&data.city._id){
                        listItem.params.data.cityId = data.city._id;
                    }
                    if(data.county&&data.county._id){
                        listItem.params.data.countyId = data.county._id;
                    }
                    //解决选择之后的显示问题
                    listItem.params.data.province = data.province;
                    listItem.params.data.city = data.city;
                    listItem.params.data.county = data.county;
                    //直接读取列表时
                    listItem.set("label", this.getPositionsLabelByData(listItem.params.data));
                    listItem.params.data.remark = this.remark;
                }
            }));
        },
        // 选择区域
        selectDistrict: function(listItem, params) {
            //params = params && params.data && params.data.provinceId && { province: params.data.provinceId, city: params.data.cityId, county: params.data.countyId } || '';
            //若市或区县不存在，则设为全部的那个默认字段
            //var k = params;
            //再次进入时 类型变成了provinceId等变成了Object
            //市-区县，修改时的错误问题
            //  错误原因：params参数错误
            //  params的参数中省-市-县应当均为object类型而不是id
            var items = {};
            items.province = params.data.provinceId;
            items.city = params.data.cityId;
            items.county = params.data.countyId;
            //选择完区划之后，自动弹出填写运费的对话框
            districtOverlay.selectDistrict(items,true).then(lang.hitch(this, function(data) {
                if (data.province) {
                    listItem.params.data = {};
                    //解决在选择完之后provinceId变为object的问题
                    listItem.params.data.provinceId = data.province._id;
                    if(data.city&&data.city._id){
                        listItem.params.data.cityId = data.city._id;  
                    }
                    if(data.county&&data.county._id){
                        listItem.params.data.countyId = data.county._id; 
                    }
                    //解决选择之后的显示问题
                    listItem.params.data.province = data.province;
                    listItem.params.data.city = data.city;
                    listItem.params.data.county = data.county;
                    //直接读取列表时
                    listItem.set("label", this.getPositionsLabelByData(listItem.params.data));
                    listItem.params.data.remark = this.remark;
                }
            }));
        },
        getPositionsLabelByData:function(data){
            //根据//this.getInfo 的值来判定，0进入页面， 1添加， 2修改
            var label = "";
            if (data && data.provinceId) {
                this.tranRegion = this.getDistrictLabel(data);
                this.remark = this.getDistrictLabel(data);
                label = "<div class='selectorDir' style='line-height:30px'>销售区域:&nbsp" +
                    "<span>" + this.getDistrictLabel(data) +
                    "</span> </div>";
            }else{
                label = "<div class='selectorDir' style='line-height:30px'>销售区域:&nbsp<span></span> </div>";
            }
            return label;
        },
        getDistrictLabel: function(data) {
            //根据//this.getInfo 的值来判定，0进入页面， 1添加， 2修改
            if(this.getInfo == 0){
                return data.remark
            }else if((this.getInfo == 1)||(this.getInfo == 2)){
                return data.province.distName + (
                    data.cityId ? (
                        "-" + data.city.distName + (
                            data.countyId ? ("-" + data.county.distName) : ""
                        )
                    ) : ""
                ); 
            }
        },
        onSave: function() {
            window.busy();
            this.stringTranRegion = "";
            this.saveData.tranRegions = this.getAttrs();
            this.saveData.tranRegion = this.getAttrsT();
            shop.save(this.saveData).then(lang.hitch(this, function(data) {
                if (data.data.ok === 1) {
                    window.free();
                    this.isEditing = true;
                    //this.tranRegions = data.tranRegions;
                    history.back();
                } else {
                    window.free();
                    alert(data.data.message);
                }
            }));
        },
        //获取 字符串连接
        getAttrsT: function() {
            var stringTranRegion = '';
            array.map(this.positionsList.getChildren(), function(listItem) {
                if(stringTranRegion!==''){
                    stringTranRegion = stringTranRegion+"，"+listItem.params.data.remark;
                }else{
                    stringTranRegion = listItem.params.data.remark;
                }
            });
            return stringTranRegion;
        },
        // 增加数据
        getAttrs: function() {
            return array.map(this.positionsList.getChildren(), function(listItem) {
                return listItem.params.data;
            });
        }
    });
});