// 变更人：潘云
// 变更时间：2016-05-17
// 变更内容：代码规范、注释、迁移
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/mk/qrCode"
],function(declare,lang,View,_ViewMixin,EdgeToEdgeStoreList,on,when,JsonRest,qrCode){
    // module:
    //        cq/ui/b/s/QrCode
    return declare("cq.ui.b.s.QrCode",[View,_ViewMixin],{
        // 记录列表开始加载的下标，默认值为0
        start : 0,
        // 每次加载的条数
        pageSize : 10,
        // 再次进入页面时加载list中的数据
        onAfterShow:function(){
            this.setQuery(this.storeList.get("query"), {
                start: 0,
                count: this.pageSize
            });
        },
        // 创建显示列表的List
        onCreatList: function(){
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                class:"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                itemMap:{sceneId:"rightText", imgUrl:"icon"}
            });
            this.store = new JsonRest({target:qrCode.loadByShopId()});
            // 将数据源赋值给storeList
            this.storeList.setStore(this.store);
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
        },
        // 第一次进入页面，加载页面的一些组件
        onFirstShow : function() {
            // 加载页面的头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        //window.moveToView("home");
                        history.back();
                    }
                },
                title:"二维码"
            };
            this.addHeader(option);
            // 加载页面的尾部信息
            option = {
                columns:[{
                    label:'添加二维码',
                    icon:'images/icon/crmicon.png',
                    iconClass:'width-16',
                    onClick:function(){
                        window.moveToView("qrCodeDetail");
                    }
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            }
            this.addColumns(option);
            this.onCreatList();
        },
        // 列表项的点击事件
        onClickList:function(evt){
            // 得到点击的ListItem
            /* var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _tsId = li.tsId;
            window.moveToView("qrCodeDetail",_tsId); */
        },
        // 列表拖动加载更多的方法
        onLoadMore:function(evt){
            if(this.busy||(0<this.end&&(this.start+this.pageSize-1>this.end))){
                return true;
            }
            if(evt.afterBottom){
                this.start = this.end+1;
                this.busy = true;
                setTimeout(lang.hitch(this,function(){
                    when(this.storeList.setQuery(this.storeList.get("query"),{
                        start: this.start,
                        count: this.pageSize
                    }), lang.hitch(this,function(){
                        this.centerPanel.resize();
                    }));
                }), 1000);
            }
        }
      });
});