// 变更人：潘云
// 变更时间；2016-05-17
// 变更内容：代码规范、注释、迁移
define(
    [
      "dojo/_base/declare",
      "dojo/_base/lang",
      "dojox/mobile/View",
      "cq/ui/view/_ViewMixin",
      "cq/biz/user/user"
    ],
    function(declare, lang,View, _ViewMixin,user) {
    // module:
    //        cq/ui/b/s/QrCodeDetail
    return declare("cq.ui.b.s.QrCodeDetail", [ View, _ViewMixin ], {
        // 设置页面是否处在编辑状态，默认为false
        isEditing : false,
        // 每次进入页面根据页面的编辑状态加载数据
        onAfterShow : function() {
            // 如果是修改，加载二维码信息
            if (!this.isEditing) {
                this.isEditing = true;
                if(!window.did){
                    this.setData({
                        isUse:true
                    });
                    this.refreshData();
                }
            }
        },
        // 第一次进入页面加载页面的组件
        onFirstShow : function() {
            // 加载页面的头部
            option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : lang.hitch(this,function() {
                        this.isEditing = false;
                        //window.moveToView("qrCode");
                        history.back();
                    })
                },
                //这个地方有问题，但不知道怎么解决
                title : window.did?"添加二维码":"编辑二维码",
                right :{
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
        };
        this.addHeader(option);
        // 添加图标
        option = {
            canAdd : true,
            icons : [],
            editable : true,
            class : "no-shake"
        };
        this.iconContainer = this.addImagePicker(option);
        option = {
            isEdge : true,
            lists : [
            {
                label:'姓名',
                rightText : '',
                moveTo : "#",
                __view_id : this.id,
                edit:{
                    type:'ref',
                    field:'userId',
                    moveTo:"#",
                    params:{
                        target:user.getOnSaleUrl(),
                        query:{
                            isUse:true,
                        },
                        searchField:"modelName",labelField:"modelName"
                    },
                    placeHolder:"必填"
                }
            },
            {
                label : '二维码是否临时',
                noArrow : true,
                edit : {
                    type : 'checkbox',
                    field : 'isTemp'
                }
            },
            {
                label:'临时的二维码过期时间',
                rightText : '',
                moveTo : "#",
                edit:{
                    type:'date',
                    field:'expireDate'
                }
            }],
          };
          this.addLists(option);
          this.onAfterShow();
        },
        // 点击完成是的响应事件
        onSaveStore : function() {
            window.busy();
            var m = this.getData();
            var iconItems = this.iconContainer.getChildren();
            //检查是否设置了图
            if (iconItems.length > 1) {
                m.logo = iconItems[0].icon;
            } else{
                m.logo = "";
            }
            // 检查必填项是否已填
            var msg=this.verify(m);
            if(msg){
                window.free();
                alert(msg);
                return;
            }
            m.images = detailImages;
            mat.save(m).then(function(data) {
                window.free();
                if(data.data.ok === 1){
                    //window.moveToView("qrCode");
                    history.back();
                }else{
                    alert("保存失败");
                    this.isEditing=true;
                }
            });
        },
        // 验证二维码是否存在
        verify:function(data){
            var msg="";
            if(!data.code){
                msg="二维码必填";
            }
            return msg;
        }
      });
    });