/**
 * Writer 杜飞军
 * Create Time 2016/05/20
 **/
//没有有效的使用已有事件接口
//初始化界面元素不够彻底
//数据刷新时修改界面元素状态不彻底
//之前的问题
//有无效代码
//属性命名
//尽可能使用标准方法
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "dojo/dom-class",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/discount",
    "cq/util/sys/date",
], function(declare, lang, View, domClass, _ViewMixin, discount, date) {
    // module:
    //        cq/ui/b/s/SelectCoupon
    return declare("cq.ui.b.selectCoupon", [View, _ViewMixin], {
        onAfterShow: function() {
            if (window.did) {
                discount.loadById(window.did).then(lang.hitch(this, function(data) {
                    if (data && data.data.item) {
                        // 活动有效期时间转换
                        var couData = data.data.item;
                        couData.startDate = date.formatISODateMinutes(couData.startDate);
                        couData.stopDate = date.formatISODateMinutes(couData.stopDate);
                        // 活动启用 不能进行编辑
                        // 判断当前时间是否大于等于开始时间
                        var time = new Date();
                        var start = Date.parse(couData.startDate) - Date.parse(time);
                        var stop = (Date.parse(couData.stopDate)) - Date.parse(time);
                        // 没有启用显示查看优惠券
                        if (!couData.using) {
                            domClass.remove(this.countSerBootom, 'none');
                            domClass.add(this.bootom, 'none');
                            domClass.add(this.countAllBootom, 'none');
                        }
                        // 启用并且没有开始活动 允许编辑
                        else if (couData.using && (start > 0) && (stop > 0)) {
                            domClass.add(this.countSerBootom, 'none');
                            domClass.remove(this.bootom, 'none');
                            domClass.add(this.countAllBootom, 'none');
                        }
                        // 启用并且正在活动中 显示停止和查看
                        else if (couData.using && (start < 0) && (stop > 0)) {
                            domClass.add(this.countSerBootom, 'none');
                            domClass.add(this.bootom, 'none');
                            domClass.remove(this.countAllBootom, 'none');
                        }
                        // 活动启用并且结束 只显示查看
                        else {
                            domClass.remove(this.countSerBootom, 'none');
                            domClass.add(this.bootom, 'none');
                            domClass.add(this.countAllBootom, 'none');
                        }
                        this.setData(couData);
                        this.refreshData();
                        this.resize();
                    }
                }));
            }
        },
        // 开始页面初始化
        onFirstShow: function() {
            var options = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "优惠活动",
                    onClick: function() {
                        history.back();
                    }
                },
                title: " "
            };
            this.addHeader(options);
            options = {
                isEdge: true,
                disabled: false,
                lists: [{
                    label: "活动名称",
                    rightText: "{{title}}"
                }, {
                    label: "活动开始时间",
                    rightText: "{{startDate}}"
                }, {
                    label: "活动结束时间",
                    rightText: "{{stopDate}}"
                }, {
                    label: "发放数量",
                    rightText: "{{totalNum}}"
                }, {
                    label: "满抵金额",
                    rightText: "{{reachAmount}}"
                }, {
                    label: "抵用金额",
                    rightText: "{{amount}}"
                }, {
                    label: "会员领取限额",
                    rightText: "{{userQuota}}"
                }, {
                    label: '活动说明',
                    rightText: "{{remark}}"
                }, {
                    label: "是否设置活动奖品",
                    rightText: "",
                    edit: {
                        type: 'checkbox',
                        field: 'isPrize'
                    }
                }, {
                    label: "是否使用",
                    rightText: "",
                    edit: {
                        type: 'checkbox',
                        field: 'using'
                    }
                }]
            };
            this.addLists(options);
            options = {
                columns: [{
                    label: "编辑",
                    className: "flex1 footer-tab-highlight",
                    onClick: lang.hitch(this, function() {
                        var data = this.getData();
                        window.moveToView("addCoupon", data._id);
                    })
                }],
                isFooter: true,
                forceWidth: false,
                className: "basedOnStatesView"
            };
            this.bootom = this.addColumns(options);
            domClass.add(this.bootom, 'none');
            options = {
                columns: [{
                    label: "查看优惠券",
                    className: "flex1 footer-tab-highlight",
                    onClick: lang.hitch(this, function() {
                        var data = this.getData();
                        window.moveToView("lookCountSer", data._id);
                    })
                }],
                isFooter: true,
                forceWidth: false,
                className: "basedOnStatesView"
            };
            this.countSerBootom = this.addColumns(options);
            domClass.add(this.countSerBootom, 'none');
            // 显示查看优惠券和停止活动
            options = {
                columns: [{
                    label: "查看优惠券",
                    className: "flex1 footer-tab-highlight",
                    onClick: lang.hitch(this, function() {
                        var data = this.getData();
                        window.moveToView("lookCountSer", data._id);
                    })
                }, {
                    label: "停止优惠活动",
                    className: "flex1 footer-tab-highlight",
                    onClick: lang.hitch(this, function() {
                        this.stopCount();
                    })
                }],
                isFooter: true,
                forceWidth: false,
                className: "basedOnStatesView"
            };
            this.countAllBootom = this.addColumns(options);
            this.onAfterShow();
        },
        // 停止活动处理
        stopCount: function() {
                discount.disableById(window.did).then(lang.hitch(this, function(data) {
                    domClass.remove(this.countSerBootom, 'none');
                    domClass.add(this.bootom, 'none');
                    domClass.add(this.countAllBootom, 'none');
                }));
            }
            // // 审核处理
            // onAssignVerify: function(){
            //     disCount.verifyById(window.did).then(lang.hitch(this,function(data){
            //         if(data.data.ok === 1){
            //             this.onAfterShow();
            //         }else{
            //             alert("审核失败");
            //         }
            //     }));
            // },
            // // 生成优惠券
            // onGenerateSeries: function(){
            //     disCount.generateSeries(window.did).then(lang.hitch(this,function(data){
            //         if(data && data.data.ok === 1){
            //             this.onAfterShow();
            //         }else{
            //             alert("生成优惠券失败");
            //         }
            //     }));
            // },
            // // 停止优惠券活动
            // onStopCoupon: function(){
            //     disCount.stopById(window.did).then(lang.hitch(this,function(data){
            //         if(data && data.data.ok === 1){
            //             this.onAfterShow();
            //         }else{
            //             alert("活动没有停止成功");
            //         }
            //     }));
            // },
            // // 发放范围显示处理
            // showDisType: function(disType){
            //     var type = "";
            //     if(disType === 0){
            //         type = "指定客户";
            //     }else if(disType === 1){
            //         type = "公开";
            //     }
            //     return type;
            // },
            // // 给选中的用户发送优惠券
            // onDistribute: function(){
            //     // 先获得当前优惠券的数据
            //     var distributeData = this.getData();
            //     // 指定客户发放数量不能大于创建的个数
            //     if(distributeData.num > 0){
            //         if(distributeData.distributedNum < distributeData.num){
            //             this.onSendDistribute();
            //         }else{
            //             alert("优惠券已经发完");
            //         }
            //     }else{
            //         // 公开下没有优惠券限制
            //         this.onSendDistribute();
            //     }
            //     // 可以发放优惠券的优惠活动：1未过期，已审核。未停用、已生成。且(公开或已发放数量小于总数量)
            // },
            // // 发放优惠券
            // onSendDistribute: function(){
            //     // 查询条件
            //     var params = {
            //         target:user.getUserUrl(),
            //         query:{},
            //         searchField:"pName",labelField:"pName"
            //     };
            //     // 选择客户
            //     jsonRef.startEdit("", this, params).then(lang.hitch(this,function(data){
            //         if(data && data._id){
            //         //    发放优惠券给客户
            //             disCount.distribute({
            //                 id: window.did,
            //                 userId: data._id
            //             }).then(lang.hitch(this,function(disData){
            //                 if(disData && disData.data.ok === 1){
            //                     alert("优惠券发放成功");
            //                 }else{
            //                     alert("优惠券发放失败");
            //                 }
            //             }));
            //         }else{
            //             // 没有选中的用户 提示没有客户
            //             alert("没有选中用户,不能发放优惠券");
            //         }
            //     }));
            // }
    });
});
