//创建人：周超   创建时间：2016-5-18  创建原因：平台设置
//  变更人:杜飞军
//  变更时间:2016/06/24
//  变更原因: 阻止等待时多次发送请求

//  变更人:母浚驰
//  变更时间:2016/09/26
//  变更原因: 增加是否自动签收
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/user/user"
    ],
    function (declare, lang, View, _ViewMixin, shop, user) {
        //路径：
        //    cq/ui/b/s/SetPlatform
        return declare("cq.ui.b.s.SetPlatform", [View, _ViewMixin], {
            //简介：
            //    平台设置：设置保证金，支付方式，支付信息，支付率以及补贴等
            //isEditing：Boolean
            //        设置编辑状态
            isEditing:false,
            //onAfterShow：
            //    参数：无，返回值：无
            //    加载/刷新页面数据
            onAfterShow:function(){
                if (!this.isEditing) {
                    //页面状态设置为修改中
                    this.isEditing=true;
                    // 如果是修改，加载信息
                    shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                        // 显示信息
                        //data.data.wxUrl = "http://log.cqthink.com/w/wx/"+data.data._id;
                        this.setData(data.data);
                        this.refreshData();
                    }));
                }
            },
            //onFirstShow：
            //        参数：无，返回值：无
            //        加载界面元素
            onFirstShow : function () {
                var option = {
                    left : {
                        iconButton : ' ',
                        arrow : "left",
                        label : "返回",
                        onClick : function () {
                            this.isEditing = false;
                            //window.moveToView("others");
                            history.back();
                        }
                    },
                    right : {
                        iconButton : ' ',
                        onClick : this.onSaveStore,
                        label : "完成"
                    },
                    title : "平台设置"
                };
                this.addHeader(option);
                option = {
                    isEdge : true,
                    class : "bottom-margin16",
                    lists : [{
                            label : '保证金金额',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'bailAmount',
                                placeHolder : "请输入保证金金额"
                            }
                        }, {
                            label : '结算周期',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'settlePeriod',
                                placeHolder : "请输入结算周期"
                            }
                        }
                    ]
                };
                this.addLists(option);
                //微信支付信息
                option = {
                    isEdge : true,
                    title : "微信支付信息",
                    class : "bottom-margin16",
                    lists : [{
                            label : '微信支付商家ID',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'wxPayMchId',
                                placeHolder : "请输入微信支付商家ID"
                            }
                        }, {
                            label : '微信支付秘钥文件',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'wxPayCert',
                                placeHolder : "请输入微信支付秘钥文件"
                            }
                        }, {
                            label : '微信支付api密码',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'wxPayPartnerKey',
                                placeHolder : "请输入微信支付api密码"
                            }
                        }
                    ]
                };
                this.addLists(option);
                //支付宝信息
                option = {
                    isEdge : true,
                    title : "支付宝信息",
                    class : "bottom-margin16",
                    lists : [{
                            label : '支付宝商家名',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'aliPayAccount',
                                placeHolder : "请输入支付宝商家名"
                            }
                        }, {
                            label : '支付宝商家id',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'aliPayMchId',
                                placeHolder : "请输入支付宝商家id"
                            }
                        }, {
                            label : '支付宝账号',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'aliPaySeller',
                                placeHolder : "请输入支付宝账号"
                            }
                        }, {
                            label : '支付宝支付api密码',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'aliPayPartnerKey',
                                placeHolder : "请输入支付宝支付api密码"
                            }
                        }
                    ]
                };
                this.addLists(option);
                //支付率
                option = {
                    isEdge : true,
                    class : "bottom-margin16",
                    title : "支付率",
                    //class : "bottom-margin16",
                    lists : [{
                            label : '微信支付率',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'wxPayFeeRate',
                                placeHolder : "请输入微信支付率"
                            }
                        }, {
                            label : '支付宝手机支付费率',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'aliWapFeeRate',
                                placeHolder : "请输入支付宝手机支付费率"
                            }
                        }, {
                            label : '支付宝网页支付费率',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'aliWebFeeRate',
                                placeHolder : "请输入支付宝网页支付费率"
                            }
                        }, {
                            label : '支付宝APP支付费率',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'aliAppFeeRate',
                                placeHolder : "请输入支付宝APP支付费率"
                            }
                        }, {
                            label : '平台手续费费率',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'platformFeeRate',
                                placeHolder : "请输入平台手续费费率"
                            }
                        }
                    ]
                };
                this.addLists(option);
                option = {
                    isEdge : true,
                    class : "bottom-margin16",
                    title : "补贴方式",
                    //class : "bottom-margin16",
                    lists : [{
                            label : '担保支付平台补贴',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'bailFeedbackRate',
                                placeHolder : "请输入担保支付平台补贴"
                            }
                        }, {
                            label : '货到付款补贴',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'casheFeebackRate',
                                placeHolder : "请输入货到付款补贴"
                            }
                        }, {
                            label : '余额支付补贴',
                            noArrow : true,
                            edit : {
                                type : 'text',
                                field : 'pointFeedbackRate',
                                placeHolder : "请输入余额支付补贴"
                            }
                        }
                    ]
                };
                this.addLists(option);
                option = {
                    isEdge : true,
                    class : "bottom-margin16",
                    title : "补贴方式",
                    //class : "bottom-margin16",
                    lists : [{
                        label : '是否自动签收',
                        edit : {
                            type : 'checkbox',
                            field : 'automaticReceipt'
                        }
                    }]
                };
                this.addLists(option);
                option = {
                    isEdge : true,
                    class : "bottom-margin16",
                    title : "责任人",
                    lists : [{
                            label : '平台责任人',
                            noArrow : false,
                            moveTo : "#",
                            edit : {
                                type : 'ref',
                                field : 'platformResponsible',
                                params : {
                                    target : user.getStaffUrl(),
                                    query : {},
                                    searchField : "search",
                                    labelField : "pName",
                                    getDataLabel: function(items){
                                        return  "<div style='float:left; width:50%;'>" 
                                                + items.pName
                                                + "</div> <div style='float:left; width:50%;'>" 
                                                + items.phone 
                                                + "</div><div style='clear:both;'></div>"
                                    }
                                }
                            }
                        }]
                };
                this.addLists(option);
                //加载页面数据
                this.onAfterShow();
            },
            //onSaveStore：
            //        参数：无，返回值：无
            //        点击完成，保存数据
            onSaveStore : function () {
                var shopData = this.getData();
                //var cs=/[^\d.]/g;
                //设置支付率
                if(shopData.wxPayFeeRate){
                    var payRate=parseFloat(shopData.wxPayFeeRate);
                    if(payRate>=1||isNaN(payRate)){
                        alert('微信支付率请填写小于1的小数');
                        return;
                    }
                }
                if(shopData.aliWapFeeRate){
                    var wapRate=parseFloat(shopData.aliWapFeeRate);
                    if(wapRate>=1||isNaN(wapRate)){
                        alert('支付宝手机支付率请填写小于1的小数');
                        return;
                    }
                }
                if(shopData.aliWebFeeRate){
                    var webRate=parseFloat(shopData.aliWebFeeRate);
                    if(webRate>=1||isNaN(webRate)){
                        alert('支付宝网页支付率请填写小于1的小数');
                        return;
                    }
                }
                if(shopData.aliAppFeeRate){
                    var appRate=parseFloat(shopData.aliAppFeeRate);
                    if(appRate>=1||isNaN(appRate)){
                        alert('支付宝APP支付率请填写小于1的小数');
                        return;
                    }
                }
                if(shopData.platformFeeRate){
                    var formRate=parseFloat(shopData.platformFeeRate);
                    if(formRate>=1||isNaN(formRate)){
                        alert('平台手续费费率请填写小于1的小数');
                        return;
                    }
                }
                //补贴格式设置
                if(shopData.bailFeedbackRate){
                    var bailRate=parseFloat(shopData.bailFeedbackRate);
                    if(isNaN(bailRate)){
                        alert("担保支付平台补贴的输入请调整为数字");
                        return;
                    }
                }
                if(shopData.casheFeebackRate){
                    var cashRate=parseFloat(shopData.casheFeebackRate);
                    if(isNaN(cashRate)){
                        alert("货到付款补贴的输入请调整为数字");
                        return;
                    }
                }
                if(shopData.pointFeedbackRate){
                    var pointRate=parseFloat(shopData.pointFeedbackRate);
                    if(isNaN(pointRate)){
                        alert("余额支付补贴的输入请调整为数字");
                        return;
                    }
                }
                //支付宝商家id填写格式
                if(shopData.aliPayMchId){
                    var aliMchId=parseFloat(shopData.aliPayMchId);
                    if(isNaN(aliMchId)){
                        alert("支付宝商家id的输入请调整为数字");
                        return;
                    }
                }
                //微信支付商家ID格式设置
                if(shopData.wxPayMchId){
                    var wxMchId=parseFloat(shopData.wxPayMchId);
                    if(isNaN(wxMchId)){
                        alert("微信支付商家id的输入请调整为数字");
                        return;
                    }
                }
                /*
                if(shopData.bailAmount===""||shopData.settlePeriod===undefined){
                    alert("请输入保证金金额");
                    return;
                }if(shopData.settlePeriod===""||shopData.settlePeriod===undefined){
                    alert("请输入结算周期");
                    return;
                }if(shopData.wxPayMchId===""||shopData.settlePeriod===undefined){
                    alert("微信支付商家ID");
                    return;
                }
                if(shopData.wxPayCert===""||shopData.settlePeriod===undefined){
                    alert("微信支付密钥文件");
                    return;
                }
                if(shopData.wxPayPartnerKey===""||shopData.settlePeriod===undefined){
                    alert("微信支付api密码");
                    return;
                }
                if(shopData.aliPayAccount===""||shopData.settlePeriod===undefined){
                    alert("支付宝商家名");
                    return;
                }
                if(shopData.aliPayMchId===""||shopData.settlePeriod===undefined){
                    alert("支付宝支付商家id");
                    return;
                }
                if(shopData.aliPaySeller===""||shopData.settlePeriod===undefined){
                    alert("支付宝账号");
                    return;
                }if(shopData.aliPayPartnerKey===""||shopData.settlePeriod===undefined){
                    alert("支付宝支付api密码");
                    return;
                }
                if(shopData.wxPayFeeRate===""||shopData.settlePeriod===undefined){
                    alert("微信支付费率");
                    return;
                }if(shopData.aliWapFeeRate===""||shopData.settlePeriod===undefined){
                    alert("支付宝手机支付费率");
                    return;
                }if(shopData.aliWebFeeRate===""||shopData.settlePeriod===undefined){
                    alert("支付宝网页支付费率");
                    return;
                }if(shopData.aliAppFeeRate===""||shopData.settlePeriod===undefined){
                    alert("支付宝APP支付费率");
                    return;
                }if(shopData.platformFeeRate===""||shopData.settlePeriod===undefined){
                    alert("平台手续费费率");
                    return;
                }if(shopData.bailFeedbackRate===""||shopData.settlePeriod===undefined){
                    alert("担保支付平台补贴");
                    return;
                }if(shopData.casheFeebackRate===""||shopData.settlePeriod===undefined){
                    alert("货到付款补贴");
                    return;
                }if(shopData.pointFeedbackRate===""||shopData.settlePeriod===undefined){
                    alert("余额支付补贴");
                    return;
                }
                */
                //设置shopData的svcID，orderCheckerId属性值的类型
                window.busy();
                shopData.svcId = shopData.svcId && shopData.svcId._id;
                shopData.orderCheckerId = shopData.orderCheckerId && shopData.orderCheckerId._id;
                shopData.platformResponsible = shopData.platformResponsible && shopData.platformResponsible._id;
                //bail.save(shopData).then(function (data) {
                shop.save(shopData).then(function (data) {
                    window.free();
                    if(data.data.ok === 1){
                        //topic.publish("whz/shop/changed", shopData);
                        this.isEditing = false;
                        //window.moveToView('others');
                        history.back();
                        alert("保存成功");
                    }else{
                        alert("保存失败");
                    }
                });
            }
    });
});