//变更人:肖芳圆
//变更时间:2016/5/17
//变更原因:代码规范,文件迁移
define([
    "dojo/_base/declare", "dojo/_base/lang", "dojo/topic", "dojox/mobile/View",
    "cq/ui/view/_ViewMixin", "cq/biz/shop/shop", "cq/biz/user/user", "dojo/on"
    ],
function(declare, lang, topic, View, _ViewMixin, shop, user, on) {
    //店铺配置页面对象
    return declare("cq.ui.b.s.Shop", [View, _ViewMixin], {
        //页面是否处于编辑状态
        isEditing:false,
        //加载数据,并显示到页面上
        onAfterShow: function() {
            if (!this.isEditing) {
                //页面状态设置为修改中
                this.isEditing = true;
                shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                    // 显示信息
                    data.data.wxUrl = "http://log.cqthink.com/w/wx/" + data.data._id;
                    this.setData(data.data);
                    this.refreshData();
                }));
            }
        },
        //初始化页面元素,绑定事件
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        this.isEditing = false;
                        history.back();
                    }
                },
                title: "店铺管理",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label: "店铺图标",
                    noArrow: false,
                    //rightIcon2 : this.shopData.logo,
                    edit: {
                        type: "image",
                        field: "logo"
                    },
                    class: "li-icon",
                    moveTo: "#"
                },{
                    label: '店铺名称',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'shopName',
                        placeHolder: "请输入店铺名称"
                    }
                },{
                    label: '店铺地址',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'address',
                        placeHolder: "请输入店铺地址"
                    }
                },{
                    label: '店铺简介',
                    rightText: '店铺详情',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'textarea',
                        field: 'brief',
                        placeHolder: "请输入店铺简介"
                    }
                }]
            };
            this.addLists(option);
            //客户信息
            option = {
                isEdge: true,
                title: "客户信息",
                class: "bottom-margin16",
                lists: [
                {
                    label: '客服电话',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'svcPhone',
                        placeHolder: "未设置"
                    }
                },{
                    label: '客服微信',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'svcWx',
                        placeHolder: "未设置"
                    }
                },{
                    label: '客服QQ',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'svcQQ',
                        placeHolder: "未设置"
                    }
                },{
                    label: '订单通知',
                    moveTo: "#",
                    edit: {
                        type: 'ref',
                        field: 'orderCheckerId',
                        placeHolder: "未设置",
                        params: {
                            target: user.getUserUrl(),
                            query: {},
                            searchField: "pName",
                            labelField: "pName"
                        }
                    }
                },{
                    label: '客服通知',
                    moveTo: "#",
                    edit: {
                        type: 'ref',
                        field: 'svcId',
                        params: {
                            target: user.getUserUrl(),
                            query: {},
                            searchField: "pName",
                            labelField: "pName"
                        }
                    }
                }]
            };
            this.addLists(option);
            //店铺信息
            option = {
                isEdge: true,
                title: "店铺信息",
                class: "bottom-margin16",
                lists: [
                {
                    label: '店主姓名',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactName',
                        placeHolder: "未填写"
                    }
                },{
                    label: '店主电话',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactPhone',
                        placeHolder: "未设置"
                    }
                },{
                    label: '店主微信',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactQQ',
                        placeHolder: "未设置"
                    }
                },{
                    label: '店主QQ',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactWx',
                        placeHolder: "未设置"
                    }
                }]
            };
            this.addLists(option);
            //电商信息
            option = {
                isEdge: true,
                title: "电商信息",
                class: "bottom-margin16",
                lists: [{
                    label: '销售区域',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'saleRegin',
                        placeHolder: "未设置"
                    }
                },{
                    label: '发货地点',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'shipAddress',
                        placeHolder: "未设置"
                    }
                },{
                    label: '自动关闭未付款订单',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'orderTimeout',
                        placeHolder: "请填写分钟数，买家下单超出时间后自动关闭订单，避免长期占用库存"
                    }
                },{
                    label: '直销包邮金额',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'shipFreeAmount',
                        placeHolder: "未设置"
                    }
                },{
                    label: '运费',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'postage',
                        placeHolder: "未设置"
                    }
                }]
            };
            this.addLists(option);
            //微信信息
            option = {
                isEdge: true,
                title: "微信信息",
                class: "bottom-margin16",
                lists: [{
                    label: '微信APPID',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'wxAppId',
                        placeHolder: "未设置"
                    }
                },{
                    label: '微信APPSEC',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'wxAppSec',
                        placeHolder: "未设置"
                    }
                },{
                    label: '微信配置Url',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'wxUrl',
                        placeHolder: '未设置',
                        disabled: "true"
                    }
                },{
                    label: '微信Token',
                    noArrow: true,
                    //rightText:'<button>复制</button>'
                    edit: {
                        type: 'text',
                        field: 'wxCqToken',
                        placeHolder: "未设置"
                    }
                },{
                    label: '订单状态模板',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'wxMsgTemplate',
                        placeHolder: "未设置"
                    }
                },{
                    label: '微信认证',
                    noArrow: true,
                    edit: {
                        type: 'checkbox',
                        field: 'wxVerification'
                    }
                },{
                    label: '快速登陆',
                    noArrow: true,
                    edit: {
                        type: 'checkbox',
                        field: 'wxAutoLogin'
                    }
                },{
                    label: '自动注册',
                    noArrow: true,
                    edit: {
                        type: 'checkbox',
                        field: 'wxAutoRegister'
                    }
                }]
            };
            this.addLists(option);
            //财务信息
            option = {
                isEdge: true,
                title: "财务信息",
                //class : "bottom-margin16",
                lists: [{
                    label: '支付宝账号',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'alipayAccount',
                        placeHolder: "未设置"
                    }
                },{
                    label: '开户行',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'bankName',
                        placeHolder: "未填写"
                    }
                },{
                    label: '账户名',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'bankAccountName',
                        placeHolder: "未设置"
                    }
                },{
                    label: '账号',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'bankAccountCode',
                        placeHolder: "未设置"
                    }
                },{
                    label: '收款人',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'payee',
                        placeHolder: "未填写"
                    }
                },{
                    label: '财务联系人姓名',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'fiName',
                        placeHolder: "未填写"
                    }
                },{
                    label: '财务联系人电话',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'fiPhone',
                        placeHolder: "未设置"
                    }
                },{
                    label: '财务联系人QQ',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'fiQQ',
                        placeHolder: "未设置"
                    }
                }]
            };
            this.addLists(option);
            var option = {
                columns: [{
                    label: '注销',
                    onClick: function() {
                        user.logout();
                        window.moveToView("main");
                    }
                },{
                    label: '修改密码',
                    onClick: function() {
                        window.moveToView("changePassword");
                    }
                },{
                    label: '预览店铺',
                    onClick: function() {
                        localStorage.setItem("from", "shop");
                        window.moveToView("iframe", encodeURIComponent(shop.getShopUrl() + "," + this.getData().shopName));
                    }
                }],
                labelClass: 'font-size1',
                className: 'padding-top-bottom16',
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        //保存数据
        onSaveStore: function() {
            var shopData = this.getData();
            // 重置内容
            shopData.svcId = shopData.svcId && shopData.svcId._id;
            shopData.orderCheckerId = shopData.orderCheckerId && shopData.orderCheckerId._id;
            for (var e in shopData) {
                if (shopData[e] == "" || shopData[e] === undefined) {
                    delete shopData[e];
                }
            }
            shop.save(shopData).then(function(data) {
                if(data.data.ok === 1){
                    topic.publish("whz/shop/changed", shopData);
                    this.isEditing = false;
                    //window.moveToView("home");
                    history.back();
                }else {
                    alert("保存失败!");
                }
            });
        }
    });
});