/**
 * 创建人: 杜飞军
 * 创建时间: 2016-07-06
 * 创建内容: 显示所有管理员
 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/JsonRest",
    "dojo/on",
    "dojo/dom-class",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shopUser"
], function(declare, lang, JsonRest, on, domClass, EdgeToEdgeStoreList, View, registry, _ViewMixin, shopUser) {
    return declare("cq.ui.b.s.ShopAdmin", [View, _ViewMixin], {
        // 初始化开始值
        start: 0,
        // 设置每次加载的条数
        pageSize: 10,
        // 设置查询条件
        setQuery: function(query) {
            this.start = 0;
            this.storeList.destroyDescendants();
            this.onLoadListData(this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            }), this.start, this.pageSize);
        },

        setRolr: function(val) {
            var admin = {
                '0': '普通管理员',
                '1': '高级管理员',
                '2': '采购员',
                '3': '销售员',
                '4': '财务'
            };
            return admin[val];
        },
        // 初始化相关接口
        onAfterShow: function() {
            if (this.storeList.store) {
                this.setQuery(this.storeList.get("query"));
            } else {
                this.onLoadListData(this.storeList.setStore(this.store, this.params, {
                    start: 0,
                    count: this.pageSize
                }), this.start, this.pageSize);
            }
            this.refreshData();
        },

        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "店铺管理员"
            };
            this.addHeader(option);

            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                "class": "icon-list-item",
                variableHeight: true,
                onComplete: lang.hitch(this, function(data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div>"
                            +"<div class='user-list-margin'>姓名:"+(data[i].userId.pName || '')+"</div>"
                            +"</div>"
                            +"<div class='webkit-list'>"
                    +"<div class='user-list-margin'>登录名:"+(data[i].userId.userName || '')+"</div>"
                            +"</div>"
                            +"<div class='webkit-list'>"
                            +"<div class='user-list-margin'>角色:"+this.setRolr(data[i].role)+"</div>"
                            +"</div>"
                            +"<div class='forth-btn'>"
                            +"<span class='deletequater float-right'>删除</span>"
                            +"<span class='editquater float-right'>编辑</span>"
                            +"</div>";
                        data[i]._logo=data[i].logo?data[i].logo:'images/userIcon.png';
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                // 查询条件
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap: { _label: "label", moveTo: "moveTo",_logo: "icon" }
            });
            // 创建数据源
            this.params = {};
            this.store = new JsonRest({ target: shopUser.loadUsers() });

            // 将数据源赋值给StoreList
            // this.storeList.setStore(this.store,this.params);
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            on(this.centerPanel, "afterscroll", lang.hitch(this, this.onLoadMore));

            // 添加底部
            option = {
                columns: [{
                    label: '添加店铺管理员',
                    icon: 'images/icon/crmicon.png',
                    iconClass: 'footer-tab-img',
                    onClick: function() {
                        window.moveToView("addShopAdmin");
                    }
                }],
                valueClass: 'font-size3',
                labelClass: 'font-size1',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },

        // 重写拖拽加载更多事件
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.pageSize)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function() {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        }), this.start, this.pageSize);
                    }), 1000);
                }
            }
        },

        // 重写List的点击事件
        onClickList: function(evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var dom = evt.target;
            var _id = li.params.userId._id;
            //编辑
            if (dom && domClass.contains(dom, "editquater")) {
                window.moveToView("addShopAdmin", _id);
            }
            //删除
            if (dom && domClass.contains(dom, "deletequater")) {
                var isDelete = confirm("确认删除管理员?");
                if (isDelete) {
                    shopUser.deleteByUser(_id).then(lang.hitch(this, function(data) {
                        if (data.data.ok === 1) {
                            alert("删除成功");
                            this.onAfterShow();
                        } else {
                            alert("删除失败");
                        }
                    }));
                }

            }
        },
    });
});
