﻿/*创建人：周科吉
  创建时间：2016-08-25
  创建内容：商品送编辑页面：包含title，wei，startTime，endTime,stopTime,amount,prizeId,isUse,mid
  */
  define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/policy/sale",
    "cq/util/sys/date",
    "cq/biz/mk/prize/prize",
    "cq/biz/mat/mat"
  ],function(declare,lang,View,_ViewMixin,sale,data,prize,mat){
      return declare("cq.ui.b.s.ShopAwardEdit",[View,_ViewMixin],{
          isEditing:false,
          //初始化界面元素
          onFirstShow:function(){
                var option = {
                    left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "商品送",
                    onClick: lang.hitch(this, function() {
                        this.isEditing = false;
                        history.back();
                        })
                    },
                    title: "",
                    right: {
                        iconButton: ' ',
                        onClick: lang.hitch(this, this.onComplete),
                        label: "完成"
                    }
                };
                this.addHeader(option);
                //添加编辑页面
                option = {
                    isEdge:true,
                    lists:[{
                        label:"活动名称",
                        rightText:"",
                        edit:{
                            type: "text",
                            field: "title"
                        }
                    },{
                        label:"开始时间",
                        rightText:"",
                        moveTo: "#",
                        edit:{
                            type: "dateMin",
                            field: "startTime"
                        } 
                    },{
                        label:"结束时间",
                        rightText:"",
                        moveTo: "#",
                        edit:{
                            type: "dateMin",
                            field: "endTime"
                        } 
                    },{
                        label:"停止时间",
                        rightText:"",
                        moveTo: "#",
                        edit:{
                            type: "dateMin",
                            field: "stopTime"
                        } 
                    },/*{
                        label:"积分数量",
                        rightText:"",
                        edit:{
                            type: "text",
                            field: "amount"
                        }
                    },*/{
                        label:"赠送积分",
                        rightText:"",
                        edit:{
                            type: "text",
                            field: "prizeQty"
                        }
                    },{
                        label:"抽奖活动",
                        noArrow:true,
                        rightText:"",
                        edit:{
                            type: "ref",
                            field: "prizeId",
                            params:{
                                target:prize.getLoadUrl(),
                                query:{},
                                searchField:"prizeName",
                                labelField:"prizeName"
                            }
                        } 
                    },{
                        label:"活动商品",
                        noArrow:true,
                        rightText:"",
                        edit:{
                            type: "ref",
                            field: "mId",
                            params:{
                                target:mat.getCurrentShopOnSaleUrl(),
                                query:{},
                                searchField:"mName",
                                labelField:"mName"
                            }
                        }
                    },{
                        label: '备注',
                        rightText: "",
                        moveTo: "#",
                        edit: {
                            type: "textarea",
                            field: "remark"
                        }
                    }]
                };
                this.addLists(option);
                this.onAfterShow();
            },
            onAfterShow:function(){
                // 选择事件后会导致重新请求 判断状态
                if (!this.isEditing) {
                    this.isEditing = true;
                    if (window.did) {
                        sale.loadById(window.did).then(lang.hitch(this, function(data) {
                            if (data && data.data.item) {
                                this.setData(data.data.item);
                                this.refreshData();
                            }
                        }));
                    } else {
                        // 如果页面先通过did进来 再从添加活动入口进来 会有数据 先清空
                        this.setData({ using: true });
                        this.refreshData();
                    }
                }
            },
            // 验证数据
            onVerify: function() {
                this.isEditing = true;
                var data = this.getData(),
                    msg = "",
                    time = new Date();
                if (!data.title) {
                    msg = "活动名称不能为空";
                }else if(!data.startTime){
                    msg ="请设置活动开始时间";
                }else if ((Date.parse(data.startTime) - Date.parse(time)) < 0) {
                    msg = "活动开始时间不能小于当前时间";
                }else if(!data.endTime){
                    msg = "请设置活动结束时间";
                } else if (Date.parse(data.stopTime) < Date.parse(data.startTime || 0)) {
                    msg = "活动结束时间不能小于开始时间";
                }  else if ((Date.parse(data.stopTime) - Date.parse(time)) < 0) {
                    msg = "活动结束时间不能小于当前时间";
                } else if (parseFloat(data.prizeQty || 0) < 0) {
                    msg = "赠送数量不能小于0";
                } 
                if (msg) {
                    alert(msg);
                    return false;
                } else {
                    if (data.distributeType === 1) {
                        data.num = 0;
                    } else if (data.distributeType === 0) {
                        if (data.num <= 0) {
                            alert("指定客户,发放优惠券必须大于0");
                            return false;
                        }
                    }
                    return true;
                }
            },
            // 完成提数据
            onComplete: function() {
                if (this.isEditing) {
                    var savePost = this.onVerify();
                    if (savePost) {
                        var data = this.getData();
                        //如果没有输入停止时间，默认跟结束时间相同
                        if(!data.stopTime){
                            data.stopTime=data.endTime;
                        }
                        if(!data.remark){
                            data.remark='';
                        }
                        sale.save(data).then(lang.hitch(this, function(dataMsg) {
                            if (dataMsg.data.ok === 1) {
                                this.isEditing = false;
                                history.back();
                            } else {
                                alert(dataMsg.data.message);
                            }
                        }));
                    }
                }
            },
      });
  });