//变更人:肖爱玲，变更时间:2016/5/21，变更原因:底部按钮样式修改、线下转账收款方信息默认
// 变更人 ： 潘云
// 变更时间 ： 2016-6-27
// 变更内容 ：修改余额的的小数点显示
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/DeferredList",
    "dojox/mobile/View",
    "dojo/store/Memory",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "dojo/request/xhr",
    "dojo/query",
    "dijit/registry",
    "cq/biz/shop/shop",
    "cq/biz/ts/pm/bail",
    "cq/biz/user/user",
    "cq/util/sys/date",
    "dojo/on",
    "dojo/dom-class"
],function(declare, lang, topic,DeferredList, View, Memory, EdgeToEdgeStoreList, _ViewMixin, xhr,
    query, registry, shop,bail, user,date,on,domClass) {
    return declare("cq.ui.b.s.ShopBailTransaction", [ View, _ViewMixin ], {
        isEditing:false,
        onAfterShow:function(){
            if(!this.isEditing){
                this.isEditing = true;
                var dfList = new DeferredList([
                    shop.loadCurrentShop(),
                    shop.loadCurrentFromPaltShop()
                ]);
                dfList.then(lang.hitch(this,function(result){
                    var data = result[0][1];
                    var paltData = result[1][1];
                    this.setData({
                        shopAvailableAmount : window.fixedTo(data.data.availableAmount,3),
                        shopBankName : paltData.data.bankName,
                        shopAccountName : paltData.data.bankAccountName,
                        shopAccountCode : paltData.data.bankAccountCode,
                        ioType:0,
                        tsType:1,
                        transferDate:date.nowISOString()
                    });
                    this.refreshData();
                }));
            }
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        this.isEditing = false;
                        //window.moveToView("shopBail");
                        history.back();
                    }
                },
                title : "保证金缴纳"
            };
            this.addHeader(option);
            option = {
                columns:[{
                    label:'在线缴纳',
                    className:'footer-tab-col-highlight sale',
                    onClick:lang.hitch(this,function(e){
                        var tsData = this.__data;
                        if(tsData.tsType==1) return;
                        tsData.tsType = 1;
                        domClass.add(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
                        domClass.remove(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
                        domClass.remove(this.onlineList.domNode,"hidden");
                        domClass.add(this.platformBank.domNode,"hidden");
                        domClass.add(this.payeeBank.domNode,"hidden");
                    })
                },{
                    label:'线下转账',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        var tsData = this.__data;
                        if(tsData.tsType==2) return;
                        tsData.tsType = 2;
                        domClass.add(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
                        domClass.remove(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
                        domClass.add(this.onlineList.domNode,"hidden");
                        domClass.remove(this.platformBank.domNode,"hidden");
                        domClass.remove(this.payeeBank.domNode,"hidden");
                    })
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label:'保证金用途',
                    rightText:"开通消费保障服务"
                },{
                    label:'生效时间',
                    rightText:"缴纳后立即生效"
                },{
                    label:'缴纳金额',
                    edit:{
                        type:'text',
                        placeHolder:"请填写要缴纳的金额",
                        field:'amount'
                    }
                },{
                    label:'店铺可用余额',
                    rightText:"{{shopAvailableAmount}}"
                }]
            };
            this.onlineList = this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16 hidden",
                lists: [{
                    label:'收款方开户行',
                    rightText:'{{shopBankName}}'
                },{
                    label:'收款方户名',
                    rightText:'{{shopAccountName}}'
                },{
                    label:'收款方开户账号',
                    rightText:'{{shopAccountCode}}'
                }]
            };
            this.platformBank = this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16 hidden",
                lists: [{
                    label:'付款方开户行',
                    edit:{
                        type:'text',
                        placeHolder:"例：招商银行 北京朝阳区支行",
                        field:'bankName'
                    }
                },{
                    label:'付款方户名',
                    edit:{
                        type:'text',
                        placeHolder:"请填写开户名称",
                        field:'bankOwner'
                    }
                },{
                    label:'付款方开户账号',
                    edit:{
                        type:'text',
                        placeHolder:"银行卡号",
                        field:'bankAccount'
                    }
                },{
                    label:'付款时间',
                    moveTo:"#",
                    edit:{
                        type:'date',
                        field:'transferDate'
                    }
                },{
                    label:'缴纳金额',
                    edit:{
                        type:'text',
                        placeHolder:"请填写要缴纳的金额",
                        field:'amount'
                    }
                }]
            };
            this.payeeBank = this.addLists(option);
            option = {
                isEdge:true,
                className: "flex2 footer-tab-highlight",
                columns:[{
                    label:"缴纳保证金",
                    onClick: lang.hitch(this, function(){
                        var bailData = this.getData();
                        if(!bailData.amount){
                            alert("请填写金额");
                            return;
                        }
                        if(bailData.tsType==2){
                            if(!bailData.bankName || !bailData.bankAccount || !bailData.bankOwner){
                                alert("信息填写不完整");
                                return;
                            }
                        }
                        bail.save(bailData).then(function(data){
                            if(data.data.ok==0){
                                alert(data.data.msg);
                            }
                            else{
                                alert("提交成功");
                                //window.moveToView("shopBail");
                                history.back();
                            }
                        });
                    })
                }],
                forceWidth: true,
                isFooter: true
            }
            this.addColumns(option);
            this.onAfterShow();
        }
    });
});