// 创建人：潘云
// 创建时间：2016-05-18
// 功能：店铺余额管理

// 变更人 ： 潘云
// 变更时间 ： 2016-6-27
// 变更内容 ：修改余额的的小数点显示
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dijit/registry",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop"
],function(declare, lang, domClass, registry, View, _ViewMixin,shop) {
    // module:
    //        cq/ui/b/s/ShopBalance
    return declare("cq.ui.b.s.ShopBail", [ View, _ViewMixin ], {
        onAfterShow:function(){
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 显示信息
                this.shopId = data.data._id;
                data.data.availableAmount = window.fixedTo(data.data.availableAmount,3);
                data.data.pendingAmount = window.fixedTo(data.data.pendingAmount,3);
                this.setData(data.data);
                this.refreshData();
            }));
        },
        // 第一次进入页面加载页面信息
        onFirstShow : function() {
            // 加载页面头部
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        //window.moveToView("shopConfig");
                        history.back();
                    }
                },
                title : "店铺余额"
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label:'可提现余额',
                    rightText: '{{availableAmount}}'
                }, {
                    label:'待结算余额',
                    rightText: '{{pendingAmount}}'
                }]
            };
            this.addLists(option);
            option = {
                isEdge: true,
                "class" : "bottom-margin16",
                lists : [{
                    label:'交易明细',
                    className : "amountRecord mblListItem",
                    moveTo : "#"
                }]
            };
            this.amoutLists = this.addLists(option);
            option = {
                columns : [{
                    label : '充值',
                    className : 'flex2 footer-tab-dark',
                    onClick : function () {
                        window.moveToView("shopBalanceTransaction");
                    }
                },{
                    label : '提现',
                    className : 'flex2 footer-tab-highlight',
                    onClick : function () {
                        window.moveToView("shopBalanceDeposit");
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.addColumns(option);
            // 为可提现余额和待确认余额绑定点击事件
            this.amoutLists.on("click",lang.hitch(this,this.onClickList));
            this.onAfterShow();
        },
        onClickList : function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            window.moveToView("transactionList",this.shopId);
        }
    });
});