// 创建人：潘云，创建时间：2016-05-19，功能：店铺余额提现
//变更人:肖爱玲，变更时间:2016/5/21，变更原因:底部按钮样式修改
// 变更人：潘云
// 变更时间：2016-06-24
// 功能：处理点击完成重复提交数据的问题

// 变更人 ： 潘云
// 变更时间 ： 2016-6-27
// 变更内容 ：修改余额的的小数点显示
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/DeferredList",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "cq/biz/shop/shop",
    "dojo/dom-class",
    "cq/biz/ts/pm/shopPayLog"
],function(declare, lang,DeferredList,View, _ViewMixin,query,shop,domClass,shopPayLog) {
    // module:
    //        cq/ui/b/s/ShopBalanceDeposit
    return declare("cq.ui.b.s.ShopBalanceDeposit", [ View, _ViewMixin ], {
        onAfterShow:function(){
            var dfList = new DeferredList([
                // 获取店铺的可用余额
                shop.loadCurrentShop(),
                // 获取店铺已申请提现，但未审核的总金额
                shopPayLog.loadByShopId({isVerified:false,ioType:1})
            ]);
            dfList.then(lang.hitch(this,function(result){
                var data = result[0][1];
                var shopdata = result[1][1];
                var amountSum = 0;
                if(shopdata.data.ok === 1){
                    shopdata = shopdata.data.items;
                    for(var i=0;i<shopdata.length;i++){
                        amountSum+=shopdata[i].amount;
                    }
                }
                this.setData({
                    availableAmount:window.fixedTo(data.data.availableAmount, 3),
                    bankName : data.data.bankName,
                    bankOwner : data.data.bankAccountName,
                    bankAccount : data.data.bankAccountCode,
                    amountSum : window.fixedTo(amountSum, 3)
                });
                this.refreshData();
            }));
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        //window.moveToView("shopBalance");
                        history.back();
                    }
                },
                title : "店铺余额提现申请"
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label:'店铺可用余额',
                    rightText:'{{availableAmount}}'
                },{
                    label:'店铺待审核金额',
                    rightText:'{{amountSum}}'
                },{
                    label:'提现金额',
                    edit:{
                        type:'text',
                        placeHolder:"请输入要提现的金额",
                        field:'amount'
                    }
                }]
            };
            this.addLists(option);
            option = {
                isEdge:true,
                className: "flex2 footer-tab-highlight",
                columns:[{
                    label:"确认提现",
                    onClick: lang.hitch(this, this.onSaveStore)
                }],
                forceWidth: true,
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        // 验证必填字段是否为空
        checkFiled : function(data){
            if(!(data.amount>0)){
                //输入内容必须为大于零的数字
                return "提现金额必须大于0";
            }
            if(!(0<=data.availableAmount-data.amount)){
                return "提现金额不能大于店铺可用余额";
            }
        },
        // 验证现有余额是否满足提现金额
        // checkAmount:function(shopdata){
            // var msg="";
            // if(parseFloat(shopdata.amount) > parseFloat(shopdata.availableAmount)){
                // msg = "提现金额不能大于店铺可用余额";
            // }
            // return msg;
        // },
        // 确认提现的点击事件
        onSaveStore : function() {
            window.busy();
            var shopdata = this.getData();
            // 将shopdata中的金额转换成数字类型的
            shopdata.amount = parseFloat(shopdata.amount);
            // 验证提现金额是否填写
            var msg=this.checkFiled(shopdata);
            if(msg){
                window.free();
                alert(msg);
                return;
            }
            // msg = this.checkAmount(shopdata);
            // if(msg){
                // window.free();
                // alert(msg);
                // return;
            // }
            shopdata.ioType = 1;
            // 将店铺的可用余额去掉，保存时不需要
            delete shopdata.availableAmount;
            shopPayLog.save(shopdata).then(lang.hitch(this,function(data){
                window.free();
                if(data.data.ok === 1){
                    alert("提现申请已经发送，请等待平台审核");
                    //window.moveToView("shopBalance");
                    history.back();
                }else{
                    alert("提现申请失败");
                }
            }));
        }
    });
});