// 创建人：潘云
// 创建时间：2016-05-19
// 功能：店铺余额详情
//  变更人:杜飞军
//  变更时间:2016/06/24
//  变更原因: 阻止等待时多次发送请求
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "cq/biz/ts/pm/shopPayLog",
    "dojo/dom-style",
],function (declare, lang, View, _ViewMixin, query, shopPayLog,domStyle) {
    // module:
    //        cq/ui/b/s/ShopBalanceDetail
    return declare("cq.ui.b.s.ShopBalanceDetail", [View, _ViewMixin], {
        onAfterShow : function () {
            shopPayLog.loadById(window.did).then(lang.hitch(this,function(data){
                // 已审核的数据
                var item = data.data.item;
                if(item.fromShopId){
                    this.fromShopId=item.fromShopId._id;
                    item.logo = item.fromShopId.logo||"";
                    item.shopName = item.fromShopId.shopName||"";
                    item.address = item.fromShopId.address||"";
                    item.fiName = item.fromShopId.fiName||"";
                    item.fiQQ = item.fromShopId.fiQQ||"";
                    item.fiPhone = item.fiPhone||"";
                }
                if(item.isVerified){
                    domStyle.set(query(".verified", this.footerColumns)[0],"display", "");
                    domStyle.set(query(".isVerified", this.footerColumns)[0],"display", "none");
                }else{
                    domStyle.set(query(".verified", this.footerColumns)[0],"display", "none");
                    domStyle.set(query(".isVerified", this.footerColumns)[0],"display", "");
                }
                this.setData(item);
                this.refreshData();
            }));
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        //window.moveToView("shopBalanceList");
                        history.back();
                    }
                },
                title : "店铺余额审核"
            };
            this.addHeader(option);
            // 店铺信息
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : "店铺图标",
                    rightIcon2 : '{{logo}}',
                    class : "li-icon"
                },{
                    label:"店铺名称",
                    rightText : '{{shopName}}'
                },{
                    label : '店铺地址',
                    rightText : '{{address}}',
                }]
            };
            this.addLists(option);
            //    充值信息
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : '银行账号',
                    rightText : '{{bankAccount}}'
                },{
                    label : '开户行',
                    rightText : '{{bankName}}'
                },{
                    label : '账户名称',
                    rightText : '{{bankOwner}}'
                },{
                    label : '金额',
                    rightText : '{{amount}}'
                },{
                    label : '流水号',
                    rightText : '{{tsCode}}'
                },{
                    label : '备注',
                    rightText : '{{remark}}'
                }]
            };
            this.addLists(option);
            // 财务人信息
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : '财务联系人姓名',
                    rightText : '{{fiName}}'
                },{
                    label : '财务联系人电话',
                    rightText : '{{fiPhone}}'
                },{
                    label : '财务联系人QQ',
                    rightText : '{{fiQQ}}'
                }]
            };
            this.addLists(option);
            // 添加底部按钮
            option = {
                isEdge : true,
                columns :[{
                    label : '已审核',
                    className : 'flex2 footer-tab-highlight verified'
                },{
                    label : '审核',
                    className : 'flex2 footer-tab-highlight isVerified',
                    onClick : lang.hitch(this,this.onVerify)
                },{
                    label : '查看明细',
                    className : 'flex2 footer-tab-dark isVerified',
                    onClick : lang.hitch(this,this.onMoveToDetail)
                }],
                forceWidth : false,
                isFooter : true
            };
            this.footerColumns=this.addColumns(option);
            this.onAfterShow();
        },
        onMoveToDetail : function(){
            window.moveToView("transactionList",this.fromShopId);
        },
        onVerify : function(){
            window.busy();
            shopPayLog.verify({
                _id : window.did
            }).then(lang.hitch(this,function(data){
                window.free();
                if(data.data.ok == 1){
                    //window.moveToView("shopBalanceList");
                    history.back();
                }else{
                    alert("审核未通过");
                }
            }));
        }
    });
});