// 创建人：潘云
// 创建时间：2016-05-18
// 功能：店铺余额审核
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/ts/pm/shopPayLog",
    "dojo/dom-class",
    "cq/util/sys/xlsx"
],function(declare,lang,array,View,_ViewMixin,query,registry,EdgeToEdgeStoreList,on,when,JsonRest,shopPayLog,domClass,xlsx){
    // module:
    //        cq/ui/b/s/ShopBalanceList
    return declare("cq.ui.b.s.ShopBalanceList",[View,_ViewMixin],{
        // 数据加载开始下标
        start:0,
        end:-1,
        // 每次加载数据的条数
        pageSize : 10,
        // 查询的数据类型，默认为充值
        ioType:"0",
        onAfterShow:function(){
            if(this.storeList.store){
                this.setQuery(this.storeList.get("query"));
            }else{
                var queryResult = this.storeList.setStore(this.store,this.queryWhere,{
                    start: 0,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
            this.refreshData();
        },
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        //window.moveToView("others");
                        history.back();
                    }
                },
                title:"店铺余额管理"
            };
            this.addHeader(option);
            option = {
                isEdge :true,
                isHeader : true,
                lists:[{
                    label:'审核类型',
                    rightText : '',
                    moveTo : "#",
                    edit:{
                        type:'options',
                        field:'ioType',
                        options:{
                            0:'充值',
                            1:'提现',
                        }
                    }
                }]
            };
            this.addLists(option);
            option = {
                placeHolder:"输入店铺名称，按回车查询",
                "class":"cqSearchBox",
                type:"search",
                isHeader : true,
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.shopName = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                isHeader : true,
                columns:[{
                    // 充值
                    label:'待审核',
                    onClick:lang.hitch(this,this.onIsState)
                },{
                    label:'已审核',
                    onClick:lang.hitch(this,this.onState)
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            option = {
                isFooter : true,
                columns : [{
                    label : "导出",
					className: 'flex2 footer-tab-highlight',
                    onClick : this.exportShopBalance
                }],
                labelClass: 'font-size1',
                className: "fix-footer"
            };
            this.addColumns(option); 
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                "class":"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        data[i]._label="<div class='mat-list-mname mat-list-margin'>商家名称："+(data[i].fromShopId.shopName||"")+
                            "</div><div class='mat-list-mname mat-list-margin'>商家地址："+(data[i].fromShopId.address?data[i].fromShopId.address:"")+
                            "</div><div class='mat-list-qty mat-list-margin'><span>金额："+ window.fixedTo((data[i].amount||0), 3)+
                            "</span><span class='mat-list-totalSale'>操作类型："+(data[i].ioType == 0?"充值":"提现")+"</span></div>";
                        data[i].moveTo="#";
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{
                    _label:"label",
                    moveTo:"moveTo"
                }
            });
            // 创建数据源
            this.queryWhere={
                ioType:0,
                isVerified:false
            };
            this.store = new JsonRest({target:shopPayLog.loadByPlatformId()});
            // 将数据源赋值给storeList
            //this.storeList.setStore(this.store,this.queryWhere);
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
            //首次进入默认未审核按钮选中
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.setData({
                ioType:0
            });
            this.onAfterShow();
        },
        //数据导出功能 11-16 程磊
        exportShopBalance : function(){
            var query = this.storeList.query;
            var url = shopPayLog.loadByPlatformId();
            // var queryString = "";
            // for(var item in query){
                // queryString += "&" + item + "=" + query[item];
            // }
            // url += queryString;
            var cols = [];
            cols[0] = {
                className:"large-width",
                field:"fromShopId.shopName",
                label:"商家名称",
            };
            cols[1] = {
                className:"large-width",
                field:"createAt",
                label:"申请时间"
            };
            cols[2] = {
                className:"large-width",
                field:"amount",
                label:"金额"
            };
            cols[3] = {
                className:"large-width",
                field:"bankAccount",
                label:"银行账号"
            };
            cols[4] = {
                className : "large-width",
                field : "bankName",
                label : "开户行"
            };
            cols[5] = {
                className : "large-width",
                field : "bankOwner",
                label : "账户名称"
            };
            cols[6] = {
                className : "large-width",
                field : "fromShopId.fiName",
                label : "财务联系人"
            };
            cols[7] = {
                className : "large-width",
                field : "fromShopId.address",
                label : "财务联系地址"
            };
            cols[8] = {
                type : "options",
                className : "large-width",
                field : "ioType",
                label : "操作类型",
                options : {
                    "0" : "充值",
                    "1" : "提现"
                }
            };
            cols[9] = {
                type : "options",
                className : "large-width",
                field : "isVerified",
                label : "是否审核",
                options : {
                    "true" : "已审核",
                    "false" : "未审核"
                }
            };
            xlsx.exportData(url,query,cols,Date.now().toString());
        },
        // 改变标签的样式
        claerLabelClass:function(evnt){
            array.forEach(query(".tab-selector",this.domNode),function(item){
                domClass.remove(item,"selected");
            });
            domClass.add(evnt.target,"selected");
        },
        // 点击待审核按钮的响应事件
        onIsState:function(evt){
            this.claerLabelClass(evt);
            var parms=this.storeList.get("query");
            parms.isVerified=false;
            this.setQuery(parms);
        },
        // 点击已审核按钮的响应事件
        onState: function(evt){
            this.claerLabelClass(evt);
            var parms=this.storeList.get("query");
            parms.isVerified=true;
            this.setQuery(parms);
        },
        //用户选择审核类型时的回调接口函数
        onDataChanged : function(field, oldValue, newValue){
            if((field==="ioType") && newValue){
                this.ioType = newValue;
            }
        },
        // 列表项的点击事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("shopBalanceDetail",_id);
        },
        onLoadMore : function (evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                }), 1000);
                }
            }
        },
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            query.ioType = this.ioType;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});