// 创建人：潘云
// 创建时间：2016-05-18
// 功能：店铺余额充值
// 变更人：潘云
// 变更时间：2016-06-24
// 功能：处理点击完成重复提交数据的问题

// 变更人 ： 潘云
// 变更时间 ： 2016-6-27
// 变更内容 ：修改余额的的小数点显示
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/DeferredList",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "cq/biz/shop/shop",
    "dojo/dom-class",
    "cq/biz/ts/pm/shopPayLog"
],function(declare, lang,DeferredList, View, _ViewMixin,query,shop,domClass,shopPayLog) {
    // module:
    //        cq/ui/b/s/ShopBalanceTransaction
    return declare("cq.ui.b.s.ShopBalanceTransaction", [ View, _ViewMixin ], {
        //设置页面的编辑状态
        isEditing:false,
        // 设置默认的选中的为在线缴纳
        tsType : 1,
        onAfterShow:function(){
            this.onLinkClick();
            if(!this.isEditing){
                this.isEditing = true;
                var dfList = new DeferredList([
                    shop.loadCurrentShop(),
                    shop.loadCurrentFromPaltShop()
                ]);
                dfList.then(lang.hitch(this,function(result){
                    var data = result[0][1]; // 当前店铺
                    var paltData = result[1][1]; // 平台方
                    this.setData({
                        availableAmount : window.fixedTo(data.data.availableAmount, 3),
                        shopBankName : paltData.data.bankName,
                        shopAccountName : paltData.data.bankAccountName,
                        shopAccountCode : paltData.data.bankAccountCode,
						bankName : data.data.bankName,
						bankOwner : data.data.bankAccountName,
						bankAccount : data.data.bankAccountCode
                    });
                    this.refreshData();
                }));
            }
        },
        // 在线缴纳按钮的点击事件
        onLinkClick : function(evt){
            if(this.tsType==1) return;
            this.tsType = 1;
            domClass.add(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
            domClass.remove(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
            domClass.remove(this.onlineList.domNode,"hidden");
            domClass.add(this.platformBank.domNode,"hidden");
            domClass.add(this.payeeBank.domNode,"hidden");
        },
        // 线下缴纳按钮的点击事件
        offLinkClick : function(evt){
            if(this.tsType==2) return;
            this.tsType = 2;
            domClass.add(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
            domClass.remove(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
            domClass.add(this.onlineList.domNode,"hidden");
            domClass.remove(this.platformBank.domNode,"hidden");
            domClass.remove(this.payeeBank.domNode,"hidden");
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        this.isEditing = false;
                        //window.moveToView("shopBalance");
                        history.back();
                    }
                },
                title : "店铺余额充值"
            };
            this.addHeader(option);
            option = {
                columns:[{
                    label:'在线缴纳',
                    className:'footer-tab-col-highlight sale',
                    onClick:lang.hitch(this,this.onLinkClick)
                },{
                    label:'线下转账',
                    className:'sale',
                    onClick:lang.hitch(this,this.offLinkClick)
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label:'生效时间',
                    rightText:"缴纳后立即生效"
                },{
                    label:'缴纳金额',
                    edit:{
                        type:'text',
                        placeHolder:"请填写要缴纳的金额",
                        field:'amount1'
                    }
                },{
                    label:'店铺可用余额',
                    rightText:"{{availableAmount}}"
                }]
            };
            this.onlineList = this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16 hidden",
                lists: [{
                    label:'收款方开户行',
                    rightText:'{{shopBankName}}'
                },{
                    label:'收款方户名',
                    rightText:'{{shopAccountName}}'
                },{
                    label:'收款方开户账号',
                    rightText:'{{shopAccountCode}}'
                }]
            };
            this.platformBank = this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16 hidden",
                lists: [{
                    label:'付款方开户行',
                    edit:{
                        type:'text',
                        placeHolder:"例：招商银行 北京朝阳区支行",
                        field:'bankName'
                    }
                },{
                    label:'付款方账户名',
                    edit:{
                        type:'text',
                        placeHolder:"请填写开户名称",
                        field:'bankOwner'
                    }
                },{
                    label:'付款方开户账号',
                    edit:{
                        type:'text',
                        placeHolder:"银行卡号",
                        field:'bankAccount'
                    }
                },{
                    label:'充值金额',
                    edit:{
                        type:'text',
                        placeHolder:"请填写要缴纳的金额",
                        field:'amount2'
                    }
                },{
                    label:'交易流水号',
                    edit:{
                        type:'text',
                        placeHolder:"请填写银行的流水单号",
                        field:'tsCode'
                    }
                },{
                    label:'备注',
                    edit:{
                        type:'text',
                        placeHolder:"请填写备注信息",
                        field:'remark'
                    }
                }]
            };
            this.payeeBank = this.addLists(option);
            option = {
                isEdge:true,
                className: "flex2 footer-tab-highlight",
                columns:[{
                    label:"确认充值",
                    onClick: lang.hitch(this, this.onSaveStore)
                }],
                forceWidth: true,
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        // 验证必填字段是否为空
        checkFiled : function(data){
            var msg="";
            if(!(data.amount>0)){
                return "金额必须大于零";
            }
            if(this.tsType == 2){
                if(!data.bankName || !data.bankAccount || !data.bankOwner){
                    msg = "付款方信息填写不完整";
                    return msg;
                }
            }
        },
        // 确认充值的点击事件
        onSaveStore : function() {
            window.busy();
            var shopdata = this.getData();
            if(this.tsType == 1){
                shopdata.amount=shopdata.amount1;
            }else if(this.tsType == 2){
                shopdata.amount=shopdata.amount2;
            }
            var msg=this.checkFiled(shopdata);
            if(msg){
                window.free();
                alert(msg);
                return;
            }
            // 如果是线下转账
            if(this.tsType == 2){
                shopdata.ioType = 0;
                shopdata = this.deleteSavaData(shopdata);
                shopPayLog.save(shopdata).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok === 1){
                        this.isEditing = false;
                        //window.moveToView("shopBalance");
                        history.back();
                    }else{
                        alert("充值失败");
                    }
                }));
            }
			if(this.tsType == 1){
				window.free();
				alert("在线缴纳还未开通，请使用线下转账！");
			}
        },
        // 对要提交的data进行筛选
        deleteSavaData:function(data){
            delete data.amount1;
            delete data.amount2;
            delete data.shopBankName;
            delete data.shopAccountName;
            delete data.shopAccountCode;
            delete data.availableAmount;
            delete data.shopId;
            return data;
        }
    });
});