/**
* 修改人: 杜飞军
* 修改时间: 2016-06-24
* 修改内容:
*         阻止等待时多次发送请求
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop"
],function(declare, lang, topic, View,  _ViewMixin, shop) {
    return declare("cq.ui.b.s.ShopBase", [ View, _ViewMixin ], {
        isEditing : false,
        //初始化相关接口
        onAfterShow:function(){
            if (!this.isEditing) {
                //页面状态设置为修改中
                this.isEditing = true;
                // 如果是修改，加载信息
                if (!window.did) {
                    shop.loadCurrentShop().then(lang.hitch(this, function (data) {
                        // 显示信息
                        data.data.wxUrl = "http://log.cqthink.com/w/wx/"+data.data._id;
                        this.setData(data.data);
                        this.refreshData();
                    }));
                }else {
                    this.setData({});
                    this.refreshData();
                }
            }
        },
        // 创建店铺的基本信息
        createShopBaseInfo : function () {
            var option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : "店铺图标",
                    noArrow : false,
                    edit : {
                        type:"image",
                        field:"logo"
                    },
                    class : "li-icon",
                    moveTo : "#"
                },{
                    label : '店铺名称',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'shopName',
                        placeHolder:"请输入店铺名称"
                    }
                },{
                    label : '店铺地址',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'address',
                        placeHolder : "请输入店铺地址"
                    }
                },{
                    label : '地理位置',
                    noArrow : false,
                    moveTo : "#",
                    edit : {
                        type : 'position',
                        lonField : 'lon',
                        latField : 'lat'
                    }
                },{
                    label : '店铺简介',
                    rightText : '店铺详情',
                    moveTo : "#",
                    edit : {
                        type : 'textarea',
                        field : 'brief',
                        placeHolder : "请输入店铺简介"
                    }
                }]
            };
            this.addLists(option);
        },
        // 创建店铺的客服信息
        createShopSvcInfo : function () {
            var option = {
                isEdge : true,
                title:"客户信息",
                class : "bottom-margin16",
                lists : [{
                    label : '客服电话',
                    noArrow : true,
                    edit : {type : 'text', field : 'svcPhone', placeHolder: "未填写"}
                },{
                    label : '客服微信',
                    noArrow : true,
                    edit : {type : 'text', field : 'svcWx', placeHolder: "未填写"}
                },{
                    label : '客服QQ',
                    noArrow : true,
                    edit : {type : 'text', field : 'svcQQ', placeHolder: "未填写"}
                }]
            };
            this.addLists(option);
        },
        // 创建店铺的店主信息
        createShopContactInfo : function () {
            var option = {
                isEdge : true,
                title:"店铺信息",
                class : "bottom-margin16",
                lists : [{
                    label : '店主姓名',
                    noArrow : true,
                    edit : {type : 'text', field : 'contactName', placeHolder: "未填写"}
                },{
                    label : '店主电话',
                    noArrow : true,
                    edit : {type : 'text', field : 'contactPhone', placeHolder: "未填写"}
                },{
                    label : '店主微信',
                    noArrow : true,
                    edit : {type : 'text', field : 'contactWx', placeHolder: "未填写"}
                },{
                    label : '店主QQ',
                    noArrow : true,
                    edit : {type : 'text', field : 'contactQQ', placeHolder: "未填写"}
                }]
            };
            this.addLists(option);
        },
        // 创建店铺的财务信息
        createShopFinanceInfo : function () {
            var option = {
                isEdge : true,
                title:"财务信息",
                class : "bottom-margin16",
                lists : [{
                    label : '支付宝账号',
                    noArrow : true,
                    edit : {type : 'text', field : 'aliPaySeller', placeHolder: "未填写"}
                },{
                    label : '开户行',
                    noArrow : true,
                    edit : {type : 'text', field : 'bankName', placeHolder: "未填写"}
                },{
                    label : '账户名',
                    noArrow : true,
                    edit : {type : 'text', field : 'bankAccountName', placeHolder: "未填写"}
                },{
                    label : '账号',
                    noArrow : true,
                    edit : {type : 'text', field : 'bankAccountCode', placeHolder: "未填写"}
                },{
                    label : '收款人',
                    noArrow : true,
                    edit : {type : 'text', field : 'payee', placeHolder: "未填写"}
                },{
                    label : '财务联系人姓名',
                    noArrow : true,
                    edit : {type : 'text', field : 'fiName', placeHolder: "未填写"}
                },{
                    label : '财务联系人电话',
                    noArrow : true,
                    edit : {type : 'text', field : 'fiPhone', placeHolder: "未填写"}
                },{
                    label : '财务联系人QQ',
                    noArrow : true,
                    edit : {type : 'text', field : 'fiQQ', placeHolder: "未填写"}
                }]
            };
            this.addLists(option);
        },
        // 用户自定义字段
        createShopDefinInfo : function(){
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        this.isEditing=false;
                        history.back();
                    }
                },
                right : {iconButton : ' ', onClick : lang.hitch(this,this.onSaveStore), label : "完成"},
                title : "店铺管理"
            };
            this.addHeader(option);
            // 基础信息
            this.createShopBaseInfo();
            // 客服信息
            this.createShopSvcInfo();
            // 店主信息
            this.createShopContactInfo();
            // 财务信息
            this.createShopFinanceInfo();
            // 用户自定义添加接口
            this.createShopDefinInfo();
            this.onAfterShow();
        },
        onSaveStore : function () {
            window.busy();
            var shopData = this.getData();
            // 重置内容
            shopData.svcId = shopData.svcId && shopData.svcId._id;
            shopData.orderCheckerId = shopData.orderCheckerId && shopData.orderCheckerId._id;
            for(var e in shopData){
                if (shopData[e] === "" || shopData[e] === undefined) {
                    delete shopData[e];
                }
            }
            shop.save(shopData).then(lang.hitch(this,function () {
                window.free();
                topic.publish("whz/shop/changed",shopData);
                this.isEditing = false;
                history.back();
            }));
        }
    });
});