// 变更日期：2016-5-19
// 变更人：母浚驰
// 变更原因：代码规范，预览页面
// 变更日期：2016-6-21
// 变更人：周科吉
// 变更原因：修复 店铺名称/支付方式/微信公众号集成/订单与客服通知建议在右边添加标签,提示是否已设置 的问题

// 变更人 ： 潘云
// 变更时间 ： 2016-6-27
// 变更内容 ：修改余额的的小数点显示

// 变更人: 杜飞军
// 变更时间: 2016-07-06
// 变更内容: 增加一个店铺管理员入口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojox/mobile/View",
    "dojo/dom-construct",
    "cq/ui/view/_ViewMixin",
    "cq/ui/b/a/_share",
    "cq/biz/shop/shop",
    "cq/biz/user/user"
],function(declare, lang, topic, View, domConstruct, _ViewMixin,_share, shop, user) {
    return declare("cq.ui.b.s.ShopConfig", [ View, _ViewMixin , _share], {
        // 加载数据,并显示到页面上
        onAfterShow:function(){
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 显示信息
                data.data.verficationStatusText = this.getVerStatusText(data.data.isVerified,data.data.isVerifySubmit);
                data.data.isTrustedPayText = data.data.isTrustedPay?"已加入":"未加入";
                data.data.isBailText = data.data.isBail?"已开通":"未开通";
                // 设置余额为 可提现余额+可结算余额
                var sumAmount = data.data.availableAmount+data.data.pendingAmount?data.data.availableAmount+data.data.pendingAmount:0;
                data.data.sumAmount = window.fixedTo(sumAmount,3);
                this.setData(data.data);
                this.refreshData();
            }));
        },
        // 获取店铺认证状态
        getVerStatusText : function (isVerified,isVerifySubmit) {
            var statusText = "";
            if (isVerifySubmit === 0  && !isVerified) {
                statusText = "未认证";
            }
            if (isVerifySubmit === -1 && !isVerified){
                statusText = "已驳回";
            }
            if (isVerifySubmit === 1 && !isVerified){
                statusText = "待审核";
            }
            if (isVerified && isVerifySubmit === 2){
                statusText = "已认证";
            }
            return statusText;
        },
        // 初始化页面元素,绑定事件
        onFirstShow : function() {
            //1.显示店铺名称和店铺图标:shopBase
            //2.会员俱乐部:shopClub
            //3.label：店铺装修，rightText：请选择店铺风格,shopDecoration
            //4.店铺认证:shopVerification
            //5.担保交易:shopSecure
            //6.保证金缴纳:shopBail
            //7.支付方式:shopPay
            //8.交易和物流通知:shopCustomerMsg
            //9.客服消息设置:shopServiceMsg
            //10.底部按钮：预览，店铺二维码（参考刘轩的设计,shopQrCode），推广店铺
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        //  变更人:肖芳圆
                        //  变更时间:2016/6/20
                        //  变更原因:解决通过返回按钮进入iframe后返回不了的问题
                        window.moveToView("home");
                        //history.back();
                    }
                },
                title : "店铺管理"
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                class : "top-bottom-margin16",
                lists : [{
                    rightIcon2 : "{{logo}}",
                    label:"{{shopName}}",
                    class : "li-icon",
                    onClick:function(){window.moveToView("shopBase");},
                    moveTo:"#"
                },{
                    label:"店铺装修",
                    rightText:"请选择店铺风格",
                    onClick:function(){window.moveToView("shopDecoration");},
                    moveTo:"#"
                }]
            };
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [/*{
                    label:"加入会员俱乐部",
                    rightText:"{{verficationStatusText}}",
                    onClick:function(){window.moveToView("shopClub");},
                    moveTo : "#"
                },*/{
                    label:"店铺认证",
                    rightText:"{{verficationStatusText}}",
                    onClick:function(){
                    window.moveToView("shopVerification");
                    },
                    moveTo : "#"
                },/*{
                    label:"担保交易",
                    rightText:"{{isTrustedPayText}}",
                    onClick:function(){window.moveToView("shopSecure");},
                    moveTo : "#"
                },*/{
                    label:"店铺余额",
                    rightText:"{{sumAmount}}",
                    onClick:function(){window.moveToView("shopBalance");},
                    moveTo : "#"
                },{
                    label:"店铺管理员",
                    onClick:function(){
                        window.moveToView("shopAdmin");
                    },
                    moveTo : "#"
                }/*{
                    label:"保证金保障",
                    rightText:"{{isBailText}}",
                    onClick:function(){window.moveToView("shopBail");},
                    moveTo : "#"
                }*/]
            };
            this.addLists(option);
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label:"支付方式",
                    onClick:function(){
                        window.moveToView("shopPay");
                    },
                    moveTo : "#"
                },{
                    label:"微信公众号集成",
                    onClick:function(){
                        window.moveToView("shopWeiXin");
                    },
                    moveTo : "#"
                },{
                    label:"订单与客服通知",
                    onClick:function(){
                        window.moveToView("shopCustomerMsg");
                    },
                    moveTo : "#"/*
                },{
                    label:"客户消息设置",
                    rightText:"{{verficationStatusText}}",
                    onClick:function(){window.moveToView("shopServiceMsg");},
                    moveTo : "#"*/
                }]
            };
            this.addLists(option);
            option = {
                columns:[{
                    label:'预览',
                    onClick:function(){
                        localStorage.setItem("from","shopConfig");
                        window.moveToView("iframe",encodeURIComponent(shop.getShopUrl()+","+this.getData().shopName));
                    }
                },{
                    label:'店铺二维码',
                    onClick:function(){
                        window.moveToView("shopQrCode");
                    }
                },{
                    label:'推广店铺',
                    onClick:lang.hitch(this,this.showShare)
                }],
                labelClass:'font-size1',
                className:'padding-top-bottom16',
                isFooter:true
            };
            this.addColumns(option);
            this.onAfterShow();
        }
        /*
        onSaveStore : function() {
            var shopData = this.getData();
            // 重置内容
            shopData.svcId = shopData.svcId && shopData.svcId._id;
            shopData.orderCheckerId = shopData.orderCheckerId && shopData.orderCheckerId._id;
            for(var e in shopData){
                if(shopData[e] == "" || shopData[e] === undefined) {
                    delete shopData[e];
                }
            }
            shop.save(shopData).then(function() {
                topic.publish("whz/shop/changed",shopData);
                this.isEditing=false;
                window.moveToView("home");
            });
        }*/
    });
});