//变更人:王龙 变更时间:2016/6/22 变更内容；隐藏订单状态模板字段
// 变更人:徐阿雪
// 变更时间:2016/6/24
// 变更原因:页面处理时候的busy和Free,防止重复提交
//变更人:王龙
//变更时间:2016/7/6/22
//变更内容:添加包邮金额字段，添加运费字段，添加发货地点和销售区域，并单列一栏
// 变更人:徐阿雪
// 变更时间:2016/7/8
// 变更原因:包邮金额设置为只能为数字和小数位数处理
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/View",
    "dojo/store/Memory",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "dojo/request/xhr",
    "dojo/query",
    "dijit/registry",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "dojo/on"
], function(declare, lang, topic, domClass, domStyle, View, Memory, EdgeToEdgeStoreList, _ViewMixin, xhr,
    query, registry, shop, user, on) {
    return declare("cq.ui.b.s.ShopCustomerMsg", [View, _ViewMixin], {
        // 显示管理运费模板
        isShow: false,
        isEditing: false,
        onAfterShow: function() {
            if (this.isEditing) return;
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                this.isEditing = true;
                //window.fixedTo(data.data.dirLmt,3);
                if (data && data.data && data.data.freightTemplated) {
                    this.isShow = data.data.freightTemplated;
                    domClass.remove(this.footerButton, 'none');
                } else {
                    this.isShow = data.data.freightTemplated;
                    domClass.add(this.footerButton, 'none');
                }
                this.setData(data.data);
                this.refreshData();
                this.resize();
                //销售区域样式设置
                var selectLand = query(".saleLand",this.domNode)[0];
                domStyle.set(selectLand.parentNode,"margin-top","0px");
                domStyle.set(selectLand.parentNode,"width","69%");
            }));
        },
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        this.isEditing = false;
                        //window.moveToView("shopConfig");
                        history.back();
                    }
                },
                right: { iconButton: ' ', onClick: this.onSaveStore, label: "完成" },
                title: "订单与客服通知"
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                title: "电商信息",
                class: "top-bottom-margin16",
                lists: [{
                    label: '新订单消息通知',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'ref',
                        field: 'orderCheckerId',
                        //更改人：郭周全  更改调用接口
                        params: {
                            target: user.getStaffUrl(),
                            query: {},
                            searchField: "search",
                            labelField: "pName",
                            getDataLabel: function(items) {
                                return "<div style='float:left; width:50%;'>" + items.pName + "</div> <div style='float:left; width:50%;'>" + items.phone + "</div><div style='clear:both;'></div>";
                            }
                        }
                    }
                }, {
                    label: '新客服消息通知',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'ref',
                        field: 'svcId',
                        //更改人：郭周全  更改调用接口
                        params: {
                            target: user.getStaffUrl(),
                            query: {},
                            searchField: "search",
                            labelField: "pName",
                            getDataLabel: function(items) {
                                return "<div style='float:left; width:50%;'>" + items.pName + "</div> <div style='float:left; width:50%;'>" + items.phone + "</div><div style='clear:both;'></div>";
                            }
                        }
                    }
                }, {
                    label: '自动关闭未付款订单',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'orderTimeout',
                        placeHolder: "填写分钟数,买家下单超出时间后自动关闭订单"
                    }
                }]
            };
            this.addLists(option);
            //添加一个option，用来添加包邮字段，运费字段，发货地点和销售区域
            option = {
                isEdge: true,
                class: "top-bottom-margin16",
                lists: this.addModoleList()
            };
            this.addLists(option);
            option = {
                columns: [{
                    label: "管理运费模板",
                    className: 'flex2 footer-tab-highlight noverify',
                    onClick: function() {
                        window.moveToView('freightList');
                    }
                }],
                forceWidth: false,
                isFooter: true
            };
            this.footerButton = this.addColumns(option);
            // 默认不显示
            this.onAfterShow();
        },
        // 提供一个可重写的基类
        addModoleList: function() {
            return [
            /*{
                label: '包邮金额',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'dirLmt',
                }
            }, {
                label: '运费',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'tranFee',
                }
            },*/ {
                label: '发货地点',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'tranAddr'
                }
            }, {
                label : '销售区域',
                rightText : "<div class='saleLand' style='word-wrap: break-word'>{{tranRegion}}</div>",
                moveTo : "#",
                variableHeight : true,
                onClick:lang.hitch(this,function(){
                    this.isEditing = false;
                    window.moveToView("positionList");
                })
            }, {
                label: '启用运费模板',
                edit: {
                    type: 'checkbox',
                    field: 'freightTemplated'
                },
                onClick: lang.hitch(this, function(e) {
                    var domNode = registry.getEnclosingWidget(e.target);
                    if (e.target && domNode.declaredClass === "dojox.mobile.Switch") {
                        this.isShow = !this.isShow;
                        if (this.isShow) {
                            domClass.remove(this.footerButton, 'none');
                        } else {
                            domClass.add(this.footerButton, 'none');
                        }
                        this.resize();
                    }
                })
            }];
        },
        onSaveStore: function() {
            // 徐阿雪  页面处理时候的busy和Free,防止重复提交， 2016/6/24
            window.busy();
            var shopData = this.getData();
            var msg = this.checkData(shopData);
            if (msg) {
                window.free();
                alert(msg);
                return;
            }
            // 重置内容
            //window.fixedTo(shopData.dirLmt,3);
            shopData.svcId = shopData.svcId && shopData.svcId._id;
            shopData.orderCheckerId = shopData.orderCheckerId && shopData.orderCheckerId._id;
            //对删除运费和包邮限制进行修改（在为空的时候也要提交给后台）   徐阿雪 2016/7/22
            if (!shopData.dirLmt) {
                shopData.dirLmt = "";
            }
            if (!shopData.tranFee) {
                shopData.tranFee = "";
            }
            if (!shopData.tranRegion) {
                shopData.tranRegion = "";
            }
            if (!shopData.tranAddr) {
                shopData.tranAddr = "";
            }
            shop.save(shopData).then(lang.hitch(this, function() {
                window.free();
                topic.publish("whz/shop/changed", shopData);
                this.isEditing = false;
                //window.moveToView("shopConfig");
                history.back();
            }));
        },
        //添加包邮金额如果不是数字给出提示  2016/7/8 徐阿雪
        checkData: function(data) { //  !isNumber(data.dirLmt)
            if (data.dirLmt && (data.dirLmt - 0 < 0 || isNaN(data.dirLmt))) {
                return "包邮金额输入不合法";
            } else if (data.tranFee && (data.tranFee - 0 < 0 || isNaN(data.tranFee))) {
                return "运费输入不合法";
            }
        }
    });
});
