//  变更人:肖芳圆
//  变更时间:2016/5/18
//  变更原因:模板无法录入,选择商品不自动设置url/title/img
//  变更人:肖芳圆
//  变更时间:2016/6/17
//  变更原因:热销、品类支持配置一行几列，总共显示几个
//  变更人:肖芳圆
//  变更时间:2016/6/21
//  变更原因:陈列位编辑的时候,不选择商品会导致显示undefined到页面中bug
//  变更人:肖芳圆
//  变更时间:2016/6/22
//  变更原因:是否启用按钮只在平台店铺显示,否则不显示
//  变更人:杜飞军
//  变更时间:2016/06/24
//  变更原因: 阻止等待时多次发送请求
//  变更人:肖芳圆
//  变更时间:2016/07/11
//  变更原因: 显示供求信息的货架类型的处理
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/request/xhr",
    "dojo/query",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/on",
    "dojo/dom",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/touch",
    "dojox/mobile/iconUtils",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dojox/mobile/ContentPane",
    "dojo/dom-attr",
    "dojox/mobile/Overlay",
    "dojox/mobile/parser",
    "dojo/store/JsonRest",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "cq/biz/shop/shelf",
    "cq/biz/mat/mat",
    "cq/biz/mat/group",
    "cq/util/config/config"
], function(declare, lang, topic, View, EdgeToEdgeStoreList, xhr, query,
registry, array, connect, on, dom, domClass, domConstruct, domStyle, touch, iconUtils, Deferred, DeferredList, ContentPane, domAttr, Overlay, parser, JsonRest, _ViewMixin, shop, user, shelf, mat, matGroup, config) {
    //货架对象，用于呈现一个货架(一组楼层)，包含若干个楼层对象，用来处理楼层之间关系的调整
    var ShelfClass = declare("", null, {
        //可编辑的标志
        editable: false,
        //当前货架楼层列表
        floors: null,
        // curFloor:null,
        _connections: null,
        _addFloorNode: null,
        //构造函数，做基本的初始化
        constructor: function(args, domNode) {
            //本货架的根节点
            this.domNode = domNode;
            //初始化楼层无关的节点和事件
            this.initElement();
            //更新本货架的编辑状态
            this.setEditable(args.editable || false);
            //更新本货架的楼层信息
            this.refresh(args.data || []);
            //选择布局的方法
            // this.selectLayout = args.selectLayout;
            // this.showBoxEditElement = args.showBoxEditElement;
            this.selectGroup = args.selectGroup;
        },
        initElement: function() {
            this._connections = [];
            this.floors = [];
            //新增添加楼层的节点
            domConstruct.create("div", {
                "class": "shelfAddFloor",
                "innerHTML": "添加橱窗"
            },
            this._addFloorNode = domConstruct.create("div", {}, this.domNode));
            //绑定添加楼层节点的点击事件
            this._connections.push(
            connect.connect(this._addFloorNode, "onclick", this, function() {
                //调用选取布局的方法
                this.selectLayout().then(lang.hitch(this, function(layout) {
                    if (layout) {
                        //依据布局添加楼层
                        this._addFloor({
                            layout: layout
                        });
                        // 如果每个商家都需要重新做首页的话,那就说明首页设计得不合理,需要做变更的就是首页了
                        if (layout == 9) {
                            // 如果是添加锁定在底部按钮,则直接给用户生成一已经将陈列位数据处理好了的楼层
                        }
                    }
                }));
            }));
        },
        refresh: function(datas) {
            //销毁楼层
            while (this.floors.length) {
                this.floors[0].destroyRecursive();
            }
            //初始化楼层
            this.floors = [];
            array.forEach(datas, function(data) {
                this._addFloor(data);
            }, this);
            //隐藏锁定节点
            var len = this.floors.length - 2;
            while (len > 0) {
                this.floors[len].setPosNode(false);
                len--;
            }
            if (this.floors.length > 0 && this.editable === true) {
                this.initPosFloorNode(this.floors[0], this.floors[0].pos);
                this.initPosFloorNode(this.floors[this.floors.length - 1],
                this.floors[this.floors.length - 1].pos);
            }
        },
        getData: function() {
            //加载楼层数据
            return array.map(this.floors,
            function(floor) {
                return floor.getData();
            });
        },
        setEditable: function(editable) {
            //设置每个楼层的可编辑
            array.forEach(this.floors,
            function(floor) {
                floor.setEditable(editable);
            });
            //修改本对象的可编辑
            this.editable = editable;
            //依据是否可编辑显示隐藏添加楼层按钮
            domStyle.set(this._addFloorNode, "display",
            this.editable ? "" : "none");
        },
        _addFloor: function(data) {
            if (this.floors.length) {
                this.floors[this.floors.length - 1].setMoveDown(true);
            }
            if (this.floors.length > 1 && !data.pos && this.floors[this.floors.length - 1].pos == 2) {
                this.floors[this.floors.length - 1].setPosNode(false);
            }
            data.shelf = this;
            data.editable = this.editable;
            data.moveDown = false;
            data.moveUp = this.floors.length > 0;
            data.showBoxEditElement = this.showBoxEditElement;
            data.selectGroup = this.selectGroup;
            //根据布局添加楼层
            this.floors.push(new FloorClass(
            data, domConstruct.create("div", {
                "style": "position:relative;"
            }, (!data.pos && this.floors.length && (this.floors[this.floors.length - 1].pos == 3)) ? this.floors[this.floors.length - 1].domNode : this._addFloorNode, "before")));
            //最后一楼锁定时，添加新楼层时，倒数第一楼（即新添加的楼层）隐藏锁定节点，倒数第三楼隐藏向下的移动节点
            if (this.floors.length && this.floors[this.floors.length - 2] && this.floors[this.floors.length - 2].pos == 3) {
                //将新添加的楼层与原来的最后一楼交换顺序
                var tempFloor = this.floors[this.floors.length - 1];
                this.floors[this.floors.length - 1] = this.floors[this.floors.length - 2];
                this.floors[this.floors.length - 2] = tempFloor;
                this.floors[this.floors.length - 2].setPosNode(false);
                this.floors[this.floors.length - 1].setMoveDown(false);
            }
            return this.floors[this.floors.length - 1];
        },
        //修改删除楼层方法为公共方法
        deleteFloor: function(floor) {
            var index = array.indexOf(this.floors, floor);
            if (this.floors.length > 1) {
                if (0 === index && this.floors[0].pos != 1) {
                    this.floors[1].setMoveUp(false);
                    this.floors[1].setPosNode(true);
                }
                //第一楼锁定时，删除第二楼，隐藏第三楼的上移按钮
                if (1 === index && this.floors[0].pos == 1 && this.floors.length > 2) {
                    this.floors[2].setMoveUp(false);
                }
                //最后一楼未锁定，删除最后一楼时，隐藏倒数第二楼的下移按钮
                if (this.floors.length - 1 === index && this.floors[this.floors.length - 1].pos != 3) {
                    this.floors[this.floors.length - 2].setMoveDown(false);
                    this.floors[this.floors.length - 2].setPosNode(true);
                }
                //最后一楼锁定时，删除倒数第二个，隐藏倒数第三个的下移按钮
                if (this.floors.length - 2 === index && this.floors[this.floors.length - 1].pos == 3 && this.floors.length > 2) {
                    this.floors[this.floors.length - 3].setMoveDown(false);
                }
                //只有四楼，且第一楼和最后一楼都锁定
                if (this.floors.length === 4 && this.floors[0].pos == 1 && this.floors[this.floors.length - 1].pos == 3) {
                    if (index == 2) {
                        this.floors[1].setMoveUp(false);
                        this.floors[1].setPosNode(false);
                    }
                    if (index == 1) {
                        this.floors[2].setMoveUp(false);
                        this.floors[2].setPosNode(false);
                    }
                }
            }
            //删除指定的楼层
            floor.destroyRecursive();
        },
        //修改移动楼层方法为公共方法
        moveFloor: function(floor, isUp) {
            //移动指定楼层，每次只能向上/下移动一个节点
            var index = array.indexOf(this.floors, floor);
            //删除当前节点
            this.floors.splice(index, 1);
            //向上/下添加当前节点
            domConstruct.place(floor.domNode,
            this.floors[isUp ? index - 1 : index].domNode,
            isUp ? "before" : "after");
            this.floors.splice(isUp ? index - 1 : index + 1, 0, floor);
            if (this.floors.length === 2) {
                //只有两个直接刷新即可
                this.floors[0].setMoveUp(false);
                this.floors[0].setMoveDown(true);
                this.floors[1].setMoveUp(true);
                this.floors[1].setMoveDown(false);
                //设置锁定
                this.floors[0].setPosNode(true);
                this.floors[1].setPosNode(true);
            } else {
                if (this.floors.length === 4 && this.floors[0].pos == 1 && this.floors[this.floors.length - 1].pos == 3) {
                    this.floors[1].setMoveUp(false);
                    this.floors[1].setMoveDown(true);
                    this.floors[2].setMoveUp(true);
                    this.floors[2].setMoveDown(false);
                } else {
                    if (index === 0 && false === isUp && this.floors[0].pos != 1 || isUp && index === 1 && this.floors[0].pos != 1) {
                        //第零个下移和第一个上移，设置前两个
                        this.floors[0].setMoveUp(false);
                        this.floors[0].setMoveDown(true);
                        this.floors[1].setMoveUp(true);
                        this.floors[1].setMoveDown(true);
                        //设置锁定
                        this.floors[0].setPosNode(true);
                        this.floors[1].setPosNode(false);
                        // this.floors[1].setMoveUp(false);
                    } else if (index === this.floors.length - 1 && isUp && this.floors[this.floors.length - 1].pos != 3 || index === this.floors.length - 2 && false === isUp && this.floors[this.floors.length - 1].pos != 3) {
                        //最后一个上移和倒数第二个下移修改最后两个
                        this.floors[this.floors.length - 1].setMoveUp(true);
                        this.floors[this.floors.length - 1].setMoveDown(false);
                        this.floors[this.floors.length - 2].setMoveUp(true);
                        this.floors[this.floors.length - 2].setMoveDown(true);
                        //设置锁定
                        this.floors[this.floors.length - 1].setPosNode(true);
                        this.floors[this.floors.length - 2].setPosNode(false);
                        // this.floors[this.floors.length - 2].setMoveDown(false);
                    }
                    //其他的移动不修改
                    if ((index == 1 && this.floors[0].pos == 1 && !isUp) || (index == 2 && this.floors[0].pos == 1 && isUp)) {
                        //第一个锁定，第二个下移/第三个上移，设置第二个和第三个
                        this.floors[1].setMoveUp(false);
                        this.floors[1].setMoveDown(true);
                        this.floors[2].setMoveUp(true);
                        this.floors[2].setMoveDown(true);
                    } else if ((index == this.floors.length - 2 && this.floors[this.floors.length - 1].pos == 3 && isUp) || (index == this.floors.length - 3 && this.floors[this.floors.length - 1].pos == 3 && !isUp)) {
                        //最后一个锁定，倒数第二个上移/倒数第三个下移，设置倒数第二个和倒数第三个
                        this.floors[this.floors.length - 2].setMoveUp(true);
                        this.floors[this.floors.length - 2].setMoveDown(false);
                        this.floors[this.floors.length - 3].setMoveUp(true);
                        this.floors[this.floors.length - 3].setMoveDown(true);
                    }
                    //其他移动不修改
                }
            }
        },
        //锁定楼层
        posFloor: function(floor, isPos) {
            var index = array.indexOf(this.floors, floor);
            //如果是第一层且未锁定，点击锁定，this.pos的值为1
            if (index === 0 && !isPos) {
                floor.setPos(1);
                if (this.floors.length > 1) {
                    this.floors[1].setMoveUp(false); //第二楼不能上移
                }
            }
            //如果是最后一层且未锁定，点击锁定，this.pos的值为3
            if (index === this.floors.length - 1 && !isPos) {
                floor.setPos(3);
                if (this.floors.length > 1) {
                    this.floors[this.floors.length - 2].setMoveDown(
                    false); //设置倒数第二楼不能下移
                }
            }
            //如果已锁定，点击则解除锁定，this.pos的值为2
            if ((index === this.floors.length - 1 || index === 0) && isPos) {
                floor.setPos(2);
                if (index === 0 && this.floors.length > 1) {
                    this.floors[1].setMoveUp(true);
                }
                if (index === this.floors.length - 1 && this.floors.length > 1) {
                    this.floors[this.floors.length - 2].setMoveDown(true);
                }
            }
        },
        initPosFloorNode: function(floor, pos) {
            var index = array.indexOf(this.floors, floor);
            if (pos == 1) {
                this.floors[index + 1].setMoveUp(false);
            }
            if (pos == 3) {
                this.floors[index - 1].setMoveDown(false);
            }
        },
        //共重载的方法
        //selectLayout : function() {
        //   if (!this.layoutOverlay) {
        //     this.layoutOverlay = new Overlay({
        //       class : "select-overly",
        //       innerHTML :
        //           "<div data='1'>横向一栏橱窗</div><div data='2'>横向两栏橱窗</div>"
        //               + "<div data='12'>横向两栏左宽右窄</div><div data='13'>横向两栏左窄右宽</div>"
        //               + "<div data='3'>左一右二橱窗</div><div data='4'>横向三栏橱窗</div>"
        //               + "<div data='5'>横向四栏橱窗</div><div data='6'>滚动图片橱窗</div>"
        //               + "<div data='7'>横向四栏按钮</div><div data='8'>横向五栏按钮</div>"
        //               + "<div data='9'>热销商品橱窗</div><div data='10'>商品分类橱窗</div>"
        //               + "<div data='11'>推荐商品橱窗</div><div data='14'>拼团商品橱窗</div>"
        //               + "<div>取消</div>"
        //     });
        //     this.layoutOverlay.startup();
        //     this.layoutOverlay.placeAt(document.body);
        //   }
        //   this.layoutOverlay.show();
        //   this.layoutOverlay.currentDef = new Deferred();
        //   this.layoutOverlay.domNode.onclick =
        //       lang.hitch(this, function(event) {
        //         this.layoutOverlay.hide();
        //         var id = event.target.getAttribute
        //                  && event.target.getAttribute("data");
        //         this.layoutOverlay.currentDef.resolve(id);
        //       });
        //   return this.layoutOverlay.currentDef;
        //this.showInOverlay(selectFloorDiv);
        //},
        //其实没有用的方法，基类里面重写了
        showBoxEditElement: function(params) {
            if (!this.boxEditOverlay) {
                this.boxEditOverlay = new Overlay({
                    class: "overlay-list",
                    innerHTML: "<div data-dojo-type='dojox/mobile/View' id='__box_edit_main' selected='true'>" + "<ul data-dojo-type='dojox/mobile/EdgeToEdgeList'>" + "<li data-dojo-type='dojox/mobile/ListItem' moveTo='__box_edit_select' id='__edit_box_prod' >商品：</li>" + "<li data-dojo-type='dojox/mobile/ListItem' moveTo='__box_edit_select' id='__edit_box_cate' >品类：</li>" + "<li data-dojo-type='dojox/mobile/ListItem' rightText='<input type=\"text\" class=\"title\"/>'>标题：</li>" + "<li data-dojo-type='dojox/mobile/ListItem'>显示标题：<div class='mblItemSwitch' id='__box_edit_show_title' data-dojo-type='dojox/mobile/Switch' data-dojo-props='leftLabel:\"\",rightLabel:\"\"'></div></li>" + "<li data-dojo-type='dojox/mobile/ListItem' rightText='<input type=\"text\" class=\"to-url\" />'>网址：</li>" + "<li data-dojo-type='dojox/mobile/ListItem' class='li-icon' id='__edit_box_img' >图片：</li>" + "<li data-dojo-type='dojox/mobile/ListItem' moveTo='#' id='__box_edit_ok' rightText='确定'></li></ul>" + "</div>" + "<div data-dojo-type='dojox/mobile/View' id='__box_edit_select'>" + "<div stlye='float:right;' onclick='dijit.registry.byId(\"__box_edit_main\").show()'>返回</div>" + "<input type='text' style='width:100%;' class='__box_edit_search'/>" + "<div data-dojo-type='dojox/mobile/ScrollablePane' data-dojo-props='height:\"400px\"'>" + "<div data-dojo-type='dojox/mobile/EdgeToEdgeStoreList' class='__box_edit_list'>" + "</div>" + "</div>" + "</div>"
                });
                this.boxEditOverlay.startup();
                this.boxEditOverlay.placeAt(document.body);
                parser.parse(this.boxEditOverlay.domNode);
                this.boxEditOverlay.boxMatList = registry.getEnclosingWidget(
                query(".__box_edit_list", this.boxEditOverlay.domNode)[0]);
                this.inputSearch = query(".__box_edit_search", this.boxEditOverlay.domNode)[0];
                this.inputTitle = query(".title", this.boxEditOverlay.domNode)[0];
                this.inputUrl = query(".to-url", this.boxEditOverlay.domNode)[0];
                this.inputImg = registry.byId("__edit_box_img");
                this.inputCate = registry.byId("__edit_box_cate");
                this.inputProd = registry.byId("__edit_box_prod");
                this.inputOk = registry.byId("__box_edit_ok");
                this.inputShowTitle = registry.byId("__box_edit_show_title");
                this.inputOk.onClick = lang.hitch(this, function() {
                    var result = {};
                    result.title = this.inputTitle.value;
                    result.link = this.inputUrl.value;
                    result.imgUrl = this.inputImg.rightIcon2;
                    result.showTitle = this.inputShowTitle.value == "on" ? true : false;
                    this.boxEditOverlay.currentDef.resolve(result);
                    this.boxEditOverlay.hide();
                });
                this.inputProd.onClick = lang.hitch(this, function(event) {
                    var list = this.boxEditOverlay.boxMatList;
                    list.store.target = mat.getOnSaleUrl();
                    list.itemMap = {
                        "mName": "label"
                    };
                    list.setQuery({
                        isUse: true
                    });
                    this.searchType = 1;
                    return true;
                });
                this.inputCate.onClick = lang.hitch(this, function(event) {
                    var list = this.boxEditOverlay.boxMatList;
                    list.store.target = matGroup.getGroupUrl();
                    list.itemMap = {
                        gName: "label"
                    };
                    list.setQuery({
                        isUse: true
                    });
                    this.searchType = 2;
                    return true;
                });
                this.inputSearch.onkeydown = lang.hitch(this, function(event) {
                    if (event.keyCode == 13) {
                        var search = event.target.value;
                        if (this.searchType == 2) {
                            this.boxEditOverlay.boxMatList.setQuery({
                                isUse: true,
                                gName: search
                            });
                        } else this.boxEditOverlay.boxMatList.setQuery({
                            isUse: true,
                            mName: search
                        });
                    }
                });
                //创建数据源
                this.params = {
                    isUse: true,
                    qty: 1
                };
                this.store = new dojo.store.JsonRest({
                    target: cq.biz.mat.mat.getOnSaleUrl()
                });
                // 将数据源赋值给storeList
                this.boxEditOverlay.boxMatList.itemMap = {
                    mName: "label"
                };
                this.boxEditOverlay.boxMatList.setStore(this.store, this.params);
                this.boxEditOverlay.boxMatList.on("click", lang.hitch(this, function(event) {
                    var item = registry.getEnclosingWidget(event.target);
                    if (!item.params || !item.params._id) return;
                    this.inputTitle.value = item.params.label;
                    this.inputUrl.value = "/w/home/" + shop.getShopId() + (this.searchType == 2 ? "#matList-" : "#mat-") + item.params._id;
                    this.inputImg.set("rightIcon2", item.params.logo || "");
                    registry.byId("__box_edit_main").show();
                }));
            }
            //开始处理初始值
            params = params || {
                title: "",
                link: "",
                showTitle: true,
                showPrc: true,
                imgUrl: ""
            };
            //标题
            this.inputTitle.value = params.title || "";
            this.inputUrl.value = params.link || "";
            this.inputImg.set("rightIcon2", params.imgUrl || "");
            this.inputShowTitle.set("value", params.showTitle ? "on" : "off");
            this.boxEditOverlay.show();
            this.boxEditOverlay.currentDef = new Deferred();
            return this.boxEditOverlay.currentDef;
        }
    });
    //楼层对象，用于呈现一个漏乘(一组陈列位)，包含若干陈列位，用于处理陈列位的数量和布局
    var FloorClass = declare("", null, {
        //本楼层的根节点
        domNode: null,
        //布局
        layout: 1,
        pos: 2,
        //可编辑
        editable: false,
        isPos: true,
        //陈列位
        _boxes: null,
        //货架
        shelf: null,
        //
        _connections: null,
        //记录初始数据
        _orgData: null,
        //上移
        _moveUpNode: null,
        //下移
        _moveDownNode: null,
        _deleteNode: null,
        _posNode: null,
        _actionNode: null,
        _bottomNode: null,
        _topNode: null,
        moveUp: null,
        moveDown: null,
        //楼层样式
        _templateStrings: {
            "1": "<div class='shop_module_item shop_module_single_activity cbox min_height_floor backgroundColor' style='position:relative;'>" + "<a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con shop_module_single_activity_title'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></div>",
            "2": "<div class='shop_module_item shop_module_double_activity min_height_floor'>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li></div>" +
            // 使用边框节点
            //目前没有作用,隐藏
            "<div class='editMoreInfoNode none'><div class='itemCheckBox'></div><span>使用边框</span></div>",
            "3": "<div class='shop_module_item shop_module_three_activity'>" + "<div class='cbox shop_module_item_left backgroundColor min_height_floor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "</a>" + "</div>" + "<div class='shop_module_item_right'><li class='cbox shop_module_item_right_img_background shop_module_item_right_top backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "</a></li>" + "<li class='cbox backgroundColor shop_module_item_right_img_background shop_module_item_right_bottom'><a class='shop_module_item_right_img' href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "</a></li></div>" + "</div>",
            "4": "<div class='shop_module_item shop_module_three min_height_floor'>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "</div>" +
            // 使用边框节点
            "<div class='editMoreInfoNode none'><div class='itemCheckBox'></div><span>使用边框</span></div>",
            "5": "<div class='shop_module_item shop_module_four min_height_floor'>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "</div>" +
            // 使用边框节点
            "<div class='editMoreInfoNode none'><div class='itemCheckBox'></div><span>使用边框</span></div>",
            "6": "<div class='shop_module_item shop_module_four min_height_floor'>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "</div>" + "<div class='sldtpNode'>" + "<span title='0'>640*200</span><span title='1'>640*298</span><span title='2'>640*400</span>" + "</div>",
            // 横向四栏按钮
            "7": "<div class='shop_module_item shop_module_fourbtn min_height_floor'>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "</div>",
            // 横向五栏按钮
            "8": "<div class='shop_module_item shop_module_five min_height_floor'>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "</div>",
            "9": "<div class='shop_module_item shop_module_single_activity cbox min_height_floor backgroundColor' style='position:relative;'>" + "<div style='height:80px;text-align:center;'>热销商品</div>" + "</div>" + "<div class='divnum'>显示商品数量<span class='hotSpan hide'></span><input type='text' class='hot hide'/></div>", //+
            // TODO: 热销商品每行显示数量,需要关注
            // 使用边框节点
            //"<div class='editMoreInfoNode'><div
            // class='itemCheckBox'></div><span>使用边框</span></div>",
            // 商品分类楼层
            "10": "<div class='shop_module_item shop_module_single_activity cbox min_height_floor backgroundColor' style='position:relative;'>" + "<div style='height:80px;text-align:center;'></div></div>" + "<div  class='divnum'>显示商品数量<span class='hotSpan hide'></span><input type='text' class='hot hide'/></div>", //+
            // 使用边框节点
            //"<div class='editMoreInfoNode'><div
            // class='itemCheckBox'></div><span>使用边框</span></div>",
            "11": "<div class='shop_module_item shop_module_single_activity cbox min_height_floor backgroundColor' style='position:relative;'>" + "<div style='height:80px;text-align:center;'>推荐商品</div></div>" + "<div class='divnum'>显示商品数量<span class='hotSpan hide'></span><input type='text' class='hot hide'/></div>", //+
            // 使用边框节点
            //"<div class='editMoreInfoNode'><div
            // class='itemCheckBox'></div><span>使用边框</span></div>"
            "12": "<div class='shop_module_item shop_module_twelve_activity min_height_floor'>" + "<li class='cbox backgroundColor kuan'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor zai'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li></div>" +
            // 使用边框节点
            "<div class='editMoreInfoNode none'><div class='itemCheckBox'></div><span>使用边框</span></div>",
            "13": "<div class='shop_module_item shop_module_thirteen_activity min_height_floor'>" + "<li class='cbox backgroundColor zai'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li>" + "<li class='cbox backgroundColor kuan'><a href='javascript:void(0)'>" + "<div class='imgNode'><img src=''/></div>" + "<div class='shop_module_item_con'>" + "<strong class='shop_module_item_title'>" + "</strong>" + "<span>" + "</span>" + "</div></a></li></div>" +
            // 使用边框节点
            "<div class='editMoreInfoNode none'><div class='itemCheckBox'></div><span>使用边框</span></div>",
            // 拼团商品楼层
            // TODO: 热销商品每行显示数量,需要关注
            "14": "<div class='shop_module_item shop_module_single_activity cbox min_height_floor backgroundColor' style='position:relative;'>" + "<div style='height:80px;text-align:center;'>拼团商品</div></div>" + "<div class='divnum'>显示商品数量<span class='hotSpan hide'></span><input type='text' class='hot hide'/></div>",
            "15": "<div class='shop_module_item shop_module_single_activity cbox min_height_floor backgroundColor' style='position:relative;'>" + "<div style='height:80px;text-align:center;'>供求信息</div></div>" + "<div class='divnum'>显示信息数量<span class='hotSpan hide'></span><input type='text' class='hot hide'/></div>"
        },
        _layoutLabel: {
            "1": "横向一栏橱窗",
            "2": "横向两栏橱窗",
            "12": "横向两栏左宽右窄",
            "13": "横向两栏左窄右宽",
            "3": "左一右二橱窗",
            "4": "横向三栏橱窗",
            "5": "横向四栏橱窗",
            "6": "滚动图片橱窗",
            "7": "横向四栏按钮",
            "8": "横向五栏按钮",
            "9": "热销商品橱窗",
            "10": "分类商品橱窗",
            "11": "推荐商品橱窗",
            "14": "拼团商品橱窗",
            "15": "供求信息橱窗"
        },
        constructor: function(args, domNode) {
            //本楼层的根节点
            this.domNode = domNode;
            //本楼层的货架
            this.shelf = args.shelf;
            //本楼层样式
            this.layout = args.layout;
            this.pos = args.pos ? args.pos : this.pos;
            //模板规格
            this.sldtp = args.sldtp;
            //是否使用边框
            this.useborder = args.useborder;
            // 楼层的显示商品数
            this.matqty = args.matqty || 4;
            //本楼层的初始数据
            this._orgData = args;
            this.moveUp = args.moveUp;
            this.moveDown = args.moveDown;
            this.showBoxEditElement = args.showBoxEditElement;
            this.selectGroup = args.selectGroup;
            //初始化楼层，并创建陈列位
            this.initElement();
            this.setEditable(args.editable);
            if (this.editable) {
                this.setPos(this.pos);
            }
        },
        onSldtpClick: function(e) {
            var dom = e.target;
            if (!this.editable) {
                return;
            }
            // if(this._boxes.length>0){
            //     alert("更换橱窗大小后,请记得重新上传已有的图片哦!亲~");
            // }
            if (!array.every(this._boxes,function(boxItem) {
                return boxItem.imgUrl == "";
            })) {
                //判断如果有一张图片存在就提示重新上传,之前用imgId,现在改为imgUrl
                alert("更换橱窗大小后,请记得重新上传已有的图片哦!亲~");
            }
            var node = query(".selected", this.domNode)[0];
            if (node) {
                domClass.remove(node, "selected");
            }
            domClass.add(dom, "selected");
            if (dom.title && this._boxes) {
                //根据点击的按钮判断,当前的图片应该设置为多大
                var curImgWidth = 400;
                if (dom.title === 0) {
                    array.forEach(this._boxes,
                    function(boxItem) {
                        boxItem.imgCutHeight = 200;
                    });
                } else if (dom.title == 1) {
                    array.forEach(this._boxes,
                    function(boxItem) {
                        boxItem.imgCutHeight = 298;
                    });
                } else {
                    array.forEach(this._boxes, function(boxItem) {
                        boxItem.imgCutHeight = curImgWidth;
                    });
                }
            }
        },
        onEditMoreInfoClick: function(e) {
            if (!this.editable) {
                return;
            }
            var node = e.target;
            if (node && node.tagName == "DIV" && node != query(".editMoreInfoNode", this.domNode)[0]) {
                if (domClass.contains(node, "boxSelect")) {
                    domClass.remove(node, "boxSelect");
                } else {
                    domClass.add(node, "boxSelect");
                }
            }
        },
        _selectMatGroup: function() {
            if (!this.editable) {
                return;
            }
            this.selectGroup().then(lang.hitch(this, function(data) {
                if (data) {
                    this._matGroupId = data.MGID;
                    this.labelNode.innerHTML = this._matGroupName = data.MGName;
                }
            }));
        },
        qtyInputOnBlur: function() {
            var qtyNode = query(".hot", this.divnum)[0],
                qty = qtyNode.value;
            if (qty) {
                var g = /^[1-9]*[1-9][0-9]*$/;
                if (!g.test(qty)) {
                    alert("请输入正整数。");
                    //   qtyNode.value = "4";
                }
            } else {
                alert("请输入数量。");
                //   this.abortFlag = true;
            }
        },
        //初始化陈列位
        _initBoxes: function() {
            //初始化陈列位
            this._boxes = [];
            //初始化楼层
            this.domNode.innerHTML = this._templateStrings[this.layout];
            // 处理是否使用边框
            this.editMoreInfoNode = query(".editMoreInfoNode", this.domNode)[0];
            // 如果有使用边框节点
            if (this.editMoreInfoNode) {
                // 侦听节点的点击事件
                this.editMoreInfoNode.onclick = lang.hitch(this, this.onEditMoreInfoClick);
                // 判断当前楼层是否使用边框属性
                // 如果是使用边框,则将input勾选
                var ii = query(".itemCheckBox", this.editMoreInfoNode)[0];
                if (this.useborder && this.useborder == 1) {
                    domClass.add(ii, "boxSelect");
                }
                // 如果未使用,则将input勾选去掉
                else {
                    domClass.remove(ii, "boxSelect");
                }
            }
            // 如果有显示商品数量节点
            this.divnum = query(".divnum", this.domNode)[0];
            if (this.divnum) {
                var spanNode = query(".hotSpan", this.divnum)[0],
                    inputNode = query(".hot", this.divnum)[0];
                // 侦听失去input焦点事件
                inputNode.onblur = lang.hitch(this, this.qtyInputOnBlur);
                // 如果货架允许编辑,则显示input
                if (this.shelf.editable) {
                    domClass.add(spanNode, "hide");
                    domClass.remove(inputNode, "hide");
                }
                // 否则显示span
                else {
                    domClass.remove(spanNode, "hide");
                    domClass.add(inputNode, "hide");
                }
                // 如果有输入框,则更新输入框内容
                if (inputNode) {
                    inputNode.value = this.matqty;
                }
                if (spanNode) {
                    spanNode.innerHTML = this.matqty;
                }
            }
            if ("6" == this.layout) {
                this.sldtpNode = query(".sldtpNode", this.domNode)[0];
                if (this.sldtpNode) {
                    this.sldtpNode.onclick = lang.hitch(this, this.onSldtpClick);
                    var i = this.sldtpNode.childNodes.length;
                    while (i--) {
                        if (this.sldtpNode.childNodes[i].title === this.sldtp) {
                            domClass.add(this.sldtpNode.childNodes[i], "selected");
                            //设置当前用户选择的图片大小
                            // switch(parseInt(this.sldtpNode.childNodes[i].title)){
                            //     case 0:{this.sldtpNodeImgHeight = 200;}break;
                            //     case 1:{this.sldtpNodeImgHeight = 298;}break;
                            //     case 2:{this.sldtpNodeImgHeight = 400;}
                            //     //default:this.sldtpNodeImgHeight = 400;
                            // }
                            break;
                        }
                    }
                    if (-1 == i) {
                        domClass.add(this.sldtpNode.childNodes[0], "selected");
                        // this.sldtpNodeImgHeight = 200;
                    }
                }
            }
            if ("10" === this.layout) {
                //楼层不该管理编辑的，不能区别对待任意一种布局的楼层，这么做是一个不好的选择，但是没有更好的选择
                this.labelNode = this.domNode.firstChild.firstChild;
                //分类商品的分类选择问题
                // 2015-9-16 郑兰 取消点击整个区域选择商品分类
                var matGroupDiv = query(".shop_module_item", this.domNode)[0];
                matGroupDiv.onclick = lang.hitch(this, this._selectMatGroup);
                // var matqtyDiv = query(".hot",this.domNode)[0].parentNode;
                this._matGroupId = this._orgData.boxData && this._orgData.boxData["box1"] && this._orgData.boxData && this._orgData.boxData["box1"].category || "";
                this._matGroupName = this._orgData.boxData && this._orgData.boxData["box1"] && this._orgData.boxData && this._orgData.boxData["box1"].title || "";
                this.labelNode.innerHTML = this._matGroupName;
            } else if ("9" == this.layout || "11" == this.layout || "14" == this.layout || "15" == this.layout) {
                //热销商品和推荐商品不需要任何编辑功能
            } else {
                //添加陈列位
                query(".cbox", this.domNode).forEach(function(domNode, index) {
                    this._boxes.push(new BoxClass({
                        shelf: this.shelf,
                        showBoxEditElement: this.showBoxEditElement,
                        cutWidth: this.getBoxImgWH(this.layout, index).cutWidth,
                        cutHeight: this.getBoxImgWH(this.layout, index).cutHeight,
                        showWidth: this.getBoxImgWH(this.layout, index).showWidth,
                        showHeight: this.getBoxImgWH(this.layout, index).showHeight,
                        box: this._orgData.boxData && this._orgData.boxData[index].box
                        //取不到数据,修改为this._orgData.boxData[index].box
                        //&& this._orgData.boxData["box" + (index + 1)]  //陈列位数据
                    },
                    domNode));
                }, this);
            }
        },
        //初始化上下移动删除锁定按钮
        _initOperateNode: function() {
            //{{1,一栏}{2,二栏}{3,三栏}{4,横向三栏}{5,横向四栏}{6,滚动图片}}
            this._topNode = domConstruct.create("div", {
                "class": "floorName",
                innerHTML: this._layoutLabel[this.layout]
            },
            this.domNode, "last");
            this._bottomNode = domConstruct.create("div", {
                "class": "shelfBtnNode" //,
                /*style:
                                         "width:40px;z-index:999;right:-44px;position:absolute;display:none;"*/
            },
            this.domNode, "first");
            //添加上下移动、删除按钮结点，并添加监听
            this._actionNode = domConstruct.create("div", {
                // style:
                // "width:32px;z-index:999;right:0;display:none;position:absolute;background-color:gainsboro;"
            },
            this._bottomNode);
            //上移
            this._moveUpNode = iconUtils.createDomButton(domConstruct.create("div", {
                "class": "mblDomButtonWhiteUpArrow shelfMoveToUp",
                onclick: lang.hitch(
                this, function() {
                    this.shelf.moveFloor(this, true);
                })
            },
            this._actionNode));
            //删除
            this._deleteNode = iconUtils.createDomButton(domConstruct.create("div", {
                "class": "mblDomButtonGrayCross shelfDelete",
                onclick: lang.hitch(
                this, function() {
                    this.shelf.deleteFloor(this);
                })
            },
            this._actionNode));
            //下移
            this._moveDownNode = iconUtils.createDomButton(domConstruct.create("div", {
                "class": "mblDomButtonWhiteDownArrow shelfMoveToDown",
                onclick: lang.hitch(
                this, function() {
                    this.shelf.moveFloor(this, false);
                })
            },
            this._actionNode));
            //锁定
            this._posNode = domConstruct.create("img", {
                "src": "images/unlock1.png",
                "style": "width:20px;height:20px;margin-top:3px;background-color:#01c303;",
                onclick: lang.hitch(this,
                function() {
                    this.isPos = this.isPos ? false : true;
                    this.shelf.posFloor(this, this.isPos);
                })
            },
            this._bottomNode);
            // 是否使用边框
        },
        initElement: function() {
            if (this._connections) {
                while (this._connections.length) {
                    this._connections.pop().remove();
                }
            }
            this._connections = [];
            this._initBoxes();
            //左侧显示楼层类型
            this._initOperateNode();
            this.setMoveUp(this.moveUp);
            this.setMoveDown(this.moveDown);
        },
        //获取陈列位图片大小
        getBoxImgWH: function(layout, index) {
            //获取陈列位的图片大小
            switch (layout.toString()) {
            case "1":
                return {
                    //横向一栏橱窗不需要裁剪
                    cutWidth: 0,
                    cutHeight: 0,
                    showWidth: "300px",
                    showHeight: "168px"
                }; //{cutWidth:600,cutHeight:336,showWidth:"300px",showHeight:"168px"};
            case "2":
                return {
                    cutWidth: 320,
                    cutHeight: 320,
                    showWidth: "148px",
                    showHeight: "148px"
                }; //{cutWidth:340,cutHeight:340,showWidth:"148px",showHeight:"148px"};
            case "3":
                if (index === 0) {
                    return {
                        cutWidth: 380,
                        cutHeight: 380,
                        showWidth: "148px",
                        showHeight: "180px"
                    }; //{cutWidth:311,cutHeight:336,showWidth:"148px",showHeight:"180px"};
                } else {
                    return {
                        cutWidth: 252,
                        cutHeight: 188,
                        showWidth: "148px",
                        showHeight: "87px"
                    }; //{cutWidth:311,cutHeight:168,showWidth:"148px",showHeight:"87px"};
                }
                break;
            case "4":
                return {
                    cutWidth: 210,
                    cutHeight: 210,
                    showWidth: "80px",
                    showHeight: "80px"
                }; // return
                // {cutWidth:160,cutHeight:160,showWidth:"80px",showHeight:"80px"};
            case "5":
                return {
                    cutWidth: 158,
                    cutHeight: 136,
                    showWidth: "70px",
                    showHeight: "70px"
                }; //{cutWidth:140,cutHeight:140,showWidth:"70px",showHeight:"70px"};
                // case "6" :  return
                // {cutWidth:640,cutHeight:this.sldtpNodeImgHeight||400,showWidth:"320px",showHeight:"200px"};//{cutWidth:600,cutHeight:336,showWidth:"300px",showHeight:"168px"};
                // 2015-09-24 图片根据用户的选择设置不同的大小
            case "6":
                if (this.sldtp) {
                    switch (parseInt(this.sldtp)) {
                    case 0:
                        return {
                            cutWidth: 640,
                            cutHeight: 200,
                            showWidth: "320px",
                            showHeight: "200px"
                        };
                    case 1:
                        return {
                            cutWidth: 640,
                            cutHeight: 298,
                            showWidth: "320px",
                            showHeight: "200px"
                        };
                    default:
                        return {
                            cutWidth: 640,
                            cutHeight: 400,
                            showWidth: "320px",
                            showHeight: "200px"
                        };
                    }
                } else {
                    return {
                        cutWidth: 640,
                        cutHeight: 200,
                        showWidth: "320px",
                        showHeight: "200px"
                    };
                }
                break;
            case "7":
                return {
                    cutWidth: 96,
                    cutHeight: 96,
                    showWidth: "300px",
                    showHeight: "168px"
                }; //{cutWidth:48,cutHeight:48,showWidth:"300px",showHeight:"168px"};
            case "8":
                return {
                    cutWidth: 80,
                    cutHeight: 80,
                    showWidth: "300px",
                    showHeight: "168px"
                }; //{cutWidth:600,cutHeight:336,showWidth:"300px",showHeight:"168px"};
                // 左宽右窄
            case "12":
                if (index === 0) {
                    return {
                        cutWidth: 390,
                        cutHeight: 210,
                        showWidth: "148px",
                        showHeight: "180px"
                    }; //{cutWidth:311,cutHeight:336,showWidth:"148px",showHeight:"180px"};
                } else {
                    return {
                        cutWidth: 240,
                        cutHeight: 210,
                        showWidth: "148px",
                        showHeight: "87px"
                    }; //{cutWidth:311,cutHeight:168,showWidth:"148px",showHeight:"87px"};
                }
                break;
                // 左窄右宽
            case "13":
                if (index === 0) {
                    return {
                        cutWidth: 240,
                        cutHeight: 210,
                        showWidth: "148px",
                        showHeight: "180px"
                    }; //{cutWidth:311,cutHeight:336,showWidth:"148px",showHeight:"180px"};
                } else {
                    return {
                        cutWidth: 390,
                        cutHeight: 210,
                        showWidth: "148px",
                        showHeight: "87px"
                    }; //{cutWidth:311,cutHeight:168,showWidth:"148px",showHeight:"87px"};
                }
                break;
            default:
                return {
                    cutWidth: 0,
                    cutHeight: 0,
                    showWidth: "0px",
                    showHeight: "0px"
                };
            }
        },
        //设置本对象可编辑
        setEditable: function(editable) {
            //设置本对象可编辑
            this.editable = editable;
            //设置本楼层每一个陈列位可编辑
            array.forEach(this._boxes,
            function(box) {
                box.setEditable(editable);
            });
            domStyle.set(this._bottomNode, "display", editable ? "" : "none");
            domStyle.set(this._actionNode, "display", editable ? "" : "none");
            domStyle.set(this._posNode, "display", editable ? "" : "none");
        },
        //获取数据
        getData: function() {
            // TODO: 热销商品每行显示数量,需要关注
            //本不该区别对待不同布局的楼层，但是没有更好的选择
            var sldtp = query(".selected", this.domNode)[0],
                useborder = query(".editMoreInfoNode", this.domNode)[0] ? (domClass.contains(
                query(".itemCheckBox", this.domNode)[0], "boxSelect") ? 1 : 0) : 0,
                matqty = query(".hot", this.domNode)[0] ? query(".hot", this.domNode)[0].value : 4;
            // query(".editMoreInfoNode",this.domNode)[0]?(domAttr.get(query("input",query(".editMoreInfoNode",this.domNode)[0])[0],"checked")?1:0):0;
            return "10" == this.layout ? {
                layout: this.layout,
                groupId: this._matGroupId,
                groupName: this._matGroupName,
                matqty: matqty,
                boxData: []
            } : {
                layout: this.layout,
                pos: this.pos,
                sldtp: sldtp && sldtp.title || "",
                useborder: useborder,
                matqty: matqty,
                boxData: array.map(this._boxes,
                function(box) {
                    return box.getData();
                })
            };
        },
        //删除楼层
        destroyRecursive: function() {
            //删除楼层
            this.shelf.domNode.removeChild(this.domNode);
            var index = array.indexOf(this.shelf.floors, this);
            if (-1 < index) {
                this.shelf.floors.splice(index, 1);
            }
            //清理陈列位
            while (this._boxes && this._boxes.length) {
                this._boxes.pop().destroyRecursive();
            }
            //取消绑定的事件
            while (this._connections.length) {
                this._connections.pop().remove();
            }
        },
        setMoveUp: function(moveUp) {
            this.moveUp = moveUp;
            domStyle.set(this._moveUpNode, "display", this.moveUp ? "" : "none");
        },
        setMoveDown: function(moveDown) {
            this.moveDown = moveDown;
            domStyle.set(this._moveDownNode, "display",
            this.moveDown ? "" : "none");
        },
        setPos: function(pos) {
            this.pos = pos;
            if (this.pos == 1 || 3) {
                this.setActionNode(false);
            }
            if (this.pos == 2) {
                this.setActionNode(true);
            }
        },
        //隐藏/显示锁定节点
        setPosNode: function(showPos) {
            domStyle.set(this._posNode, "display", showPos ? "" : "none");
        },
        //隐藏/显示楼层编辑区域
        setActionNode: function(showAct) {
            domStyle.set(this._actionNode, "display", showAct ? "" : "none");
            domAttr.set(this._posNode, "src",
            showAct ? "images/unlock1.png" : "images/lock1.png");
        }
    });
    //具体陈列内容的容器，一个陈列位只能陈列一个东西——商品、类别、资讯、文字、链接等
    var BoxClass = declare("", null, {
        //可编辑
        editable: false,
        title: null, //标题
        imgId: null, //图片
        link: null, //链接
        imgIdClass: null, //类别
        isShowTitle: null, //显示标题
        isShowPrice: null, //显示价格
        materialId: null, //商品
        category: null, //品类
        shelf: null, //货架
        tpl: null,
        domNode: null, //陈列位节点
        imgCutWidth: null,
        imgCutHeight: null,
        imgShowWidth: null,
        imgShowHeight: null,
        _connections: null,
        constructor: function(args, domNode) {
            //初始化节点
            this.domNode = domNode;
            this.showBoxEditElement = args.showBoxEditElement;
            this.imgCutWidth = args.cutWidth;
            this.imgCutHeight = args.cutHeight;
            this.imgShowWidth = args.showWidth;
            this.imgShowHeight = args.showHeight;
            this.shelf = args.shelf;
            //初始化陈列位
            this.initElement();
            //设置可编辑
            this.setEditable(args.editable);
            this.refresh(args.box || {});
        },
        initElement: function() {
            //初始化陈列位
            this._connections = [];
            this._connections.push(
            connect.connect(this.domNode, "onclick", this, function() {
                if (this.editable) {
                    this.editBox();
                }
            }));
        },
        setEditable: function(editable) {
            //设置可编辑
            this.editable = editable;
        },
        getData: function() {
            //获取数据
            return {
                box: {
                    title: this.title || "",
                    img: this.imgId || "",
                    imgUrl: this.imgUrl || "",
                    link: this.link || "",
                    type: this.imgIdClass || "3",
                    showTitle: this.isShowTitle,
                    mat: this.materialId || "",
                    category: this.category || "",
                    shelf: this.shelf || "",
                    tpl: this.tpl || "",
                    showPrc: this.isShowPrice,
                    imgCutWidth: this.imgCutWidth,
                    imgCutHeight: this.imgCutHeight,
                    imgShowWidth: this.imgShowWidth,
                    imgShowHeight: this.imgShowHeight
                }
            };
        },
        refresh: function(box) {
            this.box = box || {};
            //刷新陈列位
            this.title = this.box.title = this.box.title || "";
            this.imgId = this.box.img = this.box.img || "";
            this.imgUrl = this.box.imgUrl = this.box.imgUrl || "";
            this.link = this.box.link = this.box.link || "";
            this.imgIdClass = this.box.type = this.box.type || 3;
            this.isShowPrice = this.box.showPrc = this.box.showPrc === false ? 0 : 1;
            this.isShowTitle = this.box.showTitle = this.box.showTitle === false ? 0 : 1;
            this.materialId = this.box.mat = this.box.mat || "";
            this.category = this.box.category = this.box.category || "";
            //刷新时为啥要变更本对象对应的shelf？
            // this.shelf = this.box.shelf = this.box.shelf || "";
            this.tpl = this.box.tpl = this.box.tpl || "";
            this.price = this.box.price = this.box.price || "";
            //查找节点
            this.titleNode = query("strong", this.domNode)[0]; //标题
            this.imgNode = query("img", this.domNode)[0]; //图片
            //显示/隐藏标题
            if (this.titleNode) {
                if (this.isShowTitle) {
                    this.titleNode.innerHTML = this.title;
                }
                domStyle.set(this.titleNode.parentNode, "display",
                this.isShowTitle ? "" : "none");
            }
            //显示图片
            if (this.imgUrl) {
                domAttr.set(this.imgNode, "src",
                this.imgUrl.replace("sso", "www")); //图片
            }
            domStyle.set(this.imgNode, "display", this.imgUrl ? "" : "none");
        },
        editBox: function() {
            var box = this.getData().box || {};
            box.groupOnly = !! this.groupOnly;
            //编辑陈列位
            this.shelf.showBoxEditElement(box).then(
            lang.hitch(this, function(result) {
                if (result) {
                    this.refresh(result);
                }
            }));
        },
        destroyRecursive: function() {
            while (this._connections.length) {
                this._connections.pop().remove();
            }
        }
    });
    //编辑陈列位的编辑区域
    //陈列位编辑区域的对象
    //继承view和_viewMixin
    var BoxEdit = declare("", [View, _ViewMixin], {
        indexElement: function() {
            //创建数据编辑的list
            this.createList();
            //确定和取消按钮
            var option = {
                columns: [{
                    label: "确认",
                    onClick: lang.hitch(this, function() {
                        var m = this.getData();
                        var msg = this.checkFiled(m);
                        if (msg) {
                            alert(msg);
                            return;
                        }
                        this.currentDef.resolve(this.dataToBox(m));
                        this.hideOverlay();
                    }),
                    className: "footer-tab-highlight"
                }, {
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                        this.hideOverlay();
                    }),
                    className: "footer-tab-dark"
                }],
                labelClass: 'font-size2',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
            this.centerPanel.set("style", "height:400px;text-align: left;");
        },
        checkFiled: function(data) {
            var msg = "";
            if (!data.boxType) {
                msg = "类型没有选择!";
            } else if (data.boxType === "1" && (!data.mat)) {
                msg = "商品没有选择!";
            } else if (data.boxType === "2" && (!data.groupId)) {
                msg = "品类没有选择!";
            }else if (data.boxType === "3" && (!data.icon)) {
                msg = "图片没有选择!";
            }else if (data.boxType === "4" && (!data.title)) {
                msg = "标题没有选择!";
            }
            return msg;
        },
        onDataChanged: function(field, oldValue, newValue) {
            if (field === "boxType") {
                this.onBoxTypeChange(newValue);
            } else if (field === "groupId") {
                if(newValue){
                    var data = this.getData();
                    data.icon = newValue.logo;
                    data.title = newValue.gName;
                    data.url = "#matList-" + (newValue._id);
                    this.setData(data);
                    this.refreshData();
                }
            } else if (field === "mat") {
                //  选择后,设置为选择后的值
                //  否则不操作
                if(newValue){
                    var data = this.getData();
                    data.icon = newValue.logo;
                    data.title = newValue.mName;
                    data.url = "#matDetail-" + (newValue._id);
                    this.setData(data);
                    this.refreshData();
                }
            }
        },
        //切换box的类型,第一个参数为类型,第二个是刷新页面的时候用到
        onBoxTypeChange: function(boxType, data) {
            if (this.boxEditItems) {
                var boxItems = query(".boxItem", this.boxEditItems.containerNode);
                for (var i = 0; i < boxItems.length; i++) {
                    domClass.add(boxItems[i], "none");
                }
                if (boxType == "1") {
                    domClass.remove(query(".mat", this.boxEditItems.containerNode)[0], "none");
                } else if (boxType == "2") {
                    domClass.remove(query(".groupId", this.boxEditItems.containerNode)[0], "none");
                } else if (boxType == "3") {
                    //domClass.remove(query(".url",this.boxEditItems.containerNode)[0],"none");
                } else if (boxType == "4") {
                    domAttr.set(query("input[__data_field='title'",this.domNode)[0], "placeHolder", "标题必填");
                } else {
                    domAttr.set(query("input[__data_field='title'",this.domNode)[0], "placeHolder", "选填");
                }
            }
            //没有数据设置默认值
            this.setData(data || {
                boxType: boxType,
                showPrc: true,
                showTitle: true
            });
            this.refreshData();
        },
        createList: function() {
            //编辑的界面
            var option = {
                isEdge: true,
                lists: [
                    //类型
                {
                    label: "类型",
                    noArrow: false,
                    moveTo: "#",
                    edit: {
                        type: "options",
                        field: "boxType",
                        options: {
                            "1": "商品",
                            "2": "品类",
                            "3": "图片",
                            "4": "文本"
                        }
                    }
                }, //商品
                {
                    label: "商品",
                    noArrow: false,
                    moveTo: "#",
                    edit: {
                        type: "ref",
                        field: "mat",
                        params: {
                            target: mat.getOnSaleUrl(),
                            query: {
                                isUse: true
                            },
                            searchField: "mName",
                            labelField: "mName"
                        }
                    },
                    className: "mblListItem boxItem mat none"
                }, //品类
                {
                    label: '品类',
                    moveTo: "#",
                    edit: {
                        type: 'ref',
                        field: 'groupId',
                        moveTo: "#",
                        params: {
                            target: matGroup.getGroupUrl(),
                            query: {
                                isUse: true
                            },
                            searchField: "gName",
                            labelField: "gName"
                        }
                    },
                    className: "mblListItem boxItem groupId none"
                },
                    {
                    label: "图片",
                    noArrow: false,
                    variableHeight : true,
                    moveTo: '#',
                    //不需要控制图片size
                    imgSize: this.imgCutSize,
                    class: "li-icon",
                    edit: {
                        type: "image",
                        field: "icon"
                    }
                }, {
                    label: "标题",
                    noArrow: true,
                    edit: {
                        type: "text",
                        field: "title",
                        placeHolder: "选填"
                    }
                },
                    {
                    label: "链接",
                    noArrow: true,
                    edit: {
                        type: "text",
                        field: "url",
                        placeHolder: "选填"
                    }
                }, //showPrc
                {
                    label: '显示图片',
                    noArrow: true,
                    edit: {
                        type: "checkbox",
                        field: "showPrc"
                    }
                }, //showTitle
                {
                    label: '显示标题',
                    noArrow: true,
                    edit: {
                        type: "checkbox",
                        field: "showTitle"
                    }
                }
                ]
            }
            this.boxEditItems = this.addLists(option);
        },
        showBoxEdit: function(data) {
            this.currentDef = new Deferred();
            this.imgCutSize = {
                width: data.imgCutWidth,
                height: data.imgCutHeight
            };
            this.startup();
            //console.log(this.imgCutSize);
            var parsedData = this.boxToData(data);
            //处理默认type和显示
            this.onBoxTypeChange(parsedData && parsedData.boxType || 1, parsedData);
            return this.currentDef;
        },
        boxToData: function(box) {
            var data = {};
            data.title = box.title;
            data.url = box.link;
            data.icon = box.imgUrl;
            data.boxType = box.type;
            data.mat = box.mat;
            data.groupId = box.category;
            data.showPrc = box.showPrc;
            data.showTitle = box.showTitle;
            // TODO: 其它属性
            return data;
        },
        dataToBox: function(data) {
            var box = {};
            box.title = data.title;
            box.link = data.url;
            box.imgUrl = data.icon;
            box.type = data.boxType;
            box.mat = (data.mat && data.mat._id) || data.mat;
            box.category = data.groupId && data.groupId._id;
            box.showPrc = data.showPrc;
            box.showTitle = data.showTitle;
            // TODO: other
            return box;
        }
    });
    return declare("cq.ui.b.s.ShopDecDetail", [View, _ViewMixin], {
        onAfterShow: function() {
            if (window.did) {
                shelf.loadById(window.did).then(lang.hitch(this, function(data) {
                    this.setData(data.data.item);
                    this.refreshData();
                }));
            } else {
                this.setData({
                    isUse: true
                });
                this.refreshData();
            }
        },
        refreshData: function() {
            this.inherited(arguments);
            this._shelf.refresh(this.dataToFloors(this.getData().floors));
        },
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        //window.moveToView("shopDecoration");
                        history.back();
                    }
                },
                right: {
                    iconButton: ' ',
                    onClick: this.onSave,
                    label: "完成"
                },
                title: "店铺装修"
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                class: "top-bottom-margin16",
                lists: [
                    {
                    label: "图标",
                    noArrow: false,
                    imgSize:{width:640,height:960},
                    edit: {
                        type: "image",
                        field: "logo"
                    },
                    class: "li-icon",
                    moveTo: "#"
                },
                    {
                    label: '标题',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'title',
                        placeHolder: "给自己的装修起个名字"
                    }
                }
                //   {
                //     label : '设为主页',
                //     noArrow : true,
                //     edit : {type : 'checkbox', field : 'isMain'}
                //   }
                ]
            };
            if (config.getPlatformShopId() === shop.getShopId()) {
                option.lists.push({
                    label: '是否启用',
                    noArrow: true,
                    edit: {
                        type: 'checkbox',
                        field: 'isUse'
                    }
                });
            }
            this.addLists(option);
            //创建货架
            var d = domConstruct.create("div", {
                "class": "shelfBodyBK"
            },
            this.centerPanel.containerNode);
            this._shelf = new ShelfClass({
                editable: true
                // selectLayout: lang.hitch(this, this.selectLayout),
                // showBoxEditElement: lang.hitch(this, this.showBoxEditElement),
                // selectGroup:lang.hitch(this,this.selectGroup)
            },
            domConstruct.create("div", {
                style: "margin: auto;",
                "class": "shelfBody"
            },
            d));
            this.createFloorSelect();
            this.createBoxEdit();
            this.onAfterShow();
        },
        createFloorSelect: function() {
            //创建橱窗类型选择区域
            this.selectFloorDiv = domConstruct.create("div", {
                class: "select-overly"
            });
            var option = {
                isEdge: true,
                lists: [{
                    label: "横向一栏橱窗",
                    data: "1"
                }, {
                    label: "横向两栏橱窗",
                    data: "2"
                },
                                   {
                    label: "横向两栏左宽右窄",
                    data: "12"
                }, {
                    label: "横向两栏左窄右宽",
                    data: "13"
                },
                                   {
                    label: "左一右二橱窗",
                    data: "3"
                }, {
                    label: "横向三栏橱窗",
                    data: "4"
                },
                                   {
                    label: "横向四栏橱窗",
                    data: "5"
                }, {
                    label: "滚动图片橱窗",
                    data: "6"
                },
                                   {
                    label: "横向四栏按钮",
                    data: "7"
                }, {
                    label: "横向五栏按钮",
                    data: "8"
                },
                                   {
                    label: "热销商品橱窗",
                    data: "9"
                },
                //{label:"商品分类橱窗",data:"10"},
                {
                    label: "推荐商品橱窗",
                    data: "11"
                },
                {
                    label: "供求信息橱窗",
                    data: "15"
                }
                //,{label: "左二右一",data: "15"}
                //,{label:"拼团商品橱窗",data:"14"}
                ]
            }
            var selectFloorItem = this.addLists(option);
            option = {
                columns: [{
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.hideOverlay();
                    })
                }],
                className: "bottom-margin8 padding-top-bottom16",
                labelClass: '',
                valueClass: ''
            }
            var selectFloorCancel = this.addColumns(option);
            this.selectFloorDiv.appendChild(selectFloorItem.containerNode);
            this.selectFloorDiv.appendChild(selectFloorCancel);
            this._shelf.selectLayout = lang.hitch(this, function() {
                this.showInOverlay(this.selectFloorDiv);
                this._shelf.selectLayout.currentDef = new Deferred();
                this.selectFloorDiv.onclick = lang.hitch(this, function(event) {
                    this.hideOverlay();
                    var id = registry.getEnclosingWidget(event.target) && registry.getEnclosingWidget(event.target).data || '';
                    this._shelf.selectLayout.currentDef.resolve(id);
                });
                return this._shelf.selectLayout.currentDef;
            });
        },
        //创建货架编辑界面
        createBoxEdit: function() {
            this._shelf.showBoxEditElement = lang.hitch(this, function(box) {
                //每次重新创建view,方便生成是传图片裁剪规格的参数
                if (this.boxEdit) {
                    this.boxEdit.destroy();
                }
                this.boxEdit = new BoxEdit();
                this.boxEditDiv = domConstruct.create("div", {
                    style: "height:400px;"
                });
                this.boxEditDiv.appendChild(this.boxEdit.domNode);
                this.showInOverlay(this.boxEditDiv);
                return this.boxEdit.showBoxEdit(box);
            });
        },
        dataToFloors: function(data) {
            // floors = [obj1,obj2,obj3]
            var floors = [];
            array.forEach(data, function(item, index) {
                var type = 0;
                if (item.floorType == "slideShow") {
                    //图片滚动橱窗
                    type = 6;
                } else if (item.data.provider) {
                    if (item.data.provider === "cq/biz/mat/mat") {
                        if (item.data.action === "loadAsBoxes") {
                            //最新商品橱窗
                            type = 9;
                        } else if (item.data.action === "loadRecommendMat") {
                            //推荐商品橱窗
                            type = 11;
                        }
                    } else if (item.data.provider === "cq/biz/ts/sc/supply_demand") {
                        //供求信息橱窗
                        type = 15;
                    }
                } else if (item.boxes.length === 1) {
                    //横向一栏
                    type = 1;
                } else if (item.boxes.length === 2) {
                    //两栏
                    if (item.options.flexes == "3,2") {
                        //左宽右窄
                        type = 12;
                    } else if (item.options.flexes == "2,3") {
                        //左窄右宽
                        type = 13;
                    } else {
                        //横向两栏
                        type = 2;
                    }
                } else if (item.boxes.length === 3) {
                    //横向三栏
                    if (item.options.direction == "H1V2") {
                        //左一右二
                        type = 3;
                    } else if (item.options.direction == "H2V1") {
                        //左二右一
                        //暂无
                    } else {
                        type = 4;
                    }
                } else if (item.boxes.length === 4) {
                    //横向四栏
                    if (item.options.height == 96) {
                        //按钮
                        type = 7;
                    } else {
                        //橱窗
                        type = 5;
                    }
                } else if (item.boxes.length === 5) {
                    //横向五栏
                    type = 8;
                }
                floors.push({
                    layout: type,
                    useborder: item.options.useborder,
                    pos: item.options.position == "top" ? 1 : (item.options.position == "bottom" ? 3 : 2),
                    sldtp: "",
                    matqty: item.data.max || 4,
                    boxData: ((type == 9 || type == 11) ? [] : array.map(item.boxes, function(dt, index) {
                        return {
                            box: {
                                link: dt.url, //连接
                                title: dt.title, //标题
                                imgUrl: dt.icon, //图片src
                                category: dt.groupId, //品类id
                                mat: dt.mat, //商品id
                                type: dt.type, //类型
                                showPrc: dt.showPrc || false, //显示图片
                                showTitle: dt.showTitle || false //显示标题
                            }
                        };
                    }))
                });
            });
            return floors;
        },
        floorsToData: function(floors) {
            // height 应该是整个楼层的高度
            // 一个楼层有多个box
            var data = [];
            array.forEach(floors, function(item, index) {
                var floorData = {
                    floorType: (item.layout == 6) ? "slideShow" : "columns",
                    options: {
                        useborder: item.useborder,
                        flexes: (item.layout == 12 ? "3,2" : (item.layout == 13 ? "2,3" : "")),
                        //除开横向四栏按钮和图片滚动,其他不设置高度
                        //item.layout==7||item.layout==6
                        height: (item.layout == 7 || item.layout == 6) ? (item.boxData[0] && item.boxData[0].box.imgCutHeight) : 0,
                        direction: ((item.layout == 3) ? "H1V2" : ((item.layout == 16) ? "H2V1" : "H")),
                        position: item.pos == 3 ? "bottom" : (item.pos == 1 ? "top" : ""),
                        columns: item.boxData.length
                    },
                    boxes: ((item.layout == 9 || item.layout == 10 || item.layout == 11 || item.layout == 14 || item.layout == 15) ? null : array.map(item.boxData, function(box, index) {
                        return {
                            title: box.box.title, //标题
                            url: box.box.link, //连接
                            icon: box.box.imgUrl, //图片src
                            mat: box.box.mat, //商品id
                            groupId: box.box.category, //品类id
                            type: box.box.type - 0, //类型
                            showTitle: Boolean(box.box.showTitle), //显示标题
                            showPrc: Boolean(box.box.showPrc) //显示图片
                        };
                    }))
                };
                //处理商品数据
                var matBoxData = null;
                if (item.layout == 9) {
                    //热销商品
                    matBoxData = {
                        provider: "cq/biz/mat/mat",
                        action: "loadAsBoxes",
                        params: JSON.stringify({
                            isUse: true,
                            qty: 1,
                            pageSize: item.matqty,
                            orderBy: '-totalSale'
                        }),
                        max: item.matqty || 4
                    };
                } else if (item.layout == 11) {
                    //推荐商品
                    matBoxData = {
                        provider: "cq/biz/mat/mat",
                        action: "loadRecommendMat",
                        params: JSON.stringify({
                            isUse: true,
                            qty: 1,
                            pageSize: item.matqty
                        }),
                        max: item.matqty || 4
                    };
                } else if (item.layout == 15) {
                    //推荐商品
                    matBoxData = {
                        provider: "cq/biz/ts/sc/supply_demand",
                        action: "loadAsBoxes",
                        params: JSON.stringify({
                            isUse: true,
                            pageSize: item.matqty,
                            orderBy: '-createAt'
                        }),
                        max: item.matqty || 4
                    };
                }
                floorData.data = matBoxData;
                data.push(floorData);
            });
            return data;
        },
        onSave: function() {
            window.busy();
            var data = this.getData();
            if (!data.logo) {
                window.free();
                alert("图标没有上传!");
                return;
            } else if (!data.title) {
                window.free();
                alert("标题还没填写!");
                return;
            }
            console.log(this._shelf.getData());
            console.log(this.floorsToData(this._shelf.getData()));
            data.floors = this.floorsToData(this._shelf.getData());
            //至少需要有一个楼层
            if (data.floors.length === 0) {
                window.free();
                alert("请添加至少一个橱窗!");
                return;
            }
            var jsonData = {
                data: JSON.stringify(data)
            };
            shelf.save(jsonData).then(function(data) {
                window.free();
                if (data.data.ok === 1) {
                    //window.moveToView("shopDecoration");
                    history.back();
                } else {
                    alert(data.data.msg || "发布失败!");
                }
            });
        }
    });
});
