//  变更人:肖芳圆
//  变更时间:2016/5/18
//  变更原因:
//      1，平台模版列表，设为首页的按钮，点击之后，复制对应模版，调用设为主页方法
//      2，平台模版列表，预览按钮，点击之后跳转到对应平台的模版预览界面
//      3，平台模版列表，点击非按钮区域，不做响应
//      4，私人模版，添加预览和设为首页的按钮，点击之后分别打开对应模版的预览界面和调用设置对应模版为首页的接口
//      5，私人模版，点击其他位置进入编辑界面
//  变更人:肖芳圆
//  变更时间:2016/6/14
//  变更原因:
//      1.公共模板显示方式改为一行两列
//      2.显示模板缩略图
//      3.设为主页的时候,保存公共模板的Id
//      4.启用的公共模板需要默认为选中
//  变更人:肖芳圆
//  变更时间:2016/6/20
//  变更原因:
//      1.头部标签为私有模板,底部新增按钮又叫做 添加自定义装修 描述不统一
//  变更人:母浚驰
//  变更时间:2016/6/23
//  变更原因:
//      1.tab标签锁定到头部
//      2.加载中的提示
//  变更人:杜飞军
//  变更时间:2016/06/24
//  变更原因: 阻止等待时多次发送请求 底部功能按钮过小
//  变更人:肖芳圆
//  变更时间:2016/6/20
//  变更原因:私有模板添加取消设为主页的按钮
//  
//  变更人:杜飞军
//  变更时间:2016/07/07
//  变更原因: 切换tab会存在没有数据的背景
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/when",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/shop/shelf",
    "cq/util/config/config",
    "cq/widgets/list/RestList"
], function(declare, lang, array, domClass, domAttr, domConstruct, query, when, JsonRest, registry, View, ListItem, EdgeToEdgeStoreList, _ViewMixin, shop, shelf, config, RestList) {
    return declare("cq.ui.b.s.ShopDecoration", [View, _ViewMixin], {
        start: 0,
        pageSize: 10,
        //当前状态,public公有模板,private私有模板
        state: "public",
        //公有模板数据
        publicTemplateData: {},

        onAfterShow: function() {
            //判断是否是平台
            if (config.getPlatformShopId() === shop.getShopId()) {
                //平台隐藏tab,并显示私人模板
                this.privateTemplate();
                domClass.add(this.tabSelector, "none");
            } else {
                //商家显示tab
                if (this.state === "private") {
                    this.privateTemplate();
                } else {
                    this.publicTemplate();
                }
                domClass.remove(this.tabSelector, "none");
            }
        },

        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        //  变更人:肖芳圆
                        //  变更时间:2016/6/20
                        //  变更原因:解决通过返回按钮进入iframe后返回不了的问题
                        window.moveToView("shopConfig");
                        //history.back();
                    }
                },
                title: "店铺装修"
            };
            this.addHeader(option);

            option = {
                isHeader: true,
                columns: [{
                    label: '公共装修',
                    onClick: this.publicTemplate
                }, {
                    label: '自定义装修',
                    onClick: this.privateTemplate
                }],
                labelClass: 'font-size1 tab-selector'
            };
            this.tabSelector = this.addColumns(option);

            //公有模板列表
            this.createPublicList();
            //私有模板列表
            this.createPrivateList();

            //底部
            option = {
                columns: [{
                    icon: 'images/icon/mat.png',
                    // iconClass: 'width-16',
                    iconClass: 'footer-tab-img',
                    label: '添加自定义装修',
                    onClick: function() {
                        window.moveToView("shopDecDetail");
                    }
                }],
                valueClass: 'font-size3',
                labelClass: 'font-size1',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
        },

        //创建私有模板
        createPrivateList: function() {
            var privateList = this.privateList = domConstruct.create("div", {
                class: "privateList none"
            }, this.centerPanel.containerNode);
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight: true,
                //获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "" + "<div class='mat-list-mname mat-list-margin'>" + data[i].title + "</div>" + "<div class='margin-top24 forth-btn'>" +
                            //公共模板都要显示设为主页按钮
                            (data[i].isMain ? "<span class='cancelSet'>取消设置</span>" : "<span class='setMain'>设为主页</span>") + "<span class='preview'>预览</span><span class='edit'>编辑</span></div>";
                        data[i]._logo = data[i].logo ? data[i].logo : 'images/userIcon.png';
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap: {
                    _label: "label",
                    _logo: "icon",
                    moveTo: "moveTo"
                }
            });

            //创建数据源
            if (config.getPlatformShopId() === shop.getShopId()) {
                //平台:隐藏tab便签,只显示私有模板,初始加载私有模板
                this.state = "private";
                domClass.add(this.tabSelector, "none");
                domClass.add(this.publicList, "none");
                domClass.remove(this.privateList, "none");
            } else {
                //商家:显示tab,并默认加载平台模板
                this.state = "public";
                domClass.add(query(".tab-selector", this.tabSelector)[0], "selected");
            }
            this.params = {
                shopId: config.getPlatformShopId()
            };
            this.store = new JsonRest({
                target: shelf.load()
            });

            // 将数据源赋值给storeList
            var queryResult = this.storeList.setStore(this.store, this.params, {
                start: this.start,
                count: this.pageSize
            });
            // 加载中的提示
            this.onLoadListData(queryResult, this.start, this.pageSize);
            this.storeList.placeAt(privateList, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickPrivateList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
        },

        //私有模板被点击
        onClickPrivateList: function(evt) {
            var dom = evt.target;
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            //设为主页
            if (dom && domClass.contains(dom, "setMain")) {
                //私人模板直接设为主页
                this.setMainFun(li.params._id);
            } else if (dom && domClass.contains(dom, "cancelSet")) {
                //取消设置主页
                this.setMainFun();
            } else if (dom && domClass.contains(dom, "preview")) {
                //进平台的货架预览页面
                localStorage.setItem("from", "shopDecoration");
                window.moveToView("iframe",
                    encodeURIComponent(shop.getShopUrl() + "#shelfPreview-" + li.params._id + "," + __shop.shopName));
            } else if (dom && domClass.contains(dom, "edit")) {
                //私人模板才可以修改
                window.moveToView("shopDecDetail", li.params._id);
            }
        },

        //创建公有模板
        createPublicList: function() {
            var htmlStr = '{% for item in items %}' + '<li class="shelfItem templateId{{item._id}}" >' + '<img src="{{item.logo}}">' + '<div class="forth-btn"><span class="setMain" templateId="{{item._id}}">设为主页</span><span class="preview" templateId="{{item._id}}">预览</span></div>' + '<div class="title">{{item.title}}<span></span></div>' + '</li>' + '{% endfor %}';
            var publicList = this.publicList = domConstruct.create("ul", {
                class: "publicList",
                innerHTML: htmlStr
            }, this.centerPanel.containerNode);
            this.centerPanel.containerNode.appendChild(publicList);
            this.publicRestList = new RestList({
                target: shelf.load(),
                query: {
                    isUse: true,
                    shopId: config.getPlatformShopId()
                }
            }, publicList);
            this.publicRestList.startup();
            this.refreshPublicList();
            this.connect(publicList, "onclick", this.onClickPublicList);
            this.connect(this.publicRestList, "onDataReady", function(data) {
                array.forEach(data.items, function(item) {
                    this.publicTemplateData[item._id] = item;
                }, this);
                //设置选中的模板勾选
                if (this.publicTemplateId) {
                    var shelfSelected = query(".templateId" + this.publicTemplateId, this.domNode)[0];
                    if (shelfSelected) {
                        domClass.add(shelfSelected, "shelfSelected");
                        domClass.add(query(".setMain", shelfSelected)[0], "none");
                    }
                }
            });
        },

        //公有模板被点击
        onClickPublicList: function(evt) {
            var dom = evt.target;
            var templateId;
            //设为主页
            if (dom && domClass.contains(dom, "setMain")) {
                window.busy();
                templateId = domAttr.get(dom, "templateId");
                var data = lang.clone(this.publicTemplateData[templateId]);
                data.publicTemplateId = data._id;
                delete data._id;
                delete data.__v;
                delete data.createAt;
                delete data.lastMod;
                delete data.moveTo;
                delete data.label;
                delete data.icon;
                array.forEach(data.floors, function(floor) {
                    delete floor._id;
                    array.forEach(floor.boxes, function(box) {
                        delete box._id;
                    });
                });
                //console.log(data);
                var jsonData = {
                    data: JSON.stringify(data)
                };
                shelf.save(jsonData).then(lang.hitch(this, function(dt) {
                    window.free();
                    if (dt.data.ok !== 1) {
                        alert("设置失败!");
                        return;
                    }
                    this.setMainFun(dt.data.item._id);
                }));
            }
            //预览
            else if (dom && domClass.contains(dom, "preview")) {
                templateId = domAttr.get(dom, "templateId");
                //进平台的货架预览页面
                localStorage.setItem("from", "shopDecoration");
                window.moveToView("iframe",
                    encodeURIComponent(shop.getPlatformShopUrl() + "#shelfPreview-" + templateId + "," + __shop.shopName));
            }
        },

        setMainFun: function(id) {
            //设置为主页
            window.busy();
            shelf.setMain(id || "").then(lang.hitch(this, function(d) {
                window.free();
                if (d.data.ok === 1) {
                    alert("设置成功!");
                    this.setQuery(this.storeList.get("query"), {
                        start: this.start,
                        count: this.pageSize
                    });
                    this.refreshPublicList();
                } else {
                    alert("设置失败!");
                }
            }));
        },

        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function() {
                        // 加载中的提示
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult, this.start, this.pageSize);
                    }), 1000);
                }
            }
        },

        clearSelected: function() {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },

        publicTemplate: function() {
            // 切换的时候先移除样式
            domClass.remove(this.centerPanel.domNode, "bg-nothing");
            this.state = "public";
            this.clearSelected();
            domClass.add(query(".tab-selector", this.tabSelector)[0], "selected");
            domClass.remove(this.publicList, "none");
            domClass.add(this.privateList, "none");
            this.refreshPublicList();
        },

        refreshPublicList: function() {
            shelf.getMainShelf().then(lang.hitch(this, function(data) {
                data = data && data.data && data.data.item;
                if (data) {
                    this.publicTemplateId = data.publicTemplateId;
                } else {
                    this.publicTemplateId = "";
                }
                this.publicRestList.refreshList();
                this.resize();
            }));
        },

        privateTemplate: function() {
            // 切换的时候先移除样式
            domClass.remove(this.centerPanel.domNode, "bg-nothing");
            this.state = "private";
            this.clearSelected();
            domClass.add(query(".tab-selector", this.tabSelector)[1], "selected");
            domClass.add(this.publicList, "none");
            domClass.remove(this.privateList, "none");
            this.setQuery({
                shopId: shop.getShopId()
            });
        },

        setQuery: function(query) {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            // 加载中的提示
            var queryResult = this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult, this.start, this.pageSize);
            this.centerPanel.resize();
        }
    });
});
