﻿/*创建人：周科吉
时间：2016-08-25
内容：顶部：按照title筛选，可以切换类型(全部、生效、失效)  
 列表按照结束时间降序排列，未过期的规则，在列表中显示停用的按钮，
 点击之后提示确认停用，确认之后调用停用接口，刷新列表 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/query",
    "dojo/on",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "cq/biz/mk/policy/sale"
],function(declare,lang,JsonRest,domClass,query,on,registry,View,EdgeToEdgeStoreList,_ViewMixin,date,sale){
    return declare("cq.ui.b.s.ShopGiftList",[View,_ViewMixin],{
        //设置页面加载条数
        start:0,
        pageSize:20,
        queryInfo:{orderBy:"-endTime"},
        //初始化界面元素
        onFirstShow:function(){
            //添加头部
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "商品送"
            };
            this.addHeader(option);
            //添加收索框
            option = {
                isHeader:true,
                placeHolder : "请输入要查询条件，按回车查询",
                class : "cqSearchBox",
                type : "search",
                onInput : lang.hitch(this, function (evt) {
                    if (evt.keyCode == 13) {
                        this.queryInfo.search = evt.target.value;
                        this.setQuery(this.queryInfo);
                        this.queryInfo.search = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            //添加活动状态栏
            option={
                isHeader:true,
                columns:[{
                    label:'全部',
                    className:'flex1',
                    onClick:function(evt){
                        //选中样式
                        this.setSelected(evt.target);
                        //设置查询条件
                        this.queryInfo={};
                        //刷新列表
                        this.setQuery();
                    }
                },{
                    label:'未开始',
                    className:'flex1',
                    onClick:function(evt){
                        this.setSelected(evt.target);
                        this.queryInfo={state:1};
                        this.setQuery(this.queryInfo);
                    }
                },{
                    label:'进行中',
                    className:'flex1',
                    onClick:function(evt){
                        this.setSelected(evt.target);
                        this.queryInfo={state:2};
                        this.setQuery(this.queryInfo);
                    }
                },{
                    label:'已过期',
                    className:'flex1',
                    onClick:function(evt){
                        this.setSelected(evt.target);
                        this.queryInfo={state:3};
                        this.setQuery(this.queryInfo);
                    }
                }],
                forceWidth:false,
                labelClass:'font-size1 tab-selector'
            };
            this.setSlect = this.addColumns(option);
            //添加底部新增
            option={
                columns:[{
					label:'添加活动',
					onClick:function(){
						window.moveToView("shopAwardEdit");
					}
				}],
                labelClass: 'font-size1 tab-selector',
                isFooter: true
            };
            this.addColumns(option);
            //列表显示内容
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight: true,
                //获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    var time = new Date();
                    for (var i = 0; i < data.length; i++) {
                        var prizeObj = data[i].prizeId||{};
                        this._id = data[i]._id;
                        this.mId = data[i].mId&&data[i].mId.mName;
                        //表明现在所处的状态
                        if(data[i].isUse==true){
                            this.useType="停用";
                        }else if(data[i].isUse==false&&((Date.parse(date.formatISODateMinutes(data[i].stopTime)) - Date.parse(time))<0)){
                            this.useType="已停用";
                        }
                        data[i]._label = ""+"<div class='shelf-mat-title'>活动名称: "+ data[i].title +
                        "<div style='text-align:center;position:relative;float:right;'>状态: " + 
                        this.getCheckLabel(data[i].isUse, data[i].startTime, data[i].stopTime,data[i].endTime) + "</div></div>"+
                        "<div class='shelf-mat-title'>赠送积分:"+(data[i].prizeQty?data[i].prizeQty:'0')+"</div>"+
                        "<div class='shelf-mat-title' > 活动开始时间: " +date.formatISODateMinutes(data[i].startTime) +"</div>"+
                        "<div class='shelf-mat-title' > 活动结束时间: " +date.formatISODateMinutes(data[i].endTime) +"</div>"+
                        "<div class='shelf-mat-title'><div >活动商品:"+(this.mId?this.mId:"全部")+"</div></div>"+
                        "<div class='shelf-mat-title'><div >抽奖活动:"+(prizeObj.prizeName?prizeObj.prizeName:"暂无")+"</div></div>"+
                        "<div class='shelf-mat-title'><div style='display:inline-block;padding-top: 3px;width:80%;'>备注:"+
                        (data[i].remark?data[i].remark:'暂无备注')+"</div><div class='stopUse' style='float: right;text-align: center;margin:0px 5px 5px 0px;'>"+
                        "<div style='border:2px solid gray'>"+this.useType+"</div></div></div>";
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                itemMap: { _label: "label", logo: "icon" }
            });
            //选中全部的样式
            this.setSelected(query(".tab-selector",this.setSlect)[0]);
            // 监控列表的点击事件
            this.storeList.on("click", lang.hitch(this, this.onSaleListClick));
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            //绑定滚动加载更多
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        //加载数据
        onAfterShow:function(){
            //若果数据不存在，加载数据
            if(!this.store){
                this.store=new JsonRest({
                target:sale.getLoadUrl()
                });
                var queryResult = this.storeList.setStore(this.store,this.queryInfo,{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.setQuery();
            }
        },
        //检验活动所处的状态
        getCheckLabel: function(isUse, startDate, stopDate,endDate) {
            if((Date.parse(endDate) - Date.parse(stopDate))>0){
                this.end = stopDate;
            }else{
                this.end = endDate;
            }
            var state = "";
            var time = new Date();
            var start = Date.parse(time) - Date.parse(startDate);
            var stop = Date.parse(this.end) - Date.parse(time);
            if (!isUse) {
                return '已过期';
            } else if (start < 0) {
                return '未开始';
            } else if (start => 0 && stop > 0) {
                return '进行中';
            } else if (stop <= 0) {
                return '已过期';
            }
        },
        //列表点击事件
        onSaleListClick:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")return;
            var evtId = li.params._id;
            //如果商品为已停用状态，点击则不会跳转到编辑页面
            //如果商品为生效状态，点击不能跳转到编辑页面，只能停用后新建
            //如果点击的是停用按钮，更新停止时间和使用状态
            var time =new Date();
            if(domClass.contains(evt.target.parentNode,"stopUse")){
                //当isUse为true时才能点击停用，否则不处理
                if(li.params.isUse){
                    sale.save({_id:evtId,isUse:false,stopTime:time}).then(lang.hitch(this,function(data){
                        if(data.data.ok==1){
                            this.setQuery(this.queryInfo);
                        }
                    }));
                }
            // 当开始时间大于现在时间且停止时间大于现在时间才能进行跳转到编辑界面
            }else if((Date.parse(date.formatISODateMinutes(li.params.startTime)) - Date.parse(time))>0&&(Date.parse(date.formatISODateMinutes(li.params.stopTime)) - Date.parse(time))>0){
                window.moveToView("shopAwardEdit", evtId);
            }else{
                return;
            }
        },
        //加载更多
        onLoadMore:function(e){
            this.start=this.start+this.pageSize;
            if(!this.busy&&e.afterBottom&&this.canLoadMore(this.start)){
                this.setQuery(this.queryInfo);
            }
        },
        //依据条件加载数据
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            //清空列表
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        //选中样式设置
        setSelected: function(evt){
            //清空所有节点选中样式
            var items = query('.tab-selector',this.domNode);
            for(var i = 0;i<items.length;i++){
                domClass.remove(items[i],"selected");
            }
            domClass.add(evt,"selected");
        },
    });
});