define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ListItem",
    "dojo/on",
    "dojo/when",
    "dojo/topic",
    "dojo/store/JsonRest",
    "cq/biz/shop/shop",
    "cq/bo/user",
    "cq/biz/user/user"
],function(declare,lang,View,_ViewMixin,query,registry,EdgeToEdgeList,ListItem,on,when,topic,JsonRest,shop,user,userBack){
    return declare("cq.ui.b.s.ShopList",[View,_ViewMixin],{
        start: 0,
        pageSize: 20,
        destroyOnSvcChanged : false,
		isFirst:true,
        onFirstShow:function(){
			this.inherited(arguments);
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {						
						//首次进入时的店铺列表与从其他地方进入的店铺列表应该是不同的，首次进入点返回提示退出，其他地方直接返回
						if(this.isFirst){
							this.confToBack();
						} else {
							history.back();
						}
                    }
                },
                right :{
                    iconButton : ' ',
                    onClick : this.addShop,
                    label : "新增店铺"
                },
                title:"店铺列表"
            };
            this.addHeader(option);
			this.store = new JsonRest({
				target:user.getUserShopUrl()
			});
            this.shopList = new EdgeToEdgeList({
                "class":"icon-list-item",
				append:true,
                constraint: false,
                variableHeight : true,
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
				},
				onComplete:lang.hitch(this,function(data){
					if(this.start===0&&data.length===1 && window.did == "auto"){
						this.changeShop(data[0]);
					}
					var len = data.length;
					while(len--){
						if(data[len].shopId.isDetele){
							data.splice(len,1);
						}else{
							data[len]._label = "<div style='padding-bottom: 20px; padding-top: 20px; padding-left: 10px;height: auto;'>" + data[len].shopId.shopName +"</div>";							
							data[len].logo = data[len].shopId.logo||"images/logo.png";
						}
					}
                    this.shopList.generateList(data);
                    this.busy = false;
				}),
                itemMap:{_label:"label",logo:"icon"}
            });
			this.shopList.on("click",lang.hitch(this,this.onShopClick));
            this.shopList.placeAt(this.centerPanel.containerNode);
			this.shopList.setStore(this.store,{},{
				start:this.start,
				count:this.pageSize
			});
        },
        //是否注销登录
        confToBack : function(){
            var goBack = confirm("是否退出登录？");
            if (goBack) {				
                user.logout();
            }
        },
        onAfterShow:function(){
            this.inherited(arguments);
            this.store.target = user.getUserShopUrl();
            // 当进入shopList页面时，发布svcChanged事件，供loader监听
            topic.publish("cqthink/svc/svcChanged");
            this.shopList.destroyDescendants();
			this.shopList.setQuery({},{
				start:this.start,
				count:this.pageSize
			});
        },
        onShopClick:function(evt){
			this.isFirst=false;
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.params){
                this.changeShop(li.params);
            }
        },
		changeShop:function(data){
			user.onSelectedUserShop(data,"","home");
		},
        addShop:function(){
            window.moveToView("shopRegist");
        }
    });
});