//变更人:肖芳圆，变更时间:2016/5/18，变更原因:修改返回按钮的逻辑
//变更人:肖爱玲，变更时间:2016/5/21，变更原因:修复点击长按二维码关注之后，等不的选中标志不见了，显示了图文二维码
//变更人:杜飞军，变更时间:2016-06-08，变更原因:修改拖动两个都移动问题 增加event资源
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/event",
    "dojo/dom-style",
    "dojox/mobile/View",
    "dojox/mobile/ScrollableView",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "cq/biz/shop/shop",
    "cq/util/image/qrCode",
    "dojo/dom-class"
], function(declare, lang, array, event, domStyle, View, ScrollableView, _ViewMixin, query, shop, qrCode, domClass) {
    return declare("cq.ui.b.s.ShopQrCode", [View, _ViewMixin], {
        // 图文二维码状态 默认打开
        shopCodeType: true,
        onAfterShow: function() {
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 获取店铺二维码信息，并加入的data中
                data.data.shopQrCodeUrl = qrCode.generatePNG(shop.getShopUrl());
                this.setData(data.data);
                //显示所有的二维码
                array.forEach(query(".qrCodeClass", this.domNode), lang.hitch(this, function(item) {
                    item.src = this.getData().shopQrCodeUrl;
                }));
                //显示商家的logo
                var logo = this.getData().logo ? this.getData().logo : "images/logo.png";
                query(".logoClass", this.domNode)[0].src = logo;
                //显示商家名字
                var shopName = this.getData().shopName ? this.getData().shopName : " ";
                query(".shopLabelClass", query(".shopNameClass", this.domNode)[0])[0].innerHTML = shopName;
                this.refreshData();
            }));
        },
        onFirstShow: function() {
            //设置二维码的地址
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function() {
                        this.shopLabelClass = true;
                        history.back();
                    }),
                },
                title: "店铺二维码"
            };
            this.addHeader(option);
            option = {
                isHeader:true,
                columns: [{
                    label: '图文二维码',
                    onClick: this.imageShopCode
                }, {
                    label: '极简二维码',
                    onClick: this.minimalShopCode
                }],
                labelClass: 'font-size3 tab-selector'
            };
            this.addColumns(option);
            option = {
                columns: [{
                    label: '保存到相册',
                    onClick: lang.hitch(this, function() {
                        if (this.shopCodeType) {
                            this.saveImageDataToLibrary(function() {
                                alert("保存成功");
                            }, function() {
                                alert("保存失败");
                            }, query('.qrCodeClass', this.domNode)[0],  query('.qrcode-logo', this.codeView)[0], query('.qrcode-shopname', this.codeView)[0].innerHTML);
                        } else {
                            this.saveImageDataToLibrary(function() {
                                alert("保存成功");
                            }, function() {
                                alert("保存失败");
                            }, query('.qrCodeClass', this.domNode)[0]);

                        }
                    })
                }],
                valueClass: 'font-size3',
                labelClass: 'font-size3',
                className: 'fix-footer footer-tab-highlight',
                isFooter: true
            };
            var bottom = this.addColumns(option);
            // 检测版本
            if (!window.util.isMobile()) {
                domStyle.set(bottom, "display", "none");
            }
            //创建图文二维码
            this.createImageCodeView();
            //创建极简二维码
            this.createMinimalCodeView();
            this.scrollableView1.show();
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.onAfterShow();
        },
        //创建图文二维码的View
        createImageCodeView: function() {
            this.scrollableView1 = new ScrollableView();
            var option = {
                isEdge: true,
                variableHeight: true,
                columns: [{
                    icon: "imgurl",
                    iconClass: "logoClass qrcode-logo",
                    className: "qrcode-li1-c1"
                }, {
                    label: " ",
                    className: "shopNameClass qrcode-li1-c2"
                }],
                labelClass: 'shopLabelClass qrcode-shopname font-size3',
                className: "qrcode-li qrcode-li1"
            };
            this.codeView = this.addColumns(option);
            this.scrollableView1.domNode.appendChild(this.codeView);
            option = {
                isEdge: true,
                variableHeight: true,
                columns: [{
                    icon: "imgurl",
                    iconClass: "qrCodeClass",
                    className: "flex1"
                }],
                className: "qrcode-li qrcode-li2",
                forceWidth: false
            };
            this.scrollableView1.domNode.appendChild(this.addColumns(option));
            this.creatPublicView(this.scrollableView1);
            this.scrollableView1.placeAt(this.centerPanel.containerNode, "last");
            this.scrollableView1.on("touchStart", lang.hitch(this, this.stopScroll));
            this.scrollableView1.resize();
        },
        //创建极简二维码的view
        createMinimalCodeView: function() {
            this.scrollableView2 = new ScrollableView();
            var option = {
                isEdge: true,
                variableHeight: true,
                columns: [{
                    icon: "imgurl",
                    iconClass: "qrCodeClass qrcode",
                    className: "flex1"
                }],
                className: "qrcode-li qrcode-li2 qrcode ",
                forceWidth: false
            };
            this.scrollableView2.domNode.appendChild(this.addColumns(option));
            this.creatPublicView(this.scrollableView2);
            this.scrollableView2.placeAt(this.centerPanel.containerNode, "last");
            this.scrollableView2.on("touchStart", lang.hitch(this, this.stopScroll));
            this.scrollableView2.resize();
        },
        // 阻止滚动事件的冒泡
        stopScroll: function(e) {
            event.stop(e);
        },
        //创建stroctView的公共部分
        creatPublicView: function(strollView) {
            var option = {
                columns: [{
                    label: '长按或扫描二维码关注我的店铺'
                }],
                labelClass: 'font-size2',
                className: "qrcode-li qrcode-li3 flex2",
                forceWidth: false
            };
            strollView.domNode.appendChild(this.addColumns(option));
            option = {
                columns: [{
                    label: '发送二维码给好友吸引更多客源'
                }],
                labelClass: 'font-size5',
                className: "qrcode-li qrcode-li4"
            };
            strollView.domNode.appendChild(this.addColumns(option));
        },
        //改变标签的样式
        claerLabelClass: function(evnt) {
            array.forEach(query(".tab-selector", this.domNode), function(item) {
                domClass.remove(item, "selected");
            });
            domClass.add(evnt.target, "selected");
        },
        imageShopCode: function(evnt) {
            // 图文二维码状态
            this.shopCodeType = true;
            this.claerLabelClass(evnt);
            this.scrollableView1.show();
        },
        minimalShopCode: function(evnt) {
            this.shopCodeType = false;
            this.claerLabelClass(evnt);
            this.scrollableView2.show();
        }
    });
});
