//修改人：周科吉
//时间：2016-06-20；
//修改内容：
//     新建店铺确认后没控制导致多次点击加载同一个店铺，
//     修复新增店铺提交成功后,文本框未被清空,再次点击进入为上次填写的店铺名称的问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/dom-class",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
	"cq/ui/util/districtOverlay"
], function (declare, lang, topic, domClass, query, View, _ViewMixin, shop, user, districtSelector) {
    return declare("cq.ui.b.s.ShopRegist", [View, _ViewMixin], {
        onFirstShow : function () {
            // 清空数据
            this.setData({});
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.go(-1);
                    }
                },
                title : "创建店铺"
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                class : "top-bottom-margin16",
                lists : [{
                    label : '店铺名称',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'shopName',
                        placeHolder : '取个好听的名字'
                    }
                }/*,{
                    label : '地理位置',
                    noArrow : false,
                    moveTo : "#",
                    edit : {
                        type : 'position',
                        lonField : 'lon',
                        latField : 'lat'
                    }
                }*/]
            };
			this.addLists(option);
			//后台创建店铺的时候并没有处理省市区的问题，暂时先隐藏
			/*option = {
                isEdge : true,
                class : "top-bottom-margin16",
                lists : [{
                    label : '省市区',
                    moveTo : "#",
                    'class' : "addressName",
                    rightText : "{{town}}"
                }]
            };
            this.townNode=this.addLists(option);
			this.connect(query(".addressName", this.townNode.domNode)[0], "onclick", this.onTownClick);
			option = {
                isEdge : true,
                class : "top-bottom-margin16",
                lists : [{
                    label: '详情地址',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'address'
                    }
                }]
            };            
            this.addLists(option);*/		
            options = {
                columns : [{
                        label : "确认",
                        className : "flex1 footer-tab-highlight",
                        onClick : lang.hitch(this, this.submitInfo)
                    }
                ],
                className : '',
                forceWidth : false,
            },
            this.addColumns(options);
        },
		onTownClick:function(evt){
            var pageData = this.getData();
            var params = {
                province : pageData.provinceId,
                city : pageData.cityId,
                county : pageData.countId
            };
            districtSelector.selectDistrict(params).then(lang.hitch(this, function(data) {
                if (data) {
                    pageData.provinceId = data.province._id;
                    pageData.cityId = data.city._id;
                    pageData.countId = data.county._id;
                    pageData.town = data.province.distName + "-" + data.city.distName + "-" + data.county.distName;
                }
                this.setData(pageData);
                this.refreshData();
            }));
        },
        submitInfo : function () {
            //当提交按钮被点击时，锁定事件，
            window.busy();
            var info = this.getData();
            var msg = this.checkField(info);
            if (msg) {
                //出现异常，释放事件
                window.free();
                alert(msg);
                return;
            }
            info.userName = user.userName;
            shop.onSubmitShop(info).then(lang.hitch(this, function (data) {
                //释放事件
                window.free();
                if (data.shop) {
                    user.setCurrentShop(data.shop);
                    window.moveToView("home");
                    this.setData({});
                    this.refreshData();
                } else {
                    alert(data.data.msg || "提交失败!");
                    this.setData({});
                    this.refreshData();
                }
            }));
        },
        checkField : function (info) {
            var msg = "";
            if (!info.shopName) {
                msg = "店铺名称还没有填写!";
            }
            return msg;
        }
    });
});