define([
    "dojo/_base/declare", "dojo/_base/lang", "dojo/topic", "dojox/mobile/View",
    "dojo/store/Memory", "dojox/mobile/EdgeToEdgeStoreList", "cq/ui/view/_ViewMixin",
    "dojo/request/xhr", "dojo/query", "dijit/registry", "cq/biz/shop/shop","cq/biz/user/user",
    "dojo/on"
],function(declare, lang, topic, View, Memory, EdgeToEdgeStoreList, _ViewMixin, xhr,
    query, registry, shop, user,on) {
    return declare("cq.ui.b.s.ShopServiceMsg", [ View, _ViewMixin ], {
        onAfterShow:function(){
            shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                // 显示信息
                data.data.verficationStatusText = data.data.isVerified?"已认证":"未认证";
                this.setData(data.data);
                this.refreshData();
            }));
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        //window.moveToView("shopConfig");
                        history.back();
                    }
                },
                title : "客服消息设置"
            };
            this.addHeader(option);
            this.onAfterShow();
        },
        onSaveStore : function() {
            window.busy();
            var shopData = this.getData();
            // 重置内容
            shopData.svcId = shopData.svcId && shopData.svcId._id;
            shopData.orderCheckerId = shopData.orderCheckerId && shopData.orderCheckerId._id;
            for(var e in shopData){
                if(shopData[e] == "" || shopData[e] === undefined) {
                    delete shopData[e];
                }
            }
            shop.save(shopData).then(function() {
                window.free();
                topic.publish("whz/shop/changed",shopData);
                this.isEditing=false;
                window.moveToView("home");
            });
        }
    });
});