//变更人:肖爱玲，变更时间:2016/5/21，变更原因:底部按钮样式修改、保存检查不可空
// 变更人：潘云，变更时间：2016-6-16，变更内容：修改店铺认证的状态
// 变更人：潘云
// 变更时间：2016-06-24
// 功能：处理点击完成重复提交数据的问题
// 变更人:杜飞军
// 变更时间： 2016/08/05
// 功能：判断认证帮助页面是否存在
// 变更人：干劲
// 变更时间：20160910
// 变更内容：添加联系人和电话
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/_base/array",
    "dojo/query",
    "dojox/mobile/View",
    "cq/biz/shop/shop",
    "cq/ui/view/_ViewMixin",
    "cq/ui/util/districtOverlay",
    "cq/biz/article/article",
    "cq/biz/user/user",
    "cq/util/config/config"
], function(declare, lang, domStyle, array, query, View, shop, _ViewMixin, districtSelector, article, user, config) {
    return declare("cq.ui.b.s.ShopVerification", [View, _ViewMixin], {
        isEditing: false,
        // List是否可编辑
        isListEdit: true,
        onAfterShow: function() {
            if (!this.isEditing) {
                this.isEditing = true;
                // 隐藏驳回原因
                domStyle.set(this.rejectList.domNode, "display", "none");
                shop.loadCurrentShop().then(lang.hitch(this, function(data) {
                    // 显示信息
                    var shopData = {
                        logo : data.data.logo,
                        lon : data.data.lon,
                        lat : data.data.lat,
                        contactName : data.data.contactName,
                        contactPhone : data.data.contactPhone,
                        address : data.data.address,
                        companyName: data.data.companyName||data.data.shopName,
                        legalPerson: data.data.legalPerson,
                        businessLicense: data.data.businessLicense,
                        legalImg1: data.data.legalImg1,
                        legalImg2: data.data.legalImg2,
                        _id: data.data._id,
                        isVerified: data.data.isVerified,
                        isVerifySubmit: data.data.isVerifySubmit,
                        town:data.data.town,
                        rejectedReason: data.data.rejectedReason || ""
                    };
                    //if(data.data.provinceId&&data.data.cityId&&data.data.countyId){
                    //    shopData.provinceName = data.data.provinceId+"-"+data.data.cityId+"-"+data.data.countyId
                    //}
                    // 认证时将联系电话默认为当前登陆者的电话
                    this.userData=user.getUserData();
                    if(!shopData.contactPhone){
                        shopData.contactPhone = this.userData.userName;
                    }
                    // 根据状态显示隐藏底部按钮
                    this.setFooterClass(shopData);
                    this.setListsClass();
                    this.setData(shopData);
                    this.refreshData();                   
                }));
            }
            this.inherited(arguments);
        },
        setListsClass: function() {
            if (this.isListEdit) {
                domStyle.set(this.companyDataEdit.domNode, "display", "");
                domStyle.set(this.businessDataEdit.domNode, "display", "");
                domStyle.set(this.legalDataEdit.domNode, "display", "");
                domStyle.set(this.companyData.domNode, "display", "none");
                domStyle.set(this.businessData.domNode, "display", "none");
                domStyle.set(this.legalData.domNode, "display", "none");
                domStyle.set(this.pageList.domNode, "display", "");
                domStyle.set(this.pageList2.domNode, "display", "none");
                domStyle.set(this.address.domNode, "display", "");
                domStyle.set(this.address2.domNode, "display", "none");
            } else {
                domStyle.set(this.companyDataEdit.domNode, "display", "none");
                domStyle.set(this.businessDataEdit.domNode, "display", "none");
                domStyle.set(this.legalDataEdit.domNode, "display", "none");
                domStyle.set(this.companyData.domNode, "display", "");
                domStyle.set(this.businessData.domNode, "display", "");
                domStyle.set(this.legalData.domNode, "display", "");
                domStyle.set(this.pageList.domNode, "display", "none");
                domStyle.set(this.pageList2.domNode, "display", "");
                domStyle.set(this.address.domNode, "display", "none");
                domStyle.set(this.address2.domNode, "display", "");
            }
        },
        // 根据状态显示隐藏底部按钮
        setFooterClass: function(shopData) {
            // 显示提交认证
            if (shopData.isVerifySubmit === 0 && !shopData.isVerified) {
                domStyle.set(query(".hasverify", this.footerButton)[0], "display", "none");
                domStyle.set(query(".noverify", this.footerButton)[0], "display", "");
                domStyle.set(query(".rejectedReason", this.footerButton)[0], "display", "none");
                domStyle.set(query(".verifying", this.footerButton)[0], "display", "none");
                this.isListEdit = true;
            }
            // 显示重新提交（已驳回）
            if (shopData.isVerifySubmit === -1 && !shopData.isVerified) {
                domStyle.set(query(".hasverify", this.footerButton)[0], "display", "none");
                domStyle.set(query(".noverify", this.footerButton)[0], "display", "none");
                domStyle.set(query(".rejectedReason", this.footerButton)[0], "display", "");
                domStyle.set(query(".verifying", this.footerButton)[0], "display", "none");
                // 显示驳回原因
                domStyle.set(this.rejectList.domNode, "display", "");
                this.isListEdit = true;
            }
            // 显示审核中
            if (!shopData.isVerified && shopData.isVerifySubmit === 1) {
                domStyle.set(query(".hasverify", this.footerButton)[0], "display", "none");
                domStyle.set(query(".noverify", this.footerButton)[0], "display", "none");
                domStyle.set(query(".rejectedReason", this.footerButton)[0], "display", "none");
                domStyle.set(query(".verifying", this.footerButton)[0], "display", "");
                this.isListEdit = false;
            }
            // 显示已审核
            if (shopData.isVerifySubmit === 2 && shopData.isVerified) {
                domStyle.set(query(".hasverify", this.footerButton)[0], "display", "");
                domStyle.set(query(".noverify", this.footerButton)[0], "display", "none");
                domStyle.set(query(".rejectedReason", this.footerButton)[0], "display", "none");
                domStyle.set(query(".verifying", this.footerButton)[0], "display", "none");
                this.isListEdit = false;
            }
        },
        onFirstShow: function() {
            // 获取平台配置的商家类型对象
            this.shopType = config.shopType;
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        this.isEditing = false;
                        //window.moveToView("shopConfig");
                        history.back();
                    }
                },
                title: "店铺认证",
                right: {
                    iconButton: ' ',
                    onClick: function() {
                        article.loadPlatformByTitle("店铺认证").then(function(data) {
                            if (data.data.ok === 1) {
                                window.moveToView("helpVerification", "店铺认证");
                            } else {
                                alert('暂无认证帮助');
                            }
                        });
                    },
                    label: "认证帮助"
                }
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label: "店铺图标",
                    noArrow: false,                    
                    edit: {
                        type: "image",
                        field: "logo"
                    },
                    "class": "li-icon",
                    moveTo: "#"
                }, {
                    label: '公司名称',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'companyName',
                        placeHolder: '必填'
                    }
                },/* {
                    label : '产业类别',
                    rightText : '',
                    moveTo : "#",
                    edit : {
                        type : 'options',
                        field : 'shopType1',
                        options : {
                            0:"养殖",
                            1:"加工",
                            2:"服务"
                        }
                    }
                }, {
                    label : '经营主体',
                    rightText : '',
                    moveTo : "#",
                    edit : {
                        type : 'options',
                        field : 'shopType',
                        options : this.getShopTypeOptions()
                    }
                },*/ {
                    label: '法人姓名',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'legalPerson',
                        placeHolder: '必填'
                    }
                }, {
                    label: '身份证号',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'legalPersonCode',
                        placeHolder: '请填写法人身份证号'
                    }
                }, {
                    label: '联系人',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactName',
                        placeHolder: '必填'
                    }
                }, {
                    label: '电话',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactPhone',
                        placeHolder: '必填'
                    }
                }]
            };
            this.companyDataEdit = this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label: "店铺图标",
                    noArrow: false,
                    rightIcon2: "{{logo}}",
                    class: "li-icon"
                },{
                    label: '公司名称',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'companyName',
                        disabled: true
                    }
                }, {
                    label: '法人姓名',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'legalPerson',
                        disabled: true
                    }
                }, {
                    label: '法人身份证号',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'legalPerson',
                        disabled: true
                    }
                }, {
                    label: '联系人',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactName',
                        disabled: true
                    }
                }, {
                    label: '电话',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'contactPhone',
                        disabled: true
                    }
                }]
            };
            this.companyData = this.addLists(option);
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label: "营业执照",
                    noArrow: false,
                    imgSize: {
                        width: 600,
                        height: 800
                    },
                    edit: {
                        type: "image",
                        field: "businessLicense"
                    },
                    "class": "li-icon",
                    moveTo: "#"
                }]
            };
            this.businessDataEdit = this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label: "营业执照",
                    noArrow: false,
                    rightIcon2: "{{businessLicense}}",
                    class: "li-icon"
                }]
            };
            this.businessData = this.addLists(option);
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label: "法人身份证正面",
                    noArrow: false,
                    imgSize: {
                        width: 800,
                        height: 600
                    },
                    edit: {
                        type: "image",
                        field: "legalImg1"
                    },
                    "class": "li-icon",
                    moveTo: "#"
                }, {
                    label: "法人身份证反面",
                    noArrow: false,
                    imgSize: {
                        width: 800,
                        height: 600
                    },
                    edit: {
                        type: "image",
                        field: "legalImg2"
                    },
                    "class": "li-icon",
                    moveTo: "#"
                }]
            };
            this.legalDataEdit = this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label: "法人身份证正面",
                    noArrow: false,
                    rightIcon2: "{{legalImg1}}",
                    class: "li-icon"
                }, {
                    label: "法人身份证反面",
                    noArrow: false,
                    rightIcon2: "{{legalImg2}}",
                    class: "li-icon"
                }]
            };
            this.legalData = this.addLists(option);
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    //className : "mblListItem rejectTitle",
                    label: "驳回原因："
                }, {
                    label: "{{rejectedReason}}",
                    variableHeight: true
                }]
            };
            this.rejectList = this.addLists(option);
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label : '地理位置',
                    noArrow : false,
                    moveTo : "#",
                    edit : {
                        type : 'position',
                        lonField : 'lon',
                        latField : 'lat'
                    }
                }]
            };
            this.position = this.addLists(option);
            //可修改
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label : '省市区县',
                    moveTo : "#",
                    'class' : "addressName",
                    rightText : "{{town}}"
                }/*,{
                    label : '乡镇-村',
                    moveTo : "#",
                    'class' : "",
                    rightText : ""
                }*/]
            };
            this.pageList = this.addLists(option);
            this.connect(query(".addressName", this.pageList.domNode)[0], "onclick", this.onPageList);
            //不可修改
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label: '省市区县',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'town',
                        disabled: true
                    }
                }/*,{
                    label : '乡镇-村',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'town',
                        disabled: true
                    }
                }*/]
            };
            this.pageList2 = this.addLists(option);
            //详细地址
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label: '详情地址',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'address'
                    }
                }]
            };
            this.address = this.addLists(option);
            option = {
                isEdge: true,
                "class": "bottom-margin16",
                lists: [{
                    label: '详情地址',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'address',
                        disabled: true
                    }
                }]
            };
            this.address2 = this.addLists(option);
            option = {
                columns: [{
                    label: "提交认证",
                    className: 'flex2 footer-tab-highlight noverify',
                    onClick: this.onSaveStore
                }, {
                    label: '已认证',
                    className: 'flex2 footer-tab-highlight hasverify',
                    onClick: function() {
                        alert("已经认证，不能再提交");
                    }
                }, {
                    label: '审核中',
                    className: 'flex2 footer-tab-highlight verifying',
                    onClick: function() {
                        alert("审核中，不能重复提交");
                    }
                }, {
                    label: '重新提交',
                    className: 'flex2 footer-tab-highlight rejectedReason',
                    onClick: this.onSaveStore
                }],
                forceWidth: false,
                isFooter: true
            };
            this.footerButton = this.addColumns(option);
            this.onAfterShow();
        },
        onPageList:function(evt){
            var pageData = this.getData();
            var params = {
                province : pageData.provinceId,
                city : pageData.cityId,
                county : pageData.countId
            };
            districtSelector.selectDistrict(params).then(lang.hitch(this, function(data) {
                if (data) {
                    pageData.provinceId = data.province._id;
                    pageData.cityId = data.city._id;
                    pageData.countId = data.county._id;
                    pageData.town = data.province.distName + "-" + data.city.distName + "-" + data.county.distName;
                }
                this.setData(pageData);
                this.refreshData();
            }));
        },
        onSaveStore: function() {
            if (this.isEditing) {
                window.busy();
                this.isEditing = false;
                var shopData = this.getData();
                var msg = this.checkFiled(shopData);
                if (msg) {
                    window.free();
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                return shop.verifySubmit(shopData).then(function(data) {
                    window.free();
                    if (data && data.data && data.data.ok === 1) {
                        alert("提交成功");
                        history.back();
                    } else {
                        this.isEditing = true;
                        alert("提交失败");
                    }
                });
            }
        },
        checkFiled: function(data) {
            if (!data.logo) {
                return "店铺图标必须上传";
            }
            if (!data.companyName) {
                return "公司名称不能为空";
            }
            if (!data.legalPerson) {
                return "法人名称不能为空";
            }
            if (!data.businessLicense) {
                return "营业执照必须上传";
            }
            if (!data.legalImg1) {
                return "身份证正面必须上传";
            }
            if (!data.legalImg2) {
                return "身份证反面必须上传";
            }
			if (!data.town) {
                return "省市区必须选择";
            }
            return "";
        },
        getShopTypeOptions : function () {
            var options = {};
            if (this.shopType) {
                array.forEach(this.shopType, function (type) {
                    options[type.typeCard] = type.typeName;
                });
            }
            return options;
        }
    });
});
