define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/topic",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop"
],function(declare, lang, domClass, topic, View,  _ViewMixin, shop) {
    return declare("cq.ui.b.s.SupplyBusDetail", [ View, _ViewMixin ], {
        //初始化相关接口
        onAfterShow:function(){
                if (window.did) {
                    shop.loadById(window.did).then(lang.hitch(this, function (data) {
                        // 显示信息
                        data.data.wxUrl = "http://log.cqthink.com/w/wx/"+data.data._id;
                        this.setData(data.data);
                        this.refreshData();
                    }));
                }else {
                    this.setData({});
                    this.refreshData();
                }
        },
        // 创建店铺的基本信息
        createShopBaseInfo : function () {
            var option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : "店铺图标",
                    rightIcon2 : '{{logo}}',                
                    class : "li-icon"
                },{
                    label : '店铺名称',
                    rightText : '{{shopName}}'
                },{
                    label : '省市区县',
                    rightText : '{{town}}'
                },{
                    label : '店铺地址',
                    rightText : '{{address}}'
                },{
                    label : '地理位置',
                    noArrow : false,
                    moveTo : "#",
                    edit : {
                        type : 'position',
                        lonField : 'lon',
                        latField : 'lat'
                    }
                },{
                    label : '联系人',
                    rightText : '{{contactName}}'
                },{
                    label : '联系电话',
                    rightText : '{{contactPhone}}'
                },{
                    label : '销售区域',
                    rightText : '{{tranRegion}}',
					variableHeight:true
                },{
                    label : '营业执照',
					variableHeight:true,
                    rightIcon2 : '{{businessLicense}}',
                    class : "li-icon-imgsupply" ,
                    onClick : lang.hitch(this,function(evt){
                        if(evt.target.localName=="img"){
                            if(domClass.contains(evt.target.parentNode, "li-icon-imgsupply")){
                                var imgSrcUri = evt.target.src;
                                this.showImg(imgSrcUri); 
                            }
                        }
                    })
                }]
            };
            this.addLists(option);
        },
        // 创建店铺的客服信息
        createShopSvcInfo : function () {
            var option = {
                isEdge : true,
                title:"客户信息",
                class : "bottom-margin16",
                lists : [{
                    label : '客服电话',
					rightText : '{{svcPhone}}'
                },{
                    label : '客服微信',
					rightText : '{{svcWx}}'
                },{
                    label : '客服QQ',
					rightText : '{{svcQQ}}'
                }]
            };
            this.addLists(option);
        },
        _initPositionEdit:function (edit,li,value) {
            this.inherited(arguments);
            li.set("rightText","查看位置");
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        this.isEditing=false;
                        history.back();
                    }
                },
                title : "认证信息"
            };
            this.addHeader(option);
            // 基础信息
            this.createShopBaseInfo();
            // 客服信息
            //this.createShopSvcInfo();
            this.onAfterShow();
        }
    });
});