
//修改人: 杜飞军
//修改时间: 2016-06-08
//修改内容:
//           跳出注册页面之前清空手机号

// 变更人:刘轩
// 变更日期:2016/7/19
// 变更内容:
//          获取验证码时,只有点击到按钮才有效
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/_base/xhr",
    "dojo/query",
    "dojo/topic",
    "dijit/registry",
    "cq/util/config/config",
    "cq/biz/user/user",
    "cq/biz/shop/shop"
], function(declare, lang, View, _ViewMixin, xhr, query, topic, registry, config, user, shop) {
    return declare("cq.ui.b.s.Svcregist", [View, _ViewMixin], {
        destroyOnSvcChanged: false,
        //初始化相关接口
        onFirstShow: function() {
            this.setData({});
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.go(-1);
                        this.clearVCode();
                        this.emptyData();
                    }
                },
                title: "注册",
                right: {
                    iconButton: ' ',
                    onClick: this.registSubmit,
                    label: "确定"
                }
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                class: "top-bottom-margin16",
                lists: [{
                    label: '手机号',
                    noArrow: true,
                    edit: {
                        type: 'tel',
                        field: 'userName',
                        placeHolder: '请填写手机号'
                    },
                    className: "mblListItem userName"
                }, {
                    label: '店铺名称',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'shopName',
                        placeHolder: '取个好听的名字'
                    }
                }, {
                    className: "mblListItem btn-vcode",
                    rightText: '获取验证码',
                    onClick: lang.hitch(this, function(e){
                        var dom = e.target;
                        if(dom.className !== "mblListItemRightText"){
                            return;
                        }
                        this.getVcode();
                    })
                }, {
                    label: '验证码',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'vCode',
                        placeHolder: '请填写短信验证码'
                    },
                    rightText: "获取验证码"
                }, {
                    label: '密码',
                    noArrow: true,
                    edit: {
                        type: 'password',
                        field: 'password',
                        placeHolder: '请注意大小写'
                    }
                }, {
                    label: '确认密码',
                    noArrow: true,
                    edit: {
                        type: 'password',
                        field: 'passwordConfirm',
                        placeHolder: '与密码保持一致'
                    }
                }]
            };
            this.addLists(option);
            this.vCodeNode = query(".btn-vcode >div.mblListItemRightText", this.domNode)[0];
            // 侦听获取验证码
            //this.connect(query(".btn-vcode >div.mblListItemRightText", this.domNode)[0], "onclick", this.getVcode);
            this.connect(query(".userName input", this.domNode)[0], "onblur", this.checkePhone);
        },
        // 清空数据
        emptyData: function() {
            this.setData({});
            this.refreshData();
        },
        checkePhone: function(callback) {
            var phoneName = query(".userName input", this.domNode)[0].value;
            if(this.isCellPhone(phoneName)){
                user.checkPlatformUser(phoneName).then(lang.hitch(this, function(data) {
                    if (data.data.ok === 1) {
                        this.emptyData();
                        alert("账号已经存在,请直接登陆");
                        setTimeout(function() {
                            window.moveToView("login");
                        }, 300);
                    } else {
                        if(lang.isFunction(callback)){
                            callback.apply(this,[]);
                        }
                    }
                }));
            }else {
                alert("请输入正确的11位电话号码");
            }
        },
        updateVCode: function() {
            var diff = 60 - (Date.now() - this.vCodeSendTime) / 1000;
            if (diff > 0) {
                diff = diff.toFixed(0);
                this.vCodeNode.innerHTML = diff + "秒后重发";
            } else {
                this.vCodeSendTime = null;
                clearInterval(this.vCodeInterval);
                this.vCodeNode.innerHTML = "获取验证码";
            }
        },
        // 清除计时器
        clearVCode: function(){
            clearInterval(this.vCodeInterval);
            this.vCodeNode.innerHTML = "获取验证码";
        },
        getVcode: function(){
            this.checkePhone(this.getRegistVCode);
        },
        getRegistVCode: function(evt) {
            if (this.vCodeSendTime) {
                alert("请稍后再发");
                return;
            }
            if (!this.isCellPhone(this.getData().userName)) {
                alert("手机不合法！");
                return false;
            }
            window.busy();
            xhr("POST", {
                url: config.getDataOrigin() + "/biz/sms/sms/send_vcode",
                handleAs: "json",
                content: {
                    tel: this.getData().userName
                },
                load: lang.hitch(this, function(result) {
                    window.free();
                    if (1 === result.ok) {
                        alert("验证码已发出，请注意查收！");
                        this.vCodeSendTime = Date.now();
                        this.vCodeInterval = setInterval(lang.hitch(this, this.updateVCode), 1000);
                    } else {
                        alert(result.msg);
                    }
                })
            });
        },
        //保存数据
        saveData:function(info){
            window.busy();
            info.platformShopId = config.getPlatformShopId();
            shop.onSubmitShop(info).then(lang.hitch(this, function(data) {
                window.free();
                if (data.shop) {
                    user.setCurrentShop(data.shop);
                    topic.publish("whz/shop/changed", window.__shop);
                    this.emptyData();
                    this.clearVCode();
                    window.moveToView("home");
                } else {
                    alert("提交失败!");
                }
            }));
        },
        submi:function(info){
            this.saveData(info);
        },
        registSubmit: function() {
            var info = this.getData();
            if (!this.isCellPhone(info.userName)) {
                alert("请输入正确的11位电话号码");
                return;
            } else if(!info.shopName){
                alert("店铺名称不能为空");
                return;
            } else if (!info.vCode) {
                alert("验证码不能为空");
                return;
            } else if (!info.password || !info.passwordConfirm) {
                alert("密码不能为空");
                return;
            } else if (info.password !== info.passwordConfirm) {
                alert("两次密码不一致");
                return;
            }
            this.submi(info);
        }
    });
});