/**
 * Writer 杜飞军
 * Create Time 2016/05/20
 * Create content
 *             可查看优惠券详情
 **/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "dojo/dom-class",
    "cq/biz/mk/discountCoupon",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
], function(declare, lang, View, domClass, discountCoupon, _ViewMixin, date) {
    return declare("cq.ui.b.DisCountSerDetail", [View, _ViewMixin], {
        // 每次进入页面重新加载数据
        onAfterShow: function() {
            if (window.did) {
                discountCoupon.loadById(window.did).then(lang.hitch(this, function(data) {
                    if (data.data.ok === 1) {
                        var discount = data.data.item;
                        if (discount.state === 1 || discount.state === 2) {
                            domClass.remove(this.bootomToUser, 'none');
                            domClass.add(this.bootomToOrder, 'none');
                        } else if (discount.state === 3) {
                            domClass.add(this.bootomToUser, 'none');
                            domClass.remove(this.bootomToOrder, 'none');
                        }
                        discount.distributeDate = date.formatISODate(discount.distributeDate);
                        if (discount.useDate) {
                            discount.useDate = date.formatISODate(discount.useDate);
                        }
                        discount.state = this.viewState(discount.state);
                        this.setData(discount);
                        this.refreshData();
                        this.resize();
                    } else {
                        alert(data.data.message);
                    }
                }));
            }
        },
        viewState: function(state) {
            var view = {
                1: '已发放',
                2: '待支付',
                3: '已使用'
            };
            return view[state];
        },
        // 开始页面初始化
        onFirstShow: function() {
            var options = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "优惠活动",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "优惠券详情"
            };
            this.addHeader(options);
            options = {
                isEdge: true,
                disabled: false,
                lists: [
                // {
                //     label: "客户",
                //     rightText: "{{userId}}"
                // }, {
                //     label: "订单",
                //     rightText: "{{tsId}}"
                // }, 
                {
                    label: "领取时间",
                    rightText: "{{distributeDate}}"
                }, {
                    label: "使用时间",
                    rightText: "{{useDate}}"
                }, {
                    label: "状态",
                    rightText: "{{state}}"
                }, {
                    label: "面值",
                    rightText: "{{amount}}"
                }, {
                    label: "满抵金额",
                    rightText: "{{reachAmount}}"
                }]
            };
            this.addLists(options);
            options = {
                columns: [{
                    label: "查看客户",
                    onClick: lang.hitch(this, function() {
                        var data = this.getData();
                        window.moveToView("user", "coupon_" + data.userId);
                    })
                }],
                labelClass: 'font-size1 tab-selector',
                isFooter: true,
                className: "basedOnStatesView"
            };
            this.bootomToUser = this.addColumns(options);
            options = {
                columns: [{
                    label: "查看客户",
                    onClick: lang.hitch(this, function() {
                        var data = this.getData();
                        window.moveToView("user", "coupon_" + data.userId);
                    })
                }, {
                    label: "查看订单",
                    onClick: lang.hitch(this, function() {
                        var data = this.getData();
                        window.moveToView("orderDetailB", data.tsId);
                    })
                }],
                labelClass: 'font-size1 tab-selector',
                isFooter: true,
                className: "basedOnStatesView"
            };
            this.bootomToOrder = this.addColumns(options);
            this.onAfterShow();
        }
    });
});
