
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
// 变更人员：母浚驰
// 变更时间：2016/6/20
// 变更内容：时间格式，页面样式修改
// 变更人员：肖芳圆
// 变更时间：2016/6/24
// 变更内容：
//  1.addColumns的分隔线图片显示找不到
//  2.隐藏所有底部按钮后底部高度不正常的bug
//  3.发送修改数据请求的时候给出busy,在请求完成的时候free
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojox/mobile/ListItem",
    "cq/biz/ts/order",
    "cq/util/sys/date"
],function(declare, lang, domAttr, domClass, query, View, _ViewMixin, ListItem, order, date){
    return declare("cq.ui.b.t.OrderDetail",[View,_ViewMixin],{
        // 初始化页面元素,绑定事件
        onFirstShow:function(){
            // 创建头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    }
                },
                title:"订单详情"
            };
            this.addHeader(option);
            //收货相关信息
            // 添加class 使
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.orderList=this.addLists(option);
            this.orderStateItem = new ListItem({
                variableHeight:true
            });
            this.orderList.addChild(this.orderStateItem);
            //商品信息
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.matList=this.addLists(option);
            //费用信息
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.expenseList=this.addLists(option);
            this.expenseItem = new ListItem({
                variableHeight:true
            });
            this.expenseList.addChild(this.expenseItem);
            //底部
            /*option={
                columns:[{
                    label:"<div><span class='count'></span></div>",
                    className:"edit-car-count flex1"
                }, {
                    label:"<span class='amout'>付款</span>",
                    className:"edit-car-submit",
                    onClick: function(){
                        this.payOrder(1);
                    }
                }],
                className:'fix-footer edit-car-footer',
                forceWidth:false,
                isFooter:true
            }*/
            option = {
                columns:[{
                    label:'审核',
                    className:'flex2 footer-tab-highlight none accept',
                    onClick : lang.hitch(this,this.setAccepted)
                },
                {
                    label:'发货',
                    className:'flex2 footer-tab-highlight none deliver',
                    onClick:lang.hitch(this,this.setDelivered)
                },
                {
                    label:'退款',
                    className:'flex2 footer-tab-dark none cancel',
                    onClick:lang.hitch(this,this.setCanceled)
                }],
                forceWidth:false,
                isFooter:true
            };
            this.bottomMenus = this.addColumns(option);
            //this.addColumns(option);
            this.connectEvent();
            this.onAfterShow();
        },
        //整单审核
        setAccepted:function(){
            //系统busy状态,待请求完成后free
            window.busy();
            order.setAccepted(window.did).then(lang.hitch(this, function () {
                window.free();
                this.onAfterShow();
            }));
        },
        setDelivered:function(){
            //系统busy状态,待请求完成后fre
            window.busy();
            order.setDelivered(window.did).then(lang.hitch(this, function () {
                window.free();
                this.onAfterShow();
            }));
        },
        setCanceled:function(){
            //系统busy状态,待请求完成后fre
            window.busy();
            order.setCanceled(window.did).then(lang.hitch(this, function () {
                window.free();
                this.onAfterShow();
            }));
        },
        // 执行付款操作
        payOrder:function(type){
            if(this.orderItem.isPayed===false&&this.orderItem.isCanceled===false){
                order.setPayed(this.orderItem._id).then(lang.hitch(this,this.onAfterShow));
            }
        },
        // 绑定订单审核/退款/发货点击事件
        connectEvent:function(){
            this.connect(this.matList.domNode,"onclick",function(e){
                var dom = e.target;
                if(dom&&dom.tagName=== "SPAN"){
                    var id=domAttr.get(dom.parentNode,"detailId");
                    if(domClass.contains(dom,"edit-car-revieweds")){
                        order.setDetailAccepted(id).then(lang.hitch(this,function(){
                            this.onAfterShow();
                        }));
                    }else if(domClass.contains(dom,"edit-car-send")){
                        order.setDetailDelivered(id).then(lang.hitch(this,function(){
                            this.onAfterShow();
                        }));
                    }else if(domClass.contains(dom,"edit-car-refunds")){
                        order.setDetailRefounded(id).then(lang.hitch(this,function(){
                            this.onAfterShow();
                        }));
                    }
                }
            });
        },
        // 加载数据,并显示到页面上
        onAfterShow:function () {
            this.inherited(arguments);
            this.orderStateItem.set({label:"",rightText:""});
            this.matList.destroyDescendants();
            this.expenseItem.set({label:"",rightText:""});
            // 收货人信息列表赋值
            order.loadDetailById(window.did).then(lang.hitch(this,function (data) {
                var items=data&&data.data&&data.data.items||[];
                if(items.length){
                    //更新收货人信息
                    this.orderStateItem.set({
                        label:"<div class='webkit-list'><div class='edit-car-dName'>收货人:"+(items[0].dName?items[0].dName:"未知")+"</div><div class='edit-car-dTel'>"+(items[0].dTel?items[0].dTel:"未知")+"</div></div>"
                            +"<div class='immune-list'><div class='edit-car-dAddress'>收货地址："+(items[0].dAddress?items[0].dAddress:"未知")+"</div></div>",
                        rightText:items[0].isCanceled?"已取消":items[0].isPayed?"已支付":"未支付"
                    });
                    //添加商品列表项
                    for (var i = items.length - 1; i >= 0; i--) {
                        var listitem=new ListItem({
                            label:this.getDetailLabel(items[i]),
                            rightText:"<span class='edit-car-qty'>x"+items[i].qty+"</span>",
                            variableHeight:true
                            });
                        this.matList.addChild(listitem);
                    }
                }
            }));
            // 订单详细信息赋值
            order.loadById(window.did).then(lang.hitch(this,function (data) {
                var item = this.orderItem = data.data.item;
                //费用明细
                // 更改时间格式
                var dates = date.formatISODateMinutes(data.data.item.createAt);
                this.expenseItem.set({
                    label:"<div class='edit-car-amount'>运费:</div>"
                    +"<div class='edit-car-amount'>交易金额（含运费）:</div>"
                    +"<div class='edit-car-createAt'>创建时间:</div>",
                    rightText:"<div class='edit-car-amount'>￥"+ window.fixedTo(data.data.item.tAmount,3) +"</div>"
                    +"<div class='edit-car-amount'>￥"+ window.fixedTo(data.data.item.amount,3) +"</div>"
                    +"<div class='edit-car-createAt'>"+ dates +"</div>"
                });
                domClass.add(query(".accept",this.bottomMenus)[0],"none");
                domClass.add(query(".deliver",this.bottomMenus)[0],"none");
                domClass.add(query(".cancel",this.bottomMenus)[0],"none");
                //依据订单主表显示订单按钮
                if(item.isPayed&&false===item.isAccepted&&false===item.isCanceled){
                    domClass.remove(query(".accept",this.bottomMenus)[0],"none");
                }
                if(item.isAccepted&&false===item.isDelived&&false===item.isCanceled){
                    domClass.remove(query(".deliver",this.bottomMenus)[0],"none");
                }
                if(item.payType === "point"){
                    if(item.isPayed && false===item.isCanceled){
                        domClass.remove(query(".cancel",this.bottomMenus)[0],"none");
                    }
                }else{
                    if(item.isPayed && false===item.isCanceled && false===item.isReceipted){
                        domClass.remove(query(".cancel",this.bottomMenus)[0],"none");
                    }
                }
                
                //有可能底部全部被隐藏,所以需要重算高度
                this.resize();
            }));
        },
        // 订单详细信息赋值
        getDetailLabel:function(item){
            var label = "<img class='edit-car-matimg' src='"+item.mId.logo+"' /><span class='edit-car-matname'>"+item.mId.mName+"</span><span class='edit-car-matprice'>￥"+window.fixedTo(item.price,3)+"</span>"
                +"<span class='edit-car-priceAll'>小计:￥"+window.fixedTo(item.price*item.qty,3)+"</span><div class='forth-btn ' detailId='" + item._id +"'>";
            //if(item.isPayed&&false===item.isAccepted&&false===item.isRefounded){
            //    label += "<span class='edit-car-revieweds'>审核</span>";
            //}
            //if(item.isAccepted&&false===item.isDelived&&false===item.isRefounded){
            //    label += "<span class='edit-car-send'>发货</span>";
            //}
            //if(item.isPayed){
            //    if(false===item.isRefounded){
            //        label += "<span class='edit-car-refunds'>退款</span>";
            //    }else{
            //        label += "<span class='edit-car-refundsed'>已退款</span>";
            //    }
            //}
            label += "</div>";
            return label;
        }
    });
});