// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
// 变更人员：母浚驰
// 变更时间：2016/6/20
// 变更内容：时间格式，页面样式修改
// 变更人员：母浚驰
// 变更时间：2016/6/22
// 变更内容：订单状态不做页面跳转，只刷新
// 变更人：潘云
// 变更时间：2016-06-23
// 功能：处理列表页面的搜索框、table页锁定到顶部等问题
// 变更人：周科吉
// 变更时间：2016-07-13
// 功能：商家发货后待发货列表没显示问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "dojo/query",
    "dojo/dom-class",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/store/JsonRest",
    "cq/biz/ts/order",
    "cq/biz/user/user"
], function (declare, lang, array, View, _ViewMixin, date, query, domClass, registry, EdgeToEdgeStoreList, on, JsonRest, order, user) {
    return declare("cq.ui.b.t.OrderList", [View, _ViewMixin], {
        // 设置初始显示第0行
        start : 0,
        pageSize : 10,
        // 加载数据,并显示到页面上
        onAfterShow : function () {
            // 判断是否登陆
            user.hasLogin().then(lang.hitch(this, function (s) {
                if (s) {
                    if (this.storeList.store) {
                        this.setQuery();
                    } else {
                        this.onLoadListData(this.storeList.setStore(this.store, this.getQuery(), {
                            start : this.start,
                            count : this.pageSize
                        }), this.start, this.pageSize);
                    }
                } else {
                    window.moveToView("login");
                    user.nextPage = "orderList";
                }
            }));
        },
        // 创建列表
        onCreatList : function () {
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                "class" : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<img class='edit-car-matimg' src='"+data[i].mId.logo+"' /><span class='edit-car-matname'>"+data[i].mId.mName+"</span>"
                            +"<span class='edit-car-matprice'>单价:￥"+window.fixedTo(data[i].price,3)+"</span>"
                            +"<span class='edit-car-priceAll'>小计:￥"+window.fixedTo(data[i].price*data[i].qty,3)+"</span>",
                        data[i].rightText = this.getDetailLabel(data[i]);
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                itemMap : {_label:"label", logo:"icon"}
            });
            //读取接口
            this.store = new JsonRest({target : order.loadShopDetail()});
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            // 侦听列表点击事件
            this.storeList.on("click", lang.hitch(this,this.onClickList));
            // 侦听列表下拉事件
            this.centerPanel.on("afterscroll", lang.hitch(this,this.onLoadMore));
        },
        // 订单状态的显示
        getDetailLabel : function(data){
            //data.isRefounded=Boolean(date.isPayed&&data.isCanceled)
            var label = "";
            if (false === data.isPayed && false === data.isCanceled) {
                label += "<div class='edit-car-reviewed'>待付款</div>";
            }
            if (data.isPayed && false === data.isAccepted && false === data.isRefounded && false === data.isCanceled) {
                label += "<div class='edit-car-reviewed'>待审核</div>";
            }
            if (data.isPayed && data.isAccepted && false === data.isDelived && false === data.isRefounded && false === data.isCanceled) {
                label += "<div class='edit-car-reviewed'>待发货</div>";
            }
            if (data.isPayed && data.isAccepted && data.isDelived && false === data.isRefounded && false === data.isCanceled) {
                label += "<div class='edit-car-reviewed'>已发货</div>";
            }
            if (data.isPayed && data.isAccepted && data.isDelived &&data.isCanceled){
                label += "<div class='edit-car-reviewed'>已退款</div>";
            }
            if (data.isCanceled&& false === data.isDelived && false === data.isRefounded &&false===data.isAccepted) {
                label += "<div class='edit-car-reviewed'>已取消</div>";
            }
            /*if(data.isPayed&&data.isAccepted&&data.isDelived&&data.isReceipted&&false===data.isCanceled&&false===data.isClosed){
                label += "<div class='edit-car-reviewed'>已收货</div>";
            }*/
            label += "<div class='order-list-qty'>x"+window.fixedTo(data.qty,1)+"</div>";
            label += "<div class='edit-car-date'>" + date.formatISODate(data.createAt) + "</div>";
            return label;
        },
        //初始化页面元素,绑定事件
        onFirstShow : function () {
            // 创建头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        //this.orderType = "0";
                        window.moveToView("home");
                        // history.back();
                    }
                },
                title:"订单管理"
            };
            this.addHeader(option);
            // 创建订单状态信息
            option = {
                isHeader : true,
                columns : [{
                    label : '待审核',
                    className : 'sale',
                    onClick : lang.hitch(this,function(e){
                        this.type = 0;
                        this.selectClass(e);
                        this.onAfterShow();
                    })
                }, {
                    label:'待发货',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 1;
                        this.selectClass(e);
                        this.onAfterShow();
                    })
                }, {
                    label:'已发货',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 2;
                        this.selectClass(e);
                        this.onAfterShow();
                    })
                }, {
                    label:'待付款',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 3;
                        this.selectClass(e);
                        this.onAfterShow();
                    })
                }, {
                    label:'全部',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 4;
                        this.selectClass(e);
                        this.onAfterShow();
                    })
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.onCreatList();
            this.onAfterShow();
        },
        // 清除所有的样式
        selectClass : function (evt) {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            domClass.add(evt.target, "selected");
        },
        // 订单列表点击
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _tsId = li.tsId;
            window.moveToView("orderDetail",_tsId);
        },
        // 获取查询条件
        getQuery : function () {
            var query = {};
            if (this.type === 0 || !this.type){//待审核
                //{isPayed:true,isRefounded:false,isAccepted:false,isCanceled:false}
                query.isPayed = true;
                query.isRefounded = false;
                query.isCanceled = false;
                query.isAccepted = false;
            }
            if (this.type === 1){//待发货
                query.isPayed = true;
                query.isRefounded = false;
                query.isDelived = false;
                query.isCanceled = false;
                query.isAccepted = true;
            }
            if (this.type === 2){//已发货
                //{isPayed:true,isDelived:true,isRefounded:false,isCanceled:false,isAccepted:true}
                query.isPayed = true;
                query.isRefounded = false;
                query.isDelived = true;
                query.isCanceled = false;
                query.isAccepted = true;
            }
            if (this.type === 3){//待付款
                //{isPayed:false,isCanceled:false}
                query.isPayed = false;
                query.isCanceled = false;
            }
            return query;
        },
        // 重新赋值列表并刷新显示
        setQuery:function(){
            this.start = 0;
            this.storeList.destroyDescendants();
            this.onLoadListData(this.storeList.setQuery(this.getQuery(),{
                start: this.start,
                count: this.pageSize
            }),this.start,this.pageSize);
        },
        // 下拉列表加载更多
        onLoadMore:function(evt){
            if(!this.busy && evt.afterBottom){
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }),this.start,this.pageSize);
                    }), 1000);
                }
                
            }
        }
    });
});