// 变更人：徐阿雪
// 变更时间：2016/08/02
// 变更内容：只能查询本上架的订单，需要传商家Id，继承orderList
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/query",
    "cq/widgets/item/OrderListItem",
    "cq/ui/common/ts/OrderList",
    "cq/biz/ts/order",
    "cq/widgets/item/OrderListItemB"
], function (declare,lang,array,domClass,query,OrderListItem,OrderList,order,OrderListItemB) {
    return declare("cq.ui.b.t.OrderListB", [OrderList], {
       OrderListItem:OrderListItemB,
        onAfterShow:function(){
            //处理选中问题
            this.changeTab();
            this.type=window.did;
            this.loadFirstPage();
			// B端订单列表需要显示收货人和收货地址
			//domClass.remove(query(".order-dname",this.domNode)[0], "none");
			//domClass.remove(query(".order-dAddress",this.domNode)[0], "none");
            window.free();
        },
        //订单详情界面id
        getOrderDetailView:function(){
            return "orderDetailB";
        },
        //加载订单列表的url
        getListTarget:function(){
            return order.getShopWithDetailsUrl();
        },
        //头部状态的重写
        getStateColumn:function(){
            return {
                isHeader: true,
                columns:[{
                    label:'全部',
                    onClick:lang.hitch(this,function(e){
                        // 徐阿雪 修改movetoview，重写一个函数，获取不同type的数据，加载显示出来
                        this.type= "";
                        this.loadFirstPage();
                        this.changeTab(e);
                    })
                },{
                    label:'待审核',//
                    onClick:lang.hitch(this,function(e){
                        this.type = 0;
                        this.loadFirstPage();
                        this.changeTab(e);
                    })
                },{
                    label:'待发货',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 1;
                        this.loadFirstPage();
                        this.changeTab(e);
                    })
                },{
                    label:'已发货',
                    onClick:lang.hitch(this,function(e){
                        this.type = 2;
                        this.loadFirstPage();
                        this.changeTab(e);
                    })
                },{
                    label:'待付款',
                    onClick:lang.hitch(this,function(e){
                        this.type = 3;
                        this.loadFirstPage();
                        this.changeTab(e);
                    })
                }],
                labelClass:'font-size1 tab-selector'
            };
        },
        changeTab: function(e){
            if(e){
                var dom = e.target;
                var items = query(".tab-selector",this.domNode);
                array.forEach(items,function(item){
                    domClass.remove(item,"selected");
                },this);
                domClass.add(dom,"selected");
            }else{
                var items = query(".tab-selector",this.domNode);
                array.forEach(items,function(item){
                    domClass.remove(item,"selected");
                },this);
                domClass.add(items[0],"selected");
            }
        },
        showDelivereInfo:function(){
            var orderDnames = query(".order-dname",this.domNode);
            var orderDaddresses = query(".order-dAddress",this.domNode);
            for(var i = 0 ;i < orderDnames.length; i ++){
                domClass.remove(orderDnames[i],"none");
                domClass.remove(orderDaddresses[i],"none");
            }
        },
        // 订单查询时的属性
        getParse: function(type){
            //type = type+"";
            if(type === 0){
                //待审核：已支付，未取消，未审核
                return {
                    isPayed:true,
                    isCanceled:false,
                    isAccepted:false,
                    orderBy:'-createAt'
                };
            } else if(type === 1){
                //待发货：已支付、未取消、未发货.已审核
                return {
                    isPayed:true,
                    isCanceled:false,
                    isAccepted:true,
                    isDelived:false,
                    orderBy:'-createAt'
                };
            }else if(type === 2){
                //待收货：已支付、未取消、已发货、未收货
                return {
                    isPayed:true,
                    isCanceled:false,
                    isDelived:true,
                    isReceipted:false,
                    orderBy:'-createAt'
                };
            } else if(type === 3){
                //代付款：未支付，未取消
                return {
                    isPayed:false,
                    isCanceled:false,
                    orderBy:'-createAt'
                };
            }else{
                return {
                    orderBy:'-createAt'
                };
            }
        },
        //重写头部返回view事件
        onBackButtonClick:function(){
            //window.moveToView("home");
            history.back();
        }
    });
});