// 创建人：潘云
// 创建时间：2016-06-24
// 功能：退款记录详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/dom-style",
    "cq/util/sys/date",
    "cq/biz/ts/refundRecord",
    "cq/biz/ts/order"
], function (declare, lang, View, _ViewMixin, domStyle, date, refundRecord, order) {
    // module:
    //        cq/ui/b/t/RefundRecordDetail
    return declare("cq.ui.b.t.RefundRecordDetail", [View, _ViewMixin], {
        onAfterShow : function () {
            refundRecord.loadById(window.did).then(lang.hitch(this, function (refundData) {
                if (refundData && refundData.data && refundData.data.item && refundData.data.item.tsId) {
                    var orderId = refundData.data.item.tsId || "";
                    order.loadById(orderId).then(lang.hitch(this, function (orderData) {
                        if (orderData && orderData.data && orderData.data.item) {
                            var data = {
                                tsId : refundData.data.item.tsId || "",
                                amount : window.fixedTo((refundData.data.item.amount || 0), 3),
                                payTime : orderData.data.item.payTime ? date.formatISODateMinutes(orderData.data.item.payTime) : "",
                                //userId : orderData.data.item.userId || "",
                                payType : this.getPayTypeStr(orderData.data.item.payType),
                                payLogId : orderData.data.item.payLogId || "",
								merchantNo: refundData.data.item.merchantNo,
								bankName: refundData.data.item.bankName,  //付款银行
								bankAccountCode: refundData.data.item.bankAccountCode,  //付款账号
								bankAccountName: refundData.data.item.bankAccountName
                            };
                            this.setData(data);
                            // 判断是否显示底部按钮
                            if (refundData.data.item.isVerified) {
                                domStyle.set(this.footerColumns, "display", "none");
                            } else {
                                domStyle.set(this.footerColumns, "display", "");
                            }
                            this.refreshData();
                        }
                    }));
                }
            }));
        },
        getPayTypeStr : function (payType) {
            var str = "未支付";
            if ("wxNative" === payType) {
                str = "微信扫一扫";
            }
            if ("aliwap" === payType) {
                str = "手机网页支付宝";
            }
            if ("aliweb" === payType) {
                str = "网页支付宝";
            }
            if ("aliapp" === payType) {
                str = "支付宝APP";
            }
            if ("weixin" === payType) {
                str = "微信支付";
            }
            if ("point" === payType) {
                str = "积分支付";
            }
            return str;
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "退款订单详情"
            };
            this.addHeader(option);
            // 订单信息
            option = {
                isEdge : true,
                lists : [{
                    //label: "交易单号",
                    //rightText: "{{payLogId}}",
                    label : '交易单号',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'payLogId',
                        disabled:"true"
                    }
                },{
                    //label : "退款订单",
                    //rightText : '{{tsId}}'
                    label : '退款订单',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'tsId',
                        disabled:"true"
                    }
                }, {
                    label : "退款金额",
                    rightText : '{{amount}}'
                }, 
                // {
                    // label : '退款客户',
                    // rightText : '{{userId}}'
                // }, 
                {
                    label : '订单支付时间',
                    rightText : '{{payTime}}'
                }, {
                    label : '订单支付方式',
                    rightText : '{{payType}}'
                }, {
                    label : '商户号',
                    rightText : '{{merchantNo}}'
                }, {
                    label : '付款银行',
                    rightText : '{{bankName}}'
                }, {
                    label : '付款账号',
                    rightText : '{{bankAccountCode}}'
                }, {
                    label : '付款账户名称',
                    rightText : '{{bankAccountName}}'
                }]
            };
            this.addLists(option);
            // 添加底部按钮
            option = {
                isEdge : true,
                columns : [{
                    label : '审核',
                    className : 'flex2 footer-tab-highlight verified',
                    onClick : this.onVerify
                }],
                forceWidth : false,
                isFooter : true
            };
            this.footerColumns = this.addColumns(option);
            this.onAfterShow();
        },
        onVerify : function () {
            window.busy();
            refundRecord.verify(window.did).then(lang.hitch(this, function (data) {
                window.free();
                if (data.data.ok === 1) {
                    history.back();
                } else {
                    alert("审核未通过");
                }
            }));
        }
    });
});