// 创建人：潘云
// 创建时间：2016-06-24
// 功能：退款记录列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/query",
    "dojo/on",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
	"cq/util/sys/date",
    "cq/biz/ts/refundRecord"
], function (declare, lang, array, domClass, query, on, JsonRest, registry, View, EdgeToEdgeStoreList, _ViewMixin, date, refundRecord) {
    // module:
    //        cq/ui/b/t/RefundRecordList
    return declare("cq.ui.b.t.RefundRecordList", [View, _ViewMixin], {
        //15723458944
        isVerified : false,
        // 数据加载开始下标
        start : 0,
        // 每次加载数据的条数
        pageSize : 20,
        onAfterShow : function () {
            if (this.storeList.store) {
                this.setQuery();
            } else {
                this.onLoadListData(this.storeList.setStore(this.store, this.getQuery(), {
                    start : this.start,
                    count : this.pageSize
                }),this.start,this.pageSize);
            }
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "退款记录"
            };
            this.headerList = this.addHeader(option);
            option = {
                isHeader : true,
                columns : [{
                    label : '待审核',
                    onClick : lang.hitch(this, function (evt) {
                        this.isVerified = false;
                        this.claerLabelClass(evt);
                        this.setQuery();
                    })
                }, {
                    label : '已审核',
                    onClick : lang.hitch(this, function (evt) {
                        this.isVerified = true;
                        this.claerLabelClass(evt);
                        this.setQuery();
                    })
                }],
                labelClass : 'font-size1 tab-selector'
            };
            this.addColumns(option);
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                "class" : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0;i < data.length;i++) {
						data[i]._label = "<div class='webkit-list'>"
						+"<div class='user-list-left user-list-margin'>退款日期:"+(date.formatISODateMinutes(data[i].createAt))+"</div>"
						+"<div class='user-list-left user-list-margin'>商户号:"+(data[i].merchantNo||"")+"</div>"
						+"</div>"
						+"<div class='webkit-list'>"
						+"<div class='user-list-right user-list-margin'>退款订单:"+(data[i].tsId || "")+"</div>"
						+"<div class='user-list-margin'>退款金额:"+window.fixedTo((data[i].amount || 0),3)+"</div></div>"						
                        //data[i]._label = "<div class='mat-list-mname mat-list-margin'>退款订单："+(data[i].tsId || "")+"</div>";
                        //data[i]._rightText = "<div class='mat-list-qty mat-list-margin'>退款金额："+window.fixedTo((data[i].amount || 0),3)+"</div>";
                        data[i].moveTo = "#";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                },
                itemMap : {
                    _label : "label",
                    _rightText : "rightText",
                    moveTo:"moveTo"
                }
            });
            this.store = new JsonRest({target : refundRecord.load()});
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.onAfterShow();
        },
        // 重写List的点击事件
        onClickList:function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("refundRecordDetail",_id);
        },
        // 改变标签的样式
        claerLabelClass:function(evnt){
            array.forEach(query(".tab-selector",this.domNode),function(item){
                domClass.remove(item,"selected");
            });
            domClass.add(evnt.target,"selected");
        },
        onLoadMore : function (evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }),this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        getQuery : function () {
            var query = {};
            query.isVerified = this.isVerified;
            return query;
        },
        setQuery : function () {
            this.start = 0;
            this.storeList.destroyDescendants();
            this.onLoadListData(this.storeList.setQuery(this.getQuery(),{
                start : this.start,
                count : this.pageSize
            }),this.start,this.pageSize);
        }
    });
});