// 创建人：潘云
// 创建时间：2016-06-17
// 功能：交易明细列表
// 变更人：潘云
// 变更时间：2016-06-23
// 功能：处理列表页面的搜索框、table页锁定到顶部等问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/query",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
	"dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/biz/ts/transaction",
    "cq/util/config/config",
    "cq/util/sys/date",
    "cq/util/sys/xlsx"
], function (declare, lang, array, domClass, query, on, when, JsonRest, registry, View, EdgeToEdgeStoreList, _ViewMixin, shop, transaction, config, date, xlsx) {
    // module:
    //        cq/ui/b/t/TransactionList
    return declare("cq.ui.b.t.TransactionList", [View, _ViewMixin], {
        //15723458944
        // 数据加载开始下标
        start : 0,
        // 每次加载数据的条数
        pageSize : 20,
        onAfterShow : function () {
            this.params = {
                tsState:2
            };
			this.setSelectedClass({
				target: query(".tab-selector", this.conditionMenus)[0]
			});
            if(window.did){
                this.params.shopId = window.did;
            }
            if(!this.store){
                this.store = new JsonRest({
                    target : this.getTransactionUrl()
                });
                var queryResult = this.storeList.setStore(this.store, this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                // 将数据源赋值给StoreList
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.setQuery(this.params/*this.storeList.get("query")*/);
            }
        },
        //获取链接可重载
        getTransactionUrl:function () {
            return transaction.load();
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "交易明细"
            };
            this.headerList = this.addHeader(option);
            option = {
                isHeader : true,
                columns : [{
                    label : '已结算',
                    onClick : lang.hitch(this,function(evt){
                        var query = {};
                        this.setSelectedClass(evt);
                        query.tsState = 2;
                        if(window.did){
                            query.shopId = window.did
                        }
                        this.setQuery(query);
                    })
                }, {
                    label : '待确认',
                    onClick : lang.hitch(this,function(evt){
                        var query = {};
                        this.setSelectedClass(evt);
                        query.tsState = 1;
                        if(window.did){
                            query.shopId = window.did
                        }
                        this.setQuery(query);
                    })
                }, {
                    label : '暂停中',
                    onClick : lang.hitch(this,function(evt){
                        var query = {};
                        this.setSelectedClass(evt);
                        query.tsState = 3;
                        if(window.did){
                            query.shopId = window.did
                        }
                        this.setQuery(query);
                    })
                }, {
                    label : '已取消',
                    onClick : lang.hitch(this,function(evt){
                        var query = {};
                        this.setSelectedClass(evt);
                        query.tsState = 4;
                        if(window.did){
                            query.shopId = window.did
                        }
                        this.setQuery(query);
                    })
                }],
                labelClass : 'font-size1 tab-selector'
            };
            this.conditionMenus=this.addColumns(option);
            option = {
                isFooter : true,
                columns : [{
                    label : "导出",
					className: 'flex2 footer-tab-highlight',
                    onClick : this.exportTransaction
                }],
                labelClass: 'font-size1',
                className: "fix-footer"
            };
            this.addColumns(option);  
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                "class" : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0;i < data.length;i++) {
                        data[i]._label = "<div class='webkit-list'><div class='user-list-left user-list-margin'>类型:"+this.getTypeStr(data[i].tsType) +"</div><div class='user-list-right user-list-margin'>"+date.formatISODateMinutes(data[i].createAt)+"</div></div>";
						data[i]._label += "<div class='webkit-list'><div class='user-list-left user-list-margin'>支付方式:"+this.getPayTypeStr(data[i].payType) +"</div><div class='user-list-right user-list-margin'>"+window.fixedTo((data[i].tsAmount || 0),3)+"</div></div>";
						data[i]._label += "<div class='webkit-list'><div class='user-list-margin'>交易单号:"+this.getPayLog(data[i].payLogId)+"</div></div>";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                },
                //itemMap : {_label : "label",_rightText : "rightText"}
                itemMap : {_label : "label"}
            });
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        // 清除所有的样式
        setSelectedClass : function (evt) {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            domClass.add(evt.target, "selected");
        },
		 onClickList: function(evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem")
                return;
			// tsType1:会员购买（在线支付金额）,2:支付手续费，3：技术服务费，4：交易补贴，5：提现，6：充值, 7: 团购活动预扣，8: 团购活动补差额
			if(li.params.tsType==5||li.params.tsType==6){
				//window.moveToView("trendDetail",li.params._id);
			} else {
				window.moveToView("orderDetailB",li.params.tsId);
			}
        },
        
        //数据导出功能 11-15 程磊
        exportTransaction : function(){
            var query = this.storeList.query;
            var url = transaction.loadTshop();
            // var queryString = "";
            // for(var item in query){
                // queryString += "&" + item + "=" + query[item];
            // }
            // url += queryString;
            //1:会员购买（在线支付金额）,2:支付手续费，3：技术服务费，4：交易补贴，5：提现，6：充值, 7: 团购活动预扣，8: 团购活动补差额
            var cols = [];
            cols[0] = {
                type : "options",
                className:"large-width",
                field:"tsType",
                label:"类型",
                options:{
                    "1": '会员购买（在线支付金额）',
                    "2": '支付手续费',
                    "3": '技术服务费',
                    "4": '交易补贴',
                    "5" : '提现',
                    "6" : '充值',
                    "7" : '团购活动预扣',
                    "8" : '团购活动补差额'
                }
            };
            cols[1] = {
                className:"large-width",
                field:"createAt",
                label:"时间"
            };
            cols[2] = {
                className:"large-width",
                field:"tsAmount",
                label:"金额"
            };
            cols[3] = {
                className:"large-width",
                field:"payType",
                label:"支付方式"
            };
            cols[4] = {
                className : "large-width",
                field : "payLogId",
                label : "交易单号"
            };
            cols[5] = {
                type : "options",
                className:"large-width",
                field:"tsState",
                label:"状态",
                options:{
                    "1": '进行中',
                    "2": '已结算',
                    "3": '暂停',
                    "4": '取消'
                }
            };
            xlsx.exportData(url,query,cols,Date.now().toString());
        },
        onLoadMore : function (evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
                
            }
        },
        getTypeStr : function (type) {
            var str = "暂无交易";
            if (type === 1) {
                str = "会员购买（在线支付金额）";
            }
            if (type === 2) {
                str = "支付手续费";
            }
            if (type === 3) {
                str = "交易手续费";
            }
            if (type === 4) {
                str = "交易补贴";
            }
            if (type === 5) {
                str = "提现";
            }
            if (type === 6) {
                str = "充值";
            }
            return str;
        },
		getPayTypeStr : function (type) {
            var str = "";
            if (type === "point") {
                str = "积分支付";
            }
            if (type === "weixin") {
                str = "微信支付";
            }
            if (type === "wxNative") {
                str = "微信网页支付";
            }
            if (type === "aliwap") {
                str = "支付宝手机网页支付";
            }
            if (type === "aliweb") {
                str = "支付宝网页支付";
            }
            if (type === "chinaPay") {
                str = "银联电子支付";
            }
			if (type === "unionPay") {
                str = "银联支付";
            }
			if (type === "cash") {
                str = "现金";
            }
            return str;
        },                
        getPayLog : function(paylog){
            if(paylog){
                return paylog;
            }else{
                return "";
            }
        },
        getStateStr : function (tsState) {
            var str = "";
            if (tsState === 1) {
                str = "进行中";
            }
            if (tsState === 2) {
                str = "已结算";
            }
            if (tsState === 3) {
                str = "暂停";
            }
            if (tsState === 4) {
                str = "取消";
            }
            return str;
        },
        setQuery : function (query) {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});