// 肖爱玲 20160526
// 变更人：   周科吉
// 变更时间： 2016-06-24
// 变更内容： 为完成按钮添加busy事件
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "dijit/focus",
    "cq/biz/user/expert"
],function(declare, lang, View, _ViewMixin, date, focusUtil, expert) {
    // module:
    //      cq/ui/b/u/Expert
    return declare("cq.ui.b.u.Expert", [ View, _ViewMixin ], {
        // 检测是否编辑状态
        isEditing : false,
        // 初始化相关接口
        onAfterShow : function() {
            if (!this.isEditing) {
                this.isEditing = true;
                if (!window.did) {
                    this.setData({});
                    this.refreshData();
                } else {
                    expert.loadById(window.did).then(lang.hitch(this, function(data) {
                        this.setData(data && data.data && data.data.item || {});
                        this.refreshData();
                    }));
                }
            }
        },
        // 初始化加载显示内容
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        //window.moveToView("expertList");
                        history.back();
                        this.isEditing = false;
                    }
                },
                title : "专家管理",
                right :{
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                lists : [ {
                    label : "头像",
                    noArrow : false,
                    class : "li-icon",
                    moveTo : "#",
					imgSize:{width:480,height:650},
                    edit : {type : "image", field : "logo"}
                } ]
            };
            var list = this.addLists(option);
            var li = list.getChildren()[0];
            this.iconLi = li;
            option = {
                isEdge : true,
                class : "bottom-margin16",
                lists : [{
                    label : '编码',
                    noArrow : true,
                    edit : {type : 'text', field : 'code'}
                },{
                    label : '姓名',
                    noArrow : true,
                    edit : {type : 'text', field : 'pName', placeHolder : "必填"}
                },{
                    label : '类型',
                    moveTo : "#",
                    edit : {
                        type : 'options',
                        field : 'category',
                        options : {
                            0 : "畜牧",
                            1 : "兽医",
                            2 : "市场"
                        }
                    }
                },{
                    label : '电话',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'phone',
                        placeHolder : "请输入电话"
                    }
                },{
                    label : '地址',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'address',
                        placeHolder : "请输入地址"
                    }
                },{
                    label : '职务',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'duty'
                    }
                },{
                    label : '单位',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'company'
                    }
                },{
                    label : '领域',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'field'
                    }
                },{
                    label : '个人履历',
                    rightText : '履历详情',
                    moveTo : '#',
                    __view_id : this.id,
                    edit : {
                        type : 'textarea',
                        field : 'resumes'
                    }
                },{
                    label : '经历特长',
                    rightText : '详情',
                    moveTo : '#',
                    __view_id : this.id,
                    edit : {
                        type : 'textarea',
                        field : 'skill'
                    }
                },{
                    label:'是否使用',
                    noArrow:true,
                    edit:{
                        type:'checkbox',
                        field:'isUse',
                        value:"on"
                    }
                }]
            };
            this.addLists(option);
            this.onAfterShow();
        },
        // 保存数据
        onSaveStore : function() {
            //锁定事件
            window.busy();
            // 当前节点失去焦点
            focusUtil.curNode && focusUtil.curNode.blur();
            var m = this.getData();
            var msg = this.checkData(m);
            if (msg){
                //释放事件
                window.free();
                alert(msg);
                return;
            }
            expert.save(m).then(lang.hitch(this, function(data) {
                //释放事件
                window.free();
                if (data.data.ok == 1) {
                    this.isEditing = false;
                    history.back();
                } else {
                    alert("保存失败");
                }
            }));
        },
        // 验证文本框内容
        checkData : function(data) {
            var msg = "";
            if (!data.pName) {
                return "姓名不能为空";
            }           
            if (!data.duty) {
                return "职务不能为空";
            }
        }
    });
});