// 创建人：肖爱玲 创建日期 专家档案
//变更人：程磊
//变更日期：2016-6-23
//变更事项：列表界面清单
// 变更人：   周科吉
// 变更时间： 2016-06-24
// 变更内容： 修改底部按钮样式
// 变更人：   张金鹏
// 变更时间： 2016-06-27
// 变更内容： 1.解决客户管理界面下拉出现重复数据 2.解决不会显示"加载中"的问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/user/expert",
    "dojo/dom-class"
],function(declare, lang, View, _ViewMixin, registry, EdgeToEdgeStoreList, on,
    when, JsonRest, expert, domClass) {
    // module:
    //      cq/ui/b/u/ExpertList
    return declare("cq.ui.b.u.ExpertList", [ View, _ViewMixin ], {
        // 初始化开始值
        start : 0,
        end:-1,
        // 20160621：分页大小默认20
        pageSize:20,
        // 设置查询条件
        setQuery : function(query) {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            //20160621:处理加载更多
            var queryResult = this.storeList.setQuery(query, {
                start:this.start,
                count:this.pageSize
            });
            // 将数据源赋值给storeList
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();
        },
        // 初始化相关接口
        onAfterShow : function() {
            if (this.storeList.store) {
                this.setQuery(this.storeList.get("query"));
            } else {
                //20160621:处理加载更多
                var queryResult = this.storeList.setStore(this.store, this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                // 将数据源赋值给storeList
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        // 初始化加载显示内容
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        //window.moveToView("others");
                        history.back();
                    }
                },
                onClick : function() {},
                title : "专家管理"
            };
            this.addHeader(option);
            option = {
                isHeader:true,
                placeHolder : "请输入要查询条件，按回车查询",
                class : "cqSearchBox",
                type : "search",
                onInput : lang.hitch(this, function(evt) {
                    if (evt.keyCode == 13) {
                        this.search = evt.target.value;
                        var condition =
                        this.storeList.get("query");
                        condition.search = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                columns : [ {
                    label : '添加专家',
                    icon : 'images/icon/crmicon.png',
                    iconClass : 'footer-tab-img',
                    onClick : function() { window.moveToView("expert"); }
                } ],
                valueClass : 'font-size3',
                labelClass : 'font-size1',
                className : 'fix-footer',
                isFooter : true
            };
            this.addColumns(option);
            // 创建数据源
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                onComplete : lang.hitch(this,
                function(data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label="<div style='display:flex;'>"
                            +"<div style='flex:1;'>"
							+"<div class='user-list-left user-list-margin'>姓名:"+(data[i].pName||"")+"</div>"
							+"<div class='user-list-left user-list-margin'>类型:"+this.parseType(data[i].category)+"</div>"
							+"</div>"
                            +"<div class='user-list-right user-list-margin'>职务:"+(data[i].duty||"")+"</div>"
                            +"</div>"
                            +"<div class='webkit-list'>"
                            +"<div class='user-list-margin'>电话:"+(data[i].phone||"")+"</div></div>"
                            +"<div class='user-list-margin'>地址:"+(data[i].address||'')+" </div>"
                        data[i].moveTo="#";
                        data[i]._logo = data[i].logo? data[i].logo : 'images/userIcon.png';
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                // 查询条件
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                },
                itemMap : {
                    _label : "label",
                    _logo : "icon",
                    moveTo : "moveTo"
                }
            });
            // 创建数据源
            this.params = {orderBy:'code'};
            this.store = new JsonRest({
                target : expert.load()
            });
            // 将数据源赋值给StoreList
            // this.storeList.setStore(this.store,this.params);
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on( "afterscroll",lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
		parseType:function(typeId){
			var typeName="";
			switch(typeId){
				case 0:{
					typeName="畜牧";
					break;
				}
				case 1:{
					typeName="兽医";
					break;
				}
				case 2:{
					typeName="市场";
					break;
				}				
				default:{
					typeName="未知";
					break;
				}
			}
			return typeName;
		},
        // 重写List的点击事件
        onClickList : function(evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem"){
                return;
            }
            var _id = li.params._id;
            window.moveToView("expert", _id);
        },
        // 重写拖拽加载更多事件
        onLoadMore : function(evt) {
			//判断下拉方向和防止多次加载
            if(!this.busy&&evt.afterBottom){
				//设置本次加载内容的起始位置
                this.start = this.start + this.pageSize;
				//判断能否加载更多内容
				if(this.canLoadMore(this.start)){
					console.log("加载更多客户");
                    this.busy = true;
					setTimeout(lang.hitch(this, function() {
						//20160627:处理加载更多
							var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
								start : this.start,
								count : this.pageSize
						});
						this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
				}
            }
        }
    });
});