﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop"
],function(declare,lang,View,_ViewMixin){
    return declare("cq.ui.b.u.UserSetting",[View,_ViewMixin],{
        onFirstShow:function () {
            var options = {
                left:{
                    iconButton:" ",
                    label:"返回",
                    arrow:"left",
                    onClick:function () {
                        history.back();                        
                    }
                },
                title:"设置"
            };
            this.addHeader(options);
            options = {
                isEdge:true,
                class : "bottom-margin16",
                lists:[
                    {
                        label:"个人信息",
                        moveTo:"#",
                        rightText:"修改个人信息",
                        noArrow:false,
                        onClick:function () {
                            window.moveToView("personalInformation");
                        }
                    },
                    {
                        label:'{{shopName}}',
                        moveTo:"#",
                        rightText:"切换店铺",
                        noArrow:false,
                        onClick:function () {
                            window.moveToView("shopList");
                        }
                    }
                ]
            };
            this.addLists(options);
            if (window.__shop.platformShopId == window.__shop._id) {
                options = {
                    isEdge:true,
                    lists:[{
                            label:'平台设置',
                            moveTo:"#",
                            rightText:"点击设置",
                            noArrow:false,
                            onClick:function () {
                                window.moveToView("setPlatform");
                            }
                        }
                    ]
                };
                this.addLists(options);
            }
            
            
            option = {
                columns : [{
                    label : '修改密码',
                    className : 'flex2 footer-tab-dark',
                    onClick : function () {
                        window.moveToView("changePassword");
                    }
                },{
                    label : '注销',
                    className : 'flex2 footer-tab-highlight',
                    onClick : function () {
                        shop.logout().then(lang.hitch(this, function () {
                            window.moveToView("login");
                        }));
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.addColumns(option);
            
            this.onAfterShow();
        },
        onAfterShow:function () {
            this.inherited(arguments);
            var data = {};
            data.shopName = __shop.shopName;
            data.userName = "";
            this.setData(data);
            this.refreshData();
        }
    });
});
