 // 创建人：肖爱玲  创建时间：20160524
/*  修改日期：20160621
    修改人：胡飞
    修改内容：显示正在充值会员的姓名和手机号码，以免误充
*/
//变更人：程磊
//变更日期：20160624
//变更内容：编辑界面    busy/free
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/user"
],function(declare,lang,View,_ViewMixin,user){
    // module:
    //      cq/ui/b/u/UserCredit
    return declare("cq.ui.b.u.UserCredit", [View, _ViewMixin], {
        // 检测是否编辑状态
        isEditing: false,
        // 初始化相关接口
        onAfterShow: function () {
            if (!this.isEditing) {
                this.isEditing = true;
                // 加载当前用户的信息
                user.loadById(window.did).then(lang.hitch(this,function(userData){
                    var data={};
                    // 设置要显示的姓名和电话
                    data.pName = userData.data.item.pName||"未设置";
                    data.phone = userData.data.item.phone||"未设置";
                    // 设置本视图的数据
                    this.setData(data);
                    // 刷新显示
                    this.refreshData();
                }));
            }
        },
        // 初始化加载显示内容
        onFirstShow: function () {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function () {
                        //window.moveToView("userList");
                        this.isEditing = false;
                        history.back();
                    }
                }, title: "客户充值"
            };
            this.addHeader(option);
            // 20160621
            // 显示正在充值的会员的姓名和手机号码
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label: '姓名',
                    noArrow: true,
                    rightText:"{{pName}}"
                },{
                    label: '电话',
                    noArrow: true,
                    rightText:"{{phone}}"
                },
                //添加微信昵称
                {
                    label: '昵称',
                    noArrow: true,
                    rightText:"{{nickName}}"
                },]
            };
            this.addLists(option);
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: [{
                    label: '充值金额',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'amount',
                        placeHolder: "必填"
                    }
                }]
            };
            this.addLists(option);
            option = {
                columns : [{
                    label : '提交',
                    className : 'flex2 footer-tab-highlight',
                    onClick : function () {
                        this.onSaveStore();
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        onSaveStore: function () {
            //添加busy属性
            window.busy();
            var m = this.getData();
            if (!m.amount) {
                //添加free属性
                window.free();
                alert("金额必须输入");
                return;
            }
            m._id = window.did;
            user.incamount(m).then(lang.hitch(this, function (data) {
                //设置界面free
                window.free();
                if(data.data.ok == 1){
                    this.isEditing = false;
                    //window.moveToView("userList");
                    history.back();
                }else{
                    alert("充值失败");
                }
            }));
        }
    });
});