//变更人员： 杜飞军
//变更内容： 代码规范，添加注释，文件迁移
//变更时间： 2016/05/17
//修改人员：胡飞
//修改日期：20160621
//修改内容：会员余额为0，列表中显示余额处为空
//修改人员：胡飞
//修改日期：2016/06/22
//修改内容：修改客户管理列表显示字段依次为:LOGO/姓名/昵称/电话/余额/地址
//变更人员:   冉伟
//变更时间: 2016/6/22
//变更原因: 设置客户端底部图标的高度使其与农企宝底部高度保持一致
//变更人员: 冉伟
//变更时间: 2016/6/27
//变更原因: 1.解决客户管理界面下拉出现重复数据 2.解决不会显示"加载中"的问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/user/user",
    "dojo/dom-class"
],function(declare, lang, View, _ViewMixin, registry, EdgeToEdgeStoreList,on,when, JsonRest, user, domClass){
    // module:
    // cq/ui/b/u/UserList
    return declare("cq.ui.b.u.UserList",[View,_ViewMixin],{
        // 初始化开始值
        start:0,
        end:-1,
        pageSize : 20,
        // 设置查询条件
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();
        },
        // 初始化相关接口
        onAfterShow:function(){
            if(this.storeList.store){
                this.setQuery(this.params);
            }else{
                this.store = new JsonRest({target:user.getUserUrl()});
                var queryResult = this.storeList.setStore(this.store,this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
                this.centerPanel.resize();
            }
           // this.refreshData();
        },
        onAfterAddNameSearchBox:function(){},
        // 初始化加载显示内容
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        //window.moveToView("home");
                        history.back();
                    }
                },
                onClick:function(){},
                title:"客户管理"
            };
            this.addHeader(option);
            option = {
                placeHolder:"请输入要查询条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                isHeader:true,
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.search = evt.target.value;
                        this.setQuery(condition);
                        //condition.search = "";
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            //添加搜索款之后可能要添加客户类型选项，提供接口
            this.onAfterAddNameSearchBox();
            
            option = this.getBottomButtonOptions();
            this.addColumns(option);
            // 创建数据源
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(datas){
                    var data = datas;
                    for(var i=0;i<data.length;i++){
						data[i]._label = this.getUserLabel(data[i]);
                        //data[i].moveTo="#";
                        data[i]._logo=data[i].logo?data[i].logo:'images/userIcon.png';
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                // 查询条件
                queryOptions: {
                    count: 20,
                    start: this.start
                },
                itemMap:{
                    _label:"label",
                    _logo:"icon",
                    moveTo:"moveTo"
                }
            });
            // 创建数据源
            this.params = {};
            // this.store = new JsonRest({target:user.getUserUrl()});
            // 将数据源赋值给StoreList
            // this.onLoadListData(this.storeList.setStore(this.store,this.params));
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        getBottomButtonOptions:function(){
            return {
                columns:[{
                    label:'添加客户',
                    className: "footer-tab-highlight",
                    onClick:function(){
                        window.moveToView("user");
                    }
                }],                
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
        },
        // 重写List的点击事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem"){
                return;
            }
            var dom = evt.target;
            //编辑
            if(dom&&domClass.contains(dom,"edituser")){
                var _id = li.params._id;
                window.moveToView("user",_id);
            }
            //充值
            if(dom&&domClass.contains(dom,"usercredit")){
                var _id = li.params._id;
                window.moveToView("userCredit",_id);
            }
            //客服记录
            var currentUserInfo = {};
            if(dom&&domClass.contains(dom,"chatbtn")){
                var _id = li.params._id;
                window.moveToView("svcDetail",user.getShopId()+","+_id);
            }
            //azlx平台农户修改密码
            if(dom&&domClass.contains(dom,"changePassword")){
                var id = li.params._id;
                var password = prompt("请输入新密码");
                var userName = li.params.userName;
                user.changeUserPassword(id,userName,password).then(lang.hitch(this, function (data){
                    if(data.data.ok==1){
                        alert('密码修改成功');
                    }else{
                        alert('密码修改失败');
                    }
                }));
            }        
        },
        // 重写拖拽加载更多事件
        onLoadMore:function(evt){
			//判断下拉方向和能否加载
            if(!this.busy&&evt.afterBottom){
				//设置本次加载内容的起始位置
                this.start = this.start + this.pageSize;
				//判断能否加载更多内容
				if(this.canLoadMore(this.start)){
					console.log("加载更多客户");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
						//执行加载内容操作
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
						//执行加载更多函数
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
				}
            }
        },
		getUserLabel:function(data){
			return "<div class='webkit-list'>"
				+"<div class='user-list-left user-list-margin'>姓名:"+(data.pName||"")+"</div>"
				+"<div class='user-list-left user-list-margin'>昵称:"+(data.nickName||"")+"</div>"
				+"</div>"
				+"<div class='webkit-list'>"
				+"<div class='user-list-right user-list-margin'>余额:"+window.fixedTo(data.amount||"0" ,3)+"</div>"
				+"<div class='user-list-margin'>电话:"+(data.phone||"")+"</div></div>"
				+"<div class='webkit-list'><div class='user-list-right user-list-margin'>地址:"+(data.address||"")+"</div></div>"
				+"<div class='forth-btn'><span class='edituser float-right'>编辑</span>"
				+"<span class='usercredit float-right'>充值</span>"
				+"<span class='chatbtn float-right'>客服记录</span></div>";
		}
    });
});