//创建人：周超
//创建时间:2016-8-5
//创建内容:追加评价
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/query",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "cq/biz/ts/order",
    "cq/biz/article/ss/comment",
    "cq/biz/mat/mat",
    "cq/util/sys/date",
    "cq/ui/view/_ViewMixin"
],function(declare, lang, domClass, query, View, ListItem, order, comment, mat, date, _ViewMixin){
    return declare("whz.view.Eva",[View,_ViewMixin],{
        isEditing:false,
        // 初始化页面元素,绑定事件
        onFirstShow:function(){
            // 创建头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        this.isEditing=false;
                        history.back();
                    }
                },
                title:"评价详情"
            };
            this.addHeader(option);
            //商品信息
            option={
                isEdge:true,
                lists:[],
                'class':"bottom-margin16"
                };
            this.matList=this.addLists(option);
            //输入文本框
            option={
                isEdge:true,
                lists:[],
                'class':"bottom-margin16"
                };
            this.setInfo=this.addLists(option);
            option = {
                columns: [{
                    label: "提交",
                    onClick: lang.hitch(this, function() {
                        this.addNewInfo();
                    }),
                    className: "flex2 footer-tab-highlight"
                }],
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(option);
            this.onAfterShow();
        },
        addNewInfo:function(){
            var node = query(".getEval",this.domNode)[0];
            this.data.superadditionContent = node.value;
            this.onSaveStore();
        },
        // 加载数据,并显示到页面上
        onAfterShow:function () {
            if(!this.isEditing){
                this.isEditing = true;
                if(window.did){
                    this.matList.destroyDescendants();
                    comment.loadById(window.did).then(lang.hitch(this,function (data) {
                        //设置全局变量，方便保存
                        this.data = data.data.item;
                        this.nowDateTime = date.formatISODateMinutes(date.nowISOString());
                        this.comment = data.data.item.content;
                        mat.loadById(data.data.item.commentId).then(lang.hitch(this,function (data1) {
                            //添加商品列表项
                            var listitem=new ListItem({
                                label:this.getDetailLabel(data1.data.item),
                                //rightText:"<span class='edit-car-qty'>x"+data1.data.item.qty+"</span>",
                                variableHeight:true
                                });
                            this.matList.addChild(listitem);
                        }));
                    }));
                    this.setInfo.destroyDescendants();
                    //添加输入区域
                    var listitem=new ListItem({
                        label:"<div>追加评价</div><div class = 'evaltext'><textarea class = 'getEval' maxlength='512' rows='5' placeholder='亲，在这里追加评价哦'></textarea></div>",
                        variableHeight:true
                        });
                    this.setInfo.addChild(listitem);
                    this.resize();
                }
            }
        },
        // 订单详细信息赋值
        getDetailLabel:function(item){
            var label = "<div><img class='edit-car-matimg' src='"+item.logo+"' /><span class='edit-car-matname'>"+item.mName+"</span><span class='edit-car-matprice'>￥"+window.fixedTo(item.retailPrice,3)+"</span>";
            label += "</div>"+
            "<div style='height: 40px;line-height: 40px;'>"+(this.comment||"")+"</div>"+
            "<div>"+this.nowDateTime+"</div>";
            return label;
        },
        //保存
        onSaveStore:function(){
            window.busy();
            if(this.isEditing){
                this.isEditing=false;
                if(!this.data.superadditionContent){
                    window.free();
                    alert("评价不能为空！");
                    this.isEditing=true;
                    return;
                }
                comment.save(this.data).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok == 1){
                        alert("追加评论成功");
                        history.back();
                    }else{
                        alert("追加评论失败");
                        this.isEditing=true;
                        return;
                    }
                }));
            }
        }
    });
});