// 变更人：周超
// 变更时间：2016-08-05
// 变更内容：评价列表
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
	"dojo/dom-style",
	"dojo/query",
    "dojo/on",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojox/mobile/Rating",
    "cq/biz/article/ss/comment",
    "cq/biz/mat/mat",
	"cq/util/sys/date",
	"cq/ui/view/_ViewMixin",
], function(declare, lang, array, domClass, domStyle, query, on, JsonRest, registry, View, EdgeToEdgeStoreList, Rating, comment, mat, date, _ViewMixin){
	return declare("whz.view.EvaList",[View,_ViewMixin],{
		start : 0,
		pageSize : 7,
		onAfterShow:function(){
			this.scores = [];
			if (this.storeList.store) {
				this.setQuery(this.storeList.get("query"));
			}else{
                this.params = {
                    withMat: 1,
                    commentType : "mat",
					orderBy:"-lastMod"
                };
                this.store = new JsonRest({
                    target:comment.getLoadUrl()
                });
				this.onLoadListData(this.storeList.setStore(this.store,this.params,{
					start: 0,
					count: this.pageSize
				}),this.start,this.pageSize);
			}
			//this.refreshData();
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
                        history.back();
                        
					}
				},
				title:"商品评价"
			};
			this.addHeader(option);
			// 添加评论列表
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				"class":"icon-list-item",
				variableHeight:true,
				//获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){
                    //在读取到商品数据还没读取完就开始走下一个for循环额
					for(var i=0;i<data.length;i++){
                        // 保存评价等级信息
                        this.scores.push(data[i].score);
                        //商品名
                        data[i]._label="<div class='userInfo'>"+data[i].commentId.mName+"<div class='ratingdiv'></div></div>"
                            +"<div class='userEva font-size1'>"+((data[i].content)||("&nbsp"))+"</div>";
                        if(data[i].images){
							data[i]._label += "<div class='evalimages'>";
							array.forEach(data[i].images,function(image){
								data[i]._label += "<img src='"+image+"'>";
							});
							data[i]._label += "</div>";
						}
                        //评价时间追加显示为时分秒
                        data[i]._label += "<div class='evaDate'>"+(date.formatISODateMinutes(data[i].createAt))+"</div>";
                        //追加评价
                        data[i]._label += (data[i].superadditionContent)?("<div class='font-size1'>[追加评价]"+(data[i].superadditionContent)+"</div>"):"";
                        //回复评价
                        data[i]._label += (data[i].recoveryContent)?("<div class='font-size1' style='float:right; background-color:rgb(248,248,248)'>[商家回复]"+(data[i].recoveryContent)+"</div>"):"";
                        //按钮：追加评论，修改评论暂时放着
                        data[i]._label += (data[i].superadditionContent)?"":("<div class='edit-car-comment addContent'>追加评价</div>");
					}
					this.storeList.generateList(data);
					this.setRadio();
					this.busy = false;
				}),
				queryOptions: {
					count: this.pageSize,
					start: this.start
				},
				itemMap:{_label:"label"}
			});
			this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
            this.on("click",lang.hitch(this,this.onContentClick));
			this.onAfterShow();
		},
        onContentClick:function(evt){
            //var targ = query(".addContent",this.domNode)[0];
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            var isClickDet = domClass.contains(evt.target, "addContent");
            if(isClickDet){
                if(li.declaredClass!="dojox.mobile.ListItem") return;
                window.moveToView('eva',li.params._id);
            }
        },
		// 加载商品的评论等级
		setRadio:function(){
			var lis = query("li",this.storeList.domNode);
			for(var i = this.start;i<lis.length;i++){
				var lidiv = query("div",lis[i])[0];
				var userInfoDiv = query(".userInfo",lidiv)[0];
				var radioDiv = query(".ratingdiv",userInfoDiv)[0];
				this.createRating(radioDiv,this.scores[i]);
			}
		},
		// 创建星级评论
		createRating:function(domNode,score){
			var scoreWidget = new Rating({
                image: "/static/common/images/star-orange.png",
                numStars: 5,
                value: score
            });
			domNode.appendChild(scoreWidget.domNode);
		},
		onLoadMore : function(evt){
			if(!this.busy && evt.afterBottom){
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }),this.start,this.pageSize);
                    }), 1000);
                }
                
            }
		},
		getQuery : function(){
			var query = {};
			if(window.did){
				query.commentId = window.did;
			}
            query.withMat = 1;
			query.commentType = "mat";
			return query;
		},
		setQuery : function(){
			this.start = 0;
			this.storeList.destroyDescendants();
			this.onLoadListData(this.storeList.setQuery(this.getQuery(),{
				start: this.start,
				count: this.pageSize
			}), this.start, this.pageSize);
		}
	});
});
