//功能：依据模板定义，呈现设置界面，依据用户设置替换模板并得到结果

define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/Deferred",
	"dojo/_base/array",
	"dojo/_base/query",
	"dojo/dom-construct",
	"dojox/mobile/View",
	"cq/biz/article/pm/richTextTemp",
	"cq/ui/view/_ViewMixin"
],function(declare,lang,Deferred,array,query,domConstruct,View,richTextTemp,_ViewMixin){
	return declare("cq.ui.common.article.RichTempReplaceView",[View,_ViewMixin],{

		//依据模板创建用户设置界面，依据用户设置和模板信息，返回替换之后的结果
		startReplace:function(tempId){
			var def = this.replaceDef = new Deferred();
			this.loadTempById(tempId).then(lang.hitch(this,this.onTempLoaded));
			return def;
		},
		//依据模板id获取模板信息
		loadTempById:function(tempId){
            return richTextTemp.loadById(tempId);
		},
		//模板加载之后的处理：
		//  依据模板信息生成替换关键字设置界面,确定和取消按钮
		//  记录模板数据
		onTempLoaded:function(tempData){
			//生成设置界面
    		var option = {
    			isEdge:true,
    			lists:[]
    		};
    		array.forEach(tempData.replaceTxt,function(item){
                option.lists.push({label:item.replaceTxt,edit:{type:(item.replaceType==1?"text":"image"),field:item.replaceTxt+(item.replaceType==1?"-text":"")}});
    		});
            this.addList(option);
            //生成确定和取消按钮
            option = {
            	columns : [
            	{
            		label : "确定",
            		onClick : lang.hitch(this,function(){
            			this.onReplaceFinished(tempData.content);
            		})
            	},
            	{
            		label : "取消",
            		onClick : this.onReplaceCanceled
            	}],
	            forceWidth : false,
                isFooter : true
            };
            this.addColumns(option);
		},
		//确定按钮的响应
		onReplaceFinished:function(content){
			//获取html片段
			var replacedString = content;
			//获取用户设置的信息
			var data = this.getData();
			//遍历用户设置的信息，判断是文本类型还是图片类型，进行替换
			for(var field in data){
				if(field.indexOf("text")){
                   replacedString.replace("[["+field.split("-")[0]+"]]",data[field]);
                   delete data[field];
				}
			}
            var hideDiv = domConstruct.create("div",{
            	style:"display:none;",
            	innerHTML:replacedString
            },document.body);
            for(var field in data){
 				query("img[alt=\\[\\[field\\]\\]",hideDiv)[0].src = data[field];
            }
            replacedString = hideDiv.innerHTML;
            document.body.removeChild(hideDiv);
			//执行替换
			this.replaceDef.resolve(replacedString);
		},
		//取消按钮的响应
		onReplaceCanceled:function(){
			this.replaceDef.resolve();
		}
	});
})