﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/store/JsonRest",
    "dojo/touch",
    "dojo/query",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/blob/blob"
],function( declare, lang , array, domClass, domStyle, JsonRest, touch, query, Deferred, DeferredList, View, EdgeToEdgeStoreList, _ViewMixin, blob){
    return declare("cq.ui.common.icons.IconStorage",[View,_ViewMixin],{
        start:0,
        pageSize:20,
        //创建页面元素，初始化界面元素
        onFirstShow: function(){
            //创建头部
            this.addHeader(this.getHeadOption());
            //添加顶部图库切换
            option = {
                isHeader: true,
                className:"tabBox",
                columns:[{
                    label:'文本格式图片',
                    className:'flex1',
                    onClick:function(e){
                        this.unableEdit();
                        this.setSelected(e.target);
                        this.refreshList(1);
                    }
                },
                {
                    label:'商品格式图片',
                    className:'flex1',
                    onClick:function(e){
                        this.canEdit();
                        this.setSelected(e.target);
                        this.refreshList(2);
                    }
                }],
                labelClass:'font-size1 tab-selector',
                forceWidth: false
            };
            this.addColumns(option);
            //初始化列表显示界面
            this.storeList = new EdgeToEdgeStoreList({
                baseClass:"",
                append : true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    //?
                    //依据数据加载列表
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                // 查询条件
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{
                    _label:"label",
                    _logo:"icon",
                    moveTo:"moveTo"
                }
            });
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            //为列表项中的图片添加点击事件
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            //为中间区域绑定滑动事件和点击事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            //添加底部按钮
            this.addColumns(this.getFooterOption());
            this.onAfterShow();
        },
        getTargetUrl:function(){
            return ;
        },
        onAfterShow:function(){
            //清空列表
            this.storeList.destroyDescendants();
            var queryResult=null;
            //判断数据是否存在，并依据数据加载列表内容
            if(!this.store){
                this.params={};
                //？
                this.store= new JsonRest({target:this.getTargetUrl()});
                queryResult=this.storeList.setQuery(this.store,this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.storeList.destroyDescendants();
                setTimeout(lang.hitch(this,function(){
                    queryResult=this.storeList.setQuery(this.params,{
                        start:this.start,
                        count:this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
                }),300);
            }
        },
        getFooterOption:function(){
            return  {
                columns:[{
                    label:'添加',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:function(){
                        window.moveToView("iconEdit");
                    }
                }],
                // {
                    // label:'使用',
                    // icon:'images/icon/addnews.png',
                    // iconClass:'footer-tab-img',
                    // onClick:function(){
                        
                    // }
                // }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
        },
        getHeadOption:function(){
            return {
                left: {
                    iconButton: ' ',
                    arrow: 'left',
                    label: '返回',
                    onClick: function(){
                        history.back();
                    }
                },
                title:"图库",
                right:{
                    iconButton : ' ',
                    label : "系统图片",
                    onClick:function(){
                        window.moveToView("iconStoragePlat");
                    }
                }
            };  
        },
        //添加点击列表图片
        showFilterOverlay: function(){
            if(!this.assistFilterDiv){
                //设置筛选页面高度为body的60%
                this.assistFilterDiv = domConstruct.create("div",{style:"height:" + domStyle.get(document.body,"height")*0.3+"px",className:"assistFilterDiv"});
                this.assistFilterDiv.appendChild(this.addColumns({
                    columns : [{
                            label : '使用',
                            onClick : lang.hitch(this,function () {
                                this.useIcon();
                            }),
                            className: "footer-tab-highlight"
                        }, {
                            label : '删除',
                            onClick : lang.hitch(this,function () {
                                this.deleteIcon();
                            }),
                            className: "footer-tab-dark"
                        }
                    ],
                    labelClass : 'font-size3',
                    className : 'hflex'
                }));
                this.showInOverlay(this.assistFilterDiv);
            }else {
                this.showInOverlay(this.assistFilterDiv);
            }
        },
        canEdit:function(){
            
        },
        unableEdit:function(){
            
        },
        //选中样式
        setSelected:function(evt){
            //清空所有节点选中样式
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            //为选中节点添加选中样式
            domClass.add(evt,"selected");
        },
        //依据条件来刷新列表
        refreshList:function(num,item){
            //为1为加载   
            if(num==1){
                console.log("1");
            }else if(num==2){
                console.log("2");
            }
        },
        //加载更多
        onLoadMore:function(){
            //如果this.busy为false，且afterBottom为true，且canLoadMore为true，加载更多
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        //依据条件加载数据
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        //列表点击事件
        onClickList:function(evt){
            //获取点击事件的节点
            var li = registry.getEnclosingWidget(evt.target);
            //判断所点击的区域是否为listItem区域
            if (li.declaredClass != "dojox.mobile.ListItem"){
                return;
            }
            var _id = li.params._id;
            if (dom && domClass.contains(dom, "iconShow")){
                this.showFilterOverlay();
            } 
        },
        useIcon:function(){
            
        },
        deleteIcon:function(){
            
        }
    });
});