﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/touch",
    "dojo/query",
    "dojox/uuid/generateRandomUuid",
    "dojox/mobile/Heading",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dijit/registry",
    "dijit/_WidgetBase",
    "cq/biz/blob/blob",
    "cq/biz/article/imageLib",    
    "cq/ui/view/_ViewMixin",
    "cq/ui/util/imageBlob",
    "cq/util/edit/overlay",
    "cq/util/image/selector",
    "dojo/request/xhr",
    "cq/util/config/config"
],function(declare,lang,JsonRest,domClass,domConstruct,domStyle,touch,query,uuid,Heading,View,EdgeToEdgeStoreList,registry,_WidgetBase,blob,imageLib,_ViewMixin,imageBlob,overlay,imgSelector,xhr,config){
    //创建系统图库的ui组件
    var OrderListPlatItem = declare("", [_WidgetBase], {
        params:null,
        logo:"",
        baseClass:"icon-list-items",
        buildRendering:function(){
            this.inherited(arguments);
            //列表项的htmlStr
            var itemHtmlStr = ''+'<div class="mat-list-imgpart" style="position:relative;display:inline-block;width:100px;margin-right:20px;margin-top:10px;margin-bottom:5px"><img width="90px" height="90px" src="' + this.msgContent + '" /></div>';
            this.domNode.appendChild(domConstruct.toDom(itemHtmlStr));
        }
    });
    var OrderListItem = declare("", [_WidgetBase], {
        params:null,
        logo:"",
        baseClass:"icon-list-items",
        buildRendering:function(){
            this.inherited(arguments);
            //列表项的htmlStr
            var itemHtmlStr = ''+'<div class="mat-list-imgpart" style="position:relative;display:inline-block;width:100px;margin-right:20px;margin-top:10px;margin-bottom:5px"><img width="90px" height="90px" src="' + this.msgContent + '" /><div class="iconDelete" style="position:absolute;right:-5px;top:-45px"><img width="20px" src="http://192.168.0.2/static/sites/xmapp/images/delete.png"/></div></div>';
            this.domNode.appendChild(domConstruct.toDom(itemHtmlStr));
        }
    });
    return declare("cq.ui.common.icons.IconStorageB",[View,_ViewMixin],{
        start:0,
        pageSize:100,
        groupId:0,
         //1.初始化界面元素(编辑页面)
        onFirstShow:function(){
            //1.1添加页面头部，包括左边的取消按钮，中间的图片库和系统图片库以及右边的添加本地图片的按钮(点击图库切换View)
            var option={
                left: {
                    iconButton: ' ',
                    arrow: 'left',
                    label: '返回',
                    onClick: function(){
                        history.back();
                    }
                },
                title:'',
                center1:{
                    iconButton : ' ',
                    label : "图片库",
                    onClick:function(){
                        this.toIconView();
                        this.setQuery({});
                    }
                },
                center2:{
                    iconButton : ' ',
                    label : "系统图片",
                    onClick:function(){
                        this.toPlatIconView();
                    }
                },
                right:{
                    iconButton : ' ',
                    label : "添加",
                    onClick:function(){
                        this.addNewIcon();
                    }
                },
                baseClass:"tab-selector head-selector"
            };
            this.headerOption= this.addHeader(option);
            //1.2添加类别选项
            option={
                isHeader:true,
                columns : [{
                        label : '全部',
                        onClick : function(e){
                            this.groupId=0;
                            this.setSelected(e.target);
                            this.refreshList(e);
                        }
                    }, {
                        label : '格式文本',
                        onClick : function(e){
                            this.groupId=3;
                            this.setSelected(e.target);
                            this.refreshList(e);
                        }    
                    }, {
                        label : '商品类型',
                        onClick : function(e){
                            this.groupId=2;
                            this.setSelected(e.target);
                            this.refreshList(e);
                        }
                    },{
                        label : '聊天类型',
                        onClick : function(e){
                            this.groupId=4;
                            this.setSelected(e.target);
                            this.refreshList(e);
                        }
                    }
                ],
                labelClass : 'font-size1 tab-selector'
            };
            this.addColumns(option);
            //给平台和本地图库new 两个View用于两个图库的切换
            //初始化图库视图
            this.iconView= new View();
            //指定加载数据位置
            this.iconView.placeAt(this.centerPanel.containerNode,"last");
            //初始化系统图库视图
            this.platIconView=new View();
            //指定加载数据位置
            this.platIconView.placeAt(this.centerPanel.containerNode,"last");
            //1.3添加图库列表选项()
            this.iconList= new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    this.iconList.generateList(data);
                    this.busy = false;
                }),
                itemRenderer:OrderListItem,
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                },
                itemMap : {
                    _label : "label",
                    _logo : "icon",
                    moveTo : "moveTo"
                }
            });
            //为图库列表指定位置
            this.iconList.placeAt(this.iconView, "last");
            //添加系统图库列表
            this.platIconList= new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    this.platIconList.generateList(data);
                    this.busy = false;
                }),
                itemRenderer:OrderListPlatItem,
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                },
                itemMap : {
                    _label : "label",
                    _logo : "logo",
                    moveTo : "moveTo"
                }
            });
            //选中头部样式
            //this.setHeaderStyle(query(".icon-storage",this.headerOption)[0]);
            //绑定头部点击事件
            this.headerOption.on("click",lang.hitch(this,this.onHeadClik));
            //为系统图库列表指定位置
            this.platIconList.placeAt(this.platIconView,"last");
            //1.4为中间视图区域绑定滚动事件
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            //1.5绑定列表点击事件,执行选中并使用
            this.centerPanel.on("click",lang.hitch(this, this.onListClick));
            this.onAfterShow();
        },
        //this.onAfterShow()
        onAfterShow:function(){
            //获取当前商家的shopId
            this.currentShopId= imageLib.getShopId();
            //清空图片库列表和系统图库列表
            this.iconList.destroyDescendants();
            this.platIconList.destroyDescendants();
            //加载图片库和系统图片
            this.loadNextPage("iconList");
            this.loadNextPage("platIconList");
            //切换到图片库视图
            this.toIconView();
        },
        //加载列表数据
        loadNextPage:function(listType){
            var queryInfo = null;
            if(listType=="iconList"){
                if(this.iconList.store){
                    //获取查询条件
                    queryInfo = this.iconList.get("query");
                    this.iconList.setQuery(queryInfo,{
                        start:this.start,
                        count:this.pageSize
                    }).then(lang.hitch(this,function(){
                        this.busy = false;
                    }));
                }else{
                    var store = new JsonRest({
                        target:imageLib.getIconUrl()
                    });
                    queryInfo = {};
                    this.iconList.setStore(store,queryInfo,{
                        start:0,count:this.pageSize
                    });
                }
            }else{
                if(this.platIconList.store){
                    //获取查询条件
                    queryInfo = this.platIconList.get("query");
                    this.platIconList.setQuery(queryInfo,{
                        start:this.start,
                        count:this.pageSize
                    }).then(lang.hitch(this,function(){
                        this.busy = false;
                    }));
                }else{
                    var store1 = new JsonRest({
                        target:imageLib.getPlatIconUrl()
                    });
                    queryInfo = {};
                    this.platIconList.setStore(store1,queryInfo,{
                        start:0,count:this.pageSize
                    });
                }
            }
        },
        //处理图片剪辑
        //option ={width:,height}剪切图片的尺寸
        editImageSize:function(option){
            var fileInput = domConstruct.create("input",{
                        "class":"none",
                        type:"file"
                    },document.body);
                fileInput.click();
                fileInput.onchange = lang.hitch(this,function(){
                    if(fileInput.files&&fileInput.files[0]){
                        var url= window.URL.createObjectURL(fileInput.files[0]);
                        imgSelector.selectImg(null,{width:option.width,height:option.height},url,"").then(lang.hitch(this,function(dataUrl){
                            window.URL.revokeObjectURL(url);
                            fileInput.value="";
                            if(!dataUrl){
                                return;
                            }
                            // decode base64 string, remove space for IE compatibility
                            var binary = atob((dataUrl.substring(dataUrl.indexOf(",")+1)).replace(/\s/g, ''));
                            // get binary length
                            var len = binary.length;
                            // create ArrayBuffer with binary length
                            var buffer = new ArrayBuffer(len);
                            // create 8-bit Array
                            var view = new Uint8Array(buffer);
                            // save unicode of binary data into 8-bit Array
                            for (var i = 0; i < len; i++) {
                                view[i] = binary.charCodeAt(i);
                            }
                            //var file=new File([view],"image.png");
                            var file=new Blob([view],{type:"image/jpg"});
                            var formData = new FormData();
                            formData.append("cq_file", file);
                            xhr.post(config.getDataOrigin()+"/biz/blob/blob/upload",{
                                data : formData, handleAs : "json"
                            }).then(lang.hitch(this,function(data) {
                                if (data && data.items && data.items[0]) {
                                    imageLib.save({
                                        groupId:this.groupId,
                                        msgContent:data.items[0].uri
                                    });
                                    if(this.groupId!=0){
                                        this.setQuery({groupId:this.groupId});
                                    }else{
                                        this.setQuery({});
                                    }
                                }
                            }));
                        }));
                        
                    }
                });
        },
        //添加本地图片
        addNewIcon:function(){
            // imageBlob.selectImage().then(lang.hitch(this,function(data){
                // console.log(data);
            // }));
            if(this.groupId==3){
                this.editImageSize({width:128,height:128});
            }else{
                blob.selectAndUpload().then(lang.hitch(this,function(data){
                    if (data && data.items && data.items[0]) {
                        imageLib.save({
                            groupId:this.groupId,
                            msgContent:data.items[0].uri
                        });
                        if(this.groupId!=0){
                            this.setQuery({groupId:this.groupId});
                        }else{
                            this.setQuery({});
                        }
                    }
                }));
            }
        },
        //设置头部样式选中问题
        setHeaderStyle:function(evt){
            var items = query('.icon-storage',this.domNode);
            for(var i = 0;i<items.length;i++){
                domClass.remove(items[i],"mblTabBarButtonSelected");
            }
            domClass.add(evt,"mblTabBarButtonSelected");
        },
        //当前显示的图片库
        currentMode:"iconList",
        //切换到图片库视图
        toIconView:function(){
            console.log("hello");
            this.currentMode = "iconList";
            this.iconView.show();
            this.showEditClass();
            //初始化选中样式
            this.setSelected(query(".tab-selector",this.tabSelector)[0]);
        },
        //切换到系统图片库
        toPlatIconView:function(){
            this.currentMode = "platIconList";
            this.platIconView.show();
            this.hideEditClass();
            this.setSelected(query(".tab-selector",this.tabSelector)[0]);
            this.setQuery({});
        },
        //设置选中样式
        setSelected: function(evt){
            //清空所有节点选中样式
            var items = query('.tab-selector',this.domNode);
            for(var i = 0;i<items.length;i++){
                domClass.remove(items[i],"selected");
            }
            domClass.add(evt,"selected");
        },
        //添加头部点击事件
        onHeadClik:function(evt){
            if(domClass.contains(evt.target.parentNode,"icon-storage")){
                if(domClass.contains(evt.target.parentNode,"platIcon")){
                    this.setHeaderStyle(evt.target.parentNode);
                    this.toPlatIconView();
                }else{
                    this.setHeaderStyle(evt.target.parentNode);
                    this.toIconView();
                    this.setQuery({});
                }
            }
        },
        //点击选中并使用
        onListClick:function(evt){
            if(evt.target.localName=="img"){
                if(domClass.contains(evt.target.parentNode, "mat-list-imgpart")){
                    var imgSrcUri = evt.target.src;
                    this.showImg(imgSrcUri); 
                }
                if(domClass.contains(evt.target.parentNode,"iconDelete")){
                    var li = registry.getEnclosingWidget(evt.target);
                    if (li.declaredClass != "dijit._WidgetBase"){
                        return;
                    }
                    imageLib.remove({
                        shopId:this.currentShopId,
                        _id:li.params._id
                        });
                    if(this.groupId!=0){
                        this.setQuery({groupId:this.groupId});
                    }else{
                        this.setQuery({});
                    }   
                }
            }
        },
        //显示新增按钮
        showEditClass:function(){
            var li = query(".mblToolBarButtonLabel",this.headerOption.domNode)[1];
            domStyle.set(li,"display","");
        },
        //隐藏新增按钮
        hideEditClass:function(){
            var li = query(".mblToolBarButtonLabel",this.headerOption.domNode)[1];
            domStyle.set(li,"display","none");
        },
        //依据类别刷新列表
        refreshList:function(evt){
            var li = evt.target.innerHTML;
            if(li=="全部"){
                this.setQuery({});
            }
            if(li=="格式文本"){
                this.setQuery({groupId:3});
            }
            if(li=="商品类型"){
                this.setQuery({groupId:2});
            }
            if(li=="聊天类型"){
                this.setQuery({groupId:4});
            }
        },
        //重新赋予刷新列表
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            this.iconList.destroyDescendants();
            this.platIconList.destroyDescendants();
            var queryResult = this.iconList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            var queryResult1 = this.platIconList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.onLoadListData(queryResult1,this.start,this.pageSize);
        },
        //加载更多
        onLoadMore: function(e){
            this.start=this.start+this.pageSize;
            if(!this.busy&&e.afterBottom&&this.canLoadMore(this.start)){
                this.busy = true;
                if(this.groupId!=0){
                    this.setQuery({groupId:this.groupId});
                }else{
                    this.setQuery({});
                }
            }
        },
        //重写ViewMIxin的addHeader方法
        addHeader : function(option) {
            var heading = new Heading({
                "id" : uuid(),
                label : "<div data-dojo-type='dojox.mobile.Heading' class='mblHeading unselectable mblHeadingCenterTitle' id='dojox_mobile_Heading_14' widgetid='dojox_mobile_Heading_14'><table cellpadding='0' cellspacing='0' align='center'><tbody><tr><td align='center'><div data-dojo-type='dojox.mobile.TabBar' data-dojo-props='barType:&quot;segmentedControl&quot;' style='margin: auto;' role='tablist' class='mblTabBarSegmentedControl mblTabBar mblTabBarNoIcons' id='dojox_mobile_TabBar_2' widgetid='dojox_mobile_TabBar_2'><div data-dojo-type='dojox.mobile.TabBarButton' data-dojo-props='selected:true' role='tab' aria-selected='true' class='mblTabBarButton unselectable mblTabBarButtonSelected icon-storage ' tabindex='0' id='dojox_mobile_TabBarButton_5' widgetid='dojox_mobile_TabBarButton_5'><div class='mblTabBarButtonIconArea'><div class='mblTabBarButtonIconParent mblTabBarButtonIconParent1'></div><div class='mblTabBarButtonIconParent mblTabBarButtonIconParent2'></div></div><div class='mblTabBarButtonLabel'>"+option.center1.label+"</div></div><div data-dojo-type='dojox.mobile.TabBarButton' role='tab' aria-selected='false' class='mblTabBarButton unselectable icon-storage platIcon' tabindex='0' id='dojox_mobile_TabBarButton_6' widgetid='dojox_mobile_TabBarButton_6'><div class='mblTabBarButtonIconArea'><div class='mblTabBarButtonIconParent mblTabBarButtonIconParent1'></div><div class='mblTabBarButtonIconParent mblTabBarButtonIconParent2'></div></div><div class='mblTabBarButtonLabel'>"+option.center2.label+"</div></div></div></td></tr></tbody></table><span class='mblHeadingSpanTitle'></span><div class='mblHeadingDivTitle' role='heading' aria-level='1'></div></div>"
            });
            heading.placeAt(this._headerPane.domNode, 'first');
            heading.startup();
            if (option.left) {
                this.addBtnToHeader(option.left, heading, 'left');
            }
            if (option.right) {
                this.addBtnToHeader(option.right, heading, 'right');
            }
            this.header = heading;
            this.resize();
            return heading;
        },
        loadingBgClass:"bg-loading-img",
        nothingBgClass:"bg-nothing",
        onLoadListData:function(queryResult,start,pageSize,tp){
            domClass.add(this.centerPanel.domNode,this.loadingBgClass);
            domClass.remove(this.centerPanel.domNode,this.nothingBgClass);
            tp = ""+tp;
            queryResult.then(lang.hitch(this,function(){
                this.centerPanel.resize();
            }));
            queryResult.total.then(lang.hitch(this,function(total){
                this.totalInfo = this.totalInfo||{};
                this.totalInfo[tp] = total;
                if(start+pageSize<total){
                    domClass.add(this.centerPanel.domNode,this.loadingBgClass);
                }else{
                    domClass.remove(this.centerPanel.domNode,this.loadingBgClass);
                }
                if(total===0){
                    domClass.add(this.centerPanel.domNode,this.nothingBgClass);
                }else{
                    domClass.remove(this.centerPanel.domNode,this.nothingBgClass);
                }
            }));
        }
    });  
});