define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/Heading",
    "dojox/uuid/generateRandomUuid",
    "dojo/dom-construct",
    "dojox/mobile/ToolBarButton",
    "dojo/dom-geometry",
    "dojox/mobile/ListItem",
    "dojox/mobile/Icon",
    "dojox/mobile/SearchBox",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/RoundRectList",
    "dojox/mobile/Switch",
    "dojox/mobile/TextBox",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/IconContainer",
    "dojox/mobile/IconItem",
    "dojo/on",
    "dojo/request/xhr",
    "dojox/mobile/DatePicker",
    "cq/util/config/config",
    "cq/util/sys/date",
    "cq/util/edit/editor",
    "cq/util/edit/optionsList",
    "cq/util/edit/datePick",
    "cq/util/edit/dateTimePick",
    "cq/util/edit/textArea",
    "cq/util/edit/jsonRef",
    "cq/util/edit/position",
    "dojo/Deferred",
    "dijit/_Widget",
    "cq/widgets/SlideShow",
    "dojo/query",
    "cq/biz/ts/cart",
    "cq/util/image/selector",
    "dijit/registry",
    "cq/util/edit/overlay",
    "dojo/touch",
    "dijit/focus",
    "dojo/topic",
    "cq/biz/user/user",
    "cq/widgets/bigImg"
],function(declare, lang, array, Heading, uuid, domConstruct, ToolBarButton,
    domGeometry, ListItem, Icon, SearchBox, domClass, domStyle, domAttr,
    FixedSplitter, Pane,ScrollablePane, RoundRectList, Switch, TextBox,
    EdgeToEdgeList, IconContainer, IconItem, on, xhr, DatePicker, config,
    date, editor, optionsList, datePick, dateTimePick, textArea, jsonRef, position,
    Deferred, Widget, SlideShow, query, cart, imgSelector, registry,
    overlay,touch,focusUtil,topic,user,bigImg) {
    // 是否支持微信分享
    // 检查微信接口环境
    if(window.Wechat){
        window.Wechat.isInstalled(function (installed) {
            window.isWechatEnable = installed?true:false;
        }, function (reason) {
            window.isWechatEnable = false;
        });
    }else{
        window.isWechatEnable = false;
    }
    // 定义全局的遮罩层节点
    var maskNode = null;
    // 图片缩放工具对象:
    //        getScaledHeight:获得缩放后图片的高度
    var scaleUtil = {
        getScaledHeight:function(height){
            return height;
            //return height/640*domStyle.get(document.body, 'width') || 0;
        }
    };
    // 楼层类
    var ColumnFloor = declare("", Widget, {
        baseClass : "hhbox",
        // 显示属性配置
        options:null,
        // 商家预定义的陈列位数据
        boxes:null,
        // 获取陈列位数据的相关配置
        data:null,
        // 张松  现在将direction属性移到options中  2015/05/20
        // 楼层样式，"H"为全部横向，"H1V2"为左1右2，"H2V1"为左2又1
        // direction:"H",
        max:0,
        postCreate : function(){
            this.inherited(arguments);
            var innerHTML = "";
            if(this.options.useborder == 1){
                domClass.add(this.domNode, "useborder");
            }
            if(this.boxes){
                innerHTML = this.getDataHtml();
            }else if(this.data){
                require([this.data.provider], lang.hitch(this, function(provider){
                    var def = provider.Schema.prototype[this.data.action].apply(provider, [this.data.params]);
                    def.then(lang.hitch(this,function(data){
                        this.boxes = data;
                        innerHTML = this.getDataHtml();
                        this.domNode.innerHTML = innerHTML;
                    }));
                }));
            }
            this.domNode.innerHTML = innerHTML;
        },
        getDataHtml : function(data) {
            var innerHTML = "",imgHeight;
            if(this.options.flexes){
                this.options.flexes = ((typeof this.options.flexes == "string")?this.options.flexes.split(","):this.options.flexes);
                array.forEach(this.boxes, lang.hitch(this, function(item, index){
                    if(index > 1){
                        return;
                    }
                    if(index == 0){
                        // 张松   当调用该方法时，当前节点已经创建完成，修改baseClass不成功，需要使用domClass添加样式   2016/05/20
                        // this.baseClass += " hflex";
                        domClass.add(this.domNode, "hflex");
                    }
                    innerHTML += (item.url ? ("<a href='" + item.url + "'"):"<a href='javascript:void(0);'") + " class='flex1'";
                    innerHTML += " style='flex:" + this.options.flexes[index] + ";";
                    if(index == 0){
                        innerHTML += "margin-right:2%;";
                    }
                    innerHTML += "'><img src='";
                    innerHTML += item.icon;
                    innerHTML += "' style='";
                    innerHTML += (this.options&&this.options.height?("height:" + this.options.height + "px;"):"");
                    innerHTML += "' />";
                    innerHTML += item.title?("<span style='width:100%;text-align:center;display:inline-block;'>"+item.title + "</span>"):"";
                    innerHTML += "</a>";
                }));
            }else if(this.options.direction == "H"){
                array.forEach(this.boxes, lang.hitch(this, function(item, index){
                    if(this.data && this.data.max && index>=this.data.max){
                        return;
                    }
                    if(this.options.columns && index % this.options.columns == 0){
                        innerHTML += "<div class='hflex'>";
                    }
                    innerHTML += (item.url ? "<a class='flex1' href='" + item.url + "'"  : "<a class='flex1' href='javascript:void(0);'") + " style='display:block;";
                    if(this.options.columns && this.options.columns != 1){
                        if((index+1)%this.options.columns == 0){
                        }else{
                            innerHTML += "margin-right:2%;";
                        }
                    }
                    innerHTML += "'>";
                    //没有icon属性不创建img节点,避免显示空行 201607011 肖芳圆
                    if (item.icon) {
                        innerHTML += "<img src='";
                        innerHTML += item.icon;
                        innerHTML += "' style='";
                        innerHTML += (this.options&&this.options.height?("height:" + this.options.height + "px;"):"");
                        innerHTML += "' />";
                    }
                    innerHTML += item.title?("<span style='width:100%;text-align:center;display:inline-block;'>"+item.title + "</span>"):"";
                    innerHTML += "</a>";
                    if(this.options.columns && this.options.columns != 1 && (index+1)%this.options.columns == 0){
                        innerHTML += "</div>";
                    }
                }));
            }else if(this.options.direction == "H1V2"){
                imgHeight = 0;
                array.forEach(this.boxes, lang.hitch(this, function(item, index){
                    if(index > 2){
                        return;
                    }
                    if(index == 0){
                        // this.baseClass += " hflex";
                        domClass.add(this.domNode, "hflex");
                        imgHeight = (this.options.height ? this.options.height : (this.boxes[0].height ? this.boxes[0].height : 320));
                    }
                    if(index == 1){
                        innerHTML += "<div class='flex1 vflex'>";
                    }
                    innerHTML += (item.url ? ("<a href='" + item.url + "'")  : "<a href='javascript:void(0);'")
                        + " class='flex1'"
                        + " style='display:block;width:100%;'><img src='" + item.icon + "' style='height:"
                        + (index == 0 ? imgHeight : ((imgHeight + 21)/2 - 21))
                        + "px;' />"
                        + (item.title?("<span style='width:100%;text-align:center;display:inline-block;'>" + item.title + "</span>"):"")
                        +"</a>";
                    if(index == 2){
                        innerHTML += "</div>";
                    }
                }));
            }else if(this.options.direction == "H2V1"){
                imgHeight = 0;
                array.forEach(this.boxes, lang.hitch(this, function(item, index){
                    if(index > 2){
                        return;
                    }
                    if(index == 0){
                        // this.baseClass += "hflex";
                        domClass.add(this.domNode, "hflex");
                        imgHeight = (this.options.height ? this.options.height : (this.boxes[2].height ? this.boxes[2].height : 320));
                    }
                    if(index == 2){
                        innerHTML += "<div class='flex1'>";
                    }
                    innerHTML += (item.url ? ("<a href='" + item.url + "'") : "<a href='javascript:void(0);'")
                        + " class='flex1'"
                        + " style='display:block;width:100%;'><img src='" + item.icon + "' style='height:"
                        + (index == 2 ? imgHeight : ((imgHeight + 21)/2 - 21))
                        + "px;' />"
                        + (item.title?("<span style='width:100%;text-align:center;display:inline-block;'>" + item.title + "</span>"):"")
                        + "</a>";
                    if(index == 2){
                        innerHTML += "</div>";
                    }
                }));
            }
            return innerHTML;
        }
    });
    var IconBanner = declare("", Widget, {
        baseClass : 'banner',
        boxes:null,
        postCreate:function(){
            this.inherited(arguments);
            var innerHTML = "";
            if(this.boxes){
                array.forEach(this.boxes, lang.hitch(this, function(item){
                    innerHTML += "<img src='" + item.banner + "' class='' style='height:94px;display:block;' />"
                        + (item.userSetting?"<a class='user-setting'>设置</a>":"")
                        + "<img src='" + item.icon + "' class='banner-icon' />"
                        + "<span class='banner-title'>" + item.title + "</span>";
                }));
            }
            var fileInput = domConstruct.create('input', {
                type:'file',
                style:'display:hidden;'
            }, this.domNode);
            // var
            this.domNode.innerHTML = innerHTML;
        }
    });
    var GroupHeader = declare("", Widget, {
        baseClass : "groupheader",
        boxes:null,
        postCreate:function(){
            this.inherited(arguments);
            if(this.boxes){
                array.forEach(this.boxes, lang.hitch(this, function(item){
                    domConstruct.create("div", {
                        className:"groupheader-title",
                        innerHTML:item.title
                    }, this.domNode);
                    var a = domConstruct.create("a", {
                        href:item.url
                    }, this.domNode);
                    domConstruct.create("img", {
                        src:item.icon,
                        className:"groupheader-img"
                    }, a);
                    domConstruct.create("div", {
                        className:"groupheader-righttext",
                        innerHTML:item.rightText
                    }, a);
                    domClass.add(this.domNode, item.className);
                }));
            }
        }
    });
    return declare("cq.ui.view._ViewMixin", null, {
        // 是否销毁该页面，默认为true表示销毁，Welcome、Login、Register、ShopList页面默认不销毁
        destroyOnSvcChanged : true,
        // 中间滚动容器
        centerPanel : null,
        // view--header
        header : null,
        // view--footer
        footer : null,
        // 本页面绑定的数据
        __data : null,
        postCreate : function () {
            this.inherited(arguments);
            //防止所有对象共享数据
            this.__data = this.__data || {};
        },
        resize:function(){
            if(domStyle.get(this.domNode,"height")){
                this.inherited(arguments);
            }
        },
        createCover:function(){
            if(this.__coverDiv){
            }else{
                var div = domConstruct.create("div",{class:"cover"});
                document.body.appendChild(div);
                this.__coverDiv = div;
                div.onclick=lang.hitch(this,function(){
                    this.__coverDiv.style.display="none";
                });
            }
            return this.__coverDiv;
        },
        isCellPhone:function(phone){
            return /(^1[3|4|5|7|8][0-9]{9}$)/.test(phone) && phone.length==11;
        },
        // 张松   使用bigImg显示大图    2016/07/01
        showImg:function(url){
            //this.createCover();
            //var img = domConstruct.create("img",{src:url});
            //this.__coverDiv.innerHTML = "";
            //this.__coverDiv.appendChild(img);
            //this.__coverDiv.style.display="";
            bigImg.show(url);
        },
        buildRendering:function(){
            //执行基类方法
            this.inherited(arguments);
            //登录页的内容是自己写的，不能重构其结构
            if(""===lang.trim(this.domNode.innerHTML)){
                //占满整个区域
                domStyle.set(this.domNode,"height","100%");
                //做界面划分，上中下三个区域，中间区域高度可变
                this.addChild(this._topSplitter = new FixedSplitter({
                    variablePane:1,
                    orientation:"V"
                }));
                //添加顶部
                this._topSplitter.addChild(this._headerPane = new Pane());
                //添加中间可变区域
                this._topSplitter.addChild(this._centerPane = new Pane());
                this.centerPanel = new ScrollablePane({
                    height:"100%"
                });
                this.centerPanel.placeAt(this._centerPane.domNode,"first");
                //添加footer部分
                this._topSplitter.addChild(this._bottomPane = new Pane());
            }
        },
        //提供接口的函数，不用于继承
        startup : function() {
            this.inherited(arguments);
            if (!this._cqEventinited) {
                //只执行一次
                this.indexElement();
                this.initEvent();
                this._cqEventinited = true;
            }
        },
        //初始化相关接口
        //索引界面元素
        indexElement : function() {
        },
        //初始化事件
        initEvent : function() {
        },
        //提供进入界面的接口
        onAfterTransitionIn : function() {
            // 张松   商家端如果页面没有配置不登录可访问,则自动跳转到欢迎页面    2016/06/28
            if(config.mustLoginViews || config.notLoginViews){
                if(config.loginLevel == "hasUid"){
                    if((window.curView != "main")&&((config.mustLoginViews&&config.mustLoginViews[window.curView])
                        ||(config.mustLoginViews&&!config.mustLoginViews[window.curView]&&!config.notLoginViews)
                        ||(config.mustLoginViews&&!config.mustLoginViews[window.curView]&&config.notLoginViews&&!config.notLoginViews[window.curView])
                        ||(!config.mustLoginViews&&!config.notLoginViews[window.curView]))){
                        if(!user.getCurrentUserId()){
                            window.moveToView("main");
                            return;
                        }
                    }
                }else if(config.loginLevel == "hasLogin"){
                    if((window.curView != "main")&&((config.mustLoginViews&&config.mustLoginViews[window.curView])
                        ||(config.mustLoginViews&&!config.mustLoginViews[window.curView]&&!config.notLoginViews)
                        ||(config.mustLoginViews&&!config.mustLoginViews[window.curView]&&config.notLoginViews&&!config.notLoginViews[window.curView])
                        ||(!config.mustLoginViews&&!config.notLoginViews[window.curView]))){
                        user.hasLogin().then(function(s){
                            if(!s){
                                window.moveToView("main");
                                return;
                            }
                        });
                    }
                }
            }
            this.inherited(arguments);
            this.resize();
            if(this.get("hasShow")){
                this.onAfterShow();
            }else{
                this.onFirstShow();
                this.set("hasShow", true);
            }
        },
        // 张松  离开界面接口，离开界面时发布离开事件，方便引用界面监听   2016/06/15
        onAfterTransitionOut : function(){
        },
        //进入界面相关接口
        //是否曾经进入
        hasShow : false,
        //后续进入
        onAfterShow : function() {
        },
        //首次进入
        onFirstShow : function() {
        },
        // 发送短信
        sendSms:function(text, onSuccess, onError){
            navigator&& navigator.contacts&&navigator.contacts.pickContact(function(contact){
                var a = domConstruct.create('a', {
                    href:'sms:' + contact.phoneNumbers.join(',') + '?body=' + text,
                    style:'display:hidden;'
                }, this.domNode);
                a.click();
                a.parentNode.removeChild(a);
            },onError);
        },
        // 复制链接到剪切板  ---  参数必须是字符串
        copyToClipboard:function(text, onSuccess, onError){
            // 张松  浏览器上  2016/05/23
            // 只支持高版本浏览器
            if(window.util.isBrowser()){
                if(document.queryCommandSupported("copy")){
                    var textArea = document.createElement("textarea");
                    // Prevent zooming on iOS
                    textArea.style.fontSize = '12pt';
                    // Reset box model
                    textArea.style.border = '0';
                    textArea.style.padding = '0';
                    textArea.style.margin = '0';
                    // Move element out of screen horizontally
                    textArea.style.position = 'fixed';
                    textArea.style.right = '-9999px';
                    // Move element to the same position vertically
                    textArea.style.top = (window.pageYOffset || document.documentElement.scrollTop) + 'px';
                    textArea.setAttribute('readonly', '');
                    textArea.value = text;
                    document.body.appendChild(textArea);
                    textArea.select();
                    try{
                        if(document.execCommand('copy')){
                            onSuccess();
                        }else{
                            onError();
                        }
                    }catch(e){
                        onError();
                    }
                    textArea.parentNode.removeChild(textArea);
                }else{
                    onError();
                }
            }else if(cordova&&cordova.plugins&&cordova.plugins.clipboard){
                cordova.plugins.clipboard.copy(text, onSuccess, onError);
            }else{
                onError();
            }
        },
        // 张松  保存图片到本地  2016/05/21
        // img 图片dom节点/src
        // 添加了图文二维码的保存
        // params:
        // onSuccess 保存成功回调函数
        // onError 失败回调函数
        // qrCode 二维码图片地址或者dom节点
        // logo 商家logo图片地址或者dom节点
        // shopName 商家名称
        saveImageDataToLibrary:function(onSuccess, onError, qrCode, logo, shopName){
            if(!CanvasRenderingContext2D.prototype.roundRect){
                CanvasRenderingContext2D.prototype.roundRect = function (x, y, w, h, r) {
                    var min_size = Math.min(w, h);
                    if (r > min_size / 2){
                        r = min_size / 2;
                    }
                    this.beginPath();
                    this.moveTo(x + r, y);
                    this.arcTo(x + w, y, x + w, y + h, r);
                    this.arcTo(x + w, y + h, x, y + h, r);
                    this.arcTo(x, y + h, x, y, r);
                    this.arcTo(x, y, x + w, y, r);
                    this.closePath();
                    return this;
                };
            }
            if(window.canvas2ImagePlugin){
                // 创建canvas对象
                var myCanvas = document.createElement("canvas"),src;
                var ctx = myCanvas.getContext("2d");
                if(logo && shopName){// 图文二维码
                    myCanvas.width = 488;
                    myCanvas.height = 488;
                    ctx.fillStyle = "#fe9570";
                    ctx.fillRect(0, 0, 488, 488);
                    if(typeof logo == "string"){
                        src = qrCode;
                        qrCode = new Image();
                        qrCode.src = src;
                    }
                    qrCode.style = "width:312px;height:312px;";
                    ctx.drawImage(qrCode, 88,144,400,456);
                    if(typeof logo == "string"){
                        src = logo;
                        logo = new Image();
                        logo.src = src;
                    }
                    logo.style = "width:80px;height:80px;";
                    ctx.createPattern(logo, "no-repeat");
                    ctx.roundRect(88, 32, 168, 112, 40);
                    ctx.fillStyle = pattern;
                    ctx.fill();
                    ctx.fillStyle = "rgb(255,68,1)";
                    ctx.font = "32px SimHei Regular";
                    ctx.fillText(shopName, 178, 56);
                }else{// 极简二维码
                    if(typeof qrCode == "string"){
                        // img为图片地址或base64字符串
                        src = qrCode;
                        qrCode = new Image();
                        qrCode.src = src;
                    }
                    qrCode.style = "width:312px;height:312px;";
                    myCanvas.width = qrCode.width;
                    myCanvas.height = qrCode.height;
                    ctx.drawImage(qrCode,0,0,myCanvas.width,myCanvas.height);
                }
                window.canvas2ImagePlugin.saveImageDataToLibrary(onSuccess, onError, myCanvas);
            }
        },
        addIconBanner:function(data){
            // data = {boxes:[{icon:'',banner:'',title:''}]};
            var banner = new IconBanner(data);
            if(this.centerPanel){
                this.centerPanel.containerNode.appendChild(banner.domNode);
            }else{
                this.addChild(banner);
            }
            return banner;
        },
        //添加多列
        addShelfColumn : function(data) {
            var column = new ColumnFloor(data);
            // this.addChild(column);
            // column.refreshData(this.getDataInfo(data));
            if(this.centerPanel){
                this.centerPanel.containerNode.appendChild(column.domNode);
            }else{
                this.addChild(column);
            }
            return column;
        },
        addGroupHeader:function(data){
            var groupHeader = new GroupHeader(data);
            // this.addChild(groupHeader);
            if(this.centerPanel){
                this.centerPanel.containerNode.appendChild(groupHeader.domNode);
            }else{
                this.addChild(groupHeader);
            }
            return groupHeader;
            // {isEdge:false,lists:[{icon:'imgUrl',iconPos:'0,0,29,29',callback:function(){},
            // label:'label',rightText:'rightText',noArrow:true/false,edit:{type:'checkbox/text',field:'a.b',disabled:disabled}},{},{}],data:{}}ƒ;
            // var option = {isEdge:true, data: data[]};
        },
        //添加幻灯片
        addSlideShow : function(data) {
            array.forEach(data.boxes, function(item) {
                if (item.url) {
                    var url = item.url;
                    item.onclick = function() { location.href = url; };
                }
            });
            var slideShow = new SlideShow({
                panelsHeight : scaleUtil.getScaledHeight(data.options.height),
                lazy : false,
                auto : true,
                playInterval : 5000,
                srcField : "icon",
                isShowBigImg : data.isShowBigImg == undefined ? true : data.isShowBigImg,
                items : data.boxes
            },domConstruct.create("div", {style : "width:100%;"},this.containerNode, "last"));
            slideShow.placeAt(this.centerPanel.containerNode, "last");
            return slideShow;
        },
        addHeader : function(option) {
            var heading = new Heading({
                "id" : uuid(),
                label : option.title
            });
            heading.placeAt(this._headerPane.domNode, 'first');
            heading.startup();
            if (option.left) {
                this.addBtnToHeader(option.left, heading, 'left');
            }
            if (option.right) {
                this.addBtnToHeader(option.right, heading, 'right');
            }
            if(option.center1){
                this.addBtnToHeader(option.center1,heading,'left');
            }
            if(option.center2){
                this.addBtnToHeader(option.center2,heading,'right');
            }
            this.header = heading;
            this.resize();
            return heading;
        },
        addBtnToHeader : function(option, heading, position) {
            // 添加左边的按钮 如果设置了icon，则直接放图片
            if (option.icon) {
                var img = domConstruct.create('img', {
                    src : option.icon,
                    className : 'float-' + (position == 'left' ? 'left' : 'right')
                        + ' header-image '
                        + (option.crop ? 'image-crop' : '')
                },heading.domNode, 'first');
                this.connect(img, 'onclick', option.onClick);
            } else if (option.iconButton) {
                // 如果设置了iconButton，放toolBarButton
                var params = {
                    icon : option.iconButton,
                    class : 'float-' + (position == 'left' ? 'left' : 'right'),
                    arrow : option.arrow,
                    selectable : false
                };
                if (option.label){
                    params.label = option.label;
                }
                var btn = new ToolBarButton(params);
                btn.placeAt(heading, 'last');
                btn.startup();
                this.connect(btn, 'onClick', option.onClick);
            }
        },
        addImage : function(option) {
            // option = {src:'', onClick:function(){}, className:""}
            var img = domConstruct.create('img', {
                src : option.src,
                className : 'full-width ' + option.className||""
            },this.centerPanel.containerNode, 'last');
            this.connect(img, 'onclick', option.onClick);
            return img;
        },
        addTextBox : function(option) {
            option.class = "full-width " + (option.class ? option.class : "");
            var vNode = new TextBox(option);
            if("search"===option.type){
                var formNode = domConstruct.create("form",{
                    action:"#"
                },option.isHeader?this._headerPane.domNode:this.centerPanel.containerNode, 'last');
                formNode.onsubmit = function(){
                    return false;
                };
                vNode.placeAt(formNode, 'last');
            }else{
                vNode.placeAt(this.centerPanel.containerNode, 'last');
            }
            vNode.startup();
            if(option.isHeader){
                this.resize();
            }
            return vNode;
        },
        // 张松 上传图片组件支持配置最大上传图片数量maxImages，label的显示内容mainLabel/detailLabel 2016/06/28
        addImagePicker : function(option) {
            // 显示一组图片，最后是一个添加图片的按钮
            // 创建IconContainer
            var iconContainer = new IconContainer({
                editable : option.editable,
                class : option.class
            });
            //依据图片数据刷新图片列表的显示
            iconContainer.refreshItems = function(icons){
                this.endEdit&&this.endEdit();
                //清理
                if(this.addItem&&this.addItem.domNode.parentNode){
                    this.addItem.domNode.parentNode.removeChild(this.addItem.domNode);
                }
                var items = this.getChildren();
                while(items.length){
                    items.pop().destroyRecursive();
                }
                //添加新的
                if(icons&&icons.length){
                    for(var i=0;i<icons.length;i++){
                        this.addChild(new IconItem({
                            icon:icons[i].icon,
                            label:i?((option.detailLabel||option.detailLabel=="")?option.detailLabel:"细节图"):((option.mainLabel||option.mainLabel=="")?option.mainLabel:"主图")
                        }));
                    }
                }
                this.startEdit&&this.startEdit();
                this.addChild(this.addItem);
            };
            //刷新图标的标题
            iconContainer.refreshItemLabel = function(){
                var items = this.getChildren(),item;
                while(items.length){
                    item = items.pop();
                    if(item!==this.addItem){
                        item.set("label",items.length?((option.detailLabel||option.detailLabel=="")?option.detailLabel:"细节图"):((option.mainLabel||option.mainLabel=="")?option.mainLabel:"主图"));
                    }
                }
            };
            // 创建IconItem
            for (var i = 0; i < option.icons.length; i++) {
                iconContainer.addChild(new IconItem({icon : option.icons[i].icon}));
            }
            if (option.canAdd) {
                var iconItem = iconContainer.addItem = new IconItem({
                    editable : false,
                    onClick:function(){
                        return false;
                    },
                    innerHTML :"<div class='mblIconArea'><div class='mblIconAreaInner add-image' onclick=''>+<form action='/biz/blob/blob/upload'><input class='hidden-file-input' type='file'/></form></div></div>"
                });
                var _this = this;
                var _li = iconItem;
                // 避免触发多次点击事件  绑定container节点的click事件
                var touchFun = function(evt) {
                    // 添加图片逻辑
                    // 1、选
                    // 2、裁剪和压缩
                    // 3、上传
                    // 4、显示
                    if(domClass.contains(evt.target, "add-image")){
                        var fileInput = query(".hidden-file-input", this.domNode)[0];
                        var fileForm = query("form", this.domNode)[0];
                        fileInput.onchange = function() {
                            // 控制图片上传格式
                            // var size = fileInput.files[0].size;
                            var name = fileInput.value;
                            // size = size/1024;
                            name = name.substring(name.lastIndexOf(".") + 1).toLowerCase();
                            // if(size > 2000){
                            //    alert("图片大小不能超过2M");
                            //    return;
                            // }
                            if(name != "jpg" && name != "png" && name != "gif"){
                                alert("请选择图片格式文件上传(jpg,png,gif等)");
                                return;
                            }
                            var url= window.URL.createObjectURL(fileInput.files[0]);
                            imgSelector.selectImg(null,option.size,url).then(lang.hitch(_this,function(dataUrl){
                                window.URL.revokeObjectURL(url);
                                fileInput.value="";
                                if(!dataUrl){
                                    return;
                                }
                                // decode base64 string, remove space for IE compatibility
                                var binary = atob((dataUrl.substring(dataUrl.indexOf(",")+1)).replace(/\s/g, ''));
                                // get binary length
                                var len = binary.length;
                                // create ArrayBuffer with binary length
                                var buffer = new ArrayBuffer(len);
                                // create 8-bit Array
                                var view = new Uint8Array(buffer);
                                // save unicode of binary data into 8-bit Array
                                for (var i = 0; i < len; i++) {
                                    view[i] = binary.charCodeAt(i);
                                }
                                //var file=new File([view],"image.png");
                                var file=new Blob([view],{type:"image/jpg"});
                                var formData = new FormData();
                                formData.append("cq_file", file);
                                xhr.post(config.getDataOrigin()+"/biz/blob/blob/upload",{
                                    data : formData, handleAs : "json"
                                }).then(function(data) {
                                    //alert(data.ok + ":" + data.items);
                                    // 服务器端发生错误给提示
                                    if(data.ok == 0){
                                        alert(data.msg);
                                        return;
                                    }
                                    if (data.items && data.items.length == 1) {
                                        var newIcon = new IconItem({
                                            icon : data.items[0].uri,
                                            label : (iconContainer.getChildren().length == 1? ((option.mainLabel||option.mainLabel=="")?option.mainLabel:"主图"):((option.detailLabel||option.detailLabel=="")?option.detailLabel:"细节图"))
                                        });
                                        iconContainer.endEdit();
                                        iconContainer.addChild(newIcon, iconContainer.getChildren().length - 1);
                                        // 张松   如果参数中传入最大上传图片数量，则判断容器子元素个数，达到最大数量后隐藏添加图片按钮  2016/06/28
                                        if(option.maxImages){
                                            if(iconContainer.getChildren().length == (parseInt(option.maxImages) + 1)){
                                                if(_li && _li.domNode && _li.domNode.parentNode){
                                                    _li.domNode.parentNode.removeChild(_li.domNode);
                                                }
                                            }
                                        }
                                        iconContainer.startEdit();
                                    }
                                });
                            }));
                            return;
                        };
                        on.emit(fileInput, "click", {cancelable : true, bubbles : true});
                    }
                    return false;
                };
                touch.release(iconContainer.domNode, lang.hitch(iconItem, touchFun));
                iconContainer.addChild(iconItem);
                iconContainer.connect(iconContainer, "scaleItem" ,function(movingItem, scale){
                    if(scale>1){
                        var node = this.addItem&&this.addItem.domNode;
                        if(node&&node.parentNode){
                            node.parentNode.removeChild(node);
                        }
                    }
                });
                iconContainer.connect(iconContainer,"onMoveItem",function(){
                    this.refreshItemLabel();
                    this.addChild(this.addItem);
                });
                // 张松   当图片数量达到最大之后，如果用户点击删除图片，添加上传图片按钮 2016/06/28
                iconContainer.connect(iconContainer, "removeChild", function(){
                    if(this.addItem&&this.addItem.domNode&&(!this.addItem.domNode.parentNode)){
                        this.refreshItemLabel();
                        this.addChild(this.addItem);
                    }
                });
            }
            if (option.onClick){
                iconContainer.onItemClick = option.onClick;
            }else{
                iconContainer.onItemClick = function() {
                    return false;
                };
            }
            iconContainer.refreshItems(option.icons);
            iconContainer.placeAt(this.centerPanel.containerNode, 'last');
            return iconContainer;
        },
        addIFrame : function(option) {
            // option = {src:''}
            var iframe = domConstruct.create('iframe',{
                src : option.src,
                className : 'full-width border-none',
                height:option.height,onload:option.onload
            },this.centerPanel.containerNode, 'last');
            return iframe;
        },
        isWechatEnable:function(){
            return window.isWechatEnable;
        },
        addColumns : function(option) {
            // option =
            // {columns:[{label:'',value:'',icon:'imgUrl',icon1:'imgUrl1',iconClass:'className',onClick:function(){}, className:'', isBadge:true/false, badgeClass:''},{},{}],
            // splitter:'imgUrl',splitterWidth:2,
            // className:'className',
            //        valueClass:'className',
            //        labelClass:'className',
            // isFooter:true, forceWidth:true/false};
            // 如果forceWidth为false
            // 1、不用计算column宽度
            // 2、添加class  hflex-->container
            // 3、column --> className
            var _c = option.isFooter ? this._bottomPane.domNode : (option.isHeader?this._headerPane.domNode : this.centerPanel.containerNode);
            var className = 'column-' + option.columns.length;
            var container = domConstruct.create('div', {
                className : 'content-background full-width ' + (option.className ? option.className : '') + (option.forceWidth === false?' hflex':'')
            }, _c, 'last');
            //TODO 2014/4/13 highlight
            domAttr.set(container, 'selectedIndex', '0');
            // 如果有splitter 先创建一个splitter对象，计算宽度
            var cw = 0;
            var vw = domGeometry.getMarginBox(container).w;
            if (option.splitter) {
                var s = domConstruct.create('img', {
                    src : option.splitter,
                    className : "inline-block",
                    style : "width:"
                        + (option.splitterWidth ? option.splitterWidth : 1)
                        + "px"
                },container);
                var sw = option.splitterWidth ? option.splitterWidth : 1;
                cw = (vw - sw * (option.columns.length - 1)) / option.columns.length;
            } else {
                cw = vw / option.columns.length;
            }
            this.connect(container, 'onclick', lang.hitch(this, function(evt){
                if(!option.columns[0].icon1){
                    return;
                }
                var target = evt.target,imgs;
                while(!domClass.contains(target, 'col')){
                    target = target.parentNode;
                }
                var cols = dojo.query('.col', container);
                for(var index = 0;index < cols.length;index++){
                    if(domAttr.get(target, 'index') == domAttr.get(cols[index], 'index')){
                        imgs = query('img', cols[index]);
                        for(var i = 0;i < imgs.length;i++){
                            if(imgs[i].src.indexOf('highlight')>=0){
                                domStyle.set(imgs[i], 'display', 'inline-block');
                            }else{
                                domStyle.set(imgs[i], 'display', 'none');
                            }
                        }
                    }else{
                        imgs = query('img', cols[index]);
                        for(var i = 0;i < imgs.length;i++){
                            if(imgs[i].src.indexOf('highlight')>=0){
                                domStyle.set(imgs[i], 'display', 'none');
                            }else{
                                domStyle.set(imgs[i], 'display', 'inline-block');
                            }
                        }
                    }
                }
            }));
            var img = null;
            for (var index = 0; index < option.columns.length; index++) {
                var col = domConstruct.create('div', {
                    className : className + " inline-block  col " + (option.columns[index].className?option.columns[index].className:''),
                    // style : 'width:' + cw + 'px'
                    style:(option.forceWidth === false ? '':('width:' + cw + 'px'))
                },container,((index == 0) ? 'first' : 'last'));
                if (option.columns[index].onClick) {
                    this.connect(col, "onclick", option.columns[index].onClick);
                }
                var row1 = domConstruct.create('div', {
                    className : 'full-width h-center '
                        + (option.valueClass ? option.valueClass : ''),
                    innerHTML : option.columns[index].value || '',
                    // // 张松  badge样式，如果有badge，则添加position：relative    2016/06/29
                    style : (option.columns[index].isBadge?"position:relative;":"")
                },col);
                //TODO 2014/4/13 highlight
                domAttr.set(col, 'index', index);
                if (option.columns[index].icon) {
                    img = domConstruct.create('img', {
                        src : option.columns[index].icon,
                        className : option.columns[index].iconClass || '',
                        style : 'display:inline-block'
                    }, row1);
                }
                if(option.columns[index].icon1){
                    img = domConstruct.create('img', {
                        src : option.columns[index].icon1,
                        className : option.columns[index].iconClass || '',
                        style : 'display:none'
                    }, row1);
                }
                if(option.columns[index].isBadge){
                    var matNum = domConstruct.create("div", {
                        className:'badge ' + option.columns[index].badgeClass,
                        innerHTML:((option.columns[index].badgeClass == "orderCarNum")?cart.getNum():0),
                        // 张松   badge的显示隐藏      2016/06/29
                        style : ("display:" + (((option.columns[index].badgeClass == "orderCarNum")&&cart.getNum())?"":"none"))
                    }, row1);
                    domAttr.set(matNum, "value", ((option.columns[index].badgeClass == "orderCarNum")?cart.getNum():0));
                    if(option.columns[index].badgeClass == "orderCarNum"){
                        this.matNumNode = matNum;
                        // 张松   badge的显示隐藏      2016/06/29
                        topic.subscribe("cq/biz/ts/cart/numChanged", lang.hitch(this,function(num){
                            this.matNumNode.innerHTML = num;
                            domStyle.set(this.matNumNode, "display", num?"":"none");
                        }));
                    }
                }
                if(option.columns[index].label){
                    var row2 = domConstruct.create('div', {
                        className : 'full-width h-center '
                            + (option.labelClass ? option.labelClass : ''),
                        innerHTML : option.columns[index].label
                    },col);
                }
                if (index != (option.columns.length - 1) && option.splitter && index != 0) {
                    var s = domConstruct.create('img', {
                        src : option.splitter,
                        className : "inline-block",
                        style : "width:" + (option.splitterWidth ? option.splitterWidth : 1) + "px"
                    },container);
                }
            }
            this.footer = option.isFooter ? container : this.footer;
            if (option.isFooter) {
                query("img",this.footer).forEach(function(imageNode){
                    imageNode.onloadHandler = this.connect(imageNode,"onload",function(e){
                        e.target.onloadHandler.remove();
                        e.target.errorHandler.remove();
                        this.resize();
                    });
                    imageNode.errorHandler = this.connect(imageNode,"onerror",function(e){
                        e.target.onloadHandler.remove();
                        e.target.errorHandler.remove();
                        this.resize();
                    });
                },this);
                setTimeout(lang.hitch(this,this.resize),100);
            }
            if(option.isHeader){
                this.resize();
            }
            return container;
        },
        addSearchInput : function() {
            var sd = domConstruct.create('div', {
                className : 'search-div content-background'
            },this.centerPanel.containerNode);
            var sii =domConstruct.create('div', {
                className : 'search-inner'
            }, sd);
            var simg = domConstruct.create('img', {
                className : 'search-img',
                src : './search.jpg'
            }, sii);
            var stext = domConstruct.create('span', {
                className : 'search-text',
                innerHTML : '请输入关键字'
            },sii);
            this.connect(sd, "onclick", this.addSearchPane);
        },
        addSearchPane : function() {
            var sp = domConstruct.create('div', {
                className : 'search-pane'
            },this.domNode);
            var shd = domConstruct.create('div', {
                className : 'search-header'
            }, sp);
            var scd = domConstruct.create('div', {
                className : 'search-content'
            }, sp);
            var sd = domConstruct.create('div', {
                className : 'search-div content-background'
            }, shd);
            var simg = domConstruct.create('img',{
                className : 'search-img search-img-left',
                src : "./search.jpg"
            },sd);
            var cbtn = domConstruct.create('input',{
                type : 'button',
                value : '取消',
                className : 'cancle-btn'
            }, sd);
            var sid = domConstruct.create(
            'div', {className : 'search-input-content'}, sd);
            var si = domConstruct.create('input',{
                className : 'search-input',
                placeholder : '输入搜索关键字'
            },sid);
            // 取消按钮、查询结果面板点击事件
            this.connect(sp, "onclick", function(evt) {
                // 如果鼠标点击空白位置，则销毁遮罩层
                if (evt.target.tagName == 'DIV' && domClass.contains(evt.target, 'search-pane')) {
                    domConstruct.destroy(sp);
                }
            });
            this.connect(cbtn, "onclick",function(evt) {
                domConstruct.destroy(sp);
            });
        },
        setData : function(data) {
            this.__data = data;
        },
        getData : function() {
            if(focusUtil.curNode && focusUtil.curNode.nodeType == 1
                && focusUtil.curNode.tagName
                && focusUtil.curNode.tagName.toLowerCase() == "input"
                && focusUtil.curNode.getAttribute("__data_field")
            ){
                this.__data[focusUtil.curNode.getAttribute("__data_field")] = focusUtil.curNode.value;
            }
            // getData时，删除内容为空的字段
            /*var data = lang.clone(this.__data);
            for(var p in data){
                if(data[p] || (data[p] === 0) || (data[p] === false)){
                }else{
                    delete data[p];
                }
            }*/
            return lang.clone(this.__data);
        },
        refreshData : function() {
            this.__isRefreshing = true;
            setTimeout(lang.hitch(this,function(){
                this.__isRefreshing = false;
            }),300);
            var widgets = dojo.query("[__data_field]", this.domNode);
            for (var i = 0; i < widgets.length; i++) {
                var field = widgets[i].getAttribute("__data_field").split(".");
                var dijitWidget = registry.byNode(widgets[i]);
                if(dijitWidget){
                    var value = this.__data;
                    for (var j = 0; j < field.length; j++) {
                        value = value[field[j]];
                    }
                    value = value ? value : "";
                    if (dijitWidget.set)
                        dijitWidget.set("value", value);
                    else {
                        console.log("这个东东还不知道怎么刷新：" + widgets[i]);
                    }
                }else{
                    console.log("这个东东还不知道怎么刷新：" + widgets[i]);
                }
            }
            this.centerPanel.scrollTo({x:0,y:0});
        },
        // 添加overlay节点 参数为dom    2016-04-25
        showInOverlay:function(dom){
            overlay.domNode.innerHTML = "";
            overlay.domNode.appendChild(dom);
            overlay.show();
        },
        hideOverlay:function(){
            if(overlay){
                overlay.hide();
            }
            /*domStyle.set(maskNode, "display", "none");
            overlay.hide();*/
        },
        // 添加可滚动区域
        addScrollablePane : function(option){
            // option= {isHeader:true/false,scrollDir:"h/v",className:"class"}
            var pane = new ScrollablePane({scrollDir:option.scrollDir,baseClass:"mblScrollablePane " + option.className,height:option.height?option.height:"36px"});
            pane.placeAt(option.isHeader?this._headerPane:this.centerPanel.containerNode);
            this.resize();
            return pane;
        },
        addLists : function(option) {
            //如果没有传入数据，默认数据从this.__data中获取
            // if (!option.data) option.data = this.__data;
            // option =
            // {isEdge:false,lists:[{icon:'imgUrl',iconPos:'0,0,29,29',onClick,callback:function(){},label:'label',rightText:'rightText',noArrow:true/false,edit:{type:'checkbox/text',field:'a.b',disabled:disabled}},{},{}],data:{}};
            // 张松  option结构修改,验证文本框的输入  2016/05/19
            // 修改edit结构，添加如下属性
            // nullable:true/false 是否可空？默认为true表示可空   ----   非空通过调用本类的 validateData()方法验证，返回true/false ，true为所有必填字段有值，false为有必填字段为空
            // textType:"text/float/int" 输入内容类型
            // textValueRange:"[a,b]/(a,b)/[a,b)/(a,b]/(a,)/(,b)" 如果输入类型为数字，可以提供该属性，该属性用于确定value的最大值和最小值 -----格式必须一致，中间最好不要有空格,最小值为-Infinity，最大值为Infinity
            // regex:/[0-9]*/gi 如果输入类型为text，可以提供regex(正则表达式，格式如/.../gi,g表示全局，i表示忽略大小写，/中间为表达式内容，不要使用引号)，则文本框内容必须匹配该表达式
            var container;
            var param = {};
            if (option.class){
                param.class = option.class;
            }
            if (option.isEdge) {
                container = new EdgeToEdgeList(param);
            } else {
                container = new RoundRectList(param);
            }
            container.placeAt(option.isHeader?this._headerPane : this.centerPanel.containerNode, "last");
            container.startup();
            var switchS = [];
            var textboxs = [];
            // 张松  遍历1lists，判断是否有{{str}}占位符，如果有使用this.__data替换 --- 从for循环中提取出来，在for循环中会执行多次，影响效率  2016/05/23
            var reg = /\{\{([\w\d\.]+)\}\}/ig;
            array.map(option.lists, lang.hitch(this, function(item){
                var fs = item.label&&item.label.match(reg);
                if(fs){
                    item.__label = item.label;
                    var label = item.label.replace(reg,lang.hitch(this,function(match,capture){
                        return this.__data[capture]==undefined?"":this.__data[capture];
                    }));
                    item.label = label;
                }
                if(item.rightText && item.rightText.match(reg)){
                    item.__rightText = item.rightText;
                    var rightText = item.rightText.replace(reg,lang.hitch(this,function(match,capture){
                        return this.__data[capture]==undefined?"":this.__data[capture];
                    }));
                    item.rightText = rightText;
                }
                if(item.rightIcon2 && item.rightIcon2.match(reg)){
                    item.__rightIcon2 = item.rightIcon2;
                    var rightIcon2 = item.rightIcon2.replace(reg,lang.hitch(this,function(match,capture){
                        return this.__data[capture]==undefined?"":this.__data[capture];
                    }));
                    item.rightIcon2 = rightIcon2;
                }
                if(item.icon && item.icon.match(reg)){
                    item.__icon = item.icon;
                    var icon = item.icon.replace(reg,lang.hitch(this,function(match,capture){
                        return this.__data[capture]==undefined?"":this.__data[capture];
                    }));
                    item.icon = icon;
                }
            }));
            var edit = null;
            for (var index = 0; index < option.lists.length; index++) {
                edit = option.lists[index].edit;
                if (!option.lists[index].iconPos) {
                    option.lists[index].iconPos = "0,0,29,29";
                }
                //赵春辉    不知道为什么要这么写，导致时间等编辑方式没有右箭头    2016-04-14
                //if (option.lists[index].edit && option.lists[index].edit.type
                //&& option.lists[index].edit.field) {
                //    option.lists[index].noArrow = true;
                //    option.lists[index].rightText = '';
                //}
                option.lists[index].tabIndex = -1;
                var li = new ListItem(option.lists[index]);
                li.placeAt(container.domNode);
                li.startup();
                var onClick = option.lists[index].onClick;
                li.set('onClickFun', onClick);
                if(option.lists[index].onClick){
                    li.domNode.onclick = li.get("onClickFun");
                    // li.connect(li, "onclick", li.get('onClickFun'));
                }
                var _this = this;
                li.connect(this, "refreshData", function(){
                    if(this.__label){
                        var label = this.__label.replace(reg,lang.hitch(this,function(match,capture){
                            return _this.__data[capture]==undefined?"":_this.__data[capture];
                        }));
                        this.set("label", label);
                    }
                    if(this.__rightText){
                        var rightText = this.__rightText.replace(reg,lang.hitch(this,function(match,capture){
                            return _this.__data[capture]==undefined?"":_this.__data[capture];
                        }));
                        this.set("rightText", rightText);
                    }
                    if(this.__rightIcon2){
                        var rightIcon2 = this.__rightIcon2.replace(reg,lang.hitch(this,function(match,capture){
                            return _this.__data[capture]==undefined?"":_this.__data[capture];
                        }));
                        this.set("rightIcon2", rightIcon2);
                    }
                    if(this.__icon){
                        var icon = this.__icon.replace(reg,lang.hitch(this,function(match,capture){
                            return _this.__data[capture]==undefined?"":_this.__data[capture];
                        }));
                        this.set("icon", icon);
                    }
                });
                if (edit && edit.type && (edit.field||(edit.lonField&&edit.latField))) {
                    var type = edit.type;
                    //有可能不存在field属性
                    var field = edit.field?edit.field.split('.'):'';
                    var value = option.data||this.__data;
                    for (var i = 0; i < field.length; i++) {
                        value = value[field[i]] ? value[field[i]] : "";
                    }
                    // var value = eval("option.data." +
                    // edit.field);
                    if (edit.type == 'checkbox') {
                        // BUG:数据库中保存的值的类型是Boolean，对应JS的true和false
                        this._initCheckBox(edit,li);
                    } else if (edit.type == 'text' || edit.type == "password" || edit.type == "tel") {
                        var params = {
                            class : "right-textbox",
                            value : value
                        };
                        if (edit.disabled){
                            params.disabled = "disabled";
                        }
                        if (edit.placeHolder){
                            params.placeHolder = edit.placeHolder;
                        }
                        if (edit.pattern){
                            params.pattern = edit.pattern;
                        }
                        if(edit.type == "password"){
                            params.type = "password";
                        }
                        if(edit.type == "tel"){
                            params.type = "tel";
                        }
                        this._initTextBoxEdit(edit,li,value,params);
                    } else if (edit.type == "image") {
                        if (value){
                            li.set("rightIcon2", value);
                        }
                        li.set("clickable", true);
                        // 张松   设置是否允许选择图片的标记，存入li对象中   2016/05/19
                        li.set("disabled", option.lists[index].disabled);
                        var fileInput = domConstruct.create("input", {
                            type : "file",
                            style : "display:none;"
                        });
                        li.labelNode.appendChild(fileInput);
                        li.fileInput = fileInput;
                        li.__data_field = edit.field;
                        li.own(touch.release(li.domNode,lang.hitch(li,function() {
                            // 张松  判断是否允许选择图片，如果不允许选择，不会触发fileInput的click事件   2016/05/19
                            if(this.get("disabled")){
                                return false;
                            }
                            // on.emit(this.fileInput, "click", {cancelable : true, bubbles : true});
                            this.fileInput.click();
                        })));
                        var _li = li;
                        //  变更人:肖芳圆
                        //  变更时间:2016-06-21
                        //  变更原因:上传同路径同名文件不触发onChange事件
                        li.fileChange = function() {
                            if (!this.fileInput.files.length){
                                return;
                            }
                            if(_li.imgSize && (_li.imgSize.width == 0 || _li.imgSize.height == 0)){
                                var file=this.fileInput.files[0];
                                var formData = new FormData();
                                formData.append("cq_file", file);
                                xhr.post(config.getDataOrigin()+"/biz/blob/blob/upload",{
                                    data : formData,
                                    handleAs : "json"
                                }).then(lang.hitch(this,function(data) {
                                    if (data.items && data.items.length == 1) {
                                        _this.__data[this.__data_field] = data.items[0].uri;
                                        this.set("rightIcon2", data.items[0].uri);
                                    }
                                }));
                            }else{
                                var url= window.URL.createObjectURL(this.fileInput.files[0]);
                                imgSelector.selectImg(null,(_li.imgSize?_li.imgSize:{width:128,height:128}),url,"").then(lang.hitch(this,function(dataUrl){
                                    window.URL.revokeObjectURL(url);
                                    this.fileInput.value="";
                                    if(!dataUrl){
                                        return;
                                    }
                                    // decode base64 string, remove space for IE compatibility
                                    var binary = atob((dataUrl.substring(dataUrl.indexOf(",")+1)).replace(/\s/g, ''));
                                    // get binary length
                                    var len = binary.length;
                                    // create ArrayBuffer with binary length
                                    var buffer = new ArrayBuffer(len);
                                    // create 8-bit Array
                                    var view = new Uint8Array(buffer);
                                    // save unicode of binary data into 8-bit Array
                                    for (var i = 0; i < len; i++) {
                                        view[i] = binary.charCodeAt(i);
                                    }
                                    //var file=new File([view],"image.png");
                                    var file=new Blob([view],{type:"image/jpg"});
                                    var formData = new FormData();
                                    formData.append("cq_file", file);
                                    xhr.post(config.getDataOrigin()+"/biz/blob/blob/upload",{
                                        data : formData, handleAs : "json"
                                    }).then(lang.hitch(this,function(data) {
                                        if (data.items && data.items.length == 1) {
                                            _this.__data[this.__data_field] = data.items[0].uri;
                                            this.set("rightIcon2", data.items[0].uri);
                                        }
                                    }));
                                }));
                            }
                            //新建文件上传框
                            var fileInput = lang.clone(_li.fileInput);
                            //替换文件上传框
                            _li.fileInput.parentNode.replaceChild(fileInput, _li.fileInput);
                            _li.fileInput = fileInput;
                            fileInput.onchange = lang.hitch(_li,_li.fileChange);
                            return;
                        }
                        li.fileInput.onchange = lang.hitch(li,li.fileChange);
                        this.connect(this,"refreshData",lang.hitch(li,function(){
                            this.set("rightIcon2", _this.__data[this.__data_field]);
                        }));
                    } else if (edit.type == "richEdit"){
                        this._initRichTextEdit(edit,li,value);
                    } else if (edit.type == "options"){
                        //列表选项需要的配置：edit
                        //    type：options
                        //    field："content"
                        //    options：{k1:v1,k2,v2}...
                        this._initOptionEdit(edit,li,value);
                    }else if(edit.type == "date"){
                        this._initDateEdit(edit,li,value);
                    }else if(edit.type == "dateMin"){
                        this._initMinDateEdit(edit,li,value);
                    }else if(edit.type == "textarea"){
                        this._initTextAreaEdit(edit,li,value);
                    }else if(edit.type == "ref"){
                        this._initJsonRefEdit(edit,li,value);
                    }else if (edit.type == "position") {
                        //需要配置经度/纬度字段
                        //edit:{type:"position",lonField:"",latField:""}
                        this._initPositionEdit(edit,li,value);
                    }
                }
            }
            if(option.isHeader){
                this.resize();
            }
            return container;
        },
        _initRichTextEdit:function(edit,li,value){
            var vNode = domConstruct.create('input', {
                style:'display:none;'
            }, li.domNode, 'last');
            vNode.setAttribute("__data_field", edit.field);
            this.connect(li.domNode, 'onclick', lang.hitch(this, function(){
                var value = this.__data&&this.__data[edit.field]||"";
                editor.startEdit(value||'', this, edit.tempType).then(lang.hitch(this, function(html){
                    //赵春辉   会导致图片地址错误   16-06-13
                    //html = html.replace('"', '\\"');
                    if(this.__data){
                        try{
                            var oldValue = this.__data[edit.field];
                            if(false === this.onDataChange(edit.field, oldValue, html)){
                                return;
                            }
                            this.__data[edit.field] = html;
                            this.onDataChanged(edit.field, oldValue, html);
                        }catch(e){
                            console.log(e.message);
                        }
                    }
                }));
            }));
        },
        _initTextBoxEdit:function(edit,li,value,params){
            // 记录不允许为空的字段，方便validateData()方法做验证
            if(!this.__nullable){
                this.__nullable = [];
            }
            if(edit.nullable&&edit.nullable === false){
                this.__nullable.push(edit.field);
            }
            var vNode = new TextBox(params),field = edit.field.split(".")[0];
            li.set({
                "rightIcon":'',
                "noArrow":true,
                "rightText":""
            });
            vNode.placeAt(li, 'last');
            if(!this.textboxs){
                this.textboxs = [];
            }
            domStyle.set(vNode.domNode, "right", "32px");
            this.textboxs.push({node:vNode.domNode, field:edit.label});
            vNode.domNode.setAttribute("__data_field",edit.field);
            vNode.set("__data_field", edit.field);
            var _this = this;
            vNode.connect(vNode,"onChange",lang.hitch(this,function(){
                if(this.__data){
                    var oldValue = this.__data[field];
                    // 张松  当文本框的值发生改变时，验证信值是否符合要求，如果验证失败，改回原来的值  2016/05/19
                    if(edit.textType){
                        var validStatus = false;
                        // 输入框要求文本内容且对内容有要求，需要判断
                        if(edit.textType === "text" && edit.regex){
                            if(edit.regex.test(vNode.get("value"))){
                                // vNode.set("value", oldValue);
                                validStatus = true;
                            }
                        }else if(edit.textType === "float" && edit.textValueRange){// 输入框类型为小数
                            var maxValue = parseFloat(edit.textValueRange.substring(edit.textValueRange.indexOf(",")+1, edit.textValueRange.length-1));
                            var minValue = parseFloat(edit.textValueRange.substring(1, edit.textValueRange.indexOf(",")));
                            // 根据括号判断是否包含最大最小值
                            var nv = parseFloat(vNode.get("value"));
                            if((edit.textValueRange.indexOf("[") > -1 && nv >= minValue
                                || edit.textValueRange.indexOf("(") > -1 && nv > minValue)
                                && (edit.textValueRange.indexOf("]") > -1 && nv <= maxValue
                                || edit.textValueRange.indexOf(")") && nv < maxValue)){
                                validStatus = true;
                            }else{
                                validStatus = false;
                            }
                        }else if(edit.textType === "int" && edit.textValueRange){
                            var maxValue = parseInt(edit.textValueRange.substring(edit.textValueRange.indexOf(",")+1, edit.textValueRange.length-1));
                            var minValue = parseInt(edit.textValueRange.substring(1, edit.textValueRange.indexOf(",")));
                            var nv = parseInt(vNode.get("value"));
                            if((edit.textValueRange.indexOf("[") > -1 && nv >= minValue
                                || edit.textValueRange.indexOf("(") > -1 && nv > minValue)
                                && (edit.textValueRange.indexOf("]") > -1 && nv <= maxValue
                                || edit.textValueRange.indexOf(")") && nv < maxValue)){
                                validStatus = true;
                                vNode.set("value", nv);
                            }else{
                                validStatus = false;
                            }
                        }
                        if(validStatus == false){
                            vNode.set("value", oldValue);
                            return false;
                        }
                    }
                    //赵春辉   修改之后若调用refreshData又会触发onChange事件，防止死循环   2016-07-27
                    if(!this.__isRefreshing && false === this.onDataChange(field, oldValue, vNode.get("value"))){
                        vNode.set("value", oldValue);
                        return;
                    }
                    this.__data[field] = vNode.get("value");
                    if(!this.__isRefreshing){
                        this.onDataChanged(field, oldValue, vNode.get("value"));
                    }
                }
            }));
            vNode.connect(this,"refreshData",lang.hitch(this,function(){
                vNode.set("value", this.__data[field]);
            }));
        },
        _initJsonRefEdit:function(edit,li,value){
            if(edit&&edit.params&&edit.params.target&&edit.params.labelField&&edit.params.searchField){
                var field = edit.field.split(".")[0];
                this.connect(li.domNode,"onclick",function(){
                    if(edit.queryChange){
                        if(jsonRef.jsonStoreListHash[edit.params.target]){
                            jsonRef.jsonStoreListHash[edit.params.target].query = edit.queryChange();
                        }else {
                            edit.params.query = edit.queryChange();
                        }
                    }
                    jsonRef.startEdit(this.__data[field]||"",this,edit.params).then(lang.hitch(this,function(data){
                        var oldValue = this.__data[field];
                        if(false === this.onDataChange(field, oldValue, data)){
                            return;
                        }
                        this.__data[field] = data;
                        li.set("rightText", this.__data[field]&&this.__data[field][edit.params.labelField]||edit.placeHolder||"");
                        this.onDataChanged(field, oldValue, data);
                    }));
                });
                li.set("rightText",value&&value[edit.params.labelField]||edit.placeHolder||"");
                this.connect(this,"refreshData",function(){
                    li.set("rightText", this.__data[field]&&this.__data[field][edit.params.labelField]||edit.placeHolder||"");
                });
            }else{
                console.error("参数错误:"+edit);
            }
        },
        _initTextAreaEdit:function(edit,li,value){
            var field = edit.field.split(".")[0];
            this.connect(li.domNode, 'onclick', function(){
                textArea.startEdit(this.__data[field]||"", this).then(lang.hitch(this, function(value){
                    var oldValue = this.__data[field]||"";
                    if(false === this.onDataChange(field, oldValue, value)){
                        return;
                    }
                    this.__data[field] = value;
                    li.set("rightText", value);
                    this.onDataChanged(field, oldValue, value);
                }));
            });
            li.set("rightText", this.__data[field]||"");
            this.connect(this, "refreshData", function(){
                li.set("rightText", this.__data[field]||"");
            });
        },
        _initDateEdit:function(edit,li,value){
            var field = edit.field.split(".")[0];
            this.connect(li.domNode,"onclick",function(){
                datePick.startEdit(this.__data[field]||"",this).then(lang.hitch(this,function(value){
                    var oldValue = this.__data[field]||"";
                    if(false === this.onDataChange(field, oldValue, date.formatToISOString(value))){
                        return;
                    }
                    this.__data[field] = date.formatToISOString(value);
                    li.set("rightText",value);
                    this.onDataChanged(field, oldValue, date.formatToISOString(value));
                }));
            });
            li.set("rightText",this.__data[field]&&date.formatISODate(this.__data[field])||"");
            this.connect(this,"refreshData",function(){
                li.set("rightText",this.__data[field]&&date.formatISODate(this.__data[field])||"");
            });
        },
        //日期、小时，秒
        _initMinDateEdit:function(edit,li,value){
            var field = edit.field.split(".")[0];
            this.connect(li.domNode,"onclick",function(){
                dateTimePick.startEdit(this.__data[field]||"",this).then(lang.hitch(this,function(value){
                    var oldValue = this.__data[field]||"";
                    if(false === this.onDataChange(field, oldValue, date.formatISODateMinutes(value))){
                        return;
                    }
                    this.__data[field] = date.formatISODateMinutes(value);
                    li.set("rightText",value);
                    this.onDataChanged(field, oldValue, date.formatISODateMinutes(value));
                }));
            });
            li.set("rightText",this.__data[field]&&date.formatISODateMinutes(this.__data[field])||"");
            this.connect(this,"refreshData",function(){
                li.set("rightText",this.__data[field]&&date.formatISODateMinutes(this.__data[field])||"");
            });
        },
        _initOptionEdit:function(edit,li,value){
            var ops = edit.options,field = edit.field.split(".")[0];
            this.connect(li.domNode,"onclick",function(){
                optionsList.startEdit(this.__data[field]||"",this,ops).then(lang.hitch(this,function(value){
                    var oldValue = this.__data[field];
                    if((oldValue == undefined) || (oldValue == null)){
                        oldValue = "";
                    }
                    // 张松  如果编辑界面点击返回按钮，则保持原来的值不变  2016/06/14
                    if(value === ""){
                        value = oldValue;
                    }
                    if(false === this.onDataChange(field, oldValue, value)){
                        return;
                    }
                    li.set("rightText",ops[value]||"");
                    this.__data[field] = value;
                    this.onDataChanged(field, oldValue, value);
                }));
            });
            li.set("rightText",ops[value]||"");
            this.connect(this,"refreshData",function(){
                li.set("rightText",ops[this.__data[field]]||"");
            });
        },
        _initCheckBox:function(edit,li){
            var field = edit.field.split(".")[0],vNode = new Switch( {
                leftLabel : '',
                rightLabel : '',
                shape : 'mblSwRoundShape1',
                onStateChanged:lang.hitch(this,function(){
                    var newValue = "on"===vNode.get("value");
                    var oldValue = !newValue;
                    //赵春辉   修改之后若调用refreshData又会触发onChange事件，防止死循环   2016-07-27
                    if(!this.__isRefreshing&&false === this.onDataChange(field, oldValue, newValue)){
                        vNode.set("value", oldValue?"on":"off");
                        return;
                    }
                    this.__data[field] = newValue;
                    if(!this.__isRefreshing){
                        this.onDataChanged(field, oldValue, newValue);
                    }
                })
            });
            this.connect(this,"refreshData",function(){
                this.__data[field] = !!this.__data[field];
                vNode.set("value",this.__data[field]?"on":"off");
            });
            vNode.placeAt(li.domNode, 'last');
            vNode.startup();
            this.__data[field] = !!this.__data[field];
            vNode.set("value",this.__data[field]?"on":"off");
        },
        _initPositionEdit:function (edit,li,value) {
            //经度字段
            var lonField = edit.lonField.split(".")[0];
            //纬度字段
            var latField = edit.latField.split(".")[0];
            var pos = null;
            this.connect(li.domNode,"onclick",function(){
                pos = {lon:this.__data[lonField]||"",lat:this.__data[latField]||""};
                position.startEdit(pos,this).then(lang.hitch(this,function(value){
                    //赵春辉   有可能没有选择任何东西
                    if(!value){
                        return;
                    }
                    var oldValue = pos;
                    if(false === this.onDataChange(lonField, oldValue.lon, value.lon)
                        ||false === this.onDataChange(latField, oldValue.lat, value.lat)){
                        return;
                    }
                    //li.set("rightText","");
                    //修改__data的值
                    this.__data[lonField] = value.lon;
                    this.__data[latField] = value.lat;
                    this.onDataChanged(lonField, oldValue.lon, value.lon)
                    this.onDataChanged(latField, oldValue.lat, value.lat)
                }));
            });
            li.set("rightText","设置位置");
            // this.connect(this,"refreshData",function(){
            //     li.set("rightText",ops[this.__data[field]]||"");
            // });
        },
        validateData : function(){
            var __data = this.getData();
            for(var index = 0; index < this.__nullable; index++){
                if(__data[this.__nullable[index]] && __data[this.__nullable[index]].trim() || ("" + __data[this.__nullable[index]])){
                    continue;
                }else{
                    return false;
                }
            }
            return true;
        },
        //判断是否数字
        /*isNumber:function(num){
            return !isNaN(num);
        },*/
        startEditAsHtml : function(text) {
            return editor.startEdit(text, this);
        },
        onDataChange : function(field, oldValue, newValue){
            return true;
        },
        onDataChanged : function(field, oldValue, newValue){
        },
        dataToFloors:function(data){
            // floors = [obj1,obj2,obj3]
            var floors = [];
            array.forEach(data, function(item, index){
                var type = item.type=="slideShow"?6:(item.options.flexes!=0 && item.options.flexes[0] == 2)?13:(item.options.flexes!=0 && item.options.flexes[0] == 3)?12:(item.options.direction=="H1V2"?3:(item.options.direction=="H2V1"?15:(item.data?9:item.boxes.length==1?1:(item.boxes.length==2?2:(item.boxes.length==3?4:(item.boxes.length==4&&item.options.height==136?5:(item.boxes.length==4&&item.options.height==96?7:8)))))));
                floors.push({
                    layout:type,
                    useborder:item.options.useborder,
                    pos:2,
                    sldtp:"",
                    boxData:(type==9?[]:array.map(item.data, function(dt, index){
                        return {box:{
                            link:dt.url,
                            title:dt.title,
                            imgUrl:dt.icon
                        }};
                    }))
                });
            });
            return floors;
        },
        floorsToData:function(floors){
            // data = [{type:"slideShow/columns",options:{useborder:0/1,height:123,flexes:[2,3]/[3,2],direction:"H/H1V2/H2V1"},data:[]}]
            // height 应该是整个楼层的高度
            // 一个楼层有多个box
            var data = [];
            array.forEach(floors, function(item, index){
                data.push({
                    type:(item.layout == 6)?"slideShow":"columns",
                    options:{
                        useborder:item.useborder,
                        flexes:(item.layout == 12?[3,2]:(item.layout == 13?[2,3]:0)),
                        height:((item.layout == 3 || item.layout == 15)?item.boxData[0].imgCutHeight:0),
                        direction:((item.layout == 3)?"H1V2":((item.layout==15)?"H2V1":"H")),
                    },
                    boxes:((item.layout==9||item.layout==10||item.layout==11||item.layout==14)?null:array.map(item.boxData, function(box, index){
                        return {
                            title:box.title,
                            url:box.link,
                            icon:box.imgUrl
                        };
                    })),
                    data:((item.layout==9||item.layout==10||item.layout==11||item.layout==14)?{
                        provider:"cq/biz/mat/mat",
                        action:"loadAsBoxes",
                        max:item.matqty,
                        params:[{
                            isUse:true,
                            qty:1,
                            pageSize:item.matqty,
                            orderBy:'-totalSale'
                        }]
                    }:null)
                });
            });
            return data;
        },
        loadingBgClass:"bg-loading-img",
        nothingBgClass:"bg-nothing",
        onLoadListData:function(queryResult,start,pageSize,tp){
            domClass.add(this.centerPanel.domNode,this.loadingBgClass);
            domClass.remove(this.centerPanel.domNode,this.nothingBgClass);
            tp = ""+tp;
            queryResult.then(lang.hitch(this,function(){
                this.centerPanel.resize();
            }));
            queryResult.total.then(lang.hitch(this,function(total){
                this.totalInfo = this.totalInfo||{};
                this.totalInfo[tp] = total;
                if(start+pageSize<total){
                    domClass.add(this.centerPanel.domNode,this.loadingBgClass);
                }else{
                    domClass.remove(this.centerPanel.domNode,this.loadingBgClass);
                }
                if(total===0){
                    domClass.add(this.centerPanel.domNode,this.nothingBgClass);
                }
            }));
        },
        //赵春辉    统一判断是否可以加载更多，界面上可能有多个列表，所以需要传入类型    2016-06-27
        canLoadMore:function(start,tp){
            tp = ""+tp;
            if(this.totalInfo&&(0===this.totalInfo[tp]||this.totalInfo[tp]&&this.totalInfo[tp]<=start)){
                return false;
            }else{
                return true;
            }
        }
    });
});
