define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/store/JsonRest",
    "dojo/touch",
    "dojo/query",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dojox/mobile/View",
    "cq/widgets/item/TalkListItem",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/blob/blob",
    "cq/biz/user/user",
    "cq/biz/im/msg",
    "cq/biz/im/msg_p",
    "cq/util/sys/date"
],function( declare, lang, array, domAttr, domClass, domStyle, JsonRest, touch, query, Deferred, DeferredList, View, TalkListItem, EdgeToEdgeStoreList, _ViewMixin, blob, user, msg, msg_p,date){
    return declare("cq.ui.common.im.SvcDetail",[View,_ViewMixin],{
        pageSize:20,
        nothingBgClass:"",
        onFirstShow: function(){
            //创建页面元素，初始化界面元素k
            //创建头部
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: 'left',
                    label: '返回',
                    onClick: function(){
                        history.back();
                    }
                },
                title:"聊天信息"
            };
            this.addHeader(option);
            //添加对话消息列表
            this.storeList = new EdgeToEdgeStoreList({
                baseClass:"",
                append : true,
                constraint: false,
                query:{},
                class:"icon-list-item talk-list",
                variableHeight:true,
                onComplete:lang.hitch(this,this.onMsgDataLoaded),
                // 查询条件
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                }
            });
            //将列表放在中间滑动区域
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            //为中间区域绑定滑动事件和点击事件
            this.centerPanel.on("beforeScroll",lang.hitch(this,this.onLoadMore));
            this.centerPanel.on("click",lang.hitch(this,this.onTalkListClick));
            //添加底部回复栏和图片回复
            option = {
                placeHolder: "请输入回复内容",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, this.onMessageEnter)
            };
            this.textBox = this.addTextBox(option);
            this.footerColumn = this.addColumns({
                forceWidth: false,
                isFooter: true,
                columns: [{
                    className: "flex1",
                    label: ""
                }, {
                    className: "miniIcon imageSelector",
                    label: ""
                }],
                className: 'footerColumns'
            });
            this.textBox.placeAt(query(".flex1", this.footerColumn)[0], "only");
            domAttr.set(this.textBox.domNode,"type","text");
            
            //发图片消息
            this.own(touch.release(query(".miniIcon", this.footerColumn)[0], lang.hitch(this, function() {
                //调用blob方法处理图片            
                blob.selectAndUpload().then(lang.hitch(this, this.onUploadImage));
            })));
            //侦听msg中新消息的推送，并在列表中显示
            this.connect(msg,"onShowMsg",this.onNewMsg);
           //退出时重置消息小图标的提示
           this.connect(this,"onBeforeTransitionOut",function(){
               //清空消息列表内的小图标提示
              msg_p.clearMsgCount(this.targetUserId,this.currentUserInfo._id);
           });
           this.onAfterShow();
        },
        //当前用户的信息
        currentUserInfo:{},
        //目标用户的信息
        targetUserInfo: {},
        //对话所在商家
        currentShopId: "",
        getCurrentShopId:function(){
            return window.did.split(",")[0];
        },
        getTargetUserId:function(){
            return window.did.split(",")[1];
        },
        onAfterShow: function(){
           //从参数中读取对话双方和商家的id
           this.currentShopId = this.getCurrentShopId();
           //获取当前人的信息
           var defs = [user.getUserInfo().then(lang.hitch(this,function(data){
               this.currentUserInfo = data&&data.data&&data.data.item;
           }))];
           //获取对话人信息
		   //干劲：loadUseByIdAndShop加了权限控制，目标用户无法加载
           this.targetUserId = this.getTargetUserId();
           //获取对话双方的信息
           //清空回话列表
           this.storeList.destroyDescendants();
           this.canScrollToBottom = true;
           //刷新回话列表
           new DeferredList(defs).then(lang.hitch(this,function(){
               this.onLoadMore({
                   beforeTop:true
               }).then(lang.hitch(this,this.scrollToBottom));
           }));
        },
        
        canScrollToBottom:true,
        
        scrollToBottom:function(){
            if(this.scrollTimer){
                clearTimeout(this.scrollTimer);
            }
            this.scrollTimer = setTimeout(lang.hitch(this,function(){
                this.centerPanel.scrollTo({
                    x:0,
                    y:Math.min(0,domStyle.get(this.centerPanel.domNode,"height")-domStyle.get(this.centerPanel.containerNode,"height"))
                });
            }),300);
        },
        //加载对话消息，得到结果之后的处理函数
        onMsgDataLoaded:function(datas){
            //便利所有数据，向列表中添加第一个孩子
            array.forEach(datas,function(item){
                this.storeList.addChild(this.getListItemByData(item),0);
            },this);
            this.busy = false;
        },
        //依据一行数据得到一个消息列表项
        getListItemByData:function(data){
            //处理数据并传入talkListItem zkj
            var dataMsg = data&&data.data&&data.data.item||data;
            dataMsg.isHost = (dataMsg.senderId&&dataMsg.senderId._id)===this.currentUserInfo._id;
            dataMsg.createAt = dataMsg.createAt||date.nowISOString();
            return new TalkListItem({
                params:dataMsg
            });
        },
        //加载更多
        onLoadMore:function(e){
            var def = new Deferred();
            //若非busy且可以加载更多且从上往下拖动
            var start = this.storeList.getChildren().length;
            var queryInfo = null,queryResult;
            if(!this.busy&&this.canLoadMore(start)&&e.beforeTop){
                this.busy = true;
                var queryResult = null;
                queryInfo = {
                    shopId: this.currentShopId,
                    userId1: this.currentUserInfo._id,
                    userId2: this.targetUserId 
                };
                if(!this.storeList.store){
                    var store = new JsonRest({
                        target:msg.getSvcMsgUrl()
                    });
                    queryResult = this.storeList.setStore(store,queryInfo,{
                        start: start,
                        count: this.pageSize
                    });
                    this.onLoadListData(queryResult,start,this.pageSize);
                    queryResult.then(function(){
                        def.resolve();
                    });
                }else{
                    this.canScrollToBottom = false;
                    setTimeout(lang.hitch(this,function(){
                        queryResult = this.storeList.setQuery(queryInfo, {
                            start : start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,start,this.pageSize);
                        queryResult.then(function(){
                            def.resolve();
                        });
                    }),1000);
                }
            }
            return def;
        },
        onTalkListClick:function(evt){
            //若点击的目标为图片且不是头像，看大图)
            if(evt.target.localName == "img"){
                if(domClass.contains(evt.target.parentNode, "msgContent")){
                    var imgSrcUri = evt.target.src;
                    this.showImg(imgSrcUri); 
                } 
            }
        },
        onMessageEnter:function(evt){
            //在列表最后添加自己发送的消息
            if(evt.keyCode==13){
                this.search = evt.target.value;
                if (!this.search) {
                    return;
                }
                //保存到服务器
                var data = {
                    shopId: this.currentShopId,
                    senderId: this.currentUserInfo._id,
                    receiverId: this.targetUserId,
                    msgContent: this.search,
                    msgType: "text"
                };
                msg.save(data);
                data.senderId = this.currentUserInfo;
                data.receiverId = {_id:this.targetUserId};
                evt.target.value = this.search = "";
                this.storeList.addChild(this.getListItemByData(data));
                this.scrollToBottom();
            }
        },
        onUploadImage:function(imageInfo){
            //得到结果之后，添加图片消息，上传图片消息
            if (imageInfo && imageInfo.items && imageInfo.items[0]) {
                var data = {
                    shopId: this.currentShopId,
                    senderId: this.currentUserInfo._id,
                    receiverId: this.targetUserId,
                    msgType: "image",
                    msgContent: imageInfo.items[0].uri,
                };
                msg.save(data);
                data.senderId = this.currentUserInfo;
                data.receiverId = {_id:this.targetUserId};
                this.storeList.addChild(this.getListItemByData(data));
                this.scrollToBottom();
            }
        },
        onNewMsg:function(msgData){
            var senderId = msgData.senderId;
            senderId = senderId&&senderId._id||senderId;
            //若接收人为自己，且发送人为对话目标人
            if(senderId==this.targetUserId){
                //设置消息为已读
                msgData.isUse = true;
                //添加列表项到列表的最后
                this.storeList.addChild(this.getListItemByData(msgData));
                this.scrollToBottom();
            }
        }
    });
});