//创建人：周超
//创建时间：2016/9/6
//创建内容：合作伙伴
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
	"dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "dijit/focus",
    "cq/biz/user/user"
],function(declare,lang, domClass,View,_ViewMixin,date,focusUtil,user){
    // module:
    //      cq/ui/b/u/User
    return declare("cq.ui.b.u.User", [View, _ViewMixin], {
        // 检测是否编辑状态
        isEditing: false,
        // 初始化相关接口
        onAfterShow: function () {
            if (!this.isEditing) {
                this.isEditing = true;
                if (!window.did) {
                    this.setData({
                        sex: 1,
                        birthday: '1990-01-01',
                        //增加设置星级默认值为5
                        score:5
                    });
                    this.refreshData();
                } else {					
                    user.loadById(window.did).then(lang.hitch(this, function (data) {
						data.data.item.amount = window.fixedTo(data.data.item.amount,3);
                        this.setData(data && data.data && data.data.item || {});
                        this.refreshData();
                    }))
                }
            }
        },
        //增加一个addOptionList函数，返回数组
        addOptionList:function(){
            return oldArray=[{
                label: "客户头像",
                noArrow: false,
                class: "li-icon",
                moveTo : "#",
                edit :{
                    type:"image",
                    field:"logo"
                }
            },{
                label: '姓名',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'pName',
                    placeHolder: "必填"
                }
            },{
                label: '性别',
                moveTo: "#",
                edit: {
                    type: 'options',
                    field: 'sex',
                    options: {
                        0: "男",
                        1: "女",
                        2:"保密"
                    }
                }
            },{
                label: '电话',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'phone',
                    placeHolder: "请输入电话"
                }
            },{
                label: '地址',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'address',
                    placeHolder: "请输入地址"
                }
            },{
                label: '生日',
                moveTo: "#",
                edit: {
                    type: 'date',
                    field: 'birthday'
                }
            },{
                label: '余额',
                noArrow: true,
                edit: {
                    type: 'text',
                    field:'amount',
                    disabled: true
                }
            },{
                label:"星级",
                moveTo:'#',
                edit:{
                    type:'options',
                    field:'score',
                    options:{
                        5:'5',
                        4:'4',
                        3:'3',
                        2:'2',
                        1:'1'
                    }
                }
            },{
                label:"个人简介",
                moveTo:'#',
                edit:{
                    type:'textarea',
                    field:'userDesc'
                }
            },{
                label: '昵称',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'nickName',
                    disabled: true
                }
            },{
                label: '来源客户',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'srcUid',
                    disabled: true
                }
            },{
                label: '场景值',
                noArrow: true,
                edit: {
                    type: 'text',
                    field: 'wxSrcSid',
                    disabled: true
                }
            }];
        },
        onFirstShow: function () {			
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function () {
                        //window.moveToView("userList");
                        history.back();
                        this.isEditing = false;
                    }
                },
                title: "客户管理",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            //logo
            //li.set("clickable", false);
            //定义lists为addOptionList函数返回值
            option = {
                isEdge: true,
                class: "bottom-margin16",
                lists: this.addOptionList()
            };
            this.addLists(option);
            this.onAfterShow();
        },
        // 保存数据
        onSaveStore: function () {
            //设置界面busy
            window.busy();
            // 当前节点失去焦点
            focusUtil.curNode && focusUtil.curNode.blur();
            var m = this.getData();
            var msg = this.checkData(m);
            if (msg) {
                //设置界面free
                window.free();
                alert(msg);
                return;
            }
            m.shopId = user.getShopId();
            user.save(m).then(lang.hitch(this, function (data) {
                //设置界面free
                window.free();
                if(data.data.ok == 1){
                    this.isEditing = false;
                    //window.moveToView("userList");
                    history.back();
                }else{
                    alert("保存失败");
                }
            }));
        },
        // 验证文本框内容
        checkData: function (data) {
            var msg = "";
            if(!data.pName){
                return "姓名不能为空";
            }
            if(!data.phone){
                return "电话不能为空";
            }
        }
    });
})