//合作伙伴
//创建人：周超
//创建时间：2016/9/6
// 变更人：干劲
// 变更时间：20160910
// 变更内容：联系人显示字段错误
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/store/JsonRest",
    "dojo/on",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/biz/shop/partner",
    "cq/biz/shop/shop",
    "cq/util/config/config",
    "cq/ui/view/_ViewMixin"
],function( declare, lang, array, domClass, JsonRest, on, query, registry, View, EdgeToEdgeStoreList, partner, shop, config, _ViewMixin){
    return declare("cq.ui.common.s.MyPatennerList",[View,_ViewMixin],{
        start: 0,
        pageSize: 20,
        //第一次进入页面加载页面组件。
        onFirstShow: function(){
            //添加头部
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function(){
                        history.back();
                    }
                },
                title: "我的伙伴"
            };
            this.addHeader(option);
            //添加顶部搜索栏
            option = {
                placeHolder: "请输入关键字，按回车进行查询",
                type: "search",
                class: "cqSearchBox",
                isHeader: true,
                onInput: lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get('query');
                        condition.shopName = this.search;
                        condition.isDelete = false;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                    
                })
            };
            this.searchBox = this.addTextBox(option);
            option = {
                isHeader:true,
                columns : [{
                        label : '全部',
                        onClick : this.selectAll
                    }, {
                        label : '供应商',
                        onClick : this.saleMan
                    }, {
                        label : '分销商',
                        onClick : this.isSeledMan
                    },{
                        label : '待处理',
                        onClick : this.isAgree
                    }
                ],
                labelClass : 'font-size1 tab-selector'
            };
            this.conditMenus = this.addColumns(option);
            option = {
                columns : [{
                    icon : 'images/icon/mat.png',
                    iconClass:'footer-tab-img',
                    label : '查找更多伙伴',
                    onClick : function () {
                        window.moveToView("supplyList");
                    }
                }],
                valueClass : 'font-size3',
                labelClass : 'font-size1',
                className : 'fix-footer',
                isFooter : true
            };
            this.addColumns(option);
            //添加供货商列表
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight:true,
                onComplete: lang.hitch(this,function(data){
                    for(var i =0; i<data.length; i++){
                        //data.shopType是config下的typeCard，为一串字符串，转换为可读类型
                        array.forEach(config.shopType,function(item){
                            if(data[i].shopType==item.typeCard){
                                data[i].shopType = item.typeName;
                            }
                        });
                        //增加商品数量和销售数量
                        data[i]._label = "<div class='webkit-list'>"
                            +"<div class='user-list-left user-list-margin'>店铺名称:"+(data[i].shopName||"")+"</div>"+"<div class='user-list-margin'>"+"</div></div>"
							+"<div class='webkit-list'>"
							+"<div class='user-list-left user-list-margin'>地址:"+(data[i].address||"")+"</div>"
							+"<div class='user-list-margin'>联系人:"+(data[i].contactName||"")+"</div></div>"
                            +"<div class='hflex'><div class='user-list-margin' style='width: 60%;'>联系电话:"+(data[i].contactPhone||"")+"</div>"
                            +"<div class='forth-btn'>";
                        if(data[i].isSupplier==true){
                            data[i]._label += "<span class='usercredit float-right'>供</span>";
                        }    
                        if(data[i].isCustomer == true){
                            data[i]._label += "<span class='usercredit float-right'>销</span>";
                        }
                        if(data[i].customerState == 1){
                            data[i]._label += "<span class='usercredit float-right'>申</span>";
                        }
                        data[i]._label += "</div></div>";
                        data[i]._logo = data[i].logo?data[i].logo:'images/userIcon.png';
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + this.pageSize-1;
                    this.busy = false; 
                }),
                queryOptions: {
                    count: 20,
                    start: this.start
                },
                itemMap:{
                    _label:"label",
                    _logo:"icon",
                    moveTo:"moveTo"
                }
            });
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            //定义列表所处位置
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            //绑定列表点击事件
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            //绑定列表拖动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        onAfterShow: function(){
            //清空商家列表
            this.storeList.destroyDescendants();
            //加载数据
            var queryResult=null;
            if(!this.store){
                this.params= {isDelete:false};
                //字段isVerified没起作用，导致列表中出现未认证的商家
                this.store= new JsonRest({target:partner.getLoadUrl()});
                //将数据赋值给供应商家列表
                queryResult= this.storeList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                setTimeout(lang.hitch(this,function(){
                    queryResult= this.storeList.setQuery(this.params,{
                        start: this.start,
                        count: this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
                }),300);
            }
        },
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        //全部
        selectAll : function (evt) {
            this.params = {};
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isDelete = false;
            this.setQuery(this.params);
        },
        //供应商
        saleMan : function (evt) {
            this.params = {};
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isDelete = false;
            this.params.isSupplier = true;
            this.setQuery(this.params);
        },
        //分销商
        isSeledMan : function (evt) {
            this.params = {};
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.isDelete = false;
            this.params.isCustomer = true;
            this.setQuery(this.params);
        },
        //申请中
        isAgree : function (evt) {
            this.params = {};
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.customerState = 1;
            this.setQuery(this.params);
        },
        onClickList: function(evt){
            //得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem"){
                return;
            }
            var _id = li.params._id;
            window.moveToView("supplyBus",_id);
        },
        onLoadMore:function(evt){
            //判断this.busy是否为false和下拉方向
            if(!this.busy&&evt.afterBotton){
                this.busy = true;
                //设置本次加载的起始位置
                this.start = this.start+ this.pageSize;
                //判断能否加载更多
                if(this.canLoadMore(this.start)){
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"),{
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }),800);
                }
            }
        },
        setQuery: function(query){
            this.start = 0;
            //清空列表
            this.storeList.destroyDescendants();
            //依据条件加载数据
            var queryResult =this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});