﻿/**
 * 修改人: 杜飞军
 * 修改时间: 2016-06-08
 * 修改内容:
 *      获取验证码按钮位置
 *      修改发送验证码定时器
 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/query",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/user",
    "cq/biz/sms/sms"
],
function(declare, lang, domAttr, query, View, _ViewMixin, user, sms) {
    return declare("cq.ui.b.s.Retrieve", [View, _ViewMixin], {
        onAfterShow: function() {
            this.emptyData();
        },
        onFirstShow: function() {
            // 头部设置
            var options = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function() {
                        this.emptyData();
                        this.clearTimeView(this.vCode);
                        //window.moveToView("main");
                        history.back();
                    })
                },
                title: "找回密码"
            };
            this.addHeader(options);
            // text文本框添加  
            options = {
                isEdge: true,
                lists: [{
                    label: '手机号码',
                    noArrow: true,
                    edit: { type: 'text', field: 'userName', placeHolder: '你登陆使用名称' }
                }, {
                    className: "mblListItem btn-vcode",
                    rightText: '获取验证码',
                    onClick: lang.hitch(this, function(e) {
                        if (e.target.className !== "mblListItemRightText") {
                            return;
                        }
                        this.setVerifyCodeWaite(e.target, 60, lang.hitch(this, function() {
                            var data = this.getData();
                            sms.sendVcode(data.userName);
                        }));
                    })
                }, {
                    label: '验证码',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'vCode',
                        placeHolder: '请填写短信验证码'
                    },
                    rightText: "获取验证码"
                }, {
                    label: '密码',
                    noArrow: true,
                    edit: { type: 'password', field: 'password', placeHolder: '你登录使用的密码' }
                }, {
                    label: '确认密码',
                    noArrow: true,
                    edit: { type: 'password', field: 'repassword', placeHolder: '重复你的登陆密码' }
                }]
            };
            this.addLists(options);

            // 确认按钮 登陆
            options = {
                columns: [{
                    label: "登录",
                    className: "flex1 footer-tab-dark",
                    onClick: function() {
                        this.emptyData();
                        window.moveToView("login");
                    }
                }, {
                    label: "确认",
                    className: "flex1 footer-tab-highlight",
                    onClick: lang.hitch(this, this.onVerify)
                }],
                className: '',
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(options);
            this.vCode = query(".btn-vcode .mblListItemRightText", this.domNode)[0];
        },
        // 私有存储字符串
        _userInfo: {},
        getShopId:function(){
            return user.getShopId();
        },
        // 提交处理
        onRetrieve: function() {
            user.resetPassword({
                "userName": this._userInfo.userName,
                "password": this._userInfo.password,
                "vCode": this._userInfo.verify,
                "shopId": this.getShopId()
            }).then(lang.hitch(this, function(result) {
                if (result.data.ok === 1) {
                    this.emptyData();
                    this.clearTimeView(this.vCode);
                    window.moveToView("login");
                } 
                // else if (result.data.status === 101) {
                //     alert("验证码错误");
                // } else if (result.data.status === 102) {
                //     alert("验证码已过期");
                // } else if (result.data.status === 310) {
                //     alert("用户名已存在");
                // } else if(result.data.msg === "短信验证码无效"){
                //     alert("短信验证码无效");
                // }
                else{
                    alert(result.data.msg);
                }
            }));
        },
        // 验证字段
        onVerify: function() {
            this._userInfo.userName = query("[__data_field='userName']", this.domNode)[0].value;
            this._userInfo.verify = query("[__data_field='vCode']", this.domNode)[0].value;
            this._userInfo.password = query("[__data_field='password']", this.domNode)[0].value;
            this._userInfo.repassword = query("[__data_field='repassword']", this.domNode)[0].value;
            // 提示处理
            if (!/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(this._userInfo.userName)) {
                alert("请输入正解的11位电话号码");
            } else if (this._userInfo.verify === "") {
                alert("验证码不能为空");
            } else if (this._userInfo.password === "" || this._userInfo.repassword === "") {
                alert("密码不能为空");
            } else if (this._userInfo.password != this._userInfo.repassword) {
                alert("两次密码不一致");
            } else {
                // 登陆请求
                this.onRetrieve();
            }
        },
        // 获得验证码
        // getVetify: function() {
        //     var number = query("[__data_field='userName']", this.domNode)[0].value;
        //     if (/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(number)) {
        //         sms.sendVcode(number);
        //         alert("验证码已经发送");
        //     } else {
        //         alert("请输入正解的11位电话号码");
        //     }
        // },

        // 清空数据
        emptyData: function() {
            this.setData({});
            this.refreshData();
        },

        // 设置定时器
        setVerifyCodeWaite: function(domNode, wTime, callback) {
            var registData = this.getData();
            if (/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(registData.userName)) {
                if (this.vCodeWaite) {
                    alert("请稍后再发");
                    return;
                } else {
                    alert("验证码已经发送");
                    this.codeHtml = domAttr.get(domNode, "innerHTML");
                    this.vCodeWaite = true;
                    // 执行回调
                    callback.apply(this);
                    this.animate = setInterval(lang.hitch(this, function() {
                        wTime--;
                        // 获得传递的对象
                        domAttr.set(domNode, "innerHTML", this.codeHtml + "(" + wTime + ")");
                        if (wTime === 0) {
                            this.vCodeWaite = false;
                            clearInterval(this.animate);
                            domAttr.set(domNode, "innerHTML", this.codeHtml);
                        }
                    }), 1000);
                }
            } else {
                alert("请输入正确的11位电话号码");
            }
        },

        // 清除计时器显示
        clearTimeView: function(domNode) {
            this.vCodeWaite = false;
            // 可能存在没有点击发送验证码就清除的问题
            if (this.codeHtml) {
                domAttr.set(domNode, "innerHTML", this.codeHtml);
            }
            clearInterval(this.animate);
        }
    });
});
