﻿//添加供货商列表
//主要实现显示注册的供货商信息，顶部设有输入框查询，列表显示后支持点击事件并跳转到商家详情界面
//变更人：周科吉
//变更时间：2016-08-03
//变更事件:处理未认证商家显示问题，增加显示商家的商品数和成交量
// 变更人：干劲
// 变更时间：20160910
// 变更内容：显示销售区域，行政区划
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/store/JsonRest",
    "dojo/on",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/ui/util/districtOverlay",
    "cq/biz/shop/shop",
    "cq/util/config/config"
],function( declare, lang, array, domClass,JsonRest, on, query, registry, View, EdgeToEdgeStoreList, _ViewMixin, districtOverlay, shop, config){
    return declare("cq.ui.common.s.SupplyList",[View,_ViewMixin],{
        start: 0,
        pageSize: 20,
        //第一次进入页面加载页面组件。
        onFirstShow: function(){
            //添加头部
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function(){
                        history.back();
                    }
                },
                title: "供应商"
            };
            this.addHeader(option);
            //添加顶部搜索栏
            option = {
                placeHolder: "请输入关键字，按回车进行查询",
                type: "search",
                class: "cqSearchBox",
                isHeader: true,
                onInput: lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get('query');
                        condition.shopName = this.search;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                    
                })
            };
            this.searchBox = this.addTextBox(option);
            option = {
                isHeader:true,
                columns : [{
                        label : '选择区域',
                        onClick : this.selectDistrict
                    }
                    /*{
                        label : '全部',
                        onClick : this.allSelect
                    }, {
                        label : '省',
                        onClick : this.provinceSelect
                    }, {
                        label : '市',
                        onClick : this.citySelect
                    }, {
                        label : '区县',
                        onClick : this.countySelect
                    }*/
                ],
                labelClass : 'font-size1 tab-selector'
            };
            this.conditMenus = this.addColumns(option);
            //添加供货商列表
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight:true,
                onComplete: lang.hitch(this,function(data){
                    for(var i =0; i<data.length; i++){
                        //data.shopType是config下的typeCard，为一串字符串，转换为可读类型
                        array.forEach(config.shopType,function(item){
                            if(data[i].shopType==item.typeCard){
                                data[i].shopType = item.typeName;
                            }
                        });
                        //增加商品数量和销售数量
                        data[i]._label = "<div class='webkit-list'>"
                            +"<div class='user-list-left user-list-margin'>店铺名称:"+(data[i].shopName||"")+"</div>"+"<div class='user-list-margin'>"+"</div></div>"
							+"<div class='webkit-list'>"
							+"<div class='user-list-left user-list-margin'>销量:"+(data[i].saleAmount||'0')+"</div>"
							+"<div class='user-list-margin'>商品数:"+(data[i].shopMatNum||"0")+"</div></div>"
							+"<div class='user-list-left user-list-margin'>销售区域:"+(data[i].tranRegion||'')+"</div>"
							+"<div class='user-list-left user-list-margin'>位置:"+(data[i].town||"")+"</div></div>";
                        data[i]._logo = data[i].logo?data[i].logo:'images/logo.png';
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + this.pageSize-1;
                    this.busy = false; 
                }),
                queryOptions: {
                    count: 20,
                    start: this.start
                },
                itemMap:{
                    _label:"label",
                    _logo:"icon",
                    moveTo:"moveTo"
                }
            });
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            //定义列表所处位置
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            //绑定列表点击事件
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            //绑定列表拖动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        //清空
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        //选择区域
        selectDistrict: function(params) {
            this.params = {};
            params = params && params.data && params.data.provinceId && { province: params.data.provinceId, city: params.data.cityId, county: params.data.countyId } || '';
            //选择完区划之后，自动弹出填写运费的对话框
            districtOverlay.selectDistrict(params,true).then(lang.hitch(this, function(data) {
                if (data.province) {
                    this.params.provinceId = data.province._id;
                    this.conditMenus.childNodes[0].childNodes[1].innerHTML = data.province.distName;
                    if(data.city){
                        this.params.cityId = data.city._id;
                        this.conditMenus.childNodes[0].childNodes[1].innerHTML = data.province.distName+"-"+data.city.distName;
                    }
                    if(data.county){
                        this.params.countId = data.county._id;
                        this.conditMenus.childNodes[0].childNodes[1].innerHTML = data.province.distName+"-"+data.city.distName+"-"+data.county.distName;
                    }
                }else{
                    this.conditMenus.childNodes[0].childNodes[1].innerHTML = "选择区域";
                }
                this.setQuery(this.params);
            }));
        },
        //全部
        allSelect : function(evt){
            this.params = {};
            this.clearSelected();
            this.setQuery(this.params);
        },
        //按省查找
        provinceSelect : function(evt){
            this.params = {};
            this.params.provinceId = "provinceId";
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.setQuery(this.params);
        },
        //按市查找
        citySelect : function(evt){
            this.params = {};
            this.params.cityId = "cityId";
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.setQuery(this.params);
        },
        //区县查找
        countySelect : function(evt){
            this.params = {};
            this.params.countId = "countId";
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.setQuery(this.params);
        },
        onAfterShow: function(){
            //清空商家列表
            this.storeList.destroyDescendants();
            //加载数据
            var queryResult=null;
            if(!this.store){
                this.params= {isVerified:true};
                //字段isVerified没起作用，导致列表中出现未认证的商家
                this.store= new JsonRest({target:shop.getShopByPlatform()});
                //将数据赋值给供应商家列表
                queryResult= this.storeList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                setTimeout(lang.hitch(this,function(){
                    queryResult= this.storeList.setQuery(this.params,{
                        start: this.start,
                        count: this.pageSize
                    });
                    this.onLoadListData(queryResult,this.start,this.pageSize);
                }),300);
            }
        },
        onClickList: function(evt){
            //得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem"){
                return;
            }
            var _id = li.params._id;
            window.moveToView("supplyBus",_id);
        },
        onLoadMore:function(evt){
            //判断this.busy是否为false和下拉方向
            if(!this.busy&&evt.afterBotton){
                this.busy = true;
                //设置本次加载的起始位置
                this.start = this.start+ this.pageSize;
                //判断能否加载更多
                if(this.canLoadMore(this.start)){
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"),{
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }),800);
                }
            }
        },
        setQuery: function(query){
            this.start = 0;
            //清空列表
            this.storeList.destroyDescendants();
            //依据条件加载数据
            var queryResult =this.storeList.setQuery(query,{
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});