define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojox/mobile/View",
        "dojo/dom-construct",
        "dojo/dom-style",
        "dojo/dom-attr",
        "dojo/dom-class",
        "dojo/query",
        "dojo/on",
        "dojox/mobile/EdgeToEdgeStoreList",
		"dijit/registry",
        "cq/ui/view/_ViewMixin",
		"dojo/store/JsonRest",
        "cq/biz/shop/cm/frequentlyPurchasedMat"
    ], function (declare, lang, View, domConstruct, domStyle, domAttr, domClass, query, on, EdgeToEdgeStoreList, registry, _ViewMixin, JsonRest, frequentlyPurchasedMat) {
    return declare("whz.view.AttentionMatList", [View, _ViewMixin], {
        start : 0,
		pageSize : 10,
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        history.back();
                    }
                },
                title : "已购买商品列表"
            };
            this.addHeader(option);
			this.storeList = new EdgeToEdgeStoreList({
                append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){
						data[i]._label="<div class='mat-list-mname mat-list-margin'>" + data[i].mId.mName +
                            "</div><div class='mat-list-price mat-list-margin'>￥" + window.fixedTo(data[i].mId.retailPrice ,3)+
                            "</div><div class='mat-list-qty mat-list-margin'><span>库存：" + window.fixedTo(data[i].mId.qty ,1)+
                            "</span><span class='mat-list-totalSale'>销量：" + window.fixedTo(data[i].mId.totalSale,1) +
                            "</span></div>";
						data[i]._logo = data[i].mId.logo ? data[i].mId.logo : 'images/nomat.png';
						data[i].moveTo="#";
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions: {
					count: this.pageSize,
					start: this.start
					},
				itemMap:{_label:"label",_logo:"icon", moveTo:"moveTo"}
            });
            this.params={};
			this.store = new JsonRest({target:frequentlyPurchasedMat.getLoadUrl()});
			this.storeList.setStore(this.store,this.params);

			this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
        },
        onClickList:function(evt){
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params.mId._id;
			window.moveToView("matDetail",_id);
		},
        onLoadMore:function(evt){
			if(this.busy||(0<this.end&&(this.start+this.pageSize-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多商品");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: this.pageSize
					}), lang.hitch(this,function(){
						this.centerPanel.resize();
					}));
				}), 1000);
			}
		},
		onAfterShow : function () {
			this.setQuery(this.storeList.get("query"),{
				start: 0,
				count: this.pageSize
			});
		},
        setQuery: function(query) {
            this.start = 0;
            this.end = -1;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult, this.start, this.pageSize);
            this.centerPanel.resize();
        },
    });
});