// 变更人员：潘云
// 变更时间：2016/8/10
// 变更内容：用户地址编辑

// 变更人员：母浚驰
// 变更时间：2016/10/21
// 变更内容：用户地址编辑
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/on",
    "dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shop",
    "cq/util/config/config",
    "cq/ui/util/districtOverlay",
    "cq/biz/user/userAddress"
],function(declare, lang, query, on, domClass, View, _ViewMixin, shop, config, districtSelector, userAddress){
    return declare("cq.ui.common.u.UserAddDetail",[View,_ViewMixin],{
        // 检测是否编辑状态
        isEditing : false,
        // 初始化相关接口
        onAfterShow : function () {
            if (!this.isEditing) {
                this.isEditing = true;
                var item = {};
                //供子类传递加载参数
                var addressId = this.getId();
                shop.loadCurrentShop().then(lang.hitch(this, function(result) {
                    //在商家选择了省市县后设为默认并且不能修改
                    if(config.cannotSetProvince && result.data.town && result.data.cityId && result.data.provinceId && result.data.countId){
                        this.connectPro.remove();
                        domClass.add(query(".mblListItemRightIcon",query(".provinceName", this.pageList.domNode)[0])[0],"none");
                        item.provinceId = result.data.provinceId;
                        item.cityId = result.data.cityId;
                        item.countyId = result.data.countId;
                        item.provinceName = result.data.town;
                    }else {
                        if(!this.connectPro){
                            this.connectPro = this.connect(query(".provinceName", this.pageList.domNode)[0], "onclick", this.onPageList);
                        }
                    }
                    if (!addressId) {
                        item.isDefault = true;
                        this.setData(item);
                        this.refreshData();
                    } else {
                        userAddress.loadById(addressId).then(lang.hitch(this, function (data) {
                            if (data && data.data && data.data.item) {
                                item = data.data.item
                            }
                            item.provinceName = item.provinceId.distName + "-" + item.cityId.distName + "-" + item.countyId.distName;
                            this.setData(item);
                            this.refreshData();
                        }));
                    }
                }));
            }
        },
        getId :function () {
            return window.did || '';
        },
        backBtnClick : function (data) {
            history.back();
            this.isEditing = false;
        },
        // 初始化加载显示内容
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : lang.hitch(this, function () {
                        this.backBtnClick();
                    })
                },
                title : "收货地址编辑",
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                "class" : "bottom-margin16",
                lists : [{
                    label: '收货人',
                    edit: {
                        type: 'text',
                        field: 'contactName',
                        placeHolder : '必填',
                    }
                }, {
                    label: '电话',
                    edit: {
                        type: 'text',
                        field: 'tel',
                        placeHolder : '必填',
                    }
                }, {
                    label : '区划',
                    moveTo : "#",
                    'class' : "provinceName",
                    rightText : "{{provinceName}}"
                }, {
                    label : '详细地址',
                    edit : {
                        type : 'text',
                        field : 'detailAddress',
                        placeHolder : "必填"
                    }
                }, {
                    label : '设为默认地址',
                    edit: {
                        type: 'checkbox',
                        field: 'isDefault'
                    }
                }]
            };
            this.pageList = this.addLists(option);
            this.connectPro = this.connect(query(".provinceName", this.pageList.domNode)[0], "onclick", this.onPageList);
            this.onAfterShow();
        },
        onPageList : function (evt) {
            var pageData = this.getData();
            var params = {
                province : pageData.provinceId,
                city : pageData.cityId,
                county : pageData.countyId
            };
            districtSelector.selectDistrict(params).then(lang.hitch(this, function(data) {
                if (data) {
                    pageData.provinceId = data.province;
                    pageData.cityId = data.city;
                    pageData.countyId = data.county;
                    pageData.provinceName = data.province.distName + "-" + data.city.distName + "-" + data.county.distName;
                }
                this.setData(pageData);
                this.refreshData();
            }));

        },

        // 保存数据
        onSaveStore : function () {
            window.busy();
            var pageData = this.getData();
            var msg = this.isMessage(pageData);
            if (msg) {
                window.free();
                alert(msg);
                return;
            }
            userAddress.save(pageData).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1) {
                    this.backBtnClick(data.data.item);
                } else {
                    alert("保存失败");
                }
            }));

        },
        isMessage : function (savaData) {
            if (!savaData.contactName) {
                return "请输入收货人姓名";
            }
            if (!savaData.tel) {
                return "请输入电话";
            }
            if(!savaData.provinceName){
                if (!savaData.provinceId) {
                    return "请选择省";
                }
                if (!savaData.cityId) {
                    return "请选择市";
                }
                if (!savaData.countyId) {
                    return "请选择县";
                }
            }
            if (!savaData.detailAddress) {
                return "请详细地址";
            }
        }
    });
});
