// 变更人员：潘云
// 变更时间：2016/8/10
// 变更内容：用户地址列表

// 变更人员：肖芳圆
// 变更时间：2016/8/11
// 变更内容：提供返回的接口供子类重写
/* 
变更人：张金鹏
变更时间：2016/9/27
变更内容：增加收货地址为空的判断
 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/query",
    "dojo/on",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/userAddress"
],function(declare, lang, domClass, query, on, JsonRest, registry, _WidgetBase, View , EdgeToEdgeStoreList, _ViewMixin, userAddress){
    return declare("cq.ui.common.u.UserAddList",[View,_ViewMixin],{
        // 设置初始显示第0行
        start : 0,
        //设置页面显示条数
        pageSize : 20,
        getQuery : function () {
            var query = {};
            return query;
        },
        setQuery : function () {
            this.start = 0;
            this.storeList.destroyDescendants();
            this.onLoadListData(this.storeList.setQuery(this.getQuery(),{
                start : this.start,
                count : this.pageSize
            }),this.start,this.pageSize);
        },
        onAfterShow : function(){
            if (this.storeList.store) {
                this.setQuery();
            } else {
                this.onLoadListData(this.storeList.setStore(this.store, this.getQuery(), {
                    start : this.start,
                    count : this.pageSize
                }),this.start,this.pageSize);
            }
        },
        //初始化页面元素,绑定事件
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : lang.hitch(this,this.backBtnClick)
                },
                title:"我的收货地址"
            };
            this.addHeader(option);
            option = {
                columns : [{
                    'class': 'flex2 footer-tab-highlight',
					className: 'flex2 footer-tab-highlight',
                    label : '添加收货地址',
                    onClick : lang.hitch(this,function () {
                        this.onEditBtnClick();
                    })
                }],
                labelClass : 'font-size1',
                className : 'fix-footer',
                isFooter : true
            };
            this.footerButton = this.addColumns(option);
            this.creatList();
            this.onAfterShow();
        },
        backBtnClick : function () {
            history.back();
        },
		
		//判断一个对象是否为空
		isEmptyObject : function (obj){
			for(var n in obj){
				return false;
			}
			return true;
		},
		
        getDetailAddress : function (data) {
			if(this.isEmptyObject(data.provinceId)||this.isEmptyObject(data.cityId)){
				return "收货地址不完整或者未填写，请修改收货地址";
			}else{
				return data.provinceId.distName + "-" + data.cityId.distName + "-" +data.countyId.distName + "-" + data.detailAddress;
			}
        },
		
        creatList : function () {
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                "class" : "icon-list-item",
                variableHeight : true,
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i].detailAddress = this.getDetailAddress(data[i]);
                        data[i]._label="<div class='webkit-list'>"
                            +"<div class='address-list-left address-list-item'>收货人:" + (data[i].contactName || "") + "</div>"
                            +"<div class='address-list-left address-list-item'>电话:" + (data[i].tel || "") + "</div>"
                            +"</div><div class='webkit-list'>"
                            +"<div class='address-list-item'>详细地址:" + (data[i].detailAddress || "") + "</div>"
                            +"</div>"
                            +"<div class='forth-btn'>";
                        if (!data[i].isDefault) {
                            data[i]._label = data[i]._label + "<span class='default-address float-right'>设为默认地址</span>";
                        }
                        data[i]._label = data[i]._label + "<span class='edit-address float-right'>编辑</span><span class='delete-address float-right'>删除</span></div>";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                // 查询条件
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{_label:"label",moveTo:"moveTo"}
            });
            this.store = new JsonRest({target : userAddress.getLoadUrl()});
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
        },
        //编辑点击接口
        onEditBtnClick:function (_id) {
            window.moveToView("userAddDetail", _id);
        },
        // 订单列表点击
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = li.params._id;
            var dom = evt.target;
            //编辑
            if(dom && domClass.contains(dom,"edit-address")){
                this.onEditBtnClick(_id);
            }
            //删除
            if(dom && domClass.contains(dom,"delete-address")){
                var isDelete = confirm("确认删除这条地址信息！");
                if (isDelete) {
                    userAddress.deleteById(_id).then(lang.hitch(this, function(data) {
                        if (data.data.ok == 1) {
                            alert("删除成功");
                            this.onAfterShow();
                        } else {
                            alert("删除失败");
                        }
                    }));
                }

            }
            // 设为默认地址
            if (dom && domClass.contains(dom,"default-address")) {
                userAddress.setDefault(_id).then(lang.hitch(this, function (data) {
                    if (data.data.ok == 1) {
                        alert("设置默认地址成功");
                        this.onAfterShow();
                    } else {
                        alert ("设置失败");
                    }
                }));
            }
        },
        // 下拉列表加载更多
        // 重写加载方法
        onLoadMore:function(evt){
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }),this.start,this.pageSize);
                    }), 1000);
                }
            }
        }
    });
});
