// 地址选择对象 20160811 肖芳圆
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/Heading",
    "dojox/mobile/ToolBarButton",
    "dojox/mobile/Pane",
    "cq/ui/view/EditorBase",
    "cq/biz/user/userAddress",
    "cq/ui/common/u/UserAddList",
    "cq/ui/common/u/UserAddDetail"
],function(declare,lang,array,Deferred,domConstruct,domClass,domAttr,ScrollablePane,Heading,ToolBarButton,Pane,EditorBase,userAddress,UserAddList,UserAddDetail){
    var EditorView = declare("", [UserAddDetail], {
        showView : function (refView, id) {
            this._refView = refView;
            this.placeAt(this._refView.domNode,"after");
            this.addressId = id;
            this.show();
            this.resize();
            this._editDef = new Deferred();
            return this._editDef;
        },
        getId : function () {
            return this.addressId || "";
        },
        backBtnClick : function (data) {
            this.isEditing = false;
            this._editDef.resolve(data);
        }
    });
    var ListView = declare("", [UserAddList], {
        showList : function (refView) {
            this._refView = refView;
            this.placeAt(this._refView.domNode,"after");
            this.show();
            this.resize();
            this._editDef = new Deferred();
            return this._editDef;
        },
        backBtnClick : function () {
            this._editDef.resolve();
            this._refView.show();
        },
        onEditBtnClick : function (id) {
            var editorView = new EditorView();
            editorView.showView(this, id).then(lang.hitch(this, function () {
                if(editorView.domNode.parentNode){
                    editorView.domNode.parentNode.removeChild(editorView.domNode);
                }
                this.show();
            }));
        }
    });
    var AddrPick = declare("", [EditorBase], {
        onAfterAddedPane:function(){
            //添加底部的pane
            this.splitter.addChild(this.footerPane = new Pane({
                height:"44px"
            }));
            var footerBtn = domConstruct.toDom('<div class="content-background full-width fix-footer" selectedindex="0"><div class="column-1" style="width:100%;" index="0"><div class="full-width h-center font-size3" style=""><img src="images/icon/mat.png" class="footer-tab-img" ></div><div class="full-width h-center font-size1">添加收货地址</div></div></div>');
            this.footerPane.domNode.appendChild(footerBtn);
            this.connect(footerBtn, "onclick", this.footerBtnClick);
            var header = this.header = new Heading();
            header.placeAt(this.headerPane.domNode, "first");
            var backButton = new ToolBarButton({
                label : "返回",
                class : "float-left",
                arrow : "left",
                onClick : lang.hitch(this, this.cancel)
            });
            backButton.placeAt(header, "first");
            var completeButton = new ToolBarButton({
                label : "管理",
                class : "float-right",
                onClick : lang.hitch(this, this.editAddr)
            });
            completeButton.placeAt(header, "last");
        },
        editAddr : function () {
            var listView = new ListView();
            listView.showList(this).then(lang.hitch(this, function () {
                //地址修改完成后需要刷新
                this.initList();
                if(listView.domNode.parentNode){
                    listView.domNode.parentNode.removeChild(listView.domNode);
                }
            }));
        },
        createContent : function () {
            this.scrollablePane = new ScrollablePane({
                height:"100%"
            });
            this.scrollablePane.placeAt(this.contentPane.domNode,"first");
            this.list = domConstruct.create("ul",{
                "class" : "addr-list"
            }, this.scrollablePane.containerNode);
            this.connect(this.list, "onclick", this.listClick);
        },
        initList : function () {
            domConstruct.empty(this.list);
            userAddress.loadPlatformAddrs().then(lang.hitch(this, function (data) {
                var items = data && data.data && data.data.items || [];
                this.addrs = {};
                array.forEach(items, function (item) {
                    this.addrs[item._id] = item;
                    this.addItem(item);
                }, this);
                this.resize();
            }));
        },
        addItem : function (addr) {
            var item = domConstruct.create("li",{
                "class" : "addr-list-item " + (this.orginValue === addr._id ? "selected" : ""),
                _id : addr._id
            }, this.list);
            domConstruct.create("h5", {
                "class" : "title",
                innerHTML : addr.contactName + "<span style='float:right;'>"+addr.tel+"</span>"
            }, item);
            addr.address = addr.provinceId.distName + addr.cityId.distName + addr.countyId.distName + addr.detailAddress;
            domConstruct.create("p", {
                "class" : "dtl",
                innerHTML : (addr.isDefault ? "<span class='default'>[默认地址]</span>":"") + addr.address
            }, item);
        },
        listClick : function (e) {
            var dom = e.target;
            while (dom && dom.tagName !== "LI" && !domClass.contains(dom,"addr-list")) {
                dom = dom.parentNode;
            }
            if (dom) {
                this.addr = domAttr.get(dom, "_id");
                this.finish();
            }
        },
        footerBtnClick : function () {
            var editorView = new EditorView();
            editorView.showView(this._refView).then(lang.hitch(this, function (data) {
                if (data) {
                    //如果保存完成并传了data则回到orderinfo
                    if(editorView.domNode.parentNode){
                        editorView.domNode.parentNode.removeChild(editorView.domNode);
                    }
                    if(this.domNode.parentNode){
                        this.domNode.parentNode.removeChild(this.domNode);
                    }
                    this.addr = data._id;
                    this._refView.show();
                    this.finish();
                } else {
                    //否则显示当前页面
                    this.show();
                }
            }));
        },
        getValue : function () {
            var value = "";
            if (this.addr) {
                value = this.addr;
            } else {
                value = this.orginValue;
            }
            return value;
        },
        startEdit:function(origin,refView,options){
            this.initList();
            this.orginValue = origin || '';
            return this.inherited(arguments);
        }
    });
    return lang.mixin(lang.getObject("cq.ui.util.addrPick",true),{
        //调用方法
        startEdit:function(oldAddr,refView){
            if(!this.addrPick){
                this.addrPick = new AddrPick();
            }
            var view = this.addrPick;
            view.placeAt(refView.domNode, "after");
            var def = view.startEdit.apply(view,arguments);
            def.then(function(){
                if(view.domNode.parentNode){
                    view.domNode.parentNode.removeChild(view.domNode);
                }
            });
            return def;
        }
    });
});
