﻿// 变更人:徐阿雪
// 变更时间:2016/9/28
// 变更原因:区划详细到乡镇村
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojox/mobile/View",
    "dojox/mobile/SpinWheel",
    "dojox/mobile/SpinWheelSlot",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/bs/district",
    "cq/util/edit/overlay"
], function(declare, lang, array, connect, Deferred, domConstruct, domStyle, domClass, View, SpinWheel, SpinWheelSlot, _ViewMixin, district, overlay) {
    /*对象提供的特性：
    //对外接口：
    1，配置slot，个数和宽度
    2，读取第一个slot的数据
    3，依据前一个slot的选中数据，获取下一个slot的数据
    4，获取_id和label转呗显示的标签
    5、开始选择
    6、结束选择
    1，准备元素，根据params的参数决定
    2，响应事件，滚动，点击确定，取消
    3、开始选择
    4、初始化，依据参数加载数据和显示
    5、显示在overlay里面
    6、点击完成和取消：获取当前的结果，resolve，hide这个overlay
    */
	var SpinWheelView = declare("",[View,_ViewMixin],{
        //滚轮配置项，数组，每个slot的宽度,id，数组，宽度
        slotProps:[],
        slots:null,
        //当前每列的数据
        slotValues:null,
        //私有的一步对象
        _selectDef:null,
        _slotStarted:false,
        //开始选择
        startSelect:function(params){
            this.initSelect.apply(this,arguments);
            //异步操作对象
            if(!this.slots){
                this.createSlots();
            }
            this._selectDef = new Deferred();
            //依据当前数据加载数据，设置数据，设置选中内容
            this.loadRootData().then(lang.hitch(this,function(items){
                items = array.map(items, function(item) {
                    return [item._id, item.distName];
                });
                var slot = this.slots[0];
                slot.params.items = slot.items = items;
                slot.buildRendering();
                slot.init();
                slot.resize();
            }));
            
            overlay.showInOverlay(this.domNode);
            if(!this._slotStarted){
                this._slotStarted = true;
                setTimeout(lang.hitch(this,this.startup),300);
            }
            //返回异步操作对象
            return this._selectDef;
        },
        //初始化界面元素
        createSlots:function(){
            var slot = null;
            //创建滚轮容器
            domStyle.set(this.domNode, "height", "250px");
            if(!this.spinwheel){
                this.spinwheel = new SpinWheel({
                    style: "width:320px;",
                    "class":"districtSpin"
                });
                this.spinwheel.placeAt(this.centerPanel.domNode, "before");
                domStyle.set(this.centerPanel.domNode, "display", "none");
                //创建确定取消按钮
                this.addColumns({
                    columns: [{
                        label: "确认",
                        className: 'flex1 footer-tab-dark h-center',
                        onClick: function() {
                            this.selectFinished();
                        }
                    }, {
                        label: "取消",
                        className: 'flex1 footer-tab-highlight h-center',
                        onClick: function() {
                            this.selectCanceled();
                        }
                    }],
                    forceWidth: false,
                    isFooter: true
                });
            }
            this.slots = [];
            //创建每一个滚轮  slotProp结构obj{_id,label,upId,index,level},index 是哪个位置
            array.forEach(this.slotProps,function(slotProp,index){
                slot = this.createSlot(slot,slotProp,index);
                this.slots.push(slot);
            },this); 
        },
        //创建一个slot
        createSlot:function(upSlot,slotProp,index){
            //需要设置上级的下级，会影响到滚动完成之后的事件处理
            
            //创建slot
            var slot = new SpinWheelSlot({
                style: { textAlign: "center", width: slotProp }
            });
            this.spinwheel.addChild(slot);
            this.connect(slot, "onFlickAnimationEnd", function() {
                //区县可以选择
                if(slot.preventDistScroll){
                    slot.preventDistScroll = false;
                    return;
                }
                this.onSlotScrollEnd(slot);
            });
            //修改上级的属性
            //  若没有上级slot，为第一个
            //  若有上级，上级的下级是新创建的这个
            //  若没有下级，为最后一个
            //slot.onFlickAnimationEnd();*/
            //绑定滚动完成之后的事件处理  传递写一个slot来加载数据
            
            
            return slot;
        },
        //滚动完成之后的事件处理函数
        onSlotScrollEnd:function(slot){
            //若忽略本次滚动
            //  不再忽略下次滚动
            //  返回
            
            //修改slotValues
            //若有下级，加载下级数据，设置下级的slot
            
        },
        //完成选择
        selectFinished:function(){
            //获取当前选中的数据
            //隐藏overlay
            //返回内容
            overlay.hide();
            this._selectDef.resolve(this.getSelectedValue());
        },
        //取消选择
        selectCanceled:function(){
            //获取修改之前的数据
            //隐藏overlay
            //返回内容
            overlay.hide();
            this._selectDef.resolve(this.getOriginValue());
        },
        
        //以下接口需要重写，直接通过实例化本对象来实现功能
        //初始化原始数据。slotValues等
        initSelect:function(){
            
        },
        //获取第一列的数据   测试加载省
        loadRootData:function(){
            
        },
        //依据上级ID加载数据
        loadDataByUpper:function(upId){
            
        },
        //获取编辑之后的数据
        getSelectedValue:function(){
            
        },
        //获取编辑之前的数据
        getOriginValue:function(){
            
        }
    });
    var distributeView = new SpinWheelView({
		slotProps:[{
			width:"100px"
		},{
			width:"100px"
		},{
			width:"100px"
		}],
		initSelect:function(params,enableAll){
			this.slotValues = [params.province,params.city,params.county];
		},
		loadRootData:function(){
			//测试加载省的数据
            if(!this.slotValues[0]){
                return district.loadByLevel(2).then(lang.hitch(this, function(data) {
                    data = data && data.data && data.data.items || [];
                    return data;
                }));
            }
		},
		loadDataByUpper:function(upId){
			return district.loadByUpId(upId).then(lang.hitch(this, function(data) {
                data = data && data.data && data.data.items || [];
                return data;
            }));
		},
		getSelectedValue:function(){
			
		},
		getOriginValue:function(){
			
		}
	});
	distributeView.selectDistrict = distributeView.startSelect;
    lang.setObject("cq.ui.util.districtO",distributeView);
    return distributeView;
});