﻿// 张松   市县可以不选      2016/08/16

define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "cq/biz/shop/bs/district",
    "./SpinView"
], function(lang, array, Deferred, district, SpinView) {
    var distributeView = new SpinView({
        slotProps:[{
            width:"100px"
        },{
            width:"100px"
        },{
            width:"100px"
        }],
        initSelect:function(params,enableAll){
            this.districtHash = this.districtHash||{};
            this.oldValue = params;
            this.slotValues = params?[params.province,params.city,params.county]:[null,null,null];
            this.enableAll = !!enableAll;
        },
        //获取编辑之后的数据
        getSelectedValue:function(){
            return {
                province:this.getTargetData(this.slotValues[0]),
                city:this.getTargetData(this.slotValues[1]),
                county:this.getTargetData(this.slotValues[2])
            };
        },
        //获取编辑之前的数据
        getOriginValue:function(){
            return this.oldValue;
        },
        //获取第一列的数据
        loadRootData:function(){
            var def = null,data = this.districtHash["2"];
            if(data&& data.data && data.data.items&&data.data.items.length){
                def = new Deferred();
                def.resolve(data);
            }else{
                def = district.loadByLevel(2);
            }
            return def.then(lang.hitch(this,function(data){
                return this.onDistDataReady(data,"2");
            }));
        },
        //依据上级ID加载数据
        loadDataByUpper:function(upId){
            if(upId&&"undefined"!=typeof(upId._id)){
                upId = upId._id;
            }
            var def = null,data = this.districtHash[upId];
            if(!upId){
                def = new Deferred();
                def.resolve({});
            }else if(data&& data.data && data.data.items&&data.data.items.length){
                def = new Deferred();
                def.resolve(data);
            }else{
                def = district.loadByUpId(upId);
            }
            return def.then(lang.hitch(this,function(data){
                return this.onDistDataReady(data,upId);
            }));
        }
    });
    distributeView.selectDistrict = function(params, enableAll) {
        return this.startSelect(params,enableAll);
    };
    distributeView.onDistDataReady = function(data,upId){
        this.districtHash[upId] = data;
        data = data && data.data && data.data.items || [];
        if(data.length&&(!data[0].label)){
            array.forEach(data,function(item){
                item.label = item.distName;
            });
        }
        return (this.enableAll?[{
            _id:"",
            label:"2"==upId?"全国":"全部"
        }]:[]).concat(data);
    };
    lang.setObject("cq.ui.util.districtOverlay",distributeView);
    return distributeView;
});
