﻿// 变更人:徐阿雪
// 变更时间:2016/9/28
// 变更原因:区划详细到乡镇村
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojox/mobile/View",
    "dojox/mobile/SpinWheel",
    "dojox/mobile/SpinWheelSlot",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/bs/district",
    "cq/util/edit/overlay"
], function(declare, lang, array, connect, Deferred, domConstruct, domStyle, domClass, View, SpinWheel, SpinWheelSlot, _ViewMixin, district, overlay) {
    var DistributeView = declare("", [View, _ViewMixin], {
        enableAll: false,
        //各级的名字
        initDistrictName:"",
        //显示在label上的内容
        districtValue:"",
        //各级所放的Slot
        districtSlot:"",
        //
        _getValueByKey:function(datas,key){
            for(var i=0;i<datas.length;i++){
                if(key===datas[i]._id){
                    return datas[i].distName;
                }
            }
            return "";
        },
        //选择区划 第一级
        selectDistrict:function(params, enableAll){
            //根据行数创建列数不同的
            this.getColumns(params);
            //判断页面是否初始化
            
            /*if (!this.spinWheelName) {
                this.getColumns(params);
                //初始化页面元素和事件
                this.createSpinWheelElement();
                //this.getColumns(params);
            }*/
            var def = new Deferred();
            this._selectDef = def;
            //记录参数中的原始数据  改变还不确定
            this.oldProvince = this.province = params && params.province || null;
            this.oldCity = this.city = params && params.city || null;
            this.oldCounty = this.county = params && params.county || null;
            this.enableAll = !!enableAll;
            //有可能详细到村级，村级没有数据
            if(params.town){
                this.oldTown = this.town = params && params.town || null;
                this.oldVillage = this.village = params && params.village || null;
            }
            //加载第一条数据
            //this.loadDistrict(province,city);
            for(var i=0;i<Object.keys(params).length;i++){
                this.loadDistrict(Object.keys(params)[i],Object.keys(params)[i+1]);
                this.initDistrict(Object.keys(params)[i],Object.keys(params)[i+1]);
            }
           // this.initDistrictLast();
            this.setTimeOutMsg();
            overlay.domNode.innerHTML = "";
            this.placeAt(overlay.domNode);
            overlay.show();
            return def;
            //
        },
        //判断具体显示几列的问题
        getColumns:function(params){
            //Object.keys(params).length长度
            //Object.keys(params)[0]第一个值
            if(Object.keys(params).length>3){
                if(!this.spinWheelName1){
                    this.createWheel(2);
                    this.createSpinWheelElement(params);
                }
            }else{
                if(!this.spinWheelName){
                    this.createWheel(1);
                    this.createSpinWheelElement(params);
                }
                
            }
        },
        //加载数据 第一条数据
        loadDistrict:function(districtName,nextDistrictName){
            this.loadDistrictData(2).then(lang.hitch(this,function(districtData){
                districtDatas = districtData;
                districtValue = this._getValueByKey(districtData,this.districtName&&this.districtName._id||this.districtName||"");
                this.districtName = this.districtName||districtData[0];
                //初始下一级的数据
                this.loadDistrictData(this.districtName._id).then(nextDistrictName);
            }));
        },
        //初始化个级区划的内容
        initDistrict:function(districtName,nextDistrictName){
            initDistrictName = lang.hitch(this,function(districtData){
                districtDatas = districtData;
                this.districtName = this.districtName||districtData[0];
                districtValue = this._getValueByKey(districtData,this.districtName&&this.districtName._id||this.districtName||"");
                //初始下一级的数据
                this.loadDistrictData(this.districtName._id).then(nextDistrictName);
            });
        },
        //初始化最后一级数据
        initDistrictLast:function(districtName){
            this.districtName = this.districtName||districtData[0];
            districtValue = this._getValueByKey(districtData,this.districtName&&this.districtName._id||this.districtName||"");
        },
        //超时提示  具体不知道是做什么的,保存什么的额么
        setTimeOutMsg:function(districtName){
            setTimeout(lang.hitch(this,function(){
                this.districtSlot.adjust();
                this.initSlot(districtDatas,districtName,false);
                this.districtSlot.preventDistScroll = true;
                this.districtSlot.set("value",districtValue);
            }));
        },
        //穿件滚轮
        createWheel:function(num){
            //设置当前view的高度
            domStyle.set(this.domNode, "height", "250px");
            //创建滚轮容器
            //根据数量创建多个滚轮
            this.spinWheelName= new SpinWheel({
                style: "width:320px;",
                "class":"districtSpin"
            });
            if(num!=1){
                this.spinWheelName1= new SpinWheel({
                    style: "width:320px;",
                    "class":"districtSpin"
                });
                this.spinWheelName1.placeAt(this.centerPanel.domNode, "before");
            }
            this.spinWheelName.placeAt(this.centerPanel.domNode, "before");
            domStyle.set(this.centerPanel.domNode, "display", "none");
        },
        //创建界面元素
        createSpinWheelElement:function(params){
            //this.createWheel();
            //依据params添加个区划的滚草
            this.createDistrict(params);
            //添加底部确定和取消按钮
            this.addColumns({
                columns: [{
                    label: "确认",
                    className: 'flex1 footer-tab-dark h-center',
                    onClick: function() {
                        this.onSelectFinished();
                    }
                }, {
                    label: "取消",
                    className: 'flex1 footer-tab-highlight h-center',
                    onClick: function() {
                        this.onConcelSelect();
                    }
                }],
                forceWidth: false,
                isFooter: true
            });
        },
        //侦听滚动完成的事件
        //创建个区划级别的滚轮槽
        createDistrict:function(districtName){
            districtSlot=districtName+"Slot";
            this.districtSlot = new SpinWheelSlot({
                style: { textAlign: "center", width: "100px"}
            });
            this.spinWheelName.addChild(this.districtSlot);
            this.connect(this.districtSlot, "onFlickAnimationEnd", function() {
                if(this.districtSlot.preventDistScroll){
                    this.districtSlot.preventDistScroll = false;
                    return;
                }
                this.onSlotChanged("districtName");
            });
        },
        //点击事件
        //完成选择事件
        onSelectFinished: function() {
            overlay.hide();
            this._selectDef.resolve(/*this.selectMode==="3"?{
                province: this.province,
                city: this.city,
                county: this.county
			}:*/{
                province: this.province,
                city: this.city,
                county: this.county,
                town: this.town,
                village:this.village
            });
        },
        //取消选择事件
        onConcelSelect: function() {
            overlay.hide();
            this._selectDef.resolve(/*this.selectMode==="3"?{
                province: this.oldProvince,
                city: this.oldCity,
                county: this.oldCounty
			}:*/{
                province: this.oldProvince,
                city: this.oldCity,
                county: this.oldCounty,
                town: this.oldTown,
                village:this.oldVillage
            });
        },
        initValueBySlot: function(tp) {
            this[tp] = null;
            array.some(this[tp + "Arr"], function(item) {
                if (this[tp + "Slot"].get("key") == item._id) {
                    this[tp] = item;
                    return true;
                }
            }, this);
        },
        //滚动完成响应
        onSlotChanged: function(tp) {
            var old = this[tp];
            this.initValueBySlot(tp);
            if(old===null&&this[tp]===null||old&&this[tp]&&this[tp]&&old._id===this[tp]._id){
                return;
            }
            //添加乡镇村
            var ntp = "province" === tp ? "city" : "city" === tp ? "county" : "county" === tp ? "town" : "town" === tp ? "village" : "";
            if (ntp) {
                if (this[tp]) {
                    this.loadDistrictData(this[tp]._id).then(lang.hitch(this, function(districts) {
                        this.initSlot(districts, ntp, true);
                    }));
                } else {
                    this.initSlot([], ntp, true);
                }
            }
        },
        initSlot: function(items, tp, autoChange) {
            var slot = this[tp+"Slot"];
            this[tp+"Arr"] = items;
            var slotItems = array.map(items, function(item) {
                return [item._id, item.distName];
            });
            if (this.enableAll&&tp!=="province") {
                slotItems.unshift(["", "全部"]);
            }
            slot.domNode.innerHTML = "";
            slot.params.items = slot.items = slotItems;
            slot.buildRendering();
            slot.init();
            slot.resize();
            if (autoChange) {
                if (slot.items.length) {
                    slot.set("value", slot.items[0][1]);
                } else {
                    slot.set("value", "");
                }
                slot.onFlickAnimationEnd();
            }
        },
        districtHash:{},
        //加载数据的方法
        loadDistrictData: function(parentDistrictId) {
            parentDistrictId = parentDistrictId || 2;
            if(this.districtHash[parentDistrictId]){
                var def = new Deferred();
                def.resolve(this.districtHash[parentDistrictId]);
                return def;
            }
            return district[2===parentDistrictId?"loadByLevel":"loadByUpId"](parentDistrictId).then(lang.hitch(this, function(data) {
                data = data && data.data && data.data.items || [];
                this.districtHash[parentDistrictId] = data;
                return data;
            }));
        },
    });
    var distributeView = new DistributeView();
    lang.setObject("cq.ui.util.districtOverlay",distributeView);
    return distributeView;
});