﻿define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "cq/biz/shop/bs/district",
    "./SpinView"
], function(lang,array,Deferred,district,SpinView){
    var villageView = new SpinView({
        slotProps:[{
            width:"150px"
        },{
            width:"150px"
        }],
        //初始化原始数据
        initSelect:function(params,enableAll){
            this.villageHash = this.villageHash || {};
            this.oldValue = params;
            this.slotValues = params?[params.town,params.village]:[null,null];
            this.enableAll = !!enableAll;
        },
        //获取编辑之后的数据
        getSelectedValue:function(){
            return {
                county:this.oldValue.county,
                town:this.getTargetData(this.slotValues[0]),
                village:this.getTargetData(this.slotValues[1])
            };
        },
        //获取编辑之前的数据
        getOriginValue:function(){
            return this.oldValue;
        },
        //获取第一列的数据
        loadRootData:function(){
            return this.loadDataByUpper(this.getDataKey(this.oldValue.county));
        },
        //依赖上级ID加载数据
        loadDataByUpper:function(upId){
            if(upId&&"undefined"!=typeof(upId._id)){
                upId = upId._id;
            }
            var def = null,data = this.villageHash[upId];
            if(!upId){
                def = new Deferred();
                def.resolve({});
            }else if(data&& data.data && data.data.items&&data.data.items.length){
                def = new Deferred();
                def.resolve(data);
            }else{
                def = district.loadByUpId(upId);
            }
            return def.then(lang.hitch(this,function(data){
                return this.onDistDataReady(data,upId);
            }));
            
        }
    });
    villageView.selectVillage = function(params, enableAll){
        return this.startSelect(params,enableAll);    
    };
    villageView.onDistDataReady = function(data,upId){
        this.villageHash[upId] = data;
        data = data && data.data && data.data.items || [];
        if(data.length&&(!data[0].label)){
            array.forEach(data,function(item){
                item.label = item.distName;
            });
        }
        return (this.enableAll?[{
            _id:"",
            label:"2"==upId?"全国":"全部"
        }]:[]).concat(data);
    };  
    lang.setObject("cq.ui.util.villageOverlay",villageView);
    return villageView;
});