﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojox/mobile/View",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
    "dojox/mobile/Heading",
    "dojox/mobile/ToolBarButton"
],function(declare,lang,Deferred,View,FixedSplitter,Pane,Heading,ToolBarButton){
    return declare("cq.ui.view.EditorBase",View,{
        buildRendering : function() {
          this.inherited(arguments);
          this.domNode.style.height = "100%";
          this.addChild(this.splitter = new FixedSplitter({
              variablePane:1,
              orientation:"V"
          }));
          this.splitter.addChild(this.headerPane = new Pane());
          // 中间区域不能使用ScrollablePane ，否则contenteditable属性失效
          this.splitter.addChild(this.contentPane = new Pane());
          this.onAfterAddedPane();
          this.createContent();
        },
        onAfterAddedPane:function(){
          var header = this.header = new Heading();
          header.placeAt(this.headerPane.domNode, "first");
          var backButton = new ToolBarButton({
            label : "返回",
            class : "float-left",
            arrow : "left",
            onClick : lang.hitch(this, this.cancel)
          });
          backButton.placeAt(header, "first");
          var completeButton = new ToolBarButton({
            label : "完成",
            class : "float-right",
            onClick : lang.hitch(this, this.finish)
          });
          completeButton.placeAt(header, "last");
        },
        createContent:function(){
        },
        cancel : function() {
          this._editDef.resolve(this.orginValue);
          this._refView.show();
        },
        finish : function() {
          this._editDef.resolve(this.getValue());
          this._refView.show();
        },
        getValue:function(){
        },
        setOrigin:function(text){
        },
        startEdit : function(text, refView) {
          this.orginValue = text || "";
          this._refView = refView;
          this.setOrigin(this.orginValue);
          this.placeAt(this._refView.domNode,"after");
          this.show();
          this.resize();
          this._editDef = new Deferred();
          return this._editDef;
        }
    });
});