﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "dojox/mobile/SearchBox",
    "dojox/mobile/ToolBarButton",
    "./ListView"
],function(declare,lang,array,domConstruct,domStyle,on,when,JsonRest,SearchBox,ToolBarButton,ListView){
    return declare("cq.ui.view.JsonStoreListView",ListView,{
        //列表项的高度默认确定
        variableHeight:false,
        //store取数据的目标地址
        target:"#",
        //默认的查询条件
        query:{},
        //默认的查询选项——分页信息
        queryOptions:{
            count:20,
            start:0
        },
        searchField:"",
        labelField:"",
        // 张松  所引用的类型的编辑界面id  2016/06/15
        addPageId:"",
        // 张松    2016/06/15
        getDataLabel:null,
        //最后一行的行号
        end:-1,
        //加载中的标志
        busy:false,
        //处理scrollPane的拖动刷新操作
        onAfterAddedPane:function(){
            var formNode = domConstruct.create("form",{
                action:"#"
            },this.headerPane.domNode,"last");
            formNode.onsubmit = function(){
                return false;
            };
            this.searchBox = new SearchBox({
                "class":"full-width cqSearchBox",
                onSearch:lang.hitch(this,this.onSearch)
            });
            this.searchBox.placeAt(formNode,"last");
            this.inherited(arguments);
            // 张松  添加数据按钮  2016/06/15
            var addNewRefButton = this.addNewRefButton = new ToolBarButton({
                label : "+",
                class : "float-right font-size5",
                onClick : lang.hitch(this, function(){
                    window.moveToView(this.addPageId);
                    if(this.addEndConnect){
                        this.addEndConnect.remove();
                    }
                    this.addEndConnect = this.connect(window.viewParam[this.addPageId], "onAfterTransitionOut", lang.hitch(this, function(){
                        // 解决如果点击添加按钮之后没有做添加操作，返回时也选中第一个选项的问题
                        var options = this.optionList.getChildren();
                        this.setQuery({
                            isUse:true
                        }).then(lang.hitch(this, function(){
                            //setTimeout(lang.hitch(this, function(){
                                var children = this.optionList.getChildren();
                                if((!options || !options.length) && (!children || !children.length) || (options&&options.length&&options.length == children.length)){
                                }else{
                                    this.optionList.getChildren()[0].set("checked", true);
                                }
                                this.placeAt(pane);
                                this.show();
                            //}), 300);
                        }));
                        this.addEndConnect.remove();
                    }));
                })
            });
            addNewRefButton.placeAt(this.header, "last");
            var clearButton = new ToolBarButton({
                label:"清空",
                class : "float-right",
                onClick:lang.hitch(this,function(){
                    this.selectedItem = null;
                    this.finish();
                })
            });
            clearButton.placeAt(this.header, "last");
            domStyle.set(this.addNewRefButton.domNode, "display", this.addPageId?"":"none");
            this.own(on(this.scrollablePane,"afterscroll",lang.hitch(this,this.loadNextPage)));
        },
        //生成EdgeToEdgeStoreList需要的参数
        getListParam:function(){
            return lang.mixin(this.inherited(arguments),{
                append: true,
                constraint: false,
                query:this.query||{},
                "class":"icon-list-item",
                variableHeight:this.variableHeight,
                queryOptions:this.queryOptions||{
                    count: 10,
                    start: 0
                },
                store:this.createStore()
            });
        },
        onSearch:function(){
            this.setQuery(this.initQuery());
        },
        initQuery:function(){
            var query = lang.clone(this.query);
            if(this.searchField&&this.searchBox){
                query[this.searchField] = this.searchBox.get("value");
            }
            return query;
        },
        _searchTimer:null,
        setQuery:function(query){
            clearTimeout(this._searchTimer);
            this._searchTimer = setTimeout(lang.hitch(this,function(){
                this.queryOptions.start = 0;
                this.end = -1;
                // this.optionList.append = false;
                this.optionList.destroyDescendants(false);
                return this.optionList.setQuery(query,this.queryOptions);
            }),300);
        },
        onDataLoaded:function(datas){
            //处理最后一行
            this.end += datas.length;
            //处理加载中标志
            this.busy = false;
            if(this.labelField){
                var _id = this.selectedItem&&this.selectedItem.params&&this.selectedItem.params._id;
                array.forEach(datas,function(item){
                    // 张松  如果不传入数据加载完成之后的处理函数，则按照原来的方案处理,如果需要配置多列显示，则需要传入处理函数，函数参数为返回数据，函数中可以修改label的值  2016/06/15
                    if(!this.getDataLabel){
                        item.label = item[this.labelField];
                    }else{
                        item.label = this.getDataLabel(item);
                    }
                    if(_id&&_id==item._id){
                        item.checked = true;
                    }
                },this);
            }
        },
        createStore:function(){
            return this.store||new JsonRest({
                target:this.target||"#"
            });
        },
        getValue:function(){
            
            if(this.multiselect){
                if(this.selectedItem){
                    return this.selectedItem.length?this.selectedItem:null;    
                }else{
                    return null;
                }
            }else{
                return this.selectedItem&&this.selectedItem.params||null;    
            }
            
        },
        setOrigin:function(param){
            this.selectedItem = null;
            if(param&&param._id){
                this.selectedItem = {
                    params:param
                };
                this.isAdding = true;
                array.some(this.optionList.getChildren(),function(item){
                    if(item.params._id==param._id){
                        item.set("checked",true);
                        return true;
                    }
                },this);
                this.isAdding = false;
            }
        },
        initList:function(options){
            this.searchBox.set("value","");
            if(false===this.__firstLoad){
                this.onSearch();
            }
            this.__firstLoad = false;
        },
        //加载下一页数据
        loadNextPage:function(evt){
            if(this.busy||(0<this.end&&(this.queryOptions.start+this.queryOptions.count-1>this.end))){
                return true;
            }
            if(evt.afterBottom){
                this.queryOptions.start = this.end+1;
                console.log("加载更多商品");
                this.busy = true;
                setTimeout(lang.hitch(this,function(){
                    when(this.optionList.setQuery(this.optionList.get("query"), this.queryOptions), lang.hitch(this,function(){
                        this.resize();
                    }));
                }), 1000);
            }
        }
    });
});