﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/store/Memory",
    "dojo/store/Observable",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/EdgeToEdgeStoreList",
    "./EditorBase"
],function(declare,lang,array,domConstruct,Memory,Observable,ScrollablePane,EdgeToEdgeStoreList,EditorBase){
    return declare("cq.ui.view.ListView",EditorBase,{
        isAdding:false,
        //selectedItem:[],
        onAfterAddedPane:function(){
            this.inherited(arguments);
            this.scrollablePane = new ScrollablePane({
                height:"100%"
            });
            this.scrollablePane.placeAt(this.contentPane.domNode,"first");
            this.store = this.createStore();
            this.optionList = new EdgeToEdgeStoreList(this.getListParam());
            this.optionList.placeAt(this.scrollablePane.containerNode,"first");
        },
        getListParam:function(){
            var onDataLoaded = lang.hitch(this,this._onDataLoaded);
            return {
                
                select:this.multiselect==="multiselect"?"multiple":"single",
                //select:"single",
                store:this.store,
                query:this.getQueryOption(),
                onComplete:function(datas){
                    onDataLoaded(datas);
                    //生成列表项
                    this.generateList(datas);
                    this.append = true;
                },
                createItem:lang.hitch(this,this.createItem),
                onCheckStateChanged:lang.hitch(this,this.onItemStateChange)
            };
        },
        //数据加载成功之后，对数据做处理，如修改显示内容等
        _onDataLoaded:function(datas){
			if(datas.data){
				datas = datas.data;
			}
			if(datas.items){
				datas = datas.items;
			}
			datas = datas||[];
            array.forEach(datas,function(data){
                data.onClick = function(){
                    if(this.get("checked")){
                        this.set("checked",false);
                        this.set("checked",true);
                        return false;
                    }
                };
            });
            //自定义处理数据接口
            this.onDataLoaded(datas);
        },
        onDataLoaded:function(datas){},
        getQueryOption:function(){
            return {
                text:"*"
            };
        },
        createStore:function(){
            return this.store||Observable(this.realStore = new Memory({}));
        },
        //createItem:function(item){
        //    this.inherited(arguments);
        //},
        onItemStateChange:function(item,checked){
            if(this.multiselect==="multiselect"){
                if(this.selectedItem&&this.selectedItem.length){
                    for(var i=0;i<this.selectedItem.length;i++){
                        if(this.selectedItem[i]===item){
                            this.selectedItem.splice(i,1);
                        }
                    }
                    this.selectedItem.push(item);
                }else{
                    this.selectedItem = [];
                    this.selectedItem.push(item);;  
                }
            }else{
                this.selectedItem = item;
                if(checked&&false===this.isAdding){
                    this.finish();
                }
            }
            
        },
        getValue:function(){
            return "";
        },
        setOrigin:function(key){
            this.selectedItem = null;
            this.isAdding = true;
            if(!array.some(this.optionList.getChildren(),function(item){
                if(item.params.key==key){
                    item.set("checked",true);
                    return true;
                }
            },this)){
                this.selectedItem = {
                    params:{
                        key:key
                    }
                };
            }
            this.isAdding = false;
        },
        initList:function(){},
        startEdit:function(origin,refView,options){
            this.initList(options);
            return this.inherited(arguments);
        }
    });
});