//  变更人:肖芳圆
//  变更时间:2016/5/17
//  变更原因:需要货架的公共基类

//  变更人:肖芳圆
//  变更时间:2016/6/21
//  变更原因:锁定到头部的楼层需要放在头部节点中

//  变更人:肖芳圆
//  变更时间:2016/7/7
//  变更原因:1.清空楼层的方法堆栈溢出
//          2.楼层添加完成后需要resize();

//  变更人:肖芳圆
//  变更时间:2016/7/6
//  变更原因:1.陈列位的类型是商品的时候去加载商品的信息,显示到页面

//  变更人:肖芳圆
//  变更时间:2016/7/11
//  变更原因:1.供需类型的橱窗,头部不同

//  变更人:肖芳圆
//  变更时间:2016/7/13
//  变更原因:1.陈列位的类型是商品,且是同一个商品的时候,除了第一个商品其他显示错误的问题

//  变更人:肖芳圆
//  变更时间:2016/7/14
//  变更原因:1.陈列位的类型是商品,但没有商品id的时候会出bug
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/DeferredList",
    "dojo/Deferred",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "cq/biz/mat/mat"
], function (declare, lang, array, DeferredList, Deferred, EdgeToEdgeList, ListItem, mat) {
    return declare("cq.ui.view._ShelfMixin", null, {
        _destroyFloorItem : function (shelfItem) {
            //死循环了
            //shelfItem = this.shelfItems;
            if (shelfItem.destroyRecursive) {
                shelfItem.destroyRecursive();
            } else if (shelfItem.domNode && shelfItem.domNode.parentNode) {
                shelfItem.domNode.parentNode.removeChild(shelfItem.domNode);
            } else if (shelfItem.parentNode) {
                shelfItem.parentNode.removeChild(shelfItem);
            } else if (shelfItem.length) {
                for (var index = 0;index < shelfItem.length;index++){
                    this._destroyFloorItem(shelfItem[index]);
                }
            }
        },
        //创建shelf
        createShelf : function(data) {
            var defList = [];
            if(this.shelfItems){
                for(var index=0;index<this.shelfItems.length;index++){
                    this._destroyFloorItem(this.shelfItems[index]);
                }
            }
            this.shelfItems = [];
            //商品陈列位的商品id
            var matIds = [];
            //存商品信息的对象
            var mats = {};
            //取到需要加载的商品id
            array.forEach(data.floors, function (floor) {
                array.forEach(floor.boxes,function (box, boxIndex) {
                    //商品陈列位
                    if (box.type == "1" && box.mat) {
                        matIds.push(box.mat);
                    }
                });
            });
            //有商品类型的橱窗,去取商品的数据
            if (matIds.length > 0) {
                var def = new Deferred();
                defList.push(def);
                mat.loadByIds(matIds).then(lang.hitch(this, function (matDatas) {
                    if (matDatas && matDatas.data && matDatas.data.items) {
                        array.forEach(matDatas.data.items, function (matData) {
                            mats[matData._id] = matData;
                        });
                    }
                    def.resolve();
                }));
            }
            return new DeferredList(defList).then(lang.hitch(this, function () {
                array.forEach(data.floors, function (floor) {
                    //1.处理显示标题,显示图片的问题 2.处理商品橱窗的显示
                    array.forEach(floor.boxes, function (box) {
                        //处理是否显示图片的
                        if(!box.showPrc){
                            box.icon = '';
                        }
                        //处理是否显示
                        if (!box.showTitle) {
                            box.title = '';
                        }
                        if (box.type == 1) {
                            var boxMat = mats[box.mat];
                            box.title = "<div class='shelf-mat-title'>"+boxMat.mName+"</div>";
                            box.title+= "<div class='shelf-mat-price-normal'>"+"¥"
                            +window.fixedTo(boxMat.retailPrice,3)+"</div>";
                            box.title+= "<div class='shelf-mat-title'>"+"规格:"+boxMat.sizeType+"</div>";
                        }
                    });
                    this.createFloor(floor);
                },this);
                //添加完成后应该resize()整个页面;
                this.resize();
            }));
        },
        //根据楼层类型创建陈列位
        createFloor:function (floor) {
            //图片滚动器
            if (floor.floorType == 'slideShow') {
                this.shelfItems.push(this.addSlideShow(floor));
            }
            //头部
            else if (floor.options.position==="top") {
                var topNode = this.addShelfColumn(floor);
                this._headerPane.domNode.appendChild(topNode.domNode);
                this.resize();
                this.shelfItems.push(topNode);
            }
            //底部
            else if(floor.options.position==="bottom"){
                var boxs = [];
                array.forEach(floor.boxes,function (box) {
                    boxs.push({
                        icon:box.icon,
                        label:box.title,
                        iconClass: 'footer-tab-img',
                        className:'footer-tab-col-normal',
                        onClick:function () {
                            location.href = box.url;
                        }
                    });
                });
                var footerData = {
                    columns:boxs,
                    labelClass: 'font-size1',
                    className: 'fix-footer',
                    //设置成底部，不设置此属性则跟着上面的模块一次添加
                    isFooter: true
                };
                this.shelfItems.push(this.addColumns(footerData));
            }
            else if(floor.data && floor.data.provider){
                var groupHeaderData = null;
                if (floor.data.provider === "cq/biz/mat/mat") {
                    //商品橱窗
                    groupHeaderData={
                        boxes: [{
                            icon:"http://w.cqthink.com/w/Content/standardTmp01/images/more11.png",
                            url: "#matList",
                            rightText: "更多",
                            title: floor.data.action === "loadAsBoxes" ? "最热商品" :(floor.data.action === "loadRecommendMat" ? "推荐商品":"商品"),
                            className: "matList"
                        }]
                     };
                     this.shelfItems.push(this.addGroupHeader(groupHeaderData));
                } else if(floor.data.provider === "cq/biz/ts/sc/supply_demand"){
                    //供求信息橱窗
                    // groupHeaderData={
                    //     boxes: [{
                    //         icon:"http://w.cqthink.com/w/Content/standardTmp01/images/more11.png",
                    //         url: "#supplyDemandList",
                    //         rightText: "更多",
                    //         title: "供需信息"
                    //     }]
                    //  };
                }
                //this.shelfItems.push(this.addGroupHeader(groupHeaderData));
                floor.data.params = JSON.parse(floor.data.params);
                this.shelfItems.push(this.addShelfColumn(floor));
            }
            //其它
            else {
                this.shelfItems.push(this.addShelfColumn(floor));
            }
        }
    });
});
