define([
    "dojo/_base/declare",
    "dijit/registry",
	"dojo/_base/lang",
	"cq/biz/article/news",
	"cq/biz/article/article",
    "dojo/Deferred",
    "cq/util/sys/date",
    "cq/biz/shop/shop"
], function(declare, registry, lang, newsL, article, Deferred, date, shop) {
    return declare("cq.ui.w.a.News", null, {
        indexNewsElement: function() {
            this.news = registry.byId("News");
        },
        getCurrentShop:function(){
            this._currentShopDef = new Deferred();
            shop.loadCurrentShop().then(lang.hitch(this,function(data){
                this._currentShopDef.resolve(data);
            }));
            return this._currentShopDef;
        },
        refreshAllList: function() {
            this.getCurrentShop().then(lang.hitch(this,function(shopData){
                article.loadById(window.did).then(lang.hitch(this, function(data){
                    var item = data.data.item;
                    item.lastMod = item.lastMod?date.formatISODate(item.lastMod):"";
                    if(g_s.dateDiff('y',item.lastMod,g_s.getDate())<1){							
                        item.lastMod = item.lastMod.split(" ")[0].split("-")[1]+"-"+item.lastMod.split(" ")[0].split("-")[2];
                    }
                    item.shopName = shopData.data.shopName;
                    var newData = {};
                    newData.data = {};
                    newData.data.items = [];
                    newData.data.items.push(data.data.item);
                    this.news.onDataReady(newData);
                }));
            }));
        }
    });
});