define([
    "dojo/_base/declare",
    "dijit/registry",
	"dojo/_base/lang",
    "dojo/query",
    "dojo/dom-attr",
	"cq/biz/article/news",
	"cq/biz/article/article",
    "cq/util/sys/date",
    "dojo/_base/array",
    "cq/biz/shop/shop",
    "dojo/Deferred"
], function(declare, registry, lang, query, domAttr, news, article, date, array, shop, Deferred) {
    return declare("cq.ui.w.a.NewsList", null, {
        indexNewsListElement:function(){
            this.newsList = registry.byNode(query(".newsList",this.domNode)[0]);
        },
        initNewsListEvent:function(){
            if(!this.pageSelectEvent){
                this.pageSelectEvent = this.connect(query(".pager_page",this.domNode)[0],"onclick",function(e){
                    var dom=e.target;
                    if(dom.tagName=="SPAN"){
                        if (e && e.target && -1 < domAttr.get(e.target, "name")) {
                            var pageIndex = parseInt(domAttr.get(e.target, "name"));
                            if (pageIndex > -1) {
                                this.refreshNewsList(pageIndex);
                            }
                        }
                    }
                });
            }
        },
        getCurrentShop:function(){
            this._currentShopDef = new Deferred();
            shop.loadCurrentShop().then(lang.hitch(this,function(data){
                this._currentShopDef.resolve(data);
            }));
            return this._currentShopDef;
        },
        refreshAllList:function(){
            if(window.did){
                this.newsList.target = article.getLoadByGroupNameUrl2();
                this.newsList.query = {title: window.did};
            }else{
                this.newsList.target = article.getPlatformUrl();
                this.newsList.query = {isUse: true};
            }
            this.refreshNewsList();
        },
        refreshNewsList:function(pageIndex){
            this.newsList.refreshList(pageIndex).then(lang.hitch(this, function (data) {
                this.getCurrentShop().then(lang.hitch(this,function(shopData){
                    var items = data.items;
                    array.forEach(items,function(item){
                        item.lastMod = item.lastMod?date.formatISODate(item.lastMod):"";
                        if(g_s.dateDiff('y',item.lastMod,g_s.getDate())<1){							
                            item.lastMod = item.lastMod.split(" ")[0].split("-")[1]+"-"+item.lastMod.split(" ")[0].split("-")[2];
                        }
                        item.shopName = shopData.data.shopName;
                    });
                    this.newsList.onDataReady(data);
                }));
            }));
        }
    });
});