﻿//变更人: 潘云
//变更时间: 2016-06-30
//变更原因: 处理点击库存时没有获取到数据（对应不是平台的商品还没处理）
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dijit/registry",
    "dojo/query",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/_base/lang",
    "cq/biz/mat/mat",
    "cq/biz/article/ss/comment",
    "cq/util/sys/date",
    "cq/biz/shop/shop",
    "cq/biz/user/user"
], function(declare, array, registry, query, Deferred, domClass, domAttr, lang, mat, comment, date, shop, user) {
    return declare("widgets.MatDetail", null, {
        indexMatDetailElement: function() {
            this.inherited(arguments);
            this.goodsInfoBoxRefresh = registry.byId("goodsInfoBox");
            // 商品详情
            this.goodsInfo = registry.byNode(query(".goodsInfo", this.domNode)[0]);
            // 商品评价
            this.goodsEva = registry.byNode(query(".goodsEva", this.domNode)[0]);
            this.goodsEva.target = comment.getLoadUrl();
            
            // 累计评价
            this.totalEva = query(".totalEva", this.domNode)[0];
            
            // 标签切换
            this.gc_title = query(".gc_title", this.domNode)[0];
        },
        goodNodeClick: function(e){
            var dom = e.target;
            while(dom&&dom.tagName!=="TABLE"&dom!==this.goodsInfoBoxRefresh.domNode){
                dom = dom.parentNode;
            }
            
            if(domClass.contains(dom, "talk2shop")){
                this.talk2shop();
            }
        },
        talk2shop: function(){
            user.hasLogin().then(lang.hitch(this, function(s){
                if(s){
                    shop.loadShopByPlatform(this.shopId).then(lang.hitch(this,function(data){
                        //取出返回值中的platformResponsible字段(这个字段就是平台负责人的ID)    张金鹏，2016/07/27
                        var targetUser = data&&data.data&&data.data.svcId;
                        if(targetUser){
                            this.targetUserId = targetUser._id;
                            this.createTalkDig().then(lang.hitch(this, function(){
                                this.talkDig.show();
                            }));
                        }else{
                            alert("店铺未设置客服");
                        }
                    }));
                }else{
                    window.moveToView("login");
                    user.nextPage = "matDetail-"+window.did;
                }
            }));
        },
        createTalkDig: function(){
            if(!this._talkDlgDef){
                this._talkDlgDef = new Deferred();
                require([
                    "dojox/mobile/SimpleDialog",
                    "cq/ui/common/im/WebSvcDetail"
                ], lang.hitch(this, function(SimpleDialog, Svc){
                    
                    this.talkDig = new SimpleDialog({
                        closeButton: true,
                        style: "width:400px;height:444px;"
                    });
                    var talk = new Svc({});
                    this.talkDig.containerNode.appendChild(talk.domNode);
                    talk.initTalk(this.targetUserId,this.shopId);
                    talk.resize();
                    this.talkDig.startup();
                    this._talkDlgDef.resolve();
                }));
            }
            return this._talkDlgDef;
        },
        initMatDetailEvent: function(){
            // 联系客服点击
            this.connect(this.goodsInfoBoxRefresh.domNode, "onclick", this.goodNodeClick);
            this.connect(this.gc_title, "onclick", this.gc_title_click);
            if(!this.pageSelectEvent){
                this.pageSelectEvent = this.connect(query(".pager_page",this.domNode)[0],"onclick",function(e){
                    var dom=e.target;
                    if(dom.tagName=="SPAN"){
                        if (e && e.target && -1 < domAttr.get(e.target, "name")) {
                            var pageIndex = parseInt(domAttr.get(e.target, "name"));
                            if (pageIndex > -1) {
                                this.refreshgoodsEva(pageIndex);
                            }
                        }
                    }
                });
            }
            this.connect(this.goodsEva, "onDefRendered", function(data){
                var items = data.data.items;
                if(items.length){
                    array.forEach(items, function(item){
                        item.createAt = date.formatISODateMinutes(item.createAt);
                        if(g_s.dateDiff('y', item.createAt, g_s.getDate())>0){
                            item.time = item.createAt.split(" ")[0].split("-").join(".");
                        }else if(g_s.dateDiff('d', item.createAt, g_s.getDate())==0){
                            item.time = "今天";
                        }else{
                            item.time = item.createAt.split(" ")[0].split("-")[1]+"."+item.createAt.split(" ")[0].split("-")[2];
                        }
                        item.userName = item.userId.userName[0]+"***"+item.userId.userName[item.userId.userName.length-1];
                        
                        // 处理图片清单
                        item.imageUrls = [];
                        if(item.images&&item.images.length){
                            array.forEach(item.images, function(img){
                                item.imageUrls.push({
                                    url: img
                                });
                            });
                        }
                    });
                }
            });
            
            this.connect(this.goodsEva.domNode, "onclick", this.goodsEvaClick);
        },
        goodsEvaClick: function(e){
            var dom = e.target;
            while(dom&&dom.tagName!=="LI"&&dom!==query(".tm-m-photos-thumb", this.goodsEva.domNode)[0]){
                dom = dom.parentNode;
            }
            if(dom.tagName=="LI"){
                var curUrl = domAttr.get(query("img", dom)[0], "src"),
                    commId = domAttr.get(dom.parentNode, "commId"),
                    targetDom = query(".tm-m-photo-viewer[commId='"+commId+"']")[0],
                    curDom = query(".tm-current", dom.parentNode)[0];
                domClass[domClass.contains(dom, "tm-current")?"add":"remove"](targetDom, "hide");
                domAttr.set(query("img", targetDom)[0], "src", curUrl);
                query(".tm-current", dom.parentNode)[0]&&domClass.remove(query(".tm-current", dom.parentNode)[0], "tm-current");
                dom!=curDom&&!domClass.contains(dom, "tm-current")&&domClass.add(dom, "tm-current");
            }
            /*while(dom&&!domClass.contains(dom, "tm-m-photo-viewer")&&dom!==query(".tm-m-photo-viewer", this.goodsEva.domNode)[0]){
                dom = dom.parentNode;
            }
            // 如果点击的是大图
            if(domClass.contains(dom, "tm-m-photo-viewer")){
                // 如果大图是打开的 则关闭
                if(!domClass.contains(dom, "hide")){
                    domClass.add(dom, "hide");
                    // 清除对应的小图的选中状态
                    var commId = domAttr.get(dom, "commId");
                    query(".tm-m-photos-thumb[commId='"+commId+"'] .tm-current")[0]&&domClass.remove(query(".tm-m-photos-thumb[commId='"+commId+"'] .tm-current")[0], "tm-current");
                }
                return;
            }*/
        },
        refreshAllList: function() {
            mat.loadById(window.did).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.item){
                    data.data.item.invalid = data.data.item.qty<=0||data.data.item.isUse==false?1:0;
                }
                var item = data.data.item;
                // 获取商家信息
                if(item.fromShopId){
                    shop.loadById(item.fromShopId).then(lang.hitch(this, function(shopdata){
                        if(shopdata.data&&shopdata.data._id){
                            item.shopName = shopdata.data.shopName;
                        }else{
                            item.shopName = "";
                        }
                        this.shopId = item.fromShopId;
                        this.goodsInfoBoxRefresh.onDataReady({data:{items:[item]}});
                        this.totalEva.innerHTML = item.commentNum||0;
                    }));
                }
            }));
            this.refreshCurList(query("li[name='goodsInfo']", this.gc_title)[0]);
        },
        refreshgoodsInfo: function(){
            mat.loadById(window.did).then(lang.hitch(this,function(data){
                var item = data.data.item;
                this.goodsInfo.onDataReady({data:{items:[item]}});
            }));
        },
        refreshgoodsEva: function(pageIndex){
            this.goodsEva.refreshList(pageIndex).then(lang.hitch(this, function (data) {
                this.goodsEva.onDataReady(data);
            }));
        },
        gc_title_click: function(e){
            var dom = e.target;
            while(dom&&dom.tagName!=="LI"&&dom!=this.gc_title){
                dom = dom.parentNode;
            }
            if(dom&&dom!==this.gc_title&&dom.tagName=="LI"){
                this.refreshCurList(dom);
            }
        },
        refreshCurList: function(dom){
            // 设置选中
            query(".select", this.gc_title)[0]&&domClass.remove(query(".select", this.gc_title)[0], "select");
            domClass.add(dom, "select");
            var name = domAttr.get(dom, "name");
            array.forEach(["goodsInfo", "goodsEva"], function(c){
            domClass[name==c?"remove":"add"](this[c].domNode, "hide");
            this.goodsEva.query = {
                commentId: window.did,
                commentType: "mat"
            };
            name==c?this["refresh"+c]():null;
        }, this);
        }
    });
});