﻿//变更人: 潘云
//变更时间: 2016-11-01
//变更原因: 网站端商品评价
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/touch",
    "dijit/registry",
    "dojox/mobile/Rating",
    "dojox/mobile/IconContainer",
    "dojox/mobile/IconItem",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/_base/lang",
    "cq/biz/ts/order",
    "cq/biz/article/ss/comment",
    "cq/util/sys/date",
    "cq/biz/blob/blob",
    "cq/biz/shop/shop"
], function(declare, array, touch, registry, Rating, IconContainer, IconItem, query, domClass, domAttr, domConstruct, lang, order, comment, date, blob, shop) {
    return declare("widgets.MatEval",null, {
        indexMatDetailElement: function() {
            this.inherited(arguments);
            this.matEval = registry.byNode(query(".matEval", this.domNode)[0]);
            this.serviceEval = registry.byNode(query(".serviceEval", this.domNode)[0]);
            this.deliveryEval = registry.byNode(query(".deliveryEval", this.domNode)[0]);
            this.logisticsEval = registry.byNode(query(".logisticsEval", this.domNode)[0]);
            this.submitButton = query(".matEvalButton", this.domNode)[0];
            this.evalContent = query(".evalContent", this.domNode)[0];
            this.evalImageNode = query(".matEvalImage", this.domNode)[0];
        },
        indexEvalImage : function (option) {
            // 显示一组图片，最后是一个添加图片的按钮
            // 创建IconContainer
            var iconContainer = new IconContainer({
                editable : option.editable,
                class : option.class
            });
            //依据图片数据刷新图片列表的显示
            iconContainer.refreshItems = function(icons){
                this.endEdit&&this.endEdit();
                //清理
                if(this.addItem&&this.addItem.domNode.parentNode){
                    this.addItem.domNode.parentNode.removeChild(this.addItem.domNode);
                }
                var items = this.getChildren();
                while(items.length){
                    items.pop().destroyRecursive();
                }
                //添加新的
                if(icons&&icons.length){
                    for(var i=0;i<icons.length;i++){
                        this.addChild(new IconItem({
                            icon:icons[i].icon,
                            label:i?((option.detailLabel||option.detailLabel=="")?option.detailLabel:"细节图"):((option.mainLabel||option.mainLabel=="")?option.mainLabel:"主图")
                        }));
                    }
                }
                this.startEdit&&this.startEdit();
                this.addChild(this.addItem);
            };
            //刷新图标的标题
            iconContainer.refreshItemLabel = function(){
                var items = this.getChildren(),item;
                while(items.length){
                    item = items.pop();
                    if(item!==this.addItem){
                        item.set("label",items.length?((option.detailLabel||option.detailLabel=="")?option.detailLabel:"细节图"):((option.mainLabel||option.mainLabel=="")?option.mainLabel:"主图"));
                    }
                }
            };
            // 创建IconItem
            for (var i = 0; i < option.icons.length; i++) {
                iconContainer.addChild(new IconItem({icon : option.icons[i].icon}));
            }
            if (option.canAdd) {
                var iconItem = iconContainer.addItem = new IconItem({
                    editable : false,
                    onClick:function(){
                        return false;
                    },
                    innerHTML :"<div class='mblIconArea'><div class='mblIconAreaInner add-image' onclick=''>+<form action='/biz/blob/blob/upload'><input class='hidden-file-input' type='file'/></form></div></div>"
                });
                var _this = this;
                var _li = iconItem;
                // 避免触发多次点击事件  绑定container节点的click事件
                var touchFun = function(evt) {
                    // 添加图片逻辑
                    // 1、选
                    // 2、裁剪和压缩
                    // 3、上传
                    // 4、显示
                    if(domClass.contains(evt.target, "add-image")){
						return blob.selectAndUpload(option.size,0.7,"cut").then(lang.hitch(this,function(data){
							// 服务器端发生错误给提示
							if(data.ok == 0){
								alert(data.msg);
								return;
							}
							if (data.items && data.items.length == 1) {
								var newIcon = new IconItem({
									icon : data.items[0].uri
									//label : (iconContainer.getChildren().length == 1? ((option.mainLabel||option.mainLabel=="")?option.mainLabel:"主图"):((option.detailLabel||option.detailLabel=="")?option.detailLabel:"细节图"))
								});
								iconContainer.endEdit();
								iconContainer.addChild(newIcon, iconContainer.getChildren().length - 1);
								// 张松   如果参数中传入最大上传图片数量，则判断容器子元素个数，达到最大数量后隐藏添加图片按钮  2016/06/28
								if(option.maxImages){
									if(iconContainer.getChildren().length == (parseInt(option.maxImages) + 1)){
										if(_li && _li.domNode && _li.domNode.parentNode){
											_li.domNode.parentNode.removeChild(_li.domNode);
										}
									}
								}
								iconContainer.startEdit();
							}
						}));
                    }
                    return false;
                };
                touch.release(iconContainer.domNode, lang.hitch(iconItem, touchFun));
                iconContainer.addChild(iconItem);
                iconContainer.connect(iconContainer, "scaleItem" ,function(movingItem, scale){
                    if(scale>1){
                        var node = this.addItem&&this.addItem.domNode;
                        if(node&&node.parentNode){
                            node.parentNode.removeChild(node);
                        }
                    }
                });
                iconContainer.connect(iconContainer,"onMoveItem",function(){
                    //this.refreshItemLabel();
                    this.addChild(this.addItem);
                });
                // 张松   当图片数量达到最大之后，如果用户点击删除图片，添加上传图片按钮 2016/06/28
                iconContainer.connect(iconContainer, "removeChild", function(){
                    if(this.addItem&&this.addItem.domNode&&(!this.addItem.domNode.parentNode)){
                        //his.refreshItemLabel();
                        this.addChild(this.addItem);
                    }
                });
            }
            if (option.onClick){
                iconContainer.onItemClick = option.onClick;
            }else{
                iconContainer.onItemClick = function() {
                    return false;
                };
            }
            iconContainer.refreshItems(option.icons);
            iconContainer.placeAt(this.evalImageNode, 'last');
            return iconContainer;
        },
        initRatingData : function () {
            this.matEval.set("value", 0);
            this.serviceEval.set("value", 0);
            this.deliveryEval.set("value", 0);
            this.logisticsEval.set("value", 0);
        },
        getMatEvalData : function () {
            var data = {};
            data.matEvaluation = this.matEval.get("value");
            data.serviceEvaluation = this.serviceEval.get("value");
            data.deliveryEvaluation = this.deliveryEval.get("value");
            data.logisticsEvaluation = this.logisticsEval.get("value");
            data.content = this.evalContent.value;
            data._id = window.did;
             var iconItems = this.images.getChildren();
            if (iconItems.length > 1) {
                var images = [];
                for (var i = 0; i < iconItems.length; i++) {
                    // 如果icon存在则为用户上传的图片
                    if (iconItems[i].icon) {
                        images.push(iconItems[i].icon);
                    }
                }
                data.images = images;
            }
            return data;
        },
        // 验证必填字段是否为空
        checkFlied: function(data) {
            var msg = "";
            if ((!data.matEvaluation) && (!data.serviceEvaluation) && (!data.deliveryEvaluation) && (!data.logisticsEvaluation)) {
                msg = "给我们打个分吧~";
            } else if (!data.content) {
                msg = "说点什么再提交吧~";
            }
            return msg;
        },
        submitMatEval : function () {
            var evalData = this.getMatEvalData();
            window.busy();
            var msg = this.checkFlied(evalData);
            if (msg) {
                window.free();
                alert(msg);
                return;
            }
            order.evaluedByDetailId(evalData).then(lang.hitch(this, function (result) {
                window.free();
                if (result && result.data && result.data.ok === 1) {
                    alert("评论成功");
                    history.back();
                } else {
                    alert("评论失败");
                }
            }));
        },
        onClickRating : function (e, domNode) {
            var node = e.target;
            while (node && node.parentNode !== domNode) {
                node = node.parentNode;
            }
            registry.byNode(domNode).set("value", array.indexOf(domNode.childNodes, node) + 1);  
        },
        initMatDetailEvent: function(){
            this.inherited(arguments);
            this.connect(this.submitButton, "onclick", lang.hitch(this, this.submitMatEval));
            this.connect(this.matEval.domNode, "onclick", function(e){
                this.onClickRating(e, this.matEval.domNode);
            });
            this.connect(this.serviceEval.domNode, "onclick", function(e){
                this.onClickRating(e, this.serviceEval.domNode);
            });
            this.connect(this.deliveryEval.domNode, "onclick", function(e){
                this.onClickRating(e, this.deliveryEval.domNode);
            });
            this.connect(this.logisticsEval.domNode, "onclick", function(e){
                this.onClickRating(e, this.logisticsEval.domNode);
            });
        },
        refreshAllList: function() {
            this.inherited(arguments);
            // 初始化数据
            this.evalContent.value = "";
            domConstruct.empty(this.evalImageNode);
            // 初始化图片区域
            var option = {
                canAdd : true,
                class : "no-shake",
                detailLabel:"",
                editable:true,
                maxImages:5,
                size:{
                    height:640,
                    width:640
                },
                icons : []
            };
            this.images = this.indexEvalImage(option);
            // 初始化星星
            this.initRatingData();
        }
    });
});