﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    //"../_ViewBase",
    "dojo/_base/lang",
    "dojo/_base/json",
	"dojo/_base/xhr",
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
	"cq/biz/mat/mat",
    "cq/biz/mat/sort"
], function(declare, array, lang, json, xhr, domAttr, registry, query, domConstruct, domStyle, domClass, mat, sort) {//Base, 
    return declare("cq.ui.b.m.MatList", null, {
        lineMatQty: 4,
        matPageSize: 16,
        indexMatListElement: function(){
            // 商品列表
            this.acMallList = registry.byId("acMall");
            this.acMallList.target = mat.getLoadBySortUrl();//getOnSaleUrl
            this.acMallList.query = {
                qty: 1,
                isUse: true,
                orderBy: "code" // 默认按照编码排序
            };
            this.acMallList.pageSize = this.matPageSize;
            // 分类列表
            this.cate = query(".cate",this.domNode)[0]&&registry.byNode(query(".cate",this.domNode)[0])||null;
            // 商品排序
            this.orderControl = query(".order_control", this.domNode)[0];
            
            this.selectedCates = query(".selectedCates", this.domNode)[0];
        },
        resizeMatList: function(data){
            var items = data.data.items;
            array.forEach(items,function(item,i){
                item.appendClass = "1";
                if((i+1)%(this.lineMatQty)==0){
                    item.appendClass = "0";
                }
            }, this);
            
            setTimeout(lang.hitch(this, function(){
                query(".goodsItemh", this.acMallList.domNode).forEach(function(node){
                    if(domAttr.get(node, "margin_right")=="0"){
                        domStyle.set(node, "margin-right", "0px");
                    }
                });
            }), 0);
        },
        initMatListEvent: function(){
            //点击商品排序
            this.connect(this.orderControl, "onclick", this.orderControlOnClick);
            this.connect(this.acMallList,"onDefRendered", this.resizeMatList);
            this.cate&&this.connect(this.cate.domNode, "onclick", this.cateClick);
            
            this.selectedCates&&this.connect(this.selectedCates, "onclick", this.selectedCatesClick);
            if(!this.pageSelectEvent){
                this.pageSelectEvent = this.connect(query(".pager_page",this.domNode)[0],"onclick",function(e){
                    var dom=e.target;
                    if(dom.tagName=="SPAN"){
                        if (e && e.target && -1 < domAttr.get(e.target, "name")) {
                            var pageIndex = parseInt(domAttr.get(e.target, "name"));
                            if (pageIndex > -1) {
                                this.refreshMatList(pageIndex);
                            }
                        }
                    }
                });
            }
        },
        cateClick:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!=="LI"&&dom!==this.cate.domNode){
                dom = dom.parentNode;
            }
            if(!domAttr.has(dom,"sid")){
                return;
            }
            var sid = domAttr.get(dom,"sid"),
                sname = domAttr.get(dom, "sname"),
                nosub = domAttr.get(dom, "nosub");
            // 查询标准分类是否有下级
            // 无论是否有下级 都要加载商品
            // 刘轩 2016/9/23
            //if(nosub == "true"){
                // 已经无下级了 就要加载商品
                this.acMallList.query.sortId = sid;
                this.refreshMatList();
            //}
            
            // 将当前分类放到指定位置
            this.sort.push({
                sortId: sid,
                sortName: sname,
                nosub: nosub
            });
            // 新增导航
            //array.forEach(this.sort, function(sort){
            domConstruct.create("a", {
                innerHTML: sname,
                sid: sid,
                nosub: nosub
            }, this.selectedCates);
            //}, this);
            // 加载下级分类
            sort.loadSubSorts(sid, "code").then(lang.hitch(this, function(data){
                this.cate.onDataReady(data);
            }));
        },
        selectedCatesClick: function(e){
            var dom = e.target;
            if(dom&&dom.tagName=="A"&&dom!=this.selectedCates){
                // 确定点击分类的位置
                var curSid = domAttr.get(dom, "sid"),
                sortIds = array.map(this.sort, function(sort){
                    return sort.sortId;
                }),nosub = domAttr.get(dom, "nosub");
                
                var pos = array.indexOf(sortIds, curSid);
                if(pos<0){
                    this.sort = [];
                    query("a", this.selectedCates).forEach(function(node){
                        if(domAttr.get(node, "sid")!==""){  
                            domConstruct.destroy(node);
                        }
                    });
                    //this.acMallList.query.sortId = curSid;
                    //this.refreshMatList();
                }else if(pos>=0&&(!nosub||nosub=="false")){
                    this.sort.splice(pos+1, this.sort.length-(pos+1));
                    query("a", this.selectedCates).forEach(function(node){
                        if(domAttr.get(node, "sid")!==""){  
                            domConstruct.destroy(node);
                        }
                    });
                    array.forEach(this.sort, function(sort){
                        domConstruct.create("a", {
                            innerHTML: sort.sortName,
                            sid: sort.sortId,
                            nosub: sort.nosub
                        },this.selectedCates);
                    }, this);
                }
                //else if(pos>=0&&nosub=="true"){
                    
                //}
                // 加载商品信息
                this.acMallList.query.sortId = curSid;
                this.refreshMatList();
                // 加载下级分类
                sort.loadSubSorts(curSid, "code").then(lang.hitch(this, function(data){
                    this.cate.onDataReady(data);
                }));
            }
        },
        sorts: [],
        refreshAllList:function(){
            this.sort = [];
            if(this.cate){
                var url = "";
                // 加载分类
                url = sort.getLoadSubSortsUrl("", "code");
                xhr("GET",{
                    url:url,
                    handleAs:"json",
                    load:lang.hitch(this, function(data1){
                        var data={data:[]};
                        data.data=data1;
                        this.cate.onDataReady(data);
                    })
                });
            }
            // 加载商品
            // 判断window.did
            var keyword = query(".head_com_search_input")[0].value;
            if(keyword){
                this.acMallList.query.mName = keyword;
                query(".head_com_search_input")[0].value = "";
            }
            if(this.acMallList.query.sortId){
                sort.loadSubSorts(this.acMallList.query.sortId, "code").then(lang.hitch(this, function(data){
                    this.cate.onDataReady(data);
                }));
            }
            // 如果有window.did
            if(window.did){
                this.acMallList.query.sortId = window.did;
            }
            this.refreshMatList();
            delete this.acMallList.query["mName"];
        },
        refreshMatList:function(pageIndex){
            this.acMallList.refreshList(pageIndex).then(lang.hitch(this, function (data) {
                this.acMallList.onDataReady(data);
            }));
        },
        orderControlOnClick:function(e){
            var dom = e.target;
            while(dom&&"a"!==dom.tagName.toLowerCase()&&dom!=this.order_control){
                dom = dom.parentNode;
            }
            if(dom&&dom!==this.order_control&&domAttr.has(dom, "orderdesc")){
                var name = domAttr.get(dom,"name");
                var cls = domAttr.get(dom,"class");
                var orderDesc = domAttr.get(dom,"orderDesc");
                var selected = domAttr.get(dom,"selected");
                this.acMallList.query?this.acMallList.query:{};
                if(selected=="true"){
                    //更新查询条件
                    domAttr.set(dom,"class",(cls===""||cls==="arrow-down")?"arrow-up":"arrow-down");
                    this.acMallList.query.orderBy = name?((cls===""||cls==="arrow-down")?name:"-"+name):"";
                }else{
                    domAttr.set(dom,"selected","true");
                    this.acMallList.query.orderBy = orderDesc+name;
                    domAttr.set(dom,"class",orderDesc==="-"?"arrow-down":"arrow-up");
                }
                this.refreshMatList();
            }
        }
    });
});