﻿//变更人: 潘云
//变更时间: 2016-06-30
//变更原因: 商品没有图片时设置默认图片
define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/_base/lang",
    "dojo/_base/array",
    "cq/biz/shop/shop",
	"cq/biz/mat/mat"
	], function(declare, registry, query, domAttr, domStyle, lang, array, shop, mat) {
    return declare("cq.ui.w.s.ShopDetail", null, {
        lineMatQty:4,
        indexShopDetailElement: function() {
            this.appInfo=registry.byId("appinfo");
			this.tradeName = registry.byNode(query(".tradeName",this.domNode)[0]);
        },
        refreshAllList:function(){
            this.inherited(arguments);
			shop.loadById(window.did).then(lang.hitch(this, function(data1){
                if(!(data1.data.logo)){
                    data1.data.logo = "images/nomat.png";
                }
				var data = {};
				data.data = {};
				data.data.items = [];
				data.data.items.push(data1.data);
				this.appInfo.onDataReady(data);
            }));
            // 设置查询商品的条件
            this.tradeName.target = mat.getOnSaleUrl(window.did);
            this.tradeName.query = {
                isUse: true,
                qty: 1
            };
            this.refreshMatList();
        },
        refreshMatList:function(pageIndex){
            this.tradeName.refreshList(pageIndex).then(lang.hitch(this, function (data) {
                this.tradeName.onDataReady(data);
            }));
        },
        initShopDetailEvent:function(){
            this.connect(this.tradeName,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    item.appendClass = "1";
                    if((i+1)%(this.lineMatQty)==0){
                        item.appendClass = "0";
                    }
                }, this);
                
                setTimeout(lang.hitch(this, function(){
                    query(".goodsItemh", this.tradeName.domNode).forEach(function(node){
                        if(domAttr.get(node, "margin_right")=="0"){
                            domStyle.set(node, "margin-right", "0px");
                        }
                    });
                }), 0);
            });
            if(!this.pageSelectEvent){
                this.pageSelectEvent = this.connect(query(".pager_page",this.domNode)[0],"onclick",function(e){
                    var dom=e.target;
                    if(dom.tagName=="SPAN"){
                        if (e && e.target && -1 < domAttr.get(e.target, "name")) {
                            var pageIndex = parseInt(domAttr.get(e.target, "name"));
                            if (pageIndex > -1) {
                                this.refreshMatList(pageIndex);
                            }
                        }
                    }
                });
            }
        }
    });
});