define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dijit/registry",
    "cq/biz/shop/shop"
],function(declare,lang,array,query,domClass,domAttr, domStyle,registry,shop){
    return declare("widgets.common.ReVillager", null, {
        indexShopListElement:function(){
            this.hrgList = registry.byNode(query(".hrgList",this.domNode)[0]);
            this.hrgList.target = shop.getChildShopsURL();
            this.hrgList.query = {};
        },
        initShopListEvent:function(){
            this.connect(this.hrgList,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    item.logo = item.logo||"images/nomat.png";
                    item.address = item.address||"";
                    item.border_right = "0";
                    item.border_bottom = "0";
                    if((i+1)%2==0){
                        item.border_right = "1";//border-right:1px solid #eee;
                    }
                    if((i+1)==items.length&&(i+1)%2==1){
                        item.border_right ="1";
                    }
                    
                    if((i+1)==items.length||(i+1)==items.length-1){
                        item.border_bottom = "1";
                    }
                });
                setTimeout(lang.hitch(this, function(){
                    query("li", this.hrgList.domNode).forEach(function(node){
                        if(domAttr.get(node, "border_right")=="1"){
                            domStyle.set(node, "border-right", "1px solid #eee");
                        }
                        if(domAttr.get(node, "border_bottom")=="1"){
                            domStyle.set(node, "border-bottom", "1px solid #eee");
                        }
                    });
                }), 0);
            });
            if(!this.pageSelectEvent){
                this.pageSelectEvent = this.connect(query(".pager_page",this.domNode)[0],"onclick",function(e){
                    var dom=e.target;
                    if(dom.tagName=="SPAN"){
                        if (e && e.target && -1 < domAttr.get(e.target, "name")) {
                            var pageIndex = parseInt(domAttr.get(e.target, "name"));
                            if (pageIndex > -1) {
                                this.refreshShopList(pageIndex);
                            }
                        }
                    }
                });
            } 
        },
        refreshShopList:function(pageIndex){
            this.hrgList.refreshList(pageIndex).then(lang.hitch(this, function (data) {
                this.hrgList.onDataReady(data);
            }));
        },
        refreshAllList:function(){
            this.refreshShopList();
        }
    });
});