﻿// 变更人:肖芳圆
// 变更时间:2016-6-15
// 变更原因:购物车功能迁移
// 变更人:肖芳圆
// 变更时间:2016-6-20
// 变更原因:购物车中，如果商品数量为1，点减号的时候提示“不能删除了”，只能通过点后面的删除按钮执行删除操作
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dijit/registry",
    //"../_ViewBase",
    "cq/biz/ts/cart",
    "cq/biz/user/user",
    "cq/biz/mat/mat",
    "cq/biz/shop/shop"
], function (declare, lang, array, domAttr, query, domClass, domConstruct, Deferred, xhr, json, registry, /*Base, */cart, user, mat, shop) {
    return declare("cq.ui.w.t.OrderCar", null, {
        //购物车商品
        orderCarMats: {},
        indexOrderCarElement: function () {
            this.inherited(arguments);
            this.cartList = registry.byNode(query(".cartList",this.domNode)[0]);
            this.settlement = query(".checkOut", this.domNode)[0];
            this.ttlPrice = query(".ttlPrice", this.domNode)[0];
            this.del_mat = query(".del-mat",this.domNode)[0];
            this.clear_mat = query(".clear-mat",this.domNode)[0];
        },
        initOrderCarEvent: function () {
            this.inherited(arguments);
            // 侦听购物车
            this.connect(this.cartList.domNode, "onclick", this.orderMatListClick);
            this.connect(this.domNode, "onclick", this.domClick);
            // 侦听结算按钮
            this.connect(this.settlement, "onclick", this.settleDown);
            //清空
            this.connect(this.clear_mat, "onclick", this.clearMat);
            // 删除商品
            this.connect(this.del_mat, "onclick", this.delMats);
        },
        refreshAllList: function () {
            if(cart.getIds().length){
                mat.loadByIds(cart.getIds()).then(lang.hitch(this, function (data) {
                    // 查询有哪些商家的商品
                    var shopIds = [],items = data.data.items,mats = {},car = cart.get();
                    array.forEach(items, function(item){
                        if(!mats[item.fromShopId]){
                            mats[item.fromShopId] = {
                                mats:[]
                            }
                            shopIds.push(item.fromShopId);
                        }
                        // 判断商品有效性
                        item.invalid = item.qty<=0||item.isUse===false?1:0;
                        // 库存与加入购物车的数量取最小那个
                        // 如果商品已经失效,则按照购物车本身的数量显示 否则在购物车和库存中取最小的那个
                        item.QTY = item.invalid==1?car[item._id]:Math.min(car[item._id],item.qty);
                        car[item._id] = item.invalid==1?car[item._id]:Math.min(car[item._id],item.qty);
                        // 计算小计
                        item.AMNT = item.QTY*item.retailPrice;
                        mats[item.fromShopId].mats.push(item);
                        this.orderCarMats[item._id] = item;
                    },this);
                    // 将购物车中商品的数量修改与库存数量做比较取最小,重置购物车信息
                    cart.set(car);
                    // 将无效的商品放在后面
                    for(var mat in mats){
                        mats[mat].mats.sort(function(a,b){
                            if(a.invalid==0&&b.invalid==0){
                                return 0;
                            }else if(a.invalid==0&&b.invalid==1){
                                return -1;
                            }else if(a.invalid==1&&b.invalid==0){
                                return 1;
                            }else{
                                return 0;
                            }
                        });
                    }
                    // 如果有店铺信息,加载店铺信息
                    if(shopIds.length){
                        shop.loadByIds(shopIds).then(lang.hitch(this,function(shopData){
                            var shopItems = shopData.data;
                            array.forEach(shopItems,function(item){
                                item.mats = mats[item._id].mats;
                            });
                            var newData = {};
                            newData.data = {};
                            newData.data.items = shopItems;
                            query("#J_Selected_all")[0].checked = false;
                            query("#J_Selected_all_bt")[0].checked = false;
                            this.cartList.onDataReady(newData);
                        }));
                    }
                }));
            }else{
                this.cartList.onDataReady({data:{items:[]}});
                query("input:checked").forEach(function(node){
                    node.checked = false;
                });
            }
        },
        orderMatListClick: function (e) {
            var dom = e.target;
            if (dom&&dom.tagName=="A") {
                var c = domAttr.get(dom, "mid");
                if (-1 < c.indexOf("plus_")) {
                    this.addMatNum(c.split("_")[1], 1);
                } else if (-1 < c.indexOf("minus_")) {
                    if(domClass.contains(dom, "cannot-minus")){
                        return;
                    }
                    this.addMatNum(c.split("_")[1], - 1);
                } else if (-1 < c.indexOf("del_")) { // 点击删除按钮时
                    this.delMat(c.split("_")[1],domAttr.get(dom, "shopId"));
                }else{
                    return;
                }
            }
        },
        domClick:function(e){
            var dom = e.target;
            if(dom.tagName=="INPUT"){
                var id = domAttr.get(dom ,"id"),shopId,checkedQty,qty;
                // 选择所有
                if(id=="J_Selected_all"||id=="J_Selected_all_bt"){
                    query("input[type='checkbox']",this.domNode).forEach(function(node){
                        node.checked = dom.checked;
                    });
                    query(".cart-mat",this.domNode).forEach(function(node){
                        if(!domClass.contains(node,"cart-invalid")){
                            domClass[dom.checked?"add":"remove"](node,"selected");
                        }
                    });
                    this.updateTtlPrice();
                }else if(id.indexOf("shopId")>-1){
                    shopId = id.split("_")[1];
                    // 设置店铺商品的选中状态
                    query("input[shopId='"+shopId+"']",this.domNode).forEach(function(node){
                        node.checked = dom.checked;
                    });
                    query(".cart-mat[shopId='"+shopId+"']").forEach(function(node){
                        if(!domClass.contains(node,"cart-invalid")){
                            domClass[dom.checked?"add":"remove"](node,"selected");
                        }
                    });
                    checkedQty = query("input[type='checkbox']:checked",this.cartList.domNode).length,
                    qty = query("input[type='checkbox']",this.cartList.domNode).length;
                    if(checkedQty==qty){
                        query("#J_Selected_all",this.domNode)[0].checked = true;
                        query("#J_Selected_all_bt",this.domNode)[0].checked = true;
                    }else{
                        query("#J_Selected_all",this.domNode)[0].checked = false;
                        query("#J_Selected_all_bt",this.domNode)[0].checked = false;
                    }
                    this.updateTtlPrice();
                }else if(id.indexOf("mid")>-1){
                    // 如果已经被选择完了,则要更新商家的选中
                    shopId = domAttr.get(dom,"shopId");
                    checkedQty = query("input[shopId='"+shopId+"']:checked",this.domNode).length,
                    qty = query("input[shopId='"+shopId+"']",this.domNode).length;
                    // 设置店铺全选的选中
                    if(checkedQty==qty){
                        // 设置商家的选中
                        query("#shopId_"+shopId,this.domNode)[0].checked = true;
                    }else{
                        query("#shopId_"+shopId,this.domNode)[0].checked = false;
                    }
                    checkedQty = query("input[type='checkbox']:checked",this.cartList.domNode).length,
                    qty = query("input[type='checkbox']",this.cartList.domNode).length;
                    if(checkedQty==qty){
                        query("#J_Selected_all",this.domNode)[0].checked = true;
                        query("#J_Selected_all_bt",this.domNode)[0].checked = true;
                    }else{
                        query("#J_Selected_all",this.domNode)[0].checked = false;
                        query("#J_Selected_all_bt",this.domNode)[0].checked = false;
                    }
                    // 设置全选的选中
                    // 设置节点的选中状态
                    var cart_mat = query(".cart-mat[mid='"+id.split("_")[1]+"']",this.domNode)[0];
                    domClass[domClass.contains(cart_mat,"selected")?"remove":"add"](cart_mat,"selected");
                    this.updateTtlPrice();
                }
            }
        },
        //删除商品
        delMat: function (mid, shopId) {
            var car = cart.clear([mid]),
            // 删除节点
            node = query(".cart-mat[mid='"+mid+"']", this.cartList.domNode)[0];
            node.parentNode.removeChild(node);
            // 如果删除的商家已经没有其他商品了,则要移除商家的节点
            var root = query(".cart-body[shopId='"+shopId+"']",this.cartList.domNode)[0];
            if(query(".cart-mat",root).length==0) root.parentNode.removeChild(root);//domConstruct.empty(root);
            this.updateTtlPrice();
        },
        delMats:function(){
            // 判断是否已经选择的商品
            if(query("input[type='checkbox']:checked").length==0){
                alert("请选择要删除的商品");
                return;
            }
            // 移除选中的商品
            var id, car = cart.get(),curNode = null,matNodes = [],shopNodes = [];
            query("input[type='checkbox']:checked").forEach(lang.hitch(this, function(node){
                id = domAttr.get(node, "id");
                if(id.indexOf("mid")>-1){
                    matNodes.push(node);
                }else if(id.indexOf("shopId")>-1){
                    shopNodes.push(node);
                }
            }));
            matNodes.forEach(function(node){
                id = domAttr.get(node, "id");
                delete car[id.split("_")[1]];
                curNode = query(".cart-mat[mid='"+id.split("_")[1]+"']",this.cartList.domNode)[0];
                curNode.parentNode.removeChild(curNode);
            }, this);
            cart.set(car);
            
            shopNodes.forEach(function(node){
                id = domAttr.get(node, "id");
                curNode = query(".cart-body[shopId='"+id.split("_")[1]+"']",this.cartList.domNode)[0];
                curNode.parentNode.removeChild(curNode);
            },this);
            this.updateTtlPrice();
        },
        //修改购物车数量
        addMatNum: function(mid, inc) {
            var car = cart.get();
            //购买数量不能超过库存数量
            if((car[mid] >= this.orderCarMats[mid].qty) && (inc > 0)){
                //alert("库存不足!");
                return;
            }
            //修改数量
            car[mid] += inc;
            cart.set(car);
            // 如果数量>1
            if(car[mid]>1){
                // 移除减号上不能减的样式
                domClass.remove(query(".cart-amount a[mid='minus_"+mid+"']", this.domNode)[0], "cannot-minus");
            }else{
                // 添加减号上不能减的样式
                domClass.add(query(".cart-amount a[mid='minus_"+mid+"']", this.domNode)[0], "cannot-minus");
            }
            query(".cart-amount input[mid='num_"+mid+"']", this.cartList.domNode)[0].value = car[mid];
            query(".td-sum[mid='"+mid+"']", this.cartList.domNode)[0].innerHTML = "￥" + (car[mid] * this.orderCarMats[mid].retailPrice).toFixed(2);
            //window.updateCarNum();
            this.updateTtlPrice();
        },
        //更新合计
        updateTtlPrice: function () {
            var car = cart.get(), price = 0;
            for(var mid in car){
                // 商品信息中有且商品未失效且商品为选中
                if(this.orderCarMats[mid]&&
                this.orderCarMats[mid].invalid==0&&
                query("#mid_"+mid, this.cartList.domNode)[0].checked){
                    price += this.orderCarMats[mid].retailPrice * car[mid]
                }
            }
            this.ttlPrice.innerHTML = price.toFixed(2);
            // 如果有选中的节点,则更新结算按钮的状态
            domClass[query("input[type='checkbox']:checked",this.cartList.domNode).length?"remove":"add"](this.settlement, "disabled");
        },
        //清除失效商品
        clearMat: function () {
            var car = cart.get();
            for(var mid in car){
                if(this.orderCarMats[mid]&&this.orderCarMats[mid].invalid==1){
                    delete car[mid];
                }
            }
            cart.set(car);
            this.initData();
        },
        //结算
        settleDown: function (e) {
            if(domClass.contains(e.target, "disabled")){
                return;
            }
            var selectedMids = [];
            query("input:checked", this.cartList.domNode).forEach(function(node){
                var id = domAttr.get(node, "id");
                if(id.indexOf("mid")>-1){
                    selectedMids.push(id.split("_")[1]);
                }
            });
            cart.setSelected(selectedMids);
            if(cart.getSelected().length===0){
                alert("还没有选择任何商品哦!");
                return;
			}
			user.hasLogin().then(lang.hitch(this,function(s){
				if(s){
					window.moveToView("orderInfo");
				}else{
					window.moveToView("login");
					user.nextPage="orderInfo";
				}
			}));
        }
    });
});
