﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-attr",
    "cq/biz/ts/order",
    "cq/biz/user/user",
    "cq/util/sys/date"
], function(declare, lang, array, registry, query, domClass, domAttr, order ,user, date){
    return declare("cq.ui.w.t.OrderDetail", null, {
        indexOrderDetailElement:function(){
            this.order_detail = registry.byNode(query(".order_detail",this.domNode)[0]);
            this.payType = query(".payType",this.domNode)[0];
            this.payBtn = query(".payBtn",this.domNode)[0];
            this.orderfooter = query(".orderfooter",this.domNode)[0];
        },
        initOrderDetailEvent:function(){
            this.connect(this.payType,"onclick",this.payTypeClick);
            this.connect(this.payBtn,"onclick",this.payOrder);
            this.connect(this.order_detail.domNode, "onclick", this.order_detail_click);
            this.connect(this.order_detail,"onDefRendered",function(data){
                // 清空支付方式按钮被选中状态
                query(".payType a",this.domNode).forEach(function(node){
                    domClass.remove(node,"payBtnSelect");
                });
                var items = data.data.items;
                if(items.length){
                    items[0].canCancel = 0;
                    if(items[0].isPayed==false&&items[0].isCanceled==false){
                        items[0].canCancel = 1;
                    }
                    items[0].canReceipt = 0;
                    if(items[0].isPayed==true&&items[0].isCanceled==false&&items[0].isAccepted==true&&items[0].isDelived==true&&items[0].isReceipted==false){
                        items[0].canReceipt = 1;
                    }
                    items[0].lastMod = items[0].lastMod?date.formatISODate(items[0].lastMod):"";
                    items[0].dName = items[0].mIds[0].dName;
                    items[0].dTel = items[0].mIds[0].dTel;
                    items[0].dAddress = items[0].mIds[0].dAddress;
                    var mIds = items[0].mIds;
                    array.forEach(mIds,function(item){
                        // 获取订单状态
                        item.state = "";
                        if(item.isPayed==false&&item.isCanceled==false){
                            item.state = "待付款";
                        }else if(item.isPayed==false&&item.isCanceled){
                            item.state = "已取消";
                        }else if(item.isPayed&&item.isCanceled){
                            item.state = "已退款";
                        }else if(item.isPayed&&(false===item.isAccepted||false===item.isDelived)){
                            item.state = "待发货";
                        }else if(item.isPayed&&item.isAccepted&&item.isDelived&&item.isReceipted===false){
                            item.state = "待收货";
                        }else if(item.isPayed&&item.isReceipted==true&&item.isEvaluated==false&&!item.isClosed){
                            item.state = "已确认收货";
                        }else if(item.isPayed&&item.isEvaluated&&!item.isClosed){
                            item.state = "已评价";
                        }else if(item.isPayed&&item.isClosed){
                            item.state = "已完成"
                        }
                        // 处理评价按钮的显示问题
                        if (item.isReceipted && !item.isCanceled && !item.isRefounded && !item.isEvaluated) {
                            item.isMatEval = true;
                        } else {
                            item.isMatEval = false;
                        }
                    },this);
                }
            });
        },
        order_detail_click: function(e){
            var dom = e.target;
            if(domClass.contains(dom, "cancelOrder")){
                order.setCanceled(window.did).then(lang.hitch(this, function(){
                    this.refreshAllList();
                }));
            }else if(domClass.contains(dom, "receiptOrder")){
                order.setReceipteded(window.did).then(lang.hitch(this, function(){
                    this.refreshAllList();
                }));
            }
        },
        payOrder:function(){
            if(query(".payBtnSelect",this.payType)[0]){
                window.busy();
                var payType = domAttr.get(query(".payBtnSelect",this.payType)[0],"payType");
                order.onPayed({
                    _id: window.did,
                    payType: payType
                }).then(lang.hitch(this,function(data){
                    window.free();
                    if(data&&data.data&&data.data.ok == 1){
                        this.initData();
                    }else{
                        alert(data&&data.data&&data.data.msg||"支付出错");
                    }
                }));
            }else{
                alert("请先选择支付方式");
            }
        },
        payTypeClick:function(e){
            var dom = e.target;
            if(dom.tagName=="A"){
                // 清楚以前选中的样式
                if(query(".payBtnSelect",this.payType)[0]) domClass.remove(query(".payBtnSelect", this.payType)[0], "payBtnSelect");
                // 添加当前节点的选中
                domClass.add(dom,"payBtnSelect");
            }
        },
        refreshAllList:function(){
            user.hasLogin().then(lang.hitch(this, function(s){
                if(s){                
                    order.loadDetailById(window.did).then(lang.hitch(this,function(data){
                        var orders = data.data.items;
                        // 订单未取消且未支付
                        //加载订单信息
                        order.loadById(window.did).then(lang.hitch(this, function(data) {
                            if(data.data.item.isPayed === false && data.data.item.isCanceled === false){
                                // 待付款状态要显示付款按钮
                                domClass.remove(this.orderfooter,"hide");
                                // 重算支付方案
                                order.generatePaymentSchemeById(window.did).then(lang.hitch(this, function(data) {
                                    data.data.item.mIds = orders;
                                    var newData = {};
                                    newData.data = {};
                                    newData.data.items = [data.data.item];
                                    // 刷新订单的显示
                                    this.order_detail.onDataReady(newData);
                                    var item = data.data.item;
                                    if(item.amount-(item.point + item.couponAmount)<=0){
                                        if(g_sys_info.payDeposit){
                                            domClass.remove(query("a[type='payDeposit']", this.orderfooter)[0], "hide");
                                        }
                                    }else{
                                        if(g_sys_info.payWeiXin){
                                            domClass.remove(query("a[type='payWeiXin']", this.orderfooter)[0], "hide");
                                        }
                                        if(g_sys_info.payAli){
                                            domClass.remove(query("a[type='payAli']", this.orderfooter)[0], "hide");
                                        }
                                    }
                                }));
                            }else{
                                domClass.add(this.orderfooter,"hide");
                                data.data.item.mIds = orders;
                                var newData = {};
                                newData.data = {};
                                newData.data.items = [data.data.item];
                                // 刷新订单的显示
                                this.order_detail.onDataReady(newData);
                            }
                        }));
                        
                    }));
                }else{
                    user.nextPage = "orderDetail-"+window.did;
                    window.moveToView("login");
                }
            }));
        }
    });
});