﻿// 变更人:肖芳圆
// 变更时间:2016-6-15
// 变更原因:订单提交

// 变更人:肖芳圆
// 变更时间:2016-6-28
// 变更原因:立即购买的bug--购物车里有多类商品时，在商品详情中点击立即购买后，会将购物车中的所有商品都提交。
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dijit/registry",
    "cq/biz/ts/order",
    "cq/biz/ts/cart",
    "cq/biz/user/user",
    "cq/biz/mat/mat"
], function(declare, lang, array, query, domAttr, domClass, registry, order, cart, user, mat) {
    return declare("cq.ui.w.t.OrderInfo", null, {
        selectedMids:[],
        indexOrderInfoElement: function () {
            this.order = registry.byNode(query(".order",this.domNode)[0]);
            //取出用户名,电话,地址,备注
            this.userName = query(".username",this.domNode)[0];
            this.userPhone = query(".userphone",this.domNode)[0];
            this.userAdd = query(".useraddr",this.domNode)[0];
            //this.userRemark=query(".userremark", this.domNode)[0];
            //提交订单按钮
            this.subOrderBtn = query(".checkOutButton a", this.domNode)[0];
        },
        initOrderInfoEvent: function () {
            this.inherited(arguments);
            this.connect(this.subOrderBtn,"onclick",this.submitOrder);
            this.connect(this.userName,"onblur",function(){
                // 失去焦点时
                query(".realPay-tel",this.domNode)[0].innerHTML = this.userName.value+" "+this.userPhone.value;
            });
            this.connect(this.userPhone,"onblur",function(){
                // 失去焦点时
                query(".realPay-tel",this.domNode)[0].innerHTML = this.userName.value+" "+this.userPhone.value;
            });
            this.connect(this.userAdd,"onblur",function(){
                // 失去焦点时
                query(".realPay-addr",this.domNode)[0].innerHTML = this.userAdd.value;
            });
            
            //this.connect(query(".orderinfo-payType",this.domNode)[0], "onclick", this.choosePayType);
        },
        choosePayType:function(e){
            var dom = e.target;
            if(dom.tagName=="INPUT"){
                var checkedNodes = query("input:checked",query(".orderinfo-payType",this.domNode)[0]);
                checkedNodes.forEach(function(node){
                    if(node!==dom){
                        node.checked = false;
                    }
                });
            }
        },
        refreshAllList: function () {
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    user.getDefaultAddr().then(lang.hitch(this,function(data){
                        this.userName.value = data.pName || '';
                        this.userAdd.value = data.address || '';
                        this.userPhone.value = data.phone || '';
                        query(".realPay-addr",this.domNode)[0].innerHTML = data.address||"";
                        query(".realPay-tel",this.domNode)[0].innerHTML = (data.pName||"") + " "+ (data.phone||"");
                        //query("input:checked",query(".orderinfo-payType", this.domNode)[0]).forEach(function(node){
                        //    node.checked = false;
                        //});
                        // 加载选中的商品信息
                        var car = cart.getSelectedChart(),mids = [],allCar = cart.get();
                            mat.loadByIds(window.did?window.did:cart.getSelected()).then(lang.hitch(this,function(data){
                                var items = data.data.items,mats = {};
                                // 过滤掉失效商品
                                var newItems = array.filter(items,function(item){
                                    return item.qty>0&&item.isUse;
                                });
                                // 按照list2需要的格式 处理商品信息
                                array.forEach(newItems,function(item){
                                    mids.push({
                                        mid:item._id,
                                        qty:window.did?Math.min(1, item.qty):Math.min(car[item._id], item.qty)
                                    });
                                    if(!window.did){
                                        allCar[item._id] = Math.min(car[item._id], item.qty);
                                    }
                                    if(!mats[item.fromShopId]){
                                        mats[item.fromShopId] = [];
                                    }
                                    item.QTY = window.did?Math.min(1, item.qty):Math.min(car[item._id], item.qty);
                                    item.AMNT = item.retailPrice * item.QTY;
                                    mats[item.fromShopId].push(item);
                                });
                                if(!window.did){
                                    cart.set(allCar);
                                }
                                this.selectedMids = mids;
                                // 加载运费信息
                                order.getTAmount({mids:mids}).then(lang.hitch(this,function(tData){
                                    var shop = tData.data.item,shopItems = [],ttl = 0;
                                    for(var shopId in shop){
                                        shopItems.push({
                                            shopName:shop[shopId].shopInfo.shopName,
                                            totalPrice:shop[shopId].totalPrice+shop[shopId].tAmount,
                                            tAmount:shop[shopId].tAmount,
                                            mats:mats[shopId]
                                        });
                                        ttl += shop[shopId].totalPrice+shop[shopId].tAmount;
                                    }
                                    query(".realPay-price",this.domNode)[0].innerHTML = ttl.toFixed(2);
                                    // 依据加载后的运费信息来刷新显示
                                    var newData = {};
                                    newData.data = {};
                                    newData.data.items = shopItems;
                                    this.order.onDataReady(newData);
                                    
                                    // 显示支付方式
                                    //query(".orderinfo-payType li",this.domNode).forEach(function(node){
                                    //    var type = domAttr.get(node,"type");
                                    //    domClass[!type||g_sys_info[type]?"remove":"add"](node,"hide");
                                    //});
                                }));
                            }));
                        }));
                }else{
                    window.moveToView("login");
                    user.nextPage="orderInfo";
                }
            }));
        },
        //将分钟数转换为时间格式
        //    输入：80——分钟数
        //    输出：1小时20分钟
        minuteToTimeString:function(minutes){
            var minute = minutes%60;
            minutes = parseInt(minutes/60);
            var hour = minutes%24;
            var day = parseInt(minutes/24);
            var timeStr = "";
            if(day){
                timeStr += ""+day+"天";
            }
            if(hour){
                timeStr += ""+hour+"小时";
            }
            if(minute){
                timeStr += ""+minute+"分钟";
            }
            return timeStr;
        },
        submitOrder: function () {
            var m = {};
            m.dAddress = this.userAdd.value;
            m.dTel = this.userPhone.value;
            m.dName = this.userName.value;
            // 现备注不支持在不同商家提交
            //m.remark = this.userRemark.value;
            m.userId = user.getCurrentUserId();
            m.mids = this.selectedMids;
            var msg = this.verify(m);
            if(msg){
                alert(msg);
                return;
            }
            // 检查支付方式
            //if(query("input:checked", query(".orderinfo-payType", this.domNode)[0]).length==0)
            //{
            //    alert("请选择支付方式");
            //    return;
            //}
            //var payType = domAttr.get(query("input:checked", query(".orderinfo-payType", this.domNode)[0])[0], "payType");
            // 存收货信息
            window.busy();
            var msgs = {};
            msgs.pName = m.dName;
            msgs.phone = m.dTel;
            msgs.address = m.dAddress;
            user.setDefaultAddr(msgs);

            // 创建订单
            order.createDistributionOrder(m).then(lang.hitch(this, function (data) {
                window.free();
                if(data && data.data && data.data.ok === 1){
                    // 清除选中的商品
                    cart.clear(cart.getSelected());
                    cart.setSelected([]);
                    this.selectedMids = [];
                    // 依据选择的支付方式 支付订单
                    var orders = data.data.item, ids = [],payOrders = [];
                    for(var i in orders){
                        ids.push(orders[i].order._id);
                        payOrders.push(orders[i].order);
                    }
                    // 记录当前要支付的订单信息到全局变量中
                    window.currentPayOrder = payOrders;
                    // 提交成功后进入选择支付方式画面
                    window.moveToView("payType", ids.join(","));
                    //order.onPayedByIds({
                    //    ids: JSON.stringify(ids),
                    //    payType: payType
                    //}).then(lang.hitch(this,function(paystatus){
                        // 无论支付成功或者失败,都要跳转页面
                    //    if(ids.length>1){
                    //        window.moveToView("orderList");
                    //    }else{
                    //        window.moveToView("orderDetail", ids[0]);
                    //    }
                    //    if(paystatus&&paystatus.data&&paystatus.data.ok==1){
                            
                    //    }else{
                    //        alert(paystatus&&paystatus.data&&paystatus.data.msg||"支付出错");
                    //    }
                    //}));
                    // 未返回自动取消时间
                    //window.moveToView("orderDetail",data.data.item._id);
                    //var timeout = data.data.item.timeout
                    //if(timeout>0){
                    //    alert("请在"+this.minuteToTimeString(timeout)+"内完成支付，否则订单会自动取消。");
                    //}
                }else {
                    alert(data && data.data && data.data.msg || "订单提交失败");
                }
            }));
        },
        verify:function(data){
            var msg="";
            if(!data.dName){
                msg="收货人还没有填写";
            }else if(!data.dTel){
                msg="收货电话还没有填写";
            }else if(!data.dAddress){
                msg="收货地址还没有填写";
            }else if(!data.mids.length){
                msg = "没有要提交的商品";
            }else{
                
            }
            return msg;
        }
    });
});