﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-class",
    "cq/biz/user/user",
    "cq/biz/ts/order"
], function(declare, lang, array, query, domAttr, domClass, user, order){
    return declare("cq.ui.w.t.PayType", null, {
        indexPayTypeElement: function(){
            this.orderinfo_payType = query(".orderinfo-payType", this.domNode)[0];
            this.topayant = query(".topayant", this.domNode)[0];
            this.topaypoint = query(".topaypoint", this.domNode)[0];
            this.paynow = query(".checkOut", this.domNode)[0];
        },
        initPayTypeEvent: function(){
            this.connect(this.orderinfo_payType, "onclick", this.choosePayType);
            this.connect(this.paynow, "onclick", this.toPay);
        },
        toPay: function(){
            if(!query("input:checked", this.orderinfo_payType).length){
                alert("请选择支付方式");
                return;
            }
            var paytype = domAttr.get(query("input:checked", this.orderinfo_payType)[0], "paytype"), ids = [];
            array.forEach(window.currentPayOrder, function(item){
                ids.push(item._id);
            });
            order.onPayedByIds({
                ids: JSON.stringify(ids),
                payType: paytype
            }).then(lang.hitch(this, function(result){
                if (result && result.data && result.data.ok === 1) {
                    
                }else {
                    alert(result && result.data && result.data.msg || "支付失败!")
                }
                if(ids.length>1){
                    window.moveToView("orderList");
                }else{
                    window.moveToView("orderDetail", ids[0]);
                }
            }));
        },
        refreshAllList: function(){
            // 初始化input初始状态
            query("input:checked").forEach(function(node){
                node.checked = false;
            });
            // 初始化支付方式的显示隐藏
            query("li", this.orderinfo_payType).forEach(function(node){
                if(domAttr.has(node, "type")) domClass.add(node, "hide");
            });
            // 检查是否登录
            user.hasLogin().then(lang.hitch(this, function(s){
                if(s){
                    // 计算订单要用掉的积分
                    var canPay = true, ttl = 0, point = 0, rttl = 0;
                    if(window.currentPayOrder.length){
                        for(var i = 0;i<window.currentPayOrder.length;i++){
                            if((window.currentPayOrder[i].isPayed==false&&window.currentPayOrder[i].isCanceled==true)||window.currentPayOrder[i].isPayed){
                                canPay = false;
                                break;
                            }
                            ttl += window.currentPayOrder[i].payAmount;
                            point += (window.currentPayOrder[i].point + window.currentPayOrder[i].couponAmount);
                            rttl += window.currentPayOrder[i].amount;
                        }
                        if(!canPay){
                            alert("订单已失效,不能支付");
                            return;
                        }
                        this.topaypoint.innerHTML = point.toFixed(2);
                        this.topayant.innerHTML = ttl.toFixed(2);
                        // 则显示其他支付方式
                        if(ttl>0){
                            if(g_sys_info.payWeiXin){
                                domClass.remove(query("li[type='payWeiXin']", this.orderinfo_payType)[0], "hide");
                            }
                            if(g_sys_info.payAli){
                                domClass.remove(query("li[type='payAli']", this.orderinfo_payType)[0], "hide");
                            }
                        }
                        // 否则 余额支付按钮
                        else{
                            if(g_sys_info.payDeposit){
                                domClass.remove(query("li[type='payDeposit']", this.orderinfo_payType)[0], "hide");
                            }
                        }
                    }else{
                        alert("没有要支付的订单");
                    }
                }else{
                    user.nextPage = "payType-"+window.did;
                    window.moveToView("login");
                }
            }));
            
        },
        choosePayType:function(e){
            var dom = e.target;
            if(dom.tagName=="INPUT"){
                var checkedNodes = query("input:checked", this.orderinfo_payType);
                checkedNodes.forEach(function(node){
                    if(node!==dom){
                        node.checked = false;
                    }
                });
            }
        }
    });
});