﻿define([
    "dojo/_base/declare",
    "dojo/query",
    "dojo/_base/lang",
    "cq/biz/user/user"
], function(declare, query, lang, user) {
    return declare("cq.ui.w.u.Login", null, {
        //初始化页面元素
        indexLoginElement: function() {
            this.PhoneNum = query(".PhoneNum", this.domNode)[0]; //手机号
            // 登陆按钮节点
            this.logPwdBtn = query(".logPwdBtn", this.domNode)[0];
            // 获得登陆密码
            this.logPass = query(".VCode", this.domNode)[0];
        },
        initLoginEvent: function() {
            //登录按钮
            this.connect(this.logPwdBtn, "onclick", this.onlogPwdBtnClick);
            //添加一个键盘点击事件enter
            this.connect(this.logPass,"onkeydown",function(e){
                if(e.keyCode==13){
                    this.onlogPwdBtnClick(); 
                }
            });
        },
        onlogPwdBtnClick: function() {
            if (!/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(this.PhoneNum.value)) {
                alert("请输入正确的11位电话号码");
            } else if (!this.logPass.value) {
                alert("必须输入密码");
            } else {
                this.onLogin();
            }
        },
        onLogin: function() {
            user.loginByPassword(this.PhoneNum.value, this.logPass.value).then(lang.hitch(this,function(result) {
                if (result.data.ok === 1) {
                    this.PhoneNum.value = "";
					this.logPass.value = "";
					window.moveToView(user.nextPage|| "main");
                } else {
                    alert("用户名或密码错误");
                }
            }));
        }
    });
});
