﻿define([
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dijit/registry",
    "cq/widgets/SlideShow",
    "dojo/query",
    "dojo/_base/connect",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "cq/biz/sms/sms",
    "cq/biz/user/user"
], function(declare, domAttr, registry, SlideShow, query, connect, lang, array, xhr, json, sms, user) {
    return declare("cq.ui.w.u.Register", null, {
        //初始化页面元素
        indexRegisterElement: function() { 
            array.forEach(["PhoneNum", "VCode", "getVCode", "pwd", "cpwd", "logPwdBtn", "app_title"], function(c){
                this[c] = query("."+ c, this.domNode)[0];
            }, this);
            this.app_title.innerHTML = g_sys_info.title;
        },
        initRegisterEvent: function(){
            // 手机号文本框失去焦点时验证手机号是否已注册
            this.connect(this.PhoneNum, "onblur", lang.hitch(this, this.verifyNumber));
            // 获取验证码
            this.connect(this.getVCode, "onclick", lang.hitch(this, this.getVetify));
            // 确认注册
            this.connect(this.logPwdBtn, "onclick", lang.hitch(this, this.onVerify));
        },
        emptyRegisterData: function(){
            domAttr.remove(this.PhoneNum,"readonly");
            this.PhoneNum.value = "";
            this.VCode.value = "";
            this.pwd.value = "";
            this.cpwd.value = "";
            this.getVCode.innerHTML = "获取验证码";
            this._clear();
        },
        verifyNumber: function() {
            var verStore;
            if (/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(this.PhoneNum.value)) {
                if (verStore !== this.PhoneNum.value) {
                    user.onCheckExist(this.PhoneNum.value).then(lang.hitch(this, function(data) {
                        if (data.data.ok === 1) {
                            this.emptyRegisterData();
                            alert("账号已经存在，即将跳转到登陆页面");
                            window.moveToView("login");
                        }
                    }));
                }
            } else {
                alert("请输入正确的11位电话号码");
            }
            verStore = this.PhoneNum.value;
        },
        // 提交处理
        onRegister: function() {
            user.register({
                "userName": this.PhoneNum.value,
                "password": this.cpwd.value,
                "vCode": this.VCode.value
            }).then(lang.hitch(this, function(result) {
                if (result.data.ok === 1) {
                    // 若注册成功，自动执行登录的动作
                    user.loginByPassword(this.PhoneNum.value, this.cpwd.value).then(lang.hitch(this, function(data1) {
                        if (data1.data.ok === 1) {
                            this.emptyRegisterData();
                            window.moveToView(user.nextPage || "main");
                        }
                    }));
                } else if (result.data.status === 101) {
                    alert("验证码错误");
                } else if (result.data.status === 102) {
                    alert("验证码已过期");
                } else if (result.data.status === 310) {
                    alert("用户名已存在");
                }
            }));
        },
        // 验证字段
        onVerify: function() {
            // 提示处理
            if (!/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(this.PhoneNum.value)) {
                alert("请输入正确的11位电话号码");
            } else if (!this.VCode.value) {
                alert("验证码不能为空");
            } else if (!this.pwd.value || !this.cpwd.value) {
                alert("密码不能为空");
            } else if (this.pwd.value !== this.cpwd.value) {
                alert("两次密码不一致");
            } else {
                this.onRegister();
            }
        },
        // 获得验证码
        getVetify: function() {
            var number = this.PhoneNum.value;
            if (/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(number)) {
                domAttr.set(this.PhoneNum,"readonly","readonly");
                if(!this.resetTime||this.resetTime<=0){
                    sms.sendVcode(number);
                    this.resetTime = 60;
                    this.timerFunction();
                }
            } else {
                alert("请输入正确的11位电话号码");
            }
        },
        timerFunction:function(){
            this.timer = setTimeout(lang.hitch(this,function(){
                this.timerFunction();
            }),1000);
            if(this.resetTime == 0){
                query(".getVCode",this.domNode)[0].innerHTML= "重新获取";
                clearTimeout(this.timer);
            }else{
                this.getVCode.innerHTML = "重新获取("+this.resetTime+")";
                this.resetTime = this.resetTime - 1;
            }
            
        },
        _clear: function(){
            if(this.timer){
                clearInterval(this.timer);   
            }
        }
    });
});
