﻿define([
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/on"
],function(lang,domAttr,domConstruct,domStyle,on){
    // module:
    //      cq/util/css/clearButtonUtil
    
    
    var onInputChanged = function(){
        // summary:
        //      内容发生改变时隐藏或显示清空文本框按钮
        //      
        if(this.clearButton&&(!this.value)!=(!this._oclv)){
            this._oclv = this.value;
            domStyle.set(this.clearButton,"display",this.value&&(!this.readOnly)?"inline-block":"");
        }
    };
    
    var onInputBlur = function(){
        // summary:
        //      文本框失去焦点时隐藏清空文本框按钮
            setTimeout(lang.hitch(this,function(){
                if(this.clearButton&&this.value){
                    domStyle.set(this.clearButton,"display","none");
                }
            }),200);
        
    };
    
    var onInputFocus = function(){
        // summary:
        //   文本框获得焦点时显示清空文本框按钮   
        if(this.value){
            domStyle.set(this.clearButton,"display","inline-block");
        }
    };
    //设置readOnly的情况
    setReadOnly = function(inputNode){
        // summary:
        //      根据编辑状态重新绑定onFocus事件和onBlur事件
        this.readOnly = domAttr.get(this,"readOnly");
        this._oclv = this.value;
        //domStyle.set(this.clearButton,"display",this.value&&(!this.readOnly)?"inline-block":"");
        if(!this.readOnly){
            this.addEventListener("blur",onInputBlur);
            this.addEventListener("focus",onInputFocus);
        }else{
            domStyle.set(this.clearButton,"display","");
            this.removeEventListener("blur",onInputBlur);
            this.removeEventListener("focus",onInputFocus);
        }
    };
    return {
    // summary:
    //      用于处理文本框右侧清空按钮的显示隐藏以及清空功能
        
        initClearButton:function(inputNode){
        // summary:
        //      初始化清空按钮，并绑定事件。
        // params:
        //      inputNode:组件的input
            
            //若未处理
            if(!inputNode.clearButton){
                // 判断新(position:static)/老(position:absolute)系统
                var buttonNode = null;
                if("static"===domStyle.get(inputNode,"position")){
                    //创建button，放到input的后边
                    var isFloat = domStyle.get(inputNode,"float")==="right";
                    buttonNode = domConstruct.create("button",{
                        "class":"close-icon1",
                        style:"display:none;"+(isFloat?"":"float:none;"),
                        type:"button",
                        tabindex:-1
                    },inputNode,isFloat?"before":"after");    
                }else{
                    //创建button，放到input的后边
                    buttonNode = domConstruct.create("button",{
                        "class":"close-icon2",
                        style:"display:none;",
                        type:"button",
                        tabindex:-1
                    },inputNode,"before");    
                }
                inputNode.readOnly = domAttr.get(inputNode,"readOnly");
                //设置button的属性
                buttonNode.inputNode = inputNode;
                //设置input的属性
                inputNode.clearButton=buttonNode;
                inputNode.addEventListener("input",onInputChanged);
                inputNode.addEventListener("blur",onInputBlur);
                inputNode.addEventListener("focus",onInputFocus);
                inputNode.updateState = setReadOnly;
                setReadOnly.apply(inputNode);
                //设置button的onclick(处理桌面和设备的兼容性)
                buttonNode.onclick = buttonNode.ontouchstart = this._onClearButtonClick;
            }
        },
        //点击事件
        _onClearButtonClick:function(){
            // summary:
            //      清空文本框
            //清空自己对应input的内容
            this.inputNode.value="";
            on.emit(this.inputNode, "blur", {
                bubbles: true,
                cancelable: true
            });
            onInputChanged.apply(this.inputNode);
        }
    };
});