﻿define([
    "dojo/_base/lang",
    "dojo/sniff"
],function(lang,has){
    return lang.mixin(lang.getObject("cq.util.css.transformUtil",true),{
        //移动样式
        getTranformStr:function(x,y,z){
            return " translate3d("+(x||0)+","+(y||0)+","+(z||0)+")";
        },
        //缩放
        getScaleStr:function(x,y,z){
            return (x>=0?" scaleX("+x+")":"")+(y>=0?" scaleY("+y+")":"")+(z>=0?" scaleZ("+z+")":"");
        },
        //旋转
        getRotateStr:function(rotate){
            return " rotate("+rotate+")";
        }
    },has("webkit")?{
        //动画持续时间
        getDurationStyle:function(duration){
            return {"WebkitTransitionDuration":duration+"ms"};
        },
        //动画运动方式
        getAnimationMethodStyle:function(method){
            return {"WebkitTransitionTimingFunction":method};
        },
        getTransformStyle:function(transform){
            return {"WebkitTransform":transform};
        }
    }:has("mozilla")?{
        //移动样式
        getTranformStr:function(x,y,z){
            return " translateX("+(x||0)+") translateY("+(y||0)+") translateZ("+(z||0)+")";
        },
        getDurationStyle:function(duration){
            return {"MozTransitionDuration":duration+"ms"};
        },
        getAnimationMethodStyle:function(method){
            return {"MozTransitionTimingFunction":method};
        },
        getTransformStyle:function(transform){
            return {"MozTransform":transform};
        }
    }:{
        getDurationStyle:function(duration){
            return {"TransitionDuration":duration+"ms"};
        },
        getAnimationMethodStyle:function(method){
            return {"TransitionTimingFunction":method};
        },
        getTransformStyle:function(transform){
            return {"Transform":transform};
        }
    });
});