﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/edit/overlay"
],function(declare,lang,domConstruct,domStyle,Deferred,View,_ViewMixin,overlay){
    var ConfirmFrame = declare("",[View,_ViewMixin],{
        style:"height:480px;",
        initEvent:function(){
            this.addColumns({
                forceWidth:false,
                isFooter:true,
                labelClass : 'font-size1',
                className: 'alipayed',
                columns:[{
                    label : '完成',
                    onClick:this.onFinish,
                    className: "footer-tab-highlight"
                },{
                    label : '取消',
                    onClick:this.onCancel,
                    className: "footer-tab-dark"
                }]
            });
            domStyle.set(this.centerPanel.domNode,"display","none");
            this.frameNode = domConstruct.create("iframe",{
                width:"100%",
                height:"100%",
                style:"display:block;"
            },this.centerPanel.domNode,"after");
        },
        onCancel:function(){
            if(this.overlayHandler){
                this.overlayHandler.remove();
                this.overlayHandler = null;
                overlay.hide();
                this.def.resolve(false);
            }
        },
        onFinish:function(){
            if(this.overlayHandler){
                this.overlayHandler.remove();
                this.overlayHandler = null;
                overlay.hide();
                this.def.resolve(true);
            }
        },
        showInOverlay:function(url){
            this.def = new Deferred();
            this.overlayHandler = this.connect(overlay,"hide",this.onCancel);
            overlay.domNode.innerHTML = "";
            overlay.domNode.appendChild(this.domNode);
            overlay.show();
            this.frameNode.src = url;
            this.resize();
            return this.def;
        }
    });
    var confirmFrame = new ConfirmFrame();
    confirmFrame.placeAt(overlay.domNode);
    return {
        show:function(url){
            return confirmFrame.showInOverlay(url);
        }
    };
});