﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/Deferred",
    "dijit/_Widget"
],function(declare,lang,domConstruct,domG,domStyle,Deferred,_Widget){
    var Dropdown = declare("",[_Widget],{
        baseClass:"nav_dropdownbg",
        _showDef:null,
        buildRendering:function(){
            this.inherited(arguments);
            this.dropDownNode = domConstruct.create("div",{
                style:"width:100%;position:absolue;left:0;"
            },this.domNode);
            domStyle.set(this.domNode,"height","100%");
            this.connect(this.domNode,"onclick",function(e){
                if(e.target===this.domNode){
                    this.hide();
                }
            });
        },
        showContent:function(contentNode,refNode){
            if(this._showDef){
                this._showDef.resolve();
            }
            this._showDef = new Deferred();
            this.dropDownNode.innerHTML = "";
            this.dropDownNode.appendChild(contentNode);
            var matrix = domG.position(refNode);
            domStyle.set(this.domNode,"top",matrix.y+matrix.h+"px");
            domStyle.set(this.domNode,"display","");
            return this._showDef;
        },
        hide:function(){
            if(this._showDef){
                this._showDef.resolve();
                this._showDef = null;
            }
            domStyle.set(this.domNode,"display","none");
        }
    });
    var dropdown = new Dropdown();
    dropdown.placeAt(document.body);
    dropdown.startup();
    lang.setObject("cq.util.edit.dropdown",dropdown);
    return dropdown;
})