define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/touch",
    "dojo/query",
    "cq/ui/view/EditorBase",
    "cq/ui/view/ViewUtil",
    "dojox/mobile/Pane",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/on",
    "dojo/request/xhr",
    "cq/util/config/config",
    "cq/util/image/selector",
    "cq/biz/blob/blob",
    "dojox/mobile/IconItem",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/ToolBarButton"
],function(declare,lang,domConstruct,domClass,touch,query,EditorBase,ViewUtil,Pane,domGeometry,domStyle, on,xhr,config,imgSelector,blob,IconItem,ScrollablePane,ToolBarButton){
    var Editor = declare("",EditorBase,{
        baseClass:"mblView cqRichEditor",
        //处理回车和空格的输入，dojo会强制转为click事件。
        onAfterTransitionIn:function(){
            this.inherited(arguments);
            document.dojoClick=false;
            if(this.contentNode){
                this.contentNode.focus();
            }
            if(this.addButton){
                this.addButton.style.display="block";
            }
            window.enableDocumentTouch = true;
        },
		cancel:function(){
            this.inherited(arguments);
            document.dojoClick=true;
            this.addButton.style.display="none";
            window.enableDocumentTouch = false;
            this._backRange = null;
		},
        finish:function(){
            this.inherited(arguments);
            document.dojoClick=true;
            this.addButton.style.display="none";
            window.enableDocumentTouch = false;
            this._backRange = null;
        },
        //备份光标位置
        backCursor:function(){
            setTimeout(lang.hitch(this,function(){
                var range =  this.createRange();
                this._backRange = {sc:range.startContainer,so:range.startOffset,ec:range.endContainer,eo:range.endOffset};
                var node = range.endContainer;
                while(node.nodeType==3){
                    node = node.parentNode;
                }
                if(!node.tagName){
                    this._backRange=null;
                    return;
                }
                var y = domGeometry.position(node).y+window.scrollY;
                this.addButton.style.top = y+"px";
                this.range = this.createRange();
            }),100);
        },
        //恢复光标位置
        restoreCursor:function(){
            if(!this._backRange) {
                this._backRange = {sc:this.contentNode,so:0,ec:this.contentNode,eo:0};
            }
            var range =  this.createRange();
            range.setStart(this._backRange.sc,this._backRange.so);
            range.setEnd(this._backRange.ec,this._backRange.eo);
            this._backRange = null;
            return range;
        },
        createContent:function(){
            //var sPane = new ScrollablePane({selectable:true,height:domGeometry.getMarginBox(this.contentPane.domNode).h});
            //sPane.placeAt(this.contentPane.domNode,"last");
//sPane.disableTouchScroll=true;
            //sPane.startup();
            //sPane.isFormElement = function(){return true;};
          this.contentNode = domConstruct.create(
              "div", {
                  style : "background-color:white;margin:15px;padding:15px;",
                  contenteditable:'true'
              },this.contentPane.domNode,"last");
              //},sPane.containerNode,"last");
            // 侦听事件，备份光标位置
            // this.connect(this.contentNode,"onmouseup",this.backCursor);
            this.connect(this.contentNode,"onclick",this.backCursor);
            this.connect(this.contentNode,"onkeydown",lang.hitch(this, function(evt){
                this.range = null;
            }));
            // this.connect(this.contentNode,"onchange",this.backCursor);
            // touch.release(this.contentNode,lang.hitch(this,this.backCursor));
            // 张松   侦听图片的长按事件  2016/06/14
            touch.press(this.contentNode, lang.hitch(this, function(evt){
                var target = evt.target;
                if(target.tagName == "IMG"){
                    this.startTouchTime = new Date().getTime();
                }
            }));
            touch.release(this.contentNode, lang.hitch(this, function(evt){
                this.endTouchTime = new Date().getTime();
                // 只有当点击图片时间大于1s才算长按
                if(this.endTouchTime - this.startTouchTime >= 1000){
                    if(evt.target.tagName == "IMG"){
                        var rtn = window.confirm("是否重新上传该图片？");
                        // 如果用户选择是，则重新上传图片
                        if(rtn){
                            this.imgChange(evt.target);
                        }
                    }
                }
            }));
              //只有点击了把手，才算启动拖动操作
            //this.own(touch.press(this.contentNode,lang.hitch(this,this.onTouchStart)));
            //侦听全屏显示的节点的拖动和释放点击事件，执行拖动和拖动释放处理
            //this.own(touch.move(this.contentPane.domNode,lang.hitch(this,this.onTouchMove)));
            this.contentNode.focus();
        },
        onTouchStart2:function(e){
          this._height = domStyle.get(this.contentPane.domNode,"height");
          this._contentHeight = domStyle.get(this.contentNode,"height");
          this._touchTop = e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;
        },
        onTouchMove2:function(e){
            var y = e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;
            if(y>this._touchTop){
                if(this.contentPane.domNode.scrollTop >= this._touchTop-y){
                    this.contentPane.domNode.scrollTop += this._touchTop-y;
                }else{
                    this.contentPane.domNode.scrollTop = 0;
                }
            }else{
                if(this._height<this._contentHeight-this.contentPane.domNode.scrollTop-y+this._touchTop){
                    this.contentPane.domNode.scrollTop += this._touchTop-y;
                }//else{
                //    this.contentPane.domNode.scrollTop = this._contentHeight-this._height;
                //}
            }
            this._touchTop = y;
        },
        getValue:function(){
            return this.contentNode.innerHTML;
        },
        setOrigin:function(text){
            this.contentNode.innerHTML = text;
            this.contentPane.domNode.scrollTop = 0;
        },
        onAfterAddedPane:function(){
            this.inherited(arguments);
            this.addFooterPane();
            //赵春辉    开始编辑时支持传入模版类型，选择模版的按钮    2016-05-26
            this.selectTempButton = new ToolBarButton({
                label:"模版",
                class:"float-right "+(this.tempType?"":"none"),
                onClick:lang.hitch(this,this.onSelectFromTemp)
            });
            this.selectTempButton.placeAt(this.header.domNode,"last");
        },
        //赵春辉    开始编辑时支持传入模版类型，初始化选择的模版类型    2016-05-26
        setTempType:function(tempType){
            if(tempType){
                this.tempType = tempType;
            }else{
                this.tempType = "";
            }
            if(this.selectTempButton){
                domClass[this.tempType?"remove":"add"](this.selectTempButton.domNode,"none");
            }
        },
        //赵春辉    开始编辑时支持传入模版类型，依据模版类型执行选择    2016-05-26
        onSelectFromTemp:function(){
            this.addButton.style.display = "none";
            require([
                "cq/util/edit/jsonRef",
                "cq/biz/article/pm/richTextTemp"
            ],lang.hitch(this,function(jsonRef,richTextTemp){
                jsonRef.startEdit("",this,{
                    target:richTextTemp.getLoadUrl(),
                    query:{
                        tempType:this.tempType,
                        isUse:true
                    },
                    searchField:"title",labelField:"title"
                }).then(lang.hitch(this,function(tempInfo){
                    if(tempInfo){
                        richTextTemp.loadById(tempInfo._id).then(lang.hitch(this,function(data){
                            if(data&&data.data&&data.data.item){
                                this.contentNode.innerHTML = data.data.item.content||"";
                            }
                        }));
                    }
                    setTimeout(lang.hitch(this,this.resize),300);
                }));
            }));
        },
        addFooterPane:function(){
            //this.splitter.addChild(this.footerPane = new Pane());
            // 创建工具栏
            this.addButton = domConstruct.create('div', {class:"editor-add",innerHTML:"+"});
            document.body.appendChild(this.addButton);
            this.addButton.onclick=lang.hitch(this, this.addImg);
            this.addButton.onselectstart=function(){return false;};
            //this.addButton.onclick=function(){return false;};
            if(!this.fileInput){
                this.fileInput = domConstruct.create('input', {
                    type:'file',
                    className:'hidden-file-input'
                }, this.domNode);
            }
            // 添加图片按钮
            //var addImgBtn = domConstruct.create('input', {
            //    type:'button',
            //    onclick:lang.hitch(this, this.addImg),
            //    className:'edit-addimg',
            //    value:'添加图片'
            //}, this.footerPane.domNode);
            // 文字左右对齐，居中
            //var leftAlign = domConstruct.create('input', {
            //    type:'button',
            //    onclick:lang.hitch(this, this.textAlign),
            //    className:'edit-leftalign',
            //    value:'左对齐'
            //}, this.footerPane.domNode);
            //var centerAlign = domConstruct.create('input', {
            //    type:'button',
            //    onclick:lang.hitch(this, this.textAlign),
            //    className:'edit-centeralign',
            //    value:'居中'
            //}, this.footerPane.domNode);
            //var rightAlign = domConstruct.create('input', {
            //    type:'button',
            //    onclick:lang.hitch(this, this.textAlign),
            //    className:'edit-rightalign',
            //    value:'右对齐'
            //}, this.footerPane.domNode);
            // 字体大小
            // 颜色
        },
        textAlign:function(evt){
            var target = evt.target;
            this.containerNode.focus();
            var range = this.createRange();
            console.log(range);
        },
        resize:function(){
            this.inherited(arguments);
            domStyle.set(this.contentNode, 'min-height', this.contentNode.parentNode.style.height);
            // 设置编辑区域高度
            // domStyle.set(this.contentPane.domNode, {height:domGeometry.getMarginBox(document.body).h - domGeometry.getMarginBox(this.headerPane.domNode).h - domGeometry.getMarginBox(this.footerPane.domNode).h + 'px'});
            // this.contentPane.set('height', domGeometry.getMarginBox(document.body).h - domGeometry.getMarginBox(this.headerPane.domNode).h - domGeometry.getMarginBox(this.footerPane.domNode).h + 'px');
            // this.contentPane.resize();
            // domStyle.set(this.contentPane.containerNode, {height:'100%'});
            // 设置footerPane位置
            // domStyle.set(this.footerPane.domNode, {'top':domGeometry.getMarginBox(this.headerPane.domNode).h + domGeometry.getMarginBox(this.contentPane.domNode).h + 'px'});
            // console.log(domStyle.get(this.footerPane.domNode,'top'));
        },
        imgChange:function(node){
            blob.selectAndUpload().then(function(data){
                if(data.items && data.items.length == 1){
                    node.src = data.items[0].uri;
                }
            });
        },
        addImg:function(){
            blob.selectAndUpload().then(lang.hitch(this, function(data){
                if(data.items && data.items.length == 1){
                    this.insertHtml('<img src="' + data.items[0].uri + '"/><br/><div>&nbsp;</div>');
                }
            }));
        },
        createRange:function(){
            var selection = window.getSelection?window.getSelection():document.selection;
            var range = selection.rangeCount&&selection.rangeCount>0?selection.getRangeAt(0):(selection.createRange?selection.createRange():document.createRange());
            //var range = selection.createRange?selection.createRange():(selection.rangeCount>0?selection.getRangeAt(0):document.createRange());
            return range;
        },
        insertHtml:function(html){
            // var selection = window.getSelection?window.getSelection():document.selection;
            // var range = this.restoreCursor();
            if(!this.range){
                this.range = this.createRange();
            }
            // 判断浏览器
            var browser = this.checkBrowser().split(":");
            var IEbrowser = this.checkBrowser().split(":")[0];
            var IEverson =  Number(this.checkBrowser().split(":")[1]);
            var node = null;
            if(IEbrowser == 'IE' && IEverson < 9){
                node = this.range.parseHTML(html);
            }else{
                node = document.createElement('span');
                node.innerHTML=html;
                if(this._backRange){
                    this.range.insertNode(node);
                }else{
                    this.contentNode.appendChild(node);
                }
            }
            // 张松   连续添加两张图片时，后加的图片应该在先加的图片之后   2016/06/20
            //this.range.setStart(query("div", node)[0], 1);
            //this.range.setEnd(query("div", node)[0], 1);
            //query("div", node)[0].focus();
            this.range.setStartAfter(query("div", node)[0]);
        },
        checkBrowser:function checkBrowser(){
            var browserName=navigator.userAgent.toLowerCase();
            var Sys = {};
            var rtn = false;
            if(/msie/i.test(browserName) && !/opera/.test(browserName)){
                strBrowser = "IE: "+browserName.match(/msie ([\d.]+)/)[1];
                rtn = true;
            //return true;
            }else if(/firefox/i.test(browserName)){
                strBrowser = "Firefox: " + browserName.match(/firefox\/([\d.]+)/)[1];
                //return false;
            }else if(/chrome/i.test(browserName) && /webkit/i.test(browserName) && /mozilla/i.test(browserName)){
                strBrowser = "Chrome: " + browserName.match(/chrome\/([\d.]+)/)[1];
                //return false;
            }else if(/opera/i.test(browserName)){
                strBrowser = "Opera: " + browserName.match(/opera.([\d.]+)/)[1];
                //return false;
            }else if(/webkit/i.test(browserName) &&!(/chrome/i.test(browserName) && /webkit/i.test(browserName) && /mozilla/i.test(browserName))){
                strBrowser = "Safari: ";
                //return false;
            }else{
                strBrowser = "unKnow,未知浏览器 ";
            //return false;
            }
            strBrowser = strBrowser ;
            //alert(strBrowser)
            return strBrowser;
        }
    });
    var editor = new declare("",[ViewUtil],{
        //赵春辉    开始编辑时支持传入模版类型    2016-05-26
        startEdit:function(text,view,tempType){
            var def = this.inherited(arguments);
            this.editorView.setTempType(tempType);
            return def;
        }
    })({
        EditorClass:Editor
    });
    lang.setObject("cq.util.edit.editor",editor);
    return editor;
});