﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojox/mobile/Overlay"
],function(declare,lang,domConstruct,domStyle,Overlay){
    var maskNode = domConstruct.create("div",{
        style:"opacity:0.6;background-color:#000;display:none;",
        class:"cover"
    }, document.body, "last");
    var CqOverlay = declare("",Overlay,{
        show:function(){
            clearTimeout(this.hideTimer);
            domStyle.set(maskNode,"display","");
            this.inherited(arguments);
        },
        hide:function(){
            var arr = arguments;
            this.hideTimer = setTimeout(lang.hitch(this,function(){
                domStyle.set(maskNode,"display","none");
                Overlay.prototype.hide.apply(this,arr);
            }),0);
        }
    });
    var overlay = new CqOverlay();
    overlay.placeAt(document.body);
    overlay.startup();
    overlay.connect(maskNode, "onclick", function(){
        this.hide();
    });
    overlay.showInOverlay = function(node){
        overlay.domNode.innerHTML = "";
        overlay.domNode.appendChild(node);
        overlay.show();
    };
    lang.setObject("cq.util.edit.overlay",overlay);
    return overlay;
})