//变更人:肖芳圆
//变更时间:2016/5/27
//原因:地理位置选择对象
//变更人：郭周全
//变更时间：2016/09/28
//原因：通过经纬度逆地理编码
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/Deferred",
    "dojo/DeferredList",
    "cq/ui/view/EditorBase",
    "cq/ui/view/ViewUtil"
],function(declare,lang,xhr,domConstruct,domGeom,Deferred,DeferredList,EditorBase,ViewUtil){
    if(!window.AMap){
        domConstruct.create("script",{
            //高德地图url
            src:"http://webapi.amap.com/maps?v=1.3&amp;key=0b9138e58ee2c5776ed90d144bfbfd97"
        },document.head,"last");
    }
    var geocoder = null;
    var MapPane = declare("",EditorBase,{
        //当前已添加的标记的需要
        _markIndex:0,
        //已添加的标记对象
        addedMarks:[],
        //工具条
        enableToolBar:true,
        enableOverView:true,
        //缩放
        enableMapScale:true,
        //编辑位置
        enableEdit:true,
        //中心点经度
        lon:0,
        //中心点维度
        lat:0,
        //默认缩放级别
        mapZoom:13,
        //默认特性
        features:["bg","point","road","building"],
        createContent:function(){
            var mapId = this.contentPane.get("id")+"map";
            //处理内容
            this.mapDiv = domConstruct.create("div",{
                style:"width:100%;height:100%;",
                "id":mapId
            },this.contentPane.containerNode,"last");
            setTimeout(lang.hitch(this,function(){
                this.initMap(mapId);
            },this),300);
        },
        initMap:function(mapId){
            if(!this.map){
                if(!geocoder){
                    AMap.service('AMap.Geocoder',function(){//回调函数
                        //实例化Geocoder
                        geocoder = new AMap.Geocoder({});
                    });
                }
                
                var defs = [];
                var def1 = null,pointed = this.lon||this.lat?true:false;
                //创建地图
                var map = this.map = new AMap.Map(mapId,{
                    zoom:this.mapZoom||13, //地图显示的缩放级别,
                    resizeAble:pointed||false,
                    features:this.features
                });
                if(this.enableToolBar){
                    defs.push(def1 = new Deferred());
                    this.map.plugin(["AMap.ToolBar"],function(){
                        map.addControl(new AMap.ToolBar({
                            direction:true,//方向导航
                            ruler:true,//视野级别控制尺
                            autoPosition:false//自动定位
                        }));
                        def1.resolve();
                    });
                }
                this._mapDef = new DeferredList(defs);
                //侦听事件
                var clickHandle = AMap.event.addListener(this.map, 'click', lang.hitch(this,function(e) {
                    //点击之后判断是否可编辑，判断是否需要重新标记中心点
                    if (this.enableEdit) {
                        this.onMapCenterChanged(e.lnglat.lng, e.lnglat.lat);
                    }
                }));
                this._mapDef.then(lang.hitch(this,function(){
                    if(this.lon&&this.lat){
                        this.onMapCenterChanged(this.lon,this.lat);
                    }
                }));
            }
        },
        //重新设置中心点
        onMapCenterChanged:function(lon, lat){
            this.setCenter({lon:lon, lat:lat}, true);
            this.clearAllMarks();
            this._addMark({lon:lon, lat:lat});
        },
        setCenter:function(center,changeMap){
            if (changeMap) {
                var lon = center.lon;
                var lat = center.lat;
                if((lon||0===lon)&&(lat||0===lat)&&lon<=180&&lon>=-180&&lat>=-90&&lat<=90){
                    this.map.setCenter(new AMap.LngLat(lon,lat));
                }
            }
        },
        //添加标记
        addMark:function(markInfo){
            if(this.enableEdit){
                this._addMark(markInfo);
            }
        },
        //清除指定标记
        clearMark:function(mark){
            mark = this.addedMarks.pop();
            if(mark){
                while(mark._cqMarkEventHandlers&&mark._cqMarkEventHandlers.length){
                    AMap.event.removeListener(mark._cqMarkEventHandlers.pop());
                }
                mark.setMap(null);
            }
        },
        //清除所有标记
        clearAllMarks:function(){
            while(this.addedMarks.length){
                this.clearMark(this.addedMarks[0]);
            }
        },
        _addMark:function(markInfo){
            if(markInfo){
                markInfo.lon -= 0;
                markInfo.lat -= 0;
                if((markInfo.lon||0===markInfo.lon)&&(markInfo.lat||0===markInfo.lat)&&markInfo.lon<=180&&markInfo.lon>=-180&&markInfo.lat>=-90&&markInfo.lat<=90){
                    //创建一个标记
                    var mark = this._createMark(markInfo);
                    //记录创建的标记
                    this.addedMarks.push(mark);
                    //将标记放到地图上
                    mark.setMap(this.map);
                }
            }
        },
        //依据参数创建一个标记
        _createMark:function(markInfo){
            var mark = null;
            if(markInfo){
                var param = {
                    position:new AMap.LngLat(markInfo.lon,markInfo.lat)
                };
                mark=new AMap.Marker(param);
            }
            return mark;
        },
        //根据当前添加的点标记位置，
        setFitView:function(){
            return this.map&&this.map.setFitView();
        },
        getCenter:function () {
            return this.map.getCenter();
        },
        setOrigin:function(position){
            if(position){
                this.lon = position.lon;
                this.lat = position.lat;
                if(this.map){
                    setTimeout(lang.hitch(this,function(){
                        this.onMapCenterChanged(this.lon,this.lat);
                    }),300);
                }
            }
        },
        startEdit:function(){
            this.setCurrentDist();
            return this.inherited(arguments);
        },
        setCurrentDist:function(data){
            this.distData = data;
        },
        getValue:function(){
            var lonlat = this.getCenter();
            return lang.mixin(this.distData||{},{lon:lonlat.lng,lat:lonlat.lat});
        },
        getDistrict:function(){
            var def = new Deferred();
            if(this.map){
                this.map.getCity(function(data){
                    if(data.province&&data.district){
                        require([
                            "cq/biz/shop/bs/district"
                        ],function(district){
                            district.getPCCByName(data).then(function(data){
                                if(data&&data.data&&data.data.item&&data.data.item.province){
                                    def.resolve(data.data.item);
                                }else{
                                    def.resolve(null);
                                }
                            });
                        });
                    }else{
                        def.resolve(null);
                    }
                });
            }else{
                def.resolve(null);
            }
            return def;
        }
    });
    var editor = new ViewUtil({
        EditorClass:MapPane
    });
    editor.getCurrentDistName = function(){
        var def = new Deferred();
        if(this.editorView&&this.editorView.map){
            this.editorView.map.getCity(function(data){
                if(data.province&&data.district){
                    def.resolve(data);
                }else{
                    def.resolve();
                }
            });
        }else{
            def.resolve();
        }
        return def;
    };
    //获取详细地址数据的方法。
    editor.getDetailAddrFields = function(lon,lat){
        var def = new Deferred();
        geocoder.getAddress(new AMap.LngLat(lon,lat),function(status,result){
            if(status == "complete"){
                def.resolve(result.regeocode.formattedAddress);    
            }else{
                def.resolve();
            }
        });
        return def;
    };
    editor.setEnable=function(bool){
        this.editorView.enableEdit = bool;
    };
    lang.setObject("cq.util.edit.position",editor);
    return editor;
});