﻿define([
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/topic"
],function(lang,xhr,topic){
    var shopInfo = lang.getObject("whz.util.shopInfo",true);
    lang.mixin(shopInfo,{
        shop:{},
        ioInfo:{
            goatTotal:0,
            inTotal:0,
            outTotal:0
        },
        getLogo:function(){
            return this.shop&&this.shop.logo||'images/logo.png';
        },
        getShopName:function(){
            return this.shop&&this.shop.shopName||"";
        },
        onShopChanged:function(){},
        ioInfoChanged:function(){},
        getIoInfo:function(){
            return this.ioInfo;
        }
    });
    var loaded = false,loadIoInfo = function(){
        try{
            require([
                "cq/biz/ts/stock_io",
                "whz/util/date"
            ],function(stockIo,date){
                var startDate = new Date(Date.now()-30*24*60*60*1000);
                stockIo.summaryByDate(startDate.toISOString(),date.nowISOString()).then(function(data){
                    if(data&&data.data&&data.data.items&&data.data.items.length){
                        var item = data.data.items[0];
                        shopInfo.ioInfo = {
                            goatTotal:(item.inQty||0)-(item.outQty||0),
                            inTotal:(item.inQty||0),
                            outTotal:(item.outQty||0)
                        };
                        shopInfo.ioInfoChanged();
                    }
                });
            });
        }catch(e){
        }
    };
    topic.subscribe("whz/shop/changed",function(shop){
        shopInfo.shop = shop;
        shopInfo.onShopChanged();
        if(false===loaded){
            loaded = true;
            loadIoInfo();
        }
    });
    topic.subscribe("whz/shop/io/changed",loadIoInfo);
    return shopInfo;
});