﻿define([
    "dojo/Deferred"
],function(Deferred){
    var getRealUurl = function(url){
        var def = new Deferred();
        var img = new Image();
        img.onload = function(){
            require(["cq/util/sys/exif/exif"],function(exif){
                exif.getData({src:url}, function() {
                    exif.getAllTags(this);
                    def.resolve(preventExif(img,exif.getTag(this, 'Orientation')));
                });
            });
        };
        img.src=url;
        return def;
    },preventExif = function(img,orient){
        if(3!==orient&&6!==orient&&8!==orient){
            return img.src;
        }else{
            var cvs = document.createElement("canvas"),ctx = cvs.getContext("2d");
            //依据朝向，将图片还原
            if(6===orient){
                //实际图片向左旋转90度的结果
                cvs.width = img.height;
                cvs.height = img.width;
                ctx.rotate(Math.PI/2);
                ctx.drawImage(img,0,-img.height);
            }else if(8===orient){
                //实际图片向右旋转90度的结果
                cvs.width = img.height;
                cvs.height = img.width;
                ctx.rotate(-Math.PI/2);
                ctx.drawImage(img,-img.width,0);
            }else if(3===orient){
                //实际图片旋转180度的结果
                cvs.width = img.width;
                cvs.height = img.height;
                ctx.rotate(Math.PI);
                ctx.drawImage(img,-img.width,-img.height);
            }else{
                //实际上还有翻转、翻转之后再旋转的几个状态
                //http://blog.csdn.net/ouyangtianhan/article/details/29825885
                //  2:左右翻转
                //  4:上下翻转
                //  5:左转90度后上下翻转
                //  7:旋转翻转平移(复杂，说不清楚)
                return img.src;
            }
            return cvs.toDataURL();
        }
    };
    return {getRealUurl:getRealUurl};
});