define([
    "dojo/_base/connect",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/ready",
    "dojo/topic",
    "cq/biz/user/user_device",
    "cq/biz/user/user",
    "cq/util/config/config"
], function(connect, json, lang, Deferred, ready, topic, userDevice, user, config) {
    var appDeviceInfo = lang.getObject("mobile.appDeviceInfo", true),
    other = cqthinkinfo&&(window.PushNotification || window.baidu_push)&&("ios"===cqthinkinfo.os || "android"===cqthinkinfo.os)?null:{
        //不支持推送通知
        regist: function() {},
        bandPushMessage: function() {},
        getAppDeviceInfo: function() {},
        updateAppDeviceInfo: function() {
            //不支持推送通知的信息直接不做更新设备信息的操作
        }
    };
    var g_s = window.g_s || {
        getDateTime: function() {
            var d = new Date();
            return d.toISOString().substr(0, 10) + " " + d.toTimeString().substr(0, 8);
        },
        getDate: function() {
            return this.getDateTime().split(" ")[0];
        }
    };
    lang.mixin(appDeviceInfo, {
        //登录状态：0没有启动登录，1登录中未成功，2登录成功
        // loginState:0,
        _init: function() {
            if (!other) {
                // APP启动，首页ready之后直接调用
                this.updateAppDeviceInfo();
                topic.subscribe("/cq/biz/user/user/hasLogin", lang.hitch(this, function(){
                    this.updateAppDeviceInfo();
                }));
                //调用绑定推送通知事件
                this.bandPushMessage();
            }
        },
        updateAppDeviceInfo: function(){
            var o = this.getAppDeviceInfo();
            if (!o) {
                //若没有设备序列号信息，执行注册操作
                this.regist().then(lang.hitch(this, function() {
                    if (this.getAppDeviceInfo()) {
                        //若能够获取到设备信息，说明注册成功，就需要更新设备信息
                        this.updateAppDeviceInfo();
                    }
                }));
            }else{
                this._updateAppDeviceInfo();
            }
        },
        _updateAppDeviceInfo: function() {
            var o = this.getAppDeviceInfo(),
                n = lang.clone(o);
            // 登录成功之后才有userId
            if(user.getCurrentUserId()){
                n.userId = user.getCurrentUserId();
            }
            n.shopId = config.getPlatformShopId();
            userDevice.save(n);
        },
        onNewPushMessage: function() {
        }
    },other ? other : "ios" === cqthinkinfo.os ? {
        //ios系统中推送通知的处理
        //注册设备信息
        regist: function() {
            var def = new Deferred();
            if(!this.deviceNo && window.PushNotification){
				this.push = PushNotification.init({
					ios: {
						alert: "true",
						badge: "true",
						sound: "true",
                        clearBadge:"true"
					}
				});
				this.push.on('registration', lang.hitch(this,function(data) {
					this.deviceNo = data.registrationId;
					def.resolve();
				}));

				this.push.on('notification', lang.hitch(this,function(data) {
                    if(data.additionalData && data.additionalData.moveTo && user.getCurrentUserId() && data.additionalData.receiverShopId == user.getShopId()){
                        if(confirm(data.message+"\n现在查看吗？"))
                        window.moveToView(data.additionalData.moveTo,data.additionalData.param);
                    }
                    else{
                        alert(data.message);
                    }
				}));

				this.push.on('error', lang.hitch(this,function(e) {
					// e.message
				}));
            }else{
                def.resolve();
            }
            return def;
        },
        //绑定设备收到推送通知的响应函数
        bandPushMessage: function() {
            window.onNotificationAPN = lang.hitch(this, function(e) {
                var str = "";
                for (var i in e) {
                    str += "," + i + ":" + e[i].toString();
                }
                window.plugins.pushNotification.setApplicationIconBadgeNumber(function(e) {
                }, function() {
                }, 0);
                if(e && e.alert){
                    alert(e.alert);
                }
                this.onNewPushMessage();
            });
        },
        //获取应用设备信息
        getAppDeviceInfo: function() {
            return this.deviceNo ? {
                "appId": cqthinkinfo.app_id,
                "deviceNo":this.deviceNo
            } : null;
        }
    } : "android" === cqthinkinfo.os ? {
        // android系统中推送通知的处理
        regist: function(){
            var def = new Deferred();
            if(!this.deviceNo){
                // 将app key替换为百度提供的appkey值
                window.baidu_push.startWork("Y3zGeXDmVzcKfu7fD83jVR9L",lang.hitch(this, function(rtnJson){
                    if(rtnJson.type === "onbind"){
                        this.deviceNo = rtnJson.data.channelId;
                        // alert("deviceNo: " + this.deviceNo);
                        def.resolve();
                    }else if(rtnJson.type === "onnotificationarrived" || rtnJson.type === "onnotificationclicked"){
						if(rtnJson.data && rtnJson.data.moveTo && user.getCurrentUserId() && rtnJson.data.receiverShopId == user.getShopId()){
							if(confirm(rtnJson.data.description+"\n现在查看吗？"))
							window.moveToView(rtnJson.data.moveTo,rtnJson.data.param);
						}
                        if(rtnJson.data.description){
                            alert(rtnJson.data.description);
                        }
                        this.onNewPushMessage();
                    }
                }));
            }else{
                def.resolve();
            }
            return def;
        },
        bandPushMessage: function(){
        },
        getAppDeviceInfo: function(){
            return this.deviceNo ? {
                "appId": cqthinkinfo.app_id,
                "deviceNo":this.deviceNo
            } : null;
        }
    } : other);
    //现在只处理ios的应用
    appDeviceInfo._init();
    return appDeviceInfo;
});
