﻿define([
    "dojo/_base/lang",
    "dojo/date/locale"
],function(lang,locale){
    return lang.mixin(lang.getObject("cq.util.sys.date",true),{
        //当前时间的ISO格式字符串
        nowISOString:function(){
            return (new Date()).toISOString();
        },
        //将ISO日期字符串转换为当前日期"yyyy-mm-dd"
        formatISODate:function(isoString){
            return locale.format(new Date(isoString),{
                selector:"date",
                datePattern:"yyyy-MM-dd"
            });
        },
        //将ISO日期字符串转换为当前时间"HH:mm"
        formatISOTime:function(isoString){
            return locale.format(new Date(isoString),{
                selector:"date",
                datePattern:"HH:mm"
            });
        },
        //将ISO日期字符串转换为当前日期"yyyy-mm-dd:mm"
        formatISODateMinutes:function(isoString){
            return locale.format(new Date(isoString),{
                selector:"date",
				//干劲20161001：不要秒更合理？
                datePattern:"yyyy-MM-dd HH:mm"
            });
        },
        //将年月日"yyyy-mm-dd"字符串转为ISO日期字符串
        formatToISOString:function(dateString){
            return locale.parse(dateString,{
                selector:"date",
                datePattern:"yyyy-MM-dd"
            }).toISOString();
        },
        //将年月日"yyyy-mm-dd HH:MM"字符串转为ISO日期字符串
        formatToISOStringWithMinutes:function(dateString){
            return locale.parse(dateString,{
                selector:"date",
                datePattern:"yyyy-MM-dd HH:mm"
            }).toISOString();
        }
    });
});