define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/dom-style",
    "dijit/registry",
    "dojox/dtl/_base",
    "./Template"
],function(declare,lang,array,connect,json,xhr,domStyle,registry,dtl,Template){
    var loadedList = {},waitList = {};
    var List2 = declare("cq.widgets.List2",Template,{
        items: [],
        data: {},
        rs_wb_md: "",
        rs_wb_page: "10",
        rs_wb_flt: "",
        rs_wb_param: "({})",
        rs_wb_wait: "",
        rs_wb_order: '',
        rs_wb_group:"",
        rs_wb_egg:"",
        minRow:'-1',
        //ZCH使这个控件在新IDE中可用
        all_data: {},
        defered: null,
        curPage: 1,
        pageCount: 1,
        totalCount: 1,
        appId:"",
        rendered:false,
        postMixInProperties: function () {
            //this.isDesign = ('claro HtmlWidget editContextContainer' == (document.getElementsByTagName('body')[0])&&document.getElementsByTagName('body')[0].className);
            if (!window.rs_data_all) window.rs_data_all = {};
            this.all_data = window.rs_data_all;
            if (!this.id) {
                console.log("有数据列表" + this.rs_wb_md + "没有设置id，会导致不加载该列表数据。");
            }
            if (!this.rs_wb_page) this.rs_wb_page = "10";
            this.inherited(arguments);
        },
        refreshList: function (page) {
            // 这里要等页面初始化完毕后才加载.
            if(!this.rendered) return;
            loadedList[this.id] = false;
            if (typeof page != "object" && typeof page != "undefined") this.curPage = page;
            else this.curPage = 1;
            if(!window.g_sys_info) return;
            if (!this.rs_wb_md) return this.onDataReady({
                data: {
                    items: []
                }
            });
            if(!(this.appId||0===g_sys_info.aid))this.appId = g_sys_info.aid;
            try{
                this.defered = xhr("GET",{
                    url: g_sys_info.url_usr,
                    handleAs: "json",
                    load: lang.hitch(this, this.onDataReady),
                    sync: false,
                    preventCache:true,
                    content: {
                        tp: "query3",
                        modalName: this.rs_wb_md,
                        pageSize: this.rs_wb_page,
                        pageIndex: this.curPage,
                        filter: this.rs_wb_flt,
                        orderBy: this.rs_wb_order||(this.rs_db_egg?this.rs_wb_group:""),
                        groupBy: this.rs_wb_group,
                        egg:this.rs_wb_egg,
                        appId: this.appId,
                        hash: encodeURIComponent(json.toJson(json.fromJson(this.rs_wb_param)))
                    }
                });
            }catch(e){}
        },
        buildRendering: function () {
            this.inherited(arguments);
            if (!this.containerNode) {
                this.containerNode = this.domNode;
            }
            if(!this.tempNode){
                this.tempNode = this.domNode;
            }
            if(!this.rendered){
                this.rendered = true;
                if(this.rs_wb_wait){
                    var wl = waitList[this.rs_wb_wait] = waitList[this.rs_wb_wait]||[];
                    wl.push(this.id);
                }
                if(this.rs_wb_wait&&(!loadedList[this.rs_wb_wait])){
                    return;
                }else{
                    this.refreshList();
                }
            }
        },
        startup:function(){
            this.inherited(arguments);
            setTimeout(lang.hitch(this,function(){
                //控制不透明度
                domStyle.set(this.domNode,"opacity",1);
            }),100);
        },
        onDefRendered:function(data){
            if(0===data.data.items.length) return;
            if("-1" == this.minRow || data.data.items.length > parseInt(this.minRow,10)) return;
            var newItem, addRow = parseInt(this.minRow,10) - data.data.items.length;
            for(var i=0;i<addRow;i++){
                newItem = lang.clone(data.data.items[0]);
                for(var prop in newItem){
                    newItem[prop] = "";
                }
                data.data.items.push(newItem);
            }
        },
        onRendered: function (data) {
            //赵春辉    放到scrollPane中时显示不全问题    2015-09-24
            var p = this.getParent();
            while(p&&(!p.scrollTo)){
                p = p.getParent();
            }
            if(p){
                p.resize();
            }
        },
        onRendered2: function (data) {},
        onDataReady: function (data) {
            if (!data || !data.data || !data.data.items) return;
            setTimeout(lang.hitch(this,function(){
                loadedList[this.id] = true;
                if(waitList[this.id]){
                    array.forEach(waitList[this.id],function(l){
                        registry.byId(l).refreshList();
                    });
                }
            }));
            this.items = data.data.items;
            if (this.items) {
                this.items.sum = function () {
                    if (this.length === 0) return null;
                    var sum = {};
                    for (var f in this[0]) {
                        if (!f) continue;
                        sum[f] = 0;
                        for (var i = 0; i < this.length; i++) {
                            var cur = 0;
                            if(isNaN(this[i][f]) || this[i][f]==""||this[i][f]==null||this[i][f]==undefined){
                                cur = 0;
                            }else{
                                cur = parseFloat(this[i][f]);
                            }
                            sum[f] += cur;
                        }
                    }
                    return sum;
                };
                var toString = function () {
                    return this.__val;
                };
                for (var i = 0; i < this.items.length; i++) {
                    for (var f in this.items[i]) {
                        if (f.indexOf(".") >= 0) {
                            if (typeof this.items[i][f.split(".")[0]] == "string") this.items[i][f.split(".")[0]] = {
                                __val: this.items[i][f.split(".")[0]],
                                toString: toString
                            };
                            this.items[i][f.split(".")[0]][f.split(".")[1]] = this.items[i][f];
                        }
                    }
                }
            }
            this.data = data.data;
            this.totalCount = this.data.totalCount;
            this.pageCount = parseInt(this.totalCount / this.rs_wb_page) + (this.totalCount % this.rs_wb_page == 0 ? 0 : 1);
            if (this.id) window.rs_data_all[this.id] = data.data;
            this.onDefRendered(data);
            if (!this._template) this._template = new dtl.Template(this._templateString);
            var context = new dtl._Context(this);
            this.beforeGetContent();
            this.tempNode.innerHTML = this.onListHtmlReady(this._template.render(context));
            dojo.parser.parse(this.tempNode);
            this.afterGetContent();
            this.onRendered(data);
            this.onRendered2(data);
            //控制不透明度
            domStyle.set(this.domNode,"opacity",1);
        },
        beforeGetContent:function(){
            this.destroyDescendants(false);
            this.domNode.innerHTML = "";
        },
        afterGetContent:function(){
        }
    });
    return List2;
});