﻿define([
    "dojo/_base/declare",
    "dojo/_base/config",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dojo/dom-style",
    "dojo/_base/array",
    "dojo/dom-geometry",
    "dojo/dom-construct",
    "dojo/_base/connect",
    "dojo/_base/event",
    "cq/widgets/animation",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojox/gesture/swipe",
    "dojo/query",
    "dojo/_base/window",
    "dojo/dom-attr",
    "dojo/_base/Deferred",
    "dojo/_base/xhr",
    "dojo/has",
    "dojo/_base/sniff",
    "dojox/mobile/transition",
    "dojox/mobile/_css3"
],function(declare,config,_Widget,_TemplatedMixin,domStyle,array,domGeom,domConstruct,connect,event,animation,lang,domClass,swipe,query,win,domAttr,Deferred,xhr,has,sniff,transitDeferred,css3){
    return declare("cq.widgets.SlideShow",[_Widget,_TemplatedMixin],{
        //面板图片宽度
        panelsWidth:0,
        //面板图片高度
        panelsHeight:0,
        //图片总数
        _total:0,
        //当前位置
        _current:null,
        //当前导航的位置
        _navCurrent:null,
        //导航图片宽度
        _navsWidth:0,
        //导航图片高度
        _navsHeight:30,
        //图片src字段
        srcField:"",
        //标题字段
        titleField:"",
        //显示标题
        showTitle:true,
        //导航图片每页个数
        _navsNum:0,
        //导航项宽度
        _navsSize:0,
        //切换效果
        effect:"slide",
        //面板元素
        _panelItems:[],
        //导航元素
        _navItems:[],
        //数据
        items:[],
        //播放频率
        playInterval:3000,
        //播放定时器
        _autoPlayTimer:null,
        //大图容器
        bigImg:null,
        //是否懒加载
        lazy:true,
        //导航首元素索引
        _start:0,
        //导航末元素索引
        _end:0,
        // 张松  时候启用显示大图功能  2016/07/26
        isShowBigImg:true,
        model:"",
        where:"",
        agg:"",
        groupBy:"",
        orderBy:"",
        auto:true,
        _hasInit:false,
        //处于切换动画中
        _transiting:false,
        //自动切换下一个画面
        _isAutoPlay:true,
        //模版字符串
        templateString:['<div dojoattachpoint="wrapper" class="slideshow">',
            '<button class="nav-btn prev" dojoattachpoint="prevBtn" style="display:none;">◀</button>',
            '<button class="nav-btn next" dojoattachpoint="nextBtn" style="display:none;">▶</button>',
            '<div class="slideshow-panels">',
            '    <ul dojoattachpoint="panels"></ul>',
            '</div>',
            '<div class="slideshow-pageIndicator" dojoattachpoint="pageIndicator">',
            '    <div dojoattachpoint="title" style="display:inline-block;padding:6px 0 0 10px;">',
            '    </div>',
            '    <div style="display:inline-block;float:right;">',
            '        <ul class="indicator" dojoattachpoint="dot">',
            '        </ul>',
            '    </div>',
            '    <div class="nav-btn3" dojoattachpoint="playBtn">||',
            '    </div>',
            '</div>',
            '<div class="slideshow-controls" dojoattachpoint="navControl" style="display:none;">',
            '    <div class="nav-btn2 prev2" dojoattachpoint="prevNav" style="float:left;">◀</div>',
            '    <div class="nav-btn2 next2" dojoattachpoint="nextNav" style="float:right">▶</div>',
            '    <div class="slideshow-navs" dojoattachpoint="navsBar">',
            '        <ul dojoattachpoint="navs">',
            '        </ul>',
            '    </div>',
            '</div>',
            '</div>'].join(""),
        constructor:function(){
            this.items = [];
            this._panelItems = [];
            this._navItems = [];
            this._current = null;
        },
        postCreate: function(){
            this.inherited(arguments);
            if(!has("touch")){
                domStyle.set(this.playBtn,"display","none");
            }
            if(this.model&&!this.auto){
                return;
            }
            this._hasInit = true;
            this._initEvent();
            this.render();
        },
        onBeforeRender:function(r){
        },
        render:function(){
            this._getData().then(lang.hitch(this,function(r){
                this.onBeforeRender(r);
                this.addPanels();
                this.addNavs();
                this.addIndicator();
                this.fitSize();
                if(this.items.length>0){
                    this.show(0);
                    if (this.playInterval){
                        this.play();
                    }
                }
            }));
        },
        refresh:function(){
            if(this.model){
                this.items = [];
            }
            this._panelItems = [];
            this._navItems = [];
            this._current = null;
            this.pause();
            domConstruct.empty(this.panels);
            domConstruct.empty(this.navs);
            domConstruct.empty(this.dot);
            domStyle.set(this.panels,"left","0px");
            if(!this._hasInit){
                this._hasInit = true;
                this._initEvent();
            }
            this.render();
        },
        //获取数据
        _getData:function(){
            var def = new Deferred();
            if(this.model){
                try{
                    if(g_sys_info){
                        this._getDataByAjax().then(lang.hitch(this,function(r){
                            def.resolve(r);
                        }));
                    }
                    else{
                        this._getDataByWebsocket().then(lang.hitch(this,function(r){
                            def.resolve(r);
                        }));
                    }
                }
                catch(e){
                    this._getDataByWebsocket().then(lang.hitch(this,function(r){
                        def.resolve(r);
                    }));
                }
            }
            else def.resolve({resulttype:"1"});
            return def;
        },
        //通过ajax获取数据
        _getDataByAjax:function(){
            var def = new Deferred();
            this.appId = g_sys_info.aid;
            xhr("GET",{
                url: g_sys_info.url_usr,
                handleAs: "json",
                load: lang.hitch(this, function(r){
                    if(r.resulttype=="1"){
                        this.items = r.data.items;
                    }
                    def.resolve(r);
                }),
                error:lang.hitch(this,function(r){
                    def.resolve(r);
                }),
                sync: false,
                preventCache:true,
                content: {
                    tp: "query1",
                    modalName: this.model,
                    orderby: this.orderBy,
                    groupBy: this.groupBy,
                    egg:this.agg,
                    where:this.where
                }
            });
            return def;
        },
        //通过websocket获取数据
        _getDataByWebsocket:function(){
            var def = new Deferred();
            this.appId = g_d.websocket.appId;
            g_d.newTable("__p_slide_show_" + this.model,this.model).then(lang.hitch(this,function(){
                g_d.open("__p_slide_show_" + this.model,{
                    where:this.where,
                    orderBy:this.orderBy,
                    agg:this.agg,
                    groupBy:this.groupBy
                    }).then(lang.hitch(this,function(r){
                    if(r.resulttype=="1")this.items = r.data.items;
                    def.resolve(r);
                }));
            }));
            return def;
        },
        //播放
        play: function() {
            this.pause();
            this._isAutoPlay = true;
            if (this.playInterval) {
                this._autoPlayTimer = setTimeout(lang.hitch(this,function() {
                    this.showNext();
                }), this.playInterval);
            }
        },
        //暂停播放
        pause: function() {
            this._isAutoPlay = false;
            if (this._autoPlayTimer) {
                clearTimeout(this._autoPlayTimer);
                delete this._autoPlayTimer;
            }
        },
        //增加面板
        addPanels:function(){
            //指定了滑动元素
            if(this.items){
                //赵春辉    记录显示区域的大小    2016-03-11
                this.panelsHeight = this.panelsHeight||domStyle.get(this.domNode,"height");
                this.panelsWidth = this.panelsWidth||domStyle.get(this.domNode,"width");
                array.forEach(this.items,function(item,idx){
                    var li = domConstruct.create("li",{
                        style:"display:none;width:100%;"+(this.panelsHeight?"height:100%;":"")
                    },this.panels);
                    domConstruct.create("img",{
                        "class":this.isShowBigImg?"__showBigImg":"",
                        src:(idx===this.items.length-1||false===this.lazy)?item[this.srcField]:"",
                        // style:"width:"+(this.panelsWidth?this.panelsWidth+"px":"100%")+";cursor: pointer;",
                        // 张松  slideshow图片不拉伸，只做等比缩放，显示在正中间   2016/06/23
                        style:"cursor:pointer;",
                        onload:lang.hitch(this,this.onImageLoad)
                    },li);
                    if(item.onclick){
                        li.onclick = function(e){
                            event.stop(e);
                            item.onclick(item,e);
                        };
                    }
                    this._total = this.items.length;
                    this._current = null;
                    this._panelItems.push(li);
                },this);
            }
            domStyle.set(this.panels,"width","100%");
        },
        onImageLoad:function(e){
            //赵春辉    处理不符合规格的图片的显示区域    2015-07-14
            // 张松  slideshow图片不拉伸，只做等比缩放，显示在正中间   2016/06/23
            var node = e.target;
            // if(node.height&&this.panelsHeight&&node.height/node.width*this.panelsWidth!==this.panelsHeight){
                //赵春辉    依据显示区域大小显示    2016-03-11
                // domStyle.set(node,"margin-top",(this.panelsHeight-node.height/node.width*this.panelsWidth)/2+"px");
            // }
            if(node.height && node.width && this.panelsHeight && this.panelsWidth && node.height/node.width > this.panelsHeight/this.panelsWidth){
                domStyle.set(node, {
                    width:"100%",
                    marginTop:((this.panelsHeight - node.height/node.width*this.panelsWidth)/2 + "px")
                });
            }else{
                domStyle.set(node, {
                    height:"100%",
                    marginLeft:((this.panelsWidth - node.width/node.height*this.panelsHeight)/2 + "px")
                });
            }
        },
        //增加导航
        addNavs:function(){
            if(this.items){
                this._navsWidth = domStyle.get(this.wrapper,"height")?(domStyle.get(this.wrapper,"width")/domStyle.get(this.wrapper,"height"))*this._navsHeight:this._navsHeight;
                array.forEach(this.items,function(item,idx){
                    var li = domConstruct.create("li",{"class":"__navItem",idx:idx,style:"width:" + (this._navsWidth+2) + "px;height:" + (this._navsHeight+2)+"px;margin-left:9px;"},this.navs);
                    domConstruct.create("img",{idx:idx,src:"",style:"width:" + this._navsWidth +"px;height:" + this._navsHeight+"px;cursor: pointer;"},li);
                    this._navSize = this._navsWidth + 2 + 9;
                    this._navItems.push(li);
                },this);
            }
        },
        //添加指示器
        addIndicator:function(){
            if(this.items){
                array.forEach(this.items,function(item,idx){
                    var li = domConstruct.create("li",{},this.dot);
                    if(0==idx){
                        domClass.add(li,"active");
                        if(this.showTitle)  this.setTitle(this.titleField?item[this.titleField]:idx+1);
                    }
                },this);
            }
        },
        //设置图片标题
        setTitle:function(title){
            this.title.innerHTML = title;
        },
        //调整导航图片
        fitNavImage:function(){
            // 所有项的总宽度
            this._totalNavSize = this._navSize* this._total;
            var wrapperWidth = domStyle.get(this.wrapper,"width"),navBarWidth = Math.min(this._navSize*this._navNum,wrapperWidth);
            this._navNum = Math.min(Math.floor(wrapperWidth / this._navSize),this._total);
            domStyle.set(this.navsBar,"width", navBarWidth + "px");
            domStyle.set(this.navsBar,"margin-left",(wrapperWidth-navBarWidth)/2+"px");
            domStyle.set(this.navs,"width", this._totalNavSize + "px");
            this._start = 0;
            this._end = this._navNum -1;
            this._navBarItems = this.navs.children;
            for(var i=0;i<this.navs.children.length;i++){
                domAttr.set(this.navs.children[i],"idx",i);
                domAttr.set(this.navs.children[i].children[0],"idx",i);
                if(!has("touch")) connect.connect(this.navs.children[i],"onmouseover",this,this._selectPanel);
                else connect.connect(this.navs.children[i],"onclick",this,this._selectPanel);
            }
            domStyle.set(this.navs,"left","0px");
        },
        //调整导航按钮
        fitNavBtn:function(){
        },
        //调整大小
        fitSize:function(){
            this.fitWrapper();
            this.fitNavImage();
            this.fitNavBtn();
            //this.fitPlayBtn();
        },
        //调整容器大小
        fitWrapper:function(){
            if(this.panelsWidth){
                domStyle.set(this.wrapper,"width",this.panelsWidth + "px");
            }
            if(this.panelsHeight){
                domStyle.set(this.wrapper,"height",this.panelsHeight + "px");
            }else{
                domStyle.set(this.panels,"position","relative");
            }
        },
        fitPlayBtn:function(){
            setTimeout(lang.hitch(this,function(){
                domStyle.set(this.playBtn,"right",domGeom.getMarginBox(this.dot).w + "px");
            }),500);
        },
        //添加事件
        _initEvent:function(){
            if(!has("touch")) connect.connect(this.wrapper,"onmouseover",this,this._onIntoWrapper);
            if(!has("touch")) connect.connect(this.wrapper,"onmouseout",this,this._onOutWrapper);
            if(has("touch")) connect.connect(this.playBtn,"onclick",this,this._changeStatus);
            connect.connect(this.nextBtn,"onclick",this,this.showNext);
            connect.connect(this.prevBtn,"onclick",this,this.showPrev);
            if(has("touch")) connect.connect(this.wrapper,swipe.end,this,this.gestureSwipe);
            connect.connect(this.wrapper,"onclick",this,this.showBigImg);
            connect.connect(this.nextNav,"onclick",this,this.showNextNav);
            connect.connect(this.prevNav,"onclick",this,this.showPrevNav);
        },
        _changeStatus:function(e){
            if(e.target.innerHTML=="||"){
                this._onIntoWrapper();
                e.target.innerHTML = "▶";
                domStyle.set(this.playBtn,"right","0px");
            }
            else{
                this._onOutWrapper();
                e.target.innerHTML = "||";
                domStyle.set(this.playBtn,"right","5px");
            }
        },
        showNextNav:function(){
            this._scroll(this._navNum,1);
        },
        showPrevNav:function(){
            this._scroll(this._navNum,0);
        },
        //向指定方向滚动指定数量
        _scroll:function(number,direction){
            if(1==direction){
                this._start += number;
                this._end += number;
            }
            else{
                this._start -= number;
                this._end -= number;
            }
            var start = 0;
            for(var index=0;index<this._start;index++){
                start = domStyle.get(this._navItems[index],"width");
            }
            this._doScrolling(start);
        },
        //滚动
        _doScrolling: function(newLeft) {
            for(var index=this._start;index<=this._end;index++){
                query("img",this._navItems[index])[0].src = this.items[index][this.srcField];
            }
            var left = domStyle.get(this.navsBar,"width")-this._navsWidth*(this._end-this._start+1)
            animation.animate(this.navs,{
                    left: newLeft+left/2
                },
                {callback: lang.hitch(this,function(e) {
                    domStyle.set(this.prevNav,"display",this._start<=0?"none":"");
                    domStyle.set(this.nextNav,"display",this._end>=this.items.length-1?"none":"");
                })}
            );
        },
        //选中指定面板
        _selectPanel:function(e){
            if(!domClass.contains(e.target,"__navItem")&&!domClass.contains(e.target.parentNode,"__navItem")) return;
            var i = parseInt(domAttr.get(e.target,"idx"),10);
            e.newIndex = i % this._total;
            e.oldIndex = this._current;
            this.show(e.newIndex);
        },
        //显示大图
        showBigImg:function(e){
            if(!domClass.contains(e.target,"__showBigImg")) return;
            var items = array.map(this.items,function(item){
                return {src:item[this.srcField]};
            },this),index = this._current;
            require(["cq/widgets/bigImg"],function(bigImg){
                bigImg.show(items,index);
            });
        },
        //隐藏大图
        hideBigImg:function(e){
            setTimeout(lang.hitch(this,function(){
                domStyle.set(this.bigImg,"display","none");
            }),0);
        },
        //滑动切换图片
        gestureSwipe:function(e){
            if(e.dx>50){
                this.showPrev();
            }else if(e.dx<-50){
                this.showNext();
            }
        },
        //显示下一张图片
        showNext:function(){
             this.show(this._current + 1, 1);
        },
        //显示上一张图片
        showPrev:function(){
            this.show(this._current - 1, -1);
        },
        //进入容器
        _onIntoWrapper:function(){
            var top = (domStyle.get(this.wrapper,"height")-50)/2+"px";
            domStyle.set(this.prevBtn,{
                "display":"",
                top:top
            });
            domStyle.set(this.nextBtn,{
                "display":"",
                top:top
            });
            this.showNavControl();
            this.pause();
        },
        showNavControl:function(){
            this._start = Math.max(0,Math.floor(this._current-this._navNum/2+0.5)-1);
            if(this._start+this._navNum>this._panelItems.length-1){
                this._end = this._panelItems.length-1;
                this._start = Math.max(0,this._end-this._navNum);
            }else{
                this._end = this._start+this._navNum;
            }
            domStyle.set(this.navControl,"display","block");
            this._scroll(0,0);
        },
        //离开容器
        _onOutWrapper:function(){
            domStyle.set(this.prevBtn,"display","none");
            domStyle.set(this.nextBtn,"display","none");
            domStyle.set(this.navControl,"display","none");
            this.play();
        },
        //显示指定位置图片,dir移动方向1:右移,0:左移
        show: function(i, direction) {
            if(false===this._transiting&&this._panelItems&&this._panelItems.length&&(i = (i+this._panelItems.length)%this._panelItems.length)!==this._current){
                query("img",this._panelItems[i])[0].src = this.items[i][this.srcField];
                if (!direction) { direction = i > this._current ? 1 : 0; }
                // 生成事件属性
                var evtProps = {
                    newIndex: i,
                    newPanel: this._panelItems[i],
                    direction: direction
                };
                if (this._current != null) {
                    evtProps.oldIndex = this._current;
                    evtProps.oldPanel = this._panelItems[this._current];
                }
                this.onBeforeShow(evtProps);
                this._show(i,direction,evtProps);
                this._current = i;
                this.onAfterShow(evtProps);
            }
        },
        //显示图片前触发
        onBeforeShow:function(){
        },
        //显示图片后触发
        onAfterShow:function(e){
            array.forEach(this._navBarItems,function(item,index){
                domClass.toggle(item,"slideshow-nav-current",index===this._current);
            },this);
            if(e.oldIndex||e.oldIndex===0) domClass.remove(this.dot.children[e.oldIndex],"active");
            domClass.add(this.dot.children[e.newIndex],"active");
            if(this.showTitle)  this.setTitle(this.titleField?this.items[e.newIndex][this.titleField]:e.newIndex+1);
            if(!this.lazy)this.activate(e);
        },
        //激活导航
        activate:function(e){
            var index = e.newIndex;
            if (this._navCurrent == index) { return; }
            for(var i=0;i<this._navBarItems.length;i++){
                var idx = parseInt(domAttr.get(this._navBarItems[i],"idx"),10);
                if(idx%this._total==index) domClass.add(this._navBarItems[i],"slideshow-nav-current");
                else domClass.remove(this._navBarItems[i],"slideshow-nav-current");
            }
            this._navCurrent = index;
        },
        //显示图片
        _show:function(i,direction,e){
            var fromNode = this._panelItems[this._current||0],toNode = this._panelItems[i];
            if(this._current||0===this._current){
                this._transiting = true;
                if(config['mblCSS3Transition']){
                    var toPosition = domStyle.get(toNode, "position");
                    domStyle.set(toNode, "position", "absolute");
                    transitDeferred.then(lang.hitch(this, function(transit){
                        transit(fromNode, toNode, {transition: this.effect, reverse: (1===direction)?false:true}).then(lang.hitch(this,function(){
                            this._transiting = false;
                            array.forEach(toNode.parentNode.children,function(node){
                                if(node!==toNode){
                                    domStyle.set(node,"display","none");
                                }
                            });
                            domStyle.set(toNode, "position", toPosition);
                            if(this._isAutoPlay){
                                this.play();
                            }
                            this.onCompleteshow(e);
                        }));
                    }));
                }else{
                    if(this.effect.indexOf("cube") != -1){
                        if(has('ipad')){
                            domStyle.set(toNode.parentNode, {webkitPerspective:1600});
                        }else if(has("ios")){
                            domStyle.set(toNode.parentNode, {webkitPerspective:800});
                        }
                    }
                    var fromOrigin = "50% 50%";
                    var toOrigin = "50% 50%";
                    var scrollTop, posX, posY;
                    domStyle.set(fromNode, css3.add({}, {transformOrigin:fromOrigin}));
                    domStyle.set(toNode, css3.add({}, {transformOrigin:toOrigin}));
                    domStyle.set(fromNode,"display","none");
                }
            }
            domStyle.set(toNode,"display","");
            this._transiting = false;
            if(this._isAutoPlay){
                this.play();
            }
            this.onCompleteshow(e);
            /*if("fade"==this.effect){
                this.fade(i,direction,e);
            }
            else if("slide"==this.effect){
                this.slide(i,direction,e);
            }*/
        },
        //滑动效果
        slide:function(i,direction,e){
            var panels = this.panels.cloneNode(false);
            var targetLeft;
            if (this._current == null) {
                domConstruct.place(this._panelItems[this._panelItems.length-1],panels);
                domConstruct.place(this._panelItems[0],panels);
                if(this.items.length>1)
                    domStyle.set(panels,"left","-100%");
                else
                    domStyle.set(panels,"left","0px");
            } else {
                if (direction) {    // 下一张方向
                    domConstruct.place(this._panelItems[this._current],panels);
                    domConstruct.place(this._panelItems[i],panels);
                    domStyle.set(panels,"left",0 + "px");
                    targetLeft = -domStyle.get(this.wrapper,"width");
                } else {    // 上一张方向
                    domConstruct.place(this._panelItems[i],panels);
                    domConstruct.place(this._panelItems[this._current],panels);
                    domStyle.set(panels,"left", "-100%");
                    targetLeft = 0;
                }
            }
            domConstruct.place(panels,this.panels,"replace");
            if (targetLeft != null) {
                animation.animate(panels,{
                    left: targetLeft
                }, this.genAnimateOptions(e));
            }
            this.panels = panels;
        },
        //渐变
        fade:function(i,direction,e){
            var panelItems = this._panelItems;
            if (this._current == null) {
                array.forEach(this._panelItems,function(item,idx){
                    domStyle.set(item,"opacity",idx?0:1);
                    domStyle.set(item,"left",0);
                    domStyle.set(item,"top",0);
                    domStyle.set(item,"position",0);
                    domStyle.set(item,"display",idx?"none":"block");
                },this);
            } else {
                animation.animate(this._panelItems[this._current],{
                    opacity: 0,
                    display: 'none'
                }, this.genAnimateOptions());
                animation.animate(this._panelItems[i],{
                    opacity: 1,
                    display: 'block'
                }, this.genAnimateOptions(e));
            }
        },
        //完成动画
        onCompleteshow:function(e){
            if(this.lazy){
                if(e.newIndex > this._end)this._scroll(this._navNum,1);
                if(e.newIndex < this._start) this._scroll(this._navNum,0);
            }
        },
        //注册动画回调函数
        genAnimateOptions:function(e){
            return lang.mixin(e ? {
                    callback: lang.hitch(this,function() {
                        this.onCompleteshow(e);
                    })
                }:{
                },{
                    overwrite: false
                }
            );
        },
        destroyRecursive:function(){
            this.pause();
            this.inherited(arguments);
        }
    });
});