﻿define([
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/_base/array",
    "dojo/_base/event",
    "dojo/_base/window",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/touch",
    "cq/util/css/transformUtil"
],function(lang,connect,array,event,win,domAttr,domConstruct,domStyle,touch,transformUtil){
    domConstruct.create("style",{
        innerHTML:".bigImgPageDiv{position:absolute;bottom:0;width:100%;height:4px;background-color:black;}.bigImgPage{height:100%;background-color:#f68005;}"
    },document.head,"first");
    return lang.mixin(lang.getObject("cq.widgets.bigImg",true),{
        //初始化图片信息
        _setUrl:function(url,index){
            //支持原来的调用方式
            if(lang.isString(url)){
                url = [{
                    src:url
                }];
            }
            //当前要显示的图片列表
            this._url = url;
            //当前要显示的图片的序号
            this._curIndex = index>0?index:0;
        },
        //初始化当前页面
        _initImage:function(node,index){
            domAttr.set(node,"style","position:absolute;left:"+this.dw+"px");
            domAttr.set(node,"src","data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAIAAAACCAYAAABytg0kAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsQAAA7EAZUrDhsAAAAGYktHRAD/AP8A/6C9p5MAAAAHdElNRQfdBwoCFRp2ulIlAAAAGUlEQVQYV2Pct2/ffwYgYPr58yfDz58/GQBO9gkTNKGFEwAAAABJRU5ErkJggg==");
            node._bigImageLoading = true;
            node._bigImageOrgSize = null;
            domAttr.set(node,"src",this._url[index].src);
        },
        //获取下一张图片的序号
        _getImageIndex:function(inc){
            var nextIndex = this._curIndex+inc;
            if(nextIndex>=this._url.length){
                nextIndex = 0;
            }else if(0>nextIndex){
                nextIndex = this._url.length-1;
            }
            return nextIndex;
        },
        //隐藏大图
        hide:function(){
            if(this.imgDiv&&this.imgDiv.parentNode){
                this.imgDiv.parentNode.removeChild(this.imgDiv);
            }
        },
        //显示大图
        show:function(url,curIndex){
            if(!this.imgDiv){
                this._initElement();
            }
            //初始化图片地址
            this._setUrl(url,curIndex);
            if(this._url.length){
                //当前页面的尺寸
                this.dw = domStyle.get(document.body,"width");
                this.dh = domStyle.get(document.body,"height");
                //初始化界面上图片的内容
                this._initImage(this._preImageNode,this._getImageIndex(-1));
                this._initImage(this._curImageNode,this._curIndex);
                this._initImage(this._nextImageNode,this._getImageIndex(1));
                //界面显示到界面中
                document.body.appendChild(this.imgDiv);
                //依据条件判断是否显示标题区域
                this._updatePageShow();
            }
        },
        //初始化图片相关界面元素
        _initElement:function(){
            if(!this.imgDiv){
                //图片父容器
                this.imgDiv = domConstruct.create("div",{
                    style:"position:absolute;top:0;left:0;background-color:black;z-index:999;display:block;width:100%;height:100%;"
                });
                //前一图片
                this._preImageNode = domConstruct.create("img",{
                    onload:lang.hitch(this,this.onImageLoad)
                },this.imgDiv);
                //当前图片
                this._curImageNode = domConstruct.create("img",{
                    onload:lang.hitch(this,this.onImageLoad)
                },this.imgDiv);
                //备选图片
                this._nextImageNode = domConstruct.create("img",{
                    onload:lang.hitch(this,this.onImageLoad)
                },this.imgDiv);
                //单击关闭显示大图
                /*connect.connect(this.imgDiv,"onclick",this,function(){
                    if(this._cancelClick){
                        this._cancelClick = false;
                    }else{
                        this.hide();
                    }
                });*/
                //标题显示框
                this._pageDivNode = domConstruct.create("div",{
                    "class":"bigImgPageDiv"
                },this.imgDiv);
                //序号显示框
                this._pageNode = domConstruct.create("div",{
                    "class":"bigImgPage"
                },this._pageDivNode);
                //处理拖动和缩放
                touch.press(this.imgDiv,lang.hitch(this,function(e){
                    this._touchTimer = new Date();
                    this.onTouchStart.apply(this,arguments);
                }));
                touch.move(this.imgDiv,lang.hitch(this,this.onTouchMove));
                touch.release(this.imgDiv,lang.hitch(this,function(e){
                    //赵春辉    解决在手机上点击不能退出的问题    2016-04-19
                    if((new Date())-this._touchTimer<300){
                        this.hide();
                    }
                }));
            }
        },
        _updatePageShow:function(){
            domStyle.set(this._pageNode,{
                width:Math.floor(this.dw/this._url.length)+"px",
                "margin-left":Math.floor(this.dw/this._url.length*this._curIndex)+"px"
            });
        },
        //当图片加载完成之后需要处理图片的缩放和位置
        onImageLoad:function(e){
            var node = e.target;
            if(!node._bigImageOrgSize){
                var w = node.width,h = node.height;
                //图片原始大小
                node._bigImageOrgSize = {
                    w:w,
                    h:h
                };
            }
            node._bigImageOrgSize.scale = 1/Math.max(node._bigImageOrgSize.w/this.dw,node._bigImageOrgSize.h/this.dh,1);
            node._bigImageOrgSize.l = (
                node===this._curImageNode?0:node===this._preImageNode?-1*this.dw:this.dw
            )+(this.dw-node._bigImageOrgSize.w*node._bigImageOrgSize.scale)/2;
            node._bigImageOrgSize.t = (this.dh-node._bigImageOrgSize.h*node._bigImageOrgSize.scale)/2;
            this._updateNodeTransition(node);
            node._bigImageLoading = false;
        },
        _updateNodeTransition:function(node){
            domStyle.set(node,lang.mixin({
                position:"absolute",top:0,left:0,
                width:Math.floor(node._bigImageOrgSize.scale*node._bigImageOrgSize.w)+"px"
            },transformUtil.getTransformStyle(transformUtil.getTranformStr(Math.floor(node._bigImageOrgSize.l)+"px",Math.floor(node._bigImageOrgSize.t)+"px","0"))));
        },
        //赵春辉    以下内容大部分从cqthink.mobile.imgPrc.selector中复制过来的    2015-07-31
        //获取两点之间的距离
        getDistance:function(pos1,pos2){
            //获取两点之间的距离
            return Math.sqrt((pos1.x-pos2.x)*(pos1.x-pos2.x)+(pos1.y-pos2.y)*(pos1.y-pos2.y));
        },
        _scaleImg:function(center,scale){//alert(scale)
            if(scale!==1){
                var orgSize = this._curImageNode._bigImageOrgSize;
                //scale = orgSize.scale*scale;
                orgSize.l += (center.x-orgSize.l)*(1-scale);
                orgSize.t += (center.y-orgSize.t)*(1-scale);
                orgSize.scale *= scale;
            }
        },
        _setDuration:function(ms){
            var style = transformUtil.getDurationStyle(ms);
            array.forEach([this._preImageNode,this._curImageNode,this._nextImageNode],function(node){
                domStyle.set(node,style);
            });
        },
        //按下
        onTouchStart:function(e){
            if(this._touchEndHandler){
                this._touchEndHandler.remove();
            }
            this._touchEndHandler = touch.release(win.doc,lang.hitch(this,this.onTouchEnd));
            //手指或鼠标按下时的响应函数，可能是拖动也可能是缩放
            this.draging = true;
            this.startPos = {x:e.touches?e.touches[0].pageX:e.pageX,y:e.touches?e.touches[0].pageY:e.pageY};
            this.startPos2 = e.touches&&e.touches.length>1?{x:e.touches[1].pageX,y:e.touches[1].pageY}:null;
            this.startPos3 = this.startPos2?{
                x:(this.startPos.x+this.startPos2.x)/2,
                y:(this.startPos.y+this.startPos2.y)/2
            }:this.startPos;
            event.stop(e);
        },
        //拖动
        onTouchMove:function(e){
            //手指或鼠标移动的响应函数，调整图片的位置，或者调整图片的大小与位置
            if(this.draging){
                var orgSize = this._curImageNode._bigImageOrgSize;
                this._cancelClick = true;
                var curPos = {
                    x:e.touches?e.touches[0].pageX:e.pageX,
                    y:e.touches?e.touches[0].pageY:e.pageY
                };
                if(e.touches&&e.touches.length>1&&this.startPos2){
                    try{
                        curPos = {
                            x:(e.touches[0].pageX+e.touches[1].pageX)/2,
                            y:(e.touches[0].pageY+e.touches[1].pageY)/2
                        };
                        //手势缩放，若是放大，不能大于图片的原始大小，若缩小，不能小于要选择的区域
                        var d = this.getDistance({x:e.touches[0].pageX,y:e.touches[0].pageY},{x:e.touches[1].pageX,y:e.touches[1].pageY}),od = this.getDistance(this.startPos,this.startPos2);
                        //执行缩放操作
                        this._scaleImg({
                            x:(this.startPos.x+this.startPos2.x+e.touches[0].pageX+e.touches[1].pageX)/4,
                            y:(this.startPos.y+this.startPos2.y+e.touches[0].pageY+e.touches[1].pageY)/4
                        },Math.max(Math.min(d/od,1/orgSize.scale),1/Math.max(orgSize.w/this.dw,orgSize.h/this.dh,1)/orgSize.scale));
                    }catch(ee){
                        alert(ee.message);
                    }
                }else{
                    var x = curPos.x-this.startPos3.x,y = curPos.y-this.startPos3.y;
                    if(x===0&&y===0){
                        return;
                    }
                    //拖动
                    orgSize.l += x;
                    orgSize.t += y;
                    if(orgSize.h*orgSize.scale<this.dh){
                        orgSize.t = (this.dh-orgSize.h*orgSize.scale)/2;
                    }else if(orgSize.t>0){
                        orgSize.t = 0;
                    }else if(orgSize.t+orgSize.scale*orgSize.h<this.dh){
                        orgSize.t = this.dh-orgSize.scale*orgSize.h;
                    }
                }
                this._updateNodeTransition(this._curImageNode);
                this._updatePreNextImag();
                this.onTouchStart(e);
            }
        },
        _updatePreNextImag:function(){
            var orgSize = this._curImageNode._bigImageOrgSize,w = 0;
            if(orgSize.w*orgSize.scale<this.dw){
                w = orgSize.l-(this.dw-orgSize.w*orgSize.scale)/2;
            }else if(orgSize.l>0){
                w = orgSize.l;
            }else if(orgSize.l+orgSize.scale*orgSize.w<this.dw){
                w = orgSize.l+orgSize.scale*orgSize.w-this.dw;
            }
            if(w>0){
                this._preImageNode._bigImageOrgSize.l = w-this.dw;
                this._nextImageNode._bigImageOrgSize.l = this.dw;
            }else{
                this._preImageNode._bigImageOrgSize.l = -1*this.dw;
                this._nextImageNode._bigImageOrgSize.l = w+this.dw;
            }
            this._updateNodeTransition(this._preImageNode);
            this._updateNodeTransition(this._nextImageNode);
        },
        //释放
        onTouchEnd:function(e){
            if(this._touchEndHandler){
                this._touchEndHandler.remove();
            }
            //手指或鼠标松开的响应，结束拖动或缩放
            this._setDuration(300);
            this.draging = false;
            var node = null,curSize = this._curImageNode._bigImageOrgSize,nodes = [this._preImageNode,this._curImageNode,this._nextImageNode];
            //拖动完成，处理显示隐藏以及当前图片的切换，显示前一个
            if(curSize.l+curSize.w*curSize.scale/2<this.dw*1/6&&this.dw*2/3>curSize.l+curSize.w*curSize.scale){
                this._curIndex = this._getImageIndex(1);
                node = this._preImageNode;
                this._preImageNode = this._curImageNode;
                this._curImageNode = this._nextImageNode;
                this._nextImageNode = node;
                this._initImage(this._nextImageNode,this._getImageIndex(1));
                nodes = [this._preImageNode,this._curImageNode];
            }else if(curSize.l+curSize.w*curSize.scale/2>this.dw*2/3&&curSize.l>this.dw/3){
                this._curIndex = this._getImageIndex(-1);
                node = this._nextImageNode;
                this._nextImageNode = this._curImageNode;
                this._curImageNode = this._preImageNode;
                this._preImageNode = node;
                this._initImage(this._preImageNode,this._getImageIndex(-1));
                nodes = [this._curImageNode,this._nextImageNode];
            }else{
                if(curSize.w*curSize.scale<this.dw){
                    curSize.l = (this.dw-curSize.w*curSize.scale)/2;
                }else if(curSize.l>0){
                    curSize.l = 0;
                }else if(curSize.l+curSize.w*curSize.scale<this.dw){
                    curSize.l = this.dw-curSize.w*curSize.scale;
                }
                nodes = [this._preImageNode,this._nextImageNode];
                this._updateNodeTransition(this._curImageNode);
            }
            array.forEach(nodes,function(node){
                this.onImageLoad({target:node});
            },this);
            //alert(dojo.toJson(this._curImageNode._bigImageOrgSize));
            //显示后一个
            setTimeout(lang.hitch(this,function(){
                this._setDuration(0);
            }),300);
            this._updatePageShow();
        }
    });
});