﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dijit/_WidgetBase",
    "cq/util/sys/date"
],function(declare,array,domConstruct,_WidgetBase,date){
    return declare("cq.widgets.item.OrderListItem", [_WidgetBase], {
        baseClass:"order-list-item",
        params:null,
        buildRendering:function(){
            this.inherited(arguments);
            var countQty = 0;
            //创建订单状态栏
            domConstruct.create("div",{
                "class":"order-list-status",
                innerHTML:"<div><span class='date'>创建时间:"+
                    date.formatISODateMinutes(this.params.createAt)+
                    "</span>"+
                    "<span class='status'>"+this.getOrderStatus()+"</span></div>"
					+"<div class='date none order-dname'><span>收货人:"+this.params.details[0].dName+"</span><span style='float:right;padding-right:12px'>"+ this.params.details[0].dTel +"</span></div>"
					+"<div class='date none order-dAddress'><span>收货地址:"+this.params.details[0].dAddress+"</span></div>"
            },this.domNode);
            this.detailList = domConstruct.create("div",{
                "class":"order-detail-list"
            },this.domNode);
            array.forEach(this.params.details,function (detail){
                countQty+=detail.qty;
                this.detailList.appendChild(this.createDetails(detail));
            },this);
            this.countNode = domConstruct.create("div",{
                "class":"order-list-count",
                innerHTML:"<span class='qty'>共"+countQty+"件商品</span>"+
                    "<span class='count'>合计:<i>￥"+window.fixedTo(this.params.amount,3)+"<i></span>"+
                    "<span class='tAmount'>（含运费：￥"+window.fixedTo(this.params.tAmount,3)+"）</span>"
            },this.domNode);
        },//添加运费信息，style.css新建tAmount样式   2016/7/8 徐阿雪
        //创建订单详情的列表
        createDetails:function(data){
            var htmlStr = "";
            htmlStr+='<li class="order-detail-item">';
            htmlStr+=    '<img alt="" src="'+data.mId.logo+'" class="icon" style="margin-top: 1px;">';
            htmlStr+=    '<div class="right" style="display: block;">';
            htmlStr+=       '<div class="shelf-mat-title">'+data.mId.mName+'</div>';
            htmlStr+=        '<div><span class="price">￥'+window.fixedTo(data.price,3)+'</span><span class="qty">x'+data.qty+'</span></div>';
            htmlStr+=    '</div>';
            htmlStr+='</li>';
            return domConstruct.toDom(htmlStr);
        },
        //获取订单的状态
        getOrderStatus:function(){
            // 将orderStatus的状态按照优先级显示已退款问题修复  2016/7/6  徐阿雪 
            // 已退款是根据主表的已支付和已取消来重新定义
            var state = "",data = this.params;
            if(data.isPayed){
                //已付款
                if(data.isCanceled){
                    //已付款且已取消，则为已退款
                    state = "已退款";
                }else if(data.isDelived){
                    //已发货
                    if(data.isClosed){
                        //若已关闭，则为已完成
                        state = "已完成";
                    }else if(!data.isReceipted){
                        //若未收货，为待收货
                        state = "待收货";
                    }else{
                        //否则，待评价，评价完成之后会变成已完成
                        state = "待评价";
                    }
                }else{
                    //否则为待发货
                    state = "待发货";
                }
            }else{
                //未付款
                if(data.isCanceled){
                    //已取消
                    state = "已取消";
                }else{
                    //待付款
                    state = "待付款";
                }
            }
            return state;
        }
    });
});