﻿// 变更人：徐阿雪
// 变更时间：2016/08/02
// 变更内容：继承OrderListItem 重写订单状态
define([
    "dojo/_base/declare",
    "cq/widgets/item/OrderListItem",
],function(declare,OrderListItem){
    return declare("cq.widgets.item.OrderListItemB", [OrderListItem], {
        //重写获取订单状态
        getOrderStatus:function(){
            // 将orderStatus的状态按照优先级显示已退款问题修复  2016/7/6  徐阿雪 
            // 已退款是根据主表的已支付和已取消来重新定义
            var state = "",data = this.params;
            if(data.isPayed){
                //已付款
                if(data.isCanceled){
                    //已付款且已取消，则为已退款
                    state = "已退款";
                }else if(data.isDelived){
                    //已发货
                    if(data.isClosed){
                        //若已关闭，则为已完成
                        state = "已完成";
                    }else if(!data.isReceipted){
                        //若未收货，为待收货
                        state = "待收货";
                    }else{
                        //否则，待评价，评价完成之后会变成已完成
                        state = "待评价";
                    }
                }else if(data.isAccepted){
                    //否则为待发货
                    state = "待发货";
                }else{
                    state = "待审核";
                }
            }else{
                //未付款
                if(data.isCanceled){
                    //已取消
                    state = "已取消";
                }else{
                    //待付款
                    state = "待付款";
                }
            }
            return state;
        }
    });
});