define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "cq/util/sys/date"
],function(lang,array,date){
    return lang.mixin(lang.getObject("cq.widgets.item.itemProp",true),{
        //初始化用于评价列表的数据的属性
        initMatEvaData:function(data){
            //遍历所有数据，初始化数据的属性
            array.forEach(data,function(eva){
                //用户信息
                if(!eva.userId){
                    eva.userId = {};
                }
                eva.userId.logo = eva.userId.logo||"/static/images/mobile/user_userIcon.png";
                eva.userId.userName = eva.userId.userName||"";
                eva.content = eva.content||"";
                //评价列表显示内容
                eva._label="<div class='userInfo'><img class='userlogo' src='"+eva.userId.logo+"'><span>"+eva.userId.userName+"</span><div class='ratingdiv'></div></div>"
                    +"<div class='userEva font-size1'>"+eva.content+"</div>";
                if(eva.images){
                    eva._label += "<div class='evalimages'>";
                    array.forEach(eva.images,function(image){
                        eva._label += "<img src='"+image+"'>";
                    });
                    eva._label += "</div>";
                }
                //评价时间追加显示为时分秒
                eva._label += "<div class='evaDate'>"+(date.formatISODateMinutes(eva.createAt))+"</div>";
            });
        },
        //将评论列表中的得分信息转换为dojox.mobile.Rating
        initEvalistRating:function(list){
            //加载dojox.mobile.Rating
            require([
                "dojo/query",
                "dojox/mobile/Rating"
            ],function(query,Rating){
                //便利列表的所有孩子
                array.forEach(list.getChildren(),function(item){
                    //若没有创建rating
                    if(!item.ratingCreated){
                        //标记为已创建
                        item.ratingCreated = true;
                        //创建
                        (new Rating({
                            image: "/static/common/images/xin2.png",
                            numStars: 5,
                            value:item.params.score
                        },query(".ratingdiv",item.domNode)[0])).startup();
                    }
                });
            });
        },
        //赵春辉   将查询到的商品数据整理成货架需要的数据格式   2016-07-27
        initMatBox:function(data){
            for(var i=0;i<data.data.items.length;i++){
                data.data.items[i].icon=data.data.items[i].logo;
                data.data.items[i].title= "<div class='shelf-mat-title'>"+data.data.items[i].mName+"</div>";
                data.data.items[i].title+= "<div class='shelf-mat-price-normal'>"+"¥"+window.fixedTo(data.data.items[i].retailPrice,3)+"</div>"
                data.data.items[i].title+= "<div class='shelf-mat-title'>"+"规格:"+data.data.items[i].sizeType+"</div>"
                data.data.items[i].url="#matDetail-"+data.data.items[i]._id;
            }
        }
        //创建滚轮区域
        
    });
});