define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojox/mobile/View",
        "dojo/dom-construct",
        "dojo/dom-style",
        "dojo/dom-attr",
        "dojo/dom-class",
        "dojo/query",
		"dojo/_base/array",
        "dojo/on",
        "dijit/registry",
        "dojox/mobile/EdgeToEdgeStoreList",
        "cq/ui/view/_ViewMixin",
		"dojo/store/JsonRest",
        "cq/biz/shop/cm/shopStore",
        "cq/biz/user/user",
        "cq/util/config/config"
    ], function (declare, lang, View, domConstruct, domStyle, domAttr, domClass, query, array, on, registry, EdgeToEdgeStoreList, _ViewMixin, JsonRest, shopStore, user, config) {
    return declare("whz.view.AttentionShopList", [View, _ViewMixin], {
        start : 0,
		pageSize : 10,
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick:function(){
                        history.back();
                    }
                },
                title : "关注供应商列表"
            };
            this.addHeader(option);
			this.storeList = new EdgeToEdgeStoreList({
                append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){
						array.forEach(config.shopType,function(item){
                            if(data[i].shopType==item.typeCard){
                                data[i].shopType = item.typeName;
                            }
                        });
                        data[i]._label = "<div>"
                            +"<div>"
                            +"<div class='user-list-left user-list-margin'>店铺名称:"+(data[i].targetShopId&&data[i].targetShopId.shopName||"")+"</div>"
                            +"</div><div>"
                            //+"<div class='user-list-left user-list-margin'>店铺类型:"+(data[i].shopType||"")+"</div>"
                            +"<div class='hflex'><div class='user-list-left user-list-margin'>销量:"+(data[i].targetShopId&&data[i].targetShopId.saleAmount||0)+"</div>"
                            +"<div class='user-list-margin'>商品数:"+(data[i].targetShopId&&data[i].targetShopId.shopMatNum||"0")+"</div></div>"
                            +"</div>"
                            +"<div class='attention-btn attentioned' style='width: 64px;float: right;'>取消关注</div>";
                        //data[i]._logo = data[i].targetShopId.logo?data[i].targetShopId.logo:'images/userIcon.png';
                        data[i]._logo = data[i].targetShopId&&data[i].targetShopId.logo?data[i].targetShopId.logo:'images/userIcon.png';
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions: {
					count: this.pageSize,
					start: this.start
					},
				itemMap:{_label:"label",_logo:"icon", moveTo:"moveTo"}
            });
            this.params={};
			this.store = new JsonRest({target:shopStore.getShopListUrl()});
			this.storeList.setStore(this.store,this.params);

			this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
        },
        onClickList:function(evt){
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
            var target = evt.target;
            if(domClass.contains(target, "attention-btn")){
                if(domClass.contains(target, "attentioned")){
                    shopStore.shopStoreCancel({
                        targetShopId:li.params.targetShopId._id
                    }).then(lang.hitch(this, function(data){
                        if(data.data.ok){
                            alert("取消关注成功");
                            domClass.remove(target, "attentioned");
                            domClass.add(target, "notAttentioned");
                            target.innerHTML = "未关注";
                        }
                    }));
                }else{
                    shopStore.shopStore({
                        targetShopId:li.params.targetShopId._id
                    }).then(lang.hitch(this, function(data){
                        if(data.data.ok){
                            alert("关注成功");
                            domClass.remove(target, "notAttentioned");
                            domClass.add(target, "attentioned");
                            target.innerHTML = "已关注";
                        }
                    }));
                }
                return;
            }
			var _id = li.params.targetShopId._id;
			window.moveToView("supplyBus",_id);
		},
        onLoadMore:function(evt){
			if(this.busy||(0<this.end&&(this.start+this.pageSize-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多商家");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: this.pageSize
					}), lang.hitch(this,function(){
						this.centerPanel.resize();
					}));
				}), 1000);
			}
		},
		onAfterShow : function () {
			this.setQuery(this.storeList.get("query"),{
				start: 0,
				count: this.pageSize
			});
		},
        setQuery: function(query) {
            this.start = 0;
            this.end = -1;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            });
            this.onLoadListData(queryResult, this.start, this.pageSize);
            this.centerPanel.resize();
        },
    });
});