// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/article/autoReply",
    "dijit/focus"
], function(declare, lang, array, View, _ViewMixin, registry, EdgeToEdgeStoreList, on, when, JsonRest, autoReply, focusUtil) {
    'use strict';
    return declare("whz.view.AutoReply", [View, _ViewMixin], {
        // 设置初始显示第0行
        start: 0,

        onAfterShow: function() {
            // 重新加载数据并显示页面
            this.setQuery(this.storeList.get("query"), {
                start: 0,
                count: 10
            });
        },
        onCreatList: function() {
            // 创建列表
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item",
                variableHeight: true,
                //获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div class='webkit-list'>" + "<div class='user-list-left user-list-margin'>类型:" + this.parseRType(data[i].rType) + "</div>" + "<div class='user-list-right user-list-margin'>关键词:" + (data[i].keyword || "") + "</div>" + "</div>" + "<div class='webkit-list'>" + "<div class='user-list-margin'>回复内容:" + (data[i].replyText || "") + "</div>" + "</div>";
                        data[i].moveTo = "#";
                    }
                    this.storeList.generateList(data);
                    this.end = this.start + data.length - 1;
                    this.busy = false;
                }),
                itemMap: {
                    _label: "label",
                    logo: "icon"
                }
            });
            // 数据参数
            this.params = {};
            // 读取接口
            this.store = new JsonRest({
                target: autoReply.loadByShopId()
            });
            // 将数据源赋值给storeList
            this.storeList.setStore(this.store, this.params);
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            // 侦听点击事件
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            // 侦听列表下拉事件
            on(this.centerPanel, "afterscroll", lang.hitch(this, this.onLoadMore));
        },
        onFirstShow: function() {
            // 创建头部信息
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "自动回复"
            };
            this.addHeader(option);

            // 创建底部信息
            option = {
                columns: [{
                    label: '添加自动回复',
                    icon: 'images/icon/crmicon.png',
                    iconClass: 'width-16',
                    onClick: function() {
                        window.moveToView("autoReplyDetail");
                    }
                }],
                valueClass: 'font-size3',
                labelClass: 'font-size1',
                className: 'fix-footer',
                isFooter: true
            };
            this.addColumns(option);
            this.onCreatList();
        },

        onClickList: function(evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")
                return;
            var _tsId = li._id;
            window.moveToView("autoReplyDetail", _tsId);
        },

        // 重新赋值列表并刷新显示
        setQuery: function(query) {
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            this.storeList.setQuery(query, {
                start: this.start,
                count: 10
            });
            this.centerPanel.resize();
        },

        // 下拉列表加载更多
        onLoadMore: function(evt) {
            if (this.busy || (0 < this.end && (this.start + 10 - 1 > this.end))) {
                return true;
            }
            if (evt.afterBottom) {
                this.start = this.end + 1;
                this.busy = true;
                setTimeout(lang.hitch(this, function() {
                    when(this.storeList.setQuery(this.storeList.get("query"), {
                        start: this.start,
                        count: 10
                    }), lang.hitch(this, function() {
                        this.centerPanel.resize();
                    }));
                }), 1000);
            }
        },

        // 回复的类型
        parseRType: function(rTyId) {
            var type = "";
            var types = {
                '00000': '新会员关注自动回复',
                '99999': '找不到自动回复时的回复',
                '其他': '其他'
            };
            type = types[rTyId] || "未知";
            return type;

        }
    });
});
