// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/article/autoReply",
    "dijit/focus"
], function(declare, lang, array, View, _ViewMixin, autoReply, focusUtil) {
    "use strict";
    return declare("whz.view.AutoReplyDetail", [View, _ViewMixin], {

        // 是否编辑状态
        isEditing: false,

        onAfterShow: function() {
            // 如果是变更，加载自动回复信息
            if (!this.isEditing) {
                this.isEditing = true;
                if (!window.did) {
                    this.setData({
                        isUse: true
                    });
                    this.refreshData();
                } else {
                    // 读取接口
                    autoReply.loadById(window.did).then(lang.hitch(this, function(data) {
                        // 显示自动回复信息 加载信息
                        this.setData(data.data.item);
                        this.refreshData();
                    }));
                }
            }
        },

        onFirstShow: function() {

            // 创建头部信息
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function() {
                        history.back();
                    })
                },
                title: "自动回复设置",
                right: { iconButton: ' ', onClick: this.onSaveStore, label: "完成" }
            };
            this.addHeader(option);

            // 创建列表
            option = {
                isEdge: true,
                lists: [{
                    label: '触发条件',
                    rightText: '',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'options',
                        field: 'rType',
                        options: {
                            '00000': '新会员关注自动回复',
                            '99999': '找不到自动回复时的回复',
                            '其他': '其他'
                        }
                    }
                }, {
                    label: '回复类型',
                    rightText: '',
                    moveTo: "#",
                    __view_id: this.id,
                    edit: {
                        type: 'options',
                        field: 'replyType',
                        options: {
                            'text': '文本',
                            'image': '图片',
                            'aritcle': '图文'
                        }
                    }
                }, {
                    label: '回复主题',
                    noArrow: true,
                    edit: { type: 'text', field: 'keyword', placeHolder: '必填' }
                }, {
                    label: "回复图片",
                    noArrow: false,
                    edit: {
                        type: "image",
                        field: "imgUrl"
                    },
                    class: "li-icon",
                    moveTo: "#"
                }, {
                    label: '回复内容',
                    moveTo: "#",
                    edit: {
                        type: 'textarea',
                        field: 'replyText'
                    }
                }, {
                    label: '链接网址',
                    noArrow: true,
                    edit: { type: 'text', field: 'url' }
                }, {
                    label: '是否启用',
                    noArrow: true,
                    edit: { type: 'checkbox', field: 'isUse' }
                }]
            };
            this.addLists(option);
            this.onAfterShow();
        },

        // 保存信息
        onSaveStore: function() {

            // 当前节点失去焦点
            if (focusUtil.curNode) {
                focusUtil.curNode.blur();
            }
            // setTimeout 保存数据
            setTimeout(lang.hitch(this, function() {
                var m = this.getData();

                // 检查必填项是否已填
                var msg = this.verify(m);
                if (msg) {
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                autoReply.save(m).then(function() {
                    this.isEditing = false;
                    history.back();
                });
            }), 0);
        },

        // 验证选项是否填写
        verify: function(data) {
            var msg = "";
            if (!data.rType) {
                msg = "类型必须填写";
            }
            return msg;
        }
    });
});
