// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
define([
	"dojo/_base/declare", 
	"dojo/_base/lang", 
	"dojo/_base/array", 
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"cq/biz/article/mk/award",
	"dijit/focus"
    ],
    function(declare, lang, array, View, _ViewMixin, award, focusUtil) {
		return declare("whz.view.AwardsDetail", [ View, _ViewMixin ], { 
        
		// 是否编辑状态
        isEditing : false,      
		
        onAfterShow : function() {
			
			if (!this.isEditing) {
				this.isEditing = true;
				if(window.did){
					// 读取接口
					xxx.loadById(window.did).then(lang.hitch(this, function(data) {
						
						this.setData(data.data.item);
						this.refreshData();
					}));
				}
			}
        },
		
        onFirstShow : function() {
			
			// 创建头部信息
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : lang.hitch(this,function() {
						history.back();
					})
				},
				title : "奖项设置",
				right :
					{iconButton : ' ', onClick : this.onSaveStore, label : "完成"}
			};
			this.addHeader(option);
			
			// 创建列表
			option = {
				isEdge : true,
				lists : [{
						label : '奖品名称',
						noArrow : true,
						edit : {
							type : 'text', 
							field : 'awardName'
						}
					},
					{
						label : '奖品数量',
						noArrow : true,
						edit : {
							type : 'text', 
							field : 'awardNum'
						}
					},
					{
						label : '已中数量',
						noArrow : true,
						edit : {
							type : 'text', 
							field : 'handledNum'
						}
					},
					{
						label : '最新中奖时间',
						moveTo: "#", 
						edit : {
							type : 'date', 
							field : 'handleTime'
						}
					},
					{
						label:'奖品类型',
						rightText : '',
						moveTo : "#",
						__view_id : this.id,
						edit:{
							type:'options',
							field:'awardType',
							options:{
								0:'商城积分',
								1:'现金红包'
							}
						}
					},
					{
						label : '积分金额',
						noArrow : true,
						edit : {
							type : 'text', 
							field : 'awardAmount'
						}
					}]
			};
			this.addLists(option);
			this.onAfterShow();
        },
		
		// 保存信息
        onSaveStore : function() {

			// 当前节点失去焦点
			focusUtil.curNode&&focusUtil.curNode.blur();
			// setTimeout 保存数据
			setTimeout(lang.hitch(this, function(){
				var m = this.getData();					
				
				// 检查必填项是否已填
				// var msg=this.verify(m);
				// if(msg){
					// alert(msg);
					// this.isEditing = true;
					// return;
				// }					
				award.save(m).then(function() {
					this.isEditing = false;
					window.moveToView("luckyDrawDetail");
				});
			}), 0);
        },
		
		// 验证选项是否填写
		verify:function(data){
			var msg="";
			if(!data.awardName){
				msg="奖品名称必须填写";
			}
			if(!data.awardNum){
				msg="奖品数量必须填写";
			}
			if(!data.awardType){
				msg="奖品类型必须填写";
			}
			return msg;
		}
    });
});
