//  变更人:肖芳圆
//  变更时间:2016/9/6
//  变更原因:b2bBuy
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/Deferred",
    "dojo/topic",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/iconUtils",
	"cq/ui/view/_ViewMixin",
    "cq/biz/mat/sort",
    "cq/biz/mat/mat",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "cq/util/config/config",
    "cq/biz/ts/cart",
    "cq/biz/shop/partner"
], function (declare, lang, array, query, Deferred, topic, domConstruct, domClass, domStyle, domAttr, JsonRest, registry, _WidgetBase, View, FixedSplitter, Pane, ScrollablePane, EdgeToEdgeStoreList, iconUtils, _ViewMixin, sort, mat, shop, user, config, cart,partner) {
    var ProgressBar = declare('', [_WidgetBase], {
        'class' : "progress-bar",
        //进度
        progress : null,
        postCreate : function () {
            var progress = domConstruct.create("span",{
                'class' : "progress",
                style : "width:" + this.progress + "%;"
            }, this.domNode);
        }
    });
    //储存购物车分类的数量
    var groupCart = lang.mixin(lang.getObject("whz.view.Buy.groupCart", true),{
        mids : {},
        set : function (sortId, matId) {
            if (!this.mids[sortId]) {
                this.mids[sortId] = {};
            }
            this.mids[sortId][matId] = 0;
        },
        get : function () {
            var carts = cart.get(),
                groupCart = {};
            for (var sort in this.mids) {
                if (this.mids.hasOwnProperty(sort)) {
                    for (var mid in this.mids[sort]) {
                        if (this.mids[sort].hasOwnProperty(mid)) {
                            if(!groupCart[sort]){
                                groupCart[sort] = 0;
                            }
                            groupCart[sort] += carts[mid] || 0;
                        }
                    }
                }
            }
            return groupCart;
        }
    });
    var MatItem = declare("", [_WidgetBase], {
        //商品信息
        mat : null,
        //购物车中的数量
        qty : null,
        "class" : 'mat-list-item',
        postCreate : function () {
            this.createElement();
            this.indexElement();
            this.initEvent();
        },
        createElement : function () {
            var mat = this.mat,shopId = "";
            if(mat.fromShopId){
                if(mat.fromShopId._id){
                    shopId = "_"+mat.fromShopId._id;
                }else{
                    shopId = "_"+mat.fromShopId;
                }
            }
            //logo
            var matLink = domConstruct.create("a",{
                href : "#matDetail-" + mat._id + shopId,//mat.fromShopId?"_"+mat.fromShopId._id:""
                innerHTML : "<img src='" + mat.logo + "' />"
            }, this.domNode);
            var rightDiv = this.rightDiv = domConstruct.create("div",{
                'class' : 'right',
            },this.domNode);
            //标题
            domConstruct.create("div",{
                'class' : 'title',
                innerHTML : mat.mName + (mat.fromShopId&&mat.fromShopId.shopName ? "<a class='float-right shopName' style='color: #fff!important;' href='#supplyBus-" + mat.fromShopId._id +"'>"+ mat.fromShopId.shopName +"</a>" : "")
            },rightDiv);
            //加/减
            var carPart = this.carPart = domConstruct.create("div",{
                "class" : "carPart",
                innerHTML : "<div class='mblDomButtonRedCircleMinus'></div><div class='qtyDiv '><input value='0' type='tel' /></div><div class='mblDomButtonRedCirclePlus'></div>"
            }, rightDiv);
            //价格/规格
            var infoPart = domConstruct.create("div",{
                'class' : 'info',
                innerHTML : "<span class='price' style='color:#D35D13!important;'>￥" + window.fixedTo(mat.purchasePrice || 0, 3)  + "/" + mat.sizeType + "</span>"
            }, rightDiv);
        },
        indexElement : function () {
            this.minusBtn = iconUtils.createDomButton(query(".mblDomButtonRedCircleMinus",this.carPart)[0]);
            this.plusBtn = iconUtils.createDomButton(query(".mblDomButtonRedCirclePlus",this.carPart)[0]);
            this.qtyDiv = query('.qtyDiv',this.carPart)[0];
            this.qtyInput = query('input',this.carPart)[0];
        },
        initEvent : function () {
            //设置把商品放到对应的分类中去
            groupCart.set(this.mat.sortId, this.mat._id);
            //绑定+/-点击事件
            this.connect(this.carPart, "onclick", this.onCarPartClick);
            //输入数量事件
            this.connect(this.qtyInput, "oninput",function () {
                // TODO: 检查输入合法性
                if (this.qtyInput.value != '') {
                    var qty = Number(this.qtyInput.value) || 0;
                    this.changeCarQty(qty,true);
                }
            });
            //失去焦点的时候
            this.connect(this.qtyInput, "onblur",function () {
                if (this.qtyInput.value == '') {
                    this.changeCarQty(0,true);
                }
            });
            //购物车当前商品的数量
            this.qty = cart.get()[this.mat._id] || 0;
            this.minQty = this.mat.purchaseQty || 0;
            if (this.qty) {
                this.setCarPartHidden(false);
                this.qtyInput.value = this.qty;
            } else {
                this.setCarPartHidden(true);
            }
        },
        onCarPartClick : function (e) {
            var dom = e.target;
            while (dom && !domClass.contains(dom, "mblDomButton") && !domClass.contains(dom, "buy-group-list")){
                dom = dom.parentNode;
            }
            if (dom) {
                if (domClass.contains(dom, "mblDomButtonRedCirclePlus")) {
                    this.addCar(1);
                } else if (domClass.contains(dom, "mblDomButtonRedCircleMinus")) {
                    this.addCar(-1);
                }
            }
        },
        setCarPartHidden : function (hidden) {
            domClass[hidden ? "add" : "remove"](this.qtyDiv, "visibility");
            domClass[hidden ? "add" : "remove"](this.minusBtn, "visibility");
        },
        addCar :function (qty) {
            if (this.qty === 0) {
                //第一次添加取消数量和减号显示,有最小起订量,直接设置为最少起订量
                this.changeCarQty(this.minQty ? this.minQty : qty, true);
                this.setCarPartHidden(false);
            } else {
                //如果变化后的数量小于最小起订量,则删除本商品
                if (this.minQty && (this.qty + qty < this.minQty)) {
                    this.changeCarQty(0, true);
                } else {
                    this.changeCarQty(qty);
                }
            }
        },
        changeCarQty : function (qty, isSet) {
            if (isSet){
                // if (qty > this.mat.qty) {
                //     //设置数量大于库存
                //     alert("当前选择数量大于库存,最多选择"+ this.mat.qty + this.mat.sizeType + "!");
                //     qty = this.mat.qty;
                // }
                if (qty === 0 || (this.minQty && qty < this.minQty)){
                    qty = 0;
                    //删除购物车中商品
                    cart.clearShop([this.mat._id]);
                    //提示信息
                    //alert("小于最小起定量");
                    //隐藏减和数量输入框
                    this.setCarPartHidden(true);
                } else {
                    //如果是设置数量则需要添加的数量为设置的数量减去之前的总数量
                    //cart.add(this.mat._id, qty - this.qty);
                    cart.addByShop(this.mat.fromShopId._id,this.mat._id, qty - this.qty);
                }
                this.qty = qty;
            } else {
                this.qty += qty;
                if(this.qty <= 0){
                    this.setCarPartHidden(true);
                    cart.clearShop([this.mat._id]);
                    this.qty = 0;
                }
                // else if (this.qty > this.mat.qty) {
                //     alert("当前选则数量大于库存,最多选择"+ this.mat.qty + this.mat.sizeType + "!");
                //     this.qty = this.mat.qty
                // }
                else {
                    //cart.add(this.mat._id, qty);
                    cart.addByShop(this.mat.fromShopId._id,this.mat._id,qty);
                }
            }
            this.qtyInput.value = this.qty;
            topic.publish("buy.count.change");
        }
    });
    return declare("whz.view.Buy", [View,_ViewMixin], {
        start : 0,
        pageSize : 10,
        //查询条件
        matParams : null,
        //商品信息 {mid:mat}
        mats : null,
        //商品优惠活动{mid:groupbuying}
        matGroupbuyings : null,
        //店铺对应商品/取优惠活动用{shopId:[mid,...]}
        shopsMats : null,
        //重写加载中的背景样式
        currentShopId : 0,
        loadingBgClass :" ",
        currentStore : null,
        //是否可以加载更多,在已选商品的时候不能加载更多
        isCanLoadMore: true,
        onFirstShow : function () {
            var option ={
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        window.moveToView('home');
                    }
                },
                title : "买",
                right: {
                    iconButton : ' ',
                    label : "寻找货源",
                    onClick : function () {
                        window.moveToView("supplyList");
                    }
                }
            };
            this.addHeader(option);
            option = {
                isHeader : true,
                columns : [{
                    label : '<div class="rightFlex">切换至商家</div>',
                    className : 'flex1',
                    onClick : function () {
                        window.moveToView('b2bShopBuy');
                    }
                },{
                    label : '全部商品',
                    className : 'flex1',
                    onClick : function (e) {
                        //this.changeQuery("orderBy","createAt", e);
                        this.changeToSelected(false, e);
                    }
                }, {
                    label:'已选商品',
                    className: 'flex1',
                    onClick: function (e) {
                        //this.changeQuery("orderBy","totalSale", e);
                        this.changeToSelected(true, e);
                    }
                }],
                forceWidth : false,
                isHeader : true,
                labelClass : 'font-size1 tab-selector'
            };
            this.queryList = this.addColumns(option);
            this.createContent();
            option={
                columns:[{
                    label:"<div class='countBox'>数量:<span class='qty'>0</span>&nbsp合计:<span class='footerAmt count'>￥0.00</span></div>",
                    className:"edit-car-count flex1"
                },{
                    label:"<span class='amout'>选好了</span>",
                    className:"edit-car-submit",
                    onClick: function(){
                        this.onSaveStore();
                    }
                }],
                className:'fix-footer edit-car-footer',
                forceWidth:false,
                isFooter:true
            };
            user.getUserInfo().then(lang.hitch(this,function(data){
                var item = data && data.data && data.data.item;
                
                if(item.role == 3){
                    option.columns.splice(0,2);
                }
                this.footerDiv = this.addColumns(option);
                this.qtyDom = query(".qty",this.footerDiv)[0];
                this.countDom = query(".count",this.footerDiv)[0];
                this.tabSelected(query('.tab-selector', this.queryList), "selected", query('.tab-selector', this.queryList)[1]);
                this.onAfterShow();
                this.subscribe("buy.count.change",this.onCountChange);              
            }));       
        },
        //切换到已选或者全部
        changeToSelected: function (isSelected, e) {
            var dom = e.target;
            this.tabSelected(query('.tab-selector', this.queryList), "selected", dom);
            if (isSelected) {
                this.loadCartMats().then(lang.hitch(this, function (data) {
                    this.toggleGroup(false);
                    this.storeList.destroyDescendants();
                    this.storeList.onComplete(data);
                }));
            } else {
                this.toggleGroup(true);
                this.onAfterShow();
            }
        },
        toggleGroup: function (on) {
            domClass[on ? "remove": "add"](this.groupPane.domNode, "none");
            this.isCanLoadMore = on;
            this.matFixedSplitter.resize();
        },
        //刷新购物车合计和分类合计
        onCountChange : function () {
            this.refreshFooter();
            this.refreshGroupNum();
        },
        //刷新底部
        refreshFooter : function () {
            //底部合计
            var carts = cart.getAsArray(),
            price = 0;
            array.forEach(carts, function (m) {
                price += (this.mats[m.mid].purchasePrice || 0) * m.qty;
            }, this);
            this.qtyDom.innerHTML = cart.getNum();
            this.countDom.innerHTML = "￥" + window.fixedTo(price,3);
        },
        //刷新分类数量
        refreshGroupNum : function () {
            //处理分类数量
            var groupCarts = groupCart.get();
            //隐藏所有的分类数据角标
            array.forEach(query('.group-list-item i',this.domNode),function (i) {
                domClass.add(i,"none");
            });
            for (var sort in groupCarts) {
                if (groupCarts.hasOwnProperty(sort)) {
                    if (groupCarts[sort] > 0) {
                        var groupNum = query(".group-list-item[gid='" + sort + "'] i");
                        if (groupNum[0]) {
                            domClass.remove(groupNum[0],"none");
                            groupNum[0].innerHTML = groupCarts[sort];
                        }
                    }
                }
            }
        },
        //创建放品类和商品的切分框
        createContent : function () {
            var fixedSplitter = this.matFixedSplitter = new FixedSplitter({
                orientation:'H',
                variablePane:1
            });
            //把这个fixedSplitter放到页面的中间部分
            fixedSplitter.placeAt(this._centerPane.domNode);
            //创建分类列表的scrollablePane
            this.createGroupPane(fixedSplitter);
            //创建商品列表scrollablePane
            this.createMatListPane(fixedSplitter);
        },
        //品类列表
        createGroupPane : function (fixedSplitter) {
            var groupPane = this.groupPane = new Pane({
                style : "width:90px;"
            }),scrollablePane = ScrollablePane({height:'100%',style:"background-color: rgba(170, 170, 170, 0.2);"});
            groupPane.placeAt(fixedSplitter.containerNode);
            scrollablePane.placeAt(groupPane.domNode);
            this.groupList = domConstruct.create("ul",{
                "class" : "buy-group-list"
            },scrollablePane.containerNode);
            this.connect(this.groupList, "onclick", this.onGroupListClick);
        },
        //创建商品列表
        createMatListPane : function (fixedSplitter) {
            var matListPane = new Pane(),
                //原来的centerPanel放到右边自适应宽度的pane里面做商品的scrollablePane
                scrollablePane = this.matListScrollablePane = this.centerPanel;
            matListPane.placeAt(fixedSplitter.containerNode);
            matListPane.domNode.appendChild(scrollablePane.domNode);
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                className : "buy-mat-list",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, this.storeReady),
                itemMap : {
                    _data : "mat"
                },
                itemRenderer : MatItem
            });
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
        },
        storeReady : function (items) {
            var data = [];
            //只需要加载需要显示的商品优惠
            this.shopsMats = {};
            array.forEach(items,function (item) {
                //处理自家产品
                if(!item.purchasePrice){
                    item.purchasePrice = item.retailPrice;
                }
                data.push({
                    _data : item
                });
                this.cacheData(item);
            },this);
            this.storeList.generateList(data);
            this.busy = false;
        },
        //品类点击
        onGroupListClick : function (e) {
            var dom = e.target;
            while (dom && !domClass.contains(dom, "group-list-item") && !domClass.contains(dom, "group-list")){
                dom = dom.parentNode;
            }
            if (dom && domClass.contains(dom, "group-list-item")) {
                if (dom === query(".selected", this.groupList)[0]) {
                    return;
                }
                this.tabSelected(dom.parentNode.children, "selected", dom);
                window.busy();
                var gid = domAttr.get(dom, "gid");
                if (gid) {
                    this.matParams.sortId = gid;
                } else {
                    delete this.matParams.sortId;
                }
                this.setQuery(this.matParams);
            }
        },
        tabSelected : function (doms, className, dom) {
            array.forEach(doms, function (d) {
                domClass.remove(d, className);
            });
            if (dom) {
                domClass.add(dom, className);
            }
        },
        onLoadMore : function (evt) {
            if(!this.busy&&evt.afterBottom&&this.isCanLoadMore){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        setQuery : function (query) {
            window.busy();
            this.start = 0;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        onAfterShow : function () {
			domClass.remove(this.footerDiv,"none");
            shop.loadCurrentShop().then(lang.hitch(this, function (data) {
                if (!data.data.isVerified) {
					domClass.add(this.footerDiv,"none");
                    alert("您的店铺还没认证，请认证后开始采购！");
                }
            }));
            this.toggleGroup(true);
            //this.tabSelected(query('.tab-selector', this.queryList), "selected", query('.tab-selector', this.queryList)[1]);
            //加载完购物车商品后才可以加载商品
            this.loadCartMats().then(lang.hitch(this, function () {
                //创建数据源
                if(!this.store){
                    this.matParams = {
                        isPurchase: true,
                        preventSelf:true,
                        //qty : 1,
                        orderBy : 'createAt'
                    };
                    this.store = new JsonRest({
                        target : mat.getUrlByShop() + "?shopId=" + shop.getShopId()
                    });
                    //创建数据源,加载数据
                    // 将数据源赋值给storeList
                    this.setListStore(this.store);
                    //加载分类信息
                    sort.load({
                        isUse : true,
                        noSub : true
                    }).then(lang.hitch(this,function (data) {
                        //创建全部
                        domConstruct.create("li",{
                            "class" : "group-list-item selected",
                            innerHTML : "<span class='mat-list-mname'>" + "全部分类" + "</span>"
                        }, this.groupList);
                        var items = data && data.data && data.data.items || [];
                        array.forEach(items, function (item) {
                            domConstruct.create("li",{
                                "class" : "group-list-item",
                                innerHTML : "<span class='mat-list-mname'>" + item.sortName + "</span>" +"<i class='none'>0</i>",
                                gid : item._id
                            }, this.groupList);
                        }, this);
                        //创建完成之后需要初始化数量
                        this.onCountChange();
                    }));
                }else{
                    this.setQuery(this.matParams);
                    //初始化购物车合计和分类合计
                    this.onCountChange();
                }
            }));
        },
        //加载并处理购物车中的商品
        loadCartMats : function () {
            var def = new Deferred();
            this.mats = {};
            mat.loadByIds(cart.getIds(),shop.getShopId()).then(lang.hitch(this,  function (data) {
                var items = data && data.data && data.data.items,
                    unUseMats = [];
                array.forEach(items, function (item) {
                    if (!item.isPurchase) {
                        unUseMats.push(item._id);
                    } else {
                        groupCart.set(item.sortId, item._id);
                        this.cacheData(item);
                    }
                }, this);
                //清除数据库没有查到的商品
                array.forEach(cart.getIds(),function (id) {
                    if (!this.mats[id]) {
                        //缓存的数据中没有的商品,放到失效商品中然后清楚
                        unUseMats.push(id);
                    }
                }, this);
                //清除下架无用商品
                if (unUseMats.length) {
                    cart.clearShop(unUseMats);
                }
                def.resolve(items);
            }));
            return def;
        },
        //缓存数据,商品数据
        cacheData : function (item) {
            var shopId;
            //处理自家产品
            if(!item.purchasePrice){
                item.purchasePrice = item.retailPrice;
            }
            this.mats[item._id] = item;
            if (this.shopsMats && !this.shopsMats[item._id]) {
                this.shopsMats[item._id] = [];
            }
            //有团购活动并且没有过期才需要取活动
            if (this.shopsMats && item.groupBuying) {
                shopId = item.fromShopId._id ? item.fromShopId._id :  item.fromShopId;
                if (!this.shopsMats[shopId]) {
                    this.shopsMats[shopId] = [];
                }
                this.shopsMats[shopId].push(item._id);
            }
        },
        changeQuery : function (type, action, e) {
            var dom = e.target;
            this.tabSelected(query('.tab-selector', this.queryList), "selected", dom);
            if (type === 'orderBy') {
                //排序
                delete this.matParams.fromShopIds;
                this.matParams.orderBy = action;
                this.setQuery(this.matParams);
            } else {
                if (action === "collectShopMat") {
                    //收藏商家的商品
                    this.loadCollectShopMat();
                }
            }
        },
        //设置List的数据源
        setListStore : function (store) {
            this.currentStore = store;
            this.start = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setStore(store, this.matParams, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        loadCollectShopMat : function () {
            shopStore.load().then(lang.hitch(this, function (data) {
                var items = data && data.data && data.data.items || [];
                var shopIds = [];
                array.forEach(items, function (item) {
                    shopIds.push(item.targetShopId._id);
                });
                this.matParams.fromShopIds = shopIds;
                this.setQuery(this.matParams);
            }));
        },
        onLoadListData : function (queryResult,start,pageSize,tp) {
            this.inherited(arguments);
            queryResult.then(lang.hitch(this,function(){
                window.free();
            }));
        },
        onSaveStore : function () {
            //把购物车中的所有的商品设为选中
            var ids = cart.getIds();
            if (ids.length) {
                cart.setSelected(cart.getIds());
                window.moveToView("orderInfoB2B");
            } else {
                alert("您还没有选择任何商品!");
            }
        }
    });
});
