﻿/*
*变更人：徐阿雪
*变更时间：2016/10/17
*变更原因：依据商家合作伙伴供货商查商品
*左边显示合作伙伴列表（shop/partner/load_partner）参数（shopId：当前商家Id；isDelete：false；isSupplier：true;isVerified:true;）
*中间部分显示选择合作伙伴的商品，参数（shopId：选中的商家Id；isUse：true;qty:1）
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/topic",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/store/JsonRest",
    "dojo/DeferredList",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/iconUtils",
	"cq/ui/view/_ViewMixin",
    "cq/biz/user/user",
    "cq/biz/mat/mat",
    "cq/biz/shop/partner",
    "cq/biz/shop/shop",
    "cq/biz/ts/cart"
],function(declare, lang, array, query, topic, Deferred, domConstruct, domClass, domAttr, JsonRest,DeferredList, _WidgetBase, View, FixedSplitter, Pane, ScrollablePane, EdgeToEdgeStoreList, iconUtils, _ViewMixin, user, mat, partner, shop, cart){
    //商品对象
    var MatItem = declare("", [_WidgetBase], {
        //商品信息
        mat : null,
        matInShop : false,
        cartMats : {},
        limitedQty : null,
        "class" : 'mat-list-item',
        postCreate : function () {
            this.createElement();
            this.indexElement();
            this.initEvent();
        },
        createElement : function () {
            var mat = this.mat;
            var shopId ="";
            var limitMsg = "";
            if(mat.fromShopId){
                if(mat.fromShopId._id){
                    shopId = "_"+mat.fromShopId._id;
                }else{
                    shopId = "_"+mat.fromShopId;
                }
            }
            if(mat.limitedQty && !mat.selectMat){
                limitMsg = "限";
                this.limitedQty = mat.limitedQty;
            }
            //logo
            domConstruct.create("a",{
                href : "#matDetail-" + mat._id + shopId,
                innerHTML : "<img src=" + mat.logo + " />"
            }, this.domNode);
            var rightDiv = this.rightDiv = domConstruct.create("div",{
                'class' : 'right',
            },this.domNode);
            //标题
            domConstruct.create("div",{
                'class' : 'title',
                innerHTML : "<span style='color: #fff!important;font-weight:bold;background-color:#ff4401;font-size:larger'>"+limitMsg+"</span>"+mat.mName
            },rightDiv);
            //加/减
            var carPart = this.carPart = domConstruct.create("div",{
                "class" : "carPart",
                innerHTML : "<div class='mblDomButtonRedCircleMinus'></div><div class='qtyDiv '><input value='0' type='tel' /></div><div class='mblDomButtonRedCirclePlus'></div>"
            }, rightDiv);
            //价格/规格
            var infoPart = domConstruct.create("div",{
                'class' : 'info',
                innerHTML : "<span class='price' style='color:#D35D13!important;'>￥" + window.fixedTo(mat.purchasePrice || 0, 3)  + "/" + mat.sizeType + "</span>"
            }, rightDiv);
        },
        indexElement : function () {
            this.minusBtn = iconUtils.createDomButton(query(".mblDomButtonRedCircleMinus",this.carPart)[0]);
            this.plusBtn = iconUtils.createDomButton(query(".mblDomButtonRedCirclePlus",this.carPart)[0]);
            this.qtyDiv = query('.qtyDiv',this.carPart)[0];
            this.qtyInput = query('input',this.carPart)[0];
        },
        initEvent : function () {
            //绑定+/-点击事件
            this.connect(this.carPart, "onclick", this.onCarPartClick);
            //输入数量事件
            this.connect(this.qtyInput, "oninput",function () {
                // TODO: 检查输入合法性
                if (this.qtyInput.value != '') {
                    var qty = Number(this.qtyInput.value) || 0;
                    this.changeCarQty(qty,true);
                }
            });
            //失去焦点的时候
            this.connect(this.qtyInput, "onblur",function () {
                if (this.qtyInput.value == '') {
                    this.changeCarQty(0,true);
                }
            });
            //购物车当前商品的数量
            //只显示当前商家的数量，其他商家都有的但是没添加的不显示
            this.getQty();
            if(this.mat.selectMat){
                this.minQty = this.mat.purchaseQty || 0;
            }else{
                this.minQty = this.mat.minQty || 0;
            }
            if (this.qty) {
                this.setCarPartHidden(false);
                this.qtyInput.value = this.qty;
            } else {
                this.setCarPartHidden(true);
            }
        },
        //处理同样的商品在不同商家数量显示的情况
        //处理全部和已经选择的商品显示数量情况
        getQty : function(){
            var shops = cart.getShopIdAndMid();
            if(shops[this.mat._id]==this.mat.shopId){
                this.matInShop = true;
            }
            if(this.matInShop || this.mat.selectMat){
                this.qty = cart.get()[this.mat._id] || 0;
            }else{
                this.qty = 0;
            }
        },
        onCarPartClick : function (e) {
            var dom = e.target;
            while (dom && !domClass.contains(dom, "mblDomButton") && !domClass.contains(dom, "buy-group-list")){
                dom = dom.parentNode;
            }
            if (dom) {
                if (domClass.contains(dom, "mblDomButtonRedCirclePlus")) {
                    this.addCar(1);
                } else if (domClass.contains(dom, "mblDomButtonRedCircleMinus")) {
                    this.addCar(-1);
                }
            }
        },
        addCar :function (qty) {
            //var qq = cart.get()[this.mat._id];
            if (this.qty === 0) {
                //第一次添加取消数量和减号显示,有最小起订量,直接设置为最少起订量
                this.changeCarQty(this.minQty ? this.minQty : qty, true);
                this.setCarPartHidden(false);
            }else {
                //如果变化后的数量小于最小起订量,则删除本商品
                if (this.minQty && (this.qty + qty < this.minQty)) {
                    this.changeCarQty(0, true);
                }/*else if(this.limitedQty && this.minQty && (this.qty + qty > this.limitedQty)){
                    //如果大于限定量给出限制
                    alert("限买"+this.limitedQty);
                    this.qty = this.limitedQty;
                }*/else {
                    this.changeCarQty(qty);
                }
            }
        },
        changeCarQty : function (qty, isSet) {
            //在商品被add到购物车之前判断
            //点的是已经加载过的商品就不再loadByIds
            var ids = cart.getIds();
            var firstAdd = false;
            //第一次添加的商品另外处理
            if(!ids.length){
                firstAdd = true;
            }  
            if (isSet){
                var qq = cart.get()[this.mat._id];
                if (qty === 0 || (this.minQty && qty < this.minQty)){
                    qty = 0;
                    //删除购物车中商品
                    cart.clearShop([this.mat._id]);
                    //提示信息
                    //alert("小于最小起定量");
                    //隐藏减和数量输入框
                    this.setCarPartHidden(true);
                } else {
                    //如果是设置数量则需要添加的数量为设置的数量减去之前的总数量
                    cart.addByShop(this.mat.shopId,this.mat._id, qty - this.qty);
                }
                //不同商家有相同商品的时候显示商家商品数量
                if(qq && this.qty === 0){
                    this.qty = qq + qty;
                }else{
                    this.qty = qty;
                }
            } else {
                this.getQty();
                this.qty += qty;
                if(this.qty <= 0){
                    this.setCarPartHidden(true);
                    cart.clearShop([this.mat._id]);
                    this.qty = 0;
                }
                else {
                    cart.addByShop(this.mat.shopId,this.mat._id, qty);
                }
            }
            this.qtyInput.value = this.qty;
            var refresh = ids.indexOf(this.mat._id);
            //第一次点击的时候，点击不同商品的时候，要做刷新处理
            //只是做加减的时候不需要考虑刷新this.mat,也就是loadByids，只需要刷新左边和底部，
            if(refresh === -1 || firstAdd){
                topic.publish("buy.count.changes");
            }else{
                if(this.qty==0){
                    topic.publish("buy.count.changes");
                }else{
                    topic.publish("buy.count.changeNum");
                }
            }
        },
        setCarPartHidden : function (hidden) {
            domClass[hidden ? "add" : "remove"](this.qtyDiv, "visibility");
            domClass[hidden ? "add" : "remove"](this.minusBtn, "visibility");
        }
    });
    return declare("whz.view.B2bShopBuy",[View,_ViewMixin],{
        start:0,
        pageSize:10,
        //商品信息
        mats:{},
        //当前选择的shopId
        shopId:null,
        //保存当前点击的节点
        //点击已经选择的商品不允许加载跟多
        notLoadmore : false,
        //记录当前购物车的商品数量
        matNum : 0,
        allShopIds : {},
        //重写加载中背景
        loadingBgClass :" ",
        curentDom:0,
        onFirstShow:function(){
            var option ={
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        window.moveToView('home');
                    }
                },
                title : "买",
            };
            this.addHeader(option);
            option = {
                isHeader : true,
                columns : [{
                    label : '<div class="rightFlex">切换至品类</div>',
                    className : 'flex1',
                    onClick : function () {
                        window.moveToView('b2bBuy');
                    }
                },{
                    label : '全部商品',
                    className : 'flex1',
                    onClick : function (e) {
                        this.changeToSelected(false, e);
                    }
                }, {
                    label:'已选商品',
                    className: 'flex1',
                    onClick: function (e) {
                        this.changeToSelected(true, e);
                    }
                }],
                forceWidth : false,
                isHeader : true,
                labelClass : 'font-size1 tab-selector'
            };
            this.chooseList=this.addColumns(option);
            //创建左边不同商家列表
            var fixedSplitter = this.shopMatFixedSplitter = new FixedSplitter({
                orientation:'H',
                variablePane:1
            });
            //把这个fixedSplitter放到页面的中间部分
            fixedSplitter.placeAt(this._centerPane.domNode);
            option={
                columns:[{
                    label:"<div class='countBox'>数量:<span class='qty'>0</span>&nbsp合计:<span class='footerAmt count'>￥0.00</span></div>",
                    className:"edit-car-count flex1"
                },{
                    label:"<span class='amout'>选好了</span>",
                    className:"edit-car-submit",
                    onClick: function(){
                        this.onSaveStore();
                    }
                }],
                className:'fix-footer edit-car-footer',
                forceWidth:false,
                isFooter:true
            };
            user.getUserInfo().then(lang.hitch(this,function(data){
                var item = data && data.data && data.data.item;
                
                if(item.role == 3){
                    option.columns.splice(0,2);
                }
                this.footerDiv = this.addColumns(option);
                this.qtyDom = query(".qty",this.footerDiv)[0];
                this.countDom = query(".count",this.footerDiv)[0];
                //创建左边的列表和中间的商品列表的pane
                this.createShopSortPane(fixedSplitter);
                this.createMatListPane(fixedSplitter);
                this.subscribe("buy.count.changes",this.onChange);
                this.subscribe("buy.count.changeNum",this.onChangeNum);
                this.onAfterShow();
            }));
            //第一次进入页面或者切换店铺后创建左侧商品分类
            //this.createShopSortList().then(lang.hitch(this,function(){this.onAfterShow();}));
        },
        //创建左边商家列表
        createShopSortPane:function(fixedSplitter){
            var shopSortPane = this.shopSortPane = new Pane({
                style : "width:90px;"
            }),scrollablePane = ScrollablePane({height:'100%',style:"background-color: rgba(170, 170, 170, 0.2);"});
            shopSortPane.placeAt(fixedSplitter.containerNode);
            scrollablePane.placeAt(shopSortPane.domNode);
            this.shopSortList = domConstruct.create("ul",{
                "class" : "buy-group-list"
            },scrollablePane.containerNode);
            this.connect(this.shopSortList, "onclick", this.onShopSortClick);
        },
        //创建商品列表
        createMatListPane:function(fixedSplitter){
            var matListPane = new Pane(),
                //原来的centerPanel放到右边自适应宽度的pane里面做商品的scrollablePane
                scrollablePane = this.matListScrollablePane = this.centerPanel;
            matListPane.placeAt(fixedSplitter.containerNode);
            matListPane.domNode.appendChild(scrollablePane.domNode);
            this.shopMatList = new EdgeToEdgeStoreList({
                append : true,
                className : "buy-mat-list",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, this.storeReady),
                itemMap : {
                    _data : "mat",
                },
                itemRenderer : MatItem
            });
            this.shopMatList.placeAt(this.centerPanel.containerNode, "last");
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
        },
        storeReady : function (items) {
            var data = [];
            for(var i=0;i<items.length;i++){
                //为每个商品追加他的shopId
                var haveLevel = false;
                var shopId = domAttr.get(this.curentDom,"shopId");
                var level = this.allShopIds[shopId];//level 为0 的时候没有级别
                if(!items[i].selectMat){
                    //有等级就设置purchasePrice为等级价格，否则为真实价格
                    if(level&&items[i].prices&&items[i].prices.length){
                        array.forEach(items[i].prices,function(item){
                            if(item.level == level){
                                items[i].purchasePrice = item.price;
                                haveLevel = true;
                            }
                        },this);
                        //却没有相应的等级
                        if(!haveLevel){
                            items[i].purchasePrice = items[i].retailPrice;
                        }
                    }else{
                        items[i].purchasePrice = items[i].retailPrice;
                    }
                }
                items[i].shopId=shopId;
                data.push({
                    _data : items[i],
                });
            }
            this.shopMatList.generateList(data);
            this.busy = false;
        },
        //加载当前商家的所有伙伴，将_id，和shopName提取出来使用，
        //创建左边list
        createShopSortList:function(){
            var deferred = new Deferred();
            var shopId = shop.getShopId();
            //当前商家的id
            this.shopId = shopId;
            domConstruct.empty(this.shopSortList);
            partner.load({
                shopId:this.shopId,
                isDelete:false,
                isSupplier:true,
                isVerified:true,
                orderBy:"shopName"
            }).then(lang.hitch(this,function(data){
                var items = data && data.data && data.data.items || [];
                array.forEach(items, function (item) {
                    domConstruct.create("li",{
                        "class" : "group-list-item",
                        innerHTML : "<span class='mat-list-mname newLine'>" + item.shopName + "</span>" +"<i class='none' >0</i>",
                        shopId : item._id
                    }, this.shopSortList);
                }, this);
                deferred.resolve(this.shopSortList);
            }));
            return deferred;
        },
        //点击商家分类
        onShopSortClick:function(e){
            var dom = "";
            //点击的情况
            if(e&&e.target){
                dom = e.target;
                //处理点击到span上的情况
                while (dom && !domClass.contains(dom, "group-list-item")){
                    dom = dom.parentNode;
                }
                //点击的时候处理点击已经选中节点的情况
                if (dom === query(".selected", this.shopSortList)[0]) {
                    return;
                }
            }else if(e == 0){ //第一次进入没点击的时候
                dom = query(".group-list-item",this.domNode)[0];
            }else{
                //根据shopId设置样式
                var shopId = domAttr.get(this.curentDom,"shopId");
                var doms = query(".group-list-item",this.domNode);
                array.forEach(doms,function(d){
                    if(shopId == domAttr.get(d,"shopId")){
                        dom = d;
                    }
                },this)
            }
            if(dom && domClass.contains(dom, "group-list-item")) {
                //先清除所有节点的样式，和为点击节点设置样式
                this.tabSelected(dom.parentNode.children, "selected", dom);
                this.curentDom = dom;
                var shopIdd = domAttr.get(dom, "shopId");
                //获取选择合作商家的shopLevel
                if(typeof(this.allShopIds[shopIdd]) == "undefined"){
                    partner.loadByIdAndShopId(shopIdd,this.shopId).then(lang.hitch(this,function(data){
                        this.allShopIds[shopIdd] = data.data.shopLevel;
                        this.loadMatList({shopId:shopIdd,isUse:true,qty:1});
                    }));
                }else{
                    this.loadMatList({shopId:shopIdd,isUse:true,qty:1});
                }
                
            }
        },
        tabSelected : function (doms, className, dom) {
            //移除节点的样式
            array.forEach(doms, function (d) {
                domClass.remove(d, className);
            });
            if (dom) {
                domClass.add(dom, className);
            }
        },
        onAfterShow:function(){
            domClass.remove(this.footerDiv,"none");
            shop.loadCurrentShop().then(lang.hitch(this, function (data) {
                if (!data.data.isVerified) {
					domClass.add(this.footerDiv,"none");                    
                }
            }));
            //切换商家把购物车清零
            //将上一次的的pane销毁
            this.createShopSortList().then(lang.hitch(this,function(){
                this.shopMatFixedSplitter.resize();
                //默认加载全部
                this.changeToSelected(false,{target:query(".tab-selector",this.domNode)[1]});
                //如果购物车的商品发生变化，就刷新this.mat
                if(this.matNum != cart.getIds().length){
                    this.onChange();
                }else{
                    //其他页面选择的是同一个商品就不刷新this.mat
                    //底部和左边数量刷新；
                    this.onChangeNum();
                }
            }));
        },
        //加载全部和已经选择的商品
        changeToSelected : function(isSeleted,e){
            //isSeleted默认fasle 加载全部，
            var dom =e.target;
            var on = true;
            this.tabSelected(query('.tab-selector',this.chooseList),"selected",dom);
            this.shopMatList.destroyDescendants();
            if(isSeleted){
                //加载选择商品
                on = false;
                this.notLoadmore = false;
                var items = [];
                //其实可以直接用this.mats的内容
                for(var mid in this.mats){
                    var mats = this.mats[mid];
                    mats.selectMat = true;
                    items.push(mats);
                }
                if(items.length){
                    this.shopMatList.onComplete(items);
                }
            }else{
                this.notLoadmore = true;
                this.onShopSortClick(this.curentDom);
            }
            //隐藏左边
            domClass[on ? "remove": "add"](this.shopSortPane.domNode, "none");
            this.shopMatFixedSplitter.resize();
        },
        //加载选择的商家的商品
        loadMatList:function(query){
            this.start = 0;
            this.shopMatList.destroyDescendants();
            if(this.store){
                this.busy = true;
                var queryResult= this.shopMatList.setQuery(query, {
                    start : this.start,
                    count : this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                //如果没有store就创建数据源
                this.store = new JsonRest({target:mat.getUrlByShop()});
                this.busy=true;
                var queryResult =this.shopMatList.setStore(this.store,query,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        onLoadMore:function(e){
            if(!this.busy&&e.afterBottom&&this.notLoadmore){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.shopMatList.setQuery(this.shopMatList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        onSaveStore:function(){
            //看是否在采购清单里面
            var ids = cart.getIds();
            if (ids.length) {
                cart.setSelected(cart.getIds());
                window.moveToView("orderInfoB2B");
            } else {
                alert("您还没有选择任何商品!");
            }
        },
        //将不再采购清单的商品返回
        getNotBuyMat:function(items){
            var matToShop =cart.getShopIdAndMid();
            var addParams = [];
            //都不在采购清单，加入采购清单
            if(!items.length){
                for(var i in matToShop){
                    var mid=i;
                    addParams.push({
                        mId:mid,
                        fromShopId:matToShop[i],
                        shopId:this.shopId
                    });
                }
            }else if(items.length < cart.getIds().length){
                //有部分不在采购清单。将不在的加入采购清单
                array.forEach(cart.getIds(),function(cart){
                    var isFind = false;
                    array.forEach(items,function(item){
                        if(cart == item._id){
                            isFind = true;
                        }
                    },this);
                    if(!isFind){
                        addParams.push({
                            mId:cart,
                            fromShopId:matToShop[cart],
                            shopId:this.shopId
                        });
                    }
                },this);
            }
            return addParams;
        },
        onChange:function(){
            mat.loadByIds(cart.getIds()).then(lang.hitch(this,  function (data) {
                if(data&&data.data&&data.data.items){
                    var items =data.data.items;
                    var addParams = this.getNotBuyMat(items);
                    //有不再采购清单的就循环请求添加到采购清单
                    if(addParams.length){
                        this.addB2B(addParams);
                    }else{
                        //直接刷新
                        this.getCartMats(items);
                    }
                }  
            }));
        },
        //将不再采购清单的商品加入清单成功后在加载购物车商品
        //循环加入采购清单
        addB2B : function(addParams){
            //DeferredList参数是数组
            var def = new DeferredList(addParams.map(function(param){
                return (mat.b2bAdd(param).then(function(data){
                    if(data.data.ok == "0"){
                        //添加失败的商品，直接从购物车里面删除
                        cart.clearShop(param.mId);
                    }
                }));
            },this));
            def.then(lang.hitch(this,function(){
                //得到购物车库里面的所有商品
                mat.loadByIds(cart.getIds()).then(lang.hitch(this,function (data) {
                    var items =data.data.items;
                    this.getCartMats(items);
                }));
            }));
        },
        //获得当前购物车所有商品,刷新
        getCartMats : function(items){
            this.mats = {};
            array.forEach(items,function(item){
                if(!item.purchasePrice){
                    item.purchasePrice = item.retailPrice;
                }
                this.mats[item._id] = item;
            },this);
            this.matNum = items.length;
            this.onChangeNum();
        },
        //监听qty和count随商品点击的变化,刷新底部和商家右上角购物车数量
        onChangeNum:function(){
            var carts = cart.getAsArray(),price = 0;
            array.forEach(carts, function (m) {
                price += (this.mats[m.mid].purchasePrice || 0) * m.qty;
            }, this);
            this.qtyDom.innerHTML = cart.getNum();
            this.countDom.innerHTML = "￥" + window.fixedTo(price,3);
            var groupCarts = this.getShopmid();
            //隐藏所有的分类数据角标
            array.forEach(query('.group-list-item i',this.domNode),function (i) {
                domClass.add(i,"none");
            });
            for (var sort in groupCarts) {
                if (groupCarts.hasOwnProperty(sort)) {
                    if (groupCarts[sort] > 0) {
                        var groupNum = query(".group-list-item[shopId='" + sort + "'] i");
                        if (groupNum[0]) {
                            domClass.remove(groupNum[0],"none");
                            groupNum[0].innerHTML = groupCarts[sort];
                        }
                    }
                }
            }
        },
        //获取左侧购物车数量
        getShopmid : function () {
            var carts = cart.get();
            var shop = cart.getShopIdAndMid();
            var groupCart = {};
            for(var s in carts){
                if(!groupCart[shop[s]]){
                    groupCart[shop[s]] = 0;
                }
                groupCart[shop[s]] += carts[s] ||0;
            }
            return groupCart;
        }
    });
});