//  变更人:肖芳圆
//  变更时间:2016/7/25
//  变更原因:盐业产品购买页面

//  变更人:肖芳圆
//  变更时间:2016/8/9
//  变更原因:连续点击左边“收藏商品”刷新列表，商品列表值就空了。（购买过的商品相同）
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/Deferred",
    "dojo/topic",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/iconUtils",
	"cq/ui/view/_ViewMixin",
    "cq/biz/mat/sort",
    "cq/biz/mat/mat",
    "cq/util/config/config",
    "cq/biz/ts/cart",
    "cq/biz/shop/cm/frequentlyPurchasedMat",//购买过的接口
    "cq/biz/shop/cm/shopStore", //收藏的店铺的接口
    "cq/biz/shop/cm/matStore", //收藏商品的接口
    "cq/biz/mk/groupBuy"
], function (declare, lang, array, query, Deferred, topic, domConstruct, domClass, domStyle, domAttr, JsonRest, registry, _WidgetBase, View, FixedSplitter, Pane, ScrollablePane, EdgeToEdgeStoreList, iconUtils, _ViewMixin, sort, mat, config, cart, boughtMat, shopStore, matStore, groupBuy) {
    var ProgressBar = declare('', [_WidgetBase], {
        'class' : "progress-bar",
        //进度
        progress : null,
        postCreate : function () {
            var progress = domConstruct.create("span",{
                'class' : "progress",
                style : "width:" + this.progress + "%;"
            }, this.domNode);
        }
    });
    //储存购物车分类的数量
    var groupCart = lang.mixin(lang.getObject("whz.view.Buy.groupCart", true),{
        mids : {},
        set : function (sortId, matId) {
            if (!this.mids[sortId]) {
                this.mids[sortId] = {};
            }
            this.mids[sortId][matId] = 0;
        },
        get : function () {
            var carts = cart.get(),
                groupCart = {};
            for (var sort in this.mids) {
                if (this.mids.hasOwnProperty(sort)) {
                    for (var mid in this.mids[sort]) {
                        if (this.mids[sort].hasOwnProperty(mid)) {
                            if(!groupCart[sort]){
                                groupCart[sort] = 0;
                            }
                            groupCart[sort] += carts[mid] || 0;
                        }
                    }
                }
            }
            return groupCart;
        }
    });
    var MatItem = declare("", [_WidgetBase], {
        //商品信息
        mat : null,
        //购物车中的数量
        qty : null,
        "class" : 'mat-list-item',
        postCreate : function () {
            this.createElement();
            this.indexElement();
            this.initEvent();
        },
        createElement : function () {
            var mat = this.mat;
            //logo
            var matLink = domConstruct.create("a",{
                href : "#matDetail-" + mat._id,
                innerHTML : "<img src='" + mat.logo + "' />"
            }, this.domNode);
            var rightDiv = this.rightDiv = domConstruct.create("div",{
                'class' : 'right',
            },this.domNode);
            //标题
            domConstruct.create("div",{
                'class' : 'title',
                innerHTML : mat.mName
            },rightDiv);
            //加/减
            var carPart = this.carPart = domConstruct.create("div",{
                "class" : "carPart",
                innerHTML : "<div class='mblDomButtonRedCircleMinus'></div><div class='qtyDiv '><input value='0' type='tel' /></div><div class='mblDomButtonRedCirclePlus'></div>"
            }, rightDiv);
            //价格/规格/供应商
            var infoPart = domConstruct.create("div",{
                'class' : 'info',
                innerHTML : "<a class='shopName' href='#supplyBus-" + mat.fromShopId._id +"'>"+ mat.fromShopId.shopName +"</a>"+"<span class='price' style='color:#D35D13!important;'>￥" + window.fixedTo(mat.retailPrice, 3)  + "/" + mat.sizeType + "</span>"
            }, rightDiv);
            //优惠部分
            var couponPart = this.couponPart = domConstruct.create("div",{
                'class' : 'new-coupon none'
            },this.rightDiv);
            if(mat.groupBuy){
                domClass.remove(couponPart, "none");
                this.createGroupbuyElement();
            }
            this.couponDropBtn = domConstruct.create("i",{
                "class" : "drop none"
            },couponPart);
        },
        createGroupbuyElement : function () {
            var mat = this.mat;
            domConstruct.create("div",{
                "class" : "coupon texthidden",
                innerHTML :"<span class='coupon-tag tuan'>团</span>" +"团购价￥" + mat.groupBuy.price + "，已有" + mat.groupBuy.totalSale + "次参团"
            },this.couponPart);
            if(mat.groupBuy.rebateFlag){
                var rebateRule = '';
                array.forEach(mat.groupBuy.rebateRule,function (rule) {
                    rebateRule += "团购满" + rule.qty + "件立返" + rule.amount + "元,";
                }, this);
                rebateRule = rebateRule.substr(0, rebateRule.length-1);
                var groupCoupon = domConstruct.create("div",{
                    "class" : "coupon"
                },this.couponPart);
                //创建进度
                this.createProgressBar(this.mat.groupBuy, groupCoupon);
                groupCoupon.innerHTML += "<span class='coupon-tag fan'>返</span>" + rebateRule;
            }
            //创建倒计时
            this.createCountdownTimer();
        },
        indexElement : function () {
            this.minusBtn = iconUtils.createDomButton(query(".mblDomButtonRedCircleMinus",this.carPart)[0]);
            this.plusBtn = iconUtils.createDomButton(query(".mblDomButtonRedCirclePlus",this.carPart)[0]);
            this.qtyDiv = query('.qtyDiv',this.carPart)[0];
            this.qtyInput = query('input',this.carPart)[0];
        },
        initEvent : function () {
            //设置把商品放到对应的分类中去
            groupCart.set(this.mat.sortId, this.mat._id);
            //绑定+/-点击事件
            this.connect(this.carPart, "onclick", this.onCarPartClick);
            //输入数量事件
            this.connect(this.qtyInput, "oninput",function () {
                // TODO: 检查输入合法性
                if (this.qtyInput.value != '') {
                    var qty = Number(this.qtyInput.value) || 0;
                    this.changeCarQty(qty,true);
                }
            });
            //失去焦点的时候
            this.connect(this.qtyInput, "onblur",function () {
                if (this.qtyInput.value == '') {
                    this.changeCarQty(0,true);
                }
            });
            //优惠下拉按钮点击事件
            this.connect(this.couponDropBtn, "onclick", this.onCouponDropBtnClick);
            //购物车当前商品的数量
            this.qty = cart.get()[this.mat._id] || 0;
            this.minQty = this.mat.minQty || 0;
            if (this.qty) {
                this.setCarPartHidden(false);
                this.qtyInput.value = this.qty;
            } else {
                this.setCarPartHidden(true);
            }
        },
        onCarPartClick : function (e) {
            var dom = e.target;
            while (dom && !domClass.contains(dom, "mblDomButton") && !domClass.contains(dom, "buy-group-list")){
                dom = dom.parentNode;
            }
            if (dom) {
                if (domClass.contains(dom, "mblDomButtonRedCirclePlus")) {
                    this.addCar(1);
                } else if (domClass.contains(dom, "mblDomButtonRedCircleMinus")) {
                    this.addCar(-1);
                }
            }
        },
        onCouponDropBtnClick : function (e) {
            var dom = e.target;
            if (domClass.contains(dom, "up")) {
                //收回去
                this.tabCouponStyle(true);
            } else {
                //展开
                this.tabCouponStyle(false);
            }
        },
        //创建倒计时
        createCountdownTimer : function () {
            var groupBuy = this.mat.groupBuy,
            time = parseInt((new Date(groupBuy.sDate).getTime()-new Date().getTime())/1000);
            var countdown = this.countdown = domConstruct.create('div', {
                "class" : 'countdown',
                innerHTML : '<span class="countdown-title">距结束：</span><span class="countdown-time"></span>'
            }, this.couponPart);
            var countdownTime = query('.countdown-time', countdown)[0],
            countdownTitle = query('.countdown-title',countdown)[0];
            //活动还没开始
            if(time > 0){
                countdownTitle.innerHTML = "距开始：";
                countdownTime.innerHTML = this.msecToTimeString(time);
                this.countdownTimer = setInterval(lang.hitch(this, function () {
                    time-=1;
                    if (time>0) {
                        countdownTime.innerHTML = this.msecToTimeString(time);
                    } else {
                        clearInterval(this.countdownTimer);
                        time = parseInt((new Date(groupBuy.eDate).getTime() - new Date().getTime())/1000);
                        this.endCountdown(countdownTitle, countdownTime, time);
                    }
                }),1000);
            } else {
                time = parseInt((new Date(groupBuy.eDate).getTime() - new Date().getTime())/1000);
                if (time > 0) {
                    this.endCountdown(countdownTitle, countdownTime, time);
                } else {
                    countdown.innerHTML = "活动结束!";
                }
            }
        },
        endCountdown: function (countdownTitle, countdownTime, time) {
            countdownTitle.innerHTML = "距结束：";
            countdownTime.innerHTML = this.msecToTimeString(time);
            this.countdownTimer = setInterval(lang.hitch(this, function () {
                time-=1;
                if (time>0) {
                    countdownTime.innerHTML = this.msecToTimeString(time);
                } else {
                    clearInterval(this.countdownTimer);
                    this.countdown.innerHTML = "活动结束!";
                }
            }),1000);
        },
        msecToTimeString : function (seconds) {
            var second = seconds % 60,
            minute = parseInt(seconds/60) % 60,
            hour = parseInt(seconds/3600) % 24,
            day = parseInt(seconds/86400);
            var timeStr = '';
            if(day){
                timeStr += ""+day+"天";
            }
            if(hour || hour === 0){
                timeStr += "<span>" + (hour>9?"":"0") +  hour + "</span>" +":";
            }
            if(minute || minute === 0){
                timeStr += "<span>" + (minute>9?"":"0")+minute + "</span>"+":";
            }
            if(second || second === 0){
                timeStr += "<span>" + (second>9?"":"0")+second + "</span>";
            }
            return timeStr;
        },
        //创建进度条
        createProgressBar : function (groupBuy,dom) {
            if (groupBuy.rebateRule.length) {
                var progress = parseInt(groupBuy.totalSale / groupBuy.rebateRule[groupBuy.rebateRule.length-1].qty * 100);
                //进度最多为100%
                progress = Math.min(progress,100);
                //团购进度
                this.progressBar = new ProgressBar({
                    progress : progress
                });
                var progressDiv = domConstruct.create("div",{
                    innerHTML: "返利进度："+progress+"%"
                },dom);
                progressDiv.appendChild(this.progressBar.domNode);
            }
        },
        tabCouponStyle : function (isAdd) {
            //取消显示限制
            array.forEach(query('.coupon', this.couponPart), function (dom) {
                domClass[isAdd ? 'add' : 'remove'](dom, "texthidden");
            });
            //切换按钮样式
            domClass[isAdd ? 'remove' : 'add'](this.couponDropBtn, "up");
            //定时器
            if (this.countdown) {
                domClass[isAdd ? 'add' : 'remove'](this.countdown, "none");
            }
        },
        setCarPartHidden : function (hidden) {
            domClass[hidden ? "add" : "remove"](this.qtyDiv, "visibility");
            domClass[hidden ? "add" : "remove"](this.minusBtn, "visibility");
        },
        addCar :function (qty) {
            if (this.qty === 0) {
                //第一次添加取消数量和减号显示,有最小起订量,直接设置为最少起订量
                this.changeCarQty(this.minQty ? this.minQty : qty, true);
                this.setCarPartHidden(false);
            } else {
                //如果变化后的数量小于最小起订量,则删除本商品
                if (this.minQty && (this.qty + qty < this.minQty)) {
                    this.changeCarQty(0, true);
                } else {
                    this.changeCarQty(qty);
                }
            }
        },
        changeCarQty : function (qty, isSet) {
            if (isSet){
                if (qty > this.mat.qty) {
                    //设置数量大于库存
                    alert("当前选择数量大于库存,最多选择"+ this.mat.qty + this.mat.sizeType + "!");
                    qty = this.mat.qty;
                }
                if (qty === 0 || (this.minQty && qty < this.minQty)){
                    qty = 0;
                    //删除购物车中商品
                    cart.clear([this.mat._id]);
                    //隐藏减和数量输入框
                    this.setCarPartHidden(true);
                } else {
                    //如果是设置数量则需要添加的数量为设置的数量减去之前的总数量
                    cart.add(this.mat._id, qty - this.qty);
                }
                this.qty = qty;
            } else {
                this.qty += qty;
                if(this.qty <= 0){
                    this.setCarPartHidden(true);
                    cart.clear([this.mat._id]);
                    this.qty = 0;
                } else if (this.qty > this.mat.qty) {
                    alert("当前选则数量大于库存,最多选择"+ this.mat.qty + this.mat.sizeType + "!");
                    this.qty = this.mat.qty
                }  else {
                    cart.add(this.mat._id, qty);
                }
            }
            this.qtyInput.value = this.qty;
            topic.publish("buy.count.change");
        },
        destroy : function () {
            if (this.countdownTimer) {
                clearInterval(this.countdownTimer);
            }
            this.inherited(arguments);
        }
    });
    return declare("whz.view.Buy", [View,_ViewMixin], {
        start : 0,
        pageSize : 10,
        //查询条件
        matParams : null,
        //商品信息 {mid:mat}
        mats : null,
        //商品优惠活动{mid:groupbuying}
        matGroupbuyings : null,
        //店铺对应商品/取优惠活动用{shopId:[mid,...]}
        shopsMats : null,
        //重写加载中的背景样式
        loadingBgClass :" ",
        currentStore : null,
        onFirstShow : function () {
            var option ={
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "买"
            }
            this.addHeader(option);
            option = {
                isHeader : true,
                columns : [{
                    label : '新旧排序',
                    className : 'flex1',
                    onClick : function (e) {
                        this.changeQuery("orderBy","createAt", e);
                    }
                }, {
                    label:'销量排序',
                    className: 'flex1',
                    onClick: function (e) {
                        this.changeQuery("orderBy","totalSale", e);
                    }
                } , /*{
                    label:'买过的',
                    className: 'flex1',
                    onClick: function (e) {
                        this.changeQuery("query", "boughtMat", e);
                    }
                }, {
                    label:'收藏商品',
                    className: 'flex1',
                    onClick: function (e) {
                        this.changeQuery("query", "collectMat", e);
                    }
                }, {
                    label:'关注厂家',
                    className: 'flex1',
                    onClick: function (e) {
                        this.changeQuery("query", "collectShopMat", e);
                    }
                }*/],
                forceWidth : false,
                isHeader : true,
                labelClass : 'font-size1 tab-selector'
            }
            this.queryList = this.addColumns(option);
            this.createContent();
            option={
                columns:[{
                    label:"<div class='countBox'>数量:<span class='qty'>0</span>合计:<span class='footerAmt count'>￥0.00</span></div>",
                    className:"edit-car-count flex1"
                },{
                    label:"<span class='amout'>选好了</span>",
                    className:"edit-car-submit",
                    onClick: function(){
                        this.onSaveStore();
                    }
                }],
                className:'fix-footer edit-car-footer',
                forceWidth:false,
                isFooter:true
            };
            this.footerDiv = this.addColumns(option);
            this.qtyDom = query(".qty",this.footerDiv)[0];
            this.countDom = query(".count",this.footerDiv)[0];
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.onAfterShow();
            this.subscribe("buy.count.change",this.onCountChange);
        },
        //刷新购物车合计和分类合计
        onCountChange : function () {
            this.refreshFooter();
            this.refreshGroupNum();
        },
        //刷新底部
        refreshFooter : function () {
            //底部合计
            var carts = cart.getAsArray(),
            price = 0;
            array.forEach(carts, function (m) {
                price += this.mats[m.mid].retailPrice * m.qty;
            }, this);
            this.qtyDom.innerHTML = cart.getNum();
            this.countDom.innerHTML = "￥" + window.fixedTo(price,3);
        },
        //刷新分类数量
        refreshGroupNum : function () {
            //处理分类数量
            var groupCarts = groupCart.get();
            //隐藏所有的分类数据角标
            array.forEach(query('.group-list-item i',this.domNode),function (i) {
                domClass.add(i,"none");
            })
            for (var sort in groupCarts) {
                if (groupCarts.hasOwnProperty(sort)) {
                    if (groupCarts[sort] > 0) {
                        var groupNum = query(".group-list-item[gid='" + sort + "'] i");
                        if (groupNum[0]) {
                            domClass.remove(groupNum[0],"none");
                            groupNum[0].innerHTML = groupCarts[sort];
                        }
                    }
                }
            }
        },
        //创建放品类和商品的切分框
        createContent : function () {
            var fixedSplitter = new FixedSplitter({
                orientation:'H',
                variablePane:1
            });
            //把这个fixedSplitter放到页面的中间部分
            fixedSplitter.placeAt(this._centerPane.domNode);
            //创建分类列表的scrollablePane
            this.createGroupPane(fixedSplitter);
            //创建商品列表scrollablePane
            this.createMatListPane(fixedSplitter);
        },
        //品类列表
        createGroupPane : function (fixedSplitter) {
            var groupPane = new Pane({
                style : "width:90px;"
            }),scrollablePane = ScrollablePane({height:'100%',style:"background-color: rgba(170, 170, 170, 0.2);"});
            groupPane.placeAt(fixedSplitter.containerNode);
            scrollablePane.placeAt(groupPane.domNode);
            this.groupList = domConstruct.create("ul",{
                "class" : "buy-group-list"
            },scrollablePane.containerNode);
            this.connect(this.groupList, "onclick", this.onGroupListClick);
        },
        //创建商品列表
        createMatListPane : function (fixedSplitter) {
            var matListPane = new Pane(),
                //原来的centerPanel放到右边自适应宽度的pane里面做商品的scrollablePane
                scrollablePane = this.matListScrollablePane = this.centerPanel;
            matListPane.placeAt(fixedSplitter.containerNode);
            matListPane.domNode.appendChild(scrollablePane.domNode);
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                className : "buy-mat-list",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, this.storeReady),
                itemMap : {
                    _data : "mat"
                },
                itemRenderer : MatItem
            });
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
        },
        storeReady : function (items) {
            if (this.currentStore !== this.store) {
                items = this.parseToMatData(items);
            }
            var data = [];
            //只需要加载需要显示的商品优惠
            this.shopsMats = {};
            array.forEach(items,function (item) {
                data.push({
                    _data : item
                });
                this.cacheData(item);
            },this);
            //取优惠信息
            groupBuy.loadGroupBuys(this.shopsMats).then(lang.hitch(this,function (groupBuyData) {
                var groupBuys = groupBuyData && groupBuyData.data && groupBuyData.data.item || {};
                for (var mid in groupBuys) {
                    if (groupBuys.hasOwnProperty(mid)) {
                        this.mats[mid].groupBuy = groupBuys[mid];
                    }
                }
                this.storeList.generateList(data);
                this.busy = false;
            }));
        },
        //品类点击
        onGroupListClick : function (e) {
            var dom = e.target;
            while (dom && !domClass.contains(dom, "group-list-item") && !domClass.contains(dom, "group-list")){
                dom = dom.parentNode;
            }
            if (dom && domClass.contains(dom, "group-list-item")) {
                if (dom === query(".selected", this.groupList)[0]) {
                    return;
                }
                this.tabSelected(dom.parentNode.children, "selected", dom);
                window.busy();
                if (domClass.contains(dom, "boughtMat")) {
                    this.loadBoughtMat();
                } else if (domClass.contains(dom, "collectMat")) {
                    this.loadCollectMat();
                } else {
                    var gid = domAttr.get(dom, "gid");
                    if (gid) {
                        this.matParams.sortId = gid;
                    } else {
                        delete this.matParams.sortId;
                    }
                    //如果不是数据不是商品数据源
                    if (this.currentStore !== this.store) {
                        this.setListStore(this.store);
                    } else {
                        this.setQuery(this.matParams);
                    }
                }
            }
        },
        tabSelected : function (doms, className, dom) {
            array.forEach(doms, function (d) {
                domClass.remove(d, className);
            });
            if (dom) {
                domClass.add(dom, className);
            }
        },
        onLoadMore : function (evt) {
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        setQuery : function (query) {
            window.busy();
            this.start = 0;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        onAfterShow : function () {
            //加载完购物车商品后才可以加载商品
            this.loadCartMats().then(lang.hitch(this, function () {
                //创建数据源
                if(!this.store){
                    this.matParams = {
                        isUse : true,
                        qty : 1,
                        orderBy : 'createAt'
                    };
                    this.store = new JsonRest({
                        target : mat.getUrlByShop() + "?shopId=" + config.getPlatformShopId()
                    });
                    //创建数据源,加载数据
                    // 将数据源赋值给storeList
                    this.setListStore(this.store);
                    //加载分类信息
                    sort.load({
                        isUse : true,
                        noSub : true
                    }).then(lang.hitch(this,function (data) {
                        //创建全部
                        domConstruct.create("li",{
                            "class" : "group-list-item selected",
                            innerHTML : "<span class='mat-list-mname'>" + "全部分类" + "</span>"
                        }, this.groupList);
                        //收藏的
                        domConstruct.create("li",{
                            "class" : "group-list-item collectMat",
                            innerHTML : "<span class='mat-list-mname'>" + "收藏商品" + "</span>"
                        }, this.groupList);
                        //购买过的
                        domConstruct.create("li",{
                            "class" : "group-list-item boughtMat",
                            innerHTML : "<span class='mat-list-mname'>" + "曾购买的商品" + "</span>"
                        }, this.groupList);
                        var items = data && data.data && data.data.items || [];
                        array.forEach(items, function (item) {
                            domConstruct.create("li",{
                                "class" : "group-list-item",
                                innerHTML : "<span class='mat-list-mname'>" + item.sortName + "</span>" +"<i class='none'>0</i>",
                                gid : item._id
                            }, this.groupList);
                        }, this);
                        //创建完成之后需要初始化数量
                        this.onCountChange();
                    }));
                }else{
                    this.setQuery(this.matParams);
                    //初始化购物车合计和分类合计
                    this.onCountChange();
                }
            }));
        },
        //初始化购物车需要用到的商品
        loadCartMats : function () {
            var def = new Deferred();
            this.mats = {};
            mat.loadByIds(cart.getIds(), config.getPlatformShopId()).then(lang.hitch(this,  function (data) {
                var items = data && data.data && data.data.items,
                    unUseMats = [];
                array.forEach(items, function (item) {
                    if (item.qty == 0 || !item.isUse) {
                        unUseMats.push(item._id);
                    } else {
                        groupCart.set(item.sortId, item._id);
                        this.cacheData(item);
                    }
                }, this);
                //清除下架无用商品
                if (unUseMats.length) {
                    cart.clear(unUseMats);
                }
                def.resolve();
            }));
            return def;
        },
        //缓存数据,商品数据
        cacheData : function (item) {
            var shopId;
            this.mats[item._id] = item;
            if (this.shopsMats && !this.shopsMats[item._id]) {
                this.shopsMats[item._id] = [];
            }
            //有团购活动并且没有过期才需要取活动
            if (this.shopsMats && item.groupBuying) {
                shopId = item.fromShopId._id ? item.fromShopId._id :  item.fromShopId;
                if (!this.shopsMats[shopId]) {
                    this.shopsMats[shopId] = [];
                }
                this.shopsMats[shopId].push(item._id);
            }
        },
        changeQuery : function (type, action, e) {
            var dom = e.target;
            this.tabSelected(query('.tab-selector', this.queryList), "selected", dom);
            if (type === 'orderBy') {
                //排序
                delete this.matParams.fromShopIds;
                this.matParams.orderBy = action;
                this.setQuery(this.matParams);
            } else {
                if (action === "collectShopMat") {
                    //收藏商家的商品
                    this.loadCollectShopMat();
                }
            }
        },
        //设置List的数据源
        setListStore : function (store) {
            this.currentStore = store;
            this.start = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setStore(store, this.matParams, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        loadBoughtMat : function () {
            this.tabSelected(query('.tab-selector', this.queryList), "selected", query('.tab-selector', this.queryList)[0]);
            this.matParams.orderBy = 'createAt';
			// 我收藏的和曾购买的，保证只查询有销量的数据
			this.matParams.startQty = 1;
            if (!this.boughtMatStore) {
                this.boughtMatStore = new JsonRest({target:boughtMat.getLoadUrl()});
            }
            this.setListStore(this.boughtMatStore);			
        },
        loadCollectMat : function () {
            this.tabSelected(query('.tab-selector', this.queryList), "selected", query('.tab-selector', this.queryList)[0]);
            this.matParams.orderBy = 'createAt';
			this.matParams.startQty = 1;
            if (!this.collectMatStore) {
                this.collectMatStore = new JsonRest({target:matStore.getShopListUrl()});
            }
            this.setListStore(this.collectMatStore);
        },
        //把购买过或者收藏的信息解析成商品数据
        parseToMatData : function (items) {
            var mats = [];
            array.forEach(items, function (item) {
                mats.push(item.mId);
            });
            return mats;
        },
        loadCollectShopMat : function () {
            shopStore.load().then(lang.hitch(this, function (data) {
                var items = data && data.data && data.data.items || [];
                var shopIds = [];
                array.forEach(items, function (item) {
                    shopIds.push(item.targetShopId._id);
                });
                this.matParams.fromShopIds = shopIds;
                this.setQuery(this.matParams);
            }));
        },
        onLoadListData : function (queryResult,start,pageSize,tp) {
            this.inherited(arguments);
            queryResult.then(lang.hitch(this,function(){
                window.free();
            }));
        },
        onSaveStore : function () {
            //把购物车中的所有的商品设为选中
            var ids = cart.getIds();
            if (ids.length) {
                cart.setSelected(cart.getIds());
                window.moveToView("orderInfo");
            } else {
                alert("您还没有选择任何商品!");
            }
        }
    });
});
