// 变更人员： 母浚驰
// 变更内容： 代码规范，添加注释，文件迁移
// 变更时间： 2016/5/17
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/biz/mk/cs/cShopConfig",
	"cq/ui/view/_ViewMixin",
	"dijit/focus"
],function(declare, lang, View, cShop, _ViewMixin, focusUtil){
	return declare("whz.view.CShop",[View,_ViewMixin],{
		
		// 是否编辑状态
		isEditing : false,
		
		onFirstShow:function(){
			
			// 创建头部信息
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						history.back();
					}
				},
				title:"客户分销",
				right :
                {iconButton : ' ', onClick : this.onSaveStore, label : "完成"}
			};
			this.addHeader(option);
			
			//分销相关信息
			option = {
				isEdge : true,
				lists : [
				/* {
					label:'推广名片模版',
					rightText : '',
					moveTo : "#",
					__view_id : this.id,
					edit:{
						type:'ref',
						field:'tempLogo',
						moveTo:"#",
						//选择商品的示例
						params:{
							target:,
							query:{
								
							},
							searchField:"",labelField:""
						}
					}
				}, */
				/*{
					label : '推广名片模版',
					noArrow : true,
					edit : {type : 'text', field : 'tempLogo', placeHolder: "未设置"}
				},*/
				{
					label : '下线奖励',
					noArrow : true,
					edit : {type : 'text', field : 'newUserAmt', placeHolder: "未设置"}
				},
				{
					label : '上线奖励',
					noArrow : true,
					edit : {type : 'text', field : 'oldUserAmt', placeHolder: "未设置"}
				},
				{
					label : '兑换比率',
					noArrow : true,
					edit : {type : 'text', field : 'exRate', placeHolder: "未设置"}
				},
				{
					label:'获取条件',
					rightText : '',
					moveTo : "#",
					__view_id : this.id,
					edit:{
						type:'options',
						field:'reqType',
						options:{
							0:'注册获取',
							1:'购买任意商品',
							2:'购买足够商品'
						}
					}
				},
				{
					label : '累计消费',
					noArrow : true,
					//edit : if(options=2){}
					//edit :{type : 'text', field : 'reqAmt', placeHolder: "未设置"}
					edit :{type : 'text', field : 'reqAmt', placeHolder: "获取条件为“购买足够商品”时填写此项,累计消费X元才能获取名片"}
					
				},
				/* {
					label:'推广二维码设置',
					rightText : '',
					moveTo : "#",
					__view_id : this.id,
					edit:{
						type:'ref',
						field:'tempId',
						moveTo:"#",
						//选择商品的示例
						params:{
							target:,
							query:{
								
							},
							searchField:"",labelField:""
						}
					}
				}, */
				/*{
					label : '推广二维码设置',
					noArrow : true,
					edit : {type : 'text', field : 'tempId', placeHolder: "未设置"}
				},
				{
					label : '示例图片',
					noArrow : true,
					edit : {type : 'text', field : 'bgUrl ', placeHolder: "未设置"}
				}*/]
			};
			this.addLists(option);

			// 提成比例相关信息
			option = {
				isEdge : true,
				lists : 
				[/*{
					label : '粉丝叫法',
					noArrow : true,
					edit : {type : 'text', field : 'fansName', placeHolder: "未设置"}
				},
				{
					label : '奖励叫法',
					noArrow : true,
					edit : {type : 'text', field : 'priseName', placeHolder: "未设置"}
				},
				{
					label : '奖励单位',
					noArrow : true,
					edit : {type : 'text', field : 'priseMeasureName', placeHolder: "未设置"}
				},*/
				{
					label : '一级提成比例',
					noArrow : true,
					edit : {type : 'text', field : 'rate1', placeHolder: "未设置"}
				},
				{
					label : '二级提成比例',
					noArrow : true,
					edit : {type : 'text', field : 'rate2', placeHolder: "未设置"}
				},
				{
					label : '三级提成比例',
					noArrow : true,
					edit : {type : 'text', field : 'rate3', placeHolder: "未设置"}
				},{
					label : '是否启用',
					noArrow : true,
					edit : {type : 'checkbox', field : 'isUse'}
				}]
			};
			this.addLists(option);
			 
			this.onAfterShow();
		},
		
		onAfterShow:function () {
			// 如果是变更，加载分销信息
			if (!this.isEditing) {
				this.isEditing = true;
				cShop.loadByShopId().then(lang.hitch(this, function(data) {
					if(data.data.item){
						this.setData(data.data.item);
					}
					this.refreshData();
				}));
			}
		},
		
		// 保存界面信息
		onSaveStore:function(){

			// 当前节点失去焦点
			focusUtil.curNode&&focusUtil.curNode.blur();
			// setTimeout 保存数据
			setTimeout(lang.hitch(this, function(){
				var m = this.getData();

				// 检查必填项是否已填
				var msg=this.verify(m);
				if(msg){
					alert(msg);
					this.isEditing = true;
					return;
				}
				cShop.save(m).then(function() {
					this.isEditing = false;
					window.moveToView("home");
				});
			}), 10);
		},
		
		// 检查必填项是否已填
		verify:function(data){
			var msg="";
			if(!data.newUserAmt){
				msg="下线奖励必须填写";
			}
			return msg;
		}
	});
});
