﻿// 变更人:徐阿雪
// 变更时间:2016/7/26
// 变更原因:团购返利详细新增页面
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/EdgeToEdgeCategory",
    "dojox/mobile/ListItem",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/groupBuy",
    "cq/biz/mat/mat",
    "cq/util/sys/date"
],function(declare,lang,array,query,JsonRest,domClass,domConstruct,Deferred,EdgeToEdgeList,EdgeToEdgeCategory,ListItem,View,registry,_ViewMixin,groupBuy,mat,date){
    //创建返利阶梯
    var BoxEdit = declare("", [View, _ViewMixin], {
        editStepDef:null,
        //开始阶梯
        startEditStep:function(item){
            this.editStepDef = new Deferred();
            this.originItem = item;
            this.setData(lang.clone(item));
            this.refreshData();
            return this.editStepDef;
        },
        indexElement:function(){
            this.inherited(arguments);
            this.addLists({
                isEdge:true,
                lists:[{
                    label:"售出件数",
                    edit:{
                        type:"text",
                        field:"qty",
                        placeHolder : "输入限制件数！"
                    }
                },{
                    label:"返回金额",
                    edit:{
                        type:"text",
                        field:"amount",
                        placeHolder : "返回现金！"
                    }
                }]
            });
            this.addColumns({
                isFooter:true,
                columns : [{
                    label: "确认",
                    onClick:this.onEditStepFinished,
                    className:"footer-tab-highlight"
                },{
                    label: "取消",
                    onClick:this.onEditStepCanceled,
                    className:"footer-tab-dark"
                }]
            });
        },
        onEditStepFinished:function(){
            this.editStepDef.resolve(this.getData());
        },
        onEditStepCanceled:function(){
            this.editStepDef.resolve(this.originItem);
        }
    });
    return declare("whz.view.GroupBuy",[View,_ViewMixin],{
        isEditing : false,
        using : true,
        onFirstShow:function(){
            //导航显示
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                       this.isEditing = false;
                       history.back();
                    }
                },
                title : "新增团购商品",
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            option ={
                isEdge:true,
                lists:[{
                    label:"选择商品",
                    noArrow:false,
                    moveTo:"#",
                    edit: {
                        type: "ref",
                        field: "mId",
                        params: {
                            target: mat.getCurrentShopOnSaleUrl(),
                            query: {
                                using :true,
                                isUse :true,
                                qty:1
                            },
                            searchField: "mName",
                            labelField: "mName"
                        }
                    }
                },{
                    label:"原价",
                    noArrow:true,
                    edit : {
                        type:"text",
                        field:"retailPrice",
                        disabled:"true"
                    }
                },{
                    label:"团购价格",
                    noArrow:true,
                    edit : {
                        type:"text",
                        field:"price"
                    }
                },{
                    label:"剩余库存",
                    noArrow:true,
                    edit : {
                        type:"text",
                        field:"qty",
                        disabled:"true"
                    }
                },{
                    label:"开始时间",
                    noArrow:false,
                    moveTo:"#",
                    edit : {
                        type:"dateMin",
                        field:"sDate"
                    }
                },{
                    label:"结束时间",
                    noArrow:false,
                    moveTo:"#",
                    edit : {
                        type:"dateMin",
                        field:"eDate"
                    }
                },{
                    label:"参团返现",
                    noArrow:true,
                    edit : {
                        type:"checkbox",
                        field:"rebateFlag"
                    }
                }]
            };
            this.addLists(option);
            option = {
                columns:[{
                    label:'新增奖励条件',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:lang.hitch(this,function(){
                        var m=this.getData();
                        m.rebateRule=array.map(this.stepList.getChildren(),function(item){
                            return item.params;
                        });
                        if(m.rebateRule.length>=5){
                            alert("返利最多能有5条");
                            return;
                        }else{
                            var item =this.getStepItemByData({});
                            this.stepList.addChild(item);
                            this.onStepItemClick({target:item.labelNode});
                        }
                        
                    })
                }/*,{
                    label:'取消活动',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:lang.hitch(this,function(){
                        this.onSaveStore({using:false});
                    })
                }*/],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
            this.addColumns(option);
            //返利标题
            var stepListTitle=new EdgeToEdgeCategory({
                label:"返现条件"
            });
            stepListTitle.placeAt(this.centerPanel.containerNode,"last");
            //添加返现阶梯
            this.stepList=new EdgeToEdgeList();
            this.stepList.placeAt(this.centerPanel.containerNode,"last");
            //点击事件
            this.stepList.on("click",lang.hitch(this,this.onStepItemClick));
            this.onAfterShow();
        },
        //阶梯接列表的点击事件  参考肖芳圆 2016-7-24
        onStepItemClick:function(e){
            var dom = e.target,propItem = registry.getEnclosingWidget(e.target);
            while (dom && !domClass.contains(dom, "mblListItemIcon")) {
                dom = dom.parentNode;
            }
            if(dom){
                //删除
                propItem.destroyRecursive();
            }else{
                //编辑
                this.startEditStep(propItem.params).then(lang.hitch(this,function(item){
                    propItem.set(this.getItemStep(item));
                    this.hideOverlay();
                }));
            }
        },
        //依据数据项生成属性列表项
        getStepItemByData:function(item){
            return new ListItem(this.getItemStep(item));
        },
        //返回的格式
        getItemStep:function(item){
            if(item.qty>=0&&item.amount>=0&&item.qty!==""&&item.amount!==""){
                return {
                    icon:"mblDomButtonRedCircleMinus",
                    params:item,
                    label:"<div>每售出达"+item.qty+",每件返现"+item.amount+"</div>",
                    moveTo:"#"
                };
            }else{
                return {
                    icon:"mblDomButtonRedCircleMinus",
                    params:item,
                    label:"<div>设置返现信息</div>",
                    moveTo:"#"
                };
            }
        },
        //创建弹窗
        startEditStep:function(item){
            if(!this.stepEditDiv){
                this.stepEditDiv=domConstruct.create("div",{
                    style:"height:400px;text-align: left;"
                });
                this.stepEditItem = new BoxEdit();
                this.stepEditDiv.appendChild(this.stepEditItem.domNode);
                setTimeout(lang.hitch(this.stepEditItem,this.stepEditItem.startup),0);
            }
            this.showInOverlay(this.stepEditDiv);
            return this.stepEditItem.startEditStep(item);
        },
        onAfterShow:function(){
            if(!this.isEditing){
                this.isEditing=true;
                if(!window.did){
                    this.header.set("label","新增团购商品");
                    this.initTempByData({
                        using : true
                    });
                }else{
                    groupBuy.loadById(window.did).then(lang.hitch(this,function(data){
                        if(data.data&&data.data.ok){
                            this.header.set("label",data.data.item.mId.mName);
                            this.initTempByData(data.data.item);
                        }
                    }));
                }
            }
        },
        //依据数据初始化界面显示 canzhao  rich
        initTempByData:function(data){
            data.qty = data.mId&&data.mId.qty||"";
            data.retailPrice = data.mId&&data.mId.retailPrice||"";
            //设置数据并刷新标准页面的显示
            this.setData(data);
            this.refreshData();
            //依据属性列表初始化属性列表的显示
            //将团购列表的额所有子节点销毁
            this.stepList.destroyDescendants();
            //初始化数据属性列表 
            data.rebateRule = data.rebateRule||[];
            //遍历所有属性，添加到列表中
            array.forEach(data.rebateRule,function(item){
                this.stepList.addChild(this.getStepItemByData(item));
            },this);
            this.centerPanel.scrollTo({x:0,y:0});
        },
        //保存参加团购商品
        onSaveStore : function(d){
            if(this.isEditing){
                //alert("asd");
                window.busy();
                var m=this.getData();
                if(m.mId){
                    m.retailPrice=m.mId.retailPrice;
                    m.mId=m.mId._id;
                }
                if(window.did){
                    m._id=window.did;
                }
                m.rebateRule=array.map(this.stepList.getChildren(),function(item){
                    return item.params;
                });
                //验证输入的正确性
                var msg=this.verify(m);
                if(msg){
                    window.free();
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                if(d.using===false){
                    m.using = false;
                }
                groupBuy.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok){
                        this.isEditing = false;
                        history.back();
                    }else{
                        if(data&&data.data&&data.data.message){
                            alert(data.data.message);
                        }else{
                            alert("保存失败");
                            this.isEditing = true;
                        }
                    }
                }));
            }
        },
        //提示验证所填选项是否合法
        //返利随购买件数增加而增加，
        //最大返利必须小于活动价
        verify : function(data){
            var msg="";
            if(!data.mId){
                msg = "请选择商品";
            }else{
                if(!data.price){
                    msg = "请添加团购价格";
                }else if(data.price&&!(/^\d+(?=\.{0,1}\d+$|$)/.test(data.price))||data.retailPrice<data.price){
                    msg = "团购价格必须是大于0而且小于原价的数字";
                }else if(!data.sDate){
                    msg = "请填写活动开始时间";
                }else if(data.sDate&&data.sDate<date.formatISODateMinutes(date.nowISOString())){
                     msg = "开始时间必须大于当前时间";
                }else if(!data.eDate){
                    msg = "请填写活动结束时间";
                }else if(data.sDate>=data.eDate){
                    msg = "开始时间不能大于结束时间";
                }else if(data.rebateFlag===true&&data.rebateRule.length===0){
                    msg = "请添加返利规则";
                }else if(data.rebateFlag===false&&data.rebateRule.length>0){
                    msg = "参团返现未开启";
                }else if(data.rebateRule.length){
                    for(var i=0;i<data.rebateRule.length;i++){
                        if(data.rebateRule[i]&&(data.rebateRule[i].amount&&!(/^\d+(?=\.{0,1}\d+$|$)/.test(data.rebateRule[i].amount)))){
                            msg += "返利金额必须大于0";
                        }else if(data.rebateRule[i]&&(data.rebateRule[i].qty<0||(data.rebateRule[i].qty%1)!==0)){
                            msg += "团购数量必须为大于0的整数";
                        }else if(data.rebateRule[i+1]&&(parseInt(data.rebateRule[i].amount)>=parseInt(data.rebateRule[i+1].amount)||parseInt(data.rebateRule[i].qty)>=parseInt(data.rebateRule[i+1].qty))){
                            msg += "返现应该是阶梯式增长";
                        }else if(data.rebateRule[i]&&(parseInt(data.price)<parseInt(data.rebateRule[i].amount))){
                            msg += "返利金额应该小于团购价格";
                        }
                    }
                }
            }
            return msg;
        },
        onDataChanged: function(field, oldValue,newValue) {
            if(field==="mId"){
                this.header.set("label",newValue&&newValue.mName||"");
                var data = this.getData();
                data.qty = data.mId&&data.mId.qty||"";
                data.retailPrice = data.mId&&data.mId.retailPrice||"";
                //设置数据并刷新标准页面的显示
                this.setData(data);
                this.refreshData();
            }
        }
    });
});