﻿// 变更人:徐阿雪
// 变更时间:2016/7/26
// 变更原因:团购返利详细界面
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/query",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/groupBuy",
    "cq/biz/mat/mat",
    "cq/util/sys/date"
],function(declare,lang,query,JsonRest,domClass,EdgeToEdgeStoreList,View,registry,_ViewMixin,groupBuy,mat,date){
    return declare("whz.view.GroupBuyList",[View,_ViewMixin],{
        //设置state:""所有团购，1未开始，2进行中，3已结束  后台筛选字段是state
        //1根据团购的sDate>=当前获取的时间，
        //2根据团购的eDate>当前获取的时间
        //3根据团购的eDate<=当前获取的时间
        //筛选条件
        params : null,
        start:0,
        pageSize:5,
        onFirstShow:function(){
            //导航
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        this.params.state = "";
                        history.back();
                    }
                },
                title : "团购返利"
            };
            this.addHeader(option);
            option = {
                isHeader: true,
                placeHolder:"请输入要查询条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.params.mName = evt.target.value;
                        this.loadGroup(this.params);
                        //this.params.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.searchBox = this.addTextBox(option);
            //创建头部
            option = {
                isHeader:true,
                columns : [{
                        label : '所有团购',
                        onClick : function(e){
                            this.params.state = "";
                            this.params.mName = '';
                            this.changeOnList(e);
                        }
                    }, {
                        label : '未开始',
                        onClick : function(e){
                            this.params.state=1;
                            this.params.mName = '';
                            this.changeOnList(e);
                        }
                    }, {
                        label : '进行中',
                        onClick : function(e){
                            this.params.state=2;
                            this.params.mName = '';
                            this.changeOnList(e);
                        }
                    },{
                        label:'已结束',
                        onClick : function(e){
                            this.params.state=3;
                            this.params.mName = '';
                            this.changeOnList(e);
                        }
                    },{
                        label:'已失效',
                        onClick : function(e){
                            this.params.state=4;
                            this.params.mName = '';
                            this.changeOnList(e);
                        }
                    }],
                labelClass : 'font-size1 tab-selector'
            };
            this.addColumns(option);
            option = {
                columns :[{
                    label : "新建团购",
                    onClick:function(){
						window.moveToView("groupBuy");
					}
                }],
                labelClass : 'font-size1',
                className : 'padding-top-bottom16',
                isFooter : true
            };
            this.addColumns(option);
            this.onCreatList();
            //默认加载所有团购商品列表
            this.params.state = "";
            this.onAfterShow();
        },
        //创建列表
        onCreatList : function(){
            //创建团购商品列表
            this.groupBuyList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"mat-list-verticalList2",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        //判断是否有返现，有就显示，否则就不显示
                        var fxMsg="",status="取消团购",classname="nothing";
                        if(data[i].rebateRule&&data[i].rebateRule.length){
                            for(var index=0;index<data[i].rebateRule.length;index++){
                                fxMsg+="满"+data[i].rebateRule[index].qty+",减"+data[i].rebateRule[index].amount+"元  ";
                            }
                        }
                        if(data[i].isClosed === true&&data[i].isCanceled === false){
                            status="已结束";
                        }else if(data[i].isCanceled === true&&data[i].isClosed === false){
                            status="已失效";
                        }else if(data[i].isCanceled === false&&data[i].isClosed === false&&data[i].using === true&&data[i].sDate<date.nowISOString()){
                            //活动开始时间小于当前计算机时间
                            status="活动中";
                        }
                        var sDate = date.formatISODateMinutes(data[i].sDate);
                        var eDate = date.formatISODateMinutes(data[i].eDate);
                        //isCanceled true  using false
                        if(!data.mId){
                            if(data[i].isCanceled === false&&data[i].isClosed === false&&data[i].using === true&&data[i].sDate>date.nowISOString()){
                                classname="cancel";
                            }
                            data[i]._label="<div class='mat-list-imgpart'><img src='"+data[i].mId.logo+"'></div>"+
                                "<div class='shelf-mat-title'><span style='width:40%'>"+data[i].mId.mName+"</span><span class='"+classname+"' style='color:#00F;float:right'>"+status+"</span>"+
                                "</div><div class='shelf-mat-title'>原价："+data[i].mId.retailPrice+"<span style='float:right'>  销量："+data[i].totalSale+"</span>" +
                                "</div><div class='shelf-mat-title'>折扣价："+data[i].price+""+
                                "</div><div class='shelf-mat-title'><span>开始时间："+sDate+"</span>"+
                                "</div><div class='shelf-mat-title'><span>截止时间："+eDate+"</span>"+
                                "</div><div class='shelf-mat-title'><span>"+fxMsg+"</span>" +
                                "</div>"
                        }
                    }
                    this.groupBuyList.generateList(data);
                    this.busy=false;
                }),
                itemMap:{
                    _label:"label"
                }
            });
            this.groupBuyList.placeAt(this.centerPanel.containerNode,"last");
            //列表的点击事件
            this.groupBuyList.on("click",lang.hitch(this,this.onClickList));
            //添加滚动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        //根据type加载团购商品信息  给出query的值 
        loadGroup : function(){
            this.start = 0;
            this.groupBuyList.destroyDescendants();
            if(this.store){
                this.busy = true;
                var queryResult= this.groupBuyList.setQuery(this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                //如果没有store就创建数据源
                this.store = new JsonRest({target:groupBuy.getLoadUrl()});
                this.busy=true;
                var queryResult =this.groupBuyList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        //拖动加载更多
        onLoadMore:function(e){
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.groupBuyList.setQuery(this.groupBuyList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        onAfterShow:function(){
            //返回的时候应该还是在原来对应的列表
            if(this.params.state===""){
                this.changeOnList({
                    target:query(".tab-selector",this.domNode)[0]
                });
            }else{
                this.changeOnList({
                    target:query(".tab-selector",this.domNode)[this.params.state]
                });
            }
        },
        //选中样式
        changeOnList:function(e){
            //清空
            this.clearSelected();
            //事件发生触发添加selected样式
            domClass.add(e.target, "selected");
            this.loadGroup();
        },
        //清空所有状态
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                //移除每个节点的selected类
                domClass.remove(items[i], "selected");
            }
        },
        //将团购中的取消活动价canceled节点
        
        /**列表的点击事件   如果点击到cancel节点上就取消操作，根据列表的isCancled和isClosed做是否可以点击的判断
        否则就做跳转*/
        onClickList:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")return;
            var dom = evt.target;
            var _id = li.params._id;
            var rebateRule=li.params.rebateRule;
            //判断是否可以点击  
            var isCanceled=li.params.isCanceled;
            var isClosed=li.params.isClosed;
            if(isCanceled===true||isClosed===true){
                alert("失效活动不允许编辑");
                this.isEditing = true;
            }else if(dom&&domClass.contains(dom,"cancel")){
                var m={};
                m._id= _id;
                m.using = false;
                m.rebateRule=rebateRule;
                groupBuy.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok){
                        alert("取消成功");
                        this.loadGroup();
                    }else{
                        if(data&&data.data&&data.data.message){
                            alert(data.data.message);
                            this.isEditing = true;
                        }else{
                            alert("保存失败");
                            this.isEditing = true;
                        }
                    }
                }));
            }else{
                window.moveToView("groupBuy",_id);
            } 
        }
    });
});