define(
    [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojo/dom-class",
	"dojo/dom-style",
	"dojo/dom-attr",
	"dojo/on",
	"dojo/when",
	"dojo/query",
	"dijit/registry",
	"dojo/touch",
	"cq/ui/view/_ViewMixin"
    ],
    function(declare, lang, array, domClass, domStyle, domAttr, on,when,query, registry, touch,_ViewMixin) {
	return declare("whz.view.ListMixin", _ViewMixin, {
		//页面头部组件对象
		headerObj : null,
		// 搜索条件，页码，显示数量需要配置
		// 搜索属性对象
		searchObj : null,
		// 每页显示数量，下拉刷新时用到
		pageSize : 10,
		// 搜索框对象
		search : null,
		// tab对象
		tab : null,
		// list对象
		storeList:null,
		// 初始化页面元素
		indexElement : function(){
			this.inherited(arguments);
			this.indexHeader();
			this.indexSearchElement();
			this.indexTabElement();
			this.indexListElement();
			this.indexFloor();
		},
		// 初始化事件
		initEvent : function(){
			this.inherited(arguments);
			this.initSearchEvent();
			this.initTabEvent();
			this.initListEvent();
		},
		// 初始化页面组件方法,页面组件做为当前对象的属性
		indexHeader:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : lang.hitch(this,function() {
						window.moveToView(this.headerObj.backView);
					})
				},
				title : this.headerObj.title
			};
			this.addHeader(option);
		},
		//添加尾部按钮的接口
		indexFloor : function(){},
		
		//初始化输入框，如果search_field存在
		indexSearchElement : function(){
			if(this.searchObj){
				option = {
					placeHolder : this.searchObj.placeHolder,
					type : "search",
					class:"cqSearchBox"
					//onInput:lang.hitch(this,this.onInputSearch)
				};
			this.search = this.addTextBox(option);
			}
		},
		indexTabElement : function(){
			
		},
		indexListElement:function(){
			
		},
		//为搜索框绑定事件
		initSearchEvent : function(){
			this.search.on("input",lang.hitch(this,this.onInputSearch));
		},
		initTabEvent : function(){
			
		},
		initListEvent : function(){
			//为List列表绑定拖动加载更多
			on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
			//为List列表项绑定点击事件
			this.storeList.on("click",lang.hitch(this,this.onClickList));
		},
		//提供拖动加载更多的接口
		onLoadMore : function(evt){
			//处理默认判断 是否继续加载
			if(this.busy||(0<this.end&&(this.start+this.pageSize-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多商品");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: this.pageSize
					}), lang.hitch(this,function(){
						this.centerPanel.resize();
					}));
				}), 1000);
			}
		},
		//搜索框绑定的响应事件
		onInputSearch : function(evt){
			if(evt.keyCode == 13){
				this.search = evt.target.value;
				var condition = this.storeList.get("query");
				var filed=this.searchObj.filed;
				condition[filed] = evt.target.value;
				this.setQuery(condition);
				//evt.target.value = "";
			}
		},
		//提供List列表项点击事件的接口
		onClickList : function(evt){},
		
		
		// 获取查询参数，返回params对象
		getDataParams : function(){},
		
		// 设置storeList的查询参数
		setQuery : function(query){
			this.start=0;
			this.end=-1;
			//清空原有的storeList中的数据
			this.storeList.destroyDescendants();
			this.storeList.setQuery(query,{
				start: this.start,
				count: this.pageSize
			});
			this.centerPanel.resize();
		},
		// 获取数据完成之后，对数据进行处理
		onDefRendered : function(data){
			
		}
	});
});