define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",	
	"dojo/_base/xhr",
	"dojo/query",
	"dijit/registry",
	"cq/biz/article/article",
	"dojo/on",
	"dojo/when",
	"dojo/store/Memory",
	"dojo/store/JsonRest",
	"dojo/store/Observable",
	"whz/view/ListMixin"
],function(declare,lang,View,EdgeToEdgeStoreList,xhr,query,registry,article,on,when,Memory,JsonRest,Observable,ListMixin){
	return declare("whz.view.ListViewTest",[View,ListMixin],{
		start:0,
		pageSize:1,
		//配置头部部分的参数
		headerObj:{backView:"home",title:"咨询管理"},
		//配置搜索框参数
		searchObj:{filed:"title",placeHolder:"请输入店铺的名字"},
		//初始化相关接口
		indexFloor:function(){
			option = {
				columns:[{
					label:'添加资讯',
					icon:'images/icon/addnews.png',
					iconClass:'width-16',
					onClick:function(){
						window.moveToView("new");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
		},
		
		//初始化列表
		indexListElement:function(){
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){
						data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].title+"</div>";
						data[i]._label+="<div class='mat-list-margin'>"+data[i].brief+"</div>"
						data[i].moveTo="#";
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions: {
					count: this.pageSize,
					start: this.start
					},
				itemMap:{_label:"label",logo:"icon", moveTo:"moveTo"}
			});
			this.storeList.placeAt(this.centerPanel.containerNode,"last");
		},

		onAfterShow:function(){
			this.setQuery(this.storeList.get("query"),{
				start: this.start,
				count: this.pageSize		
			});
		},
		onFirstShow:function(){
			// 创建数据源
			this.params={};
			this.store = new JsonRest({target:article.getArticleUrl()});
			// 将数据源赋值给storeList
			this.storeList.setStore(this.store,this.params);
		},
		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params._id;
			window.moveToView("new",_id);
		}
	});
});
