// 变更人员： 母浚驰
// 变更内容： 抽奖活动编辑详情
// 变更时间： 2016/5/20
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/query",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dijit/registry",
	"dojo/dom-class",
	"dojo/dom-construct",
	"dojox/mobile/ListItem",
	"dojox/mobile/EdgeToEdgeList",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",
	"dojo/Deferred",
	"dojo/store/JsonRest",
	"cq/util/sys/date",
	"cq/util/sys/xlsx",
	"cq/util/config/config",
	"cq/biz/article/mk/prize",
	"cq/biz/article/mk/award",
	"cq/biz/user/user",
	"dijit/focus"
], function (declare, lang, query, View, _ViewMixin, registry, domClass, domConstruct, ListItem, EdgeToEdgeList, EdgeToEdgeStoreList, on, when, Deferred, JsonRest, date, xlsx, config, prize, award, user,focusUtil) {

	// 客户列表
	var SendAward = declare("", [View, _ViewMixin], {
		indexElement : function () {

			// 确定和取消
			option = {
				columns : [{
					label : "取消",
					onClick : lang.hitch(this, function () {
						this.hideOverlay();
					}),
					className : "footer-tab-dark"
				}],
				labelClass : 'font-size2',
				className : 'fix-footer',
				isFooter : true
			}
			this.addColumns(option);

			// 查询客户
			option = {
				placeHolder:"请输入要查询条件，按回车查询",
				class:"cqSearchBox",
				type:"search",
				onInput:lang.hitch(this,function(evt){
					if(evt.keyCode==13){
						this.search = evt.target.value;
						var condition = this.storeList.get("query");
						condition.search = evt.target.value;
						this.setQuery(condition);
						evt.target.value = "";
					}
				})
			};
			this.addTextBox(option);
			
			// 客户列表
			this.storeList = new EdgeToEdgeStoreList({
				append : true,
				constraint : false,
				query : {},
				class : "icon-list-item",
				variableHeight : true,
				onComplete : lang.hitch(this, function (data) {
					for (var i = 0; i < data.length; i++) {
						data[i]._label = "<div class='webkit-list'>"
							 + "<div class='user-list-left user-list-margin'>昵称:" + (data[i].wxNick || "") + "</div>"
							 + "<div class='user-list-right user-list-margin'>余额:" + (data[i].amount || "") + "</div>"
							 + "</div>"
							 + "<div class='webkit-list'>"
							 + "<div class='user-list-left user-list-margin'>姓名:" + (data[i].pName || "") + "</div>"
							 + "<div class='user-list-right user-list-margin'>电话:" + (data[i].phone || "") + "</div>"
							 + "</div>"
					}
					this.storeList.generateList(data);
					this.end = this.start + data.length - 1;
					this.busy = false;
				}),
				// 查询条件
				queryOptions : {
					count : 20,
					start : this.start
				},
				itemMap : {
					_label : "label",
					_logo : "icon",
					moveTo : "moveTo"
				}
			});
			this.params = {};
			// 创建数据源
			this.store = new JsonRest({
				target : user.getUserUrl()
			});

			// 将数据源赋值给StoreList
			this.storeList.setStore(this.store, this.params);
			this.storeList.placeAt(this.centerPanel.containerNode, "last");
			this.storeList.on("click", lang.hitch(this, this.onClickList));
			on(this.centerPanel, "afterscroll", lang.hitch(this, this.onLoadMore));

			this.centerPanel.set("style", "height:400px;text-align: left;");
		},
		// 点击客户列表事件
		onClickList : function (evt) {
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if (li.declaredClass != "dojox.mobile.ListItem")
				return;
			var _id = li.params._id;
			this.currentDef.resolve(_id);
			this.hideOverlay();
		},

		// 加载更多客户
		onLoadMore : function (evt) {
			if (this.busy || (0 < this.end && (this.start + 10 - 1 > this.end))) {
				return true;
			}
			if (evt.afterBottom) {
				this.start = this.end + 1;
				this.busy = true;
				setTimeout(lang.hitch(this, function () {
					when(this.storeList.setQuery(this.storeList.get("query"), {
							start : this.start,
							count : 20
						}), lang.hitch(this, function () {
							this.centerPanel.resize();
						}));
				}), 1000);
			}
		},
		
		// 设置查询条件
		setQuery:function(query){
			this.start = 0;
			this.end = -1;
			this.storeList.destroyDescendants();
			this.storeList.setQuery(query,{
				start: this.start,
				count: 20
			});
			this.centerPanel.resize();
		},

		showAuditOption : function () {
			this.currentDef = new Deferred();
			
			this.startup();
			this.refreshData();
			
			return this.currentDef;
		}
	});

	return declare("whz.view.LuckyDrawDetail", [View, _ViewMixin], {

		// 奖项列表
		parseDatas : [],

		// 初始化加载显示内容
		onFirstShow : function () {

			// 创建头部信息
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : lang.hitch(this, function () {
						window.moveToView("luckyDrawList");
					})
				},
				title : "添加活动",
				right : {
					icon : "images/icon/more_header.png"
				}
			};
			this.header = this.addHeader(option);

			//分销相关信息
			option = {
				isEdge : true,
				lists : [{
					label : '活动名称',
					noArrow : true,
					rightText : '{{prizeName}}'
				}, {
					label : '中奖类型',
					noArrow : true,
					rightText : '{{luckTypeText}}'
				}, {
					label : '最多可中奖量',
					noArrow : true,
					rightText : '{{maxLucky}}'
				}, {
					label : '活动开始时间',
					noArrow : true,
					rightText : '{{startTimeText}}'
				}, {
					label : '活动结束时间',
					noArrow : true,
					rightText : '{{endTimeText}}'
				}, {
					label : '是否可购买抽奖机会',
					noArrow : true,
					edit : {
						type : 'checkbox',
						field : 'canBuy',
						value : 'on'
					}
				}, {
					label : '消耗余额',
					noArrow : true,
					'class' : 'consumption',
					rightText : '{{price}}'
				}, {
					label : '每天赠送',
					noArrow : true,
					edit : {
						type : 'checkbox',
						field : 'everyDay',
						value : 'on'
					}
				}, {
					label : '免费抽奖次数',
					noArrow : true,
					'class' : 'freeTimes',
					rightText : '{{freeNum}}'
				}, {
					label : '活动说明信息',
					noArrow : true,
					rightText : '{{content}}'
				}]
			};
			this.addLists(option);

			// 添加奖项列表
			this.onCreatList();

			// 编辑活动按钮
			option = {
				columns : [
				{
					label : '编辑活动',
					icon : 'images/icon/crmicon.png',
					iconClass : 'width-16',
					onClick : function () {
						window.moveToView("luckyDrawPost", window.did);
					}
				}],
				valueClass : 'font-size3',
				labelClass : 'font-size1',
				className : 'fix-footer',
				isFooter : true
			}
			this.addColumns(option);

			option = {
				isEdge : true,
				lists : [{
					label : '活动状态',
					noArrow : true,
					rightText : '{{stateText}}'
				}, {
					label : '审核时间',
					noArrow : true,
					rightText : '{{verifyTimeText}}'
				}, {
					label : '停用时间',
					noArrow : true,
					rightText : '{{stopTimeText}}'
				}]
			}
			this.addLists(option);

			this.connectAuditEvent();
			this.onAfterShow();
		},

		// 审核状态转为文字
		parseState : function (reasonId) {
			var reason = "";
			var reasons = {
				0 : '待审核',
				1 : '已审核',
				4 : '已停用'
			};
			reason = reasons[reasonId] || "未知";
			return reason;

		},

		// 审核状态转为文字
		parseLuckType : function (reasonId) {
			var reason = "";
			var reasons = {
				0 : '随机中奖',
				1 : '先到先得'
			};
			reason = reasons[reasonId] || "未知";
			return reason;

		},

		// 加载数据并显示页面
		onAfterShow : function () {
			//销毁原有列表项
			this.awardList.destroyDescendants();
			this.parseDatas = [];
			if (window.did) {
				prize.loadById(window.did).then(lang.hitch(this, function (data) {
					if (data.data.item) {
						// 头部名称改变
						this.header.set("label", data.data.item.prizeName);

						// 转换显示信息的样式
						data.data.item.stateText = this.parseState(data.data.item.state);
						data.data.item.luckTypeText = this.parseLuckType(data.data.item.luckType);
						data.data.item.startTimeText = data.data.item.startTime && date.formatISODate(data.data.item.startTime);
						data.data.item.endTimeText = data.data.item.endTime && date.formatISODate(data.data.item.endTime);
						data.data.item.verifyTimeText = data.data.item.verifyTime && date.formatISODate(data.data.item.verifyTime);
						data.data.item.stopTimeText = data.data.item.stopTime && date.formatISODate(data.data.item.stopTime);

						// 审核状态判断是否显示编辑按钮
						if (data.data.item.state !== 0) {
							domClass.add(query(".fix-footer", this.domNode)[0], "none");
							this.resize();
						} else {
							domClass.remove(query(".fix-footer", this.domNode)[0], "none");
							this.resize();
						}

						this.setData(data.data.item);
					}
					this.freeTimeShow();
					this.refreshData();
				}));
				award.loadByPrizeId(window.did).then(lang.hitch(this, function (data) {
					if (data && data.data && data.data.items) {
						for (var i = 0; i < data.data.items.length; i++) {
							this.parseDatas.push(data.data.items[i]);
						}
						this.addSectionsToList(this.parseDatas);
						for (var i = 0; i < this.parseDatas.length; i++) {
							if (this.parseDatas[i].awardType === 0) {
								domClass.add(query(".luckyDraw-awardAmount", this.domNode)[i], "none");
							} else {
								domClass.remove(query(".luckyDraw-awardAmount", this.domNode)[i], "none");
							}
						}
					}
					this.freeTimeShow();
					this.refreshData();
				}));
			}
		},

		// 绑定头部右按钮点击事件
		connectAuditEvent : function () {
			this.connect(query(".header-image", this.domNode)[0], "onclick", function (e) {
				if (this.getData().state === 4) {
					alert("活动已经停用，不能操作");
				} else {
					this.showAudit(this.getData().state);
				}
			});
		},
		
		// 免费抽奖次数和消耗余额的显示
		freeTimeShow : function () {
			if(query(".freeTimes", this.domNode)[0]){
				if (this.getData().everyDay === false) {
					domClass.add(query(".freeTimes", this.domNode)[0], "none");
				} else {
					domClass.remove(query(".freeTimes", this.domNode)[0], "none");
				}
			}
			if(query(".consumption", this.domNode)[0]){
				if (this.getData().canBuy === false) {
					domClass.add(query(".consumption", this.domNode)[0], "none");
				} else {
					domClass.remove(query(".consumption", this.domNode)[0], "none");
				}
			}
		},

		// 创建列表
		onCreatList : function () {
			this.awardList = new EdgeToEdgeList({
				variableHeight : true,
				"class" : "section-list",
				editable : true
			});
			this.awardList.placeAt(this.centerPanel.containerNode, "last");
		},

		// 客户列表
		sendAwardEdit : function () {
			this.sendAward = new SendAward();
			this.awardEditDiv = domConstruct.create("div", {
				style : "height:400px;"
			});
			this.awardEditDiv.appendChild(this.sendAward.domNode);
			this.showInOverlay(this.awardEditDiv);
			return this.sendAward.showAuditOption();
		},

		// 添加奖项进入列表
		addSectionsToList : function (datas) {
			var listItem = null;
			//遍历所有栏目
			for (var i = 0; i < datas.length; i++) {
				listItem = new ListItem({
					label : "<div><span class='luckyDraw-awardName'>奖品名称：" + (datas[i].awardName || "未知") + " </span>"
					 + "<span class='luckyDraw-awardNum'>奖品数量：" + (datas[i].awardNum || "0") + "</span></div>"
					 + "<div><span class='luckyDraw-handledNum'>已中数量：" + (datas[i].handledNum || "0") + " </span>"
					 + "<span class='luckyDraw-handleTime'>最新中奖时间：" + (datas[i].handleTime ? this.parseType(datas[i].handleTime) : "未知") + "</span></div>"
					 + "<div><span class='luckyDraw-awardType'>奖品类型：" + ((datas[i].awardType !== "0") ? this.parseType(datas[i].awardType) : "未知") + " </span>"
					 + "<span class='luckyDraw-awardAmount'>积分金额：" + (datas[i].awardAmount || "0") + "</span></div>",
				});
				listItem.set("params", datas[i]);

				//添加到list中
				this.awardList.addChild(listItem);

			}
		},

		// 奖品类型
		parseType : function (reasonId) {
			var reason = "";
			var reasons = {
				0 : '普通奖品',
				1 : '赠送积分'
			};
			reason = reasons[reasonId] || "未知";
			return reason;

		},

		// 审核/撤销审核/获取链接/预览/导出中奖明细/赠送抽奖
		showAudit : function (type) {
			// 未审核 进行审核
			if (type === 0) {
				if (this.auditDiv) {
					this.showInOverlay(this.auditDiv);
				} else {
					var auditPart1 = this.addColumns({
						columns : [{
							icon : "images/icon/addRecord.png",
							iconClass : 'width-58 audit',
							label : '审核',
							onClick : lang.hitch(this, function () {
								// 审核
								this.onAuditClick(0);
							}),
						}, {
							icon : "images/icon/addRecord.png",
							iconClass : 'width-58 audit',
							label : '停用',
							onClick : lang.hitch(this, function () {
								// 审核
								this.onAuditClick(1);
							}),
						}],
						className : "bottom-margin8 padding-top-bottom16",
						labelClass : '',
						valueClass : ''
					});
					var auditCancel = this.addColumns({
						columns : [{
							label : '取消',
							className : 'font-size3 edit-car-submit',
							onClick : lang.hitch(this, function () {
								this.hideOverlay();
							})
						}],
						className : "footer-tab-normal",
						labelClass : '',
						valueClass : ''
					});
					this.auditDiv = domConstruct.create('div');
					this.auditDiv.className = "auditAll";
					this.auditDiv.appendChild(auditPart1);
					this.auditDiv.appendChild(auditCancel);
					this.showInOverlay(this.auditDiv);
				}
			} else if (type === 1) {
				if (this.preview) {
					this.showInOverlay(this.preview);
				} else {
					var previewPart1 = this.addColumns({
						columns : [{
							icon : "images/icon/addRecord.png",
							iconClass : 'width-58 preview',
							label : '获取链接',
							onClick : lang.hitch(this, function () {
								// 获取链接
								this.onPreviewClick(0);
							}),
						}, {
							icon : "images/icon/addRecord.png",
							iconClass : 'width-58 preview',
							label : '预览',
							onClick : lang.hitch(this, function () {
								// 预览
								this.onPreviewClick(1);
							}),
						}],
						className : "bottom-margin8 padding-top-bottom16",
						labelClass : '',
						valueClass : ''
					});

					var previewPart2 = this.addColumns({
						columns : [{
							icon : "images/icon/addRecord.png",
							iconClass : 'width-58 preview',
							label : '赠送抽奖',
							onClick : lang.hitch(this, function () {
								// 赠送抽奖
								this.onPreviewClick(2);
							}),
						}, {
							icon : "images/icon/addRecord.png",
							iconClass : 'width-58 preview',
							label : '导出中奖明细',
							onClick : lang.hitch(this, function () {
								// 导出抽奖明细
								this.onPreviewClick(3);
							}),
						}],
						className : "bottom-margin8 padding-top-bottom16",
						labelClass : '',
						valueClass : ''
					});

					var previewPart3 = this.addColumns({
						columns : [{
							icon : "images/icon/addRecord.png",
							iconClass : 'width-58 preview',
							label : '停止活动',
							onClick : lang.hitch(this, function () {
								// 停止活动
								this.onPreviewClick(4);
							}),
						}],
						className : "bottom-margin8 padding-top-bottom16",
						labelClass : '',
						valueClass : ''
					});

					var previewCancel = this.addColumns({
						columns : [{
							label : '取消',
							className : 'font-size3 edit-car-submit',
							onClick : lang.hitch(this, function () {
								this.hideOverlay();
							})
						}],
						className : "footer-tab-normal",
						labelClass : '',
						valueClass : ''
					});
					this.preview = domConstruct.create('div');
					this.preview.className = "previewAll";
					this.preview.appendChild(previewPart1);
					this.preview.appendChild(previewPart2);
					this.preview.appendChild(previewPart3);
					this.preview.appendChild(previewCancel);
					this.showInOverlay(this.preview);
				}
			}
		},

		// 审核/停用
		onAuditClick : function (type) {
			var datas = this.getData();
			if (type === 0) {
				if (Date.parse(date.formatISODate(datas.startTime)) < Date.parse(date.formatISODate(new Date()))) {
					alert("活动已经开始，不能审核");
					return;
				}
				// 审核活动
				prize.verifyById(window.did).then(lang.hitch(this, function (result) {
					if(result.data.ok){
						this.hideOverlay();
						this.onAfterShow();
					}else {
						alert("活动审核失败");
						this.hideOverlay();
						this.onAfterShow();
					}
				}));
			} else if (type === 1) {
				// 停止活动
				prize.stopById(window.did).then(lang.hitch(this, function (result) {
					if(result.data.ok === 1){
						this.hideOverlay();
						this.onAfterShow();
					}else {
						alert("无法停止活动");
						this.hideOverlay();
						this.onAfterShow();
					}
				}));
			}
		},
		
		// 导出中奖明细
		excelExport: function(datas){
			var data = {};
			data.columns = [{
				field: "userId.pName",
				name: "客户姓名"
			},{
				field: "userId.wxNick",
				name: "微信昵称"
			},{
				field: "userId.phone",
				name: "联系电话"
			},{
				field: "userId.address",
				name: "联系地址"
			},{
				field: "awards.awardName",
				name: "奖品"
			},{
				field: "createAt",
				name: "中奖时间" 
			}];
			data.datas = [];
			for(var i = 0; i < datas.length; i++){
				data.datas.push(datas[i]);
			}
			return data;
		},

		// 撤销审核/获取链接/预览/停用/赠送抽奖
		onPreviewClick : function (type) {
			if (type === 0) {
				// 获取活动地址
				prompt("活动地址", config.getDataOrigin() + "/w/home/" + prize.getShopId() + "#prizeBigWheel-" + window.did);
				this.hideOverlay();
			} else if (type === 1) {
				// 预览
				var url = config.getDataOrigin() + "/w/home/" + prize.getShopId() + "#prizeBigWheel-" + window.did;
				localStorage.setItem("from", "luckyDrawDetail-"+window.did);
				window.moveToView("iframe", encodeURIComponent(url + "," + this.getData().prizeName))
				this.hideOverlay();
			} else if (type === 2) {
				// 赠送指定客户抽奖次数
				this.sendAwardEdit().then(lang.hitch(this,function(result){
					if(result){
						prize.giftToUser(window.did,result).then(lang.hitch(this, function (result) {
							if(result.data.ok){
								alert("赠送成功");
							}
						}));
					}
				}));
			} else if (type === 3) {
				// 导出中奖明细
				prize.loadWinners(this.getData()._id).then(lang.hitch(this,function(result){
					if(result.data.ok === 1){
						if(result.data&&result.data.items){
							var datas = this.excelExport(result.data.items);
							xlsx.export(datas,this.getData().prizeName);
						}
					}else {
						alert("导出失败");
					}
					this.hideOverlay();
				}));
			} else if (type === 4) {
				// 停止活动
				prize.stopById(window.did).then(lang.hitch(this, function (result) {
					if(result.data.ok){
						this.hideOverlay();
						this.onAfterShow();
					}else {
						alert("无法停止活动");
						this.hideOverlay();
						this.onAfterShow();
					}
				}));
			}
		}
	});
});
