// 变更人员： 母浚驰
// 变更内容： 抽奖活动列表
// 变更时间： 2016/5/20
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojo/query",
	"dojo/dom-class",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dijit/registry",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",
	"cq/biz/article/mk/prize",
	"cq/util/sys/date",
	"cq/biz/user/user",
	"dojo/store/JsonRest"
], function (declare, lang, array, query, domClass, View, _ViewMixin, registry, EdgeToEdgeStoreList, on, when, prize, date, user, JsonRest) {
	return declare("whz.view.LuckyDrawList", [View, _ViewMixin], {

		// 初始化开始值
		start : 0,

		// 设置页面内容的url
		url : "",

		// 加载数据并显示页面
		onAfterShow : function () {
			// 判断是否登陆
			user.hasLogin().then(lang.hitch(this, function (s) {
					if (s) {
						if (this.url === prize.getLoadUrl()) {
							this.setQuery(this.getParse(window.did), {
								start : 0,
								count : 10
							});
						} else {
							this.url = prize.getLoadUrl();
							// 创建数据源
							this.store = new JsonRest({
								target : prize.getLoadUrl()
							});
							// 将数据源赋值给storeList
							this.storeList.setStore(this.store, this.getParse(window.did), {
								start : 0,
								count : 10
							});
						}
						this.changeOnAll(window.did);
					} else {
						window.moveToView("login");
						user.nextPage = "luckyDrawList";
					}
				}));
		},

		// 创建列表
		onFirstShow : function () {
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function () {
						window.moveToView("others");
					}
				},
				onClick : function () {},
				title : "抽奖活动"
			};
			this.addHeader(option);

			// 活动状态
			option = {
				columns : [{
						label : '待审核',
						className : 'footer-tab-col-highlight sweepstakes',
						onClick : lang.hitch(this, function (e) {
							window.moveToView("luckyDrawList", "0");
						})
					}, {
						label : '已审核',
						className : 'sweepstakes',
						onClick : lang.hitch(this, function (e) {
							window.moveToView("luckyDrawList", "1");
						})
					}, {
						label : '已停用',
						className : 'sweepstakes',
						onClick : lang.hitch(this, function (e) {
							window.moveToView("luckyDrawList", "2");
						})
					}
				],
				labelClass : 'font-size1 tab-selector'
			}
			this.addColumns(option);

			option = {
				columns : [{
						label : '添加活动',
						icon : 'images/icon/crmicon.png',
						iconClass : 'width-16',
						onClick : function () {
							window.moveToView("luckyDrawPost");
						}
					}
				],
				valueClass : 'font-size3',
				labelClass : 'font-size1',
				className : 'fix-footer',
				isFooter : true
			}
			this.addColumns(option);

			this.onCreatList();
			this.onAfterShow();
		},

		// 创建列表
		onCreatList : function () {
			this.storeList = new EdgeToEdgeStoreList({
					append : true,
					constraint : false,
					query : {},
					class : "icon-list-item",
					variableHeight : true,
					//获取数据完成后调用的的处理方法
					onComplete : lang.hitch(this, function (data) {
						for (var i = 0; i < data.length; i++) {
							data[i]._label = "<span class='luckyDraw-prizeName'>活动名称：" + data[i].prizeName + "</span>"
								 + "<div><span class='luckyDraw-startTime'>活动开始时间：" + date.formatISODate(data[i].startTime) + "</span></div><div><span class='luckyDraw-endTime'>活动结束时间：" + date.formatISODate(data[i].endTime) + "</span></div>"
						}
						this.storeList.generateList(data);
						this.end = this.start + data.length - 1;
						this.busy = false;
					}),
					itemMap : {
						_label : "label",
						logo : "icon"
					}
				});

			this.storeList.placeAt(this.centerPanel.containerNode, "last");

			// 侦听列表点击事件
			this.storeList.on("click", lang.hitch(this, this.onClickList));

			// 侦听列表下拉事件
			on(this.centerPanel, "afterscroll", lang.hitch(this, this.onLoadMore));
		},

		// 审核状态转为文字
		parseType : function (reasonId) {
			var reason = "";
			var reasons = {
				0 : '待审核',
				1 : '已审核',
				4 : '已停用'
			};
			reason = reasons[reasonId] || "未知";
			return reason;

		},

		// 订单查询时的属性
		getParse : function (type) {
			if (type === "0" || !type) {
				return {state : 0};
			} else if (type === "1") {
				return {state : 1};
			} else if (type === "2") {
				return {state : 4};
			}
		},

		//订单类型改变
		changeOnAll : function (type) {
			array.forEach(query(".sweepstakes", this.domNode), function (list, index) {
				domClass.remove(list, "footer-tab-col-highlight");
			});
			if (type) {
				domClass.toggle(query(".sweepstakes", this.domNode)[parseInt(type)], "footer-tab-col-highlight");
			} else {
				domClass.toggle(query(".sweepstakes", this.domNode)[0], "footer-tab-col-highlight");
			}
		},

		// 设置查询条件
		setQuery : function (query) {
			this.start = 0;
			this.end = -1;
			this.storeList.destroyDescendants();
			this.storeList.setQuery(query, {
				start : this.start,
				count : 20
			});
			this.centerPanel.resize();
		},

		// 重写List的点击事件
		onClickList : function (evt) {
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if (li.declaredClass != "dojox.mobile.ListItem")
				return;
			var _id = li.params._id;
			window.moveToView("luckyDrawDetail", _id);
		},

		// 重写拖拽加载更多事件
		onLoadMore : function (evt) {
			if (this.busy || (0 < this.end && (this.start + 10 - 1 > this.end))) {
				return true;
			}
			if (evt.afterBottom) {
				this.start = this.end + 1;
				console.log("加载更多活动");
				this.busy = true;
				setTimeout(lang.hitch(this, function () {
					when(this.storeList.setQuery(this.storeList.get("query"), {
							start : this.start,
							count : 20
						}), lang.hitch(this, function () {
							this.centerPanel.resize();
						}));
				}), 1000);
			}
		}
	});
});
