// 变更人员： 母浚驰
// 变更内容： 抽奖活动编辑详情
// 变更时间： 2016/5/20
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/query",
	"dojo/DeferredList",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dijit/registry",
	"dojo/dom-class",
	"dojo/dom-construct",
	"dojox/mobile/ListItem",
	"dojox/mobile/EdgeToEdgeList",
	"dojo/store/JsonRest",
	"dojo/Deferred",
	"cq/util/sys/date",
	"cq/biz/article/mk/prize",
	"cq/biz/article/mk/award",
	"dijit/focus"
], function (declare, lang, query, DeferredList, View, _ViewMixin, registry, domClass, domConstruct, ListItem, EdgeToEdgeList, JsonRest, Deferred, date, prize, award, focusUtil) {

	// 奖项设置
	var AwardEdit = declare("", [View, _ViewMixin], {
		indexElement : function () {
			var option = {
				isEdge : true,
				lists : [{
					label : '奖品名称',
					noArrow : true,
					edit : {
						type : 'text',
						field : 'awardName'
					}
				}, {
					label : '奖品数量',
					noArrow : true,
					edit : {
						type : 'text',
						field : 'awardNum'
					}
				}, {
					label : '已中数量',
					noArrow : true,
					edit : {
						type : 'text',
						field : 'handledNum',
						disabled : true
					}
				}, {
					label : '最新中奖时间',
					noArrow : true,
					edit : {
						type : 'text',
						field : 'handleTime',
						disabled : true
					}
				}, {
					label : '奖品类型',
					rightText : '',
					moveTo : "#",
					__view_id : this.id,
					edit : {
						type : 'options',
						field : 'awardType',
						options : {
							0 : '普通奖品',
							1 : '赠送积分'
						}
					}
				}, {
					label : '赠送金额',
					noArrow : true,
					'class' : 'awardAmount',
					edit : {
						type : 'text',
						field : 'awardAmount'
					}
				}]
			};
			this.awardEditItems = this.addLists(option);

			// 确定和取消
			option = {
				columns : [{
					label : "确认",
					onClick : lang.hitch(this, function () {
						var data = {};
						data.data = {};
						data.data.items = [];
						var m = this.getData();
						var msg = this.checkFiled(m);
						if (msg) {
							alert(msg);
							return;
						}
						data.data.items.push(m);
						this.currentDef.resolve(data);
						this.hideOverlay();
					}),
					className : "footer-tab-highlight"
				}, {
					label : "取消",
					onClick : lang.hitch(this, function () {
						this.currentDef.resolve();
						this.hideOverlay();
					}),
					className : "footer-tab-dark"
				}],
				labelClass : 'font-size2',
				className : 'fix-footer',
				isFooter : true
			}
			this.addColumns(option);
			this.centerPanel.set("style", "height:400px;text-align: left;");
		},
		onDataChanged : function (field, oldValue, newValue) {
			if(field === "awardType"){
				this.initEvent();
				this.refreshData();
			}
		},
		initEvent : function () {
			if (this.getData().awardType === "0" || this.getData().awardType === 0) {
				domClass.add(query(".awardAmount", this.domNode)[0], "none");
			} else {
				domClass.remove(query(".awardAmount", this.domNode)[0], "none");
			}
		},
		// 验证选项是否填写
		checkFiled : function (data) {
			var msg = "";
			if (!data.awardName) {
				msg = "奖品名称必须填写";
			}
			if (!data.awardNum) {
				msg = "奖品数量必须填写";
			}
			return msg;
		},
		// 得到数据
		showAuditOption : function (data) {
			var datas = {};
			if (data) {
				datas = data;
			}

			this.currentDef = new Deferred();
			if (datas.awardType === undefined) {
				datas.awardType = 0;
			}
			this.setData(datas || {});
			this.startup();
			this.refreshData();

			return this.currentDef;
		}
	});

	return declare("whz.view.LuckyDrawPost", [View, _ViewMixin], {

		// 是否编辑状态
		isEditing : false,

		// 奖项列表
		parseDatas : [],

		// 初始化加载显示内容
		onFirstShow : function () {

			// 创建头部信息
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : lang.hitch(this, function () {
						this.isEditing = false;
						history.back();
					})
				},
				title : "添加活动",
				right : {
					iconButton : ' ',
					onClick : this.onSaveStore,
					label : "完成"
				}

			};
			this.header = this.addHeader(option);

			//分销相关信息
			option = {
				isEdge : true,
				lists : [{
					label : '活动名称',
					noArrow : true,
					edit : {
						type : 'text',
						field : 'prizeName',
						placeHolder : "未填写"
					}
				}, {
					label : '中奖类型',
					rightText : '',
					moveTo : "#",
					__view_id : this.id,
					edit : {
						type : 'options',
						field : 'luckType',
						options : {
							0 : '随机中奖',
							1 : '先到先得'
						}
					}
				}, {
					label : '最多可中奖量',
					noArrow : true,
					edit : {
						type : 'text',
						field : 'maxLucky'
					}
				}, {
					label : '活动开始时间',
					moveTo : "#",
					edit : {
						type : 'date',
						field : 'startTime'
					}
				}, {
					label : '活动结束时间',
					moveTo : "#",
					edit : {
						type : 'date',
						field : 'endTime'
					}
				}, {
					label : '是否可购买抽奖机会',
					noArrow : true,
					edit : {
						type : 'checkbox',
						field : 'canBuy',
						value : 'off'
					}
				}, {
					label : '消耗余额',
					noArrow : true,
					'class' : 'consumption',
					edit : {
						type : 'text',
						field : 'price'
					}
				}, {
					label : '每天赠送',
					noArrow : true,
					edit : {
						type : 'checkbox',
						field : 'everyDay',
						value : 'off'
					}
				}, {
					label : '免费抽奖次数',
					noArrow : true,
					'class' : 'freeTimes',
					edit : {
						type : 'text',
						field : 'freeNum'
					}
				}, {
					label : '活动说明信息',
					moveTo : "#",
					edit : {
						type : 'textarea',
						field : 'content'
					}
				}]
			};
			this.addLists(option);

			this.awards = {
				columns : [{
					label : '添加奖项',
					icon : 'images/icon/crmicon.png',
					iconClass : 'width-16',
					onClick : function () {
						this.createAwardEdit().then(lang.hitch(this, function (data) {
							if (data && data.data && data.data.items) {
								for (var i = 0; i < data.data.items.length; i++) {
									this.parseDatas.push(data.data.items[i]);
									this.awardList.destroyDescendants();
									this.addSectionsToList(this.parseDatas);
								}
								this.awardAmountShow(this.parseDatas);
							}
						}));
					}
				}],
				valueClass : 'font-size3',
				labelClass : 'font-size1',
				className : 'fix-footer',
				isFooter : true
			}
			this.addColumns(this.awards);

			// 添加奖项列表
			this.onCreatList();

			var option = {
				isEdge : true,
				lists : [{
						label : '活动状态',
						noArrow : true,
						rightText : '{{stateText}}'
					}, {
						label : '审核时间',
						noArrow : true,
						rightText : '{{verifyTime}}'
					}, {
						label : '停用时间',
						noArrow : true,
						rightText : '{{stopTime}}'
					}
				]
			}
			this.addLists(option);

			this.onAfterShow();
		},

		// 审核状态转为文字
		parseState : function (reasonId) {
			var reason = "";
			var reasons = {
				0 : '待审核',
				1 : '已审核',
				4 : '已停用'
			};
			reason = reasons[reasonId] || "未知";
			return reason;

		},
		
		// 免费抽奖次数和消耗余额的显示
		freeTimeShow : function () {
			if(query(".freeTimes", this.domNode)[0]){
				if (this.getData().everyDay === false) {
					domClass.add(query(".freeTimes", this.domNode)[0], "none");
				} else {
					domClass.remove(query(".freeTimes", this.domNode)[0], "none");
				}
			}
			if(query(".consumption", this.domNode)[0]){
				if (this.getData().canBuy === false) {
					domClass.add(query(".consumption", this.domNode)[0], "none");
				} else {
					domClass.remove(query(".consumption", this.domNode)[0], "none");
				}
			}
		},
		
		// 开关状态改变
		onDataChanged : function (field, oldValue, newValue) {
			if(field === "canBuy" || field === "everyDay"){
				this.freeTimeShow();
				this.refreshData();
			}
		},
		
		// 赠送积分的显示
		awardAmountShow : function (datas) {
			for (var i = 0; i < datas.length; i++) {
				if (datas[i].awardType === 0 || datas[i].awardType === "0") {
					domClass.add(query(".luckyDraw-awardAmount", this.domNode)[i], "none");
				} else {
					domClass.remove(query(".luckyDraw-awardAmount", this.domNode)[i], "none");
				}
			}
		},

		// 加载数据并显示页面
		onAfterShow : function () {
			if (!this.isEditing) {
				this.isEditing = true;
				//销毁原有列表项
				this.awardList.destroyDescendants();
				this.parseDatas = [];
				if (window.did) {
					prize.loadById(window.did).then(lang.hitch(this, function (data) {
						if (data.data.item) {
							this.header.set("label", data.data.item.prizeName);
							data.data.item.stateText = this.parseState(data.data.item.state);
							this.setData(data.data.item);
						}
						this.refreshData();
					}));
					award.loadByPrizeId(window.did).then(lang.hitch(this, function (data) {
						if (data && data.data && data.data.items) {
							for (var i = 0; i < data.data.items.length; i++) {
								this.parseDatas.push(data.data.items[i]);
							}
							this.addSectionsToList(this.parseDatas);
							this.awardAmountShow(this.parseDatas);
						}
						this.refreshData();
					}));
				} else {
					// 设置默认
					this.header.set("label", "添加活动");
					this.setData({
						luckType : 0,
						maxLucky : 0
					});

					this.refreshData();
				}

			}
		},

		// 创建奖项
		createAwardEdit : function (datas) {
			if(!this.awardEditDiv){
				this.awardEdit = new AwardEdit();
				this.awardEditDiv = domConstruct.create("div", {
					style : "height:400px;"
				});
				this.awardEditDiv.appendChild(this.awardEdit.domNode);
			}
			this.showInOverlay(this.awardEditDiv);
			return this.awardEdit.showAuditOption(datas);
		},

		// 创建列表
		onCreatList : function () {
			this.awardList = new EdgeToEdgeList({
				variableHeight : true,
				"class" : "section-list",
				editable : true
			});

			this.awardList.placeAt(this.centerPanel.containerNode, "last");

			// 侦听列表点击事件
			this.awardList.on("click", lang.hitch(this, function (e) {
				this.onClickList(e, new Date());
			}));

		},

		// 添加奖项进入列表
		addSectionsToList : function (datas) {
			var listItem = null;
			//遍历所有栏目
			for (var i = 0; i < datas.length; i++) {
				listItem = new ListItem({
					label : "<div><span class='luckyDraw-awardName'>奖品名称：" + (datas[i].awardName || "未知") + " </span>"
					 + "<span class='luckyDraw-awardNum'>奖品数量：" + (datas[i].awardNum || "0") + "</span></div>"
					 + "<div><span class='luckyDraw-handledNum'>已中数量：" + (datas[i].handledNum || "0") + " </span>"
					 + "<span class='luckyDraw-handleTime'>最新中奖时间：" + (datas[i].handleTime ? this.parseType(datas[i].handleTime) : "未知") + "</span></div>"
					 + "<div><span class='luckyDraw-awardType'>奖品类型：" + ((datas[i].awardType !== "0"　|| datas[i].awardType !== 0) ? this.parseType(datas[i].awardType) : "未知") + " </span>"
					 + "<span class='luckyDraw-awardAmount'>积分金额：" + (datas[i].awardAmount || "0") + "</span></div>",
				});
				listItem.set("params", datas[i]);

				//添加到list中
				this.awardList.addChild(listItem);

			}
		},

		parseType : function (reasonId) {
			var reason = "";
			var reasons = {
				0 : '普通奖品',
				1 : '赠送积分'
			};
			reason = reasons[reasonId] || "未知";
			return reason;

		},

		// 重写List的点击事件
		onClickList : function (evt, type) {
			// 得到点击的ListItem
			// 找到listItem根节点的直接节点
			var dom = evt.target;
			if (dom) {
				var item = registry.getEnclosingWidget(dom)
					// 根据唯一标识确定点击的List
					if (type) {
						item.params.type = type.toISOString();
						this.createAwardEdit(item.params).then(lang.hitch(this, function (data) {
							if (data && data.data && data.data.items) {
								for (var i = 0; i < this.parseDatas.length; i++) {
									if (this.parseDatas[i].type == data.data.items[0].type) {
										this.parseDatas[i] = data.data.items[0];
										this.awardList.destroyDescendants();
										this.addSectionsToList(this.parseDatas);
									}
								}
								this.awardAmountShow(this.parseDatas);
							}
						}));
					}
			}
		},

		// 奖项列表格式转换
		parseToData : function (parseDatas) {
			this.datas = [];
			for (var i = 0; i < this.parseDatas.length; i++) {
				var parsedData = {};
				if (this.parseDatas[i].awardName) {
					parsedData.awardName = this.parseDatas[i].awardName;
				}
				if (this.parseDatas[i].awardNum) {
					parsedData.awardNum = this.parseDatas[i].awardNum;
				}
				if (this.parseDatas[i].handledNum) {
					parsedData.handledNum = this.parseDatas[i].handledNum;
				}
				if (this.parseDatas[i].handleTime) {
					parsedData.handleTime = this.parseDatas[i].handleTime;
				}
				if (this.parseDatas[i].awardType !== null) {
					parsedData.awardType = this.parseDatas[i].awardType;
				}
				if (this.parseDatas[i].awardAmount) {
					parsedData.awardAmount = this.parseDatas[i].awardAmount;
				}
				this.datas.push(parsedData)

			}
			return this.datas;
		},

		// 保存界面信息
		onSaveStore : function () {
			if(this.isEditing){
				// 当前节点失去焦点
				focusUtil.curNode && focusUtil.curNode.blur();
				
				// setTimeout 保存数据
				setTimeout(lang.hitch(this, function () {
					var m = this.getData();
					this.isEditing = false;
					this.parseToData(this.parseDatas);

					// 检查必填项是否已填
					var msg = this.verify(m);
					if (msg) {
						alert(msg);
						this.isEditing = true;
						return;
					}
					if (this.datas.length === 0) {
						alert("奖项必须设置");
						this.isEditing = true;
						return;
					}
					if(false === m.canBuy){
						m.price = 0;
					}
					if(false === m.everyDay){
						m.freeNum = 0;
					}
					prize.save(m).then(lang.hitch(this, function (result) {
						if(result.data.ok){
							award.save(this.datas, result.data.item._id).then(lang.hitch(this, function (result) {
								if(result.data.ok){
									history.back();
								}else {
									alert("奖项保存失败");
									this.isEditing = true;
									this.hideOverlay();
									this.onAfterShow();
								}
								
							}));
						}else {
							alert("活动保存失败");
							this.isEditing = true;
						}
					}));
				}), 10);
			}
		},

		// 检查必填项是否已填
		verify : function (data) {
			var msg = "";
			if (!data.prizeName) {
				msg = "活动名称必须填写";
			}
			if (!data.luckType && data.luckType !== 0) {
				msg = "中奖类型必须填写";
			}
			if (!data.startTime) {
				msg = "活动开始时间必须填写";
			}
			if (!data.endTime) {
				msg = "活动结束时间必须填写";
			}
			if (!data.content) {
				msg = "活动说明信息必须填写";
			}
			if (Date.parse(date.formatISODate(data.startTime)) > Date.parse(date.formatISODate(data.endTime))) {
				msg = "结束时间必须大于开始时间"
			}
			return msg;
		}
	});
});
