﻿// 变更人:徐阿雪
// 变更时间:2016/7/12
// 变更原因:商品关联农户，继承ui/b/m/mat，新加一个是否为农户列表
// 变更人:张松
// 变更时间:2016/8/5
// 变更原因:盐业不需要填写所属农户
// 变更人：杜飞军
// 变更时间：2016/10/12
// 变更原因：处理商品分级价格
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/query",
    "dojox/mobile/ListItem",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/b/m/Mat",
    "cq/biz/user/userFarmer",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat"
], function (declare, lang, array, domClass, domAttr, domConstruct, Deferred, query, ListItem, View, registry, Mat, userFarmer, _ViewMixin, mat) {
    /*
    最后追加一个ListItem，显示和编辑分级价格
        //loadList时追加Item
        //onFirstShow找到添加的Item，绑定事件
        refreshData刷新级别价格Item的显示
        事件相应函数
        保存之前检查分级价格是否变化
        
    分级价格编辑器
        开始选择，数组转对象
        完成编辑时的合法性检查
        完成编辑对象转数组
    */
    var LevelEditor = declare("", [View, _ViewMixin], {
        editStepDef: null,
        style: "height:420px;",
        isStarted: false,
        //开始阶梯
        editLevelPrice: function (item) {
            this.editStepDef = new Deferred();
            this.originItem = item || [];
            var data = {};
            array.forEach(this.originItem, function (price) {
                data["price" + price.level] = price.price;
            });
            this.showInOverlay(this.domNode);
            if (!this.isStarted) {
                this.isStarted = true;
                this.startup();
            }
            this.setData(data);
            this.refreshData();
            return this.editStepDef;
        },
        indexElement: function () {
            this.inherited(arguments);
            this.addLists({
                class: 'text_left',
                isEdge: true,
                lists: [{
                    label: "会员等级",
                    rightText: '价格'
                }, {
                    label: "级别1",
                    edit: {
                        type: "text",
                        field: "price1",
                        placeHolder: "0"
                    }
                }, {
                    label: "级别2",
                    edit: {
                        type: "text",
                        field: "price2",
                        placeHolder: "0"
                    }
                }, {
                    label: "级别3",
                    edit: {
                        type: "text",
                        field: "price3",
                        placeHolder: "0"
                    }
                }, {
                    label: "级别4",
                    edit: {
                        type: "text",
                        field: "price4",
                        placeHolder: "0"
                    }
                }, {
                    label: "级别5",
                    edit: {
                        type: "text",
                        field: "price5",
                        placeHolder: "0"
                    }
                }]
            });
            this.addColumns({
                isFooter: true,
                columns: [{
                    label: "确认",
                    onClick: this.onEditFinished,
                    className: "footer-tab-highlight"
                }, {
                    label: "取消",
                    onClick: this.onEditCanceled,
                    className: "footer-tab-dark"
                }]
            });
        },
        // 会员价格内容 限制
        levelVerify: function (data) {
            if (!data) return false;
            // 判断是否为 数字
            if (isNaN(Number(data))) {
                return '零售价只能为数字';
            }
            return true;
        },
        onEditFinished: function () {
            var data = this.getData();
            // 检查数据合法性
            for (var field in data) {
                if (data[field]) {
                    if (isNaN(data[field])) {
                        alert("级别" + (field.substr(field.length - 1)) + "价格必须为数字");
                        return;
                    }
                    if (data[field] <= 0) {
                        alert("级别" + (field.substr(field.length - 1)) + "价格必须大于零");
                        return;
                    }
                }
            }

            // 将object转为数组
            var prices = [];
            array.forEach(new Array(5), function (i, index) {
                index = index + 1;
                if (data["price" + index] > 0) {
                    prices.push({
                        level: index,
                        price: data["price" + index] - 0
                    });
                }
            });
            // 返回
            this.editStepDef.resolve(prices);
            // 隐藏
            this.hideOverlay();
        },
        onEditCanceled: function () {
            this.editStepDef.resolve(this.originItem);
            this.hideOverlay();
        }
    });
    return declare("whz.view.Mat", [Mat], {
        onAfterShow: function () {
            if (!this.isEditing) {
                this.isEditing = true;
                registry.byNode(query(".propLi", this.domNode)[0]).set("rightText", "");
                if (!window.did) {
                    // 修改上架设置 默认为不上架
                    // 默认库存9999个
                    this.dataInfo = {
                        isUse: false,
                        qty: 9999
                    };
                    this.setData(lang.hitch(this.dataInfo));
                    this.refreshPropLi();
                    this.refreshData();
                    this.header.set("label", "添加商品");
                } else {
                    this.header.set("label", "商品");
                    this.loadMatData().then(lang.hitch(this, function (data) {
                        if (data.data.ok == 1) {
                            mat.loadById(data.data.item._id).then(lang.hitch(this, function (dt) {
                                // 如果差到了这个商品 修改商品的状态
                                data.data.item.groupId = dt.data.item.groupId;
                                // 添加加载的商品信息 作为原始数据
                                this.dataInfo = lang.clone(data.data.item) || {};
                                this.setData(data.data.item);
                                // 如果平台已审核 商品名称和标准分类则不允许修改
                                this.refreshPropLi();
                                this.refreshData();
                            }));
                        } else {
                            // 修改上架设置 默认为不上架
                            // 默认库存9999个
                            this.dataInfo = {
                                isUse: false,
                                qty: 9999
                            };
                            this.header.set("label", "添加商品");
                            this.setData(lang.clone(this.dataInfo));
                            this.refreshPropLi();
                            this.refreshData();
                        }
                    }));
                }
            }
            this.resize();
        },
        //刷新数据显示时，已审核的商品不允许编辑名称
        refreshData: function () {
            this.inherited(arguments);
            if (this.getData().verifyState == 2) {
                domAttr.set(query(".matName", this.domNode)[0].lastChild, "readonly", true);
            } else {
                domAttr.set(query(".matName", this.domNode)[0].lastChild, "readonly", false);
            }
			if(query(".matName", this.domNode)[0].lastChild.updateState){
				query(".matName", this.domNode)[0].lastChild.updateState();
			}                
            if (this.levelItem) {
                var data = this.getData();
                this.levelItem.set("label", this.getLevelItemLabel(data && data.prices));
            }
        },
        //
        getLevelItemLabel: function (prices) {
            if (prices && prices.length) {
                return "会员价格:" + array.map(prices, function (price) {
                    return "<span style='margin-right:20px;'>级别" + price.level + ":" + window.fixedTo(price.price, 3) + "</span>";
                }).join("");
            } else {
                return "会员价格:点击设置";
            }
        },
        //若商品已审核，不允许修改标准分类
        onSortClicked: function () {
            if (this.getData().verifyState == 2) {
                return;
            }
            this.inherited(arguments);
        },
        addXmAssistList: function () {
            this.inherited(arguments);
            var node = query(".levelPrice", this.domNode)[0];
            this.levelItem = registry.byNode(node);
            this.connect(node, "onclick", this.onLevelItemClick);
        },
        onLevelItemClick: function () {
            if (!this.levelEditor) {
                this.levelEditor = new LevelEditor();
            }
            var data = this.getData();
            this.levelEditor.editLevelPrice(data && data.prices).then(lang.hitch(this, function (prices) {
                this.__data.prices = prices;
                this.levelItem.set("label", this.getLevelItemLabel(prices));
            }));
        },
        //在mat 的基础上添加一个选择农户的list
        saveMat: function (m) {
            // 默认非上架状态
            if (!m._id) m.isUse = false;
            // 获得保存前的id
            var id = m._id;
            // 最小起订量必须为整数
            var tt = /^\d+$/g;
            if (m.minQty && !tt.test(m.minQty)) {
                alert("最小起订量只能为正整数!");
                this.isEditing = true;
                window.free();
                return;
            }
            if (m.limitedQty && !tt.test(m.limitedQty)) {
                alert("限购数量只能为正整数!");
                this.isEditing = true;
                window.free();
                return;
            }
            if (isNaN(m.retailPrice)) {
                alert("商品价格只能为数字!");
                this.isEditing = true;
                window.free();
                return;
            }
            if (isNaN(m.marketPrice)) {
                alert("市场价只能为数字!");
                this.isEditing = true;
                window.free();
                return;
            }
            // 获得会员价格数据
            mat.save(m).then(lang.hitch(this, function (data) {
                window.free();
                if (data.data.ok === 1) {
                    // 保存成功后的信息
                    var matData = data.data.item;
                    //处理下游停止采购
                    if (id) {
                        if (this.dataInfo.isPurchase !== matData.isPurchase) {
                            if (matData.isPurchase) {
                                // 存在id并且允许采购 加入采购清单
                                mat.b2bAdd({
                                    mId: matData._id,
                                    fromShopId: matData.fromShopId
                                });
                            } else {
                                // 修改模式下 并且没有采购 调用停止采购
                                // 判断isUse避免没有任何修改的采购设置发出请求
                                mat.b2bRemove({
                                    mId: matData._id,
                                    fromShopId: matData.fromShopId
                                });
                            }
                        }
                        if (matData.isUse) {
                            //若修改了最小起订量或价格，需要同不给客户
                            var priceMdf = this.dataInfo.minQty != matData.minQty || this.dataInfo.retailPrice != matData.retailPrice;
                            if (!priceMdf) {
                                //判断会员价是否被修改
                                var oldPrices = this.getPricesMap(this.dataInfo),
                                    newPrices = this.getPricesMap(matData),
                                    level;
                                //删除了对应价格或修改了对应级别价格，认为修改了
                                for (level in oldPrices) {
                                    if (!newPrices[level] || newPrices[level] != oldPrices[level]) {
                                        priceMdf = true;
                                        break;
                                    } else {
                                        delete newPrices[level];
                                    }
                                }
                                if (!priceMdf) {
                                    //添加了新的会员级别价格，认为修改了价格
                                    for (level in newPrices) {
                                        priceMdf = true;
                                        break;
                                    }
                                }
                            }
                            if (priceMdf) {
                                //同步商品信息到下游商家
                                mat.b2bOnShelf({
                                    _id: matData._id
                                });
                            }
                        }
                    }
                    history.back();
                } else {
                    this.isEditing = true;
                    alert(data.data.msg);
                }
            }));
        },
        //依据商品生成商品会员等级价格对照表
        getPricesMap: function (data) {
            data = data && data.prices || [];
            var levelMap = {};
            array.forEach(data, function (item) {
                levelMap[item.level] = item.price;
            });
            return levelMap;
        },
        loadList: function () {
            var matListss = this.inherited(arguments);
            var op = {
                label: "最小起订量",
                moveTo: "#",
                edit: {
                    type: 'text',
                    field: 'minQty'
                }
            };
            // 添加 限购数量 --2016/11/16 杜飞军
            var op2 = {
                label: "限购数量",
                moveTo: "#",
                edit: {
                    type: 'text',
                    field: 'limitedQty'
                }
            };
            // 添加 采购起订量 采购价 是否允许采购
            var op3 = {
                label: "采购起订量",
                moveTo: "#",
                edit: {
                    type: 'text',
                    field: 'purchaseQty',
                    disabled: 'true'
                }
            };
            var op4 = {
                label: "采购价",
                moveTo: "#",
                edit: {
                    type: 'text',
                    field: 'purchasePrice',
                    disabled: 'true'
                }
            };
            var op5 = {
                label: "是否采购",
                moveTo: "#",
                edit: {
                    type: 'checkbox',
                    field: 'isPurchase'
                }
            };
            matListss.splice(6, 0, op);
            matListss.push(op2);
            matListss.push(op3);
            matListss.push(op4);
            matListss.push(op5);
            matListss.push({
                label: "会员价格",
                noArrow: false,
                moveTo: "#",
                variableHeight: true,
                className: "mblListItem levelPrice"
            })
            return matListss;
        }
    });
});
/*
        // 比较会员价格修改  a 原始参数 b 保存后的参数 a b都为数组并且数组长度一样
        comparLevelData: function(a, b) {
            var data = false;
            if (a.length != b.length) {
                data = true;
                return data;
            }
            for (var i = 0; i < a.length; i++) {
                if (a[i].level === b[i].level) {
                    if (a[i].price !== b[i].price) {
                        data = true;
                        break;
                    }
                } else {
                    data = true;
                }
            }
            return data;
        },
        // 会员价格列表点击时间
        onLevelItemClick: function(e) {
            var dom = e.target,
                propItem = registry.getEnclosingWidget(e.target);
            while (dom && !domClass.contains(dom, "mblListItemIcon")) {
                dom = dom.parentNode;
            }
            if (dom) {
                //删除
                propItem.destroyRecursive();
            } else {
                //编辑
                // 需要重写数据
                var data = propItem.params;
                var levelData = {};
                for (var i = 0; i < data.length; i++) {
                    if (!data[i].price) continue;
                    levelData['price' + data[i].level] = data[i].price;
                }
                this.startEditStep(levelData).then(lang.hitch(this, function(item) {
                    // 用于数组对象排序
                    var compare = function(prop) {
                        return function(obj1, obj2) {
                            var val1 = obj1[prop];
                            var val2 = obj2[prop];
                            if (!isNaN(Number(val1)) && !isNaN(Number(val2))) {
                                val1 = Number(val1);
                                val2 = Number(val2);
                            }
                            if (val1 < val2) {
                                return -1;
                            } else if (val1 > val2) {
                                return 1;
                            } else {
                                return 0;
                            }
                        };
                    };
                    item.sort(compare('level'));
                    propItem.set(this.getItemStep(item));
                    this.hideOverlay();
                }));
            }
        },
        //创建弹窗
        startEditStep: function(item) {
            if (!this.stepEditDiv) {
                this.stepEditDiv = domConstruct.create("div", {
                    style: "height:400px;text-align: left;"
                });
                this.stepEditItem = new BoxEdit();
                this.stepEditDiv.appendChild(this.stepEditItem.domNode);
                setTimeout(lang.hitch(this.stepEditItem, this.stepEditItem.startup), 0);
            }
            this.showInOverlay(this.stepEditDiv);
            return this.stepEditItem.startEditStep(item);
        },
        // 返回的格式
        getItemStep: function(item) {
            if (item && item.length !== 0) {
                var label = '';
                for (var i = 0; i < item.length; i++) {
                    if (!item[i].price) continue;
                    label += "<div>" + item[i].level + "级会员,价格：" + item[i].price + "元</div>";
                }
                // 挂载数据
                this.levelList.params.data = item;
                return {
                    icon: "mblDomButtonRedCircleMinus",
                    params: item,
                    label: label,
                    moveTo: "#"
                };
            } else {
                return {
                    icon: "mblDomButtonRedCircleMinus",
                    params: item,
                    label: "<div>设置会员价格</div>",
                    moveTo: "#"
                };
            }
        },
        // 获得会员价格的数据
        getLevelData: function() {
            var data = array.map(this.levelList.getChildren(), function(item) {
                return item.params;
            })[0];
            return data ? data : [];
        },
        // 保存成功后 判断数据更改通知下游
        downStreamMsg: function(b2b, matData) {
            // 已上架，且修改
            if (((this.dataInfo.minQty != matData.minQty || this.dataInfo.retailPrice != matData.retailPrice) && b2b.data.item.isUse) || this.comparLevelData(this.levelData, matData.prices)) {
                // 通知结果
                mat.b2bOnShelf({
                    _id: matData._id
                }).then(lang.hitch(this, function(msg) {
                    if (msg.data.ok === 1) {
                        //保存后执行free操作
                        window.free();
                        //window.moveToView("matList");
                        history.back();
                    } else {
                        alert(msg.data.msg);
                    }
                }));
            } else {
                //保存后执行free操作
                window.free();
                //window.moveToView("matList");
                history.back();
            }
        },
        getLevelItemByData: function(item) {
            return new ListItem(this.getItemStep(item));
        },

        addLeavelPrice: function() {
            var m = this.getLevelData();
            m.rebateRule = array.map(this.levelList.getChildren(), function(item) {
                return item.params;
            });
            // 可能 会出现追加多个填写框 应该判断填写长度
            //if (m.length >= 1) {
            if (this.levelList.getChildren().length >= 1) {
                alert("会员价格只能设置一个,你可以修改价格");
                return;
            } else {
                var item = this.getLevelItemByData([]);
                this.levelList.addChild(item);
                this.onLevelItemClick({
                    target: item.labelNode
                });
            }
        },

*/