//变更人: 张松
//变更时间: 2016-07-29
//变更原因: 继承公共基类
// 变更人: 徐阿雪
// 变更时间: 2016/8/10
// 变更原因: 添加运费
// 变更人：干劲
// 变更日期：20160911
// 变更原因：B2B商品的上下架要通知下游商家
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/query",
    "dijit/registry",
    "cq/biz/mat/mat",
    "cq/biz/shop/shop",
    "cq/ui/b/m/MatDetailB"
], function(declare, lang, domClass, query, registry, mat, shop, MatDetailB) {
    return declare("whz.view.MatDetailB", [MatDetailB], {
        // 初始化数据来源Id
        fromShopId: '',
        //B2B商品的上下架要通知下游商家
        onSaveStore: function(target) {
            var data = this.getData();
            if (!target) {
                if (this.verifyState !== 2) {
                    alert('请先提交审核,待平台通过后才能上架');
                    return;
                }
                if (data.qty == 0 || !data.qty) {
                    alert('没有库存不能上架');
                    return;
                } else {
                    window.busy();
                    mat.b2bOnShelf({
                        _id: data._id
                    }).then(lang.hitch(this, function(data) {
                        if (data && data.data && data.data.ok === 1) {
                            window.free();
                            this.changeGoods(target);
                        } else {
                            window.free();
                            alert(data.message);
                        }
                    }));
                }
            } else {
                window.busy();
                mat.b2bOffShelf({
                    _id: data._id
                }).then(lang.hitch(this, function(data) {
                    if (data && data.data && data.data.ok === 1) {
                        window.free();
                        this.changeGoods(target);
                    } else {
                        window.free();
                        alert(data.message);
                    }
                }));
            }
        },
        // 重盐的商品修改了B2B模式，也可以编辑商品
        // 如果是自己的产品，且没有提交审核，显示“提交审核”按钮，隐藏上架、下架按钮
        // 如果不是自己的产品，隐藏提交审核按钮，依据状态显示控制上架、下架按钮
        onAfterShow: function() {
            this.inherited(arguments).then(lang.hitch(this, function(data) {
                if (data && data.data && data.data.ok === 1) {
                    this.verifyState = data.data.item.verifyState;
                    if ((data.data.item.fromShopId == shop.getShopId()) && this.verifyState != 2) {
                        if (this.verifyState == 0) {
                            domClass.remove(query('.sendVerify', this.footerButton)[0], 'none');
                            domClass.add(query('.getGoodsOn', this.footerButton)[0], 'none');
                            domClass.add(query('.getGoodsDown', this.footerButton)[0], 'none');
                        }
                        if (this.verifyState == 1) {
                            domClass.add(query('.sendVerify', this.footerButton)[0], 'none');
                            domClass.add(query('.getGoodsOn', this.footerButton)[0], 'none');
                            domClass.add(query('.getGoodsDown', this.footerButton)[0], 'none');
                        }
                    } else {
                        domClass.add(query('.sendVerify', this.footerButton)[0], 'none');
                        if (data.data.item.isUse) {
                            domClass.add(query('.getGoodsOn', this.footerButton)[0], 'none');
                            domClass.remove(query('.getGoodsDown', this.footerButton)[0], 'none');
                        } else {
                            domClass.remove(query('.getGoodsOn', this.footerButton)[0], 'none');
                            domClass.add(query('.getGoodsDown', this.footerButton)[0], 'none');
                        }
                    }
                    // 用于处理 可能存在没有填写价格 不显示或者显示undefined问题
                    if (!data.data.item.retailPrice) {
                        data.data.item.retailPrice = window.fixedTo(0, 3);
                        this.setData(data.data.item);
                        this.refreshData();
                    }
                    // 用于处理shopId和fromShapId不一样时 获取不到评价信息
                    this.fromShopId = data.data.item.fromShopId;
                    if (shop.getShopId() != this.fromShopId) {
                        mat.loadById(window.did, data.data.item.fromShopId).then(lang.hitch(this, function(fromData) {
                            if (fromData && fromData.data && fromData.data.ok === 1) {
                                data.data.item.commentNum = fromData.data.item.commentNum;
                                data.data.item.scoreAvg = fromData.data.item.scoreAvg;
                                this.setData(data.data.item);
                                this.refreshData();
                                // 设置星级
                                this.putDataInHtml(data.data.item);
                            }
                        }));
                    }
                }

            }));
        },
        // 提交审核的方法 提供的重写方法
        sendVerify: function(id) {
            window.busy();
            mat.submitVerify(id).then(lang.hitch(this, function(data) {
                if (data && data.data && data.data.ok === 1) {
                    window.free();
                    alert('审核已提交');
                    this.onAfterShow();
                } else {
                    window.free();
                    alert('审核提交失败');
                }
            }));
        },
        // 重写评价点击事件
        onEvalList: function(evt) {
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = window.did;
            window.moveToView("matEvalList", _id + '_' + this.fromShopId);
        },
    });
});
