// 变更人：潘云
// 变更时间：2016-05-17
// 变更事项：代码规范、注释、迁移
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/ui/view/_ViewMixin",
	"dojo/query",
	"cq/biz/article/article"
],function(declare,lang,View,EdgeToEdgeStoreList,_ViewMixin,query,article){
	// module:
	//		whz/view/New
	return declare("whz.view.New",[View,_ViewMixin],{
		// 页面是否处在编辑中，默认值为false
		isEditing : false,
		// 加载数据
		onAfterShow : function() {
			if(!this.isEditing){
				this.isEditing = true;
				if(!window.did){
					this.setData({
						isUse:true
					});
					this.refreshData();
				}else{
					article.loadById(window.did).then(lang.hitch(this, function(data) {
						if(data.data&&data.data.ok){
							// 显示商品信息
							this.setData(data.data.item);
							this.refreshData();
						}
					}));
				}
			}
        },
        // 第一次进入页面，初始化页面组件
		onFirstShow:function(){
			// 加载页面头部
			option = {
				left:{
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick:lang.hitch(this,function(){
						this.isEditing = false;
						window.moveToView("newsList");
					})
				},
				title:"新增资讯",
				right:{
					iconButton:' ',
					onClick:this.onSaveStore,label:"完成" }
			};
			this.addHeader(option);
			// 加载页面中资讯详情的显示部分
			option = {
				isEdge:true,
				lists:[
				{
					label : "主题图片",
					noArrow : false,
					imgSize:{width:640,height:320},
					edit :{
						type:"image",
						field:"logo"
					},
					class : "li-icon",
					moveTo : "#"
				},
				{
					label:'资讯编码',
					noArrow:true,
					edit:{
						type:'text',
						field:'code'}
					},
				{
					label:'标题',
					noArrow:true,
					edit:{
						type:'text',
						field:'title'
					}
				},
				{
					label:'摘要',
					moveTo:"#",
					edit:{
						type:'textarea',
						field:'brief'
					}
				},
				{
					label : '内容',
					rightText : '资讯详情',
					moveTo : "#",
					edit:{
						type:'richEdit',
						field:'content'
					}
				},
				{
					label:'使用',
					noArrow:true,
					edit:{
						type:'checkbox',
						field:'isUse',
						value:"on"
					}
				}],
				data:this.getData()
				};
			this.addLists(option);
			this.onAfterShow();
		},
		// 将用户修改、新增的数据保存到数据库
		onSaveStore:function(){
			var m = this.getData();
			if(!m.shopId){
				m.shopId=article.getShopId();
			}
			var checkMsg=this.checkFiled(m)
			if(checkMsg){
				alert(checkMsg);
				this.isEditing=true;
				return;
			}
			this.isEditing = false;
			article.save(m).then(function(data){
				// 保存成功则跳转到资讯列表页面
				if(data.data.ok === 1){
					window.moveToView("newsList");
				}else{
					alert("保存失败");
				}	
			});
		},
		// 验证必填项是否有值
		checkFiled:function(data){
			var msg="";
			if(!data.code){
				msg="编码不能为空!";
				return msg;
			}else if(!data.title){
				msg="标题不能为空!";
				return msg;
			}else if(!data.brief){
				msg="摘要不能为空!";
				return msg;
			}else if(!data.content){
				msg="内容不能为空!";
				return msg;
			}
		}
	});
});
