// 变更人：潘云
// 变更时间：2016-05-17
// 变更事项：代码规范、注释、迁移
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/ui/view/_ViewMixin",
	"dijit/registry",
	"cq/biz/article/article",
	"dojo/on",
	"dojo/when",
	"dojo/store/JsonRest",
],function(declare,lang,View,EdgeToEdgeStoreList,_ViewMixin,registry,article,on,when,JsonRest){
	// module:
	//		whz/view/NewsList
	return declare("whz.view.NewsList",[View,_ViewMixin],{
		// 加载数据的下标，默认从0开始
		start : 0,
		// 每次加载数据的条数
		pageSize : 10,
		// 每次进入页面重新加载数据
		onAfterShow:function(){
			this.setQuery(this.storeList.get("query"),{
				start: 0,
				count: this.pageSize
				
			});
		},
		// 第一次进入页面加载页面显示组件
		onFirstShow:function(){
			// 页面头部
			option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						localStorage.removeItem("fromTrends");
						window.moveToView("home");
					}
				},
				title:"资讯管理"
			};
			this.addHeader(option);
			// 搜索框
			option = {
				placeHolder:"请输入要查询条件，按回车查询",
				type:"search",
				class:"cqSearchBox",
				onInput:lang.hitch(this,function(evt){
					if(evt.keyCode==13){
						this.search = evt.target.value;
						var condition = this.storeList.get("query");
						condition.title = evt.target.value;
						this.setQuery(condition);
						evt.target.value = "";
					}
				})
			};
			this.addTextBox(option);
			// 页面尾部按钮
			option = {
				columns:[{
					label:'添加资讯',
					icon:'images/icon/addnews.png',
					iconClass:'width-16',
					onClick:function(){
						window.moveToView("new");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
			// 资讯显示列表
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){
						data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].title+"</div>";
						data[i]._label+="<div class='mat-list-margin'>"+data[i].brief+"</div>"
						data[i].moveTo="#";
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions: {
					count: this.pageSize,
					start: this.start
					},
				itemMap:{_label:"label",logo:"icon", moveTo:"moveTo"}
			});
			// 创建数据源
			this.params={};
			this.store = new JsonRest({target:article.getArticleUrl()});
			// 将数据源赋值给storeList
			this.storeList.setStore(this.store,this.params);

			this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
		},
		// 资讯列表项的点击响应事件
		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params._id;
			window.moveToView("new",_id);
		},
		// 列表拖动的响应事件，拖动加载更多
		onLoadMore:function(evt){
			var itemHeight = 35;
			if(this.busy||(0<this.end&&(this.start+this.pageSize-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多资讯");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: this.pageSize
					}), lang.hitch(this,function(){
						this.centerPanel.resize();
					}));
				}), 1000);
			}

		}
	});
});
