// 修改人： 母浚驰
// 修改时间：2016/9/26
// 修内容容:
// 			继承cq/ui/b/OrderDetailB 增加签收凭证上传

// 变更人:母浚驰
// 变更时间:2016/10/26
// 变更内容:取消支付按钮
define([
    'dojo/_base/declare',
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dijit/registry",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    'cq/ui/b/t/OrderDetailB',
    "cq/biz/ts/order",
    "cq/biz/shop/shop",
], function(declare, lang, array, query, Deferred, domClass, domConstruct, registry, View, _ViewMixin, OrderDetailB, order, shop) {
    //评价
    var MakeCertificate = declare("", [View, _ViewMixin], {
        dataImages : null,
        // 初始化页面元素
        indexElement: function() {
            var option = {
                isEdge:true,
                lists:[{
                    label: "最多可传3张图片",
                    rightText:""
                }]
            };
            this.addLists(option);
            // 上传图片
            option = {
                maxImages: 3,
                mainLabel: "",
                detailLabel: "",
                canAdd: true,
                icons: [],
                editable: true,
                class: "no-shake",
                size: {
                    width: 640,
                    height: 640
                }
            };
            this.upImages = this.addImagePicker(option);
            // 底部按钮 提交 取消
            option = {
                columns: [{
                    label: "提交",
                    onClick: lang.hitch(this, function() {
                        window.busy();
                        var data = this.getEvalData();
                        var msg = this.checkFlied(data);
                        if (msg) {
                            window.free();
                            alert(msg);
                            return;
                        }
                        this.currentDef.resolve(data);
                        this.hideOverlay();
                    }),
                    className: "flex2 footer-tab-highlight"
                },{
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                        this.hideOverlay();
                    }),
                    className: "flex2 footer-tab-dark"
                }],
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(option);
        },
        // 验证必填字段是否为空
        checkFlied: function(data) {
            var msg = "";
            if(data.length==0){
                msg = "请上传凭证";
            }
            return msg;
        },
        // 保存时获取用户的评价信息
        getEvalData: function() {
            var upImages = [];
            // 获取图片
            var iconItems = this.upImages.getChildren();
            if (iconItems.length > 1) {
                for (var i = 0; i < iconItems.length; i++) {
                    // 如果icon存在则为用户上传的图片
                    if (iconItems[i].icon) {
                        upImages.push(iconItems[i].icon);
                    }
                }
            }
            return upImages;
        },

        showAuditOption: function(data) {
            // 初始化一个异步操作
            this.currentDef = new Deferred();
            this.dataImages = data;
            this.startup();
            this.initData();
            
            return this.currentDef;
        },
        initData: function() {
            var itemImages = [];
            if(this.dataImages&&this.dataImages.length){
                array.forEach(this.dataImages,function(item,index){
                    var itemImage = {};
                    itemImage.icon = item;
                    itemImages.push(itemImage);
                },this);
            }
            if(itemImages.length){
                this.upImages.refreshItems(itemImages);
            }
            if(itemImages.length == 3){
                var addImgNode = query(".add-image",this.domNode)[0];
                if(addImgNode && addImgNode.parentNode && addImgNode.parentNode.parentNode && addImgNode.parentNode.parentNode.parentNode){
                    addImgNode.parentNode.parentNode.parentNode.removeChild(addImgNode.parentNode.parentNode);
                }
            }
            if(!itemImages.length){
                this.upImages.refreshItems([]);
            }
        },
        resetOpen:function(){},
    });
    return declare('whz.view.OrderDetail', OrderDetailB, {
        images: null,
        addBottomMenus:function(){
            var option = {
                columns:[{
                    label:'审核',
                    className:'flex2 footer-tab-highlight none accept',
                    onClick : lang.hitch(this,this.setAccepted)
                },
                {
                    label:'发货',
                    className:'flex2 footer-tab-highlight none deliver',
                    onClick:lang.hitch(this,this.setDelivered)
                },
                {
                    label:'退款',
                    className:'flex2 footer-tab-dark none cancel',
                    onClick:lang.hitch(this,this.setCanceled)
                },
                 // {
                     // label:'支付',
                     // className:'flex2 footer-tab-highlight setPayed',
                     // onClick:lang.hitch(this,this.setPayed)
                 // },
                {
                    label:'修改价格',
                    className:'flex2 footer-tab-dark none update',
                    onClick:lang.hitch(this,this.setUpdate)
                },
                {
                    label:'上传凭证',
                    className:'flex2 footer-tab-highlight none certificate',
                    onClick:lang.hitch(this,this.makeCertificate)
                }],
                forceWidth:false,
                isFooter:true
            };
            this.bottomMenus = this.addColumns(option);
        },
        
        changeBottomStatus:function(item){
            domClass.add(query(".accept",this.bottomMenus)[0],"none");
            domClass.add(query(".deliver",this.bottomMenus)[0],"none");
            domClass.add(query(".cancel",this.bottomMenus)[0],"none");
            domClass.add(query(".update",this.bottomMenus)[0],"none");
            
            //依据订单主表显示订单按钮
            if(!item.isPayed){
                domClass.remove(query(".update",this.bottomMenus)[0],"none");
            }
            if(item.isPayed&&false===item.isAccepted&&false===item.isCanceled){
                domClass.remove(query(".accept",this.bottomMenus)[0],"none");
            }
            if(item.isAccepted&&false===item.isDelived&&false===item.isCanceled){
                domClass.remove(query(".deliver",this.bottomMenus)[0],"none");
            }
            if(item.payType === "point"){
                if(item.isPayed && false===item.isCanceled){
                    domClass.remove(query(".cancel",this.bottomMenus)[0],"none");
                }
            }else{
                if(item.isPayed && false===item.isCanceled && false===item.isReceipted){
                    domClass.remove(query(".cancel",this.bottomMenus)[0],"none");
                }
            }
            domClass.add(query(".certificate",this.bottomMenu)[0],"none");
            shop.loadCurrentFromPaltShop().then(lang.hitch(this, function(data) {
                if(data&&data.data){
                    if(data.data.automaticReceipt == false){
                        if(item.isPayed && item.isAccepted && item.isDelived && false===item.isCanceled && false===item.isReceipted && item.certificate.length==0){
                            domClass.remove(query(".certificate",this.bottomMenu)[0],"none");
                        }
                    }
                }
                //有可能底部全部被隐藏,所以需要重算高度
                this.resize();
            }));
        },
        //上传凭证
        makeCertificate: function(){
            this.getCertificate().then(lang.hitch(this,function(data){
                if(data){
                    this.images = data;
                    data = JSON.stringify(data);
                    order.saveAutomaticReceipt({certificate:data,tsId:window.did}).then(lang.hitch(this,function(result){
                        if(result.data.ok == 1){
                            this.onAfterShow();
                            alert("上传凭证成功");
                        }
                    })); 
                }
            }));
        },
        setImages:function(item){
            this.images = item.certificate;
        },
        getCertificate: function(){
            if(!this.makeCertificates){
                this.makeCertificates = new MakeCertificate();
            }
            this.certificateDiv = domConstruct.create("div", {
                style : "height:400px;"
            });
			this.certificateDiv.appendChild(this.makeCertificates.domNode);
			this.showInOverlay(this.certificateDiv);
			return this.makeCertificates.showAuditOption(this.images);
        },
        // 执行付款操作
         setPayed:function(){
            if(this.orderItem.isPayed===false&&this.orderItem.isCanceled===false){
                var params = {};
                params._id = this.orderItem._id;
                params.payType = this.orderItem.payType||"point";
                order.setPayed(params).then(lang.hitch(this,this.onAfterShow));
            }
        } 
    });
});
