// 变更人员：母浚驰
// 变更时间：2016/7/27
// 变更内容：订单
// 变更人员：母浚驰
// 变更时间：2016/08/11
// 变更内容：收货地址选择,刷新邮费

// 变更人员：母浚驰
// 变更时间：2016/8/17
// 变更内容：优惠券信息
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/ListItem",
    "dijit/registry",
    "cq/biz/mat/mat",
    "cq/biz/ts/order",
    "cq/biz/shop/shop",
    "cq/biz/mk/discount",
    "cq/biz/user/userAddress",
    "cq/ui/util/addrPick",
    "cq/util/config/config",
    "cq/ui/common/t/OrderInfo"
],function(declare, lang, query, domClass, domStyle, ListItem, registry, mat, order, shop, disCount, userAddress, addrPick, config, OrderInfo){
    return declare("whz.view.OrderInfo", OrderInfo,{
        onAfterShow : function () {
            if(!this.isEditing){
                this.isEditing = true;
                this.refreshOrderInfo();
            }
        },
        refreshOrderInfo:function(){
            this.getDefaultAddr();
        },
        //加载购物车中商品
        loadMatsByIds:function(mids){
            return mat.loadByIds(mids,config.getPlatformShopId());
        },
        //加载本次的运费
        loadTranFee:function(mids){
            if (this.addrId) {
                mids.addressId = this.addrId;
            } else {
                delete mids.addressId;
            }
            return order.getB2BCouponsAndTAmount(mids);
        },
        //提交订单
        postOrder:function(orderInfo){
            if (this.addrId) {
                orderInfo.addressId = this.addrId;
            } else {
                delete orderInfo.addressId;
            }
            return order.createB2BOrder(orderInfo);
        },
        //支付订单——一组订单
        onPayOrder:function(orderInfo){
            return order.onB2BPayByIds(orderInfo);
        },
        getPayTypeInfos:function(){
            return shop.getB2BPayType();
        },
        //获取地址
        getDefaultAddr:function(){
            userAddress.loadDefaultAddress().then(lang.hitch(this,function(data){
                if(data.data.item){
                    this.setAddr(data.data.item);
                }else {
                    this.setAddr();
                }
            }));
        },
        connectAddrEve:function(){
            this.connect(this.matList.containerNode,"onclick",this.createCouponsList);
            this.connect(this.defaultAddr.containerNode,"onclick",this.defaultAddrClick);
        },
        //地址选择点击
        defaultAddrClick:function(e){
            var listitem = registry.getEnclosingWidget(e.target);
            if (listitem.params) {
                addrPick.startEdit(this.addrId ? this.addrId : "",this).then(lang.hitch(this,function(id){
                    if (id) {
                        this.addrId = id;
                    }
                    userAddress.loadById(this.addrId).then(lang.hitch(this, function (data) {
                        this.setAddr(data.data.item);
                    }));
                }));
            } else {
                this.isEditing = false;
                window.moveToView("userAddDetail");
            }
        },
        //地址变化后更新地址,并更新运费
        setAddr:function(data){
            if (data) {
                this.addrId = data._id;
                data.address = data.provinceId.distName + data.cityId.distName + data.countyId.distName + data.detailAddress;
                this.addDefaultAddr(data);
                var m = this.getData();
                m.pName = data.contactName;
                m.phone = data.tel;
                m.address = data.address;
                this.setData(m);
            }else {
                this.addrId = "";
                this.addDefaultAddr();
            }
            this.loadMatsInfo();
        },
        //设置默认地址
        setDefaultAddr:function(data){
        },
        addDefaultAddr:function(data){
            var htmlStr = "";
            this.defaultAddr.destroyDescendants();
            this.defaultBuyer.destroyDescendants();
            if (data) {
                htmlStr = "<div><p>收货人：<span class='buyerName'>"+ data.contactName +"</span>"+
                "<span class='buyerTel'>"+ data.tel +"</span></p>"+
                "<p>收货地址：<span class='buyerAddr'>"+ data.address +"</span></p></div>";
            } else {
                htmlStr = "<div><p>请添加收货地址</p></div>"
            }
            var listitem = new ListItem({
                label:htmlStr,
                variableHeight:true,
                moveTo:"moveTo",
                params:data
            });
            this.defaultAddr.addChild(listitem);
        },
        //创建优惠券列表
        createCouponsList:function(e){
            var dom = e.target;
            if(domClass.contains(dom, "getCouponsList")){
                var shopId = dom.nextSibling.innerHTML;
                this.getData();
                //获取商家优惠券
                this.getValidDisSer({shopId:shopId}).then(lang.hitch(this,function(data){
                    if(data&&data.data&&data.data.items&&data.data.items.length>0){
                        data.data.shopId = shopId;
                        this.showCoupons(data);
                    }else {
                        var msg = data.data.message||"暂无优惠券";
                        alert(msg);
                    }
                }));
            }
        },
        //获取商家优惠券
        getValidDisSer:function(params){
            return disCount.loadAvailableByUserSelfThen(params);
        },
        //用户自领优惠券
        getCouponByUserSelf:function(params){
            return disCount.getCouponByUserSelf(params);
        }
    });
});
