// 变更人:曹桂捷
// 变更时间:2016/10/26
// 变更内容:代付
define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-attr",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "cq/biz/ts/order",
    "cq/biz/shop/shop"
],function(declare,lang,array,View,ListItem,query,domClass,domAttr,_ViewMixin,date,order,shop){
	return declare("'whz.view.OrderPayForAnother",[View,_ViewMixin],{
		//初始化界面
		onFirstShow:function(){
			var option = null;
			//创建头部
			option = {
				left : {
					iconButton: ' ',
                    arrow: "left",
                    label: "返回",
					onClick: function(){
						history.back()
					}
				},
				title: "他人代付"
			};
			this.addHeader(option);
			//收货相关信息
			option = {
				isEdge: true,
				lists: [],
				class: "bottom-margin16"
			};
			this.orderList = this.addLists(option);
            this.orderStateItem = new ListItem({
                variableHeight: true
            });
            this.orderList.addChild(this.orderStateItem);
			//商品信息
			option = {
				isEdge: true,
				lists: [],
				class: "bottom-margin16"
			};
			this.matList = this.addLists(option);
			//费用信息
			option = {
				isEdge: true,
				lists: [],
				class: "bottom-margin16"
			};
			this.expenseList = this.addLists(option);
            this.expenseItem = new ListItem({
                variableHeight: true
            });
            this.expenseList.addChild(this.expenseItem);
            //代付按钮
            option = {
            	columns: [{
            		label: "<div><span class='count'><div class='yfNode'><div><span class='mon_font'>" + "应付:￥</span><font class='yf_font_detail'>0.00</font></div><div class='jfdk_div'>" + "(余额(优惠券)抵扣<font class='jf_font_detail'>0</font>)<span style='float:right'>帮他代付</span></div></div></span></div>",
                    className: "edit-car-count flex1"
            	},{
                    label: "<span class='payAli'>支付宝支付</span>",
                    className: "edit-car-submit none",
                    onClick: lang.hitch(this, function() {
                        this.onOrderPay("aliwap");
                    })
                },{
                    label: "<span class='payWeiXin'>微信支付</span>",
                    className: "edit-car-submit none",
                    onClick: function() {
                        this.onOrderPay("weixin");
                    }
                },{
                    label: "<span class='payDeposit'>余额支付</span>",
                    className: "edit-car-submit none",
                    onClick: function() {
                        this.onOrderPay("point");
                    }
                }],
            	splitter: '../../images/mobile/splitter.png',
                className: 'fix-footer edit-car-footer',
                forceWidth: false,
                isFooter: true
            };
            this.payNode = this.addColumns(option);
            //支付成功
            option = {
                columns: [{
                    label: '代付成功',
                    className: 'flex2 footer-tab-highlight none'
                }],
                forceWidth: false,
                isFooter: true
            };
            this.payCompleted = this.addColumns(option);
            this.onAfterShow();
            this.onClickMatList();
		},
		//付款操作
		onOrderPay:function(payType){
			window.busy();
			order.onB2BPayByIds({
				_id:this.id,
				payType:payType
			}).then(lang.hitch(this,function(data){
				window.free();
				if(data && data.data && data.data.ok == 1){
					domClass.add(this.payNode,"none");
					domClass.remove(this.payCompleted,"none");
				}else{
					alert(data && data.data && data.data.msg)
				}
			}))
		},
		//查看商品详情
		onClickMatList:function(dom){
			this.connect(this.matList.domNode,"onclick",lang.hitch(this,function(e){
				var dom = e.target;
				if(dom && dom.tagName === "IMG"){
					window.moveToView("matDetail", (domAttr.get(dom, "mId"))+"_"+this.shopId);
				}
			}))
		},
		//加载数据，并显示到页面上
		onAfterShow:function(){
			if(window.did && window.did.split("-").length == 2){
				this.shopId = window.did.split("-")[0];
				this.id = window.did.split("-")[1];
			}
            this.orderStateItem.set({
                label: ""
            });
            this.matList.destroyDescendants();
            this.expenseItem.set({
                label: "",
                rightText: ""
            });
            //加载订单详情
            this.getLoadDetailById().then(lang.hitch(this,function(data){
            	var items = data && data.data && data.data.items || [];
            	if(items.length){
            		//收货人信息
            		this.orderStateItem.set({
            			label: "<div class='webkit-list'><div class='edit-car-dName'>收货人:" + (items[0].dName ? items[0].dName : "未知") + "</div><div class='edit-car-dTel'>" + (items[0].dTel ? items[0].dTel : "未知") + "</div></div>" + "<div class='immune-list'><div class='edit-car-dAddress'>收货地址：" + (items[0].dAddress ? items[0].dAddress : "未知") + "</div></div>"
                    })
                    //商品信息
                    for(var i = items.length - 1; i >=0; i--){
                    	var listItem = new ListItem({
                    		label: "<img class='edit-car-matimg' src='" + items[i].mId.logo + "' mId='" + items[i].mId._id + "'/><span class='edit-car-matname'>" + items[i].mId.mName + "</span><span class='edit-car-matprice'>￥" + window.fixedTo(items[i].price, 3) + "</span>",
                    		rightText: "<div class='edit-car-qtys'>x" + items[i].qty + "</div><div class='edit-car-subtotal'>小计:<span class='line-through'>￥" + window.fixedTo(items[i].price * items[i].qty, 3) + "</span>" + "<div style='text-align:right;'>￥" + window.fixedTo(items[i].amount, 3) + "</div></div>",
                    		variableHeight: true
                    	});
                    	this.matList.addChild(listItem);
                    }
            	}
            }));
            this.getLoadById().then(lang.hitch(this,function(data){
            	if(data && data.data && data.data.ok == 1){
            		//订单费用相关信息显示
            		var item = data.data.item;
            		var dates = date.formatISODateMinutes(item.createAt);
            		this.expenseItem.set({
            			label: "<div class='edit-car-amount'>运费:</div>" + "<div class='edit-car-amount'>交易金额（含运费）:</div>" + "<div class='edit-car-amount'>积分/优惠券抵扣:</div>" + "<div class='edit-car-createAt'>创建时间:</div>",
                		rightText: "<div class='edit-car-amount'>￥" + data.data.item.tAmount.toFixed(2) + "</div>" + "<div class='edit-car-amount'>￥" + data.data.item.amount.toFixed(2) + "</div>" + "<div class='edit-car-amount'>￥" + (data.data.item.couponAmount + data.data.item.point).toFixed(2) + "</div>" + "<div class='edit-car-createAt'>" + dates + "</div>"
           			});
           			query(".yf_font_detail", this.payNode)[0].innerHTML = (item.amount - ((item.point + item.couponAmount) || 0)).toFixed(2);
            		query(".jf_font_detail", this.payNode)[0].innerHTML = (item.point + item.couponAmount).toFixed(2);
		            //支付方式
		            this.getPayType().then(lang.hitch(this,function(payTypes){
		            	var payNodes = query(".edit-car-submit", this.payNode);
		            	var payModes = [false, false, false];
		            	if ((data.data.item.amount - ((data.data.item.point + data.data.item.couponAmount) || 0)) <= 0) {
	                        payModes[2] = true;
	                    } else {
	                        if (payTypes.payAli) {
	                            payModes[0] = true;
	                        }
	                        if (payTypes.payWeiXin) {
	                            payModes[1] = true;
	                        }
	                    }
	                    payNodes.forEach(function(node, index) {
	                        domClass[payModes[index] ? "remove" : "add"](node, "none");
	                    });
		            }))
            	}
            }));
		},
		//查询订单
		getLoadDetailById:function(){
			return order.loadDetailShopById({
				id:this.id,
				shopId:this.shopId
			});
		},
		getLoadById:function(){
			return order.loadShopById({
				id:this.id,
				shopId:this.shopId
			});
		},
		//获取支付方式
		getPayType:function(){
			return shop.getB2BPayType();
		}
	})
})