// 变更人:曹桂捷
// 变更时间:2016/10/26
// 变更内容:代付
define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-attr",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "cq/biz/ts/order",
    "cq/biz/shop/shop",
    "cq/biz/im/task_todo",
    "cq/biz/user/user"
],function(declare,lang,array,View,ListItem,query,domClass,domAttr,_ViewMixin,date,order,shop,taskTodo,user){
	return declare("whz.view.PayToAnother",[View,_ViewMixin],{
		//初始化界面
		onFirstShow:function(){
			var option = null;
			//创建头部
			option = {
				left : {
					iconButton: ' ',
                    arrow: "left",
                    label: "返回",
					onClick: function(){
						history.back();
					}
				},
				title: "他人代付"
			};
			this.addHeader(option);
			//收货相关信息
			option = {
				isEdge: true,
				lists: [],
				class: "bottom-margin16"
			};
			this.orderList = this.addLists(option);
            this.orderItem = new ListItem({
                variableHeight: true
            });
            this.orderList.addChild(this.orderItem);
            //订单状态
            option = {
                isEdge: true,
                lists: [],
                class: "bottom-margin16"
            };
            this.orderState = this.addLists(option);
            this.orderStateItem = new ListItem({
                variableHeight: true
            });
            this.orderState.addChild(this.orderStateItem);
			//商品信息L
			option = {
				isEdge: true,
				lists: [],
				class: "bottom-margin16"
			};
			this.matList = this.addLists(option);
			//费用信息
			option = {
				isEdge: true,
				lists: [],
				class: "bottom-margin16"
			};
			this.expenseList = this.addLists(option);
            this.expenseItem = new ListItem({
                variableHeight: true
            });
            this.expenseList.addChild(this.expenseItem);
            //提醒
            option = {
				isEdge: true,
				lists: [],
				class: "bottom-margin16"
			};
			this.warnList = this.addLists(option);
            this.warnItem = new ListItem({
            	label:"<span>提醒：为避免风险，建议您通过电话确认代付申请人是您亲友，不要为陌生人付款。</span>",
                variableHeight: true
            });
            this.warnList.addChild(this.warnItem);
            //代付按钮
            option = {
            	columns: [{
            		label: "<span class='count none'><div class='yfNode' style='line-height:46px;margin-left:10px'><span class='mon_font'>" + "应付:￥</span><font class='yf_font_detail'>0.00</font></div></span>",
                    className: "edit-car-count flex1"//手机上支付方式看不全
            	},{
                    label: "<span class='payRefuse'>拒绝付款</span>",
                    className: "edit-car-submit",
                    onClick: lang.hitch(this, function() {
                    	this.onPayRefuse();
                    })
                },{
                    label: "<span class='payAli'>支付宝支付</span>",
                    className: "edit-car-submit payType none",
                    onClick: lang.hitch(this, function() {
                        this.onOrderPay("aliwap");
                    })
                },{
                    label: "<span class='payWeiXin'>微信支付</span>",
                    className: "edit-car-submit payType none",
                    onClick: lang.hitch(this, function() {
                        this.onOrderPay("weixin");
                    })
                }],
            	splitter: '../../images/mobile/splitter.png',
                className: 'fix-footer edit-car-footer',
                forceWidth: false,
                isFooter: true
            };
            this.payNode = this.addColumns(option);
            this.onAfterShow();
            this.onClickMatList();
		},
		//付款操作
		onOrderPay:function(payType){
			window.busy();
            var param = {_id:this.targetTsId,ids:[this.targetTsId],payType:payType,shopId:this.targetShopId}
			order.onB2BPayByIds(param).then(lang.hitch(this,function(data){
				window.free();
				if(data && data.data && data.data.ok == 1){

				}else{
					alert(data && data.data && data.data.msg)
				}
			}))
		},
		//拒绝支付
		onPayRefuse:function(){
            var params = {};
            var pName = user.getUserData().pName||user.getUserData().pName || "未知";
            params.moveTo = "orderDetail";
            params.param = this.targetTsId;
            params.taskType = 2;
            params.targetShopId = this.targetShopId;
            params.content = pName + "拒绝了您的付款请求" ;
            params.shopId = shop.getShopId();
            params.fromShopId = shop.getShopId();
            params.receiverId = this.tsUserId;
            taskTodo.save(params).then(lang.hitch(this,function(data){
				if(data.data.ok == 1){
					alert("发送成功")
				}
				history.back();
			}));
		},
		//查看商品详情
		onClickMatList:function(dom){
			this.connect(this.matList.domNode,"onclick",lang.hitch(this,function(e){
				var dom = e.target;
				if(dom && dom.tagName === "IMG"){
					window.moveToView("matDetail", (domAttr.get(dom, "mId"))+"_"+this.targetShopId);
				}
			}))
		},
		//加载数据，并显示到页面上
		onAfterShow:function(){
			if(window.did && window.did.split("-").length == 2){
				this.targetShopId = window.did.split("-")[0];
				this.targetTsId = window.did.split("-")[1];
			}
            this.orderItem.set({
                label: ""
            });
            this.orderStateItem.set({
                label:"订单状态",
                rightText:""
            });
            this.matList.destroyDescendants();
            this.expenseItem.set({
                label: "",
                rightText: ""
            });
            
            this.getLoadById().then(lang.hitch(this,function(data){
            	if(data && data.data && data.data.ok == 1){
            		//订单费用相关信息显示
            		var item = data.data.item;
                    if(item){
                		this.amount = item.amount.toFixed(2);
                        this.tsUserId = item.userId;
                		var dates = date.formatISODateMinutes(item.createAt);
                		this.expenseItem.set({
                			label: "<div class='edit-car-amount'>运费:</div>" + "<div class='edit-car-amount'>交易金额（含运费）:</div>" + "<div class='edit-car-createAt'>创建时间:</div>",
                    		rightText: "<div class='edit-car-amount'>￥" + data.data.item.tAmount.toFixed(2) + "</div>" + "<div class='edit-car-amount'>￥" + data.data.item.amount.toFixed(2) + "</div>" + "<div class='edit-car-createAt'>" + dates + "</div>"
               			});
               			//订单是否已支付,若已支付显示已支付按钮
               			if(item.isPayed || item.isCanceled){
               				domClass.add(this.payNode,"none");
                            if(item.isPayed){
                                this.orderStateItem.set({
                                    rightText:"已支付"
                                })
                            }
                            if(item.isCanceled){
                                this.orderStateItem.set({
                                    rightText:"已取消"
                                })
                            }
               			}else{
                            domClass.remove(this.payNode,"none");
                            this.orderStateItem.set({
                                rightText:"待付款"
                            })
               				query(".yf_font_detail", this.payNode)[0].innerHTML = this.amount;
    	            		domClass.remove(query(".payRefuse",this.payNode)[0],"none");
    			            //支付方式
    			            this.getPayType().then(lang.hitch(this,function(payTypes){
    			            	var payNodes = query(".payType", this.payNode);
    			            	var payModes = [false, false];
    	                        if (payTypes.payAli) {
    	                            payModes[0] = true;
    	                        }
    	                        if (payTypes.payWeiXin) {
    	                            payModes[1] = true;
    	                        }
    		                    payNodes.forEach(function(node, index) {
    		                        domClass[payModes[index] ? "remove" : "add"](node, "none");
    		                    });
    			            }))
               			}
           			}
            	}
            }));
            //加载订单详情
            this.getLoadDetailById().then(lang.hitch(this,function(data){
                var items = data && data.data && data.data.items || [];
                if(items.length){
                    //收货人信息
                    var dName = items[0].dName ? items[0].dName : "未知";
                    this.orderItem.set({
                        label: "<div><span>"+ dName + "发起一笔代付，请您帮忙付款"+ this.amount +"元</span></div>"
                    })
                    //商品信息
                    for(var i = items.length - 1; i >=0; i--){
                        var listItem = new ListItem({
                            label: "<img class='edit-car-matimg' src='" + items[i].mId.logo + "' mId='" + items[i].mId._id + "'/><span class='edit-car-matname'>" + items[i].mId.mName + "</span><span class='edit-car-matprice'>￥" + window.fixedTo(items[i].price, 3) + "</span>",
                            rightText: "<div class='edit-car-qtys'>x" + items[i].qty + "</div><div class='edit-car-subtotal'>小计:<span class='line-through'>￥" + window.fixedTo(items[i].price * items[i].qty, 3) + "</span>" + "<div style='text-align:right;'>￥" + window.fixedTo(items[i].amount, 3) + "</div></div>",
                            variableHeight: true
                        });
                        this.matList.addChild(listItem);
                    }
                }
            }));
		},
		//查询订单
		getLoadDetailById:function(){
			return order.loadDetailShopById({
				id:this.targetTsId,
				shopId:this.targetShopId
			});
		},
		getLoadById:function(){
			return order.loadShopById({
				id:this.targetTsId,
				shopId:this.targetShopId
			});
		},
		//获取支付方式
		getPayType:function(){
			return shop.getB2BPayType();
		}
	})
})