define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojox/mobile/View",
        "cq/ui/view/_ViewMixin",
        "dojo/_base/xhr",
        "dojo/query",
        "cq/biz/shop/shop",
        "cq/biz/user/user"
    ], function (declare, lang, View, _ViewMixin, xhr, query, shop, user) {
    return declare("whz.view.PersonalInformation", [View, _ViewMixin], {
        onAfterShow : function () {
            //var data = {};
            //data.shopName = __shop.shopName;
            //data.userName = "";
            // 记载用户信息
            user.getUserInfo().then(lang.hitch(this, function(data){
                this.setData(data.data.item);
                this.refreshData();
            }));
        },
        saveUser:function(){
            var data = this.getData();
            user.save(data).then(function(){
                user.info.logo = data.logo || user.info.logo;
                user.info.pName = data.pName || user.info.pName;
                history.back(-1);
            });
            
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back(-1);
                    }
                },
                title : "个人资料",
                right : {
                    iconButton : ' ',
                    label:"完成",
                    onClick : function(){
                        this.saveUser();
                    }
                }
            };
            this.addHeader(option);
            option = {
                isEdge:true,
                lists:[{
                    label:"头像",
                    noArrow:false,
                    moveTo:"#",
                    edit:{
                        type:"image",
                        field:"logo"
                    },
                    class:"li-icon"
                },{
                    label:"姓名",
                    noArrow:false,
                    moveTo:"#",
                    edit:{
                        type:"text",
                        field:"pName"
                    }
                },{
                    label:"电话",
                    rightText:"",
                    edit:{
                        type:"tel",
                        field:"phone"
                    }
                },
                //删除商家余额
                /*{
                    label:"商家余额",
                    rightText:"",
                    edit:{
                        type:"text",
                        disabled:true,
                        field:"amount"
                    }
                },*/{
                    label:"生日",
                    noArrow:false, //增加右箭头
                    moveTo:"#",
                    edit:{
                        type:"date",
                        field:"birthday"
                    }
                },{
                    label:"性别",
                    noArrow:false,    //增加右箭头  
                    moveTo:"#",
                    edit:{
                        type:"options",
                        field:"sex",
                        options:{"0":"男","1":"女"}
                    }
                },{
                    label:"地址",
                    edit:{
                        type:"text",
                        field:"address"
                    }
                },
                //删除微信关注者
                /*{
                    label:"微信关注者",
                    edit:{
                        type:"text",
                        field:"wxSubCount",
                        disabled:true
                    }
                }*/]
            };
            this.addLists(option);
            option = {
                columns : [{
                    label : '修改密码',
                    className : 'flex2 footer-tab-dark',
                    onClick : function () {
                        window.moveToView("changePassword");
                    }
                },{
                    label : '注销',
                    className : 'flex2 footer-tab-highlight',
                    onClick : function () {
                        shop.logout().then(lang.hitch(this, function () {
                                window.moveToView("login");
                            }));
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.addColumns(option);
            this.onAfterShow();
        }
    });
});