define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dojo/_base/xhr",
	"dojo/query",
	"dijit/registry",
	"dojo/_base/Deferred",
	"dojox/mobile/ListItem",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",
	"dojo/store/JsonRest",
	"cq/biz/shop/shop",	
	"cq/biz/ts/pm/bail",	
	"cq/util/sys/date",
	"dojo/dom-class"
],function(declare,lang,View,_ViewMixin,xhr,query,registry,Deferred, ListItem,EdgeToEdgeStoreList,on,when,JsonRest,shop,bail,date,domClass){
	return declare("whz.view.PlatBail",[View,_ViewMixin],{
		start:0,
		//初始化相关接口
		indexElement:function(){
			this.platListScroll = this.centerPanel;
		},
		onAfterShow:function(){
			this.setQuery(this.storeList.get("query"), {
				start: 0,
				count: 10
			});
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() { window.moveToView("home"); }
				},
				title:"保证金审核"
			};
			this.addHeader(option);
			option = {
				placeHolder:"请输入要查询条件，按回车查询",
				class:"cqSearchBox",
				type:"search",
				onInput:lang.hitch(this,function(evt){
					if(evt.keyCode==13){
						this.search = evt.target.value;
						var condition = this.storeList.get("query");
						condition.shopName = evt.target.value;
						this.setQuery(condition);
						evt.target.value = "";
					}
				})
			};
			this.addTextBox(option);
			option = {
				columns:[{
					label:'未审核',
					onClick:this.changeNoVerify
				},
				{
					label:'已审核',
					onClick:this.changeOnVerify
				}],
				labelClass:'font-size1 tab-selector'
			}
			this.addColumns(option);
			
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
                //获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){					
					for(var i=0;i<data.length;i++){
                        data[i]._label=
							"<div>转账日期："+date.formatISODate(data[i].transferDate)+"</div>"+
							"<div>开户行："+data[i].bankName+"</div>"+
							"<div>开户名："+data[i].bankOwner+"</div>"+
                            "<div>账号："+data[i].bankAccount+"</div>"+
                            "<div>金额："+data[i].amount.toFixed(2)+"</div>";
						if(!data[i].isVerified) data[i]._label+="<div class='float-right color-white color-bg-h round-button btn-verify'>审核</div>"
					}				
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions: {
					count: 10,
					start: this.start
					},
				itemMap:{_label:"label"}
				});
			//创建数据源
			this.params={isVerified:false,ioType:0,tsType:2,shopId:shop.getShopId()};
			this.store = new JsonRest({target:bail.load()});

			// 将数据源赋值给storeList
			this.storeList.setStore(this.store,this.params);
			domClass.add(query('.tab-selector',this.domNode)[0],"selected");
			this.storeList.placeAt(this.platListScroll.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.platListScroll,"afterscroll",lang.hitch(this,this.onLoadMore));
		},

		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(!domClass.contains(evt.target,'btn-verify')) return;
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params._id;
			bail.verify({_id:_id}).then(lang.hitch(this,function(data){
				if(data.data.ok==0){
					alert(data.data.msg);
					return;
				}
				li.getParent().removeChild(li);
				alert("审核成功");
			}));

		},
		onLoadMore:function(evt){
			if(this.busy||(0<this.end&&(this.start+10-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多商家");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: 10
					}), lang.hitch(this,function(){
						this.platListScroll.resize();
					}));
				}), 1000);
			}
		},
		clearSelected:function(){
			var items = query('.tab-selector',this.domNode);
			for(var i=0;i<items.length;i++){
				domClass.remove(items[i],"selected");
			}
		},
		changeNoVerify:function(evt){
			this.clearSelected();
			domClass.add(evt.target,"selected");
			var qry = this.storeList.query;
			qry.isVerified = false;
			this.setQuery(qry);
		},
		changeOnVerify:function(evt){
			this.clearSelected();
			domClass.add(evt.target,"selected");
			var qry = this.storeList.query;
			qry.isVerified = true;
			this.setQuery(qry);
		},
		changeNoSubmit:function(evt){
			this.clearSelected();
			domClass.add(evt.target,"selected");
			this.setQuery({
				isVerifySubmit:false,
				shopId:shop.getShopId()
			});
		},
		setQuery:function(query){
			this.start = 0;
			this.end = -1;
			this.storeList.destroyDescendants();
			this.storeList.setQuery(query,{
				start: this.start,
				count: 10
			});
			this.platListScroll.resize();
		}
	});
});
