// 创建时间: 2016-10-08
// 创建人: 杜飞军
// 创建内容: 用于平台管理所有商家的产品
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/store/JsonRest",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/biz/mat/sort",
    "cq/biz/mat/mat",
    "cq/biz/shop/shop",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/xlsx"
], function(declare, lang, array, query, domConstruct, domClass, domStyle, domAttr, JsonRest, EdgeToEdgeStoreList, ScrollablePane, View, registry, sort, mat, shop, _ViewMixin, xlsx) {
    return declare('whz.view.PlatMatList', [View, _ViewMixin], {
        // sortSelect选择状态
        sortState: false,
        // 初始化查询值
        start: 0,
        pageSize: 10,
        urlQuery : "",
        onAfterShow: function() {
            // 创建数据源
            if (!this.store) {
                this.params = {
                    verifyState: 1,
                    orderBy: 'createAt'
                };
                this.store = new JsonRest({
                    target: mat.getUrlByShop() + "?shopId=" + shop.getShopId()
                });
                var queryResult = this.storeList.setStore(this.store, this.params, {
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult, this.start, this.pageSize);
            } else {
                this.setQuery(this.params);
            }
            this.initMatGroupContent();
        },
        onFirstShow: function() {
            // 头部菜单
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: function() {
                        this.hideDropDown();
                        history.back();
                    }
                },
                title: "商品管理"
            };
            this.addHeader(option);
            // 搜索框
            option = {
                isHeader: true,
                placeHolder: "请输入要查询的条件，按回车查询",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, function(evt) {
                    if (evt.keyCode === 13) {
                        this.params.mName = evt.target.value;
                        this.setQuery(this.params);
                        this.params.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            // 过滤条件
            option = {
                isHeader: true,
                columns: [{
                    label: '未审核',
                    onClick: this.changeNotVerify
                }, {
                    label: '已审核',
                    onClick: this.changeVerify
                }, {
                    label: '全部分类',
                    className: 'changeSortName',
                    onClick: this.showMatGroupDropdown
                }],
                labelClass: 'font-size1 tab-selector',
                className: "tabBox"
            };
            this.optionColumnNode = this.addColumns(option);
            option = {
                isFooter : true,
                columns : [{
                    label : "导出",
					className: 'flex2 footer-tab-highlight',
                    onClick : this.exportMat
                }],
                labelClass: 'font-size1',
                className: "fix-footer"
            };
            this.addColumns(option);            
            this.initDropdownToolBar();
            // 移除高度和行高设置 导致头部出现滚动条
            query('.tab-selector', this.optionColumnNode).forEach(function(item) {
                domStyle.set(item, { height: '16px', 'line-height': '16px' });
            });
            // 商品列表
            this.storeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query: {},
                class: "icon-list-item imgSize64",
                variableHeight: true,
                // 获取数据完成后调用的的处理方法
                onComplete: lang.hitch(this, function(data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div class='selectedState'><div class='mat-list-left'><img src='" + (data[i].logo ? data[i].logo : 'images/nomat.png') + "'></div><div class='mat-list-right'>" +
                            "<div class='mat-list-mname mat-list-margin margin-top5'>" + data[i].mName +
                            "</div><div class='mat-list-price mat-list-margin margin-top5'>" + (data[i].sortName ? data[i].sortName : '') +
                            "</div></div>" +
                            "<div class='mat-list-managed'>" +
                            "<div class='forth-btn'>";
                        if (data[i].verifyState === 1) {
                            data[i]._label += "<span class='unVerfiy float-right'>不通过</span>" +
                                "<span class='verfiy float-right'>通过</span>";
                        }
                        if (data[i].verifyState === 2) {
                            data[i]._label += "<span class='cancleVerfiy float-right'>不通过</span>";
                        }
                        data[i]._label += "</div>";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                    window.free();
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap: {
                    _label: "label",
                    _logo: "icon",
                    moveTo: "moveTo"
                }
            });
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        //加载当前商家的所有商品分类，并依据结果初始化分类区域内容
        initMatGroupContent: function() {
            this.loadSort({ noSub: true }).then(lang.hitch(this, function(data) {
                var items = data && data.data && data.data.items || [];
                this.addScrollContent([{
                    _id: "",
                    title: "全部分类"
                }].concat(array.map(items, function(item) {
                    return {
                        _id: item._id,
                        title: item.sortName,
                        verifyState: item.verifyState
                    };
                })), this.matGroupPane);
            }));
        },
        // 已经审核的
        changeVerify: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.verifyState = 2;
            this.setQuery(this.params);
        },
        // 没有审核的
        changeNotVerify: function(evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.verifyState = 1;
            this.setQuery(this.params);
        },
        clearSelected: function() {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        //选择分类的区域的根节点
        matGroupPane: null,
        //向界面上添加点击下拉区域
        initDropdownToolBar: function() {
            //添加弹出分类区域，点击之后切换当前分类并重新加载数据
            this.matGroupPane = this.addDropdownArea({
                //点击商品分类之后的响应事件
                onClick: lang.hitch(this, this.onMatGroupClick)
            });
        },
        addScrollContent: function(contents, scrollablePane) {
            var ulNode = query("ul", scrollablePane.containerNode)[0];
            //map() 方法返回一个新数组，数组中的元素为调用函数按照原始数组元素顺序依次处理后的值。
            ulNode.innerHTML = array.map(contents, function(content) {
                return "<li tabtype='matType' name='" + content._id + "'>" + content.title + "</li>";
            }).join("");
        },
        //设置选中的样式
        setItemSelected: function(node) {
            var selectedNode = query(".selected", node.parentNode)[0];
            if (selectedNode) {
                domClass.remove(selectedNode, "selected");
            }
            domClass.add(node, "selected");
        },
        //商品分类点击之后的响应事件，获取被选中的商品分类、处理选中样式、刷新数据、将选中的内容显示到分类column中
        onMatGroupClick: function(e) {
            var dom = e.target;
            var id = domAttr.get(e.target, "name");
            if (id) {
                this.params.sortId = id;
            } else {
                delete this.params.sortId;
                // 移除审核状态
                delete this.params.verifyState;
            }
            this.setQuery(this.params);

            //处理选中样式
            this.setItemSelected(e.target);
            //处理分类column中的显示
            query(".tab-selector", this.optionColumnNode)[2].innerHTML = e.target.innerHTML;
            //隐藏下拉区域
            this.hideDropDown();
        },
        //弹出商品分类下拉框
        showMatGroupDropdown: function() {
            domClass.add(query(".tab-selector", this.optionColumnNode)[2], "selected");
            domClass.remove(this.dropdowm, "none");
            domClass.remove(this.appNavDropDownBg, "none");
            domClass.remove(this.matGroupPane.domNode, "none");
            this.matGroupPane.resize();
            this.resize();
        },
        //隐藏弹出的选择分类或者排序的下拉区域
        hideDropDown: function() {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            domClass.add(this.dropdowm, "none");
            domClass.add(this.appNavDropDownBg, "none");
        },
        // 向界面上添加下拉区域，参数暂时只支持onClick——内容点击事件，返回值为该区域的根节点
        addDropdownArea: function(param) {
            //判断是否已有半透明背景，若没有，创建，处理点击事件
            if (!this.dropdowm) {
                //domConstruct.create()创建一个元素
                this.dropdowm = domConstruct.create("div", {
                    className: "nav_dropdowm none"
                });
                this.dropdownItem = domConstruct.create("div", {
                    "class": "nav_dropdowm_item"
                }, this.dropdowm);
                //创建一个背景元素
                this.appNavDropDownBg = domConstruct.create("div", {
                    className: "nav_dropdownbg none"
                });
                var tabBox = query(".tabBox", this.domNode)[0];
                tabBox.appendChild(this.dropdowm);
                tabBox.appendChild(this.appNavDropDownBg);
                //监听事件，隐藏下拉区域
                this.connect(this.appNavDropDownBg, "onclick", this.hideDropDown);
            }
            //向根节点添加scrollbalePane
            var scrollablePane = new ScrollablePane({
                height: "100%"
            });
            //把scrollablePane放到this.dropdowm的最后
            scrollablePane.placeAt(this.dropdownItem, "last");
            scrollablePane.startup();
            var ulNode = domConstruct.create("ul", {
                //向scrollablePane的containerNode中添加内容div——有特殊的class，用于添加内容
            }, scrollablePane.containerNode, "last");
            //侦听内容节点的点击事件，事件处理函数为参数中的onClick
            this.connect(ulNode, "onclick", param.onClick);
            return scrollablePane;
        },
        // // 创建品类选择列表
        // createSelect: function(data) {
        //     domConstruct.empty(this.sortSelect);
        //     if (data && data.length > 0) {
        //         for (var i = 0; i < data.length; i++) {
        //             // 头部添加一个全部分类
        //             if (i == 0) {
        //                 domConstruct.create('li', {
        //                     'class': 'sortSelectLi',
        //                     innerHTML: "全部分类",
        //                     _id: ""
        //                 }, this.sortSelect);
        //             }
        //             domConstruct.create('li', {
        //                 'class': 'sortSelectLi',
        //                 innerHTML: data[i].sortName,
        //                 _id: data[i]._id
        //             }, this.sortSelect);
        //         }
        //     }
        // },
        // 加载商品分类
        loadSort: function(params) {
            return sort.load(params);
        },
        
        //数据导出功能 11-15 程磊
        exportMat : function(){
            var query = this.storeList.query;
            var url = mat.getPlatformOnSaleUrl();
            // var queryString = "";
            // for(var item in query){
                // queryString += "&" + item + "=" + query[item];
            // }
            // url += queryString;
            var cols = [];
            cols[0] = {
                className:"large-width",
                id:"0",
                field:"mName",
                label:"商品名称"
            };
            cols[1] = {
                className:"large-width",
                id:"1",
                field:"sortName",
                label:"标准分类"
            };
            cols[2] = {
                className:"large-width",
                id:"2",
                field:"sizeType",
                label:"规格"
            };
            cols[3] = {
                className:"large-width",
                id:"3",
                field:"minQty",
                label:"最小起订量"
            };
            cols[4] = {
                className : "large-width",
                id : "4",
                field : "retailPrice",
                label : "价格"
            };
            cols[5] = {
                className : "large-width",
                id : "5",
                field : "fromShopId.shopName",
                label : "供货商家名称"
            };
            xlsx.exportData(url,query,cols,Date.now().toString());
        },
        setQuery: function(query) {
            window.busy();
            this.start = 0;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start: this.start,
                count: this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult, this.start, this.pageSize);
        },
        // 加载更多
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.pageSize + this.start;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function() {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start: this.start,
                            count: this.pageSize
                        });
                        this.onLoadListData(queryResult, this.start, this.pageSize);
                    }), 1000);
                }
            }
        },
        // 重写List的点击事件
        onClickList: function(evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            var _id;
            if (li.declaredClass != "dojox.mobile.ListItem") {
                return;
            }
            var dom = evt.target;
            // 通过
            if (dom && domClass.contains(dom, "verfiy")) {
                _id = li.params._id;
                mat.platVerify({
                    _id: _id,
                    verifyState: true
                }).then(lang.hitch(this, function(data) {
                    if (data && data.data && data.data.ok === 1) {
                        alert('操作成功');
                        this.onAfterShow();
                    } else {
                        alert('操作失败');
                    }
                }));
                return;
            }
            // 不通过
            if (dom && domClass.contains(dom, "unVerfiy")) {
                _id = li.params._id;
                mat.platVerify({
                    _id: _id,
                    verifyState: false
                }).then(lang.hitch(this, function(data) {
                    if (data && data.data && data.data.ok === 1) {
                        alert('操作成功');
                        this.onAfterShow();
                    } else {
                        alert('操作失败');
                    }
                }));
                return;
            }
            if(dom && domClass.contains(dom, "cancleVerfiy")){
                _id = li.params._id;
                mat.platVerify({
                    _id: _id,
                    verifyState: false,
                    isUse : false
                }).then(lang.hitch(this, function(data) {
                    if (data && data.data && data.data.ok === 1) {
                        alert('操作成功');
                        this.onAfterShow();
                    } else {
                        alert('操作失败');
                    }
                }));
                return; 
            }
            // 都不是则跳到消费者详情页面
            _id = li.params._id;
            window.moveToView('matDetail', _id + "_" + li.params.fromShopId._id);
        }
    });
});
