﻿// 变更人:徐阿雪
// 变更时间:2016/8/29
// 变更原因:抽奖活动详情界面
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-style",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/prize/prize",
    "cq/util/sys/date"
],function(declare,lang,query,domStyle,View,_ViewMixin,prize,date){
    return declare("widgets.mobile.PrizeDetail",[View,_ViewMixin],{
        //isActivity 是否在活动中来控制下面的按钮显示
        //sendType='1':'送积分''2':'送优惠券',3':'送赠品',
        //已开始的不能编辑，需要修改时，停用，然后新增  
        isActivity :0,
        onFirstShow:function(){
            //导航显示
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                       this.isEditing = false;
                       history.back();
                    }
                },
                title : "抽奖活动详情"
            };
            this.addHeader(option);
            //创建底部
            option = {
                columns : [{
                    label : '编辑',
                    className : 'flex2 footer-tab-dark prizeEdit',
                    onClick : function () {
                        window.moveToView("prizeEdit",window.did);
                    }
                },{
                    label : '停用',
                    className : 'flex2 footer-tab-highlight prizeStop',
                    onClick : this.stopPrize
                }, {
                    label : '抽奖记录',
                    className : 'flex2 footer-tab-dark prizeRecord',
                    onClick : lang.hitch(this, function () {
                        /*mat.setRecommend({
                            isRecommend : true,
                            _id : window.did
                        }).then(lang.hitch(this, function () {
                                this.onAfterShow();
                            }));*/
                    })
                },{
                    label : '中奖结果',
                    className : 'flex2 footer-tab-highlight prizeResult',
                    onClick : function () {
                       
                    }
                }],
                forceWidth : false,
                isFooter : true
            };
            this.footerButton = this.addColumns(option);
            //创建内容
            this.addLists({
                isEdge:true,
                lists:[{
                    label: "{{prizeName}}",
                    rightText:"{{luckType}}"
                },{
                    label: "开始时间：{{startTime}}",
                },{
                    label: "结束时间：{{endTime}}",
                },{
                    label:"消耗金额：{{price}}元",
                    rightText: "参与次数：{{involvedNum}}"
                },{
                    label:"停用时间：{{stopTime}}"
                },{
                    label:"活动说明信息：{{content}}"
                },{
                    label:"{{awardsDiv}}",
                    variableHeight: true
                }]
            });
            this.onAfterShow();
        },
        // 新增隐藏底部按钮接口
        hideFooterButton: function(){//prizeStop prizeRecord  prizeResult
            var target1 = query(".prizeEdit", this.domNode)[0];
            var target2 = query(".prizeStop", this.domNode)[0];
            var target3 = query(".prizeRecord", this.domNode)[0];
            var target4 = query(".prizeResult", this.domNode)[0];
            if(this.isActivity===1){
                domStyle.set(target3,"display","none");
                domStyle.set(target4,"display","none");
                domStyle.set(target1,"display","");
                domStyle.set(target2,"display","none");
            }else if(this.isActivity===2){
                domStyle.set(target1,"display","none");
                domStyle.set(target2,"display","");
                domStyle.set(target3,"display","");
                domStyle.set(target4,"display","");
            }else if(this.isActivity===3){
                domStyle.set(target1,"display","none");
                domStyle.set(target2,"display","none");
                domStyle.set(target3,"display","");
                domStyle.set(target4,"display","");
            }
        },
        onAfterShow:function(){
            //活动开始后显示停用、抽奖记录、中奖结果按钮
            //活动结束或停用后只显示抽奖记录、中奖结果按钮
            if(!this.isEditing){
                prize.loadById(window.did).then(lang.hitch(this,function(data){
                //this.isActivity=data.data.item.state;
                this.getActiveState(data.data.item);
                this.hideFooterButton();
                var msg="";
                var item=data.data.item;
                item.startTime=date.formatISODateMinutes(item.startTime);
                item.endTime=date.formatISODateMinutes(item.endTime);
                item.stopTime=date.formatISODateMinutes(item.stopTime)||"暂未停用";
                //各种奖项的显示数据准备
                item.awardsDiv = this.getAwards(item.awards);
                item.luckType=(item.luckType===1?"随机抽奖":"先到先得");
                this.setData(item);
                this.refreshData();
            }));
            }
        },
        //判断活动状态
        getActiveState:function(data){
            if(data.isUse===false){
                this.isActivity=3;
            }else if(data.isUse===true&&data.startTime>date.nowISOString()){//startTime
                this.isActivity=1;
            }else if(data.isUse===true&&data.startTime<date.nowISOString()&&data.endTime>date.nowISOString()){
                this.isActivity=2;
            }
        },
        //积分赠品优惠券  创建div片段
        getAwards:function(awards){
            var awardDiv="",aDiv="";
            for(var i=0;i<awards.length;i++){
                var awardName="奖品名称";
                if(awards[i].sendType==1){
                    //awards[i].sendType="送积分";
                    awards[i].awardName=awards[i].awardAmount;
                    awardName="积分金额";
                }else if(awards[i].sendType==2){
                    //awards[i].sendType="送优惠券";
                    awards[i].awardName=awards[i].awardCoupon.title;
                    awardName="优惠活动";
                }
                awardDiv+="<div class='shelf-mat-title'>"+(awards[i].awardType==1?"一等奖":awards[i].awardType==2?"二等奖":awards[i].awardType==3?"三等奖":awards[i].awardType==4?"四等奖":"五等奖")+" "+
                    "</div><div class='shelf-mat-title'>"+awardName+"："+awards[i].awardName+" " +
                    "</div><div class='shelf-mat-title'>奖品数量："+awards[i].awardNum+" "+
                    "</div><br/>";
            }
            return awardDiv;
        },
        //停用抽奖
        stopPrize:function(){
            if(!this.isEditing){
                prize.stopById(window.did).then(lang.hitch(this,function(data){
                    if(data.data.ok){
                        this.isEditing = false;
                        alert("已经停用");
                        this.onAfterShow();
                    }else{
                        this.isEditing = true;
                        alert("不成功的停用，不知道为什么会有");
                    }
                })); 
            }
        }
    });
});