﻿// 变更人:徐阿雪
// 变更时间:2016/8/29
// 变更原因:抽奖活动编辑录入
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeCategory",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/prize/prize",
    "cq/biz/mk/discount",
    "cq/util/sys/date"
],function(declare,lang,array,View,EdgeToEdgeCategory,EdgeToEdgeList,ListItem,Deferred,domClass,domStyle,domConstruct,registry,_ViewMixin,prize,discount,date){
    //'1':'送积分''2':'送优惠券',3':'送赠品',
    //创建添加奖项的overlay
    var BoxEdit = declare("",[View,_ViewMixin],{
        isEditing : false,
        editStepDef:null,
        startEditStep:function(item){
            this.editStepDef = new Deferred();
            this.originItem = item;
            //每次点击进入弹框时候根据editStepDef里面的内容来显示隐藏积分、赠品，优惠券列表
            this.showList();
            this.setData(lang.clone(item));
            this.refreshData();
            return this.editStepDef;
        },
        indexElement:function(){
            this.inherited(arguments);
            //创建公共部分和积分、赠品，优惠券
            this.commonPartList();
            this.createIntegral();
            this.createCoupon();
            this.createGift();
            //第一次点击时根据editStepDef里面是否有内容的显示情况
            this.showList();
            //创建确定取消底部按钮
            this.commonPart();
        },
        // 显示隐藏list的切换，显示隐藏积分、赠品，优惠券列表
        showList:function(){
            //根据已有数据显示隐藏列表框
            if(this.originItem&&this.gift&&this.coupon&&this.integral){//this.originItem&&this.gift&&this.coupon&&this.integral
                this.hideShowList(this.originItem.sendType);
            }
        },
        //显示隐藏积分金额、优惠活动、活动名称的切换控制
        //默认显示赠品
        hideShowList:function(sendType){
            if(sendType==1){
                domClass.add(this.gift.domNode,"none");
                domClass.add(this.coupon.domNode,"none");
                domClass.remove(this.integral.domNode,"none");
            }else if(sendType==2){
                domClass.add(this.gift.domNode,"none");
                domClass.add(this.integral.domNode,"none");
                domClass.remove(this.coupon.domNode,"none");
            }else {
                domClass.add(this.integral.domNode,"none");
                domClass.add(this.coupon.domNode,"none");
                domClass.remove(this.gift.domNode,"none");
            }
        },
        //选择积分的时候创建积分列表integral
        createIntegral:function(){
            this.integral=this.addLists({
                isEdge:true,
                lists:[{
                    label:"积分金额",
                    edit:{
                        type:"text",
                        field:"awardAmount"
                    }
                }]
            });
        },
        //选择赠品时候创建赠品列表gift
        createGift:function(){
            this.gift=this.addLists({
                isEdge:true,
                className:"gift",
                lists:[{
                    label:"奖品名称",
                    edit:{
                        type:"text",
                        field:"awardName",
                    }
                }]
            });
        },
        //选择优惠券时显示优惠券列表Coupon
        createCoupon:function(){
            this.coupon=this.addLists({
                isEdge:true,
                lists:[{
                    label:"优惠活动",
                    edit:{
                        type:"ref",
                        field:"awardCoupon",
                        params:{
                            target:discount.loadAvailableByUserSelf(),
                            query:{ 
                            },
                            searchField:"title",
                            labelField:"title"
                        }
                    }
                }]
            });
        },
        //公共部分
        commonPart:function(){
            this.addColumns({
                isFooter:true,
                columns : [{
                    label: "确认",
                    onClick:this.onEditStepFinished,
                    className:"footer-tab-highlight"
                },{
                    label: "取消",
                    onClick:this.onEditStepCanceled,
                    className:"footer-tab-dark"
                }]
            });
        },
        //公共列表部分
        commonPartList:function(){
            this.commonPartList=this.addLists({
                isEdge:true,
                lists:[{
                    label:"奖品等级",
                    edit:{
                        type:"options",
                        field:"awardType",
                        options:{
                            '1':'一等奖',
                            '2':'二等奖',
                            '3':'三等奖',
                            '4':'四等奖',
                            '5':'五等奖',
                        }
                    }
                },{
                    label:"奖品类型",
                    edit:{
                        type:"options",
                        field:"sendType",
                        placeHolder : '送积分',
                        options:{
                            '1':'送积分',
                            '2':'送优惠券',
                            '3':'送赠品',
                        }
                    }
                },{
                    label:"奖品数量",
                    edit:{
                        type:"text",
                        field:"awardNum"
                    }
                }]
            });
        },
        // 保存 取消事件
        onEditStepFinished:function(){
            if(!this.isEditing){
                this.editStepDef.resolve(this.getData());
            }
        },
        onEditStepCanceled:function(){
            this.editStepDef.resolve(this.originItem);
        },
        //选择奖品类型监听改变，显示隐藏对应的列表
        onDataChanged: function(field, oldValue,newValue) {
            var mm=this.getData();
            if(field==="sendType"){
                this.hideShowList(newValue);
            }else if(field==="awardType"){
                //控制一等奖二等奖必须有先后顺序
                var m=this.getData();
                //有aType就做出从小到大的限制，没有的话就做出提示不允许改变已经保存了的等级
                var limitType,prompt="请设置";
                if(m.aType==0){
                    //处理第一次选中一等奖
                    if(m.awardType==1){
                        this.isEditing = false;
                        limitType = m.aType+1;//originItem
                    }else{
                        limitType=1;
                    }
                    this.alertMsg({awardType:m.awardType,limitType:limitType,prompt:prompt});
                }else{
                    //如果是点击listitem节点进来，就不允许改变，如果改变给出提示，不可保存
                    if(!m.aType){
                        if(m.awardType!=this.originItem.awardType){
                            prompt="不允许更改，请设置";
                            limitType=this.originItem.awardType
                        }else{
                            limitType=m.awardType;
                            this.isEditing = false;
                        }
                        this.alertMsg({awardType:m.awardType,limitType:limitType,prompt:prompt});
                    }else if(m.aType){
                        //如果是新增进来的话aType就存在，就要控制逐步增长，如果不满足就不允许保存
                        if(m.awardType&&m.awardType==m.aType+1){
                            limitType = m.awardType;
                            this.isEditing = false;
                        }else{
                            limitType = m.aType+1;
                        }
                        this.alertMsg({awardType:m.awardType,limitType:limitType,prompt:prompt});
                    }
                }    
            }
        },
        //弹出提示
        alertMsg:function(data){
            if(data.awardType!=data.limitType){
                //this.isEditing = true;
                alert(data.prompt+(data.limitType==1?"一等奖":data.limitType==2?"二等奖":data.limitType==3?"三等奖":data.limitType==4?"四等奖":"五等奖"));
                this.isEditing = true;
                return;
            }
        }
    });
    return declare("widgets.mobile.PrizeEdit",[View,_ViewMixin],{
        isEditing : false,
        onFirstShow:function(){
            //头部
            var option = {
                isHeader : true,
                left :{
                    iconButton : " ",
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        history.back();
                    }
                },
                title : "新增抽奖",
                right : {
                    iconButton : " ",
                    onClick : this.onSavePrize,
                    label : "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge:true,
                lists:[{
                    label:"活动名称",
                    noArrow : false,
                    edit :{
                        type:"text",
                        field:"prizeName"
                    }
                },{
                    label:"中奖类型",
                    noArrow : false,
                    edit:{
                        type:"options",
                        field:"luckType",
                        options:{
                            '1':'随机中奖',
                            '2':'先到先得'
                        }
                    }
                },{
                    label:"最大中奖数量",
                    noArrow : false,
                    edit :{
                        type:"text",
                        placeHolder : '0',
                        field:"maxLucky"
                    }
                },{
                    label:"开始时间",
                    noArrow:false,
                    moveTo:"#",
                    edit : {
                        type:"dateMin",
                        field:"startTime"
                    }
                },{
                    label:"结束时间",
                    noArrow:false,
                    moveTo:"#",
                    edit : {
                        type:"dateMin",
                        field:"endTime"
                    }
                },{
                    label:"活动说明信息",
                    noArrow : false,
                    edit :{
                        type:"text",
                        field:"content"
                    }
                },{
                    label:"消耗金额",
                    noArrow : false,
                    edit :{
                        type:"text",
                        field:"price"
                    }
                },{
                    label:"参与次数",
                    noArrow : false,
                    edit :{
                        type:"text",
                        field:"involvedNum"
                    }
                },{
                    label:"未中奖的提示说明",
                    noArrow : false,
                    edit :{
                        type:"text",
                        field:"remark"
                    }
                }]
            };
            this.addLists(option);
            option = {
                columns:[{
                    label:'新增奖项',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:lang.hitch(this,function(){
                        var m=this.getData();
                        m.awards=array.map(this.stepList.getChildren(),function(item){
                            return item.params;
                        });
                        if(m.awards.length>=5){
                            alert("最高只能是五等奖");
                            return;
                        }else{
                            //控制一等奖二等奖必须有先后顺序
                            var item =this.getStepItemByData({aType:m.awards.length});
                            this.stepList.addChild(item);
                            this.onStepItemClick({target:item.labelNode}); 
                        }
                    })
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
            this.addColumns(option);
            //抽奖提示
            var stepListTitle=new EdgeToEdgeCategory({
                label:"所有抽奖"
            });
            stepListTitle.placeAt(this.centerPanel.containerNode,"last");
            //添加奖项
            this.stepList=new EdgeToEdgeList();
            this.stepList.placeAt(this.centerPanel.containerNode,"last");
            //奖项点击事件
            this.stepList.on("click",lang.hitch(this,this.onStepItemClick));
            this.onAfterShow();
        },
        //依据数据项生成属性列表项
        getStepItemByData:function(item){
            return new ListItem(this.getItemStep(item));
        },
        //奖项列表的点击事件
        onStepItemClick:function(e){
            var dom = e.target,propItem = registry.getEnclosingWidget(e.target);
            while (dom && !domClass.contains(dom, "mblListItemIcon")) {
                dom = dom.parentNode;
            }
            if(dom){
                //删除
                propItem.destroyRecursive();
            }else{
                //编辑 
                this.startEditStep(propItem.params).then(lang.hitch(this,function(item){
                    propItem.set(this.getItemStep(item));
                    this.hideOverlay();
                }));
            }
        },
        //返回的格式
        getItemStep:function(item){
            if(item.awardNum){
                return {
                    icon:"mblDomButtonRedCircleMinus",
                    params:item,
                    label:"<div>"+(item.awardType==1?"一等奖":item.awardType==2?"二等奖":item.awardType==3?"三等奖":item.awardType==4?"四等奖":"五等奖")+","+(item.sendType==1?"积分金额:"+item.awardAmount:item.sendType==2?"优惠活动:"+item.awardCoupon.title:"奖品名称："+item.awardName)+",奖品数量:"+item.awardNum+"</div>",
                    moveTo:"#"
                };
            }else{
                return {
                    icon:"mblDomButtonRedCircleMinus",
                    params:item,
                    label:"<div>设置奖项信息</div>",
                    moveTo:"#"
                };
            }
        },
        //创建弹窗
        startEditStep:function(item){
            if(!this.stepEditDiv){
                this.stepEditDiv=domConstruct.create("div",{
                    style:"height:400px;text-align: left;"
                });
                this.stepEditItem = new BoxEdit();
                this.stepEditDiv.appendChild(this.stepEditItem.domNode);
                setTimeout(lang.hitch(this.stepEditItem,this.stepEditItem.startup),0);
            }
            this.showInOverlay(this.stepEditDiv);
            return this.stepEditItem.startEditStep(item);
        },
        //依据数据初始化界面显示
        initTempByData:function(data){
            data.qty = data.mId&&data.mId.qty||"";
            data.retailPrice = data.mId&&data.mId.retailPrice||"";
            //设置数据并刷新标准页面的显示
            this.setData(data);
            this.refreshData();
            //依据属性列表初始化属性列表的显示
            this.stepList.destroyDescendants();
            //初始化数据属性列表 
            data.awards = data.awards||[];
            //遍历所有属性，添加到列表中
            array.forEach(data.awards,function(item){
                this.stepList.addChild(this.getStepItemByData(item));
            },this);
            this.centerPanel.scrollTo({x:0,y:0});
        },
        onAfterShow:function(){
            if(!this.isEditing){
                this.isEditing=true;
                if(!window.did){
                    this.header.set("label","新增抽奖");
                    this.initTempByData({
                        isUse : true
                    });
                }else{
                    prize.loadById(window.did).then(lang.hitch(this,function(data){
                        if(data.data&&data.data.ok){
                            this.header.set("label",data.data.item.prizeName);
                            this.initTempByData(data.data.item);
                        }
                    }));
                }
            }
        },
        //保存抽奖活动
        onSavePrize:function(){
            if(this.isEditing){
                window.busy();
                var m= this.getData();
                m.awards=array.map(this.stepList.getChildren(),function(item){
                    return item.params;
                });
                var msg=this.verify(m);
                if(msg){
                    window.free();
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                //m.startTime=date.
                m.stopTime=m.endTime;
                prize.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok){
                        this.isEditing = false;
                        history.back();
                    }else{
                        if(data&&data.data&&data.data.message){
                            alert(data.data.message);
                        }else{
                            alert("保存失败");
                            this.isEditing = true;
                        }
                    }
                }));
            }
        },
        //发放数量totalNum  已使用数量usedNum
        verify : function(data){
            var msg="";
            var awards=data.awards;
            if(!data.prizeName){
                msg = "活动名称必须填写";
            }else if(!data.luckType){
                msg = "中奖类型未选择";
            }else if(data.luckType&&data.luckType<0||(data.luckType%1)!==0){
                msg = "中奖数只能为大于0的整数";
            }else if(!data.startTime){
                msg = "开始时间不能为空";
            }else if(data.startTime&&data.startTime<date.formatISODateMinutes(date.nowISOString())){
                msg = "开始时间必须大于当前时间";
            }else if(!data.endTime){
                msg = "结束时间不为空";
            }else if(data.endTime<data.startTime){
                msg = "结束时间大于开始时间";
            }else if(!awards.length){
                msg = "抽奖必须填写";
            }else if(awards.length){
                for(var i=0;i<awards.length;i++){
                    if(!awards[i].sendType){
                        msg = "奖品类型必须填写";
                    }else if(!awards[i].awardNum){
                        msg = "奖品数量不为空";
                    }else if(awards[i].awardNum&&awards[i].awardNum<0||(awards[i].awardNum%1)!==0){
                        msg = "奖品数量必须大于0 的整数";
                    }else if(awards[i].sendType==2&&awards[i].awardNum>awards[i].awardCoupon.totalNum-awards[i].awardCoupon.usedNum){
                        //奖品数量<=(抽奖活动的发放数量-已使用数量)
                        msg = awards[i].awardCoupon.title+"优惠券的奖品的数量不能大于"+(awards[i].awardCoupon.totalNum-awards[i].awardCoupon.usedNum)+"";
                    }else if(awards[i].sendType==1){
                        if(!awards[i].awardAmount){
                            msg = "积分金额必须填写";
                        }else if(awards[i].awardAmount&&!(/^\d+(?=\.{0,1}\d+$|$)/.test(awards[i].awardAmount))){
                            msg = "积分金额必须是大于0 的数字";
                        }
                    }else if(awards[i].sendType==2){
                        if(!awards[i].awardCoupon){
                            msg = "优惠活动必须填写";
                        }
                    }else if(awards[i].sendType==3){
                        if(!awards[i].awardName){
                            msg = "奖品名称必须填写";
                        }
                    }
                } 
            }
            return  msg;
        }
        
    });
});