﻿// 变更人:徐阿雪
// 变更时间:2016/8/29
// 变更原因:抽奖活动列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dojo/store/JsonRest",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "cq/biz/mk/prize/prize"
],function(declare,lang,query,EdgeToEdgeStoreList,View,JsonRest,registry,_ViewMixin,date,prize){
    return declare("widgets.mobile.PrizeList",[View,_ViewMixin],{
        start:0,
        pageSize:20,
        params:null,
        onFirstShow:function(){
            //添加 头部
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        this.params.search = "";
                        history.back();
                    }
                },
                title : "抽奖活动"
            };
            this.addHeader(option);
            // 添加搜索框 按title搜索
            option = {
                isHeader: true,
                placeHolder:"请输入要查询条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.params.search = evt.target.value;
                        this.onLoadPrize();
                        evt.target.value = "";
                    }
                })
            };
            this.searchBox = this.addTextBox(option);
            option = {
                columns:[{
                    label:'新增抽奖',
                    icon:'images/icon/addnews.png',
                    iconClass:'footer-tab-img',
                    onClick:lang.hitch(this,function(){
                        window.moveToView("prizeEdit");
                    })
                }],
                valueClass:'font-size3',
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
            this.addColumns(option);
            this.onCreatList();
            this.onAfterShow();
        },
        //创建列表
        onCreatList:function(){
            this.prizeList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                //className:""
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        var startTime = date.formatISODateMinutes(data[i].startTime);
                        var endTime = date.formatISODateMinutes(data[i].endTime);
                        data[i]._label="<div class='shelf-mat-title'><span style='width:40%'>"+data[i].prizeName+"</span><span  style='color:#00F;float:right'>"+status+"</span>"+
                                "</div><div class='shelf-mat-title'><span>开始时间："+startTime+"</span>"+
                                "</div><div class='shelf-mat-title'><span>截止时间："+endTime+"</span>"+
                                "</div>";
                    }
                    this.prizeList.generateList(data);
                    this.busy = false;
                }),
                itemMap:{
                    _label:"label"
                }
            });
            this.prizeList.placeAt(this.centerPanel.containerNode,"last");
            //列表的点击事件
            this.prizeList.on("click",lang.hitch(this,this.onClickList));
            //添加滚动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        onAfterShow:function(){
            if(!this.isEditing){
                this.onLoadPrize();
            }
        },
        //加载数据
        onLoadPrize:function(){
            this.start = 0;
            this.prizeList.destroyDescendants();
            if(this.store){
                this.busy = true;
                var queryResult= this.prizeList.setQuery(this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                //如果没有store就创建数据源
                this.store = new JsonRest({target:prize.getLoadUrl()});
                this.busy=true;
                var queryResult =this.prizeList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        //加载更多
        onLoadMore:function(e){
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.prizeList.setQuery(this.prizeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        //点击事件
        onClickList:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")return;
            var dom = evt.target;
            var _id = li.params._id;
            window.moveToView("prizeDetail",_id);
        },
    });
});