define([	
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dojo/_base/xhr",
	"dijit/registry",
	"dojo/_base/Deferred",
	"dojox/mobile/ListItem",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",			
	"dojo/store/JsonRest",
	"cq/biz/mk/qrCode",
	"cq/biz/user/user",
	"dijit/focus"
],function(declare,lang,array,View,_ViewMixin,xhr,registry,Deferred, ListItem,EdgeToEdgeStoreList,on,when,JsonRest,qrCode,user,focusUtil){
	return declare("whz.view.QrCode",[View,_ViewMixin],{
		start:0,
		params:null,	
		url:"",
        indexElement : function() {
			this.codeListScroll = this.centerPanel;
        },
		
		onAfterShow:function(){
			this.setQuery(this.storeList.get("query"), {
				start: 0,
				count: 10
			});
		},
		onCreatList: function(){
			this.storeList=new EdgeToEdgeStoreList({
				append: true, 
				constraint: false, 
				query:{
				}, 
				class:"icon-list-item",
				variableHeight:true,
				//获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){					
					for(var i=0;i<data.length;i++){
						//data[i]._label="<img class='edit-qrimg' src='"+data[i].imgUrl+"' />",
						//data[i].rightText="<span class='edit-userName'>"+data[i].userId+"</span>",
						//data[i].variableHeight=true
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),				
				itemMap:{sceneId:"rightText", imgUrl:"icon"}
			});
			this.params={};
			this.store = new JsonRest({target:qrCode.loadByShopId()});
			// 将数据源赋值给storeList	
			this.storeList.setStore(this.store,this.params);
			this.storeList.placeAt(this.codeListScroll.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.codeListScroll,"afterscroll",lang.hitch(this,this.onLoadMore));
		},
        onFirstShow : function() {
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						window.moveToView("home");
					}
				},
				title:"二维码"
			};
			this.addHeader(option);
			option = {
				columns:[{
					label:'添加二维码',
					icon:'images/icon/crmicon.png',
					iconClass:'width-16',
					onClick:function(){
						window.moveToView("qrCodeDetail");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
			this.onCreatList();
        },		
		onClickList:function(evt){
			// 得到点击的ListItem
			/* var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _tsId = li.tsId;
			window.moveToView("qrCodeDetail",_tsId); */
			
		},
		setQuery:function(query){		
			this.start = 0;
			this.end = -1;		
			this.storeList.destroyDescendants();
			this.storeList.setQuery(query,{
				start: this.start,
				count: 10
			});
			this.codeListScroll.resize();
		},
		onLoadMore:function(evt){												
			if(this.busy||(0<this.end&&(this.start+10-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"),{
						start: this.start,
						count: 10
					}), lang.hitch(this,function(){
						this.codeListScroll.resize();
					}));						
				}), 1000);
			}
		}
      });
});