﻿// 变更人:徐阿雪
// 变更时间:2016/8/25
// 变更原因:注册送
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/query",
    "dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/policy/regist",
    "cq/biz/mk/prize/prize",
    "cq/util/sys/date"
],function(declare,lang,query,domClass,View,_ViewMixin,regist,prize,date){
    return declare("widgets.mobile.RegisterGift",[View,_ViewMixin],{
        isEditing : false,
        onFirstShow:function(){
            //添加 头部
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        //this.params.state = "";
                        history.back();
                    }
                },
                title : "注册送好礼",//title : window.did ? "商品" : "添加商品",
                right : {
                    iconButton : ' ',
                    onClick : this.onSaveStore,
                    label : "完成"
                }
            };
            this.addHeader(option);
            option ={
                isEdge:true,
                lists:[{
                    label:"标题",
                    noArrow : false,
                    imgSize:{width:900,height:500},
                    edit :{
                        type:"text",
                        field:"title"
                    }
                },{
                    label:"积分数量",
                    noArrow:true,
                    edit : {
                        type:"text",
                        placeHolder : '0',
                        field:"amount"
                    }
                },{
                    label:"抽奖活动",
                    noArrow:true,
                    edit: {
                        type: "ref",
                        field: "prizeId",
                        params: {
                            target: prize.getLoadUrl(),
                            query: {
                                isUse:true,
                                state:2
                            },
                            searchField: "prizeName",
                            labelField: "prizeName"
                        }
                    }
                },{
                    label:"赠送数量",
                    noArrow:true,
                    edit : {
                        type:"text",
                        placeHolder : '0',
                        field:"prizeQty"
                    }
                },{
                    label:"开始时间",
                    noArrow:false,
                    moveTo:"#",
                    edit : {
                        type:"dateMin",
                        field:"startTime"
                    }
                },{
                    label:"结束时间",
                    noArrow:false,
                    moveTo:"#",
                    edit : {
                        type:"dateMin",
                        field:"endTime"
                    }
                },{
                    label:"备注",
                    noArrow:true,
                    edit : {
                        type:"textarea",
                        field:"remark"
                    }
                }]
            };
            this.addLists(option);
            this.onAfterShow();
        },
        //保存注册活动
        onSaveStore:function(){
            //regist.
            if(this.isEditing){
                window.busy();
                var m = this.getData();
                m.amount=m.amount?m.amount:0;
                m.prizeQty=m.prizeQty?m.prizeQty:0;
                m.isUse = m.isUse?m.isUse:true;
                m.stopTime = m.stopTime?m.stopTime:m.endTime;
                var msg = this.verify(m);
                if(msg){
                    window.free();
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                if(m.data){
                    m._id=m.data.item._id;
                }
                regist.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok){
                        this.isEditing = false;
                        history.back();
                    }else{
                        if(data&&data.data&&data.data.message){
                            alert(data.data.message);
                        }else{
                            alert("保存失败");
                            this.isEditing = true;
                        }
                    }
                }));
            }
        },
        onAfterShow:function(){
            if(!this.isEditing){
                this.isEditing=true;
                if(!window.did){
                    this.header.set("label","注册送积分");
                    this.initDate({isUse:true});
                }else{
                    regist.loadById(window.did).then(lang.hitch(this,function(data){
                        if(data.data&&data.data.ok){
                            this.header.set("label",data.data.item.title);
                            this.initDate(data);
                        }
                    }));
                }
            }
        },
        //刷新列表
        initDate:function(data){
            if(data&&data.data&&data.data.item){
                data.title=data.data.item.title;
                data.amount = data.data.item.amount;
                data.prizeQty = data.data.item.prizeQty;
                data.prizeId = data.data.item.prizeId;
                data.startTime = data.data.item.startTime;
                data.endTime = data.data.item.endTime;
                data.remark = data.data.item.remark;
            }
            this.setData(data);
            this.refreshData();
        },
        //检查合法性
        verify:function(data){
            var msg="";
            //
            if(!data.title){
                msg = "标题不能为空";
            }else if(data.amount&&!(/^\d+(?=\.{0,1}\d+$|$)/.test(data.amount))){//
                //积分数量为小数，大于等于0，默认0
                msg = "积分数量必须为大于等于0的小数";
            }else if(date.prizeId&&data.prizeQty<0||(data.prizeQty%1)!==0){
                msg = "赠送数量必须大于0";
            }else if(!data.startTime){
                msg = "开始时间不能为空";
            }else if(data.startTime&&data.startTime<date.formatISODateMinutes(date.nowISOString())){
                msg = "开始时间必须大于当前时间";
            }else if(!data.endTime){
                msg = "结束时间不为空";
            }else if(data.endTime<data.startTime){
                msg = "结束时间大于开始时间";
            }
            return msg;
        }
    });
});