﻿// 变更人:徐阿雪
// 变更时间:2016/8/25
// 变更原因:注册送
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/query",
    "dojo/dom-class",
    "dojo/store/JsonRest",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/policy/regist",
    "cq/util/sys/date"
],function(declare,lang,query,domClass,JsonRest,EdgeToEdgeStoreList,View,registry,_ViewMixin,regist,date){
    return declare("widgets.mobile.RegisterGiftList",[View,_ViewMixin],{
        start:0,
        pageSize:20,
        params:null,
        onFirstShow:function(){
            //添加 头部
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        //this.params.state = 0;
                        history.back();
                    }
                },
                title : "注册送"
            };
            this.addHeader(option);
            // 添加搜索框 按title搜索
            option = {
                isHeader: true,
                placeHolder:"请输入要查询条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.params.search = evt.target.value;
                        this.loadRegisterGift();
                        evt.target.value = "";
                    }
                })
            };
            this.searchBox = this.addTextBox(option);
            // 创建列表
            option = {
                isHeader:true,
                columns : [{
                        label : '全部',
                        onClick : function(e){
                            this.params.isUse="";
                            this.params.search = '';
                            this.params.state = 0;
                            this.changeOnList(e);
                        }
                    }, {
                        label : '未开始',
                        onClick : function(e){
                            this.params.isUse=true;
                            this.params.search = '';
                            this.params.state = 1;
                            this.changeOnList(e);
                        }
                    }, {
                        label : '进行中',
                        onClick : function(e){
                            this.params.isUse=true;
                            this.params.search = '';
                            this.params.state = 2;
                            this.changeOnList(e);
                        }
                    },{
                        label : '已失效',
                        onClick : function(e){
                            this.params.isUse=false;
                            this.params.search = '';
                            this.params.state = 3;
                            this.changeOnList(e);
                        }
                    }],
                labelClass : 'font-size1 tab-selector'
            };
            this.addColumns(option);
            option = {
                columns :[{
                    label : "新增注册送礼",
                    onClick:function(){
						window.moveToView("registerGift");
					}
                }],
                labelClass : 'font-size1',
                className : 'padding-top-bottom16',
                isFooter : true
            };
            this.addColumns(option);
            this.onCreatList();
            //默认选中第一个
            this.params.state = 0;
            //按结束时间降序排序
            this.params.orderBy = "-endTime";
            this.onAfterShow();
        },
        
        onAfterShow:function(){
            //默认选中全部
            this.changeOnList({target:query(".tab-selector",this.domNode)[this.params.state]});
        },
        //选中样式
        changeOnList:function(e){
            //清空
            this.clearSelected();
            //事件发生触发添加selected样式
            domClass.add(e.target, "selected");
            this.loadRegisterGift();
        },
        //清空所有状态
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                //移除每个节点的selected类
                domClass.remove(items[i], "selected");
            }
        },
        //创建列表
        onCreatList:function(){
            this.registerGiftList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                //className:""
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    //已开始的不能编辑，需要修改时，停用，然后新增  
                    for(var i=0;i<data.length;i++){
                        var status = "停用",classname="nothing";
                        if(data[i].isUse === false){
                            if(data[i].stopTime!==data[i].endTime){
                                status = "已停用";
                            }else{
                                status = "已过期";
                            }
                        }else if(data[i].isUse === true&&data[i].startTime>date.nowISOString()){
                            status = "未开始";
                        }
                        if(data[i].isUse === true&&data[i].startTime<date.nowISOString()){
                            classname = "cancel";
                        }
                        var startTime = date.formatISODateMinutes(data[i].startTime);
                        var endTime = date.formatISODateMinutes(data[i].endTime);
                        data[i]._label="<div class='shelf-mat-title'><span style='width:40%'>"+data[i].title+"</span><span class='"+classname+"' style='color:#00F;float:right'>"+status+"</span>"+
                                "</div><div class='shelf-mat-title'>参加活动："+(data[i].prizeId?data[i].prizeId.prizeName:"暂时未参加活动")+" " +
                                "</div><div class='shelf-mat-title'>积分数量："+data[i].amount+" " +
                                "</div><div class='shelf-mat-title'>赠送数量："+data[i].prizeQty+" "+
                                "</div><div class='shelf-mat-title'><span>开始时间："+startTime+"</span>"+
                                "</div><div class='shelf-mat-title'><span>截止时间："+endTime+"</span>"+
                                "</div><div class='shelf-mat-title'><span>备注："+(data[i].remark?data[i].remark:"暂无备注")+"</span>" +
                                "</div>"
                    }
                    this.registerGiftList.generateList(data);
                    this.busy = false;
                }),
                itemMap:{
                    _label:"label"
                }
            });
            this.registerGiftList.placeAt(this.centerPanel.containerNode,"last");
            //列表的点击事件
            this.registerGiftList.on("click",lang.hitch(this,this.onClickList));
            //添加滚动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        //加载数据
        loadRegisterGift:function(){
            this.start = 0;
            this.registerGiftList.destroyDescendants();
            if(this.store){
                this.busy = true;
                var queryResult= this.registerGiftList.setQuery(this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                //如果没有store就创建数据源
                this.store = new JsonRest({target:regist.getLoadUrl()});
                this.busy=true;
                var queryResult =this.registerGiftList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        //检查是否开始返回布尔值
        isStart:function(startTime){
            var m = false;
            //data[i].sDate<date.nowISOString()
            //判断是否在活动中
            if(startTime<date.nowISOString()){
                var m = true;
            }
            return m;
        },
        //点击事件
        onClickList:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")return;
            var dom = evt.target;
            var _id = li.params._id;
            //已开始的不能编辑，需要修改时，停用，然后新增isUse
            if(dom&&domClass.contains(dom,"cancel")){
                var m={};
                m._id = _id;
                m.isUse = false;
                m.stopTime = date.nowISOString();
                regist.save(m).then(lang.hitch(this,function(data){
                    window.free();
                    if(data.data.ok){
                        alert("取消成功");
                        this.loadRegisterGift();
                    }else{
                        if(data&&data.data&&data.data.message){
                            alert(data.data.message);
                            this.isEditing = true;
                        }else{
                            alert("保存失败");
                            this.isEditing = true;
                        }
                    }
                }));
            }else if(this.isStart(li.params.startTime)||li.params.isUse === false){
                alert("不允许编辑");
                this.isEditing = true;
            }else{
                window.moveToView("registerGift",_id);
            }
        },
        //加载更多
        onLoadMore:function(e){
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.registerGiftList.setQuery(this.registerGiftList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
    });
});