//变更人:肖芳圆
//变更时间:2016/5/17
//变更原因:代码规范,文件迁移
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/DeferredList",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dijit/registry",
	"dojox/mobile/ListItem",
	"dojox/mobile/EdgeToEdgeList",
	"cq/biz/article/section",
	"dojo/dom-class",
	"dojo/dom-attr",
],function(declare,lang,DeferredList,View,_ViewMixin, registry, ListItem,
	EdgeToEdgeList,section,domClass,domAttr){
	//微信栏目管理对象
	return declare("cq.ui.b.a.Section",[View,_ViewMixin],{
		//解析数据为微信栏目需要的格式
		parseWxScetion:function (item) {
			var wxItem = {};
			wxItem.name = item.title;
			switch (parseInt(item.type)) {
				case 1:
					var subItems=[];
					for (var i = 0; i < item.subs.length; i++) {
						subItems.push(this.parseWxScetion(item.subs[i]));
					}
					wxItem.sub_button=subItems;
					break;
				case 2:
					wxItem.type = "click";
					wxItem.key = "GN" + item._id;
					break;
				case 3:
					wxItem.type = "click";
					wxItem.key = "GM" + item.groupId;
					break;
				case 4:
					wxItem.type = "view";
					wxItem.url = item.targetPath;
					break;
				case 5:
                    wxItem.type = "click";
                    wxItem.key = "R" + item.arId;
                    break;
                case 6:
                    wxItem.type = "click";
                    wxItem.key = "CS" + item.svcType;
                    break;
				default:
					break;
			}
			return wxItem;
		},
		//发布微信栏目
		onPublishSection:function(){
			//加载栏目数据
			section.load().then(lang.hitch(this,function (data) {
				var parseData = this.parseData(data.data.items);
				var items=[];
				for (var i = 0; i < parseData.length; i++) {
					var item={};
					item.name=parseData[i].title;
					items.push(this.parseWxScetion(parseData[i]));
				}
				var topLength= items.length;
                if (topLength && topLength > 3) {
                    alert("“一级栏目”与“上级栏目”为空的栏目总共不能超过3个，请重新设置！");
                    return false;
                } else if (topLength == 0) { // 一级栏目不能为0个
                    alert("没有一级栏目，请设置！");
                    return false;
                }
                while (topLength--) {
                    if (items[topLength].sub_button) {
                        if (items[topLength].sub_button.length > 5) {
                            alert("一级栏目‘" + items[topLength].name + "’下的二级栏目不能超过5个，请重新设置！");
                            return false;
                        }
                        if (items[topLength].sub_button.length == 0) {
                            alert("一级栏目‘" + items[topLength].name + "’下没有二级栏目，请添加！");
                            return false;
                        }
                    }
                }
				section.publish(items).then(function (data) {
					if(data.data.ok===1){
						alert("发布成功!");
					}else {
						alert("发布失败"+data.data.msg);
					}
				});
			}));
				//遍历所有数据组装为微信需要的格式
					//栏目类型
					//栏目内容eventKey，资讯、品类、会员服务类型的栏目的参考文档 192.168.0.25/www/yyxm_doc/货架-栏目.txt
				//遍历所有栏目检查合法性：
					//没有上级的栏目不得超过三个
					//一级栏目均不能有上级，必须有下级，下级数量不得大于五
					//类型为链接的栏目的连接地址必须合法
					//栏目的标题不能为空，长度不得大于十五
				//项服务器发更新微信栏目的请求
					//提示执行结果
		},
		//栏目移动type=0上移type=1下移
		moveSectionItem:function(item,type){
			//通过list的getChildren方法，找到所有孩子，找到当前对象的前一个
			var lists=this.edgeList.getChildren();
			var changeItem=null;
			for (var i = 0; i < lists.length; i++) {
				if(lists[i]===item){
					if(type===0){
						//上移,找到上面upSection相同的栏目
						for (var j = i-1; j > -1; j--) {
							if(lists[j].params.upSection===item.params.upSection){
								changeItem=lists[j];
								//找到一个符合条件的就退出循环
								break;
							}
						}
					}else{
						//下移,找到下方upSection相同的栏目
						for (var j = i+1; j < lists.length; j++) {
							if(lists[j].params.upSection===item.params.upSection){
								changeItem=lists[j];
								break;
							}
						}
					}
				}
			}
			//依据两个item找到对应的section
			var param=item.params;
			delete param.subs;
			var changeParam=changeItem.params;
			delete changeParam.subs;
			var temp=item.params.sOrder;
			//交换对应section的序号
			param.sOrder=changeParam.sOrder;
			changeParam.sOrder=temp;
			//保存并刷新section列表
			var defList = new DeferredList([
				section.save(param),
				section.save(changeParam)
			]);
			defList.then(lang.hitch(this,function(){
				this.onAfterShow();
			}));
		},
		//添加二级栏目,参数为上级栏目对象
		addSectionItem:function(item){
			//新增二级
			window.moveToView("sectionDetail","upId_"+item.params._id+"_maxOrder_"+this.maxOrder);
		},
		//显示编辑页面
		showEditItem:function (id) {
			if(id){
				//编辑
				window.moveToView("sectionDetail","id_"+id+"_maxOrder");
			}
			else {
				//新增
				if(this.topSectionQty>=3){
					alert("一级栏目不能超过三个!");

				}else {
					window.moveToView("sectionDetail","add_"+"add"+"_maxOrder_"+this.maxOrder);
				}
			}
		},
		//删除指定栏目列表项
		deleteSectionItem:function(item){
			//依据item找到对应的section信息
			var param=item.get("params");
			var ids=[];
			var msg="";
			//依据_id删除section数据
			ids.push(param._id);
			msg+="栏目:"+param.title;
			//找到所有的下级section，并删除
			if(param.subs.length>0){
				msg += "和"+param.title+"的二级栏目:"
				for (var i = 0; i < param.subs.length; i++) {
					ids.push(param.subs[i]._id);
					msg += param.subs[i].title+'、';
				}
			}else {
				msg += "、";
			}
			//删除最后一个顿号
			msg = msg.substr(0,msg.length-1);
			msg +=" 将被删除!";
			if(!confirm(msg)){
				return false;
			};
			//!循环调用了xhr请求
			var defs=[];
			for (var i = 0; i < ids.length; i++) {
				defs.push(section.delete(ids[i]));
			}
			//执行刷新操作
			var defList = new DeferredList(defs);
			defList.then(lang.hitch(this,function(){
				this.onAfterShow();
			}));
		},
		//list中节点被点击
		onListClick:function(e){
			//找到对应的ListItem
			//找到listItem根节点的直接节点
			var dom = e.target;
			if (dom) {
				var item=registry.getEnclosingWidget(dom)
				//若为删除图标
				if(domClass.contains(dom,"mblDomButtonGrayMinus")||
				domClass.contains(dom.parentNode,"mblDomButtonGrayMinus")){
					//找到对应ListItem，执行删除操作
					this.deleteSectionItem(item);
				}
				//若为添加按钮
				else if (domClass.contains(dom,"mblDomButtonGrayPlus")||
				domClass.contains(dom.parentNode,"mblDomButtonGrayPlus")||
				domClass.contains(dom.parentNode.parentNode,"mblDomButtonGrayPlus")) {
					//找到对应ListItem，执行添加二级栏目操作
					this.addSectionItem(item);
				}
				//若为上移按钮
				else if (domClass.contains(dom,"section_moveup")) {
					//找到对应ListItem，执行上移操作
					this.moveSectionItem(item,0);
				}
				else if (domClass.contains(dom,"section_movedown")) {
					//若为下移按钮，执行下移操作
					this.moveSectionItem(item,1);
				}else {
					//否则，编辑对应栏目
					this.showEditItem(item.params._id);
				}
			}
		},
		//添加栏目进入列表
		addSectionsToList:function(sections){
			var listItem=null;
			//遍历所有栏目
			for (var i = 0; i < sections.length; i++) {
				listItem=new ListItem({
					//设置左侧图标为删除按钮，标签为栏目标题
					icon:"mblDomButtonGrayMinus",
					label:sections[i].title,
					//若有上级，增加标签的缩进
					class:sections[i].upSection?"section_subsection":"",
					params:sections[i]
				});
				//若没有上级且下级数量不足五个，且类型为一级栏目，增加加号按钮
				if(sections[i].type==1&&sections[i].subs.length<5){
					listItem.set("rightIcon","mblDomButtonGrayPlus");
				}
				var rightText="";
				//若不是第一个，增加上移移按钮
				if(i!==0){
					rightText += "<span class='section_moveup'>上移</span>";
				}
				//若不是最后一个，增加下移按钮
				if(i!==sections.length-1){
					rightText += "<span class='section_movedown'>下移</span>";
				}
				if(rightText){
					listItem.set("rightText",rightText);
				}
				//添加到list中
				this.edgeList.addChild(listItem);
				//若有下级栏目
				if(sections[i].subs.length>0){
					//将下级栏目添加到列表中
					this.addSectionsToList(sections[i].subs);
				}
			}
		},
		//进入当前视图之后执行刷新操作
		onAfterShow:function(){
			//加载栏目数据
			section.load().then(lang.hitch(this,function(data){
				//销毁原有列表项
				this.edgeList.destroyDescendants();
				this.maxOrder=(data.data.items.length?data.data.items[data.data.items.length-1].sOrder||0:0)+1;
				//处理数据，建立数据的上下级关系
				var parseData = this.parseData(data.data.items);
				//对所有没有上级的栏目，添加栏目到栏目列表中
				this.addSectionsToList(parseData);
			}));
		},
		//功能：解析数据为一二级的格式,方便显示
		//输入：[{
		//	_id:,title:,type:,targetPath:
		//,...},...]
		//输出：[{
		//	_id:,title:,type:,targetPath:,
		//	subs:[{
		//		_id:,title:,type:,targetPath:,...
		//	},...]
		//,...},...]
		parseData:function (data) {
			var sections=[],subsections = {};
			for (var i = 0; i < data.length; i++) {
				data[i].subs = subsections[data[i]._id] = subsections[data[i]._id]||[];
				if(data[i].upSection){
					subsections[data[i].upSection] = subsections[data[i].upSection]||[];
					subsections[data[i].upSection].push(data[i]);
				}else{
					sections.push(data[i]);
				}
			}
			this.topSectionQty=sections.length;
			return sections;
		},
		//首次进入界面,初始化界面,绑定事件
		onFirstShow:function () {
			//添加顶部标题和返回按钮栏
			var option = {
                left:{
                    iconButton:' ',
                    arrow : "left",
                    label:"返回",
                    onClick:function(){
                        //返回主界面
                        history.back();
                    }
                },
                title:"微信菜单"
            };
			this.addHeader(option);
			//添加栏目列表
			this.edgeList=new EdgeToEdgeList({
				variableHeight:true,
				class:"section-list",
				editable:true
			});
			this.edgeList.placeAt(this.centerPanel.containerNode,"last");
			//侦听栏目列表根节点的onclick事件，调用this.onListClick
			this.edgeList.on("click",lang.hitch(this,this.onListClick));
			//添加底部 添加/刷新/发布按钮
			option = {
				columns:[{
					label:"添加",
					onClick:lang.hitch(this,function() {
						this.showEditItem();
					})
				},{
					label:"刷新",
					className:"footer-tab-dark",
					onClick:lang.hitch(this,this.onAfterShow)
				},{
					label:"发布",
					className:"footer-tab-highlight",
					onClick:lang.hitch(this,this.onPublishSection)
				}],
				labelClass:'font-size2',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
				//添加按钮点击之后调用天机一级栏目的函数
				//刷新按钮调用onAfterShow
				//发布按钮调用发布微信栏目的接口this.onPublishSection
			//执行刷新操作
			this.onAfterShow();
		}
	});
});
