//变更人:肖芳圆
//变更时间:2016/5/17
//变更原因:代码规范,文件迁移
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dojo/dom-class",
    "cq/biz/article/section",
    "cq/biz/mat/group",
    "cq/biz/article/autoReply"
    ],
function(declare, lang, array, View, _ViewMixin,
query, domClass, section, group, autoReply) {
    //微信栏目编辑对象
    return declare("cq.ui.b.a.SectionDetail", [View, _ViewMixin], {
        //页面的是否在编辑中
        isEditing: false,
        //首次进入界面时的初始化工作
        onFirstShow: function() {
            //顶部标题、返回和完成按钮
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "返回",
                    onClick: lang.hitch(this, function() {
                        this.isEditing = false;
                        history.back();
                    })
                },
                title: "微信栏目",
                right: {
                    iconButton: ' ',
                    onClick: this.onSaveStore,
                    label: "完成"
                }
            };
            this.addHeader(option);
            //侦听栏目类型变更事件——侦听自己的onDataChange方法，字段名为栏目类型
            //品类
            //自动回复
            //会员服务
            //...
            option = {
                isEdge: true,
                lists: [
                    {
                    label: '标题',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'title',
                        placeHolder: '必填'
                    }
                }, //列表选项——栏目类型
                {
                    label: '类型',
                    noArrow: true,
                    edit: {
                        type: 'options',
                        field: 'type',
                        moveTo: "#",
                        options: {
                            1: "一级栏目",
                            2: "资讯栏目",
                            3: "商品栏目",
                            4: "打开网页",
                            5: "自动回复",
                            6: "会员服务",
                            //7:"微信扫码"
                        }
                    }
                },
                    {
                    label: '编码',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'sCode',
                        placeHolder: '必填'
                    },
                    className: 'none' //隐藏本字段
                },
                    {
                    label: '序号',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'sOrder',
                        placeHolder: '必填'
                    },
                    className: 'none' //隐藏本字段
                }, //   {
                    //       label : "上级栏目",
                    //       moveTo : "#",
                    //       edit : {
                    //           type : 'ref', field : 'upSection', params : {
                    //               target:section.getSectionUrl(),
                    //               searchField:'title',
                    //               labelField:"title"
                    //           }
                    //       },
                    //       className : 'mblListItem none sectiondtl_item upSection'
                    //   },
                {
                    label: "品类",
                    moveTo: "#",
                    edit: {
                        type: 'ref',
                        field: 'groupId',
                        params: {
                            target: group.getGroupUrl(),
                            searchField: 'gName',
                            labelField: "gName"
                        }
                    },
                    className: 'mblListItem none sectiondtl_item groupId'
                },
                    {
                    label: '自动回复',
                    moveTo: '#',
                    edit: {
                        type: 'ref',
                        field: 'arId',
                        params: {
                            target: autoReply.loadByShopId(),
                            searchField: "keyword",
                            labelField: "keyword"
                        }
                    },
                    className: 'mblListItem none sectiondtl_item arId'
                },
                    {
                    label: '链接地址',
                    noArrow: true,
                    edit: {
                        type: 'text',
                        field: 'targetPath',
                        placeHolder: '必填'
                    },
                    className: 'mblListItem none sectiondtl_item targetPath'
                },
                    {
                    label: '服务类型',
                    noArrow: true,
                    edit: {
                        type: 'options',
                        field: 'svcType',
                        moveTo: "#",
                        options: {
                            1: "我的账户",
                            2: "我的订单",
                            3: "我的收入",
                            4: "我的二维码",
                            5: "附近商家"
                        }
                    },
                    className: 'mblListItem none sectiondtl_item svcType'
                },
                    ]
            };
            this.edgeList = this.addLists(option);
            //刷新数据显示
            this.onAfterShow();
        },
        //获取数据
        getData: function() {
            var data = lang.clone(this.inherited(arguments));
            if (data) {
                if (data.upSection && data.upSection._id) {
                    data.upSection = data.upSection._id;
                }
                if (data.groupId && data.groupId._id) {
                    data.groupId = data.groupId._id;
                }
                if (data.arId && data.arId._id) {
                    data.arId = data.arId._id;
                }
            }
            return data;
        },
        //刷新数据显示
        onAfterShow: function() {
            //若当前非编辑状态
            if (!this.isEditing) {
                //设置当前为编辑状态
                this.isEditing = true;
                var params = window.did.split('_');
                this.maxOrder = params[3] || '';
                //若window.did不为空
                if (params[0] !== "add") {
                    var id = params[1];
                    var type = params[0];
                    //若window.did为up_+sectionId
                    if (type === "upId") {
                        //添加二级栏目，初始化新增数据，栏目的上级栏目为sectionId
                        this.setData({
                            upSection: id,
                            type: 2
                        });
                        this.refreshData();
                        //调用刷新页面状态的函数：栏目类型会影响到栏目的当前状态
                        this.onSectionTypeChanged(this.getData().type);
                    } else {
                        //加载对应栏目并执行刷新操作
                        section.loadById(id).then(lang.hitch(this, function(data) {
                            this.setData(data && data.data && data.data.item || {});
                            this.refreshData();
                            //调用刷新页面状态的函数：栏目类型会影响到栏目的当前状态
                            this.onSectionTypeChanged(this.getData().type);
                        }));
                    }
                } else {
                    //否则添加一级栏目
                    //初始化新增数据，上级栏目为空
                    this.setData({
                        type: 1
                    });
                    this.refreshData();
                    //调用刷新页面状态的函数：栏目类型会影响到栏目的当前状态
                    this.onSectionTypeChanged(this.getData().type);
                }
            }
        },
        //数据变更是否合法的检查函数，当不合法时，返回false，可以阻止本次数据变更
        onDataChange: function(field, oldValue, newValue) {
            //若有上级栏目，栏目类型不能选择一级栏目
            if (field === "type") {
                if (newValue == "1" && this.getData().upSection) {
                    alert("本栏目有上级栏目,不能设置为一级栏目");
                    return false;
                } else if (oldValue == '1' && newValue != '1') {
                    alert('一级栏目,不能修改类型!');
                    return false;
                }
            }
        },
        //数据变更完成后,根据数据变更显示不同界面
        onDataChanged: function(field, oldValue, newValue) {
            if (field === "type") {
                if (newValue !== oldValue) {
                    this.onSectionTypeChanged(newValue);
                }
            }
        },
        //栏目类型发生变化的事件响应函数
        onSectionTypeChanged: function(type) {
            //获取所有需要控制的ListItem
            var Lists = query(".sectiondtl_item", this.edgeList.domNode);
            for (var i = 0; i < Lists.length; i++) {
                domClass.add(Lists[i], "none");
            }
            this.sectionType = type;
            if (type == 3) {
                domClass.remove(query(".sectiondtl_item.groupId", this.edgeList.domNode)[0], "none");
            } else if (type == 4) {
                domClass.remove(query(".sectiondtl_item.targetPath", this.edgeList.domNode)[0], "none");
            } else if (type == 5) {
                domClass.remove(query(".sectiondtl_item.arId", this.edgeList.domNode)[0], "none");
            } else if (type == 6) {
                domClass.remove(query(".sectiondtl_item.svcType", this.edgeList.domNode)[0], "none");
            }
        },
        //保存操作，参考商品的保存操作
        onSaveStore: function() {
            if (this.isEditing) {
                //离开页面修改"修改中的状态"
                this.isEditing = false;
                setTimeout(lang.hitch(this, function() {
                    var m = this.getData();
                    var msg = this.checkFiled(m);
                    if (msg) {
                        alert(msg);
                        this.isEditing = true;
                        return;
                    }
                    if (this.maxOrder) {
                        m.sOrder = this.maxOrder;
                    }
                    //console.log(m);
                    section.save(m).then(function(data) {
                        if (data.data.ok===1) {
                            window.moveToView("section");
                        }else {
                            alert("保存失败!");
                        }
                    });
                }), 0);
            }
        },
        //检查字段合法性
        checkFiled: function(data) {
            var msg = "";
            if (!data.title) {
                msg = "标题不能为空!";
            } else if (!data.type) {
                msg = "栏目类型没有选择!";
            }
            switch (parseInt(this.sectionType)) {
            case 3:
                if (!data.groupId) {
                    msg = "商品类型还没有选择!"
                }
                break;
            case 4:
                var webAddress = new RegExp("http");
                if (!data.targetPath) {
                    msg = "网址不能为空!";
                } else if (!webAddress.test(data.targetPath)) {
                    msg = "应该输入“http://www.cqthink.com”格式的网址!";
                }
                break;
            case 5:
                if (!data.arId) {
                    msg = "自动回复内容还没有选择!"
                }
                break;
            case 6:
                if (!data.svcType) {
                    msg = "服务类型还没有选择!"
                }
                break;
            default:

            }
            return msg;
        }
    });
});
