//变更人:干劲
//变更时间:20160910
//变更原因:商家消息列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/shopMsg",
    "dijit/_WidgetBase"
], function (declare, lang, domAttr, domClass, domConstruct, domStyle, query, on, when, JsonRest, registry, View, EdgeToEdgeStoreList, _ViewMixin, shopMsg,_WidgetBase) {
    return declare("whz.view.ShopMsgList", [View, _ViewMixin], {
        //筛选条件
        params : null,
        start : 0,
        pageSize:10,
        hideBottom : false,
        totalCount:0,
        onAfterShow : function () {
            //创建数据源
            if(!this.store){
                this.params = {
                };
				if(window.did == 1) this.params.msgType=1;
				if(window.did == 2) this.params.msgType=2;
                this.store = new JsonRest({
                    target : shopMsg.getLoadUrl()
                });
                var queryResult = this.storeList.setStore(this.store, this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                // 将数据源赋值给storeList
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                // 重置筛选
                //var condition = this.storeList.get("query");
                //condition.mName = "";
                //this.setQuery(condition);
				this.clearSelected();
				domClass.add(query(".tab-selector",this.conditMenus)[window.did?parseInt(window.did)-1:2],'selected');
                query(".selected",this.conditMenus)[0].click();
            }
        },
        //获取头部option的函数,可重载
        getHeadOption:function () {
            return {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        //window.moveToView("home");
                        history.back();
                    }
                },
                title : "商家消息"
            };
        },
        onFirstShow : function () {
            var option = this.getHeadOption();
            this.addHeader(option);
            option = {
                isHeader:true,
                placeHolder : "请输入要查询条件，按回车查询",
                class : "cqSearchBox",
                type : "search",
                onInput : lang.hitch(this, function (evt) {
                    if (evt.keyCode == 13) {
                        this.params.msgContent = evt.target.value;
                        this.setQuery(this.params);
                        this.params.mName = '';
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                isHeader:true,
                columns : [{
                        label : '上游',
                        onClick : this.onUpMsg
                    }, {
                        label : '下游',
                        onClick : this.onDownMsg
                    }, {
                        label : '全部',
                        onClick : this.onAllMsg
                    }
                    /*,{
                    label:'分类'
                    }*/
                ],
                labelClass : 'font-size1 tab-selector'
            };
            this.conditMenus = this.addColumns(option);
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    /*if(!data.length){
                        this.promptMessage();
                    }*/
                    for (var i = 0; i < data.length; i++) {
                        data[i]._label = "<div>"+(data[i].fromShopId && data[i].fromShopId.shopName)+
							"<span style='float:right;'>"+cq.util.sys.date.formatISODate(data[i].createAt)+"</span>"+
							"</div>"+"<div>"+data[i].msgContent+"</div>"+
							"<div><span class='is-read' style='float:right;'>"+(!data[i].isRead?"未读":"")+"</span></div>";
                        data[i].moveTo = "#";
                        data[i]._logo = (data[i].fromShopId && data[i].fromShopId.logo) ? data[i].fromShopId.logo : 'images/logo.png';
                        //data[i]._logo='images/nomat.png';
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                queryOptions : {
                    count : this.pageSize,
                    start : this.start
                },
                itemMap : {
                    _label : "label",
                    _logo : "icon",
                    moveTo : "moveTo"
                }
            });
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.storeList.placeAt(this.centerPanel.containerNode, "last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.onAfterShow();
        },
        onClickList : function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")
                return;
			if(!li.params.isRead){
				shopMsg.save({_id:li._id,isRead:true});
			}
			domClass.add(query('.is-read',li.labelNode)[0],'none');
			if(li.params.toView){
				window.moveToView(li.params.toView,li.params.toParam);
			}
        },
        // 提示信息
        promptMessage: function(){
            alert("没有查到内容");
        },
        onLoadMore : function (evt) {
            if(!this.busy&&evt.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载更多商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        //上游消息
        onUpMsg : function (evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.msgType = 1;
            this.setQuery(this.params);
        },
        //下游消息
        onDownMsg : function (evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params.msgType = 2;
            this.setQuery(this.params);
        },
        //全部
        onAllMsg : function (evt) {
            this.clearSelected();
            domClass.add(evt.target, "selected");
            this.params = {};
            this.setQuery(this.params);
        },
        setQuery : function (query) {
            this.start = 0;
            this.end = -1;
            this.totalCount = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});