define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/util/sys/date",
	"cq/ui/view/_ViewMixin",
	"dojo/_base/xhr",
	"dojo/query",
	"dijit/registry",
	"cq/biz/ts/stock_io",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",
	"dojo/store/JsonRest"
],function(declare,lang,View,EdgeToEdgeStoreList,date,_ViewMixin,xhr,query,registry,stock,EdgeToEdgeStoreList,on,when,JsonRest){
	return declare("whz.view.Stock",[View,_ViewMixin],{
		start:0,
		indexElement:function(){
            this.stockListScroll = this.centerPanel;
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() { window.moveToView("production"); }
				}, title:"存栏记录"};
			this.addHeader(option);
			option = {
				columns:[{
					icon:'images/icon/addRecord.png',
					iconClass:'width-16',
					label:'添加存栏记录',
					style:"height:50px;",
					onClick:function(){
						//window.did,类型
						window.moveToView("stockDetail",window.did);
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){
						var imdate = data[i].ioDate?date.formatISODate(data[i].ioDate):"";
						data[i]._label="<div class='webkit-list'>";
							data[i]._label+="<div class='mat-list-margin' style='width:50%;'>时间："+imdate+"</div>";
							data[i]._label+="<div class='item-list-right'>品种："+(data[i].matId?data[i].matId.mName:"未知")+"</div>";
						data[i]._label+="</div>";
						data[i]._label+="<div class='webkit-list'>";
							if(window.did==1){
								data[i]._label+="<div class='mat-list-margin' style='width:50%;'>增加数量："+data[i].inQty+"</div>";
							}else if(window.did==0){
								data[i]._label+="<div class='mat-list-margin' style='width:50%;'>减少数量："+data[i].outQty+"</div>";
							}
							data[i]._label+="<div class='item-list-right'>原因："+this.parseReason(data[i].reason)+"</div>";
						data[i]._label+="</div>";
						data[i].moveTo="#"
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions: {
					count: 10,
					start: this.start
					},
				itemMap:{_label:"label", moveTo:"moveTo"}
				});
			// 创建数据源
			this.params={ioType:window.did};
			this.store = new JsonRest({target:stock.load()});
			// 将数据源赋值给StoreList
			this.storeList.setStore(this.store,this.params);
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			this.storeList.placeAt(this.stockListScroll.containerNode,"last");
			on(this.stockListScroll,"afterscroll",lang.hitch(this,this.onLoadMore));
		},
		parseReason:function(reasonId){
			var reason="";
			switch(reasonId){
				case 1:{
					reason="繁殖"
					break;
				}
				case 2:{
					reason="购买"
					break;
				}
				case 3:{
					reason="出售"
					break;
				}
				case 4:{
					reason="自宰"
					break;
				}
				case 5:{
					reason="病死"
					break;
				}
				default:{
					reason="未知"
					break;
				}
			}
			return reason;
		},
		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params._id;
			window.moveToView("stockDetail",window.did+'_'+_id);
		},
		//加载更多数据的事件
		onLoadMore:function(evt){
			if(this.busy||(0<this.end&&(this.start+10-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多记录");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: 10
					}), lang.hitch(this,function(){
						this.stockListScroll.resize();
					}));
				}), 1000);
			}
		},
		onAfterShow:function(){
			this.start=0;
			this.setQuery({ioType:window.did}, {
				start: 0,
				count: 10
			});
		},
		setQuery:function(query){
			this.start = 0;
			this.end = -1;
			this.storeList.destroyDescendants();
			this.storeList.setQuery(query,{
				start: this.start,
				count: 10
			});
			this.stockListScroll.resize();
		}
	});
});
