define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/topic",
	"dojox/mobile/View",
	"dojo/store/Memory",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/util/sys/date",
	"cq/ui/view/_ViewMixin",
	"dojo/_base/xhr",
	"dojo/query",
	"dojo/dom-style",
	"dijit/registry",
	"dijit/focus",
	"cq/biz/ts/stock_io",
	"cq/biz/mat/mat"
],function(declare,lang,topic,View,Memory,EdgeToEdgeStoreList,date,_ViewMixin,xhr,query,domStyle,registry,focusUtil,stock,mat){
	return declare("whz.view.StockDetail",[View,_ViewMixin],{
        isEditing : false,
        type:"",//数量增加(type=1)、数量减少(type=0)
        __stockId : "",
		onAfterShow : function() {
			this.type=window.did.split("_")[0];
			window.did=window.did.split("_")[1]||'';
          // 不是修改中,需要初始化页面
          if (!this.isEditing) {
          	//数量增加,隐藏数量减少输入框
          	this.tabPage(parseInt(this.type));
          	//页面状态设置为修改中
          	this.isEditing=true;
          	//修改数据,加载数据到页面
			if(window.did){
				stock.loadById(window.did).then(lang.hitch(this, function(data) {
				  //显示信息
				  this.setData(data.data.item);
				  this.refreshData();
				}));
			}else{
				//新增数据,清空页面
				this.setData({
					ioDate:date.nowISOString(),
					reason1:1,
					reason2:3
				});
				this.refreshData();
			}
          }
        },
		refreshData:function(){
			if(this.__data){
				if(this.__data.matId&&(!this.__data.matId._id)){
					this.__data.matId = {
						_id:this.__data.matId
					};
				}
				if(this.__data.ioDate){
					this.__data.ioDate=date.formatISODate(this.__data.ioDate);
				}
				if (this.__data.reason) {
					this.__data[this.type?"reason1":"reason2"]=this.__data.reason;
				};
			}
			this.inherited(arguments);
		},
        tabPage:function(type){
        	domStyle.set(query(".outQty",this.domNode)[0],"display",type?"none":"block");
      		domStyle.set(query(".inQty",this.domNode)[0],"display",type?"block":"none");
      		domStyle.set(query(".reason1",this.domNode)[0],"display",type?"block":"none");
      		domStyle.set(query(".reason2",this.domNode)[0],"display",type?"none":"block");
        },
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						//状态不为修改中
						this.isEditing=false;
						window.moveToView("stock",this.type);
					}
				},
				title:"新增",
				right:{
					iconButton:' ',
					onClick:this.onSaveStore,label:"完成"
				}
			};
			this.addHeader(option);
			option = {
				isEdge:true,
				lists:[{
					label:'时间',
					moveTo:"#",
					edit:{
						type:'date',
						field:'ioDate'
					}
				},{
					label:'品种',
					moveTo:"#",
					edit:{
						type:'ref',
						field:'matId',
						//选择商品的示例
						params:{
							target:mat.getOnSaleUrl(),
							query:{
								isUse:true,
								qty:1
							},
							searchField:"mName",labelField:"mName"
						},
						placeHolder:"必填"
					}
				},{
					label:'增加数量',
					noArrow:true,
					class:"inQty",
					edit:{
						type:'text',
						field:'inQty',
						placeHolder:"必填"
					}
				},{
					label:'减少数量',
					noArrow:true,
					class:"outQty",
					edit:{
						type:'text',
						field:'outQty',
						placeHolder:"必填"
					}
				},{
					label:'原因',
					moveTo:"#",
					//可以添加class属性来筛选对应编辑元素的根节点
					"class":"reason1",
					edit:{
						type:'options',
						field:'reason1',
						options:{
							"1":"繁殖",
							"2":"购买"
						}
					}
				},{
					label:'原因',
					"class":"reason2",
					moveTo:"#",
					edit:{
						type:'options',
						field:'reason2',
						options:{
							"3":"出售",
							"4":"自宰",
							"5":"病死"
						}
					}
				},{
					label:'备注',
					moveTo:"#",
					edit:{
						type:'textarea',
						field:'remark',
						placeHolder:"选填"
					}
				}]
			};
			this.addLists(option);
			this.onAfterShow();
		},
		getData:function(){
			var data = lang.clone(this.inherited(arguments));
			if(data.matId&&data.matId._id){
				data.matId = data.matId._id;
			}
			data.ioDate = date.formatToISOString(data.ioDate);
			return data;
		},
		onSaveStore:function(){
			if(this.isEditing){
				//离开页面修改"修改中的状态"
				this.isEditing=false;
				// 当前节点失去焦点
				focusUtil.curNode&&focusUtil.curNode.blur();
				setTimeout(lang.hitch(this, function(){
					var m=this.getData();
					m.ioType=this.type;
					var msg=this.checkFiled(m);
					if(msg){
						alert(msg);
						this.isEditing = true;
						return;
					}
					console.log(m);
					stock.save(m).then(function(){
						topic.publish("whz/shop/io/changed");
						window.moveToView("stock",this.type);
					});
				}), 0);
			}
		},
		checkFiled:function(data){
			var msg="";
			if(!data.matId){
				msg="品种还没有选择";
			}
			if(this.type==1){
				data.reason=data.reason1;
				if(!data.inQty){
					msg="增加数量不能为空";
				}
			}else if(this.type==0){
				data.reason=data.reason2;
				if(!data.outQty){
					msg="减少数量不能为空";
				}
			}
			delete data.reason1;
			delete data.reason2;
			return msg;
		}
	});
});
