// 变更人:曹桂捷
// 变更时间:2016/10/31
// 变更内容:消息通知
define([
	"dojo/_base/declare",
    "dojo/_base/lang",
	"dojo/_base/connect",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/on",
    "dojox/mobile/View",
    "dojo/store/JsonRest",
    "dojox/mobile/EdgeToEdgeStoreList",
	"dijit/registry",
    "cq/ui/view/_ViewMixin",
	"cq/util/sys/date",
    "cq/biz/im/task_todo"
],function(declare,lang,connect,domClass,domAttr,query,on,View,JsonRest,EdgeToEdgeStoreList,registry,_ViewMixin, date, taskTodo){
	return declare("whz.view.TaskTodo",[View,_ViewMixin],{
		start:0,
		pageSize:20,
		//加载数据到页面
		//默认查询条件为未读
		onAfterShow:function(){
			if(this.storeList.store){
				this.setQuery({isRead:false});
				this.clearSelected();
           		domClass.add(query('.tab-selector', this.domNode)[0], "selected");
			}else{
				this.params = {isRead : false};
	            this.store = new JsonRest({target:taskTodo.getLoadUrl()});
            	this.onLoadListData(this.storeList.setStore(this.store,this.params,{
            		start:this.start,
            		count:this.pageSize
            	}),this.start,this.pageSize);
			}
			this.refreshData();
		},
		//初始化界面
		onFirstShow:function(){
			var opition = null;
			//头部
			option = {
				left : {
					iconButton: ' ',
                    arrow: "left",
                    label: "返回",
					onClick: function(){
						history.back()
					}
				},
				title: "消息通知"
			};
			this.addHeader(option);
			//选项卡
			option = {
				columns:[{
					label:"未读",
					className:"flex1 unRead",
					onClick:this.changeOnUnRead
				},{
					label:"已读",
					className:"flex1 isRead",
					onClick:this.changeOnIsRead
				}],
				isHeader:true,
				labelClass:'font-size1 tab-selector'
			};
			this.addColumns(option);
			//列表
			this.storeList = new EdgeToEdgeStoreList({
				append : true,
				constraint : false,
				query : {},
				class : "icon-list-item",
	            variableHeight : true,
	            onComplete : lang.hitch(this,function(data){
	            	for(var i = 0 ;i < data.length; i++){
	            		data[i]._label = "<div class='taskItem' taskId="+ data[i]._id +" moveTo="+ data[i].moveTo +" param="+ data[i].param +">"+ date.formatISODateMinutes(data[i].createAt)+"  "+ data[i].content +"</div>"
	            		data[i].moveTo = "#";
	            	}
	            	this.storeList.generateList(data);
	            	this.busy = false;
	            }),
	            queryOptions : {
                	start : this.start,
                	count : this.pageSize
	            },
	            itemMap : {
	            	_label : "label"
                }
			});
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click", lang.hitch(this, this.onClickList));
            on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
		},
		//列表点击事件
		onClickList:function(evt){
			var li = registry.getEnclosingWidget(evt.target);
			if (li.declaredClass != "dojox.mobile.ListItem"){
        		return;
        	}
        	var taskItem = query(".taskItem",li.domNode)[0];
        	var taskId = domAttr.get(taskItem,"taskId");
        	var moveTo = domAttr.get(taskItem,"moveTo");
        	var param = domAttr.get(taskItem,"param");
        	if(moveTo=="PayToAnother"){
        		moveTo = "payToAnother";
        	}
        	if(moveTo=="orderDetail"){
        		if(param.split("-").length>1){
        			param=param.split("-")[1];
        		}
        	}
        	//标记为已读
        	if(this.params.isRead == false){
        		params = {
        			_id:taskId
        		}
	        	taskTodo.setReadedById(params);
        	}
        	//获取参数跳转页面
        	window.moveToView(moveTo,param);
		},
		//清空选项卡样式
		clearSelected:function(){
			var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
		},
		//已读
		changeOnIsRead:function(evt){
			this.clearSelected();
			var dom = evt.target;
			domClass.add(dom,"selected");
			this.params.isRead = true;
			this.setQuery(this.params);
		},
		//未读
		changeOnUnRead:function(evt){
			this.clearSelected();
			var dom = evt.target;
			domClass.add(dom,"selected");
			this.params.isRead = false;
			this.setQuery(this.params);
		},
		setQuery:function(query){
			this.start = 0;
            this.storeList.destroyDescendants();
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();	
		},
		onLoadMore : function (evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }), this.start,this.pageSize);
                    }), 1000);  
                }  
            }
        },
	})
})