define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dojo/_base/xhr",
	"dojo/query",
	"dijit/registry",
	"cq/biz/article/article",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",
	"dojo/store/JsonRest"
],function(declare,lang,View,_ViewMixin,xhr,query,registry,article,EdgeToEdgeStoreList,on,when,JsonRest){
	return declare("whz.view.Trends",[View,_ViewMixin],{
		start:0,
		indexElement:function(){
            this.trendsListScroll = this.centerPanel;
		},
		onFirstShow:function(){
			var option = {left:{icon:__shop.logo?__shop.logo:'/a.png', onClick:function(){} , crop: true}, title:__shop.shopName};
			this.addHeader(option);
			//option = {src:'images/home.png', onClick:function(){}}
			//this.addImage(option);
			option = {
				columns:[{
					icon:'images/icon/shop_footer_highlight.png',
					iconClass:'width-16',
					label:'店铺',
					onClick:function(){
						localStorage.removeItem("fromNewsList");
						localStorage.removeItem("fromTrends");
						window.moveToView("home");
					}
				},
				{
					icon:'images/icon/member_footer.png',
					iconClass:'width-16',
					label:'客服',
					onClick:function(){
						window.moveToView("pendingMsg");
					}
				},
				{
					icon:'images/icon/sale_footer_highlight.png',
					iconClass:'width-16',
					label:'动态',
					onClick:function(){
						window.moveToView("trends");
					}
				},
				{
					icon:'images/icon/more_footer.png',
					iconClass:'width-16',
					label:'更多',
					onClick:function(){
						window.moveToView("others");
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer',
				isFooter:true
			}
			this.addColumns(option);
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){
						data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].title+"</div>";
						data[i]._label+="<div class='mat-list-margin'>"+data[i].brief+"</div>"
						data[i].moveTo="#";
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions: {
					count: 10,
					start: this.start
					},
				itemMap:{_label:"label",logo:"icon", moveTo:"moveTo"}
			});
			// 创建数据源
			this.params={};
			this.store = new JsonRest({target:article.getNZBShopUrl()});
			// 将数据源赋值给StoreList
			this.storeList.setStore(this.store,this.params);

			this.storeList.placeAt(this.trendsListScroll.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.trendsListScroll,"afterscroll",lang.hitch(this,this.onLoadMore));
		},
		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			window.moveToView("newDetail",li.params._id);
		},
		onLoadMore:function(evt){
			if(this.busy||(0<this.end&&(this.start+10-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多资讯");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: 10
					}), lang.hitch(this,function(){
						this.trendsListScroll.resize();
						this.start += this.storeList.pageSize||10;
					}));
				}), 1000);
			}
		}
	});
});
