/**
    变更人员： 杜飞军
    变更内容： 代码规范，添加注释，文件迁移
    变更时间： 2016/05/17
 */

define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/dom-style",
	"dojo/query",
	"dojox/mobile/View",
	"dojox/mobile/ContentPane",
	"cq/ui/view/_ViewMixin",
	"cq/biz/user/user",
	"dijit/registry",
	],function(declare,lang,domStyle,query,View,ContentPane,_ViewMixin,user,registry){
	
	// module:
	//		cq/ui/b/u/UserDetail

	return declare("whz.view.UserDetail",[View,_ViewMixin],{
		
		// 初始化显示内容
		onFirstShow:function(){
			var option={
				left:{
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick:function(){
						window.moveToView("userList");
					}
				},
				title:"客户资料",
			}
			this.addHeader(option);
			option = {
				columns:[{
					label:'修改信息',
					icon:'images/icon/crmicon.png',
					iconClass:'width-16',
					onClick:function(){
						window.moveToView("user",_id);
					}
				}],
				valueClass:'font-size3',
				labelClass:'font-size1',
				className:'fix-footer footerGrayTopBorder',
				isFooter:true
			}
			this.addColumns(option);
			var imgDiv=option = {
	            isEdge : true,
	            title:"基本信息",
	            lists : [ {
	              label : "用户头像",
	              noArrow : false,
	              rightIcon2 :"",
	              class : "li-icon"
	            } ]
	          };
	          this.addLists(option);
			option = {isEdge:true,
				class : "bottom-margin16",
				lists:[
				{label:'客户编码',noArrow:true,edit:{type:'label',field:'code',placeHolder:"必填"}},
				//{label:'头像',noArrow:true,edit:{type:'text',field:'logo'}},
				{label:'昵称',noArrow:true,edit:{type:'label',field:'nickName',placeHolder:"必填"}},
				{label:'姓名',noArrow:true,edit:{type:'label',field:'pName',placeHolder:"必填"}},
				{label:'上线客户',noArrow:false,edit:{type:'label',field:'srcUser',disabled:true}},
				{label:'关注状态',noArrow:true,edit:{type:'label',field:'subscribed',disabled:true}},
				{label:'性别',edit:{type:'label',field:'sex',options:{0:"男",1:"女"}}},
				{label:'电话',noArrow:true,edit:{type:'label',field:'phone',placeHolder:"请输入电话"}},
				{label:'地址',noArrow:true,edit:{type:'label',field:'address',placeHolder:"请输入地址"}},
				{label:'生日',edit:{type:'label',field:'birthday'}},
				{label:'积分',noArrow:true,edit:{type:'label',field:'amount',disabled:true}}
				]
				};
			this.addLists(option);
			option = {isEdge:true,
            	class : "bottom-margin16",
            	lists:[
				{label:'登录名',noArrow:true,edit:{type:'label',field:'userName',disabled:true}},
				{label:'国家',noArrow:false,edit:{type:'label',field:'countryId'}},
				{label:'省',noArrow:false,edit:{type:'label',field:'provinceId'}},
				{label:'城市',noArrow:false,edit:{type:'label',field:'cityId'}},
				]
				};
			this.addLists(option);
			option = {isEdge:true,
            	class : "bottom-margin16",
				lists:[
				{label:'关注日期',noArrow:true,edit:{type:'label',field:'subscribeDate',disabled:true}},
				{label:'取消关注日期',noArrow:true,edit:{type:'label',field:'cancelDate',disabled:true}},
				{label:'来源',noArrow:true,edit:{type:'label',field:'source'}},
				]
				};
			this.addLists(option);
			this.onAfterShow();
		},

		// 更新显示界面的内容
		onAfterShow:function(){
			this.inherited(arguments);
			this.resize();
			user.loadById(this.__userid).then(lang.hitch(this,function(data){
				if(data.data.ok==1){
					this.__data=data.data.item;
				}else{
					this.__data={};
				}
				this.refreshData();
			}));
		}
	});
});
