define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/user",
    "cq/bo/user",
],function(declare,lang,View,_ViewMixin,user,user2){
    return declare("widgets.mobile.UserSetting",[View,_ViewMixin],{
        onFirstShow:function () {
            var options = {
                left:{
                    iconButton:" ",
                    label:"返回",
                    arrow:"left",
                    onClick:function () {
                        history.back();                        
                    }
                },
                title:"设置"
            };
            this.addHeader(options);
            options = {
                isEdge:true,
                lists:[
                    {
                        label:"个人信息",
                        moveTo:"#",
                        rightText:"查看个人信息",
                        noArrow:false,
                        onClick:function () {
                            window.moveToView("personalInformation");
                        }
                    },
                    {
                        label:"修改密码",
                        moveTo:"#",
                        rightText:"",
                        noArrow:false,
                        onClick:function () {
                            window.moveToView("changePassword");
                        }
                    }
                ]
            }
            this.addLists(options);
            options={
                columns:[{
                    label:"注销登录",
                    onClick:function () {
                        this.logout();
                    },
                    className:"footer-tab-dark"
                }],
                valueCLass:"footer-tab-highlight",
                labelClass:"logout-btn",
                className:"",
                isFooter:true
            }
            this.addColumns(options);
            this.onAfterShow();
        },
        onAfterShow:function () {
            this.inherited(arguments);
            user.hasLogin().then(lang.hitch(this,function (s) {
                if(!s){
                    window.moveToView("login");
                    user.nextPage="userSetting";
                }
            }));
        },
        logout:function () {
            user2.logout();
        }
    });
});
