﻿define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"./ListView",
	"./ViewUtil"
],function(declare,lang,array,ListView,ViewUtil){
	var OptionsList = declare("",ListView,{
		getValue:function(){
			return this.selectedItem&&this.selectedItem.params.key||"";
		},
		setOrigin:function(key){
			this.selectedItem = null;
			array.some(this.optionList.getChildren(),function(item){
				if(item.params.key===key){
					item.set("checked",true);
					return true;
				}
			},this);
		},
		initList:function(options){
			var data = [];
			for(var k in options){
				data.push({
					key:k,label:options[k]
				});
			}
			this.store.setData({
				items:data
			});
			this.optionList.setQuery();
		}
	});
	var optionsList = new ViewUtil({
		EditorClass:OptionsList
	});
	lang.setObject("whz.utl.optionsList",optionsList);
	return optionsList;
});