/**
*	Create	2016/06/01 
*	Name	杜飞军
*	Deploy
*		显示查询到的服务机构
**/
define([
		"dojo/_base/declare",
		"dojo/_base/lang",
		"dojo/store/JsonRest",
		"dojo/on",
		"dojo/when",
		"dijit/registry",
		"dojox/mobile/View",
		"dojox/mobile/EdgeToEdgeStoreList",
		"cq/biz/shop/shop",
		"cq/ui/view/_ViewMixin"
	], function(declare, lang, JsonRest, on, when, registry, View, EdgeToEdgeStoreList, shop, _ViewMixin){
		// module:
		//		widgets/mobile/AgencyList
		return declare("widgets.mobile.AgencyList", [View, _ViewMixin],{
			start : 0,

			onFirstShow: function(){
				var options = {
					left: {
						iconButton: ' ',
						arrow: "left",
						label: "返回",
					onClick: function() {
							history.back();
						}
					},
					title: "服务机构"
				};
				this.addHeader(options);

				options = {
					placeHolder : "请输入要查询条件，按回车查询",
					class : "cqSearchBox",
					type : "search",
					onInput : lang.hitch(this, function (evt) {
						if (evt.keyCode == 13) {
							this.search = evt.target.value;
							var condition = this.storeList.get("query");
							condition.search = evt.target.value;
							this.setQuery(condition);
							evt.target.value = "";
						}
					})
				};
				this.addTextBox(options);

				this.storeList = new EdgeToEdgeStoreList({
					append : true,
					constraint : false,
					query : {},
					class : "icon-list-item",
					variableHeight : true,
					//获取数据完成后调用的的处理方法
					onComplete : lang.hitch(this, function (data) {
						for (var i = 0; i < data.length; i++) {
							data[i]._logo = data[i].logo ? data[i].logo : '/static/images/mobile/user_userIcon.png';
							data[i].svcPhone = data[i].svcPhone ? data[i].svcPhone : "";
							data[i].address = data[i].address ? data[i].address : "";
							data[i]._label = "<div class='mat-list-qty mat-list-margin'>名称:" + data[i].shopName + "</div>" +
								"<div class='mat-list-qty mat-list-margin'><span>电话：" + data[i].svcPhone + "</span></div>" +
								"<div class='mat-list-qty mat-list-margin'><span>地址：" + data[i].address + "</span></div>";
								data[i].moveTo = "#";
						}
						this.storeList.generateList(data);
						this.end = this.start + data.length - 1;
						this.busy = false;
					}),
					queryOptions : {
						count : 10,
						start : this.start
					},
					itemMap : {
						_label : "label",
						_logo : "icon",
						moveTo : "moveTo"
					}
				});
				//创建数据源
				this.params = {
					shopType : 2001,
					srcShop:g_sys_info.platformShopId
				};
				this.store = new JsonRest({
						target : shop.getChildShopsURL()
					});

				// 将数据源赋值给storeList
				this.storeList.setStore(this.store, this.params);
				this.storeList.placeAt(this.centerPanel.containerNode, "last");
				this.storeList.on("click", lang.hitch(this, this.onClickList));
				on(this.centerPanel, "afterscroll", lang.hitch(this, this.onLoadMore));
			},
			onClickList: function(e){
				var li = registry.getEnclosingWidget(e.target);
				if (li.declaredClass != "dojox.mobile.ListItem")
				return;
				window.moveToView("shopDetail",li._id);
			},

			setQuery(query){
				this.storeList.destroyDescendants();
				//设置开始和数量
				this.storeList.setQuery(query,{
					start: 0,
					count: 20
				});
				this.resize();
			},

			onLoadMore: function(evt){
				if (this.busy || (0 < this.end && (this.start + 10 - 1 > this.end))) {
				return true;
				}
				if (evt.afterBottom) {
					this.start = this.end + 1;
					console.log("加载更多服务机构");
					this.busy = true;
					setTimeout(lang.hitch(this, function () {
							when(this.storeList.setQuery(this.storeList.get("query"), {
									start : this.start,
									count : 10
								}), lang.hitch(this, function () {
									this.centerPanel.resize();
								}));
						}), 1000);
				}
			}
		});
})