// 变更人：宋宇
// 变更时间：2016-06-13
// 变更事项：初稿
define([
    "dojo/_base/declare", // 声明对象的
    "dojo/_base/lang", // 语言工具(改变语言上下文)
    "dojo/touch",
    "dojox/mobile/View", // view的基类
    "dojox/mobile/EdgeToEdgeStoreList", // 用于显示数据的列表
    "cq/ui/view/_ViewMixin", // 自己封装的公共的基类
    "dojo/query", // 前台ui元素的检索
    "cq/biz/im/channelMsg", // 服务器接口的代理层，方便去调服务器端的程序
    "dojo/store/JsonRest", // 从服务器加载数据的数据源
    "dojo/dom-class",
    "cq/biz/blob/blob",
    "cq/biz/user/user",
    "cq/util/sys/date"
], function (declare, lang, touch, View, EdgeToEdgeStoreList, _ViewMixin, query, channelMsg, JsonRest, domClass, blob, user, date) {
    // module:
    //		whz/view/ChannelDetail
    return declare("widgets.mobile.ChannelDetail", [View, _ViewMixin], {
        // 取数据时的开始下标，默认为0
        discussStart : 0,
        discussEnd : -1,
        liveStart : 0,
        liveEnd : -1,
        // live:选中直播区，discuss:选择讨论区
        selectedMode : "live",
        // 每次加载的数据条数，默认为10
        pageSize : 20,
        //20160628：保存定时器
        refreshTimer : null,
        // 每次进入页面，重新加载数据
        onAfterShow : function () {
            user.hasLogin().then(lang.hitch(this,function(hasLogin){
                if(hasLogin){
                    this.showLiveList();
                    user.getUserInfo().then(lang.hitch(this,function(userData){
                        this.currentUserInfo = userData&&userData.data&&userData.data.item||{};
                    }));
                }else{
                    user.nextPage = "channelDetail-"+window.did;
                    window.moveToView("login");
                }
            }));
        },
        initListData:function(data){
            for (var i = 0; i < data.length; i++) {
                if(data[i].isHost){
                    data[i]._label = "<div class='authorHeader'>" +
                        "<img class='authorLogo' src='" + (data[i].sendLogo || "/static/images/mobile/user_userIcon.png") + "'/>" +
                        "<span class='authorNick'>" + (data[i].sendNick || "主持人" ) + "</span>" +
                        "<span class='sendTime'>" + date.formatISODateMinutes(data[i].sendTime) + "</span>" +
                        "</div>" +
                        "<div class='richText'>" +
                        (data[i].msgImage ? "<img src='" + data[i].msgImage + "'>" : "") +
                        (data[i].msgText || "") +
                        "</div>";
                }
                else{
                    data[i]._label = "<div class='authorHeader'>" +
                        //日期在左侧
                        "<span class='sendTime' style='float:left;'>" + date.formatISODateMinutes(data[i].sendTime) + "</span>" +
                        "<img class='authorLogo' src='" + (data[i].sendLogo || "/static/images/mobile/user_userIcon.png") + "' style='float:right;'/>" +
                        "<span class='authorNick' style='float:right;'>" + (data[i].sendNick || "匿名用户") + "</span>" +
                        "</div>" +
                        "<div class='richText' style='text-align:right;'>" +
                        (data[i].msgImage ? "<img src='" + data[i].msgImage + "'>" : "") +
                        (data[i].msgText || "") +
                        "</div>";
                }
            }
        },
        //退出此界面时，清空定时器
        onBeforeTransitionOut:function(){
            this.clearRefreshTimeout();
        },

        // 第一次进入页面，加载页面显示的组件
        onFirstShow : function () {
            // 页面的头部
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        history.back(); //返回浏览记录的上一个页面
                    }
                },
                title : "直播详情"
            };
            this.addHeader(option);
            option = {
                isHeader: true,
                columns : [{
                    label : '直播区',
                    onClick : this.showLiveList
                }, {
                    label : '讨论区',
                    onClick : this.showDiscussList
                }],
                labelClass : 'font-size1 tab-selector'
            };
            this.tabSelector = this.addColumns(option);

            this.liveView = new View();
            this.liveView.placeAt(this.centerPanel.containerNode, "last");
            this.discussView = new View();
            this.discussView.placeAt(this.centerPanel.containerNode, "last");

            this.liveMessageList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                onComplete : lang.hitch(this, function (data) {
                    this.initListData(data);
                    this.liveMessageList.generateList(data);
                    this.liveEnd = this.liveStart + data.length - 1;
                    this.busy = false;
                }),
                queryOptions : {
                    count : this.pageSize,
                    start : this.liveStart
                },
                itemMap:{_label:"label",moveTo:"moveTo"}
            });
            this.liveMessageList.placeAt(this.liveView, "last");

            this.discussList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                class : "icon-list-item",
                variableHeight : true,
                onComplete : lang.hitch(this, function (data) {
                    this.initListData(data);
                    this.discussList.generateList(data);
                    this.discussEnd = this.discussStart + data.length - 1;
                    this.busy = false;
                }),
                queryOptions : {
                    count : this.pageSize,
                    start : this.discussStart
                },
                itemMap:{_label:"label",moveTo:"moveTo"}
            });
            this.discussList.placeAt(this.discussView, "last");
            this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
            this.centerPanel.on("click", lang.hitch(this, this.onListClick));

            option = {
                placeHolder : "请输入回复内容",
                class : "cqSearchBox",
                type : "search",
                onInput : lang.hitch(this, this.onMessageEnter)
            };
            this.textBox = this.addTextBox(option);
            this.footerColumn = this.addColumns({
                forceWidth:false,
                isFooter:true,
                columns:[{
                    className:"flex1",
                    label:""
                },{
                    className:"miniIcon imageSelector",
                    label:""
                }]
            });
            this.textBox.placeAt(query(".flex1",this.footerColumn)[0], "only");
            this._topSplitter.resize();
            this.own(touch.release(query(".miniIcon",this.footerColumn)[0],lang.hitch(this,function(){
                blob.selectAndUpload().then(lang.hitch(this, this.onUploadImage));
            })));
            
            // 创建数据源
            this.params = {};
            this.onAfterShow();
        },
        
        //清定时器
        clearRefreshTimeout : function(){
            if(this.refreshTimer){
                clearTimeout(this.refreshTimer);
                this.refreshTimer = null;
            }
        },
        
        setRefreshTimeout : function(){
            this.clearRefreshTimeout();
            if(this.selectedMode == "live"){
                this.refreshTimer = setTimeout(lang.hitch(this,this.showLiveList), 5000);
            }else{
                this.refreshTimer = setTimeout(lang.hitch(this,this.showDiscussList), 5000);
            }
        },

        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
        },
        showLiveList: function() {
            this.selectedMode = "live";
            this.clearSelected();
            domClass.add(query(".tab-selector", this.tabSelector)[0], "selected");
            this.liveView.show();
            this.liveStart = 0;
            this.liveEnd = -1;
            this.liveMessageList.destroyDescendants();
            var def = null;
            // 调用服务器的方法加载数据
            if (this.liveMessageList.store) {
                var queryInfo = this.liveMessageList.get("query");
                queryInfo.channelId = window.did;
                def = this.liveMessageList.setQuery(queryInfo, {
                    start : this.liveStart,
                    count : this.pageSize
                });
                this.onLoadListData(def, this.liveStart, this.pageSize, "live");
            } else {
                def = this.liveMessageList.setStore(new JsonRest({
                        target : channelMsg.getLoadUrl()
                    }), {
                    isHost : true,
                    channelId : window.did
                }, {
                    start : this.liveStart,
                    count : this.pageSize
                });
                this.onLoadListData(def, this.liveStart, this.pageSize, "live");
            }
            domClass.add(this.footerColumn, "none");
            def.then(lang.hitch(this, this.resize));
            this.setRefreshTimeout();
        },
        showDiscussList : function () {
            this.selectedMode = "discuss";
            this.clearSelected();
            domClass.add(query(".tab-selector", this.tabSelector)[1], "selected");
            this.discussView.show();
            this.discussStart = 0;
            this.discussEnd = -1;
            this.discussList.destroyDescendants();
            var def = null;
            // 调用服务器的方法加载数据
            if (this.discussList.store) {
                var queryInfo = this.discussList.get("query");
                queryInfo.channelId = window.did;
                def = this.discussList.setQuery(queryInfo, {
                    start : this.discussStart,
                    count : this.pageSize
                });
                // ql 为评论
                this.onLoadListData(def, this.discussStart, this.pageSize, "ql");
            } else {
                def = this.discussList.setStore(new JsonRest({
                    target : channelMsg.getLoadUrl()
                }), {
                    channelId : window.did
                }, {
                    start : this.discussStart,
                    count : this.pageSize
                });
                // ql 为评论
                this.onLoadListData(def, this.discussStart, this.pageSize, "ql");
            }
            domClass.remove(this.footerColumn, "none");
            def.then(lang.hitch(this, this.resize));
            this.setRefreshTimeout();
        },
        
        onListClick : function(evt){
            if(evt.target.localName == "img"){
                if(domClass.contains(evt.target.parentNode, "richText")){
                    var imgSrcUri = evt.target.src;
                    this.showImg(imgSrcUri); 
                } 
            }
        },

        onMessageEnter : function (evt) {
            if (evt.keyCode == 13) {
                this.search = evt.target.value;
                if (!this.search){
                    return;
                }
                channelMsg.save({
                    senderId : this.currentUserInfo._id,
                    channelId : window.did,
                    sendNick : this.currentUserInfo.pName||this.currentUserInfo.nickName||this.currentUserInfo.wxNick||"",
                    sendLogo : this.currentUserInfo.logo||null,
                    sendTime : new Date(),
                    msgType : 0,
                    msgText : this.search,
                    isHost : false
                }).then(lang.hitch(this, function () {
                    this.showDiscussList();
                    evt.target.value = "";
                }));
            }
        },
        onUploadImage:function(imageInfo){
            if(imageInfo&&imageInfo.items&&imageInfo.items[0]){
                channelMsg.save({
                    senderId : this.currentUserInfo._id,
                    channelId : window.did,
                    sendNick : this.currentUserInfo.pName||this.currentUserInfo.nickName||this.currentUserInfo.wxNick||"",
                    sendLogo : this.currentUserInfo.logo||null,
                    sendTime : new Date(),
                    msgType : 1,
                    msgImage : imageInfo.items[0].uri,
                    isHost : false
                }).then(lang.hitch(this, function () {
                    this.showDiscussList();
                }));
            }
        },

        // 拖动加载更多
        onLoadMore: function(evt) {
            if (!this.busy && evt.afterBottom) {
                if ("live" === this.selectedMode) {
                    this.liveStart = this.liveStart + this.pageSize;
                    if (this.canLoadMore(this.liveStart, "live")) {
                        this.clearRefreshTimeout();
                    this.liveStart = this.liveEnd + 1;
                    console.log("加载更多资讯");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                            var def = this.liveMessageList.setQuery(this.liveMessageList.get("query"), {
                            start : this.liveStart,
                            count : this.pageSize
                            });
                            this.onLoadListData(def, this.liveStart, this.pageSize, "live");
                        }), 1000);
                    }

                } else {
                    this.discussStart = this.discussStart + this.pageSize;
                    if (this.canLoadMore(this.discussStart, "ql")) {
                        this.clearRefreshTimeout();
                        this.discussStart = this.discussEnd + 1;
                        console.log("加载更多资讯");
                        this.busy = true;
                        setTimeout(lang.hitch(this, function() {
                            var def = this.discussList.setQuery(this.discussList.get("query"), {
                                start: this.discussStart,
                                count: this.pageSize
                            });
                            this.onLoadListData(def, this.discussStart, this.pageSize, "ql");
                        }), 1000);
                    }

                }
            }
        }
    });
});
