﻿define([	
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dojo/_base/xhr",
	"dojo/query",
	"dijit/registry",
	"dojo/_base/Deferred",
	"dojox/data/QueryReadStore",
	"dojo/ready",	
	"dojox/mobile/ListItem",
	"dojox/mobile/parser",	
	"dojox/mobile/compat",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/on",
	"dojo/when",
	"dojo/store/JsonRest",
	"cq/biz/section/section",
	"dojo/dom-attr",
	"dojo/dom-class"
],function(declare,lang,View,_ViewMixin,xhr,query,registry,Deferred,QueryReadStore, ready, ListItem,parser,compat,EdgeToEdgeStoreList,on,when,JsonRest,section,domAttr,domClass){
	return declare("whz.view.OrderInfo",[View,_ViewMixin],{
		start:0,
		isAdd : false,
        __mid : "",
        isEditing : false,
		indexElement:function(){
            this.SectionListScroll = this.centerPanel;
		},
		onFirstShow:function(){			
			var option = {
                left:{
                    iconButton:' ',
                    arrow : "left",
                    label:"返回",
                    onClick:function(){
                        history.back();
                    }
                },
                title:"订单编辑"
            };
			this.addHeader(option);

			this.StoreList=new EdgeToEdgeStoreList({
				append: true, 
				constraint: false, 
				query:{}, 
				class:"icon-list-item",
				variableHeight:true,
                //获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){
					if(data){
						for(var i=0;i<data.length;i++){
							data[i]._label="<div class='webkit-list'><div class='immune-list-left mat-list-margin immune-list'>收货人："+(data[i].consigneeName?data[i].consigneeName:"未填写")+"</div><div class='immune-list-left mat-list-totalSale'>联系电话："+(data[i].consigneeNumber?data[i].consigneeNumber:"未填写")+"</div></div>"
							+"<div class='immune-list'><div class='immune-list-left mat-list-margin'>收货地址："+(data[i].consigneeAddres?data[i].consigneeAddres:"未填写")+"</div></div>";
							data[i].moveTo="#"
						}
					}
					this.StoreList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),				
				queryOptions: { 
					count: 10, 
					start: this.start
					},
				itemMap:{_label:"label", logo:"icon",moveTo:"moveTo"}
				});
			// 创建数据源			
			this.store = new JsonRest({target:section.load()});					
			
			// 将数据源赋值给StoreList	
			this.StoreList.setStore(this.store);
			this.StoreList.placeAt(this.SectionListScroll.containerNode,"last");
			this.StoreList.on("click",lang.hitch(this,this.onClickList));			
			on(this.SectionListScroll,"afterscroll",lang.hitch(this,this.onLoadMore));	
			
		  
		},
		onMatDetailChange : function(text) {
          this.__data.remark = text;
          /* console.log(text); */
        },
        //为list绑定点击事件，点击后进入编辑界面
        onClickList:function(){
			// 得到点击的ListItem
			window.moveToView("chooseAddr");
			
		},
		onAfterShow : function() {
			// 如果是修改，
			if (!this.isEditing) {
				this.isEditing = true;
				if(this.isAdd){
					this.setData({
						isUse:true
					});
					this.refreshData();
				}else{
					section.loadById(this.__mid).then(lang.hitch(this, function(data) {
						// 显示商品信息
						this.setData(data.data.item);
						this.refreshData();
					}));
				}
			}
        },
        refreshData : function() {
          if(this.__data){
				if(this.__data.parentId&&(!this.__data.parentId._id)){
					this.__data.parentId = {
						_id:this.__data.parentId
					};
				}
			}
			this.inherited(arguments);
		  
        },
        //加载更多数据的事件
		onLoadMore:function(evt){												
			if(this.busy||(0<this.end&&(this.start+10-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多菜单");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.StoreList.setQuery(this.StoreList.get("query"), {
						start: this.start,
						count: 10
					}), lang.hitch(this,function(){
						this.SectionListScroll.resize();
					}));						
				}), 1000);
			}
		},
		onAfterShow:function(){
			this.setQuery(this.StoreList.get("query"), {
				start: 0,
				count: 10
			});			
		},
		setQuery:function(query){
			this.start = 0;
			this.end = -1;
			this.StoreList.destroyDescendants();
			this.StoreList.setQuery(query,{
				start: this.start,
				count: 10
			});
			this.SectionListScroll.resize();
		}
	});
});