// 变更人员： 程磊
// 变更内容： 讲堂详情
// 变更时间： 2016/7/6

define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "dojo/query",
    "dojo/dom-class",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/store/JsonRest",
    "dojo/dom-construct",
    "cq/biz/article/bs/schoolClass",
    "cq/biz/user/user"
], function (declare, lang, array, domStyle, View, _ViewMixin, date, query, domClass, registry, EdgeToEdgeStoreList, on, JsonRest, domConstruct,schoolClass, user) {
    //文件路径：widgets.mobile.ClassRoomDtl
    return declare("widgets.mobile.ClassRoomDtl", [View, _ViewMixin], {
        start : 0,
        //  每页显示条数
        pageSize : 10,
        //  赋值页面数据  
        onAfterShow : function () {
            if (window.did) {
                // 加载列表数据
                if (this.storeList.store) {
                    //重新赋值列表并刷新显示
                    this.setQuery();
                } else {
                    //刷新列表数据
                    this.onLoadListData(this.storeList.setStore(this.store, this.getQuery(), {
                        start : this.start,
                        count : this.pageSize
                    }), this.start, this.pageSize);
                }
                //调用讲堂接口获取讲堂数据，然后处理数据
                schoolClass.loadById(window.did).then(lang.hitch(this,function (data) {
                    //创建课程内容显示区域
                    this.classAll = "<div class='classAll none'><div class='classContent' style='line-height: 40px;'></div><div class='listAttachs'></div></div>"
                    //将该区域转换成Dom节点
                    var target = domConstruct.toDom(this.classAll);
                    //查询并得到god节点
                    this.god = query(".god", this.domNode)[0];
                    //将target节点设成god的子节点
                    this.god.appendChild(target);
                    //添加讲堂数据对象
                    var classData = {};
                    //判断数据的存在性
                    if (data && data.data && data.data.item) {
                        //给讲堂数据对象添加属性并传值
                        classData.address = data.data.item.address || "";
                        classData.teacher = data.data.item.teacher || "";
                        classData.title = data.data.item.title||"";
                        this.content = data.data.item.content || "暂无课程内容";
                        //设置日期时间的显示格式
                        classData.startDate = date.formatISODateMinutes(data.data.item.startDate);
                        classData.endDate = date.formatISODateMinutes(data.data.item.endDate);
                        this.startSignDate = data.data.item.startSignDate;
                        this.endSignDate = data.data.item.endSignDate;
                        this.endDate = data.data.item.endDate;
                        this.nowDate=date.nowISOString();
                    }
                    //查询并得到classContent节点
                    var classCon = query(".classContent", this.domNode)[0];
                    //将课程内容简介放入指定区域
                    classCon.innerHTML = this.content;
                    //获取附件列表数据信息
                    var attachList = data.data.item.attachs;
                     //将课程内容的附件列表数据信息放入第二个div区域
                     //判断附件的存在性
                     if(attachList.length!==0){
                         //存在附件的情况下逐条添加
						 var innerHtmlList="";
                        for(var i=0;i<attachList.length;i++){                            
							innerHtmlList+="<div style='height: 45px; line-height: 44px;border-top: 1px solid #ccc;'"+i+"><div style='float:left'>"+attachList[i].title+"</div>"
							+"<div style='float:right'><a  href="+attachList[i].attachUrl+" downLoad="+attachList[i].title+">点击下载</a></div></div>"                            
                        }
                     }else{
                         //不存在附件的情况下给出提示
                         var innerHtmlList="暂无附件列表";
                     }
                    //查询得到listAttachs节点
                    var listAttachs=query(".listAttachs", this.domNode)[0];
                    //将所有附件存入
                    listAttachs.innerHTML=innerHtmlList;
                    //保存讲堂数据对象
                    this.setData(classData);
                    //清空所有状态
                    this.clearSelected();
                    //添加课堂详情的选中状态
                    domClass.add(query(".tab-selector",this.domNode)[0], "selected");
                    //显示课堂详情
                    this.showClassDetail();
                    //刷新数据
                    this.refreshData();
                    //若当前(未登陆或未报名)且当前时间(大于开始报名时间，小于结束报名时间)显示报名按钮高亮否则变暗并且不可点击
                    schoolClass.getAttendState(window.did).then(lang.hitch(this,function(data){
                        var state = data.data.item;
                        var canSign=query(".getSign",this.domNode)[0];
                        var canReport=query(".getReport",this.domNode)[0];
                        if((false==state.isLogin||state.isAttended==false)&&(this.nowDate>this.startSignDate)&&(this.nowDate<this.endSignDate)){
                            //设置可点击状态
                            this.targ=true;
                            domClass.remove(canSign,"bg-gray");
                        }else{
                            //不可报名状态
                            this.targ=false;
                            //不管是否显示为报名字样或未报名字样均变暗
                            domClass.add(canSign,"bg-gray");
                            //若已报名
                            if(state.isAttended==true){
                                //若已报名，显示已报名字样
                                this.isShowSign(true);
                            }else {
                                //显示报名字样
                                this.isShowSign(false);
                            }
                        }
                         //若当前已报名且当前时间(小于结束签到时间)显示报道按钮否则变暗并不可点击----大于开始签到时间
                        if((false==state.isSigned)&&(state.isAttended==true)&&(this.nowDate<this.endDate)){
                            //设置可点击状态
                            this.canReportEvent=true;
                            domClass.remove(canReport,"bg-gray");
                        }else{
                            //变暗
                            domClass.add(canReport,"bg-gray");
                            //设置不可点击状态
                            this.canReportEvent=false;
                        }  
                    }));
                }));
                //查询得到类icon-list-item，作为学生列表节点
                this.stuList=query(".icon-list-item",this.domNode)[0];
                //将类“none”添加到学生列表节点上
                domClass.add(this.stuList,"none");
            }            
        },
        //判断是否已报名，显示已报名按钮，隐藏报名按钮
        isShowSign:function(arg){
            this.getSign=query(".getSign",this.domNode)[0];
            var signValue=this.getSign.childNodes[1];
            if(arg==true){
                signValue.innerHTML="已报名";
            }else{
                signValue.innerHTML="报名";
            }
        },
        //判断是否可以点击报到，变暗、不可点击
        // 创建列表
        onCreatList : function () {
            //实例化一个列表项目对象
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                "class" : "icon-list-item",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0; i < data.length; i++) {
                        //设置学生数据的姓名标签
                        data[i]._label = "<div class='mat-list-margin'>"+((data[i].sName)||"")+ "</div>";
                        //设置学生数据的显示头像
                        if( data[i].userId){
                            data[i]._logo = data[i].userId.logo||"../../static/sites/mobile/images/userIcon.png";
                        }else if( data[i].userId==null){
                             data[i].userId = {};
                             data[i].userId.logo="../../static/sites/mobile/images/userIcon.png";
                             data[i]._logo=data[i].userId.logo;
                        }
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                //查询选项
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap : {_label:"label", _logo:"icon"}
            });
            //配置信息
            this.store = new JsonRest({target : schoolClass.loadStudentsURL()});
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            // 侦听列表下拉事件
            this.centerPanel.on("afterscroll", lang.hitch(this,this.onLoadMore));
        },  
        //初始化界面元素
        onFirstShow : function () {
            //添加头部列表信息框
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    }
                },
                title : "讲堂详情"
            };
            this.addHeader(option);
            //添加显示讲堂详情页面基本内容的列表
            option={
                isEdge : true,
                lists : [{
                    label : "课题:",
                    rightText : '{{title}}'
                }, {
                    label : "主讲人:",
                    rightText : '{{teacher}}'
                }, {
                    label : "开始时间:",
                    rightText : '{{startDate}}'
                }, {
                    label : "结束时间:",
                    rightText : '{{endDate}}'
                }, {
                    label : "授课地址:",
                    rightText : '{{address}}'
                }]
            };
            this.addLists(option);
            // 添加tab-selector页
            option = {
                className:"god",
                columns : [
                    {
                        label : '授课内容',
                        //点击显示课程内容详情
                        onClick :this.changeOnDetail
                    },
                    {
                        label : '上课人',
                        //点击显示学生列表详情
                        onClick :this.changeOnList
                    }
                ],
                labelClass : 'font-size1 tab-selector '
            }
            this.addColumns(option);
            //创建列表
            this.onCreatList();
            //添加底部按钮
            option = {
                columns : [{
                    label : '报名',
                    className : 'flex2 footer-tab-highlight getSign',
                    //添加点击事件
                    onClick : function () {     
                     //添加报名点击函数attend
                        this.attend();
                    }
                },
                {
                    label : '签到',
                    className : 'flex2 footer-tab-dark getReport',
                    //添加签到点击事件
                    onClick : function () {
                        //添加签到函数sign
                        this.sign();
                    }
                }],
				forceWidth : false,
				isFooter : true,
				splitter : '../../static/sites/mobile/images/splitter.jpg'
            }
            this.addColumns(option);
            //初始化界面元素
            this.onAfterShow();
        },
        // 获取查询条件
        getQuery : function () {
            var query = {};
            query._id = window.did || "";
            return query;
        },
        // 重新赋值列表并刷新显示
        setQuery : function(){
            this.start = 0;
            //摧毁原始数据
            this.storeList.destroyDescendants();
            //重新赋值列表
            this.onLoadListData(this.storeList.setQuery(this.getQuery(),{
                start: this.start,
                count: this.pageSize
            }),this.start,this.pageSize);
        },
        // 下拉列表加载更多
        onLoadMore:function(evt){
            if(!this.busy && evt.afterBottom){
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }),this.start,this.pageSize);
                    }), 1000);
                } 
            }
        },
        //清空所有状态
        clearSelected : function () {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                //移除每个节点的selected类
                domClass.remove(items[i], "selected");
            }
        },
        //课程内容详情
        changeOnDetail:function(evt){
            //清空所有状态
            this.clearSelected();
            //添加类selected
            domClass.add(evt.target, "selected");
            //显示课堂详情
            this.showClassDetail();
        },
        //学生列表
        changeOnList:function(evt){
            this.clearSelected();
            domClass.add(evt.target, "selected");
            // 显示学生列表
            this.showStuList();
        },
        //显示课堂详情
        showClassDetail:function(){
             var targ=query(".classAll",this.domNode)[0];
             domClass.remove(targ,"none");
             domClass.add(this.stuList,"none");
        },
        //显示学生列表
        showStuList:function(){
            var targ=query(".classAll",this.domNode)[0];
            domClass.add(targ,"none");
            domClass.remove(this.stuList,"none");
        },
        //报名点击函数
        attend:function(){
            //判断用户是否登录
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    if(this.targ==false){
                        return;
                    }
                    user.getUserInfo().then(lang.hitch(this,function(data){                                           
                        var userInfo=data.data.item;
                        //获取用户数据
                        var argInfo={userId:userInfo._id,  _id:window.did,  sName:userInfo.userName, sPhone:userInfo.phone};
                        //查询用户状态
                        schoolClass.getAttendState(window.did).then(lang.hitch(this,function(data){
                                schoolClass.attend(argInfo).then(lang.hitch(this,function(data1){
                                    if(data1.data.ok==1){
                                        alert("报名成功！");
                                        this.setQuery();
                                        this.onAfterShow();
                                    }else{ 
                                        alert("报名失败！")
                                        this.onAfterShow();
                                    }
                                }));
                        }));
                    }));
                }else{
                    alert("请先登录");
                    window.moveToView("login");
                    user.nextPage="classRoomDtl-"+window.did;
                }
            }));
            this.refreshData();
        },
        sign:function(){
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    if(this.nowDate<this.endSignDate){
                        alert("报名时间未结束,不能报到");
                        return;
                    }
                    if(this.canReportEvent==false){
                        return;
                    }
                    user.getUserInfo().then(lang.hitch(this,function(data){
                        var userInfo=data.data.item;
                        var repInfo={userId:userInfo._id,_id:window.did};
                        //获取用户状态
                        schoolClass.getAttendState(window.did).then(lang.hitch(this,function(data){
                            if(data.data.item.isSigned==true){
                                alert("您已经签到！")
                            }else{
                                schoolClass.sign(repInfo).then(lang.hitch(this,function(data2){
                                    if(data2.data.ok==1){
                                        alert("签到成功!");
                                        this.onAfterShow();
                                    }else{
                                        alert("签到失败，您暂未报名本课堂！");
                                        this.onAfterShow();
                                    }
                                }));
                            }
                        }));
                    }));
                }else{
                    alert("请先登录");
                    window.moveToView("login");
                    user.nextPage="classRoomDtl-"+window.did;
                }
            }));
        },
        car:function(){
            return false;
        }
    });
});