// 变更人员： 潘云
// 变更内容： 讲堂列表
// 变更时间： 2016/7/1
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/query",
    "dojo/dom-class",
    "dojo/on",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "cq/biz/article/bs/schoolClass"
], function (declare, lang, array, domStyle, query, domClass, on, JsonRest, registry, View, EdgeToEdgeStoreList, _ViewMixin, date, schoolClass) {
    return declare("widgets.mobile.ClassRoomList", [View, _ViewMixin], {
        // 设置初始显示第0行
        start : 0,
        pageSize : 10,
        // 加载数据,并显示到页面上
        onAfterShow : function () {
            if (this.storeList.store) {
                this.setQuery();
            } else {
                this.onLoadListData(this.storeList.setStore(this.store, this.getQuery(), {
                    start : this.start,
                    count : this.pageSize
                }), this.start, this.pageSize);
            }
        },
        // 创建列表
        onCreatList : function () {
            this.storeList = new EdgeToEdgeStoreList({
                append : true,
                constraint : false,
                query : {},
                "class" : "icon-list-item classroomList-ul-bg",
                variableHeight : true,
                //获取数据完成后调用的的处理方法
                onComplete : lang.hitch(this, function (data) {
                    for (var i = 0; i < data.length; i++) {
                        data[i].startDate = data[i].startDate?date.formatISODateMinutes(data[i].startDate):"";
                        data[i]._label = "<div><div class = 'classroomList-name'>" + (data[i].title||"")+"</div><div class = 'classroomList-remark'>"+data[i].startDate+"</div></div>";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                itemMap : {_label:"label"}
            });
            this.store = new JsonRest({target : schoolClass.loadUrl()});
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            // 侦听列表点击事件
            this.storeList.on("click", lang.hitch(this,this.onClickList));
            // 侦听列表下拉事件
            this.centerPanel.on("afterscroll", lang.hitch(this,this.onLoadMore));
        },
        //初始化页面元素,绑定事件
        onFirstShow : function () {
            var option = {
                src : "http://192.168.0.2/static/sites/mobile/images/classRoomList.png"
            }
			this.addImage(option);
            option = {
                className : 'classroomList-tab',
                columns : [{
                    label : '课程预告',
                    className : 'flex1 classroomList-tableft',
                    onClick : lang.hitch(this,function(e){
                        this.type = 0;
                        this.selectClass(e);
                        this.onAfterShow();
                    })
                }, {
                    label : '全部课程',
                    className : 'flex1 classroomList-tabright',
                    onClick:lang.hitch(this,function(e){
                        this.type = 1;
                        this.selectClass(e);
                        this.onAfterShow();
                    })
                }],
                forceWidth : false,
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            
            
            domClass.add(query('.tab-selector', this.domNode)[0], "classroomList-selected");
            this.onCreatList();
            this.onAfterShow();
        },
        // 清除所有的样式
        selectClass : function (evt) {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "classroomList-selected");
            }
            domClass.add(evt.target, "classroomList-selected");
        },
        // 订单列表点击
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _tsId = li._id;
            window.moveToView("classRoomDtl",_tsId);
        },
        // 获取查询条件
        getQuery : function () {
            var query = {};
            if (this.type === 0 || !this.type){
                query.isUse = true;
                query.orderBy = "startDate";
                query.afterStartDate = date.nowISOString();
            }
            if (this.type === 1){
                query.isUse = true;
            }
            return query;
        },
        // 重新赋值列表并刷新显示
        setQuery : function(){
            this.start = 0;
            this.storeList.destroyDescendants();
            this.onLoadListData(this.storeList.setQuery(this.getQuery(),{
                start: this.start,
                count: this.pageSize
            }),this.start,this.pageSize);
        },
        // 下拉列表加载更多
        onLoadMore:function(evt){
            if(!this.busy && evt.afterBottom){
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)) {
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        this.onLoadListData(this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        }),this.start,this.pageSize);
                    }), 1000);
                }
                
            }
        }
    });
});