//创建人：周超  创建时间： 模块名称：我的伙伴 
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/Deferred",
	"dojox/mobile/View",			
	"dojo/store/JsonRest",
	"cq/ui/view/_ViewMixin",
	"cq/biz/mat/mat",
	"dojo/topic",
    "dojo/dom-attr",
	"dojo/dom-style",
	"dojo/query",
    "dojo/dom-construct",
	"dojo/_base/array",
	"dojox/mobile/EdgeToEdgeStoreList",
	"cq/biz/user/user",
    "cq/biz/mk/card",
	"cq/biz/ts/dis_income_d",
	"cq/util/sys/date"
], function(declare, lang, Deferred, View, JsonRest, _ViewMixin, mat, topic, domAttr, domStyle, query, domConstruct, array, EdgeToEdgeStoreList, user, card, dis_income_d, date) {
	//路径：
	//	widgets.mobile.ClientDistribute
	
    return declare("widgets.mobile.ClientDistribute", [View, _ViewMixin], {
		typeValue:1,
		typeValueT:1,
		//indexElement:
		//		参数：无
		//		返回值：无
		indexElement:function(){
            this.clientDisScroll = this.centerPanel;
		},
		//submitChange：
		//		参数：无
		//		返回值：无
		//		点击提交，兑换积分
		submitChange:function(){
			//获取兑换收入节点
			var exchangeIncome=this.getData().cgIncome;
			//获取可兑换数量节点
			var allIncome=this.getData().disRaiseableAmt;
            exchangeIncome = parseInt(exchangeIncome);
			//获取兑换点数的值
			if(!exchangeIncome){
				alert("请输入兑换数量");
			}else if(!isNaN(exchangeIncome)){
				var amt = parseFloat(exchangeIncome),
				//maxAmt = parseFloat(this.mblTextBox);
				maxAmt=parseFloat(allIncome);
				//NAN
				if(maxAmt===0){
					alert("可提现数量为0，无法兑换");
				}else if(amt>maxAmt){
					alert("可兑换数量小于您输入的数量！");
				}else{
					//调用函数,异步刷新
					user.exchangeDisAmount({amount:amt}).then(lang.hitch(this,function(result){	
						this.setQuery();
					}));
				}
			}else{
				alert("兑换失败！请确认输入格式！");
			}
		},
		//parseReason：
		//		参数：reasonId，类型：int
		//		返回值：String
		//		下拉列表收入类型显示
		parseReason:function(reasonId){
			var reason="";
			var reasons={
				"1":'新关注',
				"2":'分销收益',
				"3":'转积分',
				"4":'微信提现'
			};
			reason=reasons[reasonId]||"未知";
			return reason;
		},
		//dropDown：
		//		参数：cn，类型：String
		//		隐藏/显示下拉列表lists
        dropDown: function(cn){
			//获取节点
			var target = query("." + cn, this.domNode)[0];
			//获取显示情况
			var di = domStyle.get(target, 'display');
			//设置显示/隐藏
			domStyle.set(target, 'display', di=='none'?'block':'none');
        },
		//rotatPicture：
		//		参数：cn，类型：节点类型
		//		返回值：无
		//		旋转图片
		rotatPicture:function(cn){
		    //var target=query(".mblSpriteIcon",this.domNode)[0];
		    //var pi=domStyle.get(target,'transform');
			var target=query(".mblSpriteIcon", cn.parentNode)[0];
			if(this.typeValue==1){
				domStyle.set(target,"transform","rotate(-90deg)");
				this.typeValue=0;
			}else{
				//domStyle.set(target,'transform',pi=='rotate(-90deg)'?'rotate(-270deg)':'rotate(-90deg)'); 
				domStyle.set(target,"transform","rotate(-270deg)");
				this.typeValue=1;
			} 
		},
		rotatPictureT:function(cn){
			var target=query(".mblSpriteIcon", cn.parentNode)[0];
			if(this.typeValueT==1){
				domStyle.set(target,"transform","rotate(-90deg)");
				this.typeValueT=0;
			}else{
				domStyle.set(target,"transform","rotate(-270deg)");
				this.typeValueT=1;
				
			} 
		},
		//onCreatList：
		//		参数：无，
		//		返回值：无
		//		创建显示列表
		onCreatList: function(){
			this.storeList=new EdgeToEdgeStoreList({
				append: true, 
				constraint: false, 
				query:{}, 
				class:"icon-list-item",
				variableHeight:true,

				//获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){	
						//日期格式
						var imdate = data[i].createAt?date.formatISODate(data[i].createAt):"";
						data[i]._label="<div class='hflex'><div class='full-width h-center flex1'>"+data[i].outAmt+"</div><div class='full-width h-center flex1'>"+imdate+"</div><div class='full-width h-center flex1'>"+this.parseReason(data[i].incomeType)+"</div></div>";																	
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				itemMap:{_label:"label"}
			});
			//获取用户id
			this.getuserId=user.getCurrentUserId();
			//添加到兑换记录节点后面
			this.storeList.placeAt(this.incomeCol,"last");
		},
		//onFirstShow:
		//		参数：无
		//		返回值：无
		//		初始化界面元素
        onFirstShow: function() {
            var option = {
                columns: [{
                    icon: '/static/images/mobile/main1.png',
                    iconClass: 'footer-tab-img',
                    className: 'footer-tab-col-normal',
                    label: '首页',
                    onClick: function() {
                        window.moveToView("main");
                    }
                },{
                    icon: '/static/images/mobile/contact1.png',
                    iconClass: 'footer-tab-img',
                    //footer栏字幕显示
                    label: '动态',
                    className: 'footer-tab-col-normal',
                    onClick: function() {
                        //客户端以后都用window.moveToView来完成点击功能
                        window.moveToView("newsList");
                    }
                },{
                    icon: '/static/images/mobile/orderCar1.png',
                    iconClass: 'footer-tab-img',
                    label: '购物车',
                    //设置购物车右上角的数字
                    isBadge: true,
                    badgeClass: 'orderCarNum',
                    className: 'footer-tab-col-normal',
                    onClick: function() {
                        window.moveToView("orderCar");
                    }
                },{
                    icon: '/static/images/mobile/user1.png',
                    iconClass: 'footer-tab-img',
                    label: '我的信息',
                    className: 'footer-tab-col-normal',
                    onClick: function() {
                        window.moveToView("user");
                    }
                }],        			
                labelClass: 'font-size1',
                className: 'fix-footer',
				forceWidth: true,
                //设置成底部，不设置此属性则跟着上面的模块一次添加
                isFooter: true
            };
			//添加底部栏
            // this.addColumns(option);
            this.addFooterColumns();
			//累计收入--标题
            option = {
                columns: [{
                    label: '累计收入',
                    className: 'flex1'								
				}],
                forceWidth: false,
				labelClass:'color-h font-size3 margin-top18'
            };
			//添加标题栏
            this.addColumns(option);
            //addColumns1
            option = {
                columns: [{
                    label: '0.00',
                    className: 'flex1'
				}],
                forceWidth: false,
				labelClass:'color-h font-size4 margin-top24'
            };
            this.allAmtData=this.addColumns(option);
			//点击申请兑换之后的lists/*	
			option={
				isEdge:true,
				class:'convertWay',
				lists:[{
                    label:"可提现余额",
                    rightText:"{{disRaiseableAmt}}"
                },{
					label:'兑换方式',
					rightText:'兑换积分'
				}]
			};
			this.convertWay=this.addLists(option);
			//事先需要隐藏的lists
			domStyle.set(this.convertWay.domNode,"display","none");
			//兑换收入--隐藏
			option={
				isEdge:true,
				class: "bottom-margin16 cashIncome",
				lists:[{
					label:'兑换收入',
					edit : {type : 'text', field : 'cgIncome', placeHolder : '必填'}
				}]
			};
			this.cashIncome=this.addLists(option);
			//申请兑换--操作columns
			option = {
                isEdge:true,
                className: "bottom-margin16 operation",
                columns:[{
                    label:"<div class='li-right-div color-bg-h color-white h-center li-center-div'>" + '返回' + "</div>",
                    onClick: lang.hitch(this, function(){
                        this.type='';
                        this.onChangeType();
                    })				
                },{
                    label:"<div class='li-right-div color-bg-h color-white h-center li-center-div'>" + '提交' + "</div>",
                    onClick: function() {
                        this.submitChange();
                    }
                }],
                forceWidth: true,	
            };
            this.operation=this.addColumns(option);
			//兑换记录lists
			option={
				isEdge:true,
				class: "bottom-margin16 forRecord",
				lists:[{
					label:'兑换记录',
					rightText: '',
					noArrow: false,
					moveTo: "#",
                    onClick: lang.hitch(this, function() {
						if(domStyle.get(this.storeList.domNode, 'display')=='none'){
							domStyle.set(this.storeList.domNode,'display','block');
							domStyle.set(this.incomeCol,'display','block');
						} else {
							domStyle.set(this.storeList.domNode,'display','none');
							domStyle.set(this.incomeCol,'display','none');
						}
                    })
				}]
			};
			this.forRecord=this.addLists(option);
			//以addcolumns方式作为列表头	
			option = {
                columns: [{
                    className: 'flex1',
                    label: '兑换数量',
                },{
                    label: '时间', 
                    className: 'flex1',
                },{
                    label: '类型',
                    className: 'flex1',
                }],

                labelClass: 'font-size3 margin-top18',
                //className: 'fix-footer',
				forceWidth: true,
            };
            this.incomeCol=this.addColumns(option);
			//创建显示列表
			this.onCreatList();
			//我的二维码lists：myCode
            option = {
                isEdge: true,
                class: "bottom-margin16 myCode",
                lists: [{
                    class: "myCode",
                    label:'我的二维码',
                    rightText: '',
                    //箭头
                    noArrow: false,
                    moveTo: "#"
                }]
            };
            this.myCode=this.addLists(option);
			//我的粉丝数lists：myFans
            option = {
                isEdge: true,
                class: "bottom-margin16 allFansData",
                lists: [{
					icon:'http://w.cqthink.com/w/Content/standardTmp01/images/more11.png',	
                    iconPos: '0,0,29,29',
                    label: '我的粉丝数',
                    //右边的话 应该是一张图片
					moveTo: "#",
                    rightText: "<div class='li-right-div color-bg-h color-white h-center'>" + '0人' + "</div>",
                    noArrow: true
                }]
            };
			//this.rotatPicture('mblSpriteIcon');
            this.allFansData=this.addLists(option);	
			//我的粉丝数下拉lists
            option = {
				isEdge: true,
                class: "bottom-margin16 downOne",
                lists: [{
                    label: '&nbsp;&nbsp;一级粉丝数',
                    edit : {type : 'text', field : 'fansNum1', disabled:'true'},
                    noArrow: true,

                }, {
                    label: '&nbsp;&nbsp;二级粉丝数',
                    edit : {type : 'text', field : 'fansNum2', disabled:'true'},
                    noArrow: true
                }, {
                    label: '&nbsp;&nbsp;三级粉丝数',
                    edit : {type : 'text', field : 'fansNum3', disabled:'true'},
                    noArrow: true
                }]
            };
            this.downOne = this.addLists(option);
			domStyle.set(this.downOne.domNode,"display","none");
            domStyle.set(query(".downOne",this.domNode)[0].children[0],"color","black");
            domStyle.set(query(".downOne",this.domNode)[0].children[1],"color","black");
            domStyle.set(query(".downOne",this.domNode)[0].children[2],"color","black");
			//累计收入lists
            option = {
                isEdge: true,
                class: "bottom-margin16 allAmtDataT",
                lists: [{
					icon:'http://w.cqthink.com/w/Content/standardTmp01/images/more11.png',
                    iconPos: '0,0,29,29',
                    //callback: function() {},
                    label: '累计收入',    
                    rightText: "<div class='li-right-div color-bg-h color-white h-center'>" + '0.00个' + "</div>",                   
  				    noArrow: true,
                    moveTo: "#"
                }]
            };
            this.allAmtDataT=this.addLists(option);
		    //累计收入下拉lists
            option = {
                isEdge: true,
                class: "bottom-margin16 downTwo",
                lists: [{
                    label: '&nbsp;&nbsp;待确认收入',
                    //rightText: '0.00个',                   
                    noArrow: true,
					edit : {type : 'text', field : 'disPenddingAmt', disabled:'true'},
                    onClick: function() {
                        window.moveToView("orderList");
                    }
                }, {
                    label: '&nbsp;&nbsp;已提现收入',
                    //rightText: '0.00个',
                    noArrow: true,
					edit : {type : 'text', field : 'disRecieptAmt', disabled:'true'},
                    onClick: function() {
                        window.moveToView("orderList");
                    }
                }, {
                    label: '&nbsp;&nbsp;可提现数量',
                    //rightText: '0.00个',
					edit : {type : 'text', field : 'disRaiseableAmt', disabled:'true'},                    
                    noArrow: true,
                    //onClick: function() {}
                }]
            };
            this.downTwo = this.addLists(option);
			domStyle.set(this.downTwo.domNode,"display","none");
            domStyle.set(query(".downTwo",this.domNode)[0].children[0],"color","black");
            domStyle.set(query(".downTwo",this.domNode)[0].children[1],"color","black");
            domStyle.set(query(".downTwo",this.domNode)[0].children[2],"color","black");
			//申请兑换lists
            option = {
                isEdge: true,
                class: "bottom-margin16 forChange",
                lists: [{
                    iconPos: '0,0,29,29',
                    label: '&nbsp;&nbsp;申请兑换',
                    //右边图
                    rightText: '',
                    noArrow: false,
                    moveTo: "#",
					field : 'code',
					onClick: lang.hitch(this, function(evt){
						//var allLists=['myCode','convertWay']
						this.type=1;
                        this.onChangeType();
                    })
                }]
            };
            this.forChange=this.addLists(option);
            //每次firstShow时侦听广播
            this.subscribe("cq/biz/ts/cart/numChanged", function(num) {
                this.matNumNode.innerHTML = num;
            });
            this.indexClientDistributeElement();
            this.initClientDistributeEvent();
			this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.connectEvent();
			this.onAfterShow();
        },
        indexClientDistributeElement:function(){
            //创建二维码名片节点
            var backgroundDivNode = domConstruct.create("div",{
                style:'width:100%;height:100%;background-color:rgba(0,0,0,0.5);z-index:998;position: absolute;visibility:hidden;',class:"backgroundDiv",id:"backgroundDiv"
            },document.body,"first");
            
            var imgNode = domConstruct.create("img",{
                style:'width:80%;z-index:999;margin: 52px 10% 0;position:relative;',class:"concelQRImg"
            });
            backgroundDivNode.appendChild(imgNode);
            
            var circleNode = domConstruct.create("div",{
                class:"sk-fading-circle",style:"visibility:hidden;z-index:998;",
                innerHTML:'<div class="sk-circle1 sk-circle"></div><div class="sk-circle2 sk-circle"></div><div class="sk-circle3 sk-circle"></div><div class="sk-circle4 sk-circle"></div><div class="sk-circle5 sk-circle"></div><div class="sk-circle6 sk-circle"></div><div class="sk-circle7 sk-circle"></div><div class="sk-circle8 sk-circle"></div><div class="sk-circle9 sk-circle"></div><div class="sk-circle10 sk-circle"></div><div class="sk-circle11 sk-circle"></div><div class="sk-circle12 sk-circle"></div>'
            });
            backgroundDivNode.appendChild(circleNode);
            
            var buttonNode = domConstruct.create("div",{
                innerHTML:"<span style='width:100%;z-index:999;color: #e5004f;font-size:14px;line-height:36px;'>重新获取二维码</span>",
                style:'width:80%;z-index:999;display:none;background-color: #fff;height:36px;text-align:center;margin: 0 10%;',
                class:'getQRCode'
            });
            backgroundDivNode.appendChild(buttonNode);
        },
        
        initClientDistributeEvent:function(){
            //"我的二维码"监听
            this.connect(query(".myCode",this.domNode)[0],"onclick",function(e){
                //可视窗的宽高
                var concelQRImgNode = query(".concelQRImg",document.body)[0];
                var getQRCodeNode = query(".getQRCode",document.body)[0];
                var backgroundDivNode = query(".backgroundDiv",document.body)[0];
                //调用接口
                card.getDisCard().then(lang.hitch(this,function(result){
                    if(result.data.ok === 0){
                        alert(result.data.msg || "数据错误!");
                    }else {
                        domAttr.set(concelQRImgNode,"src",result.data.item.url);
                        domStyle.set(backgroundDivNode,{"visibility":"visible"});
                        domStyle.set(concelQRImgNode,{"visibility":"visible"});
                        domStyle.set(getQRCodeNode,{"display":"block"});
                    }
                }));
            });
            //"图片弹出重新获取二维码"监听事件
            this.connect(query(".getQRCode")[0],"onclick",function(e){
                card.getDisCard().then(lang.hitch(this,function(result){
                    if(result.data.ok === 0){
                        alert(result.data.msg || "数据错误!");
                        domStyle.set(query(".sk-fading-circle",document.body)[0],"visibility","hidden");
                        domStyle.set(query(".concelQRImg",document.body)[0],"visibility","hidden");
                        domStyle.set(query(".backgroundDiv",document.body)[0],"visibility","hidden");
                        domAttr.set(query(".getQRCode",document.body)[0],"display","none");
                    }else {
                        domAttr.set(concelQRImgNode,"src",result.data.item.url);
                        domStyle.set(backgroundDivNode,{"visibility":"visible"});
                        domStyle.set(concelQRImgNode,{"visibility":"visible"});
                        domStyle.set(getQRCodeNode,{"display":"block"});
                    }
                }));
            });
            
            //"图片弹出取消"监听事件
            this.connect(query(".concelQRImg")[0],"onclick",function(e){
                domStyle.set(query(".concelQRImg",document.body)[0],"visibility","hidden");
                domStyle.set(query(".backgroundDiv",document.body)[0],"visibility","hidden");
                domAttr.set(query(".getQRCode",document.body)[0],"display","none");
            });
        },
        connectEvent:function(){
            this.connect(query(".allFansData",this.domNode)[0],"onclick",this.paddingOne);
            this.connect(query(".allAmtDataT",this.domNode)[0],"onclick",this.paddingTwo);
        },
        paddingOne:function(e){
            var dom = e.target;
            if(dom){
                this.dropDown('downOne');
                //获取节点
                this.rotatPictureT(dom); 
            }
        },
        paddingTwo:function(e){
            var dom = e.target;
            if(dom){
                //if ((e.target||window.event.srcElement).tagName.toLowerCase() === 'span') 
                this.dropDown('downTwo');
                //query(".mblListItemIcon",query(".li-right-div", this.allAmtDataT.domNode)[0])
                this.rotatPicture(dom); 
            }
        },
		//onAfterShow:
		//		参数：无
		//		返回值：无
		//		给界面赋值数据
		onAfterShow:function(){
			user.hasLogin().then(lang.hitch(this,function(s){
				if(s){
					this.onChangeType();
				    user.loadUserInformation().then(lang.hitch(this,function(data){
						var ddi=data.data.item;
						//添加变量，赋值
						ddi.allfansNum=ddi.fansNum1+ddi.fansNum2+ddi.fansNum3;
                        ddi.disRaiseableAmt = parseFloat(ddi.disRaiseableAmt||0,10).toFixed(2);
						this.setData(ddi);
						//累计收入--标题
						query(".font-size4", this.allAmtData)[0].innerText = ddi.disTotalIncome;
						//累计收入
						query(".li-right-div", this.allAmtDataT.domNode)[0].innerText = ddi.disTotalIncome+'元';
						query(".li-right-div", this.allFansData.domNode)[0].innerText = ddi.allfansNum+"人";
						this.refreshData();
					}));
                } else {
                    window.moveToView("login");
                    user.nextPage="clientDistribute";
                }
            }));
		},
		//showDatacl:
		//		参数：arg，类型：String
		//		返回值：无
		//		部分界面元素的显示/隐藏
		showDatacl:function(arg){
			domStyle.set(this.convertWay.domNode,"display",arg);
			domStyle.set(this.cashIncome.domNode,"display",arg);
			domStyle.set(this.operation,"display",arg);
			domStyle.set(this.forRecord.domNode,"display",arg);
			domStyle.set(this.incomeCol,"display",arg);
			domStyle.set(this.storeList.domNode,'display',arg);
		},
		//disDatacl:
		//		参数：arg，类型：String
		//		返回值：无
		//		部分界面元素的显示/隐藏
		disDatacl:function(arg){
			domStyle.set(this.myCode.domNode,"display",arg);
			domStyle.set(this.allFansData.domNode,"display",arg);
			domStyle.set(this.allAmtDataT.domNode,"display",arg);
			domStyle.set(this.forChange.domNode,"display",arg);
		},
		//showDown:
		//		参数：arg，类型：String
		//		返回值：无
		//		下拉单在大页面显示隐藏切换时的处理
		showDown:function(arg){
			domStyle.set(this.downOne.domNode,"display",arg);
			domStyle.set(this.downTwo.domNode,"display",arg);
		},
		//onChangeType:
		//		参数：无
		//		返回值:无
		//		界面元素显示/隐藏的处理
		onChangeType:function(){
			//点击申请兑换
			if(this.type==1){
				this.showDatacl("block");
				this.disDatacl("none");
				this.showDown("none");
			} else {
				this.showDatacl("none");
				this.disDatacl("block");
				//domStyle.set(this.downTwo.domNode,"display","block");
                this.setQuery();
			}			
		},
		onLoadMore:function(evt){												
			if(this.busy||(0<this.end&&(this.start+10-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多商品");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
                    this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: 10
					}).then(lang.hitch(this,function(){
						this.centerPanel.resize();
					}));
				}), 1000);
			}
		},
        setQuery:function(){
            this.start = 0;
            this.end = -1;
            if(this.storeList.store){
                this.storeList.destroyDescendants();
                this.storeList.setQuery({
                    userId:user.getCurrentUserId(),
                    incomeType:3
                });
            }else{
                this.storeList.setStore(new JsonRest({
                    target:dis_income_d.load_by_userId()
                }),{
                    userId:user.getCurrentUserId(),
                    incomeType:3
                },{
                    start:this.start,
                    count:20
                });
            }
        }
    });
});