define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dojo/ready",
    "dojox/mobile/ListItem",
    "dojox/mobile/parser",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ScrollableView",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/user/user",
    "cq/biz/user/care",
    "dojo/dom-class"
],function(declare,lang,array,View,_ViewMixin,query, ready, ListItem,parser,EdgeToEdgeStoreList,ScrollableView,on,when,JsonRest,user,care,domClass){
    return declare("widgets.mobile.DstbtList",[View,_ViewMixin],{
        //设置每个List的数据的开始下标，分别对应的是关怀榜，爱心榜，人气榜
        start:0,
        pagesize:20,
        start1:0,
        pagesize1:20,
        start2:0,
        pagesize2:20,
        //初始化相关接口
        indexElement:function(){
            this.matListScroll = this.centerPanel;
        },

        //改变标签的样式,通过window.did的值判断标签的选中样式
        changeOnAll:function(){
            //将所有的标签样式都设置为未选中
            array.forEach(query(".tab-selector",this.domNode),function(list){
                domClass.remove(list,"selected");
            });
            //通过window.did的值设置选中的标签样式
            if(!window.did){
                domClass.add(query('.tab-selector',this.domNode)[0],"selected");
            }else{
                domClass.add(query('.tab-selector',this.domNode)[parseInt(window.did)],"selected");
            }
        },
        onAfterShow:function(){
            //改变标签的选中样式
            this.changeOnAll();
            this.onShowList();
            //this.onCreatList();
        },

        onFirstShow:function(){
            option = {
                columns:[
                    {
                        label:'关怀榜',
                        onClick:lang.hitch(this,function(e){
                            window.moveToView("dstbtList");
                        })
                    },
                    {
                        label:'爱心榜',
                        onClick:lang.hitch(this,function(e){
                            window.moveToView("dstbtList","1");
                        })
                    },
                    {
                        label:'人气榜',
                        onClick:lang.hitch(this,function(e){
                            window.moveToView("dstbtList","2");
                        })
                    }
                ],
                labelClass:'font-size1 tab-selector'
            }
            this.addColumns(option);


            //创建关怀榜的list
            this.onCreateList0();
            //创建爱心榜的list
            this.onCreateList1();
            //创建人气榜的list
            this.onCreateList2();
            //控制显示那个List
            this.onShowList();
            //改变选中的样式
            this.changeOnAll();
        },

        //控制显示不同的list,通过window.did
        onShowList:function(){
            if(window.did==="1"){
                this.scrollableView1.show();
            }else if(window.did==="2"){
                this.scrollableView2.show();
            }else{
                this.scrollableView.show();
            }
        },

        //创建关怀榜List
        onCreateList0:function(){
            //创建ScrollableView
            this.scrollableView=new ScrollableView();

            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"dstbtList care",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        //如果logo不存在，设置一个默认的
                        if(!data[i].logo){
                            data[i].logo="http://log.cqthink.com/static/upload/cqthink/010/f60d2927a35d0235490136ef9f4953b7ee453073794bcaf153d20a64544ea";
                        }
                        data[i]._label= "<div><img class='logo' src='"+data[i].logo+"'></div>" +
                            "<div class='username '>"+data[i].userId.pName+"</div>" +
                            "<div class='office-position'>"+data[i].remark+"</div>"
                        //data[i].moveTo="#"
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pagesize,
                    start: this.start
                },
                itemMap:{_label:"label"}
            });
            //创建数据源
            this.store = new JsonRest({target:care.loadUrl()});
            // 将数据源赋值给storeList
            this.storeList.setStore(this.store);
            //设置爱心榜List拖动加载更多
            on(this.scrollableView,"afterscroll",lang.hitch(this,this.onLoadMore));

            this.scrollableView.addChild(this.storeList);
            this.scrollableView.placeAt(this.matListScroll.containerNode,"last");
            this.scrollableView.resize();
        },
        
        //关怀榜拖动加载更多
        onLoadMore:function(evt){
            if(this.busy||(0<this.end&&(this.start+this.pagesize-1>this.end))){
                return true;
            }
            if(evt.afterBottom){
                this.start = this.end+1;
                console.log("加载更多信息");
                this.busy = true;
                setTimeout(lang.hitch(this,function(){
                    when(this.storeList.setQuery(null,{
                        start: this.start,
                        count: this.pagesize
                    }), lang.hitch(this,function(){
                        this.scrollableView.resize();
                    }));
                }), 1000);
            }
        },

        //创建爱心榜List
        onCreateList1:function(){
            //创建ScrollableView
            this.scrollableView1=new ScrollableView();
            this.storeList1=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"dstbtList love",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        //如果logo不存在，设置一个默认的
                        if(!data[i].logo){
                            data[i].logo="http://log.cqthink.com/static/upload/cqthink/010/f60d2927a35d0235490136ef9f4953b7ee453073794bcaf153d20a64544ea";
                        }
                        data[i]._label="<div>"+(this.start1+i+1)+"</div>" +
                            "<div><img class='logo' src='"+data[i].logo+"'/></div>" +
                            "<div>"+data[i].pName+"</div>" +
                            "<div class='num'>"+data[i].disTotalIncome+"</div>"
                        //data[i].moveTo="#"
                    }
                    this.storeList1.generateList(data);
                    this.end1=this.start1+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pagesize1,
                    start: this.start1
                },
                itemMap:{_label:"label"}
            });
            //创建数据源
            this.store = new JsonRest({target:user.loadLoves()});

            // 将数据源赋值给storeList
            this.storeList1.setStore(this.store);
            on(this.scrollableView1,"afterscroll",lang.hitch(this,this.onLoadMore1));

            this.scrollableView1.addChild(this.storeList1);
            this.scrollableView1.placeAt(this.matListScroll.containerNode,"last");
            this.scrollableView1.resize();
        },

        //爱心榜拖动加载更多
        onLoadMore1:function(evt){
            if(this.busy||(0<this.end1&&(this.start1+this.pagesize1-1>this.end1))){
                return true;
            }
            if(evt.afterBottom){
                this.start1 = this.end1+1;
                console.log("加载更多信息");
                this.busy = true;
                setTimeout(lang.hitch(this,function(){
                    when(this.storeList1.setQuery(null,{
                        start: this.start1,
                        count: this.pagesize1
                    }), lang.hitch(this,function(){
                        this.scrollableView1.resize();
                    }));
                }), 1000);
            }
        },
        //人气榜
        onCreateList2:function(){
            //创建ScrollableView
            this.scrollableView2=new ScrollableView();
            this.storeList2=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"dstbtList human",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        //如果logo不存在，设置一个默认的
                        if(!data[i].logo){
                            data[i].logo="http://log.cqthink.com/static/upload/cqthink/010/f60d2927a35d0235490136ef9f4953b7ee453073794bcaf153d20a64544ea";
                        }
                        data[i]._label="<div>"+(this.start2+i+1)+"</div>" +
                            "<div><img class='logo' src='"+data[i].logo+"'/></div>" +
                            "<div>"+data[i].pName+"</div>" +
                            "<div class='num'>"+data[i].fansNum1+"</div>"
                        //data[i].moveTo="#"
                    }
                    this.storeList2.generateList(data);
                    this.end2=this.start2+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pagesize2,
                    start: this.start2
                },
                itemMap:{_label:"label"}
            });
            //创建数据源
            this.store = new JsonRest({target:user.loadFans()});

            // 将数据源赋值给storeList
            this.storeList2.setStore(this.store);
            on(this.scrollableView2,"afterscroll",lang.hitch(this,this.onLoadMore2));

            this.scrollableView2.addChild(this.storeList2);
            this.scrollableView2.placeAt(this.matListScroll.containerNode,"last");
            this.scrollableView2.resize();
        },

        //加载更多人气榜
        onLoadMore2:function(evt){
            if(this.busy||(0<this.end2&&(this.start2+5-1>this.end2))){
                return true;
            }
            if(evt.afterBottom){
                this.start2 = this.end2+1;
                console.log("加载更多信息");
                this.busy = true;
                setTimeout(lang.hitch(this,function(){
                    when(this.storeList2.setQuery(null,{
                        start: this.start2,
                        count: this.pagesize2
                    }), lang.hitch(this,function(){
                        this.scrollableView2.resize();
                    }));
                }), 1000);
            }
        }

    });
});
