define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dojo/query",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/store/JsonRest",
	"cq/biz/mat/mat",
	"dojo/dom-class",
	"dojo/on",
	"cq/biz/shop/shop",
	"dojo/when",
	"dojox/mobile/ListItem",
	"dijit/registry",
    "cq/biz/user/expert",
    "dojox/mobile/ContentPane",
	], function (declare, lang, View, _ViewMixin,query,EdgeToEdgeStoreList,	JsonRest,mat,domClass,on,shop,when,ListItem,registry,expert,ContentPane) {
		
	//路径：
	//	widgets.mobile.ClientDistribute
	return declare("widgets.mobile.ExpertDetail", [View, _ViewMixin], {		
		onAfterShow : function () {				
			expert.loadById(window.did).then(lang.hitch(this, function(data) {
                this.setData(data && data.data && data.data.item || {});
				if(data&&data.data&&data.data.item){
					this.getShopInfo(data.data.item);
					this.createPersonInfo(data.data.item);
				}
                this.refreshData();
              }))
		},        
        createPersonInfo:function(data){
            if(this.dtlPane){
                this.dtlPane.destroyRecursive();
            }
            if(!data.resumes){
                data.resumes="暂无数据";
            }
            var contentHtm="<div>&nbsp;</div><div class='content'>&nbsp;&nbsp"+data.resumes+"</div><div>&nbsp;</div>";
            this.dtlPane=new ContentPane({
						content:contentHtm,
						className:"dtlnew_view dtl-content-pane"
                });
            this.dtlPane.placeAt(this.personalInfo.containerNode,"last");
        },
		//getShopInfo：
		//		参数：arg 
		//		返回值：无
		//		获取数据并显示当前商铺信息
		getShopInfo:function(arg){
			//销毁原shop信息
			this.shopInfo.destroyDescendants();
                if(!arg.duty){
                    arg.duty=" ";
                }if(!arg.address){
                    arg.address=" ";
                }if(!arg.pName){
                    arg.pName=" ";
                }if(!arg.logo){
                    arg.logo="/static/images/mobile/userIcon.png";
                }
			//创建shop信息
			var listitem=new ListItem({
						label:"<div><div class='inline-block expertLogo'><img src='"+arg.logo+"'/></div>"
							 +"<div class='inline-block expertInfo'><div class='mat-list-mname mat-list-margin'>姓名:"+arg.pName+"</div>"
							 +"<div class='mat-list-qty mat-list-margin'>职务:"+arg.duty+"</div>"
							 +"<div class='mat-list-qty mat-list-margin'>地址:"+arg.address+"</span></div></div><div>",
						variableHeight:true
						});
			this.shopInfo.addChild(listitem);			
		},
		//店铺简介
		getShopAbstract:function(arg){
			//销毁原shop信息
			this.abstractShopl.destroyDescendants();
			//创建shop信息
			if(!arg.brief){
				arg.brief="暂无简介";
			}
			var listitem=new ListItem({
				label:"<div>"+arg.brief+"<div>",
				variableHeight:true
			});
			this.abstractShopl.addChild(listitem);			
		},
		onFirstShow : function () {
			var option = {
				left : {
						iconButton : ' ',
						arrow : "left",
						label : "返回",
						onClick : function() {
							history.back();
					}
				},
				title : "专家管理",
            };
            this.addHeader(option);			
			option = {
                isEdge: true,
                class: "shopInfo",
                lists: []
            }
            this.shopInfo=this.addLists(option);			
			option = {
                isEdge : true,
                class : "",
                lists : [
					{
						label : '领域',
						noArrow : true,
						edit : {type : 'text', field : 'field',disabled:'true'}
					}
                ]
			};
			this.addLists(option);
			option = {
                isEdge : true,
                class : "personalInfo",
                lists : [{
                    label : '个人简介'
                  }
                ]
			};
			this.personalInfo=this.addLists(option);                             
			this.onAfterShow();		  
		}
	});
});
