// 创建人：肖爱玲 创建日期 专家档案

define(
    [
      "dojo/_base/declare",
	  "dojo/_base/lang", 
	  "dojox/mobile/View",
      "cq/ui/view/_ViewMixin", 
	  "dijit/registry",
      "dojox/mobile/EdgeToEdgeStoreList", 
	  "dojo/on", 
	  "dojo/when",
      "dojo/store/JsonRest", 
	  "cq/biz/user/expert", 
	  "dojo/dom-class",
	  "cq/biz/shop/shop"
    ],
    function(declare, lang, View, _ViewMixin, registry, EdgeToEdgeStoreList, on,
             when, JsonRest, expert, domClass,shop) {

      // module:
      //      widgets.mobile.ExpertList

      return declare("widgets.mobile.ExpertList", [ View, _ViewMixin ], {

        // 初始化开始值
        start : 0,
        // 设置查询条件
        setQuery : function(query) {
          this.start = 0;
          this.end = -1;
          this.storeList.destroyDescendants();
          this.storeList.setQuery(query, {start : this.start, count : 20});
          this.centerPanel.resize();
        },

        // 初始化相关接口
        onAfterShow : function() {
          if (this.storeList.store) {
            this.setQuery(this.storeList.get("query"));
          } else {
            this.storeList.setStore(this.store, this.params,
                                    {start : 0, count : 20});
          }
          this.refreshData();
        },

        // 初始化加载显示内容
        onFirstShow : function() {
          var option = {
            left : {
              iconButton : ' ',
              arrow : "left",
              label : "返回",
              onClick : function() { 
                history.back(); 
              }
            },
            onClick : function() {},
            title : "专家管理"
          };
          this.addHeader(option);
          option = {
            placeHolder : "请输入要查询条件，按回车查询",
            class : "cqSearchBox",
            type : "search",
            onInput : lang.hitch(this,
                                 function(evt) {
                                   if (evt.keyCode == 13) {
                                     this.search = evt.target.value;
                                     var condition =
                                         this.storeList.get("query");
                                     condition.search = evt.target.value;
                                     this.setQuery(condition);
                                     evt.target.value = "";
                                   }
                                 })
          };
          this.addTextBox(option);

          // 创建数据源
          this.storeList = new EdgeToEdgeStoreList({
            append : true,
            constraint : false,
            query : {},
            class : "icon-list-item",
            variableHeight : true,
            onComplete : lang.hitch(this,
                function(data) {
                  for (var i = 0; i < data.length; i++) {
                    data[i]._label="<div class='webkit-list'>"
                        +"<div class='user-list-left user-list-margin'>姓名:"+(data[i].pName||"")+"</div>"
                        +"</div>"
                        +"<div class='webkit-list'>"
                        +"<div class='user-list-margin'>领域:"+(data[i].field||"")+"</div></div>"
                        //更改个人领域为个人简介
                        //+"<div class='user-list-margin'>职务:"+(data[i].duty||'')+" </div>"
                    data[i].moveTo="#";
                    data[i]._logo = data[i].logo ? data[i].logo : '/static/images/mobile/userIcon.png';
                  }
                  this.storeList.generateList(data);
                  this.end = this.start + data.length - 1;
                  this.busy = false;
                }),
            // 查询条件
            queryOptions : {count : 20, start : this.start},
            itemMap : {_label : "label", _logo : "icon", moveTo : "moveTo"}
          });
          // 创建数据源
          this.params = {};
		  var shopId=shop.getShopId()
          this.store = new JsonRest({target : expert.load()});
          // 将数据源赋值给StoreList
          // this.storeList.setStore(this.store,this.params);
          this.storeList.placeAt(this.centerPanel.containerNode, "last");
          this.storeList.on("click", lang.hitch(this, this.onClickList));
          on(this.centerPanel, "afterscroll",
             lang.hitch(this, this.onLoadMore));
          this.onAfterShow();
        },

        // 重写List的点击事件
        onClickList : function(evt) {
          // 得到点击的ListItem
          var li = registry.getEnclosingWidget(evt.target);
          if (li.declaredClass != "dojox.mobile.ListItem") return;
          var _id = li.params._id;
           //window.moveToView("ExpertDetail", _id);
           window.moveToView("expertDetail",_id);
        },

        // 重写拖拽加载更多事件
        onLoadMore : function(evt) {
          if (this.busy || (0 < this.end && (this.start + 10 - 1 > this.end))) {
            return true;
          }
          if (evt.afterBottom) {
            this.start = this.end + 1;
            console.log("加载更多专家");
            this.busy = true;
            setTimeout(lang.hitch(this, function() {
              when(this.storeList.setQuery(this.storeList.get("query"),
                                           {start : this.start, count : 20}),
                   lang.hitch(this, function() { this.centerPanel.resize(); }));
            }), 1000);
          }
        }
      });
    });
