define(
    [
      "dojo/_base/declare", 
      "dojo/_base/lang", 
      "dojo/query",
      "dojo/on",
      "dojox/mobile/View",
      "cq/ui/view/_ViewMixin",
      "cq/biz/user/user"
    ],function(declare, lang, on, query, View , _ViewMixin, user){
       return declare("widgets.mobile.Login",[ View, _ViewMixin ],{
          onFirstShow : function(){
              // 头部设置
              var  options = {
                    left : { 
                      iconButton : ' ',
                      arrow : "left",
                      label : "返回",
                      onClick : lang.hitch(this,function() {
                                 // window.moveToView("main");
                                 history.back();
                              })
                    },
                    title : "登陆"
               };
              this.addHeader(options);
              // text文本框添加  
              options = {
                isEdge:true,
                lists : [
                 {
                  label : '手机号码',
                  noArrow : true,
                  edit : {
                    type : 'text', 
                    field : 'userName', 
                    placeHolder : '你登陆使用名称',
                  }
                },
                {
                  label : '密码',
                  noArrow : true,
                  edit : {type : 'password', field : 'password', placeHolder : '你登录使用的密码'}
                }]
              };
              this.addLists(options);
              // 确认按钮 登陆
              options = {
                columns:[{
                  label:"注册",
                  className:"flex1 footer-tab-dark",
                   onClick : function(){
                    window.moveToView("register");
                  }
                },
                {
                  label:"登录",
                  className:"flex2 footer-tab-highlight",
                  onClick : lang.hitch(this,this.onVerify)
                },
                {
                  label:"找回密码",
                  className:"flex1 footer-tab-dark",
                  onClick : function(){
                    window.moveToView("retrieve");
                  }
                }],
                className:'',
                forceWidth:false,
                isFooter:true
              };
              this.addColumns(options); 
          },
          // 私有存储字符串
          _userInfo : {},
          // 登录
          onLogin : function(){
             user.loginByPassword(this._userInfo.userName, this._userInfo.password).then(function(result){
                if(result.data.ok == 1){
                    window.moveToView(user.nextPage||"user");
                   //history.back();
                }else{
                  alert(result.data.msg);
                }
             });
          },

          // 验证字段
         onVerify : function(){
            this._userInfo.userName = this.getData().userName;
            this._userInfo.password = this.getData().password;
            // 提示处理
            if(!/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/.test(this._userInfo.userName)){
                alert("请输入正确的11位电话号码");
            }else if(this._userInfo.password === ""){
                alert("必须输入密码");
            }else{
              this.onLogin();
            }
        }
       });
    });