/**
* Writer 杜飞军
* Create Time 2016/05/25
* Deploy 
*		判断销售数量 标示已售罄 按钮不可用
**/
// 变更人：潘云
// 变更时间：2016-06-01
// 变更内容：添加商品评论模块
// 变更人：周超
// 变更时间：2016-06-14
// 变更内容：添加认证显示
// 变更人：冉伟
// 变更时间：2016-06-21
// 变更内容：1.设置显示的小数位数 2.实现商品名称独占一行,名称有多少字数显示多少,库存与规格显示在一行 3.解决宝贝评价与平均评价在手机上没有显示在一行的问题
// 变更人：冉伟
// 变更时间：2016-06-22
// 变更内容：解决下架商品还能加入购物车问题
//变更人:王龙
//变更时间:2016-06-28
//变更内容:将标题商品管理改为商品详情
// 变更人:徐阿雪
// 变更时间:2016/7/11
// 变更原因:添加包邮金额运费限制销售区域
// 变更人:徐阿雪
// 变更时间:2016/7/12
// 变更原因:添加农户入口，商品关联农户，可查看农户信息，要判断农户是否存在
// 变更人:张金鹏
// 变更时间:2016/7/18
// 变更原因:添加联系商家的入口
// 变更人:母浚驰
// 变更时间:2016/7/20
// 变更原因:供货商入口，显示商品参数
// 变更人:张松
// 变更时间:2016/7/24
// 变更原因:页面布局
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/dom-class",
	"dojo/dom-style",
	"dojo/query",
    "dojo/dom-construct",
    "dojo/store/JsonRest",
    "dojo/on",
    "dojo/when",
	"dijit/registry",
    "dojox/mobile/Rating",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
	"cq/biz/mat/mat",
    "cq/biz/mat/sort",
	"cq/biz/ts/cart",
	"cq/biz/shop/shop",
    "cq/biz/user/userFarmer",
	"cq/biz/user/user",
	"cq/biz/im/msg_p",
    "cq/ui/view/_ViewMixin"
],function(declare, lang, domClass, domStyle, query, domConstruct, JsonRest, on, when, registry, Rating, View, EdgeToEdgeStoreList, mat, sort, cart, shop, userFarmer, user, msg_p, _ViewMixin){
    return declare("whz.view.MatDetail",[View, _ViewMixin],{
		// 是否售罄或下架
		isSoldOut : false,
        farmerId : "",
        start : 0,
		onAfterShow:function(){
            // 先隐藏售罄提示
			domStyle.set(this.soldOut,"display","none");
            domClass.remove(this.matDetailDiv.containerNode,"none");
            domClass.add(this.shopsParamsDiv.containerNode,"none");
			mat.loadById(window.did).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.item&&data.data.item.scoreAvg){
                    data.data.item.scoreAvg = window.fixedTo(data.data.item.scoreAvg,2);
                }
                data.data.item.props = this.changeProps(data.data.item.props);
				//取fromShopId    张金鹏，2016/07/18
				this.matShopId = data.data.item.fromShopId;
				//20160621：设置显示的小数位数
				data.data.item.retailPrice = window.fixedTo(data.data.item.retailPrice,3);
				data.data.item.totalSale = window.fixedTo(data.data.item.totalSale,1);
				data.data.item.qty = window.fixedTo(data.data.item.qty,1);
				data.data.item.commentNum = window.fixedTo(data.data.item.commentNum,1);
                //处理sizetype没有的默认情况
                data.data.item.sizeType = data.data.item.sizeType||"个";
                //获取商铺数据
                shop.loadById(this.matShopId).then(lang.hitch(this,function(data1){
                    //添加包邮金额运费限制销售区域  徐阿雪  2016/7/11
                    if(data1.data.dirLmt){
                        data.data.item.dirLmt = "满"+data1.data.dirLmt+"包邮，";
                    }else{
                        data.data.item.dirLmt = "";
                    }
                    if(data1.data.tranRegion){
                        data.data.item.tranRegion = "限"+data1.data.tranRegion+"，";
                    }else{
                        data.data.item.tranRegion = "";
                    }
                    data.data.item.tranFee = window.fixedTo(data1.data.tranFee||0);
                    data.data.item.shopName = data1.data.shopName;
                    data.data.item.tranAddr = data1.data.tranAddr;
                    var farmerMsgList = query(".mblListItem.farmerMsgList",this.getVerified.domNode)[0];
                    //判断是否存在农户，存在就给item对象赋值，去获取农户的相关信息，并且显示农户，否则就不显示 徐阿雪
                    if(data.data.item.farmer){
                        //获取农户ID  徐阿雪  2016/7/13
                        this.farmerId = data.data.item.farmer;
                        //将userFarmer的农户信息存到item里面做展示准备
                        data.data.item.pName = data.data.item.farmer.pName;
                        this.setData(data.data.item);
                        //是农户，显示农户简要信息  徐阿雪
                        domClass.remove(farmerMsgList,"none");
                    }else{
                        this.setData(data.data.item);
                        //农户不存在，隐藏  徐阿雪  2016/7/12 
                        domClass.add(farmerMsgList,"none");
                    }
                    this.isSoldOut = false;
                    domStyle.set(query(".footer-tab-highlight", this.bottomMenus)[1], "opacity", "1");
                    // 判断库存是否等于0
                    if(data.data.item.qty === 0){
                        this.notSale("已售罄");
                    } 
                    // 判断商品是否下架
                    if(data.data.item.isUse === false){
                        this.notSale("已下架");
                    } 
                    var images=[];
                    if(data.data.item.logo){
                        images.push({icon:data.data.item.logo});
                    }
                    for (var i = data.data.item.images.length - 1; i >= 0; i--) {
                        images.push({icon:data.data.item.images[i]});
                    }
                    this.slideShow.items = images;
                    this.slideShow.refresh();
                    this.refreshData();
                    if(!this.scoreWidget){
                        // 添加星级评论
                        this.createRating();
                    }
                    this.addRatingNode();
                    if(data&&data.data&&data.data.item&&data.data.item.scoreAvg){
                        this.scoreWidget.set("value",Math.round(data.data.item.scoreAvg));
                    }else{
                        this.scoreWidget.set("value",0);
                    }
                    if(data1.data.isVerified||data1.data.isTrustedPay){
                        domClass.remove(this.getVerified.domNode,"none");
                    }
                    var dbzf = query(".dbzf",this.getVerified.domNode)[0],qyrz = query(".qyrz",this.getVerified.domNode)[0];
                    //显示隐藏认证点
                    if(data1.data.isVerified===true){
                        domClass.remove(qyrz,"none");
                    }else{
                        domClass.add(qyrz,"none");
                    }
                    if(data1.data.isTrustedPay===true){
                        if(data1.data.isVerified===true){
                            domClass.remove(dbzf,"none");
                            //若企业认证显示则右移
                            domStyle.set(dbzf,"margin-left","20%");
                        }else{
                            domClass.remove(dbzf,"none");
                        } 
                    }else{
                        domClass.add(dbzf,"none");
                    }
                }));
			}));
		},
		onFirstShow:function(){
			//this.setData({});
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						history.back();
					}
				},
				title:"商品详情"
			};
			this.addHeader(option);
            
			var data = {
				boxes : [],
				options : {
                    width:domStyle.get(this.domNode,"width"),
                    height:Math.min(domStyle.get(this.domNode,"width"),360)
				}
			};
			this.slideShow = this.addSlideShow(data);  
            //实现商品名称独占一行,名称有多少字数显示多少,库存与规格显示在一行
            var postTxt = "";
			this.addLists({
                isEdge:true,
                lists:[{
                    label: "{{mName}}",
                    variableHeight: true
                }, {
                    label:"{{sizeType}}",
                    rightText: "￥{{retailPrice}}"
                },
                //{
                //    label: "规格:{{sizeType}}",
				//	rightText: "库存:{{qty}}"
                //},
                {
                    label:"{{tranRegion}}{{dirLmt}}运费：{{freight}}元"
                },{
                    label:"<div style='width:33%;text-align:left;display:inline-block;font-size:12px;'>销量:{{totalSale}}</div><div style='width:33%;text-align:center;display:inline-block;font-size:12px;'>库存:{{qty}}</div><div style='width:33%;text-align:right;display:inline-block;font-size:12px;'>{{tranAddr}}</div>"
                }]
            });
            //创建担保支付信息
            option = {
                class:"getVerified top-bottom-margin16",
				isEdge: true,
				lists: [
                {
                    class:"sellerMsgList",
                    moveTo: "#",
                    label: "<div style='float:left' class='sellerIntro'>供货商家</div>",
                    rightText: "{{shopName}}",
                    onClick : lang.hitch(this,function(){
                        window.moveToView("supplyBus",this.matShopId);
                    })
                },{
                    label: "<div style='float:left' class='none qyrz'><img style='width: 17px;' src='/static/images/mobile/hook.png'/>企业认证</div><div class='none dbzf'><img style='width: 17px;' src='/static/images/mobile/hook.png'/>担保支付</div>"
                },
                //添加农户简要信息，设置默认为隐藏，若有农户则显示出来 徐阿雪  2016/7/12
                {
                    class:"farmerMsgList none",
                    moveTo: "#",
                    label: "<div style='float:left' class='farmerIntro'>供货农户</div>",
                    rightText: "{{pName}}",
                    //添加点击事件跳转到农户详细信息页面 徐阿雪  2016/7/12  
                    onClick : lang.hitch(this,function(){
                        window.moveToView("farmerMsg",this.farmerId._id);
                    })
                }]
			};
			this.getVerified = this.addLists(option);
			domClass.add(this.getVerified.domNode, "none");
            // 添加商品的评论模块
			option = {
                class: "top-bottom-margin16",
				isEdge: true,
				lists: [{
                    //解决宝贝评价与平均评价在手机上没有显示在一行的问题
					label : "<div style='display:flex;'>"+
                                "<div style='flex:1;'>宝贝评价({{commentNum}})</div>"+
                                "<div style='display:flex;'>"+
                                    "<div style='flex:1;'>平均得分:{{scoreAvg}}</div>"+
                                    "<div style='margin-left:5px;' class = 'ratingDiv' ></div>"+
                                "</div>"+
                            "</div>",
					variableHeight: true
				}]
			};
			this.matEvalList = this.addLists(option);
            
            // 商品详情和参数
            this.addShopAssistList();
            
			option = {
				columns:[{
					label: "已售罄"
				}],
				isFooter: true,
				labelClass: "messageDiv",
				"className": "bg-gray text-white"
			},
			this.soldOut = this.addColumns(option);

			option = {
				columns:[{
					label: '首页',
					className: 'flex2 footer-tab-highlight',
					onClick: function(){
						window.moveToView("main");
					}
				},
                //添加联系商家按钮    张金鹏，2016/07/18
                {
                    label:'联系商家',
                    className:'flex2 footer-tab-dark',
                    onClick: lang.hitch(this, this.toTalk)
                },
				{
					label: '查看购物车',
					className: 'flex2 footer-tab-dark',
					onClick: lang.hitch(this, this.toBalance)
				},
				{
					label: '加入购物车',
					className: 'flex2 footer-tab-highlight',
					onClick: lang.hitch(this, this.addOrderCar)
				}],
				forceWidth: false,
				isFooter: true
			},
			this.bottomMenus = this.addColumns(option);
			// 商品评论绑定事件
			this.matEvalList.on("click", lang.hitch(this,this.onEvalList));
			this.onAfterShow();
		},
        //添加查看大图事件 2016/6/30
        onImageNodeclick:function(e){
            if("IMG"===e.target.tagName){
                this.showImg(e.target.src);
            }
        },
        // 创建星级评论对象
        createRating : function(){
            this.scoreWidget = new Rating({
                image: "/static/common/images/star-orange.png",
                numStars: 5,
                value: 5
            });
        },
        // 添加星级评论对象
        addRatingNode: function() {
            var li = query("li", this.matEvalList.domNode)[0];
            var rightDiv = query(".mblListItemLabel", li)[0];
            var ratingDiv = query(".ratingDiv", rightDiv)[0];
			ratingDiv.appendChild(this.scoreWidget.domNode);
        },
		onEvalList: function(evt) {
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass != "dojox.mobile.ListItem") return;
			var _id = window.did;
			window.moveToView("matEvalList", _id);
		},
		addOrderCar: function() {
			if(!this.isSoldOut){
				cart.add(window.did, 1);
				alert("购物车添加成功!");
				window.moveToView("orderCar");
			}
		},
		//先检查是否登陆，若已登录则跳转到联系商家页面，若未登录则跳转到登录页面    张金鹏，2016/07/18
		toTalk: function(){
			//调用user的hasLogin()方法，返回一个异步返回值s。    张金鹏，2016/07/18
			user.hasLogin().then(lang.hitch(this,function(s){
				if(s){
					//调用msg_p对象的getSvcInfo()方法，获取和指定商家客服对话的信息的结果取名叫msgInfo    张金鹏，2016/07/18
					msg_p.getSvcInfo(this.matShopId).then(lang.hitch(this,function(msgInfo){
						if(msgInfo&&msgInfo.data&&msgInfo.data.item){
							var item = msgInfo.data.item;
							var senderId = item.senderId,receiverId = item.receiverId;
							senderId = senderId._id||senderId;
							receiverId = receiverId._id||receiverId;
							var svcId = senderId===user.getCurrentUserId()?receiverId:senderId;
							window.moveToView("svcDetail",this.matShopId+","+svcId);
						}
					}));
				}else{
					window.moveToView("login");
					//history.back();
					//user.nextPage="pendingMsg";
				}
			}));
		},
		// 直接到购物车
		toBalance: function(){
            window.moveToView("orderCar");
		},
		// 已经售罄或下架
		notSale: function (msg) {
			this.isSoldOut = true;
			query(".messageDiv", this.soldOut)[0].innerHTML=msg;
			// 显示售罄
			domStyle.set(this.soldOut, "display", "");
			domStyle.set(query(".footer-tab-highlight", this.bottomMenus)[1], "opacity", "0.7");
			this.resize();
		},
        addShopAssistList : function(){
            var option = {
                columns : [
                    {
                        label : '商品详情',
                        onClick : lang.hitch(this.changeMatDetail)
                    },
                    {
                        label : '商品参数',
                        onClick : lang.hitch(this.changeShopsParams)
                    }
                ],
                labelClass : 'font-size1 tab-selector'
            };
            this.addColumns(option);
            
            //商品详情
            option = {
                isEdge: true,
                lists: [{
                    label : "<div class='richText shopDetail'>{{content}}</div>",
                    variableHeight: true,
                    onClick:lang.hitch(this,this.onImageNodeclick)//添加查看大图事件 2016/6/30
                }]
            };
            this.matDetailDiv = this.addLists(option);
            
            // 商品参数
            option = {
                isEdge: true,
                lists: [{
                    label : "<div class='richText shopParams'>{{props}}</div>",
                    variableHeight: true
                }]
            };
            this.shopsParamsDiv = this.addLists(option);
            this.tabSelected();
        },
        // 商品参数格式转换
        changeProps : function(props){
            var str = "";
            if(props && props.length>0){
                for(var i = 0; i<props.length;i++){
                    str += "<div style='margin-top:10px;'><span>"+props[i].name+"：</span><span>"+props[i].value+"</span></div>";
                }
            }else {
                str = "暂无商品参数";
            }
            return str;
        },
        //切换到商品详情
        changeMatDetail : function (e) {
            this.tabSelected(e.target);
            domClass.remove(this.matDetailDiv.containerNode,"none");
            domClass.add(this.shopsParamsDiv.containerNode,"none");
        },
        //切换到商品参数
        changeShopsParams : function (e) {
            this.tabSelected(e.target);
            domClass.remove(this.shopsParamsDiv.containerNode,"none");
            domClass.add(this.matDetailDiv.containerNode,"none");
        },
        //切换tabbar
        tabSelected : function (dom) {
			var items = query('.tab-selector', this.domNode);
			for (var i = 0; i < items.length; i++) {
				domClass.remove(items[i], "selected");
			}
            if(dom){
                domClass.add(dom, "selected");
            }else{
                domClass.add(items[0], "selected");
            }
		}
	});
});
