define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/dom-style",
	"dojo/query",
	"dojox/mobile/View",
	"dojox/mobile/ContentPane",
	"cq/ui/view/_ViewMixin",
	"cq/biz/article/article",
	"dijit/registry",
	"dojo/topic"
	],function(declare,lang,domStyle,query,View,ContentPane,_ViewMixin,article,registry,topic){
	return declare("widgets.mobile.NewDetail",[View,_ViewMixin],{		
		//初始化相关接口
		//索引界面元素
		indexElement:function(){
            this.NewsDtlScroll = this.centerPanel;
		},
		//初始化事件
		initEvent:function(){
		},
		//第一次加载
		onFirstShow:function(){
			this.onAfterShow();
			var option = {
                columns: [{
                    icon: '/static/images/mobile/main1.png',
                    iconClass: 'footer-tab-img',
					className: 'footer-tab-col-normal',
                    label: '首页',
                    onClick: function() {
                        window.moveToView("main");
                    }
                },{
					icon: '/static/images/mobile/contact.png',
                    iconClass: 'footer-tab-img',
					//footer栏字幕显示
                    label: '动态',
					className:'footer-tab-col-highlight',
                    onClick: function() {
						//客户端以后都用window.moveToView来完成点击功能
                        window.moveToView("newsList");
                    }
                },{
					icon: '/static/images/mobile/orderCar1.png',
					//有点像样式的感觉，目前知道的三种大小分别为，把此句删掉、除了width-16之外的大小统统很大并且一样大、width-16的正常大小
                    iconClass: 'footer-tab-img',
                    label: '购物车',
                    isBadge:true,		
					badgeClass:"orderCarNum",
					className:'footer-tab-col-normal',
                    onClick: function() {
                       window.moveToView("orderCar");
                    }
                },{
                    icon: '/static/images/mobile/user1.png',
                    iconClass: 'footer-tab-img',
                    label: '我的信息',
					className:'footer-tab-col-normal',
                    onClick: function() {
                        window.moveToView("user");
                    }
                }],                			
                labelClass: 'font-size1',
                className: 'fix-footer',
                isFooter: true
            };
            //this.addColumns(option);
			this.addFooterColumns();
			//每次firstShow时侦听广播
			this.subscribe("cq/biz/ts/cart/numChanged", lang.hitch(this,function(num){
					this.matNumNode.innerHTML = num;
			}));
			this.onAfterShow();
		},
		onAfterShow:function(){
			this.inherited(arguments);			
			article["loadById"](window.did).then(lang.hitch(this,function(data){
				if(data.data.ok==1){
					if(this.dtlPane){
						this.dtlPane.destroyRecursive();
					}
					data=data.data.item;
					data.createAt=new Date(data.createAt);
					
					var contentHtm="<div class=' main-title '>"+data.title+"</div>";
					contentHtm+="<div class=' sub-title'>"+data.createAt.toLocaleDateString()+"</div>";
					//contentHtm+="<img class='img' src='"+data.logo+"' />";zsszxzxz
					contentHtm+="<div class=''>"+data.content+"</div>";
					this.dtlPane=new ContentPane({
						content:contentHtm,
						className:"dtlnew_view dtl-content-pane"
					});
					this.dtlPane.placeAt(this.NewsDtlScroll.containerNode,"last");
				}
			}));
		}
	});
});