//  变更人:肖芳圆
//  变更时间:2016-6-28
//  变更原因:
//  1.购物车中已下架或者无库存的商品前面的单选框不允许点击
//  2.点击结算时过滤掉购物车中已下架或者无库存的商品
//  3.点击+库存时,购物车数量应<=商品库存数量,若购物车数量加到>商品库存,则阻止+
//  变更人:冉伟
//  变更时间:2016-7-4
//  增加商品已下架或没库存时弹出窗口提示
//  变更人:肖芳圆
//  变更时间:2016-6-28
//  变更原因:购物车中商品按照fromShopId分组
//  变更人:肖芳圆
//  变更时间:2016-8-9
//  变更原因:在删除商品的时候,没有把商品从购物车的选中中删除,并且没有处理选中的问题
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "dijit/_WidgetBase",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mat/mat",
    "cq/biz/ts/cart",
    "cq/biz/user/user",
    "cq/biz/shop/shop"
],function(declare,lang,array,Deferred,query,domClass,domAttr,domStyle,domConstruct,registry,view,ListItem,_WidgetBase,_ViewMixin,mat,cart,user,shop){
    //继承ListItem的OrderMatItem
    var OrderCarMatItem = declare("", [ListItem], {
        //是否选中
        isChecked : null,
        disabled : false,
        //本商品的信息
        mat : null,
        qty : null,
        //构造函数 实例化时执行
        constructor : function (arg) {
            this.mat = arg.mat;
            this.qty = cart.get()[this.mat._id];
            //查看商品是否选中
            this.isChecked = array.some(cart.getSelected(), function (id) {
                if (id === this.mat._id) {
                    return true;
                }
            }, this);
            //下架或者售罄商品不能购买
            if (!(this.mat.qty && this.mat.isUse)) {
                this.disabled = true;
                //失效商品,应该从选中商品中删除,并设置为未选中状态
                if (this.isChecked === true) {
                    this.isChecked = false;
                    this.setCartSelecte(false);
                }
            }
            //如果选中的数量大于当前库存数量,则设置购物车数量为库存数量
            if (this.qty > this.mat.qty) {
                //购物车数量和显示数量同步
                cart.add(this.mat._id, (this.mat.qty - this.qty));
                this.qty = this.mat.qty;
            }
            this.label = "<label class='edit-car-checkbox' checked='"+(this.isChecked ? "checked" : "")+"'></label><a href='#matDetail-"+this.mat._id+"'><img class='edit-car-matimg' src='"+this.mat.logo+"' /></a><span class='edit-car-matname'>"+this.mat.mName+"</span><span class='edit-car-matprice'>￥"+window.fixedTo(this.mat.retailPrice,3)+"</span><span class='edit-car-stock'>(库存:"+window.fixedTo(this.mat.qty,1)+")</span>";
            this.rightText = "<a class='edit-car-minus'>-</a><span class='edit-car-qty'>"+this.qty+"</span><a class='edit-car-plus'>+</a>";
            this.class = "ordrcar-listitem mblVariableHeight " + (this.disabled ? "disabled" : "");
        },
        postCreate : function () {
            this.inherited(arguments);
            this.initEvent();
        },
        initEvent : function () {
            this.connect(this.domNode, "onclick",this.domNodeClick);
            this.qtyDiv = query(".edit-car-qty",this.domNode)[0];
        },
        domNodeClick : function (e) {
            //包含disabled class 不能点击
            if (domClass.contains(this.domNode,"disabled")) {
                return;
            }
            var dom=e.target;
            //选择商品
            if (dom&&domClass.contains(dom,"edit-car-checkbox")) {
                this.checkClick(dom);
            };
            //数量加减
            if(dom&&dom.tagName==="A"){//是点击a标签的
                if(domClass.contains(dom,"edit-car-minus")){
                    if(this.qty==1){
                        //购物车数量减到1后，继续点击减号出现的提示信息感叹号改为问号
                        if(confirm("是否删除本商品？")){
                            this.destroyRecursive();
                            this.changeQty(-this.qty);
                            this.isChecked = false;
                            this.setCartSelecte(false);
                            this.onCheck();
                        }else{return;}
                    }else{
                        this.changeQty(-1);
                    }
                }
                //增加数量
                else if(domClass.contains(dom,"edit-car-plus")){
                    //上次数量修改没有完成,不处理后面的点击
                    if (!this.isAdding) {
                        this.isAdding = true;
                        //从服务器去取商品的数量,确保数量足够
                        mat.loadById(this.mat._id).then(lang.hitch(this, function (data) {
                            this.isAdding = false;
                            // TODO: 在添加的时候,库存不够/售罄/下架的处理
                            if (data && data.data && data.data.ok === 1) {
                                if (this.qty >= data.data.item.qty) {
                                    alert("库存不够啦!");
                                    return;
                                }
                                //执行qty++操作
                                this.changeQty(1);
                            }else {
                                return;
                            }
                        }));
                    } else {
                        return;
                    }
                }
            }
        },
        //增加/减少数量
        changeQty : function (qty) {
            var mid = this.mat._id;
            this.qty += qty;
            this.qtyDiv.innerHTML = this.qty;
            if (this.qty > 0) {
                cart.add(mid,qty);
            }else {
                //从购物车中删除本商品
                cart.clear([mid]);
            }
            this.onQtyChange(this.isChecked, this.qty);
        },
        //数量增减事件
        onQtyChange : function (isChecked, qty) {},
        //选中
        checkClick : function () {
            this.setCheck(this.isChecked ? false : true);
            this.onCheck();
        },
        setCheck : function (checked) {
            var dom = query(".edit-car-checkbox", this.domNode)[0];
            this.isChecked = checked;
            this.setCartSelecte(checked);
            domAttr.set(dom,"checked",checked ? "checked": "");
        },
        //设置商品在购物车中的选中和取消选中
        setCartSelecte : function (checked) {
            var mid = this.mat._id;
            var  selectedIds = cart.getSelected();
            if (checked) {
                selectedIds.push(mid);
            } else {
                //删除商品选中,修改删除方式数组中相同值的方式
                selectedIds = array.filter(selectedIds, function (selectedId,index) {
                    if (mid !== selectedId) {
                        return true;
                    }
                }, this);
            }
            cart.setSelected(selectedIds);
        },
        //选中事件
        onCheck : function (checked) {
        },
        getCount : function () {
            return {
                price : this.qty * this.mat.retailPrice,
                qty : this.qty
            };
        }
    });
    //继承WidgetsBase的OrderShopItem
    var OrderCarShopItem = declare("", [_WidgetBase], {
        //本商家商品是否全选
        isCheckedAll : null,
        //本商家的商品
        mats : null,
        //商家信息
        shopInfo : null,
        "class" : "order-list-item",
        postCreate : function () {
            var shopInfo = this.shopInfo || {};
            //商家名称显示栏
            var statusNode = domConstruct.create("div", {
                "class":"order-list-status",
                innerHTML:"<a onclick=\"javascript:window.moveToView(\'supplyBus\',\'" + shopInfo._id + "\');\"><span>" + (shopInfo.shopName || "") + "</span></a>"
            },this.domNode);
            this.isCheckedAllNode = domConstruct.create("label", {
                "class" : "edit-car-checkbox",
                onclick : lang.hitch(this,this.onCheckClick),
            }, statusNode, "first");
            //商家商品栏
            this.detailList = domConstruct.create("div",{"class":"order-detail-list"},this.domNode);
            array.forEach(this.mats,function (mat){
                this.addMat(mat);
            },this);
            this.hasMatCheck();
            //合计/运费等
            this.footer = domConstruct.create("div",{"class":"order-list-count"},this.domNode);
        },
        addMat : function (mat) {
            var orderCarMatItem = new OrderCarMatItem({
                mat : mat,
                onCheck : lang.hitch(this, function () {
                    this.hasMatCheck();
                    this.onChange();
                }),
                onQtyChange : lang.hitch(this,function (isChecked, qty) {
                    //如果全部删除了,也需要删除本对象
                    //节点没有商品存在就删除商家节点
                    if (!registry.findWidgets(this.detailList).length) {
                        this.destroyRecursive();
                        this.onChange();
                    } else {
                        if (!qty) {
                            //判断删除后是否是全部选中了
                            this.hasMatCheck();
                            this.onChange();
                        } else if (isChecked) {
                            //选中的需要计算合计
                            this.onChange();
                        }
                    }
                })
            });
            this.detailList.appendChild(orderCarMatItem.domNode);
        },
        //判断是不是全选
        hasMatCheck : function () {
            var matItems = registry.findWidgets(this.detailList);
            //如果有一个未选中,则不是全选
            if (array.some(matItems, function (matItem) {
                if(!matItem.isChecked){
                    return true;
                }
            })) {
                this.isCheckedAll = false;
            } else {
                this.isCheckedAll = true;
            }
            this.setCheck(this.isCheckedAll);
        },
        onCheckClick : function (e) {
            var dom = e.target;
            if(dom){
                this.isCheckedAll = domAttr.get(dom, "checked") ? false : true;
                this.setALLCheck(this.isCheckedAll);
            }
            this.onChange();
        },
        setALLCheck : function (checked) {
            this.isCheckedAll = checked;
            var matItems = registry.findWidgets(this.detailList);
            array.forEach(matItems, function (matItem) {
                //已经选中的商品不需要
                if(matItem.isChecked && checked){
                    return;
                }
                matItem.setCheck(checked);
            },this);
            this.setCheck(checked);
        },
        setCheck : function (checked) {
            domAttr.set(this.isCheckedAllNode, "checked", checked ? "checked" :"");
        },
        //商品信息改变事件
        onChange : function () {
        },
        getCount : function () {
            var matItems = registry.findWidgets(this.detailList),
            count = {
                price : 0,
                qty : 0
            };
            array.forEach(matItems, function (matItem) {
                if (matItem.isChecked) {
                    var matCount = matItem.getCount()
                    count.price += matCount.price;
                    count.qty += matCount.qty;
                }
            });
            return count;
        }
    });
    //继承widgetBase
    var OrderCarMat = declare("", [_WidgetBase], {
        //商家
        shops : null,
        unUseMats : null,
        isCheckedAll : null,
        "class" : "edit-car-list",
        postCreate : function () {
            //商家名称
            var shops = this.shops;
            //生成商家列表
            for (var shop in shops) {
                if (shops.hasOwnProperty(shop)) {
                    var orderCarShopItem  = new OrderCarShopItem({
                        shopInfo : shops[shop].info,
                        mats : shops[shop].mats,
                        onChange : lang.hitch(this, this.onChange)
                    });
                    this.domNode.appendChild(orderCarShopItem.domNode);
                }
            }
            //生成失效商品列表
            array.forEach(this.unUseMats, function (unUseMat) {
                var orderCarMatItem = new OrderCarMatItem({
                    mat : unUseMat
                });
                this.domNode.appendChild(orderCarMatItem.domNode);
            }, this);
        },
        hasCheckAll : function () {
            return !array.some(registry.findWidgets(this.domNode), function (shopItem) {
                if(!shopItem.isCheckedAll && shopItem.declaredClass === "dijit._WidgetBase"){
                    return true;
                }
            });
        },
        //改变事件
        onChange : function () {
        },
        //全选
        setALLCheck : function (checked) {
            this.isCheckedAll = checked;
            array.forEach(registry.findWidgets(this.domNode), function (shopItem) {
                if(shopItem.declaredClass === "dijit._WidgetBase"){
                    shopItem.setALLCheck(checked);
                }
            });
        },
        //计算选中的金额
        countSelected : function () {
            var count = {
                price : 0,
                qty : 0
            };
            array.forEach(registry.findWidgets(this.domNode), function (shopItem) {
                if(shopItem.declaredClass === "dijit._WidgetBase"){
                        var shopCount = shopItem.getCount();
                        count.price += shopCount.price;
                        count.qty += shopCount.qty;
                }
            });
            return count;
        },
        //清空无效商品
        //问题
        clearUnUseMat : function () {
            var carts = cart.get();
            array.forEach(this.unUseMats,function (mat) {
                delete carts[mat._id];
            },this);
            cart.set(carts);
            array.forEach(registry.findWidgets(this.domNode), function (matItem) {
                if(matItem.declaredClass === "dojox.mobile.ListItem"){
                    matItem.destroyRecursive();
                }
            });
        }
    });
    return declare("widgets.mobile.OrderCar",[view,_ViewMixin],{
        mats:{},//选中的商品
        //下架/无货的商品的id数组
        unUseMats:[],//null
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    //window.moveToView("main");
                    }
                },
                title:"购物车",
                right:{
                    iconButton:'',
                    label:"编辑"    
                }
            };
            this.addHeader(option);
            option = {
                //继续选购与商品列表之间添加间隔
                class:"bottom-margin16",
                isEdge:true,
                lists:[{
                    rightText:'<a class="color-h edit-car-back">继续选购</a><a class="edit-car-clear edit-car none">清空无效商品</a>'
                }]
            }
            this.orderCarHead = this.addLists(option);
            option = {
                columns:[{
                    label:"<label class='edit-car-checkbox chooseAll'></label>全选",
                    className:"edit-car-selectall"
                },{
                    label:"<div class='countBox'>合计:<span class='count'>￥0.00</span></div><span class='edit-car-alert'>不含运费</span>",
                    className:"edit-car-count flex1"
                },{
                    label:"结算(<span class='amout'>0</span>)",
                    className:"edit-car-submit"
                }],
                className:'fix-footer edit-car-footer',
                forceWidth:false,
                isFooter:true
            }
            this.addColumns(option);

            this.carFooter=query(".edit-car-footer",this.domNode)[0];
            this.onAfterShow();
            this._topSplitter.resize();
            this.connectEvent();
        },
        connectEvent:function(){
            this.connect(query(".edit-car-submit",this.domNode)[0],"onclick",this.submitOrder);
            this.connect(query(".edit-car-checkbox.chooseAll",this.carFooter)[0],"onclick",this.chooseAllClick);
            this.connect(query(".edit-car-back",this.domNode)[0],"onclick",function(){window.moveToView("matList")});
            //清空失效商品
            this.connect(query(".edit-car-clear",this.domNode)[0],"onclick",this.delUnUseMat);
        },
        //清空失效商品
        delUnUseMat:function () {
            this.orderCarMat.clearUnUseMat();
            domClass.add(query(".edit-car-clear",this.domNode)[0], "none");
            this.unUseMats = [];
            this.onAfterShow();
        },
        //提交订单
        submitOrder:function(){
            //this.load();
            if(cart.getSelected().length===0){
                alert("还没有选择任何商品哦!");
                return;
            }
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    window.moveToView("orderInfo");
                }else{
                    window.moveToView("login");
                    user.nextPage="orderInfo";//orderInfo
                }
            }));
        },
        chooseAllClick : function (e) {
            var dom = e.target;
            if (dom) {
                var state = domAttr.get(dom, "checked");
                domAttr.set(dom, "checked", state ? "" :"checked");
                this.orderCarMat.setALLCheck(!state);
                this.refreshFooter();
            }
        },
        //刷新底部
        refreshFooter:function(){
            var qty=query(".amout",this.carFooter)[0];
            var count=query(".count",this.carFooter)[0];
            var footerCheckBox=query(".edit-car-checkbox",this.carFooter)[0];
            var info = this.orderCarMat.countSelected();
            domAttr.set(footerCheckBox,"checked",this.orderCarMat.hasCheckAll() ? "checked" : "");
            qty.innerHTML=info.qty;
            count.innerHTML="￥" + window.fixedTo(info.price,3);
        },
        onAfterShow:function(){
            //this.shops的数据格式
            this.carIds = cart.getIds();
            this.shops = {};
            //失效商品
            this.unUseMats = [];
            var shopIds = [];
            mat.loadByIds(this.carIds).then(lang.hitch(this,function (data) {
                var items = data && data.data && data.data.items || [];
                array.forEach(items, function (item) {
                    //失效商品或者无库存商品不放到商家的商品中去
                    if (!item.isUse || !item.qty) {
                        this.unUseMats.push(item);
                    } else {
                        //可购买商品,存到商家mats里面去
                        if (!this.shops[item.fromShopId]){
                            this.shops[item.fromShopId] = {
                                info : null,
                                mats : []
                            };
                            shopIds.push(item.fromShopId);
                        }
                        this.shops[item.fromShopId].mats.push(item);
                    }
                }, this);
                //处理在加入购物车后下架或者售罄的情况
                if(this.unUseMats.length){
                    var msg="";
                    for(var i=0;i<this.unUseMats.length;i++){
                        if(this.unUseMats[i].isUse === false){
                            msg+=this.unUseMats[i].mName+"已下架";
                        }
                        if(this.unUseMats[i].qty === 0){
                            msg+=this.unUseMats[i].mName+"已售罄";
                        }
                    }
                    alert(msg);
                }
                //按商家分组
                shop.loadByIds(shopIds).then(lang.hitch(this, function (shopDatas) {
                    var shopItems =  shopDatas && shopDatas.data || [];
                    array.forEach(shopItems, function (shopItem) {
                        this.shops[shopItem._id].info = shopItem
                    }, this);
                    this.refresh();
                }));
            }));
        },
        refresh:function () {
            if (this.orderCarMat) {
                this.orderCarMat.destroyRecursive();
            }
            this.orderCarMat = new OrderCarMat({
                shops : this.shops,
                unUseMats : this.unUseMats,
                onChange : lang.hitch(this ,this.onOrderCarChange)
            });
            domConstruct.place(this.orderCarMat.domNode, this.orderCarHead.domNode, "after");
            domClass[ this.unUseMats.length ? "remove" : "add"](query(".edit-car-clear",this.domNode)[0], "none");
            this.refreshFooter();
        },
        onOrderCarChange:function () {
            this.refreshFooter();
        }
    });
});