// 创建人：母浚驰
// 创建时间：2016-08-30
// 功能：所有拼团活动列表
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/query",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/pacTeam",
    "cq/biz/mk/pacMember",
    "cq/biz/user/user",
    "cq/util/sys/date"
],function(declare, lang, query, JsonRest, domClass, domStyle, EdgeToEdgeStoreList, View, registry, _ViewMixin, pacTeam, pacMember, user, date){
    return declare("widgets.mobile.PacTeamList",[View,_ViewMixin],{
        start:0,
        pageSize:10,
        onFirstShow:function(){
            //导航
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        history.back();
                    }
                },
                title : "所有拼团"
            };
            this.addHeader(option);
            
            this.onCreatList();
            this.onAfterShow();
        },
        //创建列表
        onCreatList : function(){
            //创建团购商品列表
            this.pacTeamList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"mblEdgeToEdgeList",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        if(data[i].pacId.mId){
                            data[i]._label="<div class='pacTeamList'><div class='pacMatDiv'>"
                            +"<div class='pacMatIcon'><img src='"+data[i].pacId.mId.logo+"'></div>"
                            +"<div><span>"+data[i].pacId.rcdInfo+"</span></div>"
                            +"<div class='kaituan'>"
                            +"<img class='pacimg' src='../../static/images/mobile/pacBuyList.png'>"
                            +"<div class='kaiTuanDiv' style='width: 40%;'>"
                            +"<span style='margin-left: 35px;'>成团价：￥"+data[i].pacId.pacPic+"/件</span>"
                            +"</div></div></div>"
                            +"<div class='pacTeamDiv'><span class='teamState'>"+this.stateMsg(data[i].state)
                            +"</span><span class='teamDetail' style='display:none;'>查看团队详情</span>"
                            +"<span class='orderDetail' style='display:none;'>"
                            +"查看订单详情</span></div></div>";
                        }
                    }
                    this.pacTeamList.generateList(data);
                    for(var i=0;i<data.length;i++){
                        this.editState(data[i].state,i);
                    }
                    this.busy=false;
                }),
                itemMap:{
                    _label:"label"
                }
            });
            this.pacTeamList.placeAt(this.centerPanel.containerNode,"last");
            //列表的点击事件
            this.pacTeamList.on("click",lang.hitch(this,this.onClickList));
            //添加滚动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        //根据type加载拼团商品信息  给出query的值 
        loadPac : function(){
            this.start = 0;
            this.pacTeamList.destroyDescendants();
            if(this.store){
                this.busy = true;
                var queryResult= this.pacTeamList.setQuery(this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.params = {};
                //如果没有store就创建数据源
                this.store = new JsonRest({target:pacTeam.getLoadUrl()});
                this.busy=true;
                var queryResult =this.pacTeamList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        //拖动加载更多
        onLoadMore:function(e){
            //当滚动加载更多的时候，通过e的事件来判断是setQuer哪一个列表
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.pacTeamList.setQuery(this.pacTeamList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        onAfterShow:function(){
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.loadPac();
                }else{
                    alert("您未登录，请登录");
                    window.moveToView("login");
                    user.nextPage="pacTeamList";
                }
            }));
        },
        editState:function(state,i){
            if(state == 2 || state == 3){
                domStyle.set(query(".teamDetail",this.pacTeamList.domNode)[i],"display","inline-block");
            }
        },
        stateMsg:function(state){
            var stateMsg = "";
            if(state == 1){
                stateMsg = "准备开团";
            }else if(state == 2){
                stateMsg = "开团成功";
            }else if(state == 3){
                stateMsg = "拼团成功";
            }else if(state == 4){
                stateMsg = "拼团失败";
            }
            return stateMsg;
        },
        onClickList:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")return;
            var dom = evt.target;
            var _id = li.params._id;
            var rebateRule=li.params.rebateRule;
            if(dom&&domClass.contains(dom,"teamDetail")){
                window.moveToView("pacTeamDetail",_id);
            }
        }
    });
});