// 创建人：母浚驰
// 创建时间：2016-08-30
// 功能：拼团活动编辑
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-class",
	"dojo/dom-style",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/pacBuy",
    "cq/biz/mk/pacTeam",
    "cq/biz/ts/cart",
    "cq/util/sys/date"
],function(declare, lang, query, domClass, domStyle, View, _ViewMixin, pacBuy, pacTeam, cart, date){
    return declare("widgets.mobile.PacBuyDetail",[View,_ViewMixin],{
        start : 0,
		onAfterShow:function(){
			pacBuy.loadById(window.did).then(lang.hitch(this,function(data){
                if(data && data.data && data.data.item){
                    data.data.item.endTime = date.formatISODateMinutes(data.data.item.endTime);
                    data.data.item.totalSale = data.data.item.mId.totalSale;
                    data.data.item.retailPrice = data.data.item.mId.retailPrice;
                    this.setData(data.data.item);
                    var images=[];
                    if(data.data.item.mId.logo){
                        images.push({icon:data.data.item.mId.logo});
                    }
                    this.mId = data.data.item.mId._id;
                    this.slideShow.items = images;
                    this.slideShow.refresh();
                    this.refreshData();
                }
            }));
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						history.back();
					}
				},
				title:"开团"
			};
			this.addHeader(option);
            
			var data = {
				boxes : [],
				options : {
                    width:domStyle.get(this.domNode,"width"),
                    height:Math.min(domStyle.get(this.domNode,"width"),360)
				}
			};
			this.slideShow = this.addSlideShow(data);  
            option = {
                isEdge:true,
                lists:[{
                    label:"<div class='date2' style='border:0;'><div class='dateLeft'></div>"
                        +"活动结束时间<div class='dateRight'>{{endTime}}</div></div>"
                }]
            };
            
			this.addLists(option);
            
            option = {
                'class': "pacTeam",
                isEdge:true,
                lists:[{
                    label:"<ul class='Detaipbu'><li>{{title}}</li><li>{{rcdInfo}}</li>"
                        +"<li><span>已售:{{totalSale}}</span><div style='clear: both;'></div></li></ul>"
                },{
                    label:"<div class='detailGamePlay'>"
                        +"支付开团并邀请{{pacNum}}人开团,人数不足自动退款;详见下方拼团玩法</div>"
                        +"<div class='detailPrice'><span class='priceLeft btnDetailPrice'>"
                        +"<div class='priceLeftTop btnDetailPrice'>￥{{pacPic}}/份</div>"
                        +"<div class='priceLeftBottom btnDetailPrice'>{{pacNum}}人团"
                        +"<div class='priceOne btnDetailPrice'><div class='priceTwo btnDetailPrice'>"
                        +"</div></div></div></span><span class='priceRight'><div class='priceRightTop'>"
                        +"￥{{retailPrice}}</div><div class='priceRightBottom'>单身活动价"
                        +"<div class='priceOne'><div class='priceTwo'></div></div></div></span></div>"
                }]
            };
            this.addLists(option);
            //拼团玩法
            option = {
                'class': "top-bottom-margin16 pacPlay",
                isEdge:true,
                lists:[{
                    moveTo: "#",
                    label: "<font style='color:#000;'>拼团玩法</font>",
                    rightText: "<font style='color:#666;'>查看详情</font>",
                    onClick : lang.hitch(this,function(){
                        window.moveToView("pacBuyIntroduces");
                    })
                },{
                    label:"<div class='playDiv'><div class='playlist playColor'>"
                    +"选择心仪<br>商品<div class='playNubmer'>1</div></div>"
                    +"<div class='arrow' "
                    +"style='background-image:url(../../static/images/mobile/greenArrow.png);'></div>"
                    +"<div class='playlist playColor'>"
                    +"支付开团<br>或参团<div class='playNubmer'>2</div></div>"
                    +"<div class='arrow'></div>"
                    +"<div class='playlist'>"
                    +"等待好友<br>参团支付<div class='playNubmer'>3</div></div>"
                    +"<div class='arrow'></div>"
                    +"<div class='playlist'>"
                    +"达到人数<br>团购成功<div class='playNubmer'>4</div></div></div>"
                }]
            };
            this.addLists(option);
            this.connectEvt();
			this.onAfterShow();
		},
        connectEvt:function(){
            this.connect(query(".pacTeam",this.domNode)[0],"onclick",this.teamPriceOrder);
            this.connect(query(".pacTeam",this.domNode)[0],"onclick",this.singlePriceOrder);
        },
        teamPriceOrder(e){
            var dom = e.target;
            if(dom && domClass.contains(dom.parentNode,"priceLeft")){
                var params = {};
                params._id = window.did;
                pacTeam.newTeam(params).then(lang.hitch(this,function(data){
                    if(data && data.data.ok==1){
                        alert("您建立了一个新团队");
                        cart.clear(cart.getSelected());
                        cart.setSelected([]);
                        var selectedIds = [];
                        var mId = {};
                        selectedIds.push(this.mId);
                        cart.setSelected(selectedIds);
                        mId[this.mId] = 1;
                        cart.set(mId);
                        window.moveToView("orderInfo",data.data.item._id);
                    }else{
                        alert(data.data.message);
                    }
                }));
            }
        },
        singlePriceOrder(e){
            var dom = e.target;
            if(dom && domClass.contains(dom.parentNode,"priceRight")){
                cart.clear(cart.getSelected());
                cart.setSelected([]);
                var selectedIds = [];
                var mId = {};
                selectedIds.push(this.mId);
                cart.setSelected(selectedIds);
                mId[this.mId] = 1;
                cart.set(mId);
                window.moveToView("orderInfo");
            }
        }
    });
});