// 创建人：母浚驰
// 创建时间：2016-08-30
// 功能：拼团活动列表
define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/query",
    "dojo/store/JsonRest",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/View",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/pacBuy",
    "cq/biz/user/user",
    "cq/util/sys/date"
],function(declare, lang, query, JsonRest, domClass, domStyle, EdgeToEdgeStoreList, View, registry, _ViewMixin, pacBuy, user, date){
    return declare("widgets.mobile.PacBuyList",[View,_ViewMixin],{
        //设置state:1所有团购，2进行中，3未开始，4已结束  后台筛选字段是state
        //筛选条件
        params : null,
        startDate : [],
        endDate : [],
        start:0,
        pageSize:10,
        onFirstShow:function(){
            //导航
            var option = {
                isHeader:true,
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function(){
                        this.isEditing = false;
                        this.startDate = [];
                        this.endDate = [];
                        this.params.state = 0;
                        history.back();
                    }
                },
                title : "拼团活动"
            };
            this.addHeader(option);
            
            this.onCreatList();
            this.onAfterShow();
        },
        //创建列表
        onCreatList : function(){
            //创建团购商品列表
            this.pacBuyList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{
                },
                className:"mblEdgeToEdgeList",
                variableHeight:true,
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        var sDate = date.formatISODateMinutes(data[i].startTime);
                        var eDate = date.formatISODateMinutes(data[i].endTime);
                        var buyPrice = window.fixedTo(data[i].pacPic/data[i].mId.retailPrice,3);
                        data[i]._label="<div class='discount'><span>"+buyPrice+"折</span><br>"
                        +data[i].pacNum+"人团</div>"
                        +"<div><img style='width: auto;max-width: 60%;' src='"
                        +data[i].mId.logo+"'></div>"
                        +"<div class='date2'><div class='dateLeft'></div>"
                        +"活动结束时间<div class='dateRight'>"+eDate+"</div></div>"
                        +"<ul class='pbul'><li>"+data[i].title+"</li><li>"+data[i].rcdInfo+"</li></ul>"
                        +"<div class='kaituan'>"
                        +"<img class='pacimg' src='../../static/images/mobile/pacBuyList.png'>"
                        +"<div class='kaiTuanDiv'>"
                        +"<span style='margin-left:30px;'>拼团人数："+data[i].pacNum+"人团</span>"
                        +"<span style='width:68%;'>拼团价格："+data[i].pacPic+"</span>"
                        +"<a class='editpac'>去开团"
                        +"<div class='one'><div class='two'></div></div></a></div></div>"
                        this.startDate.push(sDate);
                        this.endDate.push(eDate);
                    }
                    this.pacBuyList.generateList(data);
                    this.busy=false;
                }),
                itemMap:{
                    _label:"label"
                }
            });
            this.pacBuyList.placeAt(this.centerPanel.containerNode,"last");
            //列表的点击事件
            this.pacBuyList.on("click",lang.hitch(this,this.onClickList));
            //添加滚动事件
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        //根据type加载拼团商品信息  给出query的值 
        loadPac : function(){
            this.start = 0;
            this.pacBuyList.destroyDescendants();
            if(this.store){
                this.busy = true;
                var queryResult= this.pacBuyList.setQuery(this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                this.params = {
                    isUse : true,
                    state : 2
                };
                //如果没有store就创建数据源
                this.store = new JsonRest({target:pacBuy.getLoadByStateUrl()});
                this.busy=true;
                var queryResult =this.pacBuyList.setStore(this.store,this.params,{
                    start: this.start,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },
        //拖动加载更多
        onLoadMore:function(e){
            //当滚动加载更多的时候，通过e的事件来判断是setQuer哪一个列表
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                if(this.canLoadMore(this.start)){
                    console.log("加载商品");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.pacBuyList.setQuery(this.pacBuyList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        },
        onAfterShow:function(){
            this.loadPac();
        },
        onClickList:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")return;
            var dom = evt.target;
            var _id = li.params._id;
            var rebateRule=li.params.rebateRule;
            if(dom&&domClass.contains(dom,"editpac")){
                user.hasLogin().then(lang.hitch(this,function(s){
                    if(s){
                        window.moveToView("pacBuyDetail",_id);
                    }else{
                        window.moveToView("login");
                        user.nextPage="pacBuyList";
                    }
                }));
                
            }
        }
    });
});