// 创建人：母浚驰
// 创建时间：2016-08-30
// 功能：拼团活动编辑
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-class",
	"dojo/dom-style",
    "dijit/registry",
    "dojox/mobile/View",
    "dojox/mobile/ScrollableView",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/pacBuy",
    "cq/biz/mk/pacTeam",
    "cq/biz/mk/pacMember",
    "cq/biz/ts/cart",
    "cq/biz/user/user",
    "cq/util/image/qrCode",
    "cq/util/sys/date"
],function(declare, lang, query, domConstruct, domClass, domStyle, registry, View, ScrollableView, _ViewMixin, pacBuy, pacTeam, pacMember, cart, user, qrCode, date){
    // 拼团团队二维码
    var TeamWebchat = declare("", [View, _ViewMixin], {
        indexElement:function(){
            this.scrollableView = new ScrollableView();
            var option = {
                isEdge: true,
                variableHeight: true,
                columns: [{
                    icon: "imgurl",
                    iconClass: "logoClass qrcode-icon",
                    className: "qrcode-li1-c1"
                }, {
                    label: "<div class='matName'></div><div class='matPic'>￥<span></span></div>",
                    className: "qrcode-li1-c2"
                }],
                labelClass: 'font-size3',
                className: "qrcode-li qrcode-li1"
            };
            this.codeView = this.addColumns(option);
            this.scrollableView.domNode.appendChild(this.codeView);
            option = {
                isEdge: true,
                variableHeight: true,
                columns: [{
                    icon: "imgurl",
                    iconClass: "qrCodeClass",
                    className: "flex1"
                }],
                className: "qrcode-li qrcode-li2",
                forceWidth: false
            };
            this.scrollableView.domNode.appendChild(this.addColumns(option));
            this.creatPublicView(this.scrollableView);
            this.scrollableView.placeAt(this.centerPanel.containerNode, "last");
            this.scrollableView.on("touchStart", lang.hitch(this, this.stopScroll));
            this.scrollableView.resize();
        },
        setTeamWebchat:function(data){
            this.startup();
			
            data.teamUrl = qrCode.generatePNG(data.teamUrl);
            query(".qrCodeClass", this.domNode)[0].src = data.teamUrl;
            this.scrollableView.show();
            var logo = data.logo;
            query(".logoClass", this.domNode)[0].src = logo;
            var matName = data.mName;
            query(".matName", this.domNode)[0].innerHTML = matName;
            var pacPic = data.pacPic;
            query(".matPic span", this.domNode)[0].innerHTML = pacPic;
            this.refreshData();
        },
        creatPublicView: function(strollView) {
            var option = {
                columns: [{
                    label: '扫一扫加入我们的团购'
                }],
                labelClass: 'font-size5',
                className: "qrcode-li qrcode-li4 qrcodePac"
            };
            strollView.domNode.appendChild(this.addColumns(option));
        },
    });
    return declare("widgets.mobile.PacBuyDetail",[View,_ViewMixin],{
        start : 0,
		onAfterShow:function(){
            user.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    pacTeam.loadById(window.did).then(lang.hitch(this,function(data){
                        var datas = {};
                        if(data && data.data && data.data.item){
                            datas.endTime = date.formatISODateMinutes(data.data.item.limitTime);
                            datas.totalSale = data.data.item.pacId.mId.totalSale;
                            datas.retailPrice = data.data.item.pacId.mId.retailPrice;
                            datas.logo = data.data.item.pacId.mId.logo;
                            datas.buyPrice = window.fixedTo(data.data.item.pacId.pacPic/data.data.item.pacId.mId.retailPrice,3);
                            datas.rcdInfo = data.data.item.pacId.rcdInfo;
                            datas.title = data.data.item.pacId.title;
                            datas.pacPic = data.data.item.pacId.pacPic;
                            datas.pacNum = data.data.item.pacId.pacNum;
                            datas.mName = data.data.item.pacId.mId.mName;
                            this.pacId = data.data.item.pacId._id;
                            this.mId = datas.matId = data.data.item.pacId.mId._id;
                            this.setData(datas);
                            this.refreshData();
                            this.createPacTeam(data.data.item);
                            this.createButtom(data.data.item);
                            registry.byId("pacTeamDetail").resize();
                        }
                    }));
                }else {
                    window.moveToView("login");
                    user.nextPage="pacTeamDetail-"+window.did;
                }
            }));
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function() {
						history.back();
					}
				},
				title:"团队详情"
			};
			this.addHeader(option);
            
            option = {
                'class': "pacTeamInfo",
                isEdge:true,
                lists:[{
                    label:"<div class='discount'><span>{{buyPrice}}折</span><br>"
                    +"{{pacNum}}人团</div>"
                    +"<div><div><img class='teamMatIcon' src='{{logo}}'><div><div class='pacTitle'><span>"
                    +"拼团活动：{{title}}</span></div><div class='pacInfo'>"
                    +"<span>活动介绍：{{rcdInfo}}</span></div>"
                    +"<div class='pacPic'><span>￥{{pacPic}}</span></div>"
                    +"<div class='teamSuccess'>"
                    +"<img class='successImg' src='../../static/images/mobile/chenggong.png'></div>"
                    +"<a href='#matDetail-{{matId}}' class='teamMatDetail'><span>查看商品详情</span><a></div>"
                }]
            };
            
			this.addLists(option);
            
            option = {
                'class': "pacTeamInfo",
                isEdge:true,
                lists:[{
                    label:"<div><div class='teamIconFirst'><div>拼团介绍</div></div>"
                    +"<div class='pacInfoUl'></div></div>"
                },{
                    label:"<div><div class='teamIconSecend'><div>团员介绍</div></div>"
                    +"<div class='teamInfoUl'></div></div>"
                }]
            };
            this.addLists(option);
            //拼团玩法
            option = {
                'class': "top-bottom-margin16 pacPlay",
                isEdge:true,
                lists:[{
                    moveTo: "#",
                    label: "<font style='color:#000;'>拼团玩法</font>",
                    rightText: "<font style='color:#666;'>查看详情</font>",
                    onClick : lang.hitch(this,function(){
                        window.moveToView("pacBuyIntroduces");
                    })
                },{
                    label:"<div class='playDiv'><div class='playlist playColor'>"
                    +"选择心仪<br>商品<div class='playNubmer'>1</div></div>"
                    +"<div class='arrow' "
                    +"style='background-image:url(../../static/images/mobile/greenArrow.png);'></div>"
                    +"<div class='playlist playColor'>"
                    +"支付开团<br>或参团<div class='playNubmer'>2</div></div>"
                    +"<div class='arrow' "
                    +"style='background-image:url(../../static/images/mobile/greenArrow.png);'></div>"
                    +"<div class='playlist playColor'>"
                    +"等待好友<br>参团支付<div class='playNubmer'>3</div></div>"
                    +"<div class='arrow' "
                    +"style='background-image:url(../../static/images/mobile/greenArrow.png);'></div>"
                    +"<div class='playlist playColor'>"
                    +"达到人数<br>团购成功<div class='playNubmer'>4</div></div></div>"
                }]
            };
            this.addLists(option);
            
            option = {
                columns:[{
                    className: "footer-tab-highlight createTeam",
                    label:'我要开团',
                    onClick:lang.hitch(this,this.createTeam)
                },{
                    className: "footer-tab-dark joinTeam",
                    label:'我要参团',
                    onClick:lang.hitch(this,this.joinTeam)
                },{
                    className: "footer-tab-highlight newCreateTeam",
                    label:'重新开团',
                    onClick:lang.hitch(this,this.newCreateTeam)
                },{
                    className: "footer-tab-highlight postOrder",
                    label:'立即支付',
                    onClick:lang.hitch(this,this.postOrder)
                },{
                    className: "footer-tab-highlight shareShow",
                    label:'扫码分享',
                    onClick:lang.hitch(this,this.shareShow)
                },{
                    className: "footer-tab-highlight shareToF",
                    label:'分享给朋友',
                    onClick:lang.hitch(this,this.shareToF)
                },{
                    className: "footer-tab-highlight printWebchat",
                    label:'点击关注公众号后分享开团',
                    onClick:lang.hitch(this,this.printWebchat)
                },{
                    className: "footer-tab-dark otherTeam",
                    label:'其他商品',
                    onClick:lang.hitch(this,this.otherTeam)
                }],
                labelClass:'font-size1',
                className:'padding-top-bottom16',
                isFooter:true
            };
            this.addColumns(option);
			this.onAfterShow();
		},
        createPacTeam:function(data){
            var pacInfoList = "",teamInfoList = "",
            pacInfoDom = query(".pacInfoUl",this.domNode)[0],
            teamInfoDom = query(".teamInfoUl",this.domNode)[0],
            createTime = date.formatISODateMinutes(data.createAt);
            teamInfoDom.innerHTML = "";
            pacInfoDom.innerHTML = "";
            if(data.leader.logo){
                pacInfoList = "<li class='pacInfoLi'><img src='"+data.leader.logo+"'></li>";
                teamInfoList = "<li class='teamInfoLi'><img src='"+data.leader.logo+"'>"
                +"<span class='leader'><font>团长</font> "+data.leader.userName+"</span>"
                +"<span class='makeTeam'>"+createTime+"开团</span></li>";
            }else{
                pacInfoList = "<li class='pacInfoLi default'><img src='../../static/images/mobile/user1.png'></li>";
                teamInfoList = "<li class='teamInfoLi default'><img src='../../static/images/mobile/user1.png'>"
                +"<span class='leader'><font>团长</font> "+data.leader.userName+"</span>"
                +"<span class='makeTeam'>"+createTime+"开团</span></li>";
            }
            pacMember.loadPaidMembers({teamId:window.did}).then(lang.hitch(this,function(result){
                var items = result.data.items;
                for(var i = 1; i<items.length; i++){
                    if(items[i].userLogo){
                        pacInfoList += "<li class='pacInfoLi'><img src='"+items[i].userLogo+"'></li>";
                    }else{
                        pacInfoList += "<li class='pacInfoLi default'><img src='../../static/images/mobile/user1.png'></li>";
                    }
                }
                for(var i = items.length; i<data.pacId.pacNum; i++){
                    pacInfoList += "<li class='pacInfoLi default'><img src='../../static/images/mobile/user1.png'></li>";
                }
                var pacInfoLi = domConstruct.create('ul',{
                    innerHTML : pacInfoList
                });
                pacInfoDom.appendChild(pacInfoLi);
            }));
            
            //根据成员状态显示到页面
            pacMember.load({teamId:data._id,state:3}).then(lang.hitch(this,function(result){
                if(result && result.data && result.data.items){
                    var datas = result.data.items;
                    for(var i = 0; i<datas.length;i++){
                        var createTime = date.formatISODateMinutes(datas[i].createAt);
                        if(datas[i].user._id != data.leader._id){
                            if(datas[i].user.logo){
                                teamInfoList += "<li class='teamInfoLi'>"
                                +"<img src='"+datas[i].user.logo+"'>"
                                +"<span class='leader'>"+datas[i].user.userName+"</span>"
                                +"<span class='makeTeam'>"+createTime+"参团</span></li>";
                            }else{
                                teamInfoList += "<li class='teamInfoLi'>"
                                +"<img src='../../static/images/mobile/user1.png'>"
                                +"<span class='leader'>"+datas[i].user.userName+"</span>"
                                +"<span class='makeTeam'>"+createTime+"参团</span></li>";
                            }
                            
                        }
                    }
                    var teamInfoLi = domConstruct.create('ul',{
                        innerHTML : teamInfoList
                    });
                    teamInfoDom.appendChild(teamInfoLi);
                }
            }));
        },
        createButtom:function(data){
            var items = query(".col",this.domNode);
            var createTeam = query(".createTeam",this.domNode)[0];
            var joinTeam = query(".joinTeam",this.domNode)[0];
            var newCreateTeam = query(".newCreateTeam",this.domNode)[0];
            var postOrder = query(".postOrder",this.domNode)[0];
            var shareShow = query(".shareShow",this.domNode)[0];
            var shareToF = query(".shareToF",this.domNode)[0];
            var printWebchat = query(".printWebchat",this.domNode)[0];
            var otherTeam = query(".otherTeam",this.domNode)[0];
            var teamSuccess = query(".teamSuccess",this.domNode)[0];
            var successImg = query(".successImg",this.domNode)[0];
            //successImg.src = "../../static/images/mobile/chenggong.png";
            for(var i = 0; i<items.length;i++){
                domStyle.set(items[i],"display","none");
            }
            domStyle.set(teamSuccess,"display","none");
            var param = {};
            param.user = user.userId;
            param.teamId = data._id;
            //开团成功
            if(data.state == 2){
                pacMember.load(param).then(lang.hitch(this,function(result){
                    //我已入团
                    if(result && result.data && result.data.items.length>0){
                        //订单已支付，已经关注公众号
                        //if(result.data.item.state == 3 && true == true){
                          //  domStyle.set(printWebchat,"display","inline-block");
                        //订单已支付，未关注公众号
                        //}else 
                        if(result.data.items[0].state == 3){
                            domStyle.set(shareShow,"display","inline-block");
                        //订单未支付
                        }else if(result.data.items[0].state == 2){
                            domStyle.set(postOrder,"display","inline-block");
                        }
                    //我未入团
                    }else {
                        domStyle.set(createTeam,"display","inline-block");
                        domStyle.set(joinTeam,"display","inline-block");
                    }
                    registry.byId("pacTeamDetail").resize();
                }));
            }
            //拼团成功
            if(data.state == 3){
                domStyle.set(createTeam,"display","inline-block");
                domStyle.set(otherTeam,"display","inline-block");
                domStyle.set(teamSuccess,"display","block");
            //拼团失败
            }else if(data.state == 4){
                domStyle.set(newCreateTeam,"display","inline-block");
                domStyle.set(otherTeam,"display","inline-block");
                successImg.src = "../../static/images/mobile/shibai.png";
                domStyle.set(teamSuccess,"display","block");
            } 
            //测试
            /* else if(data.state == 2){
                domStyle.set(createTeam,"display","inline-block");
                domStyle.set(joinTeam,"display","inline-block");
            //测试订单已支付
            }else if(data.orderPay == 1){
                domStyle.set(shareShow,"display","inline-block");
            }
            //测试订单未支付
            else if(data.orderPay == 2){
                domStyle.set(postOrder,"display","inline-block");
            }
            //测试我未入团
            else if(data.joinTeam == 0){
                domStyle.set(createTeam,"display","inline-block");
                domStyle.set(joinTeam,"display","inline-block");
            } */
        },
        //我要开团
        createTeam:function(e){
            window.moveToView("pacBuyDetail",this.pacId);
        },
        //我要参团
        joinTeam:function(e){
            var selectedIds = [];
            var mId = {};
            selectedIds.push(this.mId);
            cart.setSelected(selectedIds);
            mId[this.mId] = 1;
            cart.set(mId);
            pacMember.joinTeam({teamId: window.did}).then(lang.hitch(this,function(result){
                if(result.data.ok == 1){
                    alert("你正准备参团请提交订单");
                    window.moveToView("orderInfo",window.did);
                }else{
                    alert("参团失败");
                }
            }));
        },
        //重新开团
        newCreateTeam:function(e){
            window.moveToView("pacBuyDetail",this.pacId);
        },
        //立即支付
        postOrder:function(e){
            cart.clear(cart.getSelected());
            cart.setSelected([]);
            var selectedIds = [];
            var mId = {};
            selectedIds.push(this.mId);
            cart.setSelected(selectedIds);
            mId[this.mId] = 1;
            cart.set(mId);
            window.moveToView("orderInfo",window.did);
        },
        //扫码分享
        shareShow:function(e){
            this.teamWebchatEdit();
        },
        //分享给朋友
        shareToF:function(e){
            e
        },
        //点击关注公众号后分享开团
        printWebchat:function(e){
            e
        },
        //其他拼团
        otherTeam:function(e){
            window.moveToView("pacAllTeamList");
        },
        
        // 拼团团队二维码
		teamWebchatEdit : function () {
            var pacInfo = this.getData();
            pacInfo.teamUrl = location.href;
            this.teamWebchat = new TeamWebchat();
			this.webchatDiv = domConstruct.create("div", {
				style : "height:600px;"
			});
			this.webchatDiv.appendChild(this.teamWebchat.domNode);
			this.showInOverlay(this.webchatDiv);
			return this.teamWebchat.setTeamWebchat(pacInfo);
		},
    });
});