﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dojo/Deferred",
    "dojox/mobile/View",
    "dojox/mobile/ListItem",
    "dojox/mobile/SpinWheel",
    "dojox/mobile/SpinWheelSlot",
    "cq/ui/view/_ViewMixin",
    "cq/ui/view/_ShelfMixin",
    "cq/util/edit/overlay",
    "cq/biz/article/article",
    "cq/biz/mat/mat",
    "cq/biz/user/userFarmer",
    "cq/biz/shop/shop"
],function(declare,lang,array,domConstruct,domStyle,query,Deferred,View,ListItem,SpinWheel,SpinWheelSlot,_ViewMixin,_ShelfMixin,overlay,article,mat,userFarmer,shop){
    domConstruct.create("style",{
        innerHTML: ".List4 .List:last-child,.List3 .List:last-child,.List2 .List:last-child{margin-right:5px;}"
    }, document.head);
    //创建弹出框选择乡村
    var BoxEdit = declare("", [View, _ViewMixin], {
        style:"height:250px;",
        editStepDef:null,
        //选择乡村弹出框
        startEditStep:function(item){
            if(!this.districtSelectPane){
                //创建乡村的滚轮的 div 
                this.createTownVillage();
            }
            overlay.domNode.innerHTML = "";
            overlay.domNode.appendChild(this.domNode);
            overlay.show();
            
            this.editStepDef = new Deferred();
            this.originItem = item;
            this.loadChildShopData(null,this.townSlot,"town");
            return this.editStepDef;
        },
        //初始化选择的滚轮，底部确定取消按钮，侦听事件
        createTownVillage:function(){
            this.districtSelectPane = domConstruct.create("div",{
                style:"width:100%;"
            },this.centerPanel.domNode.parentNode);
            domStyle.set(this.centerPanel.domNode,"display","none");
            this.spinwheel = new SpinWheel({
                style:"width:220px;"
            });
            //滚轮选择乡村
            //镇
            this.townSlot = new SpinWheelSlot({
                style:{textAlign:"center", width:"100px"}
            });
            this.spinwheel.addChild(this.townSlot);
            this.connect(this.townSlot,"onFlickAnimationEnd",this.onTownChanged);
            this.spinwheel.placeAt(this.districtSelectPane, 'last');
            //村
            this.villageSlot = new SpinWheelSlot({
                style:{textAlign:"center", width:"100px"}
            });
            this.spinwheel.addChild(this.villageSlot);
            this.connect(this.villageSlot,"onFlickAnimationEnd",this.onVillageChanged);
            this.spinwheel.startup();
            this.addColumns({
				columns:[{
					label: '确定',
					className: 'flex2 footer-tab-dark',
					onClick: lang.hitch(this, this.onFinished)
				},{
					label: '取消',
					className: 'flex2 footer-tab-highlight',
					onClick: lang.hitch(this, this.onConcel)
				}],
				forceWidth: false,
				isFooter: true
            });
        },
        loadChildShopData:function(parentShop,slot,tp){
            shop.getChildShops({
                srcShop:parentShop?parentShop._id:shop.getShopId()
            }).then(lang.hitch(this,function(data){
                this[tp+"Arr"] = data&&data.data&&data.data.items;
                this[tp] = this[tp+"Arr"][0];
                slot.domNode.innerHTML = "";
                slot.params.items = slot.items = array.map(this[tp+"Arr"],function(item){
                    return [item._id,item.shopName];
                },this);
                slot.buildRendering();
                slot.init();
                slot.resize();
                if(this[tp]&&this[tp].shopName){
                    slot.set("value", this[tp].shopName);
                }
                slot.onFlickAnimationEnd();
            }));
        },
        onTownChanged:function(){
            array.forEach(this.townArr,function(item){
                if(this.townSlot.get("key") == item._id){
                    this.town = item;
                }
            },this);
            this.loadChildShopData(this.town,this.villageSlot,"village");
        },
        onVillageChanged:function(){
            array.forEach(this.villageArr,function(item){
                if(this.villageSlot.get("key") == item._id){
                    this.village = item;
                }
            },this);
        },
        onFinished:function(){
            this.editStepDef.resolve(this.village);
            overlay.hide();
        },
        onConcel:function(){
            this.editStepDef.resolve(this.originItem);
            overlay.hide();
        }
    });
    var borderStyle = "border:1px solid rgb(93,179,8);border-radius:5px;";//外边框圆角线条样式
    var imgBorderStyle = "border-radius:5px 5px 0 0;";//图片上面两个角圆角化
    var centerTitleStyle = "text-align:center;height:20px;overflow:hidden";
    return declare("widgets.mobile.ReVillager",[View,_ViewMixin,_ShelfMixin],{
        nodeHash:{},
        //区域信息
        areaInfos:[{
            icon:"/static/sites/mobile/images/village/clr.png",
            areaId:"村里人",
            minHeight:0,
            tp:"user",
            titleTp:"before",
            maxNum:4
        },{
            icon:"/static/sites/mobile/images/village/clh.png",
            areaId:"村里货",
            minHeight:0,
            tp:"mat",
            titleTp:"before",
            maxNum:3
        },{
            icon:"/static/sites/mobile/images/village/cly.png",
            areaId:"村里游",
            minHeight:0,
            tp:"news",
            titleTp:"over",
            maxNum:2
        },{
            icon:"/static/sites/mobile/images/village/cls.png",
            areaId:"村里事",
            minHeight:0,
            tp:"news",
            titleTp:"over",
            maxNum:3
        },{
            icon:"/static/sites/mobile/images/village/cyq.png",
            areaId:"村优企",
            minHeight:0,
            tp:"news",
            titleTp:"before",
            maxNum:3
        }],
        //选择乡村
        getTownVillage:function(){
            this.startEditStep().then(lang.hitch(this,function(data){
                //根据取得的镇的id获取镇的商家信息
                data.logo = data.logo?data.logo:'../../static/sites/yytyb/images/logo.png';
                this.shopInfo = data;
                this.refreshRevillageInfo();
            }));
        },
        //创建弹窗
        startEditStep:function(item){
            if(!this.stepEditDiv){
                this.stepEditDiv=domConstruct.create("div",{
                    style:"height:400px;text-align: left;"
                });
                this.stepEditItem = new BoxEdit();
                this.stepEditDiv.appendChild(this.stepEditItem.domNode);
                setTimeout(lang.hitch(this.stepEditItem,this.stepEditItem.startup),0);
            }
            this.showInOverlay(this.stepEditDiv);
            return this.stepEditItem.startEditStep(item);
        },
        onFirstShow:function(){
            domStyle.set(this.domNode,{
                "background-color":"#FFF"
            });
            this.addHeader({
				left:{
                    icon: '../../static/sites/yytyb/images/logo.png',//'images/logo.png'
                    crop: true
                },
                //left:{icon:window.__shop.logo?window.__shop.logo:'images/logo.png'},
                title:"进村入户",
                right:{
					iconButton : ' ',
                    label : "切换乡村",
                    onClick:lang.hitch(this,this.getTownVillage)
				}
            });
            this.addTypedArea("基本概况",0);
            array.forEach(this.areaInfos,this.addArea,this);
            this.addFooterColumns();
            this.onAfterShow();
        },
        //添加一个不带标题的区域
        addTypedArea:function(tp,minHeight,isFlex,maxNum){
            this.nodeHash[tp] = domConstruct.create("div",{
                "class":(isFlex?("hflex "+"List"+maxNum):""),
                style:"min-height:"+minHeight+"px;"
            },this.centerPanel.containerNode);
        },
        //添加一个带标题区域
        addArea:function(areaInfo){
                //添加标题区域
            this.logo = domConstruct.create("div",{
                style:"text-align:left;margin:20px 5px 10px 5px;",//height:44px;
                innerHTML:'<img style="width:auto;max-width:100%;" src="'+(areaInfo.icon?areaInfo.icon:'../../static/common/images/nopic.png')+'">'
            },this.centerPanel.containerNode);
            //添加内容区域
            this.addTypedArea(areaInfo.areaId,areaInfo.minHeight,true,areaInfo.maxNum);
        },
        //显示之后，若第一次，获取一个商家，显示其信息
        onAfterShow:function(){
            if(!this.shopInfo){
                shop.loadById(shop.getShopId()).then(lang.hitch(this,function(data){
                    this.shopInfo = data.data;
                    //this.shop = data.data;
                    //每次页面刷新都要改变登陆图标
                    this.refreshRevillageInfo();
                }));
            }
        },
        //依据当前的商家信息刷新界面显示
        refreshRevillageInfo:function(){
            //刷新标题和logo
			if (this.header) {
				var icon = query(".header-image.image-crop", this.header.domNode)[0];
				if (icon) {
					icon.src = this.shopInfo.logo || "../../static/sites/yytyb/images/logo.png";
				}
				this.header.set("label", this.shopInfo.shopName);
			}
            //刷新基本概况
            article.load({
                shopId:this.shopInfo._id,
                title:"基本概况"
            }).then(lang.hitch(this,function(data){
                var item = data&&data.data&&data.data.items&&data.data.items[0]||{};
                var logo = item.logo||"",content = item.content;
                this.nodeHash["基本概况"].innerHTML = (
                    logo?"<img style='width:100%;' src='"+logo+"'>":""
                )+(
                    content?"<div style='padding:10px 10px 10px 10px;margin:0 5px;"+borderStyle+"'>"+content+"</div>":""
                );
            }));
            //刷新村里人等信息
            array.forEach(this.areaInfos,this.refreshAreaContent,this);
            
        },
        //加载村里人事等等信息
        refreshAreaContent:function(areaInfo){
            var def = null,shopId = this.shopInfo._id,url = "";
            if("user"===areaInfo.tp){
                def = userFarmer.load({
                    shopId:shopId,
                    orderBy:"-createAt",
                    isFarmer:true,
                    pageSize:areaInfo.maxNum
                });
                url = "#farmerMsg-";
            }else if("mat"===areaInfo.tp){
                def = mat.loadRecMat({
                    shopId:shopId,
                    orderBy:"code",
                    isUse:true,
                    qty:1,
                    pageSize:areaInfo.maxNum
                });
                url = "#matDetail-";
            }else if("news"===areaInfo.tp){
                def = article.loadByGroupNameFromShop({
                    shopId:shopId,
                    title:areaInfo.areaId,
                    orderBy:"code",
                    pageSize:areaInfo.maxNum
                });
                url = "#newDetail-";
            }else{
                return;
            }
            def.then(lang.hitch(this,function(data){
                var items = data&&data.data&&data.data.items||[];
                //空对象来保存相应截取的条数
                var item=[];
                array.forEach(items,function(item){
                    item.url = url+item._id;
                });
                //内容补齐
                if(items.length<areaInfo.maxNum){
                    items[areaInfo.maxNum-1] = null;
                }
                this.nodeHash[areaInfo.areaId].innerHTML = array.map(items,function(item){
                    return this.createCardHtml(item,areaInfo.tp,areaInfo.titleTp);
                },this).join("");
            }));
        },
        //获取卡片形状的html片段
        createCardHtml:function(item,tp,titleTp){
            if(!item){
                return '<div class="flex1" style="background:none;position:relative;"></div>';
            }else{
                var icon = item.logo;
                var title = "";
                var img = "";
                imgstyle = "margin:1px;overflow:hidden";
                if(tp==="mat"){
                    title = '<div style="font-size:16px;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;">'+(item.mName||"")+'</div>';//style="margin-top:1%;'+centerTitleStyle+'"
                    img = '<img src="'+item.logo+'" style="width:100%;'+imgBorderStyle+'"/>';
                }else if(tp==="news"){
                    title = '<div style="font-size:16px;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;">'+(item.title||"")+'</div>';//style="'+centerTitleStyle+'"
                    img = '<img src="'+item.logo+'" style="width:160%;margin-left:-30%;'+imgBorderStyle+'"/>';
                }else{
                    img = '<img src="'+item.logo+'" style="width:auto;max-width:100%;border-radius: 5px;'+imgBorderStyle+'"/>';
                    title = '<div >'+
                        '<font style="color:rgb(93,179,8);">村民：</font>'+(item.pName||"")+'</div>';
                }
                return '<div style="margin-left:5px;" class="flex1 List">'+//style="position:relative;background:none;background-color:white;'+borderStyle+''+imgstyle+'" 
                    '<a style="border: 1px solid rgb(93,179,8);display: block;border-radius: 5px;position: relative;overflow:hidden;line-height:30px;" href="'+item.url+'" >'+img+'<div '+(
                    titleTp==="over"?
                    'style="text-align:center;width:100%;position:absolute;background-color:rgba(0,0,0,0.5);bottom:0px;color:white;overflow:hidden;white-space: nowrap;text-overflow: ellipsis;':
                    'style="position: absolute;bottom: 0;background: white;width: 100%;border-radius: 0 0 5px 5px;line-height:30px;text-align:center;font-size:14px;"'
                )+'>'+title+'</div></a></div>';
            }
        }
    });
});