﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/View",
	"cq/ui/view/_ViewMixin" ,
    "cq/ui/view/_ShelfMixin",
    "cq/biz/article/article",
    "cq/biz/mat/mat",
    "cq/biz/ts/sc/supply_demand",
    "cq/biz/shop/shop",
    "cq/util/sys/date",
    "cq/biz/user/user"
],function(declare,lang,array,query, Deferred,domConstruct,domClass,domStyle,View,_ViewMixin,_ShelfMixin,article,mat,supplyDemand,shop,date,user){
    domConstruct.create("style", {
        innerHTML: ".List3 .List:last-child{margin-right:5px;}"
    }, document.head);
    return declare("widgets/mobile/SaleBuyCenter",[View,_ViewMixin,_ShelfMixin],{
        //初始化界面元素
        onFirstShow:function(){
            //添加顶部图片
            var option = {src:'/static/sites/mobile/images/village/headPic.png', onClick:function(){}};
			this.addImage(option);
            //添加供求信息
            option = {
				isEdge:true,
				lists:[{
					label:"供求信息",
					rightText:"",
					rightIcon:"",
					onClick:function(){}
				}]
			};
			this.addLists(option);
            //供求信息切换栏
            option = {
                columns: [{
                    icon: '',
                    iconClass: '',
					className: 'flex1',
                    label: '供应',
                    onClick: function(evt) {
                        this.setSelect(evt.target);
                        query(".saleBuy")[0].innerHTML="";
                        this.onLoadSaleInfo(0);
                    }
                },{
                    icon: '',
                    iconClass: '',
                    label: '求购',
					className:'flex1',
                    onClick: function(evt) {
                        this.setSelect(evt.target);
                        query(".saleBuy")[0].innerHTML="";
                        this.onLoadSaleInfo(1);
                    }
                }],
                forceWidth:false,
                labelClass: 'font-size3',
                className: 'saleBuy-tab',
            };
            this.selector = this.addColumns(option);
           
            var containerNode = domConstruct.create("div",{
                className:"saleBuy",
                style : "height:216px;background:white;",
            },this.centerPanel.containerNode,"last");
            option = {
				isEdge:true,
				lists:[{
					label:"桃园市场",
					rightText:"更多",
					class:"matGroupHeader",
					rightIcon:"",
					onClick:function(){
						window.moveToView("matList");
					}
				}]
			};
			this.marketOption=this.addLists(option);
            
            var saleMarketNode = domConstruct.create("div",{
                className: "matShelf",
                style: "background:white;padding-top: 5px;padding-bottom: 5px;"
            },this.centerPanel.containerNode,"last");
            option = {
				isEdge:true,
				lists:[{
					label:"价格行情",
					rightText:"",
					class:"matGroupHeader",
					rightIcon:"",
					onClick:function(){
						window.moveToView("");
					}
				}]
			};
			this.addLists(option);
            option = {src:'/static/sites/mobile/images/village/price.png', onClick:function(){
                this.getArticleMsg();
            }};
			this.addImage(option);
            this.addFooterColumns();
            this.setSelectClass();
            this.setSelect(query(".saleBuyFlex",this.domNode)[0]);
            //设置样式
            domStyle.set(query(".saleBuy-tab",this.selector.domNode)[0],"line-height","30px");
            //为文字设置颜色
            var labelItems=query(".mblListItemLabel",this.domNode);
            for(var i=0;i<labelItems.length;i++){
                domStyle.set(query(".mblListItemLabel",this.domNode)[i],"color","#199419");
                domStyle.set(query(".mblListItemLabel",this.domNode)[i],"font-weight","bold");
            }
            //绑定商品跳转详情
            this.connect(query(".matShelf")[0],'onclick',function(evt){
                this.moveToDetail(evt);
            });
            this.onAfterShow();
        },
        //加载数据
        onAfterShow:function(){
            //加载桃园市场显示内容
            mat.loadRecMat({
                isUse:true,
                orderBy:"code",
                pageSize:6,
                shopId:mat.getShopId()
            }).then(lang.hitch(this,function(data){
                var items = data&&data.data&&data.data.items||[], d1 = null, d2 = null, len = 0;
                domConstruct.empty(query(".matShelf")[0]);
                if(items.length<=3&&items.length>0){
                    d1 = domConstruct.create("div", {
                        class: "hflex List3"
                    });
                    len = 3-items.length;
                    while(len--){
                        items.push({});
                    }
                    array.forEach(items, function(item){
                        d1.appendChild(this.getHtmlToDom(item));
                    }, this);
                    query(".matShelf")[0].appendChild(d1);
                }else{
                    d1 = domConstruct.create("div", {
                        class: "hflex List3"
                    });
                    d2 = domConstruct.create("div", {
                        class: "hflex List3",
                        style: "margin-top:5px;"
                    });
                    len = 6-items.length;
                    while(len--){
                        items.push({});
                    }
                    array.forEach(items, function(item, i){
                        if(i+1<=3){
                            d1.appendChild(this.getHtmlToDom(item));
                        }else{
                            d2.appendChild(this.getHtmlToDom(item));
                        }
                    }, this);
                    query(".matShelf")[0].appendChild(d1);
                    query(".matShelf")[0].appendChild(d2);
                }
            }));
            //加载供应信息显示内容
            this.onLoadSaleInfo();
            
        },
        getHtmlToDom: function(item){
            return domConstruct.toDom(item._id?(
            '<div title="'+item._id+'"class="matItems flex1 List" style="margin-left:5px;">'+ // style="vertical-align:top;display:inline-block;width:29%;margin-right: 10px;border:1px solid rgb(93,179,8);border-radius: 10px;"
                '<a href="#matDetail-'+item._id+'" style="border:1px solid rgb(93,179,8);border-radius:5px;display:block;overflow: hidden;position: relative;">'+
                    '<img style="width: auto;max-width: 100%;border-radius: 5px;" src="' +(item.logo?item.logo:("/static/sites/mobile/images/village/nomat.jpg"))+ '">'+
                    '<div style="position: absolute;bottom: 0;width: 100%;background: white;font-size: 14px;">'+
                        '<div style="line-height: 24px;margin-left: 5px;margin-right: 5px;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;">'+item.mName+'</div>'+
                        '<div style="display:flex;margin-bottom: 5px;">'+
                            '<div style="flex:1;color:#ff4401;line-height:20px;margin-left:5px;margin-right:5px;">￥'+item.retailPrice+'</div>'+
                            '<img style="margin-right:5px;" width="20px" height="20px" src="/static/sites/mobile/images/village/matCar.png"/>'+
                        '</div>'+
                    '</div>'+
                '</a>'+
            '</div>')
            :'<div class="flex1"></div>');
        },
        //加载供应信息显示内容
        onLoadSaleInfo:function(params){
            supplyDemand.loadByType({
                isUse:true,
                pageSize:5,
                orderBy:"-createAt",
                ioType:params
            }).then(lang.hitch(this,function(data){
                var items = data&&data.data&&data.data.items||[];
                
                // 添加头部
                var str = "<table style='width:100%;font-size:14px;border-collapse: collapse;'>"+
                    "<tr style='height:35px;border-bottom: 1px solid #ccc;text-weight:bold'>"+
                        "<td style='width:30%;padding-left:5px;'>品种</td>"+
                        "<td >数量</td>"+
                        "<td >价格</td>"+
                        "<td >发布日期</td>"+
                        "<td >联系电话</td>"+
                    "</tr>";
                
                // 加载商家信息
                var shopIds = [];
                array.forEach(items, function(item){
                    shopIds.push(item.fromShopId._id);
                });
                var shopInfo = {};
                shop.loadByIds(shopIds).then(lang.hitch(this, function(shopData){
                    var shopItems = shopData.data;
                    array.forEach(shopItems, function(item){
                        shopInfo[item._id] = item.contactPhone||"无";
                    });
                    
                    array.forEach(items, function(item){
                        str += '<tr style="border-bottom: 1px solid #ccc;height:35px;font-size:13px">'+
                        '<td class="matName1" style="padding-left:5px">'+(item.product?item.product:"")+'</td>'+
                        '<td class="count">'+(item.qty?window.fixedTo(item.qty,1):0)+'/个</td>'+
                        '<td class="price">'+((item.minPrice?window.fixedTo(item.minPrice,3):"0")+"/"+item.unit)+'</td>'+
                        '<td class="date">'+(date.formatISODate(item.sdDate))+'</td>'+
                        '<td class="tel">'+(shopInfo[item.fromShopId._id])+'</td>'+
                        '</tr>'
                    });
                    str += '</table>';
                    
                    query(".saleBuy")[0].innerHTML = str;
                }));
                // 为数据添加联系电话属性
                //if(data1.length){
                //    this.getSendUserInfo(0);
                //    this.getSendUserInfo(1);
                //    this.getSendUserInfo(2);
                //    this.getSendUserInfo(3);
                //    this.getSendUserInfo(4);
                //}
                //setTimeout(lang.hitch(this,function(){
                    //this.saleSupplyOption = array.map(data1,function(item){
                    //    return(''+'<tr style="border-bottom: 1px solid gray;height:35px;font-size:16px">'+
                    //    '<td class="matName1" style="padding-left:10px">'+(item.product?item.product:"")+'</td>'+
                    //    '<td class="count">'+(item.qty?window.fixedTo(item.qty,1):0)+'/个</td>'+
                    //    '<td class="price">'+((item.minPrice?window.fixedTo(item.minPrice,3):"0")+"/"+item.unit)+'</td>'+
                    //    '<td class="date">'+(date.formatISODate(item.sdDate))+'</td>'+
                        //'<td class="tel">'+(item.contactPhone?item.contactPhone:"110")+'</td>'+
                    //    '</tr>');
                    //});
                    //this.saleSupplyHtml=this.saleSupplyOption.join("");
                    //query(".saleBuy")[0].innerHTML=
                    //    "<table style='width:100%;background:white; border-collapse:collapse ;font-weight:blod'>"+
                    //    "<tr style='height:28px;border-bottom: 1px solid gray;text-weight:bold'>"+
                    //    "<td style='width:19%;padding-left:10px;font-weight:bold'>品种</td>"+
                    //    "<td style='width:19%;font-weight:bold'>数量</td>"+
                    //    "<td style='width:19%;font-weight:bold'>价格</td>"+
                    //    "<td style='width:19%;font-weight:bold'>发布日期</td>"+
                    //    "<td style='width:19%;font-weight:bold'>联系电话</td>"+
                    //    "</tr>"+
                    //        array.forEach(data1, function(item){
                    //            this.getHtml(item);
                    //        }, this)//this.saleSupplyHtml
                    //    +"</table>";
                //}),300);
            }));
        },
        //
        setSelectClass:function(){
            var items = query('.flex1',this.selector);
            for(var i = 0;i<items.length;i++){
                domClass.add(items[i],"saleBuyFlex");
            }
            var items1 = query(".saleBuyFlex",this.domNode);
            for(var j = 0;j<items1.length;j++){
                domStyle.set(items1[j],"background","#E3E2E2");
            }
        },
        //设置选中样式
        setSelect:function(evt){
            this.setSelectClass();
            if(domClass.contains(evt.parentNode,"content-background")){
                domStyle.set(evt,"background","#5EAC49");
            }
            if(domClass.contains(evt.parentNode,"column-2")){
                domStyle.set(evt.parentNode,"background","#5EAC49");
            }
        },
        //跳转到商品详情页面
        moveToDetail:function(evt){
            //如果点击节点的父节点class为matItems,则获取父节点的name属性实现跳转
            if(domClass.contains(evt.target.parentNode,"matItems")){
                var _id = evt.target.parentNode.title;
                window.moveToView("matDetail",_id);
            }else{
                var parentNode1 = evt.target.parentNode;
                if(domClass.contains(parentNode1.parentNode,"matItems")){
                    window.moveToView("matDetail",parentNode1.parentNode.title);
                }
            }
        },
        //获取资讯消息，并作处理
        getArticleMsg:function(){
            article.load({
                shopId:article.getShopId(),
                title:"价格行情"
            }).then(lang.hitch(this,function(data){
                this.items=data&&data.data&&data.data.items||[];
                if(!this.items.length==0){
                    window.moveToView("newDetail",this.items[0]._id);
                }
            }));
        },
        shopInfo: {},
        //加载发布者的信息
        getSendUserInfo:function(shopId){
            var def = new Deferred();
            if(this.shopInfo[shopId]){
                def.resolve(this.shopInfo[shopId]);
            }else{
                shop.loadById(shopId).then(lang.hitch(this,function(data){
                    this.shopInfo[data.data._id] = data.data.contactPhone||"暂无联系方式";
                    def.resolve(data.data.contactPhone);
                })); 
            }
            return def;
        }
        
    });
});