define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"cq/ui/view/_ViewMixin",
	"dojo/query",
	"dojox/mobile/EdgeToEdgeStoreList",
	"dojo/store/JsonRest",
	"cq/biz/mat/mat",
	"dojo/dom-class",
	"dojo/on",
	"cq/biz/shop/shop",
	"dojo/when",
	"dojox/mobile/ListItem",
	"dijit/registry",
	], function (declare, lang, View, _ViewMixin,query,EdgeToEdgeStoreList,	JsonRest,mat,domClass,on,shop,when,ListItem,registry) {
		
	//路径：
	//	widgets.mobile.ClientDistribute
	return declare("widgets.mobile.ShopDetail", [View, _ViewMixin], {
		start : 0,            
		onAfterShow : function () {
			//获取当前商铺信息			
			shop.loadById(window.did).then(lang.hitch(this,function(data){
				var args=data.data;
				this.setData(args);
				this.getShopInfo(args);
				this.getShopAbstract(args);
				this.refreshData();
				var whereData=this.StoreList.get("query");
				whereData.shopId=window.did;
				this.setQuery(whereData);
			}))
		},
		//setQuery：
		//		参数：query，类型：array
		//		设置列表起止
		setQuery:function(query){
			//清空			
			this.StoreList.destroyDescendants();
			//设置开始和数量
			this.StoreList.setQuery(query,{
				start: 0,
				count: 10
			});
			this.centerPanel.resize();
		},
		//onLoadMore:
		//		参数：evt点击事件
		//		返回值：无
		//		加载更多
		onLoadMore:function(evt){												
			if(this.busy||(0<this.end&&(this.start+10-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多商品");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.StoreList.setQuery(this.StoreList.get("query"), {
						start: this.start,
						count: 10
					}), lang.hitch(this,function(){
						this.centerPanel.resize();
					}));						
				}), 1000);
			}
		},
		//onClickList:
		//		参数：evt
		//		返回值：无
		//		给列表添加点击事件
		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params._id;
			window.moveToView("matDetail",_id);
			
		},
		//getShopInfo：
		//		参数：arg 
		//		返回值：无
		//		获取数据并显示当前商铺信息
		getShopInfo:function(arg){
			//销毁原shop信息
			this.shopInfo.destroyDescendants();
			if(!arg.svcPhone){
				arg.svcPhone=" ";
			}if(!arg.address){
				arg.address=" ";
			}if(!arg.shopName){
				arg.shopName=" ";
			}if(!arg.logo){
				arg.logo='/static/images/mobile/userIcon.png';
			}
			//创建shop信息
			var listitem=new ListItem({
						label:"<div style='display: flex' ><div><img src='"+arg.logo+"'/></div>"
							 +"<div style='line-height: 45px;'><div class='mat-list-mname mat-list-margin'>商家名:"+arg.shopName+"</div>"
							 +"<div class='mat-list-qty mat-list-margin'>电话:"+arg.svcPhone/*客服信息里面的电话*/+"</div>"
							 +"<div class='mat-list-qty mat-list-margin'>地址:"+arg.address+"</span></div></div><div>",
						variableHeight:true
						});
			this.shopInfo.addChild(listitem);
			
		},
		//店铺简介
		getShopAbstract:function(arg){
			//销毁原shop信息
			this.abstractShopl.destroyDescendants();
			//创建shop信息
			if(!arg.brief){
				arg.brief="暂无简介";
			}
			var listitem=new ListItem({
						label:"<div>"+arg.brief+"<div>",
						variableHeight:true
						});
			this.abstractShopl.addChild(listitem);
			
		},
		//onCreatList：
		//		参数：无
		//		返回值：无
		//		创建商品列表
		onCreatList:function(){
			this.StoreList=new EdgeToEdgeStoreList({
				append: true, 
				constraint: false, 
				query:{
				}, 
				class:"icon-list-item",
				variableHeight:true,
                //获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){					
					for(var i=0;i<data.length;i++){
                        data[i]._label="<div class='mat-list-mname mat-list-margin'>"+data[i].mName+
                            "</div><div class='mat-list-qty mat-list-margin'><span>库存："+data[i].qty+
                            "</span></div>"
                        data[i].moveTo="#";
						data[i]._logo = data[i].logo ? data[i].logo : '/static/sites/xmapp/images/nomat.png';
					}
					this.StoreList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),			
					queryOptions : {
						count : 10,
						start : this.start
					},
					itemMap : {_label : "label",_logo : "icon",moveTo : "moveTo"}
				});
			//创建数据源			
			this.params={isUse:true,qty:1,shopId:window.did};	
			//this.store = new JsonRest({target:mat.getOnSaleUrl()});	
			this.store = new JsonRest({target:mat.getUrlByShop()});					
			// 将数据源赋值给StoreList	
			this.StoreList.setStore(this.store,this.params);
			this.StoreList.placeAt(this.centerPanel.containerNode,"last");
			this.StoreList.on("click",lang.hitch(this,this.onClickList));			
			on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));			
				
		},
		
		onFirstShow : function () {
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function () {
						history.back();
					}
				},
				title : ""
			};
			this.addHeader(option);
			
			option = {
                isEdge: true,
                class: "bottom-margin16 shopInfo",
                lists: []
            }
            this.shopInfo=this.addLists(option);
			
			option = {
                isEdge: true,
                lists: [
				{label: '店铺简介'}   
				]
            }
            this.addLists(option);
			
			option = {
				isEdge : true,
				class : "bottom-margin16 abstractShopl",
				lists : []
			};
          this.abstractShopl=this.addLists(option);
		  this.onCreatList();
		  this.onAfterShow();
		  
		}

	});
});
