// 创建人：潘云
// 创建时间：2016-6-2
// 页面功能：商家列表
define([	
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
    "dojo/_base/event",
    "dojo/query",
    "dojo/on",
    "dojo/when",
    "dojo/dom-construct",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/store/JsonRest",
	"dojox/mobile/View",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dijit/registry",
    "cq/ui/view/_ViewMixin",
	"cq/biz/shop/shop"
],function(declare,lang,array,event,query,on,when,domConstruct,domAttr,domClass,JsonRest,View,ScrollablePane,EdgeToEdgeStoreList,registry,_ViewMixin,shop){
	return declare("widgets.mobile.ShopList",[View,_ViewMixin],{
        // 开始加载数据的下标
		start:0,
        // 每次加载数据的条数
        pageSize:10,
        // 用来存放选项的节点
        appNavItems:[],
        onAfterShow:function(){
			if(this.storeList.store){
				this.setQuery();
			}else{
				this.storeList.setStore(this.store,this.getQuery(),{
					start: 0,
					count: this.pageSize
				});
			}
			this.refreshData();
		},
		onFirstShow:function(){
			var option = {
				left : {
					iconButton : ' ',
					arrow : "left",
					label : "返回",
					onClick : function(){
						history.back();
					//window.moveToView("main");
					}
				},
				title:"商家列表"
			};
			this.addHeader(option);
		    option = {
				placeHolder:"请输入要查询条件，按回车查询",
				class:"cqSearchBox",
				type:"search",
				onInput:lang.hitch(this,function(evt){
					if(evt.keyCode==13){
						this.search = evt.target.value;
						this.setQuery();
						evt.target.value = "";
					}
				})
			};
			this.addTextBox(option);

			option = {
				className:"tabBox",
				columns:[{
					label:'全部分类',
					onClick:lang.hitch(this,function(e){
						this.tabNav(e,"0");
					})
				},
				{
					label:'全部乡镇',
					onClick:lang.hitch(this,function(e){
						this.tabNav(e,"1");
					})
				}],
				labelClass:'font-size1 tab-selector'
			}
			this.addColumns(option);
            // 获取乡镇的查询条件
            var parms = {
                svcShop:'5703ca7d0ccae34b2b40ab8c',
                shopType:2001
            };
            shop.getChildShops(parms).then(lang.hitch(this,function(data){
                var villages = [];
                villages.push({title:"全部乡镇",value:""});
                if(data&&data.data&&data.data.ok&&data.data.items){
                    for(var i = 0;i<data.data.items.length;i++){
                        villages.push({
                            title:data.data.items[i].shopName,
                            value:data.data.items[i]._id
                        });
                    }
                }
                this.createTabNavDropdowm("shopTypeTal",[
                    {
                        title:"全部分类",value:2000
                    },
                    {
                        title:"养殖企业",value:2002
                    },
                    {
                        title:"养殖户",value:2004
                    },
                    {
                        title:"合作社",value:2003
                    },
                    {
                        title:"养殖场",value:2005
                    }]);
                this.createTabNavDropdowm("svcShopTal",villages);
                this.inintTabNav();
            }));
			
			this.storeList=new EdgeToEdgeStoreList({
				append: true,
				constraint: false,
				query:{},
				class:"icon-list-item",
				variableHeight:true,
                //获取数据完成后调用的的处理方法
				onComplete:lang.hitch(this,function(data){
					for(var i=0;i<data.length;i++){
                        if(!data[i].logo){
                            data[i].logo = "/static/images/mobile/userIcon.png";
                        }
                        data[i]._label="<div class='mat-list-mname mat-list-margin'>商家名称："+(data[i].shopName||"")+
                            "</div><div class='mat-list-mname mat-list-margin'>商家地址："+(data[i].address||"")+
                            "</div><div class='mat-list-mname mat-list-margin'><span>客户电话："+(data[i].svcPhone||"")+"</div>";
                         data[i].moveTo="#";
					}
					this.storeList.generateList(data);
					this.end=this.start+data.length-1;
					this.busy = false;
				}),
				queryOptions : {
					count: this.pageSize, 
					start: this.start
				},
				itemMap:{_label:"label", logo:"icon",moveTo:"moveTo"}
			});
			// 创建数据源
			this.store = new JsonRest({target:shop.getChildShopsURL()});
			// 将数据源赋值给StoreList
			this.storeList.placeAt(this.centerPanel.containerNode,"last");
			this.storeList.on("click",lang.hitch(this,this.onClickList));
			on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
		},
        // 创建类型选项
        createTypeOption:function(tab,options){
			var item=domConstruct.create("div",{
				className:"nav_dropdowm_item"
			});
            this.dropdowm.appendChild(item);
			this.appNavItems.push(item);
			var ul=domConstruct.create("ul");
			item.appendChild(ul);
			var li="";
			for (var i = 0; i < options.length; i++) {
				li=domConstruct.create("li",{
					tabType:tab,
					tabValue:options[i].value
				});
				li.innerHTML=options[i].title;
				ul.appendChild(li);
			};
        },
        
        // 创建乡镇选项
        createVillOption:function(tab,options){
            // 创建一个ScrollablePane
            var itemScroll = new ScrollablePane({height:"287px",class:"nav_dropdowm_item"});
            var item = itemScroll.domNode;
			this.dropdowm.appendChild(item);
			this.appNavItems.push(item);
			var ul=domConstruct.create("ul");
            var itemContent = query("div",item)[0];
			itemContent.appendChild(ul);
			var li="";
			for (var i = 0; i < options.length; i++) {
				li=domConstruct.create("li",{
					tabType:tab,
					tabValue:options[i].value
				});
				li.innerHTML=options[i].title;
				ul.appendChild(li);
			};
            itemScroll.startup();
            itemScroll.on("touchStart",lang.hitch(this,this.stopScroll));
        },
        // 阻止滚动事件的冒泡
        stopScroll:function(e){
            event.stop(e);
        },
		//创建导航的下拉
		createTabNavDropdowm:function(tab,options){
			if(!this.dropdowm){
				this.dropdowm=domConstruct.create("div",{
					className:"nav_dropdowm none"
				});
				this.appNavDropDownBg=domConstruct.create("div",{
					className:"nav_dropdownbg none"
				});
                
				var tabBox=query(".tabBox",this.domNode)[0];
				tabBox.appendChild(this.dropdowm);
				tabBox.appendChild(this.appNavDropDownBg);
				this.connect(this.dropdowm,"onclick",this.onDropdowmClick);
				this.connect(this.appNavDropDownBg,"onclick",this.dropUp);
			}
            if(tab === "shopTypeTal"){
                this.createTypeOption(tab,options);
            }
            if(tab === "svcShopTal"){
                this.createVillOption(tab,options);
            }
		},
		//初始化导航默认
		inintTabNav:function(){
			var typeOption = query("li[tabValue='2000']",this.dropdowm)[0];
            var villOption = query("li[tabType='svcShopTal']",this.dropdowm)[0];
			if(typeOption){
				this.tabStyle(typeOption,typeOption.parentNode.children,"selected");
			}
            if(villOption){
                this.tabStyle(villOption,villOption.parentNode.children,"selected");
            }
		},
		onDropdowmClick:function(e){
			var dom=e.target;
			if (dom&&dom.tagName=="LI") {
                // 判断选中的类型
				if(domAttr.get(dom,"tabType")==="shopTypeTal"){
					this.shopType=domAttr.get(dom,"tabValue");
					this.chooseTabType(dom);
				}else if (domAttr.get(dom,"tabType")==="svcShopTal") {
					this.svcShop=domAttr.get(dom,"tabValue");
					this.chooseTabType(dom);
				};
			};
		},
		chooseTabType:function(dom){
            // 刷新数据
			this.setQuery();
			this.tabStyle(dom,dom.parentNode.children,"selected");
			query(".selected.tab-selector",this.appNav)[0].innerHTML=dom.innerHTML;
			this.dropUp();
		},
		onClickList:function(evt){
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if(li.declaredClass!="dojox.mobile.ListItem") return;
			var _id = li.params._id;
			window.moveToView("shopDetail",_id);
		},
		onLoadMore:function(evt){
			if(this.busy||(0<this.end&&(this.start+this.pageSize-1>this.end))){
				return true;
			}
			if(evt.afterBottom){
				this.start = this.end+1;
				console.log("加载更多商品");
				this.busy = true;
				setTimeout(lang.hitch(this,function(){
					when(this.storeList.setQuery(this.storeList.get("query"), {
						start: this.start,
						count: 10
					}), lang.hitch(this,function(){
						this.centerPanel.resize();
					}));
				}), 1000);
			}
		},
		clearSelected:function(){
			var items = query('.tab-selector',this.domNode);
			for(var i=0;i<items.length;i++){
				domClass.remove(items[i],"selected");
			}
		},
		tabNav:function(e,type){
			var dom=e.target;
            if(dom){
                array.forEach(this.appNavItems,function(index){
                    domClass.add(index,"none");
                },this);
                if(domClass.contains(dom,"selected")){
                    this.dropUp();
                }else{
                	this.clearSelected();
					domClass.add(e.target,"selected");
                    domClass.remove(this.appNavItems[type],"none");
                    this.dropDown();
                }
            }
		},
         //收起框
        dropUp:function(isFresh){
        	this.clearSelected();
            domClass.add(this.dropdowm,"none");
            domClass.add(this.appNavDropDownBg,"none");
        },
        //打开框
        dropDown:function(){
           domClass.remove(this.dropdowm,"none");
           domClass.remove(this.appNavDropDownBg,"none");
        },
        // 获取查询条件
        getQuery:function(){
            var query = {};
            if(!this.shopType||this.shopType === "2000"){
                query.shopType = [2002,2003,2004,2005];
            }else{
                query.shopType = [this.shopType];
            }
            if(this.svcShop){
                query.srcShop = this.svcShop;
            }
            if(this.search && this.search !== ""){
                query.shopName = this.search;
                this.search = "";
            }
            return query;
        },
        // 刷新数据
		setQuery:function(){
			this.start = 0;
			this.end = -1;
			this.storeList.destroyDescendants();
            this.storeList.setQuery(this.getQuery(),{
                start: this.start,
                count: this.pageSize
            });
            this.centerPanel.resize();
		},
		//切换样式
        tabStyle:function(dom,domArray,className){
            array.forEach(domArray,function(index){
                domClass.remove(index,className);
            });
            if(dom){
                domClass.add(dom,className);
            }
        }
	});
});