//  变更人:肖芳圆
//  变更时间:2016/07/11
//  变更原因: 消费者端供求信息列表
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/util/sys/date",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/store/JsonRest",
    "cq/biz/ts/sc/supply_demand"
],function(declare,lang,array,domClass,View,_ViewMixin,date,query,registry,EdgeToEdgeStoreList,JsonRest,supplyDemand){
    return declare("widgets.mobile.SupplyDemandList",[View,_ViewMixin],{
        start:0,
        pageSize:10,
        onAfterShow:function(){
            if(this.store){
                this.setQuery(this.queryParams, {
                    start: this.start,
                    count: this.pageSize
                });

            }else{
                // 创建数据源
                this.store = new JsonRest({target:supplyDemand.getPlatformDataUrl()});
                this.queryParams = {ioType:0,isUse:true};
                // 将数据源赋值给storeList
                var queryResult = this.storeList.setStore(this.store, this.queryParams,{
                    start:this.start,
                    count:this.pageSize
                });
                // 将数据源赋值给storeList
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }
        },

        onCreatList: function(){
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                class:"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    var icon = "";
                    for(var i=0;i<data.length;i++){
                        // 有图片时 使用用户图片
                        if(data[i].fromShopId&&data[i].fromShopId.logo){
                            icon = data[i].fromShopId.logo;
                        }else {// 没有时使用默认图片
                            icon = "/static/sites/mobile/images/logo.png";
                        }
                        data[i]._label="<div style='display: flex;'><img class='edit-car-matimg' style='border-radius: 50%;' src='"+icon+"' /><div style='flex:1;margin-left:2px;'>发布单位："+
                            (data[i].fromShopId&&data[i].fromShopId.shopName)+
                            "<br/>上市时间："+
                            (data[i].sdDate?date.formatISODate(data[i].sdDate):"")+
                            "<br/>品种："+(data[i].product||"")+
                            "<br/>价格："+((window.fixedTo(data[i].minPrice||0,3))||"")+"~"+(window.fixedTo((data[i].maxPrice) || 0, 3)||"")+"/"+(data[i].unit||"")+
                            "<br/>数量："+(window.fixedTo(data[i].qty||0,3))+
							"</div></div>";
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                itemMap:{_label:"label", logo:"icon"}
            });
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function() {
                        history.back();
                    }
                },
                title:"供求信息"
            };
            this.addHeader(option);
            option = {
                columns:[{
                    label:'供应',
                    className:'footer-tab-col-highlight sale',
                    onClick:lang.hitch(this,function(e){
                        domClass.remove(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
                        domClass.add(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
                        this.queryParams.ioType = 0;
                        this.setQuery(this.queryParams);
                    })
                },
                {
                    label:'需求',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        domClass.remove(query(".sale",this.domNode)[0], "footer-tab-col-highlight");
                        domClass.add(query(".sale",this.domNode)[1], "footer-tab-col-highlight");
                        this.queryParams.ioType = 1;
                        this.setQuery(this.queryParams);
                    })
                }],
                labelClass:'font-size1 tab-selector'
            }
            this.addColumns(option);
            this.onCreatList();
            this.onAfterShow();
        },
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _tsId = li._id;
            window.moveToView("supplyDemandDetail",_tsId);
        },
        setQuery:function(query){
            this.start = 0;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        },
        onLoadMore:function(evt){
            if(!this.busy&&evt.afterBottom){
                this.start = this.pageSize+this.start;
                if(this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this,function(){
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
                }
            }
        }
    });
});
