//变更人:杜飞军
//变更时间:2016-06-07
//变更原因:显示商品列表 
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/query",
    "dojo/dom-class",
    "dojo/store/JsonRest",
    "dojo/on",
    "dojo/when",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/b/m/MatDetail",
    "cq/biz/mat/xmMat",
    "cq/biz/shop/shop",
    "cq/util/config/config",
],function (declare, lang, Deferred, query, domClass, JsonRest, on, when, EdgeToEdgeStoreList, MatDetailView, xmMat, shop, config) {
    return declare("whz.view.XmMatDetail", MatDetailView, {
        start : 0,
        hideBottom: true,
        //重载的取数据方法
        loadMatData:function () {
            var def = new Deferred();
            xmMat.loadById(window.did).then(lang.hitch(this, function (data) {
                //修改辅助资料引用为文本
                if(data.data.ok){
                    var item = data.data.item;
                    if(item.purposes&&item.purposes.title){
                        item.purposes = item.purposes.title;
                    }
                    if(item.variety&&item.variety.title){
                        item.variety = item.variety.title;
                    }
                    if(item.color&&item.color.title){
                        item.color = item.color.title;
                    }
                    if(item.sex&&item.sex.title){
                        item.sex = item.sex.title;
                    }
                }
                def.resolve(data);
            }));
            if(this.shopsQtyDiv){
                this.setQuery();
            }
            return def;
        },
        //辅助资料
        addXmAssistList:function () {
            var option = {
                isEdge : true,
                lists : [{
                        label : "用途:{{purposes}}",
                        rightText : "品种:{{variety}}"
                    }, {
                        label : "颜色:{{color}}",
                        rightText : "性别:{{sex}}"
                    }
                ]
            }
            this.addLists(option);
            if(config.getPlatformShopId() === shop.getShopId()){
                this.addShopsQtyNode();
            }
        },
        //添加商家库存节点
        addShopsQtyNode : function () {
            var option = {
                columns : [{
                        label : '商品详情',
                        onClick : lang.hitch(this.changeMatDetail)
                    }, {
                        label : '商家库存',
                        onClick : lang.hitch(this.changeShopsQty)
                    }
                ],
                labelClass : 'font-size1 tab-selector'
            }
            this.addColumns(option);
            this.tabSelected();
            this.shopsQtyDiv = EdgeToEdgeStoreList({
                    append : true,
                    constraint : false,
                    query : {},
                    class : "icon-list-item none",
                    variableHeight : true,
                    //获取数据完成后调用的的处理方法
                    onComplete : lang.hitch(this, function (data) {

                        for (var i = 0; i < data.length; i++) {
                            data[i]._label =
                            "<div class='mat-list-mname mat-list-margin'>"
                                + (data[i].fromShopId && data[i].fromShopId.shopName)
                            +"</div>"
                            +"<div class='mat-list-qty mat-list-margin'>"
                                +"<span class='mat-list-totalSale'>库存：" + data[i].qty + "</span>"
                            +"</div>"

                            data[i].moveTo = "#";
                            data[i]._logo = data[i].fromShopId && data[i].fromShopId.logo ? data[i].fromShopId.logo : 'images/nomat.png';
                        }
                        this.shopsQtyDiv.generateList(data);
                        this.end = this.start + data.length - 1;
                        this.busy = false;
                    }),
                    queryOptions : {
                        count : 10,
                        start : this.start
                    },
                    itemMap : {
                        _label : "label",
                        _logo : "icon",
                        moveTo : "moveTo"
                    }
                });
                //创建数据源
                this.store = new JsonRest({
                        target : xmMat.getShopQtyUrl()
                    });

                // 将数据源赋值给shopsQtyDiv
                this.shopsQtyDiv.setStore(this.store);
                this.shopsQtyDiv.placeAt(this.centerPanel.containerNode, "last");
                this.shopsQtyDiv.on("click", lang.hitch(this, this.onClickList));
                this.centerPanel.on("afterscroll", lang.hitch(this, this.onLoadMore));
                this.tabSelected();
        },
        //商家库存列表加载更多
        onLoadMore : function (evt) {
            if (this.busy || (0 < this.end && (this.start + 10 - 1 > this.end))) {
                return true;
            }
            if (evt.afterBottom) {
                this.start = this.end + 1;
                console.log("加载更多商品");
                this.busy = true;
                setTimeout(lang.hitch(this, function () {
                        when(this.shopsQtyDiv.setQuery(this.shopsQtyDiv.get("query"), {
                                start : this.start,
                                count : 10
                            }), lang.hitch(this, function () {
                                this.centerPanel.resize();
                            }));
                    }), 1000);
            }
        },
        //刷新商家库存列表
        setQuery : function () {
            this.start = 0;
            this.end = -1;
            this.shopsQtyDiv.destroyDescendants();
            this.shopsQtyDiv.setQuery({}, {
                start : this.start,
                count : 10
            });
            this.centerPanel.resize();
        },
        //切换到商品详情
        changeMatDetail : function (e) {
            this.tabSelected(e.target);
            domClass.remove(this.matDetailDiv.containerNode,"none");
            domClass.add(this.shopsQtyDiv.containerNode,"none");
        },
        //切换到商家库存
        changeShopsQty : function (e) {
            this.tabSelected(e.target);
            domClass.remove(this.shopsQtyDiv.containerNode,"none");
            domClass.add(this.matDetailDiv.containerNode,"none");
            this.setQuery();
        },
        //切换tabbar
        tabSelected : function (dom) {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            if(dom){
                domClass.add(dom, "selected");
            }else{
                domClass.add(items[0], "selected");
            }
        }
    });
});
