//变更人: 杜飞军
//变更时间:2016-06-07
//变更原因: 给消费者端查看
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/request/xhr",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/ScrollablePane",
    "cq/ui/b/m/MatList",
    "cq/biz/mat/xmMat",
    "cq/biz/shop/bs/parameter"
],function (declare, lang, array, xhr, domConstruct, domClass, domAttr, domStyle, Deferred, query, registry, ScrollablePane, MatListView, xmMat, parameter) {
    return declare("whz.view.XmMatList", MatListView, {
        hideBottom: true,
        getHeadOption:function () {
            return {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "返回",
                    onClick : function () {
                        window.moveToView("home");
                    }
                },
                title : "全部商品",
                right : {
                    iconButton : ' ',
                    label : "筛选",
                    onClick:lang.hitch(this.showFilterOverlay)
                }
            }
        },
        getMatUrl:function () {
            return xmMat.getLoadUrl();
        },
        onClickList : function (evt) {
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem")
                return;
            var _id = li.params._id;
            window.moveToView("xmMatDetail", _id);

        },
        showFilterOverlay:function () {
            var assistData = null;
            var assistGroupTitle = {
                "xmColor" : "颜色",
                "xmUsage" : "用途",
                "xmSex" : "性别",
                "xmVariety" : "品种"
            };
            if(!this.assistFilterDiv){
                this.assistFilterDiv = domConstruct.create("div",{style:"height:" + domStyle.get(document.body,"height")+"px",className:"assistFilterDiv"});
                this.getXmAssistData().then(lang.hitch(this,function (data) {
                    if(data.data.ok === 1){
                        var scrollablePane = new ScrollablePane({height:domStyle.get(document.body,"height")-49+"px"});
                        scrollablePane.placeAt(this.assistFilterDiv);
                        scrollablePane.startup();
                        assistData = this.parserAssistData(data.data.items);
                        for(var type in assistData){
                            domConstruct.create("div",{className:"mat-list-margin padding-top-bottom16",innerHTML:assistGroupTitle[type]},scrollablePane.containerNode)
                            scrollablePane.containerNode.appendChild(this.createAssistList(assistData[type]));
                        }
                        this.assistFilterDiv.appendChild(this.addColumns({
                            columns : [{
                                    label : '确认',
                                    onClick : lang.hitch(this,function () {
                                        this.setQueryParams();
                                    }),
                                    className: "footer-tab-highlight"
                                }, {
                                    label : '取消',
                                    onClick : lang.hitch(this,function () {
                                        this.hideOverlay();
                                    }),
                                    className: "footer-tab-dark"
                                }
                            ],
                            labelClass : 'font-size3',
                            className : 'hflex'
                        }));
                        this.showInOverlay(this.assistFilterDiv);
                    }
                }));
            }else {
                this.showInOverlay(this.assistFilterDiv);
            }
        },
        setQueryParams:function () {
            var selecteds = query(".selected input",this.assistFilterDiv);
            var assistParams = {
                'xmUsage' : 'purposes',
                'xmSex' : 'sex',
                'xmColor' : 'color',
                'xmVariety' : 'variety'
            }
            //删除原有的属性
            for (var type in assistParams) {
                delete this.params[assistParams[type]];
            }
            //重新获取属性
            array.forEach(selecteds,function (selected) {
                this.params[assistParams[domAttr.get(selected,"type")]] = domAttr.get(selected,"value");
            },this);
            console.log(this.params);
            this.setQuery(this.params);
            this.hideOverlay();
        },
        createAssistList:function (assists) {
            var option = { isEdge : true ,lists : [] ,class : "padding-top8 " + (assists[0]&&assists[0].purpose)};
            var edgeList = null;
            array.forEach(assists,function (assist) {
                option.lists.push({
                    label : assist.title,
                    rightText : "<input class='assist' value='"+assist._id+"' type='"+assist.purpose+"' style='display:none'>",
                    className : 'mblListItem h-four-pane bottom-margin8'
                });
            });
            edgeList = this.addLists(option);
            this.connect(edgeList.containerNode,"onclick",function (e) {
                var dom = e.target;
                var listItems = null;
                while (dom&&!domClass.contains(dom,"mblListItem")) {
                    dom = dom.parentNode;
                }
                if(dom&&domClass.contains(dom,"selected")){
                    domClass.remove(dom,"selected");
                }else if(dom){
                    listItems = query(".mblListItem",dom.parentNode);
                    array.forEach(listItems,function (listItem) {
                        domClass.remove(listItem,"selected");
                    });
                    domClass.add(dom,"selected");
                }
            });
            return edgeList.containerNode;
        },
        getXmAssistData:function () {
            var def = new Deferred();
            parameter.loadPlatform().then(function (result) {
                def.resolve(result);
            });
            return def;
        },
        parserAssistData:function (items) {
            //items : [{title:"用来吃",purpose:"xmUsage",isUser:true}]
            // assistData : {
            //                 xmUsage:[{title:"用途",purpose:"xmUsage",isUser:true}]
            //                 xmVariety:[{title:"品种",purpose:"xmVariety",isUser:true}]
            //                 xmColor:[{title:"颜色",purpose:"xmColor",isUser:true}]
            //                 xmSex:[{title:"性别",purpose:"xmSex",isUser:true}]
            //             }
            var assistData = {
                xmVariety : [],
                xmColor : [],
                xmSex : [],
                xmUsage : []
            };
            array.forEach(items, function (item) {
                item.purpose = item.purpose
                if(!assistData[item.purpose]){
                    assistData[item.purpose] = [];
                }
                assistData[item.purpose].push(item);
            });
            return assistData;
        }
    });
});
